# region System Include
using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
# endregion

#region Assetlink Include
using Assetlink.Services;
using Assetlink.Services.Engines;
using Assetlink.Services.Engines.ReportEngine;
using Assetlink.Diagnostic;
using Assetlink.Framework;
#endregion Assetlink Include

/// <summary>
/// Summary description for ALReportWS
/// </summary>
/// 
namespace Assetlink.Services.ReportWS
{
    // Definition of Custom Types
    using XML = System.String;
    using ERRORXML = System.String;

    public class ALReportWS : System.Web.Services.WebService
    {
        # region Member Variable

        public ALServiceHeader RequestHeader;

        # endregion

        # region Constructor
        public ALReportWS()
        {
            //
            // TODO: Add constructor logic here
            //
        }
        # endregion

        # region Public Methods

        /// <summary>
        /// <CreatedBy>Nachiket Deshpande</CreatedBy>
        /// </summary>
        /// <param name="InputXML"></param>
        /// <returns></returns>
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML CreateReport(XML InputXML)
        {
            ERRORXML ErrorXML = null;
            Report_Engine ReportObj = null;
            
            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                
                ErrorXML = ReportObj.CreateReport(InputXML);
                
                return "Success2";

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in CreateReport Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in CreateReport Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End CreateReport", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

            }
            
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in CreateReport Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in CreateReport Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                //return ErrorXML;
                return "ONe";
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                //return ErrorXML;
                return "TWO";
            }

            //return ErrorXML;
            if (ErrorXML == null)
                return "Xero";
            else
            {
                return "Four";
            }
        }
        
        /// <summary>
        /// <CreatedBy>Nachiket Deshpande</CreatedBy>
        /// </summary>
        /// <param name="InputXML"></param>
        /// <returns></returns>
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML UpdateReport(XML InputXML)
        {
            ERRORXML ErrorXML = null;
            Report_Engine ReportObj = null;
            
            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.UpdateReport(InputXML);

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in UpdateReport Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in UpdateReport Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End UpdateReport", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

            }

            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in UpdateReport Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in UpdateReport Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }

            return ErrorXML;
        }


        /// <summary>
        /// <CreatedBy>Nachiket Deshpande</CreatedBy>
        /// </summary>
        /// <param name="ReportID"></param>
        /// <returns></returns>
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML DeleteReport(String ReportID)
        {
            ERRORXML ErrorXML = null;
            Report_Engine ReportObj = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.DeleteReport(ReportID);

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in DeleteReport Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in DeleteReport Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End DeleteReport", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);
            }

            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in DeleteReport Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in DeleteReport Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }

            return ErrorXML;
        }

        /// <summary>
        /// <CreatedBy>Bhavana Chavan</CreatedBy>
        /// </summary>
        /// <param name="FilterXML, InputDataXML"></param>
        /// <returns>ErrorXML</returns>

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML CreateReportSchedule(String FilterXML, String InputDataXML)
        {
            ERRORXML        ErrorXML            = null;
            Report_Engine   ReportObj           = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.CreateReportSchedule(FilterXML, InputDataXML);

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in CreateReportSchedule Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in CreateReportSchedule Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in CreateReportSchedule Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in CreateReportSchedule Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;                
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            return ErrorXML;
        }

        /// <summary>
        /// <CreatedBy>Bhavana Chavan</CreatedBy>
        /// </summary>
        /// <param name="ScheduleReportID, FilterXML, InputDataXML"></param>
        /// <returns>ErrorXML</returns>
        [WebMethod(MessageName = "Update SCHEDULEREPORTDETAILS as well as updates instances of SCHEDULEDREPORTINSTANCES")]
        [SoapHeader("RequestHeader")]
        public ERRORXML UpdateReportSchedule(String ScheduleReportID,String FilterXML, String InputDataXML)
        {
            ERRORXML        ErrorXML        = null;
            Report_Engine   ReportObj       = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.UpdateReportSchedule(ScheduleReportID, FilterXML, InputDataXML);

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in UpdateReportSchedule Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in UpdateReportSchedule Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in UpdateReportSchedule Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in UpdateReportSchedule Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            return ErrorXML;
        }

        /// <summary>
        /// <CreatedBy>Bhavana Chavan</CreatedBy>
        /// <purpose>This will update only the SCHEDULEREPORTDETAILS table,it will not update SCHEDULEDREPORTINSTANCES instances.</purpose>
        /// </summary>
        /// <param name="InputDataXML"></param>
        /// <returns>ErrorXML</returns>
        [WebMethod(MessageName = "Update SCHEDULEREPORTDETAILS only")]
        [SoapHeader("RequestHeader")]
        public ERRORXML UpdateReportSchedule(String InputDataXML, bool IsReschedule)
        {
            ERRORXML ErrorXML = null;
            Report_Engine ReportObj = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.UpdateReportSchedule(InputDataXML, IsReschedule);

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in UpdateReportSchedule Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in UpdateReportSchedule Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in UpdateReportSchedule Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in UpdateReportSchedule Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            return ErrorXML;
        }

        /// <summary>
        /// <CreatedBy>Yuvraj Deshmukh</CreatedBy>
        /// <purpose>This function will update the Current Schedule Instance Details and will create the next schedule instance record.
        /// It will also update the SCHRPT_LASTRUN and SCHRPT_NEXTRUN Relations</purpose>
        /// </summary>
        /// <param name="ScheduleDetailsID">Report Schedule Details ID</param>
        /// <param name="LastExecutedScheduleInstanceID">ID of Last Executed Report Schedule Instance for which record Details need to be update and next Schedule Instance 
        /// need to be calculated</param>
        /// <param name="ScheduleInstanceStatus">To Update Schedule Instance Status</param>
        /// <param name="ErrorXml">To Update Schedule Instance Error xml if any</param>
        /// <param name="NotificationID">Notification Stamped for the Instance</param>
        /// <returns>if error will return error xml or else return nill</returns>
        [SoapHeader("RequestHeader")]
        [WebMethod]
        public ERRORXML UpdateReportScheduleInstanceForNextRun(String ScheduleDetailsID, String LastExecutedScheduleInstanceID, String ScheduleInstanceStatus, String ErrorXml, ulong NotificationID)
        {
            ERRORXML ErrorXML = null;
            Report_Engine ReportObj = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.UpdateReportScheduleInstanceForNextRun(ScheduleDetailsID, LastExecutedScheduleInstanceID, ScheduleInstanceStatus, ErrorXml, NotificationID);

                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in UpdateReportSchedule Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in UpdateReportSchedule Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in UpdateReportSchedule Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in UpdateReportSchedule Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            return ErrorXML;
        }
        
        /// <summary>
        /// <CreatedBy>Bhavana Chavan</CreatedBy>
        /// </summary>
        /// <param name="SCHRPT_IDList"></param>
        /// <returns>ErrorXML</returns>
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML DeleteScheduleReport(String SCHRPT_IDList)
        {
            ERRORXML            ErrorXML        = null;
            Report_Engine       ReportObj       = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.DeleteScheduleReport(SCHRPT_IDList);
                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in DeleteScheduleReport Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in DeleteScheduleReport Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in DeleteScheduleReport Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in DeleteScheduleReport Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }

            return ErrorXML;

        }
        
        /// <summary>
        /// <createddate> 15th Feb 2010 </createddate>
        /// <author> Archana Pisal </author>
        /// <purpose> This API is used to get all the schedule instances marked for deletion i.e. MARKASDELETED = 1 and 
        /// delete these records Permanently.
        /// </purpose>
        /// </summary>
        /// <returns></returns>
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML DeleteScheduleReportInstanceDetails()
        {
            ERRORXML        ErrorXML            = null;
            Report_Engine   objReportEngine     = null;

            try
            {
                objReportEngine = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML        = objReportEngine.DeleteScheduleReportInstanceDetails();
                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in DeleteScheduleReportInstanceDetails Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in DeleteScheduleReportInstanceDetails Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in DeleteScheduleReportInstanceDetails Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in DeleteScheduleReportInstanceDetails Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }

            return ErrorXML;

        }

        /// <summary>
        /// <CreatedBy>Bhavana Chavan</CreatedBy>
        /// <purpose> Restamp the instance in SCHEDULEDREPORTINSTANCES table for the instance which has status as ERROR. </purpose>
        /// </summary>
        /// <param name="ScheduleReportID, ref IsAlreadyExist"></param>
        /// <returns>ErrorXML</returns>
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML ResendErrorInstance(String ScheduleReportID, ref bool IsAlreadyExist)
        {
            ERRORXML            ErrorXML        = null;
            Report_Engine       ReportObj       = null;

            try
            {
                ReportObj = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                ErrorXML = ReportObj.ResendErrorInstance(ScheduleReportID, ref IsAlreadyExist);
                if (ErrorXML != null)
                {
                    ExceptionTracing.TraceLog("Error in ResendErrorInstance Begin",
                                           "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(ErrorXML, "ReportService",
                                              RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in ResendErrorInstance Ends",
                                              "ReportService", RequestHeader.TenantName, DateTime.Now);
                }
            }
            catch (SoapException ExcepObj)
            {
                ExceptionTracing.TraceLog("Error in ResendErrorInstance Begin",
                                          "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExcepObj.Message, "ReportService",
                                          RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ResendErrorInstance Ends", "ReportService",
                                           RequestHeader.TenantName, DateTime.Now);

                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
                return ErrorXML;
            }

            return ErrorXML;
        }
        
        #region Web methods For AdHoc Reports

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML CreateAdHocReport(ref XML AdHocReportInputXML)
        {
            Report_Engine   engine_Reports  = null;
            ERRORXML        errorxml_Output = null;

            try
            {
                ExceptionTracing.TraceLog("Begin CreateAdHocReport", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports  = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.CreateAdHocReport(ref AdHocReportInputXML);
                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in CreateAdHocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in CreateAdHocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End CreateAdHocReport", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in CreateAdHocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in CreateAdHocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in CreateAdHocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in CreateAdHocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML UpdateAdHocReport(ref XML AdHocReportInputXML)
        {
            Report_Engine   engine_Reports  = null;
            ERRORXML        errorxml_Output = null;

            try
            {
                ExceptionTracing.TraceLog("Begin UpdateAdHocReport", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports  = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.UpdateAdHocReport(ref AdHocReportInputXML);
                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in UpdateAdHocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in UpdateAdHocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End UpdateAdHocReport", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in UpdateAdHocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in UpdateAdHocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in UpdateAdHocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in UpdateAdHocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }

            return (errorxml_Output);
        }

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML DeleteAdHocReports(String CommaSeparatedReportIDList)
        {
            Report_Engine   engine_Reports  = null;
            ERRORXML        errorxml_Output = null;

            try
            {
                ExceptionTracing.TraceLog("Begin DeleteAdHocReports", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports  = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.DeleteAdHocReports(CommaSeparatedReportIDList);
                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in DeleteAdHocReports Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in DeleteAdHocReports Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End DeleteAdHocReports", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in DeleteAdHocReports Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in DeleteAdHocReports Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in DeleteAdHocReports Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in DeleteAdHocReports Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML AdHocReportExportToExcelForView(String AdHocReportID, out String FileCollectionXML)
        {
            Report_Engine engine_Reports = null;
            ERRORXML errorxml_Output = null;
            FileCollectionXML = null;

            try
            {
                ExceptionTracing.TraceLog("Begin AdHocReportExportToExcel", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports = new Report_Engine(RequestHeader.SessionID, RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.AdHocReportExportToExcelForView(AdHocReportID, out FileCollectionXML);
                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End AdHocReportExportToExcel", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML AdHocReportExportToExcelForReportScheduler(String AdHocReportID, String ReportSchedulerID, out String FileCollectionXML)
        {
            Report_Engine engine_Reports = null;
            ERRORXML errorxml_Output = null;
            FileCollectionXML = null;

            try
            {
                ExceptionTracing.TraceLog("Begin AdHocReportExportToExcel", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.AdHocReportExportToExcelForReportScheduler(AdHocReportID, ReportSchedulerID, out FileCollectionXML);
                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End AdHocReportExportToExcel", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in AdHocReportExportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML ExportAdhocReport(String AdhocReportID, String ScheduledReportInstanceID, String ScheduledReportExportFormat, out String ExportOutPutXml)
        {
            Report_Engine engine_Reports    = null;
            ERRORXML errorxml_Output        = null;
            ExportOutPutXml                 = null;

            try
            {
                ExceptionTracing.TraceLog("Begin ExportAdhocReport", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports  = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.ExportAdhocReport(AdhocReportID, ScheduledReportInstanceID, ScheduledReportExportFormat, out ExportOutPutXml);

                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in ExportAdhocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in ExportAdhocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End ExportAdhocReport", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in ExportAdhocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ExportAdhocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in ExportAdhocReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ExportAdhocReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML GetAdHocReportGroupedDataXML(XML ReportConfiguration, XML xml_SearchOutput, ref XML GroupCollectionXML)
        {
            Report_Engine engine_Reports = null;
            ERRORXML errorxml_Output = null;           

            try
            {
                ExceptionTracing.TraceLog("Begin GetAdHocReportGroupedDataXML", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports = new Report_Engine(RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);
                errorxml_Output = engine_Reports.GetAdHocReportGroupedDataXML(ReportConfiguration, xml_SearchOutput, ref GroupCollectionXML);

                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in GetAdHocReportGroupedDataXML Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in GetAdHocReportGroupedDataXML Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End GetAdHocReportGroupedDataXML", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in GetAdHocReportGroupedDataXML Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in GetAdHocReportGroupedDataXML Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in GetAdHocReportGroupedDataXML Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in GetAdHocReportGroupedDataXML Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        #endregion

        #region Web methods for Crystal Reports
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML ExportCrystalReportToExcel(String TenantName, String ParametersXML, String StoredProcedureName, String ExcelFilePath, String TableName)
        {
            Report_Engine   engine_Reports      = null;
            ERRORXML        errorxml_Output     = null;            

            try
            {
                ExceptionTracing.TraceLog("Begin ExportCrystalReportToExcel", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports = new Report_Engine(RequestHeader.SessionID, RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName, "Crystal Report");
                errorxml_Output = engine_Reports.ExportCrystalReportToExcel(TenantName, ParametersXML, StoredProcedureName, ExcelFilePath, TableName);

                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in ExportCrystalReportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in ExportCrystalReportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End ExportCrystalReportToExcel", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in ExportCrystalReportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ExportCrystalReportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in ExportCrystalReportToExcel Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ExportCrystalReportToExcel Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        #endregion

        #region Web method for Asset Metadate Report
        [WebMethod]
        [SoapHeader("RequestHeader")]
        public ERRORXML ExportAssetMetadataReport(String ExportType, XML UserInputXml, XML SearchInputXml, XML SortFieldListXml, XML FormConfigXml, int SortType, out String ResultExportPath)
        {
            Report_Engine engine_Reports = null;
            ERRORXML errorxml_Output = null;

            ResultExportPath = null;

            try
            {
                ExceptionTracing.TraceLog("Begin ExportAssetMetadataReport", "ReportService", RequestHeader.TenantName, DateTime.Now);

                engine_Reports = new Report_Engine(RequestHeader.SessionID, RequestHeader.UserID, RequestHeader.Language, RequestHeader.TenantName);

                errorxml_Output = engine_Reports.ExportAssetMetadataReport(ExportType, UserInputXml, SearchInputXml, SortFieldListXml, FormConfigXml, SortType, out ResultExportPath);

                if (errorxml_Output != null)
                {
                    ExceptionTracing.TraceLog("Error in ExportAssetMetadataReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog(errorxml_Output, "ReportService", RequestHeader.TenantName, DateTime.Now);
                    ExceptionTracing.TraceLog("Error in ExportAssetMetadataReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);
                }

                ExceptionTracing.TraceLog("End ExportAssetMetadataReport", "ReportService", RequestHeader.TenantName, DateTime.Now);
            }
            catch (SoapException ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in ExportAssetMetadataReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ExportAssetMetadataReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                ExceptionTracing.TraceLog("Error in ExportAssetMetadataReport Begin", "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog(ExceptionObject.Message, "ReportService", RequestHeader.TenantName, DateTime.Now);
                ExceptionTracing.TraceLog("Error in ExportAssetMetadataReport Ends", "ReportService", RequestHeader.TenantName, DateTime.Now);

                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }
        #endregion

        # endregion
    }
}