#region System Includes

using System;
using System.Data;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Xml.Xsl;
using System.Linq;
using System.Reflection;
using System.Xml.Linq;
using System.Globalization;
#endregion

#region Assetlink Includes

using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.CustomControls.HelperClasses;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.ReportFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Pages;

#endregion

namespace Assetlink.Solutions.Reports
{
    #region Directives Include

    using XML = String;
    using ERRORXML = String;

    #endregion

    public partial class AdHocReportPreview : ALAjaxPage
    {
        #region Member Variables

        ALSolutionCommon ALSolutionCommonObj = null;
        ALParam ALParamObj = null;
        String ReportID = null;        
        String ParentPageName = "";        
        String Level_LocalizedStr = null;
        String TotalFor_LocalizedStr = null;
        String ReportGeneratedBy = null;
        String ReportGeneratedOn = null;

        //Yuvraj
        FormFacade FormFacadeObject = null;
        List<ObjectInfo> ObjectInfoCollection = new List<ObjectInfo>();
        String ScreenMode = "READONLY";
        String UserRoleName = null;

        //Ankit
        public String[] controlNamesArray = null;
        public String[] attributeNamesArray = null;
        public String[] attributeValueArray = null;
        public XML AdHocReportConfigXML = null;
        public String TenantName = null;
        
        UserControl ALUC_AdvQryBldr = null;        
        private bool IsAggregationRequired = false;

        Formats         Format               = null;
        CultureInfo     CustomCulture        = null;
        bool            ShowNote             = false;
        String          MaxSearchResultAlert = "";
        bool            ShowResultGrid       = false;
        #endregion

        #region Member Classes
        class Constants
        {
            public const string DATA_TYPE_TEXT      = "TEXT";
            public const string DATA_TYPE_STRING    = "STRING";
            public const string DATA_TYPE_NUMBER    = "NUMBER";
            public const string DATA_TYPE_FLOAT     = "FLOAT";
            public const string DATA_TYPE_CURRENCY  = "CURRENCY";
            public const string DATA_TYPE_DATE      = "DATE";
            public const string DATA_TYPE_DATETIME  = "DATETIME";
            public const string DATA_TYPE_MULTILINE = "MULTILINE";
        }

        public class XslExtensionClass
        {
            private CultureInfo CustomCulture = null;
            private Formats Format = null;
            private ALCommon ALCommonObj = null;
            private String TenantName = null;
            
            public XslExtensionClass(Formats FormatObj, CultureInfo CustomCultureObj)
            {
                Format = FormatObj;
                CustomCulture = CustomCultureObj;
            }
            public XslExtensionClass(UInt64 SessionID, UInt64 UserID,String Language, String TenantName,Formats FormatObj, CultureInfo CustomCultureObj)
            {
                Format          = FormatObj;
                CustomCulture   = CustomCultureObj;
                ALCommonObj     = new ALCommon(TenantName, UserID.ToString(), SessionID.ToString(), Language);
                this.TenantName = TenantName;
            }

            public String FormatValueforDataType(String datatype, String value)
            {
                String dateFormat = "";
                String[] valueArr = null;   
                try
                {
                    switch (datatype.ToUpper())
                    {
                        case Constants.DATA_TYPE_TEXT:
                            break;
                        case Constants.DATA_TYPE_STRING:
                            if (value.Contains("$AL$"))
                            {
                                ALCommonObj.ConvertDelimiterSeparatorToSeparator(value, ",", out value, out valueArr, false, TenantName);
                            }
                            break;
                        case Constants.DATA_TYPE_NUMBER:
                            value = Format.FormatNumericField(value, CustomCulture);
                            break;
                        case Constants.DATA_TYPE_CURRENCY:
                            value = Format.FormatCurrencyField(value, CustomCulture);
                            break;
                        case Constants.DATA_TYPE_FLOAT:
                            value = Format.FormatFloatField(value, CustomCulture);
                            break;
                        case Constants.DATA_TYPE_DATE:
                            if (!String.IsNullOrEmpty(value))
                            {
                                valueArr = value.Split(new String[] { "/" }, StringSplitOptions.None);
                                value = valueArr[1] + " " + GetMonthName(valueArr[0]) + " " + valueArr[2];
                            }
                            dateFormat = Format.ColumnDateFieldFormat;
                            value = Format.FormatDateField(value, CustomCulture);
                            if (dateFormat == "")
                                value = value.Split(' ')[0]; //done to remove time bcoz when no format given it gives datetime by default
                            break;
                        case Constants.DATA_TYPE_DATETIME:
                            if (!String.IsNullOrEmpty(value))
                            {
                                String[] datetimeArr = value.Split(new String[] { " " }, StringSplitOptions.None);
                                value = datetimeArr[0];
                                valueArr = value.Split(new String[] { "/" }, StringSplitOptions.None);
                                value = valueArr[1] + " " + GetMonthName(valueArr[0]) + " " + valueArr[2];
                                if (datetimeArr.Length > 1 && datetimeArr[1] != null && datetimeArr[1] != "")
                                {
                                    String timeStamp = datetimeArr[1];
                                    String[] timeStampArr = timeStamp.Split(new String[] { ":" }, StringSplitOptions.None);
                                    if (Convert.ToInt32(timeStampArr[0]) == 0 && Convert.ToInt32(timeStampArr[1]) == 0 && Convert.ToInt32(timeStampArr[2]) == 0)
                                        value = Format.FormatDateField(value, CustomCulture);
                                    else
                                    {
                                        value += " " + datetimeArr[1];
                                        value = Format.FormatDateTimeField(value, CustomCulture);
                                    }
                                }
                                else
                                    value = Format.FormatDateField(value, CustomCulture);
                            }
                            break;
                        case Constants.DATA_TYPE_MULTILINE:
                            value = value.Replace("\n", "<BR>");
                            break;
                        default:
                            break;
                    }
                }
                catch (Exception)
                {
                    value = "";
                }

                if (value == null)
                    value = "";

                return value;

            }

            private String GetMonthName(string sMonthNum)
            {
                string GetMonthValue = "";
                switch (sMonthNum)
                {
                    case "01":
                        GetMonthValue = "January";
                        break;
                    case "02":
                        GetMonthValue = "February";
                        break;
                    case "03":
                        GetMonthValue = "March";
                        break;
                    case "04":
                        GetMonthValue = "April";
                        break;
                    case "05":
                        GetMonthValue = "May";
                        break;
                    case "06":
                        GetMonthValue = "June";
                        break;
                    case "07":
                        GetMonthValue = "July";
                        break;
                    case "08":
                        GetMonthValue = "August";
                        break;
                    case "09":
                        GetMonthValue = "September";
                        break;
                    case "10":
                        GetMonthValue = "October";
                        break;
                    case "11":
                        GetMonthValue = "November";
                        break;
                    case "12":
                        GetMonthValue = "December";
                        break;
                }
                return GetMonthValue;
            }
        }
        #endregion

        #region Standard Methods

        protected override void InitializeCulture()
        {
            ALSolutionCommonObj = new ALSolutionCommon();
            ALParamObj = new ALParam();

            ALSolutionCommonObj.httpContext = HttpContext.Current;
            ALSolutionCommonObj.InitALParam(ref ALParamObj);

            TenantName = ALParamObj.TenantName;

            Page.UICulture = Localization.GetCultureName(ALParamObj.Language, ALParamObj.TenantName);
            Localization.SetCultureForPage(ALParamObj.Language, ALParamObj.TenantName);
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            try
            {   
                initializeURLParameters();
                initializeControls();
                initializeServerSideEvents();                
            }
            catch (Exception ExceptionObject)
            {
                redirectToErrorPage(ExceptionObject.Message);                
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {           

            Page.Header.DataBind();
            string eventor = null;
            string eventArgs = "";
            try
            {
                eventor                     = Ajax.EventGeneratorUniqueID;             
                Ajax.AsynchronousRequest    = true;

                ALGridAdHocData.TenantName  = ALParamObj.TenantName;
                ALGridAdHocData.Language    = ALParamObj.Language;
                ALGridAdHocData.SessionID   = ALParamObj.SessionID;
                ALGridAdHocData.UserID      = ALParamObj.UserID;

                if (!IsPostBack)
                {
                    //Load grid control with required data.    
                    if (ShowResultGrid)
                    {
                        prepareGridData();
                        ALGridAdHocData.Initialize();
                    }

                    if (!ShowResultGrid)
                    {
                        ALGridAdHocData.Visible = false;
                        AdhocReportPreview_ActBar.Visible = false;
                    }
                }
                else
                {
                    ALGridAdHocData.AjaxRef = Ajax;

                    if (eventor != null && eventor.Contains("LevelSelectDD"))
                    {
                        eventArgs = Request["__EVENTARGUMENT"];
                        ShowLevelChangeHandler(eventArgs);
                    }                   
                }
            }
            catch (Exception ExceptionObject)
            {
                redirectToErrorPage(ExceptionObject.Message);
            }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            try
            {
                if (IsPostBack)
                {
                    string eventor = Ajax.EventGeneratorUniqueID;

                    if (eventor != null && eventor.Contains("btnSavePreview"))
                    {
                        if (ParentPageName == "AdHocReportConfiguration")
                            Ajax.AppendExecuteJavaScript("refreshWindowOpener()");
                        else
                            Ajax.AppendExecuteJavaScript("CancelWindow()");
                        Ajax.AddControlsToRender(ALGridAdHocData);
                    }
                    else if (eventor != null && eventor.Contains(AB_GenerateRpt.UniqueID))
                    {
                        Ajax.AddControlsToRender(ABC_PersonliazedFilters);
                        Ajax.AddControlsToRender(Div_NoResultNote);                        
                        Ajax.AddControlsToRender(Div_Grid);
                        Ajax.AddControlsToRender(Div_AdhocReportPreview_ActBar);
                    }
                    else
                        Ajax.AddControlsToRender(Div_Grid);

                    Ajax.WriteControlHTMl(Page, writer);
                }
                else
                {                   
                    base.Render(writer);
                    if (ShowResultGrid && ShowNote)
                    {
                        Page.Response.Write("<script>alert('" + MaxSearchResultAlert + "');</script>");                        
                    }
                }
            }
            catch (Exception ExceptionObject)
            {
                redirectToErrorPage(ExceptionObject.Message);
            }
        }

        #endregion

        #region Event Handlers
        public void PageActionBarClickFunc(Object sender, EventArgs eventArgs)
        {
            String separator = "$AL$";
            String controlName = null;
            String btnName = null;
            String args = null;
            XML ReportConfigXML = null;

            try
            {
                controlName = sender.ToString();
                btnName = controlName.Substring((controlName.IndexOf(separator) + separator.Length), (controlName.LastIndexOf(separator) - controlName.IndexOf(separator) - separator.Length));

                if (btnName.CompareTo("btnSavePreview") == 0)
                {
                    args = Request["__EVENTARGUMENT"];
                    ReportConfigXML = ViewState["ReportConfigXML"].ToString();
                    saveAdHocReportConfigDetails(ReportConfigXML, args);
                }
            }
            catch (Exception ExceptionObject)
            {
                redirectToErrorPage(ExceptionObject.Message);
            }
        }

        public void ShowLevelChangeHandler(String args)
        {
            String GridConfigXML = ViewState["AdHocReportGridConfiguration"].ToString();
            String[] argsArr = args.Split(new String[] { "$ALSEP$" }, StringSplitOptions.None);

            int SelectedDepth = Convert.ToInt32(argsArr[0]);
            String widthList = argsArr[1];
            String[] widthListArr = widthList.Split(new String[] { "$SET$" }, StringSplitOptions.None);
            int currDepth = 0;

            XDocument xDoc_GridConfig = XDocument.Parse(GridConfigXML);
            IEnumerable<XElement> gridHeaderCols = xDoc_GridConfig.Root.Element("header").Elements("headercolumn");
            
            int currOrder = 0;
            foreach (XElement gridHeaderCol in gridHeaderCols)
            {
                currOrder = Convert.ToInt32(gridHeaderCol.Attribute("order").Value);
                gridHeaderCol.SetAttributeValue("width", widthListArr[currOrder - 1]);
            }

            IEnumerable<XElement> GridLevelsList = xDoc_GridConfig.Root.XPathSelectElements("levels/level");
            
            foreach (XElement gridLevel in GridLevelsList)
            {
                currDepth = Convert.ToInt32(gridLevel.Attribute("depth").Value);
                if (currDepth < SelectedDepth)
                    gridLevel.SetAttributeValue("expand", "true");
                else
                    gridLevel.SetAttributeValue("expand", "false");
            }

            GridConfigXML = xDoc_GridConfig.Root.ToString();

            ALGridAdHocData.ConfigXml   = GridConfigXML;
            ALGridAdHocData.DataXml     = ViewState["AdHocReportGridData"].ToString();
            ALGridAdHocData.Initialize();
        }

        public void AB_GenerateRpt_Click(Object sender, EventArgs eventArgs)
        { 
            String separator = "$AL$";
            String controlName = null;
            String btnName = null;
            String str_TempFilePath = null;

            try
            {
                controlName = sender.ToString();
                btnName     = controlName.Substring((controlName.IndexOf(separator) + separator.Length), (controlName.LastIndexOf(separator) - controlName.IndexOf(separator) - separator.Length));

                if (btnName.CompareTo("GenerateReport") == 0)
                {
                    str_TempFilePath = String.Format("{0}{1}_SearchDetails.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ReportID);
                    if (File.Exists(str_TempFilePath))
                        File.Delete(str_TempFilePath);

                    str_TempFilePath = String.Format("{0}{1}.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ReportID);
                    if (File.Exists(str_TempFilePath))
                        File.Delete(str_TempFilePath);

                    ABC_PersonliazedFilters.IsMinimize = true;
                    ShowResultGrid          = true;
                    ALGridAdHocData.Visible = true;
                    AdhocReportPreview_ActBar.Visible = true;

                    prepareGridData();
                    ALGridAdHocData.Initialize();
                    if(ShowNote)
                    {
                        Ajax.WriteExecuteJavaScript("javascript:alert('" + MaxSearchResultAlert + "');");
                    }
                }
            }
            catch (Exception ExceptionObject)
            {
                redirectToErrorPage(ExceptionObject.Message);
            }
        }
        #endregion

        #region Private Methods

        //initializeURLParameters() method is used to set the parameters from URL.
        private void initializeURLParameters()
        {
            if (String.IsNullOrEmpty(ALParamObj.SolutionName))
                ALParamObj.SolutionName = "Reports";

            ReportID        = ALSolutionCommonObj.GetParamValue("REPORTID");
            ParentPageName  = ALSolutionCommonObj.GetParamValue("ParentPageName");
            UserRoleName    = ALSolutionCommonObj.GetParamValue("UserRoleName");
            if (String.IsNullOrEmpty(UserRoleName))
                UserRoleName = "";
            else
                UserRoleName = UserRoleName.ToUpper();
        }

        //initializeControls() method is used to get the controls and set properties of controls.
        private void initializeControls()
        {
            #region member variables
            String      str_ActionBarXml        = null;
            String      str_Filters             = null;
            #endregion

            Title.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "AdhocReport_PreviewPage");            

            String str_RedirectURL = null;            

            String ExcelIconToolTip         = Localization.GetString("ALResource", ALParamObj.TenantName, "AdhocReport_Preview_ExportReport_Excelsheet_Tooltip");
            String ExportToLocalizedStr     = Localization.GetString("ALResource", ALParamObj.TenantName, "ExportTo_Shared");
            String ViewLevelsLocalizedStr   = Localization.GetString("ALResource", ALParamObj.TenantName, "AdhocReport_Preview_ViewLevels");
            Level_LocalizedStr              = Localization.GetString("ALResource", ALParamObj.TenantName, "Level_Shared");
            TotalFor_LocalizedStr           = Localization.GetString("ALResource", ALParamObj.TenantName, "AdhocReport_Preview_TotalFor");
            str_Filters                     = Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_Lbl_Filters");

            ABC_AdHocReportView.TenantName  = ALParamObj.TenantName;
            ABC_AdHocReportView.CaptionText = "View Details"; //****THIS SHOUD INCLUDE REPORT NAME ALSO.
            ABC_AdHocReportView.DisplayLayout= eDisplayLayout.OnlyContents;

            LBL_ExportTo.InnerText          = ExportToLocalizedStr + ":";
            LBL_ViewLevels.InnerText        = ViewLevelsLocalizedStr + ":";
            ExcelIcon.Src                   = GetImagesPath() + "Icon_Excel.png";

            ExcelIcon.Alt                   = ExcelIconToolTip;

            String ExportToExcelURL         = "AdHocReportExportHandler.ashx?REPORTID="+ ReportID + "&EXPORTTYPE=EXCELEXPORT";
            ExportToExcelURL                += "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&Language=" + ALParamObj.Language + "&TenantName=" + ALParamObj.TenantName + "&SolutionName=" + ALParamObj.SolutionName;
            ExportToExcelURL                = ALSolutionCommonObj.EncodeURLForResponseRedirects(ExportToExcelURL);
            ExcelIcon.Attributes.Add("onclick", "javascript:ShowPopupWindow('" + ExportToExcelURL + "');");
            ExcelIcon.Attributes.Add("title", ExcelIconToolTip);
            ClientLogo.Src                  = GetImagesPath() + "Client_Logo1.gif";           

            //Yuvraj
            //Set the properties to the form control used for Adhoc reporting.
            setAdHocReportConfigFormControl();
            
            #region Set the properties for Personalization Filters Form            
            StringBuilder sb_Temp = new StringBuilder(500);
            sb_Temp.AppendFormat(@"<table width='100%' class='AdHocReportPreviewActionBar'>
                                    <tr style='height:25px;'>
                                        <td class='TextWhite' width='75px' align='left'>
                                            {5}
                                        </td>
                                        <td id='LBL_ViewLevels' runat='server' class='TextWhite' width='190px' align='right'>
                                            {2}:
                                        </td>
                                        <td id='Div_LevelSelectDDContainer' runat='server'>
                                            <select id='LevelSelectDD' disabled='disabled' class='Text' onchange='ShowLevelChangeHandler()'>
                                                <option value='0' class='Text'>Level 1</option>
                                                <option value='1' class='Text'>Level 2</option>
                                                <option value='2' class='Text'>Level 3</option>
                                            </select>
                                        </td>
                                        <td id='LBL_ExportTo' runat='server' align='right' class='TextWhite'>
                                            {1}:
                                        </td>
                                        <td width='16px'>
                                            <img id='ExcelIcon' runat='server' src='{0}Icon_Excel.png' alt='{3}' width='16' height='16' title='{3}' />
                                        </td>
                                    </tr>
                                </table>", GetImagesPath(), ExportToLocalizedStr, ViewLevelsLocalizedStr, ExcelIconToolTip, ExportToExcelURL, str_Filters);

            //ABC_PersonliazedFilters.ExpandedImage   = "Btn_Down_Small.gif";
            //ABC_PersonliazedFilters.CollapsedImage  = "ico_arrow_cal_Right.gif";
            ABC_PersonliazedFilters.TenantName      = ALParamObj.TenantName;
            ABC_PersonliazedFilters.CaptionTextMode = eCaptionTextMode.HTML;
            ABC_PersonliazedFilters.CaptionHTML     = sb_Temp;
            
            setPersonalizationFiltersForm();
            
            str_ActionBarXml                = @"<ActionControlListCollection>
                                                 <ActionControlList ActionBarType='PageButtonBar'>   
                                                        <ActionControl Alignment='left' Tooltip='RPT_Generate_Shared' TooltipID='RPT_Generate_Shared' 
                                                            DisplayTextID='RPT_Generate_Shared' UIType='ALButton' Name='GenerateReport' Order='0' CausesValidation='False'>
                                                        </ActionControl>
                                                        <ActionControl Alignment='left' Tooltip='Close_Shared' TooltipID='Close_Shared' DisplayTextID='Close_Shared' 
                                                            UIType='ALButton' Name='Close' Order='1' CausesValidation='False'>
                                                        </ActionControl>                           
                                                 </ActionControlList> 
                                              </ActionControlListCollection>";

            AB_GenerateRpt.TenantName       = ALParamObj.TenantName;
            AB_GenerateRpt.InputXMLType     = ActionBar.XMLType.InnerXML;
            AB_GenerateRpt.InputXML         = str_ActionBarXml;
            AB_GenerateRpt.AddAttributes("Close", "href", "javascript:CancelWindow();");
            #endregion

            str_RedirectURL = "AdHocReportPrintView.aspx?SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID
                                + "&Language=" + ALParamObj.Language + "&TenantName=" + ALParamObj.TenantName
                                + "&SolutionName=" + ALParamObj.SolutionName + "&REPORTID=" + ReportID
                                + "&ReportGeneratedBy=" + ReportGeneratedBy + "&ReportGeneratedOn=" + ReportGeneratedOn
                                + "&FromPreviewScreen=TRUE";
            
            str_RedirectURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_RedirectURL);

            if (UserRoleName.Equals("READER"))
            {
                controlNamesArray = new string[] { "btnPrintView" };
                attributeNamesArray = new string[] { "href" };
                attributeValueArray = new string[] { "Javascript:ShowAdHocReportPrintViewWindow('" + str_RedirectURL + "','ALGridAdHocData');" };

                InitializeActionBar(form1, "AdhocReportPreview_ActBar", "AdhocReportPreviewReadOnly_ActionBar", controlNamesArray, attributeNamesArray, attributeValueArray);
            }
            else
            {
                controlNamesArray = new string[] { "btnSavePreview", "btnCancel", "btnPrintView" };
                attributeNamesArray = new string[] { "href", "href", "href" };
                attributeValueArray = new string[] { "javascript:SaveReportPreviewClick('$CONTROLID$','ALGridAdHocData')", "javascript:CancelWindow();", "Javascript:ShowAdHocReportPrintViewWindow('" + str_RedirectURL + "','ALGridAdHocData');" };

                InitializeActionBar(form1, "AdhocReportPreview_ActBar", "AdhocReportPreview_ActionBar", controlNamesArray, attributeNamesArray, attributeValueArray);
            }
        }

        /// <summary>
        /// This function is used to initialize Actionbar.
        /// </summary>
        private void InitializeActionBar(Control sbParent, String actBarName, String actBarXmlFileName, String[] controlNameArray, String[] attributeNameArray, String[] attributeValueArray)
        {
            #region Variables
            ActionBar actBar = null;
            #endregion Variables

            #region Initialize the Action Bar
            actBar = (ActionBar)sbParent.FindControl(actBarName);                

            actBar.TenantName = ALParamObj.TenantName;
            actBar.InputXMLType = ActionBar.XMLType.XMLPath;
            actBar.InputXML = ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "", actBarXmlFileName);

            if (controlNameArray != null && attributeNameArray != null && attributeValueArray != null)
            {
                if ((controlNameArray.Length == attributeNameArray.Length) && (attributeNameArray.Length == attributeValueArray.Length))
                {
                    int i = 0;
                    foreach (String controlName in controlNameArray)
                    {
                        actBar.AddAttributes(controlName, attributeNameArray[i], attributeValueArray[i]);
                        i++;
                    }
                }
            }
            actBar = null;
            #endregion Initialize the Action Bar
        }

        //initializeServerSideEvents() method sets the event handlers assigned to controls.
        private void initializeServerSideEvents()
        {   
        }        

        //saveAdHocReportConfigDetails() method is used to save the AdHoc Report Configuration.
        private void saveAdHocReportConfigDetails(XML ReportConfigXML, String widthList)
        {
            Report_Facade facade_AdHocReport = null;
            XML ErrorXML = null;
            XDocument xdoc_DisplayConfig = XDocument.Parse(ReportConfigXML);                        
            String[] widthListArr = null;
            StringBuilder sb_updateXML = new StringBuilder();
            String updateXML = null;
            int count = 0;

            XElement xEle_ConfigColumnColl = xdoc_DisplayConfig.Root.XPathSelectElement("DisplayLayout/SeriesCollection/AdHocReportsDisplayColumns/CONFIGCOLUMNSCOLLECTION");
            IEnumerable<XElement> lst_GroupConfigColumn = xEle_ConfigColumnColl.XPathSelectElements("CONFIGCOLUMNS[GROUPBYLEVEL != 'None']");
            IEnumerable<XElement> lst_NonGroupConfigColumn = xEle_ConfigColumnColl.XPathSelectElements("CONFIGCOLUMNS[GROUPBYLEVEL = 'None']");

            widthListArr = widthList.Split(new String[] {"$SET$"}, StringSplitOptions.None);
                        
            foreach (XElement xEle_Column in lst_GroupConfigColumn)
            {       
                xEle_Column.SetElementValue("WIDTH", widthListArr[count]);                
            }

            if (lst_GroupConfigColumn != null && lst_GroupConfigColumn.Count() > 0)
                count++;

            foreach (XElement xEle_Column in lst_NonGroupConfigColumn)
            {
                xEle_Column.SetElementValue("WIDTH", widthListArr[count]);
                count++;
            }

            ReportConfigXML = xdoc_DisplayConfig.Root.ToString();
            sb_updateXML.AppendFormat("<ADHOCREPORT><REPORTID>{0}</REPORTID><REPORTCONFIGXML>{1}</REPORTCONFIGXML></ADHOCREPORT>", ReportID, ReportConfigXML);
            updateXML = sb_updateXML.ToString();

            facade_AdHocReport = new Report_Facade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            ErrorXML = facade_AdHocReport.UpdateAdHocReport(ref updateXML);
        }

        //prepareGridData() method is used to prepare the input XML for the grid control.
        private void prepareGridData()
        {
            #region Method Variables

            SearchConfiguration     facade_SearchConfiguration  = null;
            XslCompiledTransform    xslcomptrans_Object         = null;
            XPathDocument           xpathdoc_AdHocReport        = null;
            XPathDocument           xpathdoc_SearchResultOutput = null;
            XPathNavigator          xpathnav_AdHocReport        = null;
            XPathNavigator          xpathnav_ReportConfig       = null;
            XsltArgumentList        xsltarglist_Object          = null;
            XmlDocument             xmldoc_GridColumns          = null;
            XmlDocument             xmldoc_GroupDataType        = null;
            String                  str_InsertString            = null;
            String                  str_XSLTFilePath            = null;
            String                  str_TargetObjectTypeName    = null;
            StringBuilder           strbldr_GridDataResultXML   = null;            
            StringWriter            strwrtr_GridDataResult      = null;
            XML                     xml_SearchInput             = null;
            XML                     xml_SearchOutput            = null;
            XML                     xml_DisplayConfiguration    = null;
            XML                     xml_GridConfiguration       = null;
            XML                     xml_GridColumnsArgument     = null;
            ERRORXML                errorxml_Output             = null;
            String                  FormatXMLPath               = null;
            String                  cultureInfo                 = null;
            String                  GroupDataTypeMap            = "";            
            StringDictionary        dict_PlaceHolder            = null;           
            Report_CommonFunctions  ObjCommonFn                 = null;
            String                  st_InsertString             = null;
            String                  TargetEntity                = null;
            String                  FilterPersonalizationXML    = null;
            String                  FormDataXML                 = null;
            String                  Str_SearchXml               = null;
            String                  str_FilterCombination       = null;
            int                     NoOfFilters                 = 0;
            List<ObjectInfo>        ObjectInfoCollection        = null;
            XPathNavigator          xpNav_Form                  = null;
            InfrastructureFacadeClass ObjInfraSt                = null;           
            #endregion

            facade_SearchConfiguration  = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            ObjCommonFn                 = new Report_CommonFunctions(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName);
            ObjInfraSt                  = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            MaxSearchResultAlert        = "";

            if (String.IsNullOrEmpty(AdHocReportConfigXML))
            {
                if (ViewState["AdHocReportConfigXML"] != null && !String.IsNullOrEmpty((String)ViewState["AdHocReportConfigXML"]))
                    AdHocReportConfigXML = ViewState["AdHocReportConfigXML"].ToString();
                else
                    AdHocReportConfigXML = GetReportData();
            }

            //Retrieve the search input XML from REPORTCONFIGXML.
            xpathdoc_AdHocReport = new XPathDocument(new StringReader(AdHocReportConfigXML));
            xpathnav_ReportConfig = xpathdoc_AdHocReport.CreateNavigator().SelectSingleNode("ADHOCREPORTCOLLECTION/ADHOCREPORT/REPORTCONFIGXML/CONFIGURATION");            
            if (xpathnav_ReportConfig == null)
            {
                throw new Exception("Err_AdhocReport_Invalid_Report_Configuration");
            }
            else
                ViewState["ReportConfigXML"] = xpathnav_ReportConfig.OuterXml;

            xpathnav_AdHocReport = xpathnav_ReportConfig.SelectSingleNode("SEARCHINPUT/INPUTXML/SEARCHCOLLECTION/SEARCH");
            if (xpathnav_AdHocReport != null)
            {
                xml_SearchInput = xpathnav_AdHocReport.OuterXml;
                if (String.IsNullOrEmpty(xml_SearchInput))
                {
                    throw new Exception("Err_AdhocReport_Invalid_NSearchInputXML_Report_Data");
                }

                str_InsertString = "<SESSIONINFO UserID='" + ALParamObj.UserID + "' Language='" + ALParamObj.Language
                        + "' TenantName='" + ALParamObj.TenantName + "' SessionID='" + ALParamObj.SessionID + "'/><MAXRESULTSIZE>" + ObjCommonFn.GetMaxRecordCount() + "</MAXRESULTSIZE>";
                xml_SearchInput = ALCommon.InsertBefore(ref xml_SearchInput, "<TARGETENTITY>", ref str_InsertString);

				#region Add "FROMODS" attribute to "SEARCH" node so that search operation will be performed on appropriate Table
				
				XmlDocument		tmpDoc	= null;
				XPathNavigator	xpNav	= null;

				tmpDoc	= new XmlDocument();
				tmpDoc.LoadXml(xml_SearchInput);
				xpNav	= tmpDoc.CreateNavigator();

				if (xpNav.SelectSingleNode("SEARCH") != null)
					xpNav.SelectSingleNode("SEARCH").CreateAttribute("", "FromODS", "", "True");

                #endregion

                #region Add Personalized Filters to Search XML
                if (ShowResultGrid)
                {                    
                    if(ViewState["PersonalizedObjectInfoList"] != null)
                         ObjectInfoCollection = (List<ObjectInfo>)ViewState["PersonalizedObjectInfoList"];

                    xpNav_Form = xpathnav_ReportConfig.SelectSingleNode("Form");
                    if(xpNav_Form != null && !String.IsNullOrEmpty(xpNav_Form.InnerXml))
                    {
                        FormFacade FormFacadeObj            = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        FormFacadeObj.FormName              = xpNav_Form.GetAttribute("Name","");//"ODSDIGITALASSET_Report";
                        FormFacadeObj.SolutionName          = ALParamObj.SolutionName;
                        FormFacadeObj.ShowConfiguredFields  = true;
                        FormFacadeObj.ConfigurationXMLType  = "INNERXML";
                        FormFacadeObj.ConfigurationXML      = xpathnav_ReportConfig.SelectSingleNode("Form").OuterXml;                        
                        TargetEntity                        =  xpNav_Form.GetAttribute("TARGETOBJECTNAME","");

                        errorxml_Output                     = FormFacadeObj.GetNSearchInputXML("EDIT", "DataField", Frm_PersonalizeFilters, ObjectInfoCollection, out FormDataXML,
                            out Str_SearchXml, out str_FilterCombination, out NoOfFilters);

                        if (String.IsNullOrEmpty(errorxml_Output) && !String.IsNullOrEmpty(FormDataXML))
                        {
                            ALReportHelper.MergePersonalizedFiltersIntoSearchXML(ref tmpDoc, Str_SearchXml, str_FilterCombination, xpNav_Form);                          

                            String str_PersonalizeFiltersPath   = String.Format("{0}{1}_PersonalizeFilters.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ReportID);
                            FormDataXML                         = String.Format("<{0}COLLECTION>{1}</{0}COLLECTION>", TargetEntity.ToUpper(), FormDataXML);                            

                            //Update User Personalization
                            FilterPersonalizationXML = String.Format(@"<FILTERPERSONALIZATION>
                                                                            <ADHOCREPORTFILTERS>
                                                                                    <FILTERLIST>
                                                                                        {0}{1}       
                                                                                    </FILTERLIST>        
                                                                            </ADHOCREPORTFILTERS>
                                                                            <FORMDATAXML>{2}</FORMDATAXML>
                                                                       </FILTERPERSONALIZATION>", str_FilterCombination, 
                                                                       ALCommon.GetInnerValue(ref Str_SearchXml, "<FILTERLIST>", "</FILTERLIST>"),FormDataXML);

                            File.WriteAllText(str_PersonalizeFiltersPath, FilterPersonalizationXML);
                            errorxml_Output = ObjInfraSt.UpdateUserPersonalization("ADHOCREPORTFILTERPERSONALIZATION", "RPT_" + ReportID, ref FilterPersonalizationXML);
                        }
                    }
                }
                #endregion
            
                xml_SearchInput = tmpDoc.OuterXml;				
            }

            xml_SearchOutput = null;
            errorxml_Output = facade_SearchConfiguration.GetHierarchialData(xml_SearchInput, ref xml_SearchOutput);
            if ((!String.IsNullOrEmpty(errorxml_Output)) || (String.IsNullOrEmpty(xml_SearchOutput)))
            {
                throw new Exception("Err_AdhocReport_Get_Report_Data");
            }

           
            //Retrieve the display layout configuration XML from REPORTCONFIGXML.
            xpathnav_AdHocReport = xpathnav_ReportConfig.SelectSingleNode("DisplayLayout/SeriesCollection/AdHocReportsDisplayColumns");
            if (xpathnav_AdHocReport != null)
            {
                xml_DisplayConfiguration = xpathnav_AdHocReport.InnerXml;
            }
            if (String.IsNullOrEmpty(xml_DisplayConfiguration))
            {
                throw new Exception("Err_AdhocReport_Invalid_Report_DisplayConfiguration");
            }

            //Retrieve the name of the object type.
            xpathnav_AdHocReport = xpathnav_ReportConfig.SelectSingleNode("SearchTarget");
            if (xpathnav_AdHocReport != null)
            {
                str_TargetObjectTypeName = xpathnav_AdHocReport.GetAttribute("ObjectName", "");
            }
            if (String.IsNullOrEmpty(str_TargetObjectTypeName))
            {
                throw new Exception("Err_AdhocReport_Invalid_Report_EntityName");
            }

            if (IsShowGrid(xml_SearchOutput, str_TargetObjectTypeName))
            {
                ShowResultGrid = true;

                #region Max Search Result alert hendling
                dict_PlaceHolder = new StringDictionary();
                ObjCommonFn.Get_TOPNRecords_From_SearchResult(str_TargetObjectTypeName, ref xml_SearchOutput, ref ShowNote, ref dict_PlaceHolder);
                if (ShowNote)
                {
                    MaxSearchResultAlert = Localization.GetString("ALResource", ALParamObj.TenantName, "AdhocReport_MaxResultNote", dict_PlaceHolder); ;
                }

                #endregion

                //Retrieve the input configuration XML for grid control.                        
                getGridInputConfiguration(xml_DisplayConfiguration, str_TargetObjectTypeName, ref xml_GridConfiguration, ref xml_GridColumnsArgument, ref GroupDataTypeMap);
                if (String.IsNullOrEmpty(xml_GridConfiguration))
                {
                    throw new Exception("Err_AdhocReport_Invalid_Report_GridConfiguration");
                }

                if (String.IsNullOrEmpty(xml_GridColumnsArgument))
                {
                    throw new Exception("Err_AdhocReport_Invalid_Report_GridDisplayColumns");
                }

                XML DataXML = null;
                Report_Facade reportFacadeObj = new Report_Facade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                errorxml_Output = reportFacadeObj.GetAdHocReportGroupedDataXML(xpathnav_ReportConfig.OuterXml, xml_SearchOutput, ref DataXML);
                if (!String.IsNullOrEmpty(errorxml_Output))
                    throw new Exception(errorxml_Output);
                else
                {
                    if (ShowNote)
                    {
                        st_InsertString = String.Format(@"<REPORTDATA>
                                                      <SHOWMAXRESULTNOTE>TRUE</SHOWMAXRESULTNOTE>
                                                      <TOTALRESULTCOUNT>{0}</TOTALRESULTCOUNT>
                                                      <MAXRESULTCOUNT>{1}</MAXRESULTCOUNT>
                                                    </REPORTDATA>", dict_PlaceHolder["TOTALRESULTCOUNT"], dict_PlaceHolder["MAXRESULTCOUNT"]);
                        File.WriteAllText(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ReportID + "_SearchDetails.xml", st_InsertString);
                    }

                    File.WriteAllText(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ReportID + ".xml", DataXML);
                }

                CustomCulture = new CultureInfo(Localization.GetCultureName(ALParamObj.Language, ALParamObj.TenantName));
                FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out cultureInfo);
                Format = new Formats(FormatXMLPath);

                //Load the XSLT.
                str_XSLTFilePath = ALSolutionCommon.GetXSLTPath(ALParamObj.TenantName, ALParamObj.SolutionName) + "AdHocReportGridPreview.xslt";

                XsltSettings xsltSettingsObj = new XsltSettings();
                xsltSettingsObj.EnableScript = true;

                xslcomptrans_Object = new XslCompiledTransform(true);
                xslcomptrans_Object.Load(str_XSLTFilePath, xsltSettingsObj, null);

                //Initiate the object for argumets.
                xsltarglist_Object = new XsltArgumentList();
                xmldoc_GridColumns = new XmlDocument();
                xmldoc_GridColumns.LoadXml(xml_GridColumnsArgument);

                xmldoc_GroupDataType = new XmlDocument();
                xmldoc_GroupDataType.LoadXml(GroupDataTypeMap);

                xsltarglist_Object.AddParam("ParamArrayGridColumns", "", xmldoc_GridColumns);
                xsltarglist_Object.AddParam("ParamGroupDataTypeMap", "", xmldoc_GroupDataType);
                xsltarglist_Object.AddParam("ParamTargetObjectName", "", str_TargetObjectTypeName);
                xsltarglist_Object.AddParam("LocalizedTotalFor", "", TotalFor_LocalizedStr);
                xsltarglist_Object.AddParam("IsAggregationRequired", "", IsAggregationRequired.ToString().ToUpper());
                xsltarglist_Object.AddExtensionObject("arpv:MyUtils", new XslExtensionClass(Convert.ToUInt64(ALParamObj.SessionID), Convert.ToUInt64(ALParamObj.UserID), ALParamObj.Language, ALParamObj.TenantName, Format, CustomCulture));

                //Initiate the output string writer.
                strbldr_GridDataResultXML = new StringBuilder();
                strwrtr_GridDataResult = new StringWriter(strbldr_GridDataResultXML);

                //Transform the search result XML into the grid XML.
                xpathdoc_SearchResultOutput = new XPathDocument(new StringReader(DataXML));
                xslcomptrans_Object.Transform(xpathdoc_SearchResultOutput, xsltarglist_Object, strwrtr_GridDataResult);

                if (String.IsNullOrEmpty(strbldr_GridDataResultXML.ToString()))
                {
                    throw new Exception("Err_AdhocReport_Invalid_Report_GridData");
                }

                //Initialize the grid properties.
                ALGridAdHocData.ConfigXml = xml_GridConfiguration;
                ALGridAdHocData.DataXml = strbldr_GridDataResultXML.ToString();
                ViewState["AdHocReportGridConfiguration"] = xml_GridConfiguration;
                ViewState["AdHocReportGridData"] = strbldr_GridDataResultXML.ToString();                
            }
            else
            {
                ShowResultGrid                      = false;
                ALGridAdHocData.Visible             = false;
                AdhocReportPreview_ActBar.Visible   = false;                

                Div_NoResultNote.Controls.Clear();
                StringBuilder sbTemp = new StringBuilder(100);
                sbTemp.AppendFormat(@"<table width='100%' border='0' cellspacing='0' cellpadding='5'>
                                            <tr>
                                                <td align='center'><asp:Label ID='Lbl_NoResult' runat='server' class='TextWarning'>{0}</asp:Label></td>
                                            </tr>
                                        </table>", Localization.GetString("ALErrorResource",ALParamObj.TenantName, "ERR_CLM_NoResultsFound_Shared"));

                Div_NoResultNote.Controls.Add(new LiteralControl(sbTemp.ToString()));
            }
        }

        private void GetNLevelConfigColumnList(XPathNavigator xpathnav_DisplayConfig, Int32 currLevel, String TargetObjectTypeName, XML xml_GridLevelsTemplate, ref XML xml_GridLevels, ref String selectDDHTML, ref XML GroupDataTypeMap)
        {            
            XPathNavigator      xpathnav_Column             = null;
            String              str_DataRelationName        = null;
            String              str_DataObjectName          = null;
            String              str_DataFieldName           = null;
            String              str_DataFieldType           = null;
            String              str_DataFieldDisplayName    = null;
            String              str_ColumnName              = null;
            StringBuilder       sb_GridLevelsConfig         = null;
            String              currLevelTemplate           = null;

            currLevelTemplate = xml_GridLevelsTemplate;
            xpathnav_Column = xpathnav_DisplayConfig.SelectSingleNode("CONFIGCOLUMNS[GROUPBYLEVEL='" + (currLevel + 1).ToString() + "']");
            
            if (currLevel == 0)
                selectDDHTML += "<select id=\"LevelSelectDD\" class=\"Text\" onchange=\"ShowLevelChangeHandler(this,'ALGridAdHocData')\" onserverchange=\"ShowLevelChangeHandler\"><option value=\"" + currLevel.ToString() + "\" class=\"Text\" selected=\"selected\">"+ Level_LocalizedStr + " "  + (currLevel + 1).ToString() + "</option>";
            else
                selectDDHTML += "<option value=\"" + currLevel.ToString() + "\" class=\"Text\">" + Level_LocalizedStr + " " + (currLevel + 1).ToString() + "</option>";

            if (xpathnav_Column != null)
            {
                str_DataRelationName = xpathnav_Column.SelectSingleNode("RELATIONSHIPNAME").InnerXml;
                str_DataObjectName = xpathnav_Column.SelectSingleNode("OBJECTNAME").InnerXml;
                str_DataFieldName = xpathnav_Column.SelectSingleNode("FIELDNAME").InnerXml;
                str_DataFieldDisplayName = xpathnav_Column.SelectSingleNode("FIELDTITLE").InnerXml;
                str_ColumnName = str_DataRelationName + "." + str_DataFieldName;
                str_DataFieldType = xpathnav_Column.SelectSingleNode("FIELDDATATYPE").InnerXml;

                GroupDataTypeMap += "<GROUP DataType='" + str_DataFieldType + "' level='"+(currLevel+1).ToString()+"'/>";

                if (currLevel == 0)
                {
                    currLevelTemplate = currLevelTemplate.Replace("$TEXTCSS$", "AdHocReportPreviewGroupText");
                    currLevelTemplate = currLevelTemplate.Replace("$NUMBERCSS$", "AdHocReportPreviewGroupNumber");
                }
                else
                {
                    currLevelTemplate = currLevelTemplate.Replace("$TEXTCSS$", "AdHocReportPreviewSubGroupText");
                    currLevelTemplate = currLevelTemplate.Replace("$NUMBERCSS$", "AdHocReportPreviewSubGroupNumber");
                }

                sb_GridLevelsConfig = new StringBuilder();
                sb_GridLevelsConfig.AppendFormat("<level depth='{0}' type='{1}' levelcss='AdHocReportPreviewRow' headercss='AdHocReportPreviewRow' header='false' expand='false'>{2}</level>", currLevel.ToString(), str_ColumnName, currLevelTemplate);
                xml_GridLevels += sb_GridLevelsConfig.ToString();

                currLevel++;
                GetNLevelConfigColumnList(xpathnav_DisplayConfig, currLevel, TargetObjectTypeName, /*GridColumnsXMLTemplate, */xml_GridLevelsTemplate, ref xml_GridLevels, ref selectDDHTML, ref GroupDataTypeMap);
            }
            else
            {
                str_ColumnName = TargetObjectTypeName;
                currLevelTemplate = currLevelTemplate.Replace("$TEXTCSS$", "AdHocReportPreviewText");
                currLevelTemplate = currLevelTemplate.Replace("$NUMBERCSS$", "AdHocReportPreviewNumber");
                sb_GridLevelsConfig = new StringBuilder();
                sb_GridLevelsConfig.AppendFormat("<level depth='{0}' type='{1}' levelcss='AdHocReportPreviewRow' headercss='AdHocReportPreviewRow' header='false' expand='false'>{2}</level>", currLevel.ToString(), str_ColumnName, currLevelTemplate);
                xml_GridLevels += sb_GridLevelsConfig.ToString();
                selectDDHTML += "</select>";
            }            
        }

        private void getGridInputConfiguration(XML DisplayConfigurationXML, String TargetObjectTypeName,
                ref XML GridConfigurationXML, ref XML GridColumnsArgumentXML, ref XML GroupDataTypeMap)
        {
            #region Member variabels
            XPathDocument       xpathdoc_DisplayConfig      = null;
            XPathNavigator      xpathnav_DisplayConfig      = null;
            XPathNavigator      xpathnav_Column             = null;
            XPathNavigator      xpathnav_GroupByColumn      = null;            
            XPathNodeIterator   xpathiter_Column            = null;
            XML                 xml_GridHeadings            = null;
            String              str_DataRelationName        = null;
            String              str_DataObjectName          = null;
            String              str_DataFieldName           = null;
            String              str_DataFieldType           = null;
            String              str_DataFieldDisplayName    = null;
            Int32               int_ColumnCount             = 0;
            Int32               total_ColumnCount           = 0;
            String              str_ColumnName              = null;
            String              str_Aggregation             = null;
            String              str_Width                   = "";
            XML                 xml_GridLevels              = null;
            XML                 xml_GridLevelsTemplate      = null;
            XML                 GridColumnsXMLTemplate      = null;            
            bool                bool_Freeze                 = false;
            String              selectDDHTML                = "";
            String              CSSPlaceHolder              = "$TEXTCSS$";
            XmlDocument         CaptionXML                  = null;
            XmlNode             DDLNode                     = null;
            String              str_DDLHTML                 = null;
            StringBuilder       sb_Temp                     = null;
            String              str_TempHTML                = null;
            XmlNode             ExportToExcelNode           = null;
            #endregion

            xpathdoc_DisplayConfig = new XPathDocument(new StringReader(DisplayConfigurationXML));
            xpathnav_DisplayConfig = xpathdoc_DisplayConfig.CreateNavigator().SelectSingleNode("CONFIGCOLUMNSCOLLECTION");
            xpathnav_GroupByColumn = xpathnav_DisplayConfig.SelectSingleNode("CONFIGCOLUMNS[GROUPBYLEVEL='1']");
            xpathiter_Column = xpathnav_DisplayConfig.Select("CONFIGCOLUMNS[GROUPBYLEVEL='None']");

            if (xpathnav_GroupByColumn != null)
            {
                if (xpathiter_Column != null)
                    total_ColumnCount = xpathiter_Column.Count;

                if (total_ColumnCount > 0)
                    bool_Freeze = true;

                int_ColumnCount++;
                str_ColumnName = TargetObjectTypeName + ".GROUPDATAVALUE";
                GridColumnsXMLTemplate += "<COLUMN><OBJECTNAME>" + TargetObjectTypeName
                                        + "</OBJECTNAME><FIELDDATATYPE>TEXT"
                                        + "</FIELDDATATYPE><RELATIONSHIPNAME>" + TargetObjectTypeName
                                        + "</RELATIONSHIPNAME><AGGREGATION>NONE"
                                        + "</AGGREGATION><FIELDNAME>GROUPDATAVALUE"
                                        + "</FIELDNAME><COLUMNINDEX>" + int_ColumnCount.ToString()
                                        + "</COLUMNINDEX></COLUMN>";
                
                str_Width = "200"; //Default Width
                if (xpathnav_GroupByColumn.SelectSingleNode("WIDTH") != null)
                {
                    if (!String.IsNullOrEmpty(xpathnav_GroupByColumn.SelectSingleNode("WIDTH").InnerXml))
                        str_Width = xpathnav_GroupByColumn.SelectSingleNode("WIDTH").InnerXml;
                }

                xml_GridHeadings += "<headercolumn cellcss='AGHeaderWithWrapAdHocReport' textcss='AGHeadTextWithWrapAdHocReportPreview' type='text' order='" + int_ColumnCount.ToString()
                                    + "' displaytextid='AdhocReport_Preview_GroupedBy'"
                                    + " name='" + str_ColumnName + "' width='"+str_Width+"' freeze='" + bool_Freeze.ToString().ToLower() + "' iconcss='AdHocReportLeafImage'/>";

                xml_GridLevelsTemplate += "<datafield name='" + str_ColumnName + "'"
                           + " footer='false' footercss=''><header cellcss='AdHocReportPreviewAGCell'><levelheadercolumn value=''/>"
                           + "</header><data cellcss='AdHocReportPreviewAGCell'><leveldatacolumn value='$" + str_ColumnName + "'"
                           + " textcss='$TEXTCSS$'/></data></datafield>";

                bool_Freeze = false;

                str_Width = "";
            }

            if (xpathiter_Column != null)
            {                
                while (xpathiter_Column.MoveNext())
                {
                    int_ColumnCount++;
                    xpathnav_Column = xpathiter_Column.Current;
                    str_DataRelationName = xpathnav_Column.SelectSingleNode("RELATIONSHIPNAME").InnerXml;
                    str_DataObjectName = xpathnav_Column.SelectSingleNode("OBJECTNAME").InnerXml;
                    str_DataFieldName = xpathnav_Column.SelectSingleNode("FIELDNAME").InnerXml;
                    str_DataFieldType = xpathnav_Column.SelectSingleNode("FIELDDATATYPE").InnerXml;
                    str_DataFieldDisplayName = xpathnav_Column.SelectSingleNode("FIELDTITLE").InnerXml;
                    str_Aggregation = xpathnav_Column.SelectSingleNode("AGGREGATION").InnerXml;
                    if (xpathnav_Column.SelectSingleNode("WIDTH") != null)
                    {
                        if (!String.IsNullOrEmpty(xpathnav_Column.SelectSingleNode("WIDTH").InnerXml))
                            str_Width = xpathnav_Column.SelectSingleNode("WIDTH").InnerXml;
                    }
                    str_ColumnName = str_DataRelationName + "." + str_DataFieldName;

                    if (str_Aggregation.ToUpper() != "NONE")
                        IsAggregationRequired = true;

                    GridColumnsXMLTemplate += "<COLUMN><OBJECTNAME>" + str_DataObjectName
                                            + "</OBJECTNAME><FIELDDATATYPE>" + str_DataFieldType.ToUpper() 
                                            + "</FIELDDATATYPE><RELATIONSHIPNAME>" + str_DataRelationName 
                                            + "</RELATIONSHIPNAME><AGGREGATION>" + str_Aggregation.ToUpper() 
                                            + "</AGGREGATION><FIELDNAME>" + str_DataFieldName 
                                            + "</FIELDNAME><COLUMNINDEX>" + int_ColumnCount.ToString() 
                                            + "</COLUMNINDEX></COLUMN>";

                    if (String.IsNullOrEmpty(str_Width))
                    {
                        switch (str_DataFieldType.ToUpper())
                        {
                            case Constants.DATA_TYPE_DATE:
                            //case Constants.DATA_TYPE_DATETIME:
                            case Constants.DATA_TYPE_FLOAT:
                            case Constants.DATA_TYPE_NUMBER:
                            case Constants.DATA_TYPE_CURRENCY:
                                str_Width = "120";
                                break;
                            case Constants.DATA_TYPE_DATETIME:
                                str_Width = "150";
                                break;
                            default:
                                str_Width = "200";
                                break;
                        }
                    }

                    switch (str_DataFieldType.ToUpper())
                    {                        
                        case Constants.DATA_TYPE_FLOAT:
                        case Constants.DATA_TYPE_NUMBER:
                        case Constants.DATA_TYPE_CURRENCY:
                            CSSPlaceHolder = "$NUMBERCSS$";
                            break;
                        default:
                            CSSPlaceHolder = "$TEXTCSS$";
                            break;
                    }
                    
                    //Following is done as when date time is present formatting is handled by XSLT.
                    //This is done to provide the feature that when time is 12:00 AM, then time should not be shown and only date should be shown
                    if (str_DataFieldType.ToLower() == Constants.DATA_TYPE_DATETIME.ToLower())
                        str_DataFieldType = Constants.DATA_TYPE_TEXT.ToLower();

                    ALSolutionCommon.EncodeSpecialCharacters(ref str_DataFieldDisplayName);

                    xml_GridHeadings += "<headercolumn cellcss='AGHeaderWithWrapAdHocReport' textcss='AGHeadTextWithWrapAdHocReportPreview' type='" + str_DataFieldType.ToLower() + "' order='" + int_ColumnCount.ToString()
                                + "' displaytextid='" + str_DataFieldDisplayName
                                + "' name='" + str_ColumnName + "' width='" + str_Width + "' freeze='" + bool_Freeze.ToString().ToLower() + "'/>"; //****" + xpathnav_Column.GetAttribute("Width", "") + " WIDTH SHOULD BE TAKEN FROM LIST.
                    
                    xml_GridLevelsTemplate += "<datafield name='" + str_ColumnName
                               + "' footer='false' footercss=''><header cellcss='AdHocReportPreviewAGCell'><levelheadercolumn value=''/>"
                               + "</header><data cellcss='AdHocReportPreviewAGCell'><leveldatacolumn value='$" + str_ColumnName
                               + "' textcss='"+CSSPlaceHolder+"'/></data></datafield>";
                    
                    str_Width = "";
                }
            }

            GridColumnsArgumentXML = "<GRIDCOLUMNS>";
            GroupDataTypeMap = "<GROUPS>";

            GridColumnsArgumentXML += GridColumnsXMLTemplate;            
            GetNLevelConfigColumnList(xpathnav_DisplayConfig, 0, TargetObjectTypeName, xml_GridLevelsTemplate, ref xml_GridLevels, ref selectDDHTML, ref GroupDataTypeMap);

            #region Assign Updated DDL HTML to BaseControls CaptionTextHTML       
            Div_LevelSelectDDContainer.InnerHtml = selectDDHTML;
            sb_Temp        = ABC_PersonliazedFilters.CaptionHTML;
            str_TempHTML   = sb_Temp.ToString();
            CaptionXML     = new XmlDocument();           
            CaptionXML.LoadXml(str_TempHTML);

            DDLNode        = CaptionXML.SelectSingleNode("//select");
            if (DDLNode != null)
                DDLNode.ParentNode.InnerXml = selectDDHTML;

            String ExportToExcelURL = "AdHocReportExportHandler.ashx?REPORTID=" + ReportID + "&EXPORTTYPE=EXCELEXPORT";
            ExportToExcelURL += "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&Language=" + ALParamObj.Language + "&TenantName=" + ALParamObj.TenantName + "&SolutionName=" + ALParamObj.SolutionName;
            ExportToExcelURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ExportToExcelURL);
        
            ExportToExcelNode = CaptionXML.SelectSingleNode("//img[@id='ExcelIcon']");
            if(ExportToExcelNode != null)
            {
                ((XmlElement)ExportToExcelNode).SetAttribute("onclick", "javascript:ShowPopupWindow('" + ExportToExcelURL + "');");
                ((XmlElement)ExportToExcelNode).SetAttribute("class", "AdHocReportPreviewExcelIcon");
            }

            sb_Temp        = new StringBuilder(CaptionXML.OuterXml);
            ABC_PersonliazedFilters.CaptionHTML  = sb_Temp;
            #endregion

            GridConfigurationXML = "<gridconfiguration width='96%' height='55%' columnresizing='true'><header checkbox='false' wrap='true' leafimage='false' bordercss='AGHeaderBorderAdHocReport'>"
                    + xml_GridHeadings + "</header><levels>" + xml_GridLevels + "</levels></gridconfiguration>";
            
            GridColumnsArgumentXML += "</GRIDCOLUMNS>";
            GroupDataTypeMap += "</GROUPS>";
        }

        //Yuvraj
        private void setAdHocReportConfigFormControl()
        {
            XML             xml_FormControlInput    = null;
            ERRORXML        errorxml_Output         = null;
            XML             xml_SearchOutput        = null;
            XDocument       xDoc_FormInput          = null;
            XElement        xEle_Field              = null;            
            UserFacade      userFacadeObj           = null; 
            String          userXML                 = null;
            String          userAttrsXML            = null;
            XPathDocument   xpDoc_UserColl          = null;
            XPathNavigator  xpNav_User              = null;
            String          FormatXMLPath           = null;
            String          cultureInfo             = null;

            userFacadeObj = new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

            FormFacadeObject = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            FormFacadeObject.ShowConfiguredFields   = true;
            FormFacadeObject.SolutionName           = ALParamObj.SolutionName;
            FormFacadeObject.FormName               = "AdHocReportPreview";

            Form_AdHocConfig.TenantName             = ALParamObj.TenantName;
            Form_AdHocConfig.ConfigurationXMLType   = CustomControls.Form.InputType.XMLPath;
            Form_AdHocConfig.ConfigurationXML       = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "AdHocReportPreview_FormConfiguration");            

            if (!IsPostBack)
            {
                xml_SearchOutput = getFormDataSearchResultSetXML();                

                errorxml_Output = FormFacadeObject.GetFormInputXML(ScreenMode, xml_SearchOutput, out xml_FormControlInput, out ObjectInfoCollection);
                if (!(String.IsNullOrEmpty(errorxml_Output)))
                {
                    throw new Exception("Err_AdhocReport_Get_ReportSummary_FormInputXML");
                }

                if (ObjectInfoCollection != null)
                    ViewState["ObjectInfoList"] = ObjectInfoCollection;

                if (!String.IsNullOrEmpty(xml_FormControlInput))
                {
                    xDoc_FormInput = XDocument.Parse(xml_FormControlInput);
                    xEle_Field = xDoc_FormInput.Root.XPathSelectElement("Field[@Name='ADHOCREPORT_REPORTGENERATEDBY']");
                    if (xEle_Field != null)
                    {
                        userAttrsXML = "<USER><FIRSTNAME/><LASTNAME/><LOGINNAME/><MIDDLENAME/></USER>";
                        errorxml_Output = userFacadeObj.GetUser(ulong.Parse(ALParamObj.UserID), userAttrsXML, null, out userXML);
                        xpDoc_UserColl = new XPathDocument(new StringReader(userXML));
                        xpNav_User  = xpDoc_UserColl.CreateNavigator().SelectSingleNode("USERCOLLECTION");
                        ReportGeneratedBy  = ALCommon.GetFormattedUserName(xpNav_User);
                        xEle_Field.SetElementValue("Value", ReportGeneratedBy);
                    }

                    xEle_Field = xDoc_FormInput.Root.XPathSelectElement("Field[@Name='ADHOCREPORT_GENERATEDON']");
                    if (xEle_Field != null)
                    {
                        FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out cultureInfo);
                        DateTime now = DateTime.Now;                                                
                        ReportGeneratedOn = ALCommon.FormatDateTimeField(FormatXMLPath, now.Day.ToString(), now.Month.ToString(), now.Year.ToString(), now.Hour.ToString(), now.Minute.ToString(), now.Second.ToString(), System.Globalization.CultureInfo.GetCultureInfo(cultureInfo), null);
                        xEle_Field.SetElementValue("Value", ReportGeneratedOn);
                    }

                    xml_FormControlInput = xDoc_FormInput.Root.ToString();

                    Form_AdHocConfig.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                    Form_AdHocConfig.InputXML = xml_FormControlInput;
                }
            }
        }

        //getFormDataSearchResultSetXML() method is used to retrieve the data results for Adhoc report instance which is required for form control.
        private XML getFormDataSearchResultSetXML()
        {
            SearchConfiguration facade_SearchConfiguration = null;
            String str_InsertString = null;
            XML xml_SearchInput = null;
            XML xml_SearchOutput = null;
            ERRORXML errorxml_Output = null;

            errorxml_Output = FormFacadeObject.GetHierarchicalSearchXML(ScreenMode, out xml_SearchInput);
            if (!(String.IsNullOrEmpty(errorxml_Output)))
            {
                throw new Exception("Err_AdhocReport_Get_ReportSummary_SearchInputXML");
            }

            if (String.IsNullOrEmpty(xml_SearchInput))
            {
                throw new Exception("Err_AdhocReport_Invalid_ReportSummary_SearchInputXML");
            }

            str_InsertString = @"<FILTERLIST>
			            <FILTER>
				            <FILTERID>1</FILTERID>
				            <EXPRESSION>REPORTID</EXPRESSION>
				            <OPERATOR>EQUALTO</OPERATOR>
				            <EXPRESSIONVALUE>" + ReportID + @"</EXPRESSIONVALUE>
				            <ISCASESENSITIVE>False</ISCASESENSITIVE>
			            </FILTER>
                    </FILTERLIST>";
            xml_SearchInput = ALCommon.InsertAfter(ref xml_SearchInput, "<TARGETENTITY>", ref str_InsertString);

            if (!(xml_SearchInput.Contains("<AUTHORIZATIONREQUIRED>")))
            {
                str_InsertString = "<AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>";
                xml_SearchInput = ALCommon.InsertBefore(ref xml_SearchInput, "<TARGETENTITY>", ref str_InsertString);
            }

            str_InsertString = "<SESSIONINFO UserID='" + ALParamObj.UserID + "' Language='" + ALParamObj.Language
                    + "' TenantName='" + ALParamObj.TenantName + "' SessionID='" + ALParamObj.SessionID + "'/>";
            xml_SearchInput = ALCommon.InsertBefore(ref xml_SearchInput, "<TARGETENTITY>", ref str_InsertString);

            if (!(xml_SearchInput.Contains("REPORTCONFIGXML")))
            {
                str_InsertString = "<EXPRESSION><FIELDNAME>REPORTCONFIGXML</FIELDNAME><ALIAS>REPORTCONFIGXML</ALIAS></EXPRESSION>";
                xml_SearchInput = ALCommon.InsertBefore(ref xml_SearchInput, "</SELECTLIST>", ref str_InsertString);
            }

            facade_SearchConfiguration = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            errorxml_Output = facade_SearchConfiguration.GetHierarchialData(xml_SearchInput, ref xml_SearchOutput);
            if (!String.IsNullOrEmpty(errorxml_Output))
            {
                throw new Exception("Err_AdhocReport_Get_ReportSummary_Details");
            }

            AdHocReportConfigXML                = xml_SearchOutput;
            ViewState["AdHocReportConfigXML"]   = AdHocReportConfigXML;
            return (xml_SearchOutput);
        }

        private string GetImagesPath()
        {
            return String.Format("/{0}/App_Themes/{1}/Images/", ALParamObj.TenantName, Page.Theme);
        }

        /// This is used to redirect current page to an error page if any error occurred while working with system.
        //redirectToErrorPage() method is used to redirect current page to an error page if any error occurred while working with system.
        private void redirectToErrorPage(String ErrorMessageString)
        {
            String str_RedirectionPage = null;
            ERRORXML errorxml_Output = null;
            StringBuilder sb_ErrorPageURL = null;
            String str_ErrorPageURL = null;

            ErrorMessageString = Localization.GetString("ALErrorResource", ALParamObj.TenantName, ErrorMessageString, ErrorMessageString);

            errorxml_Output = ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "REPORTS", null, ErrorMessageString, null, null, ref str_ErrorPageURL);
            if (String.IsNullOrEmpty(errorxml_Output))
            {
                sb_ErrorPageURL = new StringBuilder(200);
                sb_ErrorPageURL.Append("/" + ALParamObj.TenantName + "/Common/ASPX/ShowError.aspx?" + ALSolutionCommon.AppendStandardParamforURL(ALParamObj));
                sb_ErrorPageURL.Append("&ShowOKButton=FALSE&ErrorMessage=" + ErrorMessageString);
                str_ErrorPageURL = sb_ErrorPageURL.ToString();
            }

            str_RedirectionPage = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_ErrorPageURL);
            if (Page.IsPostBack)
                Ajax.Redirect(this.Page, str_RedirectionPage);
            else
                Response.Redirect(str_RedirectionPage);
        }

        private void setPersonalizationFiltersForm()
        {
            #region member variables
            XML             xml_FormControlInput        = null;         
            ERRORXML        errorxml_Output             = null;
            XML             xml_SearchOutput            = null;
            XDocument       xDoc_ReportXML              = null;
            XElement        xEle_ReportRoot             = null;            
            XElement        xEle_ReportForm             = null;
            XElement        xEle_PersonalizationFilter  = null;
            String          str_PersonalizeFiltersPath  = null;
            InfrastructureFacadeClass ObjInfrast        = null;
            String          UserPersonalization         = null;
            #endregion
            
            FormFacadeObject                        = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            FormFacadeObject.ShowConfiguredFields   = true;
            FormFacadeObject.SolutionName           = ALParamObj.SolutionName;

            if (String.IsNullOrEmpty(AdHocReportConfigXML))
            {
                if (ViewState["AdHocReportConfigXML"] != null && !String.IsNullOrEmpty((String)ViewState["AdHocReportConfigXML"]))
                    AdHocReportConfigXML = ViewState["AdHocReportConfigXML"].ToString();
                else
                    AdHocReportConfigXML = GetReportData();
            }

            xDoc_ReportXML                          = XDocument.Parse(AdHocReportConfigXML);
            xEle_ReportRoot                         = xDoc_ReportXML.Root;
            xEle_PersonalizationFilter              = xEle_ReportRoot.XPathSelectElement("ADHOCREPORT/REPORTCONFIGXML/CONFIGURATION/PersonalizationFilters/PersonalizationFilter");
            if(xEle_PersonalizationFilter != null)
            {
                xEle_ReportForm                     = xEle_ReportRoot.XPathSelectElement("ADHOCREPORT/REPORTCONFIGXML/CONFIGURATION/Form");
                if (xEle_ReportForm != null)
                {
                    str_PersonalizeFiltersPath                  = String.Format("{0}{1}_PersonalizeFilters.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ReportID);
                    if (!File.Exists(str_PersonalizeFiltersPath))                    
                    {
                        //Get User Personalization for report filters and save it.
                        ObjInfrast      = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        errorxml_Output = ObjInfrast.GetUserPersonalization("ADHOCREPORTFILTERPERSONALIZATION", "RPT_" + ReportID, out UserPersonalization);
                        if (String.IsNullOrEmpty(errorxml_Output))
                        {
                            if (!String.IsNullOrEmpty(UserPersonalization))
                            {
                                File.WriteAllText(str_PersonalizeFiltersPath, UserPersonalization);                                
                                xml_SearchOutput = ALCommon.GetInnerValue(ref UserPersonalization, "<FORMDATAXML>", "</FORMDATAXML>");
                            }
                        }
                        else
                        { 
                            //Redirect to Error Page
                        }
                    }
                    else
                    {
                        xml_SearchOutput = File.ReadAllText(str_PersonalizeFiltersPath);
                        xml_SearchOutput = ALCommon.GetInnerValue(ref xml_SearchOutput, "<FORMDATAXML>", "</FORMDATAXML>");
                    }
                   
                    ShowResultGrid                              = false;
                    FormFacadeObject.ConfigurationXMLType       = "INNERXML";
                    FormFacadeObject.ConfigurationXML           = xEle_ReportForm.ToString(); 
                    FormFacadeObject.FormName                   = xEle_ReportForm.Attribute("Name").Value;
                    Frm_PersonalizeFilters.TenantName           = ALParamObj.TenantName;
                    Frm_PersonalizeFilters.ConfigurationXMLType = CustomControls.Form.InputType.InnerXML;
                    Frm_PersonalizeFilters.ConfigurationXML     = xEle_ReportForm.ToString();

                    errorxml_Output                             = FormFacadeObject.GetFormInputXML("EDIT", xml_SearchOutput, out xml_FormControlInput, out ObjectInfoCollection);
                    if (!(String.IsNullOrEmpty(errorxml_Output)))
                    {
                        throw new Exception("Err_AdhocReport_Get_ReportSummary_FormInputXML");
                    }

                    if (ObjectInfoCollection != null)
                        ViewState["PersonalizedObjectInfoList"] = ObjectInfoCollection;

                    Frm_PersonalizeFilters.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                    Frm_PersonalizeFilters.InputXML     = xml_FormControlInput;                    
                }
                else
                {
                    ShowResultGrid = true;
                    Div_PersonalizeFilters.Attributes.Add("style", "display:none;");
                    Div_ActionBar.Attributes.Add("style", "display:bock;");
                }
            }
            else
            {
                ShowResultGrid = true;
                Div_PersonalizeFilters.Attributes.Add("style", "display:none;");
                Div_ActionBar.Attributes.Add("style", "display:bock;");
            }
        }


        private String GetReportData()
        {
            #region Method Variables

            SearchConfiguration     facade_SearchConfiguration  = null;            
            StringBuilder           strbldr_SearchInputXML      = null;
            XML                     xml_SearchOutput            = null;            
            ERRORXML                errorxml_Output             = null;            
            #endregion

            facade_SearchConfiguration  = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            strbldr_SearchInputXML      = new StringBuilder(250);

            strbldr_SearchInputXML.AppendFormat(@"<SEARCH>
	                <TARGETOBJECT>ADHOCREPORT</TARGETOBJECT>
	                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
	                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                <SESSIONINFO UserID='{0}' Language='{1}' TenantName='{2}' SessionID='{3}'/>
	                <TARGETENTITY>
		                <SELECTLIST>
			                <EXPRESSION>
				                <FIELDNAME>REPORTID</FIELDNAME>
				                <ALIAS>REPORTID</ALIAS>
			                </EXPRESSION>
			                <EXPRESSION>
				                <FIELDNAME>REPORTCONFIGXML</FIELDNAME>
				                <ALIAS>REPORTCONFIGXML</ALIAS>
			                </EXPRESSION>
		                </SELECTLIST>
                        <FILTERLIST>
			                <FILTER>
				                <FILTERID>1</FILTERID>
				                <EXPRESSION>REPORTID</EXPRESSION>
				                <OPERATOR>EQUALTO</OPERATOR>
				                <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
				                <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                </FILTER>
                        </FILTERLIST>
	                </TARGETENTITY>
                </SEARCH>", ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ALParamObj.SessionID, ReportID);

            errorxml_Output = facade_SearchConfiguration.GetHierarchialData(strbldr_SearchInputXML.ToString(), ref xml_SearchOutput);
            if ((!String.IsNullOrEmpty(errorxml_Output)) || (String.IsNullOrEmpty(xml_SearchOutput)))
            {
                throw new Exception("Err_AdhocReport_Get_Report_Configuration");
            }
            AdHocReportConfigXML                = xml_SearchOutput;
            ViewState["AdHocReportConfigXML"]   = AdHocReportConfigXML;
            return AdHocReportConfigXML;
        }

        private bool IsShowGrid(String SearcgResultXML, String TargetEntity)
        {
            bool showGrid = true;
            String str_SearchString = null;

            str_SearchString = String.Format("<{0}>", TargetEntity);
            if (SearcgResultXML.IndexOf(str_SearchString) == -1)
                showGrid = false;
            return showGrid;
        }
        #endregion        
    }
}