#region System Includes
    using System;
    using System.Data;
    using System.Xml;
    using System.Text;
    using System.Configuration;
    using System.Web;
    using System.Web.Security;
    using System.Web.UI;
    using System.Collections;
    using System.Web.UI.WebControls;
    using System.Web.UI.WebControls.WebParts;
    using System.Web.UI.HtmlControls;
    using System.Xml.XPath;
    using System.IO;    
    using System.Collections.Generic;
#endregion

#region AssetlinkInclude
    using Assetlink.Solutions;
    using Assetlink.CustomControls;
    using Assetlink.Solutions.Facade.CommonFacade;    
    using Assetlink.Solutions.Facade.UGMFacade;
    using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
    using Assetlink.Solutions.Facade.PMFacade;
    using Assetlink.Solutions.Pages;
#endregion

//-----------------------------------------------------//
// File Name:   Manage_AssignContributor.aspx.cs       //
// Author:      Mr. Hemant Karkande.                   //
// Class:       Manage_AssignContributor               //
// Created On:  08th December 2006                     //
//-----------------------------------------------------//

namespace Assetlink.Solutions.MarketingWorkBench
{
    using XML       = String;
    using ERRORXML  = String;

    public partial class Manage_AssignContributor : ALAjaxPage 
    {
        #region Member Variables
            private ALSolutionCommon ALSolutionCommonObj     = null;
            //private Dictionary<String, String> m_ParamList   = null;
            public ALParam ALParamObj                        = null;
            private String PackageDefinitionID               = null;
            private String ProcessDefinitionID               = null;
            private String ParentDeliverableID               = null;                 
            private String FormMode                          = "Edit";
            private String Mode                              = null;
            private String Access                            = null; 
            private String ParentProjectID                   = null;        
            private String TempPath                          = null; 
            private String[] strSeparator                    = null;
            private String SolutionName                      = "MarketingWorkBench";
            private String ResourceListFile                  = "MWB_AssignContributor.xml";
			private String ResourceTreeFile					 = "MWB_AssignContributorTreeXML.xml";
            
            private String TaskDefinitionFileName            = "MWB_TaskDefinitionForRoles.xml";
            private String RolesXMLFileName                  = "MWB_TaskRoles.xml";
            private String BreadCrumbCtrlID                  = null;
            private String ParentBreadcrumbName              = null; 
            private String PrevScreen                        = null; 
            private String str_GoBackScreen                  = null; 
            private String DeliverableActivityName           = null;
            private String ProjectId                         = null;
            
        #endregion

        #region ControlsOnPage
            private Assetlink.CustomControls.ListControl    Lst_Assign_Contributors = null;
            private ActionBar                               Ab_AssignContributors   = null;
            private ALBreadCrumb                            RolesBreadCrumb         = null; 
        #endregion

        # region Protected Methods

            protected void Page_Init(object sender, EventArgs e)
        {
            ALSolutionCommonObj = new ALSolutionCommon();
            ALParamObj = new ALParam();

            ALSolutionCommonObj.httpContext = HttpContext.Current;
            ALSolutionCommonObj.InitALParam(ref ALParamObj);

            ((ALMasterPage)this.Master).SessionID       = ALParamObj.SessionID;
            ((ALMasterPage)this.Master).UserID          = ALParamObj.UserID;
            ((ALMasterPage)this.Master).Language        = ALParamObj.Language;
            ((ALMasterPage)this.Master).TenantName      = ALParamObj.TenantName;
            ((ALMasterPage)this.Master).SolutionName    = SolutionName;
            ((ALMasterPage)this.Master).PageTitle       = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_MarketingWorkbench_Shared");
        }

            protected void Page_Load(object sender, EventArgs e)
            {	
                setParameters();
                setControls();
                setLeftPane();
                if (!IsPostBack)
                {
                    if (FormMode.ToUpper() == "CREATE")
                    {
                        setPageInCreateMode();
                        setBreadcrumbs(); 
                    }
                    else if (FormMode.ToUpper() == "EDIT")
                    {
                        setPageInEditMode();
                        setBreadcrumbs(); 
                    }
                }
            }

			protected void HiddenBtn_SelectResourceType_Click(object sender, EventArgs e)
			{
				String			ResourceID	 = null;
				StringBuilder	FilePath	 = null;
				UserFacade		UserFacadeObj= null;
				MWB_Helper		MWB_HelperObj= null;
				String			TempPath	 = null;
				XPathDocument	RecDoc		 = null;
				XPathNavigator	xpNav		 = null;
				XPathNodeIterator	xpIter	 = null;
				String			SelectedValue= null;
				XML				SearchXML	 = null;
				XML				UserXML		 = null;
				ERRORXML		ErrorXml	 = null;
				XPathDocument   UserDoc		 = null;				
				String        UserID        = null;
                String        LoginName     = null;
                String        FirstName     = null;
                String        LastName      = null;  
                String        MiddleName    = null;                    
                String        FormattedName = null;
				StringBuilder  ItemListXML	= null;	
				try
				{
					ResourceID = Request["__EVENTARGUMENT"];
					FilePath		= new StringBuilder(100);
					ItemListXML		= new StringBuilder(200);
					UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					MWB_HelperObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					TempPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					FilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
					if(!String.IsNullOrEmpty(ResourceID))
					{
						// read the List XML and Update it with the Selected ResourceName
						if(File.Exists(FilePath.ToString()))
						{
							RecDoc = new XPathDocument(FilePath.ToString());
							xpNav  = RecDoc.CreateNavigator();
							xpNav  = xpNav.SelectSingleNode("//*/TreeNode[@Selected='True']");
							if(xpNav != null)
							{
								SelectedValue = xpNav.GetAttribute("Text", "");
								SearchXML = GetSearchXML(SelectedValue);
								ErrorXml = UserFacadeObj.GetUserList(SearchXML, ref UserXML);
								if(ErrorXml == null)
								{
									UserDoc = new XPathDocument(new StringReader(UserXML));
									xpNav = UserDoc.CreateNavigator();
									ItemListXML.Append("<Item Text='None' Value='None' Selected='True'></Item>");
                                    xpIter = xpNav.Select("SEARCHOUTPUTXML/USERCOLLECTION/USER");
									while(xpIter.MoveNext())
									{
										UserID		= xpIter.Current.SelectSingleNode("USERID").Value;
										LoginName	= xpIter.Current.SelectSingleNode("LOGINNAME").Value;
										FirstName	= xpIter.Current.SelectSingleNode("FIRSTNAME").Value;
										MiddleName  = xpIter.Current.SelectSingleNode("MIDDLEINITIAL").Value;
										LastName	= xpIter.Current.SelectSingleNode("LASTNAME").Value;
										FormattedName = ALCommon.FormatUserName(FirstName, LastName, MiddleName, LoginName, ALCommon.GetUserNameFormat());
										ItemListXML.AppendFormat("<Item Text='{0}' Value='{1}' Selected='False'></Item>", ALCommon.TrimAndReplaceSpecialChars(FormattedName), UserID);
									}
									UpdateList(ResourceID, SelectedValue, ItemListXML.ToString());
									// also update other resource types matching the selected resource name.
									UpdateSimilarResources(ResourceID, SelectedValue);
								}
							}
						}
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

            protected override void Render(HtmlTextWriter writer)
            {
				String EvenGen = Ajax.EventGeneratorUniqueID;
				if (IsPostBack)
                {
					if(EvenGen.Contains("HiddenBtn_SelectResourceType"))
						Ajax.AddControlsToRender(Lst_Assign_Contributors);
					Ajax.WriteControlHTMl(this.Page, writer);
                }
                else
                    base.Render(writer);
            }
        # endregion

        # region Private Methods

            private void setParameters()
            {
                ulong			ErrorID				= 0;
                StringBuilder	ErrorPageURL_Exp	= null;

                try
                {
                    strSeparator = new String[1] { "$AL$" };
                    ParentDeliverableID = ALSolutionCommonObj.GetParamValue("DeliverableID");
                    ParentProjectID     = ALSolutionCommonObj.GetParamValue("ProjectID");
                    PackageDefinitionID = ALSolutionCommonObj.GetParamValue("PackageDefinitionID");
                    ProcessDefinitionID = ALSolutionCommonObj.GetParamValue("ProcessDefinitionID");
                    Mode                = ALSolutionCommonObj.GetParamValue("Mode");
                    Access              = ALSolutionCommonObj.GetParamValue("Access");  
                    FormMode            = ALSolutionCommonObj.GetParamValue("FormMode");
                    BreadCrumbCtrlID    = ALSolutionCommonObj.GetParamValue("BREADCRUMBCTRLID");
                    ParentBreadcrumbName= ALSolutionCommonObj.GetParamValue("PARENTBREADCRUMBNAME");
                    PrevScreen          = ALSolutionCommonObj.GetParamValue("PrevScreen");
                    DeliverableActivityName = ALCommon.Decrypt(ALSolutionCommonObj.GetParamValue("ActivityName"));
                    str_GoBackScreen        = ALSolutionCommonObj.GetParamValue("GoBackScreen");
                    ProjectId           = ALSolutionCommonObj.GetParamValue("ProjectID");
                    
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "setParameters", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_DeliverableDetails_Exceptionwhilesettingtheparameters_Shared"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            /// <alsummary>
            /// <CreatedDate>08 December 2006</CreatedDate>
            /// <Authour>Hemant Karkande</Authour>
            /// <Purpose>To set Tenant name and XMLs for the controls on this page.</Purpose>
            /// <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes> 
            /// </alsummary>
            private void setControls()
            {
                StringBuilder ListControlXMLPath    = null;                
                StringBuilder ActionBarXMLPath      = null;
                StringBuilder CancelBtnURL          = null;                 
                ulong		  ErrorID				= 0;
                StringBuilder ErrorPageURL_Exp	    = null;

                try
                {
                    ListControlXMLPath  = new StringBuilder();
                    ActionBarXMLPath    = new StringBuilder();                    
                    CancelBtnURL        = new StringBuilder();

                    Page_CreatePage.TenantName = ALParamObj.TenantName;
                    Page_CreatePage.SectionHeading = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Manage_AssignContributor_AssignContributor");
                    // set the tenant name of task panes
                    Left_1_tp_MarketingWorkBench.TenantName = ALParamObj.TenantName;
                    Left_2_tp_TP_Manage.TenantName = ALParamObj.TenantName;    

                    TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);  

                    // set the input XML paths of task panes.                    
                    Left_1_tp_MarketingWorkBench.SelectedSectionName = "Manage";

                    //Bread Crumbs
                    RolesBreadCrumb = (ALBreadCrumb)this.Page_CreatePage.FindControl("RolesBreadcrumb");
                    RolesBreadCrumb.TenantName = ALParamObj.TenantName;
                    RolesBreadCrumb.BreadcrumbTextMode = ALBreadCrumb.BreadcrumbText.Text;  
    

                    //Contributor List
                    Lst_Assign_Contributors             = (Assetlink.CustomControls.ListControl)Page_CreatePage.FindControl("Content_1_lc_Assign_Contributors");
                    Lst_Assign_Contributors.TenantName  = ALParamObj.TenantName;
                    
                    //Contributor AB
                    ActionBarXMLPath = null;
                    ActionBarXMLPath = new StringBuilder();
                    ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Manage_FinalAssignContributor_Content_2_ab_AssignContributors_ButtonBar_ActionBar"));
                    Ab_AssignContributors               = (ActionBar)Page_CreatePage.FindControl("Content_2_ab_AssignContributors_ButtonBar");
                    Ab_AssignContributors.TenantName    = ALParamObj.TenantName;
                    Ab_AssignContributors.InputXML      = ActionBarXMLPath.ToString();
                    Ab_AssignContributors.Click         += new EventHandler(Ab_AssignContributors_Click);

                    if (FormMode.ToUpper() == "CREATE")
                        //Go to ROProject Screen
                        CancelBtnURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ParentProjectID);
                    else if (FormMode.ToUpper() == "EDIT")
                    {
                        if ((!String.IsNullOrEmpty(str_GoBackScreen)) && (str_GoBackScreen.ToUpper() == "ROPROJECT"))
                        {
                            CancelBtnURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ParentProjectID);
                        }
                        else
                        {
                            //Go to RODeliverable Screen
                            CancelBtnURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&PackageDefinitionID={5}&ProcessDefinitionID={6}&DeliverableID={7}&Mode={8}&Access={9}&BREADCRUMBCTRLID={10}&PARENTBREADCRUMBNAME={11}&PrevScreen={12}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ParentProjectID, PackageDefinitionID, ProcessDefinitionID, ParentDeliverableID, Mode, Access, BreadCrumbCtrlID, ParentBreadcrumbName, PrevScreen);
                        }
                    }

                    Ab_AssignContributors.AddAttributes("btn_Cancel", "href", CancelBtnURL.ToString()); 
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "setControls", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_DeliverableDetails_Exceptionwhilesettingthecontrols_Shared"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void setBreadcrumbs()
            {
                ulong           ErrorID             = 0;
                StringBuilder   ErrorPageURL_Exp    = null;

                try
                {
                    RolesBreadCrumb.BreadcrumbUniqueID      = BreadCrumbCtrlID;
                    RolesBreadCrumb.ParentBreadcrumbName    = ParentBreadcrumbName;
                    RolesBreadCrumb.NavigateUrl             = this.Request.Url.AbsoluteUri;
                    RolesBreadCrumb.InputXml                = null;
                    RolesBreadCrumb.Name                    = "Roles";
                    RolesBreadCrumb.DisplayText             = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_Manage_AssignContributor_AssignContributor");
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "setBreadcrumbs", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_Exceptionwhilesettingbreadcrumb"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void setLeftPane()
            {
                LeftPaneFacade  LeftPaneObj         = null;
                ulong           ErrorID             = 0;
                StringBuilder   ErrorPageURL_Exp    = null;
                    
                try
                {
                    LeftPaneObj = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, "MarketingWorkBench");
                    LeftPaneObj.SolutionName = "MarketingWorkBench";
                    LeftPaneObj.GetTaskPaneNode(this.Page, null);
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "setLeftPane", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_DeliverableDetails_Exceptionwhilesettingleftpane_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }
        
            /// <alsummary>
            /// <createddate>08 December 2006</createddate>
            /// <author>Hemant Karkande</author>
            /// <purpose>To Handle clicks on the button bar.</purpose>
            /// <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes>
            /// </alsummary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            private void Ab_AssignContributors_Click(object sender, EventArgs e)
            {                
                ulong           ErrorID             = 0;
                StringBuilder   ErrorPageURL_Exp    = null;

                try
                {
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                    if (Parameters[1].Equals("btn_Done"))
                    {
                        if (FormMode.ToUpper() == "CREATE")
                            AssigneRoles();
                        else if (FormMode.ToUpper() == "EDIT")
                            ModifyRoles();
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "Ab_AssignContributors_Click", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_Exceptionwhilehandlingactionbarevents"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void ModifyRoles()
            {
                ulong               ErrorID             = 0;
                StringBuilder       ErrorPageURL_Exp    = null;
                String              ErrorPageURL        = null; 
                StringBuilder       TempFilePath        = null; 
                XML                 ListXML             = null;                
                XML                 DeliverableXML      = null; 
                ERRORXML            ErrorXMLString      = null; 
                MktgWorkBenchFacadeClass MktgWorkBenchFacadeObj = null; 
 
                try
                {
                    MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    
                    ListXML = Lst_Assign_Contributors.Source;

                    TempFilePath = new StringBuilder();
                    TempFilePath.AppendFormat("{0}{1}", TempPath, RolesXMLFileName);

                    DeliverableXML = File.ReadAllText(TempFilePath.ToString());

					ErrorXMLString = MktgWorkBenchFacadeObj.PrepareRolesXMLToUpdateDeliverable(ListXML, DeliverableXML, ResourceListFile);
                    if (String.IsNullOrEmpty(ErrorXMLString))
                    {
                        if ((!String.IsNullOrEmpty(str_GoBackScreen)) && (str_GoBackScreen.ToUpper() == "ROPROJECT"))
                        {
                            gotoROProjectPage(); 
                        }
                        else
                        {
                            gotoRODeliverablePage();
                        }
                    }
                    else
                    {
                        //Show error
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "DELIVERABLE", null, 
                            Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_ErrorWhileModifyingRolesForTheDeliverableTasks"),
                            null, GetBackUrl(), ref ErrorPageURL);
                        if (!IsPostBack)
                        {
                            //Response.Redirect(ErrorPageURL);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "ModifyRoles", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_Exceptionwhilemodifyingroles"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void AssigneRoles()
            {
                ulong                       ErrorID                 = 0;
                StringBuilder               ErrorPageURL_Exp        = null;
                String                      ErrorPageURL            = null; 
                StringBuilder               TempFilePath            = null;                
                XML                         ListXML                 = null;
                XML                         ReturnXML               = null; 
                ERRORXML                    ErrorXMLString          = null; 
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null; 
 
                try
                {
                    MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);                    
                    ListXML = Lst_Assign_Contributors.Source;
                    ErrorXMLString = MktgWorkBenchFacadeObj.PrepareRolesXMLForDeliverable(PackageDefinitionID, ProcessDefinitionID, TaskDefinitionFileName, ResourceListFile, ListXML, out ReturnXML);
                    if ((String.IsNullOrEmpty(ErrorXMLString)))
                    {
                        //save this return xml on the NTFS and pass the file name to the deliverable page
                        if (!String.IsNullOrEmpty(ReturnXML))
                        {
                            TempFilePath = new StringBuilder();
                            TempFilePath.AppendFormat("{0}{1}", TempPath, RolesXMLFileName);

                            File.WriteAllText(TempFilePath.ToString(), ReturnXML);
                        }
                        gotoDeliverableScreen();
                    }
                    else
                    {
                        //show error
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "DELIVERABLE", null, 
                            Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_ErrorWhilePreparingRolesXMLForDeliverable"),
                            null, GetBackUrl(), ref ErrorPageURL);
                        if (!IsPostBack)
                        {
                            //Response.Redirect(ErrorPageURL);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "AssigneRoles", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_Exceptionwhileassigningroles"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private String GetBackUrl()
            {
                StringBuilder ParamURL = null;                
                try
                {                   
                    ParamURL = new StringBuilder();                   

                    ParamURL.AppendFormat("/{0}/{4}/ASPX/Manage_AssignContributor.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName);
                    ParamURL.AppendFormat("&FormMode={0}&ProcessDefinitionID={1}&PackageDefinitionID={2}&ProjectID={3}&Mode={4}&Access={5}&BREADCRUMBCTRLID={6}&PARENTBREADCRUMBNAME={7}&ActivityName={8}", FormMode, ProcessDefinitionID, PackageDefinitionID, ProjectId, Mode, Access, BreadCrumbCtrlID, ParentBreadcrumbName, ALCommon.Encrypt(DeliverableActivityName));

                    return ParamURL.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            private void gotoRODeliverablePage()
            {
                StringBuilder   ParamURL			= null;
                StringBuilder   URL					= null;
                String          EncryptURL			= null;
			    ulong			ErrorID				= 0;
                StringBuilder	ErrorPageURL_Exp	= null;

                try
                {
                    ParamURL    = new StringBuilder();
                    URL         = new StringBuilder();

                    //Go to RODeliverable Screen
                    ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&PackageDefinitionID={5}&ProcessDefinitionID={6}&DeliverableID={7}&Mode={8}&Access={9}&BREADCRUMBCTRLID={10}&PARENTBREADCRUMBNAME={11}&PrevScreen={12}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ParentProjectID, PackageDefinitionID, ProcessDefinitionID, ParentDeliverableID, Mode, Access, BreadCrumbCtrlID, ParentBreadcrumbName, PrevScreen);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "gotoRODeliverablePage", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_ExceptionwhilegoingtoRODeliverablepage"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void gotoROProjectPage()
            {
                StringBuilder   ParamURL			= null;
                StringBuilder   URL					= null;
                String          EncryptURL			= null;
			    ulong			ErrorID				= 0;                
                String          str_ErrorPageURL    = null; 

                try
                {
                    ParamURL    = new StringBuilder(150);
                    URL         = new StringBuilder(150);

                    //Go to RODeliverable Screen
                    ParamURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName=" + ALParamObj.TenantName + "&Language=" + ALParamObj.Language + "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&ProjectID=" + ParentProjectID + "");
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_AssignContributor.aspx", "gotoROProjectPage", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_ExceptionwhilegoingtoROProjectpage"));
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "DELIVERABLE", null, ExceptionObject.Message, null, null, ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self',''");
                }
            }

            private void gotoDeliverableScreen()
            {
                StringBuilder   ParamURL            = null;
                StringBuilder   URL                 = null;            
                String          EncryptURL          = null;
                ulong			ErrorID				= 0;
                StringBuilder	ErrorPageURL_Exp    = null;
                try
                {
                    ParamURL = new StringBuilder();
                    URL      = new StringBuilder();

                    ParamURL.AppendFormat("Manage_DeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&FormMode={4}&ProcessDefinitionID={5}&PackageDefinitionID={6}&ProjectID={7}&Mode={8}&Access={9}&RolesFileName={10}&BREADCRUMBCTRLID={11}&PARENTBREADCRUMBNAME={12}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, "Create", ProcessDefinitionID, PackageDefinitionID, ParentProjectID, Mode, Access, RolesXMLFileName, BreadCrumbCtrlID, ParentBreadcrumbName);
                    ParamURL.AppendFormat("&ActivityName=" + ALCommon.Encrypt(DeliverableActivityName));
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    //Ajax.WriteExecuteJavaScript(URL.ToString());
                    if (!IsPostBack) 
                        Response.Redirect(EncryptURL);   
                    else
                        Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "gotoDeliverableScreen", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ROProjectDetails_Exceptionwhilegoingtodeliverablepage_Shared"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }
                   
            /// <alsummary>
            /// <createdate>08 December 2006</createdate>
            /// <purpose>Select Contributors</purpose>
            ///  <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes>
            /// </alsummary>
            private void setPageInCreateMode()
            {
                ListFacade					ListFacadeObj               = null;
                MktgWorkBenchFacadeClass	MktgWorkBenchFacadeObj		= null;
				MWB_Helper					MWB_HelperObj				= null;
                XML							AssignContributorListXML	= null;
                XML							ContributorGroupXML         = null; 
                XML							ConfigXML                   = null; 
                XML							ReturnXML                   = null; 
                Boolean						ShowEmptyList               = true; 
                ERRORXML					ErrorXMLString              = null; 
                ulong						ErrorID				        = 0;
                StringBuilder				ErrorPageURL_Exp	        = null;				
                try
                {
                    ListFacadeObj			= new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MktgWorkBenchFacadeObj	= new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					MWB_HelperObj			= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language,Page.Theme);					
                    ErrorXMLString			= GetContributorXML(out ContributorGroupXML);
                    if (!String.IsNullOrEmpty(ContributorGroupXML))
                    {
                        ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "AssignContributorsList");
                        if (!String.IsNullOrEmpty(ConfigXML))
                        {
                            ListFacadeObj.PrepareListXml(ConfigXML, ContributorGroupXML, out AssignContributorListXML);

                            MktgWorkBenchFacadeObj.AddUsersForRoles(AssignContributorListXML, ContributorGroupXML, null, out ReturnXML);

							ReturnXML = MWB_HelperObj.InsertHTMLForAssignContributor(HiddenBtn_SelectResourceType.UniqueID,null, ReturnXML);
                            Lst_Assign_Contributors.Source = ReturnXML;
                            ShowEmptyList = false; 
                        }
                        if (ShowEmptyList)
                        {
                            ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "AssignContributorsList", ref AssignContributorListXML);
                            Lst_Assign_Contributors.Source = AssignContributorListXML;
                        }
                    }
                    else
                    {
                        //goto next screen
                        gotoDeliverableScreen(); 
                    }
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "setPageInCreateMode", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_Exceptionwhilesetingthepageincreatemode"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private ERRORXML GetContributorXML(out XML ContributorGroupXML)
            {
                XML                 SearchXML                       = null;                
                StringBuilder       GroupSearchString               = null; 
                StringBuilder       TempFilePath                    = null; 
                ERRORXML            ErrorXMLString                  = null; 
                ulong			    ErrorID				            = 0;
                StringBuilder	    ErrorPageURL_Exp	            = null;
                GroupFacade         GroupFacadeObj                  = null; 
                MWB_Helper          MWBHelperObj                    = null; 
                MktgWorkBenchFacadeClass MktgWorkBenchFacadeObj     = null; 
				List<ModifyContributor>	ModContList					= null;
                try
                {
                    ContributorGroupXML = null;
					GroupSearchString	   = new StringBuilder();
                    MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    GroupFacadeObj         = new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBHelperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);  

                    TempFilePath = new StringBuilder();
                    TempFilePath.AppendFormat("{0}{1}", TempPath, TaskDefinitionFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());

                    //Get the search XML required for the Group
					ErrorXMLString = MktgWorkBenchFacadeObj.GetRolesGroupSearchXML(PackageDefinitionID, ProcessDefinitionID, TaskDefinitionFileName, out ModContList);
                    if (String.IsNullOrEmpty(ErrorXMLString))
                    {
						foreach(ModifyContributor McObj in ModContList)
						{
							GroupSearchString.AppendFormat("{0}$RID${1}$AL$",McObj.ResourceID, McObj.DummyResourceName);
						}
						MktgWorkBenchFacadeObj.GetGroupsAndUsersForRoles(GroupSearchString.ToString(), out SearchXML);
						if(!String.IsNullOrEmpty(SearchXML))
						{							
							ContributorGroupXML = SearchXML;
						}
                    }
					prepareResourceFile(ModContList,null);
                    
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "GetContributorXML", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_Exceptionwhilegettingthecontributorxml"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ContributorGroupXML = null; 
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                    return ErrorXMLString; 
                }
            }        
            
            private XML getAssociationXML()
            {
                StringBuilder   AssociationXML      = null;
                ulong			ErrorID				= 0;
                StringBuilder	ErrorPageURL_Exp	= null;

                try
                {
                    AssociationXML = new StringBuilder();
                    AssociationXML.Append(@"<ASSOCIATION GetAllFacets='FALSE'>
	                                            <PROCESS_INFORMATION Type='RELATION'>
		                                            <WORKFLOWPROCESSINFOID/>
	                                            </PROCESS_INFORMATION>
	                                            <PROCESS_ACTIVITY Type='RELATION'>
		                                            <ACTIVITYID/>
		                                            <SUBFLOWACTIVITY Type='RELATION'>
			                                            <WORKFLOWPROCESSID/>
                                                        <STATUS/>
                                                        <WORKFLOWPROCESS_WORKFLOWINFORMATION Type='RELATION'>
	                                                        <WORKFLOWSUBCATEGORY/>
                                                            <ROUTEMETHOD/>
                                                        </WORKFLOWPROCESS_WORKFLOWINFORMATION>
			                                            <PROCESS_ACTIVITY Type='RELATION'>
				                                            <ACTIVITYID/>
				                                            <ACTIVITY_RESOURCE Type='RELATION'>
					                                            <RESOURCEID/>
					                                            <RESOURCETYPE/>
					                                            <ACTUAL_RESOURCE Type='RELATION'>
						                                            <RESOURCEID/>
						                                            <RESOURCETYPE/>
						                                            <RESOURCE_USER Type='RELATION'>
							                                            <USERID/>
							                                            <FIRSTNAME/>
							                                            <MIDDLEINITIAL/>
							                                            <LASTNAME/>
							                                            <LOGINNAME/>
						                                            </RESOURCE_USER>
					                                            </ACTUAL_RESOURCE>
				                                            </ACTIVITY_RESOURCE>
				                                            <ACTIVITY_CONTRIBUTOR Type='RELATION'>
					                                            <USERID/>
					                                            <FIRSTNAME/>
					                                            <MIDDLEINITIAL/>
					                                            <LASTNAME/>
					                                            <LOGINNAME/>
				                                            </ACTIVITY_CONTRIBUTOR>
			                                            </PROCESS_ACTIVITY>
		                                            </SUBFLOWACTIVITY>
	                                            </PROCESS_ACTIVITY>
                                            </ASSOCIATION>");
                   return AssociationXML.ToString();
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "getAssociationXML", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_AssignContributor_ExceptionwhilegettingassociationXML"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                    return null; 
                }
            }

            private void setPageInEditMode()
            {
                ulong			            ErrorID				        = 0;
                StringBuilder	            ErrorPageURL_Exp	        = null;
                StringBuilder               AttributesXML               = null; 
                StringBuilder               GroupSearchString           = null; 
                StringBuilder               TempFilePath                = null; 
                ListFacade                  ListFacadeObj               = null;
                GroupFacade                 GroupFacadeObj              = null;
                ERRORXML                    ErrorXMLString              = null; 
                XML                         AssignContributorListXML    = null; 
                XML                         AssociationXML              = null;
                XML                         DeliverableXML              = null;                
                XML                         GroupListXML                = null; 
                XML                         ConfigXML                   = null; 
                XML                         ReturnXML                   = null; 
                Boolean                     ShowEmptyList               = true; 
                int                         Total                       = 0;
                int                         Index                       = 1;                                
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj      = null;
                MWB_Helper                  MWBHelperObj                = null; 
                List<ModifyContributor>		ModContList					= null;
				List<ModifyContributor>		RemContList					= null;
				String						RName						= null;
                try
                {
                    
                    ListFacadeObj = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    GroupFacadeObj = new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBHelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language,Page.Theme);

                    //Prepare Attribute XML
                    AttributesXML = new StringBuilder();
                    AttributesXML.Append(@"<WORKFLOWPROCESS>
	                                            <WORKFLOWPROCESSID/>
                                           </WORKFLOWPROCESS>"); 

                    //Get the Association XML
                    AssociationXML = getAssociationXML();
                    //Get the Deliverable
                    ErrorXMLString = MktgWorkBenchFacadeObj.GetDeliverable(ParentDeliverableID, AttributesXML.ToString(), AssociationXML, out DeliverableXML);
                    if (String.IsNullOrEmpty(ErrorXMLString))
                    {
                        
                        TempFilePath = new StringBuilder();
                        TempFilePath.AppendFormat("{0}{1}", TempPath, RolesXMLFileName);
                        if (File.Exists(TempFilePath.ToString()))
                            File.Delete(TempFilePath.ToString());

                        File.WriteAllText(TempFilePath.ToString(), DeliverableXML);

						ErrorXMLString = MktgWorkBenchFacadeObj.GetRolesGroupSearchString_ModifyRoles(DeliverableXML, out ModContList, out RemContList);
                        if ((String.IsNullOrEmpty(ErrorXMLString)) && (ModContList.Count > 0))  
                        {
                            //Prepare comma seprated resource type string
                            GroupSearchString = new StringBuilder();
							Total = ModContList.Count;
							for(Index = 0; Index < Total;Index++ )
							{
								//Do not put EVERYONE group, since tracking, discussion and approvals task users are going under this resourcetype 
								//which we don't want to change
								if(ModContList[Index].DummyResourceName.ToUpper() != "EVERYONE")
								{
									RName = ((String.IsNullOrEmpty(ModContList[Index].ActualResourceName) ? ModContList[Index].DummyResourceName : ModContList[Index].ActualResourceName));
									if(Index < Total)
										GroupSearchString.AppendFormat("{0}$RID${1}$AL$", ModContList[Index].ResourceID, RName);
									else
										GroupSearchString.AppendFormat("{0}$RID${1}", ModContList[Index].ResourceID, RName);									
								}
							}
							prepareResourceFile(ModContList, RemContList);
							if(!String.IsNullOrEmpty(GroupSearchString.ToString()))
                            {
								ErrorXMLString = MktgWorkBenchFacadeObj.GetGroupsAndUsersForRoles(GroupSearchString.ToString(), out GroupListXML);
								if(!String.IsNullOrEmpty(GroupListXML) && (ErrorXMLString == null))
                                {
                                    ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "AssignContributorsList");
                                    if (!String.IsNullOrEmpty(ConfigXML))
                                    {
										GroupListXML = UpdateResourceTypeColumn(GroupListXML, ModContList);
										ListFacadeObj.PrepareListXml(ConfigXML, GroupListXML, out AssignContributorListXML);
                                        

										MktgWorkBenchFacadeObj.AddUsersForRoles(AssignContributorListXML, GroupListXML, ModContList, out ReturnXML);
                                        
										ReturnXML = MWBHelperObj.InsertHTMLForAssignContributor(HiddenBtn_SelectResourceType.UniqueID,ModContList, ReturnXML);
                                        Lst_Assign_Contributors.Source = ReturnXML;
                                        ShowEmptyList = false; 
                                    }
                                }
                            }
                        }
                    }
                    if (ShowEmptyList)
                    {
                        ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "AssignContributorsList", ref AssignContributorListXML);
                        Lst_Assign_Contributors.Source = AssignContributorListXML;
                    }

                    

                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_FinalAssignContributor.aspx", "setPageInEditMode", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectDetails_Info_Exceptionwhilesettingthepageineditmode_Shared"));
                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }	

			private void prepareResourceFile(List<ModifyContributor> ModContList,List<ModifyContributor> RemContList)
			{				
				String[]		strSeparator	= null;			
				StringBuilder	ResourceXML		= null;
				StringBuilder	FilePath		= null;
				try
				{
					strSeparator = new String[1] { "$AL$" };
					ResourceXML	 = new StringBuilder(200);
					FilePath	 = new StringBuilder(150);
					FilePath.AppendFormat("{0}{1}",ALSolutionCommon.GetTempPath(ALParamObj.SessionID),ResourceListFile);
					ResourceXML.Append("<RESOURCECOLLECTION>");
					foreach(ModifyContributor McObj in ModContList)
					{
						if (!String.IsNullOrEmpty(McObj.ActualResourceName))
							ResourceXML.AppendFormat(@"<RESOURCE ResourceID='{0}' SelectedGroupName='{2}'><RESOURCETYPE>{1}</RESOURCETYPE></RESOURCE>", McObj.ResourceID,ALCommon.TrimAndReplaceSpecialChars(McObj.DummyResourceName),ALCommon.TrimAndReplaceSpecialChars(McObj.ActualResourceName));
						else						
							ResourceXML.AppendFormat(@"<RESOURCE ResourceID='{0}'><RESOURCETYPE>{1}</RESOURCETYPE></RESOURCE>", McObj.ResourceID, ALCommon.TrimAndReplaceSpecialChars(McObj.DummyResourceName));
					}
					if(RemContList != null)
					{
						foreach(ModifyContributor McObj in RemContList)
						{
							if(!String.IsNullOrEmpty(McObj.ActualResourceName))
								ResourceXML.AppendFormat(@"<RESOURCE ResourceID='{0}' SelectedGroupName='{2}'><RESOURCETYPE>{1}</RESOURCETYPE></RESOURCE>", McObj.ResourceID, ALCommon.TrimAndReplaceSpecialChars(McObj.DummyResourceName), ALCommon.TrimAndReplaceSpecialChars(McObj.ActualResourceName));
							else
								ResourceXML.AppendFormat(@"<RESOURCE ResourceID='{0}'><RESOURCETYPE>{1}</RESOURCETYPE></RESOURCE>", McObj.ResourceID, ALCommon.TrimAndReplaceSpecialChars(McObj.DummyResourceName));
						}
					}

					ResourceXML.Append("</RESOURCECOLLECTION>");
					File.WriteAllText(FilePath.ToString(),ResourceXML.ToString());
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private XML GetSearchXML(String GpName)
			{
				StringBuilder Search = null;
				try
				{
					Search = new StringBuilder();
					Search.AppendFormat(@"<INPUTXML>
											<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
											<SEARCHCOLLECTION>
											<SEARCH>
											<TARGETOBJECT>USER</TARGETOBJECT>
											<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
											<ISCASESENSITIVE>False</ISCASESENSITIVE>
											<SEARCHALLFACETS>False</SEARCHALLFACETS>
											<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
											<FILTERLIST>
												<FILTER>
													<FIELDNAME>GROUPNAME</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>{4}</FIELDVALUE>
													<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
												<FILTER>
													<FIELDNAME>STATUS</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>ACTIVE</FIELDVALUE>											
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
											</FILTERLIST>
											<FIELDCOLLECTION>
												<TARGETENTITYFIELDS>
													<FIELD>USERID</FIELD>
													<FIELD>LOGINNAME</FIELD>
													<FIELD>FIRSTNAME</FIELD>
													<FIELD>LASTNAME</FIELD>
													<FIELD>MIDDLEINITIAL</FIELD>
													<FIELD>EMAILID</FIELD>
												</TARGETENTITYFIELDS>
											</FIELDCOLLECTION>
											</SEARCH>
											</SEARCHCOLLECTION>
										</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
					return Search.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private void UpdateList(String ResourceID, String SelectedResourceName, XML ItemList)
			{
				XmlDocument ListSourceDoc = null;
				XmlNode		RowNode		  = null;
				XmlNode		ColNode		  = null;
				MWB_Helper	MwbHelperObj  = null;
				try
				{
					ListSourceDoc = new XmlDocument();
					MwbHelperObj  = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language,Page.Theme);					
					ListSourceDoc.LoadXml(Lst_Assign_Contributors.Source);
					RowNode		  =	ListSourceDoc.SelectSingleNode("List/Data/Group/Row[Column[@Name='RESOURCEID']='" + ResourceID + "']");
					if(RowNode != null)
					{
						ColNode				= RowNode.SelectSingleNode("Column[@Name='CONTRIBUTOR']");
						ColNode.InnerXml	= ItemList;
						ColNode				= RowNode.SelectSingleNode("Column[@Name='RESOURCETYPES']");
						ColNode.InnerText	= MwbHelperObj.getColumnHTMLForContributor(ResourceID, SelectedResourceName,HiddenBtn_SelectResourceType.UniqueID);
					}
					Lst_Assign_Contributors.Source = ListSourceDoc.InnerXml;
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private void UpdateSimilarResources(String ResourceID, String SelectedValue)
			{
				StringBuilder	FilePath = null;
				XmlDocument		ResDoc	 = null;
				XmlNodeList		RNodeList = null;
				String			ResName	 = null;
				XmlNode			ResNode	 = null;
				try
				{
					FilePath = new StringBuilder();
					FilePath.AppendFormat("{0}{1}",ALSolutionCommon.GetTempPath(ALParamObj.SessionID),ResourceListFile);
					if(File.Exists(FilePath.ToString()))
					{
						ResDoc = new XmlDocument();
						ResDoc.Load(FilePath.ToString());
						ResNode = ResDoc.DocumentElement.SelectSingleNode("RESOURCE[@ResourceID='" + ResourceID + "']");
						if(ResNode != null)
						{
							ResName = ResNode.SelectSingleNode("RESOURCETYPE").InnerText;
						}
						RNodeList = ResDoc.DocumentElement.SelectNodes("RESOURCE[@ResourceID!='" + ResourceID + "' and RESOURCETYPE='" + ResName + "']");
						foreach(XmlNode RNode in RNodeList)
						{
							((XmlElement)RNode).SetAttribute("SelectedGroupName",SelectedValue);
						}
						ResDoc.Save(FilePath.ToString());
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private XML UpdateResourceTypeColumn(XML GroupListXML, List<ModifyContributor> ModContList)
			{
				XmlDocument GroupDoc = null;
				XmlNode		ResNode	 = null;
				try
				{
					GroupDoc = new XmlDocument();
					GroupDoc.LoadXml(GroupListXML);
					if((ModContList != null) && (ModContList.Count > 0))
					{
						foreach(ModifyContributor McObj in ModContList)
						{
							ResNode = GroupDoc.SelectSingleNode("SEARCHOUTPUTXML/RESOURCECOLLECTION/RESOURCE[RESOURCEID='"+ McObj.ResourceID+"']");
							if(ResNode != null)
							{
								ResNode.SelectSingleNode("RESOURCENAME").InnerText = McObj.DummyResourceName;
							}
						}
					}
					return GroupDoc.InnerXml;
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}


        # endregion
    }
}