using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.XPath;

#region AssetlinkInclude
using Assetlink;
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Pages;
#endregion

//-----------------------------------------------------//
// File Name:   SelectResourceType.aspx.cs			   //
// Author:      Ms. Mugdha Moolay                      //
// Class:       SelectResourceType                     //
// Created On:  22 May 2008                            //
//-----------------------------------------------------//

namespace Assetlink.Solutions.MarketingWorkBench
{
	using XML		= String;
	using ERRORXML	= String;

	public partial class SelectResourceType : ALAjaxPage
	{
		#region Member Variables
		private ALSolutionCommon	ALSolutionCommonObj	= null;
		private ALParam				ALParamObj			= null;
		private String				ResourceFileName	= null;
		private String				ActivityID			= null;
		private String              SolutionName        = "MarketingWorkBench";
		private String				trvInputPath		= null;		
		private String				HiddenButtonID		= null;
		private String				HTMLContainer		= null;
		private	String				Hiddenip			= null;
		private	String				SelectedValueFileName= null;
		private String				ResourceTreeFile	= null;
		private String				FromScreen			= null;
        private String              TaskID              = null;
        private String              StepID              = null;
		#endregion

		#region ControlsOnPage
			private ALTreeView								ResourceTree		= null;
			private ActionBar								ResourceAB			= null;
			private ALPanel									ResourceTreePanel	= null;
			private Assetlink.CustomControls.ListControl	Lst_SelectGroup		= null;
			private	SquareBlankSection						SBS_Tree			= null;
		#endregion

		#region Protected Methods

		protected void Page_Init(object sender, EventArgs e)
		{
		    ERRORXML					ErrorXML				= null; 
            Boolean						IsValid					= true;
            String						ErrorPageURL			= null; 
            InfrastructureFacadeClass   InfrastructureFacadeObj = null;
            StringBuilder ShowErrorPageUrl = null;
			try
			{
                Page.Header.DataBind();
				ALParamObj = new ALParam();
                ALSolutionCommonObj = new ALSolutionCommon();

                ALSolutionCommonObj.httpContext = HttpContext.Current;
                ALSolutionCommonObj.InitALParam(ref ALParamObj);

                InfrastructureFacadeObj = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                ErrorXML = InfrastructureFacadeObj.IsSessionValid(ref IsValid);
                if (!IsValid)
                {
                    //ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "MWB_REQUEST_ADDDELIVERABLE", null, "Session Invalid ! Please login again", null, "", ref ErrorPageURL);
                    ShowErrorPageUrl = new StringBuilder(150);
                    ShowErrorPageUrl.AppendFormat("{0}{1}/{2}/{3}",
                                           ALCommon.GetCommunicationProtocol(),
                                           ALCommon.GetInternetAddress(),
                                            ALParamObj.TenantName, "Common/ASPX/ShowError.aspx");

                    ShowErrorPageUrl.AppendFormat("?TenantName={0}&UserID={1}&SessionID={2}&Language={3}", ALParamObj.TenantName, ALParamObj.UserID, ALParamObj.SessionID, ALParamObj.Language);

                    ShowErrorPageUrl.AppendFormat("&ErrorCode={0}&ErrorMessage={1}&ShowOKButton = true", "SESSION_INVALID",
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_SESSION_INVALID_shared"));

                    ErrorPageURL = ShowErrorPageUrl.ToString();
                    Response.Redirect(ErrorPageURL);
                }
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		protected void Page_Load(object sender, EventArgs e)
		{
			try
			{
				setParameters();				
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		protected void ResourceTree_onExpand(object sender, EventArgs e)
		{
			ALTreeView		expNode			= (ALTreeView)sender;
			String			ExpandedGroupID = null;
			XmlDocument		TreeDoc			= null;
			XmlNode			TrNode			= null;
			XML				OutputGroupXML	= null;
			XML				SubTreeXML		= null;
			try
			{

				if(!expNode.ShowExpanded)
				{
					ExpandedGroupID = expNode.Value;
					TreeDoc = new XmlDocument();
					if(File.Exists(trvInputPath))
					{						
						TreeDoc.Load(trvInputPath);
						TrNode = TreeDoc.SelectSingleNode("//*/TreeNode[@Value='" + ExpandedGroupID + "']");						
					}
					if(expNode.NodeData == "NOEXPANDED")
					{
						OutputGroupXML = GetOneLevelSubGroups(ExpandedGroupID);
						if(OutputGroupXML != null)
						{
							SubTreeXML = GetTreeXMLForSubGroups(ExpandedGroupID, OutputGroupXML);
							if((TrNode != null) && (!String.IsNullOrEmpty(SubTreeXML)))
							{
								TrNode.InnerXml = SubTreeXML;
								StringBuilder tempStr = new StringBuilder(200);
								tempStr.Append("<TreeNodes>");
								tempStr.Append(TrNode.InnerXml);
								tempStr.Append("</TreeNodes>");
								expNode.InnerNodeScr = tempStr.ToString();								
							}							
							((XmlElement)TrNode).SetAttribute("GetDataOnDemand", "False");
							((XmlElement)TrNode).SetAttribute("NodeData", "EXPANDED");
							expNode.GetDataOnDemand = false;
							expNode.NodeData = "EXPANDED";
						}
					}
					
					((XmlElement)TrNode).SetAttribute("ShowExpanded", "TRUE");
					expNode.ShowExpanded = true;
					TreeDoc.Save(trvInputPath);
				}
				else
				{
					ExpandedGroupID = expNode.Value;
					TreeDoc = new XmlDocument();
					if(File.Exists(trvInputPath))
					{
						TreeDoc.Load(trvInputPath);						
						TrNode = TreeDoc.SelectSingleNode("//*/TreeNode[@Value='" + ExpandedGroupID + "']");
						((XmlElement)TrNode).SetAttribute("ShowExpanded", "FALSE");
						TreeDoc.Save(trvInputPath);
						expNode.ShowExpanded = false;
					}
				}				
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		protected void ResourceAB_Click(object sender, EventArgs e)
		{
			String[]		strSeparator			= null;
			

			try
			{
				strSeparator		= new String[1] { "$AL$" };
				String strSender    = (String)sender;
                String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
				
				if(Parameters[1].Equals("Btn_Done"))
				{
					if(FromScreen.ToUpper() == "TASK")
						HandleFromTask();
					else
						HandleFromAssignContributor();
					
				}
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		protected override void CreateChildControls()
		{
			setParameters();
			setControls();
			//base.CreateChildControls();
		}

		protected override void Render(HtmlTextWriter writer)
		{
			if(IsPostBack)
			{
				string eventGenID = Ajax.EventGeneratorUniqueID;
                if (eventGenID.Contains("ResTree"))
				{
					Ajax.AddControlsToRender(ResourceTreePanel);
				}
				Ajax.WriteControlHTMl(this.Page, writer);
			}
			else
			{
				base.Render(writer);
			}
		}
		#endregion

		#region Private Methods
		private void setParameters()
		{
			try
			{
				//ResourceFileName		= ALSolutionCommonObj.GetParamValue("ResourceFileName");
                TaskID                  = ALSolutionCommonObj.GetParamValue("TaskID");
                if(String.IsNullOrEmpty(TaskID))
                    StepID = ALSolutionCommonObj.GetParamValue("StepID");
				FromScreen				= ALSolutionCommonObj.GetParamValue("FromScreen");
				if(FromScreen.ToUpper() == "ASSIGNCONTRIBUTOR")
				{
					ActivityID = ALSolutionCommonObj.GetParamValue("ResourceID");
                    ResourceFileName = "MWB_AssignContributor.xml";
                    ResourceTreeFile = "MWB_AssignContributorTreeXML.xml";
				}
				else
				{
					ActivityID				= ALSolutionCommonObj.GetParamValue("ActivityID");
					//SelectedValueFileName	= ALSolutionCommonObj.GetParamValue("SelectedValueFileName");
                    if (String.IsNullOrEmpty(TaskID))
                    {
                        ResourceFileName = StepID + "_ActivityResourceColl.xml";
                        ResourceTreeFile = StepID + "_ResourceGroupTree.xml";
                    }
                    else
                    {
                        ResourceFileName = TaskID + "_ActivityResourceColl.xml";
                        ResourceTreeFile = TaskID + "_ResourceGroupTree.xml";
                    }

                    SelectedValueFileName = "STEP_" + ActivityID + "_ContributorGroup_SelectedValueList.xml";
                    String SelFilePath    = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedValueFileName;

                    if (!File.Exists(SelFilePath))
                        SelectedValueFileName = StepID + "_ContributorGroup_SelectedValueList.xml";

					HTMLContainer			= ALSolutionCommonObj.GetParamValue("HTMLContainer");
					Hiddenip				= ALSolutionCommonObj.GetParamValue("Hiddenip");
					if(String.IsNullOrEmpty(HTMLContainer))
					{
						HTMLContainer = ALSolutionCommonObj.GetParamValue("DivID");
					}
					if(String.IsNullOrEmpty(Hiddenip))
					{
						Hiddenip = ALSolutionCommonObj.GetParamValue("HiddenInputID");
					}
				}
				//ResourceTreeFile		= ALSolutionCommonObj.GetParamValue("ResourceTreeFile");                
				HiddenButtonID			= ALSolutionCommonObj.GetParamValue("HiddenBtnID");
				
				trvInputPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				trvInputPath += ResourceTreeFile;
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private void setControls()
		{
			StringBuilder ActionBarXMLPath = null;
			try
			{
                Page_Header.Title             = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_SelectResourceTypeSectionHeading");
				ActionBarXMLPath			  = new StringBuilder(100);
				ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_SelectResourceType_ActionBar"));
                Pg.TenantName = ALParamObj.TenantName;
                Lst_SelectGroup = (Assetlink.CustomControls.ListControl)Pg.FindControl("LstSelectGroup");
				Lst_SelectGroup.TenantName    = ALParamObj.TenantName;
                SBS_Tree = (SquareBlankSection)Pg.FindControl("SBSTree");
				SBS_Tree.TenantName			  = ALParamObj.TenantName;
				ResourceTreePanel			  = (ALPanel)SBS_Tree.FindControl("TrPanel");
                ResourceTree = (ALTreeView)ResourceTreePanel.FindControl("ResTree");
				ResourceTree.TenantName		  =	ALParamObj.TenantName;
				if((FromScreen.ToUpper() == "TASK") && (!IsPostBack))
				{
					showResourceTreeForTask();
				}
				else if((FromScreen.ToUpper() == "ASSIGNCONTRIBUTOR") && (!IsPostBack))
				{
					showResourceTreeForAssignContributor();				
				}
				ResourceTree.NodeScr = File.ReadAllText(trvInputPath);
				ResourceTree.onExpand+=new EventHandler(ResourceTree_onExpand);
				ResourceTree.SetChildNodeExpandEventHandler(ResourceTree_onExpand);
                ResourceAB = (ActionBar)Pg.FindControl("TreeSelectionAB");
				ResourceAB.TenantName		  = ALParamObj.TenantName;
				ResourceAB.InputXMLType		  = ActionBar.XMLType.XMLPath;
				ResourceAB.InputXML			  = ActionBarXMLPath.ToString();
				ResourceAB.Click+=new EventHandler(ResourceAB_Click);
				//ResourceAB.AddAttributes("Btn_Done","href","javascript:SubmitResourceType('$CONTROLID$','"+HiddenButtonID+"')");
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private void showResourceTreeForTask()
		{
			String				TempXMLPath		= null;
			StringBuilder		FilePath		= null;
			XPathDocument		xpResourceDoc	= null;
			XPathDocument		GroupDoc		= null;
			XPathNavigator		xpNav			= null;
			XPathNavigator		ResNav			= null;
			XPathNodeIterator	xpNodeIter		= null;
			String				ResourceType	= null;
			StringBuilder		SearchXML		= null;			
			GroupFacade			GrpFacadeObj	= null;
			ERRORXML			ErrorXml		= null;
			XML					GroupXML		= null;
			StringBuilder		TreeXML			= null;
			String				GroupID			= null;
			String				GroupName		= null;
			String				GrpDesc			= null;			
			String				SelectedGpName	= null;			
            String[]            strArrGroup             = null;
            int                 i_index                 = 0;
            String              str_ResourceGroups      = null;

			try
			{
				// check for the Resource file name, select the Activity node for the ActivityID sent as a url parameter
				// select all the resources for this Activity and get all the groups and sub groups that match these resources
				FilePath		= new StringBuilder(100);
				SearchXML		= new StringBuilder(350);				
				GrpFacadeObj	= new GroupFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
				TempXMLPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				FilePath.AppendFormat("{0}{1}", TempXMLPath, ResourceFileName);
				if(File.Exists(FilePath.ToString()))
				{
					xpResourceDoc = new XPathDocument(FilePath.ToString());
					xpNav		  = xpResourceDoc.CreateNavigator();
					xpNav		  = xpNav.SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY[@ActivityID='"+ActivityID+"']");
					if(xpNav != null)
					{
						ResNav = xpNav.SelectSingleNode("RESOURCE[@SelectedGroupName]");
						if (ResNav !=null)
							SelectedGpName = ResNav.GetAttribute("SelectedGroupName", "");
						ShowSelectedGroup(SelectedGpName);
						ViewState["PreviousSelectedGroup"] = SelectedGpName;
						xpNodeIter = xpNav.Select("RESOURCE");
						if(xpNodeIter.Count > 0)
						{
							strArrGroup         = new String[xpNodeIter.Count];
							while(xpNodeIter.MoveNext())
							{								
								ResourceType = xpNodeIter.Current.SelectSingleNode("RESOURCETYPE").Value;
								// check if any selected Resource is there.
								//IsSelected = xpNodeIter.Current.GetAttribute("Selected", "");
								//SelectedGpName = xpNodeIter.Current.GetAttribute("SelectedGroupName","");
								strArrGroup[i_index++] = ResourceType;
							}
                            str_ResourceGroups      = ALCommon.PrepareFilterValueForINClause(strArrGroup);
							
							SearchXML.AppendFormat(@"<INPUTXML>
															<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
															<SEARCHCOLLECTION>
															    <SEARCH>
															        <TARGETOBJECT>GROUP</TARGETOBJECT>
															        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
															        <ISCASESENSITIVE>False</ISCASESENSITIVE>
															        <SEARCHALLFACETS>False</SEARCHALLFACETS>
															        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
															        <FILTERLIST>
																        <FILTER>
																	        <FIELDNAME>GROUPNAME</FIELDNAME>
																	        <OPERATOR>IN</OPERATOR>
																	        <FIELDVALUE>{4}</FIELDVALUE>
																	        <NAVIGATIONPATH>GROUP</NAVIGATIONPATH>
																	        <ISCASESENSITIVE>False</ISCASESENSITIVE>
																        </FILTER>
																        <FILTER>
																	        <FIELDNAME>ISDELETED</FIELDNAME>
																	        <OPERATOR>EQUALTO</OPERATOR>
																	        <FIELDVALUE>0</FIELDVALUE>
																	        <NAVIGATIONPATH>GROUP</NAVIGATIONPATH>
																	        <ISCASESENSITIVE>False</ISCASESENSITIVE>
																        </FILTER>
															        </FILTERLIST>
                                                                    <SORTCOLUMN>GROUPNAME</SORTCOLUMN>
                                                                    <SORTORDER>ASC</SORTORDER>    
															    </SEARCH>
															</SEARCHCOLLECTION>
														</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, str_ResourceGroups);
							ErrorXml =  GrpFacadeObj.GetGroupList(SearchXML.ToString(), ref GroupXML);
                            if (ErrorXml == null)
                            {
                               
                                GroupDoc = new XPathDocument(new StringReader(GroupXML));
                                TreeXML = new StringBuilder(200);
                                xpNav = GroupDoc.CreateNavigator();
                                xpNodeIter = xpNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP");
                                if (xpNodeIter.Count > 0)
                                {
                                    TreeXML.Append("<TreeNodes>");
                                    TreeXML.Append("<TreeNode DisplayTextID=\"MWB_ResourceTreeHeading\" NodeData=\"RootOfTree\" Value=\"ROOTID\" TooltipID=\"MWB_ResourceTreeToolTip\"");
                                    TreeXML.Append(" PostbackType=\"None\" GetDataOnDemand=\"True\" Selectionmode=\"None\">");
                                    while (xpNodeIter.MoveNext())
                                    {
                                        GroupID = xpNodeIter.Current.SelectSingleNode("GROUPID").Value;
                                        GroupName = xpNodeIter.Current.SelectSingleNode("GROUPNAME").Value;
                                        GrpDesc = xpNodeIter.Current.SelectSingleNode("DESCRIPTION").Value;
                                        TreeXML.AppendFormat(@"<TreeNode Text=""{0}"" NodeData=""NOEXPANDED"" Value=""{1}"" Tooltip=""{2}""", ALCommon.TrimAndReplaceSpecialChars(GroupName), GroupID, ALCommon.TrimAndReplaceSpecialChars(GrpDesc));
                                        TreeXML.Append(@" PostbackType=""Expand"" GetDataOnDemand=""True"" Selectionmode=""SingleSelect""");
                                        TreeXML.Append("></TreeNode>");
                                    }
                                    TreeXML.Append("</TreeNode>");
                                    TreeXML.Append("</TreeNodes>");
                                }                                
                                File.WriteAllText(trvInputPath, TreeXML.ToString());
                            }
                            
						}
					}
				}
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private String GetOneLevelSubGroups(String expGroupID)
		{			
            String			strAssociation	= null;
			String			OutputGroupXML	= null;
			GroupFacade		UGMFacadeObj	= null;
			ERRORXML		ErrorXML		= null;
			
			try
			{
				UGMFacadeObj	= new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);				
				strAssociation	= "<ASSOCIATION><GROUP_SUBGROUP Type='RELATION'/></ASSOCIATION>";
				ErrorXML = UGMFacadeObj.GetGroup(expGroupID, strAssociation,false,false, out OutputGroupXML);
				if (ErrorXML==null)
					return OutputGroupXML;
				return null;
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private XML GetTreeXMLForSubGroups(String expGroupID,XML GroupXML)
		{
			XPathDocument		xpDoc			= null;
			XPathNavigator		xpNav			= null;
			StringBuilder		TreeXML			= null;
			XPathNodeIterator	xpNodeIter		= null;
			String				GroupID			= null;
			String				GroupName		= null;
			String				GrpDesc			= null;
			//XPathExpression     xpExp			= null;
			try
			{
				TreeXML = new StringBuilder(200);
				if(GroupXML != null)
				{
					xpDoc		= new XPathDocument(new StringReader(GroupXML));
					xpNav		= xpDoc.CreateNavigator();					

					xpNodeIter	= xpNav.Select("GROUPCOLLECTION/GROUP/GROUP_SUBGROUP[@PARENT='FALSE']/GROUP");
					while(xpNodeIter.MoveNext())
					{
						GroupID		= xpNodeIter.Current.SelectSingleNode("GROUPID").Value;
						GroupName	= xpNodeIter.Current.SelectSingleNode("GROUPNAME").Value;
						GrpDesc		= xpNodeIter.Current.SelectSingleNode("DESCRIPTION").Value;
						TreeXML.AppendFormat(@"<TreeNode Text=""{0}"" NodeData=""NOEXPANDED"" Value=""{1}"" Tooltip=""{2}""", ALCommon.TrimAndReplaceSpecialChars(GroupName), GroupID, ALCommon.TrimAndReplaceSpecialChars(GrpDesc));
						//TreeXML.Append("PostbackType=\"Expand\" GetDataOnDemand=\"True\" Selectionmode=\"SingleSelect\"></TreeNode>");
						TreeXML.Append(@" PostbackType=""Expand"" GetDataOnDemand=""True"" Selectionmode=""SingleSelect""");
						TreeXML.Append("></TreeNode>");
					}
				}
				return TreeXML.ToString();
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private void ShowSelectedGroup(String GroupName)
		{
			ListFacade		ListFacadeObj = null;			
			XML				ResultXML	  = null;			
			String			ConfigXml	  = null;
			StringBuilder	GroupXML	  = null;

			try
			{
				ListFacadeObj = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);				
				GroupXML	  = new StringBuilder(250);
				if(!String.IsNullOrEmpty(GroupName))
				{
					GroupXML.AppendFormat("<SEARCHOUTPUTXML><GROUPCOLLECTION><GROUP><GROUPNAME>{0}</GROUPNAME></GROUP></GROUPCOLLECTION></SEARCHOUTPUTXML>", ALCommon.TrimAndReplaceSpecialChars(GroupName));
					ConfigXml = ListFacadeObj.GetConfigurationXML(SolutionName, null, "SelectedResourceType");
					ListFacadeObj.PrepareListXml(ConfigXml, GroupXML.ToString(), out ResultXML);					
				}
				else
				{
					ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "SelectedResourceType", ref ResultXML);
				}
				Lst_SelectGroup.Source = ResultXML;
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private void showResourceTreeForAssignContributor()
		{
			String				TempXMLPath		= null;
			StringBuilder		FilePath		= null;
			XPathDocument		xpResourceDoc	= null;
			XPathDocument		GroupDoc		= null;
			XPathNavigator		xpNav			= null;			
			XPathNodeIterator	xpNodeIter		= null;			
			StringBuilder		GroupList		= null;
			StringBuilder		SearchXML		= null;			
			GroupFacade			GrpFacadeObj	= null;
			ERRORXML			ErrorXml		= null;
			XML					GroupXML		= null;
			StringBuilder		TreeXML			= null;
			String				GroupID			= null;
			String				GroupName		= null;
			String				GrpDesc			= null;			
			String				SelectedGpName	= null;
			String			   	GpName			= null;

			try
			{
				// check for the Resource file name, select the Activity node for the ActivityID sent as a url parameter
				// select all the resources for this Activity and get all the groups and sub groups that match these resources
				FilePath		= new StringBuilder(100);
				GroupList		= new StringBuilder(200);
				SearchXML		= new StringBuilder(350);				
				GrpFacadeObj	= new GroupFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
				TempXMLPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				FilePath.AppendFormat("{0}{1}", TempXMLPath, ResourceFileName);
				if(File.Exists(FilePath.ToString()))
				{
					xpResourceDoc = new XPathDocument(FilePath.ToString());
					xpNav		  = xpResourceDoc.CreateNavigator();
					xpNav		  = xpNav.SelectSingleNode("RESOURCECOLLECTION/RESOURCE[@ResourceID='"+ActivityID+"']");
					if(xpNav != null)
					{
						GpName = xpNav.SelectSingleNode("RESOURCETYPE").Value;
						if (xpNav.GetAttribute("SelectedGroupName","")=="")
							SelectedGpName = xpNav.SelectSingleNode("RESOURCETYPE").Value;
						else
							SelectedGpName = xpNav.GetAttribute("SelectedGroupName","");

						ViewState["PreviousSelectedGroup"] = SelectedGpName;

						ShowSelectedGroup(SelectedGpName);
						xpNodeIter = xpNav.Select("RESOURCE");					
						SearchXML.AppendFormat(@"<INPUTXML>
														<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
														<SEARCHCOLLECTION>
														    <SEARCH>
														        <TARGETOBJECT>GROUP</TARGETOBJECT>
														        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
														        <ISCASESENSITIVE>False</ISCASESENSITIVE>
														        <SEARCHALLFACETS>False</SEARCHALLFACETS>
														        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
														        <FILTERLIST>
															        <FILTER>
																        <FIELDNAME>GROUPNAME</FIELDNAME>
																        <OPERATOR>EQUALTO</OPERATOR>
																        <FIELDVALUE>{4}</FIELDVALUE>
																        <NAVIGATIONPATH>GROUP</NAVIGATIONPATH>
																        <ISCASESENSITIVE>False</ISCASESENSITIVE>
															        </FILTER>
														        </FILTERLIST>
                                                                <SORTCOLUMN>GROUPNAME</SORTCOLUMN>
                                                                <SORTORDER>ASC</SORTORDER>    
														    </SEARCH>
														</SEARCHCOLLECTION>
													</INPUTXML>", ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language,ALCommon.TrimAndReplaceSpecialChars(GpName));
						ErrorXml =  GrpFacadeObj.GetGroupList(SearchXML.ToString(), ref GroupXML);
						if(ErrorXml == null)
						{
							GroupDoc	= new XPathDocument(new StringReader(GroupXML));
							TreeXML		= new StringBuilder(200);
							xpNav		= GroupDoc.CreateNavigator();
							xpNodeIter	= xpNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP");
							if(xpNodeIter.Count > 0)
							{
								TreeXML.Append("<TreeNodes>");
								TreeXML.Append("<TreeNode DisplayTextID=\"MWB_ResourceTreeHeading\" NodeData=\"RootOfTree\" Value=\"ROOTID\" TooltipID=\"MWB_ResourceTreeToolTip\"");
								TreeXML.Append(" PostbackType=\"None\" GetDataOnDemand=\"True\" Selectionmode=\"None\">");
								while(xpNodeIter.MoveNext())
								{
									GroupID		= xpNodeIter.Current.SelectSingleNode("GROUPID").Value;										
									GroupName	= xpNodeIter.Current.SelectSingleNode("GROUPNAME").Value;
									GrpDesc		= xpNodeIter.Current.SelectSingleNode("DESCRIPTION").Value;
									TreeXML.AppendFormat(@"<TreeNode Text=""{0}"" NodeData=""NOEXPANDED"" Value=""{1}"" Tooltip=""{2}""", ALCommon.TrimAndReplaceSpecialChars(GroupName), GroupID, ALCommon.TrimAndReplaceSpecialChars(GrpDesc));										
									TreeXML.Append(@" PostbackType=""Expand"" GetDataOnDemand=""True"" Selectionmode=""SingleSelect""");
									TreeXML.Append("></TreeNode>");
								}
								TreeXML.Append("</TreeNode>");
								TreeXML.Append("</TreeNodes>");									
							}
							else
							{
								// no groups to select
							}
							File.WriteAllText(trvInputPath, TreeXML.ToString());
						}						
					}
				}
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		
		}

		private void HandleFromTask()
		{

			XmlDocument		TreeDoc					= null;
			XmlNode			TrNode					= null;
			String			SelectedResourceID		= null;
			String			SelectedResourceName	= null;
			StringBuilder	sb_SelectedValueXML		= null;
			String			SelectedValueListXML	= null;
			XmlDocument		ActResDoc				= null;
			String			TempPath				= null;
			String			ActResFile				= null;
			XmlNode			ResourceNode 			= null;
			XmlNode			ParentTrNode			= null;
			String			ResourceName			= null;
			XmlNodeList		RNodeList				= null;
			try
			{
				sb_SelectedValueXML = new StringBuilder(150);
				TempPath			= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				ActResFile			= TempPath + ResourceFileName;
				SelectedValueListXML = TempPath + SelectedValueFileName;
				sb_SelectedValueXML.Append("<ValueList>");
				if(ResourceTree.SelectedNodes.Count > 0)
				{
					TreeDoc = new XmlDocument();
					TreeDoc.Load(trvInputPath);
					ActResDoc = new XmlDocument();
					ActResDoc.Load(ActResFile);


					RNodeList = ActResDoc.SelectNodes("ACTIVITYCOLLECTION/ACTIVITY[@ActivityID='" + ActivityID + "']/RESOURCE");
					foreach(XmlNode RNode in RNodeList)
					{
						if(((XmlElement)RNode).GetAttribute("Selected") != null)
						{
							((XmlElement)RNode).RemoveAttribute("Selected","");
							((XmlElement)RNode).RemoveAttribute("SelectedGroupName", "");
						}
					}
					foreach(ALTreeView TNode in ResourceTree.SelectedNodes)
					{
						TrNode = TreeDoc.SelectSingleNode("//*/TreeNode[@Value='" + TNode.Value + "']");
						if(TrNode != null)
						{
							((XmlElement)TrNode).SetAttribute("Selected", "True");
							SelectedResourceID = TNode.Value;
							SelectedResourceName = TNode.Text;
							sb_SelectedValueXML.AppendFormat("<Value ID=\"{0}\" Text=\"{1}\"/>", SelectedResourceID, ALCommon.TrimAndReplaceSpecialChars(SelectedResourceName));								

							ParentTrNode = TreeDoc.SelectSingleNode("TreeNodes/TreeNode/TreeNode[descendant::TreeNode[@Selected='True']]");

							if(ParentTrNode != null)
							{
								ResourceName = ((XmlElement)ParentTrNode).GetAttribute("Text");
                                ResourceNode = ActResDoc.SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY[@ActivityID='" + ActivityID + "']/RESOURCE[RESOURCETYPE=" + ALXmlUtil.GetXpathValueString(ResourceName) + "]");
								if(ResourceNode != null)
								{
									((XmlElement)ResourceNode).SetAttribute("Selected", "True");
									((XmlElement)ResourceNode).SetAttribute("SelectedGroupName", SelectedResourceName);
								}
							}
							else
							{
								if(ParentTrNode == null)
									ParentTrNode = TreeDoc.SelectSingleNode("TreeNodes/TreeNode/TreeNode[@Selected='True']");
								if(ParentTrNode != null)
								{
									ResourceName = ((XmlElement)ParentTrNode).GetAttribute("Text");
                                    ResourceNode = ActResDoc.SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY[@ActivityID='" + ActivityID + "']/RESOURCE[RESOURCETYPE=" + ALXmlUtil.GetXpathValueString(ResourceName) + "]");
									if(ResourceNode != null)
									{
										((XmlElement)ResourceNode).SetAttribute("Selected", "True");
										((XmlElement)ResourceNode).SetAttribute("SelectedGroupName", SelectedResourceName);
									}
								}
							}
							
							// also update the activity resource file to set the selected resource.
						}
					}
					TreeDoc.Save(trvInputPath);
					ActResDoc.Save(ActResFile);
				}
				sb_SelectedValueXML.Append("</ValueList>");
				File.WriteAllText(SelectedValueListXML, sb_SelectedValueXML.ToString());
				if((ViewState["PreviousSelectedGroup"] != null) && (ViewState["PreviousSelectedGroup"].ToString() == SelectedResourceName) || (String.IsNullOrEmpty(SelectedResourceName)))
					Ajax.WriteExecuteJavaScript("javascript:window.close();");
				else
				Ajax.WriteExecuteJavaScript("javascript:CloseMe('"+ HiddenButtonID +"','"+ActivityID+"');");
			}
			catch(Exception ExcepObj)
			{
				
				throw ExcepObj;
			}
		}

		private void HandleFromAssignContributor()
		{

			XmlDocument		TreeDoc					= null;
			XmlNode			TrNode					= null;
			String			SelectedResourceID		= null;
			String			SelectedResourceName	= null;			
			XmlDocument		ActResDoc				= null;
			String			TempPath				= null;
			String			ActResFile				= null;
			XmlNode			ResourceNode 			= null;
			XmlNode			ParentTrNode			= null;
			String			ResourceName			= null;
			XmlNodeList		RNodeList				= null;
			try
			{
				
				TempPath			= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				ActResFile			= TempPath + ResourceFileName;				
				if(ResourceTree.SelectedNodes.Count > 0)
				{
					TreeDoc = new XmlDocument();
					TreeDoc.Load(trvInputPath);
					ActResDoc = new XmlDocument();
					ActResDoc.Load(ActResFile);


					RNodeList = ActResDoc.SelectNodes("RESOURCECOLLECTION/RESOURCE[@ResourceID='" + ActivityID + "']");					
					foreach(ALTreeView TNode in ResourceTree.SelectedNodes)
					{
						TrNode = TreeDoc.SelectSingleNode("//*/TreeNode[@Value='" + TNode.Value + "']");
						if(TrNode != null)
						{
							((XmlElement)TrNode).SetAttribute("Selected", "True");
							SelectedResourceID = TNode.Value;
							SelectedResourceName = TNode.Text;
							ParentTrNode = TreeDoc.SelectSingleNode("TreeNodes/TreeNode/TreeNode[descendant::TreeNode[@Selected='True']]");

							if(ParentTrNode != null)
							{
								ResourceName = ((XmlElement)ParentTrNode).GetAttribute("Text");
								ResourceNode = ActResDoc.SelectSingleNode("RESOURCECOLLECTION/RESOURCE[@ResourceID='" + ActivityID + "']");
								if(ResourceNode != null)
								{
									((XmlElement)ResourceNode).SetAttribute("Selected", "True");
									((XmlElement)ResourceNode).SetAttribute("SelectedGroupName", SelectedResourceName);
								}
							}
							else
							{
								if(ParentTrNode == null)
									ParentTrNode = TreeDoc.SelectSingleNode("TreeNodes/TreeNode/TreeNode[@Selected='True']");
								if(ParentTrNode != null)
								{
									ResourceName = ((XmlElement)ParentTrNode).GetAttribute("Text");
									ResourceNode = ActResDoc.SelectSingleNode("RESOURCECOLLECTION/RESOURCE[@ResourceID='" + ActivityID + "']");
									if(ResourceNode != null)
									{
										((XmlElement)ResourceNode).SetAttribute("Selected", "True");
										((XmlElement)ResourceNode).SetAttribute("SelectedGroupName", SelectedResourceName);
									}
								}
							}
							// also update the activity resource file to set the selected resource.
						}
					}
					TreeDoc.Save(trvInputPath);
					ActResDoc.Save(ActResFile);
				}
				if((ViewState["PreviousSelectedGroup"] != null) && (ViewState["PreviousSelectedGroup"].ToString() == SelectedResourceName) || (String.IsNullOrEmpty(SelectedResourceName)))
					Ajax.WriteExecuteJavaScript("javascript:window.close();");
				else
					Ajax.WriteExecuteJavaScript("javascript:CloseMe('"+ HiddenButtonID +"','"+ActivityID+"');");
			}
			catch(Exception ExcepObj)
			{
				
				throw ExcepObj;
			}
		}
		#endregion
	}
}
