﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml;
using System.Xml.XPath;
using System.IO;
using System.Text;
using System.Collections.Specialized;
using System.Linq;
using System.Xml.Linq;

#region Assetlink Includes
using Assetlink;
using Assetlink.CustomControls;
using Assetlink.Solutions;
using Assetlink.Solutions.Pages;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Facade.ReportFacade;
using Assetlink.Components;
using Assetlink.Solutions.Facade.CampaignManagerFacade.CampaignManager;
#endregion

public partial class Reports_ASCX_ReportScheduler : System.Web.UI.UserControl
{
    #region Private Members
    private FormFacade      ReportScheduleFromFacadeObj   = null;
    private Form            ReportScheduleFrom              = null;
    public  ALBaseControl   ReportSummaryBase             = null;
    Form                    Frm_PersonalizeFilters          = null; 
    #endregion

    #region Public Members
    public  AjaxData    AjaxDataObject            = null;
    public  ALParam     ALParamObj                = null;
    public  DateTime    ScheduleStartDateTime;
    public  DateTime    ScheduleEndaDate;
    public  String      RunCycle                  = null;
    #endregion

    #region Public Properties
    public String ReportID
    {
        set
        {
            ViewState["ReportID"] = value;
        }

        get
        {
            return (String)ViewState["ReportID"];
        }
    }

    public String ReportName
    {
        set
        {
            ViewState["ReportName"] = value;
        }

        get
        {
            return (String)ViewState["ReportName"];
        }
    }

    public String ReportSubject
    {
        set
        {
            ViewState["ReportSubject"] = value;
        }

        get
        {
            if (ViewState["ReportSubject"] == null)
                return ReportName;
            else
                return (String)ViewState["ReportSubject"];
        }
    }

    public String ReportMessage
    {
        set
        {
            ViewState["ReportMessage"] = value;
        }

        get
        {
            if (ViewState["ReportSubject"] == null)
                return "Please find the report attached.";
            else
                return (String)ViewState["ReportMessage"];
        }
    }

    public String ScheduleReportType
    {
        set
        {
            ViewState["ScheduleReportType"] = value;
        }

        get
        {
            return (String)ViewState["ScheduleReportType"];
        }
    }

    public Form ReportScheduleFromControl
    {
        get
        {
            return ReportScheduleFrom;
        }
    }

    public Form Frm_PersonalizeFiltersControl
    {
        get
        {
            return Frm_PersonalizeFilters;
        }
    }

    public String ScheduleDataXml
    {
        set
        {
            ViewState["ScheduleDataXml"] = value;
            SetScheduleDataXml(value);
        }
        get
        {
            return GetScheduleDataXml();
        }
    }

    public String LastRunStatus
    {
        set
        {
            ViewState["LastRunStatus"] = value;
        }

        get
        {
            return (String)ViewState["LastRunStatus"];
        }
    }

    public String ReportDataXml
    {
        set
        {
            ViewState["ReportDataXml"] = value;
        }

        get
        {
            if (ViewState["ReportDataXml"] == null)
                return "";
            else
                return (String)ViewState["ReportDataXml"];
        }
    }

    private bool IsPersonalizedFiltersPresent
    {
        set
        {
            ViewState["IsPersonalizedFiltersPresent"] = value;
        }

        get
        {
            if (ViewState["IsPersonalizedFiltersPresent"] == null)
                return false;
            else
                return (bool)ViewState["IsPersonalizedFiltersPresent"];
        }
    }
    #endregion

    #region private Properties
    private String ScheduleOperionMode
    {
        set
        {
            ViewState["ScheduleOperionMode"] = value;
        }

        get
        {
            return (String)ViewState["ScheduleOperionMode"];
        }
    }
    #endregion

    #region Standard Control
    protected override void CreateChildControls()
    {
        PrepareMemberVariables();
        base.CreateChildControls();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
           
    }
    protected override void OnPreRender(EventArgs e)
    {
        if ((IsPostBack && ScheduleOperionMode == "CREATE") || (ScheduleOperionMode == "EDIT" && this.ViewState["PreviousRunCycle"] != null && this.ViewState["PreviousRunCycle"].ToString()!="MONTHLY"))        
        {            
            ((ALAjaxPage)(this.Page)).Ajax.WriteExecuteJavaScript("Javascript:SetSelectedValueForMonthly();");
        }
        base.OnPreRender(e);
    }
    protected override void Render(HtmlTextWriter writer)
    {        
        writer.Write("<div id='Div_" + this.ClientID + "'>");
            base.Render(writer);
        writer.Write("</div>");
    }
    #endregion

    #region private Medthods

    private void PrepareMemberVariables()
    {
        #region member variables
        String                  FormConfigXMLPath           = null;
        String                  Mintue                      = null;
        String                  SolutionConfig              = null;
        String                  FormConfigXML               = null;
        XPathDocument           xpDoc_SolConfig             = null;
        XPathNavigator          xpNav_SolConfig             = null;
        XmlDocument             XmlDoc_FormConfig           = null;
        XmlNode                 FormFieldNode               = null;
        XmlNode                 xmlnode_Instruction         = null;
        StringDictionary        strdict_PlaceHolders        = null;
        String                  str_TempData                = null;
        String                  ReportFormConfiguration     = null;
        XDocument               xDoc_ReportXML              = null;
        XElement                xEle_ReportRoot             = null;            
        XElement                xEle_ReportForm             = null;
        XElement                xEle_PersonalizationFilter  = null;
        List<ObjectInfo>        ObjectInfoCollection        = null;
        FormFacade              FormFacadeObject            = null;
        String                  xml_SearchOutput            = null;
        String                  xml_FormControlInput        = null;
        String                  errorxml_Output             = null;
        InfrastructureFacadeClass ObjInfrast                = null;
        String                  UserPersonalization         = null;
        #endregion

        ReportSummaryBase = RSB;
        ReportSummaryBase.TenantName = ALParamObj.TenantName;
        ReportSummaryBase.DisplayLayout = eDisplayLayout.SimpleWithoutCaptionBar;

        SolutionConfig      = ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, "StrategicPlanner", null, "SolutionConfiguration");
        xpDoc_SolConfig     = new XPathDocument(SolutionConfig);
        xpNav_SolConfig     = xpDoc_SolConfig.CreateNavigator().SelectSingleNode("SolutionConfiguration/FISCALMONTH");

        if (ReportScheduleFromFacadeObj != null)
            return;

        if (LastRunStatus != null)
        {
            if (LastRunStatus.ToUpper() == "RESUBMITTED" || LastRunStatus.ToUpper() == "SENDING NOTIFICATION")
            {
                lbl_RescheduleText.Visible = true;
            }
        }
        
        #region Report Schedule Controls
        ReportScheduleFrom = RSF;
        ReportScheduleFrom.TenantName = ALParamObj.TenantName;
        ReportScheduleFrom.SolutionName = ALParamObj.SolutionName;
        ReportScheduleFrom.SessionID = ALParamObj.SessionID;
        ReportScheduleFrom.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
        if (IsPostBack)
            ReportScheduleFrom.AjaxRef = AjaxDataObject;
        #endregion

        #region Campaign Schedule Facade
        ReportScheduleFromFacadeObj                         = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        ReportScheduleFromFacadeObj.SolutionName            = ALParamObj.SolutionName;
        ReportScheduleFromFacadeObj.FormName                = "FRM_ReportSchedule";
        ReportScheduleFromFacadeObj.ShowConfiguredFields    = true;
        ReportScheduleFromFacadeObj.ConfigurationXMLType    = Assetlink.CustomControls.Form.InputType.InnerXML.ToString();

        FormConfigXMLPath                                   = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "", "FRM_ReportSchedule_FormConfiguration");
        XmlDoc_FormConfig                                   = new XmlDocument();
        XmlDoc_FormConfig.Load(FormConfigXMLPath);
        
        switch(ScheduleReportType)
        {
            case "ADHOCREPORT":
                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Options']/Column/Field[@Name='SCHEDULEDREPORTDETAILS_EXPORTFORMAT']");
                if (FormFieldNode != null)
                {
                    ((XmlElement)FormFieldNode).SetAttribute("DisplayType", "READONLY");
                    ((XmlElement)FormFieldNode).SetAttribute("Disable", "Yes");
                    ((XmlElement)FormFieldNode).SetAttribute("DefaultValue", "Excel");
                    FormFieldNode.InnerXml = "<Item><DisplayValue>Excel</DisplayValue><Value>Excel</Value></Item>";
                }


                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Schedule Details']/Column/Field[@Name='SCHEDULEDREPORTDETAILS_SCHEDTIME']");
                if (FormFieldNode != null)
                    ((XmlElement)FormFieldNode).SetAttribute("ShowRefreshIcon", "true");

                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Receivers']/Column/Field[@Name='SelectTo']");
                if (FormFieldNode != null)
                    ((XmlElement)FormFieldNode).SetAttribute("ValidateInput", "false");

                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Receivers']/Column/Field[@Name='SelectCC']");
                if (FormFieldNode != null)
                    ((XmlElement)FormFieldNode).SetAttribute("ValidateInput", "false");

                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Receivers']/Column/Field[@Name='SelectBCC']");
                if (FormFieldNode != null)
                    ((XmlElement)FormFieldNode).SetAttribute("ValidateInput", "false");

                break;

            default:
                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Receivers']/Column/Field[@Name='SCHEDULEDREPORTDETAILS_SUBJECT']");
                if (FormFieldNode != null)
                    ((XmlElement)FormFieldNode).SetAttribute("FieldVisible", "False");

                FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Receivers']/Column/Field[@Name='SCHEDULEDREPORTDETAILS_MESSAGE']");
                if (FormFieldNode != null)
                    ((XmlElement)FormFieldNode).SetAttribute("FieldVisible", "False");
                break;
        }

        if (xpNav_SolConfig != null)
        {
            FormFieldNode = XmlDoc_FormConfig.SelectSingleNode("Form/Section[@Heading='Report Schedule Details']/Column/Field[@Name='SCHEDULEDREPORTDETAILS_QUARTERLYOPTION']");
            if (FormFieldNode != null)
            {
                xmlnode_Instruction = FormFieldNode.SelectSingleNode("Instruction");
                if(xmlnode_Instruction != null)
                {
                    strdict_PlaceHolders = new StringDictionary();
                    strdict_PlaceHolders.Add("FISCALMONTH", xpNav_SolConfig.InnerXml);
                    xmlnode_Instruction.InnerText = Localization.GetString("ALResource", ALParamObj.TenantName, "Rpt_ScheduledReport_NoteForQuarterlyIntervalReport", strdict_PlaceHolders);
                    strdict_PlaceHolders.Clear();
                }
            }
        }

        FormConfigXML                                       = XmlDoc_FormConfig.OuterXml;
        ReportScheduleFromFacadeObj.ConfigurationXML        = FormConfigXML;
        ReportScheduleFrom.ConfigurationXML                 = FormConfigXML;
        #endregion

        #region personalization Filters Form
        ABC_PersonliazedFilters.TenantName = ALParamObj.TenantName;
        ABC_PersonliazedFilters.SectionHeading = Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_Lbl_Filters");

        Frm_PersonalizeFilters = (Form)ABC_PersonliazedFilters.FindControl("Frm_PersonalizeFilters");
        Frm_PersonalizeFilters.TenantName = ALParamObj.TenantName;
        if (IsPostBack)
            Frm_PersonalizeFilters.AjaxRef = AjaxDataObject;

        if (!String.IsNullOrEmpty(ReportDataXml))
        {
            if (ViewState["ScheduleDataXml"] != null && !String.IsNullOrEmpty(ViewState["ScheduleDataXml"].ToString()))
            {
                xml_SearchOutput = ViewState["ScheduleDataXml"].ToString();
                xml_SearchOutput = ALCommon.GetInnerValue(ref xml_SearchOutput, "<SCHEDULEREPORTFILTERXML>", "</SCHEDULEREPORTFILTERXML>");

                if(!String.IsNullOrEmpty(xml_SearchOutput))
                    xml_SearchOutput = ALCommon.GetInnerValue(ref xml_SearchOutput, "<FORMDATAXML>", "</FORMDATAXML>");
            }

            str_TempData                = ReportDataXml;
            ReportFormConfiguration     = ALCommon.GetInnerValue(ref str_TempData, "<REPORTCONFIGXML>", "</REPORTCONFIGXML>");

            xDoc_ReportXML              = XDocument.Parse(str_TempData);
            xEle_ReportRoot             = xDoc_ReportXML.Root;
            xEle_PersonalizationFilter  = xEle_ReportRoot.XPathSelectElement("ADHOCREPORT/REPORTCONFIGXML/CONFIGURATION/PersonalizationFilters/PersonalizationFilter");
            if (xEle_PersonalizationFilter != null)
            {
                StringBuilder sb_Temp = new StringBuilder(500);
                sb_Temp.AppendFormat(@"<table width='100%' class='Max_MainTitleBar_WithBorder'>
                                    <tr style='height:15px;'>
                                        <td class='MainTitleText' align='left'>
                                            {0}
                                        </td>                                      
                                    </tr>
                                </table>", Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_Lbl_Filters"));

                //ABC_PersonliazedFilters.CaptionTextMode = Assetlink.CustomControls.eCaptionTextMode.HTML;
                //ABC_PersonliazedFilters.CaptionHTML     = sb_Temp; 

                //ABC_PersonliazedFilters.CaptionTextMode = Assetlink.CustomControls.eCaptionTextMode.Text;
                //ABC_PersonliazedFilters.CaptionText     = Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_Lbl_Filters");

                FormFacadeObject                            = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, this.Page.Theme);
                xEle_ReportForm                             = xEle_ReportRoot.XPathSelectElement("ADHOCREPORT/REPORTCONFIGXML/CONFIGURATION/Form");
                FormFacadeObject.ConfigurationXMLType       = "INNERXML";
                FormFacadeObject.ConfigurationXML           = xEle_ReportForm.ToString(); 
                FormFacadeObject.FormName                   = xEle_ReportForm.Attribute("Name").Value;
                FormFacadeObject.ShowConfiguredFields       = true;
                Frm_PersonalizeFilters.ConfigurationXMLType = Form.InputType.InnerXML;
                Frm_PersonalizeFilters.ConfigurationXML     = xEle_ReportForm.ToString();

                //Create Schedule Case: Use Filter values from User Personalization
                if (String.IsNullOrEmpty(xml_SearchOutput))
                { 
                    String str_PersonalizeFiltersPath                  = String.Format("{0}{1}_PersonalizeFilters.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ReportID);
                    if (!File.Exists(str_PersonalizeFiltersPath))                    
                    {
                        //Get User Personalization for report filters and save it.
                        ObjInfrast      = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        errorxml_Output = ObjInfrast.GetUserPersonalization("ADHOCREPORTFILTERPERSONALIZATION", "RPT_" + ReportID, out UserPersonalization);
                        if (String.IsNullOrEmpty(errorxml_Output))
                        {
                            if (!String.IsNullOrEmpty(UserPersonalization))
                            {
                                File.WriteAllText(str_PersonalizeFiltersPath, UserPersonalization);                                
                                xml_SearchOutput = ALCommon.GetInnerValue(ref UserPersonalization, "<FORMDATAXML>", "</FORMDATAXML>");
                            }
                        }                       
                    }
                    else
                    {
                        xml_SearchOutput = File.ReadAllText(str_PersonalizeFiltersPath);
                        xml_SearchOutput = ALCommon.GetInnerValue(ref xml_SearchOutput, "<FORMDATAXML>", "</FORMDATAXML>");
                    }
                }

                if (!IsPostBack)
                {
                    errorxml_Output                             = FormFacadeObject.GetFormInputXML("EDIT", xml_SearchOutput, out xml_FormControlInput, out ObjectInfoCollection);
                    if (!(String.IsNullOrEmpty(errorxml_Output)))
                    {
                        throw new Exception("Err_AdhocReport_Get_ReportSummary_FormInputXML");
                    }

                    if (ObjectInfoCollection != null)
                        ViewState["PersonalizedObjectInfoList"] = ObjectInfoCollection;

                
                    Frm_PersonalizeFilters.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                    Frm_PersonalizeFilters.InputXML = xml_FormControlInput;
                }
                IsPersonalizedFiltersPresent        = true;   
            }
            else
            {
                Div_PersonalizeFilters.Attributes.Add("style","display:none;");
                IsPersonalizedFiltersPresent = false;
            }
        }
        else
        {
            Div_PersonalizeFilters.Attributes.Add("style", "display:none;");
            IsPersonalizedFiltersPresent = false;
        }
        #endregion
        //ReportSummaryBase.CaptionText                       = Localization.GetString("ALResource", ALParamObj.TenantName, "CM_ROCampaign_Schedule");                              
        ListItem[] Hour                                     = { new ListItem("01"), new ListItem("02"), new ListItem("03"), new ListItem("04"), new ListItem("05"), new ListItem("06"), new ListItem("07"), new ListItem("08"), new ListItem("09"), new ListItem("10"), new ListItem("11"), new ListItem("12") };       
        
    }
    
    private String SetScheduleDataXml(String ScheduleDataXml)
    {
        String          ErrorXML                = null;
        String          FormInputXML            = null;        
        XmlDocument     ScheduleXmlDoc          = null;
        XmlNode         ScheduleStartDateNode   = null;
        XmlDocument     xmlDoc_FormInputXml     = null;
        XmlNode         FieldNode               = null;        

        List<Assetlink.Solutions.Facade.CommonFacade.ObjectInfo> ListObj = new List<Assetlink.Solutions.Facade.CommonFacade.ObjectInfo>();        
        
        if (ReportScheduleFromFacadeObj == null)
            PrepareMemberVariables();

        if (ScheduleDataXml.IndexOf("<SCHEDREPORTID>") > 0)
            ScheduleOperionMode = "EDIT";
        else
            ScheduleOperionMode = "CREATE";

        ErrorXML = ReportScheduleFromFacadeObj.GetFormInputXML(ScheduleOperionMode, ScheduleDataXml, out FormInputXML, out ListObj);

        
        #region create mode handling
        if (ScheduleOperionMode == "CREATE")
        {
            // in case of CREATE mode update FormInputXML for "To" field 
            String UserDataXMLPath = ALSolutionCommon.GetDataFolderPath(ALParamObj.TenantName, ALParamObj.UserID) + ALParamObj.UserID + ".xml";
            if (File.Exists(UserDataXMLPath))
            {
                String          LoggedinUser    = null;
                XPathDocument   xDocUserDataXML = new XPathDocument(UserDataXMLPath);
                XPathNavigator  xNavUserData    = xDocUserDataXML.CreateNavigator();

                LoggedinUser  = xNavUserData.SelectSingleNode("USER/FIRSTNAME").Value;
                LoggedinUser += " " + xNavUserData.SelectSingleNode("USER/LASTNAME").Value;

                if (String.IsNullOrEmpty(LoggedinUser))
                    LoggedinUser = xNavUserData.SelectSingleNode("USER/LOGINNAME").Value;

                LoggedinUser += " <" + xNavUserData.SelectSingleNode("USER/EMAILID").Value + ">";
                String LoggedinUserValue = @"<Item>
			                                    <DisplayValue>" + ALSolutionCommon.TrimAndReplaceSpecialChars(LoggedinUser) + @",</DisplayValue>
			                                    <Value>
				                                    <USER>" + ALParamObj.UserID + @",</USER>
				                                    <GROUP/>
				                                    <RECIPIENTEMAILINFO/>
			                                    </Value>
		                                    </Item>";
                FormInputXML = FormInputXML.Replace("</Field><Field Name=\"SelectCC\"", LoggedinUserValue + "</Field><Field Name=\"SelectCC\"");
            }
        }
        #endregion

        if (ErrorXML == null)
        {
            if (ScheduleOperionMode == "CREATE")
            {
                Page.ClientScript.RegisterHiddenField("hdn_selctedMonthlyOption", "DATE");
                xmlDoc_FormInputXml = new XmlDocument();
                xmlDoc_FormInputXml.LoadXml(FormInputXML);
                FieldNode = xmlDoc_FormInputXml.SelectSingleNode("FieldList/Field[@Name='SCHEDULEDREPORTDETAILS_SCHEDREPORTINSTANCENAME']");
                if (FieldNode != null)
                {
                    FieldNode.InnerXml = "<Value>" + ReportName + "</Value>";
                }

                FieldNode = xmlDoc_FormInputXml.SelectSingleNode("FieldList/Field[@Name='SCHEDULEDREPORTDETAILS_SUBJECT']");
                if (FieldNode != null)
                {
                    FieldNode.InnerXml = "<Value>" + ReportSubject + "</Value>";
                }

                FieldNode = xmlDoc_FormInputXml.SelectSingleNode("FieldList/Field[@Name='SCHEDULEDREPORTDETAILS_MESSAGE']");
                if (FieldNode != null)
                {
                    FieldNode.InnerXml = "<Value>" + ReportMessage + "</Value>";
                }

                FormInputXML = xmlDoc_FormInputXml.OuterXml;
            }
            else
            {                
                RunCycle = ALCommon.GetInnerValue(ref ScheduleDataXml, "<RUNCYCLE>", "</RUNCYCLE>");
                this.ViewState["PreviousRunCycle"] = RunCycle;
                if (RunCycle == "MONTHLY")
                {
                    Page.ClientScript.RegisterHiddenField("hdn_selctedMonthlyOption", "");
                }
                else
                {
                    Page.ClientScript.RegisterHiddenField("hdn_selctedMonthlyOption", "DATE");
                }
            }                       

            ReportScheduleFrom.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
            ReportScheduleFrom.ResetBinders = true;
            ReportScheduleFrom.InputXML = FormInputXML;
            ReportScheduleFrom.ResetFacetSeriesFields();
            this.ViewState["ReportScheduleFrom"] = ListObj;

            #region Prepar Start time UI
            if (!String.IsNullOrEmpty(ScheduleDataXml))
            {
                ScheduleXmlDoc = new XmlDocument();
                ScheduleXmlDoc.LoadXml(ScheduleDataXml);

                ScheduleStartDateNode = ScheduleXmlDoc.SelectSingleNode("//SCHEDULESTARTDATE");
                if (ScheduleStartDateNode != null && ScheduleStartDateNode.InnerText != "")
                {
                    DateTime StartTime = new DateTime(DateTime.Now.Year, 1, 1, Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("HOUR").InnerText), Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("MINUTE").InnerText), 0);
                    String AMPTMforMate = StartTime.ToString("hh:mm tt");                                                            
                }
            }

            #endregion
        }

        return ErrorXML;
    }

    private String GetScheduleDataXml()
    {
        String ErrorXml                     = null;
        String ScheduleDataXml              = null;
        XmlDocument ScheduleXmlDoc          = null;
        XmlNode     ScheduleStartDateNode   = null;
        DateTime    ScheduledateTime;

        ErrorXml = ReportScheduleFromFacadeObj.GetFormDataXML(ScheduleOperionMode, "DATAFIELD", ReportScheduleFrom,
                    (List<Assetlink.Solutions.Facade.CommonFacade.ObjectInfo>)this.ViewState["ReportScheduleFrom"], out ScheduleDataXml);

        if (ErrorXml == null)
        {
            #region Getting the Start Time
            ScheduleXmlDoc = new XmlDocument();
            ScheduleXmlDoc.LoadXml(ScheduleDataXml);

            //ScheduleStartDateNode = ScheduleXmlDoc.SelectSingleNode("//SCHEDULESTARTDATE");
            //if (ScheduleStartDateNode != null)
            //{
            //    if (ScheduleStartDateNode.InnerText == "")
            //    {
            //        ScheduledateTime = DateTime.Now;
            //        ScheduleStartDateNode.InnerXml = "<YEAR>" + ScheduledateTime.Year + "</YEAR><MONTH>" + ScheduledateTime.Month + "</MONTH><DAY>" + ScheduledateTime.Day + "</DAY><HOUR>00</HOUR><MINUTE>00</MINUTE><SECOND>00</SECOND>";
            //    }

            //    String TwentyHoutHourTime = DateTimeOffset.Parse( ListObj_Hour.SelectedValue + ":" + ListObj_Min.SelectedValue + " " + ListObj_AMPM.SelectedValue).ToString("HH:mm");
                
            //    ScheduleStartDateNode.SelectSingleNode("HOUR").InnerText    = TwentyHoutHourTime.Substring(0,2);
            //    ScheduleStartDateNode.SelectSingleNode("MINUTE").InnerText  = TwentyHoutHourTime.Substring(3, 2);

            //    ScheduleStartDateTime = new DateTime(Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("DAY").InnerText),
            //                                         Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("HOUR").InnerText), Convert.ToInt32(ScheduleStartDateNode.SelectSingleNode("MINUTE").InnerText), 0);

            //    ScheduleEndaDate = ScheduleStartDateTime.AddDays(1);

            //}
            #endregion

            return ScheduleXmlDoc.OuterXml;
        }
        return null;
    }
        
    #endregion

    #region Public Methods
    public String SaveScheduleDetails(String ScheduleReportID, String FilterXML, String strScheduleDataXML)
    {
        #region member variables
        String         ErrorXml             = null;
        String         FormOutputXML        = null;
        String         MonthlyOptionType    = null;
        ScheduleReport objSCHRptFacade      = null;
        List<ObjectInfo> ObjectInfoCollection = null;
        String         TargetEntity         = null;
        String          FormDataXML                 = null;
        String          Str_SearchXml               = null;
        String          str_FilterCombination       = null;
        int             NoOfFilters                 = 0;        
        XDocument       xDoc_ReportXML              = null;
        XElement        xEle_ReportRoot             = null;            
        XElement        xEle_ReportForm             = null;
        String          FilterPersonalizationXML    = null;
        XmlNode         ScheduleRptFilterXMLNode    = null;
        #endregion

        objSCHRptFacade = new ScheduleReport(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        ErrorXml = ReportScheduleFromFacadeObj.GetFormDataXML(ScheduleOperionMode, "DATAFIELD", ReportScheduleFrom,
                    (List<Assetlink.Solutions.Facade.CommonFacade.ObjectInfo>)this.ViewState["ReportScheduleFrom"], out FormOutputXML);
        Frm_PersonalizeFilters = (Form)ABC_PersonliazedFilters.FindControl("Frm_PersonalizeFilters");

        if (IsPersonalizedFiltersPresent)
        {            
            xDoc_ReportXML  = XDocument.Parse(ReportDataXml);
            xEle_ReportRoot = xDoc_ReportXML.Root;
            xEle_ReportForm = xEle_ReportRoot.XPathSelectElement("ADHOCREPORT/REPORTCONFIGXML/CONFIGURATION/Form");
            if(xEle_ReportForm != null && !String.IsNullOrEmpty(xEle_ReportForm.ToString()))
            {
                FormFacade FormFacadeObj            = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                FormFacadeObj.FormName              = xEle_ReportForm.Attribute("Name").Value;//"ODSDIGITALASSET_Report";
                FormFacadeObj.SolutionName          = ALParamObj.SolutionName;
                FormFacadeObj.ShowConfiguredFields  = true;
                FormFacadeObj.ConfigurationXMLType  = "INNERXML";
                FormFacadeObj.ConfigurationXML      = xEle_ReportForm.ToString();                        
                TargetEntity                        =  xEle_ReportForm.Attribute("TARGETOBJECTNAME").Value;

                ErrorXml = FormFacadeObj.GetNSearchInputXML("EDIT", "DataField", Frm_PersonalizeFilters, ObjectInfoCollection, out FormDataXML,
                    out Str_SearchXml, out str_FilterCombination, out NoOfFilters);

                if (String.IsNullOrEmpty(ErrorXml) && !String.IsNullOrEmpty(FormDataXML))
                {   
                    FormDataXML                         = String.Format("<{0}COLLECTION>{1}</{0}COLLECTION>", TargetEntity.ToUpper(), FormDataXML);                            

                    //Schedule Filter Personalization
                    FilterPersonalizationXML = String.Format(@"<FILTERPERSONALIZATION>
                                                                    <ADHOCREPORTFILTERS>
                                                                            <FILTERLIST>
                                                                                {0}{1}       
                                                                            </FILTERLIST>        
                                                                    </ADHOCREPORTFILTERS>
                                                                    <FORMDATAXML>{2}</FORMDATAXML>
                                                               </FILTERPERSONALIZATION>", str_FilterCombination, 
                                                               ALCommon.GetInnerValue(ref Str_SearchXml, "<FILTERLIST>", "</FILTERLIST>"),FormDataXML);
                }
            }
        }

        if (!String.IsNullOrEmpty(FormOutputXML))
        {
            XmlDocument FormOutputXMLDoc = new XmlDocument();
            FormOutputXMLDoc.LoadXml(FormOutputXML);

            if (FormOutputXMLDoc.SelectSingleNode("SCHEDULEDREPORTDETAILS/ENDDATE").InnerXml == "")
            {
                FormOutputXMLDoc.SelectSingleNode("SCHEDULEDREPORTDETAILS/ENDDATE").InnerXml = FormOutputXMLDoc.SelectSingleNode("SCHEDULEDREPORTDETAILS/STARTDATE").InnerXml;
                FormOutputXML = FormOutputXMLDoc.OuterXml;
            }

            //MonthlyOptionType = Request["hdn_selctedMonthlyOption"];
            MonthlyOptionType = ReportScheduleFrom.GetValues("SCHEDULEDREPORTDETAILS_MONTHLYOPTIONTYPE_DATE");

            if (MonthlyOptionType == null)
                MonthlyOptionType = "";

            if (!String.IsNullOrEmpty(FilterPersonalizationXML))
            {
                ScheduleRptFilterXMLNode = FormOutputXMLDoc.SelectSingleNode("SCHEDULEDREPORTDETAILS/SCHEDULEREPORTFILTERXML");
                if (ScheduleRptFilterXMLNode == null)
                {
                    ScheduleRptFilterXMLNode = FormOutputXMLDoc.CreateElement("SCHEDULEREPORTFILTERXML");
                    FormOutputXMLDoc.SelectSingleNode("SCHEDULEDREPORTDETAILS").AppendChild(ScheduleRptFilterXMLNode);
                }
                ScheduleRptFilterXMLNode.InnerXml = FilterPersonalizationXML;
                FormOutputXML                     = FormOutputXMLDoc.OuterXml;
            }

            if (String.IsNullOrEmpty(ScheduleReportID))
            {
                String strMonthlyOptionNode = "<MONTHLYOPTIONTYPE>" + MonthlyOptionType + "</MONTHLYOPTIONTYPE>";
                FormOutputXML = ALCommon.InsertBefore(ref FormOutputXML, "</SCHEDULEDREPORTDETAILS>", ref strMonthlyOptionNode);

                String strDeliveryOptionNode = "<DELIVERYMODE>Email</DELIVERYMODE>";
                FormOutputXML = ALCommon.InsertBefore(ref FormOutputXML, "</SCHEDULEDREPORTDETAILS>", ref strDeliveryOptionNode);

                String strExportOptionNode = "<EXPORTFORMAT>Excel</EXPORTFORMAT>";
                FormOutputXML = ALCommon.InsertBefore(ref FormOutputXML, "</SCHEDULEDREPORTDETAILS>", ref strExportOptionNode);

                // create mode
                if ((FormOutputXML.IndexOf("<SCHRPT_TOUSER") == -1) && (FormOutputXML.IndexOf("<SCHRPT_TOGROUP") == -1) && (FormOutputXML.IndexOf("<SCHRPT_TORECIPIENT") == -1))
                {
                    // add loggin user as SCHRPT_TOUSER
                    FormOutputXML = FormOutputXML.Replace("</SCHEDULEDREPORTDETAILS>", "<SCHRPT_TOUSER TYPE=\"RELATION\">" + ALParamObj.UserID + "</SCHRPT_TOUSER></SCHEDULEDREPORTDETAILS>");
                }

                if(String.IsNullOrEmpty(ScheduleReportType))
                    ErrorXml = objSCHRptFacade.CreateReportSchedule(ReportID, FilterXML, FormOutputXML);
                else
                    ErrorXml = objSCHRptFacade.CreateReportSchedule(ReportID, ScheduleReportType, FilterXML, FormOutputXML);
            }
            else
            {
                if (MonthlyOptionType == "")
                {
                    MonthlyOptionType = ALCommon.GetInnerValue(ref strScheduleDataXML, "<MONTHLYOPTIONTYPE>", "</MONTHLYOPTIONTYPE>");
                    String strMonthlyOptionNode = "<MONTHLYOPTIONTYPE>" + MonthlyOptionType + "</MONTHLYOPTIONTYPE>";
                    FormOutputXML = ALCommon.InsertBefore(ref FormOutputXML, "</SCHEDULEDREPORTDETAILS>", ref strMonthlyOptionNode);
                }
                else
                {
                    String strMonthlyOptionNode = "<MONTHLYOPTIONTYPE>" + MonthlyOptionType + "</MONTHLYOPTIONTYPE>";
                    FormOutputXML = ALCommon.InsertBefore(ref FormOutputXML, "</SCHEDULEDREPORTDETAILS>", ref strMonthlyOptionNode);
                }

                #region Disassociate instances of RECIPIENT
                if ((FormOutputXML.IndexOf("SCHRPT_TOEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\"")>-1) ||
                    (FormOutputXML.IndexOf("SCHRPT_CCEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\"")>-1) ||
                    (FormOutputXML.IndexOf("SCHRPT_BCCEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\"")>-1))
                {
                    XPathDocument xFormOutPutDoc = new XPathDocument(new StringReader(FormOutputXML));
                    XPathNavigator xNavForm = xFormOutPutDoc.CreateNavigator();
                    XPathDocument xDataXMLDoc = new XPathDocument(new StringReader(strScheduleDataXML));
                    XPathNavigator xNavDataXML = xDataXMLDoc.CreateNavigator();
                    XPathNavigator xRecipientNode = null;
                    String DisassociatedID = null;

                    foreach (XPathNavigator ToDiassociate in xNavForm.Select("SCHEDULEDREPORTDETAILS/SCHRPT_TOEMAILRECIPIENT[@DISASSOCIATE='TRUE']"))
                    {
                        xRecipientNode = xNavDataXML.SelectSingleNode("SCHEDULEDREPORTDETAILSCOLLECTION/SCHEDULEDREPORTDETAILS/SCHRPT_TOEMAILRECIPIENT/RECIPIENTEMAILINFO[EMAILID='" + ToDiassociate.InnerXml + "']");
                        if (xRecipientNode != null)
                        {
                            DisassociatedID = xRecipientNode.SelectSingleNode("EMAILINFOID").InnerXml;
                            FormOutputXML = FormOutputXML.Replace("<SCHRPT_TOEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\">" + ToDiassociate + "</SCHRPT_TOEMAILRECIPIENT>",
                                    "<SCHRPT_TOEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\">" + DisassociatedID + "</SCHRPT_TOEMAILRECIPIENT>");
                        }
                    }

                    foreach (XPathNavigator CCDiassociate in xNavForm.Select("SCHEDULEDREPORTDETAILS/SCHRPT_CCEMAILRECIPIENT[@DISASSOCIATE='TRUE']"))
                    {
                        xRecipientNode = xNavDataXML.SelectSingleNode("SCHEDULEDREPORTDETAILSCOLLECTION/SCHEDULEDREPORTDETAILS/SCHRPT_CCEMAILRECIPIENT/RECIPIENTEMAILINFO[EMAILID='" + CCDiassociate.InnerXml + "']");
                        if (xRecipientNode != null)
                        {
                            DisassociatedID = xRecipientNode.SelectSingleNode("EMAILINFOID").InnerXml;
                            FormOutputXML = FormOutputXML.Replace("<SCHRPT_CCEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\">" + CCDiassociate + "</SCHRPT_CCEMAILRECIPIENT>",
                                    "<SCHRPT_CCEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\">" + DisassociatedID + "</SCHRPT_CCEMAILRECIPIENT>");
                        }
                    }

                    foreach (XPathNavigator BCCDiassociate in xNavForm.Select("SCHEDULEDREPORTDETAILS/SCHRPT_BCCEMAILRECIPIENT[@DISASSOCIATE='TRUE']"))
                    {
                        xRecipientNode = xNavDataXML.SelectSingleNode("SCHEDULEDREPORTDETAILSCOLLECTION/SCHEDULEDREPORTDETAILS/SCHRPT_BCCEMAILRECIPIENT/RECIPIENTEMAILINFO[EMAILID='" + BCCDiassociate.InnerXml + "']");
                        if (xRecipientNode != null)
                        {
                            DisassociatedID = xRecipientNode.SelectSingleNode("EMAILINFOID").InnerXml;
                            FormOutputXML = FormOutputXML.Replace("<SCHRPT_BCCEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\">" + BCCDiassociate + "</SCHRPT_BCCEMAILRECIPIENT>",
                                    "<SCHRPT_BCCEMAILRECIPIENT TYPE=\"RELATION\" DISASSOCIATE=\"TRUE\">" + DisassociatedID + "</SCHRPT_BCCEMAILRECIPIENT>");
                        }
                    }

                }
                #endregion

                ErrorXml = objSCHRptFacade.UpdateReportSchedule(ScheduleReportID, FilterXML, strScheduleDataXML, FormOutputXML);
            }
        }
        return ErrorXml;
    }

    #endregion

}
