using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;


#region Assetlink Includes
using Assetlink;
using Assetlink.CustomControls;
using Assetlink.Solutions;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Pages;
using Assetlink.Components;
using Assetlink.Solutions.Facade.ReportFacade;
#endregion

public partial class Report_ASPX_AdHocReportSchedule_Create_Edit : ALAjaxPage
{
    #region Private Members
    private ALSolutionCommon    ALSolutionCommonObj     = null;
    private ALParam             ALParamObj              = null;
    
    private String              ReportID                = null;
    private String              ReportName              = null;
    private String              ScheduleID              = null;
    private String              ClosePopupFunction      = null;
    private String              AddScheduleBtnUniqueID  = null;

    private String m_ScheduleDataXML = null;
    private String ScheduleDataXML
    {
        get
        {
            return (String)ViewState["ScheduleDataXML"];
        }
        set
        {
            ViewState["ScheduleDataXML"] = value;
        }
    }

    private String CurrentPageURL
    {
        get
        {
            if(ViewState["CurrentPageURL"] == null)
                return Page.Request.RawUrl;
            else
                return (String)ViewState["CurrentPageURL"];
        }
        set
        {
            ViewState["CurrentPageURL"] = value;
        }
    }
    #endregion

    #region Standard Function
    protected void Page_Init(object sender, EventArgs e)
    {
        ALSolutionCommonObj = new ALSolutionCommon();
        ALParamObj          = new ALParam();

        ALSolutionCommonObj.httpContext = HttpContext.Current;
        ALSolutionCommonObj.InitALParam(ref ALParamObj);

        PrepareMemberVariables();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            CurrentPageURL = Page.Request.RawUrl;
    }

    protected override void OnPreRender(EventArgs e)
    {
        ObjReportSchedule.ReportSummaryBase.DisplayLayout = eDisplayLayout.OnlyContents;
        if (ObjReportSchedule.ReportScheduleFromControl != null)
        {
            Page.RegisterHiddenField("Form_ID", ObjReportSchedule.ReportScheduleFromControl.ClientID);
        }

        if (m_ScheduleDataXML != null)
            ScheduleDataXML = m_ScheduleDataXML;

        DateTime CurrentDate = new DateTime();
        CurrentDate = DateTime.Now;
        Page.RegisterHiddenField("CurrentDate_Day", CurrentDate.Day.ToString());
        Page.RegisterHiddenField("CurrentDate_Month", GetMonthValue(CurrentDate.Month));
        Page.RegisterHiddenField("CurrentDate_Year", CurrentDate.Year.ToString());

        base.OnPreRender(e);
    }

    protected override void Render(HtmlTextWriter writer)
    {
        if (IsPostBack)
        {
            if (ObjReportSchedule != null)
            {
                if (Ajax.EventGeneratorUniqueID.IndexOf(ObjReportSchedule.UniqueID) >= 0)
                {
                    Ajax.AddControlsToRender(ObjReportSchedule.ReportScheduleFromControl);
                    Ajax.AddControlsToRender(ObjReportSchedule.Frm_PersonalizeFiltersControl);
                }
            }

            Ajax.WriteControlHTMl(Page, writer);
        }
        else
            base.Render(writer);
    }
    #endregion

    #region private function
    private void PrepareMemberVariables()
    {
        ScheduleReport  objSCHRptFacade = null;
        String          XmlReportName   = null;;
        String          ReportXML       = null;

        #region Set the Member Variables
        ReportID                = ALSolutionCommonObj.GetParamValue("ReportID");
        ReportName              = Server.UrlDecode(ALSolutionCommonObj.GetParamValue("ReportName"));
        ScheduleID              = ALSolutionCommonObj.GetParamValue("ScheduleID");
        ClosePopupFunction      = ALSpecialCharHandling.DecodeSpecialCharactersForJS(ALSolutionCommonObj.GetParamValue("ClosePopupWindowFun"));
        AddScheduleBtnUniqueID  = ALSolutionCommonObj.GetParamValue("AddScheduleBtnUniqueID");
        #endregion

        #region Schedule Control
        XmlReportName                   = ReportName;
        ALSolutionCommon.EncodeSpecialCharacters(ref XmlReportName);
        ObjReportSchedule.ALParamObj    = ALParamObj;
        ObjReportSchedule.ReportID      = ReportID;
        ObjReportSchedule.ReportName    = XmlReportName + "1";
        ObjReportSchedule.ScheduleReportType = "ADHOCREPORT";
        
        if (Page.IsPostBack)
        {
            ObjReportSchedule.AjaxDataObject = Ajax;
        }
        else
        {
            #region get Report personalized Filter configuration
            GetReportDetails(ReportID, ref ReportXML);
            ObjReportSchedule.ReportDataXml = ReportXML;
            #endregion

            if (String.IsNullOrEmpty(ScheduleID))
            {
                ObjReportSchedule.ScheduleDataXml = "";
            }
            else
            {
                #region Assign Sechdule Data Xml
                GetScheduleReportDetails(ScheduleID, ref m_ScheduleDataXML);
                objSCHRptFacade = new ScheduleReport(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                objSCHRptFacade.ProcessScheduleRptDataXmlForEditMode(ref m_ScheduleDataXML);
                ObjReportSchedule.ScheduleDataXml = m_ScheduleDataXML;
                #endregion
            }            
        }
        #endregion

        #region Schedule Action Bar
        AB_ScheduleReport.TenantName = ALParamObj.TenantName;
        String ActionBarXml = ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "", "AdhocReportSchedule_ActionBar");

        AB_ScheduleReport.InputXMLType = ActionBar.XMLType.XMLPath;
        AB_ScheduleReport.InputXML = ActionBarXml;
        AB_ScheduleReport.AddAttributes("ScheduleReport", "href", "Javascript:if(ValidateForm_RSF()){if(Validate_Date_Range_Custom()){ ValidateAndSubmit() }}");
        Page.RegisterHiddenField("PageScheduleSaveButtonUID", AB_ScheduleReport.UniqueID + "$leftScheduleReport0");
        AB_ScheduleReport.AddAttributes("Cancel", "href", "Javascript:parent." + ClosePopupFunction);

        AB_ScheduleReport.Click += new EventHandler(AB_ScheduleReport_Click);
        #endregion
    }

    private void GetScheduleReportDetails(String ScheduleRptID, ref String ScheduleRptXml)
    {
        #region Member Variables
        String                  ErrorXML            = null;
        StringBuilder           sbSessionInfo       = null;
        StringBuilder           sbInputXML          = null;
        SearchConfiguration     SearchObj           = null;
        String                  ErrorPageURL        = null; 
        #endregion

        #region Prepre Search Input Xml
        sbSessionInfo = new StringBuilder();
        sbSessionInfo.AppendFormat("<SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'></SESSIONINFO>", ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ALParamObj.SessionID);

        sbInputXML = new StringBuilder();
        sbInputXML.AppendFormat(@"<SEARCH>
                                    <TARGETOBJECT>SCHEDULEDREPORTDETAILS</TARGETOBJECT>
                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                    <TARGETENTITY>
	                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
                                        <FILTERLIST>
                                            <FILTER>
                                                <EXPRESSION>SCHEDREPORTID</EXPRESSION>
                                                <OPERATOR>EQUALTO</OPERATOR>
                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>		                                                        
                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                            </FILTER>                                            
                                        </FILTERLIST>                                            
                                        <SELECTLIST>
		                                    <EXPRESSION>
			                                    <FIELDNAME>SCHEDREPORTID</FIELDNAME>
			                                    <ALIAS>SCHEDREPORTID</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>SCHEDREPORTINSTANCENAME</FIELDNAME>
			                                    <ALIAS>SCHEDREPORTINSTANCENAME</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>DESCRIPTION</FIELDNAME>
			                                    <ALIAS>DESCRIPTION</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>SCHEDTYPE</FIELDNAME>
			                                    <ALIAS>SCHEDTYPE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>STARTDATE</FIELDNAME>
			                                    <ALIAS>STARTDATE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>ENDDATE</FIELDNAME>
			                                    <ALIAS>ENDDATE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>SCHEDTIME</FIELDNAME>
			                                    <ALIAS>SCHEDTIME</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>RUNCYCLE</FIELDNAME>
			                                    <ALIAS>RUNCYCLE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>WEEKLYOPTION</FIELDNAME>
			                                    <ALIAS>WEEKLYOPTION</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>DAILYOPTION</FIELDNAME>
			                                    <ALIAS>DAILYOPTION</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>YEARLYOPTION</FIELDNAME>
			                                    <ALIAS>YEARLYOPTION</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>DayOFMonth</FIELDNAME>
			                                    <ALIAS>DayOFMonth</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>DELIVERYMODE</FIELDNAME>
			                                    <ALIAS>DELIVERYMODE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>EXPORTFORMAT</FIELDNAME>
			                                    <ALIAS>EXPORTFORMAT</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>FILTERVALUES</FIELDNAME>
			                                    <ALIAS>FILTERVALUES</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>NOTIFYME</FIELDNAME>
			                                    <ALIAS>NOTIFYME</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>MONTHLYOPTIONTYPE</FIELDNAME>
			                                    <ALIAS>MONTHLYOPTIONTYPE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>MONTHLYOPTIONDAY</FIELDNAME>
			                                    <ALIAS>MONTHLYOPTIONDAY</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>MONTHLYOPTIONDATE</FIELDNAME>
			                                    <ALIAS>MONTHLYOPTIONDATE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>SELECTEDMONTHS</FIELDNAME>
			                                    <ALIAS>SELECTEDMONTHS</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>MESSAGE</FIELDNAME>
			                                    <ALIAS>MESSAGE</ALIAS>
		                                    </EXPRESSION>
                                            <EXPRESSION>
			                                    <FIELDNAME>SUBJECT</FIELDNAME>
			                                    <ALIAS>SUBJECT</ALIAS>
		                                    </EXPRESSION>
                                             <EXPRESSION>
			                                    <FIELDNAME>SCHEDULEREPORTFILTERXML</FIELDNAME>
			                                    <ALIAS>SCHEDULEREPORTFILTERXML</ALIAS>
		                                    </EXPRESSION>
	                                    </SELECTLIST>
                                        <RELATIONSHIP NAME='SCHRPT_TOUSER'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_CCUSER'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_BCCUSER'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_TOGROUP'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_CCGROUP'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_BCCGROUP'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_TOEMAILRECIPIENT'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_CCEMAILRECIPIENT'>			                                                                                    
	                                    </RELATIONSHIP>
                                        <RELATIONSHIP NAME='SCHRPT_BCCEMAILRECIPIENT'>			                                                                                    
	                                    </RELATIONSHIP>
                                    </TARGETENTITY>{0}
                                </SEARCH>", sbSessionInfo.ToString(), ScheduleRptID);
        #endregion

        #region Perform Search
        SearchObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        ErrorXML = SearchObj.GetHierarchialData(sbInputXML.ToString(), ref ScheduleRptXml);
        if (!String.IsNullOrEmpty(ErrorXML))
        {
            ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, null, ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_AdhocReport_Schedule_GetScheduleDetails_Error"), null, GetBackUrl(), ref ErrorPageURL);
            if (!IsPostBack)
                Response.Redirect(ErrorPageURL);
            else
                Ajax.Redirect(Page, ErrorPageURL);
        }
        #endregion
    }

    private void GetReportDetails(String ReportID, ref String ReportXML)
    {
        #region Member Variables
        String          ErrorXML        = null;
        StringBuilder   sbSessionInfo   = null;
        StringBuilder   sbInputXML      = null;
        SearchConfiguration SearchObj   = null;
        String          ErrorPageURL    = null;
        #endregion

        #region Prepre Search Input Xml
        sbSessionInfo = new StringBuilder();
        sbSessionInfo.AppendFormat("<SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'></SESSIONINFO>", ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ALParamObj.SessionID);

        sbInputXML = new StringBuilder();        
        sbInputXML.AppendFormat(@"<SEARCH>
	                <TARGETOBJECT>ADHOCREPORT</TARGETOBJECT>
	                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
	                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                <SESSIONINFO UserID='{0}' Language='{1}' TenantName='{2}' SessionID='{3}'/>
	                <TARGETENTITY>
		                <SELECTLIST>
			                <EXPRESSION>
				                <FIELDNAME>REPORTID</FIELDNAME>
				                <ALIAS>REPORTID</ALIAS>
			                </EXPRESSION>
                            <EXPRESSION>
				                <FIELDNAME>REPORTNAME</FIELDNAME>
				                <ALIAS>REPORTNAME</ALIAS>
			                </EXPRESSION>
			                <EXPRESSION>
				                <FIELDNAME>REPORTDESCRIPTION</FIELDNAME>
				                <ALIAS>REPORTDESCRIPTION</ALIAS>
			                </EXPRESSION>
                            <EXPRESSION>
				                <FIELDNAME>REPORTCONFIGXML</FIELDNAME>
				                <ALIAS>REPORTCONFIGXML</ALIAS>
			                </EXPRESSION>
		                </SELECTLIST>
                        <FILTERLIST>
			                <FILTER>
				                <FILTERID>1</FILTERID>
				                <EXPRESSION>REPORTID</EXPRESSION>
				                <OPERATOR>EQUALTO</OPERATOR>
				                <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
				                <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                </FILTER>
                        </FILTERLIST>
	                </TARGETENTITY>
                </SEARCH>", ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ALParamObj.SessionID, ReportID);
        #endregion

        #region Perform Search
        SearchObj   = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        ErrorXML    = SearchObj.GetHierarchialData(sbInputXML.ToString(), ref ReportXML);
        if (!String.IsNullOrEmpty(ErrorXML))
        {
            ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, null, ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_AdhocReport_Schedule_GetReportDetails_Error"), null, GetBackUrl(), ref ErrorPageURL);
            if (!IsPostBack)
                Response.Redirect(ErrorPageURL);
            else
                Ajax.Redirect(Page, ErrorPageURL);
        }
        #endregion
    }

    private String GetMonthValue(int sMonthName)
    {
        switch (sMonthName)
        {
            case 1:
                return "January";
            case 2:
                return "February";
            case 3:
                return "March";
            case 4:
                return "April";
            case 5:
                return "May";
            case 6:
                return "June";
            case 7:
                return "July";
            case 8:
                return "August";
            case 9:
                return "September";
            case 10:
                return "October";
            case 11:
                return "November";
            case 12:
                return "December";

        }
        return "";
    }

    private String GetBackUrl()
    {
        if (ALSolutionCommonObj == null)
            ALSolutionCommonObj = new ALSolutionCommon();

        return CurrentPageURL.Substring(0, CurrentPageURL.IndexOf("?") + 1) + ALSolutionCommonObj.DecryptURL(CurrentPageURL.Substring(CurrentPageURL.IndexOf("=") + 1));
    }
    #endregion

    #region Events
    void AB_ScheduleReport_Click(object sender, EventArgs e)
    {
        String[] SenderValues   = null;
        String[] Separators     = { "$AL$" };
        String SenderString     = null;
        String ErrorXML         = null;

        try
        {
            SenderString = (String)sender;
            SenderValues = SenderString.Split(Separators, StringSplitOptions.RemoveEmptyEntries);

            if (SenderValues[1].Equals("ScheduleReport"))
            {
                if (String.IsNullOrEmpty(ScheduleID))
                {
                    ErrorXML = ObjReportSchedule.SaveScheduleDetails(null, null, "");
                }
                else
                {
                    ErrorXML = ObjReportSchedule.SaveScheduleDetails(ScheduleID, null, ScheduleDataXML);
                }

                if (ErrorXML == null)
                {
                    Ajax.WriteExecuteJavaScript("parent.__doPostBack('" + AddScheduleBtnUniqueID + "','');");
                    Ajax.WriteExecuteJavaScript("parent." + ClosePopupFunction);
                }
                else
                {
                    String ErrorPageURL = null;
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, null, ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_AdhocReport_Schedule_Save_Error"), null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                        Response.Redirect(ErrorPageURL);
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self');");
                }
            }
        }
        catch (Exception ExcepObj)
        {
            String AdditionalParams = "&ResourceID=Err_AdhocReport_Schedule_Save_Exception";
            ALSolutionCommonExtension.DumpExceptionAndRedirectToErrorPage(ExcepObj, null, null, true, null, AdditionalParams, GetBackUrl());
        }       
    }
    #endregion
}
