#region System Include
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;
using System.Xml.XPath;
using System.Text;
#endregion System Include

#region Assetlink Include
    using Assetlink.CustomControls;
    using Assetlink.Solutions;
    using Assetlink.Solutions.Facade.CommonFacade;
    using Assetlink.Solutions.Facade.InfrastructureFacade;
    using Assetlink.Solutions.Facade.StrategicPlannerFacade;
    using Assetlink.Solutions.Pages;
    using Assetlink;
#endregion Assetlink Include

using ERRORXML  = System.String;
using XML       = System.String;

public partial class Tree :ALAjaxPage
{
    ALSolutionCommon    CommonFunctionsObj  = null;
    ALParam             ALParamObj          = null;
    String              ValueListPath       = null;
    List<ALTreeView>    ListOfTreeNodes     = null;

    string          SelectedValueListXML    = "";
    string          TreeXML                 = "";
    String          ControlID               = null;
    string          HTMLContainer           = "";
    string          Hiddenip                = "";
    string          NamedHierarchyID        = "";
    string          SelectionMode           = "";
    string          InstallPath             = null;
    StringBuilder   HTMLContainerValue      = null;
    StringBuilder   HiddenipValue           = null;
    String          strDisablePath          = null;

    String          ErrorPageURL            = null;
    String          ErrorXML                = null;
    bool            bIsSessionValid         = false;
    String          ActivityLevel           = null;
    String          SolutionConfigPath      = null;
    XPathDocument   xpDoc_SolutionConfig    = null;
    XPathNavigator  xpNav_SolutionConfig    = null;
    StrategicPlanner_Helper SPHelperObj     = null;
    XPathNavigator  xpNav_Nomenclature      = null;

    //multiselect related changes
    private ListItem[]      objListItems            = null;
    String                  str_CheckBoxListID      = null;
    String                  str_RemovePanelID       = null;
    String                  str_outputhtml          = null;
    String                  str_SessionKey          = null;
    
    String                  str_RestrictActivityTypeSelection   = null; 
    String                  str_ConsiderICSpecial               = null;
    String                  str_ICValue                         = null; 
    String                  str_SourceAttributesXMLPath         = null;
    String                  str_ParentActivityID                = null; 
    String                  str_ActivityID                      = null; 
    String                  str_ParentForActivitySelected       = null; 
    String                  str_FromScreen                      = null;
    string                  SF_BudgetApproved                   = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        InfrastructureFacadeClass InfrastructureFacadeObj = null;

        Page.Header.DataBind();

        Ajax.AsynchronousRequest = true;
        if (!IsPostBack)
        {
            SetParameters();
            GetParameterValues();
            InfrastructureFacadeObj = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

            ErrorXML = InfrastructureFacadeObj.IsSessionValid(ref bIsSessionValid);
            if (!bIsSessionValid)
            {
                CommonFunctionsObj.PrepareErrorPageUrl(ALParamObj.SolutionName, "", "MARKETINGACTIVITY", null, "Session Invalid ! Please login again", null, "", ref ErrorPageURL);
                if (!IsPostBack)
                    Response.Redirect(ErrorPageURL);
                else
                    Ajax.Redirect(this.Page, ErrorPageURL);
            }

            SetControls();
        }
        //Ajax.AsynchronousRequest = true;
    }

    void SetControls()
    {
        
        try
        {
            if (xpNav_Nomenclature != null)
            {
                this.ActivityTypeSelectionTree.Nomenclature = xpNav_Nomenclature.Value;
            }
            this.ActivityTypeSelectionTree.SessionID    = ALParamObj.SessionID;
            this.ActivityTypeSelectionTree.UserID       = ALParamObj.UserID;
            this.ActivityTypeSelectionTree.TenantName   = ALParamObj.TenantName;
            this.ActivityTypeSelectionTree.Language     = ALParamObj.Language;            
            this.ActivityTypeSelectionTree.ActivityTypeSelectionClick += new EventHandler(ActivityTypeSelectionTree_ActivityTypeSelectionClick);
            this.ParentControlID.Value = ControlID;
            Title.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "SP_Admin_ActivityTemp_SelectType");
        }
        catch (Exception )
        {
        }
    }

    void SetParameters()
    {
        try
        {
            CommonFunctionsObj              = new ALSolutionCommon();
            ALParamObj                      = new ALParam();
            CommonFunctionsObj.httpContext  = HttpContext.Current;
            CommonFunctionsObj.InitALParam(ref ALParamObj);
            if (String.IsNullOrEmpty(ALParamObj.SolutionName))
            {
                ALParamObj.SolutionName = "StrategicPlanner";
            }
            ValueListPath                   = CommonFunctionsObj.GetParamValue("SelectedValueListXML");
            strDisablePath                  = CommonFunctionsObj.GetParamValue("DISABLEPATH");
            if (!String.IsNullOrEmpty(strDisablePath))
            {
                strDisablePath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + strDisablePath;
            }
            str_SessionKey                  = ALParamObj.SessionID + "ACTVITYTYPEPATH";
        }
        catch (Exception )
        {
        }
    }

    protected void ActivityTypeSelectionTree_ActivityTypeSelectionClick(object sender, EventArgs e)
    {
        Boolean         bool_ChildActivityExists= false;
        StringBuilder   ErrorPageURL_Exp        = null; 
        ulong           ulong_ErrorID           = 0;
        String          str_ListOfTrees         = null; 
        StringBuilder   sb_TempFileLocation     = null; 
        try
        {
            ListOfTreeNodes = (List<ALTreeView>)sender;
            
            bool_ChildActivityExists = CheckForBelowActivities(ListOfTreeNodes, ref str_ListOfTrees);

            if (!bool_ChildActivityExists)
                ActivityTypeSelected(str_ListOfTrees, false);
            else
            {
                //get the confirmation from the user that
                //Change in Activity type will affect activities below
                sb_TempFileLocation = new StringBuilder(25);
                sb_TempFileLocation.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + "StrategicPlanner_SelectedActivityTypes.xml");
                if (File.Exists(sb_TempFileLocation.ToString()))
                    File.Delete(sb_TempFileLocation.ToString());
                
                File.WriteAllText(sb_TempFileLocation.ToString(), str_ListOfTrees);
  
                Ajax.WriteExecuteJavaScript("sp_AllowActivityTypeChange('" + Btn_Hidden_Save.UniqueID + "', '" + sender + "');");

            }
        }
        catch (Exception ExceptionObj)
        {
            ulong_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "ActivityTypeTree.aspx", "ActivityTypeSelectionTree_ActivityTypeSelectionClick", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_SP_ActivityTypeSelection_ExceptionWhileHandlingActivityTypeSelectionClick"));

            ErrorPageURL_Exp = new StringBuilder();
            ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?TenantName={2}&ErrorID={1}&JS_CloseOnOk=True", ALParamObj.TenantName, ulong_ErrorID.ToString(), ALParamObj.TenantName);
            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
        }
    }

    protected void Btn_Hidden_SaveClick(object sender, EventArgs e)
    {
        StringBuilder   ErrorPageURL_Exp        = null; 
        ulong           ulong_ErrorID           = 0;
        StringBuilder   sb_TempFileLocation     = null;
        String          str_ListOfTrees         = null; 
 
        try
        {
            sb_TempFileLocation = new StringBuilder(25);
            sb_TempFileLocation.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + "StrategicPlanner_SelectedActivityTypes.xml");
            if (File.Exists(sb_TempFileLocation.ToString()))
            {
                str_ListOfTrees = File.ReadAllText(sb_TempFileLocation.ToString());
                ActivityTypeSelected(str_ListOfTrees, true);
            }
        }
        catch (Exception ExceptionObj)
        {
            ulong_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "ActivityTypeTree.aspx", "Btn_Hidden_SaveClick", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_SP_ActivityTypeSelection_ExceptionWhileHandlingActivityTypeSelectionClick"));

            ErrorPageURL_Exp = new StringBuilder();
            ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?TenantName={2}&ErrorID={1}&JS_CloseOnOk=True", ALParamObj.TenantName, ulong_ErrorID.ToString(), ALParamObj.TenantName);
            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
        }
    }

    private void ActivityTypeSelected(String str_ListOfTreeNodes, Boolean IsActivityTypeChanged)
    {
        XmlDocument         SelectedValueList_doc   = null;
        XmlElement          ValueListNode           = null;
        XmlElement          ValueNode               = null;
        XPathNavigator      TreeNode_Nav            = null;
        XPathDocument       xp_ListOfTrees          = null;
        XPathDocument       TreeNode_doc            = null;
        XPathNodeIterator   iter_ListOfTreeNodes    = null; 

        xp_ListOfTrees = new XPathDocument(new StringReader(str_ListOfTreeNodes));
        iter_ListOfTreeNodes = xp_ListOfTrees.CreateNavigator().Select("LISTOFTREES/TreeNodes");
 
        SelectedValueList_doc = new XmlDocument();
        ValueListNode = SelectedValueList_doc.CreateElement("ValueList");
        SelectedValueList_doc.AppendChild(ValueListNode);

        foreach (XPathNavigator TreeNode in iter_ListOfTreeNodes)
        {
            TreeNode_doc = new XPathDocument(new System.IO.StringReader(TreeNode.OuterXml));
            TreeNode_Nav = TreeNode_doc.CreateNavigator().SelectSingleNode("//TreeNode");
            if (TreeNode_Nav == null)
                continue;

            ValueNode = SelectedValueList_doc.CreateElement("Value");
            if (SelectionMode.ToUpper().Equals("MULTISELECT"))
            {
                ValueNode.SetAttribute("ID", TreeNode_Nav.GetAttribute("ID", ""));
            }
            else
            {
                ValueNode.SetAttribute("ID", ALSpecialCharHandling.TrimAndReplaceSpecialChars(TreeNode_Nav.GetAttribute("NodeData", "")));
            }
            //Changes for ICM.
            Session[str_SessionKey] = TreeNode_Nav.GetAttribute("Path", "").Replace("$ALPATHSEP$", "$ALP$");
            ValueNode.SetAttribute("NAMEDHIERARCHYID", TreeNode_Nav.GetAttribute("ID", ""));
            ValueNode.SetAttribute("Text", TreeNode_Nav.GetAttribute("Path", "").Replace("$ALPATHSEP$", "-"));
            ValueNode.SetAttribute("Value", TreeNode_Nav.GetAttribute("Text", ""));
            ValueListNode.AppendChild(ValueNode);
        }
        SelectedValueList_doc.Save(ValueListPath);
        GetSelectedNodes(ref SelectedValueList_doc);
        this.Close.Value = "true";
        this.ParentHiddenHTMLContainer.Value = HTMLContainer;
        this.ParentHiddenip.Value = Hiddenip;
        if (HiddenipValue != null)
        {
            this.ParentHiddenipValue.Value = HiddenipValue.ToString();
        }

        //Multiselect related changes
        str_outputhtml = MultiSelectCommon.PrepareCheckBoxListHTML(objListItems, str_CheckBoxListID, SelectionMode, true);

        if (HTMLContainerValue != null)
        {
            //  this.ParentHiddenHTMLContainerValue.Value = HTMLContainerValue.ToString();

            //Multiselect related changes
            this.ParentHiddenHTMLContainerValue.Value = str_outputhtml;
        }
        this.ParentControlID.Value = ControlID;
        if (TreeNode_Nav != null)
        {
            //Changes for ICM.
            this.SelectedActivityType.Value = ALSpecialCharHandling.EncodeSpecialCharactersForJS(TreeNode_Nav.GetAttribute("Text", "") + "$ALPATHVALSEP$" + TreeNode_Nav.GetAttribute("Path", "") + "$ALPATHVALSEP$" + TreeNode_Nav.GetAttribute("ID", "") + "$ALPATHVALSEP$" + IsActivityTypeChanged.ToString());
        }

        if ((String.IsNullOrEmpty(this.ParentHiddenipValue.Value)) || (String.IsNullOrEmpty(this.ParentHiddenHTMLContainerValue.Value)))
        {
            //pass removepanelid
            if (SelectionMode.ToUpper().Equals("SINGLESELECT"))
            {
                Ajax.WriteExecuteJavaScript("DoClose(false,'" + str_RemovePanelID + "');");
            }
            else
            {
                Ajax.WriteExecuteJavaScript("DoClose(true,'" + str_RemovePanelID + "');");
            }
        }
        else
        {
            //pass removepanelid
            Ajax.WriteExecuteJavaScript("DoClose(true,'" + str_RemovePanelID + "');");
        }
    }

    /// <summary>
    /// <CreatedOn>25 July 2011</CreatedOn>
    /// <Author>Mr. Hemant Karkande</Author>
    /// <Purpose>To check whther there exists activities below current activity</Purpose>
    /// </summary>
    /// <returns>
    /// TRUE: If activity exists below
    /// FALSE: Otherwise
    /// </returns>
    private Boolean CheckForBelowActivities(List<ALTreeView> ListOfTreeNodes, ref String str_ListOfTrees)
    {
        Boolean             bool_BelowActivityExists= false;
        String              str_SearchOutput        = null; 
        String              str_SelectedValue       = null; 
        StringBuilder       sb_SearchInputXML       = null; 
        XPathDocument       xp_ActivityXML          = null;
        XPathDocument       TreeNode_doc            = null; 
        XPathNavigator      TreeNode_Nav            = null; 
        XPathNavigator      nav_ActivityType        = null;
        ERRORXML            ErrorXMLString          = null;
        SearchConfiguration SearchObj               = null;
        StringBuilder       sb_ListofTrees          = null;

        sb_ListofTrees = new StringBuilder(50);
        sb_ListofTrees.Append("<LISTOFTREES>"); 

        foreach (ALTreeView TreeNode in ListOfTreeNodes)
        {
            TreeNode_doc = new XPathDocument(new System.IO.StringReader(TreeNode.NodeScr));
            TreeNode_Nav = TreeNode_doc.CreateNavigator().SelectSingleNode("//TreeNode");
            sb_ListofTrees.Append(TreeNode_doc.CreateNavigator().OuterXml);  
            str_SelectedValue = TreeNode_Nav.GetAttribute("Path", "");
        }
        sb_ListofTrees.Append("</LISTOFTREES>");

        str_ListOfTrees = sb_ListofTrees.ToString();
 
        if (!String.IsNullOrEmpty(str_ActivityID) && (!String.IsNullOrEmpty(str_RestrictActivityTypeSelection) && str_RestrictActivityTypeSelection.ToUpper() == "YES"))
        {
            //Get the below activity
            sb_SearchInputXML = new StringBuilder(50);
            sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                <AUTHORIZATIONREQUIRED>TRUE</AUTHORIZATIONREQUIRED>
                                                <TARGETOBJECT>MARKETINGACTIVITY</TARGETOBJECT>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <SESSIONINFO Language='" + ALParamObj.Language + "' TenantName='" + ALParamObj.TenantName + "' UserID='" + ALParamObj.UserID + "' SessionID='" + ALParamObj.SessionID + @"'/>
                                                <TARGETENTITY>
                                                   <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                   <SELECTLIST>	                                                    
                                                        <EXPRESSION>
		                                                    <FIELDNAME>ACTIVITYTYPE</FIELDNAME>
		                                                    <ALIAS>ACTIVITYTYPE</ALIAS>
	                                                    </EXPRESSION>
                                                    </SELECTLIST> 
                                                    <RELATIONSHIP NAME='MARKETINGACTIVITY_HIERARCHY'>                                                   
                                                        <SELECTLIST>	                                                        
                                                            <EXPRESSION>
		                                                        <FIELDNAME>ACTIVITYTYPE</FIELDNAME>
		                                                        <ALIAS>ACTIVITYTYPE</ALIAS>
	                                                        </EXPRESSION>
                                                        </SELECTLIST> 
                                                    </RELATIONSHIP>     
                                                    <FILTERLIST>			                                            
	                                                    <FILTER>
		                                                    <FILTERID>1</FILTERID>
		                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
		                                                    <OPERATOR>EQUALTO</OPERATOR>
		                                                    <EXPRESSIONVALUE>" + str_ActivityID + @"</EXPRESSIONVALUE>
		                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                    </FILTER>
                                                    </FILTERLIST> 
                                               </TARGETENTITY>
                                             </SEARCH>");
            SearchObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            ErrorXMLString = SearchObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutput);
            if (String.IsNullOrEmpty(ErrorXMLString) && !String.IsNullOrEmpty(str_SearchOutput))
            {
                xp_ActivityXML = new XPathDocument(new StringReader(str_SearchOutput));
                //Get the current selected value for activity type
                nav_ActivityType = xp_ActivityXML.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/ACTIVITYTYPE");//MARKETINGACTIVITY_HIERARCHY/MARKETINGACTIVITY");
                if (nav_ActivityType != null && !String.IsNullOrEmpty(nav_ActivityType.Value))
                {
                    if (!String.IsNullOrEmpty(str_SelectedValue))
                    {
                        str_SelectedValue = str_SelectedValue.Replace("$ALPATHSEP$", "$ALP$");  
                        if (nav_ActivityType.Value.ToUpper() != str_SelectedValue.ToUpper())
                        {
                            nav_ActivityType = xp_ActivityXML.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETINGACTIVITY_HIERARCHY/MARKETINGACTIVITY");
                            if (nav_ActivityType != null)
                                bool_BelowActivityExists = true;
                        }
                    }
                }
            }
        }

        return bool_BelowActivityExists; 
    }

    private void GetParameterValues()
    {

        XPathNavigator nav_RestrictActivityTypeSelection= null;
        XPathNavigator nav_ConsiderICSpecial            = null; 
        XPathNavigator nav_ICValue                      = null; 

        ViewState["GotParameterValues"] = "true";
        
        SelectedValueListXML        = CommonFunctionsObj.GetParamValue("SelectedValueListXML");
        TreeXML                     = CommonFunctionsObj.GetParamValue("TreeXML");
        NamedHierarchyID            = CommonFunctionsObj.GetParamValue("NamedHierarchyID");
        SelectionMode               = CommonFunctionsObj.GetParamValue("SelectionMode");
        HTMLContainer               = CommonFunctionsObj.GetParamValue("HTMLContainer");
        Hiddenip                    = CommonFunctionsObj.GetParamValue("Hiddenip");
        ControlID                   = CommonFunctionsObj.GetParamValue("ControlID");
        ActivityLevel               = CommonFunctionsObj.GetParamValue("ACTIVITYLEVEL");
        str_ParentActivityID        = CommonFunctionsObj.GetParamValue("ParentActivityID");
        str_ActivityID              = CommonFunctionsObj.GetParamValue("ActivityID");
        str_SourceAttributesXMLPath = CommonFunctionsObj.GetParamValue("SOURCEATTRIBUTES");
        str_ParentForActivitySelected = CommonFunctionsObj.GetParamValue("PARENTFORACTIVITYSELECTED"); 
        str_FromScreen              = CommonFunctionsObj.GetParamValue("FromScreen");
        SF_BudgetApproved           = CommonFunctionsObj.GetParamValue("SF_BudApproved");
 
        //Multiselect related changes
        str_CheckBoxListID          = CommonFunctionsObj.GetParamValue("CheckBoxListID");
        str_RemovePanelID           = CommonFunctionsObj.GetParamValue("RemovePanelID");
        
        SPHelperObj = new StrategicPlanner_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        SolutionConfigPath = SPHelperObj.GetConfigurationXMLPath(ALParamObj.SolutionName, "", "SolutionConfiguration");
        if (!String.IsNullOrEmpty(SolutionConfigPath))
        {
            xpDoc_SolutionConfig = new XPathDocument(SolutionConfigPath);
            xpNav_SolutionConfig = xpDoc_SolutionConfig.CreateNavigator();
            if (!String.IsNullOrEmpty(ActivityLevel))
            {
                xpNav_Nomenclature = xpNav_SolutionConfig.SelectSingleNode("//ACTIVITYLEVEL_NOMENCLATURE/ACTIVITYLEVEL[@Level='" + ActivityLevel + "']/SINGULARNAME");
                if (xpNav_Nomenclature != null)
                    this.ActivityTypeSelectionTree.Nomenclature = xpNav_Nomenclature.Value;
            }

            //Read the soultion configuration for Restriction in Activity Type selection settings
            nav_RestrictActivityTypeSelection = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration/ACTIVITYTYPESELECTION/RESTRICTACTIVITYTYPESELECTION");
            if (nav_RestrictActivityTypeSelection != null)
                str_RestrictActivityTypeSelection = nav_RestrictActivityTypeSelection.Value;

            if (!String.IsNullOrEmpty(str_RestrictActivityTypeSelection) && str_RestrictActivityTypeSelection.ToUpper() == "YES")
            {
                nav_ConsiderICSpecial = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration/ACTIVITYTYPESELECTION/CONSIDERICASSPECIALTYPE");
                if (nav_ConsiderICSpecial != null)
                    str_ConsiderICSpecial = nav_ConsiderICSpecial.Value;

                if (!String.IsNullOrEmpty(str_ConsiderICSpecial) && str_ConsiderICSpecial.ToUpper() == "YES")
                {
                    nav_ICValue = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration/ACTIVITYTYPESELECTION/INTEGRATEDCAMPAIGNVALUE");
                    if (nav_ICValue != null)
                        str_ICValue = nav_ICValue.Value;
                }
            }
        }
    }

   
    protected override void CreateChildControls()
    {
        ERRORXML        ErrorXML        = null;
        String          str_TreeXML     = null;
        StringBuilder   sb_TreeXMLPath  = null;
        SetParameters();
        SetControls();

        GetParameterValues();

        if (!String.IsNullOrEmpty(str_ParentForActivitySelected) && str_ParentForActivitySelected.ToUpper() == "NO")
        {
            LC_ErrorString.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "SP_SelectParentForActivity");
            div_ActivityTypeSelectionTree.Visible = false;
            div_NoActivityTypeToSelect.Visible = true;
            return;
        }

        if (InstallPath == null || InstallPath == "")
            InstallPath = ALSolutionCommon.GetInstallationDir();

        if (SelectedValueListXML == null || SelectedValueListXML == "" || SelectedValueListXML == "NO MATCH FOUND")
			SelectedValueListXML = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName,ALParamObj.SolutionName,"selectedvaluexml");

        //SF_BudgetApproved = Request.QueryString["SF_BudApproved"], is true when SameFamilyActivityTypeSelection and Budget Approved
        //In this case only allowed to change Activity Type to peer and children of selected activity. Get TreeXML from NamedHierarchyPath in Temp folder.
        if (String.Compare(SF_BudgetApproved, "True", true) > -1)
        {
            sb_TreeXMLPath = new StringBuilder(100);
            sb_TreeXMLPath.AppendFormat("{0}\\FRM_ActivityDetails_MARKETINGACTIVITY_ACTIVITYTYPE_SameFamilyActivityType_NamedHierarchy_{1}.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), str_ActivityID.ToString());
            TreeXML = sb_TreeXMLPath.ToString();
        }
        //TreeXML = Request.QueryString["TreeXML"];
        else if (TreeXML == null || TreeXML == "" || TreeXML == "NO MATCH FOUND")
			TreeXML = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "TreeInput");

        if (NamedHierarchyID != null && NamedHierarchyID != "" && NamedHierarchyID != "NO MATCH FOUND")
        {
            //Earlier there was no restriction on Activity type selection all the NH values were there in the file
            //This check has been commented to support Restriction in Activity type feature as there can be diffrent parents for diffrent activities
            
            // Modified by : Priyanka C. Defect: S0884726 when SameFamilyActivityTypeSelection is true and Budget Approved is true, can change to only peer and children activities
            // Added condition to stop rewrite over TreeXML in above case.
            if (String.Compare(SF_BudgetApproved, "True", true) < 0)
            {
                SPHelperObj.getFlatNamedHierarchyValue(NamedHierarchyID);
                TreeFacade TreeObj = new TreeFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                TreeObj.GetObsoleteValues = false;
                String TreeInputXML = null;
                if (SelectionMode == null && SelectionMode == "" && SelectionMode == "NO MATCH FOUND")
                    SelectionMode = "None";
                ErrorXML = TreeObj.GetTree("StrategicPlanner", "", "GetActivityTypeSelectionTree_" + SelectionMode.ToUpper(), out TreeInputXML);
                {
                    if (TreeInputXML != null && TreeInputXML != "")
                    {
                        FileStream      fsTreeXML = null;
                        StreamWriter    swTreeXML = null;
                        fsTreeXML = new FileStream(TreeXML, FileMode.Create);
                        swTreeXML = new StreamWriter(fsTreeXML);
                        swTreeXML.Write(TreeInputXML);
                        swTreeXML.Close();
                        fsTreeXML.Close();
                    }
                }
            }
        }

       

        XmlDocument treedoc = new XmlDocument();
        treedoc.Load(TreeXML);
        SetPath(ref treedoc);

        #region RestrictionInActivityTypeSelection
        XPathDocument   xp_ActivityXML          = null;
        XPathNavigator  nav_ActivityType        = null;
        String          str_SelectedActivityType= null; 

        if (Convert.ToUInt32(ActivityLevel) > 1 && !String.IsNullOrEmpty(str_RestrictActivityTypeSelection) && str_RestrictActivityTypeSelection.ToUpper() == "YES")
        {
            if (String.IsNullOrEmpty(str_SourceAttributesXMLPath) && !String.IsNullOrEmpty(str_FromScreen) && str_FromScreen.ToUpper() == "ACTIVITYCALENDAR" && !String.IsNullOrEmpty(str_ParentActivityID))
            {
                //Activity type selection on the "Add Activity" screen from Calendar
                str_SourceAttributesXMLPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + str_ParentActivityID + "_SourceAttributes.xml";
            }

            if (!String.IsNullOrEmpty(str_SourceAttributesXMLPath) && File.Exists(str_SourceAttributesXMLPath))
            {
                xp_ActivityXML = new XPathDocument(str_SourceAttributesXMLPath);
                nav_ActivityType = xp_ActivityXML.CreateNavigator().SelectSingleNode("SOURCEENTITY/SOURCEATTRIBUTES_FOR_ACTIVITY[LEVEL = " + ActivityLevel + "]/ACTIVITYTYPE");
                if (nav_ActivityType != null && !String.IsNullOrEmpty(nav_ActivityType.Value))
                    str_SelectedActivityType = nav_ActivityType.Value;
                else
                {
                    //Activity type is not selected at current parent 
                    //so go one level up
                    nav_ActivityType = xp_ActivityXML.CreateNavigator().SelectSingleNode("SOURCEENTITY/SOURCEATTRIBUTES_FOR_ACTIVITY[LEVEL = " + (Convert.ToInt32(ActivityLevel) - 1) + "]/ACTIVITYTYPE");
                    if (nav_ActivityType != null && !String.IsNullOrEmpty(nav_ActivityType.Value))
                        str_SelectedActivityType = nav_ActivityType.Value;
                }
            }
            else if (!String.IsNullOrEmpty(str_ParentActivityID))
            {
                //Source attribute xml does not exists
                //Fetch the Activity type selected for the given parent activity id
                str_SelectedActivityType = FetchActivityType();
            }
            if (!String.IsNullOrEmpty(str_SelectedActivityType))
            {
                if (!String.IsNullOrEmpty(str_ConsiderICSpecial) && str_ConsiderICSpecial.ToUpper() == "YES")
                {
                    if (!String.IsNullOrEmpty(str_ICValue) && str_SelectedActivityType.ToUpper() != str_ICValue.ToUpper())
                        RestrictActivityTypeSelection(ref treedoc, str_SelectedActivityType, false);
                    else if (!String.IsNullOrEmpty(str_ICValue) && str_SelectedActivityType.ToUpper() == str_ICValue.ToUpper())
                        RestrictActivityTypeSelection(ref treedoc, str_SelectedActivityType, true);
                }
                else
                    RestrictActivityTypeSelection(ref treedoc, str_SelectedActivityType, false);
            }
        }
        #endregion
        XmlDocument SelDoc = new XmlDocument();
        treedoc.Save(TreeXML);
        if (File.Exists(SelectedValueListXML))
        {
            SelDoc.Load(SelectedValueListXML);
            SetTreeSelectedNode(ref treedoc, ref SelDoc);
           
        }
        if (!String.IsNullOrEmpty(strDisablePath) && File.Exists(strDisablePath))
        {
            SetDisableNode(ref treedoc);
        }
        //SetFirstLevelExpanded(treedoc);
        XmlElement RootElement = null;
        RootElement = (XmlElement)treedoc.DocumentElement.SelectSingleNode("TreeNode");
        if (xpNav_Nomenclature != null)
        {
            RootElement.SetAttribute("Text", xpNav_Nomenclature.Value + " Type");
        }
        RootElement.SetAttribute("ShowExpanded", "true");

        str_TreeXML = treedoc.OuterXml;
        this.ActivityTypeSelectionTree.TreeXML = str_TreeXML;
        base.CreateChildControls();
    }

    /// <summary>
    /// <CreatedOn>04 August 2011</CreatedOn>
    /// <Author>Mr. Hemant Karkande</Author>
    /// <Purpose>To Fetch the Activity type for the Parent ActivityID</Purpose>
    /// </summary>
    /// <returns></returns>
    private String FetchActivityType()
    {
        String              str_SearchOutput        = null; 
        StringBuilder       sb_SearchInputXML       = null; 
        XPathDocument       xp_ActivityXML          = null;
        XPathNavigator      nav_ActivityType        = null;
        ERRORXML            ErrorXMLString          = null;
        SearchConfiguration SearchObj               = null;

        sb_SearchInputXML = new StringBuilder(50);
        sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                            <AUTHORIZATIONREQUIRED>TRUE</AUTHORIZATIONREQUIRED>
                                            <TARGETOBJECT>MARKETINGACTIVITY</TARGETOBJECT>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <SESSIONINFO Language='" + ALParamObj.Language + "' TenantName='" + ALParamObj.TenantName + "' UserID='" + ALParamObj.UserID + "' SessionID='" + ALParamObj.SessionID + @"'/>
                                            <TARGETENTITY>
                                               <PRIVILEGENAME>READ</PRIVILEGENAME>
                                               <SELECTLIST>	                                                    
                                                    <EXPRESSION>
	                                                    <FIELDNAME>ACTIVITYTYPE</FIELDNAME>
	                                                    <ALIAS>ACTIVITYTYPE</ALIAS>
                                                    </EXPRESSION>
                                                </SELECTLIST> 
                                                <RELATIONSHIP NAME='MARKETINGACTIVITY_HIERARCHY' HIERARCHY='BOTTOMUP'>                                                   
                                                    <SELECTLIST>	                                                        
                                                        <EXPRESSION>
	                                                        <FIELDNAME>ACTIVITYTYPE</FIELDNAME>
	                                                        <ALIAS>ACTIVITYTYPE</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST> 
                                                </RELATIONSHIP>     
                                                <FILTERLIST>			                                            
                                                    <FILTER>
	                                                    <FILTERID>1</FILTERID>
	                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
	                                                    <OPERATOR>EQUALTO</OPERATOR>
	                                                    <EXPRESSIONVALUE>" + str_ParentActivityID + @"</EXPRESSIONVALUE>
	                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                </FILTERLIST> 
                                           </TARGETENTITY>
                                         </SEARCH>");
        SearchObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        ErrorXMLString = SearchObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutput);
        if (String.IsNullOrEmpty(ErrorXMLString) && !String.IsNullOrEmpty(str_SearchOutput))
        {
            xp_ActivityXML = new XPathDocument(new StringReader(str_SearchOutput));
            //Get the current selected value for activity type
            nav_ActivityType = xp_ActivityXML.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/ACTIVITYTYPE");
            if (nav_ActivityType != null && !String.IsNullOrEmpty(nav_ActivityType.Value))
                //Activity Type is there for the given parent activity
                return nav_ActivityType.Value;
            else
            {
                //Activity Type is not there for the given parent activity
                //Search one level up
                nav_ActivityType = xp_ActivityXML.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETINGACTIVITY_HIERARCHY/MARKETINGACTIVITY/ACTIVITYTYPE");
                if (nav_ActivityType != null && !String.IsNullOrEmpty(nav_ActivityType.Value))
                    return nav_ActivityType.Value;
            }
        }
        return null;
    }

    /// <summary>
    /// <CreatedOn>25 July 2011</CreatedOn>
    /// <Author>Mr. Hemant Karkande</Author>
    /// <Purpose>To remove tree nodes depending on the activity type selected at the parent level</Purpose>
    /// </summary>
    /// <param name="treedoc">Tree document</param>
    /// <param name="str_ParentActivityType">Parent Activity type</param>
    /// <param name="bool_ConsiderICSpecial">Whether to consider IC as special type or not</param>
    private void RestrictActivityTypeSelection(ref XmlDocument treedoc, String str_ParentActivityType, Boolean bool_ConsiderICSpecial)
    {
        XmlNode             node_ParentActivityTree = null;
        XmlNode             node_RootTreeNode       = null; 
        String[]            strA_ActivityTypes      = null;
        String[]            strA_Seprator           = new string[1] { "$ALP$" };
        String              str_FinalParentActivityType = null;
        StringDictionary    sd_PlaceHolder          = null;

        strA_ActivityTypes = str_ParentActivityType.Split(strA_Seprator, StringSplitOptions.RemoveEmptyEntries);
        str_FinalParentActivityType = strA_ActivityTypes[strA_ActivityTypes.Length - 1];

        node_RootTreeNode = treedoc.SelectSingleNode("TreeNodes/TreeNode");
        node_ParentActivityTree = node_RootTreeNode.SelectSingleNode("//TreeNode[@NodeData=" + ALXmlUtil.GetXpathValueString(str_FinalParentActivityType) + "]");
        if (node_ParentActivityTree != null && node_ParentActivityTree.HasChildNodes && !bool_ConsiderICSpecial)
        {
            ((XmlElement)node_ParentActivityTree).SetAttribute("Selectionmode", "None");
            node_RootTreeNode.RemoveAll();
            node_RootTreeNode.InnerXml = node_ParentActivityTree.OuterXml;
        }
        else if (node_ParentActivityTree != null && bool_ConsiderICSpecial)
        {
            //Make IC node as a root node
            ((XmlElement)node_ParentActivityTree).SetAttribute("Selectionmode", "None");
            node_ParentActivityTree.InnerXml = node_RootTreeNode.InnerXml;
            node_RootTreeNode.RemoveAll();
            node_RootTreeNode.InnerXml = node_ParentActivityTree.OuterXml;

            //Remove IC node from the hierarchy
            node_RootTreeNode = treedoc.SelectSingleNode("TreeNodes/TreeNode/TreeNode");
            node_ParentActivityTree = node_RootTreeNode.SelectSingleNode("TreeNode[@NodeData=" + ALXmlUtil.GetXpathValueString(str_FinalParentActivityType) + "]");
            if (node_ParentActivityTree != null)
                node_RootTreeNode.RemoveChild(node_ParentActivityTree);   
        }
        else
        {
            sd_PlaceHolder = new StringDictionary();
            sd_PlaceHolder.Add("NOMENCLATURE", this.ActivityTypeSelectionTree.Nomenclature.ToString());
            //No nodes available for selection
            node_RootTreeNode.RemoveAll();
            LC_ErrorString.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "SP_NoActivityTypesToSelect",sd_PlaceHolder);      
            div_NoActivityTypeToSelect.Visible = true;
            div_ActivityTypeSelectionTree.Visible = false;
        }

    }

    private void SetDisableNode(ref XmlDocument treedoc)
    {
        XPathDocument       xpDoc_Disable       = null;
        XPathNavigator      xpNav_Disable       = null;
        XPathNodeIterator   xpItr_DisableNodes  = null;
        XmlElement          xmlEle_Node         = null;
        xpDoc_Disable       = new XPathDocument(strDisablePath);
        xpNav_Disable       = xpDoc_Disable.CreateNavigator();
        xpNav_Disable.MoveToFirstChild();
        xpItr_DisableNodes  = xpNav_Disable.SelectChildren(XPathNodeType.Element);
        while (xpItr_DisableNodes.MoveNext())
        {
            xmlEle_Node = (XmlElement)treedoc.SelectSingleNode("//TreeNode[@ID='" + xpItr_DisableNodes.Current.Value + "']");
            if (xmlEle_Node != null)
            {
                xmlEle_Node.SetAttribute("IsDisabled", "True");
            }
        }
   
    }

    private void SetTreeSelectedNode(ref XmlDocument treedoc, ref XmlDocument SelDoc)
    {
        //XmlElement  SelectedNode        = null;
        XmlElement  SelectedTreeNode    = null;
        String      SelectedValue       = null;
        XmlNodeList SelectedNodeList    = null;
        String      str_ActTypeId       = null;
        String      str_ActTypeName     = null;
        String      str_ActTypePath     = null;

        if (SelDoc != null)
        {
            #region By Parita
            // Changes done by Parita Harniya on 16 July 08
            // Changed the position of the code as it should be executed for every case (its not conditional).

            SelectedNodeList = treedoc.DocumentElement.SelectNodes("//*/TreeNode[@Selected='True']");
            foreach (XmlElement Node in SelectedNodeList)
            {
                Node.SetAttribute("Selected", "False");
            }
            // set the expanded true to false
            SelectedNodeList = treedoc.DocumentElement.SelectNodes("//*/TreeNode[@ShowExpanded='true']");
            foreach (XmlElement Node in SelectedNodeList)
            {
                Node.SetAttribute("ShowExpanded", "False");
            }

            // Changes done by Parita Harniya on 16 July 08 ends here.
            #endregion
            SelectedNodeList = SelDoc.SelectNodes("ValueList/Value");
            foreach(XmlElement SelectedNode in SelectedNodeList)
            {
                SelectedValue   = SelectedNode.GetAttribute("Value", "");
                str_ActTypeName = SelectedNode.GetAttribute("Text", "");
                if (Session[str_SessionKey] != null && SelectionMode.ToUpper().Equals("SINGLESELECT"))
                {
                    if (!String.IsNullOrEmpty(Session[str_SessionKey].ToString()))
                    {
                        SPHelperObj.getPathForSelectedActivityType(Session[str_SessionKey].ToString(), ref str_ActTypeId, ref str_ActTypePath);
                    }
                }
                else
                {
                    str_ActTypeId = SelectedNode.GetAttribute("NAMEDHIERARCHYID");
                    str_ActTypePath = SelectedNode.GetAttribute("Path");
                }

                HTMLContainerValue = new StringBuilder();
                HiddenipValue      = new StringBuilder();
                HTMLContainerValue.AppendFormat("{0}",SelectedValue);
                HiddenipValue.AppendFormat("{0}$COLON${1}", SelectedNode.GetAttribute("ID", ""), SelectedValue);
                SelectedTreeNode = (XmlElement)treedoc.SelectSingleNode("//TreeNode[@ID='" + str_ActTypeId + "']");
                if (SelectedTreeNode != null)
                {
                    SelectedTreeNode.SetAttribute("Selected", "True");
                    XmlElement ParentElement = (XmlElement)SelectedTreeNode.ParentNode;
                    while (ParentElement != null)
                    {
                        ParentElement.SetAttribute("ShowExpanded", "true");
                        if (ParentElement.ParentNode.NodeType != XmlNodeType.Document)
                        {
                            ParentElement = (XmlElement)ParentElement.ParentNode;
                        }
                        else
                        {
                            ParentElement = null;
                        }
                    }
                }
                SelectedTreeNode = (XmlElement)treedoc.SelectSingleNode("//TreeNode[translate(@Path,'$','-')=" + ALXmlUtil.GetXpathValueString(SelectedValue) + "]");
                if (SelectedTreeNode != null)
                {
                    SelectedTreeNode.SetAttribute("Selected", "True");
                    XmlElement ParentElement = (XmlElement)SelectedTreeNode.ParentNode;
                    while (ParentElement != null)
                    {
                        ParentElement.SetAttribute("ShowExpanded", "true");
                        if (ParentElement.ParentNode.NodeType != XmlNodeType.Document)
                        {
                            ParentElement = (XmlElement)ParentElement.ParentNode;
                        }
                        else
                        {
                            ParentElement = null;
                        }
                    }
                }
                if (SelectedNode != null && SelectedTreeNode != null)
                {
                    SelectedNode.SetAttribute("Value", SelectedTreeNode.GetAttribute("Text"));
                }
            }
        }
    }

    private void GetSelectedNodes(ref XmlDocument SelectedValueList_doc)
    {
        XmlNodeList     SelectedNodeList    = null;
        String      	SelectedValue       = null;

        
        Int32           ItemNo              = 0;        

        if (SelectedValueList_doc != null)
        {
            HTMLContainerValue  = new StringBuilder();
            HiddenipValue       = new StringBuilder();
            SelectedNodeList    = SelectedValueList_doc.SelectNodes("ValueList/Value");
            objListItems        = new ListItem[SelectedNodeList.Count];
            foreach(XmlElement SelectedNode in SelectedNodeList)
            {
                //SelectedValue = SelectedNode.GetAttribute("Value", "");
                SelectedValue = SelectedNode.GetAttribute("Text", "");                
                HTMLContainerValue.AppendFormat("{0}", ALSpecialCharHandling.TrimAndReplaceSpecialChars(SelectedValue));
                HiddenipValue.AppendFormat("{0}$COLON${1}", ALSpecialCharHandling.TrimAndReplaceSpecialChars(SelectedNode.GetAttribute("ID", "")), ALSpecialCharHandling.TrimAndReplaceSpecialChars(SelectedValue));

                //multiselect related changes as of common               
                
                objListItems[ItemNo++] = new ListItem(ALSpecialCharHandling.TrimAndReplaceSpecialChars(SelectedValue), SelectedNode.GetAttribute("ID", ""));
            }
        }
    }

    //void SetFirstLevelExpanded(XmlDocument TreeDoc)
    //{
    //    XmlNodeList TreeNodeList = null;
    //    try
    //    {
    //        TreeNodeList = TreeDoc.DocumentElement("TreeNode/TreeNode");
    //        forea
    //    }
    //    catch (Exception ExcepObj)
    //    {
    //        throw ExcepObj;
    //    }
    //}

    protected override void Render(HtmlTextWriter writer)
    {
        if (!IsPostBack)
        {
            base.Render(writer);
        }
        else
        {
            Ajax.AddControlsToRender(HiddenDiv);
            Ajax.WriteControlHTMl(this.Page, writer);
        }
    }

    protected override void InitializeCulture()
    {
        ALSolutionCommon ALSolutionCommonObj = new ALSolutionCommon();
        ALParam ALParamObj = new ALParam();

        ALSolutionCommonObj.httpContext = HttpContext.Current;
        ALSolutionCommonObj.InitALParam(ref ALParamObj);

        Page.Culture = Page.UICulture = Localization.GetCultureName(ALParamObj.Language, ALParamObj.TenantName);
        Localization.SetCultureForPage(ALParamObj.Language, ALParamObj.TenantName);
    }

    void SetPath(ref XmlDocument TreeDoc)
    {
        StringBuilder ActivitytypePath          = null;
        StringBuilder ActivityTypePathVal       = null;
        
        XPathDocument xp_TreeDoc = null;
        XPathNavigator xp_TreeNav = null;
        XPathNavigator xp_TreeNodeNav = null;

        XmlNodeList TreeNodeList = null;

        ActivitytypePath    = new StringBuilder();
        ActivityTypePathVal = new StringBuilder();
        xp_TreeDoc = new XPathDocument(new StringReader(TreeDoc.InnerXml));
        xp_TreeNav = xp_TreeDoc.CreateNavigator();
        xp_TreeNav = xp_TreeNav.SelectSingleNode("TreeNodes");
        TreeNodeList = TreeDoc.DocumentElement.SelectNodes("//*/TreeNode");
        foreach (XmlElement TreeNode in TreeNodeList)
        {
            String Path = null;
            ActivitytypePath.Remove(0, ActivitytypePath.Length);
            ActivitytypePath.Append(TreeNode.GetAttribute("NodeData"));
            xp_TreeNodeNav = xp_TreeNav.SelectSingleNode("//*/TreeNode[@ID=\"" + TreeNode.GetAttribute("ID") + "\"]");
            if (xp_TreeNodeNav != null)
            {
                while (xp_TreeNodeNav.MoveToParent())
                {
                    Path = ActivitytypePath.ToString();                    
                        if (!String.IsNullOrEmpty(xp_TreeNodeNav.GetAttribute("NodeData", "")) && (((!xp_TreeNodeNav.GetAttribute("Text", "").Equals("ActivityTypes"))) && ((!xp_TreeNodeNav.GetAttribute("Selectionmode", "").Equals("None")))))
                        {
                            ActivitytypePath.Remove(0, ActivitytypePath.Length);
                            ActivitytypePath.AppendFormat("{0}$ALPATHSEP${1}", xp_TreeNodeNav.GetAttribute("NodeData", ""), Path);                        
                        }
                }
            }
            TreeNode.SetAttribute("Path", ActivitytypePath.ToString());          
        }

    }
}
