#region System Includes
using System;
using System.Web;
using System.Web.UI;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Xml;
using System.Xml.XPath;
using System.Text;
using System.IO;
using System.Threading;
using System.Globalization;
using System.Web.UI.WebControls;
#endregion

#region Assetlink Includes
using Assetlink;
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.CustomControls.HelperClasses;
using Assetlink.Solutions.Facade.ResourceManagementFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.Solutions.Pages;
#endregion

namespace Assetlink.Solutions.ResourceManagement
{
    public partial class ResourceManagement_ResourceTimeSheet : ALAjaxPage
    {
        #region Constants
        const String OperationCreate = "CREATE";
        const String OperationUpdate = "UPDATE";
        const String OperationDelete = "DELETE";
        const String LayoutContributorList      = "CONTRIBUTORLIST";
        const String LayoutNonContributorList   = "NONCONTRIBUTORLIST";

        const String TimesheetModeDaily  = "DAILY";
        const String TimesheetModeWeekly = "WEEKLY";
        const String OtherProjectID  = "OTHERWORK";
        const String DeletedProjectID = "DELETED PROJECT";
              String[] Month         = { "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" };
              String[] Weekdays      = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};            

        #endregion

        String              TimesheetID                 = null;
        String              TimeSheetForDate            = null;
        DateTime            TimeSheetForDateObj;
        String              TimeSheetStatus             = "Draft";
        String              TimesheetReviewedByUserID   = null;
        Boolean             IsEditable                  = true;

        ulong               ErrorID                     = 0;
        String              ErrorXML                    = null;
        StringBuilder       BackUrl                     = null;
        String              strErrorPageURL             = null;
        ALParam             ALParamObj                  = null;
        LeftPaneFacade      LeftPaneObj                 = null;
        StringBuilder       AjaxErrorPageURL            = null;        
        ALSolutionCommon    ALSolutionCommonObj         = null;
        Boolean             IsSetControlsDone           = false;
        Boolean             ResponseRedirectionStarted  = false;

        HybridDictionary    FieldInfoCollection         = null;
        OrderedDictionary   TimeSheetDataRows           = null;
        OrderedDictionary   ProjectDetailsList          = null;
        OrderedDictionary   ResourceCategorysList       = null;
        OrderedDictionary   ObsoleteResourceCategorysList = null;
        OrderedDictionary   AssociatedResourceCategorysList = null;
        ResourceDef         ResourceDefObj              = null;
        String              ResourceDefID               = null;
        CultureInfo         UserCulture                 = null;
        String              TimeSheetMode               = TimesheetModeDaily;
        List<String>        TimeSheetDaysList;
        String              SourceListLayout            = null;
        String              DestinationListLayout       = null;

        XPathDocument       GridConfigurationXMLDoc = null;
        String              ErrorPageURL            = null;
        String              PastedTSId              = null;
        String              CacheName                   = null;
        String              TSIDCacheName               = null;
        String              TSForDateobjCacheName       = null;
        String              TSStatusCacheName           = null;
        String              TSReviewedByCacheName       = null;
        String              TSIsEditableCacheName       = null;

        String              TSFieldInfoColCacheName     = null;
        String              TSGridConfigDocCacheName    = null;
        String              TSProjDetailsListCacheName  = null;
        String              TSResCatListCacheName       = null;
        String              TSResDefObjCacheName        = null;
        String              TSResDefIDCacheName         = null;
        String              TSUserCultureCacheName      = null;
        String              TSObsoleteResCatListCacheName = null;
        String              TSDestListLayoutCacheName   = null;

        #region Structure definitions
        struct FieldInfo
        {
            public String name;
            public String type;
            public String fieldtype;
            public String editable;
            public String showeditable;
            public String treeddcache;
            public String NHID;
            public String TypeName;
            public String RelationshipName;
            public String CustomColumnType;
        }

        struct RowInfo
        {
            public String depth;
            public String ParentID;
        }
        #endregion

        #region Page Methods
        protected void Page_Init(object sender, EventArgs e)
        {
            Hashtable URLParams_HT = null;
       
            try
            {
                ALSolutionCommonObj = new ALSolutionCommon();
                ALParamObj          = new ALParam();

                ALSolutionCommonObj.httpContext = HttpContext.Current;
                ALSolutionCommonObj.InitALParam(ref ALParamObj);
                ALParamObj.SolutionName = "Timesheets";

                this.Master.GetType().GetProperty("TenantName").SetValue(this.Master, ALParamObj.TenantName, null);               
                this.Master.GetType().GetProperty("SolutionName").SetValue(this.Master, ALParamObj.SolutionName, null);                
                this.Master.GetType().GetProperty("SessionID").SetValue(this.Master, ALParamObj.SessionID, null);
                this.Master.GetType().GetProperty("UserID").SetValue(this.Master, ALParamObj.UserID, null);
                this.Master.GetType().GetProperty("Language").SetValue(this.Master, ALParamObj.Language, null);

                //setting left pane
                URLParams_HT             = new Hashtable();
                LeftPaneObj              = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName);
                LeftPaneObj.SolutionName = ALParamObj.SolutionName;
                LeftPaneObj.GetTaskPaneNode(this.Page, URLParams_HT);

                if (String.IsNullOrEmpty(ALSolutionCommonObj.GetParamValue("TimeSheetForDateChange")))
                    TimeSheetForDate = ALSolutionCommonObj.GetParamValue("TimeSheetForDate");
                else
                    TimeSheetForDate = ALSolutionCommonObj.GetParamValue("TimeSheetForDateChange");

                Ajax.AsynchronousRequest = true;
            }
            catch (Exception ExpObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Timesheet_ResourceTimeSheet.aspx", "Page_Init", ExpObj, null, null);
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "RESOURCETIMESHEET", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_RM_ResourceCategoryList_ErrorOccuredWhileGeneratingResourceCategoryList"), null, BackUrl.ToString(), ref strErrorPageURL);
                if (IsPostBack)
                {
                    Ajax.Redirect(this, strErrorPageURL);
                }
                else
                {
                    Response.Redirect(strErrorPageURL, true);
                }
            }
        }         
       
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                SetControls();
            }
            catch (Exception ExpObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Timesheet_ResourceTimeSheet.aspx", "Page_Load", ExpObj, null, null);
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "RESOURCETIMESHEET", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_RM_ResourceCategoryList_ErrorOccuredWhileGeneratingResourceCategoryList"), null, BackUrl.ToString(), ref strErrorPageURL);
                if (IsPostBack)
                {
                    Ajax.Redirect(this, strErrorPageURL);
                }
                else
                {
                    Response.Redirect(strErrorPageURL, true);
                }
            }
        }

        protected override void OnPreRenderComplete(EventArgs e)
        {
            AddCacheItem(TSIDCacheName, TimesheetID);
            AddCacheItem(TSResDefObjCacheName, ResourceDefObj);
            AddCacheItem(TSResDefIDCacheName, ResourceDefID);
            AddCacheItem(TSUserCultureCacheName, UserCulture);
            AddCacheItem(TSForDateobjCacheName, TimeSheetForDateObj);
            AddCacheItem(TSStatusCacheName, TimeSheetStatus);
            AddCacheItem(TSReviewedByCacheName, TimesheetReviewedByUserID);
            AddCacheItem(TSIsEditableCacheName, IsEditable);
            AddCacheItem("TimeSheetMode", TimeSheetMode);

            AddCacheItem(TSFieldInfoColCacheName, FieldInfoCollection);
            AddCacheItem(TSGridConfigDocCacheName, GridConfigurationXMLDoc);
            AddCacheItem(CacheName, TimeSheetDataRows);
            AddCacheItem(TSProjDetailsListCacheName, ProjectDetailsList);
            AddCacheItem(TSResCatListCacheName, ResourceCategorysList);
            AddCacheItem(TSObsoleteResCatListCacheName, ObsoleteResourceCategorysList);
            AddCacheItem(TSDestListLayoutCacheName, DestinationListLayout);
            
            if (ResourceDefObj != null)
            {
                Div_ContributorsView.Visible = true;
                Div_NonContributorView.Visible = false;
                Img1.Width = 572;
            }
            else
            {
                Div_ContributorsView.Visible = false;
                Div_NonContributorView.Visible = true;
                Img1.Width = 352;
            }

            if(!IsPostBack)
                CopiedTimeSheetnote.Controls.Add(new LiteralControl(PrepareCopiedTimesheetNote()));
            base.OnPreRenderComplete(e);
        }

        
        protected override void Render(HtmlTextWriter writer)
        {            
            try
            {         
                if (IsPostBack)
                {
                    Ajax.WriteControlHTMl(this.Page, writer);
                }
                else
                {
                    RegisterNumberLocalizationAPI();

                    base.Render(writer);
                }
            }
            catch (Exception ExpObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Timesheet_ResourceTimeSheet.aspx", "Page_Render", ExpObj, null, null);
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "RESOURCETIMESHEET", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_RM_ResourceCategoryList_ErrorOccuredWhileGeneratingResourceCategoryList"), null, BackUrl.ToString(), ref strErrorPageURL);
                if (IsPostBack)
                {
                    Ajax.Redirect(this, strErrorPageURL);
                }
                else
                {
                    Response.Redirect(strErrorPageURL, true);
                }
            }
        }        
        
        #endregion

        #region Private Methods
        private void RegisterNumberLocalizationAPI()
        {
            StringBuilder JSFunction = new StringBuilder(1024);
            
            JSFunction.Append(@"function ConvertDisplayNumberToStdFormat(ValueToConvert) 
                                {"); 
                                     if(UserCulture.NumberFormat.NumberDecimalSeparator != ".")
                                         JSFunction.Append(@" ValueToConvert = ValueToConvert.replace(new RegExp('" + UserCulture.NumberFormat.NumberDecimalSeparator + @"', 'g'), '.');");
                                        
                    JSFunction.Append(@" return ValueToConvert;
                                }


                                function ConvertStdNumberToDisplayFormat(NumberToConvert) 
                                {"); 

                                    if(UserCulture.NumberFormat.NumberDecimalSeparator != ".")
                    JSFunction.Append(@"NumberToConvert = NumberToConvert.toString();
                                        NumberToConvert = NumberToConvert.replace(new RegExp('\\.', 'g'), '" + UserCulture.NumberFormat.NumberDecimalSeparator + @"');");

                    JSFunction.Append(@" return NumberToConvert;
                                }");

            Page.ClientScript.RegisterClientScriptBlock(typeof(String), "NumberLocalization", "<script type='text/javascript'> " + JSFunction.ToString() + "</script>");
        }

        private void SetControls()
        {
            String          ActBarXMLPath           = null;           
            String          UserCultureName         = null;
            TimeSheet       TimeSheetFacadeObj      = null;
            String          GridConfigXml           = null;
            CacheName                               = null;
            TSIDCacheName                           = null;
            TSForDateobjCacheName                   = null;
            TSStatusCacheName                       = null;
            TSReviewedByCacheName                   = null;
            TSIsEditableCacheName                   = null;
            TSFieldInfoColCacheName                 = null;
            TSGridConfigDocCacheName                = null;
            TSProjDetailsListCacheName              = null;
            TSResCatListCacheName                   = null;
            TSResDefObjCacheName                    = null;
            TSResDefIDCacheName                     = null;
            TSUserCultureCacheName                  = null;
            TSObsoleteResCatListCacheName           = null;
            TSDestListLayoutCacheName               = null;

            #region Get TimeSheet Mode
            if (!IsPostBack)
            {
                TimeSheetFacadeObj      = new TimeSheet(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName);
                String TimeSheetView    = TimeSheetFacadeObj.GetSolutionConfigValue("TIMESHEETVIEW");
                if (TimeSheetView != "" && TimeSheetView.ToUpper() == "WEEKLY")
                    TimeSheetMode = TimesheetModeWeekly;
            }
            else
                TimeSheetMode = (String)GetCacheItem("TimeSheetMode");
            #endregion

            #region Prepare TimesheetDay List
            TimeSheetDaysList = new List<String>();
            if (TimeSheetMode == TimesheetModeDaily)
            {
                TimeSheetDaysList.Add("UTILIZATION");
                Page.ClientScript.RegisterStartupScript(typeof(String), "TimeSheetDayList", "<script type='text/javascript'>SetTimeSheetDayList(new Array('UTILIZATION'));</script>");
            }
            else
            {
                TimeSheetDaysList.Add("DAY1HOURS");
                TimeSheetDaysList.Add("DAY2HOURS");
                TimeSheetDaysList.Add("DAY3HOURS");
                TimeSheetDaysList.Add("DAY4HOURS");
                TimeSheetDaysList.Add("DAY5HOURS");
                TimeSheetDaysList.Add("DAY6HOURS");
                TimeSheetDaysList.Add("DAY7HOURS");
                Page.ClientScript.RegisterStartupScript(typeof(String), "TimeSheetDayList", "<script type='text/javascript'>SetTimeSheetDayList(new Array('DAY1HOURS','DAY2HOURS','DAY3HOURS','DAY4HOURS','DAY5HOURS','DAY6HOURS','DAY7HOURS'));</script>");
            }
            #endregion

            if (!IsPostBack)
            {
                Div_ALBase.CaptionHTML = new StringBuilder("&nbsp;&nbsp;" + Localization.GetString("ALResource", ALParamObj.TenantName, "TS_MyTimesheets"));
                lblCalendar.Text       = Localization.GetString("ALResource", ALParamObj.TenantName, "TS_Timesheetfor");

                //JCalTimeSheetDate
                #region Time Sheed Date Settings
                String      FormatXmlPath   = ALCommon.GetFormatDetails(ALParamObj.TenantName, out UserCultureName);
                UserCulture                 = new CultureInfo(UserCultureName);
                Formats     FormatesObj     = new Formats(FormatXmlPath);
                TimeSheetForDateObj         = DateTime.Now;

                if(!String.IsNullOrEmpty(TimeSheetForDate))
                {
                    String[] DateDetails;
                    if (TimeSheetForDate.IndexOf('/') > 0)
                    {
                        DateDetails = TimeSheetForDate.Split('/');
                    }
                    else 
                    {
                        DateDetails = TimeSheetForDate.Split(' ');

                        for(int i =0; i<=11; i++)
                        {
                            if (Month[i].ToUpper() == DateDetails[1].ToUpper())
                            {
                                DateDetails[1] = (i + 1).ToString();
                                break;
                            }
                        }
                    }

                    TimeSheetForDateObj  = new DateTime(Convert.ToInt16(DateDetails[2]),Convert.ToInt16(DateDetails[1]),Convert.ToInt16(DateDetails[0]));
                }

                JCalTimeSheetDate.DateFormat = FormatesObj.ColumnDateFieldFormat;
                JCalTimeSheetDate.TenantName = ALParamObj.TenantName;
                JCalTimeSheetDate.HiddenText = TimeSheetForDateObj.Day + " " + Month[(TimeSheetForDateObj.Month - 1)] + " " + TimeSheetForDateObj.Year;
                JCalTimeSheetDate.Text = FormatesObj.FormatDateField(JCalTimeSheetDate.HiddenText, UserCulture);

                JCalTimeSheetDate.ChangeEvent = "onchange";
                JCalTimeSheetDate.ChangeEventMethod = "javascript:OnTimeSheetDateChange(this);";
                PreviousDayImg.Src  = "/" + ALParamObj.TenantName + "/App_Themes/Default/images/previous_1.gif";
                NextDayImg.Src      = "/" + ALParamObj.TenantName + "/App_Themes/Default/images/next_1.gif";
                PreviousDayImg.Attributes.Add("Title", Localization.GetString("ALResource", ALParamObj.TenantName, "TS_Previous_Day"));
                NextDayImg.Attributes.Add("Title", Localization.GetString("ALResource", ALParamObj.TenantName, "TS_Next_Day"));



                ALCommon ALCommonObj    = new ALCommon();
                DateTime PreviousDate   =  TimeSheetForDateObj.AddDays(-1);
                PreviousDayHandler.Attributes.Add("href", ALCommonObj.EncodeURLForResponseRedirects("Timesheet_ResourceTimeSheet.aspx?" + ALSolutionCommon.AppendStandardParamforURL(ALParamObj) + "&TimeSheetForDate=" + PreviousDate.Day + "/" + PreviousDate.Month + "/" + PreviousDate.Year));
                DateTime NextDate       = TimeSheetForDateObj.AddDays(1);
                NextDayHandler.Attributes.Add("href", ALCommonObj.EncodeURLForResponseRedirects("Timesheet_ResourceTimeSheet.aspx?" + ALSolutionCommon.AppendStandardParamforURL(ALParamObj) + "&TimeSheetForDate=" + NextDate.Day + "/" + NextDate.Month + "/" + NextDate.Year));
                #endregion

                #region Paste Options Popup
                PasteOptions.TenantName         = ALParamObj.TenantName;
                PasteOptions.ThemeName          = Page.Theme;
                PasteOptions.ShowDimmer         = true;
                PasteOptions.CaptionText        = Localization.GetString("ALResource", ALParamObj.TenantName, "TS_PasteTimeSheet");
                PasteOptions.PopupWidth         = 350;
                Btn_PasteOptionsOk.Text         = Localization.GetString("ALResource", ALParamObj.TenantName, "Ok_Shared");
                Btn_PasteOptionsOk.ToolTip      = Localization.GetString("ALResource", ALParamObj.TenantName, "Ok_Shared");
                Btn_PasteOptionsCancel.Text     = Localization.GetString("ALResource", ALParamObj.TenantName, "Cancel_Shared");
                Btn_PasteOptionsCancel.ToolTip  = Localization.GetString("ALResource", ALParamObj.TenantName, "Cancel_Shared");

                Btn_PasteOptionsOk.Attributes.Add("href", "JavaScript:onPasteTimeSheetOkclick('" + Rbtn_Append.ClientID + "','" + ALSpecialCharHandling.EncodeSpecialCharactersForJS(PasteOptions.ClosePopupJavascript) + "')");
                Btn_PasteOptionsCancel.Attributes.Add("href", "JavaScript:" + PasteOptions.ClosePopupJavascript);

                lbl_Append.Text                 = Localization.GetString("ALResource", ALParamObj.TenantName, "TS_AppendTimesheet");
                lbl_Overwrite.Text              = Localization.GetString("ALResource", ALParamObj.TenantName, "TS_OverwriteTimesheet");
                lbl_CopyPastNote.Text           = Localization.GetString("ALResource", ALParamObj.TenantName, "TS_TimesheetCopyWarning");

                //btn_Add.Text        = Localization.GetString("ALResource", ALParamObj.TenantName, "Add_Shared");
                //btn_Add.ToolTip     = Localization.GetString("ALResource", ALParamObj.TenantName, "Add_Shared");
                btn_Delete.Text     = Localization.GetString("ALResource", ALParamObj.TenantName, "Delete_Shared");
                btn_Delete.ToolTip  = Localization.GetString("ALResource", ALParamObj.TenantName, "TS_DeleteTimesheet_Items");
                btn_Delete.Attributes.Add("Onclick", "JavaScript:DeleteGridRow();");
                lbl_MandatoryNote.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "Mandatory_fields_Note");
                lbl_MandatoryNote_NonContributorView.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "Mandatory_fields_Note");

                Drp_ItemToaddCount.Attributes.Add("onchange", "javascript:InsertBlankRow(this.value); this.selectedIndex = 0;");
                Drp_ItemToaddCount.Items.Add(new ListItem(Localization.GetString("ALResource", ALParamObj.TenantName, "TS_AddROW").Replace(" $AL$ROWCOUNT$AL$", ""), "0"));
                Drp_ItemToaddCount.Items.Add(new ListItem(Localization.GetString("ALResource", ALParamObj.TenantName, "TS_AddROW").Replace("$AL$ROWCOUNT$AL$", "1"), "1"));
                Drp_ItemToaddCount.Items.Add(new ListItem(Localization.GetString("ALResource", ALParamObj.TenantName, "TS_AddROWS").Replace("$AL$ROWCOUNT$AL$", "2"), "2"));
                Drp_ItemToaddCount.Items.Add(new ListItem(Localization.GetString("ALResource", ALParamObj.TenantName, "TS_AddROWS").Replace("$AL$ROWCOUNT$AL$", "5"), "5"));
                Drp_ItemToaddCount.Items.Add(new ListItem(Localization.GetString("ALResource", ALParamObj.TenantName, "TS_AddROWS").Replace("$AL$ROWCOUNT$AL$", "10"), "10"));
                #endregion
            }

            //Grid
            ALTimeSheetGrid.TenantName  = ALParamObj.TenantName;
            ALTimeSheetGrid.Language    = ALParamObj.Language;
            ALTimeSheetGrid.SessionID   = ALParamObj.SessionID;
            ALTimeSheetGrid.UserID      = ALParamObj.UserID;
            
            if (!IsSetControlsDone)
            {
                ALTimeSheetGrid.InsertNode      += new ALGrid.CustomInsertNodeEventHandler(ALTimeSheetGrid_InsertNode);
                ALTimeSheetGrid.InitDDTreeData  += new ALGrid.InitTreeDDEventHandler(ALTimeSheetGrid_InitDDTreeData);
                ALTimeSheetGrid.UpdateNode      += new ALGrid.CustomUpdateNodeEventHandler(ALTimeSheetGrid_UpdateNode);
                ALTimeSheetGrid.EditCellClick   += new ALGrid.EditCellEventHandler(ALTimeSheetGrid_EditCellClick);
                ALTimeSheetGrid.DeleteRows      += new ALGrid.GridDeleteRowsHandler(ALTimeSheetGrid_DeleteRows);
                ALTimeSheetGrid.GridRefresh += new ALGrid.GridRefreshHandler(ALTimeSheetGrid_GridRefresh);

                IsSetControlsDone               = true;
            }

            CacheName = "TimeSheetDt_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");

            TSIDCacheName                   = "TimesheetID_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSForDateobjCacheName           = "TimeSheetForDateObj_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSStatusCacheName               = "TimeSheetStatus_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSReviewedByCacheName           = "TimesheetReviewedByUserID_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSIsEditableCacheName           = "IsEditable_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");

            TSFieldInfoColCacheName         = "FieldInfoCollection_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSGridConfigDocCacheName        = "GridConfigurationXMLDoc_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSProjDetailsListCacheName      = "ProjectDetailsList_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSResCatListCacheName           = "ResourceCategorysList_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSResDefObjCacheName            = "ResourceDefObj_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSResDefIDCacheName             = "ResourceDefID_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSUserCultureCacheName          = "UserCulture_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSObsoleteResCatListCacheName   = "ObsoleteResourceCategorysList_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");
            TSDestListLayoutCacheName       = "DestinationListLayout_" + ALParamObj.UserID + "_" + JCalTimeSheetDate.HiddenText.Replace(" ", "_");

            if (IsPostBack)
            {
                TimeSheetDataRows = (OrderedDictionary)GetCacheItem(CacheName);

                if (TimeSheetDataRows == null)
                    TimeSheetDataRows = new OrderedDictionary();
            }
            else
                TimeSheetDataRows = new OrderedDictionary();
          
            if (IsPostBack)
            {
                TimesheetID                 = (String)GetCacheItem(TSIDCacheName);
                TimeSheetForDateObj         = (DateTime)GetCacheItem(TSForDateobjCacheName);
                TimeSheetStatus             = (String)GetCacheItem(TSStatusCacheName);
                TimesheetReviewedByUserID   = (String)GetCacheItem(TSReviewedByCacheName);
                IsEditable                  = (Boolean)GetCacheItem(TSIsEditableCacheName);

                FieldInfoCollection         = (HybridDictionary)GetCacheItem(TSFieldInfoColCacheName);
                GridConfigurationXMLDoc     = (XPathDocument)GetCacheItem(TSGridConfigDocCacheName);
                ProjectDetailsList          = (OrderedDictionary)GetCacheItem(TSProjDetailsListCacheName);
                ResourceCategorysList       = (OrderedDictionary)GetCacheItem(TSResCatListCacheName);
                ResourceDefObj              = (ResourceDef)GetCacheItem(TSResDefObjCacheName);
                ResourceDefID               = (String)GetCacheItem(TSResDefIDCacheName);
                UserCulture                 = (CultureInfo)GetCacheItem(TSUserCultureCacheName);
                ObsoleteResourceCategorysList = (OrderedDictionary)GetCacheItem(TSObsoleteResCatListCacheName);
                DestinationListLayout       = (String)GetCacheItem(TSDestListLayoutCacheName);


                ALTimeSheetGrid.ConfigXml   = GridConfigurationXMLDoc.CreateNavigator().InnerXml;
                ALTimeSheetGrid.AjaxRef     = Ajax;
            }
            else
            {
                FieldInfoCollection     = new HybridDictionary();
                ProjectDetailsList      = new OrderedDictionary();
                ResourceCategorysList   = new OrderedDictionary();
                ObsoleteResourceCategorysList = new OrderedDictionary();


                PrepareGridData();

                /*if(ResourceDefObj != null)
                    GridConfigXml = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, null, "TimeSheets_"+ TimeSheetMode +"_GridConfiguration"));
                else
                    GridConfigXml = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, null, "TimeSheets_" + TimeSheetMode + "_NonContributors_GridConfiguration"));*/

                if (TimeSheetDataRows.Count > 0)
                {
                    foreach (String key in TimeSheetDataRows.Keys)
                    {
                        TimeSheetItemRow TimeSheetRow = (TimeSheetItemRow)TimeSheetDataRows[key];
                        if (TimeSheetRow.ColumnNameValues["RESOURCATEGORYID"] == "")
                        {
                            DestinationListLayout = LayoutNonContributorList;
                            ResourceDefObj = null; //Is a user
                        }
                        else
                            DestinationListLayout = LayoutContributorList;
                        break;
                    }
                }
                else if (ResourceDefObj == null)
                {
                    DestinationListLayout = LayoutNonContributorList;
                }
                else if (ResourceDefObj.IsObsolete == true)
                {
                    DestinationListLayout = LayoutNonContributorList;
                    ResourceDefObj = null; //Is a user
                }
                else
                    DestinationListLayout = LayoutContributorList;

                if (DestinationListLayout == LayoutContributorList)
                    GridConfigXml = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, null, "TimeSheets_" + TimeSheetMode + "_GridConfiguration"));
                else
                    GridConfigXml = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, null, "TimeSheets_" + TimeSheetMode + "_NonContributors_GridConfiguration"));

                
                GridConfigXml   = GridConfigXml.Replace("$AL$EDITABLE$AL$", IsEditable.ToString().ToLower());
                GridConfigXml   = GridConfigXml.Replace("$AL$TEXTCSS$AL$", IsEditable ? "AGText" : "AGRowText");
                GridConfigurationXMLDoc = new XPathDocument(new StringReader(GridConfigXml));
                
                #region Prepare Column Meta Data
                if (FieldInfoCollection.Count == 0)
                {
                    XPathNavigator      GridConfigurationRootNode   = null;
                    XPathExpression     SortColumnExp               = null;
                    XPathNodeIterator   GridColumnNodes             = null;

                    GridConfigurationRootNode   = GridConfigurationXMLDoc.CreateNavigator();
                    SortColumnExp               = GridConfigurationRootNode.Compile("gridconfiguration/header/headercolumn");
                    SortColumnExp.AddSort("@order", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                    GridColumnNodes             = GridConfigurationRootNode.Select(SortColumnExp);
                    while (GridColumnNodes.MoveNext())
                    {
                        FieldInfo FieldInfoObj = new FieldInfo();
                        FieldInfoObj.name           = GridColumnNodes.Current.GetAttribute("name", "");
                        FieldInfoObj.type           = GridColumnNodes.Current.GetAttribute("type", "");
                        FieldInfoObj.fieldtype      = GridColumnNodes.Current.GetAttribute("fieldtype", "");
                        FieldInfoObj.editable       = GridColumnNodes.Current.GetAttribute("editable", "");
                        FieldInfoObj.showeditable   = GridColumnNodes.Current.GetAttribute("showeditable", "");
                        FieldInfoObj.treeddcache    = GridColumnNodes.Current.GetAttribute("columncaching", "");
                        FieldInfoObj.NHID           = GridColumnNodes.Current.GetAttribute("namedhierarchyid", "");
                        FieldInfoObj.TypeName       = GridColumnNodes.Current.GetAttribute("typename", "");
                        FieldInfoObj.RelationshipName = GridColumnNodes.Current.GetAttribute("relationshipname", "");
                        FieldInfoObj.CustomColumnType = GridColumnNodes.Current.GetAttribute("customcolumntype", "");

                        if (!FieldInfoCollection.Contains(GridColumnNodes.Current.GetAttribute("name", "")))
                            FieldInfoCollection.Add(GridColumnNodes.Current.GetAttribute("name", ""), FieldInfoObj);
                    }
                }
                #endregion

                ALTimeSheetGrid.ConfigXml = GridConfigurationXMLDoc.CreateNavigator().InnerXml;
                ALTimeSheetGrid.DataXml   = GenerateGridInputXML();
                ALTimeSheetGrid.Initialize();
            }
            
            //ActionBar
            ActBarXMLPath = ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "", "TimeSheets_SubmitTimeSheetActions");
            AB_TimeSheetActions.TenantName      = ALParamObj.TenantName;
            AB_TimeSheetActions.InputXMLType    = ActionBar.XMLType.XMLPath;
            AB_TimeSheetActions.InputXML        = ActBarXMLPath;
            AB_TimeSheetActions.Click += new EventHandler(AB_TimeSheetActionsList_Click);

            AB_TimeSheetActions.AddAttributes("Btn_Save", "href", "Javascript:DoSave('" + AB_TimeSheetActions.UniqueID + "$leftBtn_Save0')");
            AB_TimeSheetActions.AddAttributes("Btn_Submit", "href", "Javascript:DoSubmit('" + AB_TimeSheetActions.UniqueID + "$leftBtn_Submit1')");
            AB_TimeSheetActions.AddAttributes("Btn_CopyTimeSheet", "href", "Javascript:CopyTimeSheet('" + AB_TimeSheetActions.UniqueID + "$leftBtn_CopyTimeSheet2','" + AB_TimeSheetActions.UniqueID + "$leftBtn_Save0')");
            AB_TimeSheetActions.AddAttributes("Btn_PasteTimeSheet", "href", "Javascript:" + PasteOptions.ShowPopupWindowJavascript);
            GridActionPanel.Visible = IsEditable;

            Page.ClientScript.RegisterStartupScript(typeof(String), "EnableButtons", "<script type='text/javascript'>SetActionButtionVisiblity('" + AB_TimeSheetActions.ClientID + "'," + PrepareActionButtonStateObj() + "); SetIsTimeSheetSavedValue("+ (String.IsNullOrEmpty(TimesheetID)? "false" : "true") +");</script>");

            FrmTimesheet.TenantName             = ALParamObj.TenantName;
            FrmTimesheet.InputXMLType           = Assetlink.CustomControls.Form.InputType.InnerXML;
            FrmTimesheet.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.XMLPath;
            FrmTimesheet.SolutionName           = ALParamObj.SolutionName;
        }

        private void PrepareGridData()
        {
            StringBuilder       sbSearchInput               = null;
            String              ContributorProjectsXml      = null;
            String              ContributorReSourceDefXml   = null;
            SearchConfiguration SearchObj                   = null;
            String              ErrorXML                    = null;
            String              AssociatedIdList            = null;
            String              FilterString                = null;
            String              FilterCombination           = null;
            ProjectDetails      ProjectDetailsObj           = null;


            #region Get Resoure Def Details
            #region search
            sbSearchInput = new StringBuilder(30);
            sbSearchInput.AppendFormat(@"<SEARCH>
                                            <TARGETOBJECT>RESOURCEDEF</TARGETOBJECT>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                            <SESSIONINFO SessionID='{0}' Language='{1}' TenantName='{2}' UserID='{3}'/>
                                            <TARGETENTITY>
                                                <FILTERLIST>
                                                    <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <EXPRESSION>USERID</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>
                                                        <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        <RELATIONSHIPNAME>RESOURCEDEF_USER</RELATIONSHIPNAME>
                                                    </FILTER>
                                                </FILTERLIST>
                                                <SELECTLIST>
                                                    <EXPRESSION>
                                                        <FIELDNAME>RESOURCEDEFID</FIELDNAME>
                                                        <ALIAS>RESOURCEDEFID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
		                                                <FIELDNAME>ISOBSOLETE</FIELDNAME>
		                                                <ALIAS>ISOBSOLETE</ALIAS>
	                                                </EXPRESSION>
                                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_SUNDAY</FIELDNAME>
					                                    <ALIAS>Sunday</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_MONDAY</FIELDNAME>
					                                    <ALIAS>Monday</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_TUESDAY</FIELDNAME>
					                                    <ALIAS>Tuesday</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_WEDNESDAY</FIELDNAME>
					                                    <ALIAS>Wednesday</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_THURSDAY</FIELDNAME>
					                                    <ALIAS>Thursday</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_FRIDAY</FIELDNAME>
					                                    <ALIAS>Friday</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>AVAIL_ON_SATURDAY</FIELDNAME>
					                                    <ALIAS>Saturday</ALIAS>
				                                    </EXPRESSION>
                                                </SELECTLIST>
                                                <RELATIONSHIP NAME='RESOURCECAT_RESOURCE'>
                                                    <SORTLIST>
							                            <SORTEXPRESSION>
								                            <SORTSEQUENCE>1</SORTSEQUENCE>
								                            <SORTORDER>ASC</SORTORDER>
								                            <COLUMNNAME>RESOURCECATNAME</COLUMNNAME>
							                            </SORTEXPRESSION>
						                            </SORTLIST>     
                                                    <SELECTLIST>
	                                                    <EXPRESSION>
		                                                    <FIELDNAME>RESOURCECATID</FIELDNAME>
		                                                    <ALIAS>RESOURCECATID</ALIAS>
	                                                    </EXPRESSION>
	                                                    <EXPRESSION>
		                                                    <FIELDNAME>RESOURCECATNAME</FIELDNAME>
		                                                    <ALIAS>RESOURCECATNAME</ALIAS>
	                                                    </EXPRESSION>
                                                        <EXPRESSION>
		                                                    <FIELDNAME>ISOBSOLETE</FIELDNAME>
		                                                    <ALIAS>ISOBSOLETE</ALIAS>
	                                                    </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>    
                                            </TARGETENTITY>
                                        </SEARCH>", ALParamObj.SessionID, ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID);

            SearchObj   = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            ErrorXML    = SearchObj.GetHierarchialData(sbSearchInput.ToString(), ref ContributorReSourceDefXml);
            #endregion

            #region Prepare Resource Categoty Data
            if (ErrorXML == null)
            {
                XPathDocument   ResourceDefXpathDoc     = new XPathDocument(new StringReader(ContributorReSourceDefXml));
                XPathNavigator  ResourceDefXpathDocRoot = ResourceDefXpathDoc.CreateNavigator().SelectSingleNode("RESOURCEDEFCOLLECTION/RESOURCEDEF");

                if (ResourceDefXpathDocRoot != null)
                {
                    ResourceDefObj = new ResourceDef(ResourceDefXpathDocRoot.SelectSingleNode("RESOURCEDEFID").Value, ResourceDefXpathDocRoot.SelectSingleNode("ISOBSOLETE").Value);
                    foreach (String Weekday in Weekdays)
                    {
                        XPathNavigator HoursAvailable = ResourceDefXpathDocRoot.SelectSingleNode(Weekday);
                        if (HoursAvailable != null && HoursAvailable.Value != "")
                            ResourceDefObj.AvailableHours[Weekday] = Convert.ToDouble(HoursAvailable.Value);
                        else
                            ResourceDefObj.AvailableHours[Weekday] = 0;
                    }

                    if (ResourceDefObj != null)
                        ResourceDefID = ResourceDefObj.ResourceDefID;

                    XPathNodeIterator ResourceCategoryIterator = ResourceDefXpathDocRoot.Select("RESOURCECAT_RESOURCE/RESOURCECAT");

                    #region Prepare ResourceCategory Details
                    while (ResourceCategoryIterator.MoveNext())
                    {
                        ResourceCategory ResourceCategoryObj = null;
                        String ResourceCategoryID = ResourceCategoryIterator.Current.SelectSingleNode("RESOURCECATID").Value;
                        if (!ResourceCategorysList.Contains(ResourceCategoryID))
                        {
                            ResourceCategoryObj = new ResourceCategory(ResourceCategoryID, ResourceCategoryIterator.Current.SelectSingleNode("RESOURCECATNAME").Value,
                                ResourceCategoryIterator.Current.SelectSingleNode("ISOBSOLETE").Value, ALParamObj.TenantName);
                            if (ResourceCategoryObj.IsObsolete)
                                ObsoleteResourceCategorysList.Add(ResourceCategoryID, ResourceCategoryObj);
                            else
                                ResourceCategorysList.Add(ResourceCategoryID, ResourceCategoryObj);
                        }
                    }
                    #endregion
                }
                else //User is not added in a resource def
                {
                    //String          URL             = null;
                    //String          ErrorMessage    = null;
                    //StringBuilder   URLBuilder      = new StringBuilder(1024);

                    //ErrorMessage = Assetlink.Localization.GetString("ALResource", ALParamObj.TenantName, "TS_Warning_User_isnotaddin_ResourceDef");
                    //URLBuilder.AppendFormat("/{0}/Common/ASPX/DefaultScene_DefaultPage.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID);
                    //ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, null, null, ErrorMessage, null, URLBuilder.ToString(), ref URL);

                    //try
                    //{
                    //    Response.Clear();
                    //    Response.ContentType = "text/plain";
                    //    Response.Redirect(URL, false);
                    //    Response.End();
                    //}
                    //catch(ThreadAbortException exc)
                    //{
                    //}
                }
            }
            else
                ShowErrorPage("ERR_RM_ErrorOccuredWhileGeneratingResourceCategoryDetails_Shared");
            #endregion
            #endregion

            #region Get the TimeSheet data
            GetTimeSheetData(TimeSheetForDateObj, false);

            #region Read the Resource Catgories associate with timesheet Items
            if (AssociatedResourceCategorysList != null)
            {
                foreach (String Key in AssociatedResourceCategorysList.Keys)
                {
                    ResourceCategory ResourceCategoryObj = (ResourceCategory)AssociatedResourceCategorysList[Key];
                    if (ResourceCategoryObj.IsObsolete)
                    {
                        if (ObsoleteResourceCategorysList[ResourceCategoryObj.ResourceCategoryID] == null)
                            ObsoleteResourceCategorysList.Add(ResourceCategoryObj.ResourceCategoryID, ResourceCategoryObj);
                    }
                    else
                    {
                        if (ResourceCategorysList[ResourceCategoryObj.ResourceCategoryID] == null)
                            ResourceCategorysList.Add(ResourceCategoryObj.ResourceCategoryID, ResourceCategoryObj);
                    }
                }
            }
            #endregion

            if (ResourceDefObj != null && ResourceCategorysList.Count == 0) //redirect to Error Screen
                ShowErrorPage("TS_NotaValideResource");
            
            /*if (ResourceDefObj != null)
            {
                //if the resource id Obsolete and Timesheet is not in edit mode consider the resource as user
                //if resource doesn't belong to non-Obsolete resource categories and Timesheet is not in edit mode consider the resource as user.
                //if ((ResourceDefObj.IsObsolete || ResourceCategorysList.Count == 0) && TimesheetID == null)
                if(ResourceDefObj.IsObsolete && TimesheetID == null)
                {
                    ResourceDefObj = null;
                    GetTimeSheetData(TimeSheetForDateObj, false);
                }
            }*/

            #endregion

            #region Get Contributor Projects

            ProjectDetailsObj = new ProjectDetails(OtherProjectID, Localization.GetString("ALResource", ALParamObj.TenantName, "OTHER_Shared"), "");
            if(!ProjectDetailsList.Contains(ProjectDetailsObj.ProjectID))
                ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);

            //Project dropdown list will be populated only if Timesheet is editable.
            if (IsEditable)
            {

                #region Search
                sbSearchInput = new StringBuilder(30);
                sbSearchInput.AppendFormat(@"<SEARCH>
                                                    <TARGETOBJECT>ACTIVITY</TARGETOBJECT>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <SESSIONINFO SessionID='{0}' Language='{1}' TenantName='{2}' UserID='{3}'/>
                                                    <TARGETENTITY>
	                                                    <SELECTLIST>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>ACTIVITYID</FIELDNAME>
	                                                            <ALIAS>ACTIVITYID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>STATUS</FIELDNAME>
	                                                            <ALIAS>STATUS</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>STARTDATE</FIELDNAME>
	                                                            <ALIAS>STARTDATE</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>DUEDATE</FIELDNAME>
	                                                            <ALIAS>DUEDATE</ALIAS>
                                                            </EXPRESSION>
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
	                                                            <FILTERID>1</FILTERID>
	                                                            <EXPRESSION>USERID</EXPRESSION>
	                                                            <OPERATOR>EQUALTO</OPERATOR>
	                                                            <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
	                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                            <RELATIONSHIPNAME>ACTIVITY_CONTRIBUTOR</RELATIONSHIPNAME>
                                                            </FILTER>
                                                            <FILTER>
	                                                            <FILTERID>2</FILTERID>
	                                                            <EXPRESSION>STATUS</EXPRESSION>
	                                                            <OPERATOR>IN</OPERATOR>
	                                                            <EXPRESSIONVALUE>('ACTIVE','COMPLETED','CANCELLED','ONHOLD')</EXPRESSIONVALUE>
	                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            </FILTER>
                                                        </FILTERLIST>
                                                        <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
		                                                    <SELECTLIST>
			                                                    <EXPRESSION>
				                                                    <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
				                                                    <ALIAS>WORKFLOWPROCESSID</ALIAS>
			                                                    </EXPRESSION>
                                                                <EXPRESSION>
					                                                <FIELDNAME>PROCESSNAME</FIELDNAME>
					                                                <ALIAS>PROCESSNAME</ALIAS>
				                                                </EXPRESSION>
		                                                    </SELECTLIST>
		                                                    <RELATIONSHIP NAME='DELIVERABLE_TASK' HIERARCHY='BOTTOMUP'>
			                                                    <SELECTLIST>
				                                                    <EXPRESSION>
					                                                    <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
					                                                    <ALIAS>WORKFLOWPROCESSID</ALIAS>
				                                                    </EXPRESSION>
			                                                    </SELECTLIST>
			                                                    <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
                                                                <FILTERLIST>
                                                                    <FILTER>
                                                                      <FILTERID>1</FILTERID>
                                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                                      <OPERATOR>IN</OPERATOR>
                                                                      <EXPRESSIONVALUE>('NEW','DRAFT','ACTIVE')</EXPRESSIONVALUE>
                                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                    </FILTER>
                                                                    <FILTER>
                                                                      <FILTERID>2</FILTERID>
                                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                                      <EXPRESSIONVALUE>ONHOLD</EXPRESSIONVALUE>
                                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                    </FILTER>
                                                                    <FILTER>
                                                                      <FILTERID>3</FILTERID>
                                                                      <EXPRESSION>DUEDATE</EXPRESSION>
                                                                      <OPERATOR>INRANGE</OPERATOR>
                                                                      <EXPRESSIONVALUE>
                                                                            <VALUE Order='1'>{6}</VALUE>
                                                                            <VALUE Order='2'>{4}</VALUE>
                                                                      </EXPRESSIONVALUE>
                                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                    </FILTER>
                                                                    <FILTER>
                                                                      <FILTERID>4</FILTERID>
                                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                                      <OPERATOR>IN</OPERATOR>
                                                                      <EXPRESSIONVALUE>('COMPLETED','CANCELLED')</EXPRESSIONVALUE>
                                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                    </FILTER>
                                                                    <FILTER>
                                                                      <FILTERID>5</FILTERID>
                                                                      <EXPRESSION>ACTUALENDDATE</EXPRESSION>
                                                                      <OPERATOR>INRANGE</OPERATOR>
                                                                      <EXPRESSIONVALUE>
                                                                            <VALUE Order='1'>{5}</VALUE>
                                                                            <VALUE Order='2'>{6}</VALUE>
                                                                      </EXPRESSIONVALUE>
                                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                    </FILTER>
                                                                    <FILTER>
                                                                      <FILTERID>6</FILTERID>
                                                                      <EXPRESSION>WORKFLOWCATEGORY</EXPRESSION>
                                                                      <OPERATOR>IN</OPERATOR>
                                                                      <EXPRESSIONVALUE>('PROJECT','DELIVERABLE','TASK')</EXPRESSIONVALUE>
                                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                      <RELATIONSHIPNAME>WORKFLOWPROCESS_WORKFLOWINFORMATION</RELATIONSHIPNAME>
                                                                    </FILTER>
                                                                    <FILTERCOMBINATION>( ((1) OR ((2) AND (3)) OR ((4) AND (5))) AND (6)  )</FILTERCOMBINATION>
                                                                  </FILTERLIST>
				                                                <SELECTLIST>
					                                                <EXPRESSION>
						                                                <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
						                                                <ALIAS>WORKFLOWPROCESSID</ALIAS>
					                                                </EXPRESSION>
					                                                <EXPRESSION>
						                                                <FIELDNAME>PROCESSNAME</FIELDNAME>
						                                                <ALIAS>PROCESSNAME</ALIAS>
					                                                </EXPRESSION>
                                                                    <EXPRESSION>
						                                                <FIELDNAME>WORKFLOWPROCESSUNIQUEID</FIELDNAME>
						                                                <ALIAS>WORKFLOWPROCESSUNIQUEID</ALIAS>
					                                                </EXPRESSION>
				                                                </SELECTLIST>
			                                                </RELATIONSHIP>
		                                                    </RELATIONSHIP>
	                                                    </RELATIONSHIP>
                                                    </TARGETENTITY>
                                                </SEARCH>", ALParamObj.SessionID, ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ConvertStringToDateXML(TimeSheetForDateObj.AddMonths(3), false), ConvertStringToDateXML(TimeSheetForDateObj.AddMonths(-1), false), ConvertStringToDateXML(TimeSheetForDateObj, false));

                SearchObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXML = SearchObj.GetHierarchialData(sbSearchInput.ToString(), ref ContributorProjectsXml);
                #endregion

                #region Prepare data
                if (ErrorXML == null)
                {
                    XPathDocument ContibutorProjectsXPathDoc = new XPathDocument(new StringReader(ContributorProjectsXml));
                    XPathNavigator ContibutorProjectsXPathDocRoot = ContibutorProjectsXPathDoc.CreateNavigator();

                    XPathExpression SelectExpression = ContibutorProjectsXPathDocRoot.Compile("ACTIVITYCOLLECTION/ACTIVITY");
                    SelectExpression.AddSort("PROCESS_ACTIVITY/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/WORKFLOWPROCESSUNIQUEID", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    XPathNodeIterator ActivityListIterator = ContibutorProjectsXPathDocRoot.Select(SelectExpression);

                    //XPathNodeIterator ActivityListIterator = ContibutorProjectsXPathDocRoot.Select("ACTIVITYCOLLECTION/ACTIVITY");

                    //ProjectDetailsObj = new ProjectDetails(OtherProjectID, Localization.GetString("ALResource", ALParamObj.TenantName, "OTHER_Shared"), ""); 
                    //ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);

                    while (ActivityListIterator.MoveNext())
                    {
                        #region Prepare Project Details
                        XPathNodeIterator ContibutorProjectsIterator = ActivityListIterator.Current.Select("PROCESS_ACTIVITY/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS");

                        while (ContibutorProjectsIterator.MoveNext())
                        {
                            String ProjectID = ContibutorProjectsIterator.Current.SelectSingleNode("WORKFLOWPROCESSID").Value;
                            if (!ProjectDetailsList.Contains(ProjectID))
                            {
                                ProjectDetailsObj = new ProjectDetails(ProjectID, ContibutorProjectsIterator.Current.SelectSingleNode("WORKFLOWPROCESSUNIQUEID").Value, ContibutorProjectsIterator.Current.SelectSingleNode("PROCESSNAME").Value);
                                ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);
                            }
                        }
                        #endregion
                    }

                    foreach (String k in TimeSheetDataRows.Keys)
                    {
                        TimeSheetItemRow tmpRow = (TimeSheetItemRow)TimeSheetDataRows[k];

                        if ((tmpRow.Get("PROJECTID") != OtherProjectID) && (tmpRow.Get("PROJECTID") != "DELETED PROJECT"))
                            AssociatedIdList += tmpRow.Get("PROJECTID") + ",";
                    }

                    if (!String.IsNullOrEmpty(AssociatedIdList))
                    {
                        AssociatedIdList = AssociatedIdList.Substring(0, AssociatedIdList.Length - 1);

                        FilterString = @"<FILTER>
                                      <FILTERID>7</FILTERID>
                                      <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
                                      <OPERATOR>IN</OPERATOR>
                                      <EXPRESSIONVALUE>(" + AssociatedIdList + @")</EXPRESSIONVALUE>
                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                </FILTER>";

                        FilterCombination = "<FILTERCOMBINATION>( ((1) OR ((2) AND (3)) OR ((4) AND (5)) OR (7) ) AND (6)  )</FILTERCOMBINATION>";
                    }
                    else
                    {
                        FilterString = "";
                        FilterCombination = "<FILTERCOMBINATION>( ((1) OR ((2) AND (3)) OR ((4) AND (5))) AND (6)  )</FILTERCOMBINATION>";
                    }

                    #region Prepare data for APM,DM and Complete Access users, Complete Access Group and Readers Users & Groups

                    #region Search XML
                    sbSearchInput = new StringBuilder(30);
                    sbSearchInput.AppendFormat(@"<SEARCH>
                                              <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                              <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                              <SEARCHALLFACETS>FALSE</SEARCHALLFACETS>
                                              <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                              <SESSIONINFO SessionID='{0}' Language='{1}' TenantName='{2}' UserID='{3}'/>
                                              <TARGETENTITY>
                                                <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                <SELECTLIST>
                                                  <EXPRESSION>
                                                    <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                    <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                    <ALIAS>PROCESSNAME</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>WORKFLOWPROCESSUNIQUEID</FIELDNAME>
                                                    <ALIAS>WORKFLOWPROCESSUNIQUEID</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>STATUS</FIELDNAME>
                                                    <ALIAS>STATUS</ALIAS>
                                                  </EXPRESSION>
                                                </SELECTLIST>
                                                <FILTERLIST>
                                                    <FILTER>
                                                      <FILTERID>1</FILTERID>
                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                      <OPERATOR>IN</OPERATOR>
                                                      <EXPRESSIONVALUE>('NEW','DRAFT','ACTIVE')</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                      <FILTERID>2</FILTERID>
                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>ONHOLD</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                      <FILTERID>3</FILTERID>
                                                      <EXPRESSION>DUEDATE</EXPRESSION>
                                                      <OPERATOR>INRANGE</OPERATOR>
                                                      <EXPRESSIONVALUE>
                                                            <VALUE Order='1'>{6}</VALUE>
                                                            <VALUE Order='2'>{4}</VALUE>
                                                      </EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                      <FILTERID>4</FILTERID>
                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                      <OPERATOR>IN</OPERATOR>
                                                      <EXPRESSIONVALUE>('COMPLETED','CANCELLED')</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                      <FILTERID>5</FILTERID>
                                                      <EXPRESSION>ACTUALENDDATE</EXPRESSION>
                                                      <OPERATOR>INRANGE</OPERATOR>
                                                      <EXPRESSIONVALUE>
                                                            <VALUE Order='1'>{5}</VALUE>
                                                            <VALUE Order='2'>{6}</VALUE>
                                                      </EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                      <FILTERID>6</FILTERID>
                                                      <EXPRESSION>WORKFLOWCATEGORY</EXPRESSION>
                                                      <OPERATOR>IN</OPERATOR>
                                                      <EXPRESSIONVALUE>('PROJECT','DELIVERABLE','TASK')</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <RELATIONSHIPNAME>WORKFLOWPROCESS_WORKFLOWINFORMATION</RELATIONSHIPNAME>
                                                    </FILTER>
                                                    {7}
                                                    {8}
                                                  </FILTERLIST>
                                                <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
                                                    <SELECTLIST>
                                                      <EXPRESSION>
                                                        <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                        <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                        <ALIAS>PROCESSNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>WORKFLOWPROCESSUNIQUEID</FIELDNAME>
                                                        <ALIAS>WORKFLOWPROCESSUNIQUEID</ALIAS>
                                                      </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='DELIVERABLE_TASK' HIERARCHY='BOTTOMUP'>
                                                    <SELECTLIST>
                                                      <EXPRESSION>
                                                        <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                        <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                        <ALIAS>PROCESSNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>WORKFLOWPROCESSUNIQUEID</FIELDNAME>
                                                        <ALIAS>WORKFLOWPROCESSUNIQUEID</ALIAS>
                                                      </EXPRESSION>
                                                    </SELECTLIST>
                                                    <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
                                                        <SELECTLIST>
                                                          <EXPRESSION>
                                                            <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                            <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                          </EXPRESSION>
                                                          <EXPRESSION>
                                                            <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                            <ALIAS>PROCESSNAME</ALIAS>
                                                          </EXPRESSION>
                                                          <EXPRESSION>
                                                            <FIELDNAME>WORKFLOWPROCESSUNIQUEID</FIELDNAME>
                                                            <ALIAS>WORKFLOWPROCESSUNIQUEID</ALIAS>
                                                          </EXPRESSION>
                                                        </SELECTLIST>
                                                    </RELATIONSHIP>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
                                                  <SELECTLIST>
                                                    <EXPRESSION>
                                                      <FIELDNAME>USERID</FIELDNAME>
                                                      <ALIAS>USERID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LOGINNAME</FIELDNAME>
                                                      <ALIAS>LOGINNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                      <ALIAS>FIRSTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                      <ALIAS>MIDDLEINITIAL</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LASTNAME</FIELDNAME>
                                                      <ALIAS>LASTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>EMAILID</FIELDNAME>
                                                      <ALIAS>EMAILID</ALIAS>
                                                    </EXPRESSION>
                                                  </SELECTLIST>
                                                  <FILTERLIST>
                                                    <FILTER>
                                                      <EXPRESSION>USERID</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <FILTERID>1</FILTERID>
                                                    </FILTER>
                                                  </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROJECTMANAGER'>
                                                  <SELECTLIST>
                                                    <EXPRESSION>
                                                      <FIELDNAME>USERID</FIELDNAME>
                                                      <ALIAS>USERID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LOGINNAME</FIELDNAME>
                                                      <ALIAS>LOGINNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                      <ALIAS>FIRSTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                      <ALIAS>MIDDLEINITIAL</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LASTNAME</FIELDNAME>
                                                      <ALIAS>LASTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>EMAILID</FIELDNAME>
                                                      <ALIAS>EMAILID</ALIAS>
                                                    </EXPRESSION>
                                                  </SELECTLIST>
                                                  <FILTERLIST>
                                                    <FILTER>
                                                      <EXPRESSION>USERID</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <FILTERID>1</FILTERID>
                                                    </FILTER>
                                                  </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='DELIVERABLEMANAGER'>
                                                  <SELECTLIST>
                                                    <EXPRESSION>
                                                      <FIELDNAME>USERID</FIELDNAME>
                                                      <ALIAS>USERID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LOGINNAME</FIELDNAME>
                                                      <ALIAS>LOGINNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                      <ALIAS>FIRSTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                      <ALIAS>MIDDLEINITIAL</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LASTNAME</FIELDNAME>
                                                      <ALIAS>LASTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>EMAILID</FIELDNAME>
                                                      <ALIAS>EMAILID</ALIAS>
                                                    </EXPRESSION>
                                                  </SELECTLIST>
                                                  <FILTERLIST>
                                                    <FILTER>
                                                      <EXPRESSION>USERID</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <FILTERID>1</FILTERID>
                                                    </FILTER>
                                                  </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROCESSCOMPLETEACCESS_GROUP'>
                                                  <SELECTLIST>
                                                    <EXPRESSION>
                                                      <FIELDNAME>GROUPID</FIELDNAME>
                                                      <ALIAS>GROUPID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>GROUPNAME</FIELDNAME>
                                                      <ALIAS>GROUPNAME</ALIAS>
                                                    </EXPRESSION>
                                                  </SELECTLIST>
                                                  <RELATIONSHIP NAME='GROUP_MEMBERUSER'>
                                                    <SELECTLIST>
                                                      <EXPRESSION>
                                                        <FIELDNAME>USERID</FIELDNAME>
                                                        <ALIAS>USERID</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                        <ALIAS>FIRSTNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                        <ALIAS>MIDDLEINITIAL</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>LASTNAME</FIELDNAME>
                                                        <ALIAS>LASTNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>LOGINNAME</FIELDNAME>
                                                        <ALIAS>LOGINNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>EMAILID</FIELDNAME>
                                                        <ALIAS>EMAILID</ALIAS>
                                                      </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
                                                      <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <EXPRESSION>STATUS</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>
                                                        <EXPRESSIONVALUE>Active</EXPRESSIONVALUE>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      </FILTER>
                                                      <FILTER>
                                                      <EXPRESSION>USERID</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <FILTERID>2</FILTERID>
                                                    </FILTER>
                                                    <FILTERCOMBINATION>((1)AND(2))</FILTERCOMBINATION>
                                                    </FILTERLIST>
                                                  </RELATIONSHIP>
                                                  <FILTERLIST>
                                                    <FILTER>
                                                      <FILTERID>1</FILTERID>
                                                      <EXPRESSION>ISDELETED</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                  </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROCESSCOMPLETEACCESS_USER'>
                                                  <SELECTLIST>
                                                    <EXPRESSION>
                                                      <FIELDNAME>USERID</FIELDNAME>
                                                      <ALIAS>USERID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                      <ALIAS>FIRSTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                      <ALIAS>MIDDLEINITIAL</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LASTNAME</FIELDNAME>
                                                      <ALIAS>LASTNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>LOGINNAME</FIELDNAME>
                                                      <ALIAS>LOGINNAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                      <FIELDNAME>EMAILID</FIELDNAME>
                                                      <ALIAS>EMAILID</ALIAS>
                                                    </EXPRESSION>
                                                  </SELECTLIST>
                                                  <FILTERLIST>
                                                    <FILTER>
                                                      <EXPRESSION>STATUS</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>Active</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                      <EXPRESSION>USERID</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <FILTERID>1</FILTERID>
                                                    </FILTER>
                                                  </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='READERS'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                          <FIELDNAME>USERID</FIELDNAME>
                                                          <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>LOGINNAME</FIELDNAME>
                                                          <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                          <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                          <ALIAS>MIDDLEINITIAL</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>LASTNAME</FIELDNAME>
                                                          <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>EMAILID</FIELDNAME>
                                                          <ALIAS>EMAILID</ALIAS>
                                                        </EXPRESSION>
                                                  </SELECTLIST>
                                                  <FILTERLIST>
                                                    <FILTER>
                                                      <EXPRESSION>USERID</EXPRESSION>
                                                      <OPERATOR>EQUALTO</OPERATOR>
                                                      <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                      <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                      <FILTERID>1</FILTERID>
                                                    </FILTER>
                                                  </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROCESSREADER_GROUPS'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>GROUPID</FIELDNAME>
                                                            <ALIAS>GROUPID</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>GROUPNAME</FIELDNAME>
                                                            <ALIAS>GROUPNAME</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
                                                        <FILTER>
                                                            <EXPRESSION>ISDELETED</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </RELATIONSHIP> 
                                              </TARGETENTITY>
                                            </SEARCH>", ALParamObj.SessionID, ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ConvertStringToDateXML(TimeSheetForDateObj.AddMonths(3), false), ConvertStringToDateXML(TimeSheetForDateObj.AddMonths(-1), false), ConvertStringToDateXML(TimeSheetForDateObj, false), FilterString, FilterCombination);
                    #endregion

                    SearchObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXML = SearchObj.GetHierarchialData(sbSearchInput.ToString(), ref ContributorProjectsXml);

                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        ContibutorProjectsXPathDoc = new XPathDocument(new StringReader(ContributorProjectsXml));
                        ContibutorProjectsXPathDocRoot = ContibutorProjectsXPathDoc.CreateNavigator();
                        SelectExpression = ContibutorProjectsXPathDocRoot.Compile("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS");
                        SelectExpression.AddSort("WORKFLOWPROCESSUNIQUEID", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);

                        XPathNodeIterator WorkflowProcessIterator = ContibutorProjectsXPathDocRoot.Select(SelectExpression);
                        String ProjectID = null;
                        String ProjectName = null;
                        String ProjectUniqueID = null;
                        MktgWorkBenchFacadeClass MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                        while (WorkflowProcessIterator.MoveNext())
                        {
                            ProjectDetailsObj = null;

                            //Logged in user is Project Manager
                            if (WorkflowProcessIterator.Current.SelectSingleNode("PROJECTMANAGER") != null)
                            {
                                ProjectID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSID").Value;
                                ProjectName = WorkflowProcessIterator.Current.SelectSingleNode("PROCESSNAME").Value;
                                ProjectUniqueID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSUNIQUEID").Value;
                                ProjectDetailsObj = new ProjectDetails(ProjectID, ProjectUniqueID, ProjectName);

                                if (!ProjectDetailsList.Contains(ProjectDetailsObj.ProjectID))
                                    ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);
                            }

                            //Logged in user is Acting Project Manager
                            if (WorkflowProcessIterator.Current.SelectSingleNode("ACTINGPROJECTMANAGER") != null)
                            {
                                ProjectID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSID").Value;
                                ProjectName = WorkflowProcessIterator.Current.SelectSingleNode("PROCESSNAME").Value;
                                ProjectUniqueID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSUNIQUEID").Value;
                                ProjectDetailsObj = new ProjectDetails(ProjectID, ProjectUniqueID, ProjectName);

                                if (!ProjectDetailsList.Contains(ProjectDetailsObj.ProjectID))
                                    ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);
                            }

                            if(MWBFacadeObj.isUserFromProjectCompleteAccessUserGroup(ALParamObj.UserID, WorkflowProcessIterator.Current))
                            {
                                //Logged in user belongs to complete access group
                                ProjectID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSID").Value;
                                ProjectName = WorkflowProcessIterator.Current.SelectSingleNode("PROCESSNAME").Value;
                                ProjectUniqueID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSUNIQUEID").Value;
                                ProjectDetailsObj = new ProjectDetails(ProjectID, ProjectUniqueID, ProjectName);

                                if (!ProjectDetailsList.Contains(ProjectDetailsObj.ProjectID))
                                    ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);
                            }

                            //Logged in user is Deliverable Manager
                            if (WorkflowProcessIterator.Current.SelectSingleNode("DELIVERABLEMANAGER") != null)
                            {
                                if (WorkflowProcessIterator.Current.SelectSingleNode("PROJECT_DELIVERABLE") != null)
                                {
                                    ProjectID = WorkflowProcessIterator.Current.SelectSingleNode("PROJECT_DELIVERABLE/WORKFLOWPROCESS/WORKFLOWPROCESSID").Value;
                                    ProjectName = WorkflowProcessIterator.Current.SelectSingleNode("PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROCESSNAME").Value;
                                    ProjectUniqueID = WorkflowProcessIterator.Current.SelectSingleNode("PROJECT_DELIVERABLE/WORKFLOWPROCESS/WORKFLOWPROCESSUNIQUEID").Value;
                                    ProjectDetailsObj = new ProjectDetails(ProjectID, ProjectUniqueID, ProjectName);

                                    if (!ProjectDetailsList.Contains(ProjectDetailsObj.ProjectID))
                                        ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);
                                }
                            }

                            // Logged in user is Project or Task Reader 
                            if (MWBFacadeObj.isUserFromProcessReadersUserGroup(ALParamObj.UserID, WorkflowProcessIterator.Current))
                            {

                                if (WorkflowProcessIterator.Current.SelectSingleNode("DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS") != null)
                                {
                                    //Display the project in dropdown only if logged in user is Task reader and Task status is not "New" and "Draft"
                                    if( (WorkflowProcessIterator.Current.SelectSingleNode("STATUS").Value.ToUpper() != "NEW") &&
                                        (WorkflowProcessIterator.Current.SelectSingleNode("STATUS").Value.ToUpper() != "DRAFT") )
                                    {
                                        ProjectID = WorkflowProcessIterator.Current.SelectSingleNode("DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/WORKFLOWPROCESSID").Value;
                                        ProjectName = WorkflowProcessIterator.Current.SelectSingleNode("DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROCESSNAME").Value;
                                        ProjectUniqueID = WorkflowProcessIterator.Current.SelectSingleNode("DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/WORKFLOWPROCESSUNIQUEID").Value;
                                        ProjectDetailsObj = new ProjectDetails(ProjectID, ProjectUniqueID, ProjectName);
                                    }
                                }
                                else
                                {
                                    //LoggedIn user is project reader
                                    ProjectID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSID").Value;
                                    ProjectName = WorkflowProcessIterator.Current.SelectSingleNode("PROCESSNAME").Value;
                                    ProjectUniqueID = WorkflowProcessIterator.Current.SelectSingleNode("WORKFLOWPROCESSUNIQUEID").Value;
                                    ProjectDetailsObj = new ProjectDetails(ProjectID, ProjectUniqueID, ProjectName);
                                }

                                if (ProjectDetailsObj != null)
                                {
                                    if (!ProjectDetailsList.Contains(ProjectDetailsObj.ProjectID))
                                        ProjectDetailsList.Add(ProjectDetailsObj.ProjectID, ProjectDetailsObj);
                                }
                            }
                        }
                    }
                    else
                        ShowErrorPage("ERR_TS_ErrorFetchResourceProjects");
                    #endregion
                }
                else
                    ShowErrorPage("ERR_TS_ErrorFetchResourceProjects");
                ProjectDetailsList = SortProjectIDList(ProjectDetailsList);
                #endregion
            }
            #endregion
        }

        private OrderedDictionary SortProjectIDList(OrderedDictionary ProjDetailsList)
        {
            ProjectDetails      CurObj                      = null;
            ArrayList           ProcUniqueIdList            = null;
            IEnumerator         keyEnum                     = null;
            IEnumerator         listEnum                    = null;
            OrderedDictionary   TmpDic                      = null;

            //Array is sorted if size is 1
            if (ProjDetailsList.Count <= 1)
                return ProjDetailsList;

            ProcUniqueIdList    = new ArrayList();
            TmpDic              = new OrderedDictionary();
            keyEnum             = ProjDetailsList.Keys.GetEnumerator();

            while (keyEnum.MoveNext())
            {
                CurObj = (ProjectDetails)ProjDetailsList[keyEnum.Current.ToString()];
                ProcUniqueIdList.Add(CurObj.ProjectCode);
            }

            if (ProcUniqueIdList.Count > 0)
                ProcUniqueIdList.Sort();

            listEnum = ProcUniqueIdList.GetEnumerator();

            while (listEnum.MoveNext())
            {
                keyEnum = ProjDetailsList.Keys.GetEnumerator();

                while (keyEnum.MoveNext())
                {
                    CurObj = (ProjectDetails)ProjDetailsList[keyEnum.Current.ToString()];
                    if (listEnum.Current.ToString() == CurObj.ProjectCode)
                    {
                        TmpDic.Add(CurObj.ProjectID, CurObj);
                        break;
                    }
                }
            }
            return TmpDic;
        }

        private String getInsertRowPosition()
        {
            OrderedDictionary TmpDic = new OrderedDictionary();
            String LastEditedTimeSheetItemID = null;

            //Traverse through all the rows in the dictionary and indentify which row is last edited.
            foreach (String TimeSheetItemID in TimeSheetDataRows.Keys)
            {
                TimeSheetItemRow TimeSheetItemRowObj = (TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemID];
                Boolean OtherColumnValuesAreEmpty = true;

                foreach (String ColumnName in FieldInfoCollection.Keys)
                {
                    String ColumnValue = "";
                    ColumnValue = TimeSheetItemRowObj.Get(ColumnName);

                    if (!String.IsNullOrEmpty(ColumnValue))
                    {
                        if (ColumnName == "UTILIZATION")
                        {
                            if (ColumnValue == "0" && OtherColumnValuesAreEmpty == true)
                            {
                                //do nothing as this row is empty
                            }
                            else
                            {
                                OtherColumnValuesAreEmpty = false;
                                if (!PastedTSId.Contains(TimeSheetItemID))
                                {
                                    LastEditedTimeSheetItemID = TimeSheetItemID;
                                    //break;
                                }
                            }
                        }
                        else
                        {
                            if (!PastedTSId.Contains(TimeSheetItemID))
                            {
                                LastEditedTimeSheetItemID = TimeSheetItemID;
                                //break;
                            }
                        }
                    }
                    else
                        OtherColumnValuesAreEmpty = true;
                }
            }

            //If all the rows are empty then copied rows will get added at start.
            if (LastEditedTimeSheetItemID == null)
            {
                String[] IDList = PastedTSId.Split(new String[] { "," }, StringSplitOptions.RemoveEmptyEntries);

                foreach (String ID in IDList)
                {
                    TimeSheetItemRow TimeSheetItemRowObj2 = (TimeSheetItemRow)TimeSheetDataRows[ID];

                    if (!TmpDic.Contains(ID))
                        TmpDic.Add(ID, TimeSheetItemRowObj2);
                }
            }


            //Again traverse through all rows and insert all the rows till last edited rows. Insert last edited row
            //then insert the rows that are copied from other timesheet and then add remaining empty rows.
            foreach (String TimeSheetItemID in TimeSheetDataRows.Keys)
            {
                TimeSheetItemRow TimeSheetItemRowObj1 = (TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemID];

                if (TimeSheetItemID == LastEditedTimeSheetItemID)
                {
                    if (!TmpDic.Contains(TimeSheetItemID))
                        TmpDic.Add(TimeSheetItemID, TimeSheetItemRowObj1);

                    String[] IDList = PastedTSId.Split(new String[] { "," }, StringSplitOptions.RemoveEmptyEntries);

                    foreach (String ID in IDList)
                    {
                        TimeSheetItemRowObj1 = (TimeSheetItemRow)TimeSheetDataRows[ID];

                        if (!TmpDic.Contains(ID))
                            TmpDic.Add(ID, TimeSheetItemRowObj1);
                    }
                }
                else
                {
                    if (!TmpDic.Contains(TimeSheetItemID))
                    {
                        TmpDic.Add(TimeSheetItemID, TimeSheetItemRowObj1);
                    }
                }
            }

            TimeSheetDataRows = TmpDic;

            return null;
        }

        private void GetTimeSheetData(DateTime FectTimeSheetForDate, Boolean IsCopyPaste)
        {
            StringBuilder       sbSearchInput               = null;
            StringBuilder       sbTimesheetFieldtoGet       = null;          
            String              TimeSheetXml                = null;
            SearchConfiguration SearchObj                   = null;
            String              ErrorXML                    = null;
            String              SearchInput                 = null;
            ProjectDetails      ProjectDetailsObj           = null;
            FrmTimesheet.Visible                            = false;
            PastedTSId                                      = null;

            #region Search
            sbTimesheetFieldtoGet           = new StringBuilder(1024);
            AssociatedResourceCategorysList = new OrderedDictionary();

            foreach (String Day in TimeSheetDaysList)
                sbTimesheetFieldtoGet.AppendFormat("<EXPRESSION><FIELDNAME>{0}</FIELDNAME><ALIAS>{0}</ALIAS></EXPRESSION>", Day);

            sbSearchInput = new StringBuilder(30);
            sbSearchInput.AppendFormat(@"<SEARCH>
                                          <TARGETOBJECT>TIMESHEET</TARGETOBJECT>
                                          <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                          <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                          <SESSIONINFO SessionID='{0}' Language='{1}' TenantName='{2}' UserID='{3}'/>
                                          <TARGETENTITY>
                                                <FILTERLIST>
                                                    <FILTER>
                                                            <FILTERID>1</FILTERID>
                                                            <EXPRESSION>FROMTIMESHEETDATE</EXPRESSION>
                                                            <OPERATOR>LESSTHANEQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE><VALUE>{4}</VALUE></EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                            <FILTERID>2</FILTERID>
                                                            <EXPRESSION>TOTIMESHEETDATE</EXPRESSION>
                                                            <OPERATOR>GREATERTHANEQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE><VALUE>{4}</VALUE></EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                            <FILTERID>3</FILTERID>
                                                            <EXPRESSION>ISDAILY</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>{5}</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                    <FILTER>
                                                            <FILTERID>4</FILTERID>
                                                            <EXPRESSION>USERID</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            <RELATIONSHIPNAME>TM_CREATEDBY_USER</RELATIONSHIPNAME>
                                                    </FILTER>", ALParamObj.SessionID, ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ConvertStringToDateXML(FectTimeSheetForDate, false), TimeSheetMode == TimesheetModeDaily ? "1" : "0");

                    if (ResourceDefID != null)
                    {
                        sbSearchInput.AppendFormat(@"<FILTER>
                                                            <FILTERID>5</FILTERID>
                                                            <EXPRESSION>RESOURCEDEFID</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>" + ResourceDefID + @"</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            <RELATIONSHIPNAME>TM_CREATEDBY</RELATIONSHIPNAME>
                                                    </FILTER>
                                                    <FILTERCOMBINATION>((1) AND (2) AND (3) AND ((4) OR (5)))</FILTERCOMBINATION>");
                    }
           
                         sbSearchInput.AppendFormat(@"
                                                </FILTERLIST> 
                                                <RELATIONSHIP NAME='TM_ITEM'>  
	                                                <SORTLIST>
							                            <SORTEXPRESSION>
								                            <SORTSEQUENCE>1</SORTSEQUENCE>
								                            <SORTORDER>ASC</SORTORDER>
								                            <COLUMNNAME>ITEMORDER</COLUMNNAME>
							                            </SORTEXPRESSION>
						                            </SORTLIST>     
                                                    <SELECTLIST>
                                                          <EXPRESSION>
                                                                <FIELDNAME>TIMESHEETITEMSID</FIELDNAME>
                                                                <ALIAS>TIMESHEETITEMSID</ALIAS>
                                                          </EXPRESSION>
                                                          <EXPRESSION>
                                                                <FIELDNAME>UNIT_OF_MEASURE</FIELDNAME>
                                                                <ALIAS>UNIT_OF_MEASURE</ALIAS>
                                                          </EXPRESSION>
                                                          <EXPRESSION>
                                                                <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                                <ALIAS>DESCRIPTION</ALIAS>
                                                          </EXPRESSION>
                                                          <EXPRESSION>
                                                                <FIELDNAME>MISC_TASK</FIELDNAME>
                                                                <ALIAS>MISC_TASK</ALIAS>
                                                          </EXPRESSION>
                                                          <EXPRESSION>
                                                                <FIELDNAME>ITEMORDER</FIELDNAME>
                                                                <ALIAS>ITEMORDER</ALIAS>
                                                          </EXPRESSION>
                                                           {0}
                                                    </SELECTLIST>
                                                    <RELATIONSHIP NAME='TM_WORKFLOWPROCESS'>
                                                        <SELECTLIST>
                                                              <EXPRESSION>
                                                                    <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                                    <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                              </EXPRESSION>
                                                              <EXPRESSION>
                                                                    <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                                    <ALIAS>PROCESSNAME</ALIAS>
                                                              </EXPRESSION>
                                                              <EXPRESSION>
                                                                    <FIELDNAME>WORKFLOWPROCESSUNIQUEID</FIELDNAME>
                                                                    <ALIAS>WORKFLOWPROCESSUNIQUEID</ALIAS>
                                                              </EXPRESSION>
                                                        </SELECTLIST>
                                                    </RELATIONSHIP>
                                                    <RELATIONSHIP NAME='TMITEM_RESCAT'>
                                                        <SELECTLIST>
                                                              <EXPRESSION>
                                                                    <FIELDNAME>RESOURCECATID</FIELDNAME>
                                                                    <ALIAS>RESOURCECATID</ALIAS>
                                                              </EXPRESSION>
                                                              <EXPRESSION>
                                                                    <FIELDNAME>RESOURCECATNAME</FIELDNAME>
                                                                    <ALIAS>RESOURCECATNAME</ALIAS>
                                                              </EXPRESSION>
                                                              <EXPRESSION>
                                                                    <FIELDNAME>ISOBSOLETE</FIELDNAME>
                                                                    <ALIAS>ISOBSOLETE</ALIAS>
                                                              </EXPRESSION>
                                                        </SELECTLIST>
                                                    </RELATIONSHIP>
                                                </RELATIONSHIP>
                                                $AL$TM_REVIEWEDBY$AL$
                                            </TARGETENTITY>
                                        </SEARCH>", sbTimesheetFieldtoGet.ToString());

            if (IsCopyPaste)
                SearchInput = sbSearchInput.ToString().Replace("$AL$TM_REVIEWEDBY$AL$", "");
            else
                SearchInput = sbSearchInput.ToString().Replace("$AL$TM_REVIEWEDBY$AL$", @"<RELATIONSHIP NAME='TM_REVIEWEDBY'>
                                                                                                <SELECTLIST>
                                                                                                      <EXPRESSION>
                                                                                                            <FIELDNAME>USERID</FIELDNAME>
                                                                                                            <ALIAS>USERID</ALIAS>
                                                                                                      </EXPRESSION>
                                                                                                       <EXPRESSION>
                                                                                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                                                            <ALIAS>FIRSTNAME</ALIAS>
                                                                                                      </EXPRESSION>
                                                                                                      <EXPRESSION>
                                                                                                            <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
                                                                                                      </EXPRESSION>
                                                                                                       <EXPRESSION>
                                                                                                            <FIELDNAME>LASTNAME</FIELDNAME>
                                                                                                            <ALIAS>LASTNAME</ALIAS>
                                                                                                      </EXPRESSION>
                                                                                                      <EXPRESSION>
                                                                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                                                            <ALIAS>LOGINNAME</ALIAS>
                                                                                                      </EXPRESSION>
                                                                                                       <EXPRESSION>
                                                                                                            <FIELDNAME>EMAILID</FIELDNAME>
                                                                                                            <ALIAS>EMAILID</ALIAS>
                                                                                                      </EXPRESSION>
                                                                                                </SELECTLIST>
                                                                                            </RELATIONSHIP>");

            SearchObj   = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            ErrorXML    = SearchObj.GetHierarchialData(SearchInput, ref TimeSheetXml);
            #endregion

            #region Populate time sheet Item Data
            if (ErrorXML == null)
            {
                XPathDocument   TimeSheetXpathDoc       = new XPathDocument(new StringReader(TimeSheetXml));
                XPathNavigator  TimeSheetXpathDocRoot   = TimeSheetXpathDoc.CreateNavigator().SelectSingleNode("TIMESHEETCOLLECTION/TIMESHEET");
                String          TimeSheetItmeID         = null;

                if (TimeSheetXpathDocRoot != null)
                {
                    TimeSheetItemRow TimeSheetItemRowObj = null;

                    if (!IsCopyPaste)
                    {
                        TimesheetID     = TimeSheetXpathDocRoot.SelectSingleNode("TIMESHEETID").Value;
                        TimeSheetStatus = TimeSheetXpathDocRoot.SelectSingleNode("STATUS").Value;

                        if(TimeSheetXpathDocRoot.SelectSingleNode("TM_REVIEWEDBY/USER/USERID") != null)
                            TimesheetReviewedByUserID = TimeSheetXpathDocRoot.SelectSingleNode("TM_REVIEWEDBY/USER/USERID").Value;
                    }

                    if (TimeSheetStatus == "Draft" || TimeSheetStatus == "Rejected")
                        IsEditable = true;
                    else
                        IsEditable = false;

                    XPathNodeIterator TimeSheetItems = TimeSheetXpathDocRoot.Select("TM_ITEM/TIMESHEETITEMS");

                    while (TimeSheetItems.MoveNext())
                    {
                        #region Populate Timesheet Item data
                        TimeSheetItmeID = TimeSheetItems.Current.SelectSingleNode("TIMESHEETITEMSID").Value;
                        if (IsCopyPaste)
                        {
                            TimeSheetItemRowObj     = new TimeSheetItemRow(null, OperationCreate);
                            TimeSheetItmeID         = TimeSheetItemRowObj.TimeSheetItemID;
                            PastedTSId              += "," + TimeSheetItmeID;
                        }
                        else
                            TimeSheetItemRowObj = new TimeSheetItemRow(TimeSheetItmeID, OperationUpdate);

                        if (TimeSheetItems.Current.SelectSingleNode("TM_WORKFLOWPROCESS/WORKFLOWPROCESS/WORKFLOWPROCESSID") != null)
                            TimeSheetItemRowObj.Add("PROJECTID", TimeSheetItems.Current.SelectSingleNode("TM_WORKFLOWPROCESS/WORKFLOWPROCESS/WORKFLOWPROCESSID").Value);
                        else
                        if ((TimeSheetItems.Current.SelectSingleNode("MISC_TASK") != null) && (TimeSheetItems.Current.SelectSingleNode("MISC_TASK").Value == "1")) 
                            TimeSheetItemRowObj.Add("PROJECTID", OtherProjectID);
                        else
                            TimeSheetItemRowObj.Add("PROJECTID", DeletedProjectID);

                        if (TimeSheetItems.Current.SelectSingleNode("TM_WORKFLOWPROCESS/WORKFLOWPROCESS/PROCESSNAME") != null)
                            TimeSheetItemRowObj.Add("PROJECTNAME", TimeSheetItems.Current.SelectSingleNode("TM_WORKFLOWPROCESS/WORKFLOWPROCESS/PROCESSNAME").Value);
                        else
                        if(TimeSheetItemRowObj.Get("PROJECTID") == DeletedProjectID)
                            TimeSheetItemRowObj.Add("PROJECTNAME", Localization.GetString("ALResource", ALParamObj.TenantName, "TS_ProjectDeleted"));

                        if (TimeSheetItems.Current.SelectSingleNode("TM_WORKFLOWPROCESS/WORKFLOWPROCESS/WORKFLOWPROCESSUNIQUEID") != null)
                            TimeSheetItemRowObj.Add("PROJECTCODE", TimeSheetItems.Current.SelectSingleNode("TM_WORKFLOWPROCESS/WORKFLOWPROCESS/WORKFLOWPROCESSUNIQUEID").Value);
                        else
                        if (TimeSheetItemRowObj.Get("PROJECTID") == DeletedProjectID)
                            TimeSheetItemRowObj.Add("PROJECTCODE", Localization.GetString("ALResource", ALParamObj.TenantName, "TS_DeleteProject"));

                        if (TimeSheetItems.Current.SelectSingleNode("TMITEM_RESCAT/RESOURCECAT/RESOURCECATID") != null)
                        {
                            String ResourceCategoryID = TimeSheetItems.Current.SelectSingleNode("TMITEM_RESCAT/RESOURCECAT/RESOURCECATID").Value;
                            if (IsCopyPaste && ResourceDefObj == null)
                                TimeSheetItemRowObj.Add("RESOURCATEGORYID", "");
                            else
                                TimeSheetItemRowObj.Add("RESOURCATEGORYID", ResourceCategoryID);

                            #region Read Resource Category Details
                            ResourceCategory ResourceCategoryObj = new ResourceCategory(ResourceCategoryID, TimeSheetItems.Current.SelectSingleNode("TMITEM_RESCAT/RESOURCECAT/RESOURCECATNAME").Value,
                                   TimeSheetItems.Current.SelectSingleNode("TMITEM_RESCAT/RESOURCECAT/ISOBSOLETE").Value, ALParamObj.TenantName);
                            if (!AssociatedResourceCategorysList.Contains(ResourceCategoryID))
                                AssociatedResourceCategorysList.Add(ResourceCategoryID, ResourceCategoryObj);
                            #endregion

                            SourceListLayout = LayoutContributorList;
                        }
                        else
                        {
                            TimeSheetItemRowObj.Add("RESOURCATEGORYID", "");
                            SourceListLayout = LayoutNonContributorList;
                        }

                        if (TimeSheetItems.Current.SelectSingleNode("DESCRIPTION") != null)
                            TimeSheetItemRowObj.Add("DESCRIPTION", TimeSheetItems.Current.SelectSingleNode("DESCRIPTION").Value);
                        else
                            TimeSheetItemRowObj.Add("DESCRIPTION", "");

                        if (IsCopyPaste)
                        {
                            foreach (String Day in TimeSheetDaysList)
                                TimeSheetItemRowObj.Add(Day, "0");
                        }
                        else
                        {
                            foreach (String Day in TimeSheetDaysList)
                            {
                                if (TimeSheetItems.Current.SelectSingleNode(Day) != null)
                                    TimeSheetItemRowObj.Add(Day, TimeSheetItems.Current.SelectSingleNode(Day).Value);
                                else
                                    TimeSheetItemRowObj.Add(Day, "");
                            }
                        }

                        //Populate Projects associated with Timesheet for the loggedin user.
                        if (IsCopyPaste)
                        {
                            String ResourceCategoryID = TimeSheetItemRowObj.ColumnNameValues["RESOURCATEGORYID"];

                            //If project is deleted then it will notbe copied durong copy paste.
                            //If the user dont belong to Rsource Category or the resource category is obsolete then dn't copy
                            if (TimeSheetItemRowObj.Get("PROJECTID") != DeletedProjectID && (ResourceDefObj == null && String.IsNullOrEmpty(ResourceCategoryID) || (!String.IsNullOrEmpty(ResourceCategoryID) && ResourceCategorysList[ResourceCategoryID] != null)) &&
                                SourceListLayout == DestinationListLayout)
                            {
                                TimeSheetDataRows.Add(TimeSheetItmeID, TimeSheetItemRowObj);
                                
                                ProjectDetailsObj = new ProjectDetails(TimeSheetItemRowObj.Get("PROJECTID"), TimeSheetItemRowObj.Get("PROJECTCODE"), TimeSheetItemRowObj.Get("PROJECTNAME"));
                                
                                if(ProjectDetailsList == null)
                                    ProjectDetailsList = new OrderedDictionary();

                                if(!ProjectDetailsList.Contains(TimeSheetItemRowObj.Get("PROJECTID")))
                                    ProjectDetailsList.Add(TimeSheetItemRowObj.Get("PROJECTID"),ProjectDetailsObj);
                            }
                            else
                            {
                                PastedTSId = PastedTSId.Replace(TimeSheetItemRowObj.TimeSheetItemID, "");
                            }
                        }
                        else
                        {
                            TimeSheetDataRows.Add(TimeSheetItmeID, TimeSheetItemRowObj);

                            if (TimeSheetItemRowObj.Get("PROJECTID") != DeletedProjectID)
                            {
                                if(TimeSheetItemRowObj.Get("PROJECTID") == OtherProjectID)
                                    ProjectDetailsObj = new ProjectDetails(OtherProjectID, Localization.GetString("ALResource", ALParamObj.TenantName, "OTHER_Shared"), "");
                                else
                                    ProjectDetailsObj = new ProjectDetails(TimeSheetItemRowObj.Get("PROJECTID"), TimeSheetItemRowObj.Get("PROJECTCODE"), TimeSheetItemRowObj.Get("PROJECTNAME"));

                                if (ProjectDetailsList == null)
                                    ProjectDetailsList = new OrderedDictionary();

                                if (!ProjectDetailsList.Contains(TimeSheetItemRowObj.Get("PROJECTID")))
                                    ProjectDetailsList.Add(TimeSheetItemRowObj.Get("PROJECTID"), ProjectDetailsObj);
                            }
                        }
                        #endregion
                    }

                    #region Prepare tha Form Data
                    if((!IsCopyPaste) && TimeSheetStatus != "Draft")
                    {
                        FormFacade FormFacadeObj            = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        FormFacadeObj.SolutionName          = ALParamObj.SolutionName;
                        FormFacadeObj.ShowConfiguredFields  = true;
                        FormFacadeObj.FormName              = "Timesheet_ReviewDetails";
                        FormFacadeObj.ConfigurationXML      = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, "Timesheet_ReviewDetails_FormConfiguration");
                        String InputXML                     = "<TIMESHEETCOLLECTION>" + TimeSheetXpathDocRoot.OuterXml + "</TIMESHEETCOLLECTION>";
                        String DataXML                      = null;
                        List<ObjectInfo>   ObjInfoList      = null;

                        ErrorXML    = FormFacadeObj.GetFormInputXML("ReadOnly", InputXML, out DataXML, out ObjInfoList);
                        if (ErrorXML == null)
                        {
                            FrmTimesheet.InputXML = DataXML;
                        }
                        FrmTimesheet.Visible = true;
                    }

                    #endregion
                }
            }
            else
                ShowErrorPage("ERR_TS_ErrorFetchTimeSheetData");
            #endregion
        }

        private void GetEventRowIDAndColumnID(String Param, out String TimeSheetItemRowID, out String TimeSheetColumnID)
        {
            String[] Seperator  = { "$" };
            String[] CellIDArr  = Param.Split(Seperator, StringSplitOptions.RemoveEmptyEntries);
            TimeSheetItemRowID  = CellIDArr[1];
            TimeSheetColumnID   = CellIDArr[2];
        }

        private String GenerateGridInputXML()
        {
            XPathNavigator      GridConfigurationRootNode   = null;
            XPathNavigator      XPathNav                    = null;
            XmlDocument         GridNodeXMLDoc              = null;
            XmlNode             EmptyGridNode               = null;
            XmlNode             GridNodeHierarchy           = null;
            XmlNode             GirdDataRow                 = null;
            TimeSheetItemRow    TimeSheetItemRowObj         = null;
            XPathNodeIterator   xpItrEmptyRow               = null;
            Dictionary<String,Double> TimeSheetHours        = new Dictionary<String,Double>();

            GridConfigurationRootNode   = GridConfigurationXMLDoc.CreateNavigator();
            GridNodeXMLDoc              = new XmlDocument();
            GridNodeHierarchy           = GridNodeXMLDoc.CreateElement("griddata");
            EmptyGridNode               = GridNodeXMLDoc.CreateElement("EmptyGridNode");
            xpItrEmptyRow               = GridConfigurationRootNode.Select("gridconfiguration/insert_empty_row");

            if(TimeSheetDataRows.Count == 0)
            {
                xpItrEmptyRow.MoveNext();

                int rowCont = 0;
                while (rowCont < 10)
                {
                    XPathNav = xpItrEmptyRow.Current.SelectSingleNode("griddata");
                    EmptyGridNode.InnerXml = XPathNav.InnerXml;

                    GirdDataRow = PrepareGridRow(EmptyGridNode.SelectSingleNode("gridnode"), null);
                    if (GirdDataRow != null)
                        GridNodeHierarchy.AppendChild(GirdDataRow);

                    rowCont++;
                }

            }
            else
            if(TimeSheetDataRows.Count > 0)
            {
                xpItrEmptyRow.MoveNext();
                XPathNav = xpItrEmptyRow.Current.SelectSingleNode("griddata");
                EmptyGridNode.InnerXml = XPathNav.InnerXml;

                foreach (String TimeSheetItemID in TimeSheetDataRows.Keys)
                {
                    GirdDataRow = PrepareGridRow(EmptyGridNode.SelectSingleNode("gridnode"), TimeSheetItemID);
                    TimeSheetItemRowObj = (TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemID];

                    if (TimeSheetItemRowObj.Operation == OperationDelete)
                        continue;

                    foreach (String Day in TimeSheetDaysList)
                    {
                        if (!TimeSheetHours.ContainsKey(Day))
                            TimeSheetHours.Add(Day, 0);

                        if (TimeSheetItemRowObj.ColumnNameValues.ContainsKey(Day) && TimeSheetItemRowObj.ColumnNameValues[Day] != "")
                            TimeSheetHours[Day] += Convert.ToDouble(TimeSheetItemRowObj.ColumnNameValues[Day]);
                    }

                    if (GirdDataRow != null)
                        GridNodeHierarchy.AppendChild(GirdDataRow);
                }
            }

            String FooterRow = GridConfigurationRootNode.SelectSingleNode("gridconfiguration/insert_total_row/griddata").InnerXml;

            foreach (String Day in TimeSheetDaysList)
            {
                if (TimeSheetHours.ContainsKey(Day))
                    FooterRow = FooterRow.Replace("$AL$TOTAL" + Day + "$AL$", TimeSheetHours[Day].ToString());
                else
                    FooterRow = FooterRow.Replace("$AL$TOTAL" + Day + "$AL$", "0");
            }

            FooterRow = FooterRow.Replace("$AL$HOURSLABEL$AL$", Localization.GetString("ALResource", ALParamObj.TenantName, "TS_DailyTotal"));

            GridNodeHierarchy.InnerXml += FooterRow;

            return GridNodeHierarchy.OuterXml;
        }

        private XmlNode PrepareGridRow(String RowID)
        {
            XPathNavigator      GridConfigurationRootNode   = null;
            XPathNavigator      XPathNav                    = null;
            XmlDocument         GridNodeXMLDoc              = null;
            XmlNode             EmptyGridNode               = null;

            GridConfigurationRootNode   = GridConfigurationXMLDoc.CreateNavigator();
            GridNodeXMLDoc              = new XmlDocument();
            EmptyGridNode               = GridNodeXMLDoc.CreateElement("EmptyGridNode");
            XPathNav                    = GridConfigurationRootNode.SelectSingleNode("gridconfiguration/insert_empty_row/griddata");
            EmptyGridNode.InnerXml      = XPathNav.InnerXml;

            return PrepareGridRow(EmptyGridNode.SelectSingleNode("gridnode"), RowID);
        }

        private XmlNode PrepareGridRow(XmlNode EmptyNode, String RowID)
        {
            XPathNavigator    RowTemplate   = null;
            XPathNavigator    DefaultColumn = null;
            XmlNode           NewGridNode   = null;
            ulong             UniqueID      = 0;
            TimeSheetItemRow  TimeSheetItemRowObj;
            Boolean           IsNewRecord   = false;

            String              ProjectID           = null;
            String              ResourceCategoryID  = null;
            ProjectDetails      ProjectDetailsObj   = null;
            ResourceCategory    ResourceCategoryObj = null;

            RowTemplate = GridConfigurationXMLDoc.CreateNavigator().SelectSingleNode("gridconfiguration/metadata/insertrow/rows[contains(@position,'EMPTYROW')]");
            NewGridNode = EmptyNode.Clone();

            if (String.IsNullOrEmpty(RowID))
            {
                ALCommon.GenerateUniqueID(ref UniqueID);
                RowID                   = UniqueID.ToString();
                TimeSheetItemRowObj     = new TimeSheetItemRow(RowID, OperationCreate);
                TimeSheetDataRows.Add(RowID, TimeSheetItemRowObj);
                IsNewRecord             = true;

                if (ResourceCategorysList.Count == 1)
                {
                    foreach (String ResourceCategotyID in ResourceCategorysList.Keys)
                        TimeSheetItemRowObj.Add("RESOURCATEGORYID", ResourceCategotyID);
                }
            }
            else
            {
                TimeSheetItemRowObj     = (TimeSheetItemRow)TimeSheetDataRows[RowID];
                IsNewRecord             = false;
            }

            ((XmlElement)NewGridNode).SetAttribute("id", RowID);

            ProjectID = TimeSheetItemRowObj.Get("PROJECTID");
            if (ProjectID != "" && ProjectID.IndexOf(" ") < 0)
                ProjectDetailsObj = (ProjectDetails)ProjectDetailsList[TimeSheetItemRowObj.Get("PROJECTID")];

            ResourceCategoryID  = TimeSheetItemRowObj.Get("RESOURCATEGORYID");
            if (ResourceCategoryID != "" && ResourceCategoryID.IndexOf(" ") < 0)
            {
                ResourceCategoryObj = (ResourceCategory)ResourceCategorysList[TimeSheetItemRowObj.Get("RESOURCATEGORYID")];
                if(ResourceCategoryObj == null) //Search in ObsoleteList
                    ResourceCategoryObj = (ResourceCategory)ObsoleteResourceCategorysList[TimeSheetItemRowObj.Get("RESOURCATEGORYID")];
            }

            foreach(String ColumnName in FieldInfoCollection.Keys)
            {
                FieldInfo ColumnInfo    = (FieldInfo)FieldInfoCollection[ColumnName];
                String ColumnValue      = "";

                if (IsNewRecord && TimeSheetItemRowObj.Get(ColumnName) == "")
                {
                    DefaultColumn = RowTemplate.SelectSingleNode("column[@columnname='" + ColumnName + "']");
                    ColumnValue = DefaultColumn == null ? "" : DefaultColumn.GetAttribute("value", "");
                    TimeSheetItemRowObj.Add(ColumnName, ColumnValue);
                }

                switch (ColumnName)
                {
                    case "PROJECTID":
                        if (ProjectDetailsObj != null)
                            ColumnValue = ProjectDetailsObj.ProjectCode + "$DDTREE$" + ProjectDetailsObj.ProjectID;
                        else
                            ColumnValue = TimeSheetItemRowObj.Get("PROJECTCODE"); // if project is not present in Project list dropdown then project info is obtained from the query made to fetch timesheet info.
                        break;

                    case "PROJECTTITLE":
                        if (ProjectDetailsObj != null)
                            ColumnValue = ProjectDetailsObj.ProjectName;
                        else
                            ColumnValue = TimeSheetItemRowObj.Get("PROJECTNAME");
                        break;

                    case "RESOURCATEGORYID":
                        if (ResourceCategoryObj != null)
                            ColumnValue = ResourceCategoryObj.ResourceCategoryName + "$DDTREE$" + ResourceCategoryObj.ResourceCategoryID;
                        break;
                    default:
                        ColumnValue = TimeSheetItemRowObj.Get(ColumnName);
                        break;
                }

                XmlNode ValueNode = NewGridNode.SelectSingleNode("data/datafield[@name='" + ColumnName + "']/name/row/value");
                ((XmlElement)ValueNode).SetAttribute("text", ColumnValue);
                ((XmlElement)ValueNode).SetAttribute("id", RowID + "$" + ColumnName);
            }
            return NewGridNode;
        }

        private String PrepareActionButtonStateObj()
        {
            String ButtonBitCode;
            if (IsEditable)
            {
                ButtonBitCode = "save:1";

                if (TimeSheetForDateObj <= DateTime.Now)
                    ButtonBitCode += ",submit:1";
                else
                    ButtonBitCode += ",submit:0";

                ButtonBitCode += ",copy:1";

                if (GetCacheItem("SourceTimeSheetDate") == null)
                    ButtonBitCode += ",paste:0";
                else
                {
                    if (((DateTime)GetCacheItem("SourceTimeSheetDate")).ToShortDateString() == TimeSheetForDateObj.ToShortDateString())
                        ButtonBitCode += ",paste:0";
                    else
                        ButtonBitCode += ",paste:1";
                }
            }
            else
            {
                ButtonBitCode = "save:0,submit:0,copy:1,paste:0";
            }

            return "eval({" + ButtonBitCode + "})";
        }

        private String PrepareCopiedTimesheetNote()
        {
            Object      SourceTimeSheetDateObj  = GetCacheItem("SourceTimeSheetDate");
            DateTime    CopiedTimeSheetDate;
            String      CultureInformation      = null;


            if (SourceTimeSheetDateObj != null)
            {
                CopiedTimeSheetDate = (DateTime)SourceTimeSheetDateObj;

                String      FormatXmlPath   = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);
                CultureInfo CustomCulture   = new CultureInfo(CultureInformation);
                Formats     FormatesObj     = new Formats(FormatXmlPath);
                String      DateToFormate   = CopiedTimeSheetDate.Day + " " + Month[(CopiedTimeSheetDate.Month - 1)] + " " + CopiedTimeSheetDate.Year;

                return "<div>" + Localization.GetString("ALResource", ALParamObj.TenantName, "TS_TimesheetCopiedNote").Replace("$AL$COPIEDTIMESHEETDATE$AL$", "<span class='TextBoldBlack'>" + FormatesObj.FormatDateField(DateToFormate, CustomCulture) + "</span>") + "</div>";
            }
            else
                return "";
        }

        private String GetBackUrl()
        {
            StringBuilder ParamURL = null;

            ParamURL = new StringBuilder(125);

            /*if (ScreenMode == "MERCHANTSUBMISSION")
                ParamURL.AppendFormat("/{0}/{1}/ASPX/PP_Merchant_SubmissionList.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
            else*/
                ParamURL.AppendFormat("/{0}/{1}/ASPX/PP_Manage_SubmissionList.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);

            ParamURL.AppendFormat("TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.SolutionName);
            return ParamURL.ToString();
        }

        private void AddCacheItem(String ObjectName, Object ObjectToBeAdded)
        {
            ObjectName = GetCacheName(ObjectName);
            if (CacheManager.IsCached(ObjectName))
                CacheManager.RemoveCacheItem(ObjectName);

            CacheManager.AddCacheItem(ObjectName, ObjectToBeAdded, 120);

        }

        private Object GetCacheItem(String ObjectName)
        {
            ObjectName = GetCacheName(ObjectName);
            return CacheManager.GetCacheItem(ObjectName);
        }

        private String GetCacheName(String ObjectName)
        {
            return ALParamObj.SessionID + "_" + ObjectName;
        }

        private DateTime GetTimesheetWeekStartDate()
        {
            int i = 0;
            for (; i <= 6; i++)
            {
                if (Weekdays[i].ToUpper() == TimeSheetForDateObj.DayOfWeek.ToString().ToUpper())
                    break;
            }

            DateTime WeekStartDate = TimeSheetForDateObj.AddDays(i * -1);
            return WeekStartDate;
        }

        private DateTime GetTimesheetWeekEndDate()
        {
            return GetTimesheetWeekStartDate().AddDays(6);
        }

        public static String ConvertStringToDateXML(DateTime DateToConvert,Boolean IncludeTime)
        {
            StringBuilder ToReturnXml = new StringBuilder(512);

            ToReturnXml.AppendFormat("<DAY>{0}</DAY><MONTH>{1}</MONTH><YEAR>{2}</YEAR>", DateToConvert.Day, DateToConvert.Month, DateToConvert.Year);

            if(IncludeTime)
                ToReturnXml.AppendFormat("<HOUR>{0}</HOUR><MINUTE>{1}</MINUTE><SECOND>{2}</SECOND>", DateToConvert.Hour, DateToConvert.Minute, DateToConvert.Second);

            return ToReturnXml.ToString();
        }

        private void SetCopyTimesheetSource()
        {
            DateTime SourceTimeSheetDate = new DateTime(TimeSheetForDateObj.Year, TimeSheetForDateObj.Month, TimeSheetForDateObj.Day);
            AddCacheItem("SourceTimeSheetDate", SourceTimeSheetDate);
            Ajax.WriteExecuteJavaScript("SetCopyNote('" + CopiedTimeSheetnote.ClientID + "','" + ALSpecialCharHandling.EncodeSpecialCharactersForJS(PrepareCopiedTimesheetNote()) + "');");
            Ajax.WriteExecuteJavaScript("SetActionButtionVisiblity('" + AB_TimeSheetActions.ClientID + "'," + PrepareActionButtonStateObj() + ");");
        }

        private String GetBackURL()
        {
            String BackURL = null;
            BackURL = "/" + ALParamObj.TenantName + "/Common/ASPX/DefaultScene_DefaultPage.aspx?SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&Language=" + ALParamObj.Language + "&TenantName=" + ALParamObj.TenantName + "&SolutionName=" + ALParamObj.SolutionName;
            return BackURL;
        }

        private void ShowErrorPage(String ErrorResourceKey)
        {
            String          AdditionalParams    = null;
            StringBuilder   RedirectURL         = null;
            StringBuilder   RedirectParameters  = null;

            AdditionalParams	= "&ResourceID=" + ErrorResourceKey;
			RedirectURL			= new StringBuilder(200);
			RedirectParameters	= new StringBuilder(200);

			RedirectURL.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?", ALParamObj.TenantName);
			RedirectParameters.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}{4}&Backurl={5}&JS_CloseOnOk=False",
					 ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, AdditionalParams, GetBackURL().Replace("&", "%26"));
			RedirectURL.AppendFormat("Param={0}",ALSolutionCommonObj.EncryptURL(RedirectParameters.ToString()));

            try
            {
                if (Ajax != null && IsPostBack)
                    Ajax.Redirect(Page, RedirectURL.ToString());
                else
                {
                    Response.Redirect(RedirectURL.ToString());
                    Response.End();
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception)
            { }
        }
        #endregion

        #region Event Handlers
        void ALTimeSheetGrid_EditCellClick(object sender, ALGrid.GridEditCellArgs e)
        {
            String TimeSheetItemRowID    = null;
            String TimeSheetColumnID     = null;

            GetEventRowIDAndColumnID(e.dataCellID, out TimeSheetItemRowID, out TimeSheetColumnID);

            if (TimeSheetDataRows.Contains(TimeSheetItemRowID))
            {
                TimeSheetItemRow TimeSheetItemRowObj = ((TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemRowID]);

                switch (TimeSheetColumnID)
                {
                    case "PROJECTID":
                        TimeSheetItemRowObj.Add(TimeSheetColumnID, e.newHiddenVal);
                        if (TimeSheetItemRowObj.Operation == OperationUpdate && e.oldHiddenVal != "" && TimeSheetItemRowObj.RelationsToDrop.IndexOf("<TM_WORKFLOWPROCESS") < 0)
                        {
                            if (e.oldHiddenVal != OtherProjectID)
                            {
                                if (e.oldHiddenVal != DeletedProjectID)
                                    TimeSheetItemRowObj.RelationsToDrop += "<TM_WORKFLOWPROCESS TYPE='RELATION' DISASSOCIATE='TRUE'>" + e.oldHiddenVal + "</TM_WORKFLOWPROCESS>";
                                else
                                    TimeSheetItemRowObj.RelationsToDrop += "<TM_WORKFLOWPROCESS/>";

                                //Project Title
                                TimeSheetItemRowObj.Add("PROJECTNAME", ((ProjectDetails)ProjectDetailsList[e.newHiddenVal]).ProjectName);

                                //Project Code
                                if (((ProjectDetails)ProjectDetailsList[e.newHiddenVal]).ProjectID != OtherProjectID)
                                    TimeSheetItemRowObj.Add("PROJECTCODE", ((ProjectDetails)ProjectDetailsList[e.newHiddenVal]).ProjectCode);
                                else
                                    TimeSheetItemRowObj.Add("PROJECTCODE", "");
                            }
                            else
                                TimeSheetItemRowObj.RelationsToDrop += "<TM_WORKFLOWPROCESS/>";
                        }
                        
                        if (ProjectDetailsList.Contains(e.newHiddenVal))
                            e.callbackHandler = "UpdateProjectTitle('" + TimeSheetItemRowID + "','"+ ALSpecialCharHandling.EncodeSpecialCharactersForJS(((ProjectDetails)ProjectDetailsList[e.newHiddenVal]).ProjectName) +"')";
                        break;

                    case "RESOURCATEGORYID":
                        TimeSheetItemRowObj.Add(TimeSheetColumnID, e.newHiddenVal);
                        if (TimeSheetItemRowObj.Operation == OperationUpdate && e.oldHiddenVal != "" && TimeSheetItemRowObj.RelationsToDrop.IndexOf("<TMITEM_RESCAT") < 0)
                            TimeSheetItemRowObj.RelationsToDrop += "<TMITEM_RESCAT TYPE='RELATION' DISASSOCIATE='TRUE'>" + e.oldHiddenVal + "</TMITEM_RESCAT>";

                        break;
                    default:
                        if (TimeSheetDaysList.Contains(TimeSheetColumnID))
                        {
                            try
                            {
                                Double Hours;
                                Hours = (Double)Convert.ChangeType(e.newVal, typeof(Double), UserCulture);
                                if (Hours < 0)
                                    Hours = (Double)Convert.ChangeType(e.oldVal, typeof(Double), UserCulture);
                                if (Convert.ToDouble(Hours) % 0.25 == 0)
                                    TimeSheetItemRowObj.Add(TimeSheetColumnID, Hours.ToString());
                            }
                            catch { }
                        }
                        else
                            TimeSheetItemRowObj.Add(TimeSheetColumnID, e.newVal);
                        break;
                }
            }

            
        }

        void ALTimeSheetGrid_InsertNode(object sender, ALGrid.GridInsertRowArgs e)
        {
            StringBuilder   DataXml         = null;
            XmlNode         NewDataGridNode = null;

            DataXml = new StringBuilder(1024);
            DataXml.Append("<griddata>");

            for (int i = 0; i < Convert.ToInt16(e.Text); i++)
            {
                NewDataGridNode = PrepareGridRow(null);
                if (NewDataGridNode != null)
                    DataXml.Append(NewDataGridNode.OuterXml);
            }

            DataXml.Append("</griddata>");

            e.DataXml = DataXml.ToString();

        }


        //Not in use
        void ALTimeSheetGrid_UpdateNode(object sender, ALGrid.GridUpdateRowArgs e)
        {
            String  RowID           = e.Ids.Split('_')[0];
            XmlNode NewDataGridNode = PrepareGridRow(RowID);

            if (NewDataGridNode != null)
                e.DataXml = "<griddata>" + NewDataGridNode.OuterXml + "</griddata>";
            else
                e.DataXml = "<griddata></griddata>";
        }

        void ALTimeSheetGrid_DeleteRows(object sender, ALGrid.GridDeleteRowsArgs e)
        {
            if (e.delRows != null)
            {
                foreach (String TimeSheetItemRowID in e.delRows.Split(','))
                {
                    if (TimeSheetDataRows.Contains(TimeSheetItemRowID))
                    {
                        TimeSheetItemRow TimeSheetItemRowObj = ((TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemRowID]);

                        if (TimeSheetItemRowObj.Operation == OperationCreate)
                            TimeSheetDataRows.Remove(TimeSheetItemRowID);
                        else
                            TimeSheetItemRowObj.Operation = OperationDelete;
                    }
                }
            }
        }


        void ALTimeSheetGrid_GridRefresh(object sender, ALGrid.GridRefreshArgs e)
        {
            Object SourceTimeSheetDateObj = GetCacheItem("SourceTimeSheetDate");
            if (SourceTimeSheetDateObj != null)
            {
                DateTime FectTimeSheetForDate   = (DateTime)SourceTimeSheetDateObj;
                Boolean  Append                 = Boolean.Parse(e.Params);
                
                if (!Append)
                {
                    List<String> TimeSheetIDs = new List<String>();
                    foreach (String TimeSheetItemRowID in TimeSheetDataRows.Keys)
                        TimeSheetIDs.Add(TimeSheetItemRowID);

                    foreach (String TimeSheetItemRowID in TimeSheetIDs)
                    {
                        if (TimeSheetDataRows.Contains(TimeSheetItemRowID))
                        {
                            TimeSheetItemRow TimeSheetItemRowObj = ((TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemRowID]);

                            if (TimeSheetItemRowObj.Operation == OperationCreate)
                                TimeSheetDataRows.Remove(TimeSheetItemRowID);
                            else
                                TimeSheetItemRowObj.Operation = OperationDelete;
                        }
                    }
                }

                GetTimeSheetData(FectTimeSheetForDate, true);
                getInsertRowPosition();
                e.DataXML = GenerateGridInputXML();

                AddCacheItem("SourceTimeSheetDate", null);
                e.callbackHandler = "SetActionButtionVisiblity('" + AB_TimeSheetActions.ClientID + "'," + PrepareActionButtonStateObj() + "); SetCopyNote('" + CopiedTimeSheetnote.ClientID + "','" + ALSpecialCharHandling.EncodeSpecialCharactersForJS(PrepareCopiedTimesheetNote()) + "'); SetIsTimeSheetSavedValue(false); SetUpdatedRows('" + PastedTSId + "');";
            }
        }

        void ALTimeSheetGrid_InitDDTreeData(object sender, ALGrid.InitTreeDDArgs e)
        {
        
            TreeNodeCollection  nodelist             = null;
            String              TimeSheetItemRowID       = null;
            String              TimeSheetColumnID    = null;

            GetEventRowIDAndColumnID(e.dataCellId, out TimeSheetItemRowID, out TimeSheetColumnID);
            nodelist = new TreeNodeCollection();

            switch (TimeSheetColumnID)
            {
                case "PROJECTID":
                    foreach (String ProjectID in ProjectDetailsList.Keys)
                    {
                        ProjectDetails ProjectDetailsObj = ((ProjectDetails)ProjectDetailsList[ProjectID]);

                        TreeNode TreeNodeobj = new TreeNode();
                        TreeNodeobj.Text    = ProjectDetailsObj.ProjectCode;
                        TreeNodeobj.Value   = ProjectID;
                        nodelist.Add(TreeNodeobj);
                    }
                    break;
                case "RESOURCATEGORYID":
                    {
                        foreach (String ResourceCategoryID in ResourceCategorysList.Keys)
                        {
                            ResourceCategory ResourceCategoryObj = (ResourceCategory)ResourceCategorysList[ResourceCategoryID];
                        
                            TreeNode TreeNodeobj = new TreeNode();
                            TreeNodeobj.Text    = ResourceCategoryObj.ResourceCategoryName;
                            TreeNodeobj.Value   = ResourceCategoryID;
                            nodelist.Add(TreeNodeobj);
                        }

                        //Add the Obsolete Resource Categoty to list if they are part of current Time sheet
                        List<String> AddedResourceCategoryIDs = new List<String>();
                        foreach (String TimeSheetItemID in TimeSheetDataRows.Keys)
                        {
                            TimeSheetItemRow TimeSheetItemRowObj    = (TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemID];
                            String           ResourceCategoryID     = TimeSheetItemRowObj.ColumnNameValues["RESOURCATEGORYID"];
                            if ((!AddedResourceCategoryIDs.Contains(ResourceCategoryID)) && ObsoleteResourceCategorysList.Contains(ResourceCategoryID))
                            {
                                ResourceCategory ResourceCategoryObj = (ResourceCategory)ObsoleteResourceCategorysList[ResourceCategoryID];
                                if (ResourceCategoryObj != null)
                                {
                                    TreeNode TreeNodeobj    = new TreeNode();
                                    TreeNodeobj.Text        = ResourceCategoryObj.ResourceCategoryName;
                                    TreeNodeobj.Value = ResourceCategoryID;
                                    nodelist.Add(TreeNodeobj);
                                    AddedResourceCategoryIDs.Add(ResourceCategoryID);
                                }
                            }
                        }
                        
                    }
                    break;
            }

            e.DDNodeList = nodelist;
        }

        protected void AB_TimeSheetActionsList_Click(object Sender, EventArgs e)
        {
            String    Btn_Clicked                       = null;
            String[]  str_Separator                     = { "$AL$" };
            StringBuilder TimeSheetInputXmlBuilder      = null;
            String        ErrorXml                      = null;
            String        InputXml                      = null;
            TimeSheet     TimeSheetFacadeObj            = null;
            StringBuilder TimeSheetItemInputXmlBuilder  = null;
            List<String>  ToDeleteTimeSheetItems        = null;
            long          TimeSheetItmeOrder            = 0;
            Double        TotalHours                    = 0;

            try
            {
                if (Ajax.EventGeneratorUniqueID == null)
                    return; //not a Valid Post Back, Defensive code for FF on Delete Roe Event

                Btn_Clicked = Sender.ToString().Split(str_Separator, StringSplitOptions.None)[1];

                switch (Btn_Clicked.ToUpper())
                {
                    case "BTN_COPYTIMESHEET":
                        SetCopyTimesheetSource();
                        return;

                    case "BTN_PASTETIMESHEET":
                        return;
                }

                TimeSheetFacadeObj              = new TimeSheet(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName);
                TimeSheetInputXmlBuilder        = new StringBuilder(1024);
                TimeSheetItemInputXmlBuilder    = new StringBuilder(1024);
                ToDeleteTimeSheetItems          = new List<String>();

                if (String.IsNullOrEmpty(TimesheetID))
                {
                    //Create
                    if (ResourceDefObj != null)
                        TimeSheetInputXmlBuilder.AppendFormat("<TM_CREATEDBY TYPE='RELATION' PARENTID='True'>{0}</TM_CREATEDBY>", ResourceDefObj.ResourceDefID);
                    else
                        TimeSheetInputXmlBuilder.AppendFormat("<TM_CREATEDBY_USER TYPE='RELATION' PARENTID='True'>{0}</TM_CREATEDBY_USER>", ALParamObj.UserID);
                        
                    TimeSheetInputXmlBuilder.AppendFormat("<CREATEDON_DATE>{0}</CREATEDON_DATE>", ConvertStringToDateXML(DateTime.Now, true));
                }
                else
                {
                    //Update
                    TimeSheetInputXmlBuilder.AppendFormat("<TIMESHEETID>{0}</TIMESHEETID>", TimesheetID);
                }

                if (TimeSheetMode == TimesheetModeDaily)
                {
                    TimeSheetInputXmlBuilder.AppendFormat("<FROMTIMESHEETDATE>{0}</FROMTIMESHEETDATE>", ConvertStringToDateXML(TimeSheetForDateObj, true));
                    TimeSheetInputXmlBuilder.AppendFormat("<TOTIMESHEETDATE>{0}</TOTIMESHEETDATE>", ConvertStringToDateXML(TimeSheetForDateObj, true));
                    TimeSheetInputXmlBuilder.Append("<ISDAILY>1</ISDAILY>");
                }
                else
                {
                    TimeSheetInputXmlBuilder.AppendFormat("<FROMTIMESHEETDATE>{0}</FROMTIMESHEETDATE>", ConvertStringToDateXML(GetTimesheetWeekStartDate(), true));
                    TimeSheetInputXmlBuilder.AppendFormat("<TOTIMESHEETDATE>{0}</TOTIMESHEETDATE>", ConvertStringToDateXML(GetTimesheetWeekEndDate(), true));
                    TimeSheetInputXmlBuilder.Append("<ISDAILY>0</ISDAILY>");
                }

                #region Prepare TimeSheet Items Xml
                foreach(String TimeSheetItemID in TimeSheetDataRows.Keys)
                {
                    TimeSheetItemRow TimeSheetItemRowObj = (TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemID];
                    if (!String.IsNullOrEmpty(TimeSheetItemRowObj.Get("PROJECTID")))
                    {
                        //If user tries to submit timesheet with deleted project then alert will be displayed.
                        if ((TimeSheetItemRowObj.Get("PROJECTID") == DeletedProjectID) && (Btn_Clicked.ToUpper() == "BTN_SUBMIT"))
                        {
                            if (TimeSheetItemRowObj.Operation != OperationDelete)
                            {
                                Ajax.WriteExecuteJavaScript("ShowAlert('Alert_TS_CannotSubmitDeletedProjects');");
                                return;
                            }
                        }
                        
                        switch (TimeSheetItemRowObj.Operation)
                        {
                            case OperationCreate:
                                TimeSheetItemInputXmlBuilder.Append("<TIMESHEETITEMS>");
                                TimeSheetItemInputXmlBuilder.AppendFormat("<TIMESHEETITEMSID>{0}</TIMESHEETITEMSID>", TimeSheetItemRowObj.TimeSheetItemID);
                                break;

                            case OperationUpdate:
                                TimeSheetItemInputXmlBuilder.Append("<TIMESHEETITEMS TYPE='ENTITY' MODIFIED='TRUE'>");
                                TimeSheetItemInputXmlBuilder.AppendFormat("<TIMESHEETITEMSID>{0}</TIMESHEETITEMSID>", TimeSheetItemRowObj.TimeSheetItemID);

                                TimeSheetItemInputXmlBuilder.Append(TimeSheetItemRowObj.RelationsToDrop.Replace("<TM_WORKFLOWPROCESS/>",""));
                                if (TimeSheetItemRowObj.RelationsToDrop.IndexOf("<TM_WORKFLOWPROCESS") >= 0 && TimeSheetItemRowObj.Get("PROJECTID") != OtherProjectID)
                                    TimeSheetItemInputXmlBuilder.AppendFormat("<TM_WORKFLOWPROCESS TYPE='RELATION' PARENTID='True'>{0}</TM_WORKFLOWPROCESS>", TimeSheetItemRowObj.Get("PROJECTID"));

                                if (ResourceDefObj != null)
                                {
                                    if (TimeSheetItemRowObj.RelationsToDrop.IndexOf("<TMITEM_RESCAT") >= 0)
                                        TimeSheetItemInputXmlBuilder.AppendFormat("<TMITEM_RESCAT TYPE='RELATION' PARENTID='True'>{0}</TMITEM_RESCAT>", TimeSheetItemRowObj.Get("RESOURCATEGORYID"));
                                }

                                break;

                            case OperationDelete:
                                ToDeleteTimeSheetItems.Add(TimeSheetItemRowObj.TimeSheetItemID);
                                TimeSheetInputXmlBuilder.AppendFormat("<TM_ITEM  TYPE='RELATION' DISASSOCIATE='TRUE' >{0}</TM_ITEM>", TimeSheetItemRowObj.TimeSheetItemID);
                                continue;
                                break;
                        }

                        foreach (String TimeSheetItemColumnName in TimeSheetItemRowObj.ColumnNameValues.Keys)
                        {
                            //FieldInfo ColumnInfo = (FieldInfo)FieldInfoCollection[TimeSheetItemColumnName];
                            switch (TimeSheetItemColumnName)
                            {
                                case "PROJECTID":
                                    if (TimeSheetItemRowObj.Operation == OperationCreate && TimeSheetItemRowObj.Get(TimeSheetItemColumnName) != OtherProjectID)
                                        TimeSheetItemInputXmlBuilder.AppendFormat("<TM_WORKFLOWPROCESS TYPE='RELATION' PARENTID='True'>{0}</TM_WORKFLOWPROCESS>", TimeSheetItemRowObj.Get(TimeSheetItemColumnName));
                                    break;

                                case "RESOURCATEGORYID":
                                    if (ResourceDefObj != null)
                                    {
                                        if (TimeSheetItemRowObj.Operation == OperationCreate)
                                            TimeSheetItemInputXmlBuilder.AppendFormat("<TMITEM_RESCAT TYPE='RELATION' PARENTID='True'>{0}</TMITEM_RESCAT>", TimeSheetItemRowObj.Get(TimeSheetItemColumnName));
                                    }
                                    break;
                                default:
                                    if (TimeSheetDaysList.Contains(TimeSheetItemColumnName))
                                    {
                                        if (TimeSheetItemRowObj.ColumnNameValues.ContainsKey(TimeSheetItemColumnName) && TimeSheetItemRowObj.ColumnNameValues[TimeSheetItemColumnName] != "")
                                            TotalHours += Convert.ToDouble(TimeSheetItemRowObj.Get(TimeSheetItemColumnName));

                                        TimeSheetItemInputXmlBuilder.AppendFormat("<{0}>{1}</{0}>", TimeSheetItemColumnName.ToUpper(), TimeSheetItemRowObj.Get(TimeSheetItemColumnName));
                                    }
                                    else
                                        TimeSheetItemInputXmlBuilder.AppendFormat("<{0}>{1}</{0}>", TimeSheetItemColumnName.ToUpper(), ALSolutionCommon.TrimAndReplaceSpecialChars(TimeSheetItemRowObj.Get(TimeSheetItemColumnName)));
                                    break;
                            }
                        }

                        TimeSheetItemInputXmlBuilder.AppendFormat("<MISC_TASK>{0}</MISC_TASK>", TimeSheetItemRowObj.Get("PROJECTID") == OtherProjectID ? "1" : "0");
                        TimeSheetItmeOrder++;
                        TimeSheetItemInputXmlBuilder.AppendFormat("<ITEMORDER>{0}</ITEMORDER>", TimeSheetItmeOrder.ToString());
                        TimeSheetItemInputXmlBuilder.Append("</TIMESHEETITEMS>");
                    }
                }
                #endregion
                
                switch (Btn_Clicked.ToUpper())
                {
                    case "BTN_SAVE":
                        TimeSheetInputXmlBuilder.Append("<STATUS>Draft</STATUS>");
                        break;

                    case "BTN_SUBMIT":
                        TimeSheetInputXmlBuilder.Append("<STATUS>Submitted</STATUS>");
                        TimeSheetInputXmlBuilder.AppendFormat("<SUBMITTEDON_DATE>{0}</SUBMITTEDON_DATE>", ConvertStringToDateXML(DateTime.Now, true));
                        if(!String.IsNullOrEmpty(TimesheetReviewedByUserID))
                            TimeSheetInputXmlBuilder.AppendFormat("<TM_REVIEWEDBY TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</TM_REVIEWEDBY>",TimesheetReviewedByUserID);
                        TimeSheetInputXmlBuilder.AppendFormat("<REVIEWEDON_DATE></REVIEWEDON_DATE>");

                        #region check for anomalyFlag
                        String anomalyFlag = "";
                        if (TimeSheetMode == TimesheetModeDaily)
                        {
                            if (ResourceDefObj != null && TotalHours < ResourceDefObj.AvailableHours[TimeSheetForDateObj.DayOfWeek.ToString()])
                                anomalyFlag = "101";
                            else
                            {
                                Double DefaultHours = TimeSheetFacadeObj.GetSolutionConfigValue("NO_OF_HOURS") == "" ? 0 : Convert.ToDouble(TimeSheetFacadeObj.GetSolutionConfigValue("NO_OF_HOURS"));
                                if (TotalHours > DefaultHours)
                                    anomalyFlag = "100";
                            }
                        }
                        else
                        {
                            Double DefaultHours = TimeSheetFacadeObj.GetSolutionConfigValue("NO_OF_HOURS") == "" ? 0 : Convert.ToDouble(TimeSheetFacadeObj.GetSolutionConfigValue("NO_OF_HOURS"));
                            if (TotalHours > (DefaultHours * TimeSheetDaysList.Count))
                                anomalyFlag = "100";
                        }
                        #endregion

                        TimeSheetInputXmlBuilder.AppendFormat("<ANOMALY_CONST>{0}</ANOMALY_CONST>", anomalyFlag);
                        break;
                }

                if(TimeSheetItemInputXmlBuilder.Length > 0)
                    TimeSheetInputXmlBuilder.AppendFormat("<TM_ITEM TYPE='RELATION'>{0}</TM_ITEM>", TimeSheetItemInputXmlBuilder.ToString());
                InputXml = "<TIMESHEET>" + TimeSheetInputXmlBuilder.ToString() + "</TIMESHEET>";

                #region Update DataBase
                if (String.IsNullOrEmpty(TimesheetID))
                {
                    ErrorXml = TimeSheetFacadeObj.CreateTimeSheet(ref InputXml);
                    if (ErrorXml == null)
                    {
                        XPathDocument TimeSheetXmlDoc = new XPathDocument(new StringReader(InputXml));
                        TimesheetID = TimeSheetXmlDoc.CreateNavigator().SelectSingleNode("//TIMESHEET/TIMESHEETID").Value;

                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("ShowAlert('Alert_TS_TimesheetCreationFailed');");
                        Ajax.WriteExecuteJavaScript("window.open(window.location ,'_self');");
                        return;
                    }
                }
                else
                    ErrorXml = TimeSheetFacadeObj.UpdateTimeSheet(ref InputXml);

                if (ErrorXml == null)
                {
                    Ajax.WriteExecuteJavaScript("SetIsTimeSheetSavedValue(true)");
                    if (Btn_Clicked.ToUpper() == "BTN_SAVE" && Request["__EVENTARGUMENT"] == "True") //Save and Copy
                    {
                        SetCopyTimesheetSource();
                    }
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("ShowAlert('Alert_TS_TimesheetUpdationFailed');");
                    Ajax.WriteExecuteJavaScript("window.open(window.location ,'_self');");
                    return;
                }
               
                //remove Copy Source
                //AddCacheItem("SourceTimeSheetDate", null);

                if(Btn_Clicked.ToUpper() == "BTN_SUBMIT")
                    Ajax.WriteExecuteJavaScript("window.open(window.location ,'_self');");
                /*else
                    Ajax.WriteExecuteJavaScript("SetActionButtionVisiblity('" + AB_TimeSheetActions.ClientID + "'," + PrepareActionButtonStateObj() + ");");
                */
                #region Update the Local Data Structure
                foreach (String ToDeleteTimeSheetItemID in ToDeleteTimeSheetItems)
                    TimeSheetDataRows.Remove(ToDeleteTimeSheetItemID);

                foreach (String TimeSheetItemID in TimeSheetDataRows.Keys)
                {
                    TimeSheetItemRow TimeSheetItemRowObj = ((TimeSheetItemRow)TimeSheetDataRows[TimeSheetItemID]);
                    if (!String.IsNullOrEmpty(TimeSheetItemRowObj.Get("PROJECTID")))
                    {
                        TimeSheetItemRowObj.Operation = OperationUpdate;
                    }
                    TimeSheetItemRowObj.RelationsToDrop  = "";
                }
                #endregion
                #endregion

            }
            catch (Exception ExpObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Timesheet_ResourceTimeSheet.aspx", "AB_TimeSheetActionsList_Click", ExpObj, null, null);
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "RESOURCETIMESHEET", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_RM_ResourceCategoryList_ErrorOccuredWhileGeneratingResourceCategoryList"), null, BackUrl.ToString(), ref strErrorPageURL);
                if (IsPostBack)
                {
                    Ajax.Redirect(this, strErrorPageURL);
                }
                else
                {
                    Response.Redirect(strErrorPageURL, true);
                }
            }
        }

        #endregion
    }

    class TimeSheetItemRow
    {
        public readonly String TimeSheetItemID;
        public String Operation;
        public Dictionary<String, String> ColumnNameValues;
        public String RelationsToDrop;

        public TimeSheetItemRow(String TimeSheetItemID, String Operation)
        {
            this.TimeSheetItemID    = TimeSheetItemID;
            this.Operation          = Operation;
            ColumnNameValues        = new Dictionary<String,String>();
            RelationsToDrop         = "";

            if ((Operation == "CREATE") && (String.IsNullOrEmpty(TimeSheetItemID)))
            {
                ulong UniqueID = 0;
                ALCommon.GenerateUniqueID(ref UniqueID);
                this.TimeSheetItemID = UniqueID.ToString();
            }
        }

        public void Add(String ColumnName, String Value)
        {
            if (ColumnNameValues.ContainsKey(ColumnName))
                ColumnNameValues[ColumnName] = Value;
            else
                ColumnNameValues.Add(ColumnName, Value);
        }

        public String Get(String ColumnName)
        {
            if (ColumnNameValues.ContainsKey(ColumnName))
                return ColumnNameValues[ColumnName];
            else
                return "";
        }
    }

    class ProjectDetails
    {
        public readonly String ProjectID;
        public readonly String ProjectCode;
        public String ProjectName;

        public ProjectDetails(String ProjectID, String ProjectCode, String ProjectName)
        {
            this.ProjectID      = ProjectID;
            this.ProjectCode    = ProjectCode;
            this.ProjectName    = ProjectName;
        }
    }

    class ResourceCategory
    {
        public readonly String ResourceCategoryID;
        public String ResourceCategoryName;
        public Boolean IsObsolete = false;


        public ResourceCategory(String ResourceCategoryID, String ResourceCategoryName, String IsObsolete, String TenantName)
        {
            this.ResourceCategoryID = ResourceCategoryID;
            this.ResourceCategoryName = ResourceCategoryName;
            if (IsObsolete == "1")
            {
                this.IsObsolete = true;
                this.ResourceCategoryName += " (" + Assetlink.Localization.GetString("ALResource", TenantName, "Obsolete_Shared") + ")";
            }
        }
    }

    class ResourceDef
    {
        public readonly String ResourceDefID;
        public Dictionary<String,Double>AvailableHours;
        public Boolean IsObsolete = false;

        public ResourceDef(String ResourceDefID, String IsObsolete)
        {
            this.ResourceDefID  = ResourceDefID;
            AvailableHours      = new Dictionary<String,Double>();
            if (IsObsolete == "1")
                this.IsObsolete = true;
        }
    }
}
