using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Text;
using System.Xml.XPath;
using System.IO;
using System.Threading;
using System.Collections.Specialized;

#region AssetlinkInclude
using Assetlink;
using Assetlink.Solutions;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.StrategicPlannerFacade;
using Assetlink.Solutions.Facade.CurrencyConversionFacade;
using Assetlink.Solutions.Facade.ApprovalsFacade;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.CustomControls;
using Assetlink.Widgets;
using Assetlink.Solutions.Pages;
#endregion

namespace Assetlink.Commitment.RODetails
{
    using XML = System.String;
    using ERRORXML = System.String;

    public partial class CommitmentDetails_RO : Widgets_UserControlBase
    {
        String[] Separator = null;
        UInt64  ErrorID = 0;
        List<ObjectInfo> ObjList = null;
        String SourceEntityAttributeXML = null;
        String ConfigXMLPath = null;
        String PaymentScheduleListXMLPath = null;
        String CommitmentLineItemXMLPath = null;
        Binder LST_Attachments = null;
        StringBuilder BackUrl = null;
        String PageErrorMessage = null;
        String ErrorPageURL = null;
        ALBreadCrumb CommitmentBreadcrumb = null;
        Solutions.ALSolutionCommon CommonFunctionObj = null;
        double OutstandingCommittedAmount = 0;
		 TabFacade obj_TabFacade = null;
        ApprovalsFacadeClass        ApprovalsObj = null;
        MktgWorkBenchFacadeClass    MWBFacadeObj = null;
        ListFacade                  ListFacadeObj = null;
        Boolean IsCommitmentApprovalEnabled = false;
        Assetlink.CustomControls.Form           FRM_CommitmentDetails   = null;
        Assetlink.CustomControls.Form           FRM_CloseCommitment     = null;
        Assetlink.CustomControls.ListControl    LST_PaymentSchedule     = null;
        Assetlink.CustomControls.ListControl    LST_CommitmentItems     = null;        
        ActionBar                               ATN_CloseCommitment     = null;
        ALLiteralControl                        Lbl_ShowPlanCurrency    = null;
        ALPanel                                 ShowCurrencyPanel       = null;
        ALLiteralControl                        Lbl_ShowChangedCurrency = null;
        ActionBar AB_ROCommitmentDetails        = null;
        ALAjaxPage objALPage                    = null;
        InvoiceWidget InvoiceList               = null;
        ALTab Commitment_Tab                    = null;
        ALPanel ALPanel_CommitmentInfo          = null;
        CustomControls.ListControl Lc_CommitmentApprovalJobList           = null;
        CustomControls.ListControl Lc_VendorApprovalJobList = null;
        ALPanel ALPanel_Approvals               = null;
     
        private CurrencyConversionClass ObjCurrencyConvertor = null;
        private String ConvertedCurrencyDetails = "";

        const string           ALFormatFileName        = "Formats.xml";    

        #region Properties

        public UInt64 CommitmentID
        {
            get
            {
                object obj = this.ViewState["CommitmentID"];
                if (obj == null)
                {
                    return 0;
                }
                return (UInt64)obj;
            }
            set
            {
                this.ViewState["CommitmentID"] = value;
            }
        }

        public String TaskPaneList
        {
            get
            {
                if (this.ViewState["TaskPaneList"] == null)
                {
                    return String.Empty;
                }
                return (String)this.ViewState["TaskPaneList"];
            }
            set
            {
                this.ViewState["TaskPaneList"] = value;
            }
        }

        public String RelationshipName
        {
            get
            {
                if (this.ViewState["RelationshipName"] == null)
                {
                    return String.Empty;
                }
                return (String)this.ViewState["RelationshipName"];
            }
            set
            {
                this.ViewState["RelationshipName"] = value;
            }
        }

        public String SourceAttributes
        {
            get
            {
                if (this.ViewState["SourceAttributes"] == null)
                {
                    return String.Empty;
                }
                return (String)this.ViewState["SourceAttributes"];
            }
            set
            {
                this.ViewState["SourceAttributes"] = value;
            }
        }

        public String AccessMode
        {
            get
            {
                if (this.ViewState["AccessMode"] == null)
                {
                    return String.Empty;
                }
                return (String)this.ViewState["AccessMode"];
            }
            set
            {
                this.ViewState["AccessMode"] = value;
            }
        }

        public String Mode
        {
            get
            {
                if (this.ViewState["Mode"] == null)
                {
                    return String.Empty;
                }
                return (String)this.ViewState["Mode"];
            }
            set
            {
                this.ViewState["Mode"] = value;
            }
        }

        public String[] JSFileNames
        {
            get
            {
                return GetJSFileName();

            }           
        }

        public String ParentBreadcrumbName
        {
            get
            {
                Object Obj = this.ViewState["ParentBreadcrumbName"];
                if (Obj != null)
                {
                    return (String)Obj;
                }
                return null;
            }
            set
            {
                this.ViewState["ParentBreadcrumbName"] = value;
            }

        }

        public String ParentBreadcrumbID
        {
            get
            {
                Object Obj = this.ViewState["ParentBreadcrumbID"];
                if (Obj != null)
                {
                    return (String)Obj;
                }
                return null;            
            }
            set
            {
                this.ViewState["ParentBreadcrumbID"] = value;
            }
        }

        public String BreadcrumbXML
        {
            get
            {
                Object Obj = this.ViewState["BreadcrumbXML"];
                if (Obj != null)
                {
                    return (String)Obj;
                }
                return null;
            }
            set
            {
                this.ViewState["BreadcrumbXML"] = value;
            }
        }

        /// <summary>
        /// This property defines whether the currency for perticular plan
        /// is changed or not, depending on which the list will be shown readonly
        /// and currency is converted to selected currency.
        /// </summary>
        public bool MultiCurrencyView
        {
            get
            {
                Object Obj = this.ViewState["MultiCurrencyView"];
                return (Obj == null) ? false : (bool)Obj;
            }
            set
            {
                this.ViewState["MultiCurrencyView"] = value;
            }
        }

        /// <summary>
        /// This property specifies the selected currency 
        /// in case of multicurrencyview.
        /// </summary>
        public String SelectedCurrency
        {
            get
            {
                Object Obj = this.ViewState["SelectedCurrency"];
                return (Obj == null) ? "" : (String)Obj;
            }
            set
            {
                this.ViewState["SelectedCurrency"] = value;
            }
        }
        

        /// <summary>
        /// This property specifies the Vendor Resource
        /// </summary>
        public String VendorResource
        {
            get
            {
                Object Obj = this.ViewState["VendorResource"];
                return (Obj == null) ? "" : (String)Obj;
            }
            set
            {
                this.ViewState["VendorResource"] = value;
            }
        }

        /// <summary>
        /// This property specifies the selected tab
        /// </summary>
        public String ReadonlyMode_SelectedTabName
        {
            get
            {
                Object Obj = this.ViewState["ReadonlyMode_SelectedTabName"];
                return (Obj == null) ? "CommitmentInfo" : (String)Obj;
            }
            set
            {
                this.ViewState["ReadonlyMode_SelectedTabName"] = value;
            }
        }

        /// <summary>
        /// Added for facet series export url handling.
        /// </summary>
        public string FacetSeriesExportUrl
        {
            get
            {
                return FRM_CommitmentDetails.GetSeriesExportUrl();
            }
        }

        #endregion Properties

        #region Event Handler
        private static readonly object ObjCloseCommitment = new object();
        public event EventHandler CloseCommitment
        {
            add
            {
                this.Events.AddHandler(ObjCloseCommitment, value);
            }
            remove
            {
                this.Events.RemoveHandler(ObjCloseCommitment, value);
            }
        }

		private static readonly object ObjVoidCommitment = new object();
        public event EventHandler VoidCommitmentHandler
        {
            add
            {
                this.Events.AddHandler(ObjVoidCommitment, value);
            }
            remove
            {
                this.Events.RemoveHandler(ObjVoidCommitment, value);
            }
        }
        #endregion


        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                CommonFunctionObj = new Solutions.ALSolutionCommon();
                objALPage = this.Page as ALAjaxPage;
                CommonFunctionObj.httpContext = HttpContext.Current;
                SetParameters();
				GetCommitmentApprovalSetting();
                SetControls();

                if (!IsPostBack)
                {
                    GetCommitmentDetails(CommitmentID);
                }
                // Start of Changes done by Parita Harniya on 4 July 2008
                // Description: Function call added in else condition for reading initial commitment amount
                else
                {
                    GetCommitmentAmount();
                }
                // Changes done by Parita Harniya on 4 July 2008 ends here.

                DisplayEditButton();               
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "Page_Load", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner","SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }
        
        protected override void CreateChildControls()
        {
            try
            {
                Solutions.ALSolutionCommon CommonFunctionObj = new Solutions.ALSolutionCommon();
                CommonFunctionObj.httpContext = HttpContext.Current;
                SetParameters();
                base.CreateChildControls();
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "CreateChildControls", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        void SetParameters()
        {
            try
            {
                ObjList = new List<ObjectInfo>();
                PageErrorMessage = Localization.GetString("ALErrorResource", SetBaseObj.TenantName, "ERR_SP_CommitmentWidget_Get");
                Separator = new String[1] { "$AL$" };
                SourceEntityAttributeXML = ALSolutionCommon.GetTempPath(SetBaseObj.SessionID) + this.ClientID + "StrategicPlanner_SourceEntityInfo.xml";
                GetBackURL();

                if ((Session["MULTICURRENCYVIEW"] != null && Session["MULTICURRENCYVIEW"].ToString() == "true") &&
                        (Session["SELECTEDCURRENCY"] != null && Session["SELECTEDCURRENCY"].ToString() != ""))
                {
                    MultiCurrencyView = true;
                    SelectedCurrency = Session["SELECTEDCURRENCY"].ToString();
                }
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "SetParameters", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        void SetControls()
        {
            String          TempXMLPath             = null;
            String          CultureInformation      = null;
            String          PersonalisationXMLPath  = null;
            StringBuilder   InvoiceListFilterXML    = null;
            StringBuilder   UploadURLPath           = null;
            StringBuilder   DownloadURLPath         = null;
            StringBuilder   StartHeaderLiteral      = null;
            StringBuilder   JavaScript              = null;
            String          FormatXMLPath           = null;
            StringBuilder   ListControlXSLTPath     = null;

            try
            {
                InvoiceListFilterXML                = new StringBuilder();
                StartHeaderLiteral                  = new StringBuilder();
                JavaScript                          = new StringBuilder();
                ListControlXSLTPath                 = new StringBuilder(100);
                PersonalisationXMLPath              = ALCommon.GetFormatDetails(SetBaseObj.TenantName, out CultureInformation);

                FormatXMLPath                       = ALCommon.GetFormatDetails(SetBaseObj.TenantName, out CultureInformation);
                ListControlXSLTPath.AppendFormat("{0}{1}\\XSLT\\SortListXML.xslt", ALCommon.GetInstallationDir(), SetBaseObj.TenantName);
                SBS_Commitment.TenantName           = SetBaseObj.TenantName;
				Commitment_Tab          = (ALTab)this.SBS_Commitment.FindControl("COMMITMENT_TAB");
				ALPanel_CommitmentInfo  = (ALPanel)Commitment_Tab.FindControl("CommitmentInfo");
                
				FRM_CommitmentDetails               = (Assetlink.CustomControls.Form)this.ALPanel_CommitmentInfo.FindControl("Content_1_Frm_FRM_CommitmentDetails");
                FRM_CommitmentDetails.TenantName    = SetBaseObj.TenantName;
                FRM_CommitmentDetails.SolutionName  = SetBaseObj.SolutionName;

                CommitmentBreadcrumb = (ALBreadCrumb)this.SBS_Commitment.FindControl("CommitmentBreadcrumb");
                CommitmentBreadcrumb.TenantName = SetBaseObj.TenantName;
                this.CommitmentBreadcrumb.Name = "CommitmentBreadcrumb";
                if (!String.IsNullOrEmpty(ParentBreadcrumbID))
                {
                    CommitmentBreadcrumb.ParentBreadcrumbName   = ParentBreadcrumbName;
                    CommitmentBreadcrumb.BreadcrumbUniqueID     = ParentBreadcrumbID;
                }
                else
                {
                    CommitmentBreadcrumb.ParentBreadcrumbName   = ParentBreadcrumbName;
                }

                InvoiceList                     = (InvoiceWidget)this.ALPanel_CommitmentInfo.FindControl("InvoiceList");
                InvoiceList.TenantName          = SetBaseObj.TenantName;
                InvoiceList.SessionID           = SetBaseObj.SessionID;
                InvoiceList.UserID              = SetBaseObj.UserID;
                InvoiceList.Language            = SetBaseObj.Language;
                InvoiceList.SolutionName        = SetBaseObj.SolutionName;
                InvoiceList.DefaultScreenName   = "InvoiceList";
                InvoiceList.WidgetName          = "SP_InvoiceWidget";
                InvoiceList.TaskPaneList        = this.TaskPaneList;
                InvoiceList.SourceEntityID      = CommitmentID;
                if (!IsPostBack)
                {
                    InvoiceList.AccessMode = AccessMode;
                    if (Mode.ToUpper().Equals("LISTREADONLY"))
                    {
                        InvoiceList.Mode = "EDITABLE";
                    }
                    else
                    {
                        InvoiceList.Mode = Mode;
                    }
                }
                InvoiceListFilterXML.AppendFormat(@"<FILTERLIST>			                                            
                                                        <FILTER>
                                                            <FILTERID>1</FILTERID>
                                                            <EXPRESSION>COMMITMENTID</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            <RELATIONSHIPNAME>COMMITMENT_TO_INVOICE</RELATIONSHIPNAME>
                                                        </FILTER>
                                                        <FILTER>
                                                            <FILTERID>2</FILTERID>
                                                            <EXPRESSION>COMMITMENTID</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            <RELATIONSHIPNAME>CONTD_COMMIT_INVOICE</RELATIONSHIPNAME>
                                                        </FILTER>
                                                        <FILTERCOMBINATION>((1)OR(2))</FILTERCOMBINATION>
                                                    </FILTERLIST>", CommitmentID.ToString());
                InvoiceList.FilterListXML       = InvoiceListFilterXML.ToString();
                InvoiceList.RelationShipName    = "COMMITMENT_TO_INVOICE";
                InvoiceList.DeleteInvoiceClick += new EventHandler(InvoiceList_DeleteInvoiceClick);
                InvoiceList.BatchReconcile += new EventHandler(InvoiceList_BatchReconcile);
                InvoiceList.ParentBreadcrumbID = this.CommitmentBreadcrumb.BreadcrumbUniqueID;
                InvoiceList.ParentBreadcrumbName = this.CommitmentBreadcrumb.Name;
                InvoiceList.BreadcrumbXML = this.BreadcrumbXML;

                InvoiceList.MultiCurrencyView = MultiCurrencyView;
                InvoiceList.SelectedCurrency = SelectedCurrency;

                
                obj_TabFacade                       = new TabFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                Commitment_Tab.TenantName           = SetBaseObj.TenantName;
                obj_TabFacade.TabName               = "Commitment";
                obj_TabFacade.WidgetName            = SetBaseObj.WidgetName;
                obj_TabFacade.ScreenName            = "ROCommitment";
                Commitment_Tab.onTabClick           += new ALTab.TabEventHandler(Commitment_Tab_onTabClick);
                if (!IsPostBack)
                {
                    obj_TabFacade.InitializeTab(ref Commitment_Tab);
                }
                if (IsCommitmentApprovalEnabled)
                    Commitment_Tab.SelectedTabName = ReadonlyMode_SelectedTabName;
                ALPanel_Approvals                                     = (ALPanel)Commitment_Tab.FindControl("Approvals");
                ALPanel_Approvals.Visible                             = IsCommitmentApprovalEnabled;
                Lc_CommitmentApprovalJobList                          = (Assetlink.CustomControls.ListControl)ALPanel_Approvals.FindControl("ID_LC_CommitmentApprovalJobList");
                Lc_CommitmentApprovalJobList.SectionHeading           = "Internal Approvals";                          
                Lc_CommitmentApprovalJobList.TenantName               = SetBaseObj.TenantName;
                Lc_CommitmentApprovalJobList.XSLTPath                 = ListControlXSLTPath.ToString();
                Lc_CommitmentApprovalJobList.CultureInformation       = CultureInformation;
                Lc_CommitmentApprovalJobList.PersonalizationFilePath  = FormatXMLPath;

                Lc_VendorApprovalJobList                              = (Assetlink.CustomControls.ListControl)ALPanel_Approvals.FindControl("ID_LC_VendorApprovalJobList");
                Lc_VendorApprovalJobList.TenantName                   = SetBaseObj.TenantName;
                Lc_VendorApprovalJobList.SectionHeading               = "Vendor Approvals";
                Lc_VendorApprovalJobList.XSLTPath                     = ListControlXSLTPath.ToString();
                Lc_VendorApprovalJobList.CultureInformation           = CultureInformation;
                Lc_VendorApprovalJobList.PersonalizationFilePath      = FormatXMLPath;

                CloseCommitment_PopControl.TenantName = SetBaseObj.TenantName;
                
                LST_PaymentSchedule                         = (Assetlink.CustomControls.ListControl)this.ALPanel_CommitmentInfo.FindControl("Content_3_lc_LST_PaymentSchedule");
                LST_PaymentSchedule.TenantName              = SetBaseObj.TenantName;
                LST_PaymentSchedule.XSLTPath                = ALSolutionCommon.GetXSLTPath(SetBaseObj.TenantName, null) + "SortListXML.xslt";
                LST_PaymentSchedule.CultureInformation      = CultureInformation;
                LST_PaymentSchedule.PersonalizationFilePath = PersonalisationXMLPath;

                LST_CommitmentItems             = (Assetlink.CustomControls.ListControl)this.ALPanel_CommitmentInfo.FindControl("Content_4_lc_LST_CommitmentItems");
                LST_CommitmentItems.TenantName  = SetBaseObj.TenantName;
                LST_CommitmentItems.XSLTPath    = ALSolutionCommon.GetXSLTPath(SetBaseObj.TenantName, null) + "SortListXML.xslt";
                LST_CommitmentItems.CultureInformation = CultureInformation;
                LST_CommitmentItems.PersonalizationFilePath = PersonalisationXMLPath;
                
                LST_Attachments                         = (Binder)this.ALPanel_CommitmentInfo.FindControl("Content_7_lc_LST_Attachments");
                LST_Attachments.TenantName              = SetBaseObj.TenantName;
                LST_Attachments.SolutionName            = SetBaseObj.SolutionName;
                LST_Attachments.WidgetName              = "SP_CommitmentWidget";
                LST_Attachments.BinderListHeading       = Localization.GetString("ALResource", SetBaseObj.TenantName, "AttachemntList_Shared");
                LST_Attachments.ListConfigurationName   = "CommitmentAttachments";
                LST_Attachments.ConfigName              = "COMMITMENT_ATTACH";
                LST_Attachments.Mode                    = Binder.Modes.ReadOnly;
                LST_Attachments.Layout                  = Binder.LayoutType.BinderList_WithThumbnails;
                ALButton1.TenantName                    = SetBaseObj.TenantName;
                StringBuilder ParameterList             = new StringBuilder();
                ParameterList.AppendFormat("TenantName={0}&SessionID={1}&UserID={2}&Language={3}&SolutionName=StrategicPlanner&ControlID={4}", SetBaseObj.TenantName, SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.Language, this.ALButton1.UniqueID);
                UploadURLPath                           = new StringBuilder();
                UploadURLPath.AppendFormat("/{0}/Common/ASPX/UploadFiles.aspx?Param={1}", SetBaseObj.TenantName, CommonFunctionObj.EncryptURL(ParameterList.ToString()));
                LST_Attachments.UploadUrl               = UploadURLPath.ToString();
                DownloadURLPath                         = new StringBuilder();
                DownloadURLPath.AppendFormat("/{0}/Common/ASPX/FileDownload.aspx?Param={1}", SetBaseObj.TenantName, CommonFunctionObj.EncryptURL(ParameterList.ToString()));
                LST_Attachments.DownloadUrl             = DownloadURLPath.ToString();
                LST_Attachments.FieldName               = "ATTACHMENTS";

                FRM_CloseCommitment                 = (Assetlink.CustomControls.Form)this.SBS_CloseCommitment.FindControl("FRM_CloseCommitment");
                FRM_CloseCommitment.SolutionName    = SetBaseObj.SolutionName;
                FRM_CloseCommitment.TenantName      = SetBaseObj.TenantName;
                FRM_CloseCommitment.WidgetName      = "SP_CommitmentWidget";
                
                TempXMLPath                 = ALSolutionCommon.GetTempPath(SetBaseObj.SessionID);
                ConfigXMLPath               = TempXMLPath + FRM_CommitmentDetails.ClientID + ".xml";
                PaymentScheduleListXMLPath  = TempXMLPath + LST_PaymentSchedule.ClientID + ".xml";
                CommitmentLineItemXMLPath   = TempXMLPath + LST_CommitmentItems.ClientID + ".xml";
            
                ID_Start_Header.Text = StartHeaderLiteral.ToString();

                ATN_CloseCommitment = (ActionBar)this.SBS_CloseCommitment.FindControl("ATN_CloseCommitment");
                ATN_CloseCommitment.TenantName = SetBaseObj.TenantName;
                ATN_CloseCommitment.InputXMLType = ActionBar.XMLType.InnerXML;
                ATN_CloseCommitment.InputXML = @"<ActionBar>
		                                            <ActionControlList ActionBarType='PageButtonBar'>
			                                            <ActionControl Alignment='left' Tooltip='Close Commitment' TooltipID='SP_CommitmentRO_CloseCommitment' DisplayTextID='Save_Shared' UIType='ALButton' Name='btn_CloseCommitment' Order='0' CausesValidation='False' EventArgument=''>
				                                            <DisplayText>Save</DisplayText>
			                                            </ActionControl>
			                                            <ActionControl Alignment='left' Tooltip='Cancel' UIType='ALButton' Name='btn_Cancel' Order='1' CausesValidation='False' EventArgument='' TooltipID='Cancel_Shared' DisplayTextID='Cancel_Shared'>
				                                            <DisplayText>Cancel</DisplayText>
			                                            </ActionControl>
		                                            </ActionControlList>
	                                            </ActionBar>";
                ATN_CloseCommitment.Click += new EventHandler(FRM_CloseCommitment_ActionBarClick);

				if (IsPostBack)
				{
					SetROActionBarInputXML(null);
				}

				ALPC_VoidCommitment.TenantName          = SetBaseObj.TenantName;
                ALPC_VoidCommitment.CaptionText         = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_COMMITMENTRO_VOIDCOMMITMENTTXT"); 
                ALPC_VoidCommitment.PopupHeight         = 400;
                ALPC_VoidCommitment.PopupWidth          = 600;
                ALPC_VoidCommitment.ShowCloseIcon       = false;
                ALPC_VoidCommitment.PopupDisplayMode    = ePopupDisplayMode.Simple;

                ALPC_VoidCommitment.Style.Add(HtmlTextWriterStyle.Display, "None");
                AB_VoidCommitment.TenantName            = SetBaseObj.TenantName;
                AB_VoidCommitment.InputXMLType          = ActionBar.XMLType.InnerXML;
                AB_VoidCommitment.InputXML              = @"<ActionBar>
	                                                            <ActionControlList ActionBarType='PageButtonBar'>
		                                                            <ActionControl Alignment='left' Tooltip='" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Save_Shared")) + @"' UIType='ALButton' Name='btn_SaveVoidCommitment' Order='0' CausesValidation='False' EventArgument=''>
			                                                            <DisplayText>" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Save_Shared")) + @"</DisplayText>
		                                                            </ActionControl>
		                                                            <ActionControl Alignment='left' Tooltip='" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Cancel_Shared")) + @"' UIType='ALButton' Name='btn_CancelVoidCommitment' Order='1' CausesValidation='False' EventArgument=''>
			                                                            <DisplayText>" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Cancel_Shared")) + @"</DisplayText>
		                                                            </ActionControl>
                                                                </ActionControlList>
	                                                        </ActionBar>";
                StringBuilder MandatoryJavascript       = new StringBuilder(50);
                MandatoryJavascript.Append("<script type='text/javascript'>function CommitmantWidget_ValidateMandatoryFields(buttonid)");
                MandatoryJavascript.Append("{");
                MandatoryJavascript.Append("if(ValidateForm_" + FRM_VoidCommitment.ID + "())");
                MandatoryJavascript.Append("{");
                MandatoryJavascript.Append("__doPostBack(buttonid,'');");
                MandatoryJavascript.Append("}");
                MandatoryJavascript.Append("}</script>");

                if (!Page.IsClientScriptBlockRegistered("CheckFormMandatory"))
                    Page.RegisterClientScriptBlock("CheckFormMandatory", MandatoryJavascript.ToString());

                AB_VoidCommitment.AddAttributes("btn_SaveVoidCommitment", "href", "javascript:CommitmantWidget_ValidateMandatoryFields('$CONTROLID$');");
                AB_VoidCommitment.AddAttributes("btn_CancelVoidCommitment", "href","javascript:"+ ALPC_VoidCommitment.ClosePopupJavascript + ";");
                AB_VoidCommitment.Click                 += new EventHandler(AB_ROCommitmentDetails_ActionBarClick);

                FRM_VoidCommitment.SolutionName         = SetBaseObj.SolutionName;
                FRM_VoidCommitment.TenantName           = SetBaseObj.TenantName;
                FRM_VoidCommitment.WidgetName           = "SP_CommitmentWidget";

                ALPC_EditVoidCommitmentNo.TenantName    = SetBaseObj.TenantName;
                ALPC_EditVoidCommitmentNo.CaptionText   = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_CommitmentRO_EditVoidCommitmentNoTXT");
                ALPC_EditVoidCommitmentNo.PopupHeight   = 400;
                ALPC_EditVoidCommitmentNo.PopupWidth    = 600;
                ALPC_EditVoidCommitmentNo.ShowCloseIcon = false;
                ALPC_EditVoidCommitmentNo.PopupDisplayMode = ePopupDisplayMode.Simple;
                ALPC_EditVoidCommitmentNo.Style.Add(HtmlTextWriterStyle.Display, "None");

                AB_EditVoidCommitmentNo.TenantName      = SetBaseObj.TenantName;
                AB_EditVoidCommitmentNo.InputXMLType    = ActionBar.XMLType.InnerXML;
                AB_EditVoidCommitmentNo.InputXML        = @"<ActionBar>
	                                                            <ActionControlList ActionBarType='PageButtonBar'>
		                                                            <ActionControl Alignment='left' Tooltip='" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Save_Shared")) + @"' UIType='ALButton' Name='btn_SaveEditVoidCommitmentNo' Order='0' CausesValidation='False' EventArgument=''>
			                                                            <DisplayText>" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Save_Shared")) +@"</DisplayText>
		                                                            </ActionControl>
		                                                            <ActionControl Alignment='left' Tooltip='" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Cancel_Shared")) + @"' UIType='ALButton' Name='btn_CancelEditVoidCommitmentNo' Order='1' CausesValidation='False' EventArgument=''>
			                                                            <DisplayText>" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(Localization.GetString("ALResource", SetBaseObj.TenantName, "Cancel_Shared")) +@"</DisplayText>
		                                                            </ActionControl>
                                                                </ActionControlList>
	                                                        </ActionBar>";

                MandatoryJavascript.Remove(0, MandatoryJavascript.Length);
                MandatoryJavascript.Append("<script type='text/javascript'>function CommitmantWidget_FRMEditVoidCommitment_ValidateMandatoryFields(buttonid)");
                MandatoryJavascript.Append("{");
                MandatoryJavascript.Append("if(ValidateForm_" + FRM_EditVoidCommitmentNo.ID + "())");
                MandatoryJavascript.Append("{");
                MandatoryJavascript.Append("__doPostBack(buttonid,'');");
                MandatoryJavascript.Append("}");
                MandatoryJavascript.Append("}</script>");

                if (!Page.IsClientScriptBlockRegistered("CheckFormMandatory_EditVoidCommitment"))
                    Page.RegisterClientScriptBlock("CheckFormMandatory_EditVoidCommitment", MandatoryJavascript.ToString());

                AB_EditVoidCommitmentNo.AddAttributes("btn_SaveEditVoidCommitmentNo", "href", "javascript:CommitmantWidget_FRMEditVoidCommitment_ValidateMandatoryFields('$CONTROLID$');");
                AB_EditVoidCommitmentNo.AddAttributes("btn_CancelEditVoidCommitmentNo", "href", "javascript:" + ALPC_EditVoidCommitmentNo.ClosePopupJavascript + ";");
                AB_EditVoidCommitmentNo.Click           += new EventHandler(AB_ROCommitmentDetails_ActionBarClick);

                FRM_EditVoidCommitmentNo.SolutionName   = SetBaseObj.SolutionName;
                FRM_EditVoidCommitmentNo.TenantName     = SetBaseObj.TenantName;
                FRM_EditVoidCommitmentNo.WidgetName     = "SP_CommitmentWidget";
                
                ShowCurrencyPanel       = (ALPanel)SBS_Commitment.FindControl("ShowCurrencyPanel");
                Lbl_ShowPlanCurrency    = (ALLiteralControl)ShowCurrencyPanel.FindControl("Lbl_ShowPlanCurrency");                
                Lbl_ShowChangedCurrency = (ALLiteralControl)ShowCurrencyPanel.FindControl("Lbl_ShowChangedCurrency");
                if (Session["MULTICURRENCYVIEW"] != null && Session["MULTICURRENCYVIEW"].ToString() == "true")
                {
                    ShowCurrencyPanel.Attributes.Add("Style", "visibility:visible;display:block;");

                    Lbl_ShowPlanCurrency.Text       = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_ROPlanDetails_PlanCurrency") + " " + Session["PLANCURRENCY"].ToString();
                    Lbl_ShowChangedCurrency.Text    = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_SelectedCurrency_Shared") + " " + Session["SELECTEDCURRENCY"].ToString();
                }
                else
                {
                    ShowCurrencyPanel.Attributes.Add("Style", "visibility:hidden;display:none;");
                }

                //Set Vendor Info properties
                Popup_VendorInfo.TenantName         = SetBaseObj.TenantName;
                Popup_VendorInfo.ImageAlignment     = eImageAlignment.Disable;
                Popup_VendorInfo.PopupHeight        = 300;
                Popup_VendorInfo.PopupWidth         = 400;
                Popup_VendorInfo.CaptionText        = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_VendorManagment_VendorInformation_Shared");
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "SetControls", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        void AB_ROCommitmentDetails_ActionBarClick(object sender, EventArgs arg)
        {
            String          ParameterString     = null;
            String[]        Parameters          = null;
            ERRORXML        ErrorXML            = null;
            
            try
            {
                ParameterString     = (String)sender;
                Parameters          = ParameterString.Split(Separator, 3, StringSplitOptions.RemoveEmptyEntries);

                switch (Parameters[1])
                {
                    case "btn_VoidCommitment":  VoidCommitment();                       
                                                break;
                    case "btn_SaveVoidCommitment": ErrorXML = MarkCommitmentAsVoid();
                                                    if (ErrorXML == null)
                                                    {
                                                        BubbleVoidCommitmentEvent(arg);
                                                    }
                                                break;
                    case "btn_SaveEditVoidCommitmentNo": ErrorXML = UpdateVoidCommitmentNo();
                                                      break;
                    case "btn_CommitmentApprove":
                        {
                            RedirectToApprovals("CommitmentDetails.rpt", "Commitment_Approval", "CommitmentApproval");
                        }
                        break;
                    case "btn_GeneratePO":
                        {
							RedirectToApprovals("PurchaseOrderDetails.rpt", "PO_Approval", "VendorApproval");
                        } break;        
                    default :
                        break;
                }

                if (ErrorXML != null)
                {
                    CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, "SP_Commitmentwidget", "COMMITMENT", ErrorXML, null, null, BackUrl.ToString(), ref ErrorPageURL);
                    if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                    }
                }                      
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "AB_ROCommitmentDetails_ActionBarClick", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

         private void RedirectToApprovals(String ReportFileName,String PDFFileName,String JobType)
        {
            StringBuilder       ParamURL            = new StringBuilder(100);
            StringBuilder       SrcFilePath         = new StringBuilder(100);
            String              EncryptURL          = null;
			String				BrdCrm				= null;

            try
            {
                SrcFilePath.AppendFormat("{0}{1}.xml", ALSolutionCommon.GetTempPath(SetBaseObj.SessionID.ToString()), CommitmentID.ToString());
				BrdCrm = generateBreadcrumb();
                ParamURL.AppendFormat("/{0}/Reports/Commitment Details/CommitmentDetails.aspx?", SetBaseObj.TenantName);
				ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&BREADCRUMBNAME=CommitmentBreadcrumb&PARENTBREADCRUMBNAME={10}&BREADCRUMBID={11}&BREADCRUMBXML={12}&BreadCrumCmtFilePath={13}", SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language, SetBaseObj.SolutionName, CommitmentID, TaskPaneList, this.Page.MasterPageFile, this.Page.Theme, SourceAttributes,this.ParentBreadcrumbName, this.ParentBreadcrumbID, this.BreadcrumbXML, BrdCrm);
                ParamURL.AppendFormat("&CommitmentAccess={0}&CommitmentMode={1}&ApprovalsAccess={2}&ApprovalsMode={3}", AccessMode, Mode, "Write", "");
            
                if (SetBaseObj.IsCustomized)
                {
                    ParamURL.Append("&IsCustomized=true");
                }
                else
                {
                    ParamURL.Append("&IsCustomized=false");
                }

                ParamURL.AppendFormat("&CommitmentTempFilePath={0}&ReportFileName={1}&PDFFileName={2}&ApprovalJobType={3}&VendorResource={4}", SrcFilePath.ToString(), ReportFileName, PDFFileName, JobType, VendorResource);
                EncryptURL = CommonFunctionObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(EncryptURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + EncryptURL + "','_self','');");
                }
            }
            catch (Exception obj_Exception)
            {
                throw obj_Exception;
            }
        }

        void Commitment_Tab_onTabClick(object Sender, TabClickEventarg TabclickEventarg)
        {
            if (!IsPostBack && IsCommitmentApprovalEnabled)
            {
                ListFacadeObj = new ListFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                ApprovalsObj  = new ApprovalsFacadeClass(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                MWBFacadeObj  = new MktgWorkBenchFacadeClass(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
            
                StringBuilder sb_CommitmentApprovalJobSearch = new StringBuilder(300);
                StringBuilder sb_VendorApprovalJobSearch = new StringBuilder(300);
                StringBuilder sb_PeSearchXML = new StringBuilder(200);
                sb_PeSearchXML.AppendFormat(@"<FILTERLIST>
                                            <FILTER>
	                                            <FILTERID>1</FILTERID>
	                                            <OPERATOR>EQUALTO</OPERATOR>
	                                            <EXPRESSION>WORKFLOWCATEGORY</EXPRESSION>
	                                            <EXPRESSIONVALUE>SP_COMMITMENTAPPROVALSJOB</EXPRESSIONVALUE>
	                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                            <RELATIONSHIPNAME>WORKFLOWPROCESS_WORKFLOWINFORMATION</RELATIONSHIPNAME>
                                            </FILTER>
                                            <FILTER>
	                                            <FILTERID>2</FILTERID>
	                                            <OPERATOR>IN</OPERATOR>
	                                            <EXPRESSION>STATUS</EXPRESSION>
	                                            <EXPRESSIONVALUE>('New','Draft','Active','Completed','Cancelled')</EXPRESSIONVALUE>
	                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                            </FILTER>");

                sb_CommitmentApprovalJobSearch.AppendFormat(@"{0}<FILTER>
	                                            <FILTERID>3</FILTERID>
	                                            <OPERATOR>EQUALTO</OPERATOR>
	                                            <EXPRESSION>COMMITMENTID</EXPRESSION>
	                                            <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
	                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                <RELATIONSHIPNAME>COMMITMENT_WFP_APPROVAL</RELATIONSHIPNAME>
                                            </FILTER></FILTERLIST>", sb_PeSearchXML.ToString(), CommitmentID.ToString());
                showCommitmeApprovalJobList(sb_CommitmentApprovalJobSearch.ToString());

                sb_VendorApprovalJobSearch.AppendFormat(@"{0}<FILTER>
	                                            <FILTERID>4</FILTERID>
	                                            <OPERATOR>EQUALTO</OPERATOR>
	                                            <EXPRESSION>COMMITMENTID</EXPRESSION>
	                                            <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
	                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                <RELATIONSHIPNAME>COMMITMENT_WFP_VENDOR</RELATIONSHIPNAME>
                                            </FILTER></FILTERLIST>", sb_PeSearchXML.ToString(), CommitmentID.ToString());
                showVendorApprovalJobList(sb_VendorApprovalJobSearch.ToString());
            }
        }

        void BubbleVoidCommitmentEvent(EventArgs e)
        {
            EventHandler VoidCommitmentEvent = (EventHandler)this.Events[ObjVoidCommitment];
            if (VoidCommitmentEvent != null)
            {
                VoidCommitmentEvent(this, e);
            }
        }

		void VoidCommitment()
        {
            XPathDocument   CommitmentXMLDoc    = null;
            XPathNavigator  XPathNav            = null;

            try
            {
                if (!String.IsNullOrEmpty((String)this.ViewState["COMMITMENTDETAILS"]))
                {
                    CommitmentXMLDoc    = new XPathDocument(new StringReader((String)this.ViewState["COMMITMENTDETAILS"]));
                    XPathNav            = CommitmentXMLDoc.CreateNavigator();
                    if (XPathNav.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_TO_INVOICE/INVOICE") == null)
                    {
                       ((ALAjaxPage)Page).Ajax.WriteExecuteJavaScript(ALPC_VoidCommitment.ShowPopupWindowJavascript);
                    }
                    else
                    {
                        ((ALAjaxPage)Page).Ajax.WriteExecuteJavaScript("javascript:alert('" + Localization.GetString("ALJSResource", SetBaseObj.TenantName, "Alert_SP_CommitmentDetailsRO_VoidCommitment_InvoicesNotAllowed") + "');");                        
                    }
                 }
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "VoidCommitment", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }                
            }
        }
		
		ERRORXML MarkCommitmentAsVoid()
        {
            XmlDocument         CommitmentXMLDoc    = null;
            XmlNode             CommitmentNode      = null;
            XmlNode             FieldNode           = null;
            CommitmentFacade    CommitmentObj       = null;
            ERRORXML            ErrorXML            = null;

            try
            {
                CommitmentXMLDoc    = new XmlDocument();
                CommitmentNode      = CommitmentXMLDoc.CreateElement("COMMITMENT");
                
                FieldNode           = CommitmentXMLDoc.CreateElement("COMMITMENTID");
                FieldNode.InnerText = CommitmentID.ToString();
                CommitmentNode.AppendChild(FieldNode);

                FieldNode           = CommitmentXMLDoc.CreateElement("STATUS");
                FieldNode.InnerText = "Void";
                CommitmentNode.AppendChild(FieldNode);

                FieldNode           = CommitmentXMLDoc.CreateElement("VOIDEDCOMMITNO");
                FieldNode.InnerText = FRM_VoidCommitment.GetValues("COMMITMENT_VOIDEDCOMMITNO");
                CommitmentNode.AppendChild(FieldNode);

                FieldNode           = CommitmentXMLDoc.CreateElement("REASONFORVOID");
                FieldNode.InnerText = FRM_VoidCommitment.GetValues("COMMITMENT_REASONFORVOID");
                CommitmentNode.AppendChild(FieldNode);

                CommitmentObj       = new CommitmentFacade(SetBaseObj.SessionID, SetBaseObj.UserID,
                                                    SetBaseObj.TenantName, SetBaseObj.Language);
                ErrorXML            = CommitmentObj.MarkCommitmentAsVoid(CommitmentNode.OuterXml);
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "MarkCommitmentAsVoid", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            return ErrorXML;
        }
        void InvoiceList_BatchReconcile(object sender, EventArgs e)
        {
            GetCommitmentDetails(CommitmentID);
        }

        void InvoiceList_DeleteInvoiceClick(object sender, EventArgs e)
        {
            try
            {
                GetCommitmentDetails(0);
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "InvoiceList_DeleteInvoiceClick", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        /// <summary>
        /// Function which reads InitialCommittedAmount and assigns to variable 'OutstandingCommittedAmount'
        /// Function written by Parita Harniya on 4 July 2008
        /// </summary>
        void GetCommitmentAmount()
        {            
            StringBuilder SrcFilePath                           = null;
            String FileName                                     = null;
            String TempFilePath                                 = null;
            XPathDocument xpDoc_CommitmentDetailsXML            = null;
            XPathNavigator xpNav_CommitmentDetailsRootElement   = null;
            XPathNavigator xpNav_AmountElement                  = null;

            TempFilePath = ALSolutionCommon.GetTempPath(SetBaseObj.SessionID.ToString());

            FileName = CommitmentID.ToString() + ".xml";
            SrcFilePath = new StringBuilder();
            SrcFilePath.AppendFormat("{0}{1}", TempFilePath, FileName);

            xpDoc_CommitmentDetailsXML = new XPathDocument(SrcFilePath.ToString());
            xpNav_CommitmentDetailsRootElement = xpDoc_CommitmentDetailsXML.CreateNavigator();
            xpNav_AmountElement = xpNav_CommitmentDetailsRootElement.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/OUTSTANDINGCOMMITTEDAMOUNT/AMOUNT");

            if (xpNav_AmountElement != null)
            {
                try
                {
                    OutstandingCommittedAmount = double.Parse(xpNav_AmountElement.InnerXml);
                }
                catch (Exception )
                {
                    OutstandingCommittedAmount = 0;
                }
            }
        }

        void GetCommitmentDetails(UInt64 SourceEntityID)
        {
            XmlElement SearchElement = null;
            String TempFilePath = null;
            String FileName = null;
            String strAssociationXML = null;
            String FormConfigXMLPath = null;
            StringBuilder FilterXML = null; 
            StringBuilder SrcFilePath = null;
            ERRORXML ErrorXML = null;
            XML ReturnCommitmentDetails = null;
            String strFormInputXml = null;
            String ReturnList = null;
            String ListConfigXML = null;
            XmlElement CommitmentTitle = null;
            System.IO.FileStream FileStreamObj = null;
            System.IO.StreamWriter StreamWriterObj = null;
            String str_BreadcrumbXML = null;
            String str_VendorResourceName = null;
            XPathNavigator CommitmentDetail_Nav = null;
            XPathNavigator xp_nav = null;
            XPathDocument xp_FrmConfigXML = null;
            XmlDocument FormInputXml = null;
            XmlDocument CommitmentDetailXML = null;
            XmlDocument SearchInputXML = null;
            
            XmlNode FieldListNode = null;
            ListFacade LST = null;

            StrategicPlanner_Helper HelperObj = null;

            StringBuilder PersonalizationFilePath = null;

			String FirstName = null;
			String LastName = null;
			String LoginName = null;
			StringBuilder urlParam = null;
			XmlElement temp_element = null;

            String  str_VendorID    = null;
            String  str_VendorURL   = null;
            XmlNode xmlnode_Vendor  = null;
            String  str_VendorName  = null;
            XPathNavigator xnav_VendorID = null;

            try
            {
                FormInputXml = new XmlDocument();
                SearchInputXML = new XmlDocument();
                CommitmentDetailXML = new XmlDocument();
                LST = new ListFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                //for form control
                TempFilePath = ALSolutionCommon.GetTempPath(SetBaseObj.SessionID.ToString());
                FileName = CommitmentID.ToString() + ".xml";
                SrcFilePath = new StringBuilder();
                SrcFilePath.AppendFormat("{0}{1}", TempFilePath, FileName);
                FormFacade FormObj = new FormFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                if (SetBaseObj.IsCustomized)
                {
                    FormConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName,SetBaseObj.SolutionName, "SP_CommitmentWidget", "FRM_CommitmentDetails_FormConfiguration");
                }
                else
                {
                    FormConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, "", "SP_CommitmentWidget", "FRM_CommitmentDetails_FormConfiguration");
                }

                HelperObj = new StrategicPlanner_Helper(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                HelperObj.GetAssociationXMLEx("", FormConfigXMLPath, ref strAssociationXML);

                FilterXML = new StringBuilder();
                FilterXML.AppendFormat(@"<SEARCH>
                                            <TARGETOBJECT>COMMITMENT</TARGETOBJECT>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{5}'/>
                                            <TARGETENTITY>
                                                <PRIVILEGENAME>READ</PRIVILEGENAME>                                                        
                                                <FILTERLIST>
                                                    <FILTER>
		                                                <FILTERID>1</FILTERID>
		                                                <EXPRESSION>COMMITMENTID</EXPRESSION>
		                                                <OPERATOR>EQUALTO</OPERATOR>
		                                                <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
		                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                                
	                                                </FILTER>
                                                </FILTERLIST>
                                                <SELECTLIST>
                                                    <EXPRESSION>
                                                        <FIELDNAME>COMMITMENTID</FIELDNAME>
                                                        <ALIAS>COMMITMENTID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>COMMITMENTNUMBER</FIELDNAME>
                                                        <ALIAS>COMMITMENTNUMBER</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>TITLE</FIELDNAME>
                                                        <ALIAS>TITLE</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                        <ALIAS>DESCRIPTION</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>CURRENCYTYPE</FIELDNAME>
                                                        <ALIAS>CURRENCYTYPE</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>INITIALCOMMITTEDAMOUNT</FIELDNAME>
                                                        <ALIAS>INITIALCOMMITTEDAMOUNT</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>STATUS</FIELDNAME>
                                                        <ALIAS>STATUS</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>CREATEDON</FIELDNAME>
                                                        <ALIAS>CREATEDON</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>COMMITTEDON</FIELDNAME>
                                                        <ALIAS>COMMITTEDON</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>DUEON</FIELDNAME>
                                                        <ALIAS>DUEON</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>LASTUPDATEDON</FIELDNAME>
                                                        <ALIAS>LASTUPDATEDON</ALIAS>
                                                    </EXPRESSION>
                                                   <EXPRESSION>
                                                        <FIELDNAME>NOTIFYONACCEPT</FIELDNAME>
                                                        <ALIAS>NOTIFYONACCEPT</ALIAS>
                                                    </EXPRESSION>
                                                   <EXPRESSION>
                                                        <FIELDNAME>CLOSURENOTES</FIELDNAME>
                                                        <ALIAS>CLOSURENOTES</ALIAS>
                                                    </EXPRESSION>
                                                     <EXPRESSION>
                                                        <FIELDNAME>REASONFORVOID</FIELDNAME>
                                                        <ALIAS>REASONFORVOID</ALIAS>
                                                    </EXPRESSION>
                                                   <EXPRESSION>
                                                        <FIELDNAME>ATTACHMENTS</FIELDNAME>
                                                        <ALIAS>ATTACHMENTS</ALIAS>
                                                    </EXPRESSION>
                                                   <EXPRESSION>
                                                        <FIELDNAME>OUTSTANDINGCOMMITTEDAMOUNT</FIELDNAME>
                                                        <ALIAS>OUTSTANDINGCOMMITTEDAMOUNT</ALIAS>
                                                    </EXPRESSION>   
                                                    <EXPRESSION>
                                                            <FIELDNAME>LASTUPDATEDON</FIELDNAME>
                                                            <ALIAS>LASTUPDATEDON</ALIAS>
                                                    </EXPRESSION>       
                                                    <EXPRESSION>
                                                        <FIELDNAME>VOIDEDCOMMITNO</FIELDNAME>
                                                        <ALIAS>VOIDEDCOMMITNO</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>REVISEDCOMMITNO</FIELDNAME>
                                                        <ALIAS>REVISEDCOMMITNO</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>PODATE</FIELDNAME>
                                                        <ALIAS>PODATE</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                         <FIELDNAME>VACKNOWLEDGEDATE</FIELDNAME>
                                                         <ALIAS>VACKNOWLEDGEDATE</ALIAS>
                                                    </EXPRESSION>   
                                                    <EXPRESSION>
                                                         <FIELDNAME>CONTINUEDFLAG</FIELDNAME>
                                                         <ALIAS>CONTINUEDFLAG</ALIAS>
                                                    </EXPRESSION>                                                                                            
                                                </SELECTLIST>
                                                {4}
                                                <RELATIONSHIP NAME='COMMITMENT_LINEITEM'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>SEQUENCEORDER</FIELDNAME>
                                                            <ALIAS>SEQUENCEORDER</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                            <FIELDNAME>LINEITEMSID</FIELDNAME>
                                                            <ALIAS>LINEITEMSID</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                            <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                            <ALIAS>DESCRIPTION</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                            <FIELDNAME>RATE</FIELDNAME>
                                                            <ALIAS>RATE</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                            <FIELDNAME>ITEMAMOUNT</FIELDNAME>
                                                            <ALIAS>ITEMAMOUNT</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                            <FIELDNAME>MARKETINGCOSTCATEGORY</FIELDNAME>
                                                            <ALIAS>MARKETINGCOSTCATEGORY</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                            <FIELDNAME>RATEUNITS</FIELDNAME>
                                                            <ALIAS>RATEUNITS</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>QUANTITY</FIELDNAME>
                                                            <ALIAS>QUANTITY</ALIAS>
                                                        </EXPRESSION>                                                               
                                                    </SELECTLIST>
                                                    <SORTLIST>
                                                        <SORTEXPRESSION>
                                                            <SORTORDER>ASC</SORTORDER>
                                                            <COLUMNNAME>SEQUENCEORDER</COLUMNNAME>
                                                        </SORTEXPRESSION>
                                                    </SORTLIST>                                                            
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='CONTINUED_COMMITMENT' HIERARCHY='BOTTOMUP'>
                                                    <SELECTLIST>                                                       
                                                        <EXPRESSION>
                                                            <FIELDNAME>COMMITMENTID</FIELDNAME>
                                                            <ALIAS>COMMITMENTID</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>OUTSTANDINGCOMMITTEDAMOUNT</FIELDNAME>
                                                            <ALIAS>OUTSTANDINGCOMMITTEDAMOUNT</ALIAS>
                                                        </EXPRESSION>                                                            
                                                    </SELECTLIST>                                                                                                                                                                   
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='COMMITMENT_TO_VENDOR'>
                                                      <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>VENDORSID</FIELDNAME>
                                                            <ALIAS>VENDORSID</ALIAS>
                                                        </EXPRESSION>
                                                         <EXPRESSION>
                                                            <FIELDNAME>NAME</FIELDNAME>
                                                            <ALIAS>NAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                                <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                                <ALIAS>DESCRIPTION</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>VENDORTYPE</FIELDNAME>
                                                                <ALIAS>VENDORTYPE</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>URL</FIELDNAME>
                                                                <ALIAS>URL</ALIAS>
                                                        </EXPRESSION>                                                                                                      
                                                    </SELECTLIST>
												<RELATIONSHIP NAME='VENDOR_VENDORINFO'>
												<SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>VENDORADDRESS</FIELDNAME>
                                                            <ALIAS>VENDORADDRESS</ALIAS>
                                                        </EXPRESSION>
												</SELECTLIST>
												</RELATIONSHIP>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='COMMITMENT_CREATOR'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>USERID</FIELDNAME>
                                                            <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                         <EXPRESSION>
                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                            <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>   
														<EXPRESSION>
                                                                    <FIELDNAME>EMAILID</FIELDNAME>
                                                                    <ALIAS>EMAILID</ALIAS>
                                                         </EXPRESSION>
														<EXPRESSION>
                                                                     <FIELDNAME>PHONENUMBER</FIELDNAME>
                                                                     <ALIAS>PHONENUMBER</ALIAS>
                                                         </EXPRESSION>                                                
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='COMMITMENT_MODIFIER'>   
                                                    <SELECTLIST>
                                                         <EXPRESSION>
                                                            <FIELDNAME>USERID</FIELDNAME>
                                                            <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                         <EXPRESSION>
                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                            <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>                                                        
                                                    </SELECTLIST>   
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='COMMITMENT_PAYMENTINSTALLMENT'> 
                                                     <SELECTLIST>
                                                         <EXPRESSION>
                                                            <FIELDNAME>PAYMENTINSTALLMENTID</FIELDNAME>
                                                            <ALIAS>PAYMENTINSTALLMENTID</ALIAS>
                                                        </EXPRESSION>
                                                         <EXPRESSION>
                                                            <FIELDNAME>DUEON</FIELDNAME>
                                                            <ALIAS>DUEON</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                                <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                                <ALIAS>DESCRIPTION</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>INSTALLMENTAMOUNT</FIELDNAME>
                                                                <ALIAS>INSTALLMENTAMOUNT</ALIAS>
                                                        </EXPRESSION>
                                                       <EXPRESSION>
                                                                <FIELDNAME>STATUS</FIELDNAME>
                                                                <ALIAS>STATUS</ALIAS>
                                                        </EXPRESSION>                                                        
                                                    </SELECTLIST>   
                                                    <SORTLIST>
                                                        <SORTEXPRESSION>
                                                            <SORTORDER>ASC</SORTORDER>
                                                            <COLUMNNAME>DUEON</COLUMNNAME>
                                                        </SORTEXPRESSION>
                                                    </SORTLIST>                                                      
                                                </RELATIONSHIP>
                                               	<RELATIONSHIP NAME='COMMITMENT_TO_INVOICE'> 
                                                     <SELECTLIST>
                                                         <EXPRESSION>
                                                            <FIELDNAME>INVOICEID</FIELDNAME>
                                                            <ALIAS>INVOICEID</ALIAS>
                                                        </EXPRESSION>
                                                     </SELECTLIST>   
                                                 </RELATIONSHIP> 	
                                                  <RELATIONSHIP NAME='COMMITMENT_VENDORCONTACT'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
	                                                            <ALIAS>LOGINNAME</ALIAS>
                                                            </EXPRESSION>
                                                             <EXPRESSION>
	                                                            <FIELDNAME>USERID</FIELDNAME>
	                                                            <ALIAS>USERID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
						                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
						                                        <ALIAS>FIRSTNAME</ALIAS>
						                                    </EXPRESSION>
					                                        <EXPRESSION>
					                                            <FIELDNAME>LASTNAME</FIELDNAME>
					                                            <ALIAS>LASTNAME</ALIAS>
					                                         </EXPRESSION>
                                                        </SELECTLIST>
                                                 </RELATIONSHIP>
                                                   <RELATIONSHIP NAME='COMMITMENT_WFP_APPROVAL'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
	                                                            <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>STATUS</FIELDNAME>
	                                                            <ALIAS>STATUS</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
				                                                <FIELDNAME>REVIEWSTATUS</FIELDNAME>
				                                                <ALIAS>REVIEWSTATUS</ALIAS>
			                                                 </EXPRESSION>
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
		                                                        <FILTERID>1</FILTERID>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>Completed</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                            <FILTER>
		                                                        <FILTERID>2</FILTERID>
		                                                        <EXPRESSION>REVIEWSTATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>Approved</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                            <FILTER>
		                                                        <FILTERID>3</FILTERID>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>Active</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>    
                                                             <FILTER>
		                                                        <FILTERID>4</FILTERID>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>New</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>    
                                                            <FILTERCOMBINATION>((1)AND(2))OR (3)OR (4)</FILTERCOMBINATION>
                                                        </FILTERLIST>
		                                         </RELATIONSHIP>
                                                 <RELATIONSHIP NAME='COMMITMENT_WFP_VENDOR'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
	                                                            <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>STATUS</FIELDNAME>
	                                                            <ALIAS>STATUS</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
				                                                <FIELDNAME>REVIEWSTATUS</FIELDNAME>
				                                                <ALIAS>REVIEWSTATUS</ALIAS>
			                                                 </EXPRESSION>
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
		                                                        <FILTERID>1</FILTERID>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>Completed</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                            <FILTER>
		                                                        <FILTERID>2</FILTERID>
		                                                        <EXPRESSION>REVIEWSTATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>Approved</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                            <FILTER>
		                                                        <FILTERID>3</FILTERID>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>Active</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>    
                                                             <FILTER>
		                                                        <FILTERID>4</FILTERID>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>New</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>    
                                                            <FILTERCOMBINATION>((1)AND(2))OR (3)OR (4)</FILTERCOMBINATION>
                                                        </FILTERLIST>
		                                         </RELATIONSHIP>   
                                             </TARGETENTITY>
                                          </SEARCH>", SetBaseObj.Language, SetBaseObj.TenantName, SetBaseObj.UserID, CommitmentID, strAssociationXML, SetBaseObj.SessionID);

                CommitmentFacade CommitmentObj = new CommitmentFacade(SetBaseObj.SessionID, SetBaseObj.UserID,
                                                                         SetBaseObj.TenantName, SetBaseObj.Language);

                ErrorXML = CommitmentObj.GetCommitmentEx(FilterXML.ToString(), out ReturnCommitmentDetails); ;
                if (ErrorXML != null)
                {
                    CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, "SP_Commitmentwidget", "COMMITMENT", ErrorXML, null, null, BackUrl.ToString(), ref ErrorPageURL);
                    if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                else
                {
                    //Convert currency in case of MulitCurrencyView
                    if (MultiCurrencyView && !String.IsNullOrEmpty(SelectedCurrency))
                    {
                        ConvertedCurrencyDetails = "";
                        ReturnCommitmentDetails = "<SEARCHOUTPUTXML>" + ReturnCommitmentDetails + "</SEARCHOUTPUTXML>";
                        ObjCurrencyConvertor = new CurrencyConversionClass(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                        ErrorXML = ObjCurrencyConvertor.ConvertToCurrencyType(ReturnCommitmentDetails, SelectedCurrency, DateTime.Now, ref ConvertedCurrencyDetails);
                        if (String.IsNullOrEmpty(ErrorXML) && !String.IsNullOrEmpty(ConvertedCurrencyDetails))
                        {
                            ReturnCommitmentDetails = ConvertedCurrencyDetails;
                            ReturnCommitmentDetails = ReturnCommitmentDetails.Replace("<SEARCHOUTPUTXML>", "");
                            ReturnCommitmentDetails = ReturnCommitmentDetails.Replace("</SEARCHOUTPUTXML>", "");
                        }
                    }
                    //Assign the Binder XML
                    AssignBinderXML(ReturnCommitmentDetails);
                    CommitmentDetailXML.LoadXml(ReturnCommitmentDetails);
                    CommitmentDetailXML.Save(SrcFilePath.ToString());
                    this.ViewState["COMMITMENTDETAILS"] = ReturnCommitmentDetails;
                    //Also sets the commitment amount
                    XmlElement CommitmentStatus = (XmlElement)CommitmentDetailXML.DocumentElement.SelectSingleNode("COMMITMENT/STATUS");
                    if (CommitmentStatus != null)
                    {
                        String strStatus            = CommitmentStatus.InnerText;
                        this.ViewState["STATUS"]    = strStatus;                  
                    }

                    XmlElement VoidedCommitmentNo = (XmlElement)CommitmentDetailXML.DocumentElement.SelectSingleNode("COMMITMENT/VOIDEDCOMMITNO");
                    if (VoidedCommitmentNo != null)
                    {
                        this.ViewState["VOIDEDCOMMITNO"] = VoidedCommitmentNo.InnerText;
                    }

                    SetROActionBarInputXML(CommitmentDetailXML);
                    SaveSourceInformation(ReturnCommitmentDetails);
                    xp_nav = CommitmentDetailXML.CreateNavigator();
                    CommitmentDetail_Nav = xp_nav.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT");

                    //Set Vendor Resource ID
                    if (CommitmentDetail_Nav.SelectSingleNode("COMMITMENT_VENDORCONTACT/USER/USERID") != null)
                        VendorResource = CommitmentDetail_Nav.SelectSingleNode("COMMITMENT_VENDORCONTACT/USER/USERID").Value;

                    FieldListNode = FormInputXml.CreateElement("FieldList");
                    ((XmlElement)FieldListNode).SetAttribute("FormName", "FRM_CommitmentDetails");
                    FormInputXml.AppendChild(FieldListNode);

                    if (FormConfigXMLPath == "FILENOTFOUND")
                    {
                        Response.Redirect("../../../Common/ASPX/ShowError.aspx?Message=Form Configuration file not found.", false);
                    }

                    xp_FrmConfigXML = new XPathDocument(FormConfigXMLPath);
                    XPathNavigator xp_nav_FormConfig = xp_FrmConfigXML.CreateNavigator();
                    XPathNodeIterator xp_FieldNodes = xp_nav_FormConfig.Select("FormConfiguration/Form[@Name='FRM_CommitmentDetails']/Section/Column/Field");

					#region Get Requisitioner details and create URL
					XmlDocument commitment_Doc = new XmlDocument();
					commitment_Doc.LoadXml(ReturnCommitmentDetails);
					XPathNavigator xp_Nav_Commitment = commitment_Doc.CreateNavigator();
                    //Show Vendor Resource Name as User Name format
                    if (xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_VENDORCONTACT/USER") != null)
                    {
                        FirstName = xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_VENDORCONTACT/USER/FIRSTNAME").Value;
                        LastName  = xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_VENDORCONTACT/USER/LASTNAME").Value;
                        LoginName = xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_VENDORCONTACT/USER/LOGINNAME").Value;
                        str_VendorResourceName = ALCommon.FormatUserName(FirstName, LastName, "", LoginName, ALCommon.GetUserNameFormat());
                    }
					FirstName = xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_CREATOR/USER/FIRSTNAME").Value;
					LastName = xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_CREATOR/USER/LASTNAME").Value;
					LoginName = xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_CREATOR/USER/LOGINNAME").Value;

					urlParam = new StringBuilder(200);
					urlParam.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&RequestedUserID={4}&ThemeName=Default", SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language, xp_Nav_Commitment.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_CREATOR/USER/USERID").Value);
					String url = "/" + SetBaseObj.TenantName + "/Common/ASPX/ROUserDetails.aspx?" + urlParam.ToString();

					commitment_Doc.Load(FormConfigXMLPath);
					temp_element = (XmlElement)commitment_Doc.DocumentElement.SelectSingleNode("//*/Field[@Name='COMMITMENT_CREATOR']");
					temp_element.SetAttribute("URL", url);

					#endregion

					FormObj.ConfigurationXML = ConfigXMLPath;
					FormObj.FormName = "FRM_CommitmentDetails";
                    FormObj.ShowConfiguredFields = true;
                    FileStreamObj = new System.IO.FileStream(ConfigXMLPath, System.IO.FileMode.Create);
                    StreamWriterObj = new System.IO.StreamWriter(FileStreamObj);
					StreamWriterObj.Write(commitment_Doc.InnerXml);
                    StreamWriterObj.Close();
                    FileStreamObj.Close();                    

                    FormObj.GetFormInputXML("ReadOnly", ReturnCommitmentDetails, out strFormInputXml, out ObjList);

					commitment_Doc.LoadXml(strFormInputXml);
					temp_element = (XmlElement)commitment_Doc.SelectSingleNode("//*/Field[@Name='COMMITMENT_CREATOR']");
					XmlElement atr = commitment_Doc.CreateElement("Value");
					atr.InnerText = "<a href=\"" + CommonFunctionObj.EncodeURLForResponseRedirects(url) + "\" target='_blank'>" + ALCommon.FormatUserName(FirstName,LastName,"",LoginName,ALCommon.GetUserNameFormat()) + "</a>";
					temp_element.AppendChild(atr);

                    //Set URL to vendor name to view vendor information
                    xnav_VendorID = CommitmentDetail_Nav.SelectSingleNode("COMMITMENT_TO_VENDOR/VENDORS/VENDORSID");
                    if (xnav_VendorID != null)
                    {
                        str_VendorID    = xnav_VendorID.Value;
                        str_VendorURL   = "/" + SetBaseObj.TenantName + "/StrategicPlanner/ASPX/Administration_VendorDetails.aspx?SessionID=" + SetBaseObj.SessionID
                              + "&TenantName=" + SetBaseObj.TenantName + "&UserID=" + SetBaseObj.UserID
                              + "&Language=" + SetBaseObj.Language + "&VENDORSID=" + str_VendorID;
                        Popup_VendorInfo.NavigateURL = CommonFunctionObj.EncodeURLForResponseRedirects(str_VendorURL);

                        xmlnode_Vendor = commitment_Doc.SelectSingleNode("FieldList/Field[@Name='VENDORS_NAME_COMMITMENT_TO_VENDOR']");
                        if (xmlnode_Vendor != null)
                        {
                            str_VendorName          = xmlnode_Vendor.SelectSingleNode("Value").InnerXml;
                            xmlnode_Vendor.InnerXml = "<Value><a href=\"javascript:" + Popup_VendorInfo.ShowPopupWindowJavascript + "\">" + str_VendorName + "</a></Value>";
                        }
                    }

                    //Show Vendor Resource Name as User Name format
                    temp_element 	= (XmlElement)commitment_Doc.SelectSingleNode("//*/Field[@Name='USER_LOGINNAME_COMMITMENT_VENDORCONTACT']");
                    if (!String.IsNullOrEmpty(str_VendorResourceName))
                    {
                        atr = (XmlElement)temp_element.SelectSingleNode("Value");
                        atr.InnerText = str_VendorResourceName;
                        temp_element.AppendChild(atr);
                    }

                    #region Hide Vendor Resource & Requisitioner
                    if (!IsCommitmentApprovalEnabled)
                    {
                        temp_element = (XmlElement)commitment_Doc.DocumentElement.SelectSingleNode("Field[@Name='USER_LOGINNAME_COMMITMENT_VENDORCONTACT']");
                        if (temp_element != null)
                        {
                            temp_element.SetAttribute("FieldVisible", "False");
                        }

                        temp_element = (XmlElement)commitment_Doc.DocumentElement.SelectSingleNode("Field[@Name='COMMITMENT_CREATOR']");
                        if (temp_element != null)
                        {
                            temp_element.SetAttribute("FieldVisible", "False");
                        }
                    }
                    #endregion

                    strFormInputXml = commitment_Doc.OuterXml;
					
                    PersonalizationFilePath = new StringBuilder();
                    PersonalizationFilePath.Append(ALCommon.GetFormatXMLPath(SetBaseObj.TenantName));
                    
                    FRM_CommitmentDetails.ConfigurationXMLType = CustomControls.Form.InputType.XMLPath;
                    FRM_CommitmentDetails.InputXMLType = CustomControls.Form.InputType.InnerXML;
                    FRM_CommitmentDetails.PersonalizationFilePath = PersonalizationFilePath.ToString();
                    FRM_CommitmentDetails.ConfigurationXML = ConfigXMLPath;
                    AssignSourceAttributes(ref strFormInputXml);
                    FRM_CommitmentDetails.ResetBinders = true;
                    FRM_CommitmentDetails.InputXML = strFormInputXml;
                    //Facet Series
                    FRM_CommitmentDetails.ResetFacetSeriesFields();

                    XPathNavigator PaymentSchedule_Nav = CommitmentDetail_Nav.SelectSingleNode("COMMITMENT_PAYMENTINSTALLMENT");

                    if (PaymentSchedule_Nav != null)
                    {
                        SearchElement = SearchInputXML.CreateElement("SEARCHOUTPUTXML");
                        SearchElement.InnerXml = PaymentSchedule_Nav.OuterXml;
                        if (SetBaseObj.IsCustomized)
                        {
                            ListConfigXML = LST.GetConfigurationXML(SetBaseObj.SolutionName, "SP_CommitmentWidget", "GetCommitmentDetails_PaymentSchedule");
                        }
                        else
                        {
                            ListConfigXML = LST.GetConfigurationXML("", "SP_CommitmentWidget", "GetCommitmentDetails_PaymentSchedule");
                        }

                        LST.PrepareListXml(ListConfigXML, SearchElement.OuterXml, out ReturnList);
                    }
                    else
                    {
                        if (SetBaseObj.IsCustomized)
                        {
                            ListConfigXML = LST.GetConfigurationXML(SetBaseObj.SolutionName, "SP_CommitmentWidget", "GetCommitmentDetails_PaymentSchedule");
                        }
                        else
                        {
                            ListConfigXML = LST.GetConfigurationXML("", "SP_CommitmentWidget", "GetCommitmentDetails_PaymentSchedule");
                        }
                        if (SetBaseObj.IsCustomized)
                        {
                            LST.ReturnHeaderForEmptyList(SetBaseObj.SolutionName, "SP_CommitmentWidget", "GetCommitmentDetails_PaymentSchedule", ref ReturnList);
                        }
                        else
                        {
                            LST.ReturnHeaderForEmptyList("", "SP_CommitmentWidget", "GetCommitmentDetails_PaymentSchedule", ref ReturnList);
                        }
                    }

                    FileStreamObj = new System.IO.FileStream(PaymentScheduleListXMLPath, System.IO.FileMode.Create);
                    StreamWriterObj = new System.IO.StreamWriter(FileStreamObj);
                    StreamWriterObj.Write(ReturnList);
                    StreamWriterObj.Close();
                    FileStreamObj.Close();

                    LST_PaymentSchedule.InputType = Assetlink.CustomControls.ListControl.SourceType.XMLPath;
                    LST_PaymentSchedule.Source = PaymentScheduleListXMLPath;
                    LST_PaymentSchedule.PersonalizationFilePath = PersonalizationFilePath.ToString();

                    XPathNavigator CommitmentItems_Nav = CommitmentDetail_Nav.SelectSingleNode("COMMITMENT_LINEITEM");

                    if (CommitmentItems_Nav != null)
                    {
                        SearchElement = SearchInputXML.CreateElement("SEARCHOUTPUTXML");
                        SearchElement.InnerXml = CommitmentItems_Nav.OuterXml;
                        if (SetBaseObj.IsCustomized)
                        {
                            ListConfigXML = LST.GetConfigurationXML(SetBaseObj.SolutionName, "SP_CommitmentWidget", "GetCommitmentDetails_LineItems");
                        }
                        else
                        {
                            ListConfigXML = LST.GetConfigurationXML("", "SP_CommitmentWidget", "GetCommitmentDetails_LineItems");
                        }
                      
                        LST.PrepareListXml(ListConfigXML, SearchElement.OuterXml, out ReturnList);
                    }
                    else
                    {
                        if (SetBaseObj.IsCustomized)
                        {
                            LST.ReturnHeaderForEmptyList(SetBaseObj.SolutionName, "SP_CommitmentWidget", "GetCommitmentDetails_LineItems", ref ReturnList);
                        }
                        else
                        {
                            LST.ReturnHeaderForEmptyList(SetBaseObj.SolutionName, "SP_CommitmentWidget", "GetCommitmentDetails_LineItems", ref ReturnList);
                        }
                    }

                    FileStreamObj   = new System.IO.FileStream(CommitmentLineItemXMLPath, System.IO.FileMode.Create);
                    StreamWriterObj = new System.IO.StreamWriter(FileStreamObj);
                    StreamWriterObj.Write(ReturnList);
                    StreamWriterObj.Close();
                    FileStreamObj.Close();

                    LST_CommitmentItems.InputType = Assetlink.CustomControls.ListControl.SourceType.XMLPath;
                    LST_CommitmentItems.Source = CommitmentLineItemXMLPath;
                    LST_CommitmentItems.PersonalizationFilePath = PersonalizationFilePath.ToString();
                    InvoiceList.SourceAttributes = SourceEntityAttributeXML;

                    XPathNavigator Attachment_Nav = CommitmentDetail_Nav.SelectSingleNode("COMMITMENT_LINEITEM");
                }
                if (String.IsNullOrEmpty(ParentBreadcrumbID) && (!String.IsNullOrEmpty(BreadcrumbXML)) && (System.IO.File.Exists(BreadcrumbXML)))
                {
                    str_BreadcrumbXML                  = System.IO.File.ReadAllText(BreadcrumbXML);
                    if (!IsPostBack)
                    {
                        ProcessBreadCrumbXML(ref str_BreadcrumbXML);
                    }
                    this.CommitmentBreadcrumb.InputXml = str_BreadcrumbXML;
                    ParentBreadcrumbID                 = CommitmentBreadcrumb.BreadcrumbUniqueID;
                }
                if (!IsPostBack)
                {
                    this.CommitmentBreadcrumb.NavigateUrl = this.Request.Url.AbsoluteUri;
                }
                CommitmentTitle                       = (XmlElement)CommitmentDetailXML.DocumentElement.SelectSingleNode("COMMITMENT/TITLE");                
                this.CommitmentBreadcrumb.DisplayText = CommitmentTitle.InnerText;

            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "GetCommitmentDetails", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        #region Common_Functions
        protected String GetMonthValue(String sMonthName)
        {
            string GetMonthValue = "";
            switch (sMonthName)
            {
                case "January":
                    GetMonthValue = "1";
                    break;
                case "February":
                    GetMonthValue = "2";
                    break;
                case "March":
                    GetMonthValue = "3";
                    break;
                case "April":
                    GetMonthValue = "4";
                    break;
                case "May":
                    GetMonthValue = "5";
                    break;
                case "June":
                    GetMonthValue = "6";
                    break;
                case "July":
                    GetMonthValue = "7";
                    break;
                case "August":
                    GetMonthValue = "8";
                    break;
                case "September":
                    GetMonthValue = "9";
                    break;
                case "October":
                    GetMonthValue = "10";
                    break;
                case "November":
                    GetMonthValue = "11";
                    break;
                case "December":
                    GetMonthValue = "12";
                    break;
            }
            return GetMonthValue;
        }

        protected String GetMonthName(String sMonthNum)
        {
            string GetMonthValue = "";
            switch (sMonthNum)
            {
                case "1":
                    GetMonthValue = "January";
                    break;
                case "2":
                    GetMonthValue = "February";
                    break;
                case "3":
                    GetMonthValue = "March";
                    break;
                case "4":
                    GetMonthValue = "April";
                    break;
                case "5":
                    GetMonthValue = "May";
                    break;
                case "6":
                    GetMonthValue = "June";
                    break;
                case "7":
                    GetMonthValue = "July";
                    break;
                case "8":
                    GetMonthValue = "August";
                    break;
                case "9":
                    GetMonthValue = "September";
                    break;
                case "10":
                    GetMonthValue = "October";
                    break;
                case "11":
                    GetMonthValue = "November";
                    break;
                case "12":
                    GetMonthValue = "December";
                    break;
            }
            return GetMonthValue;
        }
        #endregion Common_Functions

        void DisplayEditButton()
        {
            if (this.ViewState["STATUS"] != null)
            {
                String Status = (String)this.ViewState["STATUS"];
                if (Status.ToUpper().Equals("CLOSED") || Status.ToUpper().Equals("CONTINUED"))
                {
                  if (!IsPostBack)
                  {
                      InvoiceList.Mode = "LISTREADONLY";
                  }
                }
            }
        }

        protected void ATN_Commitment_Click(object sender, EventArgs e)
        {
            String ParameterString = (String)sender;
            String[] Parameters = ParameterString.Split(Separator, 3, StringSplitOptions.RemoveEmptyEntries);
            switch (Parameters[1])
            {
                case "BTN_EditCommitment": break;
                case "BTN_CloseCommitment":
                    break;
            }
        }

        void HandleCloseCommitment()
        {
            
            if (this.ViewState["COMMITMENTDETAILS"] != null)
            {
                ERRORXML ErrorXML = null;
                XmlDocument CommitmentDetails = new XmlDocument();
                CommitmentDetails.LoadXml((String)this.ViewState["COMMITMENTDETAILS"]);
                XmlElement CommitmentElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT");
                XmlElement StatusElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/STATUS");
                if (StatusElement != null)
                {
                    StatusElement.InnerText = "Closed";
                }
                XmlElement ClosureElement = null;
                ClosureElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/CLOSURENOTES");
                if (ClosureElement != null)
                {
                    ClosureElement.InnerText = FRM_CloseCommitment.GetValues("COMMITMENT_CLOSURENOTES");
                }
                else
                {
                    ClosureElement              = CommitmentDetails.CreateElement("CLOSURENOTES");
                    ClosureElement.InnerText    = FRM_CloseCommitment.GetValues("COMMITMENT_CLOSURENOTES");
                    CommitmentElement.AppendChild(ClosureElement);
                }
                XmlElement RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/COMMITMENT_TO_VENDOR");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/COMMITMENT_PAYMENTINSTALLMENT");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/COMMITMENT_LINEITEM");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/FILESYSTEM");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/COMMITMENT_CREATOR");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/COMMITMENT_MODIFIER");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                RelationElement = (XmlElement)CommitmentDetails.DocumentElement.SelectSingleNode("COMMITMENT/LASTUPDATEDON");
                if (RelationElement != null)
                {
                    CommitmentElement.RemoveChild(RelationElement);
                }
                CommitmentFacade CommitmentObj = new CommitmentFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                XML CommitmentXML = CommitmentDetails.DocumentElement.InnerXml;

                ErrorXML = CommitmentObj.UpdateCommitment(ref CommitmentXML);

                if (ErrorXML != null)
                {
                    if (ErrorXML.Contains("ISPLANLOCKEDFORBULKUPDATES"))
                    {
                        //Get the plan id from errorxml
                        XPathDocument xDocument = new XPathDocument(new System.IO.StringReader(ErrorXML));
                        XPathNavigator xNavigator = xDocument.CreateNavigator();
                        XPathNavigator xDataNavigator = xNavigator.SelectSingleNode("descendant::PLANID");
                        String str_ErrorMessage = null;
                        String str_PlanID = xDataNavigator.Value;

                        //get the errormessage
                        BulkUpdatesFacade objBuckUpdateFacde = new BulkUpdatesFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                        objBuckUpdateFacde.IsPlanLocked(str_PlanID, "PLAN", ref str_ErrorMessage);

                        BackUrl = new StringBuilder(100);
                        BackUrl.AppendFormat("/" + SetBaseObj.TenantName + "/StrategicPlanner/ASPX/Planner_Planlist.aspx?SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}", SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language, SetBaseObj.SolutionName);
                        CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, str_ErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                    }
                    else
                    CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", ErrorXML, null, null, BackUrl.ToString(), ref ErrorPageURL);
                    if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return;
                }
            }
        }

        ERRORXML UpdateVoidCommitmentNo()
        {
            XmlDocument         CommitmentXMLDoc    = null;
            XmlNode             CommitmentNode      = null;
            XmlNode             FieldNode           = null;
            CommitmentFacade    CommitmentObj       = null;
            ERRORXML            ErrorXML            = null;
            XML                 CommitmentXML       = null;

            try
            {
                CommitmentXMLDoc    = new XmlDocument();
                CommitmentNode      = CommitmentXMLDoc.CreateElement("COMMITMENT");
                
                FieldNode           = CommitmentXMLDoc.CreateElement("COMMITMENTID");
                FieldNode.InnerText = CommitmentID.ToString();
                CommitmentNode.AppendChild(FieldNode);

                FieldNode           = CommitmentXMLDoc.CreateElement("VOIDEDCOMMITNO");
                FieldNode.InnerText = FRM_EditVoidCommitmentNo.GetValues("COMMITMENT_VOIDEDCOMMITNO");
                CommitmentNode.AppendChild(FieldNode);

                CommitmentObj       = new CommitmentFacade(SetBaseObj.SessionID, SetBaseObj.UserID,
                                                    SetBaseObj.TenantName, SetBaseObj.Language);

                CommitmentXML       = CommitmentNode.OuterXml;
                ErrorXML            = CommitmentObj.UpdateCommitmentFields(ref CommitmentXML);

                if (ErrorXML != null)
                {
                    if (ErrorXML.Contains("ISPLANLOCKEDFORBULKUPDATES"))
                    {
                        //Get the plan id from errorxml
                        XPathDocument xDocument = new XPathDocument(new System.IO.StringReader(ErrorXML));
                        XPathNavigator xNavigator = xDocument.CreateNavigator();
                        XPathNavigator xDataNavigator = xNavigator.SelectSingleNode("descendant::PLANID");
                        String str_ErrorMessage = null;
                        String str_PlanID = xDataNavigator.Value;

                        //get the errormessage
                        BulkUpdatesFacade objBuckUpdateFacde = new BulkUpdatesFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                        objBuckUpdateFacde.IsPlanLocked(str_PlanID, "PLAN", ref str_ErrorMessage);

                        BackUrl = new StringBuilder(100);
                        BackUrl.AppendFormat("/" + SetBaseObj.TenantName + "/StrategicPlanner/ASPX/Planner_Planlist.aspx?SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}", SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language, SetBaseObj.SolutionName);
                        CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, str_ErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                    }
                    else
                        CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", ErrorXML, null, null, BackUrl.ToString(), ref ErrorPageURL);
                    if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                else
                {
                    GetCommitmentDetails(CommitmentID);
                }
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "UpdateVoidCommitmentNo", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            return ErrorXML;
        }

        String FormURL(String Mode)
        {
            String URL;
            URL = "SessionID=" + SetBaseObj.SessionID + "&UserID=" + SetBaseObj.UserID + "&TenantName=" + SetBaseObj.TenantName + "&Language=" + SetBaseObj.Language + "&SolutionName=" + SetBaseObj.SolutionName + "&Mode=Edit" + "&CommitmentID=" + CommitmentID + "&TaskPaneList=" + TaskPaneList + "&MasterPageFile=" + this.Page.MasterPageFile + "&Theme=" + this.Page.Theme + "&SOURCEATTRIBUTES=" + SourceAttributes + "&AccessMode=" + AccessMode + "&BREADCRUMBNAME=" + this.ParentBreadcrumbName + "&BREADCRUMBID=" + this.ParentBreadcrumbID + "&BREADCRUMBXML=" + this.BreadcrumbXML;
            if (SetBaseObj.IsCustomized)
            {
                URL = URL + "&IsCustomized=true";
            }
            else
            {
                URL = URL + "&IsCustomized=false";
            }

            URL = CommonFunctionObj.EncryptURL(URL);
            return URL;
        }

        void SetButtonAttributes()
        {
            try
            {

            }
            catch (Exception )
            {
            }

        }

        void SaveSourceInformation(String CommitmentXML)
        {
            try
            {
                XmlDocument SourceAttribXML = null;
                XmlElement CommitmentElement = null;
                XPathDocument EntityXML = new XPathDocument(new System.IO.StringReader(CommitmentXML));
                SourceAttribXML = new XmlDocument();
                if (!String.IsNullOrEmpty(SourceAttributes) && System.IO.File.Exists(SourceAttributes))
                {
                    SourceAttribXML.Load(SourceAttributes);
                    StringBuilder SourceEntityXML = new StringBuilder();
                    XmlElement InvoiceElement = (XmlElement)SourceAttribXML.DocumentElement.SelectSingleNode("//*/SOURCEENTITY_FOR_INVOICE");
                    CommitmentElement = (XmlElement)SourceAttribXML.DocumentElement.SelectSingleNode("//*/SOURCEENTITY_FOR_COMMITMENT/SOURCEENTITYNAME/a");
                    if (InvoiceElement == null)
                    {
                        SourceEntityXML.Append("<SOURCEENTITY_FOR_INVOICE>");
                    }
                    XPathNavigator EntityRootElement = EntityXML.CreateNavigator();
                    XPathNavigator EntityElement = EntityRootElement.SelectSingleNode("//*/TITLE");
                    XPathNavigator OutstandingCommittedAmountElement = EntityRootElement.SelectSingleNode("//*/TITLE");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.AppendFormat("<SOURCEENTITYLABEL>{0}</SOURCEENTITYLABEL>", "Parent Path");
                        String url = HttpContext.Current.Request.Url.AbsolutePath;
                        StringBuilder ParamBuilder = new StringBuilder();
                        if (this.ViewState["STATUS"] == null)
                        {
                            ParamBuilder.AppendFormat("TenantName={0}&SessionID={1}&UserID={2}&Language={3}&SolutionName={4}&TaskPaneList={5}&CommitmentID={6}&Mode={7}&MasterPageFile={8}&Theme={9}&SOURCEATTRIBUTES={10}&AccessMode={11}&BREADCRUMBNAME={12}&BREADCRUMBID={13}&BREADCRUMBXML={14}", SetBaseObj.TenantName, SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.Language, SetBaseObj.SolutionName, TaskPaneList, CommitmentID, Mode, this.Page.MasterPageFile, this.Page.Theme, SourceAttributes, AccessMode, ParentBreadcrumbName, ParentBreadcrumbID, BreadcrumbXML);
                        }
                        else
                        {
                            ParamBuilder.AppendFormat("TenantName={0}&SessionID={1}&UserID={2}&Language={3}&SolutionName={4}&TaskPaneList={5}&CommitmentID={6}&Mode={7}&MasterPageFile={8}&Theme={9}&SOURCEATTRIBUTES={10}&AccessMode={11}&STATUS={12}&BREADCRUMBNAME={13}&BREADCRUMBID={14}&BREADCRUMBXML={15}", SetBaseObj.TenantName, SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.Language, SetBaseObj.SolutionName, TaskPaneList, CommitmentID, Mode, this.Page.MasterPageFile, this.Page.Theme, SourceAttributes, AccessMode, (String)this.ViewState["STATUS"], ParentBreadcrumbName, ParentBreadcrumbID, BreadcrumbXML);
                        }
                        SourceEntityXML.AppendFormat("<SOURCEENTITYNAME>{0}</SOURCEENTITYNAME>", "<a href='" + url + "?Param=" + CommonFunctionObj.EncryptURL(ParamBuilder.ToString()) + "'>" + CommitmentElement.InnerXml + " / " + EntityElement.InnerXml + "</a>");
                    }
                    EntityElement = EntityRootElement.SelectSingleNode("//*/INITIALCOMMITTEDAMOUNT");
                    OutstandingCommittedAmountElement = EntityRootElement.SelectSingleNode("//*/OUTSTANDINGCOMMITTEDAMOUNT");
                    if (OutstandingCommittedAmountElement != null)
                    {
                        //Set the Commitment Amount
                        XPathNavigator AmountElement = OutstandingCommittedAmountElement.SelectSingleNode("AMOUNT");
                        if (AmountElement != null)
                        {
                            try
                            {
                                OutstandingCommittedAmount = double.Parse(AmountElement.InnerXml);
                            }
                            catch (Exception )
                            {
                                OutstandingCommittedAmount = 0;
                            }
                        }
                        SourceEntityXML.AppendFormat("<SOURCEENTITYAMOUNT>{0}</SOURCEENTITYAMOUNT>", EntityElement.InnerXml);
                    }
                    EntityElement = EntityRootElement.SelectSingleNode("//*/COMMITMENT_TO_VENDOR");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.AppendFormat("<SOURCEENTITYVENDOR>{0}</SOURCEENTITYVENDOR>", EntityElement.InnerXml);
                    }
                    EntityElement = EntityRootElement.SelectSingleNode("//*/COMMITMENT_LINEITEM");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.AppendFormat("<SOURCELINEITEMS>{0}</SOURCELINEITEMS>", EntityElement.InnerXml);
                    }
                    EntityElement = EntityRootElement.SelectSingleNode("//*/OUTSTANDINGCOMMITTEDAMOUNT");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.AppendFormat("<CHECKFOROVERSPENT>true</CHECKFOROVERSPENT><AMOUNTFOROVERSPENTCHECK>{0}</AMOUNTFOROVERSPENTCHECK>", EntityElement.InnerXml);
                    }
                    EntityElement = EntityRootElement.SelectSingleNode("//CONTINUED_COMMITMENT/COMMITMENT/OUTSTANDINGCOMMITTEDAMOUNT");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.AppendFormat("<CONTINUEDCOMMITMENTAMOUNT>{0}</CONTINUEDCOMMITMENTAMOUNT>", EntityElement.InnerXml);
                    }                  
                    EntityElement = EntityRootElement.SelectSingleNode("//COMMITMENT/DESCRIPTION");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.Append("<COMMITMENTDESCRIPTION>");
                        SourceEntityXML.Append(ALSpecialCharHandling.TrimAndReplaceSpecialChars(EntityElement.Value));
                        SourceEntityXML.Append("</COMMITMENTDESCRIPTION>");                        
                    }
                    EntityElement = EntityRootElement.SelectSingleNode("//COMMITMENT/TITLE");
                    if (EntityElement != null)
                    {
                        SourceEntityXML.Append("<COMMITMENTTITLE>");
                        SourceEntityXML.Append(ALSpecialCharHandling.TrimAndReplaceSpecialChars(EntityElement.Value));
                        SourceEntityXML.Append("</COMMITMENTTITLE>");
                    }
                    if (InvoiceElement == null)
                    {
                        SourceEntityXML.Append("</SOURCEENTITY_FOR_INVOICE>");
                        SourceAttribXML.DocumentElement.InnerXml = SourceAttribXML.DocumentElement.InnerXml + SourceEntityXML.ToString();
                    }
                    else
                    {
                        InvoiceElement.InnerXml = SourceEntityXML.ToString();
                    }
                    SourceAttribXML.Save(SourceEntityAttributeXML);
                }
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "SaveSourceInformation", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        void AssignSourceAttributes(ref String CommitmentXML)
        {
            try
            {
                XmlDocument CommitmentDoc = new XmlDocument();
                CommitmentDoc.LoadXml(CommitmentXML);
                //PO Date and Vendor Acknowledge date is set to read only mode 
                if (!IsCommitmentApprovalEnabled)
                {
                    XmlNode xmlEle_Field = null;
                    xmlEle_Field = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_PODATE']");
                    if (xmlEle_Field != null)
                    {
                        if (xmlEle_Field.Attributes.GetNamedItem("FieldVisible") == null)
                            ((XmlElement)xmlEle_Field).SetAttribute("FieldVisible", "False");
                        else
                            xmlEle_Field.Attributes.GetNamedItem("FieldVisible").InnerText = "False";
                    }

                    xmlEle_Field = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_VENDOR_ACKNOWLEDGEMENT_DATE']");
                    if (xmlEle_Field != null)
                    {
                        if (xmlEle_Field.Attributes.GetNamedItem("FieldVisible") == null)
                            ((XmlElement)xmlEle_Field).SetAttribute("FieldVisible", "False");
                        else
                            xmlEle_Field.Attributes.GetNamedItem("FieldVisible").InnerText = "False";
                    }
                }
                else
                    if (this.ViewState["STATUS"] != null)
                    {
                        String str_Status =this.ViewState["STATUS"].ToString();
                        if (!(String.Compare(str_Status, "Submitted to Vendor", true) == 0 || String.Compare(str_Status, "Vendor Approved", true) == 0))
                        {
                            XmlNode xmlEle_Field = null;
                            xmlEle_Field = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_PODATE']");
                            if (xmlEle_Field != null)
                            {
                                if (xmlEle_Field.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)xmlEle_Field).SetAttribute("FieldVisible", "False");
                                else
                                    xmlEle_Field.Attributes.GetNamedItem("FieldVisible").InnerText = "False";
                            }
                        }

                        if (!(String.Compare(str_Status, "Vendor Approved", true) == 0 || String.Compare(str_Status, "Vendor Rejected", true) == 0))
                        {
                            XmlNode xmlEle_Field = null;
                            xmlEle_Field = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_VENDOR_ACKNOWLEDGEMENT_DATE']");
                            if (xmlEle_Field != null)
                            {
                                if (xmlEle_Field.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)xmlEle_Field).SetAttribute("FieldVisible", "False");
                                else
                                    xmlEle_Field.Attributes.GetNamedItem("FieldVisible").InnerText = "False";
                            }
                        }
                    }
                // hide closurenotes
                XmlElement ClosureNotes = (XmlElement)CommitmentDoc.SelectSingleNode("//*/Field[@Name='COMMITMENT_CLOSURENOTES']");
                XPathNavigator xpNav_CommitmentStatus = CommitmentDoc.CreateNavigator();
                xpNav_CommitmentStatus = xpNav_CommitmentStatus.SelectSingleNode("//*/Field[@Name='COMMITMENT_STATUS']/Value");
                if (xpNav_CommitmentStatus.InnerXml.ToUpper().Equals("CLOSED"))
                {
                    ClosureNotes.SetAttribute("FieldVisible", "True");
                }
                else
                    ClosureNotes.SetAttribute("FieldVisible", "False");

                #region Set Visibility of COMMITMENT_REVISEDCOMMITNO, COMMITMENT_REASONFORVOID and COMMITMENT_VOIDEDCOMMITNO
                XmlNode FieldNode   = null;
                FieldNode           = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_REASONFORVOID']");
                if (FieldNode != null)
                {
                    if (xpNav_CommitmentStatus.InnerXml.ToUpper().Equals("VOID"))
                    {
                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "True");
                    }
                    else
                    {
                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "False");
                    }
                }

                FieldNode           = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_VOIDEDCOMMITNO']");
                if (FieldNode != null)
                {
                    if (xpNav_CommitmentStatus.InnerXml.ToUpper().Equals("VOID"))
                    {
                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "True");
                    }
                    else
                    {
                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "False");
                    }
                }

                FieldNode           = CommitmentDoc.SelectSingleNode("FieldList/Field[@Name='COMMITMENT_REVISEDCOMMITNO']/Value");
                if ((FieldNode != null) && (!String.IsNullOrEmpty(FieldNode.InnerText)))
                {
                    FieldNode       = FieldNode.ParentNode;
                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "True");
                }
                else
                {
                     FieldNode       = FieldNode.ParentNode;
                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "False");
                }
                #endregion	
                
                if (!String.IsNullOrEmpty(SourceAttributes) && System.IO.File.Exists(SourceAttributes))
                {
                    XPathDocument SourceDoc = new XPathDocument(SourceAttributes);
                    XPathNavigator SourceNav = SourceDoc.CreateNavigator();
                    XPathNavigator SourceFieldNav = null;

                    XPathNavigator SourceTitleLabel = SourceNav.SelectSingleNode("//SOURCEENTITY/SOURCEENTITY_FOR_COMMITMENT/SOURCEENTITYLABEL");
                    SourceFieldNav = SourceNav.SelectSingleNode("//SOURCEENTITY/SOURCEENTITY_FOR_COMMITMENT/SOURCEENTITYNAME/a");
                    XmlElement FieldElement = (XmlElement)CommitmentDoc.SelectSingleNode("//*/Field[@Name='SourceEntityName']");
                    if ((SourceTitleLabel != null) && (SourceFieldNav != null))
                    {
                        if (FieldElement != null)
                        {
                            FieldElement.SetAttribute("Label", SourceTitleLabel.InnerXml);
                            XmlElement Value = CommitmentDoc.CreateElement("Value");
                            Value.InnerXml = SourceFieldNav.InnerXml;
                            FieldElement.AppendChild(Value);                           
                        }
                    }
                    CommitmentXML = CommitmentDoc.InnerXml;
                }
                else
                {
                    XmlElement CommitmentElements = (XmlElement)CommitmentDoc.DocumentElement.SelectSingleNode("//*/Field[@Name='SourceEntityName']");
                    if (CommitmentElements != null)
                    {
                        CommitmentElements.SetAttribute("FieldVisible", "false");
                    }
                    CommitmentXML = CommitmentDoc.InnerXml;
                }
            }
            catch (Exception ExcepObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "AssignSourceAttributes", ExcepObj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner", "SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        void AssignBinderXML(String CommitmentXML)
        {
            XPathDocument CommitmentDoc = new XPathDocument(new System.IO.StringReader(CommitmentXML));
            XPathNavigator CommitmentNav = CommitmentDoc.CreateNavigator();
            XPathNavigator FSNav = CommitmentNav.SelectSingleNode("//*/FILESYSTEM");
            if (FSNav != null)
            {
                LST_Attachments.InputXMLType = Binder.InputType.InnerXML;
                LST_Attachments.InputXML = FSNav.OuterXml;
            }
        }

        protected override void OnPreRender(EventArgs e)
        {
            if (!String.IsNullOrEmpty(InvoiceList.DataXMLPath))
            {
                XPathDocument Invoice_Doc = null;
                String ConfigXMLPath = null;
                String FieldCollectionXML = null;
                String SearchXML = null;
                String ErrorXML = null;
                String DataXML = null;
                String FormInputXML = null;
                FormFacade FormObj = null;
                XPathNavigator Invoice_Nav = null;
                Invoice_Doc = new XPathDocument(InvoiceList.DataXMLPath);
                Invoice_Nav = Invoice_Doc.CreateNavigator();
                XmlDocument CommitmentXMLDoc            = null;
                XmlNode     CommitmentCollectionNode    = null;        
                XmlNode     CommitmentNode              = null;
                XmlNode     FieldNode                   = null;

                if (Invoice_Nav != null)
                {
                    XPathNodeIterator InvoiceNodeList = Invoice_Nav.Select("INVOICECOLLECTION/INVOICE");
                    if (InvoiceNodeList.Count > 0)
                    {
                        this.Page.ClientScript.RegisterHiddenField("AlertMessage", Localization.GetString("ALJSResource", SetBaseObj.TenantName, "Alert_SP_CommitmentWidget_CloseCommitment"));
                    }
                    else
                    {
                        this.Page.ClientScript.RegisterHiddenField("AlertMessage", Localization.GetString("ALJSResource", SetBaseObj.TenantName, "Alert_SP_CommitmentWidget_CloseCommitmentWithInvoices"));
                    }
                }
                if (SetBaseObj.IsCustomized)
                {
                    ConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, SetBaseObj.SolutionName, "SP_CommitmentWidget", "Frm_CloseCommitment_FormConfiguration");
                }
                else
                {
                    ConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, "", "SP_CommitmentWidget", "Frm_CloseCommitment_FormConfiguration");
                }
                FormObj = new FormFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                FormObj.ConfigurationXML = ConfigXMLPath;
                FormObj.FormName = "Frm_CloseCommitment";
                ErrorXML = FormObj.GetSearchAndFieldCollectionXML(out SearchXML, out FieldCollectionXML);
                if (ErrorXML == null)
                {
                    ErrorXML = FormObj.CreateDataXML(FieldCollectionXML, out DataXML);
                    if (ErrorXML == null)
                    {
                        ErrorXML = FormObj.GetFormInputXML("Create", DataXML, out FormInputXML, out ObjList);
                        if (ErrorXML == null)
                        {
                            XmlDocument FormInputDoc = new XmlDocument();
                            FormInputDoc.LoadXml(FormInputXML);
                            XmlElement ClosureWarning = (XmlElement)FormInputDoc.DocumentElement.SelectSingleNode("Field[@Name='ClosureWarning']");
                            if (ClosureWarning != null)
                            {
                                if (OutstandingCommittedAmount != 0)
                                {
                                    XmlElement ValueElement = FormInputDoc.CreateElement("Value");
                                    ValueElement.InnerXml = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_CommitmentWidget_ClosureWarning");
                                    ClosureWarning.AppendChild(ValueElement);
                                    ClosureWarning.SetAttribute("Disable", "Yes");
                                    ClosureWarning.SetAttribute("DisplayType", "ReadOnly");
                                }
                                else
                                {
                                    ClosureWarning.SetAttribute("FieldVisible", "false");
                                }
                                FormInputXML=FormInputDoc.InnerXml;
                            }
                            FRM_CloseCommitment.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.XMLPath;
                            FRM_CloseCommitment.ConfigurationXML = ConfigXMLPath;
                            FRM_CloseCommitment.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                            FRM_CloseCommitment.InputXML = FormInputXML;
                            AssignCloseCommitmentAttributes();
                        }
                    }
                }
                
				if (SetBaseObj.IsCustomized)
                {
                    ConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, SetBaseObj.SolutionName, "SP_CommitmentWidget", "FRM_VoidCommitment_FormConfiguration");
                }
                else
                {
                    ConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, "", "SP_CommitmentWidget", "FRM_VoidCommitment_FormConfiguration");
                }
                FormObj                     = new FormFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                FormObj.ConfigurationXML    = ConfigXMLPath;
                FormObj.FormName            = "Frm_VoidCommitment";
                ErrorXML                    = FormObj.GetSearchAndFieldCollectionXML(out SearchXML, out FieldCollectionXML);
                if (ErrorXML == null)
                {
                    ErrorXML = FormObj.CreateDataXML(FieldCollectionXML, out DataXML);
                    if (ErrorXML == null)
                    {
                        ErrorXML                                    = FormObj.GetFormInputXML("Create", DataXML, out FormInputXML, out ObjList);
                        FRM_VoidCommitment.ConfigurationXMLType     = Assetlink.CustomControls.Form.InputType.XMLPath;
                        FRM_VoidCommitment.ConfigurationXML         = ConfigXMLPath;
                        FRM_VoidCommitment.InputXMLType             = Assetlink.CustomControls.Form.InputType.InnerXML;
                        FRM_VoidCommitment.InputXML                 = FormInputXML;
                    }
                }

                if (SetBaseObj.IsCustomized)
                {
                    ConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, SetBaseObj.SolutionName, "SP_CommitmentWidget", "FRM_EditVoidCommitmentNo_FormConfiguration");
                }
                else
                {
                    ConfigXMLPath = ALSolutionCommon.GetFormConfigurationXMLPath(SetBaseObj.TenantName, "", "SP_CommitmentWidget", "FRM_EditVoidCommitmentNo_FormConfiguration");
                }
                FormObj                                         = new FormFacade(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                FormObj.ConfigurationXML                        = ConfigXMLPath;
                FormObj.FormName                                = "FRM_EditVoidCommitmentNo";

                CommitmentXMLDoc                                = new XmlDocument();
                CommitmentCollectionNode                        = CommitmentXMLDoc.CreateElement("COMMITMENTCOLLECTION");
                CommitmentNode                                  = CommitmentXMLDoc.CreateElement("COMMITMENT");
                FieldNode                                       = CommitmentXMLDoc.CreateElement("COMMITMENTID");
                FieldNode.InnerText                             = CommitmentID.ToString();
                CommitmentNode.AppendChild(FieldNode);
                FieldNode                                       = CommitmentXMLDoc.CreateElement("VOIDEDCOMMITNO");
                if (this.ViewState["VOIDEDCOMMITNO"]!=null)
                    FieldNode.InnerText                         = (String)this.ViewState["VOIDEDCOMMITNO"];
                CommitmentNode.AppendChild(FieldNode);
                CommitmentCollectionNode.AppendChild(CommitmentNode);
                DataXML                                         = CommitmentCollectionNode.OuterXml;
                ErrorXML                                        = FormObj.GetFormInputXML("EDIT", DataXML, out FormInputXML, out ObjList);
                FRM_EditVoidCommitmentNo.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.XMLPath;
                FRM_EditVoidCommitmentNo.ConfigurationXML       = ConfigXMLPath;
                FRM_EditVoidCommitmentNo.InputXMLType           = Assetlink.CustomControls.Form.InputType.InnerXML;
                FRM_EditVoidCommitmentNo.InputXML               = FormInputXML;
            }
            base.OnPreRender(e);
        }

        void AssignCloseCommitmentAttributes()
        {
            StringBuilder JavaScript = null;
            JavaScript = new StringBuilder();
            JavaScript.AppendFormat("javascript:{0}", CloseCommitment_PopControl.ClosePopupJavascript); 
            if (ATN_CloseCommitment != null)
            {
                ATN_CloseCommitment.AddAttributes("btn_Cancel", "href", JavaScript.ToString());
            }
        }

        void FRM_CloseCommitment_ActionBarClick(object sender, EventArgs e)
        {
            
            HandleCloseCommitment();
            InvokeCloseEvent(e);
        }

        void InvokeCloseEvent(EventArgs e)
        {
            EventHandler CloseEvent = (EventHandler)this.Events[ObjCloseCommitment];
            if (CloseEvent != null)
            {
                CloseEvent(this, e);
            }
        }

        void GetBackURL()
        {
            try
            {
                if (CommonFunctionObj == null)
                {
                    CommonFunctionObj = new Solutions.ALSolutionCommon();
                }
                XPathDocument xp_SourceDoc = null;
                XPathNavigator xp_SourceNav = null;
                if (!String.IsNullOrEmpty(SourceEntityAttributeXML))
                {
                    BackUrl = new StringBuilder();
                    if (!String.IsNullOrEmpty(SourceAttributes) && System.IO.File.Exists(SourceAttributes))
                    {
                        xp_SourceDoc = new XPathDocument(SourceAttributes);
                        xp_SourceNav = xp_SourceDoc.CreateNavigator();
                        XPathNavigator SourceName = xp_SourceNav.SelectSingleNode("//SOURCEENTITY/SOURCEENTITY_FOR_COMMITMENT/SOURCEENTITYNAME/a");
                        if (SourceName != null)
                        {
                            BackUrl.Append(SourceName.GetAttribute("href", ""));
                            String Params = null;
                            String URL = null;
                            int Pos = BackUrl.ToString().IndexOf("?Param=");
                            URL = BackUrl.ToString().Substring(0, Pos);
                            Pos = Pos + ("?Param=").Length;
                            Params = BackUrl.ToString().Substring(Pos);
                            Params = CommonFunctionObj.DecryptURL(Params);
                            BackUrl.Remove(0, BackUrl.Length);
                            BackUrl.AppendFormat("{0}?{1}", URL, Params);
                        }
                    }
                }
            }
            catch (Exception Excepobj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_RO.aspx", "GetBackURL", Excepobj, null, null);
                CommonFunctionObj.PrepareErrorPageUrl("StrategicPlanner","SP_CommitmentWidget", "COMMITMENT", null, PageErrorMessage, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        String[] GetJSFileName()
        {
            String[] str_JSFileName = null;
            StringBuilder JSFilePath = null;
            try
            {
                JSFilePath = new StringBuilder();
                JSFilePath.AppendFormat("/{0}/Widgets/{1}/JS/", SetBaseObj.TenantName, SetBaseObj.WidgetName);
                str_JSFileName = new String[1];
                str_JSFileName[0] = JSFilePath.ToString() + "HandleSubmit.js";
                return str_JSFileName;
            }
            catch (Exception )
            {
                return null;
            }
        }

        /// <alsummary>
        /// <createddate>5 Feb 2009</createddate>
        /// <author>Mr.Pravin Shinde</author>
        /// <purpose>This method shows a list of Commitment Approvals jobs.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private void showCommitmeApprovalJobList(XML Ps_SearchInputXML)
        {
            XML                             JobListXML          = null;
            ERRORXML                        ErrorXML            = null;
            String                          ConfigXML           = null;
            String                          ErrorPageURL        = null;
            ulong                           ErrorID             = 0;

            try
            {
                Lc_CommitmentApprovalJobList.EnableIterators     = true;
                ConfigXML   = ListFacadeObj.GetConfigurationXML(SetBaseObj.SolutionName, SetBaseObj.WidgetName, "ApprovalsJobList");
                ErrorXML    = GetApprovalJobListXML(Ps_SearchInputXML,ConfigXML,out JobListXML);
                if (ErrorXML == null)
                {
                     Lc_CommitmentApprovalJobList.SectionHeading = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_CommitmentRO_Approvals_InternalApprovals");
                     Lc_CommitmentApprovalJobList.Source = JobListXML;
                }
                else
                {
                    CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, null, "APPROVALSJOB", null, "Error while getting job list", null, BackUrl.ToString(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                        objALPage.Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "CommitmentDetails_RO.ascx", "showJobList", ExceptionObject, null, "Exception while showing Job List.");
                CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        /// <alsummary>
        /// <createddate>5 Feb 2009</createddate>
        /// <author>Mr.Pravin Shinde</author>
        /// <purpose>This method shows a list of Vendor Approvals jobs.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private void showVendorApprovalJobList(XML Ps_SearchInputXML)
        {
            XML                         JobListXML              = null;
            ERRORXML                    ErrorXML                = null;
            String                      ConfigXML               = null;
            String                      ErrorPageURL            = null;
            ulong                       ErrorID                 = 0;

            try
            {
                Lc_VendorApprovalJobList.EnableIterators         = true;
                ConfigXML = ListFacadeObj.GetConfigurationXML(SetBaseObj.SolutionName, SetBaseObj.WidgetName, "ApprovalsJobList");
                ErrorXML  = GetApprovalJobListXML(Ps_SearchInputXML, ConfigXML, out JobListXML); 
                if (ErrorXML == null)
                {
                    Lc_VendorApprovalJobList.SectionHeading = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_CommitmentRO_Approvals_VendorApprovals");
                    Lc_VendorApprovalJobList.Source = JobListXML;
                }
                else
                {
                    CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, null, "APPROVALSJOB", null, "Error while getting job list", null, BackUrl.ToString(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                        objALPage.Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "CommitmentDetails_RO.ascx", "showVendorApprovalJobList", ExceptionObject, null, "Exception while showing Job List.");
                CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, BackUrl.ToString(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    objALPage.Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        /// <alsummary>
        /// <createddate>5 Feb 2009</createddate>
        /// <author>Mr.Pravin Shinde</author>
        /// <purpose>This method prepares list XML for Approval jobs.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private ERRORXML GetApprovalJobListXML(XML Ps_SearchInputXML, String ConfigXML, out String JobListXML)
        {
            ERRORXML                        ErrorXML            = null;
            StringBuilder                   JobCollection       = null;
                                            JobListXML          = null;
            
            JobCollection   = new StringBuilder();

            ErrorXML        = ApprovalsObj.GetAllApprovalsJobs(Ps_SearchInputXML, ref JobListXML);
            if (ErrorXML == null)
            {
                ListFacadeObj.AddParameter("Mode", "Route");
                ListFacadeObj.AddParameter("Access", AccessMode);
                ListFacadeObj.AddParameter("CommitmentMode", Mode);
                ListFacadeObj.AddParameter("CommitmentAccess", AccessMode);
                ListFacadeObj.AddParameter("FromROCommitmentPage", "True");
                ListFacadeObj.AddParameter("CommitmentID", CommitmentID.ToString());
                ListFacadeObj.AddParameter("TaskPaneList", TaskPaneList.ToString());
                ListFacadeObj.AddParameter("MasterPageFile",this.Page.MasterPageFile);
                ListFacadeObj.AddParameter("CommitmentID", CommitmentID.ToString());
                ListFacadeObj.AddParameter("TaskPaneList", TaskPaneList.ToString());
                ListFacadeObj.AddParameter("Theme", this.Page.Theme);
                ListFacadeObj.AddParameter("SOURCEATTRIBUTES", SourceAttributes);
                ListFacadeObj.AddParameter("BREADCRUMBNAME", "CommitmentBreadcrumb");
                ListFacadeObj.AddParameter("BREADCRUMBID", this.ParentBreadcrumbID);
                ListFacadeObj.AddParameter("BREADCRUMBXML", this.BreadcrumbXML);
                ListFacadeObj.AddParameter("IsCustomized", SetBaseObj.IsCustomized.ToString());
                ListFacadeObj.AddParameter("CommitmentTitle", Server.UrlEncode(this.CommitmentBreadcrumb.DisplayText));
                ListFacadeObj.AddParameter("SolutionName", SetBaseObj.SolutionName);
                ListFacadeObj.AddParameter("PARENTBREADCRUMBNAME", this.ParentBreadcrumbName);
                JobCollection.AppendFormat("<SEARCHOUTPUTXML>{0}</SEARCHOUTPUTXML>", JobListXML);
                ListFacadeObj.PrepareListXml(ConfigXML, JobCollection.ToString(), out JobListXML);
                MWBFacadeObj.InsertPercentCompleteClass("DUEDATE", ref JobListXML);
                ModifyJobListXML(ref JobListXML);
            }
            return ErrorXML;
        }

        /// <alsummary>
        /// <createddate>5 Feb 2009</createddate>
        /// <author>Mr.Pravin Shinde</author>
        /// <purpose>This method sets action bar according to status of commitement.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private void SetROActionBarInputXML(XmlDocument XmlDoc_CommitmentDetails)
        {
           Boolean                  ShowCommitmentApprovalsButton       = false;
           Boolean                  ShowGeneratePOButton                = false;
           Boolean                  ShowEditButton                      = false;
           Boolean                  ShowCloseCommitmentButton           = false;
           Boolean                  ShowVoidCommitmentButton            = true;  
           Boolean                  ShowEditVoidCommitmentNoButton      = false;    
           Boolean                  ShowActionBar                       = true;
           XPathNavigator           xpNav_CommitmentDetails             = null;
           XPathNodeIterator        xpItr_DeleteJobs                    = null;
           XPathNavigator           xpNav_IsContinuedCommmitment        = null;
           ApprovalsFacadeClass     obj_Approvals                       = null;
           ERRORXML                 ErrorXML                            = null;
           StringBuilder            sb_ActionBarInputXML                = null;
           String                   TempString                          = null;
           String                   str_CommitmentStatus                = null;
           String                   str_InvoiceListMode                 = null;
           StringBuilder            JavaScript                          = null;
           bool                     bIsContinuedCommmitment             = false;
           String                   str_ContinuedFlag                   = null;
           XPathNavigator           xpNav_ContinuedFlag                 = null;

           AB_ROCommitmentDetails               = (ActionBar)this.ALPanel_CommitmentInfo.FindControl("AB_ROCommitmentDetails");
           AB_ROCommitmentDetails.TenantName    = SetBaseObj.TenantName;

           if (XmlDoc_CommitmentDetails == null)
           {
               if (this.ViewState["COMMITMENTDETAILS"] != null)
               {
                   XmlDoc_CommitmentDetails = new XmlDocument();
                   XmlDoc_CommitmentDetails.LoadXml(this.ViewState["COMMITMENTDETAILS"].ToString());
               }
           }
           if (XmlDoc_CommitmentDetails != null)
           {
               xpNav_CommitmentDetails = XmlDoc_CommitmentDetails.CreateNavigator();
               str_CommitmentStatus = xpNav_CommitmentDetails.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/STATUS").Value;
           }

           xpNav_IsContinuedCommmitment = xpNav_CommitmentDetails.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/CONTINUED_COMMITMENT/COMMITMENT/COMMITMENTID");
           if (xpNav_IsContinuedCommmitment != null)
           {
               bIsContinuedCommmitment = true;
           }

           if (IsCommitmentApprovalEnabled)
           {
               #region if CommitmentApproval ss Enabled
               if (XmlDoc_CommitmentDetails != null)
               {
                   if (!IsPostBack)
                   {
                       #region Check for New "CommitmentApproval" jobs

                       xpItr_DeleteJobs = xpNav_CommitmentDetails.Select("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_WFP_APPROVAL/WORKFLOWPROCESS/STATUS[text()='New']");
                       if (xpItr_DeleteJobs.Count > 0)
                       {
                           obj_Approvals = new ApprovalsFacadeClass(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                           //Delete Commitment Approval "New" jobs
                           foreach (XPathNavigator xpNav_DeleteJob in xpItr_DeleteJobs)
                           {
                               xpNav_DeleteJob.MoveToParent();
                               ErrorXML = obj_Approvals.DeleteApprovalsJob(xpNav_DeleteJob.SelectSingleNode("WORKFLOWPROCESSID").Value);
                               if (!String.IsNullOrEmpty(ErrorXML))
                               {
                                   CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, "SP_Commitmentwidget", "COMMITMENT", ErrorXML, null, null, BackUrl.ToString(), ref ErrorPageURL);
                                   if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                                   {
                                       Response.Redirect(ErrorPageURL);
                                   }
                                   else
                                   {
                                       objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                                   }
                               }
                           }
                       }
                       #endregion

                       #region Check for New Vendor Approved Job
                       xpItr_DeleteJobs = xpNav_CommitmentDetails.Select("COMMITMENTCOLLECTION/COMMITMENT/COMMITMENT_WFP_VENDOR/WORKFLOWPROCESS/STATUS[text()='New']");
                       if (xpItr_DeleteJobs.Count > 0)
                       {
                           obj_Approvals = new ApprovalsFacadeClass(SetBaseObj.SessionID, SetBaseObj.UserID, SetBaseObj.TenantName, SetBaseObj.Language);
                           //Delete Commitment Vendor "New" jobs
                           foreach (XPathNavigator xpNav_DeleteJob in xpItr_DeleteJobs)
                           {
                               xpNav_DeleteJob.MoveToParent();
                               ErrorXML = obj_Approvals.DeleteApprovalsJob(xpNav_DeleteJob.SelectSingleNode("WORKFLOWPROCESSID").Value);
                               if (!String.IsNullOrEmpty(ErrorXML))
                               {
                                   CommonFunctionObj.PrepareErrorPageUrl(SetBaseObj.SolutionName, "SP_Commitmentwidget", "COMMITMENT", ErrorXML, null, null, BackUrl.ToString(), ref ErrorPageURL);
                                   if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                                   {
                                       Response.Redirect(ErrorPageURL);
                                   }
                                   else
                                   {
                                       objALPage.Ajax.WriteExecuteJavaScript("javascript:window.open('" + ErrorPageURL + "','_self','');");
                                   }
                               }
                           }
                       }
                       #endregion
                   }

                   xpNav_ContinuedFlag = xpNav_CommitmentDetails.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT/CONTINUEDFLAG");
                   if (xpNav_ContinuedFlag != null)
                   {
                       str_ContinuedFlag = xpNav_ContinuedFlag.Value;
                   }

                   #region Set Action Button visibility
                   if ((String.Compare(str_CommitmentStatus, "New", true) == 0) || (String.Compare(str_CommitmentStatus, "Rejected", true) == 0) || (String.Compare(str_CommitmentStatus, "Draft", true) == 0))
                   {
                       ShowCommitmentApprovalsButton    = true;
                       ShowGeneratePOButton             = false;
                       ShowEditButton                   = true;
                       ShowCloseCommitmentButton        = true;
                       str_InvoiceListMode              = "READONLY";
                   }
                   if ((String.Compare(str_CommitmentStatus, "Submitted for Review", true) == 0) || (String.Compare(str_CommitmentStatus, "Submitted to Vendor", true) == 0))
                   {
                       ShowCommitmentApprovalsButton    = false;
                       ShowGeneratePOButton             = false;
                       ShowEditButton                   = false;
                       ShowCloseCommitmentButton        = false;
                       str_InvoiceListMode              = "READONLY";
                   }
                   if (String.Compare(str_CommitmentStatus, "Vendor Approved", true) == 0)
                   {
                       ShowCommitmentApprovalsButton    = false;
                       ShowGeneratePOButton             = false;
                       ShowEditButton                   = false;
                       ShowCloseCommitmentButton        = true;
                       str_InvoiceListMode              = "EDITABLE";
                   }
                   if ((String.Compare(str_CommitmentStatus, "Approved", true) == 0) || (String.Compare(str_CommitmentStatus, "Vendor Rejected", true) == 0))
                   {
                       ShowCommitmentApprovalsButton    = false;
                       ShowGeneratePOButton             = true;
                       ShowEditButton                   = true;
                       ShowCloseCommitmentButton        = true;
                       str_InvoiceListMode              = "READONLY";
                   }
                   if ((String.Compare(str_CommitmentStatus, "Void", true) == 0) || (String.Compare(str_CommitmentStatus, "Closed", true) == 0))
                   {
                       ShowCommitmentApprovalsButton    = false;
                       ShowGeneratePOButton             = false;
                       ShowEditButton                   = false;
                       ShowCloseCommitmentButton        = false;
                       ShowVoidCommitmentButton         = false;
                       ShowActionBar                    = false;
                       if (String.Compare(str_CommitmentStatus, "Void", true) ==0)
                       {
                           ShowActionBar                    = true;
                           ShowEditVoidCommitmentNoButton   = true;
                           str_InvoiceListMode = "READONLY";
                       }
                       else
                       {
                           str_InvoiceListMode = "LISTREADONLY";
                       }
                   }
                   if ((String.Compare(str_CommitmentStatus, "Continued", true) == 0 || bIsContinuedCommmitment) && str_ContinuedFlag != "1")
                   {
                       ShowEditButton                   = false;
                       ShowCommitmentApprovalsButton    = false;
                       ShowCloseCommitmentButton        = false;
                       ShowVoidCommitmentButton         = false;
                       ShowActionBar                    = false;
                   }                    
                   #endregion
               }

               #region Read Solution Configuration  for Approvals Settings

               if (!IsCommitmentApprovalEnabled)
                {
                       ShowCommitmentApprovalsButton    = false;
                       ShowGeneratePOButton             = false;
                }
                
               #endregion

               #region Set Action Bar

                if (AccessMode == "Write" && (!Mode.ToUpper().Equals("READONLY")))
                {
                    sb_ActionBarInputXML = new StringBuilder(200);
                    sb_ActionBarInputXML.Append(@"<ActionBar> 
                                                  <ActionControlList ActionBarType='PageButtonBar'>");
                    if (ShowEditButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Edit Commitment' UIType='ALButton' Name='BTN_EditCommitment' Order='0' CausesValidation='False' DisplayTextID='SP_CommitmentRO_EditCommitment' TooltipID='SP_CommitmentRO_EditCommitment_Tooltip'>
                                                        <DisplayText>Edit Commitment</DisplayText>                                                    
                                                    </ActionControl>");
                    }
                    if (ShowCloseCommitmentButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Close Commitment' UIType='ALButton' Name='BTN_CloseCommitment' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_CloseCommitment' TooltipID='SP_CommitmentRO_CloseCommitment_Tooltip'>
                                                        <DisplayText>Close Commitment</DisplayText>
                                                    </ActionControl>");
                    }

                    if (ShowVoidCommitmentButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Void Commitment' UIType='ALButton' Name='btn_VoidCommitment' Order='4' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_VoidCommitment' TooltipID='SP_CommitmentRO_VoidCommitment_Tooltip'>
		                                                   <DisplayText>Void Commitment</DisplayText>
	                                                </ActionControl>");
                    }

                    if (ShowEditVoidCommitmentNoButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Void Commitment' UIType='ALButton' Name='btn_EditVoidCommitmentNo' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_EditVoidCommitmentNoBtn' TooltipID='SP_CommitmentRO_EditVoidCommitmentNoBtn_Tooltip'>
                                                   <DisplayText>Edit Revised #</DisplayText>
                                            </ActionControl>");
                        AB_ROCommitmentDetails.AddAttributes("btn_EditVoidCommitmentNo", "href", "javascript:" + ALPC_EditVoidCommitmentNo.ShowPopupWindowJavascript);
                    }

                    if (ShowCommitmentApprovalsButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Send Commitment for Approval' UIType='ALButton' Name='btn_CommitmentApprove' Order='2' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_CommitmentApproval' TooltipID='SP_CommitmentRO_CommitmentApproval_Tooltip'>
		                                                <DisplayText>Commitment Approval</DisplayText>
	                                            </ActionControl>");
                    }
                    if (ShowGeneratePOButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Generate Purchase order and send to Vendor' UIType='ALButton' Name='btn_GeneratePO' Order='3' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_GeneratePO' TooltipID='SP_CommitmentRO_GeneratePO_Tooltip'>
		                                                <DisplayText>Generate PO</DisplayText>
	                                             </ActionControl>");
                    }
                    sb_ActionBarInputXML.Append(" </ActionControlList></ActionBar>");


                    CloseCommitment_PopControl.TenantName = SetBaseObj.TenantName;
                    CloseCommitment_PopControl.CaptionText = Localization.GetString("ALResource", SetBaseObj.TenantName, "SP_CommitmentRO_CloseCommitment"); 
                    CloseCommitment_PopControl.PopupDisplayMode = ePopupDisplayMode.Simple;
                    CloseCommitment_PopControl.Style.Add(HtmlTextWriterStyle.Display, "None");

                    JavaScript = new StringBuilder();
                    TempString = CloseCommitment_PopControl.ShowPopupWindowJavascript;
                    TempString = TempString.Replace("'", "\"");
                    JavaScript.AppendFormat("javascript:javascript:ShowConfirmForCloseCmt('{0}', '{1}');", this.Div_CloseCommitment.ClientID, TempString);

                    if (ShowActionBar)
                    {
                        AB_ROCommitmentDetails.InputXMLType = ActionBar.XMLType.InnerXML;
                        AB_ROCommitmentDetails.InputXML = sb_ActionBarInputXML.ToString();
                        AB_ROCommitmentDetails.Click += new EventHandler(AB_ROCommitmentDetails_ActionBarClick);

                        AB_ROCommitmentDetails.AddAttributes("BTN_CloseCommitment", "href", JavaScript.ToString());
                        AB_ROCommitmentDetails.AddAttributes("BTN_EditCommitment", "href", "../../SP_CommitmentWidget/ASPX/Commitment_Edit.aspx?Param=" + FormURL("Edit"));
                    }
                }
                else
                {
                    str_InvoiceListMode = "READONLY";
                }
           #endregion

               #endregion
           }
           else
           {
               if ((String.Compare(str_CommitmentStatus, "Void", true) == 0) || (String.Compare(str_CommitmentStatus, "Closed", true) == 0))
               {
                   ShowEditButton                   = false;
                   ShowCloseCommitmentButton        = false;
                   ShowVoidCommitmentButton         = false;
                   ShowActionBar                    = false;
                   if (String.Compare(str_CommitmentStatus, "Void", true)==0)
                   {
                       ShowActionBar                    = true;
                       ShowEditVoidCommitmentNoButton   = true;
                       str_InvoiceListMode              = "READONLY";
                   }
                   else
                   {
                       str_InvoiceListMode              = "LISTREADONLY";
                   }
               }
               else if ((String.Compare(str_CommitmentStatus, "Continued", true) == 0 || bIsContinuedCommmitment) && str_ContinuedFlag != "1")
               {
                   ShowEditButton                   = false;
                   ShowCommitmentApprovalsButton    = false;
                   ShowCloseCommitmentButton        = false;
                   ShowVoidCommitmentButton         = false;
                   ShowActionBar                    = false;
               }
               else
               {
                   ShowEditButton                   = true;
                   ShowCloseCommitmentButton        = true;
                   ShowVoidCommitmentButton         = true;
                   ShowEditVoidCommitmentNoButton   = false;
                   ShowActionBar                    = true;
               }
               #region if CommitmentApproval is Disabled
             
                if (AccessMode == "Write" && (!Mode.ToUpper().Equals("READONLY")))
                {
                    sb_ActionBarInputXML = new StringBuilder(200);
                    sb_ActionBarInputXML.Append(@"<ActionBar> 
                                              <ActionControlList ActionBarType='PageButtonBar'>");

                    if (ShowEditButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Edit Commitment' UIType='ALButton' Name='BTN_EditCommitment' Order='0' CausesValidation='False' DisplayTextID='SP_CommitmentRO_EditCommitment' TooltipID='SP_CommitmentRO_EditCommitment_Tooltip'>
                                                        <DisplayText>Edit Commitment</DisplayText>                                                    
                                                    </ActionControl>");
                    }

                    if (ShowCloseCommitmentButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Close Commitment' UIType='ALButton' Name='BTN_CloseCommitment' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_CloseCommitment' TooltipID='SP_CommitmentRO_CloseCommitment_Tooltip'>
                                                        <DisplayText>Close Commitment</DisplayText>
                                                    </ActionControl>");
                    }

                    if (ShowVoidCommitmentButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Void Commitment' UIType='ALButton' Name='btn_VoidCommitment' Order='4' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_VoidCommitment' TooltipID='SP_CommitmentRO_VoidCommitment_Tooltip'>
		                                                   <DisplayText>Void Commitment</DisplayText>
	                                                </ActionControl>");
                    }

                    if (ShowEditVoidCommitmentNoButton)
                    {
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Void Commitment' UIType='ALButton' Name='btn_EditVoidCommitmentNo' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='SP_CommitmentRO_EditVoidCommitmentNoBtn' TooltipID='SP_CommitmentRO_EditVoidCommitmentNoBtn_Tooltip'>
                                                   <DisplayText>Edit Revised #</DisplayText>
                                            </ActionControl>");
                        AB_ROCommitmentDetails.AddAttributes("btn_EditVoidCommitmentNo", "href", "javascript:" + ALPC_EditVoidCommitmentNo.ShowPopupWindowJavascript);
                    }

                    sb_ActionBarInputXML.Append(" </ActionControlList></ActionBar>");

                    CloseCommitment_PopControl.TenantName = SetBaseObj.TenantName;
                    CloseCommitment_PopControl.CaptionText = "Close Commitment";
                    CloseCommitment_PopControl.PopupDisplayMode = ePopupDisplayMode.Simple;
                    CloseCommitment_PopControl.Style.Add(HtmlTextWriterStyle.Display, "None");

                    JavaScript = new StringBuilder();
                    TempString = CloseCommitment_PopControl.ShowPopupWindowJavascript;
                    TempString = TempString.Replace("'", "\"");
                    JavaScript.AppendFormat("javascript:javascript:ShowConfirmForCloseCmt('{0}', '{1}');", this.Div_CloseCommitment.ClientID, TempString);

                    AB_ROCommitmentDetails = (ActionBar)this.ALPanel_CommitmentInfo.FindControl("AB_ROCommitmentDetails");
                    AB_ROCommitmentDetails.TenantName = SetBaseObj.TenantName;
                    if (ShowActionBar)
                    {
                        AB_ROCommitmentDetails.InputXMLType = ActionBar.XMLType.InnerXML;
                        AB_ROCommitmentDetails.InputXML = sb_ActionBarInputXML.ToString();
                        AB_ROCommitmentDetails.Click += new EventHandler(AB_ROCommitmentDetails_ActionBarClick);

                        AB_ROCommitmentDetails.AddAttributes("BTN_CloseCommitment", "href", JavaScript.ToString());
                        AB_ROCommitmentDetails.AddAttributes("BTN_EditCommitment", "href", "../../SP_CommitmentWidget/ASPX/Commitment_Edit.aspx?Param=" + FormURL("Edit"));
                    }
                }
               #endregion
           }

           //Set Invoice Widget Action Bar
           if ((!String.IsNullOrEmpty(str_InvoiceListMode)) && (!String.IsNullOrEmpty(InvoiceList.Mode)) && (!InvoiceList.Mode.ToUpper().Equals(str_InvoiceListMode.ToUpper())))
           {
               InvoiceList.Mode = str_InvoiceListMode;
           }
           InvoiceList.CommitmentStatus = str_CommitmentStatus;
       }

        /// <alsummary>
       /// <createddate>5 Feb 2009</createddate>
       /// <author>Mr.Pravin Shinde</author>
       /// <purpose>This method modify Job List XML to set job sttaus.</purpose>
       /// <featurelist>
       ///     <feature></feature>
       /// </featurelist>
       /// <xmlstructure><![CDATA[]]></xmlstructure>
       /// 	<xmlattributes>
       /// 		<node>
       ///	        <name/>
       ///	<parentnode/>
       ///	<attribute/>
       ///</node>
       /// </xmlattributes>
       /// </alsummary>
        private void ModifyJobListXML(ref String JobListXML)
        {
            XmlDocument     xmlDoc_JobListXML           = null;
            XmlNodeList     xmlNodlst_JobListXML        = null;
            XmlNode         xmlNod_ColumnNode           = null;
            String          str_JobStatus               = null;
            String          str_ReviewStatus            = null;

            xmlDoc_JobListXML = new XmlDocument();
            xmlDoc_JobListXML.LoadXml(JobListXML);

            xmlNodlst_JobListXML = xmlDoc_JobListXML.SelectNodes("List/Data/Group/Row");

            foreach (XmlNode xmlNod_Row in xmlNodlst_JobListXML)
            {
                xmlNod_ColumnNode = xmlNod_Row.SelectSingleNode("Column[@Name='STATUS']");
                str_JobStatus     = xmlNod_ColumnNode.InnerText;

                if (xmlNod_Row.SelectSingleNode("Column[@Name='REVIEWSTATUS']") != null)
                {
                    str_ReviewStatus = xmlNod_Row.SelectSingleNode("Column[@Name='REVIEWSTATUS']").InnerText;
                }
                if (String.Compare(str_JobStatus, "Completed", true) != 0)
                {
                    if (String.Compare(str_JobStatus, "Cancelled", true) == 0 && !String.IsNullOrEmpty(str_ReviewStatus))
                    {

                    }
                    else
                    {
                        xmlNod_ColumnNode = xmlNod_Row.SelectSingleNode("Column[@Name='REVIEWSTATUS']");
                        xmlNod_ColumnNode.InnerText = "---";
                    }
                }
            }
            JobListXML = xmlDoc_JobListXML.OuterXml;
        }

        /// <alsummary>
        /// <createddate>5 Feb 2009</createddate>
        /// <author>Mr.Pravin Shinde</author>
        /// <purpose>This method Get Commitment Approval settings.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private void GetCommitmentApprovalSetting()
        {
             StringDictionary            strdict_KeysWithXpath                  = null;
             StringDictionary            strdict_Values                         = null;

             if (!IsPostBack || (Session["IsCommitmentApporvalEnabled"] == null))
             {
                 strdict_KeysWithXpath  = new StringDictionary();
                 strdict_Values         = new StringDictionary();

                 strdict_KeysWithXpath.Add("COMMITMENTAPPROVALREQUIRED", "APPROVALSCONFIGURATION/COMMITMENTAPPROVALREQUIRED");
                 CommonFunctions.GetSolutionConfigurationSettings(SetBaseObj.TenantName, SetBaseObj.SolutionName, strdict_KeysWithXpath, out strdict_Values);
                 if (!String.IsNullOrEmpty(strdict_Values["COMMITMENTAPPROVALREQUIRED"]))
                 {
                     Boolean.TryParse(strdict_Values["COMMITMENTAPPROVALREQUIRED"], out IsCommitmentApprovalEnabled);
                     Session["IsCommitmentApporvalEnabled" ] = IsCommitmentApprovalEnabled.ToString();
                 }
             }
             else
             {
                 if (Session["IsCommitmentApporvalEnabled"] != null)
                 {
                     Boolean.TryParse(Session["IsCommitmentApporvalEnabled"].ToString(), out IsCommitmentApprovalEnabled);
                 }
             }
        }
        	/// <summary>
		/// This function generates breadcrumb which is passed as parameter to Reports page in case of commitment Approval.
		/// </summary>
		/// <returns></returns>
        private String generateBreadcrumb()
		{
			XmlDocument Xmldoc = null;
			XPathNavigator xpNav = null;
			XPathNodeIterator nodeIterator = null;
			String Breadcrumxml = null;
			String breadCrm = null;
			String BreadCrumbFilePath = null;

			try
				{
				Breadcrumxml = this.CommitmentBreadcrumb.InputXmlNode.InnerXml;
				Xmldoc = new XmlDocument();
				Xmldoc.LoadXml(Breadcrumxml);
				xpNav = Xmldoc.CreateNavigator();
				nodeIterator = xpNav.SelectDescendants("BreadCrumb", "", true);

				while (nodeIterator.MoveNext())
					{
					breadCrm += nodeIterator.Current.GetAttribute("DisplayText", "");

					if (nodeIterator.CurrentPosition < nodeIterator.Count)
						breadCrm += " " + this.CommitmentBreadcrumb.Separator + " ";
					}

				BreadCrumbFilePath = ALSolutionCommon.GetTempPath(SetBaseObj.SessionID) + "_" + SetBaseObj.SolutionName + "_" + "ReportBreadCrumValue.txt";
				File.WriteAllText(BreadCrumbFilePath,breadCrm);
				}
			catch (Exception excepObj)
				{
                    throw excepObj;
				}
			return BreadCrumbFilePath;
		}

        /// <summary>
        /// This method removes CommitmentBreadcrumb URL. It is required in case of commitment breadcrumb.
        /// </summary>
        /// <param name="BreadCrumbXML"></param>
        private void ProcessBreadCrumbXML(ref String BreadCrumbXML)
        {
            XmlDocument xmlDoc_BreadCrumbXML = new XmlDocument();
            xmlDoc_BreadCrumbXML.LoadXml(BreadCrumbXML);

            XmlNode xmlNod_CommitmentBreadCrumb = null;
            xmlNod_CommitmentBreadCrumb = xmlDoc_BreadCrumbXML.SelectSingleNode("//BreadCrumb[@Name='Commitmentbreadcrumb']");
            if (xmlNod_CommitmentBreadCrumb != null)
            {
                ((XmlElement)xmlNod_CommitmentBreadCrumb).SetAttribute("NavigationUrl", "");
            }
            BreadCrumbXML = xmlDoc_BreadCrumbXML.OuterXml;
        }
    }
}
