#region System_Includes
    using System;
    using System.Data;
    using System.Xml;
    using System.Text;
    using System.Configuration;
    using System.Web;
    using System.Web.Security;
    using System.Web.UI;
    using System.Collections;
    using System.Web.UI.WebControls;
    using System.Web.UI.WebControls.WebParts;
    using System.Web.UI.HtmlControls;
    using System.Xml.XPath;
    using System.IO;
    using System.Collections.Generic;
    using System.Collections.Specialized;
    using System.Xml.Xsl;
    using System.Threading;

#endregion

#region AssetlinkInclude
    using Assetlink;
    using Assetlink.Solutions;
    using Assetlink.CustomControls;
    using Assetlink.Widgets;
    using Assetlink.Solutions.Facade.CommonFacade;
    using Assetlink.Solutions.Facade.PMFacade;
    using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
    using Assetlink.Solutions.Facade.NotificationFacade;
    using Assetlink.Solutions.Facade.ApprovalsFacade;
    using Assetlink.Widgets.PMWidgetCommon;
    using Assetlink.Solutions.Pages;
    using Assetlink.Solutions.Facade.StrategicPlannerFacade;
    
#endregion

//----------------------------------------------------------//
// File Name    : Commitment_Approvals_JobDetails.aspx.cs   //
// Author       : Mr. Pravin Shinde.                        //
// Class        : Approvals_EditJobDetails                  //
// Created On   : 30th March 2007                           //
//----------------------------------------------------------//

namespace Assetlink.Solutions.StrategicPlanner
{
    using XML       = String;
    using ERRORXML  = String;

    public partial class Commitment_Approvals_JobDetails : ALAjaxPage
    {
        #region Member Variables
            private const String                        WidgetName                              = "SP_CommitmentWidget";
            private ALSolutionCommon                    ALSolutionCommonObj                     = null;
            private List<ObjectInfo>                    ObjInfoList                             = null;
            private List<ObjectInfo>                    ObjAdvInfoList                          = null;
            public ALParam                              ALParamObj                              = null;
            String[]                                    strSeparator                            = null;
            private String                              SolutionName                            = "StrategicPlanner";
            private Boolean                             Approvals_WidgetControlReferesh         = false;
            private Boolean                             ApprovalsFormReferesh                   = false;
            private Control                             ControlToRefresh;
            private PM_Approvals_WidgetEventArgs        PM_Approvals_WidgetEventArgs_Obj        = null;
            private String                              Str_SolutionDisplayName                 = "Approvals";
            private Boolean                             IsCustomized                            = false;
            private String                              TaskPaneList                            = null;
            private String                              BreadcrumbName                          = null;
            private String                              BreadcrumbID                            = null;
            private String                              BreadcrumbXML                           = null;
            private String                              str_BreadcrumbXML                       = null;
            private String                              MasterPageFileName                      = null;
            private String                              strTheme                                = null;
            private Hashtable                           UrlList                                 = null;
            private String                              str_Theme                               = null;
            private String                              PDFFilePath                             = null;
            private String                              CommitmentMode                                    = null;
            private String                              CommitmentID                            = null;
            private String                              CommitmentTitle                         = null;
            private String                              SourceAttributes                        = null;
            private String                              CommitmentAccess                              = null;
            private String                              ApprovalJobType                         = null;
            private String                              VendorResource                          = null;
            private String                              CommitmentTempFilePath                  = null;
            private String                              str_ApprovalsJobName                    = null;
            private String                              str_ParentBreadCrumbName                = null;
            private Boolean                             IsSubmitClicked                         = false;
            private String                              PODate                                  = null;
        
        #endregion

        #region ControlsOnPage
            private Form                    FRM_EditJob                             = null;
            private Form                    FRM_JobAdvDetails                       = null;
            private ActionBar               AB_EditJob                              = null;            
            private TextBox                 TextBox_ReminderFrequencey              = null;
            private CheckBox                CB_CC_To_Owner                          = null;
            private CheckBox                CB_Notify_JobDelayed                    = null;     
            private ApprovalsWidget         Approvals_WidgetControl                 = null;
            private Common_ASCX_ALUC_SuggestionListControl    UC_ReadersSelection   = null;
            private ALPanel                 ALPanel_ReadersSelection                = null;
            private ALPanel                 ALPanel_ImportNotes                     = null; 
            private SquareBlankSection      ALSqurBlnkSection_JobAdvancedDetails    = null;
            private Assetlink.CustomControls.ListControl LC_Prev_Revision           = null; 
            private HiddenField             HF_ImportNotes                          = null;     
            private RadioButton             RB_Sequential                           = null;         
            private RadioButton             RB_Simultaneous                         = null;
            private Label                   lbl_Sequential                          = null;
            private Label                   lbl_Simultaneous                        = null;
            private Help                    RouteMethod_Help                        = null;
            private ALBreadCrumb            CommitmentBreadcrumb                    = null;
            //private ALButton                Btn_EditJob                 = null; 
        #endregion

        #region Property
            public String JobProcessID
        {
            get
            {
                if (this.ViewState["JobProcessID"] != null)
                {
                    return this.ViewState["JobProcessID"].ToString();
                }
                else
                {
                    return null;
                }
            }
            set
            {
                this.ViewState["JobProcessID"] = value;
            }
        }
            #endregion
        
        #region Protected Methods

        protected void Page_PreInit(object sender, EventArgs e)
            {
                setParameters();
                this.Page.MasterPageFile    = MasterPageFileName;
                this.Page.Theme = str_Theme;
            }

            protected void Page_Init(object sender, EventArgs e)
            {
                this.Master.GetType().GetProperty("TenantName").SetValue(this.Master, ALParamObj.TenantName, null);
                this.Master.GetType().GetProperty("SolutionName").SetValue(this.Master, SolutionName, null);
                this.Master.GetType().GetProperty("SessionID").SetValue(this.Master, ALParamObj.SessionID, null);
                this.Master.GetType().GetProperty("UserID").SetValue(this.Master, ALParamObj.UserID, null);
                this.Master.GetType().GetProperty("Language").SetValue(this.Master, ALParamObj.Language, null);
            }

            protected void Page_Load(object sender, EventArgs e)
            {
                ulong           ErrorID             = 0;
                String          ErrorPageURL        = null; 

                try
                {
                    if (!IsPostBack)
                    {
                        CreateCommitmentApprovalJob();
                    }
                    setControls();
                    GetTaskPanes();
                    Ajax.AsynchronousRequest = true;
                    if (!IsPostBack)
                    {
                        getPackageProcessIDs();
                        setPageInEditMode();
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "Page_Load", ExceptionObject, null, "Exception while loading the Page.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            protected void Approvals_WidgetControl_ProcessModified(object sender, PM_Approvals_WidgetEventArgs e)
            {
                ApprovalsFacadeClass    ApprovalsFacadeObj  = null; 
                String                  EventString         = null;
                String                  ErrorXML            = null;
                String                  UpdateProcessXML    = null;
                String		            ErrorPageURL		= null;

                try
                {
                    SetAndRefreshControl(e.ControlToRefresh);

                    EventString = e.EventName;
                    ApprovalsFacadeObj = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if ((EventString == "REVIEWERS_ADDED") || ((EventString == "REVIEWERS_DELETED")) || 
                        (EventString == "REVIEWER_DURATION_MODIFIED") || (EventString == "ACTIVITY_SEQUENCE_DEPENDENCY_MODIFIED") ||
                        (EventString == "ROUTEMETHOD_CHANGED"))
                    {                
                        GetApprovalTaskXMLForUpdate(null, EventString, out UpdateProcessXML);
                        ErrorXML = ApprovalsFacadeObj.UpdateApprovalsJob(JobProcessID, true, MWB_TimeLineEvents.TASK_DURATION_CHANGED, ref UpdateProcessXML);
                        if (ErrorXML != null)
                        {
							ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                        UpdateApprovalsFormXML();
                        ApprovalsFormReferesh = true;
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }
            
            protected void AB_EditJob_Click(object sender, EventArgs e)
            {
                try
                {
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btn_SaveAsDraft"))
                    {
                        if (ValidateReminderDuration())
                            Ajax.WriteExecuteJavaScript("ShowAlert('Alert_Approvals_NumericDurationNeeded_Shared');");
                        else
                            SaveApprovalsJob("Draft");
                    }
                    else if (Parameters[1].Equals("btn_Submit"))
                    {
                        if (ValidateReminderDuration())
                            Ajax.WriteExecuteJavaScript("ShowAlert('Alert_Approvals_NumericDurationNeeded_Shared');");
                        else
                        if (Approvals_WidgetControl.DuplicateReviewersSelected)
                            Ajax.WriteExecuteJavaScript("ShowAlert('Alert_Common_DuplicateApproversSelected');");
                        else
                        {
                            Approvals_WidgetControl.PreformPostSubmitActions();
                            if (Approvals_WidgetControl.ReviewersSelected == false)
                                Ajax.WriteExecuteJavaScript("ShowAlert('Alert_Approvals_EditJobDetails_PleseSelApprover');");
                            else if (Approvals_WidgetControl.ApprovalsFileUploaded == false)
                                Ajax.WriteExecuteJavaScript("ShowAlert('Alert_Approvals_EditJobDetails_UploadFileForApp');");
                            else
                                SaveApprovalsJob("Active");
                        }

                    }
                    else if (Parameters[1].Equals("btn_Cancel"))
                    {
                        gotoCommitmentROPage();
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            protected void Approvals_WidgetControl_BeforeProcessModification(object sender, PM_Approvals_WidgetEventArgs e)
            {
                String  EventString      = null;
                String  JavascriptURL    = null;

                try
                {
                    EventString = e.EventName;
                   
                    if (EventString == "ADD_REVIEWERS_CLICKED")
                    {
                        JavascriptURL = Approvals_WidgetControl.GetUserSelectionWindowURL;
                        if (!String.IsNullOrEmpty(JavascriptURL))
                        {
                            Ajax.WriteExecuteJavaScript(JavascriptURL);
                        }

                        SetAndRefreshControl(e.ControlToRefresh);
                    }
                    else if (EventString == "CALCULATE_TIMELINE_CLICKED")
                        CalculateTimeLineClicked();
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

     
            protected override void Render(HtmlTextWriter writer)
            {

                RB_Simultaneous.Attributes.Add("onclick", Approvals_WidgetControl.RouteMethodSimultaneous_JavaScript);
                RB_Sequential.Attributes.Add("onclick", Approvals_WidgetControl.RouteMethodSequential_JavaScript);
                
                if (IsPostBack)
                {
                    String EventGenerator = Ajax.EventGeneratorUniqueID;

                    //if (EventGenerator.Contains("ALUC_ReadersSelection")||(EventGenerator.Contains("ALUC_ReadersSelection") && EventGenerator.Contains("BTN_DELETEUSER")) || (EventGenerator.Contains("ALUC_ReadersSelection") && EventGenerator.Contains("btnHiddenSelectUserGroup")))
                    if(UC_ReadersSelection.IsControlUpdated)
                        Ajax.AddControlsToRender(ALPanel_ReadersSelection);

                    if ((ApprovalsFormReferesh == true) || (EventGenerator.Contains("ApprovalsDetails_Form")))
                    {
                        Ajax.AddControlsToRender(FRM_EditJob);
                        Ajax.AddControlsToRender(FRM_JobAdvDetails);
                    }
                    if (ControlToRefresh != null)
                        Ajax.AddControlsToRender(ControlToRefresh);

                    if ((EventGenerator.Contains("LC_ID_PreviousRevisions_Min_Btn")) || (EventGenerator.Contains("LC_ID_PreviousRevisions")))
                        Ajax.AddControlsToRender(LC_Prev_Revision);

                    Ajax.WriteControlHTMl(this.Page, writer);
                }
                else
                    base.Render(writer);
            }
        #endregion

        #region Private Methods

            private void CalculateTimeLineClicked()
            {
                XML                     JobXML              = null; 
                ERRORXML                ErrorXML            = null;
                ApprovalsFacadeClass    ApprovalsFacadeObj  = null; 
                try
                {
                    ApprovalsFacadeObj = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

					GetApprovalTaskXMLForUpdate("", "CALCULATE_TIMELINE_CLICKED", out JobXML);
                    if (!String.IsNullOrEmpty(JobXML))
                    {
                        ErrorXML = ApprovalsFacadeObj.UpdateApprovalsJob(JobProcessID, true, MWB_TimeLineEvents.TASK_DURATION_CHANGED, ref JobXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            UpdateApprovalsFormXML();
                            ApprovalsFormReferesh = true;
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            private void setParameters()
            {
			    ulong   ErrorID     = 0;
                String  ErrorPageURL= null; 

                try
                {
                    UrlList                 = new Hashtable();
                    ALSolutionCommonObj     = new ALSolutionCommon();
                    ALParamObj              = new ALParam();
                    ALSolutionCommonObj.httpContext = HttpContext.Current;
                    ALSolutionCommonObj.InitALParam(ref ALParamObj);

                    TaskPaneList                = ALSolutionCommonObj.GetParamValue("TaskPaneList");
                    JobProcessID                = ALSolutionCommonObj.GetParamValue("JobProcessID");
                    MasterPageFileName          = ALSolutionCommonObj.GetParamValue("MasterPageFile");
                    CommitmentMode              = ALSolutionCommonObj.GetParamValue("CommitmentMode");
                    CommitmentID                = ALSolutionCommonObj.GetParamValue("CommitmentID");
                    TaskPaneList                = ALSolutionCommonObj.GetParamValue("TaskPaneList");
                    str_Theme                   = ALSolutionCommonObj.GetParamValue("Theme");
                    SourceAttributes            = ALSolutionCommonObj.GetParamValue("SOURCEATTRIBUTES");
                    CommitmentAccess            = ALSolutionCommonObj.GetParamValue("CommitmentAccess");
                    BreadcrumbName              = ALSolutionCommonObj.GetParamValue("BREADCRUMBNAME");
                    BreadcrumbID                = ALSolutionCommonObj.GetParamValue("BREADCRUMBID");
                    CommitmentTitle             = ALSolutionCommonObj.GetParamValue("CommitmentTitle");
                    BreadcrumbXML               = ALSolutionCommonObj.GetParamValue("BREADCRUMBXML");
                    IsCustomized                = Convert.ToBoolean(ALSolutionCommonObj.GetParamValue("IsCustomized"));
                    ApprovalJobType             = ALSolutionCommonObj.GetParamValue("ApprovalJobType");
                    PDFFilePath                 = Server.UrlDecode(ALSolutionCommonObj.GetParamValue("PDFFilePath"));
                    SolutionName                = ALSolutionCommonObj.GetParamValue("SolutionName");
                    VendorResource              = ALSolutionCommonObj.GetParamValue("VendorResource");
                    CommitmentTempFilePath      = ALSolutionCommonObj.GetParamValue("CommitmentTempFilePath");
                    str_ParentBreadCrumbName    = ALSolutionCommonObj.GetParamValue("PARENTBREADCRUMBNAME");
                    PODate                      = ALSolutionCommonObj.GetParamValue("PODate");
                    if (!String.IsNullOrEmpty(CommitmentTempFilePath))
                    {
                        CommitmentTempFilePath = Server.UrlDecode(CommitmentTempFilePath);
                    }
                    if (String.IsNullOrEmpty(SolutionName))
                    {
                        SolutionName = "StrategicPlanner";
                    }

                    if (!IsPostBack)
                        ViewState.Add("IsMediaFileForImportNotes", false);

                    UrlList.Add("IsCustomized", IsCustomized.ToString());
                    UrlList.Add("AccessMode", CommitmentAccess);
                    UrlList.Add("SOURCEATTRIBUTES", SourceAttributes);
                    UrlList.Add("TaskPaneList", TaskPaneList);
                    UrlList.Add("CommitmentID", CommitmentID);
                    UrlList.Add("Mode", CommitmentMode);
                    UrlList.Add("MasterPageFile", MasterPageFileName);
                    UrlList.Add("Theme", strTheme);
                    UrlList.Add("RelationshipName", "COMMITMENT_TO_INVOICE");
                    UrlList.Add("SourceEntityID", CommitmentID.ToString());

                    strSeparator = new String[1] { "$AL$" };
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "setParameters", ExceptionObject, null, "Exception while setting the parameters for the Create Page.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            private void setControls()
            {
                StringBuilder ListControlXSLTPath   = null;
                StringBuilder ActionBarXMLPath      = null;
                String        InstalledPath         = null;
                String        FormatXMLPath         = null;
                String        CultureInformation    = null;
			    ulong         ErrorID				= 0;
                String        ErrorPageURL          = null; 
                Literal       Literal1              = null;
                Literal       Literal2              = null;

                try
                {
                    ActionBarXMLPath    = new StringBuilder(125);
                    ListControlXSLTPath = new StringBuilder(125);

                    FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);

                    Page_CreatePage.TenantName = ALParamObj.TenantName;
                    Page_CreatePage.SectionHeading = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_EditJobDetails_AppJobDetails");

                    // set the input XML paths of task panes.
                    InstalledPath = ALCommon.GetInstallationDir();
                    ListControlXSLTPath.AppendFormat("{0}{1}\\XSLT\\SortListXML.xslt", InstalledPath, ALParamObj.TenantName);

                    FRM_EditJob                         = (Form)Page_CreatePage.FindControl("ApprovalsDetails_Form");
                    FRM_EditJob.TenantName              = ALParamObj.TenantName;
                    FRM_EditJob.SolutionName            = SolutionName;
                    FRM_EditJob.WidgetName              = WidgetName;
                    FRM_EditJob.CultureInformation      = CultureInformation;
                    FRM_EditJob.PersonalizationFilePath = FormatXMLPath;
                    FRM_EditJob.AddCustomValidator("WORKFLOWPROCESS_PROCESSNAME", "onblur", "ValidateName('$CONTROLID$')", false);
                    
                    ALSqurBlnkSection_JobAdvancedDetails             = (SquareBlankSection)Page_CreatePage.FindControl("ID_JobAdvancedDetails");
                    ALSqurBlnkSection_JobAdvancedDetails.TenantName  = ALParamObj.TenantName;

                    FRM_JobAdvDetails                                = (Form)ALSqurBlnkSection_JobAdvancedDetails.FindControl("ApprovalsAdvacedDetails_Form");
                    FRM_JobAdvDetails.TenantName                     = ALParamObj.TenantName;
                    FRM_JobAdvDetails.SolutionName                   = SolutionName;
                    FRM_JobAdvDetails.CultureInformation             = CultureInformation;
                    FRM_JobAdvDetails.PersonalizationFilePath        = FormatXMLPath;
                    FRM_JobAdvDetails.WidgetName = WidgetName;

                    TextBox_ReminderFrequencey                      = (TextBox)ALSqurBlnkSection_JobAdvancedDetails.FindControl("ID_ReminderFrq");
                    TextBox_ReminderFrequencey.Attributes.Add("onblur", "javascript:ValidateDuration('" + TextBox_ReminderFrequencey.ClientID + "')");


                    CB_CC_To_Owner                                  = (CheckBox)ALSqurBlnkSection_JobAdvancedDetails.FindControl("CheckBox_ID_CC_To_Owner");
                    CB_Notify_JobDelayed                            = (CheckBox)ALSqurBlnkSection_JobAdvancedDetails.FindControl("CheckBox_ID_Notify_JobDelayed");
                    Approvals_WidgetControl                         = (ApprovalsWidget)Page_CreatePage.FindControl("Approvals_Widget");

                    ALPanel_ReadersSelection                        = (ALPanel)ALSqurBlnkSection_JobAdvancedDetails.FindControl("ID_ReadersSelection");
                    UC_ReadersSelection                             = (Common_ASCX_ALUC_SuggestionListControl)ALPanel_ReadersSelection.FindControl("ALUC_ReadersSelection");

                    ALPanel_ImportNotes                             = (ALPanel)Page_CreatePage.FindControl("ALPanel_ImportNotes");
                    HF_ImportNotes                                  = (HiddenField)ALPanel_ImportNotes.FindControl("__ImportNotes");

                    LC_Prev_Revision                                = (Assetlink.CustomControls.ListControl)ALSqurBlnkSection_JobAdvancedDetails.FindControl("LC_ID_PreviousRevisions");
                    LC_Prev_Revision.TenantName                     = ALParamObj.TenantName;
                    LC_Prev_Revision.XSLTPath                       = ListControlXSLTPath.ToString();

                    LC_Prev_Revision.CultureInformation = CultureInformation;
                    LC_Prev_Revision.PersonalizationFilePath = FormatXMLPath;

                    LC_Prev_Revision.EventOnExpand = true;
                    LC_Prev_Revision.CollapsedClick += new EventHandler(LC_Prev_Revision_CollapsedClick);
                    if (!IsPostBack)
                        LC_Prev_Revision.IsMinimize = true;

                    RB_Sequential                                    = (RadioButton)ALSqurBlnkSection_JobAdvancedDetails.FindControl("RB_Sequential");
                    RB_Simultaneous                                  = (RadioButton)ALSqurBlnkSection_JobAdvancedDetails.FindControl("RB_Simultaneous");
                    lbl_Simultaneous                                 = (Label)ALSqurBlnkSection_JobAdvancedDetails.FindControl("Simultaneous_Label");
                    lbl_Sequential                                   = (Label)ALSqurBlnkSection_JobAdvancedDetails.FindControl("Sequential_Label");
                    RouteMethod_Help                                 = (Help)ALSqurBlnkSection_JobAdvancedDetails.FindControl("Help_RouteMethod");
                    RouteMethod_Help.TenantName                      = ALParamObj.TenantName;
                    RouteMethod_Help.ContentDisplayMode              = Help.DisplayModeEnum.HTML;
                    RouteMethod_Help.Content = @"
                                        <b>" + Localization.GetString("ALResource",ALParamObj.TenantName,"Approvals_RouteMethod_Shared")+ @"</b>
                                        <ul>
                                        <li>" + Localization.GetString("ALResource",ALParamObj.TenantName,"Approvals_EditJobDetails_SequentialMethodInfo") + @"</li>
                                        <li>" + Localization.GetString("ALResource",ALParamObj.TenantName,"Approvals_EditJobDetails_SimultaneousMethodInfo") + @"</li>
                                        <li>" + Localization.GetString("ALResource",ALParamObj.TenantName,"Approvals_EditJobDetails_SequenSimulMethodsInfo") + @"</li>
                                        </ul>
                                        ";
                    AB_EditJob = (ActionBar)Page_CreatePage.FindControl("ID_EditJob_ActionBar");
                    AB_EditJob.TenantName = ALParamObj.TenantName;
                    ActionBarXMLPath = null;
                    ActionBarXMLPath = new StringBuilder();
                    ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, WidgetName, "Approvals_EditJob_AB_EditJobButtonBar"));
                    AB_EditJob.InputXML     = ActionBarXMLPath.ToString();
                    AB_EditJob.Click    +=new EventHandler(AB_EditJob_Click);

                    CommitmentBreadcrumb = (ALBreadCrumb)this.Page_CreatePage.FindControl("CommitmentBreadcrumb");
                    CommitmentBreadcrumb.TenantName = ALParamObj.TenantName;
                    this.CommitmentBreadcrumb.ParentBreadcrumbName = BreadcrumbName;
                    if (!String.IsNullOrEmpty(BreadcrumbID))
                    {
                        CommitmentBreadcrumb.ParentBreadcrumbName   = BreadcrumbName;
                        CommitmentBreadcrumb.BreadcrumbUniqueID     = BreadcrumbID;
                    }
                    else
                    {
                        CommitmentBreadcrumb.ParentBreadcrumbName   = BreadcrumbName; 
                    }

                    if (String.IsNullOrEmpty(BreadcrumbID) && (!String.IsNullOrEmpty(BreadcrumbXML)) && (System.IO.File.Exists(BreadcrumbXML)))
                    {
                        str_BreadcrumbXML = System.IO.File.ReadAllText(BreadcrumbXML);
                        this.CommitmentBreadcrumb.InputXml = str_BreadcrumbXML;
                        BreadcrumbID  = CommitmentBreadcrumb.BreadcrumbUniqueID;
                    }
                    if (!IsPostBack)
                    {
                        this.CommitmentBreadcrumb.NavigateUrl = this.Request.Url.AbsoluteUri;
                    }
                    CommitmentBreadcrumb.DisplayText = Server.UrlDecode(str_ApprovalsJobName);
                    
                    Literal1 = (Literal)ALSqurBlnkSection_JobAdvancedDetails.FindControl("Literal1");
                    Literal1.Text    = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_RouteMethod_Shared") + ":";
                    Literal2 = (Literal)ALSqurBlnkSection_JobAdvancedDetails.FindControl("Literal2");
                    Literal2.Text = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_EditJobDetails_SendReminders") + ":";
                    
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "setControls", ExceptionObject, null, "Exception while setting the controls.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            void GetTaskPanes()
            {
            try
            {
                Search searchControl = null;
                String[] TaskPaneSep = new String[1] { "$AL$" };
                LeftPaneFacade LFP = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName);
                ContentPlaceHolder LeftPane = (ContentPlaceHolder)this.Master.FindControl("Assetlink_LeftBarContentPlaceHolder");
                LeftPane.Controls.Clear();
                LeftPane.Controls.Add(new LiteralControl("<table width='100%' cellpadding='0' cellspacing='0'>"));
                if (!String.IsNullOrEmpty(TaskPaneList))
                {
                    String[] ListofTaskPanes = TaskPaneList.Split(TaskPaneSep, StringSplitOptions.RemoveEmptyEntries);

                    foreach (String strTaskPane in ListofTaskPanes)
                    {
                        
                        char[] sep = new char[1] { '$' };
                        String[] TaskPaneAttrib = strTaskPane.Split(sep, StringSplitOptions.RemoveEmptyEntries);
                        if (!TaskPaneAttrib[0].Contains("SEARCHPANECONTROL_"))
                        {
                            LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                            TaskPane ctlTaskPane = new TaskPane();
                            ctlTaskPane.TaskPaneName = TaskPaneAttrib[0];
                            if (TaskPaneAttrib.Length > 1)
                            {
                                ctlTaskPane.SelectedSectionName = TaskPaneAttrib[1];
                            }
                            LeftPane.Controls.Add(ctlTaskPane);
                            LeftPane.Controls.Add(new LiteralControl("</td></tr>"));
                        }
                        else
                        {
                            Search ctlTaskPane = new Search();
                            ctlTaskPane.SearchPaneName = TaskPaneAttrib[0].Replace("SEARCHPANECONTROL_", "");
                            if (TaskPaneAttrib.Length > 1)
                            {
                                ctlTaskPane.SelectedSectionName = TaskPaneAttrib[1];
                            }
                            searchControl = ctlTaskPane;
                        }
                        
                    }
                }
                if (searchControl != null)
                {
                    LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                    LeftPane.Controls.Add(searchControl);
                    LeftPane.Controls.Add(new LiteralControl("</td></tr>"));
                }
                LeftPane.Controls.Add(new LiteralControl("</table>"));
                LFP.GetTaskPaneNode(this.Page, UrlList);
            }
            catch (Exception )
            {
            }
        }

            private void setPageInEditMode()
            {
                FormFacade                  FormFacadeObj       = null;
                ApprovalsFacadeClass        ApprovalsFacadeObj  = null; 
                StringBuilder               AssociationXML      = null;
                StringBuilder               sb_AttributesXML    = null;
                String                      TempFilePath        = null; 
                String                      FormConfigXMLPath   = null; 
                String                      JobName             = null; 
                String                      ErrorPageURL        = null; 
                StringBuilder               FormDataXML         = null; 
                XML                         ReturnJobXML        = null; 
                XML                         FormInputXML        = null; 
                XmlDocument                 InputXMLDoc         = null; 
                XmlDocument                 FormInputXMLDoc     = null;
                XmlNode                     FieldNode           = null; 
                XmlNode                     WorkflowProcessNode = null; 
                XmlNode                     WorkflowInfoNode    = null;
                XmlNode                     ReminderFrqNode     = null;
                XmlNode                     CCToOwnerNode       = null;
                XmlNode                     NotifyJobDelayNode  = null; 
                XmlNode                     ReadersNode         = null; 
                ERRORXML                    ErrorXML            = null;
                String                      str_AssociatedFacets= null;
                try
                {
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    AssociationXML      = new StringBuilder(50);

                    TempFilePath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

                    ErrorXML  = getAssociatedAdditionalFacets(out str_AssociatedFacets);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='FALSE'>" + str_AssociatedFacets);
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                    }

                            AssociationXML.Append(@"<READERS Type='RELATION'>
		                                                <LOGINNAME/>
		                                                <FIRSTNAME/>
		                                                <MIDDLEINITIAL/>
		                                                <LASTNAME/>
		                                                <EMAILID/>
	                                                </READERS>	                                                
                                                </ASSOCIATION>");
                        
                        sb_AttributesXML = new StringBuilder(100);
                        sb_AttributesXML.Append(@"<WORKFLOWPROCESS>
	                                                    <WORKFLOWPROCESSID/>
                                                        <PROCESSNAME/>
                                                        <DESCRIPTION/>
	                                                    <STATUS/>
                                                        <STARTDATE/>
                                                        <DUEDATE/>
                                                        <ACTUALSTARTDATE/>
	                                                    <ACTUALENDDATE/>
                                                        <PROCESSFILE/>
                                                    </WORKFLOWPROCESS>");

                    ErrorXML = ApprovalsFacadeObj.GetApprovalsJob(JobProcessID, null, AssociationXML.ToString(), out ReturnJobXML);
                    if (ErrorXML == null)
                    {
                        InputXMLDoc = new XmlDocument();
                        InputXMLDoc.LoadXml(ReturnJobXML);

                        WorkflowProcessNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS");
                        
                        JobName = WorkflowProcessNode.SelectSingleNode("PROCESSNAME").InnerText;
                        
                        __JobStatus.Value = WorkflowProcessNode.SelectSingleNode("STATUS").InnerText;
                        __WorkflowInformationID.Value = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/WORKFLOWINFORMATIONID").InnerText;

                        __RevisionNumber.Value = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/REVISIONNUMBER").InnerText;

                        __ApprovalsJobID.Value = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/APPROVALSJOBID").InnerText;

                       
                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        FormFacadeObj.FormName              = "Approvals_JobDetails";
                        FormFacadeObj.ShowConfiguredFields  = false;
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        FormDataXML                         = new StringBuilder();
                        FormDataXML.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", WorkflowProcessNode.OuterXml);
                        ErrorXML                            = FormFacadeObj.GetFormInputXML("EDIT", FormDataXML.ToString(), out FormInputXML, out ObjInfoList);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(FormInputXML)))
                        {
                            FRM_EditJob.ConfigurationXMLType    = CustomControls.Form.InputType.XMLPath;
                            FRM_EditJob.ConfigurationXML        = FormConfigXMLPath;
                            FRM_EditJob.InputXML                = FormInputXML;
                        }
                        ViewState["ObjectList"] = ObjInfoList;
                        FormInputXML                        = null;

                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                            
                        FormFacadeObj.FormName              = "JobAdvancedDetails";
                        FormFacadeObj.ShowConfiguredFields  = false;
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        ErrorXML = FormFacadeObj.GetFormInputXML("EDIT", FormDataXML.ToString(), out FormInputXML, out ObjAdvInfoList);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(FormInputXML)))
                        {
                            FormInputXMLDoc = new XmlDocument();
                            FormInputXMLDoc.LoadXml(FormInputXML);

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALDUEDATE']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_REVIEWSTATUS']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWINFORMATION_ROUTEMETHOD']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            ViewState["AdvancedObjectList"]         = ObjAdvInfoList;
                            FRM_JobAdvDetails.ConfigurationXMLType  = CustomControls.Form.InputType.XMLPath;
                            FRM_JobAdvDetails.ConfigurationXML      = FormConfigXMLPath;
                            FRM_JobAdvDetails.InputXML              = FormInputXMLDoc.OuterXml;
                            //Paint the WorkflowInfo fields
                            WorkflowInfoNode = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
                            if (WorkflowInfoNode != null)
                            {
                                ReminderFrqNode = WorkflowInfoNode.SelectSingleNode("REMINDERFREQUENCY");
                                if ((ReminderFrqNode != null) && (!String.IsNullOrEmpty(ReminderFrqNode.InnerText)))
                                    TextBox_ReminderFrequencey.Text = ReminderFrqNode.InnerText;

                                CCToOwnerNode = WorkflowInfoNode.SelectSingleNode("CCTOOWNER");
                                if ((CCToOwnerNode != null) && (CCToOwnerNode.InnerText == "0"))
                                    CB_CC_To_Owner.Checked = false;

                                if (WorkflowInfoNode.SelectSingleNode("ROUTEMETHOD") != null)
                                {
                                    if (String.Compare(WorkflowInfoNode.SelectSingleNode("ROUTEMETHOD").InnerText, "SEQUENTIAL", true) == 0)
                                        RB_Sequential.Checked   = true;
                                    else
                                        RB_Simultaneous.Checked = true;
                                }
                            }

                            //Paint Approvals Widget
                            setApprovalsWidget(WorkflowProcessNode);

                            ReadersNode = WorkflowProcessNode.SelectSingleNode("READERS");
                            setReadersSelectionControl(ReadersNode);

                            SetActionBar(__RevisionNumber.Value,__ApprovalsJobID.Value);

                            //Hide revision list if no revisions present
                            if (Convert.ToUInt16(__RevisionNumber.Value) < 2)
                            {
                                LC_Prev_Revision.Visible = false;                                
                            }
                          
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("Approvals", null, "APPROVALSJOB", ErrorXML, "Error while getting form input XML.", null, GetBackUrl(), ref ErrorPageURL);
                            Response.Redirect(ErrorPageURL, true);
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl("Approvals", null, "APPROVALSJOB", ErrorXML, "Error while getting Approvals Job.", null, GetBackUrl(), ref ErrorPageURL);
                        Response.Redirect(ErrorPageURL, true);
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setApprovalsWidget(XmlNode WorkflowProcessNode)
            {
                String                      ApprovalsMode                   = null;
                String                      AttachmentsRequired             = null;
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj          = null; 
				String						PackageDefID			        = null;
				String						ProcessDefID			        = null;
                String                      str_DocumentRequired            = null;
                Boolean                     bl_CancelSelectAll              = true;
                StringDictionary            strdict_KeysWithXpath           = null;
                StringDictionary            strdict_Values                  = null;
                
                try
                {
                    strdict_KeysWithXpath = new StringDictionary();
                    strdict_Values = new StringDictionary();
                    

                    MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        
                    ApprovalsMode = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/ROUTEMETHOD").InnerText;
					PackageDefID = WorkflowProcessNode.SelectSingleNode("PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID").InnerText;
					ProcessDefID = WorkflowProcessNode.SelectSingleNode("PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").InnerText;

                    Approvals_WidgetControl.SessionID                               = ALParamObj.SessionID;
                    Approvals_WidgetControl.UserID                                  = ALParamObj.UserID;
                    Approvals_WidgetControl.TenantName                              = ALParamObj.TenantName;
                    Approvals_WidgetControl.Language                                = ALParamObj.Language;
                    Approvals_WidgetControl.SolutionName                            = SolutionName;
                    Approvals_WidgetControl.WidgetName                              = "PM_APPROVALSWIDGET";
                    Approvals_WidgetControl.ProcessID                               = JobProcessID;
                    Approvals_WidgetControl.DefaultScreenName                       = "APPROVALS_EDIT";
					Approvals_WidgetControl.PackageDefinitionID                     = PackageDefID;
					Approvals_WidgetControl.ProcessDefinitionID                     = ProcessDefID;
                    Approvals_WidgetControl.FileforApprovalSection_TitleBarVisible  = false;
                    Approvals_WidgetControl.show_JobMode                            = false;
                    Approvals_WidgetControl.ShowGlobalRoutes                        = true;

                    Approvals_WidgetControl.CancelApprovalIfRejectedSelectAll = bl_CancelSelectAll;// Convert.ToBoolean(str_CancelSelectAll);         

                    MktgWorkBenchFacadeObj.ReadSolutionConfiguration(SolutionName, "DOCUMENTREQUIRED", out str_DocumentRequired);
                    if ((!String.IsNullOrEmpty(str_DocumentRequired)) && (str_DocumentRequired.ToUpper() == "NO"))
                    {
                        Approvals_WidgetControl.DocumentRequired = false;
                    }
                    else
                    {
                        Approvals_WidgetControl.DocumentRequired = true;
                    }  

                    //Read solution configuration XML for attachments required value
                    MktgWorkBenchFacadeObj.ReadSolutionConfiguration(SolutionName, "ATTACHMENTSREQUIRED", out AttachmentsRequired);
                    if ((!String.IsNullOrEmpty(AttachmentsRequired)) && (AttachmentsRequired.ToUpper() == "YES"))
                        Approvals_WidgetControl.AttachmentsRequired = true;                
                    else
                        Approvals_WidgetControl.AttachmentsRequired = false;  

                    if (ApprovalsMode.ToUpper() == "SIMULTANEOUS")
                        Approvals_WidgetControl.ApprovalsMode = ApprovalsWidget.ApprovalsModeType.SIMULTANEOUS;
                    else if (ApprovalsMode.ToUpper() == "SEQUENTIAL")
                        Approvals_WidgetControl.ApprovalsMode = ApprovalsWidget.ApprovalsModeType.SEQUENTIAL;

                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void SetAndRefreshControl(List<String> ControlHierarchy)
            {
                for (int index = 0; index < ControlHierarchy.Count; index++)
                {
                    if (index == 0)
                        ControlToRefresh = ALFindControl((Control)Page, ControlHierarchy[index]);
                    else
                        ControlToRefresh = ALFindControl(ControlToRefresh, ControlHierarchy[index]);
                }
            }
            
            private Control ALFindControl(Control SourceControl, String ID)
            {
                Control Ctrl = null;
                Ctrl = SourceControl.FindControl(ID);
                if (Ctrl == null)
                {
                    for (int i = 0; i < SourceControl.Controls.Count; i++)
                    {
                        Ctrl = ALFindControl(SourceControl.Controls[i], ID);
                        if (Ctrl != null)
                            break;
                    }
                }
                return Ctrl;
            }

            private void GetApprovalTaskXMLForUpdate(String JobStatus, String EventString, out String ApprovalJobXML)
            {
                XmlDocument  FormDataDocument    = null;
                XmlDocument  UserDoc             = null;
                XmlNode      WorkflowProcessNode = null;
                XmlNode      StatusNode          = null;
                XmlNode      ReadersNode         = null;
                XmlNode      WFProc_WFInfoNode   = null;
                XmlNode      WFInfoNode          = null;
                XmlNode      RouteMethodNode     = null;
                XmlNode      ReminderFreqNode    = null;
                XmlNode      CCToOwnerNode       = null;
                XmlNode      NotifyIfDelayedNode = null; 
                XmlNode      StartDateNode       = null;
                XmlNode      xmlNod_ProcessName  = null;
                XmlNode      xmlNod_ProcessDesc  = null;
                XmlNodeList  UserNodeList        = null;
                String       UserXML             = null;
                StringBuilder TodaysDateXML      = null; 
                String       FormOutputXML       = null;
                String       ErrorXML            = null;
                StringBuilder WorkFlowCategory   = null;    
                FormFacade   FormFacadeObj       = null;
                String          JobFormXML       = null;
                XPathDocument   xpDoc_JobInfo    = null;
                XPathNavigator  xpNav_JobInfo    = null;
                String          FormConfigXMLPath = null;
                try
                {
                 

                    ApprovalJobXML                          = null;
                    TodaysDateXML                           = new StringBuilder();
                    ObjAdvInfoList                          = (List<ObjectInfo>)ViewState["AdvancedObjectList"];

                    FormFacadeObj                           = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    if (IsCustomized)
                    {
                        FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "JobAdvancedDetails_FormConfiguration");
                    }
                    else
                    {
                        FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "JobAdvancedDetails_FormConfiguration");
                    }
                    FormFacadeObj.FormName                  = "JobAdvancedDetails";
                    FormFacadeObj.SolutionName              = SolutionName;
                    FormFacadeObj.ReturnOnlyRelatedInfo     = true;
                    FormFacadeObj.ConfigurationXML          = FormConfigXMLPath;
                    FormFacadeObj.ConfigurationXMLType      = "XMLPath";
                    ErrorXML = FormFacadeObj.GetFormDataXML("EDIT", "DATAFIELD", FRM_JobAdvDetails, ObjAdvInfoList, out FormOutputXML);
                    if (ErrorXML == null)
                    {
                        FormDataDocument = new XmlDocument();
                        //WorkflowProcessNode = FormDataDocument.CreateElement("WORKFLOWPROCESS");
                        //FormDataDocument.AppendChild(WorkflowProcessNode);

                        //WFProcessIDNode = FormDataDocument.CreateElement("WORKFLOWPROCESSID");
                        //WFProcessIDNode.InnerText = JobProcessID;
                        FormDataDocument.LoadXml(FormOutputXML);

                        WorkflowProcessNode = FormDataDocument.SelectSingleNode("WORKFLOWPROCESS");
                        if ((!String.IsNullOrEmpty(JobStatus)) && (JobStatus.ToUpper() == "ACTIVE"))
                        {
                            //Put the Process Start Date
                            StartDateNode = WorkflowProcessNode.SelectSingleNode("STARTDATE");
                            if ((StartDateNode != null) && (StartDateNode.HasChildNodes))
                            {
                                StartDateNode.SelectSingleNode("DAY").InnerText = DateTime.Today.Day.ToString();
                                StartDateNode.SelectSingleNode("MONTH").InnerText = DateTime.Today.Month.ToString();
                                StartDateNode.SelectSingleNode("YEAR").InnerText = DateTime.Today.Year.ToString();
                            }
                        }

                        if (!String.IsNullOrEmpty(JobStatus))
                        {
                            if (!String.IsNullOrEmpty(__JobStatus.Value))
                            {
                                if (__JobStatus.Value.ToUpper() != JobStatus.ToUpper())
                                {
                                    StatusNode = WorkflowProcessNode.SelectSingleNode("STATUS");
                                    StatusNode.InnerText = JobStatus;
                                    WorkflowProcessNode.AppendChild(StatusNode);  
                                }
                                else
                                    WorkflowProcessNode.RemoveChild(WorkflowProcessNode.SelectSingleNode("STATUS"));
                            }
                        }
                        else
                            WorkflowProcessNode.RemoveChild(WorkflowProcessNode.SelectSingleNode("STATUS"));

                        //WorkflowProcessNode.AppendChild(WFProcessIDNode);   

                        WFProc_WFInfoNode = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION");
                        WFInfoNode = WFProc_WFInfoNode.SelectSingleNode("WORKFLOWINFORMATION");
                        ((XmlElement)WFInfoNode).SetAttribute("MODIFIED", "TRUE");  

                        if ((EventString != null) && (EventString.ToUpper() == "ROUTEMETHOD_CHANGED"))
                        {
                            //Change the RouteMethod field in the ALFCT_WORKFLOWINFORMATION facet.
                            //WFProc_WFInfoNode = FormDataDocument.CreateElement("WORKFLOWPROCESS_WORKFLOWINFORMATION");
                            //((XmlElement)WFProc_WFInfoNode).SetAttribute("TYPE", "RELATION");
                            //WorkflowProcessNode.AppendChild(WFProc_WFInfoNode);
            
                            //WFInfoNode = FormDataDocument.CreateElement("WORKFLOWINFORMATION");
                            //((XmlElement)WFInfoNode).SetAttribute("MODIFIED", "TRUE");
                            //WFProc_WFInfoNode.AppendChild(WFInfoNode);

                            //WFInfoIDNode = FormDataDocument.CreateElement("WORKFLOWINFORMATIONID");
                            //WFInfoIDNode.InnerText = __WorkflowInformationID.Value;
                            //WFInfoNode.AppendChild(WFInfoIDNode);

                            RouteMethodNode = FormDataDocument.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/ROUTEMETHOD");
                            if (RouteMethodNode == null)
                            {
                                RouteMethodNode = FormDataDocument.CreateElement("ROUTEMETHOD");
                            }
                            RouteMethodNode.InnerText = Approvals_WidgetControl.ApprovalsMode.ToString();
                            WFInfoNode.AppendChild(RouteMethodNode);
                        }
                        else
                        {
                            RouteMethodNode = FormDataDocument.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/ROUTEMETHOD");
                            if (RouteMethodNode != null)
                            {
                                WFInfoNode.RemoveChild(RouteMethodNode);

                            }
                        }
						if (String.IsNullOrEmpty(EventString))
						{
							//UserXML = UC_ReadersSelection.GetOutputUserList(UC_ReadersSelection.InstanceName);
                            UserXML = UC_ReadersSelection.OutputEntityCollectionXML;
							if (UserXML != null)
							{
								UserDoc = new XmlDocument();
								UserDoc.LoadXml(UserXML);
                                UserNodeList = UserDoc.SelectNodes("descendant::USER[@ASSOCIATE='TRUE']");
								foreach (XmlNode UserNode in UserNodeList)
								{
									ReadersNode = FormDataDocument.CreateElement("READERS");
									((XmlElement)ReadersNode).SetAttribute("TYPE", "RELATION");
									ReadersNode.InnerText = UserNode.SelectSingleNode("USERID").InnerText;
									WorkflowProcessNode.AppendChild(ReadersNode);
									ReadersNode = null;
								}
								UserNodeList = UserDoc.SelectNodes("descendant::USER[@DISASSOCIATE='TRUE']");
								foreach (XmlNode UserNode in UserNodeList)
								{
									ReadersNode = FormDataDocument.CreateElement("READERS");
									((XmlElement)ReadersNode).SetAttribute("TYPE", "RELATION");
									ReadersNode.InnerText = UserNode.SelectSingleNode("USERID").InnerText;
									((XmlElement)ReadersNode).SetAttribute("DISASSOCIATE", "TRUE");
									WorkflowProcessNode.AppendChild(ReadersNode);
									ReadersNode = null;
								}
							}

							//Check for the Reminder frequency, CC to Owner, Notify if delayed
							if (WFInfoNode != null)
							{
								ReminderFreqNode = FormDataDocument.CreateElement("REMINDERFREQUENCY");
								ReminderFreqNode.InnerText = TextBox_ReminderFrequencey.Text;

								CCToOwnerNode = FormDataDocument.CreateElement("CCTOOWNER");
								if (CB_CC_To_Owner.Checked)
									CCToOwnerNode.InnerText = "1";
								else
									CCToOwnerNode.InnerText = "0";

								NotifyIfDelayedNode = FormDataDocument.CreateElement("NOTIFYIFJOBDELAYED");
								if (CB_Notify_JobDelayed.Checked)
									NotifyIfDelayedNode.InnerText = "1";
								else
									NotifyIfDelayedNode.InnerText = "0";

								WFInfoNode.AppendChild(ReminderFreqNode);
								WFInfoNode.AppendChild(CCToOwnerNode);
								WFInfoNode.AppendChild(NotifyIfDelayedNode);
							}
							else
							{
								WorkFlowCategory = new StringBuilder();

								WFProc_WFInfoNode = FormDataDocument.CreateElement("WORKFLOWPROCESS_WORKFLOWINFORMATION");
								((XmlElement)WFProc_WFInfoNode).SetAttribute("TYPE", "RELATION");
								WorkflowProcessNode.AppendChild(WFProc_WFInfoNode);

								WorkFlowCategory.Append("<WORKFLOWINFORMATION MODIFIED='TRUE'>");
									WorkFlowCategory.AppendFormat("<WORKFLOWINFORMATIONID>{0}</WORKFLOWINFORMATIONID>", __WorkflowInformationID.Value);
									WorkFlowCategory.AppendFormat("<REMINDERFREQUENCY>{0}</REMINDERFREQUENCY>", TextBox_ReminderFrequencey.Text);
									if (CB_CC_To_Owner.Checked)
										WorkFlowCategory.Append("<CCTOOWNER>1</CCTOOWNER>");
									else
										WorkFlowCategory.Append("<CCTOOWNER>0</CCTOOWNER>");

									if (CB_Notify_JobDelayed.Checked)
										WorkFlowCategory.Append("<NOTIFYIFJOBDELAYED>1</NOTIFYIFJOBDELAYED>");
									else
										WorkFlowCategory.Append("<NOTIFYIFJOBDELAYED>0</NOTIFYIFJOBDELAYED>");

								WorkFlowCategory.Append("</WORKFLOWINFORMATION>");

								WFProc_WFInfoNode.InnerXml = WorkFlowCategory.ToString(); 
							}
                        }

                        //Changes done by: Pravin
                        //Approval Smart Changes
                        //Date: 15 Dec 2008
                        //Job details form is split into two forms.name and description is accepted from Approvals_JobDetails form 
                        
                        ObjInfoList                         = (List<ObjectInfo>)ViewState["ObjectList"];
                        FormFacadeObj                       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        FormFacadeObj.FormName              = "Approvals_JobDetails";
                        FormFacadeObj.SolutionName          = SolutionName;
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        FormFacadeObj.ConfigurationXMLType  = "XMLPath";
                        FormFacadeObj.ReturnOnlyRelatedInfo = true;

                        ErrorXML                            = FormFacadeObj.GetFormDataXML("EDIT", "DATAFIELD", FRM_EditJob, ObjInfoList, out FormOutputXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            xpDoc_JobInfo                = new XPathDocument(new StringReader(FormOutputXML));
                            xpNav_JobInfo                = xpDoc_JobInfo.CreateNavigator();

                            if (!String.IsNullOrEmpty(xpNav_JobInfo.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").Value))
                            {
                                xmlNod_ProcessName              = FormDataDocument.CreateElement("PROCESSNAME");
                                xmlNod_ProcessName.InnerText    = xpNav_JobInfo.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").Value;
                                WorkflowProcessNode.AppendChild(xmlNod_ProcessName);
                            }

                            xmlNod_ProcessDesc                  = FormDataDocument.CreateElement("DESCRIPTION");
                            xmlNod_ProcessDesc.InnerText        = xpNav_JobInfo.SelectSingleNode("WORKFLOWPROCESS/DESCRIPTION").Value;
                            WorkflowProcessNode.AppendChild(xmlNod_ProcessDesc);

                            //Copy the facet information associated with new form to workflow process info

                            XPathNavigator xpNav_WorkFlowProcess        = xpNav_JobInfo.SelectSingleNode("//WORKFLOWPROCESS");
                            XPathNodeIterator xpNodItr_Relationshiptype = xpNav_WorkFlowProcess.Select("*[@TYPE='RELATION']");
                            foreach (XPathNavigator xpNav_RelationshipType in xpNodItr_Relationshiptype)
                            {
                                XmlNode xmlNod_Relatinship  = FormDataDocument.CreateElement(xpNav_RelationshipType.Name);
                                ((XmlElement)xmlNod_Relatinship).SetAttribute("TYPE","RELATION");
                                xmlNod_Relatinship.InnerXml = xpNav_RelationshipType.InnerXml;
                                WorkflowProcessNode.AppendChild(xmlNod_Relatinship);
                            }
                        }

                        //Pravin 
                        //Add Commitment Updates
                        if (IsSubmitClicked)
                        {
                            XmlElement      xmlEle_CommitmentApproval   = null;
                            XmlElement      xmlEle_Commitment           = null;
                            XmlElement      xmlEle_CommitmentField      = null;
                            String          str_CARelationShipName      = null;
                            StringBuilder   sb_PoDate                   = null;
                            Boolean         IsGeneratePODate            = false;
                            String          str_CommitmentStatus        = null;
                            if (String.Compare(ApprovalJobType, "CommitmentApproval", true) == 0)
                            {
                                str_CARelationShipName = "COMMITMENT_WFP_APPROVAL";
                                str_CommitmentStatus = "Submitted for Review";
                            }
                            else
                                if (String.Compare(ApprovalJobType, "VendorApproval", true) == 0)
                                {
                                    DateTime dt_PoDate = new DateTime();
                                    if (!String.IsNullOrEmpty(PODate))
                                    {
                                        DateTime.TryParse(PODate, out dt_PoDate);
                                    }
                                    else
                                    {
                                        dt_PoDate = DateTime.Now;
                                    }

                                    sb_PoDate = new StringBuilder(50);
                                    sb_PoDate.AppendFormat(@"<YEAR>{0}</YEAR>
			                                                <MONTH>{1}</MONTH>
			                                                <DAY>{2}</DAY>
			                                                <HOUR>00</HOUR>
			                                                <MINUTE>00</MINUTE>
			                                                <SECOND>00</SECOND>", dt_PoDate.Year, dt_PoDate.Month, dt_PoDate.Day);
                                    IsGeneratePODate        = true;
                                    str_CommitmentStatus    = "Submitted to Vendor";
                                    str_CARelationShipName  = "COMMITMENT_WFP_VENDOR";
                                }
                            //Pravin - End
                            if (!String.IsNullOrEmpty(str_CARelationShipName))
                            {

                                xmlEle_CommitmentApproval = FormDataDocument.CreateElement(str_CARelationShipName);
                                xmlEle_CommitmentApproval.SetAttribute("TYPE", "RELATION");
                                WorkflowProcessNode.AppendChild(xmlEle_CommitmentApproval);

                                xmlEle_Commitment = FormDataDocument.CreateElement("COMMITMENT");
                                xmlEle_Commitment.SetAttribute("MODIFIED", "TRUE");
                                xmlEle_CommitmentApproval.AppendChild(xmlEle_Commitment);

                                xmlEle_CommitmentField = FormDataDocument.CreateElement("COMMITMENTID");
                                xmlEle_CommitmentField.InnerText = CommitmentID;
                                xmlEle_Commitment.AppendChild(xmlEle_CommitmentField);

                                xmlEle_CommitmentField = FormDataDocument.CreateElement("STATUS");
                                xmlEle_CommitmentField.InnerText = str_CommitmentStatus;
                                xmlEle_Commitment.AppendChild(xmlEle_CommitmentField);

                                if (IsGeneratePODate)
                                {
                                    xmlEle_CommitmentField = FormDataDocument.CreateElement("PODATE");
                                    xmlEle_CommitmentField.InnerXml = sb_PoDate.ToString();
                                    xmlEle_Commitment.AppendChild(xmlEle_CommitmentField);
                                }
                            }
                        }
                        ApprovalJobXML = FormDataDocument.OuterXml;

                    }

                    


                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            private void UpdateApprovalsFormXML()
            {
                FormFacade              FormFacadeObj       = null;
                ApprovalsFacadeClass    ApprovalsFacadeObj  = null; 
                ERRORXML                ErrorXML            = null;
                XmlDocument             InputXMLDoc         = null;
                XmlNode                 WorkflowProcessNode = null;
                XML                     ReturnJobXML        = null;
                DateTime                StartDate;
                DateTime                DueDate;
                StringBuilder           AssociationXML      = null;
                XmlDocument             FormInputXMLDoc     = null;
                XmlNode                 FieldNode           = null;
                StringBuilder           FormDataXML         = null;
                String                  FormConfigXMLPath   = null;
                String                  JobName             = null;
                String                  FormInputXML        = null;

                try
                {
                    StartDate           = new DateTime(1, 1, 1);
                    DueDate             = new DateTime(1, 1, 1);

                    AssociationXML = new StringBuilder(50);
                    if (ViewState["ProcessAssociatedFacets"] != null)
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='FALSE'>" + ViewState["ProcessAssociatedFacets"].ToString() + "</ASSOCIATION>");
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE' />");
                    }

                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    ErrorXML = ApprovalsFacadeObj.GetApprovalsJob(JobProcessID, null, AssociationXML.ToString(), out ReturnJobXML);
                    if (ErrorXML == null)
                    {
                        InputXMLDoc = new XmlDocument();
                        InputXMLDoc.LoadXml(ReturnJobXML);

                        WorkflowProcessNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS");

                        JobName = WorkflowProcessNode.SelectSingleNode("PROCESSNAME").InnerText;

                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "Approvals_JobDetails");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "Approvals_JobDetails");
                        }
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        FormFacadeObj.FormName              = "Approvals_JobDetails";
                        FormFacadeObj.ShowConfiguredFields  = false;

                        FormDataXML = new StringBuilder();
                        FormDataXML.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", WorkflowProcessNode.OuterXml);
                        ErrorXML    = FormFacadeObj.GetFormInputXML("EDIT", FormDataXML.ToString(), out FormInputXML, out ObjInfoList);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(FormInputXML)))
                        {
                            FRM_EditJob.ConfigurationXMLType    = CustomControls.Form.InputType.XMLPath;
                            FRM_EditJob.ConfigurationXML        = FormConfigXMLPath;
                            FRM_EditJob.InputXML                = FormInputXML;
                        }
                        ViewState["ObjectList"] = ObjInfoList;
                        //Set Approvals Job Advanced Details
                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        FormFacadeObj.FormName              = "JobAdvancedDetails";
                        FormFacadeObj.ShowConfiguredFields  = false;
                        FormInputXML                        = null;

                        ErrorXML = FormFacadeObj.GetFormInputXML("EDIT", FormDataXML.ToString(), out FormInputXML, out ObjAdvInfoList);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(FormInputXML)))
                        {
                            FormInputXMLDoc = new XmlDocument();
                            FormInputXMLDoc.LoadXml(FormInputXML);

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALDUEDATE']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_REVIEWSTATUS']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWINFORMATION_ROUTEMETHOD']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            FRM_JobAdvDetails.ConfigurationXMLType  = CustomControls.Form.InputType.XMLPath;
                            FRM_JobAdvDetails.ConfigurationXML      = FormConfigXMLPath;

                            FRM_JobAdvDetails.InputXML      = FormInputXMLDoc.OuterXml;
                            ViewState["AdvancedObjectList"] = ObjAdvInfoList;
                        }
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setReadersSelectionControl(XmlNode ReadersNode)
            {
                StringBuilder PrevSelectedUserXML = null;
                try
                {
                    PrevSelectedUserXML = new StringBuilder();
                    if (ReadersNode != null)
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList>{0}</SelectedUsersList></UserSelectionXML>", ReadersNode.InnerXml);
                    else
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList></SelectedUsersList></UserSelectionXML>");

                    UC_ReadersSelection.TenantName          = ALParamObj.TenantName;
                    UC_ReadersSelection.SessionID           = ALParamObj.SessionID;
                    UC_ReadersSelection.UserID              = ALParamObj.UserID;
                    UC_ReadersSelection.Language            = ALParamObj.Language;
                    //UC_ReadersSelection.InstanceName        = "ApprovalJob_Readers";
                    //UC_ReadersSelection.Layout              = "LIST";
                    UC_ReadersSelection.Mode                = ALSolutionEnums.SuggestionListControl_DisplayMode.Edit;
                    UC_ReadersSelection.SolutionName        = SolutionName;
                    UC_ReadersSelection.ListConfigurationName      = "ReadersList";
                    //UC_ReadersSelection.UserSelection_Mode  = "BUTTON";
                    //UC_ReadersSelection.OnlyUserIDs         = "FALSE";
                    //UC_ReadersSelection.SelectionMode       = "MultiSelect";
                    UC_ReadersSelection.EntityName              = "USER";
                    UC_ReadersSelection.EntityPrimaryKey        = "USERID";
                    UC_ReadersSelection.WidgetName = WidgetName;
                    UC_ReadersSelection.InputEntityCollectionXML = PrevSelectedUserXML.ToString();
                   
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }
            
            private void gotoApprovalsJobListPage()
            {
                StringBuilder   ParamURL	 = null;
                StringBuilder   URL			 = null;
                String          EncryptURL	 = null;
			    ulong			ErrorID		 = 0;
                String          ErrorPageURL = null;

                try
                {
                    ParamURL    = new StringBuilder();
                    URL         = new StringBuilder();
                    ParamURL.AppendFormat("Approvals_JobList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionDisplayName={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Server.UrlEncode(Str_SolutionDisplayName));
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "gotoApprovalsJobListPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }

            private void SaveApprovalsJob(String JobStatus)
            {
                String                  UpdateJobXML        = null;
                ERRORXML                ErrorXML            = null;
                ApprovalsFacadeClass    ApprovalsFacadeObj  = null;
                String					ErrorPageURL		= null;
                
                try
                {
                    IsSubmitClicked = true;
                    ApprovalsFacadeObj = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    GetApprovalTaskXMLForUpdate(JobStatus, null, out UpdateJobXML);
                    
                    if (JobStatus.ToUpper() == "ACTIVE")
                    {
                        //Commented due to changes in Approval widget.
                        //Approvals_WidgetControl.SaveReviewerInfo();
                        if (!String.IsNullOrEmpty(HF_ImportNotes.Value))
                        {
                            if (HF_ImportNotes.Value.ToUpper() == "YES")
                            {
                                if (ViewState["IsMediaFileForImportNotes"] != null && (bool)ViewState["IsMediaFileForImportNotes"])
                                    ErrorXML = ApprovalsFacadeObj.ImportNotesForMediaFile(JobProcessID, __ApprovalsJobID.Value, __RevisionNumber.Value);
                                else
                                    ErrorXML = ApprovalsFacadeObj.ImportNotes(JobProcessID, __ApprovalsJobID.Value, __RevisionNumber.Value);
                            }
                        }
                        ErrorXML = ApprovalsFacadeObj.UpdateApprovalsJob(JobProcessID, true, MWB_TimeLineEvents.TASK_DURATION_CHANGED, ref UpdateJobXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            //ErrorXML = StampNotificationForApprovalsJob(JobProcessID);
                            //ErrorXML = null;
                            //if (String.IsNullOrEmpty(ErrorXML))
                            //{
                                gotoCommitmentROPage();
                            //}
                        }
                        else
                        {
							ALSolutionCommonObj.PrepareErrorPageUrl("Approvals", null, "APPROVALSJOB", null, "Update Job Failed.",null, GetBackUrl(), ref ErrorPageURL);
							Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    else
                    {
                        Approvals_WidgetControl.SaveReviewerInfo(false);
                        ErrorXML = ApprovalsFacadeObj.UpdateApprovalsJob(JobProcessID, true, MWB_TimeLineEvents.TASK_DURATION_CHANGED, ref UpdateJobXML);
                        if (ErrorXML == null)
                        {
                            gotoCommitmentROPage();
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("Approvals", null, "APPROVALSJOB", null, "Update Job Failed.", null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            private ERRORXML StampNotificationForApprovalsJob(String JobProcessID)
            {
                String              ReturnJobXML            = null;
                String              ContributorID           = null;
                String              JobScreenURL            = null;
                String              NotificationXML         = null;
                String              ActivityID              = null;
                String              ReaderID                = null; 
                String              Duration                = null; 
                long                RemainingMins           = 0;
                long                ActivityDuration        = 0;
                XML                 ErrorXML                = null;
                StringBuilder       AssociationXML          = null;
                StringBuilder       Message                 = null;
                StringBuilder       Subject                 = null;
                XmlDocument         xp_retTaskXMLDoc        = null;    
                XPathNavigator      TaskNavigator           = null;
                XPathNavigator      ActivityNav             = null;
                XPathNavigator      ContributorNav          = null;
                XPathNavigator      Reader                  = null; 
                XPathNavigator      TempNavigator           = null; 
                XPathNavigator      DurationNavigator       = null; 
                XPathNodeIterator   Readers                 = null; 
                XPathNodeIterator   ActiveActivities        = null; 
                NotificationHelper          NotificationHelperObj       = null;
                EmailChannel                EmailChannelObj             = null;
                XPathNodeIterator           FileSystemIterator          = null;
                MWB_Helper                  MWB_HelperObj               = null; 
                NotificationFacadeClass     NotificationFacadeObj       = null;
                ApprovalsFacadeClass        ApprovalsFacadeObj          = null; 
                PMFacadeClass               PMFacadeObj                 = null; 
                String		                ErrorPageURL		        = null;
                String                      str_AutoLoginRequired       = null;
                String                      str_ContriLoginName         = null;
                String                      str_ReaderLoginName         = null;
                Boolean                     bl_AutoLoginRequired        = false;
                ALCommon                    ALCommonObj                 = null;
                try
                {
                    //Check AutoLogin required for email
                    ALCommonObj = new ALCommon();
                    ALCommonObj.GetTenantSetting(ALParamObj.TenantName, "CONFIGURATION/APPROVALSETTINGS/AUTOLOGINFOREMAIL", out str_AutoLoginRequired);
                    if ((!String.IsNullOrEmpty(str_AutoLoginRequired)))
                    {
                        Boolean.TryParse(str_AutoLoginRequired, out bl_AutoLoginRequired);
                    }

                    //Get the Task.
                    AssociationXML = new StringBuilder(50);
                    if (ViewState["ProcessAssociatedFacets"] != null)
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='FALSE'>" + ViewState["ProcessAssociatedFacets"].ToString());
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                    }
                            AssociationXML.Append(@"<READERS Type='RELATION'>
		                                                <LOGINNAME/>
		                                                <FIRSTNAME/>
		                                                <MIDDLEINITIAL/>
		                                                <LASTNAME/>
	                                                </READERS>
	                                                <PROCESS_ACTIVITY Type='RELATION'>
		                                                <ACTIVITYID/>
		                                                <STATUS/>
		                                                <STARTACTIVITY/>
		                                                <ENDACTIVITY/>
		                                                <ACTIVITY_CONTRIBUTOR Type='RELATION'>
			                                                <LOGINNAME/>
			                                                <FIRSTNAME/>
			                                                <MIDDLEINITIAL/>
			                                                <LASTNAME/>
		                                                </ACTIVITY_CONTRIBUTOR>
		                                                <ACTIVITY_INFORMATION Type='RELATION'>
			                                                <ACTIVITYINFORMATIONID/>
			                                                <DURATION/>
		                                                </ACTIVITY_INFORMATION>
	                                                </PROCESS_ACTIVITY>
                                                </ASSOCIATION>");  

                    MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);   
                    ErrorXML = ApprovalsFacadeObj.GetApprovalsJob(JobProcessID, null, AssociationXML.ToString(), out ReturnJobXML);
                    if (ErrorXML == null)
                    {
                        //Email Stamping for the contributor of 1st step from Task.
                        xp_retTaskXMLDoc = new XmlDocument();
                        xp_retTaskXMLDoc.LoadXml(ReturnJobXML);
                        TaskNavigator = xp_retTaskXMLDoc.CreateNavigator();

                        //Delete Filesystem node
                        FileSystemIterator = TaskNavigator.Select("descendant::FILESYSTEM");
                        while (FileSystemIterator.MoveNext())
                        {
                            TempNavigator = FileSystemIterator.Current;
                            TempNavigator.DeleteSelf();
                            FileSystemIterator = TaskNavigator.Select("descendant::FILESYSTEM");
                        }

                        ActiveActivities = TaskNavigator.Select("descendant::PROCESS_ACTIVITY/ACTIVITY[STATUS='Active' and (STARTACTIVITY != 'True' and ENDACTIVITY != 'True')]");
                        if (ActiveActivities.Count > 0)
                        {
                            while (ActiveActivities.MoveNext())
                            {
                                ActivityNav = ActiveActivities.Current;
                                DurationNavigator = ActivityNav.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION");
                                if (DurationNavigator != null)
                                {
                                    Duration = DurationNavigator.Value;
                                    ActivityDuration = PMFacadeObj.ConvertMinutesToDays(Convert.ToInt64(Duration), out RemainingMins);
                                }
                                ContributorNav = ActivityNav.SelectSingleNode("descendant::ACTIVITY_CONTRIBUTOR");
                                if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                {
                                    ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;

                                    NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                    NotificationHelperObj.Init("6501", ALParamObj.UserID);

                                    EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                    EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                    NotificationHelperObj.AddChannel(EmailChannelObj);
                                    Message = new StringBuilder();
                                    Message.Append("<MESSAGE Sender='");
                                    Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()));
                                    Message.Append("' Reciever='");
                                    Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav)));
                                    Message.Append("' Duration='");
                                    Message.Append(ALCommon.TrimAndReplaceSpecialChars(ActivityDuration.ToString()));
                                    Message.Append("' >");
                                    Message.Append(TaskNavigator.InnerXml);
                                    Message.Append("</MESSAGE>");

                                    //Message.AppendFormat("<MESSAGE Sender='{0}' Reciever='{1}' Duration='{2}'>{3}</MESSAGE>", MWB_HelperObj.getLogedInUserName(), MWB_HelperObj.getUserName(ContributorNav), ActivityDuration.ToString(), TaskNavigator.InnerXml);

                                    Subject = new StringBuilder();
                                    Subject.Append("<SUBJECT>");
                                    Subject.Append(TaskNavigator.InnerXml);
                                    Subject.Append("</SUBJECT>");

                                    //Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);
                                    str_ContriLoginName = ContributorNav.SelectSingleNode("USER/LOGINNAME").Value;
                                    ActivityID          = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                    JobScreenURL = ApprovalsFacadeObj.GetEmailScreenURL("Approvals",Server.UrlEncode("Approvals"),bl_AutoLoginRequired,str_ContriLoginName, JobProcessID, "RESPONSE", ActivityID);

                                    ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                    ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                    ErrorXML = NotificationHelperObj.AddLink("JobScreenURL", JobScreenURL);

                                    ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                    if (ErrorXML == null && NotificationXML != null)
                                    {
                                        NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                        ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                        if (!String.IsNullOrEmpty(ErrorXML))
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            break;
                                        }
                                    }
                                    else
                                    {
                                        if (!String.IsNullOrEmpty(ErrorXML))
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            break;
                                        }
                                    }
                                }
                            }
                        }

                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            //Email Stamping for the Readers of the Task.
                            Readers = TaskNavigator.Select("descendant::READERS/USER");
                            if (Readers.Count > 0)
                            {
                                while (Readers.MoveNext())
                                {
                                    Reader = Readers.Current;

                                    EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                    NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                    NotificationHelperObj.Init("6502", ALParamObj.UserID);

                                    ReaderID = Reader.SelectSingleNode("USERID").Value;
                                    EmailChannelObj.AddRecipient("TO", ReaderID, false);

                                    NotificationHelperObj.AddChannel(EmailChannelObj);
                                    Message = new StringBuilder();
                                    Message.AppendFormat("<MESSAGE Sender='");
                                    Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()));
                                    Message.AppendFormat("' Reciever='");
                                    Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(Reader)));
                                    Message.AppendFormat("' >");
                                    Message.Append(TaskNavigator.InnerXml);
                                    Message.Append("</MESSAGE>");

                                    //Message.AppendFormat("<MESSAGE Sender='{0}' Reciever='{1}'>{2}</MESSAGE>", MWB_HelperObj.getLogedInUserName(), MWB_HelperObj.getUserName(Reader), TaskNavigator.InnerXml);

                                    Subject = new StringBuilder();
                                    Subject.Append("<SUBJECT>");
                                    Subject.Append(TaskNavigator.InnerXml);
                                    Subject.Append("</SUBJECT>");

                                    //Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);
                                    str_ReaderLoginName = Reader.SelectSingleNode("LOGINNAME").Value;
                                    JobScreenURL = ApprovalsFacadeObj.GetEmailScreenURL("Approvals", Server.UrlEncode("Approvals"), bl_AutoLoginRequired, str_ReaderLoginName, JobProcessID, "READONLY", null);

                                    ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                    ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                    ErrorXML = NotificationHelperObj.AddLink("JobScreenURL", JobScreenURL);

                                    ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);
                                    if (ErrorXML == null && NotificationXML != null)
                                    {
                                        NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                        ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                        if (!String.IsNullOrEmpty(ErrorXML))
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            break;
                                        }
                                    }
                                    else
                                    {
                                        if (!String.IsNullOrEmpty(ErrorXML))
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXML; 
                }
                catch(Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>14 April 2007</createddate>
            /// <author>Hemant Karkande</author>
            /// <purpose>To show previous revisions list.</purpose>
            /// <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes>
            /// </alsummary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void LC_Prev_Revision_CollapsedClick(object sender, EventArgs e)
            {
                ApprovalsFacadeClass    ApprovalsFacadeObj      = null;
                MktgWorkBenchFacadeClass MWBFacadeObj           = null; 
                ERRORXML                ErrorXMLString          = null; 
                ListFacade              ListFacadeObj           = null;
                XML                     PreviousRevisionsXML    = null; 
                XML                     ConfigXML               = null; 
                XML                     OutputXML               = null; 
                StringBuilder           TempXML                 = null;
			    ulong			        ErrorID				    = 0;
                String                  ErrorPageURL            = null;
                try
                {
                    LC_Prev_Revision.IsMinimize = false;
                    LC_Prev_Revision.EnableIterators = true;  

                    MWBFacadeObj        = new MktgWorkBenchFacadeClass (ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ListFacadeObj       = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    ErrorXMLString = ApprovalsFacadeObj.GetAllPreviousRevisions(__ApprovalsJobID.Value, __RevisionNumber.Value, ref PreviousRevisionsXML);
                    if (String.IsNullOrEmpty(ErrorXMLString))
                    {
                        ListFacadeObj.AddParameter("Mode", "Route");
                        ListFacadeObj.AddParameter("Access", "Write");
                        TempXML = new StringBuilder();
                        ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "PreviousRevisions");
                        TempXML.Remove(0, TempXML.Length);
                        TempXML.AppendFormat("<SEARCHOUTPUTXML>{0}</SEARCHOUTPUTXML>", PreviousRevisionsXML);
                        ListFacadeObj.PrepareListXml(ConfigXML, TempXML.ToString(), out OutputXML);

                        MWBFacadeObj.InsertPercentCompleteClass("DUEDATE", ref OutputXML);  

                        LC_Prev_Revision.Source = OutputXML;
                    }
                    else
                    {
                        //Error getting previous revisions
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "LC_Prev_Revision_CollapsedClick", ExceptionObject, null, "Exception while showing previous revision list.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }

            private void SetActionBar(String RevisionNumber,String str_WorkFlowProcessID)
            {
                StringBuilder JavaScript = null; 
                try
                {
                    if (!String.IsNullOrEmpty(RevisionNumber))
                    {
                        if (Convert.ToInt32(RevisionNumber) > 1 && IsCopyCommentsFromLastVersion(str_WorkFlowProcessID,RevisionNumber))
                        {
                            JavaScript = new StringBuilder();
                            JavaScript.AppendFormat("javascript:ValidateForm('$CONTROLID$','{0}', '" + Localization.GetString("ALJSResource", ALParamObj.TenantName, "Cnfm_Approvals_EditJobDetails_CnfmForCopyNotes") + "')", HF_ImportNotes.ClientID);
                            AB_EditJob.AddAttributes("btn_Submit", "href", JavaScript.ToString());
                        }
                        else
                            AB_EditJob.AddAttributes("btn_Submit", "href", "javascript:ValidateForm('$CONTROLID$')");
                    }
                    else
                        AB_EditJob.AddAttributes("btn_Submit", "href", "javascript:ValidateForm('$CONTROLID$')");

                    AB_EditJob.AddAttributes("btn_SaveAsDraft", "href", "javascript:ValidateForm('$CONTROLID$')");
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }
            
            private string GetBackUrl()
            {
				StringBuilder ParamURL = null;
				try
				{
                    ParamURL = new StringBuilder();
                    if (IsCustomized)
                        ParamURL.AppendFormat("/{0}/{1}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
                    else
                        ParamURL.AppendFormat("/{0}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName);

                    ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&AccessMode={10}&BREADCRUMBNAME={11}&BREADCRUMBID={12}&BREADCRUMBXML={13}&IsCustomized={14}&SelectedTabName=Approvals&Mode={15}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, "StrategicPlanner", CommitmentID, TaskPaneList, MasterPageFileName, str_Theme, SourceAttributes, CommitmentAccess, str_ParentBreadCrumbName, BreadcrumbID, BreadcrumbXML, IsCustomized, CommitmentMode);
					return ParamURL.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
            }
            
            private Boolean IsCopyCommentsFromLastVersion(String str_WorkFlowProcessID, String CurrentRevision)
            {
                XML                     str_SearchOutputResultXML   = null;
                StringBuilder           sb_SearchInputXML           = null;
                ushort                  us_CurrentRevision          = 0;
                SearchConfiguration     obj_SearchConfiguration     = null;
                ERRORXML                ErrorXML                    = null;
                XPathDocument           xpDoc_SearchResult          = null;
                XPathNavigator          xpNav_SearchResult          = null; 
                XPathNavigator          xpNav_FileName              = null;
                CommonFunctions         obj_CommonFunctions         = null;
                bool                    bool_IsMediaFile            = false;
                bool                    bool_IsVideoFile            = false;

                try
                {
                    us_CurrentRevision          = ushort.Parse(CurrentRevision);
                    us_CurrentRevision--;
                    obj_SearchConfiguration     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    sb_SearchInputXML           = new StringBuilder(400);

                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
	                                                 <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' Language='" + ALParamObj.Language + "' TenantName='" + ALParamObj.TenantName + "' UserID='" + ALParamObj.UserID + @"'></SESSIONINFO>
	                                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
	                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
	                                                <MAXRESULTSIZE>1</MAXRESULTSIZE>
	                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                                                <TARGETENTITY>
		                                                <PRIVILEGENAME>READ</PRIVILEGENAME>
		                                                <FILTERLIST>
			                                                <FILTER>
				                                                <EXPRESSION>APPROVALSJOBID</EXPRESSION>
				                                                <OPERATOR>EQUALTO</OPERATOR>
				                                              <EXPRESSIONVALUE>" + str_WorkFlowProcessID + @"</EXPRESSIONVALUE>
				                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
				                                                <RELATIONSHIPNAME>WORKFLOWPROCESS_WORKFLOWINFORMATION</RELATIONSHIPNAME>
			                                                </FILTER>
				                                                <FILTER>
				                                                <EXPRESSION>REVISIONNUMBER</EXPRESSION>
				                                                <OPERATOR>EQUALTO</OPERATOR>
				                                               <EXPRESSIONVALUE>" + us_CurrentRevision.ToString() + @"</EXPRESSIONVALUE>
				                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
				                                                <RELATIONSHIPNAME>WORKFLOWPROCESS_WORKFLOWINFORMATION</RELATIONSHIPNAME>
			                                                </FILTER>
		                                                </FILTERLIST>
                                                        <RELATIONSHIP NAME='WORKFLOWPROCESS_WORKFLOWINFORMATION'>
                                                            <SELECTLIST>					                                                                                                             				                                            
                                                                 <EXPRESSION>
					                                                <FIELDNAME>ANNOTATIONMETHOD</FIELDNAME>
					                                                <ALIAS>ANNOTATIONMETHOD</ALIAS>
				                                                </EXPRESSION>                                                                 
			                                                </SELECTLIST>
			                                            </RELATIONSHIP>
		                                                <SELECTLIST>
			                                                <EXPRESSION>
				                                                <FIELDNAME>PROCESSFILE</FIELDNAME>
				                                                <ALIAS>PROCESSFILE</ALIAS>
			                                                </EXPRESSION>
		                                                </SELECTLIST>
	                                                </TARGETENTITY>
                                                </SEARCH>");

                     ErrorXML = obj_SearchConfiguration.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutputResultXML);
                     if (!String.IsNullOrEmpty(ErrorXML))
                     {
                         throw new Exception(ErrorXML);
                     }

                     obj_CommonFunctions    = new CommonFunctions(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                     xpDoc_SearchResult     = new XPathDocument(new StringReader(str_SearchOutputResultXML));
                     xpNav_SearchResult     = xpDoc_SearchResult.CreateNavigator();

                     xpNav_FileName = xpNav_SearchResult.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/FILESYSTEM/FILE/NAME");
                     if (xpNav_FileName != null)
                     {
                         bool_IsMediaFile = obj_CommonFunctions.IsMediaFile(xpNav_FileName.Value, "Approvals", ref bool_IsVideoFile);
                         String PDFProcessor = CheckPDFProcessorRequired(xpDoc_SearchResult);

                         bool_IsMediaFile = (PDFProcessor.ToUpper() == "ASSETLINK PROPRIETARY");
                         if (bool_IsMediaFile && !bool_IsVideoFile)
                         {
                             ViewState["IsMediaFileForImportNotes"] = true;
                             return true;
                         }
                     }
                }
                catch (Exception obj_Exception)
                {
                    throw obj_Exception;
                }
                return false;
            }

            /// <alsummary>
            /// <createddate>04 December 2007</createddate>
            /// <author>Bhalchandra</author>
            /// <purpose>To get the Approval Job's Package and Process ID.</purpose>
            /// </alsummary>
            private void getPackageProcessIDs()
            {
                ERRORXML                    ErrorXml                        = null;
                ulong                       ul_ErrorID                      = 0;
                String                      str_ErrorPage                   = null;
                String                      str_ReturnProjectXml            = null;
                StringBuilder               sb_SearchInputXml               = null;
                SearchConfiguration         obj_SearchConfig                = null;
                XPathDocument               xpathDoc_ProjectXml             = null;
                XPathNavigator              xpathNav_PackageDefinitionID    = null;
                XPathNavigator              xpathNav_ProcessDefinitionID    = null;

                try
                {
                    sb_SearchInputXml = new StringBuilder(1000);
                    sb_SearchInputXml.Append(@"<SEARCH>
                                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' Language='" + ALParamObj.Language + "' TenantName='" + ALParamObj.TenantName + "' UserID='" + ALParamObj.UserID + @"'></SESSIONINFO>
                                                <TARGETENTITY>
                                                    <SELECTLIST>
				                                        <EXPRESSION>
					                                           <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                               <ALIAS>WORKFLOWPROCESSID</ALIAS>
				                                         </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
		                                                <FILTER>
			                                                <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>" + JobProcessID + @"</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>
                                                    </FILTERLIST>
                                                    <RELATIONSHIP NAME='PROCESS_INFORMATION'>          
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>PROCESSDEFINITIONID</FIELDNAME>
                                                                <ALIAS>PROCESSDEFINITIONID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>PACKAGEDEFINITIONID</FIELDNAME>
                                                                <ALIAS>PACKAGEDEFINITIONID</ALIAS>
                                                            </EXPRESSION>
                                                     </SELECTLIST>
                                                    </RELATIONSHIP>
                                                </TARGETENTITY>
                                            </SEARCH>");
                    obj_SearchConfig    = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXml = obj_SearchConfig.GetHierarchialData(sb_SearchInputXml.ToString(), ref str_ReturnProjectXml);
                    if ((String.IsNullOrEmpty(ErrorXml)) && (!String.IsNullOrEmpty(str_ReturnProjectXml)))
                    {
                        xpathDoc_ProjectXml = new XPathDocument(new StringReader(str_ReturnProjectXml));
                        xpathNav_ProcessDefinitionID = xpathDoc_ProjectXml.CreateNavigator().SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID");
                        if (xpathNav_ProcessDefinitionID != null)
	                    {
                            __ProcessDefinitionID.Value = xpathNav_ProcessDefinitionID.Value;
	                    }

                        xpathNav_PackageDefinitionID = xpathDoc_ProjectXml.CreateNavigator().SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID");
                        if (xpathNav_ProcessDefinitionID != null)
	                    {
                            __PackageDefinitionID.Value = xpathNav_PackageDefinitionID.Value;
	                    }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "getPackageProcessIDs", obj_Exception, null, "Exception while getting jobs ProcessDefinitionID and PackageDefitionID");
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", null, obj_Exception.Message, null, GetBackUrl(), ref str_ErrorPage);
                    Response.Redirect(str_ErrorPage);
                }
            }

            /// <alsummary>
            /// <createddate>04 December 2008</createddate>
            /// <author>Bhalchandra</author>
            /// <purpose>To get the approval job's associated additional facets.</purpose>
            /// </alsummary>
            private String getAssociatedAdditionalFacets(out String str_ProcessAssociatedFacets)
            {
                ERRORXML    ErrorXml                        = null;
                ulong       ul_ErrorID                      = 0;
                String      str_ErrorPage                   = null;
                String      str_ActivityAssociatedFacets    = null;
                MWB_Helper  obj_MWBHelper                   = null;
                

                try
                {
                    str_ProcessAssociatedFacets = "";
                        obj_MWBHelper   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        ErrorXml        = obj_MWBHelper.GetAssociatedAdditionalFacets(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, null, false,out str_ProcessAssociatedFacets, out str_ActivityAssociatedFacets);
                        if (String.IsNullOrEmpty(ErrorXml))
                        {
                            if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                            {
                                ViewState["ProcessAssociatedFacets"] = str_ProcessAssociatedFacets;
                            }
                        }
                    
                    return ErrorXml;
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "getAssociatedAdditionalFacets", obj_Exception, null, "Exception while getting Associated Additional Facets");
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", null, obj_Exception.Message, null, GetBackUrl(), ref str_ErrorPage);
                    Response.Redirect(str_ErrorPage);
                    str_ProcessAssociatedFacets = "";
                    return null;
                }
            }

            /// <alsummary>
            /// <CreatedOn>24 Feb 2009</CreatedOn>
            /// <Author>Mr.Pravin Shinde</Author>
            /// <Purpose>This method creates approvals job for commitment approvals and vendor approvals</Purpose>
            /// </alsummary>
            private void CreateCommitmentApprovalJob()
            {
                ERRORXML                    ErrorXML                                    = null;
                CommitmentFacade            obj_Commitment                              = null;
                ApprovalsFacadeClass        obj_ApprovalsFacade                         = null;
                String                      PackageName                                 = "Commitment Package";
                String                      CommitmentPackageList                       = null;
                XPathDocument               xpDoc_CommitmentProcess                     = null;
                XPathNavigator              xpNav_RootCommitmentProcess                 = null;
                XPathNavigator              xpNav_CommitmentProcess                     = null;
                XPathDocument               xpDoc_WorkFlowProcess                       = null;
                XPathNavigator              xpNav_WorkFlowProcess                       = null;
                XPathDocument               xpDoc_Commitment                            = null;
                XPathNavigator              xpNav_Commitment                            = null;
                XPathNavigator              XpNav_CommitmentRoot                        = null; 
                String                      PackageID                                   = null;
                String                      ProcessID                                   = null;
                StringBuilder               sb_ApprovalJob                              = null;
                String                      str_Workflowcategory                        = "SP_COMMITMENTAPPROVALSJOB";
                String                      str_RouteMethod                             = "SIMULTANEOUS";
                String                      str_FileName                                = null;
                String                      str_FileDispName                            = null;
                String                      str_FilePath                                = null;
                String                      str_InputXML                                = null;
                String                      EncryptURL                                  = null;
                String                      str_WorkFlowProcessID                       = null;
                String                      str_CommitmentWorkFlowRelationName          = null;
                String                      str_WorkFlowProcessName                     = null;
                String                      str_CommitmentNumber                        = null;
                String                      str_CommitmentTitle                         = null;
                StringBuilder               ParamURL                                    = null;
                StringBuilder               URL                                         = null;
                ulong                       ApprovalsJobID                              = 0;
                StringBuilder               sb_CommitmentPackageDefnFile                = null;
                StringBuilder               sb_ApprovalJobName                          = null;
                StringBuilder               sb_ApprovalJobDesc                          = null;
                String                      ErrorPageURL                                = null;
                StringBuilder               sb_XPDLFilePath                             = null;
                FileTransfer                FileTransferObj                             = null;
                StringBuilder               FileContents                                = null;

                try
                {

                    if (!String.IsNullOrEmpty(JobProcessID))
                    {
                        return;
                    }

                    sb_ApprovalJobName              = new StringBuilder(100);
                    sb_ApprovalJobDesc              = new StringBuilder(100);
                    ParamURL                        = new StringBuilder(100);
                    URL                             = new StringBuilder(100);
                    sb_ApprovalJob                  = new StringBuilder(200);
                    sb_CommitmentPackageDefnFile    = new StringBuilder(100);
                    obj_Commitment                  = new CommitmentFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_ApprovalsFacade             = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    #region Read Commitment Details
                    if (!String.IsNullOrEmpty(CommitmentTempFilePath))
                    {
                        xpDoc_Commitment        = new XPathDocument(CommitmentTempFilePath);
                        XpNav_CommitmentRoot    =  xpDoc_Commitment.CreateNavigator();
                        xpNav_Commitment        = XpNav_CommitmentRoot.SelectSingleNode("COMMITMENTCOLLECTION/COMMITMENT");
                        str_CommitmentNumber    = xpNav_Commitment.SelectSingleNode("COMMITMENTNUMBER").Value;
                        str_CommitmentTitle     = xpNav_Commitment.SelectSingleNode("TITLE").Value;
                    }

                    #endregion

                    #region Create pdf file for commitment approval

                    str_FileName                    = Path.GetFileName(PDFFilePath); ;
                    str_FileDispName                = str_FileName;
                    str_FilePath                    = PDFFilePath;
                    #endregion

                    #region Check Approval job type (Commitment Approval/ Vendor Approval)
                    if (String.Compare(ApprovalJobType, "CommitmentApproval", true) == 0)
                    {
                        str_CommitmentWorkFlowRelationName = "COMMITMENT_WFP_APPROVAL";
                        str_WorkFlowProcessName = "Commitment Approval";
                        str_ApprovalsJobName    = "Commitment Approval for Commitment #: "+ str_CommitmentNumber;
                        sb_ApprovalJobName.AppendFormat("Commitment Approval for Commitment #: {0}", ALCommon.TrimAndReplaceSpecialChars(str_CommitmentNumber));
                        sb_ApprovalJobDesc.AppendFormat("Commitment Approval job for {0}", ALCommon.TrimAndReplaceSpecialChars(str_CommitmentTitle));
                    }
                    else
                        if (String.Compare(ApprovalJobType, "VendorApproval", true) == 0)
                        {
                            str_CommitmentWorkFlowRelationName = "COMMITMENT_WFP_VENDOR";
                            str_WorkFlowProcessName = "Send to Vendor";
                            str_ApprovalsJobName    = "Vendor Approval for Commitment #: " + str_CommitmentNumber;
                            sb_ApprovalJobName.AppendFormat("Vendor Approval for Commitment #: {0}", ALCommon.TrimAndReplaceSpecialChars(str_CommitmentNumber));
                            sb_ApprovalJobDesc.AppendFormat("Vendor Approval job for {0}", ALCommon.TrimAndReplaceSpecialChars(str_CommitmentTitle));
                        }
                    
                    #endregion

                    #region Get Commitment Process

                    ErrorXML = obj_Commitment.GetCommitmentProcess(PackageName, out CommitmentPackageList);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        xpDoc_CommitmentProcess             = new XPathDocument(new StringReader(CommitmentPackageList));
                        xpNav_RootCommitmentProcess         = xpDoc_CommitmentProcess.CreateNavigator();
                        PackageID                           = xpNav_RootCommitmentProcess.SelectSingleNode("PACKAGEDEFINITION/PACKAGE/PACKAGEDEFINITIONID").Value;
                        xpNav_CommitmentProcess             = xpNav_RootCommitmentProcess.SelectSingleNode("PACKAGEDEFINITION/PACKAGE/PACKAGE_PROCESS/WORKFLOWPROCESS/PROCESSNAME[text()='" + str_WorkFlowProcessName+ "']");
                        xpNav_CommitmentProcess.MoveToParent();
                        ProcessID                           = xpNav_CommitmentProcess.SelectSingleNode("WORKFLOWPROCESSID").Value;
                    }
                    else
                    {
                        if (String.IsNullOrEmpty(CommitmentPackageList))
                        {
                            sb_XPDLFilePath = new StringBuilder(100);
                            if (IsCustomized)
                            {
                                sb_XPDLFilePath.AppendFormat(@"{0}{1}\{2}\Widgets\SP_CommitmentWidget\Configuration\PACKAGEDEFINITION\XPDL\CommitmentPackage.xpdl", ALCommon.GetInstallationDir(), ALParamObj.SolutionName, ALParamObj.TenantName);
                            }
                            else
                            {
                                sb_XPDLFilePath.AppendFormat(@"{0}{1}\Widgets\SP_CommitmentWidget\Configuration\PACKAGEDEFINITION\XPDL\CommitmentPackage.xpdl", ALCommon.GetInstallationDir(), ALParamObj.TenantName);
                            }

                            ErrorXML = ProcessApprovalsPackage(sb_XPDLFilePath.ToString(), ref CommitmentPackageList);
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                xpDoc_CommitmentProcess     = new XPathDocument(new StringReader(CommitmentPackageList));
                                xpNav_RootCommitmentProcess = xpDoc_CommitmentProcess.CreateNavigator();
                                PackageID                   = xpNav_RootCommitmentProcess.SelectSingleNode("PACKAGEDEFINITION/PACKAGEDEFINITIONID").Value;
                                xpNav_CommitmentProcess     = xpNav_RootCommitmentProcess.SelectSingleNode("PACKAGEDEFINITION/XPDLFILE/Package/WorkflowProcesses/WorkflowProcess[@Name='" + str_WorkFlowProcessName + "']");
                                ProcessID                   = xpNav_CommitmentProcess.GetAttribute("Id", "");
                            }
                        }
                    }
                   
                    #endregion

                    #region Create Approval Job


                    FileTransferObj = new FileTransfer(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    FileContents = new StringBuilder(100);
                    FileContents.AppendFormat(@"<FILECOLLECTION>
                                                    <FILE Operation='CREATE' Order='1'>
                                                    <FIELDNAME>PROCESSFILE</FIELDNAME>
                                                    <SEQUENCEORDER>1</SEQUENCEORDER>
                                                    <NAME>{0}</NAME>
                                                    <DISPLAYNAME>{1}</DISPLAYNAME>
                                                    <PATH>{2}</PATH>        
                                                    </FILE>
                                                </FILECOLLECTION>", ALCommon.TrimAndReplaceSpecialChars(str_FileName),
                                                                    ALCommon.TrimAndReplaceSpecialChars(str_FileDispName),
                                                                    ALCommon.TrimAndReplaceSpecialChars(str_FilePath));

                    
                    string str_FileContents = FileContents.ToString();
                    
                    FileTransferObj.SaveFile(ref str_FileContents);
                    str_FileContents = str_FileContents.Replace("<FILECOLLECTION>", "");
                    str_FileContents = str_FileContents.Replace("</FILECOLLECTION>", "");

                    ALCommon.GenerateUniqueID(ref ApprovalsJobID);
                    sb_ApprovalJob.AppendFormat(@"<WORKFLOWPROCESS ProcessDefinitionID=""{0}"">
                                                <WORKFLOWPROCESS_WORKFLOWINFORMATION TYPE=""RELATION"">
                                                <WORKFLOWINFORMATION>
	                                                <WORKFLOWCATEGORY>{1}</WORKFLOWCATEGORY>
                                                    <WORKFLOWSUBCATEGORY>Route</WORKFLOWSUBCATEGORY>
	                                                <ROUTEMETHOD>{2}</ROUTEMETHOD>
	                                                <APPROVALSJOBID>{3}</APPROVALSJOBID>
	                                                <REVISIONNUMBER>1</REVISIONNUMBER>
	                                                <REMINDERFREQUENCY>2</REMINDERFREQUENCY>
                                                </WORKFLOWINFORMATION>
                                                </WORKFLOWPROCESS_WORKFLOWINFORMATION>
                                                <APPROVALS_JOBINITIATOR TYPE=""RELATION"">{4}</APPROVALS_JOBINITIATOR>
                                                <FILESYSTEM>
	                                                    {5}
                                                 </FILESYSTEM>
                                                 <{6} TYPE=""RELATION"" PARENTID=""TRUE"">{7}</{6}>
                                                 <PROCESSNAME>{8}</PROCESSNAME>  
                                                 <DESCRIPTION>{9}</DESCRIPTION>
                                                 </WORKFLOWPROCESS>", ProcessID, str_Workflowcategory, str_RouteMethod, ApprovalsJobID.ToString(), ALParamObj.UserID,str_FileContents,str_CommitmentWorkFlowRelationName,CommitmentID,sb_ApprovalJobName.ToString(),sb_ApprovalJobDesc.ToString());
                                                                     

                    str_InputXML = sb_ApprovalJob.ToString();    
                    ErrorXML     = obj_ApprovalsFacade.CreateApprovalsJob(PackageID, ProcessID, false, SolutionName, ref str_InputXML);
                    if (!String.IsNullOrEmpty(ErrorXML))
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALS", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }

                    xpDoc_WorkFlowProcess = new XPathDocument(new StringReader(str_InputXML));
                    xpNav_WorkFlowProcess = xpDoc_WorkFlowProcess.CreateNavigator();
                    str_WorkFlowProcessID = xpNav_WorkFlowProcess.SelectSingleNode("//WORKFLOWPROCESSID").Value;
                    JobProcessID = str_WorkFlowProcessID;

                    //Add Vendor Resource
                    if (String.Compare(ApprovalJobType, "VendorApproval", true) == 0 && !String.IsNullOrEmpty(VendorResource))
                    {
                        AddVendorResource(str_InputXML);
                    }
                    #endregion
                }
                catch (ThreadAbortException)
                { }
                catch (Exception obj_Exception)
                {
                    ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "gotoCommitmentROPage", obj_Exception, null, "Exception while Create Approvals Job.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, obj_Exception.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
                
            }

            /// <alsummary>
            /// <CreatedOn>24 Feb 2009</CreatedOn>
            /// <Author>Mr.Pravin Shinde</Author>
            /// <Purpose>This method creates the add vendor resource to Vendor approval</Purpose>
            /// </alsummary>
            /// <param name="ProcessNode">The Process Node will be used to read the End Activity Sequence No 
            /// and transitions that will also be updated as a result of creating the new Activity</param>
            /// <returns>The XML required to create the new Activity</returns>
            private void AddVendorResource(String ApprovalJobXML)
        {
            XPathDocument       xpDoc_ApprovalJob               = null;
            XPathNavigator      xpNav_ApprovalJobRoot           = null;
            XPathNavigator      xpNav_ApprovalJob               = null;
            String              str_Activity                    = null;
            String              str_Transition                  = null;
            String              ErrorXML                        = null;
            String              UpdateProcessXML                = null;
            String              str_Instructions                = null;
            String              ErrorPageURL                    = null;
            StringBuilder       sb_UpdateApprovalJob            = null;
            PMFacadeClass       Obj_PMFacade                    = null;
            StringDictionary    strdict_KeysWithXpath           = null;
            StringDictionary    strdict_Values                  = null;

            try
            {
                strdict_KeysWithXpath = new StringDictionary();
                strdict_Values = new StringDictionary();
                strdict_KeysWithXpath.Add("INSTRUCTIONSTOVENDOR","APPROVALSCONFIGURATION/INSTRUCTIONSTOVENDOR");
                xpDoc_ApprovalJob       = new XPathDocument(new StringReader(ApprovalJobXML));
                xpNav_ApprovalJobRoot   = xpDoc_ApprovalJob.CreateNavigator();
                xpNav_ApprovalJob       = xpNav_ApprovalJobRoot.SelectSingleNode("WORKFLOWPROCESS");
                CommonFunctions.GetSolutionConfigurationSettings(ALParamObj.TenantName, ALParamObj.SolutionName, strdict_KeysWithXpath, out strdict_Values);
                if (strdict_Values["INSTRUCTIONSTOVENDOR"] != null)
                    str_Instructions = strdict_Values["INSTRUCTIONSTOVENDOR"];
                PrepareActivityXMLForVendorResource(xpNav_ApprovalJob, true, VendorResource,str_Instructions, out str_Activity, out str_Transition);
                sb_UpdateApprovalJob = new StringBuilder(300);
                sb_UpdateApprovalJob.AppendFormat(@"<WORKFLOWPROCESS MODIFIED='TRUE'>
                                                <WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>
                                                <PROCESS_ACTIVITY TYPE='RELATION'>{1}</PROCESS_ACTIVITY>{2}</WORKFLOWPROCESS>", xpNav_ApprovalJob.SelectSingleNode("WORKFLOWPROCESSID").Value, str_Activity, str_Transition);
                UpdateProcessXML    = sb_UpdateApprovalJob.ToString();
                Obj_PMFacade        = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXML            = Obj_PMFacade.UpdateProcess(false, true, ref UpdateProcessXML);
                if (!String.IsNullOrEmpty(ErrorXML))
                {
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALS", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            catch (Exception obj_Exception)
            {
                throw obj_Exception;
            }
        }

            /// <alsummary>
        /// <CreatedOn>24 Feb 2009</CreatedOn>
        /// <Author>Mr.Pravin Shinde</Author>
        /// <Purpose>This method creates the default Activity XML to add vendor resource</Purpose>
        /// </alsummary>
        /// <param name="ProcessNode">The Process Node will be used to read the End Activity Sequence No 
        /// and transitions that will also be updated as a result of creating the new Activity</param>
        /// <returns>The XML required to create the new Activity</returns>
            private void PrepareActivityXMLForVendorResource(XPathNavigator xpNav_Process,Boolean bool_AddActCont_rel ,String str_DMID,String str_Instructions,  out String str_Activity, out String str_Transition)
        {
            StringBuilder sb_Activity           = null;
            StringBuilder sb_Transition         = null;
            StringBuilder XPathQuery            = null;
            XPathNavigator xpNav_EndActivity       = null;
            XPathNavigator xpNav_ProcessTransition= null;
            XPathNavigator xpNav_Transition = null;
            String        str_EndActSeqNo       = null;
            String        EndActivityID         = null;
            Int32         ActSeqNo              = 0;
            String        str_TaskName          = null;
            String        str_Duration          = null;
            String        StartActivityID       = null;
            ulong         ActivityID            = 0;
            PMFacadeClass obj_PMFacadeClass     = null;
            
            try
            {
                obj_PMFacadeClass = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ALCommon.GenerateUniqueID(ref ActivityID);
                sb_Activity     = new StringBuilder(250);
                sb_Transition   = new StringBuilder(250);
                str_Transition  = null;

                xpNav_ProcessTransition = xpNav_Process.SelectSingleNode("PROCESS_TRANSITION");
                xpNav_EndActivity = xpNav_Process.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[ENDACTIVITY/text()='True']");
                if (xpNav_EndActivity != null)
                {
                    str_EndActSeqNo = xpNav_EndActivity.SelectSingleNode("SEQUENCENUMBER").Value;
                    if (str_EndActSeqNo != null)
                        ActSeqNo = Convert.ToInt32(str_EndActSeqNo);
                    ActSeqNo++;
                    EndActivityID = xpNav_EndActivity.SelectSingleNode("ACTIVITYID").Value;
                }
                str_TaskName = xpNav_Process.SelectSingleNode("PROCESSNAME").Value;
                str_Duration = obj_PMFacadeClass.ConvertDaysToMinutes(2).ToString();

                // Prepare Input XML for New Activity

                sb_Activity.AppendFormat(@"<ACTIVITY>
                                            <ACTIVITYID>{0}</ACTIVITYID>
                                             <INSTRUCTIONS>{1}</INSTRUCTIONS>", ActivityID, ALCommon.TrimAndReplaceSpecialChars(str_Instructions));
                sb_Activity.Append(@"<ACTIVITYTYPE>Implementation</ACTIVITYTYPE>
                                            <IMPLEMENTATIONTYPE>Task</IMPLEMENTATIONTYPE>
                                            <STATUS>New</STATUS><ACTIVITYNAME>");
                sb_Activity.Append(ALCommon.TrimAndReplaceSpecialChars(str_TaskName));
                sb_Activity.Append(@"</ACTIVITYNAME>
                                            <ENDACTIVITY>False</ENDACTIVITY>
                                            <STARTACTIVITY>False</STARTACTIVITY>
                                            <TASKTYPE>TaskManual</TASKTYPE>
                                            <SEQUENCENUMBER>" + str_EndActSeqNo + "</SEQUENCENUMBER>");
                sb_Activity.Append(@"<ACTIVITY_INFORMATION TYPE='RELATION'>
                                            <ACTIVITYINFORMATION>
                                            <STARTMODE>Automatic</STARTMODE>
                                            <FINISHMODE>Manual</FINISHMODE>
                                            <STARTDATELOCKED>0</STARTDATELOCKED>
                                            <CANCELAPPROVALIFREJECTED>1</CANCELAPPROVALIFREJECTED>
                                            <DURATION>" + str_Duration + "</DURATION>");
                  sb_Activity.Append(@"</ACTIVITYINFORMATION></ACTIVITY_INFORMATION>
                                        <ACTIVITY_RESOURCE TYPE='RELATION'>
                                            <RESOURCE><PLANNEDEFFORT>2880</PLANNEDEFFORT>");
                        sb_Activity.Append(@"<RESOURCECOUNT>1</RESOURCECOUNT>
                                            <RESOURCETYPE>EVERYONE</RESOURCETYPE>
                                            <USERASSIGNED>False</USERASSIGNED>
                                        <ACTUAL_RESOURCE TYPE='RELATION'>
                                            <RESOURCE>
                                            <RESOURCECOUNT>1</RESOURCECOUNT>
                                            <RESOURCETYPE>EVERYONE</RESOURCETYPE>
                                            <USERASSIGNED>TRUE</USERASSIGNED>
                                            <RESOURCE_USER TYPE='RELATION'>" + str_DMID + "</RESOURCE_USER>");
                sb_Activity.AppendFormat(@"</RESOURCE>
                                                </ACTUAL_RESOURCE>
                                                </RESOURCE>
                                                </ACTIVITY_RESOURCE>");
                if (bool_AddActCont_rel)
                    sb_Activity.AppendFormat("<ACTIVITY_CONTRIBUTOR TYPE='RELATION'>{0}</ACTIVITY_CONTRIBUTOR>", str_DMID);
                sb_Activity.Append("</ACTIVITY>");

                // Update the end Activity Sequence No
                sb_Activity.AppendFormat(@"<ACTIVITY MODIFIED='TRUE'>
                                            <ACTIVITYID>{0}</ACTIVITYID>
                                            <SEQUENCENUMBER>{1}</SEQUENCENUMBER>
                                           </ACTIVITY>", EndActivityID, ActSeqNo.ToString());
                str_Activity = sb_Activity.ToString();
                // Now Prepare the Transition XML for new Activity.
                StartActivityID = xpNav_Process.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY/text()='True']/ACTIVITYID").Value;
                XPathQuery = new StringBuilder(100);
                XPathQuery.AppendFormat("TRANSITION[FROMACTIVITY/text()='{0}' and TOACTIVITY/text()='{1}']", StartActivityID, EndActivityID);

                xpNav_Transition = xpNav_ProcessTransition.SelectSingleNode(XPathQuery.ToString());
                if (xpNav_Transition != null)
                {
                    sb_Transition.AppendFormat(@"<PROCESS_TRANSITION TYPE='RELATION' DISASSOCIATE='TRUE'>
                                                {0}</PROCESS_TRANSITION>", xpNav_Transition.SelectSingleNode("TRANSITIONID").Value);
                    sb_Transition.AppendFormat(@"<PROCESS_TRANSITION TYPE='RELATION'><TRANSITION>
                                                    <FROMACTIVITY TYPE='RELATION'>{0}</FROMACTIVITY>
                                                    <TOACTIVITY TYPE='RELATION'>{1}</TOACTIVITY>
                                                </TRANSITION>", StartActivityID, ActivityID);

                    sb_Transition.AppendFormat(@"<TRANSITION>
                                                    <FROMACTIVITY TYPE='RELATION'>{0}</FROMACTIVITY>
                                                    <TOACTIVITY TYPE='RELATION'>{1}</TOACTIVITY>
                                                </TRANSITION></PROCESS_TRANSITION>", ActivityID, EndActivityID);
                    str_Transition = sb_Transition.ToString();
                }
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

            /// <alsummary>
            /// <CreatedOn>24 Feb 2009</CreatedOn>
            /// <Author>Mr.Pravin Shinde</Author>
            /// <Purpose>This method redirects to commitment RO Page</Purpose>
            /// </alsummary>
            /// <param name="ProcessNode">The Process Node will be used to read the End Activity Sequence No 
            /// and transitions that will also be updated as a result of creating the new Activity</param>
            /// <returns>The XML required to create the new Activity</returns>
            private void gotoCommitmentROPage()
            {
            StringBuilder ParamURL = null;
            StringBuilder URL = null;
            String EncryptURL = null;
            ulong ErrorID = 0;
            String ErrorPageURL = null;

            try
            {
                ParamURL = new StringBuilder();
                URL = new StringBuilder();
                if (IsCustomized)
                    ParamURL.AppendFormat("/{0}/{1}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
                else
                    ParamURL.AppendFormat("/{0}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName);

                ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&AccessMode={10}&BREADCRUMBNAME={11}&BREADCRUMBID={12}&BREADCRUMBXML={13}&IsCustomized={14}&SelectedTabName=Approvals&Mode={15}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, "StrategicPlanner", CommitmentID, TaskPaneList, MasterPageFileName, str_Theme, SourceAttributes, CommitmentAccess, str_ParentBreadCrumbName, BreadcrumbID, BreadcrumbXML, IsCustomized,CommitmentMode);

                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                {
                    Response.Redirect(EncryptURL);
                }
                else
                {
                    this.Ajax.WriteExecuteJavaScript("javascript:window.open('" + EncryptURL + "','_self','');");
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_JobDetails.aspx", "gotoCommitmentROPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
            }
        }

            /// <summary>
            /// <createddate>10 March 2009</createddate>
            /// <author>Mr.Pravin Shinde</author>
            /// <purpose>This method imports approvals package.</purpose>
            /// </summary>
            /// <param name="XPDLPath">Default Approvals XPDL file path.</param>
            /// <param name="ApprovalsTypeXML">Returns XPDL-XML as string</param>
            /// <returns>ErrorXml</returns>
            private ERRORXML ProcessApprovalsPackage(String XPDLPath, ref XML ApprovalsTypeXML)
            {
                XmlDocument     ApprovalsPackageDoc     = null;
                XmlNodeList     ApprovalsProcessNodes   = null; 
                XmlNode         ProcessHeaderNode       = null; 
                XmlNode         ProcessCreatedDateNode  = null; 
                XmlNode         ProcessAuthorNode       = null;  
                XmlNode         ProcessLastModifiedDate = null; 
                XmlNode         PackageNode             = null; 
                String          XSLTPath                = null;
                String          RetrunByXSLT            = null;
                String          InputToCreateAPI        = null; 
                ERRORXML        ErrorXMLString          = null; 
                StringBuilder   XSLTFilePath            = null; 
                PMFacadeClass   PMFacadeObj             = null;
                Stream          Memory_Stream           = null;
                StreamReader    Stream_Reader           = null;
                XslCompiledTransform GET_XSLT           = null;
                String          ErrorPageURL            = null; 

                 
                try
                {
                    ApprovalsPackageDoc = new XmlDocument();
                    XSLTFilePath        = new StringBuilder(150);
                    GET_XSLT            = new XslCompiledTransform();
                    Memory_Stream       = new MemoryStream();
                    PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);   
                    
                    if (!String.IsNullOrEmpty(XPDLPath) && File.Exists(XPDLPath))
                    {
                        ApprovalsPackageDoc.Load(XPDLPath);
                        PackageNode = ApprovalsPackageDoc.DocumentElement;
                        ApprovalsProcessNodes = PackageNode.SelectNodes("WorkflowProcesses/WorkflowProcess");

                        foreach (XmlNode ApprovalsProcessNode in ApprovalsProcessNodes)
                        {
                            ProcessHeaderNode = ApprovalsProcessNode.SelectSingleNode("ProcessHeader");
                            ProcessLastModifiedDate = ProcessHeaderNode.Attributes.GetNamedItem("LastModified");
                            if (ProcessLastModifiedDate != null)
                            {
                                ProcessHeaderNode.Attributes.RemoveNamedItem("LastModified");
                            }
                            
                            ProcessCreatedDateNode = ProcessHeaderNode.SelectSingleNode("Created");
                            if (ProcessCreatedDateNode != null)
                            {
                                ProcessCreatedDateNode.InnerText = DateTime.Today.ToShortDateString();
                            }

                            ProcessAuthorNode = ApprovalsProcessNode.SelectSingleNode("RedefinableHeader/Author");
                            if (ProcessAuthorNode != null)
                            {
                                ProcessAuthorNode.InnerText = PMFacadeObj.getLogedInUserName(ALParamObj.TenantName, ALParamObj.UserID);
                            }   
                        }

                        XSLTPath = ALSolutionCommon.GetXSLTPath(ALParamObj.TenantName, "ProcessDesigner");
                        XSLTFilePath.AppendFormat("{0}Get_PackageXSLT.xslt", XSLTPath);
                        GET_XSLT.Load(XSLTFilePath.ToString());

                        if (PackageNode != null)
                        {
                            GET_XSLT.Transform(PackageNode, null, Memory_Stream);
                            Memory_Stream.Position = 0;
                            Stream_Reader = new StreamReader(Memory_Stream);
                            RetrunByXSLT = Stream_Reader.ReadToEnd();
                            Memory_Stream.Flush();
                            Stream_Reader.Close();

                            if (RetrunByXSLT != null)
                            {
                                ApprovalsPackageDoc = null;
                                ApprovalsPackageDoc = new XmlDocument(); 
                                ApprovalsPackageDoc.LoadXml(RetrunByXSLT);
                                PackageNode = ApprovalsPackageDoc.SelectSingleNode("PACKAGEDEFINITION/PACKAGE");
                                if (PackageNode != null)
                                {
                                    ApprovalsTypeXML = PackageNode.OuterXml;
                                    ErrorXMLString = PMFacadeObj.CreatePackageDef(ref ApprovalsTypeXML);
                                }
                            }
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", ErrorXMLString, "Invalid ApprovalsPackage.xpdl file path.", null, GetBackUrl(), ref ErrorPageURL);
                        Response.Redirect(ErrorPageURL, true);
                    }
                    return (ErrorXMLString);
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            private String CheckPDFProcessorRequired(XPathDocument ProcessXMLDocument)
            {

                XPathNavigator node_AnnotationMethod = null;

                node_AnnotationMethod = ProcessXMLDocument.CreateNavigator();
                node_AnnotationMethod = node_AnnotationMethod.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/ANNOTATIONMETHOD");

                if (node_AnnotationMethod != null)
                {
                    return node_AnnotationMethod.Value.ToUpper();
                }
                //mudassar: this path shoould never be reached
                return "";
            }

            private Boolean ValidateReminderDuration()
            {
                if (String.IsNullOrEmpty(TextBox_ReminderFrequencey.Text.Trim()))
                {
                    return true;
                }
                else
                {
                    try
                    {
                        int tmpval = Int32.Parse(TextBox_ReminderFrequencey.Text.Trim());

                        if (tmpval < 0)
                        {
                            return true;
                        }
                    }
                    catch (Exception exc)
                    {
                        return true;
                    }
                }
                return false;
            }
        #endregion
    }
}
