#region System_Includes
    using System;
    using System.Data;
    using System.Xml;
    using System.Text;
    using System.Configuration;
    using System.Web;
    using System.Web.Security;
    using System.Web.UI;
    using System.Collections;
    using System.Web.UI.WebControls;
    using System.Web.UI.WebControls.WebParts;
    using System.Web.UI.HtmlControls;
    using System.Xml.XPath;
    using System.IO;
    using System.Collections.Generic;
    using System.Threading; 
#endregion

#region Assetlink_Includes
    using Assetlink.Solutions;
    using Assetlink.CustomControls;
    using Assetlink.Solutions.Facade.CommonFacade;
    using Assetlink.Solutions.Facade.PMFacade;
    using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
    using Assetlink.Solutions.Facade.NotificationFacade;
    using Assetlink.Solutions.Facade.ApprovalsFacade; 
    using Assetlink.Widgets;
    using Assetlink.Widgets.PMWidgetCommon;
    using Assetlink.Solutions.Pages;
#endregion

//---------------------------------------------------------//
// File Name:   Commitment_Approvals_ROJobDetails.aspx.cs  //
// Author:      Mr. Pravin Shinde.                         //
// Class:       Commitment_Approvals_ROJobDetails          //
// Created On:  05th Feb 2009                              //
//---------------------------------------------------------//


namespace Assetlink.Solutions.StrategicPlanner
{
    using XML       = String;
    using ERRORXML  = String;

    public partial class Commitment_Approvals_ROJobDetails : ALAjaxPage
    {

        #region Member Variables
            private const String                        WidgetName                              = "SP_CommitmentWidget";
            private ALSolutionCommon                    ALSolutionCommonObj                     = null;
            private List<ObjectInfo>                    ObjInfoList                             = null;
            private List<ObjectInfo>                    ObjAdvInfoList                          = null;
            public ALParam                              ALParamObj                              = null;
            String[]                                    strSeparator                            = null;
            private String                              JobProcessID                            = null; 
            private String                              Access                                  = null; 
            private String                              Mode                                    = null; 
            private String                              TempPath                                = null; 
            private String                              SolutionName                            = "Approvals";
            private String                              Approvals_Job_StateFile                 = "Approvals_ROJob_StateFile.xml";
            private Boolean                             ApprovalsFormReferesh                   = false;
            private String                              Str_SolutionDisplayName                 = "Approvals";
            private String                              TaskPaneList                            = null;
            private String                              BreadcrumbName                          = null;
            private String                              BreadcrumbID                            = null;
            private String                              BreadcrumbXML                           = null;
            private String                              str_BreadcrumbXML                       = null;
            private String                              MasterPageFileName                      = null;
            private String                              strTheme                                = null;
            private Hashtable                           UrlList                                 = null;
            private String                              str_Theme                               = null;
            private String                              PDFFilePath                             = null;
            private String                              CommitmentID                            = null;
            private String                              CommitmentTitle                         = null;
            private String                              SourceAttributes                        = null;
            private String                              AccessMode                              = null;
            private String                              ApprovalJobType                         = null;
            private String                              str_ApprovalsJobName                    = null;
            private Boolean                             IsCustomized                            = false;
            private String                              str_ParentBreadCrumbName                = null;
            private String                              CommitmentAccess                        = null;
            private String                              CommitmentMode                          = null;
            private Control                             ControlToRefresh;
            private bool                                IsVideoOnly                             = true;
        #endregion

        #region ControlsOnPage
            private Form                    FRM_ReadOnlyJob             = null;
            private Form                    FRM_JobAdvDetails           = null;
            private ActionBar               AB_ReadOnlyJob              = null;            
            //private Label                   Label_RevisionNumber        = null; 
            private ApprovalsWidget         Approvals_WidgetControl     = null;
            private ALUC_ALUserSelection    UC_ReadersSelection         = null;
            private ALUC_ALUserSelection    UC_JobInitiator             = null; 
            private ALPanel                 ALPanel_ReadersSelection    = null;
            private ALPanel                 ALPanel_JobInitiator        = null; 
            private Assetlink.CustomControls.ListControl LC_Prev_Revision= null; 
            private SquareBlankSection      SBS_Collabration            = null; 
            private ALBreadCrumb            CommitmentBreadcrumb        = null;
            private ALBaseControl           ALBase_AdvancedDetails      = null;
            private Label                   Label1                      = null;
            private Label                   Label12                     = null;
        #endregion

        #region Property

	    public Boolean IsMediaFileForApproval
	    {
		    get
            {
                if (this.ViewState["MediaFileForApproval"] != null)
                {
                    Boolean m_IsMediaFileForApproval = (Boolean)this.ViewState["MediaFileForApproval"];
                    return m_IsMediaFileForApproval; 
                }
                else
                {
                    return false;
                }
            }
		    set 
            {
                this.ViewState["MediaFileForApproval"] = value;
            }
	    }


        public String MediaTopicID
        {
            get
            {
                if (this.ViewState["MediaTopicID"] != null)
                {
                    return this.ViewState["MediaTopicID"].ToString();
                }
                else
                {
                    return "0";
                }
            }
            set
            {
                this.ViewState["MediaTopicID"] = value;
            }
        }
	
            #endregion

        #region Protected Methods
            
            protected void Page_PreInit(object sender, EventArgs e)
            {
                setParameters();
                this.Page.MasterPageFile    = MasterPageFileName;
                this.Page.Theme             = str_Theme;
            }

            protected void Page_Init(object sender, EventArgs e)
            {

                if (!String.IsNullOrEmpty(ALSolutionCommonObj.GetParamValue("SolutionDisplayName")))
                    Str_SolutionDisplayName = Server.UrlDecode(ALSolutionCommonObj.GetParamValue("SolutionDisplayName"));

                this.Master.GetType().GetProperty("TenantName").SetValue(this.Master, ALParamObj.TenantName, null);
                this.Master.GetType().GetProperty("SolutionName").SetValue(this.Master, SolutionName, null);
                this.Master.GetType().GetProperty("SessionID").SetValue(this.Master, ALParamObj.SessionID, null);
                this.Master.GetType().GetProperty("UserID").SetValue(this.Master, ALParamObj.UserID, null);
                this.Master.GetType().GetProperty("Language").SetValue(this.Master, ALParamObj.Language, null);
            }

            protected void Page_Load(object sender, EventArgs e)
            {
                ulong  ErrorID      = 0;
                String ErrorPageURL = null;

                try
                {
                    setControls();
                    GetTaskPanes();
                    Ajax.AsynchronousRequest = true;
                    
                    if (!IsPostBack)
                    {
                        getPackageProcessIDs();
                        setPageInROMode();
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "Page_Load", ExceptionObject, null, "Exception while loading the Page.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            protected void Approvals_WidgetControl_ProcessModified(object sender, PM_Approvals_WidgetEventArgs e)
            {
                String      EventString = null;
                String      JobStatus   = null;
                ERRORXML    ErrorXML    = null; 

                try
                {
                    SetAndRefreshControl(e.ControlToRefresh);
                    EventString = e.EventName;

                    if (EventString == "STEPS_CANCELLED")
                    {
                        UpdateApprovalsFormXML(out JobStatus);
                        //ErrorXML = StampNotificationForApprovalsJob(JobProcessID, "STEP_CANCELLED");
                        //if (String.IsNullOrEmpty(ErrorXML))
                        //{
                            ApprovalsFormReferesh = true;
                            if ((JobStatus.ToUpper() == "COMPLETED") || (JobStatus.ToUpper() == "CANCELLED"))
                                gotoApprovalsROJobPage();
                        //}
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }
            
            protected void AB_ReadOnlyJob_Click(object sender, EventArgs e)
            {
                ulong  ErrorID      = 0;
                String ErrorPageURL = null;

                try
                {
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btn_ViewConsolidatedDocument"))
                    {
                        GetConsolidatedDocument();
                    }
                    else if (Parameters[1].Equals("btn_TerminateJob"))
                    {
                        CancelApprovalsJob();
                    }
                    else if (Parameters[1].Equals("btn_CreateNewRevision"))
                    {
                        CreateRevision();
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "AB_ReadOnlyJob_Click", ExceptionObject, null, "Exception in AB_ReadOnlyJob_Click.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            
            /// <alsummary>
            /// <createddate>12 April 2007</createddate>
            /// <author>Hemant Karkande</author>
            /// <purpose>To show previous revisions list.</purpose>
            /// <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes>
            /// </alsummary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void LC_Prev_Revision_CollapsedClick(object sender, EventArgs e)
            {
                ApprovalsFacadeClass    ApprovalsFacadeObj      = null;
                MktgWorkBenchFacadeClass MWBFacadeObj           = null; 
                ERRORXML                ErrorXMLString          = null; 
                ListFacade              ListFacadeObj           = null;
                XML                     PreviousRevisionsXML    = null; 
                XML                     ConfigXML               = null; 
                XML                     OutputXML               = null; 
                StringBuilder           TempXML                 = null;
			    ulong			        ErrorID				    = 0;
                String                  ErrorPageURL            = null;
 
                try
                {
                    LC_Prev_Revision.IsMinimize = false;
                    LC_Prev_Revision.EnableIterators = true;  

                    MWBFacadeObj        = new MktgWorkBenchFacadeClass (ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ListFacadeObj       = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    ErrorXMLString = ApprovalsFacadeObj.GetAllPreviousRevisions(__ApprovalsJobID.Value, __RevisionNumber.Value, ref PreviousRevisionsXML);
                    if (String.IsNullOrEmpty(ErrorXMLString))
                    {
                        ListFacadeObj.AddParameter("Mode", Mode);
                        ListFacadeObj.AddParameter("Access", Access);
                        TempXML = new StringBuilder();
                        ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, WidgetName, "PreviousRevisions");
                        TempXML.Remove(0, TempXML.Length);
                        TempXML.AppendFormat("<SEARCHOUTPUTXML>{0}</SEARCHOUTPUTXML>", PreviousRevisionsXML);
                        ListFacadeObj.PrepareListXml(ConfigXML, TempXML.ToString(), out OutputXML);

                        MWBFacadeObj.InsertPercentCompleteClass("DUEDATE", ref OutputXML);  

                        LC_Prev_Revision.Source = OutputXML;
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXMLString, null, null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "LC_Prev_Revision_CollapsedClick", ExceptionObject, null, "Exception while showing previous revision list.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }

            protected override void Render(HtmlTextWriter writer)
            {
                if (IsPostBack)
                {
                    String EventGenerator = Ajax.EventGeneratorUniqueID;
                    if (ControlToRefresh != null)
                        Ajax.AddControlsToRender(ControlToRefresh);

                    if (ApprovalsFormReferesh == true)
                    {
                        Ajax.AddControlsToRender(FRM_ReadOnlyJob);
                        
                        Ajax.AddControlsToRender(AB_ReadOnlyJob);   
                    }

                    if (EventGenerator.Contains("btn_ViewConsolidatedDocument"))
                        Ajax.AddControlsToRender(AB_ReadOnlyJob);

                    if ((EventGenerator.Contains("LC_ID_PreviousRevisions_Min_Btn")) || (EventGenerator.Contains("LC_ID_PreviousRevisions")))
                        Ajax.AddControlsToRender(LC_Prev_Revision);  

                    Ajax.WriteControlHTMl(this.Page, writer);
                }
                else
                    base.Render(writer);
            }
        #endregion

        #region Private Methods

            private void setParameters()
            {
			    ulong  ErrorID      = 0;
                String ErrorPageURL = null;

                try
                {
                    UrlList = new Hashtable();
                    ALSolutionCommonObj = new ALSolutionCommon();
                    ALParamObj = new ALParam();

                    ALSolutionCommonObj.httpContext = HttpContext.Current;
                    ALSolutionCommonObj.InitALParam(ref ALParamObj);

                    JobProcessID                = ALSolutionCommonObj.GetParamValue("JobProcessID");
                    Access                      = ALSolutionCommonObj.GetParamValue("Access"); 
                    JobProcessID                = ALSolutionCommonObj.GetParamValue("JobProcessID");
                    BreadcrumbName              = ALSolutionCommonObj.GetParamValue("BREADCRUMBNAME");
                    BreadcrumbID                = ALSolutionCommonObj.GetParamValue("BREADCRUMBID");
                    BreadcrumbXML               = ALSolutionCommonObj.GetParamValue("BREADCRUMBXML");
                    MasterPageFileName          = ALSolutionCommonObj.GetParamValue("MasterPageFile");
                    Mode                        = ALSolutionCommonObj.GetParamValue("Mode");
                    CommitmentID                = ALSolutionCommonObj.GetParamValue("CommitmentID");
                    TaskPaneList                = ALSolutionCommonObj.GetParamValue("TaskPaneList");
                    str_Theme                   = ALSolutionCommonObj.GetParamValue("Theme");
                    SourceAttributes            = ALSolutionCommonObj.GetParamValue("SOURCEATTRIBUTES");
                    CommitmentAccess            = ALSolutionCommonObj.GetParamValue("CommitmentAccess");
                    CommitmentMode              = ALSolutionCommonObj.GetParamValue("CommitmentMode");
                    CommitmentTitle             = ALSolutionCommonObj.GetParamValue("CommitmentTitle");
                    if (!String.IsNullOrEmpty(ALSolutionCommonObj.GetParamValue("IsCustomized")))
                        IsCustomized            = Convert.ToBoolean(ALSolutionCommonObj.GetParamValue("IsCustomized"));
                    ApprovalJobType             = ALSolutionCommonObj.GetParamValue("ApprovalJobType");
                    PDFFilePath                 = Server.UrlDecode(ALSolutionCommonObj.GetParamValue("PDFFilePath"));
                    SolutionName                = ALSolutionCommonObj.GetParamValue("SolutionName");
                    str_ParentBreadCrumbName    = ALSolutionCommonObj.GetParamValue("PARENTBREADCRUMBNAME");

                    UrlList.Add("IsCustomized", IsCustomized.ToString());
                    UrlList.Add("AccessMode", CommitmentAccess);
                    UrlList.Add("SOURCEATTRIBUTES", SourceAttributes);
                    UrlList.Add("TaskPaneList", TaskPaneList);
                    UrlList.Add("CommitmentID", CommitmentID);
                    UrlList.Add("Mode", CommitmentMode);
                    UrlList.Add("MasterPageFile", MasterPageFileName);
                    UrlList.Add("Theme", strTheme);
                    UrlList.Add("RelationshipName", "COMMITMENT_TO_INVOICE");
                    UrlList.Add("SourceEntityID", CommitmentID.ToString());

                    strSeparator    = new String[1] { "$AL$" };
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "setParameters", ExceptionObject, null, "Exception while setting the parameters for the Create Page.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            private void setControls()
            {
                StringBuilder ListControlXSLTPath   = null;
                StringBuilder ModifyJobURL          = null; 
                //StringBuilder DoneButtonURL         = null; 
                String        InstalledPath         = null;
                String        FormatXMLPath         = null;
                String        CultureInformation    = null;
                String        EncryptURL            = null; 
			    ulong         ErrorID				= 0;
                String        ErrorPageURL          = null;           

                try
                {
                    ListControlXSLTPath = new StringBuilder();

                    FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);

                    Page_CreatePage.TenantName = ALParamObj.TenantName;
                    Page_CreatePage.SectionHeading = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_ViewJob_Shared");

                    TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);    

                    // set the input XML paths of task panes.
                    InstalledPath = ALCommon.GetInstallationDir();
                    ListControlXSLTPath.AppendFormat("{0}{1}\\XSLT\\SortListXML.xslt", InstalledPath, ALParamObj.TenantName);

                    // set the tenant name of task panes
                    FRM_ReadOnlyJob                 = (Form)Page_CreatePage.FindControl("ApprovalsDetails_Form");
                    FRM_ReadOnlyJob.TenantName      = ALParamObj.TenantName;
                    FRM_ReadOnlyJob.SolutionName    = SolutionName;

                    FRM_ReadOnlyJob.CultureInformation      = CultureInformation;
                    FRM_ReadOnlyJob.PersonalizationFilePath = FormatXMLPath;

                    ALBase_AdvancedDetails                      = (ALBaseControl)Page_CreatePage.FindControl("ALBase_AdvancedDetails");
                    ALBase_AdvancedDetails.TenantName           = ALParamObj.TenantName;
                    ALBase_AdvancedDetails.CaptionText          = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_EditJobDetails_AppJobInfo");
                    FRM_JobAdvDetails                           = (Form)ALBase_AdvancedDetails.FindControl("ApprovalsAdvacedDetails_Form");
                    FRM_JobAdvDetails.TenantName                = ALParamObj.TenantName;
                    FRM_JobAdvDetails.SolutionName              = SolutionName;
                    FRM_JobAdvDetails.CultureInformation        = CultureInformation;
                    FRM_JobAdvDetails.PersonalizationFilePath   = FormatXMLPath;

                    SBS_Collabration            = (SquareBlankSection)Page_CreatePage.FindControl("Content_1_sbs_Collaboration_Details");
                    SBS_Collabration.TenantName = ALParamObj.TenantName;
                    if(!IsPostBack) 
                        SBS_Collabration.IsMinimize = true;

                    Label1                                      = (Label)SBS_Collabration.FindControl("Label1");
                    Label1.Text                                 = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_ROJobDetails_JobInitiatedBy") + ":";
                    Label12                                     = (Label)SBS_Collabration.FindControl("Label2");
                    Label12.Text                                = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_Readers_Shared") + ":";
                    ALPanel_ReadersSelection                    = (ALPanel)SBS_Collabration.FindControl("ID_ReadersSelection");
                    UC_ReadersSelection                         = (ALUC_ALUserSelection)ALPanel_ReadersSelection.FindControl("ALUC_ReadersSelection");

                    ALPanel_JobInitiator                        = (ALPanel)SBS_Collabration.FindControl("ID_JobInitiator");
                    UC_JobInitiator                             = (ALUC_ALUserSelection)ALPanel_JobInitiator.FindControl("ALUC_JobInitiator");   

                    Approvals_WidgetControl                     = (ApprovalsWidget)Page_CreatePage.FindControl("Approvals_Widget");

                    LC_Prev_Revision            = (Assetlink.CustomControls.ListControl)Page_CreatePage.FindControl("LC_ID_PreviousRevisions");
                    LC_Prev_Revision.TenantName = ALParamObj.TenantName;
                    LC_Prev_Revision.XSLTPath   = ListControlXSLTPath.ToString();
                    //Approvals_WidgetControl.Show_ROReviewerListActionBar = false;
                    LC_Prev_Revision.CultureInformation      = CultureInformation;
                    LC_Prev_Revision.PersonalizationFilePath = FormatXMLPath;

                    LC_Prev_Revision.EventOnExpand = true;
                    LC_Prev_Revision.CollapsedClick +=new EventHandler(LC_Prev_Revision_CollapsedClick);
                    if (!IsPostBack)
                        LC_Prev_Revision.IsMinimize = true;

                    if (Access.ToUpper() == "READ")
                        LC_Prev_Revision.Visible = false;   

                    AB_ReadOnlyJob = (ActionBar)Page_CreatePage.FindControl("Content_5_ab_ROJob_ActionBar");
                    AB_ReadOnlyJob.TenantName = ALParamObj.TenantName;

                    ModifyJobURL = new StringBuilder();
                    ModifyJobURL.AppendFormat("Approvals_UpdateJobDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&Mode={4}&Access={5}&JobProcessID={6}&SolutionDisplayName={7}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Mode, Access, JobProcessID, Server.UrlEncode(Str_SolutionDisplayName));
                    ModifyJobURL.AppendFormat("&SolutionName={0}&CommitmentID={1}&TaskPaneList={2}&MasterPageFile={3}&Theme={4}&SOURCEATTRIBUTES={5}&AccessMode={6}&BREADCRUMBNAME={7}&BREADCRUMBID={8}&BREADCRUMBXML={9}&PARENTBREADCRUMBNAME={10}&IsCustomized={11}&SelectedTabName=Approvals&CommitmentAccess={12}&CommitmentMode={13}", SolutionName, CommitmentID, TaskPaneList, MasterPageFile, str_Theme, SourceAttributes, AccessMode, BreadcrumbName, BreadcrumbID, BreadcrumbXML, str_ParentBreadCrumbName, IsCustomized,CommitmentAccess,CommitmentMode);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ModifyJobURL.ToString());
                    AB_ReadOnlyJob.AddAttributes("btn_ModifyJob", "href", EncryptURL);

                    //DoneButtonURL = new StringBuilder();

                    //if(Mode.ToUpper() == "APPROVE")
                    //{
                    //    DoneButtonURL.AppendFormat("Approvals_ApproveList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&Mode={4}&SolutionDisplayName={5}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Mode, Server.UrlEncode(Str_SolutionDisplayName));
                    //    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(DoneButtonURL.ToString());
                    //}
                    //else if(Mode.ToUpper() == "ROUTE")
                    //{
                    //    DoneButtonURL.AppendFormat("Approvals_JobList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&Mode={4}&Access={5}&SolutionDisplayName={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Mode, Access, Server.UrlEncode(Str_SolutionDisplayName));
                    //    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(DoneButtonURL.ToString());
                    //}

                    SetDoneBtnURL();
                  //  AB_ReadOnlyJob.AddAttributes("btn_Done", "href", EncryptURL);
                    AB_ReadOnlyJob.Click +=new EventHandler(AB_ReadOnlyJob_Click);

                    CommitmentBreadcrumb = (ALBreadCrumb)this.Page_CreatePage.FindControl("CommitmentBreadcrumb");
                    CommitmentBreadcrumb.TenantName = ALParamObj.TenantName;
                    this.CommitmentBreadcrumb.ParentBreadcrumbName = BreadcrumbName;
                    if (!String.IsNullOrEmpty(BreadcrumbID))
                    {
                        CommitmentBreadcrumb.ParentBreadcrumbName = BreadcrumbName;
                        CommitmentBreadcrumb.BreadcrumbUniqueID = BreadcrumbID;
                    }
                    else
                    {
                        CommitmentBreadcrumb.ParentBreadcrumbName = BreadcrumbName;
                    }

                    if (String.IsNullOrEmpty(BreadcrumbID) && (!String.IsNullOrEmpty(BreadcrumbXML)) && (System.IO.File.Exists(BreadcrumbXML)))
                    {
                        str_BreadcrumbXML = System.IO.File.ReadAllText(BreadcrumbXML);
                        this.CommitmentBreadcrumb.InputXml = str_BreadcrumbXML;
                        BreadcrumbID = CommitmentBreadcrumb.BreadcrumbUniqueID;
                    }
                    if (!IsPostBack)
                    {
                        this.CommitmentBreadcrumb.NavigateUrl = this.Request.Url.AbsoluteUri;
                    }
                    //this.CommitmentBreadcrumb.DisplayText = CommitmentTitle;
                    
                   // CommitmentBreadcrumb.NavigateUrl = GetROCommitmentPageURL();
                    
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "setControls", ExceptionObject, null, "Exception while setting the controls.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }
          
            private void setPageInROMode()
            {
                ApprovalsFacadeClass     ApprovalsFacadeObj  = null; 
                FormFacade               FormFacadeObj       = null;
                StringBuilder            AssociationXML      = null;
                StringBuilder            FormDataXML         = null;
                XML                      ReturnJobXML        = null;
                XML                      FormInputXML        = null;
                ERRORXML                 ErrorXML            = null;
                String                   FormConfigXMLPath   = null;
                String                   JobName             = null;
                String                   ErrorPageURL        = null;
                String                   str_FileName        = null;
                StringBuilder            TempFilePath        = null;
                XmlDocument              InputXMLDoc         = null;
                XmlDocument              FormInputXMLDoc     = null;
                XmlNode                  FieldNode           = null; 
                XmlNode                  WorkflowProcessNode = null;
                XmlNode                  WorkflowInfoNode    = null;
                XmlNode                  ReadersNode         = null;
                XmlNode                  WFProcessInfoNode   = null; 
                XmlNode                  JobInitiatorNode    = null;
                XmlNode                  node_ReviewStatus   = null; 
                XmlNode            	     FileNameNode        = null;
                ulong                    ErrorID			 = 0;
                CommonFunctions          obj_CommonFunctions = null;
                String                  str_AssociatedFacets = null;

                try
                {
                    AssociationXML = new StringBuilder();
                    TempFilePath   = new StringBuilder();

                    TempFilePath.AppendFormat("{0}{1}", TempPath, Approvals_Job_StateFile);
                    ErrorXML = getAssociatedAdditionalFacets(out str_AssociatedFacets);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='FALSE'>" + str_AssociatedFacets);
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                    }
                            AssociationXML.Append(@"<READERS Type='RELATION'>
		                                                <LOGINNAME/>
		                                                <FIRSTNAME/>
		                                                <MIDDLEINITIAL/>
		                                                <LASTNAME/>
		                                                <EMAILID/>
	                                                </READERS>
	                                                <APPROVALS_JOBINITIATOR Type='RELATION'>
		                                                <LOGINNAME/>
		                                                <FIRSTNAME/>
		                                                <MIDDLEINITIAL/>
		                                                <LASTNAME/>
		                                                <EMAILID/>
	                                                </APPROVALS_JOBINITIATOR>                                                 
                                                    <WORKFLOWPROCESS_MEDIATOPIC Type='RELATION'>
                                                        <TOPICID/>
                                                    </WORKFLOWPROCESS_MEDIATOPIC>
                                                </ASSOCIATION>");

                    ApprovalsFacadeObj = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXML = ApprovalsFacadeObj.GetApprovalsJob(JobProcessID, null, AssociationXML.ToString(), out ReturnJobXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        InputXMLDoc = new XmlDocument();
                        InputXMLDoc.LoadXml(ReturnJobXML);
                        InputXMLDoc.Save(TempFilePath.ToString());

                        WorkflowProcessNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS");

                        FileNameNode = WorkflowProcessNode.SelectSingleNode("FILESYSTEM/FILE/NAME");
                        if (FileNameNode != null)
                        {
                            obj_CommonFunctions = new CommonFunctions(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            str_FileName = FileNameNode.InnerText;
                            IsMediaFileForApproval = obj_CommonFunctions.IsMediaFile(str_FileName,"Approvals", ref IsVideoOnly);

                            String PDFProcessor = CheckPDFProcessorRequired(InputXMLDoc);

                            IsMediaFileForApproval = (PDFProcessor.ToUpper() == "ASSETLINK PROPRIETARY");

                            if (WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_MEDIATOPIC/TOPIC/TOPICID") != null)
                                MediaTopicID = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_MEDIATOPIC/TOPIC/TOPICID").InnerText;
                        }

                        JobName = WorkflowProcessNode.SelectSingleNode("PROCESSNAME").InnerText;
                        CommitmentBreadcrumb.DisplayText = Server.UrlDecode(JobName);
                        //Get the Package Definition and Process Definition id's
                        WFProcessInfoNode = WorkflowProcessNode.SelectSingleNode("PROCESS_INFORMATION/WORKFLOWPROCESSINFO");
                        if (WFProcessInfoNode != null)
                        {
                            __PackageDefinitionID.Value = WFProcessInfoNode.SelectSingleNode("PACKAGEDEFINITIONID").InnerText;
                            __ProcessDefinitionID.Value = WFProcessInfoNode.SelectSingleNode("PROCESSDEFINITIONID").InnerText;
                        }
                        FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        //FormConfigXMLPath = ApprovalsFacadeObj.GetFormConfigXMLPath(SolutionName, "Approvals_JobDetails", JobName);
                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        
                        FormFacadeObj.ConfigurationXML  = FormConfigXMLPath;
                        FormFacadeObj.FormName          = "Approvals_JobDetails";
                        FormFacadeObj.SolutionName      = SolutionName;

                        FormDataXML                         = new StringBuilder();
                        FormDataXML.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", WorkflowProcessNode.OuterXml);
                        ErrorXML                            = FormFacadeObj.GetFormInputXML("ReadOnly", FormDataXML.ToString(), out FormInputXML, out ObjInfoList);
                        FRM_ReadOnlyJob.InputXML            = FormInputXML;
                        FRM_ReadOnlyJob.ConfigurationXML    = FormConfigXMLPath;
                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        
                        FormFacadeObj                       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        FormFacadeObj.FormName              = "JobAdvancedDetails";
                        FormFacadeObj.SolutionName          = SolutionName;
                        FormFacadeObj.ShowConfiguredFields  = false;
                        FormInputXML                        = null;

                        FormDataXML                         = new StringBuilder();
                        FormDataXML.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", WorkflowProcessNode.OuterXml);
                        ErrorXML                            = FormFacadeObj.GetFormInputXML("ReadOnly", FormDataXML.ToString(), out FormInputXML, out ObjInfoList);
                        FormInputXMLDoc                     = new XmlDocument();
                        FormInputXMLDoc.LoadXml(FormInputXML);
                        
                        //apply percentdone class
                        ApplyPercentDoneClass(WorkflowProcessNode.SelectSingleNode("STATUS").InnerText, InputXMLDoc, ref FormInputXML);

                        if (WorkflowProcessNode.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE")
                        {
                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALDUEDATE']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_REVIEWSTATUS']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }

                        }
                        else
                        {
                            node_ReviewStatus = WorkflowProcessNode.SelectSingleNode("REVIEWSTATUS");
                            if ((node_ReviewStatus == null) || (String.IsNullOrEmpty(node_ReviewStatus.InnerText)))
                            {
                                FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_REVIEWSTATUS']");
                                if (FieldNode != null)
                                {
                                    if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                    else
                                        FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                                }
                            }
                        }

                        if (FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWINFORMATION_ROUTEMETHOD']") != null)
                        {
                            XmlNode ValueNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWINFORMATION_ROUTEMETHOD']/Value");
                            String str_RouteMethod = ValueNode.InnerText;
                            if (String.Compare(str_RouteMethod, "SIMULTANEOUS", true) == 0)
                                ValueNode.InnerText = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_Simultaneous_Shared");
                            else if (String.Compare(str_RouteMethod, "SEQUENTIAL", true) == 0)
                                ValueNode.InnerText = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_Sequential_Shared");
                        }
                        FRM_JobAdvDetails.ConfigurationXMLType = CustomControls.Form.InputType.XMLPath;
                        FRM_JobAdvDetails.ConfigurationXML = FormConfigXMLPath;
                        FormInputXML                        = FormInputXMLDoc.OuterXml;
                        FRM_JobAdvDetails.InputXML          = FormInputXML;

                        //Show Revision Number
                        WorkflowInfoNode = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
                        if (WorkflowInfoNode != null)
                        {
                            __RevisionNumber.Value = WorkflowInfoNode.SelectSingleNode("REVISIONNUMBER").InnerText;

                            __ApprovalsJobID.Value = WorkflowInfoNode.SelectSingleNode("APPROVALSJOBID").InnerText;
                        }

                        //Paint the Readers.
                        ReadersNode = WorkflowProcessNode.SelectSingleNode("READERS");
                        setReadersSelectionControl(ReadersNode);

                        //Paint the Task Initiator.
                        JobInitiatorNode = WorkflowProcessNode.SelectSingleNode("APPROVALS_JOBINITIATOR");
                        if ((JobInitiatorNode != null) && (JobInitiatorNode.HasChildNodes))
                        {
                            setJobInitiatorControl(JobInitiatorNode);
                        }

                        //Paint Approvals Widget
                        setApprovalsWidget(WorkflowProcessNode);

                        setApprovalsJobActionBar(Mode, WorkflowProcessNode, null);

                        //Hide revision list if no revisions present
                        if (Convert.ToUInt16( __RevisionNumber.Value) < 2)
                        {
                            LC_Prev_Revision.Visible = false;
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, "Error while getting Approvals Job.", null, GetBackUrl(), ref ErrorPageURL);
                        Response.Redirect(ErrorPageURL, true);   
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "setPageInROMode", ExceptionObject, null, "Exception while setting page in read only mode.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Response.Redirect(ErrorPageURL);
                }
            }
            
            private void ApplyPercentDoneClass(String JobStatus, XmlDocument InputXMLDoc, ref String FormInputXML)
            {
                XmlDocument                 FormXMLDoc          = null;
                XmlNode                     FieldNode           = null;
                XmlNode                     DueDateNode         = null;
                String                      PercentDoneClass    = null;
                DateTime                    DueDate;
                MktgWorkBenchFacadeClass    MWBFacadeObject     = null;
	            ulong			            ErrorID				= 0;
                String                      ErrorPageURL        = null;

                try
                {
                    FormXMLDoc = new XmlDocument();
                    FormXMLDoc.LoadXml(FormInputXML);

                    if (JobStatus.ToUpper() != "NEW" && JobStatus.ToUpper() != "DRAFT")
                    {
                        DueDate = DateTime.Today;

                        DueDateNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DUEDATE");
                        DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESSINFO_PERCENTDONE_PROCESS_INFORMATION']");

                        MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(JobStatus, DueDate);

                        //Pravin
                        //Approval Smart changes 
                        //Percent done is not shown on the screen
                        ((XmlElement)FieldNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                        FormInputXML = FormXMLDoc.OuterXml;
                    }
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "ApplyPercentDoneClass", ExceptionObj, null, "Exception while applying percent done class.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObj.Message, null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            private void setJobInitiatorControl(XmlNode JobInitiatorNode)
            {
                StringBuilder PrevSelectedUserXML = null;

                try
                {
                    PrevSelectedUserXML = new StringBuilder();

                    if (JobInitiatorNode != null)
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList>{0}</SelectedUsersList></UserSelectionXML>", JobInitiatorNode.InnerXml);
                    else
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList></SelectedUsersList></UserSelectionXML>");

                    UC_JobInitiator.TenantName          = ALParamObj.TenantName;
                    UC_JobInitiator.SessionID           = ALParamObj.SessionID;
                    UC_JobInitiator.UserID              = ALParamObj.UserID;
                    UC_JobInitiator.Language            = ALParamObj.Language;
                    UC_JobInitiator.InstanceName        = "Approvals_JobInitiator";
                    UC_JobInitiator.Layout              = "SIMPLE";
                    UC_JobInitiator.Mode                = "READONLY";
                    UC_JobInitiator.SolutionName        = SolutionName;
                    UC_JobInitiator.ConfigListName      = "ReadersList";
                    UC_JobInitiator.OnlyUserIDs         = "FALSE"; 
                    UC_JobInitiator.PrevSelectedUserXML = PrevSelectedUserXML.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            private void setReadersSelectionControl(XmlNode ReadersNode)
            {
                StringBuilder PrevSelectedUserXML = null;
                try
                {
                    PrevSelectedUserXML = new StringBuilder();
                    if (ReadersNode != null)
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList>{0}</SelectedUsersList></UserSelectionXML>", ReadersNode.InnerXml);
                    else
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList></SelectedUsersList></UserSelectionXML>");

                    UC_ReadersSelection.TenantName          = ALParamObj.TenantName;
                    UC_ReadersSelection.SessionID           = ALParamObj.SessionID;
                    UC_ReadersSelection.UserID              = ALParamObj.UserID;
                    UC_ReadersSelection.Language            = ALParamObj.Language;
                    UC_ReadersSelection.InstanceName        = "ApprovalJob_Readers";
                    UC_ReadersSelection.Layout              = "SIMPLE";
                    UC_ReadersSelection.Mode                = "READONLY";
                    UC_ReadersSelection.SolutionName        = SolutionName;
                    UC_ReadersSelection.ConfigListName      = "ReadersList";
                    UC_ReadersSelection.OnlyUserIDs         = "FALSE";
                    UC_ReadersSelection.PrevSelectedUserXML = PrevSelectedUserXML.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void SetAndRefreshControl(List<String> ControlHierarchy)
            {
                for (int index = 0; index < ControlHierarchy.Count; index++)
                {
                    if (index == 0)
                        ControlToRefresh = ALFindControl((Control)Page, ControlHierarchy[index]);
                    else
                        ControlToRefresh = ALFindControl(ControlToRefresh, ControlHierarchy[index]);
                }
            }

            private Control ALFindControl(Control SourceControl, String ID)
            {
                Control Ctrl = null;
                Ctrl = SourceControl.FindControl(ID);
                if (Ctrl == null)
                {
                    for (int i = 0; i < SourceControl.Controls.Count; i++)
                    {
                        Ctrl = ALFindControl(SourceControl.Controls[i], ID);
                        if (Ctrl != null)
                            break;
                    }
                }
                return Ctrl;
            }

            private void UpdateApprovalsFormXML(out String JobStatus)
            {
                StringBuilder            AssociationXML      = null;
                ApprovalsFacadeClass     ApprovalsFacadeObj  = null; 
                ERRORXML                 ErrorXML            = null;
                XmlDocument              InputXMLDoc         = null;
                XmlDocument              FormInputXMLDoc     = null; 
                XmlNode                  WorkflowProcessNode = null;
                XmlNode                  FieldNode           = null; 
                XmlNode                  node_ReviewStatus   = null; 
                MWB_Helper               MWBHelperClassObj   = null;
                String                   JobName             = null;
                String                   FormConfigXMLPath   = null;
                String                   FormInputXML        = null;
                XML                      ReturnJobXML        = null;
                FormFacade               FormFacadeObj       = null;
                StringBuilder            FormDataXML         = null;

                try
                {
                    JobStatus = null;
                    AssociationXML = new StringBuilder();
                    

                    ApprovalsFacadeObj = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    
                    if (ViewState["ProcessAssociatedFacets"] != null)
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='FALSE'>" + ViewState["ProcessAssociatedFacets"].ToString() + "</ASSOCIATION>");
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE' />");
                    }
                    ErrorXML = ApprovalsFacadeObj.GetApprovalsJob(JobProcessID, null, AssociationXML.ToString(), out ReturnJobXML);
                    if (ErrorXML == null)
                    {
                        InputXMLDoc = new XmlDocument();
                        InputXMLDoc.LoadXml(ReturnJobXML);

                        WorkflowProcessNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS");
                        JobStatus           = WorkflowProcessNode.SelectSingleNode("STATUS").InnerText;
                        FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                        MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        JobName = WorkflowProcessNode.SelectSingleNode("PROCESSNAME").InnerText;
                        if (IsCustomized)
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = FormFacadeObj.GetConfigurationXMLPath("", WidgetName, "Approvals_JobDetails_FormConfiguration");
                        }
                        
                        FormFacadeObj.ConfigurationXML          = FormConfigXMLPath;
                        FormFacadeObj.FormName                  = "Approvals_JobDetails";
                        FormFacadeObj.SolutionName              = SolutionName;

                        FormDataXML                             = new StringBuilder();
                        FormDataXML.Append("<WORKFLOWPROCESSCOLLECTION>" + WorkflowProcessNode.OuterXml + "</WORKFLOWPROCESSCOLLECTION>");
                        ErrorXML                                = FormFacadeObj.GetFormInputXML("ReadOnly", FormDataXML.ToString(), out FormInputXML, out ObjInfoList);
                        FRM_ReadOnlyJob.ConfigurationXMLType    = CustomControls.Form.InputType.XMLPath;
                        FRM_ReadOnlyJob.ConfigurationXML        = FormConfigXMLPath;
                        FRM_ReadOnlyJob.InputXML                = FormInputXML;


                        if (IsCustomized)
                        {
                            FormConfigXMLPath = ApprovalsFacadeObj.GetConfigurationXMLPath(SolutionName, WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        else
                        {
                            FormConfigXMLPath = ApprovalsFacadeObj.GetConfigurationXMLPath("", WidgetName, "JobAdvancedDetails_FormConfiguration");
                        }
                        FormFacadeObj                       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        FormFacadeObj.ConfigurationXML      = FormConfigXMLPath;
                        FormFacadeObj.FormName              = "JobAdvancedDetails";
                        FormFacadeObj.SolutionName          = SolutionName;
                        FormFacadeObj.ShowConfiguredFields  = false;
                        FormInputXML                        = null;

                        FormDataXML                         = new StringBuilder();
                        FormDataXML.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", WorkflowProcessNode.OuterXml);
                        ErrorXML                            = FormFacadeObj.GetFormInputXML("ReadOnly", FormDataXML.ToString(), out FormInputXML, out ObjInfoList);
                        FormInputXMLDoc                     = new XmlDocument();
                        FormInputXMLDoc.LoadXml(FormInputXML);

                        //apply percentdone class
                        ApplyPercentDoneClass(WorkflowProcessNode.SelectSingleNode("STATUS").InnerText, InputXMLDoc, ref FormInputXML);

                        if (WorkflowProcessNode.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE")
                        {
                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALDUEDATE']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }
                            FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_REVIEWSTATUS']");
                            if (FieldNode != null)
                            {
                                if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                else
                                    FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                            }
                        }
                        else
                        {
                            node_ReviewStatus = WorkflowProcessNode.SelectSingleNode("REVIEWSTATUS");
                            if ((node_ReviewStatus == null) || (String.IsNullOrEmpty(node_ReviewStatus.InnerText)))
                            {
                                FieldNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_REVIEWSTATUS']");
                                if (FieldNode != null)
                                {
                                    if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                    else
                                        FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                                }
                            }
                        }

                        if (FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWINFORMATION_ROUTEMETHOD']") != null)
                        {
                            XmlNode ValueNode = FormInputXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWINFORMATION_ROUTEMETHOD']/Value");
                            String str_RouteMethod = ValueNode.InnerText;
                            if (String.Compare(str_RouteMethod, "SIMULTANEOUS", true) == 0)
                                ValueNode.InnerText = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_Simultaneous_Shared");
                            else if (String.Compare(str_RouteMethod, "SEQUENTIAL", true) == 0)
                                ValueNode.InnerText = Localization.GetString("ALResource", ALParamObj.TenantName, "Approvals_Sequential_Shared");
                        }

                        FormInputXML                            = FormInputXMLDoc.OuterXml;
                        FRM_JobAdvDetails.ConfigurationXMLType = CustomControls.Form.InputType.XMLPath;
                        FRM_JobAdvDetails.ConfigurationXML      = FormConfigXMLPath;
                        FRM_JobAdvDetails.InputXML              = FormInputXML;

                      
                        if ((JobStatus.ToUpper() == "COMPLETED") || (JobStatus.ToUpper() == "CANCELLED"))
                        {
                          setApprovalsJobActionBar(Mode, WorkflowProcessNode, null);
                        }
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setApprovalsWidget(XmlNode WorkflowProcessNode)
            {
                String                      ApprovalsMode           = null;
                String                      AttachmentsRequired     = null;
                String                      str_DocumentRequired    = null; 
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null; 

                try
                {
                    MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    ApprovalsMode = WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/ROUTEMETHOD").InnerText;

                    Approvals_WidgetControl.SessionID                               = ALParamObj.SessionID;
                    Approvals_WidgetControl.UserID                                  = ALParamObj.UserID;
                    Approvals_WidgetControl.TenantName                              = ALParamObj.TenantName;
                    Approvals_WidgetControl.Language                                = ALParamObj.Language;
                    Approvals_WidgetControl.SolutionName                            = SolutionName;
                    Approvals_WidgetControl.WidgetName                              = "PM_APPROVALSWIDGET";
                    Approvals_WidgetControl.ProcessID                               = JobProcessID;
                    Approvals_WidgetControl.DefaultScreenName                       = "APPROVALS_READONLY";
                    Approvals_WidgetControl.Access                                  = Access;
                    Approvals_WidgetControl.IsTaskInitiatorLoggedIn                 = true;
                    Approvals_WidgetControl.show_JobMode                            = false;
                    Approvals_WidgetControl.FileforApprovalSection_TitleBarVisible  = false;
                    //Approvals_WidgetControl.
                    MktgWorkBenchFacadeObj.ReadSolutionConfiguration(SolutionName, "DOCUMENTREQUIRED", out str_DocumentRequired);
                    if ((!String.IsNullOrEmpty(str_DocumentRequired)) && (str_DocumentRequired.ToUpper() == "NO"))
                    {
                        Approvals_WidgetControl.DocumentRequired = false;
                    }
                    else
                    {
                        Approvals_WidgetControl.DocumentRequired = true;
                    }
                    ViewState["DocumentRequired"] = str_DocumentRequired;

                    //Read solution configuration XML for attachments required value
                    MktgWorkBenchFacadeObj.ReadSolutionConfiguration(SolutionName, "ATTACHMENTSREQUIRED", out AttachmentsRequired);
                    if ((!String.IsNullOrEmpty(AttachmentsRequired)) && (AttachmentsRequired.ToUpper() == "YES"))
                        Approvals_WidgetControl.AttachmentsRequired = true;
                    else
                        Approvals_WidgetControl.AttachmentsRequired = false;

                    if (ApprovalsMode.ToUpper() == "SIMULTANEOUS")
                    {
                        Approvals_WidgetControl.ApprovalsMode = ApprovalsWidget.ApprovalsModeType.SIMULTANEOUS;
                        __RouteMethod.Value = "SIMULTANEOUS";
                    }
                    else if (ApprovalsMode.ToUpper() == "SEQUENTIAL")
                    {
                        Approvals_WidgetControl.ApprovalsMode = ApprovalsWidget.ApprovalsModeType.SEQUENTIAL;
                        __RouteMethod.Value = "SEQUENTIAL";
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setApprovalsJobActionBar(String Mode, XmlNode WorkflowProcessNode, XPathNavigator WorkflowProcessNav)
            {
                StringBuilder   ActionBarXMLPath        = null;
                StringBuilder   ParameterList           = null;
                StringBuilder   DownLoadUrlPath         = null;
                XmlDocument     ActionBarXMLDoc         = null;
                XmlNode         ActionControlListNode   = null;
                XmlNode         FileNode                = null;
                XPathNavigator  FileNav                 = null;
                String          JobStatus               = null;
                String          InstalledPath           = null; 
                Boolean         ShowCreateRevisionBtn   = false;
                try
                {
                    InstalledPath = ALCommon.GetInstallationDir();

                    if (WorkflowProcessNode != null)
                        JobStatus = WorkflowProcessNode.SelectSingleNode("STATUS").InnerText;
                    else
                        JobStatus = WorkflowProcessNav.SelectSingleNode("STATUS").Value;

                    ActionBarXMLPath = new StringBuilder();
					ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName,SolutionName,WidgetName, "Approvals_ROJob_AB_ActionBar"));

                    ActionBarXMLDoc = new XmlDocument();
                    ActionBarXMLDoc.Load(ActionBarXMLPath.ToString());
                    ActionControlListNode = ActionBarXMLDoc.SelectSingleNode("ActionControlList");

                    if (Access.ToUpper() == "READ")
                    {
                        ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_TerminateJob']"));
                        ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ModifyJob']"));
                        //ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_CreateNewRevision']"));
                        if (JobStatus.ToUpper() != "COMPLETED")
                        {
                            ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ViewConsolidatedDocument']"));
                        }
                        else
                        {
                            if ((ViewState["DocumentRequired"] != null) && (!String.IsNullOrEmpty(ViewState["DocumentRequired"].ToString())) && (ViewState["DocumentRequired"].ToString().ToUpper() == "NO"))
                            {
                                ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ViewConsolidatedDocument']"));
                            }
                            else
                            {
                                if (IsMediaFileForApproval)
                                {
                                    StringBuilder sb_MediaFileConsildatedURL = new StringBuilder();                                    
                                    if (IsVideoOnly)
                                    {
                                        sb_MediaFileConsildatedURL.AppendFormat("/{0}/MarketingWorkBench/ASPX/ViewConsolidatedMediaFile.aspx?", ALParamObj.TenantName);
                                        sb_MediaFileConsildatedURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&TopicID={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, MediaTopicID);
                                    }
                                    else
                                    {
                                        sb_MediaFileConsildatedURL.AppendFormat("/{0}/Widgets/PM_ApprovalsWidget/ASPX/ShowMediaFile.aspx?", ALParamObj.TenantName);
                                        sb_MediaFileConsildatedURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&MediaTopicID={4}&Mode=ReadOnly&IsVideoOnly={5}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, MediaTopicID, IsVideoOnly.ToString());
                                    }
                                    
                                    StringBuilder sb_JavaScript = new StringBuilder();
                                    sb_JavaScript.AppendFormat("javascript:OpenNewWindow('{0}','MediaFileConsolidated','left=100,top=100,resizable=1,width=800,height=550,scrollbars=yes');", ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_MediaFileConsildatedURL.ToString()));
                                    AB_ReadOnlyJob.AddAttributes("btn_ViewConsolidatedDocument", "href", sb_JavaScript.ToString());
                                }
                                else
                                {
                                    if (WorkflowProcessNode != null)
                                        FileNode = WorkflowProcessNode.SelectSingleNode("FILESYSTEM/FILE[FIELDNAME='CONSOLIDATEDFILE']");
                                    else
                                        FileNav = WorkflowProcessNav.SelectSingleNode("FILESYSTEM/FILE[FIELDNAME='CONSOLIDATEDFILE']");

                                    if (FileNode != null)
                                    {
                                        ParameterList = new StringBuilder();
                                        ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=CONSOLIDATEDFILE&ObjectID={5}&FileName={6}&DownloadFileName={6}&SchemaID={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, FileNode.SelectSingleNode("OBJECTID").InnerText, Server.UrlEncode(FileNode.SelectSingleNode("NAME").InnerText), FileNode.SelectSingleNode("SCHEMAID").InnerText);
                                    }
                                    else if (FileNav != null)
                                    {
                                        ParameterList = new StringBuilder();
                                        ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=CONSOLIDATEDFILE&ObjectID={5}&FileName={6}&DownloadFileName={6}&SchemaID={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, FileNav.SelectSingleNode("OBJECTID").Value, Server.UrlEncode(FileNav.SelectSingleNode("NAME").Value), FileNav.SelectSingleNode("SCHEMAID").Value);
                                    }

                                    if (ParameterList != null)
                                    {
                                        DownLoadUrlPath = new StringBuilder();
                                        DownLoadUrlPath.AppendFormat("javascript:OpenNewWindow('/{1}/Common/ASPX/FileDownload.aspx?Param={0}','','')", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()),ALParamObj.TenantName);
                                        AB_ReadOnlyJob.AddAttributes("btn_ViewConsolidatedDocument", "href", DownLoadUrlPath.ToString());
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if ((JobStatus.ToUpper() != "ACTIVE") || (Mode.ToUpper() != "ROUTE"))
                        {
                            ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_TerminateJob']"));
                            ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ModifyJob']"));
                        }

                        if ((JobStatus.ToUpper() == "CANCELLED") && (Mode.ToUpper() == "ROUTE"))
                            ShowCreateRevisionBtn = true;

                        if (!ShowCreateRevisionBtn)
                        {
                            if ((JobStatus.ToUpper() == "COMPLETED") && (Mode.ToUpper() == "ROUTE"))
                                ShowCreateRevisionBtn = true;
                        }

                        //if (!ShowCreateRevisionBtn)
                        //    ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_CreateNewRevision']"));

                        if ((JobStatus.ToUpper() != "COMPLETED") || (Mode.ToUpper() != "ROUTE"))
                        {
                            ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ViewConsolidatedDocument']"));
                        }
                        else
                        {
                            if ((ViewState["DocumentRequired"] != null) && (!String.IsNullOrEmpty(ViewState["DocumentRequired"].ToString())) && (ViewState["DocumentRequired"].ToString().ToUpper() == "NO"))
                            {
                                ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ViewConsolidatedDocument']"));
                            }
                            else
                            {
                                if (IsMediaFileForApproval)
                                {
                                    StringBuilder sb_MediaFileConsildatedURL = new StringBuilder();
                                    if (IsVideoOnly)
                                    {
                                        sb_MediaFileConsildatedURL.AppendFormat("/{0}/MarketingWorkBench/ASPX/ViewConsolidatedMediaFile.aspx?", ALParamObj.TenantName);
                                        sb_MediaFileConsildatedURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&TopicID={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, MediaTopicID);
                                    }
                                    else
                                    {
                                        sb_MediaFileConsildatedURL.AppendFormat("/{0}/Widgets/PM_ApprovalsWidget/ASPX/ShowMediaFile.aspx?", ALParamObj.TenantName);
                                        sb_MediaFileConsildatedURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&MediaTopicID={4}&Mode=ReadOnly&IsVideoOnly={5}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, MediaTopicID, IsVideoOnly.ToString());
                                    } 
                                    StringBuilder sb_JavaScript = new StringBuilder();
                                    sb_JavaScript.AppendFormat("javascript:OpenNewWindow('{0}','MediaFileConsolidated','left=100,top=100,resizable=1,width=800,height=550,scrollbars=yes');", ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_MediaFileConsildatedURL.ToString()));
                                    AB_ReadOnlyJob.AddAttributes("btn_ViewConsolidatedDocument", "href", sb_JavaScript.ToString());
                                }
                                else
                                {
                                    if (WorkflowProcessNode != null)
                                        FileNode = WorkflowProcessNode.SelectSingleNode("FILESYSTEM/FILE[FIELDNAME='CONSOLIDATEDFILE']");
                                    else
                                        FileNav = WorkflowProcessNav.SelectSingleNode("FILESYSTEM/FILE[FIELDNAME='CONSOLIDATEDFILE']");

                                    if (FileNode != null)
                                    {
                                        ParameterList = new StringBuilder();
                                        ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=CONSOLIDATEDFILE&ObjectID={5}&FileName={6}&DownloadFileName={6}&SchemaID={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, FileNode.SelectSingleNode("OBJECTID").InnerText, Server.UrlEncode(FileNode.SelectSingleNode("NAME").InnerText), FileNode.SelectSingleNode("SCHEMAID").InnerText);
                                    }
                                    else if (FileNav != null)
                                    {
                                        ParameterList = new StringBuilder();
                                        ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=CONSOLIDATEDFILE&ObjectID={5}&FileName={6}&DownloadFileName={6}&SchemaID={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, FileNav.SelectSingleNode("OBJECTID").Value, Server.UrlEncode(FileNav.SelectSingleNode("NAME").Value), FileNav.SelectSingleNode("SCHEMAID").Value);
                                    }

                                    if (ParameterList != null)
                                    {
                                        DownLoadUrlPath = new StringBuilder();
                                        DownLoadUrlPath.AppendFormat("javascript:OpenNewWindow('/{1}/Common/ASPX/FileDownload.aspx?Param={0}','','')", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()),ALParamObj.TenantName);
                                        AB_ReadOnlyJob.AddAttributes("btn_ViewConsolidatedDocument", "href", DownLoadUrlPath.ToString());
                                    }
                                }
                            }
                        }
                    }
                    AB_ReadOnlyJob.InputXML = ActionBarXMLDoc.InnerXml;
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void CancelApprovalsJob()
            {
                StringBuilder               ProcessXML          = null;
                XML                         UpdateProcessXML    = null;
                ERRORXML                    ErrorXML            = null;
                ApprovalsFacadeClass        ApprovalsFacadeObj  = null; 
                ulong                       ErrorID             = 0;
                String                      ErrorPageURL        = null;
 
                try
                {
                    ProcessXML = new StringBuilder();
                    //HemantK: 19 Nov 2008:Put the review status as Cancelled
                    ProcessXML.Append(@"<WORKFLOWPROCESS>
                                            <WORKFLOWPROCESSID>" + JobProcessID + "</WORKFLOWPROCESSID>"
                                        + @"<STATUS>Cancelled</STATUS>
                                            <REVIEWSTATUS>Cancelled</REVIEWSTATUS>    
                                        </WORKFLOWPROCESS>");

                    UpdateProcessXML = ProcessXML.ToString();
                    
                    ApprovalsFacadeObj = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXML = ApprovalsFacadeObj.UpdateApprovalsJob(JobProcessID, false, MWB_TimeLineEvents.NONE, ref UpdateProcessXML); 
                    if (ErrorXML == null)
                    {
                        //ErrorXML = StampNotificationForApprovalsJob(JobProcessID, "JOB_CANCELLED");
                        //if (String.IsNullOrEmpty(ErrorXML))
                        //{
                            gotoApprovalsJobListPage();
                        //}
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "CancelApprovalsJob", ExceptionObj, null, "Exception while cancelling job.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObj.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }

            private void gotoApprovalsJobListPage()
            {
                StringBuilder   ParamURL	 = null;
                StringBuilder   URL			 = null;
                String          EncryptURL	 = null;
			    ulong			ErrorID		 = 0;
                String          ErrorPageURL = null;

                try
                {
                    ParamURL    = new StringBuilder();
                    URL         = new StringBuilder();
                    if (IsCustomized)
                        ParamURL.AppendFormat("/{0}/{1}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
                    else
                        ParamURL.AppendFormat("/{0}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName);

                    ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&AccessMode={10}&Mode={11}&BREADCRUMBNAME={12}&BREADCRUMBID={13}&BREADCRUMBXML={14}&IsCustomized={15}&Mode={16}&SelectedTabName=Approvals", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName, CommitmentID, TaskPaneList, MasterPageFile, str_Theme, SourceAttributes, CommitmentAccess, CommitmentMode, str_ParentBreadCrumbName, BreadcrumbID, BreadcrumbXML, IsCustomized, CommitmentMode);

                    EncryptURL  = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());

                }
                catch (Exception ExceptionObject)
                {
                    ErrorID     = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "gotoCommitmentROPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
              
            }

            private ERRORXML StampNotificationForApprovalsJob(String JobProcessID, String Event)
            {
                String              ContributorID           = null;
                String              JobScreenURL            = null;
                String              NotificationXML         = null;
                String              Duration                = null; 
                XML                 ErrorXML                = null;
                XML                 Active_ActivitiesXML    = null; 
                XML                 Cancelled_ActivitiesXML = null; 
                StringBuilder       TempFilePath            = null; 
                StringBuilder       Message                 = null;
                StringBuilder       Subject                 = null;
                StringReader        sr_ActivityXML          = null; 
                XPathDocument       xp_ActivityXMLDoc       = null; 
                XPathNavigator      Root_ActivityXMLDoc     = null; 
                XmlDocument         xp_JobXMLDoc            = null;    
                XPathNavigator      JobNavigator            = null;
                XPathNavigator      ActivityNav             = null;
                XPathNavigator      ContributorNav          = null;
                XPathNavigator      TempNavigator           = null; 
                XPathNavigator      DurationNavigator       = null; 
                XPathNodeIterator   ActiveActivities        = null; 
                NotificationHelper  NotificationHelperObj   = null;
                EmailChannel        EmailChannelObj         = null;
                XPathNodeIterator   FileSystemIterator      = null;
                MWB_Helper               MWB_HelperObj      = null; 
                NotificationFacadeClass NotificationFacadeObj = null;
                ApprovalsFacadeClass    ApprovalsFacadeObj  = null;
                PMFacadeClass           PMFacadeObj         = null; 
                ulong                   ErrorID             = 0;
                long                    RemainingMins       = 0;
                long                    ActivityDuration    = 0;
                String		            ErrorPageURL		= null;
                String                      str_AutoLoginRequired       = null;
                 String                     str_LoginName               = null;
                Boolean                     bl_AutoLoginRequired        = false;
                ALCommon                    ALCommonObj                 = null;
                try
                {
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    //Check AutoLogin required for email
                    ALCommonObj = new ALCommon();
                    ALCommonObj.GetTenantSetting(ALParamObj.TenantName, "CONFIGURATION/APPROVALSETTINGS/AUTOLOGINFOREMAIL", out str_AutoLoginRequired);
                    if ((!String.IsNullOrEmpty(str_AutoLoginRequired)))
                    {
                        Boolean.TryParse(str_AutoLoginRequired, out bl_AutoLoginRequired);
                    }

                    if (Event.ToUpper() == "JOB_CANCELLED")
                    {
                        //Get the Active Actities XML from the Widget
                        Active_ActivitiesXML = Approvals_WidgetControl.GetActiveActivitiesXML;
                        if (!String.IsNullOrEmpty(Active_ActivitiesXML))
                        {
                            //Load the Active Activities XML
                            sr_ActivityXML = new StringReader(Active_ActivitiesXML);
                            xp_ActivityXMLDoc = new XPathDocument(sr_ActivityXML);
                            Root_ActivityXMLDoc = xp_ActivityXMLDoc.CreateNavigator();

                            //Load the State file for the Job details
                            TempFilePath = new StringBuilder();
                            TempFilePath.AppendFormat("{0}{1}", TempPath, Approvals_Job_StateFile);

                            xp_JobXMLDoc = new XmlDocument();
                            xp_JobXMLDoc.Load(TempFilePath.ToString());
                            JobNavigator = xp_JobXMLDoc.CreateNavigator();

                            //Delete Filesystem node
                            FileSystemIterator = JobNavigator.Select("descendant::FILESYSTEM");
                            while (FileSystemIterator.MoveNext())
                            {
                                TempNavigator = FileSystemIterator.Current;
                                TempNavigator.DeleteSelf();
                                FileSystemIterator = JobNavigator.Select("descendant::FILESYSTEM");
                            }

                            ActiveActivities = Root_ActivityXMLDoc.Select("descendant::ACTIVITY");
                            if (ActiveActivities.Count > 0)
                            {
                                while (ActiveActivities.MoveNext())
                                {
                                    ActivityNav = ActiveActivities.Current;
                                    ContributorNav = ActivityNav.SelectSingleNode("descendant::ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER");
                                    if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                    {
                                        ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;

                                        NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                        NotificationHelperObj.Init("6503", ALParamObj.UserID);

                                        EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                        EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                        NotificationHelperObj.AddChannel(EmailChannelObj);
                                        Message = new StringBuilder();
                                        Message.Append("<MESSAGE Sender='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()));
                                        Message.Append("' Reciever='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav)));
                                        Message.Append("' >");
                                        Message.Append(JobNavigator.InnerXml);
                                        Message.Append("</MESSAGE>");

                                        Subject = new StringBuilder();
                                        Subject.Append("<SUBJECT>");
                                        Subject.Append(JobNavigator.InnerXml);
                                        Subject.Append("</SUBJECT>");
                                        str_LoginName = ContributorNav.SelectSingleNode("USER/LOGINNAME").Value;
                                        JobScreenURL  = ApprovalsFacadeObj.GetEmailScreenURL(SolutionName, Server.UrlEncode(Str_SolutionDisplayName),bl_AutoLoginRequired,str_LoginName, JobProcessID, "APPROVEREADONLY", ActivityNav.SelectSingleNode("ACTIVITYID").Value);

                                        ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                        ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                        ErrorXML = NotificationHelperObj.AddLink("JobScreenURL", JobScreenURL);

                                        ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                        if (ErrorXML == null && NotificationXML != null)
                                        {
                                            NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                            ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                            if (!String.IsNullOrEmpty(ErrorXML))
                                            {
                                                ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else if (Event.ToUpper() == "STEP_CANCELLED")
                    {
                        //Get the cancelled Actities XML from the Widget
                        Cancelled_ActivitiesXML = Approvals_WidgetControl.GetCurrentCancelledActivitiesXML;
                        if (!String.IsNullOrEmpty(Cancelled_ActivitiesXML))
                        {
                            //Load the Active Activities XML
                            sr_ActivityXML = new StringReader(Cancelled_ActivitiesXML);
                            xp_ActivityXMLDoc = new XPathDocument(sr_ActivityXML);
                            Root_ActivityXMLDoc = xp_ActivityXMLDoc.CreateNavigator();

                            //Load the State file for the Job details
                            TempFilePath = new StringBuilder();
                            TempFilePath.AppendFormat("{0}{1}", TempPath, Approvals_Job_StateFile);

                            xp_JobXMLDoc = new XmlDocument();
                            xp_JobXMLDoc.Load(TempFilePath.ToString());
                            JobNavigator = xp_JobXMLDoc.CreateNavigator();

                            //Delete Filesystem node
                            FileSystemIterator = JobNavigator.Select("descendant::FILESYSTEM");
                            while (FileSystemIterator.MoveNext())
                            {
                                TempNavigator = FileSystemIterator.Current;
                                TempNavigator.DeleteSelf();
                            }

                            ActiveActivities = Root_ActivityXMLDoc.Select("descendant::ACTIVITY");
                            if (ActiveActivities.Count > 0)
                            {
                                while (ActiveActivities.MoveNext())
                                {
                                    ActivityNav = ActiveActivities.Current;
                                    ContributorNav = ActivityNav.SelectSingleNode("descendant::ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER");
                                    if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                    {
                                        ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;

                                        NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                        NotificationHelperObj.Init("6504", ALParamObj.UserID);

                                        EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                        EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                        NotificationHelperObj.AddChannel(EmailChannelObj);
                                        Message = new StringBuilder();
                                        Message.Append("<MESSAGE Sender='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()));
                                        Message.Append("' Reciever='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav)));
                                        Message.Append("' >");
                                        Message.Append(JobNavigator.InnerXml);
                                        Message.Append("</MESSAGE>");

                                        Subject = new StringBuilder();
                                        Subject.Append("<SUBJECT>");
                                        Subject.Append(JobNavigator.InnerXml);
                                        Subject.Append("</SUBJECT>");

                                        str_LoginName = ContributorNav.SelectSingleNode("USER/LOGINNAME").Value;
                                        JobScreenURL  = ApprovalsFacadeObj.GetEmailScreenURL(SolutionName, Server.UrlEncode(Str_SolutionDisplayName),bl_AutoLoginRequired,str_LoginName, JobProcessID, "APPROVEREADONLY", ActivityNav.SelectSingleNode("ACTIVITYID").Value);

                                        ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                        ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                        ErrorXML = NotificationHelperObj.AddLink("JobScreenURL", JobScreenURL);

                                        ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                        if (ErrorXML == null && NotificationXML != null)
                                        {
                                            NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                            ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                            if (!String.IsNullOrEmpty(ErrorXML))
                                            {
                                                ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        Active_ActivitiesXML = Approvals_WidgetControl.GetActiveActivitiesXML;
                        if ((!String.IsNullOrEmpty(Active_ActivitiesXML)) && (__RouteMethod.Value.ToUpper() == "SEQUENTIAL"))  
                        {
                            //Load the Active Activities XML
                            sr_ActivityXML = new StringReader(Active_ActivitiesXML);
                            xp_ActivityXMLDoc = new XPathDocument(sr_ActivityXML);
                            Root_ActivityXMLDoc = xp_ActivityXMLDoc.CreateNavigator();

                            ActiveActivities = Root_ActivityXMLDoc.Select("descendant::ACTIVITY");
                            if (ActiveActivities.Count > 0)
                            {
                                while (ActiveActivities.MoveNext())
                                {
                                    ActivityNav = ActiveActivities.Current;
                                    ContributorNav = ActivityNav.SelectSingleNode("descendant::ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER");
                                    if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                    {
                                        ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;
                                        DurationNavigator = ActivityNav.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION");
                                        if (DurationNavigator != null)
                                        {
                                            Duration = DurationNavigator.Value;
                                            ActivityDuration = PMFacadeObj.ConvertMinutesToDays(Convert.ToInt64(Duration), out RemainingMins);
                                        }

                                        NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                        NotificationHelperObj.Init("6501", ALParamObj.UserID);

                                        EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                        EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                        NotificationHelperObj.AddChannel(EmailChannelObj);
                                        Message = new StringBuilder();
                                        Message.Append("<MESSAGE Sender='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()));
                                        Message.Append("' Reciever='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav)));
                                        Message.Append("' Duration='");
                                        Message.Append(ALCommon.TrimAndReplaceSpecialChars(ActivityDuration.ToString()));
                                        Message.Append("' >");
                                        Message.Append(JobNavigator.InnerXml);
                                        Message.Append("</MESSAGE>");

                                        Subject = new StringBuilder();
                                        Subject.Append("<SUBJECT>");
                                        Subject.Append(JobNavigator.InnerXml);
                                        Subject.Append("</SUBJECT>");
                                        str_LoginName = ContributorNav.SelectSingleNode("USER/LOGINNAME").Value;
                                        JobScreenURL  = ApprovalsFacadeObj.GetEmailScreenURL(SolutionName, Server.UrlEncode(Str_SolutionDisplayName),bl_AutoLoginRequired,str_LoginName, JobProcessID, "RESPONSE", ActivityNav.SelectSingleNode("ACTIVITYID").Value);

                                        ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                        ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                        ErrorXML = NotificationHelperObj.AddLink("JobScreenURL", JobScreenURL);

                                        ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                        if (ErrorXML == null && NotificationXML != null)
                                        {
                                            NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                            ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                            if (!String.IsNullOrEmpty(ErrorXML))
                                            {
                                                ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    return ErrorXML; 
                }
                catch(Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "StampNotificationForApprovalsJob", ExceptionObj, null, "Exception while sending notifications.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObj.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    return ErrorXML; 
                }
            }

            private void GetConsolidatedDocument()
            {
                MktgWorkBenchFacadeClass        MktgWBFacadeObj             = null;
                ApprovalsFacadeClass            ApprovalsFacadeObj          = null; 
                ERRORXML                        ErrorXML                    = null;
                String                          OutputXML                   = null;
                String                          ErrorPageURL                = null;
                StringBuilder                   AssociationXML              = null;
                StringBuilder                   AttributesXML               = null;
                StringBuilder                   ParameterList               = null;
                StringBuilder                   DownLoadUrlPath             = null;
                StringBuilder                   sb_MediaFileConsildatedURL  = null;
                StringReader                    String_Reader               = null;
                XPathDocument                   OutputXMLDoc                = null;
                XPathNavigator                  OutputXMLNav                = null;
                XPathNavigator                  WorkflowProcessNav          = null;
                XPathNavigator                  ConsolidatedFileNav         = null;

                try
                {
                    if (IsMediaFileForApproval)
                    {
                        sb_MediaFileConsildatedURL = new StringBuilder(100);
                        if (IsVideoOnly)
                        {
                            sb_MediaFileConsildatedURL.AppendFormat("/{0}/MarketingWorkBench/ASPX/ViewConsolidatedMediaFile.aspx?", ALParamObj.TenantName);
                            sb_MediaFileConsildatedURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&TopicID={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, MediaTopicID);
                        }
                        else
                        {
                            sb_MediaFileConsildatedURL.AppendFormat("/{0}/Widgets/PM_ApprovalsWidget/ASPX/ShowMediaFile.aspx?", ALParamObj.TenantName);
                            sb_MediaFileConsildatedURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&MediaTopicID={4}&Mode=ReadOnly&IsVideoOnly={5}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, MediaTopicID, IsVideoOnly.ToString());
                        }

                        Ajax.WriteExecuteJavaScript("OpenNewWindow('" + ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_MediaFileConsildatedURL.ToString()) + "','Media File Consolidated','left=100,top=100,resizable=1,width=800,height=550,scrollbars=yes');");

                        return; 
                    }

                    MktgWBFacadeObj     = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    ErrorXML = MktgWBFacadeObj.ConsolidateDocument(JobProcessID);
                    if (ErrorXML == null)
                    {
                        AttributesXML = new StringBuilder();
                        AttributesXML.Append(@"<WORKFLOWPROCESS>
	                                                <WORKFLOWPROCESSID/>
	                                                <STATUS/>
	                                                <CONSOLIDATEDFILE FileRequired='YES' TransferMode='SYNCHRONOUS'/>
                                                </WORKFLOWPROCESS>");

                        AssociationXML = new StringBuilder(50);
                        if (ViewState["ProcessAssociatedFacets"] != null)
                        {
                            AssociationXML.Append("<ASSOCIATION GetAllFacets='FALSE'>" + ViewState["ProcessAssociatedFacets"].ToString() + "</ASSOCIATION>");
                        }
                        else
                        {
                            AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE' />");
                        }

                        ErrorXML = ApprovalsFacadeObj.GetApprovalsJob(JobProcessID, AttributesXML.ToString(), AssociationXML.ToString(), out OutputXML);
                        if (ErrorXML == null)
                        {
                            String_Reader = new StringReader(OutputXML);
                            OutputXMLDoc = new XPathDocument(String_Reader);
                            OutputXMLNav = OutputXMLDoc.CreateNavigator();

                            WorkflowProcessNav = OutputXMLNav.SelectSingleNode("WORKFLOWPROCESS");
                            ConsolidatedFileNav = WorkflowProcessNav.SelectSingleNode("FILESYSTEM/FILE[FIELDNAME='CONSOLIDATEDFILE']");
                            if (ConsolidatedFileNav != null)
                            {
                                ParameterList = new StringBuilder();
                                DownLoadUrlPath = new StringBuilder();

                                ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=PROCESSFILE&ObjectID={5}&FileName={6}&DownloadFileName={6}&SchemaID={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.SolutionName, ALParamObj.Language, ConsolidatedFileNav.SelectSingleNode("OBJECTID").Value, Server.UrlEncode(ConsolidatedFileNav.SelectSingleNode("NAME").Value), ConsolidatedFileNav.SelectSingleNode("SCHEMAID").Value);
                                DownLoadUrlPath.AppendFormat("javascript:OpenNewWindow('/{1}/Common/ASPX/FileDownload.aspx?Param={0}','','')", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()),ALParamObj.TenantName);

                                Ajax.WriteExecuteJavaScript(DownLoadUrlPath.ToString());

                                setApprovalsJobActionBar(Mode, null, WorkflowProcessNav);
                            }
                            else
                            {
                                ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", null, "Consolidated file not found.", null, GetBackUrl(), ref ErrorPageURL);
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, "Error while getting Approvals Job.", null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, "Error in Consolidation.", null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }
        
            private void CreateRevision()
            {
                ERRORXML                ErrorXML                = null; 
                String                  NewApprovalsJobID       = null;
                String                  ErrorPageURL            = null;
                XPathDocument           xp_ErrorXML             = null;
                XPathNavigator          nav_ErrorCode           = null; 
                ApprovalsFacadeClass    ApprovalsFacadeObj      = null;
 
                try 
                {
                    //Call CreateRevisionEx() API from Approvals Engine
                    ApprovalsFacadeObj  = new ApprovalsFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXML = ApprovalsFacadeObj.CreateRevisionEX(__ApprovalsJobID.Value,  JobProcessID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, out NewApprovalsJobID);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        //Go to Edit Job Page
                        gotoApprovalsEditJobPage(NewApprovalsJobID);
                    }
                    else
                    {
                        xp_ErrorXML = new XPathDocument(new StringReader(ErrorXML));
                        nav_ErrorCode = xp_ErrorXML.CreateNavigator().SelectSingleNode("descendant::ERRORCODE");
                        if ((nav_ErrorCode != null) && (!String.IsNullOrEmpty(nav_ErrorCode.Value)) && (nav_ErrorCode.Value.ToUpper() == "APPROVALSENGINE_JOB_LASTREVISIONISNOTCOMPLETEORCANCELLED"))
                        {
                            Ajax.WriteExecuteJavaScript("alert('Last revision of this job is not completed or cancelled.')");
                            return;
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
	                throw(ExceptionObj);
                }
            }

            private void gotoApprovalsEditJobPage(String NewJobProcessID)
            {
                StringBuilder   ParamURL	= null;
                StringBuilder   URL			= null;
                String          EncryptURL	= null;
			    ulong			ErrorID		= 0;
                String          ErrorPageURL= null;

                try
                {
                    ParamURL    = new StringBuilder();
                    URL         = new StringBuilder();
                    ParamURL.AppendFormat("Approvals_EditJobDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&JobProcessID={4}&Mode=Route&Access=Write&SolutionDisplayName={5}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, NewJobProcessID, Server.UrlEncode(Str_SolutionDisplayName));
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "gotoApprovalsEditJobPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }

            private void gotoApprovalsROJobPage()
            {
                StringBuilder   ParamURL	= null;
                StringBuilder   URL			= null;
                String          EncryptURL	= null;
			    ulong			ErrorID		= 0;
                String          ErrorPageURL= null;

                try
                {
                    ParamURL    = new StringBuilder();
                    URL         = new StringBuilder();
                    ParamURL.Append("Commitment_Approvals_ROJobDetails.aspx?TenantName=" + ALParamObj.TenantName + "&Language=" + ALParamObj.Language + "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&JobProcessID=" + JobProcessID + "&Mode=" + Mode + "&Access=" + Access + "&SolutionDisplayName=" + Server.UrlEncode(Str_SolutionDisplayName) + "&BREADCRUMBNAME=" + BreadcrumbName + "&BREADCRUMBID=" + BreadcrumbID + "&BREADCRUMBXML =" + BreadcrumbXML + "&MasterPageFile=" + MasterPageFileName + "&CommitmentID=" + CommitmentID + "&TaskPaneList=" + TaskPaneList + "&Theme=" + str_Theme + "&SOURCEATTRIBUTES=" + SourceAttributes + "&CommitmentAccess=" + CommitmentAccess + "&CommitmentMode=" + CommitmentMode + "&CommitmentTitle=" + CommitmentTitle + "&IsCustomized=" + IsCustomized + "&ApprovalJobType=" + ApprovalJobType + "&PDFFilePath=" + PDFFilePath + "&SolutionName=" + SolutionName + "&PARENTBREADCRUMBNAME=" + str_ParentBreadCrumbName + "");
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "gotoApprovalsROJobPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                    ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }

            private string GetBackUrl()
            {
				StringBuilder ParamURL = null;
				try
				{

                    ParamURL = new StringBuilder();
                    if (IsCustomized)
                        ParamURL.AppendFormat("/{0}/{1}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
                    else
                        ParamURL.AppendFormat("/{0}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName);

                    ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&AccessMode={10}&BREADCRUMBNAME={11}&BREADCRUMBID={12}&BREADCRUMBXML={13}&IsCustomized={14}&SelectedTabName=Approvals&Mode={15}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName, CommitmentID, TaskPaneList, MasterPageFile, str_Theme, SourceAttributes, CommitmentAccess, str_ParentBreadCrumbName, BreadcrumbID, BreadcrumbXML, IsCustomized, CommitmentMode);
                    return ParamURL.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
            }

            /// <alsummary>
            /// <createddate>04 December 2007</createddate>
            /// <author>Bhalchandra</author>
            /// <purpose>To get the Approval Job's Package and Process ID.</purpose>
            /// </alsummary>
            private void getPackageProcessIDs()
            {
                ERRORXML                    ErrorXml                        = null;
                ulong                       ul_ErrorID                      = 0;
                String                      str_ErrorPage                   = null;
                String                      str_ReturnProjectXml            = null;
                StringBuilder               sb_SearchInputXml               = null;
                SearchConfiguration         obj_SearchConfig                = null;
                XPathDocument               xpathDoc_ProjectXml             = null;
                XPathNavigator              xpathNav_PackageDefinitionID    = null;
                XPathNavigator              xpathNav_ProcessDefinitionID    = null;

                try
                {
                    sb_SearchInputXml = new StringBuilder(1000);
                    sb_SearchInputXml.Append(@"<SEARCH>
                                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                 <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' Language='" + ALParamObj.Language + "' TenantName='" + ALParamObj.TenantName + "' UserID='" + ALParamObj.UserID + @"'></SESSIONINFO>
                                                <TARGETENTITY>
                                                    <SELECTLIST>
				                                        <EXPRESSION>
					                                           <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                               <ALIAS>WORKFLOWPROCESSID</ALIAS>
				                                         </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
		                                                <FILTER>
			                                                <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>" + JobProcessID + @"</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>
                                                    </FILTERLIST>
                                                    <RELATIONSHIP NAME='PROCESS_INFORMATION'>          
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>PROCESSDEFINITIONID</FIELDNAME>
                                                                <ALIAS>PROCESSDEFINITIONID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>PACKAGEDEFINITIONID</FIELDNAME>
                                                                <ALIAS>PACKAGEDEFINITIONID</ALIAS>
                                                            </EXPRESSION>
                                                     </SELECTLIST>
                                                    </RELATIONSHIP>
                                                </TARGETENTITY>
                                            </SEARCH>");
                    obj_SearchConfig    = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXml = obj_SearchConfig.GetHierarchialData(sb_SearchInputXml.ToString(), ref str_ReturnProjectXml);
                    if ((String.IsNullOrEmpty(ErrorXml)) && (!String.IsNullOrEmpty(str_ReturnProjectXml)))
                    {
                        xpathDoc_ProjectXml = new XPathDocument(new StringReader(str_ReturnProjectXml));
                        xpathNav_ProcessDefinitionID = xpathDoc_ProjectXml.CreateNavigator().SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID");
                        if (xpathNav_ProcessDefinitionID != null)
	                    {
                            __ProcessDefinitionID.Value = xpathNav_ProcessDefinitionID.Value;
	                    }

                        xpathNav_PackageDefinitionID = xpathDoc_ProjectXml.CreateNavigator().SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID");
                        if (xpathNav_ProcessDefinitionID != null)
	                    {
                            __PackageDefinitionID.Value = xpathNav_PackageDefinitionID.Value;
	                    }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "getPackageProcessIDs", obj_Exception, null, "Exception while getting projects ProcessDefinitionID and PackageDefitionID");
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", null, obj_Exception.Message, null, GetBackUrl(), ref str_ErrorPage);
                    Response.Redirect(str_ErrorPage);
                }
            }

            /// <alsummary>
            /// <createddate>04 December 2008</createddate>
            /// <author>Bhalchandra</author>
            /// <purpose>To get the approval job's associated additional facets.</purpose>
            /// </alsummary>
            private String getAssociatedAdditionalFacets(out String str_ProcessAssociatedFacets)
            {
                ERRORXML    ErrorXml                        = null;
                ulong       ul_ErrorID                      = 0;
                String      str_ErrorPage                   = null;
                String      str_ActivityAssociatedFacets    = null;
                MWB_Helper  obj_MWBHelper                   = null;
                

                try
                {
                    str_ProcessAssociatedFacets = "";
                        obj_MWBHelper   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        ErrorXml        = obj_MWBHelper.GetAssociatedAdditionalFacets(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, null, false,out str_ProcessAssociatedFacets, out str_ActivityAssociatedFacets);
                        if (String.IsNullOrEmpty(ErrorXml))
                        {
                            if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                            {
                                ViewState["ProcessAssociatedFacets"] = str_ProcessAssociatedFacets;
                            }
                        }
                    
                    return ErrorXml;
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "getAssociatedAdditionalFacets", obj_Exception, null, "Exception while getting Associated Additional Facets");
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "APPROVALSJOB", null, obj_Exception.Message, null, GetBackUrl(), ref str_ErrorPage);
                    Response.Redirect(str_ErrorPage);
                    str_ProcessAssociatedFacets = "";
                    return null;
                }
            }

            void GetTaskPanes()
        {
            try
            {
                Search searchControl = null;
                String[] TaskPaneSep = new String[1] { "$AL$" };
                LeftPaneFacade LFP = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName);
                ContentPlaceHolder LeftPane = (ContentPlaceHolder)this.Master.FindControl("Assetlink_LeftBarContentPlaceHolder");
                LeftPane.Controls.Clear();
                LeftPane.Controls.Add(new LiteralControl("<table width='100%' cellpadding='0' cellspacing='0'>"));
                if (!String.IsNullOrEmpty(TaskPaneList))
                {
                    String[] ListofTaskPanes = TaskPaneList.Split(TaskPaneSep, StringSplitOptions.RemoveEmptyEntries);

                    foreach (String strTaskPane in ListofTaskPanes)
                    {

                        char[] sep = new char[1] { '$' };
                        String[] TaskPaneAttrib = strTaskPane.Split(sep, StringSplitOptions.RemoveEmptyEntries);
                        if (!TaskPaneAttrib[0].Contains("SEARCHPANECONTROL_"))
                        {
                            LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                            TaskPane ctlTaskPane = new TaskPane();
                            ctlTaskPane.TaskPaneName = TaskPaneAttrib[0];
                            if (TaskPaneAttrib.Length > 1)
                            {
                                ctlTaskPane.SelectedSectionName = TaskPaneAttrib[1];
                            }
                            LeftPane.Controls.Add(ctlTaskPane);
                            LeftPane.Controls.Add(new LiteralControl("</td></tr>"));
                        }
                        else
                        {
                            //LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                            Search ctlTaskPane = new Search();
                            ctlTaskPane.SearchPaneName = TaskPaneAttrib[0].Replace("SEARCHPANECONTROL_", "");
                            if (TaskPaneAttrib.Length > 1)
                            {
                                ctlTaskPane.SelectedSectionName = TaskPaneAttrib[1];
                            }
                            searchControl = ctlTaskPane;
                            //LeftPane.Controls.Add(new LiteralControl("</tr></td>"));
                        }

                    }
                }
                //if (!string.IsNullOrEmpty(Status))
                //{
                //    if (!Status.ToUpper().Equals("CLOSED") && AccessMode.ToUpper().Equals("WRITE"))
                //    {
                //        LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                //        TaskPane EditCommitmentTaskPane = new TaskPane();
                //        EditCommitmentTaskPane.TaskPaneName = "EditCommitmentTaskPane";
                //        LeftPane.Controls.Add(EditCommitmentTaskPane);
                //        LeftPane.Controls.Add(new LiteralControl("</td></tr>"));        

                //    }
                //}
                //else
                //{
                //    if (!String.IsNullOrEmpty(AccessMode))
                //    {
                //        if (AccessMode.ToUpper().Equals("WRITE"))
                //        {
                //            LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                //            TaskPane EditCommitmentTaskPane = new TaskPane();
                //            EditCommitmentTaskPane.TaskPaneName = "EditCommitmentTaskPane";
                //            LeftPane.Controls.Add(EditCommitmentTaskPane);
                //            LeftPane.Controls.Add(new LiteralControl("</td></tr>"));
                //        }
                //    }
                //}
                if (searchControl != null)
                {
                    LeftPane.Controls.Add(new LiteralControl("<tr><td>"));
                    LeftPane.Controls.Add(searchControl);
                    LeftPane.Controls.Add(new LiteralControl("</td></tr>"));
                }
                LeftPane.Controls.Add(new LiteralControl("</table>"));
                LFP.GetTaskPaneNode(this.Page, UrlList);
            }
            catch (Exception obj_Exception)
            {
            }
        }

        private void SetDoneBtnURL()
        {
            StringBuilder ParamURL = null;
            StringBuilder URL = null;
            String EncryptURL = null;
            ulong ErrorID = 0;
            String ErrorPageURL = null;

            try
            {
                ParamURL = new StringBuilder();
                URL = new StringBuilder();
                if (IsCustomized)
                    ParamURL.AppendFormat("/{0}/{1}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
                else
                    ParamURL.AppendFormat("/{0}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName);

				ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&AccessMode={10}&BREADCRUMBNAME={11}&BREADCRUMBID={12}&BREADCRUMBXML={13}&IsCustomized={14}&Mode={15}&SelectedTabName=Approvals", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName, CommitmentID, TaskPaneList, MasterPageFile, str_Theme, SourceAttributes, CommitmentAccess, str_ParentBreadCrumbName, BreadcrumbID, BreadcrumbXML, IsCustomized,CommitmentMode);

                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                AB_ReadOnlyJob.AddAttributes("btn_Done", "href", EncryptURL);
             
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "gotoCommitmentROPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
            }
        }

        private String GetROCommitmentPageURL()
        {
             StringBuilder ParamURL = null;
            StringBuilder URL = null;
            String EncryptURL = null;
            ulong ErrorID = 0;
            String ErrorPageURL = null;

            try
            {
                ParamURL = new StringBuilder();
                URL = new StringBuilder();
                if (IsCustomized)
                    ParamURL.AppendFormat("/{0}/{1}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName, ALParamObj.SolutionName);
                else
                    ParamURL.AppendFormat("/{0}/Widgets/SP_CommitmentWidget/ASPX/Commitment_RO.aspx?", ALParamObj.TenantName);

                ParamURL.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&Language={3}&SolutionName={4}&Mode=Edit&CommitmentID={5}&TaskPaneList={6}&MasterPageFile={7}&Theme={8}&SOURCEATTRIBUTES={9}&AccessMode={10}&BREADCRUMBNAME={11}&BREADCRUMBID={12}&BREADCRUMBXML={13}&IsCustomized={14}&SelectedTabName=Approvals", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName, CommitmentID, TaskPaneList, MasterPageFile, str_Theme, SourceAttributes, AccessMode, str_ParentBreadCrumbName, BreadcrumbID, BreadcrumbXML, IsCustomized);

                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
               
                //if (!IsPostBack || (!(this.Page is ALAjaxPage)))
                //{
                //    Response.Redirect(EncryptURL);
                //}
                //else
                //{
                //    this.Ajax.WriteExecuteJavaScript("javascript:window.open('" + EncryptURL + "','_self','');");
                //    Ajax.WriteExecuteJavaScript(URL.ToString());
                //}
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Commitment_Approvals_ROJobDetails.aspx", "gotoCommitmentROPage", ExceptionObject, null, "Exception while going to Job List Screen.");
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "APPROVALSJOB", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
            }
            return EncryptURL;
        }

        private String CheckPDFProcessorRequired(XmlDocument ProcessXMLDocument)
        {

            XmlNode node_AnnotationMethod = null;

            node_AnnotationMethod = ProcessXMLDocument.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/ANNOTATIONMETHOD");

            if (node_AnnotationMethod != null)
            {
                return node_AnnotationMethod.InnerText.ToUpper();
            }
            //mudassar: this path shoould never be reached
            return "";            
        }
               
        #endregion
    }
}
