using System;
using System.Xml;
using System.Xml.XPath;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;



namespace Assetlink
{
    #region Classes for building Data Strucutre for N Level Search

    #region Classes for building Dynamic SQL .

    public class FieldCollection
    {
        public      String       m_FieldName                = null;     // Variable for storing FieldName of Entity/Facet Type.
        public      String      m_FieldDataType             = null;     // Variable for storing Field Datatype of Entity/Facet Type.
        public      String      m_Alias                     = null;     // Variable for storing Alias Name for FieldName of Entity/Facet Type.
        public      String      m_RelationshipName          = null;     // Variable for storing RelationshipName.
        public      bool        m_IsHidden                  = false;    // variable used for supporting GroupBy and Sorting
        public      String      m_StructureColumnName       = null;     // This variable stores Structure Name used for generating XML.
        public      bool        m_IsSortRequested           = false;    // boolean value which identifies whether Sort is requested or not.    
        public      String      m_SortType                  = null;     // Variable which will store SortType.  
        public      bool        m_IsPrimaryKey              = false;    // Variable which will store whether
        public      String      m_IsFileRequired            = "NO";     // Variable which stores information for FILE/BINDER whether file needs to be copied to OUTBOX
        public      String      m_TransferMode              = null;     // Variable which stores information for TransferMode i.e Synchronous or ASynchronous
        public      Int32       m_FieldSize                 = 0;        // Variable which stores FieldSize. This is required for TeraData while generating XML Structure.
        public      String      m_SchemaID                  = null;     // Data type is String bec we do not need to convert it later. 

    }

    public class AggregateAttributes
    {
        public      String      m_FieldName                 = null;     // Variable for storing FieldName on which Aggregate Function is requested.
        public      String      m_RelationshipName          = null;     // Variable for storing RelationshipName. 
        public      String      m_Alias                     = null;     // Variable for storing Alias Name for Aggregate Function Output.
        public      String      m_FunctionName              = null;     // variable for storing Aggregate function name
        public      bool        m_IsDistinct                = true;     // variable which stores whether is distinct is required. 
    }

    public class SortSpecification
    {
        public      Int32       m_SortSequence              = 0;       // Variable for storing Sort Sequence Number.
        public      String      m_SortFieldName             = null;    // Variable for storing FieldName on which Sort is requested.
        public      String      m_RelationshipName          = null;    // Variable for storing RelationshipName.
        public      String      m_SortOrder                 = null;    // Variable for storing SortOrder i.e ASC or DESC.
    }

    public class FilterCollection
    {
        public      String      m_FieldName                 = null;    // Variable for storing FieldName on which Filter is requested(Compulsory).
        public      String      m_Operator                  = null;    // Variable for storing Operator for Filter(Compulsory).
        public      String      m_FieldValue                = null;    // Variable for storing Filter Value(Compulsory).
        public      String      m_RelationshipName          = null;    // Variable for storing RelationshipName(Optional).
        public      bool        m_IsCaseSensitive           = false;   // variable for storing whether filter is case sensitive or not(Optional).
        public      String      m_IsParent                  = null;    // variable for storing which approach should be used ( i.e TOPDOWN or BOTTOMUP by default TOPDOWN approach is used).
        public      int         m_FilterID                  = 0;       // Variable for storing FilterID(Optional).
        public      XmlNode     m_XMLNode                   = null;    // Variable for storing DateNodeFilter.
        public      bool        m_IsProcessedForFilterCombination = false;//Has this filter been processed for making filter combination
        public      bool        m_IsINOptimized             = false;   //Stores whether IN was optimized for this filter. Numeric datatypes handled mostly

        public      List<String>      m_FieldValueParameterized   = null;    
        public      String      m_FieldDataType             = null;    // Variable for storing Filter Value(Compulsory).
        public      List<String> m_ParameterizedVariables = null;

        public FilterCollection()
        {
            m_FieldValueParameterized = new List<String>();
            m_ParameterizedVariables = new List<String>();
        }

    }

    public class GroupByExpression
    {
        public      String      Expression                  = null;    // Variable for storing GroupByExpression.
    }

    public class HierarchyObject 
    {
        public      long        m_TagID                 = 0;                        // Variable for storing UniqueID for Generating Structure table.
        public      String      m_CollectionName        = null;                     // Variable for storing CollectionName.
        public      long        m_ParentID              = 0;                        // Variable for storing ParentID for Generating Structure.
        public      String      m_RelationshipName      = null;                     // Variable for storing RelationshipName.
        public      String      m_TableName             = null;                     // Variable for storing Entity/facet table name.
        public      String      m_PrimaryKeyName        = null;                     // Variable for storing PrimaryKeyName for ENTITY/FACET type.
        public      String      m_PrivilegeLevel        = null;                     // Variable for storing requested PrivilegeLevel.
        public      String      m_ObjectType            = null;                     // Variable for storing ObjectType i.e ENTITY/FACET.    
        public      ulong       m_ObjectTypeID          = 0;                        // Variable for storing ObjectTypeID i.e ENTITY/FACET type ID.
        public      String      m_ObjectTypeName        = null;                     // Variable for storing ObjectTypeName.
        public      String      m_ObjectAliasName       = null;                     // Variable for storing Object's Alias Name specified by caller.
        public      String      m_FilterCombination     = null;                     // Variable for storing FilterCombination i.e (1(2))
        public      ulong       m_MaxResultSize         = 0;                        // Variable for storing MaxResultSize i.e (1(2))
        public      String      m_SimpleSearchString    = null;                     // Variable for storing Simple Search String.
        public      bool        m_IsRelatedEntity       = false;                    // variable for storing relationship type i.e whether its a related entity or related facet.
        public      ulong       m_RelationshipTypeID    = 0;                        // variable for storing relationshiptypeid 
        public      long        m_ActualTagID           = 0;
        public      String      m_ColumnList            = null;
        public      String      m_EveryOneUserTableName = null;
        public      String      m_PrimaryKeyforTableVariable = null;
        public      String      m_ContainerName         = null;
        public      bool        m_IsHierarchyObjectProcessed = false;
        public      SortedList  m_RelatedFacetTypes     = null;
        public      Boolean     m_IsSearch_In_All_Facets = false;
        public      Boolean     m_IsSearchAllFacets     = false;
        public      StringBuilder SimpleSearchQueryBuilder = null;
        public      Int32       m_RelatedObjectLevel    = 0;
        public      Int32       m_RelatedObjectNumber   = 0;
        public      Boolean     m_IsSimpleSearchCaseSensitive = false;
        public      long        m_ThresholdResultCount  = -1;
        public      Boolean     m_IsFileRequired        = false;
        public      Boolean     m_DoPaging              = false;
        public      Int32       m_PageNumber            = 1;
        public      Int32       m_RecordsPerPage        = 1;
        public      String      m_PagingSortField       = null;
        public      String      m_PagingSortFieldOrder  = "ASC";//Ascending or descending. Used for paging
        public      Boolean     m_IsFilterCombinationAdded = false;
        public      Boolean     m_IsSearchInDocuments   = false;
        public      StringBuilder DocumentSearchQueryBuilder = null;
        public      String      m_FileRelationships     = null; 

        // Lists for Objects
        public List<FieldCollection>        FieldCollectionList         = null;   // List for storing requested FieldCollection.
        public List<AggregateAttributes>    AggregateAttrList           = null;   // List for storing requested AggregateAttrList.
        public List<SortSpecification>      SortSpecificationList       = null;   // List for storing requested SortSpecificationList.
        public List<FilterCollection>       FilterCollectionList        = null;   // List for storing requested FilterCollectionList.
        public List<GroupByExpression>      GroupByExpressionList       = null;   // List for storing requested GroupByExpressionList.
        public List<FieldCollection>        CustomFieldCollectionList   = null;   // List for storing requested FieldCollection.

        public HierarchyObject()
        {
            FieldCollectionList         = new List<FieldCollection>();
            AggregateAttrList           = new List<AggregateAttributes>();
            SortSpecificationList       = new List<SortSpecification>();
            FilterCollectionList        = new List<FilterCollection>();
            GroupByExpressionList       = new List<GroupByExpression>();
            CustomFieldCollectionList   = new List<FieldCollection>();
        }

        public override string ToString()
        {
            return string.Format("({0}) {1}", m_TableName + m_ObjectTypeName);
        }
    }

    /// <summary>
    /// This class is required to maintain Relationship collection with RelationshipTypeId and Alias for Relationship
    /// </summary>
    public class RelationshipCollection
    {
        public      String          m_RelationshipName          = null;
        public      String          m_AssemblyAliasName         = null;
        public      ulong           m_RelationshionTypeId       = 0;
        
    }

    public class TableVariableCollection
    {
        public      String          m_TableVariableName         = null;
        public      String          m_Query                     = null;
        public      String          m_TableVariablePrimaryKey   = null;
        public      String          m_FilterID                  = null;
        public      bool            m_IsTableVariableInWhereClause = false;
    }

    #endregion

    #region Classes for building Sort Partition data structure.

    public class Predecessor
    {
        public      String          m_RelationshipName          = null;
        public      int             m_StartColumnNumber         = 0;
        public      int             m_NumberofFields            = 0;
        public      long            m_PredecessorID             = 0;
        public      long            m_SortPartitionID           = 0;  // This variable is used while preparing Select Clause for Sorting 
        public      Int32           m_RelatedObjectLevel        = 0;
    }

    public class SortPartitionColumnTagIDPair
    {
        public      long            TagID                       = 0;
        public      long            ParentID                    = 0;
        public      String          SortPartitionColumnName     = null;
        public      String          SortPartitionStructColumnName = null;

    }

    public class SortPartitionNamedValue
    {
        public      String          SortPartitionName           = null;
        public      String          SortPartitionValue          = null;
        public      String          SortPartitionType           = null;
    }

    public class Sibling : Predecessor
    {
        public int m_SortValue = 0;
    }

    public class SortPartition
    {
        public      long            m_NodeID                    = 0;
        public      long            m_ParentID                  = 0;
        public      int             m_StartColumnNumber         = 0;
        public      long            m_SortPartitionID           = 0;
        public      String          m_SortPartitionColumnName   = null;
        public      String          m_RelationshipName          = null;
        public      List<Sibling>   SiblingList                 = null;
        public      List<Predecessor> PredecessorList           = null;

        public SortPartition()
        {
            SiblingList = new List<Sibling>();
            PredecessorList = new List<Predecessor>();
        }
    }

    public class ConfigConstantAttributes
    {
        public static string ATTRIB_RECORDS_PER_PAGE    = "RecordsPerPage";
        public static string ATTRIB_PAGE_NUMBER         = "PageNumber";
    }

    public class NSearchCommon : AssetlinkBase
    {

        #region DataStructures for XML Generation

        public      Hashtable       m_TagObjectType         = new Hashtable();
        public      Hashtable       m_TagStartColumn        = new Hashtable();
        public      Hashtable       m_TagNumColumns         = new Hashtable();
        public      Hashtable       m_OrdinalColumn         = new Hashtable();
        public      Hashtable       m_OrdinalIsXML          = new Hashtable();
        public      int             m_StartColumn           = 0;

        #endregion

        #region Public Member Variables

        public      ulong               m_EveryOneUserID            = 0;        //Variable for Storing EveryOneUserID 
        public      String              m_GroupIDList               = null;     //Variable for Storing GroupIDList in which logged in User is direct/indirect member of that group.
        public      int                 m_TotalNumberOfFields       = 0;
        public      int                 m_ParentNodeNumber          = 0;
        public      SortedList          m_SortPartitionColumnsList  = null;
        public      List<SortPartition> SortPartitionList           = null;
        public      List<HierarchyObject> HierarchyObjectList       = null;
        public      SortedList          m_StructureSortPartitionList = null;
        public      XmlDocument         InputXMLDocument            = null;
        public      SortedList          m_BinderFields              = null;
        public      SortedList          m_FileFields                = null;
        public      SortedList          m_AssoFileBinderFields      = null;
        public      SortedList          m_FieldCollectionList       = null;

        public      ArrayList           m_UniqueIDList              = null;
        public      List<SortPartitionColumnTagIDPair> m_SPColTagIDList = null;
        public      Boolean             IsAuthorizationRequired     = true;
        public      Boolean             IsFileSystemRequired        = false;

        public      const               Int32 m_OnlyBinderFields            = 35; //Add 1 to the count if you add a column in ALFS_FILE table.
        public      const               Int32 m_OnlyFileFields              = 19; //Add 1 to the count if you add a column in ALFS_FILE table.
        public      const               Int32 m_BinderandFileFieldsCount    = 53; //Add 2 to the count if you add a column in ALFS_FILE table.
        public      static              Int32 EveryOneID                    = 500;
        public      int                 ColumnNumberCount                   = 0;
        public      Boolean             IsFileBinderFieldsFetched           = false;
        public      int[]               RelatedObjectNumber                 = new int[15];
        public      int                 FilterTableVar_Count                = 0;
        public      String              GroupIDList                         = null;
        public      String              m_DummyQuery                        = null;
        public      String              m_DummyFieldname                    = null;

        public      Boolean             m_Paging                            = false;

        #endregion

        #region Constructors
        public NSearchCommon(ulong UserID, string CurrentLanguage, string TenantName)
            : base(UserID, CurrentLanguage, TenantName)
        {
        }
#       endregion

        #region Public Methods

        /// <summary>
        /// Convetrs the User operator value to the data base operator value
        /// </summary>
        /// <param name="Operator">Operator</param>
        /// <returns>Data base operator value</returns>
        public static string GetSearchOperatorValue(string Operator)
        {
            string OperatorValue = "";
            switch (Operator.ToUpper())
            {
                case "ENDSWITH":
                case "STARTSWITH":
                case "CONTAINS":
                case "LIKE":
                    OperatorValue = " LIKE";
                    break;
                case "EQUALTO":
                    OperatorValue = " =";
                    break;
                case "GREATERTHAN":
                    OperatorValue = " >";
                    break;
                case "LESSTHAN":
                    OperatorValue = " <";
                    break;
                case "GREATERTHANEQUALTO":
                    OperatorValue = " >=";
                    break;
                case "LESSTHANEQUALTO":
                    OperatorValue = " <=";
                    break;
                case "NOTEQUALTO":
                    OperatorValue = " <>";
                    break;
                case "IN":
                    OperatorValue = " IN";
                    break;
                case "INRANGE":
                    OperatorValue = "BETWEEN";
                    break;
                case "NOTIN":
                    OperatorValue = " NOT IN";
                    break;
                case "NOTLIKE":
                    OperatorValue = " NOT LIKE";
                    break;
                case "IS":
                    OperatorValue = " IS";
                    break;
                case "IS NOT":
                    OperatorValue = " IS NOT";
                    break;
            }
            return OperatorValue;
        }

        /// <summary>
        /// This function returns Privilege value from Privilege Name
        /// </summary>
        /// <param name="PrivilegeName">Privilege Name like DELETE,DENY,WRITE etc</param>
        /// <param name="PrivilegeValue">Privilege value like 1,2,3 etc</param>
        /// <returns></returns>
        public static int GetPrivilegeValueFromName(string PrivilegeName)
        {
            int PrivilegeValue = 0;

            switch (PrivilegeName.ToUpper())
            {
                case "NOACCESS":
                    PrivilegeValue = OMPrivileges.NOACCESS.GetHashCode();
                    break;
                case "READ":
                    PrivilegeValue = OMPrivileges.READ.GetHashCode();
                    break;

                case "WRITE":
                    PrivilegeValue = OMPrivileges.WRITE.GetHashCode();
                    break;
                case "DELETE":
                    PrivilegeValue = OMPrivileges.DELETE.GetHashCode();
                    break;
                case "DENY":
                    PrivilegeValue = OMPrivileges.DENY.GetHashCode();
                    break;
            }
            return PrivilegeValue; 
        }

        /// <summary>
        /// Prepares the Select clause for an Object
        /// </summary>
        /// <param name="EntityTypeNode">Root Node of the XML containing Entity Information</param>
        /// <returns>returns Select Clause</returns>
        public static string GetSelectClauseForObject(XmlNode EntityTypeNode)
        {
            StringBuilder SelectClause = null;

            string TableName = "";
            string PrimaryKey = "";

            TableName = EntityTypeNode.SelectSingleNode("TABLENAME").InnerText;
            PrimaryKey = EntityTypeNode.SelectSingleNode("PRIMARYKEY").InnerText;
            SelectClause = new StringBuilder();

            SelectClause.AppendFormat("SELECT {0} FROM {1}", PrimaryKey, TableName);
            return SelectClause.ToString();
        }

        /// <summary>
        /// NSearchCommonObj function validates Filtercombination
        /// FilterString is as follows : (1(2)3)
        /// </summary>
        /// <param name="FilterCombinationString">String of filter combination</param>
        /// <returns></returns>
        public static bool ValidateFilterCombination(String FilterCombinationString)
        {

            Stack FilterCombinationStack = null;

            if (FilterCombinationString != null && FilterCombinationString != "")
            {
                FilterCombinationStack = new Stack();
                foreach (Char ch in FilterCombinationString)
                {
                    switch (ch)
                    {
                        case '(':
                            FilterCombinationStack.Push(ch.ToString());
                            break;
                        case ')':
                            FilterCombinationStack.Pop();
                            break;
                    }
                }
                if (FilterCombinationStack.Count == 0)
                    return true;
            }

            return false;
        }
        #endregion

    }


    #endregion

    #endregion
}
