﻿# region System Includes

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.XPath;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;

#endregion

#region Assetlink Includes

using Assetlink.Services.MediaProcessors.ConsolidationComponent;
using Assetlink.MediaProcessors;

#endregion

namespace Assetlink.Services.ALMSOfficeProcessorWebService
{
    using XML       = System.String;
    using ERRORXML  = System.String;

    [WebService(Namespace = "Assetlink.WebServices")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    public class ALMSOfficeProcessorWS : System.Web.Services.WebService
    {
        #region Public Methods
        [WebMethod]
        public ERRORXML ConsolidateWordDocument(String SourcePath, String DestinationPath)
        {
            ERRORXML ErrorXML = null;
            Consolidation object_Consolidation = null;
            try
            {
                foreach (String File in System.IO.Directory.GetFiles(SourcePath))
                {
                    object_Consolidation = new Consolidation();
                    object_Consolidation.ConsolidateWordDocument(File, DestinationPath);
                }
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML ConsolidateExcelSpreadSheet(String SourcePath, String DestinationPath)
        {
            ERRORXML ErrorXML = null;
            Consolidation object_Consolidation = null;
            try
            {
                foreach (String File in System.IO.Directory.GetFiles(SourcePath))
                {
                    object_Consolidation = new Consolidation();
                    object_Consolidation.ConsolidateExcelSpreadSheet(File, DestinationPath);
                }
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML ConsolidatePDFDocument(String SourcePath, String DestinationPath)
        {
            ERRORXML ErrorXML = null;
            Consolidation object_Consolidation = null;
            try
            {
                foreach (String File in System.IO.Directory.GetFiles(SourcePath))
                {
                    object_Consolidation = new Consolidation();
                    object_Consolidation.ConsolidatePDFDocument(File, DestinationPath);
                }
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        [WebMethod]
        //ExportCrystalReportDataToExcel() method is used to generate an excel file using given Data XML.
        public ERRORXML ExportCrystalReportDataToExcel(String DataFilePath, String ExcelFilePath)
        {           
            ERRORXML                ErrorXML                = null;
            MSOffice_MediaPlugin    Obj_MSOfficeMediaPlugin = null;
            try
            {
                Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
                ErrorXML = Obj_MSOfficeMediaPlugin.ExportCrystalReportDataToExcel(DataFilePath, ExcelFilePath);
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        
        [WebMethod]
        public ERRORXML GeneratePDFFromMHtml(String SourcePath, String DestinationPath)
        {
            ERRORXML                ErrorXML                = null;
            MSOffice_MediaPlugin    Obj_MSOfficeMediaPlugin = null;

            try
            {
                Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
                ErrorXML = Obj_MSOfficeMediaPlugin.GeneratePDFFromMHtml(SourcePath, DestinationPath);
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML GenerateExcelFromMHtml(String SourcePath, String DestinationPath)
        {
            ERRORXML                ErrorXML                = null;
            MSOffice_MediaPlugin    Obj_MSOfficeMediaPlugin = null;

            try
            {
                Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
                ErrorXML = Obj_MSOfficeMediaPlugin.GenerateExcelFromMHtml(SourcePath, DestinationPath);
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        #endregion
    
        #region Methods For Facet Series

        [WebMethod]
        public ERRORXML ImportExcelForFacetSeries(XML FacetSeriesConfigXML, XML SeriesIDListXML, ref XML xml_FileCollection)
        {
            ERRORXML ErrorXML = null;
            MSOffice_MediaPlugin Obj_MSOfficeMediaPlugin = null;
            try
            {
                Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
                ErrorXML = Obj_MSOfficeMediaPlugin.ImportExcelForFacetSeries(FacetSeriesConfigXML, SeriesIDListXML, ref xml_FileCollection);
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML GetExcelRecordCountForFacetSeries(XML FacetSeriesConfigXML, ref String ColListXML)
        {
            ERRORXML ErrorXML = null;
            MSOffice_MediaPlugin Obj_MSOfficeMediaPlugin = null;
            try
            {
                Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
                ErrorXML = Obj_MSOfficeMediaPlugin.GetExcelRecordCountForFacetSeries(FacetSeriesConfigXML, ref ColListXML);
            }
            catch (SoapException ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            catch (Exception ExcepObj)
            {
                ErrorXML = HelperFunctions.prepareExceptionXML(ExcepObj);
            }
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML GenerateImportExcelTemplateForFacetSeries(String FilePathForFacetSeriesConfig, out XML FileCollectionXML)
        {
            MSOffice_MediaPlugin    mediaplugin_MSOfficeObject  = null;
            ERRORXML                errorxml_Output             = null;

            FileCollectionXML = null;
            try
            {                
                mediaplugin_MSOfficeObject = new MSOffice_MediaPlugin();
                errorxml_Output = mediaplugin_MSOfficeObject.GenerateImportExcelTemplateForFacetSeries(FilePathForFacetSeriesConfig, out FileCollectionXML);
            }
            catch (SoapException ExceptionObject)
            {
                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }

            return (errorxml_Output);
        }

        [WebMethod]
        public ERRORXML GenerateExcelForFacetSeries(String FilePathForFacetSeriesConfig, String FilePathForFacetSeriesResultantData, 
                out XML FileCollectionXML)
        {
            MSOffice_MediaPlugin    mediaplugin_MSOfficeObject  = null;
            ERRORXML                errorxml_Output             = null;

            FileCollectionXML = null;

            try
            {
                mediaplugin_MSOfficeObject = new MSOffice_MediaPlugin();
                errorxml_Output = mediaplugin_MSOfficeObject.GenerateExcelForFacetSeries(FilePathForFacetSeriesConfig,
                        FilePathForFacetSeriesResultantData, out FileCollectionXML);
            }
            catch (SoapException ExceptionObject)
            {
                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            return (errorxml_Output);
        }

        #endregion

        
        [WebMethod]
        public ERRORXML GenerateImportExcelTemplateForEntity(String FilePathForFacetSeriesConfig, out XML FileCollectionXML)
        {
            MSOffice_MediaPlugin    mediaplugin_MSOfficeObject  = null;
            ERRORXML                errorxml_Output             = null;

            FileCollectionXML = null;
            try
            {                
                mediaplugin_MSOfficeObject  = new MSOffice_MediaPlugin();
                errorxml_Output             = mediaplugin_MSOfficeObject.GenerateImportExcelTemplateForEntity(FilePathForFacetSeriesConfig, out FileCollectionXML);
            }
            catch (SoapException ExceptionObject)
            {
                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }
            catch (Exception ExceptionObject)
            {
                errorxml_Output = HelperFunctions.prepareExceptionXML(ExceptionObject);
            }

            return (errorxml_Output);
        }

        #region Methods For Promotional Planner
        [WebMethod]
        public ERRORXML ExportSubmissionDataToExcel(XML SubmissionDetailsXML)
        {
            ERRORXML ErrorXML = null;
            MSOffice_MediaPlugin Obj_MSOfficeMediaPlugin = null;
            Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
            ErrorXML = Obj_MSOfficeMediaPlugin.ExportSubmissionDataToExcel(SubmissionDetailsXML);
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML ExportVehicleDataToExcel(String JobInfoXML, String ExcelLayoutNode)
        {
            ERRORXML ErrorXML = null;
            MSOffice_MediaPlugin Obj_MSOfficeMediaPlugin = null;
            Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
            ErrorXML = Obj_MSOfficeMediaPlugin.ExportVehicleDataToExcel(JobInfoXML, ExcelLayoutNode);
            return ErrorXML;
        }

        [WebMethod]
        public ERRORXML PrepareConsolidatedSubmissionReport(String JobInfoXML, String ExcelLayoutNode)
        {
            ERRORXML ErrorXML = null;
            MSOffice_MediaPlugin Obj_MSOfficeMediaPlugin = null;
            Obj_MSOfficeMediaPlugin = new MSOffice_MediaPlugin();
            ErrorXML = Obj_MSOfficeMediaPlugin.PrepareConsolidatedSubmissionReport(JobInfoXML, ExcelLayoutNode);
            return ErrorXML;
        }
        #endregion
    }
}

