using System;
using System.Data;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.IO;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;

#region AssetlinkInclude
    using Assetlink.CustomControls;
    using Assetlink.Solutions;
    using Assetlink.Solutions.Facade.CommonFacade;
    using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
    using Assetlink.Solutions.Facade.NotificationFacade;
    using Assetlink.Solutions.Pages;
    using Assetlink.Widgets;
#endregion 

namespace Assetlink.Solutions.MarketingWorkBench
{
    using XML       = String;
    using ERRORXML  = String;

    public partial class Manage_ProjectList: ALAjaxPage
    {
        #region MemberVariable
            private ALSolutionCommon            ALSolutionCommonObj = null;
            //private Dictionary<String, String>  m_ParamList         = null;
            public ALParam                      ALParamObj          = null;
            String[]                            strSeparator        = null;
            private String                      PackageDefinitionID = "0";
            private String                      SolutionName        = "MarketingWorkBench";
            private String                      ConfigurationFile   = "MarketingWorkBench_ProjectList_PredefinedSearch";
            private String                      ProcessDefinitionID = "0";
            Boolean                             isActivityPathNode  = false;
        #endregion

        #region ControlsOnPage
            PredefinedSearchWidget                  Ps_SearchForProjects = null;
            Assetlink.Components.ListComponent      Lc_myProject         = null;
            ActionBar                                Ab_projectList       = null;
        #endregion

        #region ProtectedMethods

        protected void Page_Init(object sender, EventArgs e)
        {
            ALSolutionCommonObj = new ALSolutionCommon();
            ALParamObj = new ALParam();

	        ALSolutionCommonObj.httpContext = HttpContext.Current;
    	    ALSolutionCommonObj.InitALParam(ref ALParamObj);

            ((ALMasterPage)this.Master).SessionID       = ALParamObj.SessionID;
            ((ALMasterPage)this.Master).UserID          = ALParamObj.UserID;
            ((ALMasterPage)this.Master).Language        = ALParamObj.Language;
            ((ALMasterPage)this.Master).TenantName      = ALParamObj.TenantName;
            ((ALMasterPage)this.Master).SolutionName    = "MarketingWorkBench";
            ((ALMasterPage)this.Master).PageTitle       = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_MarketingWorkbench_Shared");
        }
               
        protected void Page_Load(object sender, EventArgs e)
        {
            ulong  ErrorID      = 0;
            String Ps_OutPutXML = null;
            String ErrorPageURL = null;

            try
            {
                setParameters();
                setControls();
                setLeftPane();
                if (!IsPostBack)
                {
                    Session["FROMLISTSCREEN"] = "";
                    GetAllProjectTypes();
                    setPredefinedSearchForProject();
                    Ps_OutPutXML = Ps_SearchForProjects.GetOutPutXML();
                    showProjectList(Ps_OutPutXML);
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "Page_Load", ExceptionObj, null, 
                                                             Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhileloadingtheProjectListPage"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObj.Message, null, GetBackUrl(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        /// <alsummary>
        /// <createddate>27-Feb-07</createddate>
        /// <author>Bhalchandra Kadam</author>
        /// <purpose>This method handles the Left Pane (Projects)  click event to Create new Project</purpose>
        /// </alsummary>
        //protected void Left_3_tp_Projects_SectionClick(object sender, EventArgs e)
        //{
            
        //}

        /// <alsummary>
        /// <createddate>1-oct-06</createddate>
        /// <author>Mugdha moolay</author>
        /// <purpose>This method handles the action bar click event.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        protected void Ab_projectList_Click(object sender, EventArgs e)
        {
            ERRORXML ErrorXML     = null;
            ulong    ErrorID      = 0;
            String   ErrorPageURL = null; 
            try
            {
                String strSender            = (String)sender;
                String[] Parameters         = strSender.Split(strSeparator,3, StringSplitOptions.RemoveEmptyEntries);
                if (Parameters[1].Equals("btn_DeleteProject"))
                {
                    ErrorXML = deleteProject();
                }
                else if (Parameters[1].Equals("btn_CreateProject"))
                    createProject();
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "Ab_projectList_Click", ExceptionObject, null, Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilehandlingProjectListActionBar"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
            }
        }

        protected void Ps_SearchForProjects_SearchBtn_Clicked(object sender, EventArgs e)
        {
            XML     Ps_OutputXML = null;
            ulong   ErrorID      = 0;
            String  ErrorPageURL = null; 

            try
            {
                Ps_OutputXML = Ps_SearchForProjects.OutPutXML;
                showProjectList(Ps_OutputXML);
            }
            catch (Exception ExceptionObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "Ps_SearchForProjects_SearchBtn_Clicked", ExceptionObj, null, Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilehandlingSearchbuttonclick"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObj.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
            }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            if (IsPostBack)
            {
                String EventGenerator = Ajax.EventGeneratorUniqueID;

                if (EventGenerator.Contains("btn_DeleteProject") || (EventGenerator.Contains("btn_Search")) || (EventGenerator.Contains("ProjectListLC")))
                    Ajax.AddControlsToRender(Lc_myProject);

                Ajax.WriteControlHTMl(this.Page, writer);
            }
            else
                base.Render(writer);
        }

        void Lc_myProject_BeforeListControlProcessing(Assetlink.Components.ListComponent sender, ref string ListControlXML)
        {
                MktgWorkBenchFacadeClass MWBFacadeObj       = null;
                ulong                    ul_ErrorID         = 0;
                String                   str_ErrorPageURL   = null;
                
                try
                {
                    MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBFacadeObj.InsertPercentCompleteClass("DUEDATE", ref ListControlXML);
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this, "Manage_ProjectList.aspx", "Lc_myProject_BeforeListControlProcessing", obj_Exception,"",
                                                                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionBeforeListControlProcessing"));
                    ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "DELIVERABLE", null, obj_Exception.Message, null, GetBackUrl(), ref str_ErrorPageURL);
                    if (IsPostBack)
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                    }
                    else
                    {
                        Response.Redirect(str_ErrorPageURL);
                    }
                }
            }
        #endregion

        #region PrivateMethods

        private String GetBackUrl()
        {
            StringBuilder ParamURL = null;            
            try
            {
                ParamURL = new StringBuilder(125);
                if (!IsPostBack)
                {
                    ParamURL.AppendFormat("/{0}/Common/ASPX/DefaultScene_DefaultPage.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID);
                }
                else
                {
                    ParamURL.AppendFormat("/{0}/{4}/ASPX/Manage_ProjectList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName);
                }
                return ParamURL.ToString () ;
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        private void setParameters()
        {
            ulong  ErrorID      = 0;
            String ErrorPageURL = null; 
            try
            {
                strSeparator = new String[1] { "$AL$" };
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "setParameters", ExceptionObject, null, 
                                                            Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilesettingtheparametersfortheProjectListPage"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        private void setControls()
        {
            StringBuilder ActionBarXMLPath      = null;            
            String        FormatXMLPath         = null;
            String        CultureInformation    = null;
            ulong         ErrorID               = 0;
            String        ErrorPageURL          = null; 
            MWB_Helper    MWBHelperObj          = null; 

            try
            {
                ActionBarXMLPath    = new StringBuilder(125);
                MWBHelperObj        = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        

                FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);

                Page_CreatePage.TenantName = ALParamObj.TenantName;
                Page_CreatePage.SectionHeading = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Manage_ProjectList_ViewProjects_Shared");
                // set the tenant name of task panes
                Left_1_tp_MarketingWorkBench.TenantName = ALParamObj.TenantName;
                Left_2_tp_Manage.TenantName             = ALParamObj.TenantName;

                // set the input XML paths of task panes.                
                ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName,SolutionName, "", "MarketingWorkBench_Manage_ProjectList_Content_3_ab_ActionBar"));

                Ps_SearchForProjects                = (PredefinedSearchWidget)Page_CreatePage.FindControl("ProjectSearchPS");
                Ps_SearchForProjects.TenantName     = ALParamObj.TenantName;
                Ps_SearchForProjects.UserID         = ALParamObj.UserID;
                Ps_SearchForProjects.SessionID      = ALParamObj.SessionID;
                Ps_SearchForProjects.Language       = ALParamObj.Language;
                Ps_SearchForProjects.SolutionName   = SolutionName;
                Ps_SearchForProjects.WidgetName     = "STD_PredefinedSearchWidget";
                Ps_SearchForProjects.InputXMLType   = PredefinedSearchWidget.PredefinedSearchInputXMLType.XMLPath;
                Ps_SearchForProjects.ShowTopFilter  = "No";

                Ps_SearchForProjects.ErrorBackURL   = MWBHelperObj.PrepareBackURLforPredefinedSearch(true); 

                Ps_SearchForProjects.IsUserPersonalizationRequired = true;
                Ps_SearchForProjects.ColumnName         = "WORKBENCHPERSONALIZATION";
                Ps_SearchForProjects.ScreenName         = "MANAGE_PROJECTLIST";
                Ps_SearchForProjects.ListName           = "PROJECTLIST";
                Ps_SearchForProjects.PredefinedFilterID = "PROJECTLISTID";
                Ps_SearchForProjects.SearchBtn_Clicked +=new EventHandler(Ps_SearchForProjects_SearchBtn_Clicked); 

                Lc_myProject                        = (Assetlink.Components.ListComponent)Page_CreatePage.FindControl("ProjectListLC");
                Lc_myProject.TenantName             = ALParamObj.TenantName;
                Lc_myProject.SessionID              = ALParamObj.SessionID;
                Lc_myProject.UserID                 = ALParamObj.UserID;
                Lc_myProject.Language               = ALParamObj.Language;
                Lc_myProject.AllowBrowserCaching    = true;
                Lc_myProject.IteratorMode           = Assetlink.Components.ListComponent.Iteratormode.Simple;
                Lc_myProject.BeforeListControlProcessing += new Assetlink.Components.ListComponent.ProcessControlXML(Lc_myProject_BeforeListControlProcessing);

                Lc_myProject.CultureInformation = CultureInformation;
                Lc_myProject.PersonalizationFilePath = FormatXMLPath;

                Ab_projectList                  = (ActionBar)Page_CreatePage.FindControl("ProjectListAB");
                Ab_projectList.TenantName       = ALParamObj.TenantName;
                Ab_projectList.AddAttributes("btn_DeleteProject", "href", "javascript:HandleDeleteSubmit('$CONTROLID$',DecodeSpecialCharactersForJS('" +
                           ALSpecialCharHandling.EncodeSpecialCharactersForJS(Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Manage_ProjectList_NoProjectSelected")) + "'));");
                Ab_projectList.InputXML         = ActionBarXMLPath.ToString();
                Ab_projectList.Click += new EventHandler(Ab_projectList_Click);
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "setControls", ExceptionObject, null,
                                                            Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilesettingthecontrolsfortheProjectListPage"));

                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        private void setPredefinedSearchForProject()
        {
            try
            {
                Ps_SearchForProjects.XMLDataSource =  ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, null, ConfigurationFile);
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        /// <alsummary>
        /// <createddate>1-oct-06</createddate>
        /// <author>Mugdha moolay</author>
        /// <purpose>This method shows a list of projects on the Project List Control.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
		///	        <name/>
		///	<parentnode/>
		///	<attribute/>
		///</node>
        /// </xmlattributes>
        /// </alsummary>
        private void showProjectList(XML Ps_SearchInputXML)
        {
            MktgWorkBenchFacadeClass MWBFacadeObj               = null;
            XML                      ProjectListXML             = null; 
            ERRORXML                 ErrorXML                   = null;
            ListFacade               ListFacadeObj              = null;   
            String                   ConfigXML                  = null;
            String                   ErrorPageURL               = null;
            ulong                    ErrorID                    = 0;
            StringBuilder            ProjectColl                = null;
            XmlDocument              Ps_XMLDoc                  = null;
            XmlNode                  FilterNode                 = null;
            XPathDocument            xpathdoc_ConfigDoc         = null;
            XPathNavigator           xpathnav_SearchConfigNav   = null;
            XPathNavigator           xpathnav_SearchNav         = null;
            XPathDocument            xpathdoc_SolnConfigDoc     = null;
            XPathNavigator           xpathnav_SolnConfig        = null;
            XPathNavigator           xpathnav_ShowActivityPath  = null;
            String                   str_SolutionConfigPath     = null;
            String                   str_GroupFilter            = null;
            MWB_Helper               facade_MWBHelperObj        = null;

            try
            {
                MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                //ListFacadeObj = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ProjectColl = new StringBuilder(500);
                Ps_XMLDoc = new XmlDocument();
                Lc_myProject.EnableIterators = true;
                ListFacadeObj = Lc_myProject.ListFacadeObject;
                //Load the Predefined Search Input XML and check whether there is Filter Node of "ALL" on PROCESSDEFINITIONID
                if (!String.IsNullOrEmpty(Ps_SearchInputXML))
                {
                    Ps_XMLDoc.LoadXml(Ps_SearchInputXML);
                    ErrorXML =  MWBFacadeObj.getProcessCompleteAccessGroupFilter(ALParamObj.UserID, out str_GroupFilter);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        if (!String.IsNullOrEmpty(str_GroupFilter))
                        {
                            FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[RELATIONSHIPNAME='PROCESSCOMPLETEACCESS_GROUP']/EXPRESSIONVALUE");
                            if (FilterNode != null)
                            {
                                FilterNode.InnerText = str_GroupFilter;
                            }

                            //Project Readers Group filter
                            FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[RELATIONSHIPNAME='PROCESSREADER_GROUPS']/EXPRESSIONVALUE");
                            if (FilterNode != null)
                            {
                                FilterNode.InnerText = str_GroupFilter;
                            }
                        }
                        else
                        {
                            //User is not member of any group so remove group filter.
                            FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[RELATIONSHIPNAME='PROCESSCOMPLETEACCESS_GROUP']");
                            if (FilterNode != null)
                            {
                                FilterNode.ParentNode.RemoveChild(FilterNode);
                            }
                            //Project Readers Group filter
                            FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[RELATIONSHIPNAME='PROCESSREADER_GROUPS']");
                            if (FilterNode != null)
                            {
                                FilterNode.ParentNode.RemoveChild(FilterNode);
                            }
                        }
                    }
                    else
                    {
                        //Error occurred while getting user groups.
                        FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[RELATIONSHIPNAME='PROCESSCOMPLETEACCESS_GROUP']");
                        if (FilterNode != null)
                        {
                            FilterNode.ParentNode.RemoveChild(FilterNode);
                        }
                        //Project Readers Group filter
                        FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[RELATIONSHIPNAME='PROCESSREADER_GROUPS']");
                        if (FilterNode != null)
                        {
                            FilterNode.ParentNode.RemoveChild(FilterNode);
                        }
                    }

                    //Handling for ProjectID filter
                    //Remove if empty
                    FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[EXPRESSION='WORKFLOWPROCESSUNIQUEID']/EXPRESSIONVALUE");
                    if (FilterNode != null && FilterNode.InnerText.Contains("('')"))
                    {
                        FilterNode = FilterNode.ParentNode;
                        FilterNode.ParentNode.RemoveChild(FilterNode);
                    }

                    FilterNode = Ps_XMLDoc.DocumentElement.SelectSingleNode("FILTER[EXPRESSION='PROCESSDEFINITIONID']");
                    if (FilterNode != null)
                    {
                        if (FilterNode.SelectSingleNode("EXPRESSIONVALUE").InnerText.ToUpper() == "ALL")
                        {
                            Ps_XMLDoc.DocumentElement.RemoveChild(FilterNode);
                            
                        }
                    }
                    Ps_SearchInputXML = Ps_XMLDoc.OuterXml;

                    if (!IsPostBack)
                    {
                        //Get Setting for showing ActivityPath or not
                        str_SolutionConfigPath = ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, null, "SolutionConfiguration");
                        if (!String.IsNullOrEmpty(str_SolutionConfigPath) && File.Exists(str_SolutionConfigPath))
                        {
                            xpathdoc_SolnConfigDoc  = new XPathDocument(str_SolutionConfigPath);
                            xpathnav_SolnConfig     = xpathdoc_SolnConfigDoc.CreateNavigator();
                            if (xpathnav_SolnConfig != null)
                            {
                                xpathnav_ShowActivityPath = xpathnav_SolnConfig.SelectSingleNode("SolutionConfiguration/SHOWACTIVITYPATHONLISTS");
                                if (xpathnav_ShowActivityPath != null)
                                    ViewState["ShowActivityPathOnLists"] = xpathnav_ShowActivityPath.InnerXml.ToString();
                            }
                        }
                    }
                    //Get search config XML form List Config XML (Removed from facade)
                    if (ViewState["ShowActivityPathOnLists"] != null && ViewState["ShowActivityPathOnLists"].ToString().ToUpper() == "YES")
                        ConfigXML = ListFacadeObj.GetConfigurationXML("MarketingWorkBench", null, "ProjectList_WithActivityPath");
                    else
                        ConfigXML = ListFacadeObj.GetConfigurationXML("MarketingWorkBench", null, "ProjectList");

                    
                    if (!String.IsNullOrEmpty(ConfigXML))
                    {
                        xpathdoc_ConfigDoc          = new XPathDocument(new StringReader(ConfigXML));
                        xpathnav_SearchConfigNav    = xpathdoc_ConfigDoc.CreateNavigator();
                        xpathnav_SearchNav          = xpathnav_SearchConfigNav.SelectSingleNode("Configuration/SEARCH");
                        if (xpathnav_SearchNav != null)
                        {
                            if (xpathnav_SearchNav.SelectSingleNode("TARGETENTITY/RELATIONSHIP[@NAME='MARKETINGACTIVITY_PROJECT']") != null)
                            {
                                isActivityPathNode = true;
                            }
                            ProjectListXML = xpathnav_SearchNav.OuterXml;
                        }

                        //Replacing Session Info with Current values
                        ProjectListXML = ProjectListXML.Replace("$USERID$", ALParamObj.UserID);
                        ProjectListXML = ProjectListXML.Replace("$LANGUAGE$", ALParamObj.Language);
                        ProjectListXML = ProjectListXML.Replace("$TENANTNAME$", ALParamObj.TenantName);
                        ProjectListXML = ProjectListXML.Replace("$SESSIONID$", ALParamObj.SessionID);
                    }

                    ErrorXML = MWBFacadeObj.GetAllProjects(Ps_SearchInputXML, ref ProjectListXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        if (isActivityPathNode == true)
                        {
                            facade_MWBHelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            facade_MWBHelperObj.GetActivityPathSeparator(ref ProjectListXML);
                        }
                        
                        ProjectColl.AppendFormat("<SEARCHOUTPUTXML>{0}</SEARCHOUTPUTXML>", ProjectListXML);

                        Lc_myProject.CurrentPageNumber = 1;
                        XmlDocument ProjectListDoc = null;

                        ProjectListDoc = new XmlDocument();
                        ProjectListDoc.LoadXml(ProjectColl.ToString());
                        Lc_myProject.ListConfigurationXml = ConfigXML;
                        Lc_myProject.SearchResultXmlDoc = ProjectListDoc;
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", null,
                            Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_ProjectList_Errorwhilegettingallprojects"),
                            null, GetBackUrl(), ref ErrorPageURL);

                        if (!IsPostBack)
                        {
                            Response.Redirect(ErrorPageURL, true);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "showProjectList", ExceptionObject, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhileshowingProjectList_Shared"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        /// <alsummary>
        /// <createddate>1-oct-06</createddate>
        /// <author>Mugdha moolay</author>
        /// <purpose>This methosd deletes a project instance</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private ERRORXML deleteProject()
        {
            MktgWorkBenchFacadeClass MWBFacadeObj       = null;
            ERRORXML                 ErrorXML           = null;
            String                   ProjectID          = null;
            ulong                   ErrorID             = 0;
            String                  ReturnProjectXML    = null;
            XPathDocument           xp_RetProjectXMLDoc = null;
            XPathNavigator          xp_RetProcessNav    = null;
            XPathNodeIterator       xp_BriefIterator    = null;
            XPathNavigator          xp_BriefNavigator   = null;
            String                  Status              = null;
            String					BriefID				= null;
            StringBuilder           AssociationXML      = null;
            StringBuilder			UpdateBriefXML		= null;
            String                  ErrorPageURL        = null;
            String                  DeleteAllowed       = null;
            XML						UpdateXML			= null;
            Boolean                 DeleteProjectFlag   = false;
            Boolean                 bool_AllowDelete    = false; 
            String                  Ps_OutPutXML        = null;
            String                  str_ProcessDefID    = null;
            MWB_Helper              MWB_HelperObj       = null;
            String                  str_AssociatedFacets= null;
            String                  str_PMID            = null;
            String                  str_APMID           = null;

            try
            {
                ProjectID = Request["__EVENTARGUMENT"];
                UpdateBriefXML	= new StringBuilder();

                MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                //Read solution configuration XML for value of the MODE attribute.
                MWBFacadeObj.ReadSolutionConfiguration(SolutionName, "DELETEMODE", out DeleteAllowed);
                XmlDocument ListDoc = Lc_myProject.SearchResultXmlDoc;
                if (!String.IsNullOrEmpty(ProjectID))
                {
                    AssociationXML = new StringBuilder(250);
                    if (ListDoc.SelectSingleNode("SEARCHOUTPUTXML/WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS[WORKFLOWPROCESSID='" + ProjectID + "']") != null)
                    {
                        str_ProcessDefID = ListDoc.SelectSingleNode("SEARCHOUTPUTXML/WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS[WORKFLOWPROCESSID='" + ProjectID + "']/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").InnerText;
                    }

                    MWB_HelperObj.GetAssociatedFacetListForNotifications("5021", str_ProcessDefID, SolutionName, out str_AssociatedFacets);


                    AssociationXML.AppendFormat(@"<SEARCH>
                                                    <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    AssociationXML.AppendFormat(@"<TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
                                                <TARGETENTITY>
                                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                    <FILTERLIST>
	                                                    <FILTER>
		                                                    <FILTERID>1</FILTERID>
		                                                    <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
		                                                    <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                    </FILTER>
                                                    </FILTERLIST>", ProjectID);

                    if (!String.IsNullOrEmpty(str_AssociatedFacets))
                        AssociationXML.Append(str_AssociatedFacets);

                    AssociationXML.AppendFormat(@"<RELATIONSHIP NAME='PROJECTMANAGER'>
						                            <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                            <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                            <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>LASTNAME</FIELDNAME>
                                                            <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>EMAILID</FIELDNAME>
                                                            <ALIAS>EMAILID</ALIAS>
                                                        </EXPRESSION>
						                            </SELECTLIST>
					                            </RELATIONSHIP>
                                                <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
						                            <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                            <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                            <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>LASTNAME</FIELDNAME>
                                                            <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>EMAILID</FIELDNAME>
                                                            <ALIAS>EMAILID</ALIAS>
                                                        </EXPRESSION>
						                            </SELECTLIST>
					                            </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROCESSCOMPLETEACCESS_USER'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>USERID</FIELDNAME>
                                                            <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
                                                        <FILTER>
                                                            <EXPRESSION>STATUS</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>Active</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </RELATIONSHIP> 
                                                <RELATIONSHIP NAME='PROCESSCOMPLETEACCESS_GROUP'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>GROUPID</FIELDNAME>
                                                            <ALIAS>GROUPID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
                                                        <FILTER>
                                                            <EXPRESSION>ISDELETED</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </RELATIONSHIP> 
                                                <RELATIONSHIP NAME='BRIEF_PROJECT'>
						                            <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>BRIEFID</FIELDNAME>
                                                            <ALIAS>BRIEFID</ALIAS>
                                                        </EXPRESSION>
						                            </SELECTLIST>
                                                <RELATIONSHIP NAME='BRIEFINITIATOR'>
						                            <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                            <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                            <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>LASTNAME</FIELDNAME>
                                                            <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>                                                        
						                            </SELECTLIST>
					                            </RELATIONSHIP>
					                            </RELATIONSHIP></TARGETENTITY></SEARCH>");
                    SearchConfiguration SearchConfigObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXML = SearchConfigObj.GetHierarchialData(AssociationXML.ToString(), ref ReturnProjectXML);
                    if (ErrorXML == null)
                    {
                        ReturnProjectXML = ReturnProjectXML.Replace("<WORKFLOWPROCESSCOLLECTION>", String.Empty);
                        ReturnProjectXML = ReturnProjectXML.Replace("</WORKFLOWPROCESSCOLLECTION>", String.Empty);

                        xp_RetProjectXMLDoc = new XPathDocument(new StringReader(ReturnProjectXML));
                        xp_RetProcessNav = xp_RetProjectXMLDoc.CreateNavigator();
                        if ((!String.IsNullOrEmpty(DeleteAllowed)) && (DeleteAllowed.ToUpper() != "RESTRICTED"))
                        {
                            DeleteProjectFlag = true;
                        }
                        else
                        {
                            Status = xp_RetProcessNav.SelectSingleNode("WORKFLOWPROCESS/STATUS").Value;

                            if (Status.Equals("New", StringComparison.OrdinalIgnoreCase) || Status.Equals("Draft", StringComparison.OrdinalIgnoreCase))
                                DeleteProjectFlag = true;
                            else
                                DeleteProjectFlag = false;
                        }

                        //Check Project access
                        str_PMID = xp_RetProcessNav.SelectSingleNode("WORKFLOWPROCESS/PROJECTMANAGER/USER/USERID").Value;
                        str_APMID = xp_RetProcessNav.SelectSingleNode("WORKFLOWPROCESS/ACTINGPROJECTMANAGER/USER/USERID").Value;

                        if (str_PMID == ALParamObj.UserID || str_APMID == ALParamObj.UserID || MWBFacadeObj.isUserFromProjectCompleteAccessUserGroup(ALParamObj.UserID, xp_RetProcessNav))
                            bool_AllowDelete = true;

                        if (DeleteProjectFlag && bool_AllowDelete)
                        {
                            ErrorXML = MWBFacadeObj.DeleteProject(ProjectID);
                            if (ErrorXML == null)
                            {
                                if (xp_RetProcessNav.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID") != null)
                                {
                                   str_ProcessDefID = xp_RetProcessNav.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").Value;
                                }
                                xp_BriefIterator = xp_RetProcessNav.Select("WORKFLOWPROCESS/BRIEF_PROJECT/BRIEF");
                                while (xp_BriefIterator.MoveNext())
                                {
                                    xp_BriefNavigator = xp_BriefIterator.Current;
                                    {
										UpdateBriefXML = new StringBuilder();
                                        BriefID = xp_BriefNavigator.SelectSingleNode("BRIEFID").Value;
                                        UpdateBriefXML.Append(@"<BRIEF>
                                                                 <BRIEFID>");
                                        UpdateBriefXML.Append(BriefID);
                                         UpdateBriefXML.Append(@"</BRIEFID>
                                                                 <STATUS>Project Deleted</STATUS>
                                                                </BRIEF>");
                                        UpdateXML = UpdateBriefXML.ToString();
                                        ErrorXML = MWBFacadeObj.UpdateBrief(ref UpdateXML);
                                        if (ErrorXML == null)
                                        {
                                            ErrorXML = StampNotificationForBrief(BriefID, ProjectID, xp_BriefNavigator.SelectSingleNode("BRIEFINITIATOR"), ReturnProjectXML, str_ProcessDefID);
                                            if (!String.IsNullOrEmpty(ErrorXML))
                                            {
                                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                                break; 
                                            }
                                        }
                                        else
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            break;
                                        }
                                    }
                                }
                                if (String.IsNullOrEmpty(ErrorXML))
                                {
                                    Ps_OutPutXML = Ps_SearchForProjects.OutPutXML;
                                    showProjectList(Ps_OutPutXML);
                                }
                            }
                            else
                            {
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                        else if (!bool_AllowDelete)
                            Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_NoDeleteAccessForProject',null);");
                        else
                            Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_Manage_ProjectList_Projectcannotbedeleted',null);");
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                return ErrorXML;
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "deleteProject", ExceptionObject, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhiledeletingProject"));

                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                return null;
            }
        }

        /// <alsummary>
        /// <createddate>1-oct-06</createddate>
        /// <author>Mugdha moolay</author>
        /// <purpose>This method creates a project instance.</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private void createProject()
        {
            StringBuilder ParamURL          = null;
            StringBuilder URL               = null;
            String        EncryptURL        = null;            
            ulong         ErrorID           = 0;
            String        ErrorPageURL      = null; 
            try
            {
                ParamURL            = new StringBuilder(200);
                URL                 = new StringBuilder(250);
                PackageDefinitionID = __PackageDefinitionID.Value;                
                ProcessDefinitionID = Ab_projectList.GetSelectedValueByName("lst_ProjectType");
                if (ProcessDefinitionID != "NONE")
                {
                    ParamURL.AppendFormat("Manage_ProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionID={4}&ProcessDefinitionID={5}&FormMode=CREATE", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                else
                    Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_Manage_ProjectList_Pleaseselectaprojecttype_Shared',null);");
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "createProject", ExceptionObject, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilecreatingProject"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
            }
        }

        /// <alsummary>
        /// <createddate>1-0ct-06</createddate>
        /// <author>Mugdha moolay</author>
        /// <purpose>This method gets the project types and adds them to the drop down list of the action bar</purpose>
        /// <featurelist>
        ///     <feature></feature>
        /// </featurelist>
        /// <xmlstructure><![CDATA[]]></xmlstructure>
        /// 	<xmlattributes>
        /// 		<node>
        ///	        <name/>
        ///	<parentnode/>
        ///	<attribute/>
        ///</node>
        /// </xmlattributes>
        /// </alsummary>
        private ERRORXML GetAllProjectTypes()
        {
            MktgWorkBenchFacadeClass MWBFacadeObj       = null;
            ERRORXML                 ErrorXML           = null;
            XML                      ProjectTypeXML     = null;
            XmlDocument              ProjectTypeDoc     = null;
            XmlDocument              ActionBarDoc       = null;
            XmlDocument              PS_ConfigDoc       = null; 
            XmlNode                  PackageDefIDNode   = null;
            XmlNode                  ActionControlNode  = null;            
            XmlNode                  ItemNode           = null;
            XmlNode                  Parent_Node        = null;
            XmlNode                  FilterNode         = null; 
            XmlNode                  Ps_FilterValueNode = null; 
            XmlNode                  FilterValueListNode= null; 
            XmlNodeList              FilterValueNodeList= null; 
            XmlNodeList              ChildNodeList      = null;   
            XmlAttribute             TextAttr           = null;
            XmlAttribute             ValueAttr          = null;
            XmlAttribute             SelectedAttr       = null;
            StringBuilder           ActionBarXMLPath    = null;
            StringBuilder           PS_ProjectTypeXML   = null; 
            String                  PS_ConfigPath       = null;             
            String                  ErrorPageURL        = null; 
            ulong                   ErrorID             = 0;
            StringReader            SB_ErrorXML         = null;
            XPathDocument           ErrorXMLDoc         = null;
            XPathNavigator          ErrorNav            = null;
            XPathNavigator          ErrorCodeNav        = null;
            XPathExpression         xpExp_ProcessName   = null;
            XPathNodeIterator       iter_ProcessNodeList= null; 

            try
            {
                MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ActionBarDoc = new XmlDocument();
                PS_ConfigDoc = new XmlDocument();
                ActionBarXMLPath = new StringBuilder(125);
                PS_ProjectTypeXML = new StringBuilder(125);
                                
				ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName,SolutionName, "", "MarketingWorkBench_Manage_ProjectList_Content_3_ab_ActionBar"));
                PS_ConfigPath = ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, null, ConfigurationFile);

                ActionBarDoc.Load(ActionBarXMLPath.ToString());
                ActionControlNode = ActionBarDoc.SelectSingleNode("ActionControlList/ActionControl[@Name='btn_CreateProject']");
                if (ActionControlNode != null)
                {
                    //Do not get project types if Create Project Button not configured.
                    ErrorXML = MWBFacadeObj.GetProjectTypes(out ProjectTypeXML);
                    if (!String.IsNullOrEmpty(ErrorXML))
                    {
                        SB_ErrorXML = new StringReader(ErrorXML);
                        ErrorXMLDoc = new XPathDocument(SB_ErrorXML);
                        ErrorNav = ErrorXMLDoc.CreateNavigator();

                        ErrorCodeNav = ErrorNav.SelectSingleNode("ERRORCOLLECTION/ERROR/ERRORCODE");
                        if (ErrorCodeNav != null)
                        {
                            if (ErrorCodeNav.Value.ToUpper() == "MWBENGINE_PROJECT_PROJECTTYPESNOTFOUND" || ErrorCodeNav.Value.ToUpper() == "MWBENGINE_PROJECT_GETPROJECTTYPESFAILED")
                            {
                                //clear NTFS action bar xml.
                                ActionControlNode = ActionBarDoc.SelectSingleNode("ActionControlList/ActionControl[@Name='lst_ProjectType']");

                                //Load the Predefined Search configuration XML
                                PS_ConfigDoc.Load(PS_ConfigPath);
                                FilterNode = PS_ConfigDoc.DocumentElement.SelectSingleNode("PredefinedFilters/PredefinedFilter/Filter[@Name = 'PROCESSDEFINITIONID']");
                                if ((ActionControlNode != null) && (FilterNode != null))
                                {
                                    ChildNodeList = ActionControlNode.SelectNodes("Item[@Value!='NONE']");
                                    if (ChildNodeList.Count > 0)
                                    {
                                        foreach (XmlNode ChildNode in ChildNodeList)
                                        {
                                            Parent_Node = ChildNode.ParentNode;
                                            Parent_Node.RemoveChild(ChildNode);
                                        }
                                    }

                                    //Remove from Predefined Search XML
                                    FilterValueListNode = FilterNode.SelectSingleNode("FilterValueList");
                                    FilterValueNodeList = FilterValueListNode.SelectNodes("FilterValue[DisplayValue != 'All']");
                                    if (FilterValueNodeList.Count > 0)
                                    {
                                        foreach (XmlNode FilterValueNode in FilterValueNodeList)
                                        {
                                            Parent_Node = FilterValueNode.ParentNode;
                                            Parent_Node.RemoveChild(FilterValueNode);
                                        }
                                    }
                                    ActionBarDoc.Save(ActionBarXMLPath.ToString());
                                    PS_ConfigDoc.Save(PS_ConfigPath);
                                    Ab_projectList.InputXML = ActionBarXMLPath.ToString();
                                }
                                return null; //Project Types XPDL's is not imported ( or Project Type is not configured );
                            }
                            else
                            {
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                Response.Redirect(ErrorPageURL, true);
                                return ErrorXML;
                            }
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "PROJECT", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            Response.Redirect(ErrorPageURL, true);
                            return ErrorXML;
                        }
                    }

                    else
                    {
                        ProjectTypeDoc = new XmlDocument();
                        ProjectTypeDoc.LoadXml(ProjectTypeXML);
                        PackageDefIDNode = ProjectTypeDoc.SelectSingleNode("PACKAGEDEFINITION/PACKAGE/PACKAGEDEFINITIONID");
                        PackageDefinitionID = PackageDefIDNode.InnerText;
                        __PackageDefinitionID.Value = PackageDefinitionID;
                        
                        ActionControlNode = ActionBarDoc.SelectSingleNode("ActionControlList/ActionControl[@Name='lst_ProjectType']");

                        //Load the Predefined Search configuration XML
                        PS_ConfigDoc.Load(PS_ConfigPath);
                        FilterNode = PS_ConfigDoc.DocumentElement.SelectSingleNode("PredefinedFilters/PredefinedFilter/Filter[@Name = 'PROCESSDEFINITIONID']");
                        if ((ActionControlNode != null) && (FilterNode != null))
                        {
                            //Remove from the action bar xml
                            ChildNodeList = ActionControlNode.SelectNodes("Item[@Value!='NONE']");
                            if (ChildNodeList.Count > 0)
                            {
                                foreach (XmlNode ChildNode in ChildNodeList)
                                {
                                    Parent_Node = ChildNode.ParentNode;
                                    Parent_Node.RemoveChild(ChildNode);
                                }
                            }

                            //Remove from Predefined Search XML
                            FilterValueListNode = FilterNode.SelectSingleNode("FilterValueList");
                            FilterValueNodeList = FilterValueListNode.SelectNodes("FilterValue[DisplayValue != 'All']");
                            if (FilterValueNodeList.Count > 0)
                            {
                                foreach (XmlNode FilterValueNode in FilterValueNodeList)
                                {
                                    Parent_Node = FilterValueNode.ParentNode;
                                    Parent_Node.RemoveChild(FilterValueNode);
                                }
                            }

                            xpExp_ProcessName = XPathExpression.Compile("PACKAGEDEFINITION/PACKAGE/PACKAGE_PROCESS/WORKFLOWPROCESS");
                            xpExp_ProcessName.AddSort("PROCESSNAME", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);

                            iter_ProcessNodeList = ProjectTypeDoc.CreateNavigator().Select(xpExp_ProcessName);
                            foreach (XPathNavigator nav_ProcessNode in iter_ProcessNodeList)
                            {
                                ItemNode = ActionBarDoc.CreateElement("Item");
                                TextAttr = ActionBarDoc.CreateAttribute("Text");
                                TextAttr.InnerText = nav_ProcessNode.SelectSingleNode("PROCESSNAME").Value;
                                ValueAttr = ActionBarDoc.CreateAttribute("Value");
                                ValueAttr.InnerText = nav_ProcessNode.SelectSingleNode("WORKFLOWPROCESSID").Value;
                                SelectedAttr = ActionBarDoc.CreateAttribute("Selected");
                                SelectedAttr.InnerText = "False";
                                ItemNode.Attributes.Append(TextAttr);
                                ItemNode.Attributes.Append(ValueAttr);
                                ItemNode.Attributes.Append(SelectedAttr);
                                ActionControlNode.AppendChild(ItemNode);
                                ItemNode = null;

                                //Update UserPersonalization Configuration XML
                                Ps_FilterValueNode = PS_ConfigDoc.CreateElement("FilterValue");
                                ((XmlElement)Ps_FilterValueNode).SetAttribute("IsSelected", "False");
                                PS_ProjectTypeXML.Remove(0, PS_ProjectTypeXML.Length);

                                PS_ProjectTypeXML.AppendFormat(@"<DisplayValue>{0}</DisplayValue>
                                                            <Value>{1}</Value>", ALSpecialCharHandling.TrimAndReplaceSpecialChars(nav_ProcessNode.SelectSingleNode("PROCESSNAME").Value), nav_ProcessNode.SelectSingleNode("WORKFLOWPROCESSID").Value);

                                Ps_FilterValueNode.InnerXml = PS_ProjectTypeXML.ToString();
                                FilterValueListNode.AppendChild(Ps_FilterValueNode);
                            }
                            ActionBarDoc.Save(ActionBarXMLPath.ToString());
                            PS_ConfigDoc.Save(PS_ConfigPath);
                            Ab_projectList.InputXML = ActionBarXMLPath.ToString();
                        }
                    }
                }
                return ErrorXML;
            }
            catch (ThreadAbortException)
            { return ErrorXML; }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "GetAllProjectTypes", ExceptionObject, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilegettingProjectTypes_Shared"));

                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                Response.Redirect(ErrorPageURL);
                return ErrorXML;
            }
        }

        private void setLeftPane()
        {
            Hashtable       URLParams_HT = null;
            LeftPaneFacade  LeftPaneObj  = null;
            ulong           ErrorID      = 0;
            String          ErrorPageURL = null; 
            try
            {                
                URLParams_HT = new Hashtable();                
                LeftPaneObj = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, "MarketingWorkBench");
                URLParams_HT.Add("PackageDefinitionID", PackageDefinitionID);
                URLParams_HT.Add("ProcessDefinitionID", ProcessDefinitionID);
                URLParams_HT.Add("FormMode", "Create");
                LeftPaneObj.SolutionName = "MarketingWorkBench";
                LeftPaneObj.GetTaskPaneNode(this.Page, URLParams_HT);
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ProjectList.aspx", "setLeftPane", ExceptionObject, null,
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_ProjectList_ExceptionwhilesettingLeftPanefortheProjectListPage"));
                ALSolutionCommonObj.PrepareErrorPageUrl(ALParamObj.SolutionName, null, "PROJECT", null, ExceptionObject.Message, null, GetBackUrl(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
        }

        private XML GetSearchXMLForBriefEntity(String BriefID)
        {
            StringBuilder BriefSearchXML = null;
            try
            {
                BriefSearchXML = new StringBuilder(1000);
                BriefSearchXML.Append(@"<SEARCH>
                                            <TARGETOBJECT>BRIEF</TARGETOBJECT>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    BriefSearchXML.AppendFormat("<SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'></SESSIONINFO>", ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ALParamObj.SessionID);
                    BriefSearchXML.Append(@"<SEARCHALLFACETS>TRUE</SEARCHALLFACETS>
                                                <TARGETENTITY>
                                                    <RELATIONSHIP NAME='BRIEFINITIATOR'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>USERID</FIELDNAME>
                                                                <ALIAS>USERID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                <ALIAS>FIRSTNAME</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                <ALIAS>LASTNAME</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                            <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>     
                                                            <FIELDNAME>EMAILID</FIELDNAME>
									                        <ALIAS>EMAILID</ALIAS>
                                                        </EXPRESSION>   
                                                    </SELECTLIST>
                                                </RELATIONSHIP>   
                                               <FILTERLIST>
                                                    <FILTER>
                                                        <EXPRESSION>BRIEFID</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>");
                                BriefSearchXML.AppendFormat("<EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>", BriefID);
                                BriefSearchXML.Append(@"<ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                </FILTERLIST>
                                            </TARGETENTITY>
                                        </SEARCH>");
                return BriefSearchXML.ToString();  
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

         private String GetEmailScreenURL(String ProjectID)
        {
            String          DefaultPageMode             = null;
            String          CommunicationProtocol       = null;
            String          InternetAddress             = null;
            StringBuilder   DefaultPageParameterList    = null;
            StringBuilder   ParameterList               = null;
            StringBuilder   SolutionPageUrl             = null;
            StringBuilder   DefaultPageUrl              = null;

            try
            {   
                DefaultPageMode       = "EMAIL";
                CommunicationProtocol = ALCommon.GetCommunicationProtocol();
                InternetAddress       = ALCommon.GetInternetAddress();
                
                SolutionPageUrl  = new StringBuilder();
                SolutionPageUrl.AppendFormat("{0}{1}/{2}/{3}/ASPX/WorkBenchLinkHandler.ashx", CommunicationProtocol, InternetAddress, ALParamObj.TenantName, SolutionName);

                ParameterList = new StringBuilder(50);
                ParameterList.AppendFormat("Mode=MANAGE&SourceID={0}&SourceType=PROJECT", ProjectID);

                DefaultPageParameterList = new StringBuilder(75);
                DefaultPageParameterList.AppendFormat("Language={0}&Mode={1}&SolutionPage={2}&Param={3}", ALParamObj.Language, DefaultPageMode, SolutionPageUrl, ALCommon.Encrypt(ParameterList.ToString()));
                
                DefaultPageUrl = new StringBuilder(200);
                DefaultPageUrl.AppendFormat("{0}{1}/{2}/default.aspx?{3}", CommunicationProtocol, InternetAddress, ALParamObj.TenantName, DefaultPageParameterList.ToString());
                
                DefaultPageUrl = DefaultPageUrl.Replace("&", "%26");

                return DefaultPageUrl.ToString();
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        private ERRORXML StampNotificationForBrief(String BriefID, String InputProjectID, XPathNavigator BriefInitiator, String ReturnProjectXML, String str_ProcessDefID)
        {
            ERRORXML                    ErrorXMLString          = null;
            String                      BriefInitiatorID        = null; 
            String                      ProjectScreenURL        = null; 
            String                      NotificationXML         = null; 
            StringBuilder               Message                 = null;
            StringBuilder               Subject                 = null;
            XmlDocument                 xp_ProjectXMLDoc        = null;
            XPathNavigator              Root_ProjectXMLDoc      = null; 
            XPathNavigator              FileSystem              = null;
            XPathNodeIterator           FileSystemNodes         = null; 
            EmailChannel                EmailChannelObj         = null;
            MWB_Helper                  MWB_HelperObj           = null; 
            NotificationFacadeClass     NotificationFacadeObj   = null;
            NotificationHelper          NotificationHelperObj   = null;
            XPathNavigator              ProjectManager          = null;
            XPathNavigator              ActingProjectManager    = null;
            try
            {
                MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                //Get the Brief Initiator
                BriefInitiatorID = BriefInitiator.SelectSingleNode("USER/USERID").Value;

                EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                NotificationHelperObj.Init("5021", ALParamObj.UserID, str_ProcessDefID);
                
                EmailChannelObj.AddRecipient("TO", BriefInitiatorID, false);
                NotificationHelperObj.AddChannel(EmailChannelObj);
                
                xp_ProjectXMLDoc = new XmlDocument();
                xp_ProjectXMLDoc.LoadXml(ReturnProjectXML);
                Root_ProjectXMLDoc = xp_ProjectXMLDoc.CreateNavigator();

                FileSystemNodes = Root_ProjectXMLDoc.Select("//FILESYSTEM");
                while (FileSystemNodes.MoveNext())
                {
                    FileSystem = FileSystemNodes.Current;
                    FileSystem.DeleteSelf();
                    FileSystemNodes = Root_ProjectXMLDoc.Select("//FILESYSTEM");
                }
                ProjectManager      = Root_ProjectXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROJECTMANAGER");
                if (ProjectManager != null)
                {
                    ProjectManager.CreateAttribute(null, "ProjectManager", "", ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER"))));	
                }
                ActingProjectManager = Root_ProjectXMLDoc.SelectSingleNode("WORKFLOWPROCESS/ACTINGPROJECTMANAGER");
                if (ActingProjectManager != null)
                {
                    ActingProjectManager.CreateAttribute(null, "ActingProjectManager", "", ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ActingProjectManager.SelectSingleNode("USER"))));
                }

                Message = new StringBuilder();
                //Comments : Sender and receiver name's contains special characters fix.
                //          bugid : 2335
                Message.Append("<MESSAGE>");
                //Message.Append(ALSpecialCharHandling.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()));
                //Message.Append("' Reciever='");
                //Message.Append(ALSpecialCharHandling.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(BriefInitiator)));
                //Message.Append("'>");
                Message.Append(Root_ProjectXMLDoc.InnerXml);
                Message.Append("</MESSAGE>");


                Subject = new StringBuilder();
                Subject.Append("<SUBJECT>");
				Subject.Append(Root_ProjectXMLDoc.InnerXml);
				Subject.Append("</SUBJECT>");

                ProjectScreenURL = GetEmailScreenURL(InputProjectID);
                ErrorXMLString = NotificationHelperObj.AddSubject(Subject.ToString());
                ErrorXMLString = NotificationHelperObj.AddMessage(Message.ToString());
                ErrorXMLString = NotificationHelperObj.AddLink("ProjectScreenURL", ProjectScreenURL);

                ErrorXMLString = NotificationHelperObj.GetNotificationXML(ref NotificationXML);
                if (ErrorXMLString == null && NotificationXML != null)
                {
                    NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXMLString = NotificationFacadeObj.StampNotification(NotificationXML);
                }
                return ErrorXMLString;
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        #endregion

    }
}