﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using System.Collections.Specialized;

#region Assetlink Includes
using Assetlink;
using Assetlink.Solutions.Pages;
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.ReportFacade;
#endregion

public partial class ScheduledReport_ErrorInfo : ALAjaxPage
{
    #region Member Variables
    ALSolutionCommon                ALSolutionCommonObj         = null;
    ALParam                         ALParamObj                  = null;
    String                          SCHRptInstanceID            = null;
    String                          PopupWindowID               = null;
    String                          SCHRPTDetailsID             = null;
    String                          ErrorXML                    = null;   
    #endregion

    #region Page Methods
    protected void Page_Init(object sender, EventArgs e)
    {
        ALSolutionCommonObj     = new ALSolutionCommon();
        ALParamObj              = new ALParam();

        try
        {
            ALSolutionCommonObj.httpContext = HttpContext.Current;
            ALSolutionCommonObj.InitALParam(ref ALParamObj);

            SCHRptInstanceID = ALSolutionCommonObj.GetParamValue("SCHEDREPORTINSTID");
            PopupWindowID = ALSolutionCommonObj.GetParamValue("PopupWindowID");
            SCHRPTDetailsID = ALSolutionCommonObj.GetParamValue("SCHEDREPORTID");

            ALB_OK.TenantName = ALParamObj.TenantName;
            ALB_OK.Attributes.Add("href", "javascript:ClosePopup('" + PopupWindowID + "');");
            
            #region Set ErrorList attributes
            CC_LC_ErrorList.TenantName = ALParamObj.TenantName;
            //CC_LC_ErrorList.SectionHeading = Localization.GetString("ALResource", ALParamObj.TenantName, "DAM_AssetListWidget_OperationFailedDetails");
            CC_LC_ErrorList.TitleBarVisible = false;
            CC_LC_ErrorList.cssHeadingTitle = "PageTitleText";
            CC_LC_ErrorList.ImageAlignment = SquareBlankSection.m_ImageAlignment.Disable;
            CC_LC_ErrorList.cssHeaderRow = "ThumbViewScreenMainHead";
            CC_LC_ErrorList.InputType = Assetlink.CustomControls.ListControl.SourceType.InnerXML;
            #endregion
        }
        catch (System.Threading.ThreadAbortException)
        {
        }
        catch (Exception objExcep)
        {
            ALSolutionCommonExtension.DumpExceptionAndRedirectToErrorPage(objExcep, null, "", true, "", "&JS_CloseOnOk=TRUE", null);
        }
    }
   
    protected void Page_Load(object sender, EventArgs e)
    {
        int                             count                       = 0;
        String                          strErrorDetails             = null;
        String                          ResourceID                  = null;
        String                          ErrorMessage                = null;
        StringBuilder                   inputListXml                = null;
        StringDictionary                strDict_AdditioanlInfo      = null;
        XPathDocument                   xpDoc_ErrorDetails          = null;
        XPathNavigator                  xpNav_ErrorDetails          = null;
        XPathNavigator                  xErrorCodeNavigator         = null;
        XPathNavigator                  xErrorMessageNavigator      = null;
        XPathNodeIterator               xErrorCollectionIterator    = null;

        try
        {
            if (!String.IsNullOrEmpty(SCHRptInstanceID))
            {
                GetInstanceErrorDetails(out strErrorDetails);
                if (!String.IsNullOrEmpty(strErrorDetails))
                {
                    xpDoc_ErrorDetails = new XPathDocument(new StringReader(strErrorDetails));
                    xpNav_ErrorDetails = xpDoc_ErrorDetails.CreateNavigator();

                    inputListXml = new StringBuilder(16);
                    xErrorCollectionIterator = xpNav_ErrorDetails.Select("ERRORCOLLECTION/ERROR");
                    if (xErrorCollectionIterator != null && xErrorCollectionIterator.Count > 0)
                    {
                        createHeaderListXml(ref inputListXml, xErrorCollectionIterator.Count);
                        inputListXml.AppendFormat("<Group Value=\"None\" EndRow=\"{0}\">", xErrorCollectionIterator.Count);

                        while (xErrorCollectionIterator.MoveNext())
                        {
                            count++;
                            inputListXml.AppendFormat("<Row Order=\"{0}\">", count);
                            xErrorCodeNavigator = (xErrorCollectionIterator.Current).SelectSingleNode("descendant::ERRORCODE");
                            xErrorMessageNavigator = (xErrorCollectionIterator.Current).SelectSingleNode("descendant::MESSAGE");

                            if (xErrorCodeNavigator != null)
                            {
                                strDict_AdditioanlInfo = CommonFunctions.GetAdditionaInfoFromError(xErrorCollectionIterator.Current);
                                ResourceID = ALSolutionCommonObj.GenerateResourceIDFromErrorCode(ALParamObj.SolutionName, "", xErrorCodeNavigator.Value);
                                xErrorCodeNavigator.MoveToParent();
                                xErrorCodeNavigator = xErrorCodeNavigator.SelectSingleNode("EXCEPTION/MESSAGE");
                                if (xErrorCodeNavigator != null)
                                {
                                    if (!strDict_AdditioanlInfo.ContainsKey("EXCEPTION_MESSAGE"))
                                        strDict_AdditioanlInfo.Add("EXCEPTION_MESSAGE", ALSolutionCommon.TrimAndReplaceSpecialChars(xErrorCodeNavigator.Value));
                                }
                                strDict_AdditioanlInfo.Add("NEWLINE", "\n");
                                ResourceID = ResourceID.Replace("ERR__ERR", "ERR");
                                ErrorMessage = Localization.GetString("ALErrorResource", ALParamObj.TenantName, ResourceID, strDict_AdditioanlInfo);
                            }
                            else
                            {
                                ErrorMessage = ALSolutionCommon.TrimAndReplaceSpecialChars(xErrorMessageNavigator.Value);
                            }
                            inputListXml.Append("<Column Name=\"Details\" HTMLDecoding=\"True\">");
                            inputListXml.Append(ErrorMessage);
                            inputListXml.Append("</Column>");
                            inputListXml.Append("</Row>");
                        }
                        inputListXml.Append("</Group></Data></List>");
                        CC_LC_ErrorList.Source = inputListXml.ToString();
                    }
                    else
                    {
                        Panel_ErrorList.Style.Add("Display", "none");
                    }
                }
                else
                {
                    Panel_ErrorList.Style.Add("Display", "none");
                }
            }
        }
        catch (System.Threading.ThreadAbortException)
        {
        }
        catch (Exception objExcep)
        {
            ALSolutionCommonExtension.DumpExceptionAndRedirectToErrorPage(objExcep, null, "", true, "", "&JS_CloseOnOk=TRUE", null);
        }
    }

    protected override void Render(HtmlTextWriter writer)
    {
        try
        {
            if (IsPostBack)
            {                
                Ajax.WriteControlHTMl(Page, writer);
            }
            else
                base.Render(writer);
        }
        catch (System.Threading.ThreadAbortException)
        {
        }
        catch (Exception objExcep)
        {
            ALSolutionCommonExtension.DumpExceptionAndRedirectToErrorPage(objExcep, null, "", true, "", "&JS_CloseOnOk=TRUE", null);
        }
    }
    #endregion

    #region Private Methods
    private void GetInstanceErrorDetails(out String ErrorDetailsXML)
    {
        StringBuilder               sbSessionInfo           = null;
        StringBuilder               sbInputXML              = null;
        String                      ErrorXML                = null;
        String                      OutputXML               = null;
        SearchConfiguration         SearchObj               = null;

        ErrorDetailsXML = null;
        sbSessionInfo = new StringBuilder(16);
        sbSessionInfo.AppendFormat("<SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'></SESSIONINFO>", ALParamObj.Language, ALParamObj.TenantName, ALParamObj.UserID, ALParamObj.SessionID);

        sbInputXML = new StringBuilder(16);
        sbInputXML.AppendFormat(@"<SEARCH>
	                                    <TARGETOBJECT>SCHEDULEDREPORTINSTANCES</TARGETOBJECT>
	                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                        <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                                    <TARGETENTITY>
		                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
                                            <FILTERLIST>
                                                <FILTER>
                                                    <EXPRESSION>SCHEDREPORTINSTANCEID</EXPRESSION>
                                                    <OPERATOR>EQUALTO</OPERATOR>
                                                    <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>		                                                        
                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                </FILTER>                                            
                                            </FILTERLIST>                                            
                                            <SELECTLIST>
			                                    <EXPRESSION>
				                                    <FIELDNAME>ERRORCONFIGURATIONXML</FIELDNAME>
				                                    <ALIAS>ERRORCONFIGURATIONXML</ALIAS>
			                                    </EXPRESSION>                                                
                                            </SELECTLIST>
                                        </TARGETENTITY>{0}
                                    </SEARCH>", sbSessionInfo.ToString(), SCHRptInstanceID);

        SearchObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        ErrorXML = SearchObj.GetHierarchialData(sbInputXML.ToString(), ref OutputXML);
        if (ErrorXML == null)
        {
            ErrorDetailsXML = ALCommon.GetInnerValue(ref OutputXML, "<ERRORCONFIGURATIONXML>", "</ERRORCONFIGURATIONXML>");
        }
    }

    private void createHeaderListXml(ref StringBuilder inputListXml, int n)
    {
        inputListXml.Append("<List Name=\"Error List\" PageSize=\"10\" HeaderHeight=\"30px\" DataHeight=\"25px\" GridLines=\"Yes\" ResultSet=\"Complete\" ErrorMessage=\"No Errors.\" EnableIterators=\"true\" NumberOfRows=\"");
        inputListXml.Append(n);
        inputListXml.Append("\">");
        inputListXml.Append("<Header SelectionType=\"\" SelectionName=\"\" SelectAll=\"\" SelectionColumnName=\"\" DisplayHeader=\"Yes\">");
        inputListXml.Append("<Column Order=\"1\" Name=\"Details\" Width=\"100%\" Align=\"left\" Valign=\"center\" SortDataType=\"Text\" DisplayState=\"Yes\" ApplySort=\"Yes\" RowAlign=\"left\" RowValign=\"center\" UIType=\"HTML\" Target=\"_self\" DisplayValue=\"Message\" DisplayTextID=\"DAM_AssetListWidget_ReasonForFailure\" cssColumnHeader=\"TextHighlightedBlack\"/>");
        inputListXml.Append("</Header>");
        inputListXml.Append("<Data GroupLevel=\"1\">");
    }
    #endregion    
}
