using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Xml.XPath;
using System.Xml;
using System.IO;
using System.Collections.Specialized;
using System.Threading;
using System.Collections.Generic;

#region Assetlink Includes
using Assetlink;
using Assetlink.Solutions;
using Assetlink.Widgets.WidgetCommon;
using Assetlink.CustomControls;
using Assetlink.Solutions.Pages;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.DAMFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;

#endregion

//------------------------------------------------------------------------//
// File Name:   TermsandConditions.aspx.cs                                //
// Author:      Mr. Pravin Shinde                                         //
// Class:       Common_ASPX_ViewOrginal_TermsandConditions                //
// Created On:  31st March 2009                                           //
//------------------------------------------------------------------------//
namespace Assetlink.Solutions
{
    using ERRORXML = String;
    public partial class TermsandConditions : ALAjaxPage
    {

        # region Member Variables
        ALSolutionCommon                ALSolutionCommonObj                 = null;
        ALParam                         ALParamObj                          = null;
        String                          SolutionName                        = null;
        String                          DigitalAssetID                      = null;
        String                          AuditingSolutionName                = null;
        String                          IsCurrentVersion                    = null;
        Boolean                         isStampAudit                        = false;
        DAMCommonFunctions              Obj_DAMCommonFunctions              = null;
        DAMHelper                       DAMHelperObj                        = null;
        ulong                           ErrorID                             = 0;
        String                          DownloadType                        = null;
        String                          ParentSectionID                     = null;
        String                          MaxAccessRights                     = null;
        String                          RevisionID                          = null;
        String                          str_AllowDownloadOfExpiredAssets    = "false";
        XPathDocument                   xpDoc_SearchResult                  = null;
        XPathNavigator                  xpNav_RootSearchResult              = null;
        String                          DownloadPageURL                     = null;
        String                          CheckForCrossVault                  = null;
        String                          AssetListMode                       = null;
        String                          TempFilePath                        = null;
        String                          str_VaultName                       = null;
        FormFacade                      objFormFacade                       = null;
        List<ObjectInfo>                ObjectInfoList                      = null;
        Boolean                         IsTandCSEnabled                     = false;
        Boolean                         IsTrackReasonForDownloadEnabled     = false;
        Boolean                         IsTandCSAvailable                   = true;
        DamCommon                       obj_DamCommon                       = null;
		String                          str_IsTandCSEnabled                 = null;
        public String TenantName = null;
        #endregion

        #region Properties
        public String VaultID
        {
            get
            {
                String Buffer = (String)ViewState["VaultID"];
                return ((Buffer == null) ? String.Empty : Buffer);
            }
            set
            {
                ViewState["VaultID"] = value;
            }
        }
        #endregion

        #region Protected Methods
        protected override void OnPreInit(EventArgs e)
        {
            initializeURLParameters();    
            String ThemeName = null;
            ThemeName        = ALSolutionCommonObj.GetParamValue("ThemeName");
            if (!String.IsNullOrEmpty(ThemeName))
                Page.Theme = ThemeName;

            if (String.IsNullOrEmpty(ALParamObj.SolutionName))
                ALParamObj.SolutionName = "DAM";
            base.OnPreInit(e);
        }

        protected override void InitializeCulture()
        {
            ALSolutionCommonObj = new ALSolutionCommon();
            ALParamObj          = new ALParam();

            ALSolutionCommonObj.httpContext = HttpContext.Current;
            ALSolutionCommonObj.InitALParam(ref ALParamObj);

            Page.UICulture = Localization.GetCultureName(ALParamObj.Language, ALParamObj.TenantName);
            Localization.SetCultureForPage(ALParamObj.Language, ALParamObj.TenantName);

            Page.Title = Localization.GetString("ALResource", ALParamObj.TenantName, "DAM_DownloadOriginal_Shared");
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            Page.Header.DataBind();
            initializeSettings();           // get all the standard paths like Installation Directory, TempFile Path
            initializeControls();           // get the controls and set properties of controls
            initializeClientSideEvents();   // all the javascript call on the controls
            initializeServerSideEvents();   // all the event handlers assigned to controls
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            #region Check IsSessionValid
            if (!IsSessionValid())
            {
                String RedirectUrl = null;

                DAMHelperObj.GetShowErrorPageUrlForSessionInvalid(ref RedirectUrl);

                if (IsPostBack)
                {

                    Ajax.Redirect(this.Page, RedirectUrl);
                }
                else
                {
                    Response.Redirect(RedirectUrl);
                }
            }
            #endregion 
            if (!IsPostBack)
            {
                ManageScreenLayout();
                SetDigitalAssetDetails();
            }
            SetActionBarInputXML();
        }

        protected override void Render(HtmlTextWriter writer)
        {
            if ((IsPostBack) && (Ajax.EventGeneratorUniqueID != null) && (!Ajax.IsNonAjaxPostback))
            {
                Ajax.AddControlsToRender(Div_TC);
                Ajax.AddControlsToRender(Div_downloadLink);
                Ajax.WriteControlHTMl(this.Page, writer);
            }
            else
            {
                base.Render(writer);
            }
        }
        #endregion

        #region Event Handlers
        void actionbar_ReasonForDownload_Click(object sender, EventArgs e)
        {
            String          ParameterString     = null;
            String[]        Parameters          = null;
            String[]        Separator           = null;
            String          DataXML             = null;
            String          ErrorXML            = null;
            ulong           ErrorID             = 0;
            String          TermsAndCSAccepted  = null;
            String          FormConfigXMLPath   = null;
            String          FormName            = null;
            String          ErrorPageURL        = null;


            try
            {
                if (Request["__EventArgument"] != null)
                    TermsAndCSAccepted = Request["__EventArgument"].ToString();
                Separator       = new String[1] { "$AL$" };
                ParameterString = (String)sender;
                Parameters      = ParameterString.Split(Separator, 3, StringSplitOptions.RemoveEmptyEntries);

                switch (Parameters[1])
                {
                    case "BTN_Save":
                        {
                            objFormFacade = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            GetFormConfigXMLPath(ref FormConfigXMLPath, ref FormName);
                            objFormFacade.ShowConfiguredFields = true;

                            objFormFacade.FormName              = FormName;
                            objFormFacade.SolutionName          = ALParamObj.SolutionName;
                            objFormFacade.ConfigurationXMLType  = "XMLPath";
                            objFormFacade.ConfigurationXML      = FormConfigXMLPath;

                            ErrorXML = objFormFacade.GetFormDataXML("Create", "DATAFIELD", ALFORM_RFD, ObjectInfoList, out DataXML);
                            if (!String.IsNullOrEmpty(ErrorXML) || String.IsNullOrEmpty(DataXML))
                            {
                                ErrorID         = ALSolutionCommon.DumpErrorInfo("DAM_ReasonForDownload.aspx", "GetFormDataXML", ErrorXML);
                                ErrorXML        = ALSolutionCommon.PrepareErrorXML("DAM_REASONFORDOWNLOAD_AUDITFORMDATAXMLREADFAILED", "");
                                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", null, "DAMSOLUTION", ErrorXML, null, null, null, ref ErrorPageURL);
                                ErrorPageURL    = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                                Ajax.Redirect(this.Page, ErrorPageURL);
                            }

                            SetAuditInfo(DataXML);

                            if (!String.IsNullOrEmpty(TermsAndCSAccepted))
                                RedirectToDownloadPage(true);
                            else
                                RedirectToDownloadPage(false);
                        }
                        break;
                }
            }
            catch (ThreadAbortException )
            {
            }
            catch (Exception )
            {

            }
        }

        void ActionBar_Click(object sender, EventArgs e)
        {
            String      ParameterString = null;
            String[]    Parameters      = null;
            String[]    Separator       = null;

            try
            {
                Separator           = new String[1] { "$AL$" };
                ParameterString     = (String)sender;
                Parameters          = ParameterString.Split(Separator, 3, StringSplitOptions.RemoveEmptyEntries);

                switch (Parameters[1])
                {
                    case "BTN_Accept":
                        {
                            if (isStampAudit && !IsTrackReasonForDownloadEnabled)
                                RedirectToDownloadPage(true);
                            else
                            {                                
                                ALBase_TermsAndCS.Visible = false;
                                BC_DownloadFile.Visible = true;
                                link_downloadAsset.Attributes.Add("href", GetDownloadPageURL());                
                            }
                        }
                        break;
                }
            }
            catch (Exception )
            {

            }
        }
        #endregion

        #region Private Functions
        private void initializeURLParameters()
        {
            TenantName  = ALParamObj.TenantName;
            SolutionName = ALParamObj.SolutionName;
            if (String.IsNullOrEmpty(ALParamObj.SolutionName))
            {
                SolutionName = "DAM";
            }
            
            VaultID                             = ALSolutionCommonObj.GetParamValue("VaultID");
            DigitalAssetID                      = ALSolutionCommonObj.GetParamValue("DigitalAssetID");
            AuditingSolutionName                = ALSolutionCommonObj.GetParamValue("AuditingSolutionName");
            AuditingSolutionName                = Server.UrlDecode(AuditingSolutionName);
            IsCurrentVersion                    = ALSolutionCommonObj.GetParamValue("IsCurrentVersion");
            DownloadType                        = ALSolutionCommonObj.GetParamValue("DownloadType");
            RevisionID                          = ALSolutionCommonObj.GetParamValue("RevisionID");
            MaxAccessRights                     = ALSolutionCommonObj.GetParamValue("MaxAccessRights");
            ParentSectionID                     = ALSolutionCommonObj.GetParamValue("ParentSectionID");
            str_AllowDownloadOfExpiredAssets    = ALSolutionCommonObj.GetParamValue("AllowDownloadOfExpiredAssets"); 
            DownloadPageURL                     = ALSolutionCommonObj.GetParamValue("DownloadPageURL");
            CheckForCrossVault                  = ALSolutionCommonObj.GetParamValue("CheckForCrossVault");
            AssetListMode                       = ALSolutionCommonObj.GetParamValue("AssetListMode");
            TempFilePath                        = ALSolutionCommonObj.GetParamValue("TempFilePath");
            str_IsTandCSEnabled                 = ALSolutionCommonObj.GetParamValue("IsTandCSEnabled");

            if (String.IsNullOrEmpty(IsCurrentVersion) && String.IsNullOrEmpty(RevisionID))
                IsCurrentVersion = "TRUE";

            if (String.IsNullOrEmpty(str_AllowDownloadOfExpiredAssets))
                str_AllowDownloadOfExpiredAssets = "false";
        }

        private void initializeSettings()
        {
            Obj_DAMCommonFunctions = new DAMCommonFunctions(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            if (ALSolutionCommonExtension.IsAuditingEnabled(this.Page, ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language))
            {
                isStampAudit = true;
            }

            if (Obj_DAMCommonFunctions.isTrackReasonForDownload())
            {
                IsTrackReasonForDownloadEnabled = true;
            }

            if (str_IsTandCSEnabled == null)
            {
                if (ALParamObj.SolutionName == "DAM")
                {
                    if (DAMCommonFunctions.IsTermsAndConditionsEnabled(ALParamObj.TenantName, ALParamObj.SessionID, ALParamObj.SolutionName, this.Page))
                    {
                        IsTandCSEnabled = true;
                    }
                }
            }
            else
            {
                Boolean.TryParse(str_IsTandCSEnabled, out IsTandCSEnabled);
            }

            DAMHelperObj = new DAMHelper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            bool IsAssetExpiryEnabled = DAMCommonFunctions.IsAssetExpiryEnabled(ALParamObj.TenantName, ALParamObj.SessionID, ALParamObj.SolutionName, ALParamObj.Language, ALParamObj.UserID, this.Page);
            if (!IsAssetExpiryEnabled || ((String.Compare(str_AllowDownloadOfExpiredAssets, "true", true) == 0) && IsAssetExpiryEnabled))
            {
                DAMHelperObj.AllowDownloadOfExpiredAsset = true; 
            }
            

        }

        private void initializeControls()
        {
            ALBase_TermsAndCS.TenantName    = ALParamObj.TenantName;
            ALBase_TermsAndCS.CaptionText   = Localization.GetString("ALResource", TenantName, "DAM_ApplicationPreferences_TermsAndConditions"); 
            ActionBar.TenantName            = ALParamObj.TenantName;
            ActionBar.Click+=new EventHandler(ActionBar_Click);

            BC_DownloadFile.TenantName      = ALParamObj.TenantName;
            BC_DownloadFile.CaptionText     = String.Format(" {0}", Localization.GetString("ALResource", TenantName, "DAM_AssetListWidget_FileToBeDownloaded"));
            Lbl_downloadAsset.Text          =  Localization.GetString("ALResource", TenantName, "DAM_DownloadZipFiles_ClickToDownload");
            BC_DownloadFile.Visible         = false;
            String spaceFilePath = String.Format("/{0}/App_Themes/{1}/images/spacer.gif", TenantName, Page.Theme);
            Img2.Attributes.Add("src", spaceFilePath);
        }

        private void initializeClientSideEvents()
        {

        }

        private void initializeServerSideEvents()
        {

        }

        private void GetTermsAndConditons()
        {
            String              str_FilePath            = null;
            String              str_SearchResult        = null;
            StringBuilder       sb_SearchInputXML       = null;
            StringBuilder       sb_Xpath                = null;
            SearchConfiguration obj_SearchConfiguration = null;
            ERRORXML            ErrorXML                = null;
            XPathNavigator      xpNav_FileSystem        = null;
            XPathNavigator      xpNav_VaultTandCSType   = null;
            String              ErrorPageURL            = null;
            String              str_XpathAssetRendition = null;
            XPathNavigator      xpNav_AssetExpired      = null;
            XPathNavigator      xpNav_MarkedAsDeleted   = null;
            XPathNavigator      xpNav_AssetLocked       = null;
            String              str_ErrorCode           = null;
            try
            {

                switch (DownloadType)
                {
                    case "SingleFileDownload":
                        {
                            #region SingleFileDownload
                            sb_SearchInputXML = new StringBuilder(300);
                            obj_SearchConfiguration = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);


                            #region Prepare Header nodes of Search Input XML
                            sb_SearchInputXML.AppendFormat(@"<SEARCH>
	                                <SESSIONINFO TenantName=""{0}"" Language=""{1}"" UserID=""{2}"" SessionID=""{3}""/>
	                                <TARGETOBJECT>DIGITALASSET</TARGETOBJECT>
	                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
	                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                                <MAXRESULTSIZE>1</MAXRESULTSIZE>
	                                <TARGETENTITY>
		                                <PRIVILEGENAME>READ</PRIVILEGENAME>
		                                <FILTERLIST>
			                                <FILTER>
				                                <FILTERID>1</FILTERID>
				                                <EXPRESSION>DIGITALASSETID</EXPRESSION>
				                                <OPERATOR>EQUALTO</OPERATOR>
				                                <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
				                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                                </FILTER>
		                                </FILTERLIST>", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.UserID, ALParamObj.SessionID, DigitalAssetID);
                            #endregion

                            if (String.Compare(IsCurrentVersion, "TRUE", true) == 0)
                            {

                                sb_SearchInputXML.AppendFormat(@"<RELATIONSHIP NAME='DIGITALASSET_CURRENTREVISION'>
	                                                            <SELECTLIST>
		                                                            <EXPRESSION>
			                                                            <FIELDNAME>CONTENTREVISIONID</FIELDNAME>
			                                                            <ALIAS>CONTENTREVISIONID</ALIAS>
		                                                            </EXPRESSION>
		                                                            <EXPRESSION>
			                                                            <FIELDNAME>VERSIONNUMBER</FIELDNAME>
			                                                            <ALIAS>VERSIONNUMBER</ALIAS>
		                                                            </EXPRESSION>
	                                                            </SELECTLIST>
                                                                <RELATIONSHIP NAME='CONTENTREVISION_RENDITION'>
                                                                <FILTERLIST>
	                                                                <FILTER>
		                                                                <FILTERID>1</FILTERID>
		                                                                <EXPRESSION>RENDITIONTYPE</EXPRESSION>
		                                                                <OPERATOR>EQUALTO</OPERATOR>
		                                                                <EXPRESSIONVALUE>Original</EXPRESSIONVALUE>
		                                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                                </FILTER>
                                                                </FILTERLIST>");

                                str_XpathAssetRendition = "DIGITALASSETCOLLECTION/DIGITALASSET/DIGITALASSET_CURRENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION";

                                #region Prepare Search Input XML for current version
                                sb_SearchInputXML.Append(@"<SELECTLIST>
					                                <EXPRESSION>
						                                <FIELDNAME>ASSETRENDITIONID</FIELDNAME>
						                                <ALIAS>ASSETRENDITIONID</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>NAME</FIELDNAME>
						                                <ALIAS>NAME</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>FILENAME</FIELDNAME>
						                                <ALIAS>FILENAME</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>ACTUALFILE</FIELDNAME>
						                                <ALIAS>ACTUALFILE</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>FILEFORMAT</FIELDNAME>
						                                <ALIAS>FILEFORMAT</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>FILESIZE</FIELDNAME>
						                                <ALIAS>FILESIZE</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>RENDITIONTYPE</FIELDNAME>
						                                <ALIAS>RENDITIONTYPE</ALIAS>
					                                </EXPRESSION>
                                                    <EXPRESSION>
						                                <FIELDNAME>HEIGHT</FIELDNAME>
						                                <ALIAS>HEIGHT</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>WIDTH</FIELDNAME>
						                                <ALIAS>WIDTH</ALIAS>
					                                </EXPRESSION>
				                                </SELECTLIST>
			                                </RELATIONSHIP>
                                             </RELATIONSHIP>
                                            <RELATIONSHIP NAME=""SECTION_DIGITALASSET"">
			                                    <SELECTLIST>
				                                    <EXPRESSION>
					                                    <FIELDNAME>NAME</FIELDNAME>
					                                    <ALIAS>NAME</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>PATH</FIELDNAME>
					                                    <ALIAS>PATH</ALIAS>
				                                    </EXPRESSION>
			                                    </SELECTLIST>
                                                 <RELATIONSHIP NAME='SECTION_VAULT'>
	                                                <SELECTLIST>
		                                                <EXPRESSION>
			                                                <FIELDNAME>VAULTID</FIELDNAME>
			                                                <ALIAS>VAULTID</ALIAS>
		                                                </EXPRESSION>
                                                        <EXPRESSION>
			                                                <FIELDNAME>NAME</FIELDNAME>
			                                                <ALIAS>NAME</ALIAS>
		                                                </EXPRESSION>
                                                        <EXPRESSION>
						                                    <FIELDNAME>TERMSANDCONDITIONSTYPE</FIELDNAME>
						                                    <ALIAS>TERMSANDCONDITIONSTYPE</ALIAS>
					                                     </EXPRESSION>
					                                     <EXPRESSION>
						                                        <FIELDNAME>TERMSANDCONDITIONSFILE</FIELDNAME>
						                                        <ALIAS>TERMSANDCONDITIONSFILE</ALIAS>
					                                     </EXPRESSION>
	                                                </SELECTLIST>
			                                    </RELATIONSHIP>
		                                    </RELATIONSHIP>
                                            <SELECTLIST>
			                                        <EXPRESSION>
				                                        <FIELDNAME>DIGITALASSETID</FIELDNAME>
				                                        <ALIAS>DIGITALASSETID</ALIAS>
			                                        </EXPRESSION>
			                                        <EXPRESSION>
				                                        <FIELDNAME>NAME</FIELDNAME>
				                                        <ALIAS>NAME</ALIAS>
			                                        </EXPRESSION>
			                                        <EXPRESSION>
				                                        <FIELDNAME>ISLOCKED</FIELDNAME>
				                                        <ALIAS>ISLOCKED</ALIAS>
			                                        </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>ASSETEXPIRED</FIELDNAME>
                                                        <ALIAS>ASSETEXPIRED</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>MARKEDASDELETED</FIELDNAME>
                                                        <ALIAS>MARKEDASDELETED</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
				                                        <FIELDNAME>EXPIRYDATE</FIELDNAME>
				                                        <ALIAS>EXPIRYDATE</ALIAS>
			                                        </EXPRESSION>        
		                                        </SELECTLIST>
	                                        </TARGETENTITY>
                                        </SEARCH>
                                        ");
                                #endregion
                            }
                            else
                            {
                                str_XpathAssetRendition = "DIGITALASSETCOLLECTION/DIGITALASSET/DIGITALASSET_CONTENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION";

                                #region Prepare Search Input XML for specified version
                                sb_SearchInputXML.AppendFormat(@"
                                        <RELATIONSHIP NAME=""DIGITALASSET_CONTENTREVISION"">
                                            <SELECTLIST>
                                                <EXPRESSION>
                                                    <FIELDNAME>CONTENTREVISIONID</FIELDNAME>
                                                    <ALIAS>CONTENTREVISIONID</ALIAS>
                                                </EXPRESSION>
                                                <EXPRESSION>
                                                    <FIELDNAME>VERSIONNUMBER</FIELDNAME>
                                                    <ALIAS>VERSIONNUMBER</ALIAS>
                                                </EXPRESSION>
                                            </SELECTLIST>
                                            <FILTERLIST>
                                                <FILTER>
					                                <EXPRESSION>CONTENTREVISIONID</EXPRESSION>
					                                <OPERATOR>EQUALTO</OPERATOR>
					                                <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
					                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
				                                </FILTER>
                                            </FILTERLIST>
                                            <RELATIONSHIP NAME=""CONTENTREVISION_RENDITION"">
                                                <FILTERLIST>
                                                    <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <EXPRESSION>RENDITIONTYPE</EXPRESSION>
                                                        <OPERATOR>IN</OPERATOR>
                                                        <EXPRESSIONVALUE>('{1}','{2}')</EXPRESSIONVALUE>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                </FILTERLIST>
                                                <SELECTLIST>
                                                    <EXPRESSION>
                                                        <FIELDNAME>ASSETRENDITIONID</FIELDNAME>
                                                        <ALIAS>ASSETRENDITIONID</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>NAME</FIELDNAME>
                                                        <ALIAS>NAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>FILENAME</FIELDNAME>
                                                        <ALIAS>FILENAME</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>ACTUALFILE</FIELDNAME>
                                                        <ALIAS>ACTUALFILE</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>FILEFORMAT</FIELDNAME>
                                                        <ALIAS>FILEFORMAT</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>FILESIZE</FIELDNAME>
                                                        <ALIAS>FILESIZE</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
                                                        <FIELDNAME>RENDITIONTYPE</FIELDNAME>
                                                        <ALIAS>RENDITIONTYPE</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
						                                <FIELDNAME>HEIGHT</FIELDNAME>
						                                <ALIAS>HEIGHT</ALIAS>
					                                </EXPRESSION>
					                                <EXPRESSION>
						                                <FIELDNAME>WIDTH</FIELDNAME>
						                                <ALIAS>WIDTH</ALIAS>
					                                </EXPRESSION>
                                                </SELECTLIST>
                                            </RELATIONSHIP>
                                        </RELATIONSHIP>
                                        <RELATIONSHIP NAME=""SECTION_DIGITALASSET"">
			                                    <SELECTLIST>
				                                    <EXPRESSION>
					                                    <FIELDNAME>NAME</FIELDNAME>
					                                    <ALIAS>NAME</ALIAS>
				                                    </EXPRESSION>
				                                    <EXPRESSION>
					                                    <FIELDNAME>PATH</FIELDNAME>
					                                    <ALIAS>PATH</ALIAS>
				                                    </EXPRESSION>
			                                    </SELECTLIST>
                                                 <RELATIONSHIP NAME='SECTION_VAULT'>
	                                                <SELECTLIST>
		                                                <EXPRESSION>
			                                                <FIELDNAME>VAULTID</FIELDNAME>
			                                                <ALIAS>VAULTID</ALIAS>
		                                                </EXPRESSION>
                                                        <EXPRESSION>
			                                                <FIELDNAME>NAME</FIELDNAME>
			                                                <ALIAS>NAME</ALIAS>
		                                                </EXPRESSION>
                                                        <EXPRESSION>
						                                     <FIELDNAME>TERMSANDCONDITIONSTYPE</FIELDNAME>
						                                     <ALIAS>TERMSANDCONDITIONSTYPE</ALIAS>
					                                    </EXPRESSION>
					                                    <EXPRESSION>
						                                     <FIELDNAME>TERMSANDCONDITIONSFILE</FIELDNAME>
						                                     <ALIAS>TERMSANDCONDITIONSFILE</ALIAS>
					                                    </EXPRESSION>
	                                                </SELECTLIST>
			                                    </RELATIONSHIP>
		                                </RELATIONSHIP>
                                        <SELECTLIST>
                                            <EXPRESSION>
                                                <FIELDNAME>DIGITALASSETID</FIELDNAME>
                                                <ALIAS>DIGITALASSETID</ALIAS>
                                            </EXPRESSION>
                                            <EXPRESSION>
                                                <FIELDNAME>NAME</FIELDNAME>
                                                <ALIAS>NAME</ALIAS>
                                            </EXPRESSION>
                                            <EXPRESSION>
                                                <FIELDNAME>ISLOCKED</FIELDNAME>
                                                <ALIAS>ISLOCKED</ALIAS>
                                            </EXPRESSION>
                                            <EXPRESSION>
                                                <FIELDNAME>ASSETEXPIRED</FIELDNAME>
                                                <ALIAS>ASSETEXPIRED</ALIAS>
                                            </EXPRESSION>
                                            <EXPRESSION>
                                                <FIELDNAME>MARKEDASDELETED</FIELDNAME>
                                                <ALIAS>MARKEDASDELETED</ALIAS>
                                            </EXPRESSION>
                                        </SELECTLIST>
                                    </TARGETENTITY>
                                </SEARCH>", RevisionID, "Original","Thumbnail");
                                #endregion
                            }
                            ErrorXML = obj_SearchConfiguration.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchResult);
                            if (!String.IsNullOrEmpty(ErrorXML))
                            {
                                ErrorID             = ALSolutionCommon.DumpErrorInfo("TermsandConditions.ASPX", "GetTermsAndConditions", ErrorXML);
                                ErrorXML            = ALSolutionCommon.PrepareErrorXML("TERMSANDCONDITIONS_VAULTSPECIFIC_READFAILED", "");
                                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", null, "DAMSOLUTION", ErrorXML, null, null, null, ref ErrorPageURL);
                                ErrorPageURL        = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                                Redirect(ErrorPageURL);
                            }

                            ViewState["SearchResultXML"]    = str_SearchResult;
                            ViewState["Xpath"]              = str_XpathAssetRendition;
                            xpDoc_SearchResult              = new XPathDocument(new StringReader(str_SearchResult));
                            xpNav_RootSearchResult          = xpDoc_SearchResult.CreateNavigator();

                            //Check if Asset is locked/Expired/Deleted
                            str_ErrorCode           = null;
                            xpNav_MarkedAsDeleted   = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/MARKEDASDELETED");
                            if (xpNav_MarkedAsDeleted != null && xpNav_MarkedAsDeleted.Value != "0")
                            {
                                if (xpNav_MarkedAsDeleted.Value == "2")
                                    str_ErrorCode = "DIGITALASSET_DIGITALASSETMARKEDFORPERMANANTDELETE_Shared";
                                else
                                    str_ErrorCode = "DIGITALASSET_DIGITALASSETMARKEDASDELETED_Shared";
                            }
                            else
                            { 
                                xpNav_AssetExpired = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/ASSETEXPIRED");
                                if (xpNav_AssetExpired != null && xpNav_AssetExpired.Value == "1")
                                    str_ErrorCode = "DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETEXPIRED";
                                else
                                {
                                    xpNav_AssetLocked = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/ISLOCKED");
                                    if (xpNav_AssetLocked != null && xpNav_AssetLocked.Value == "1")
                                        str_ErrorCode = "DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETLOCKED";
                                }

                            }
                            if (!String.IsNullOrEmpty(str_ErrorCode))
                            {
                                ErrorXML = ALSolutionCommon.PrepareErrorXML(str_ErrorCode, "");
                                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "DAMSOLUTION", ErrorXML, "", "", "", ref ErrorPageURL);
                                ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                                Redirect(ErrorPageURL);
                            }

                            VaultID                         = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/SECTION_DIGITALASSET/SECTION/SECTION_VAULT/VAULT/VAULTID").Value;
                            sb_Xpath                        = new StringBuilder(100);
                            xpNav_VaultTandCSType           = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/SECTION_DIGITALASSET/SECTION/SECTION_VAULT/VAULT/TERMSANDCONDITIONSTYPE");
                            if (xpNav_VaultTandCSType.Value == "2")
                            {
                                xpNav_FileSystem      = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/SECTION_DIGITALASSET/SECTION/SECTION_VAULT/VAULT/FILESYSTEM/FILE/FIELDNAME[text()='TERMSANDCONDITIONSFILE']");
                                if (xpNav_FileSystem != null)
                                {
                                    xpNav_FileSystem.MoveToParent();
                                    xpNav_FileSystem.MoveToParent();

                                    ErrorXML = Obj_DAMCommonFunctions.GetTermsAndConditionsFile(xpNav_FileSystem.OuterXml, ref str_FilePath);
                                    if (!String.IsNullOrEmpty(ErrorXML))
                                    {
                                        ErrorID         = ALSolutionCommon.DumpErrorInfo("TermsandConditions.ASPX", "GetTermsAndConditionsFile", ErrorXML);
                                        ErrorXML        = ALSolutionCommon.PrepareErrorXML("TERMSANDCONDITIONS_VAULTSPECIFIC_GETFILEFAILED", "");
                                        ALSolutionCommonObj.PrepareErrorPageUrl("DAM", null, "DAMSOLUTION", ErrorXML, null, null, null, ref ErrorPageURL);
                                        ErrorPageURL    = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                                        Redirect(ErrorPageURL);
                                    }
                                    else
                                    {
                                        if (String.Compare(Path.GetExtension(str_FilePath), ".pdf",true) == 0 || String.Compare(Path.GetExtension(str_FilePath), ".html",true) == 0 || String.Compare(Path.GetExtension(str_FilePath), ".htm",true) == 0)
                                        {
                                            str_FilePath =  DAMCommonFunctions.GetTermsandConditionsHTTPPath(str_FilePath);
                                            frame_TermsAndConditionsile.Attributes.Add("src", str_FilePath);
                                            Panel_TermsAndConditionsText.Visible = false;
                                        }
                                        else
                                        {
                                            String TermsAndConditionsText = null;
                                            TermsAndConditionsText = File.ReadAllText(str_FilePath);
                                            literal_TermsAndConditions.Text = TermsAndConditionsText;
                                            literal_TermsAndConditions.DisplayMode = ALLiteralControl.DisplayModeEnum.HTML;
                                            Panel_TermsAndConditionsFile.Visible = false;
                                        }
                                    }
                                }
                            }
                            else
                                if (xpNav_VaultTandCSType.Value == "1")
                                {
                                    GetDefaultTermsAndConditions();
                                }
                                else
                                    if (xpNav_VaultTandCSType.Value == "0" || String.IsNullOrEmpty(xpNav_VaultTandCSType.Value))
                                    {
                                        if (!(isStampAudit && IsTrackReasonForDownloadEnabled))
                                        {
                                            Redirect(GetDownloadPageURL());
                                        }
                                        else
                                        {
                                            IsTandCSAvailable = false;
                                        }
                                    }
                            #endregion
                        } break;
                    case "MultipleFileDownload":
                        {
                            #region MultipleFileDownload
                            if (!String.IsNullOrEmpty(TempFilePath) && File.Exists(TempFilePath))
                            {
                                xpDoc_SearchResult      = new XPathDocument(TempFilePath);
                                xpNav_RootSearchResult  = xpDoc_SearchResult.CreateNavigator();
                                sb_Xpath                = new StringBuilder(100);
                                str_VaultName           = xpNav_RootSearchResult.SelectSingleNode("VAULTCOLLECTION/VAULT/NAME").Value;
                                VaultID                 = xpNav_RootSearchResult.SelectSingleNode("VAULTCOLLECTION/VAULT/VAULTID").Value;
                                xpNav_VaultTandCSType   = xpNav_RootSearchResult.SelectSingleNode("VAULTCOLLECTION/VAULT/TERMSANDCONDITIONSTYPE");
                                if (xpNav_VaultTandCSType.Value == "2")
                                {
                                    xpNav_FileSystem = xpNav_RootSearchResult.SelectSingleNode("VAULTCOLLECTION/VAULT/FILESYSTEM/FILE/FIELDNAME[text()='TERMSANDCONDITIONSFILE']");
                                    if (xpNav_FileSystem != null)
                                    {
                                        xpNav_FileSystem.MoveToParent();
                                        xpNav_FileSystem.MoveToParent();

                                        ErrorXML            = Obj_DAMCommonFunctions.GetTermsAndConditionsFile(xpNav_FileSystem.OuterXml, ref str_FilePath);
                                        if (!String.IsNullOrEmpty(ErrorXML))
                                        {
                                            ErrorID         = ALSolutionCommon.DumpErrorInfo("TermsandConditions.ASPX", "GetTermsAndConditionsFile", ErrorXML);
                                            ErrorXML        = ALSolutionCommon.PrepareErrorXML("TERMSANDCONDITIONS_VAULTSPECIFIC_GETFILEFAILED", "");
                                            ALSolutionCommonObj.PrepareErrorPageUrl("DAM", null, "DAMSOLUTION", ErrorXML, null, null, null, ref ErrorPageURL);
                                            ErrorPageURL    = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                                            Redirect(ErrorPageURL);
                                        }
                                        else
                                        {
                                            if (String.Compare(Path.GetExtension(str_FilePath), ".pdf", true) == 0 || String.Compare(Path.GetExtension(str_FilePath), ".html",true) == 0 || String.Compare(Path.GetExtension(str_FilePath), ".htm", true) == 0)
                                            {
                                                str_FilePath = DAMCommonFunctions.GetTermsandConditionsHTTPPath(str_FilePath);

                                                frame_TermsAndConditionsile.Attributes.Add("src", str_FilePath);
                                                Panel_TermsAndConditionsText.Visible = false;
                                            }
                                            else
                                            {
                                                String TermsAndConditionsText           = null;
                                                TermsAndConditionsText                  = File.ReadAllText(str_FilePath);
                                                literal_TermsAndConditions.Text         = TermsAndConditionsText;
                                                literal_TermsAndConditions.DisplayMode  = ALLiteralControl.DisplayModeEnum.HTML;
                                                Panel_TermsAndConditionsFile.Visible    = false;
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    GetDefaultTermsAndConditions();
                                }
                            }
                            else
                            {
                                GetDefaultTermsAndConditions();
                            }
                            #endregion
                        } break;


                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception obj_Exception)
            {
                ErrorID         = ALSolutionCommon.DumpExceptionInfo(this.Page, "TermsandConditions.ASPX", "GetTermsAndConditions", obj_Exception, "", "");
                ErrorXML        = ALSolutionCommon.PrepareErrorXML("TERMSANDCONDITIONS_GETTERMSANDCONDITIONS_EXCEPTION", "");
                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", null, "DAMSOLUTION", ErrorXML, null, null, null, ref ErrorPageURL);
                ErrorPageURL    = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                Redirect(ErrorPageURL);
            }
        }

        private bool IsSessionValid()
        {
            bool m_IsSessionValid = false;
            String ErrorXml = "";
            InfrastructureFacadeClass ObjINFI = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

            ErrorXml = ObjINFI.IsSessionValid(ref m_IsSessionValid);
            if (String.IsNullOrEmpty(ErrorXml))
                return m_IsSessionValid;
            return false;
        }

        private void GetDefaultTermsAndConditions()
        {
            StringDictionary    dict_SettingswithXpath  = null;
            StringDictionary    dict_SettingsValue      = null;
            String              FilePath                = null;

            dict_SettingswithXpath = new StringDictionary();
            dict_SettingswithXpath.Add("FILEPATH","TERMSANDCONDITIONS/FILEPATH");
            dict_SettingsValue = new StringDictionary();

            DAMCommonFunctions.GetDAMApplicationPreferencesSettings(ALParamObj.TenantName, dict_SettingswithXpath, out dict_SettingsValue);

            FilePath = dict_SettingsValue["FILEPATH"]; 

            if (!String.IsNullOrEmpty(FilePath) && File.Exists(FilePath))
            {

                if (String.Compare(Path.GetExtension(FilePath), ".pdf",true) == 0 || String.Compare(Path.GetExtension(FilePath), ".html",true) == 0 || String.Compare(Path.GetExtension(FilePath), ".htm",true) == 0)
                {
                    FilePath = DAMCommonFunctions.GetTermsandConditionsHTTPPath(FilePath);

                    frame_TermsAndConditionsile.Attributes.Add("src", FilePath);
                    Panel_TermsAndConditionsText.Visible = false;
                }
                else
                {
                    String TermsAndConditionsText = null;
                    TermsAndConditionsText = File.ReadAllText(FilePath);
                    literal_TermsAndConditions.Text = TermsAndConditionsText;
                    literal_TermsAndConditions.DisplayMode = ALLiteralControl.DisplayModeEnum.HTML;
                    Panel_TermsAndConditionsFile.Visible = false;
                }
            }
            else
            {
                if (!(isStampAudit && IsTrackReasonForDownloadEnabled))
                {
                    Redirect(GetDownloadPageURL());
                }
                else
                {
                    IsTandCSAvailable = false;
                }
            }
        }

        private String GetDownloadPageURL()
        {
            #region member variable
            String         ErrorXML                   = "";
            String         FileDownloadURL            = "";
            String         AuditXml                   = null;
            String         str_Xpath                  = null;
            String         ErrorPageURL               = null;
            DamCommon      ObjDamCommon               = null;
            StringBuilder  IncrementeDownloadInputXML = null;
            #endregion

            if (xpDoc_SearchResult == null && ViewState["SearchResultXML"] != null)
            {
                xpDoc_SearchResult      = new XPathDocument(new StringReader(ViewState["SearchResultXML"].ToString()));
                xpNav_RootSearchResult  = xpDoc_SearchResult.CreateNavigator();
            }
            
            if (ViewState["Xpath"] != null)
                str_Xpath = ViewState["Xpath"].ToString();

            bool IsAuditEnabled = ALSolutionCommonExtension.IsAuditingEnabled(this.Page, ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            ErrorXML            = DAMHelperObj.PrepareDigitalAssetDownloadUrl(xpNav_RootSearchResult, str_Xpath, DigitalAssetID, "Original","",AuditingSolutionName,IsAuditEnabled, RevisionID, ref FileDownloadURL, ref AuditXml);
            if (!String.IsNullOrEmpty(ErrorXML))
            {
                if (ErrorXML.Equals("DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETLOCKED") || ErrorXML.Equals("DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETEXPIRED")
                                   || ErrorXML.Equals("DIGITALASSET_DIGITALASSETMARKEDASDELETED_Shared") || ErrorXML.Equals("DIGITALASSET_DIGITALASSETMARKEDFORPERMANANTDELETE_Shared"))
                    ErrorXML = ALSolutionCommon.PrepareErrorXML(ErrorXML, "");

                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "DAMSOLUTION", ErrorXML, "", "", "", ref ErrorPageURL);
                ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                Redirect(ErrorPageURL);
            }
            if (IsAuditEnabled && !String.IsNullOrEmpty(AuditXml))
            {
                Session["AuditInputXml"] = AuditXml;
            }

            if (!String.IsNullOrEmpty(FileDownloadURL))
            {                
                //Increment Download Count
                IncrementeDownloadInputXML = new StringBuilder();
                IncrementeDownloadInputXML.AppendFormat("<DIGITALASSETCOLLECTION><DIGITALASSET><DIGITALASSETID>{0}</DIGITALASSETID></DIGITALASSET></DIGITALASSETCOLLECTION>", DigitalAssetID);
                ObjDamCommon               = new DamCommon(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Page.Theme);
                ErrorXML                   = ObjDamCommon.IncrementDownloadCount(IncrementeDownloadInputXML.ToString());
                if (!String.IsNullOrEmpty(ErrorXML))
                {
                    ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "", ErrorXML, "", "", "", ref ErrorPageURL);
                    ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                    Redirect(ErrorPageURL);
                }
            }
            else
            {
                ErrorXML = ALSolutionCommon.PrepareErrorXML("DAM_DOWLOAD_DIGITALASSETFAILED", "");
                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "DAMSOLUTION", ErrorXML, "", "", "", ref ErrorPageURL);
                ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                Redirect(ErrorPageURL);
            }

            return FileDownloadURL;
        }

        private void SetActionBarInputXML()
        {
            #region member variable
            DAMCommonFunctions DAMCommonFunctionsObj = null;
            StringBuilder sb_ActionBarInputXML = null;
            #endregion


            switch (DownloadType)
            {
                case "SingleFileDownload":
                    {

                        ActionBar.InputXMLType = ActionBar.XMLType.InnerXML;
                        sb_ActionBarInputXML = new StringBuilder(200);
                        sb_ActionBarInputXML.Append(@"<ActionBar> 
                                              <ActionControlList ActionBarType='PageButtonBar'>");

                        sb_ActionBarInputXML.AppendFormat(@"<ActionControl Alignment='left' Tooltip='I Accept' UIType='ALButton' Name='BTN_Accept' Order='0' CausesValidation='False' DisplayTextID='DAM_TermsAndConditions_IAccept' TooltipID='DAM_TermsAndConditions_IAccept'>
                                                        <DisplayText>I Accept</DisplayText>");

                        DAMCommonFunctionsObj = new DAMCommonFunctions(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        bool IsAuditEnabled = ALSolutionCommonExtension.IsAuditingEnabled(this.Page, ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                        if (IsAuditEnabled && IsTrackReasonForDownloadEnabled)
                        {
                            
                            sb_ActionBarInputXML.AppendFormat(@"<Attributes>
                                                    <Attribute>
	                                                    <Name>href</Name>
	                                                    <Value>javascript:ShowReasonForDownload('{0}','{1}');</Value>
                                                    </Attribute>
                                                </Attributes>", ALBase_TermsAndCS.ClientID, ALBase_ReasonForDownload.ClientID);
                        }

                        
                        sb_ActionBarInputXML.Append("</ActionControl>");
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Decline' UIType='ALButton' Name='BTN_Decline' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='DAM_TermsAndConditions_Decline' TooltipID='DAM_TermsAndConditions_Decline'>
                                          <DisplayText>Decline</DisplayText>
                                           <Attributes>
                                            <Attribute>
	                                            <Name>href</Name>
	                                            <Value>javascript:window.close();</Value>
                                            </Attribute>
                                        </Attributes>");
                        sb_ActionBarInputXML.Append("</ActionControl>");
                        sb_ActionBarInputXML.Append(" </ActionControlList></ActionBar>");
                        ActionBar.InputXML = sb_ActionBarInputXML.ToString();
                        sb_ActionBarInputXML.Remove(0, sb_ActionBarInputXML.Length);
                        ALBase_ReasonForDownload.TenantName = ALParamObj.TenantName;
                        ALBase_ReasonForDownload.CaptionText= Localization.GetString("ALResource", TenantName, "DAM_AssetListWidget_PleaseSpecifyReasonforDownload"); 

                        actionbar_ReasonForDownload.TenantName = ALParamObj.TenantName;
                        actionbar_ReasonForDownload.InputXMLType = ActionBar.XMLType.InnerXML;
                        sb_ActionBarInputXML.Remove(0, sb_ActionBarInputXML.Length);
                        sb_ActionBarInputXML.Append(@"<ActionBar> 
                                              <ActionControlList ActionBarType='PageButtonBar'>
                                                <ActionControl Alignment='left' Tooltip='' UIType='ALButton' Name='BTN_Save' Order='0' CausesValidation='False' DisplayTextID='Save_Shared' TooltipID='Save_Shared'>
                                                        <DisplayText>Save</DisplayText>");
                        if (IsAuditEnabled && IsTrackReasonForDownloadEnabled)
                        {
                            
                            sb_ActionBarInputXML.Append(@"<Attributes>
                                                    <Attribute>
	                                                    <Name>href</Name>
	                                                    <Value>javascript:SaveReasonForDownload('$CONTROLID$');</Value>
                                                    </Attribute>
                                                </Attributes>");
                        }
                        sb_ActionBarInputXML.Append("</ActionControl>");
                        sb_ActionBarInputXML.Append(@"<ActionControl Alignment='left' Tooltip='Cancel' UIType='ALButton' Name='BTN_Cancel' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='CancelBtn_Shared' TooltipID='CancelBtn_Shared'>
                                          <DisplayText>Cancel</DisplayText>
                                           <Attributes>
                                            <Attribute>
	                                            <Name>href</Name>
	                                            <Value>javascript:window.close();</Value>
                                            </Attribute>
                                        </Attributes>");
                        sb_ActionBarInputXML.Append(@"</ActionControl>
                                              </ActionControlList></ActionBar>");
                        actionbar_ReasonForDownload.InputXML = sb_ActionBarInputXML.ToString();
                        actionbar_ReasonForDownload.Click += new EventHandler(actionbar_ReasonForDownload_Click);

                        sb_ActionBarInputXML.Remove(0, sb_ActionBarInputXML.Length);
                        sb_ActionBarInputXML.Append(@"<ActionBar>
                                                        <ActionControlList ActionBarType='PageButtonBar'>
                                                            <ActionControl Alignment='center' Tooltip='Decline' UIType='ALButton' Name='BTN_Close' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='Close_Shared' TooltipID='Close_Shared'>
                                                                  <DisplayText>Close</DisplayText>
                                                                   <Attributes>
                                                                    <Attribute>
	                                                                    <Name>href</Name>
	                                                                    <Value>javascript:window.close();</Value>
                                                                    </Attribute>
                                                                </Attributes>
                                                            </ActionControl>
                                                        </ActionControlList>
                                                    </ActionBar>");

                        AB_Close.InputXML = sb_ActionBarInputXML.ToString();
                    } break;
                case "MultipleFileDownload":
                    {
                        if (String.IsNullOrEmpty(TempFilePath))
                            TempFilePath = String.Empty;

                        ActionBar.InputXMLType = ActionBar.XMLType.InnerXML;
                        sb_ActionBarInputXML = new StringBuilder(200);
                        sb_ActionBarInputXML.AppendFormat(@"<ActionBar> 
                                              <ActionControlList ActionBarType='PageButtonBar'>
                                                <ActionControl Alignment='left' Tooltip='I Accept' UIType='ALButton' Name='BTN_Accept' Order='0' CausesValidation='False' DisplayTextID='DAM_TermsAndConditions_IAccept' TooltipID='DAM_TermsAndConditions_IAccept'>
                                                        <DisplayText>I Accept</DisplayText>
                                                        <Attributes>
                                                            <Attribute>
	                                                            <Name>href</Name>
	                                                            <Value>javascript:RedirectToParentPage('Accept','{0}');</Value>
                                                            </Attribute>
                                                        </Attributes>
                                                        </ActionControl>
                                                        <ActionControl Alignment='left' Tooltip='Decline' UIType='ALButton' Name='BTN_Decline' Order='1' CausesValidation='False' EventArgument='' DisplayTextID='DAM_TermsAndConditions_Decline' TooltipID='DAM_TermsAndConditions_Decline'>
                                                        <DisplayText>Decline</DisplayText>
                                                           <Attributes>
                                                            <Attribute>
	                                                            <Name>href</Name>
	                                                            <Value>javascript:window.close();</Value>
                                                            </Attribute>
                                                        </Attributes></ActionControl></ActionControlList></ActionBar>", VaultID);
                        ActionBar.InputXML = sb_ActionBarInputXML.ToString();
                    } break;
            }
          
         
        }
        
        private void Redirect(String URL)
        {
            if (!IsPostBack)
            {
                Response.Redirect(URL);
            }
            else
            {
                Ajax.Redirect(this.Page, URL);
            }
        }

        private void SetDigitalAssetDetails()
        {
            XmlDocument     xmlDoc_Output               = new XmlDocument();
            XmlDocument     xmlDoc_DigitalAsset         = new XmlDocument();
            XmlDocument     xmlDoc_ConfigurationXML     = new XmlDocument();
            StringBuilder   sb_DigitalAssetIDs          = new StringBuilder(100);
            StringBuilder   sb_ImagePathPath            = new StringBuilder(100);
            XmlNode         xmlNod_DigitalAsset         = null;
            String          str_ThubnailFilePath        = null;
            String          str_ItemDescription         = null;
            String          str_AssetName               = null;
            String          str_Height                  = null;
            String          str_Width                   = null;
            Int64           CalHeight                   = Convert.ToInt64(Image_AspectRatio.MaxHeight);
            Int64           CalWidth                    = Convert.ToInt64(Image_AspectRatio.MaxWidth);
            ERRORXML        ErrorXML                    = null;
            ALBase_DigitalAssetDetails.TenantName       = ALParamObj.TenantName;

            sb_DigitalAssetIDs.AppendFormat("<SEARCHOUTPUTXML FirstTimeFlag='TRUE'><DIGITALASSETCOLLECTION><DIGITALASSET><DIGITALASSETID>{0}</DIGITALASSETID></DIGITALASSET></DIGITALASSETCOLLECTION></SEARCHOUTPUTXML>", DigitalAssetID);

            if (String.IsNullOrEmpty(ALParamObj.SolutionName))
                ALParamObj.SolutionName = "DAM";
            
            xmlDoc_DigitalAsset.LoadXml(sb_DigitalAssetIDs.ToString());
            xmlDoc_ConfigurationXML.Load(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, "DAM", "", "FacetFieldSelection"));

            obj_DamCommon               = new DamCommon(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Page.Theme);
            obj_DamCommon.WidgetName    = "DAM_AssetListWidget";
            ErrorXML                    = obj_DamCommon.GetDAMContentsEx(xmlDoc_DigitalAsset, xmlDoc_ConfigurationXML, ref xmlDoc_Output);
            
            if (xmlDoc_Output != null)
            {
                xmlNod_DigitalAsset = xmlDoc_Output.SelectSingleNode("SEARCHOUTPUTXML/DIGITALASSET");
                if (xmlNod_DigitalAsset != null)
                {

                    str_AssetName = xmlNod_DigitalAsset.SelectSingleNode("NAME").InnerText;
                    if (xmlNod_DigitalAsset.SelectSingleNode("ITEMDESCRIPTION") != null)
                        str_ItemDescription = xmlNod_DigitalAsset.SelectSingleNode("ITEMDESCRIPTION").InnerXml;
                    if (String.Compare(IsCurrentVersion, "True", true) == 0)
                    {
                        if (xmlNod_DigitalAsset.SelectSingleNode("THUMBNAILFILE") != null)
                            str_ThubnailFilePath = xmlNod_DigitalAsset.SelectSingleNode("THUMBNAILFILE").InnerText;
                        else
                        {
                            sb_ImagePathPath.AppendFormat("/{0}/App_Themes/{1}/Images/Default_AssetThumbnail.gif", ALParamObj.TenantName, this.Page.Theme);
                            str_ThubnailFilePath = sb_ImagePathPath.ToString();
                        }


                        #region Get Thumbnail height, width according to Aspect ratio
                        XmlNode xmlNod_CurrentThumb = xmlNod_DigitalAsset.SelectSingleNode("DIGITALASSET_CURRENTTHUMBNAILRENDITION/ASSETRENDITION");
                        if (xmlNod_CurrentThumb != null)
                        {
                            if (xmlNod_CurrentThumb.SelectSingleNode("HEIGHT") != null)
                                str_Height = xmlNod_CurrentThumb.SelectSingleNode("HEIGHT").InnerText;

                            if (xmlNod_CurrentThumb.SelectSingleNode("WIDTH") != null)
                                str_Width = xmlNod_CurrentThumb.SelectSingleNode("WIDTH").InnerText;
                        }
                    }
                    else
                    {
                        GetThumbnailForNonCurrentVersions(out str_ThubnailFilePath, out str_Height, out str_Width);
                    }

                    if (!String.IsNullOrEmpty(str_Height) && !(String.IsNullOrEmpty(str_Width)) && (Convert.ToInt64(str_Height) > 0) && (Convert.ToInt64(str_Width) > 0))
                        DamCommon.GetAspectRatio(Convert.ToInt64(Image_AspectRatio.MaxHeight), Convert.ToInt64(Image_AspectRatio.MaxWidth), Convert.ToInt64(str_Height), Convert.ToInt64(str_Width), ref CalHeight, ref CalWidth);
                    #endregion

                    img_DigitalAssetThumb.ImageUrl  = str_ThubnailFilePath;
                    img_DigitalAssetThumb.Height    = Convert.ToUInt16(CalHeight);
                    img_DigitalAssetThumb.Width     = Convert.ToUInt16(CalWidth);

                    Panel_AssetDescriptor.Controls.Add(new LiteralControl(str_ItemDescription));
                    ALBase_DigitalAssetDetails.CaptionText  = Localization.GetString("ALResource", TenantName, "DAM_BatchDownload_PageTitle") + " " + str_AssetName;
                    lit_Asset_Name.Text                     = Localization.GetString("ALResource", TenantName, "DAM_BatchDownload_PageTitle") + " " + str_AssetName;
                }
            }

        }

        private void SetReasonForDownload()
        {
            String ErrorXML = null;
            String FileDownloadURL = null;
            String AuditXml                     = null;
            String ErrorPageURL                 = null;
            ALBase_ReasonForDownload.TenantName = ALParamObj.TenantName;
            if (!IsTandCSEnabled)
            {
                ErrorXML = DAMHelperObj.PrepareDigitalAssetDownloadUrl(DigitalAssetID, "Original", "", AuditingSolutionName, isStampAudit, "", ref FileDownloadURL, ref AuditXml);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    if (isStampAudit && !String.IsNullOrEmpty(AuditXml))
                    {
                        Session["AuditInputXml"] = AuditXml;
                        ViewState["FileDownloadURL"] = FileDownloadURL;
                        GetVaultID(AuditXml);
                    }
                }
                else
                {
                    if (ErrorXML.Equals("DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETLOCKED") || ErrorXML.Equals("DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETEXPIRED")
                                       || ErrorXML.Equals("DIGITALASSET_DIGITALASSETMARKEDASDELETED_Shared") || ErrorXML.Equals("DIGITALASSET_DIGITALASSETMARKEDFORPERMANANTDELETE_Shared"))
                        ErrorXML = ALSolutionCommon.PrepareErrorXML(ErrorXML, "");

                    ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "DAMSOLUTION", ErrorXML, "", "", "", ref ErrorPageURL);
                    ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                    Redirect(ErrorPageURL);
                }
            }
            SetReasonForDownloadForm();
        }

        private void SetReasonForDownloadForm()
        {
            String FormConfigXMLPath = null;
            String FormName = null;
            String ErrorXML = null;
            String FormInputXML = null;
            objFormFacade       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            GetFormConfigXMLPath(ref FormConfigXMLPath, ref FormName);
            objFormFacade.ShowConfiguredFields = true;

            objFormFacade.FormName = FormName;
            objFormFacade.SolutionName = ALParamObj.SolutionName;
            objFormFacade.ConfigurationXMLType = "XMLPath";
            objFormFacade.ConfigurationXML = FormConfigXMLPath;

            ErrorXML = objFormFacade.GetFormInputXML("CREATE", null, out FormInputXML, out ObjectInfoList);
            ALFORM_RFD.TenantName = ALParamObj.TenantName;
            ALFORM_RFD.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.XMLPath;
            ALFORM_RFD.ConfigurationXML = FormConfigXMLPath;
            ALFORM_RFD.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
            ALFORM_RFD.InputXML = FormInputXML;
        }

        private void AddTermsAndCSAcceptedParam(ref String AuditXml)
        {
            XmlNode xmlNod_AuditLog = null;
            XmlElement xmlEle_Param = null;
            XmlNode xmlNod_Vault = null;
            XmlDocument xmlDoc_AuditXML = new XmlDocument();
            xmlDoc_AuditXML.LoadXml(AuditXml);

            xmlNod_AuditLog = xmlDoc_AuditXML.SelectSingleNode("AuditParams");
            if (xmlNod_AuditLog != null)
            {
                
                xmlEle_Param = xmlDoc_AuditXML.CreateElement("Param");
                xmlEle_Param.SetAttribute("Name", "TERMSANDCONDITIONSACCEPTED");
                xmlEle_Param.SetAttribute("Value", "1");
                xmlNod_AuditLog.AppendChild(xmlEle_Param);

                xmlNod_Vault = xmlNod_AuditLog.SelectSingleNode("Param[@Name='VAULTID']");
                if (xmlNod_Vault != null)
                    VaultID = ((XmlElement)xmlNod_Vault).GetAttribute("Value");
            }
            AuditXml = xmlDoc_AuditXML.OuterXml;
        }

        private void SetAuditInfo(String DataXML)
        {
            StringBuilder sb_FilePath = new StringBuilder(100);
            ulong UniqueID = 0;

            if (DataXML.Length < 300)
            {
                Session["DAMAuditInputXML"] = DataXML;
            }
            else
            {
                ALCommon.GenerateUniqueID(ref UniqueID);
                sb_FilePath.AppendFormat(@"{0}{1}_DAMAuditInputXML.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), UniqueID.ToString());
                File.WriteAllText(sb_FilePath.ToString(), DataXML);
                Session["DAMAuditInputXMLPATH"] = sb_FilePath.ToString();
            }
        }

        private void GetFormConfigXMLPath(ref String str_FormPath, ref String FormName)
        {

            StringBuilder sb_FormName = new StringBuilder(100);
            sb_FormName.AppendFormat("{0}_ReasonForDownload_FormConfiguration", VaultID);

            str_FormPath = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName, "DAM", sb_FormName.ToString());
            if (!File.Exists(str_FormPath))
            {
                sb_FormName.Remove(0, sb_FormName.Length);
                sb_FormName.Append("ReasonForDownload_FormConfiguration");
                str_FormPath = ALSolutionCommon.GetFormConfigurationXMLPath(ALParamObj.TenantName, ALParamObj.SolutionName, sb_FormName.ToString());
                if (!File.Exists(str_FormPath))
                {
                    RedirectToDownloadPage(false);
                }
            }
            sb_FormName = sb_FormName.Replace("_FormConfiguration", "");
            FormName = sb_FormName.ToString();
        }

        private void ManageScreenLayout()
        {
            if (String.Compare(DownloadType, "SingleFileDownload", true) == 0)
            {
                if (IsTandCSEnabled)
                {
                    GetTermsAndConditons();
                    if (IsTandCSAvailable)
                        ALBase_ReasonForDownload.Style.Add(HtmlTextWriterStyle.Display, "None");
                    else
                        ALBase_TermsAndCS.Visible = false;
                }
                else
                {
                    ALBase_TermsAndCS.Visible = false;
                }

                if (IsTrackReasonForDownloadEnabled)
                {
                    SetReasonForDownload();
                }
                else
                {
                    ALBase_ReasonForDownload.Visible = false;
                }
            }
            else
            {
                ALBase_DigitalAssetDetails.Visible  = false;
                ALBase_ReasonForDownload.Visible    = false;
                BC_DownloadFile.Visible             = false;
                if (IsTandCSEnabled)
                {
                    GetTermsAndConditons();
                }
                else
                {
                    ALBase_TermsAndCS.Visible = false;
                }
            }
        }

        private void GetVaultID(String AuditXml)
        {
            XPathDocument   xpDoc_Audit         = null;
            XPathNavigator  xpNav_RootAudit     = null;
            XPathNavigator  xpNav_Audit         = null;

            xpDoc_Audit     = new XPathDocument(new StringReader(AuditXml));
            xpNav_RootAudit = xpDoc_Audit.CreateNavigator();

            xpNav_Audit      = xpNav_RootAudit.SelectSingleNode("AuditParams/Param[@Name='VAULTID']");
            if (xpNav_Audit != null)
            {
                VaultID = xpNav_Audit.GetAttribute("Value", "");
            }
        }

        private void RedirectToDownloadPage(Boolean TandCSAccepted)
        {
            String          str_Xpath                   = null;
            String          AuditXml                    = null;
            String          FileDownloadURL             = null;
            String          ErrorXML                    = null;
            String          ErrorPageURL                = null;
            StringBuilder   IncrementeDownloadInputXML  = null;
            DamCommon       ObjDamCommon                = null;

            if (xpDoc_SearchResult == null && ViewState["SearchResultXML"] != null)
            {
                xpDoc_SearchResult      = new XPathDocument(new StringReader(ViewState["SearchResultXML"].ToString()));
                xpNav_RootSearchResult  = xpDoc_SearchResult.CreateNavigator();
                str_Xpath               = ViewState["Xpath"].ToString();
            }

            if (IsTandCSEnabled)
            {
                if (xpNav_RootSearchResult != null)
                {
                    ErrorXML = DAMHelperObj.PrepareDigitalAssetDownloadUrl(xpNav_RootSearchResult, str_Xpath, DigitalAssetID, "Original", "", AuditingSolutionName, isStampAudit, RevisionID, ref FileDownloadURL, ref AuditXml);
                }
                else
                {
                    ErrorXML = DAMHelperObj.PrepareDigitalAssetDownloadUrl(DigitalAssetID, "Original", "", AuditingSolutionName, isStampAudit, "", ref FileDownloadURL, ref AuditXml);
                }

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    if (isStampAudit && !String.IsNullOrEmpty(AuditXml))
                    {
                        if (TandCSAccepted)
                        {
                            AddTermsAndCSAcceptedParam(ref AuditXml);
                        }
                        Session["AuditInputXml"] = AuditXml;
                    }
                }
                else
                {
                    if (ErrorXML.Equals("DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETLOCKED") || ErrorXML.Equals("DAMFACADE_DAMHELPER_DOWNLOADDIGITALASSET_DIGITALASSETEXPIRED")
                                       || ErrorXML.Equals("DIGITALASSET_DIGITALASSETMARKEDASDELETED_Shared") || ErrorXML.Equals("DIGITALASSET_DIGITALASSETMARKEDFORPERMANANTDELETE_Shared"))
                        ErrorXML = ALSolutionCommon.PrepareErrorXML(ErrorXML, "");

                    ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "DAMSOLUTION", ErrorXML, "", "", "", ref ErrorPageURL);
                    ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                    Response.Redirect(ErrorPageURL);

                }
            }
            else
            {
                if (ViewState["FileDownloadURL"] != null)
                    FileDownloadURL = ViewState["FileDownloadURL"].ToString(); ;
            }

            if (!String.IsNullOrEmpty(FileDownloadURL))
            {
                //Increment Download Count
                IncrementeDownloadInputXML = new StringBuilder();
                IncrementeDownloadInputXML.AppendFormat("<DIGITALASSETCOLLECTION><DIGITALASSET><DIGITALASSETID>{0}</DIGITALASSETID></DIGITALASSET></DIGITALASSETCOLLECTION>", DigitalAssetID);
                ObjDamCommon = new DamCommon(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Page.Theme);
                ErrorXML = ObjDamCommon.IncrementDownloadCount(IncrementeDownloadInputXML.ToString());
            }
            else
            {
                ErrorXML = ALSolutionCommon.PrepareErrorXML("DAM_DOWLOAD_DIGITALASSETFAILED", "");
                ALSolutionCommonObj.PrepareErrorPageUrl("DAM", "", "DAMSOLUTION", ErrorXML, "", "", "", ref ErrorPageURL);
                ErrorPageURL = ErrorPageURL + "&JS_CloseOnOk=TRUE";
                Response.Redirect(ErrorPageURL);
            }


            if (IsPostBack)
            {                   
                //Show Link to Download File
                ALBase_TermsAndCS.Visible = false;
                if (IsTrackReasonForDownloadEnabled && !TandCSAccepted)
                    ALBase_ReasonForDownload.Visible = false;
                BC_DownloadFile.Visible = true;
                link_downloadAsset.Attributes.Add("href", FileDownloadURL);                
            }
            else
                Response.Redirect(FileDownloadURL);
        }

        private void GetThumbnailForNonCurrentVersions(out String ThumbnailFilePath, out  String ThumbnailHeight, out String ThumbnailWidth)
        {
            String          ThumbnailFileName       = String.Empty;
            String          str_ThumbnailFilePath   = String.Empty;
            String          ObjectID                = null;
            String          FileFormat              = String.Empty;
            StringBuilder   sb_ImageURL             = new StringBuilder(100);
            XPathNavigator  xpNav_AssetRendition    = null;
                            ThumbnailFilePath       = String.Empty;
                            ThumbnailHeight         = String.Empty;
                            ThumbnailWidth          = String.Empty;

            //Get Original rendition file format
            xpNav_AssetRendition = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/DIGITALASSET_CONTENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION/RENDITIONTYPE[text()='Original']");
            if (xpNav_AssetRendition != null)
            {
                xpNav_AssetRendition.MoveToParent();
                FileFormat = xpNav_AssetRendition.SelectSingleNode("FILEFORMAT").Value;
            }

            //check for Thumbnail rendition
            xpNav_AssetRendition      = xpNav_RootSearchResult.SelectSingleNode("DIGITALASSETCOLLECTION/DIGITALASSET/DIGITALASSET_CONTENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION/RENDITIONTYPE[text()='Thumbnail']");
            if (xpNav_AssetRendition != null)
            {
                XmlDocument xmlDoc_FileSyste        = new XmlDocument();
                String      httpThumbnailFilePath   = null;

                xpNav_AssetRendition.MoveToParent();

                xmlDoc_FileSyste.LoadXml(xpNav_AssetRendition.SelectSingleNode("FILESYSTEM").OuterXml);
                if (xmlDoc_FileSyste.SelectSingleNode("//FILE/NAME") != null)
                    ThumbnailFileName = xmlDoc_FileSyste.SelectSingleNode("//FILE/NAME").InnerText;

                if (xmlDoc_FileSyste.SelectSingleNode("//FILE/OBJECTID") != null)
                    ObjectID = xmlDoc_FileSyste.SelectSingleNode("//FILE/OBJECTID").InnerText;

                if (!String.IsNullOrEmpty(ThumbnailFileName) && !String.IsNullOrEmpty(ObjectID))
                {
                    ThumbnailFileName = Server.UrlEncode(ThumbnailFileName);
                    ThumbnailFileName = ThumbnailFileName.Replace("+", " ");
                    //Following path is constructed with file name as <ObjectID>_<FileName> because GetFile method of DAMFacase/DamCommon 
                    //gets file with name <ObjectID>_<FileName>.
                    //ThumbnailFilePath = "/" + SetBaseObj.TenantName + "/" + DownloadFolder + "/" + ObjectID + "_" + ThumbnailFileName; 
                    str_ThumbnailFilePath = ALSolutionCommon.GetDownloadFilePath(ALParamObj.TenantName) + ObjectID + "_" + ThumbnailFileName;
                    httpThumbnailFilePath = ALSolutionCommon.GetHTTPDownloadFilePath(ALParamObj.TenantName) + ObjectID + "_" + ThumbnailFileName;
                    if (File.Exists(str_ThumbnailFilePath))
                        ThumbnailFilePath = httpThumbnailFilePath;
                    else
                    {
                        str_ThumbnailFilePath = obj_DamCommon.GetFile(xmlDoc_FileSyste.SelectSingleNode("FILESYSTEM"));
                        if (!String.IsNullOrEmpty(str_ThumbnailFilePath))
                        {
                            ThumbnailFilePath = httpThumbnailFilePath;
                        }
                        else
                        {
                            if (!String.IsNullOrEmpty(FileFormat))
                                str_ThumbnailFilePath = obj_DamCommon.GetDefaultThumbnailAccordingToFileFormat(FileFormat);

                            if (String.IsNullOrEmpty(str_ThumbnailFilePath))
                            {
                                sb_ImageURL.Remove(0, sb_ImageURL.Length);
                                sb_ImageURL.AppendFormat("/{0}/App_Themes/{1}/Images/Default_AssetThumbnail.gif", ALParamObj.TenantName, Page.Theme);
                                ThumbnailFilePath = sb_ImageURL.ToString();
                            }
                            else
                            {
                                ThumbnailFilePath = Server.UrlPathEncode(str_ThumbnailFilePath);
                            }
                        }
                    }
                }

                if (xpNav_AssetRendition != null)
                {
                    
                    if (xpNav_AssetRendition.SelectSingleNode("HEIGHT") != null)
                        ThumbnailHeight = xpNav_AssetRendition.SelectSingleNode("HEIGHT").Value;

                    if (xpNav_AssetRendition.SelectSingleNode("WIDTH") != null)
                        ThumbnailWidth = xpNav_AssetRendition.SelectSingleNode("WIDTH").Value;
                }

            }
            else
            {
                if (!String.IsNullOrEmpty(FileFormat))
                    ThumbnailFilePath = obj_DamCommon.GetDefaultThumbnailAccordingToFileFormat(FileFormat);

                if (String.IsNullOrEmpty(ThumbnailFilePath))
                {
                    sb_ImageURL.Remove(0, sb_ImageURL.Length);
                    sb_ImageURL.AppendFormat("/{0}/App_Themes/{1}/Images/Default_AssetThumbnail.gif", ALParamObj.TenantName, Page.Theme);
                    ThumbnailFilePath = sb_ImageURL.ToString();
                }
            }
        }

       
        #endregion
    }
}