#region SystemInclude
using System;
using System.Data;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.IO;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Collections.Specialized;
#endregion

#region AssetlinkInclude
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.Solutions.Facade.NotificationFacade;
using Assetlink.Solutions.Facade.PMFacade;
using Assetlink.Solutions.Facade.ApprovalsFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Pages;
#endregion


//-----------------------------------------------------//
// File Name:   Manage_ROGatherInfoTask.aspx.cs        //
// Author:      Ms. Mugdha Moolay.                     //
// Class:       Perform_ResponseGatherInfoTask         //
// Created On:  16th December 2006                     //
//-----------------------------------------------------//


namespace Assetlink.Solutions.MarketingWorkBench
{
    using XML       = String;
    using ERRORXML  = String;

    public partial class Manage_ROGatherInfoTask : ALAjaxPage
    {   
        #region MemberVariables
            private ALSolutionCommon            ALSolutionCommonObj     = null;
            //private Dictionary<String, String>  m_ParamList             = null;
            public ALParam                      ALParamObj              = null; 
            private String                      TaskID                  = null;
            private String                      ProjectID               = null;
            private String                      DeliverableID           = null;
            private String                      Mode                    = null;
            private String                      SolutionName            = "MarketingWorkBench";
            private String                      TaskFile                = null;
            private String                      GroupListFile           = null;
            private String                      DisplayPredecessorFile  = null;
            private String[]                    strSeparator            = null;
            private String                      PackageDefinitionID     = null;
            private String                      ProcessDefinitionID     = null;
            private List<string>                ActivityIDOrderedList   = null; 
            private List<ObjectInfo>            StepObjInfoList         = null;
            private Hashtable                   StepFormIDTable         = null;
            private String						Access					= "READ";
            private String						PrevScreen				= null;
            private String                      BreadCrumbCtrlID        = null; 
            private String                      ParentBreadcrumbName    = null; 
            //private List<ObjectInfo>			ObjInfoList				= null;
            private	String						TabClickFlag			= null;
            private String						SelectedTab				= null;
            private String						TaskReader				= null;
			private String						StepResourceFileName	= null;
			private String						ResourceTreeFile		= null;
            private String                      str_ResponseBreadCrumbs = null;
            private String                      str_StepAccess          = null;
            private String                      str_ComponentFacetFileName = "_ComponentFacet.xml";
            private String                      str_ComponentFacetStatus   = "Editable";
            private String                      str_ProjectInfoTempFileName      = "_ProjectInfo.xml";
            private String                      str_SelectedComponentsIDFileName = "_SelectedComponentsID.xml";
        #endregion

        #region ControlsOnPage
            private Form                                 Frm_TaskDetails          = null;
            private Form                                 Frm_ROProjectDetails     = null;	
            Form                                         TempStepForm             = null;       
            private Assetlink.CustomControls.ListControl Lst_PredecessorList      = null;
            private   ActionBar                          Ab_ROGatherInfoTask      = null;
            private ALUC_ALUserSelection                 UC_InitiatorSelection    = null;
            private ALPanel                              ALPanel_InitiatorSelection = null;
            private Binder                               Binder_Attachments         = null;
            private ALPanel                              Manual_Activities          = null;            
            private ALPanel                              ALPanel_HiddenFields       = null;
            private HiddenField                          __NewContributorIDs_HF     = null;
            private HiddenField                          __OldContributorIDs_HF     = null;
            private HiddenField                          Hidden_PredecessorFound    = null;
            private HiddenField							 HiddenPreviousWorkflow		= null;
            private ALBreadCrumb                         RO_GatherInfoBreadCrumb    = null;
            private ALTab								 ROGatherInfoTaskTab		= null;
			private ALPanel								 Panel_TaskDetails			= null;
			private ALPanel								 Panel_UserRoles			= null;
			private	ALPanel								 Panel_Dependencies			= null;
            private ALPanel                               Panel_ProjectDetails      = null;
            private SquareBlankSection                    Sbs_ProjectDetails        = null;
            private CustomControls.ListControl           Lst_UserGroup              = null;
            private CustomControls.ListControl           LC_TaskReaders             = null; 
            private CheckBox                             checkBoxObj                = null;
            private TextBox                              textBoxObj                 = null;
            private Literal                              Literal_TaskInitiator      = null;
        #endregion

        #region ProtectedMethods

		    protected override void CreateChildControls()
		    {
			    try
			    {
				    setParameters();
				    setControls();
				    setLeftPane();
				    if(IsPostBack)
				    {
					    if(ViewState["TabClickFlag"] != null)
					    {
						    //if(Mode.ToUpper() == "MANAGE")
						    {
							    SetStepForm_InPostBack();
							    setStepFormEventHandler();
						    }
					    }
                        String EventGenerator = Ajax.EventGeneratorUniqueID;
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        if (StepFormIDTable != null)
                        {
                            IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                            while (StepFormIDEnum.MoveNext())
                            {
                                if ((!String.IsNullOrEmpty(EventGenerator)) &&(EventGenerator.Contains(StepFormIDEnum.Value.ToString() + "_HiddenMSDELETEButton")))
                                {
                                    UpdateContributorDropDownList(StepFormIDEnum.Key.ToString(), StepFormIDEnum.Value.ToString());
                                    break;
                                }
                            }
                        }
				    }
				    base.CreateChildControls();
			    }
			    catch(Exception ExcepObj)
			    {
				    throw ExcepObj;
			    }
		    }

            protected void Page_Init(object sender, EventArgs e)
            {
                ALSolutionCommonObj = new ALSolutionCommon();
                ALParamObj = new ALParam();

                ALSolutionCommonObj.httpContext = HttpContext.Current;
                ALSolutionCommonObj.InitALParam(ref ALParamObj);

                ((ALMasterPage)this.Master).SessionID       = ALParamObj.SessionID;
                ((ALMasterPage)this.Master).UserID          = ALParamObj.UserID;
                ((ALMasterPage)this.Master).Language        = ALParamObj.Language;
                ((ALMasterPage)this.Master).TenantName      = ALParamObj.TenantName;
                ((ALMasterPage)this.Master).SolutionName    = SolutionName;
                ((ALMasterPage)this.Master).PageTitle       = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_MarketingWorkbench_Shared");
                if (String.IsNullOrEmpty(ALParamObj.SolutionName))
                    ALParamObj.SolutionName = SolutionName;
            }

            protected void Page_Load(object sender, EventArgs e)
            {
                setParameters();
                setControls();
				setControlProperties();
                setLeftPane();
                
                if (!IsPostBack)
                {
                    DeleteTempFiles();
					setSelectedTab();
                    getBaselineConfig();
                }
            }

            protected void Ab_ROGatherInfoTask_Click(object sender, EventArgs e)
            {
				Boolean		IsWriteAccessAllowed = true;
				ERRORXML	ErrorXML			 = null;
				Boolean		alertGiven			 = false;
				String		ErrorPageURL		 = null;
                String      EncryptURL           = null;
                String      NewTaskID            = null;
                StringBuilder   ParamURL         = null;
                StringBuilder   URL              = null;
                 String         TempBreadCrumbID = null;
                String          TempParentBCName = null;
                try
                {
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btn_Done"))
                    {
                        if ((Mode.ToUpper() == "PERFORM") && (!String.IsNullOrEmpty(PrevScreen)) && (PrevScreen.ToUpper() == "PERFORMLIST"))
                            gotoPerformListScreen();
                        else if ((Mode.ToUpper() == "PERFORM") && (Access.ToUpper() == "READ"))
                        {                            
                                gotoDeliverableROScreen();
                        }
                        else
                        {
                            if (!String.IsNullOrEmpty(Access))
                            {
								if(Access.ToUpper()=="READ")
									IsWriteAccessAllowed = false;
                            }

							if(IsWriteAccessAllowed)
                            {
                                if (Mode.ToUpper() == "MANAGE")
                                {
									ErrorXML = SaveTask(out alertGiven);
									if ((ErrorXML==null)&&(!alertGiven))
									{
										DeleteTempFiles();
										if(PrevScreen.ToUpper() == "ROPROJECT")
											gotoProjectROScreen();
                                        else if (PrevScreen.ToUpper().Equals("VIEWDELIVERABLES"))
                                            gotoViewDeliverableScreen();
										else
											gotoDeliverableROScreen();
									}
									else
									{
										if (ErrorXML!=null)
										{
											ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
											if(!IsPostBack)
											{
												Response.Redirect(ErrorPageURL, true);
											}
											else
												Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
										}
									}
                                }
                            }
                            else
                            {
								// if Mode == MANAGE and ParentProjectID and ParentDeliverableID are Both null then the logged in User is a task Reader
								// CHANGED FOR BUG FIX 1634
								//if(String.IsNullOrEmpty(ProjectID) && String.IsNullOrEmpty(DeliverableID) && Mode.ToUpper() == "MANAGE")
								if((!String.IsNullOrEmpty(TaskReader)) && (TaskReader.ToUpper() == "YES") && (Mode.ToUpper() == "MANAGE"))
								{
                                    if (!String.IsNullOrEmpty(PrevScreen) && PrevScreen.ToUpper() == "VIEWTASKS")
                                        gotoViewTasksScreen();
                                    else
									    gotoProjectListScreen();
								}
								else
								{
									if(PrevScreen.ToUpper() == "ROPROJECT")
										gotoProjectROScreen();
                                    else if (PrevScreen.ToUpper().Equals("VIEWDELIVERABLES"))
                                        gotoViewDeliverableScreen();
									else
										gotoDeliverableROScreen();
								}
                            }
                        }                        
                    }
                    else if (Parameters[1].Equals("btn_CancelTask"))
                    {
                        ErrorXML =  CancelTask();
                        if (ErrorXML == null)
                        {
							DeleteTempFiles();
							if(PrevScreen.ToUpper() == "ROPROJECT")
								gotoProjectROScreen();
                            else if (PrevScreen.ToUpper().Equals("VIEWDELIVERABLES"))
                                gotoViewDeliverableScreen();
							else
								gotoDeliverableROScreen();
						}
						else
						{
							ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
							if(!IsPostBack)
							{
								Response.Redirect(ErrorPageURL, true);
							}
							else
								Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
						}
                    }
                    else if (Parameters[1].Equals("btn_ReRoute"))
                    {
                        ErrorXML = ReRouteTask(out NewTaskID);
                        if (ErrorXML == null)
                        {
                            if (!String.IsNullOrEmpty(__BreadCrumbCtrlID.Value))
                            {
                                TempBreadCrumbID = __BreadCrumbCtrlID.Value;
                            }
                            else
                            {
                                TempBreadCrumbID = RO_GatherInfoBreadCrumb.BreadcrumbUniqueID;
                            }
                            if (!String.IsNullOrEmpty(__ParentBreadCrumbName.Value))
                            {
                                TempParentBCName = __ParentBreadCrumbName.Value;
                            }
                            else
                            {
                                TempParentBCName = ParentBreadcrumbName;
                            }
                            ParamURL = new StringBuilder(100);
                            URL      = new StringBuilder(50);
                            //ParamURL.AppendFormat("Manage_CreateGatherInfoTask.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&FormMode={4}&DeliverableID={5}&ProjectID={6}&TaskID={7}&Access={8}&BREADCRUMBCTRLID={9}&PrevScreen={10}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, "Edit", DeliverableID, ProjectID, NewTaskID, Access, TempBreadCrumbID, PrevScreen);
                            //ParamURL.AppendFormat("&PARENTBREADCRUMBNAME={0}&Mode={1}&PackageDefinitionID={2}&ProcessDefinitionID={3}", TempParentBCName, Mode, __PackageDefinitionID.Value, __ProcessDefinitionID.Value);
                            ParamURL.AppendFormat("WorkBenchLinkHandler.ashx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&SourceID={6}&SourceType=TASK", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, NewTaskID);
                            ParamURL.AppendFormat("&PARENTBREADCRUMBNAME={0}&Mode={1}&PrevScreen={2}&BREADCRUMBCTRLID={3}", ParentBreadcrumbName, Mode, PrevScreen, BreadCrumbCtrlID);

                            EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                            URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                            Ajax.WriteExecuteJavaScript(URL.ToString());

                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    else if (Parameters[1].Equals("btn_PrintTask"))
                    {
                        //PrintTask();
                    }

                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }            
            }

            protected void StepForm_SelectionChanged(object sender, EventArgs e)
            {
                String          FormID              = null;
                DropDownList    SelectedDropDown    = null;
                String          ListID              = null;
                String          SelectedValue       = null;
                String          SelectedID          = null;
                MWB_Helper      MWB_HelperObj       = null;                
                String          SelectedContributor = null;
                ListItem        SelectedListItem    = null;
                String          MailID              = null;
                StringBuilder	GroupListXML		= null;
				StringBuilder	TempPath			= null;
				String			TempFilePath		= null;
				String			FileName			= null;
                String          StepID              = null;
                try
                {
                    MWB_HelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    
                    SelectedDropDown = (DropDownList)sender;
                    ListID           = SelectedDropDown.ID;
                    SelectedListItem = SelectedDropDown.SelectedItem;
                    SelectedValue    = SelectedListItem.Text;
                    SelectedID		 = SelectedListItem.Value;
					GroupListXML	 = new StringBuilder();
					TempFilePath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					TempPath		 = new StringBuilder();
                    StepFormIDTable  = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                                                    
                    while (StepFormIDEnum.MoveNext())
                    {
                        if (ListID.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            FormID = StepFormIDEnum.Value.ToString();
                            StepID = StepFormIDEnum.Key.ToString();
                            break;
                        }
                    }
                    if (FormID!=null)
                    {                    
                        TempStepForm        = (Form)Manual_Activities.FindControl(FormID);                            
                        SelectedContributor = TempStepForm.GetValues("Contributor");
						FileName			= FormID + "_GroupUsers.xml";
						TempPath.AppendFormat("{0}{1}", TempFilePath, FileName);
                        //Get the Previous Contributors name and Email ID
                        ViewState["PreviousContributor"]    = TempStepForm.GetValues("PreviousContributor");
                        ViewState["EmailID"]                = TempStepForm.GetValues("EmailID");

						if (ListID.Contains("Contributor"))
                        {
                            if (SelectedID.ToUpper() != "NONE")
                            {
                                MWB_HelperObj.GetMailAddressForSelectedUser(SelectedID, FileName, out MailID);
                                //setStepFormInputXMLForMailAddress(FormID, MailID);
                            }
                           setStepFormInputXMLForMailAddress(StepID, FormID, MailID);
                        }                       
                    }
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }
            
            protected void ROGatherInfoTaskTab_onTabClick(object sender,TabClickEventarg e)
            {
				ALPanel SelectedTab = null;
				try
				{
					TabClickFlag = "TRUE";
					ViewState["TabClickFlag"] = "TRUE";
					SelectedTab = (ALPanel)e.SelectedTab;    
                    if (!IsPostBack)
                        setBreadcrumbs();
					switch(SelectedTab.Name.ToUpper())
					{
						case "INFO":
									if (Mode.ToUpper()=="MANAGE")
										setPageForTaskDetails_ManageMode();
									else
										setPageForTaskDetails_PerformMode();
									break;
						case "USER ROLES":
									GetUserRoles();
									break;
						case "DEPENDENCIES":
									GetDependencies();
									break;
					}                    
				}
				catch(Exception Excepobj)
				{
					throw Excepobj;
				}	
            }

			protected void Hidden_SelectResourceType_Click(object sender, EventArgs e)
			{
				StringBuilder	FilePath	 = null;
				XPathDocument	RecDoc		 = null;
				XPathNavigator	xpNav		 = null;
				String			SelectedValue= null;
				UserFacade		UserFacadeObj= null;
				XML				SearchXML	 = null;
				XML				UserXML		 = null;
				ERRORXML		ErrorXml	 = null;
				XPathDocument   UserDoc		 = null;
				MWB_Helper		MWB_HelperObj= null;
				String			StepID		 = null;
				String			StepFormID	 = null;
				String			ItemList	 = null;
				String			TempPath	 = null;
				String			FileName	 = null;			
				try
				{
					StepID			= Request["__EVENTARGUMENT"];
					FilePath		= new StringBuilder();
					UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					MWB_HelperObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					TempPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					FilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
					if(File.Exists(FilePath.ToString()))
					{
						RecDoc = new XPathDocument(FilePath.ToString());
						xpNav  = RecDoc.CreateNavigator();
						xpNav  = xpNav.SelectSingleNode("//*/TreeNode[@Selected='True']");
						if(xpNav != null)
						{
							SelectedValue	= xpNav.GetAttribute("Text","") ;						

							SearchXML = GetSearchXML(SelectedValue);
							ErrorXml = UserFacadeObj.GetUserList(SearchXML, ref UserXML);
							if(ErrorXml == null)
							{
								UserDoc			= new XPathDocument(new StringReader (UserXML));
								ItemList		= MWB_HelperObj.GetContributorXML(UserDoc);
								StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
								IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
								while (StepFormIDEnum.MoveNext())
								{
									StepFormID = StepFormIDEnum.Value.ToString();
									if (StepFormID.Contains(StepID))
										break;
								}
								if(StepFormID != null)
								{
									// save the user file on ntfs
									FilePath.Remove(0, FilePath.Length);
									
									FileName = StepFormID + "_GroupUsers.xml";
									FilePath.AppendFormat("{0}{1}", TempPath, FileName);
									File.WriteAllText(FilePath.ToString(), UserXML);
									setStepFormInputXMLForGroup(StepID, StepFormID, ItemList);
								}
							}
						}
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}
            
            protected override void Render(HtmlTextWriter writer)
            {
                if (IsPostBack)
                {
                    String EventGenerator = Ajax.EventGeneratorUniqueID;

					StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
					if(StepFormIDTable != null)
					{
						IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
						while(StepFormIDEnum.MoveNext())
						{
							if(EventGenerator.Contains(StepFormIDEnum.Value.ToString()))
							{
								Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
								if(StepForm != null)
								{
									Ajax.AddControlsToRender(StepForm);
                                    if (EventGenerator.Contains("ExportSeriesRecord"))
                                    {
                                        String ExportUrl = StepForm.GetSeriesExportUrl();
                                        if (!String.IsNullOrEmpty(ExportUrl))
                                            Ajax.WriteExecuteJavaScript(ExportUrl);
                                    }
                                    if (ViewState["ComponentFacetFieldName"] != null)
                                    {
                                        //loading digital assets for components dynamically.
                                        Ajax.WriteExecuteJavaScript("javascript:" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                                    }
                                }
							}
						}
					}

					if(!String.IsNullOrEmpty(TabClickFlag) && TabClickFlag.Equals("TRUE"))
					{
						if(ROGatherInfoTaskTab.SelectedTab != null)
						{
							Ajax.AddControlsToRender(ROGatherInfoTaskTab.SelectedTab);
							Ajax.WriteExecuteJavaScript("javascript:" + ROGatherInfoTaskTab.HighlightTabJavaScript);
						}
					}

                    if (EventGenerator.Contains("Content_1_Frm_TaskDetails"))
                    {
                        Ajax.AddControlsToRender(Frm_TaskDetails);
                        if (EventGenerator.Contains("ExportSeriesRecord"))
                        {
                            String ExportUrl = Frm_TaskDetails.GetSeriesExportUrl();
                            if (!String.IsNullOrEmpty(ExportUrl))
                                Ajax.WriteExecuteJavaScript(ExportUrl);
                        }
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            //loading digital assets for components dynamically.
                            Ajax.WriteExecuteJavaScript("javascript:" + (String)Frm_TaskDetails.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                        }
                    }
					
                    if (EventGenerator.Contains("Content_2_lc_PredecessorList_Min_Btn") || EventGenerator.Contains("Content_2_lc_PredecessorList"))
                        Ajax.AddControlsToRender(Lst_PredecessorList);
                    if (EventGenerator.Contains("Binder_Documents"))
                        Ajax.AddControlsToRender(Binder_Attachments);

                    if (EventGenerator.Contains("Content_1_sbs_Project_Details"))
                        Ajax.AddControlsToRender(Sbs_ProjectDetails);

                    if (EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperNext") || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperLast") || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperFirst") || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperPrev"))
                    {
                        Ajax.AddControlsToRender(Lst_UserGroup);
                    }

                    if (EventGenerator.Contains(LC_TaskReaders.UniqueID))
                        Ajax.AddControlsToRender(LC_TaskReaders);

                    Ajax.AddControlsToRender(TempStepForm);
                    Ajax.AddControlsToRender(ALPanel_HiddenFields);
                    Ajax.WriteControlHTMl(this.Page, writer);
                }
                else
                {
                    base.Render(writer);
                    if ((ViewState["ComponentFacetFieldName"] != null))
                    {
                        //loading digital assets for components dynamically.
                        writer.Write("<script type=\"text/javascript\">" + (String)Frm_TaskDetails.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        if (StepFormIDTable != null)
                        {
                            IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                            while (StepFormIDEnum.MoveNext())
                            {
                                Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                                if (StepForm != null)
                                {
                                    writer.Write("<script type=\"text/javascript\">" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                                }
                            }
                        }
                    }
                }
            }

            /// <alsummary>
            /// <createddate>16-Dec-2008</createddate>
            /// <author>Radha A</author>
            /// <purpose>To receive selected sign id's</purpose>
            /// </alsummary>
            protected void Btn_Hidden_SelectSigns_Click(object sender, EventArgs e)
            {
                String          SelectedRowsFilePath   = null;
                String          str_ActivityID         = null;
                ERRORXML        ErrorXml               = null;
                Boolean         alertGiven             = false;


            try
            {
                ErrorXml = SaveTask(out alertGiven);
                if ((ErrorXml == null) && (!alertGiven))
                {
                    UpdateTaskSteps();
                    SelectedRowsFilePath = Request["__EVENTARGUMENT"];
                    GetSelectedStepForm("STEP_" + SelectedRowsFilePath.Split(',')[1], out str_ActivityID);
                }
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

            /// <alsummary>
            /// <createddate>17 April 2009</createddate>
            /// <author>Radha A</author>
            /// <purpose>To Handle clicks on the Component Facet Series List Action bar.</purpose>
            /// </alsummary>
            protected void Frm_TaskDetails_SeriesActionBarClick(object sender, EventArgs e)
            {
                ulong        ErrorID                = 0;
                String       EncryptURL             = null; 

                try
                {
                    String strSender            = (String)sender;
                    String[] Parameters         = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                    {
                        getDigitalAssetsFromFacetIDs("TASK", null);
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ROGatherInfoTask.aspx", "Frm_TaskDetails_SeriesActionBarClick", ExceptionObject, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlingComponentListactionbarclick_Shared"));
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ExceptionObject.Message, null, null, ref EncryptURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                }
            }

            /// <summary>
            /// <Author>Anita Kale</Author>
            /// <CreatedOn>18th May 2009</CreatedOn>
            /// <Purpose>Event Handler for Expansion of project Info Section</Purpose>
            /// </summary>
            protected void Sbs_ProjectDetails_CollapsedClick(object sender, EventArgs e)
            {
                Sbs_ProjectDetails.IsMinimize = false;
                setProjectInfo();
            }

       #endregion

        #region PrivateMethods

            private void setPageForTaskDetails_ManageMode()
            {
                MktgWorkBenchFacadeClass MWBFacadeObj       = null;
                GroupFacade              GroupFacadeObj     = null;
                MWB_Helper               MWBHelperClassObj  = null;
                XmlDocument              InputXMLDoc        = null;
                XmlDocument              TempDoc            = null;
                XmlDocument				 FormXMLDoc			= null;
                ERRORXML                 ErrorXML           = null;                
                XmlNodeList              ActivityNodeList   = null;
                XmlNode                  FileSystemNode     = null;    
                XmlNode                  ProcessActivityNode= null;
                XmlNode                  ActivityResponseNode=null;
                XmlNode					 FieldNode			 = null;                
                XML                      ReturnTaskXML      = null;
                XML                      FormInputXML       = null;                
                StringBuilder            ProcessColl        = null;                
                StringBuilder            TempPath           = null;
                StringBuilder            ResourceTypeList   = null;
                FormFacade               FormFacadeObj      = null;  
                String                   TaskName           = null;                
                String                   FormConfigXMLPath  = null;
                String                   ActivityStatus     = null;
                String                   TempFilePath       = null;
                Hashtable                ResourceTable      = null;
                int                      ActivityCount      = 0;
                List<ObjectInfo>         ObjInfoList        = null;
				XML						ResourceXML			= null;
				StringBuilder			ActResourceXML		= null;
                String          str_StdFormName         = null;
                String          str_DynamicFormName     = null;
                String          str_SelectedFormName    = null;
                String          FormConfigXML           = null;
                String          SearchXML               = null;
                String          str_TaskXML             = null; 
                String          str_ActivitiesXML       = null; 
                
                XPathExpression          xp_SortExpression       = null;
                XPathNodeIterator        xp_SortNodeIter         = null;
                String                   str_SortXML             = null;
                String                   str_ShowBaseline        = "NO";
                
                try
                {
                    MWBFacadeObj        = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    GroupFacadeObj      = new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ProcessColl         = new StringBuilder();                    
                    TempPath            = new StringBuilder();
                    ResourceTypeList    = new StringBuilder();
					ActResourceXML		= new StringBuilder();
                    ResourceTable       = new Hashtable();
                    InputXMLDoc         = new XmlDocument();
                    TempDoc             = new XmlDocument();
					FormXMLDoc			= new XmlDocument();                  
                    StepFormIDTable       = new Hashtable();
                    ActivityIDOrderedList = new List<string>();
                    TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);


                    FormFacadeObj.SolutionName = SolutionName;
                    str_StdFormName     = "Task_Details";
                    
                    ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "RO_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_ManageMode):- Before GetGatherInfoTask() function.");
                    ErrorXML = GetGatherInfoTask(out str_TaskXML);
                    
                    ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "RO_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_ManageMode):- After GetGatherInfoTask() function.");
                    str_ShowBaseline = ViewState["ShowBaseline"].ToString();
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_ManageMode):- Before GetGatherInfoTaskActivities() function.");
                        ErrorXML = GetGatherInfoTaskActivities( out str_ActivitiesXML);
                        ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_ManageMode):- After GetGatherInfoTaskActivities() function.");

                        //Assign values for prior notification
                        SetAdvanceReminderValues("<WORKFLOWPROCESS>" + str_TaskXML + "</WORKFLOWPROCESS>");
                    }

                    if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_TaskXML)) && (!String.IsNullOrEmpty(str_ActivitiesXML))) 
                    {
                        MergeTaskActivities(str_TaskXML, str_ActivitiesXML, out ReturnTaskXML);

                        str_DynamicFormName     = __ProcessDefinitionID.Value + "_" + str_StdFormName;
                        FormConfigXMLPath       = MWBHelperClassObj.GetFormConfigXMLPath(str_StdFormName,str_DynamicFormName, out str_SelectedFormName);
                        FormFacadeObj.FormName  = str_SelectedFormName;
                        FormFacadeObj.ShowConfiguredFields = true;  
                        
                        InputXMLDoc.LoadXml(ReturnTaskXML);

                        FormConfigXML           = File.ReadAllText(FormConfigXMLPath);
                        FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out SearchXML);
                        //HemantK:For Component Facet Series
                        ErrorXML = GetComponentFacetForTask(ref InputXMLDoc, ref FormConfigXML, SearchXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            CheckComponentFacetSeriesStatus(Frm_TaskDetails);

                            ProcessColl.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", InputXMLDoc.OuterXml);
                            ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ProcessColl.ToString(), out FormInputXML, out ObjInfoList);
                            ViewState["ObjectList"] = ObjInfoList;

                            if (InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PREVIOUS_WORKFLOW/WORKFLOWPROCESS")!=null)
							    HiddenPreviousWorkflow.Value = "TRUE";
						    else
							    HiddenPreviousWorkflow.Value = "FALSE";
                            PackageDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID").InnerText;
                            ProcessDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").InnerText;
                            __TaskStatus.Value = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/STATUS").InnerText;
                            TaskName = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                            //ViewState["TaskTitle"] = TaskName;
                            RO_GatherInfoBreadCrumb.DisplayText = TaskName;
                            ProcessActivityNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                            
                            // Save the Gather info task Task 
                            TempPath.AppendFormat("{0}{1}",ALSolutionCommon.GetTempPath(ALParamObj.SessionID),TaskFile);
                            InputXMLDoc.Save(TempPath.ToString());
                            TempPath.Remove(0, TempPath.Length);

                            xp_SortExpression   = XPathExpression.Compile("ACTIVITY");
                            xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                            xp_SortNodeIter     = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                            while (xp_SortNodeIter.MoveNext())
                            {
                                str_SortXML     += xp_SortNodeIter.Current.OuterXml;
                            }
                            ProcessActivityNode.InnerXml = str_SortXML;

                            if (FormConfigXML != null)
                            {
                                Frm_TaskDetails.ConfigurationXML = FormConfigXML;

                                // display the initiator
							    setInitiatorSelectionControl(null);
                                
                                //Display Attachments
                                FileSystemNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM");
                                XmlNode AssetNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ASSETREFERENCES");
                                setAttachments(FileSystemNode, AssetNode);
                                
                                //apply percentdone class
                                ApplyPercentDoneClass(__TaskStatus.Value, InputXMLDoc, ref FormInputXML);

							    FormXMLDoc.LoadXml(FormInputXML);
							    if((__TaskStatus.Value.ToUpper() != "COMPLETED") && (__TaskStatus.Value.ToUpper() != "CANCELLED"))
							    {
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALSTARTDATE']");
								    if(FieldNode != null)
								    {
									    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
								    }
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALENDDATE']");
								    if(FieldNode != null)
								    {
									    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
								    }
							    }

                                if (str_ShowBaseline == "NO")
                                {
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASESTARTDATE']");
                                    if (FieldNode != null)
                                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASEENDDATE']");
                                    if (FieldNode != null)
                                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                }

							    Frm_TaskDetails.InputXML = FormXMLDoc.OuterXml;

                                ActivityNodeList = InputXMLDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE='Task']");
                                ActivityIDOrderedList = new List<string>();
    							
                                if(Access.ToUpper() == "READ")
                                {
								    foreach (XmlNode ActivityNode in ActivityNodeList)
								    {
                                        setROResponseForm(ActivityNode);
                                    }
                                }
                                else
                                {
								    ActResourceXML.Append("<ACTIVITYCOLLECTION>");
								    foreach (XmlNode ActivityNode in ActivityNodeList)
								    {                                
									    ActivityStatus = ActivityNode.SelectSingleNode("STATUS").InnerText;
									    switch (ActivityStatus.ToUpper())
									    {
										    case "NEW":
										    case "ACTIVE":
										    case "DRAFT":
											    ResourceXML = MWBHelperClassObj.GetActivityResourceXML(ActivityNode);
											    if(!String.IsNullOrEmpty(ResourceXML))
											    {
												    ActResourceXML.Append(ResourceXML);
											    }
											    ActivityCount++;
											    setStepForm(ActivityNode);
											    break;
										    case "CANCELLED":
										    case "COMPLETED":
											    ActivityCount++;
											    ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
												setROResponseForm(ActivityNode);
											    break;
									    }
								    }
								    ActResourceXML.Append("</ACTIVITYCOLLECTION>");
								    TempPath.Remove(0, TempPath.Length);
								    TempPath.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
								    File.WriteAllText(TempPath.ToString(), ActResourceXML.ToString());
                                }
                                ViewState["StepFormIDList"] = StepFormIDTable;
                                ViewState["ActivityIDList"] = ActivityIDOrderedList;

                            }
                            setGatherInfoTaskActionBar(Mode, __TaskStatus.Value);
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            private void ApplyPercentDoneClass(String TaskStatus, XmlDocument InputXMLDoc, ref String FormInputXML)
            {
                XmlDocument                 FormXMLDoc          = null;
                XmlNode                     FieldNode           = null;
                XmlNode                     DueDateNode         = null;
                String                      PercentDoneClass    = null;
                DateTime                    DueDate;
                MktgWorkBenchFacadeClass    MWBFacadeObject     = null;
		        ulong			            ErrorID				= 0;
                StringBuilder	            ErrorPageURL_Exp	= null;

                try
                {
                    FormXMLDoc = new XmlDocument();
                    FormXMLDoc.LoadXml(FormInputXML);

                    if (TaskStatus.ToUpper() != "NEW" && TaskStatus.ToUpper() != "DRAFT")
                    {
                        DueDate = DateTime.Today;

                        DueDateNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DUEDATE");
                        DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESSINFO_PERCENTDONE_PROCESS_INFORMATION']");

                        MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(TaskStatus, DueDate);

                        ((XmlElement)FieldNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                        FormInputXML = FormXMLDoc.OuterXml;
                    }
                    
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ROGatherInfoTask.aspx", "ApplyPercentDoneClass", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_DeliverableDetails_Exceptionwhileshowingactualdatesforthedeliverable_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            } 

            private void setPageForTaskDetails_PerformMode()
            {
                MktgWorkBenchFacadeClass MWBFacadeObj       = null;
                GroupFacade              GroupFacadeObj     = null;
                MWB_Helper               MWBHelperClassObj  = null;
                XmlDocument              InputXMLDoc        = null;
                XmlDocument              TempDoc            = null;
                ERRORXML                 ErrorXML           = null;                
                XmlNodeList              ActivityNodeList   = null;
                XmlNode                  FileSystemNode     = null;    
                XmlNode                  ProcessActivityNode=null;
                XmlNode                  TempNode           = null;                 
                XML                      ReturnTaskXML      = null;
                XML                      FormInputXML       = null;                
                StringBuilder            ProcessColl        = null;                
                StringBuilder            TempPath           = null;
                StringBuilder            ResourceTypeList   = null;
                FormFacade               FormFacadeObj      = null;  
                String                   TaskName           = null;                
                String                   FormConfigXMLPath  = null;
                String                   TempFilePath       = null;
                Hashtable                ResourceTable      = null;                
                List<ObjectInfo>         ObjInfoList        = null;
                String          str_StdFormName         = null;
                String          str_DynamicFormName     = null;
                String          str_SelectedFormName    = null;
                String          FormConfigXML           = null;
                String          SearchXML               = null;
                String          str_TaskXML             = null; 
                String          str_ActivitiesXML       = null; 
                String          str_ActivityFacets      = null; 
                XPathExpression          xp_SortExpression       = null;
                XPathNodeIterator        xp_SortNodeIter         = null;
                String                   str_SortXML             = null;
                List<String>            ActDefList              = null;
                try
                {
                    MWBFacadeObj        = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    GroupFacadeObj      = new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ProcessColl         = new StringBuilder();                    
                    TempPath            = new StringBuilder();
                    ResourceTypeList    = new StringBuilder();
                    ResourceTable       = new Hashtable();
                    InputXMLDoc         = new XmlDocument();
                    TempDoc             = new XmlDocument();   
                    StepFormIDTable     = new Hashtable();                 
                    TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    
                    FormFacadeObj.SolutionName = SolutionName;
                    str_StdFormName         = "Task_Details";

                    ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "RO_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_PerformMode):- Before GetGatherInfoTask() function.");
                    ErrorXML = GetGatherInfoTask(out str_TaskXML);
                    ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "RO_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_PerformMode):- After GetGatherInfoTask() function.");

                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                     
                        ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_PerformMode):- Before GetGatherInfoTaskActivities() function.");
                        ErrorXML = GetGatherInfoTaskActivities( out str_ActivitiesXML);
                        ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (setPageForTaskDetails_PerformMode):- After GetGatherInfoTaskActivities() function.");
                    }

                    if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_TaskXML)) && (!String.IsNullOrEmpty(str_ActivitiesXML))) 
                    {
                        MergeTaskActivities(str_TaskXML, str_ActivitiesXML, out ReturnTaskXML);    

                        InputXMLDoc.LoadXml(ReturnTaskXML);
                        
                        str_DynamicFormName = __ProcessDefinitionID.Value + "_" + str_StdFormName;
                        FormConfigXMLPath   = MWBHelperClassObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out str_SelectedFormName);
                        FormFacadeObj.FormName = str_SelectedFormName;
                        FormFacadeObj.ShowConfiguredFields = true;
                        
                        //Radha:For component facet series action bar.
                        FormConfigXML   = File.ReadAllText(FormConfigXMLPath);
                        FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out SearchXML);
                        //HemantK:For Component Facet Series
                        GetComponentFacetForTask(ref InputXMLDoc, ref FormConfigXML, SearchXML);
                        CheckComponentFacetSeriesStatus(Frm_TaskDetails);
                        
                        ProcessColl.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", InputXMLDoc.OuterXml);
                        ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ProcessColl.ToString(), out FormInputXML, out ObjInfoList);
                        //ViewState["ObjectList"] = ObjInfoList;
                        
                        PackageDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID").InnerText;
                        ProcessDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").InnerText;
                        __TaskStatus.Value = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/STATUS").InnerText;
                        TaskName = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                        //ViewState["TaskTitle"] = TaskName; 
                        RO_GatherInfoBreadCrumb.DisplayText = TaskName;
                        ProcessActivityNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                        
                        // Save the Gather info task Task 
                        TempNode = ProcessActivityNode.SelectSingleNode("ACTIVITY[ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "']");
                        if ((Mode.ToUpper() == "PERFORM") && (TempNode == null) && (str_ResponseBreadCrumbs == "0"))
                        {
                            //ViewState["IsUserContributor"] = "false";
                            gotoErrorPage(Localization.GetString("ALResource", ALParamObj.TenantName, "Unauthorised_Access_Shared"));
                            return;
                        }
                        else
                        {
                            //ViewState["IsUserContributor"] = "true";
                            TempPath.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), TaskFile);
                            InputXMLDoc.Save(TempPath.ToString());
                            TempPath.Remove(0, TempPath.Length);
                            xp_SortExpression   = XPathExpression.Compile("ACTIVITY");
                            xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                            xp_SortNodeIter     = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                            while (xp_SortNodeIter.MoveNext())
                            {
                                str_SortXML     += xp_SortNodeIter.Current.OuterXml;
                            }
                            ProcessActivityNode.InnerXml = str_SortXML;

                            if (FormConfigXML != null)
                            {
                                Frm_TaskDetails.ConfigurationXML = FormConfigXML;

                                // display the initiator
                                //Initiator = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                setInitiatorSelectionControl(null);
                                //Display Attachments
                                FileSystemNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM");
                                XmlNode AssetNodeNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ASSETREFERENCES");
                                setAttachments(FileSystemNode, AssetNodeNode);
                                //PaintPredecessorList(ReturnTaskXML);
                                //apply percentdone class
                                ApplyPercentDoneClass(__TaskStatus.Value, InputXMLDoc, ref FormInputXML);

								TempDoc.LoadXml(FormInputXML);
								if((__TaskStatus.Value.ToUpper() != "COMPLETED") && (__TaskStatus.Value.ToUpper() != "CANCELLED"))
								{
                                    TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALSTARTDATE']");
									if(TempNode != null)
									{
										((XmlElement)TempNode).SetAttribute("FieldVisible", "false");
									}
                                    TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALENDDATE']");
									if(TempNode != null)
									{
										((XmlElement)TempNode).SetAttribute("FieldVisible", "false");
									}
								}

                                TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASESTARTDATE']");
                                if (TempNode != null)
                                    ((XmlElement)TempNode).SetAttribute("FieldVisible", "false");

                                TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASEENDDATE']");
                                if (TempNode != null)
                                    ((XmlElement)TempNode).SetAttribute("FieldVisible", "false");

								Frm_TaskDetails.InputXML = TempDoc.OuterXml;
                                ActivityNodeList = InputXMLDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE='Task']");

                                foreach (XmlNode ActivityNode in ActivityNodeList)
                                {
                                    setROResponseForm(ActivityNode);

                                }
                            }
                            ViewState["StepFormIDList"] = StepFormIDTable;
                            ViewState["ActivityIDList"] = ActivityIDOrderedList;
                            setGatherInfoTaskActionBar(Mode, __TaskStatus.Value);
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }
            
            private String GetBackURL()
			{
				StringBuilder ParamURL  = null;
				//StringBuilder URL       = null;              
				try
				{
					ParamURL = new StringBuilder();
					//URL = new StringBuilder();
                    if (!IsPostBack)
                    {
                        if (PrevScreen.ToUpper().Equals("VIEWDELIVERABLES"))
                            ParamURL.Append("/" + ALParamObj.TenantName + "/" + SolutionName + "/ASPX/Manage_DeliverableList.aspx?" + ALSolutionCommon.AppendStandardParamforURL(ALParamObj));
                        else
                        {
                            ParamURL.Append(@"/" + ALParamObj.TenantName + "/" + SolutionName + "/ASPX/Manage_RODeliverableDetails.aspx?TenantName=" + ALParamObj.TenantName + "&Language="
                            + "" + ALParamObj.Language + "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&DeliverableID=" + DeliverableID + "&ProjectID="
                            + ProjectID + "&Mode=" + Mode + "&Access=" + Access + "&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID=" + BreadCrumbCtrlID + "");
                        }
                    }
                    else
                    {
                        ParamURL.AppendFormat("Manage_ROGatherInfoTask.aspxTenantName={0}&Language={1}&SessionID={2}&UserID={3}&FormMode={4}&DeliverableID={5}&ProjectID={6}&TaskID={7}&Access={8}&BREADCRUMBCTRLID={9}&PrevScreen={10}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, "Edit", DeliverableID, ProjectID, TaskID, Access, BreadCrumbCtrlID, PrevScreen);
                        ParamURL.AppendFormat("&PARENTBREADCRUMBNAME={0}&Mode={1}&PackageDefinitionID={2}&ProcessDefinitionID={3}", ParentBreadcrumbName, Mode, __PackageDefinitionID.Value, __ProcessDefinitionID.Value);
                    }
					return ParamURL.ToString();
				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
			}

            private void gotoErrorPage(String ErrorMessage)
			{			
				StringBuilder   BackURL			= null;
				String			strErrorPageUrl	= null;
				StringBuilder	ErrorPageUrl	= null;
				try
				{
                    BackURL         = new StringBuilder();
					ErrorPageUrl	= new StringBuilder();

                    BackURL.AppendFormat("/{0}/Common/ASPX/DefaultScene_DefaultPage.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID);
					ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "WORKFLOWPROCESS", null, ErrorMessage, null, BackURL.ToString(), ref strErrorPageUrl);				
                    if (!IsPostBack)
                    {
                        Response.Redirect(strErrorPageUrl, true);
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + strErrorPageUrl + "','_self','');");
				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
			}

            private void setGatherInfoTaskActionBar(String Mode, String TaskStatus)
            {
                StringBuilder ActionBarXMLPath      = null;                
                XmlDocument   ActionBarXMLDoc       = null;
                XmlNode       ActionControlListNode = null;
                try
                {
                    ActionBarXMLPath = new StringBuilder();                    
					ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Manage_ROGatherInfoTask_Content_6_ab_Task_ActionBar_ActionBar"));

                    ActionBarXMLDoc = new XmlDocument();
                    ActionBarXMLDoc.Load(ActionBarXMLPath.ToString());
                    ActionControlListNode = ActionBarXMLDoc.SelectSingleNode("ActionControlList");

                    //if (__TaskInitiatorID.Value != ALParamObj.UserID)
					if(Access.ToUpper()=="READ")
                    {
                        ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_CancelTask']"));
                        //ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_PrintTask']")); 
                        ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ReRoute']"));
                    }
                    else
                    {
                        if ((TaskStatus.ToUpper() != "ACTIVE") || (Mode.ToUpper() != "MANAGE"))
                        {
                            ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_CancelTask']"));
                        }
                        if ((TaskStatus.ToUpper() != "COMPLETED") || (Mode.ToUpper() != "MANAGE"))
                        {
                            ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ReRoute']"));
                        }
                    }
                    Ab_ROGatherInfoTask.InputXML = ActionBarXMLDoc.InnerXml;
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setInitiatorSelectionControl(XmlNode InitiatorNode)
            {
                StringBuilder PrevSelectedUserXML = null;
                String		  OldUserXML		  = null;
				bool		  IsFirstTime		  = false;
                try
                {
                    PrevSelectedUserXML = new StringBuilder();
                    if (InitiatorNode != null)
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList>{0}</SelectedUsersList></UserSelectionXML>", InitiatorNode.InnerXml);
                    else
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList></SelectedUsersList></UserSelectionXML>");
                        
                        OldUserXML = UC_InitiatorSelection.PrevSelectedUserXML;
					if(String.Compare(OldUserXML, PrevSelectedUserXML.ToString(), true) != 0)
						IsFirstTime = true;

					if(IsFirstTime)
						UC_InitiatorSelection.FirstTime = "TRUE";

                    UC_InitiatorSelection.TenantName          = ALParamObj.TenantName;
                    UC_InitiatorSelection.SessionID           = ALParamObj.SessionID;
                    UC_InitiatorSelection.UserID              = ALParamObj.UserID;
                    UC_InitiatorSelection.Language            = ALParamObj.Language;
                    UC_InitiatorSelection.InstanceName        = "GatherInfoTask_Initiator";
                    UC_InitiatorSelection.Layout              = "SIMPLE";
                    UC_InitiatorSelection.Mode                = "READONLY";
                    UC_InitiatorSelection.SolutionName        = SolutionName;
                    UC_InitiatorSelection.PrevSelectedUserXML = PrevSelectedUserXML.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setAttachments(XmlNode FileSystemNode,XmlNode AssetReferences)
            { 
                StringBuilder UploadUrlPath     = null;
                StringBuilder DownLoadUrlPath   = null;
                StringBuilder ParameterList     = null;
                String        FileSystemXml     = "";
                try
                {
                    UploadUrlPath                   = new StringBuilder();
                    DownLoadUrlPath                 = new StringBuilder();
                    ParameterList                   = new StringBuilder();
					ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName,ALParamObj.Language);
                    UploadUrlPath.AppendFormat("../../Common/ASPX/UploadFiles.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                    ParameterList.Remove(0, ParameterList.Length);
                    ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language);
                    DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                    Binder_Attachments.TenantName           = ALParamObj.TenantName;
                    Binder_Attachments.SolutionName         = "MarketingWorkBench";
                    Binder_Attachments.BinderListHeading    = Localization.GetString("ALResource", ALParamObj.TenantName, "Attachments_shared");
                    Binder_Attachments.Layout               = Binder.LayoutType.BinderList_WithThumbnails;
                    Binder_Attachments.Mode                 = Binder.Modes.ReadOnly;
                    Binder_Attachments.InputXMLType         = Binder.InputType.InnerXML;
                    Binder_Attachments.ListConfigurationName= "TaskAttachments";
                    Binder_Attachments.FieldName            = "ATTACHMENTS";
                    //Binder_Attachments.ConfigName = "PROJECT_ATTACH";
                    Binder_Attachments.UploadUrl            = UploadUrlPath.ToString();
                    Binder_Attachments.DownloadUrl          = DownLoadUrlPath.ToString();
                    Binder_Attachments.EnableAssetSelection = true;
                    Binder_Attachments.DigitalAssetRelationShip = "PROCESS_ASSETREFERENCES";

                    Attachment.TenantName   = ALParamObj.TenantName;
                    Attachment.SessionID    = ALParamObj.SessionID;
                    Attachment.UserID       = ALParamObj.UserID;
                    Attachment.ThemeName    = Page.Theme;
                    Attachment.Language     = ALParamObj.Language;
                    Attachment.BinderFieldName = "ATTACHMENTS";
                    
                    if (FileSystemNode != null)
                        FileSystemXml = FileSystemNode.OuterXml;

                    if (AssetReferences != null)
                    {
                        if (FileSystemNode == null)
                        {
                            Attachment.PrepareInputXMLWithAssetReferences(null, AssetReferences.CreateNavigator(), ref FileSystemXml);
                        }
                        else
                        {
                            Attachment.PrepareInputXMLWithAssetReferences(FileSystemNode.CreateNavigator(), AssetReferences.CreateNavigator(), ref FileSystemXml);
                        }
                    }

                    Binder_Attachments.InputXML = FileSystemXml;
                    //if (FileSystemNode.SelectNodes("BINDER").Count > 0)
                    //{
                    //    Binder_Attachments.BinderOperation = "Update";
                    //    Binder_Attachments.InputXML = FileSystemNode.OuterXml;
                    //}
                    //else
                    //{
                    //    Binder_Attachments.BinderOperation = "Update";
                    //    Binder_Attachments.InputXML = null;
                    //}
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void PaintPredecessorList(XML TaskXML)
            {
                ERRORXML                    ErrorXMLString          = null;
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;
                ListFacade                  ListFacadeObj           = null;
                XmlDocument                 AssociationXMLDoc       = null;
                XmlDocument                 InputXMLDoc             = null; 
                XmlNode                     Process_ActivityNode    = null;
                XmlNode                     WFProcessNode           = null; 
                XmlNode                     SearchXMLNode           = null; 
                XML                         PredecessorListXML      = null; 
                XML                         ConfigXML               = null; 
                String                      ParentActivityID        = null; 
                StringBuilder               ParamURL                = null;
                StringBuilder               URL                     = null; 
     
                try
                {
                    AssociationXMLDoc       = new XmlDocument();
                    InputXMLDoc             = new XmlDocument();
                    ParamURL                = new StringBuilder();
                    URL                     = new StringBuilder();
                    MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ListFacadeObj           = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        
                    
                    AssociationXMLDoc = null;
                    AssociationXMLDoc = new XmlDocument();
                    AssociationXMLDoc.LoadXml(TaskXML);

                    WFProcessNode = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS");
                    if ((WFProcessNode != null) && (WFProcessNode.HasChildNodes))
                    {
                        ParentActivityID = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/ACTIVITYID").InnerText;   
                        //Now get the Predecessors for the current deliverable
                        Process_ActivityNode = null;
                        ErrorXMLString = GetPredecessors(WFProcessNode, ParentActivityID, ref Process_ActivityNode);
                        if (ErrorXMLString != null)
                        {
                            //Error Getting Predecessors paint empty list
                            ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
                            Lst_PredecessorList.Source = PredecessorListXML;
                        }
                        else
                        {
                            if ((Process_ActivityNode != null) && (Process_ActivityNode.HasChildNodes))
                            {
                                //Prepare Predecessor List.
                                SearchXMLNode = InputXMLDoc.CreateElement("SEARCHOUTPUTXML");
                                InputXMLDoc.AppendChild(SearchXMLNode);
                                SearchXMLNode.AppendChild(InputXMLDoc.ImportNode(Process_ActivityNode, true));
                                //Get the Configuration XML from ListConfigurationXML
                                //ListFacadeObj.AddParameter("ProjectID", ParentProjectID);
                                //PackageDefinitionID = __PackageDefinitionID.Value;
                                //ProcessDefinitionID = __ProcessDefinitionID.Value;
                                ListFacadeObj.AddParameter("PackageDefinitionID", PackageDefinitionID);
                                ListFacadeObj.AddParameter("ProcessDefinitionID", ProcessDefinitionID);
                                ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "PredecessorListForROTask");
                                if (ConfigXML != null)
                                {
                                    ListFacadeObj.PrepareListXml(ConfigXML, InputXMLDoc.OuterXml, out PredecessorListXML);
                                    if (PredecessorListXML != null)
                                    {                                    
										// Do not delete this commented code.
										////ParamURL.AppendFormat("Manage_DefineConditions.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionId={4}&ProcessDefinitionId={5}&ParentID={6}&TaskID={7}&RDFRelationshipName={8}&ToActivityID={9}&FromActivityID=", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID, ParentDeliverableID, TaskID, RDF_RelationshipName, ParentActivityID);
										//ParamURL.AppendFormat("Manage_DefineConditions.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionId={4}&ProcessDefinitionId={5}&ParentID=111&TaskID={6}&RDFRelationshipName={7}&ToActivityID={8}&FormMode=READONLY&FromActivityID=", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID, TaskID, RDF_RelationshipName, ParentActivityID);

										//MktgWorkBenchFacadeObj.InnsertConditionImages(PredecessorListXML, ParamURL.ToString(), out FinalListXML);
										MktgWorkBenchFacadeObj.InsertPercentCompleteClass("DUEDATE", ref PredecessorListXML);
										Lst_PredecessorList.Source = PredecessorListXML;
                                    }
                                    else
                                    {
                                        //There are no Predecessors paint empty list
                                        ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
                                        Lst_PredecessorList.Source = PredecessorListXML;
                                    }
                                }
                            }
                            else
                            {
                                //There are no Predecessors paint empty list
                                ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
                                Lst_PredecessorList.Source = PredecessorListXML;
                            }
                        }
                    }
                    else
                    {
                        ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
                        Lst_PredecessorList.Source = PredecessorListXML;
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            private ERRORXML GetPredecessors(XmlNode WFProcessNode, String ActIDForTask, ref XmlNode Predecessor_ActivityNode)
            {
                ERRORXML                ErrorXMLString          = null;
                XmlDocument             ReturnXMLDoc            = null;
                XmlNode                 Process_ActivityNode    = null;
                XmlNode                 Process_TransitionNode  = null;
                XmlNode                 ActivityNode            = null; 
                XmlNode                 OperationNode           = null; 
                XmlNodeList             TransitionNodes         = null; 
                String                  PrdecessorID            = null; 
     
                try
                {
                    ReturnXMLDoc = new XmlDocument();
                    Predecessor_ActivityNode = ReturnXMLDoc.CreateElement("PROCESS_ACTIVITY");

                    //Select Process Activities and Process Transition nodes
                    Process_ActivityNode    = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY");
                    Process_TransitionNode  = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");

                    //Select Predecessors
                    TransitionNodes = Process_TransitionNode.SelectNodes("TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID='" + ActIDForTask + "']");
                    foreach (XmlNode Transition in TransitionNodes)
                    {
                        OperationNode = Transition.Attributes.GetNamedItem("Operation");
                        if ((OperationNode != null) && (OperationNode.InnerText.ToUpper() != "DELETED"))
                        {
                            PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                            ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
                            if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE") 
                                Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
                        }
                        else if (OperationNode == null)
                        {
                            PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                            ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
                            if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE") 
                                Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
                        }
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }
            
            private ERRORXML CancelTask()
            {
                StringBuilder               UpdateTaskXML   = null;
                String                      TaskStatus      = "Cancelled";                
                MktgWorkBenchFacadeClass    MktgWBFacadeObj = null;
                XML                         SaveTaskXML     = null;
                ERRORXML                    ErrorXML        = null;

                try
                {
                    UpdateTaskXML   = new StringBuilder();
                    if ((__TaskStatus.Value.ToUpper() != "CANCELLED") && (__TaskStatus.Value.ToUpper() != "COMPLETED"))
                    {
                        MktgWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        UpdateTaskXML.AppendFormat("<WORKFLOWPROCESS><WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>", TaskID);
                        UpdateTaskXML.AppendFormat("<STATUS>{0}</STATUS>", TaskStatus);
                        UpdateTaskXML.AppendFormat("</WORKFLOWPROCESS>");
                        SaveTaskXML = UpdateTaskXML.ToString();
                        ErrorXML = MktgWBFacadeObj.UpdateTask(TaskID, false, MWB_TimeLineEvents.NONE, true, ref SaveTaskXML);
                    }                    
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {
					throw (ExceptionObj);
                }
            }

            private ERRORXML ReRouteTask(out String NewTaskID)
            {
                MktgWorkBenchFacadeClass    obj_MWBFacade       = null;
                StringBuilder               AssociationXML      = null;
                StringBuilder               InputXML            = null;
                ERRORXML                    ErrorXML            = null;
                String                      str_ActFacets       = null;
                String                      str_ProcessFacets   = null;                
                InfrastructureFacadeClass   InfrastructureFacadeClassObj    = null;
                String                      str_ObjectIDSeries              = null;

                try
                {
                obj_MWBFacade   = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                InfrastructureFacadeClassObj = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);                                
                AssociationXML  = new StringBuilder(100);
                InputXML        = new StringBuilder(100);
                NewTaskID       = null;
                ErrorXML        = InfrastructureFacadeClassObj.GetNextIDInSeries("TaskUniqueID_Series", ref str_ObjectIDSeries);
                if (!String.IsNullOrEmpty(ErrorXML))
                    return ErrorXML;

                obj_MWBFacade.GetAssociatedAdditionaFacets(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, out str_ProcessFacets, out str_ActFacets);
               
                AssociationXML.AppendFormat(@"<ASSOCIATION>
                                                <PROCESS_INFORMATION Type='RELATION' PrimaryKey='WORKFLOWPROCESSINFOID' Operation='Create' IsFacet='False'>
                                                    <PRIORITY/>
                                                    <FINISHMODE/>
                                                    <NOTIFYCONTRIBUTORSONRESPONSE/>
                                                    <DURATIONUNIT/>
                                                    <PROCESSDEFINITIONID/>
                                                    <NOTIFYONRESPONSE/>
                                                    <PACKAGEDEFINITIONID/>
                                                    <DURATION/>
                                                    <COMPLETEDDURATION/>
			                                        <PERCENTDONE/>
                                                    <STARTDATELOCKED/>
                                                </PROCESS_INFORMATION>
                                                <PROCESS_ASSETREFERENCES Type='RELATION' PrimaryKey='DIGITALASSETID' Operation='Association' IsFacet='False'><DIGITALASSETID/></PROCESS_ASSETREFERENCES>
                                                <WORKFLOWPROCESS_WORKFLOWINFORMATION Type='RELATION' PrimaryKey='WORKFLOWINFORMATIONID' Operation='Create' IsFacet='False'>
                                                    <WORKFLOWSUBCATEGORY/>
                                                    <ROUTEMETHOD/>
                                                    <CCTOOWNER/>                                                    
                                                    <REMINDERFREQUENCY/>
                                                    <NOTIFYIFJOBDELAYED/>
                                                    <WORKFLOWCATEGORY/>
                                                </WORKFLOWPROCESS_WORKFLOWINFORMATION>
                                                <PROCESS_ACTIVITY Type='RELATION' PrimaryKey='ACTIVITYID' Operation='Create' IsFacet='False'>
                                                    <ACTIVITYID/>
                                                    <ACTIVITYNAME/>
                                                    <DESCRIPTION/>
                                                    <STATUS/>
                                                    <STARTACTIVITY/>
                                                    <ENDACTIVITY/>
                                                    <STARTDATE/>
                                                    <ACTIVITYTYPE/>
                                                    <IMPLEMENTATIONTYPE/>
                                                    <TASKTYPE/>
                                                    <INSTRUCTIONS/>
                                                    <SEQUENCENUMBER/>
                                                    <ACTIVITY_INFORMATION Type='RELATION' PrimaryKey='ACTIVITYINFORMATIONID' Operation='Create' IsFacet='False'>
                                                        <STARTMODE/>
				                                        <FINISHMODE/>
				                                        <STARTQUANTITY/>
				                                        <DURATION/>				                                        
				                                        <SLACKTIME/>
				                                        <PRIORITY/>
                                                        <COMPLETEDDURATION/>
					                                    <PERCENTDONE/>
				                                        <PACKAGEDEFINITIONID/>
				                                        <PROCESSDEFINITIONID/>
				                                        <ACTIVITYDEFINITIONID/>                                                        
                                                    </ACTIVITY_INFORMATION>
                                                    <ACTIVITY_RESOURCE Type='RELATION' PrimaryKey='RESOURCEID' Operation='Create' IsFacet='False'>
                                                        <ACTUAL_RESOURCE Type='RELATION' PrimaryKey='RESOURCEID' Operation='Create' IsFacet='False'>
                                                            <RESOURCE_USER Type='RELATION' PrimaryKey='USERID' Operation='Association' IsFacet='False'>
                                                                <USERID/>
                                                            </RESOURCE_USER>
                                                        </ACTUAL_RESOURCE>
                                                    </ACTIVITY_RESOURCE>
                                                    <ACTIVITY_RESPONSE Type='RELATION' PrimaryKey='RESPONSEID' Operation='Create' IsFacet='False' FileRequired='Yes'/>
                                                    <ACTIVITY_CONTRIBUTOR Type='RELATION' PrimaryKey='USERID' Operation='Association' IsFacet='False'>
                                                        <USERID/>
                                                    </ACTIVITY_CONTRIBUTOR>" + obj_MWBFacade.getRelationshipXMLfromFacetList(str_ActFacets) + @"</PROCESS_ACTIVITY>
                                                <PROCESS_TRANSITION Type='RELATION' PrimaryKey='TRANSITIONID' Operation='Create' IsFacet='False'>
                                                    <FROMACTIVITY Type='RELATION' PrimaryKey='ACTIVITYID' Operation='Association' IsFacet='False'>
                                                        <ACTIVITYID/>
                                                    </FROMACTIVITY>
                                                    <TOACTIVITY Type='RELATION' PrimaryKey='ACTIVITYID' Operation='Association' IsFacet='False'>
                                                        <ACTIVITYID/>
                                                    </TOACTIVITY>
                                                </PROCESS_TRANSITION>
                                                <PROCESSCOMPLETION_USER Type='RELATION' PrimaryKey='USERID' Operation='Association' IsFacet='False'>
                                                    <USERID/>
                                                    <FILTERLIST>
                                                        <FILTER>
	                                                        <EXPRESSION>STATUS</EXPRESSION>
	                                                        <OPERATOR>EQUALTO</OPERATOR>
	                                                        <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
	                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </PROCESSCOMPLETION_USER>
                                                <PROCESSCOMPLETION_GROUP Type='RELATION' PrimaryKey='GROUPID' Operation='Association' IsFacet='False'>
                                                    <GROUPID/>
                                                    <FILTERLIST>
                                                        <FILTER>
	                                                        <EXPRESSION>ISDELETED</EXPRESSION>
	                                                        <OPERATOR>EQUALTO</OPERATOR>
	                                                        <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
	                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </PROCESSCOMPLETION_GROUP>
                                                <READERS Type='RELATION' PrimaryKey='USERID' Operation='Association' IsFacet='False'>
                                                    <USERID/>
                                                    <FILTERLIST>
                                                        <FILTER>
	                                                        <EXPRESSION>STATUS</EXPRESSION>
	                                                        <OPERATOR>EQUALTO</OPERATOR>
	                                                        <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
	                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </READERS>" + obj_MWBFacade.getRelationshipXMLfromFacetList(str_ProcessFacets) + "</ASSOCIATION>");

                 InputXML.AppendFormat(@"<WORKFLOWPROCESS>
	                                            <STARTDATE>
		                                            <YEAR>{0}</YEAR>
		                                            <MONTH>{1}</MONTH>
		                                            <DAY>{2}</DAY>                                                    
	                                            </STARTDATE>
	                                            <DUEDATE>
		                                            <YEAR>{0}</YEAR>
		                                            <MONTH>{1}</MONTH>
		                                            <DAY>{2}</DAY>                                                    
	                                            </DUEDATE>	                                            
	                                            <STATUS>New</STATUS>
                                                <PROCESSNAME>{3}</PROCESSNAME>
                                                <WORKFLOWPROCESSUNIQUEID>{4}</WORKFLOWPROCESSUNIQUEID>
	                                            <PROCESS_INFORMATION TYPE='RELATION'>
		                                            <WORKFLOWPROCESSINFO>
			                                            <COMPLETEDDURATION>0</COMPLETEDDURATION>
			                                            <PERCENTDONE>0</PERCENTDONE>
                                                        <STARTDATELOCKED>1</STARTDATELOCKED>
		                                            </WORKFLOWPROCESSINFO>
	                                            </PROCESS_INFORMATION>
	                                            <WORKFLOWPROCESS_WORKFLOWINFORMATION TYPE='RELATION'>
		                                            <WORKFLOWINFORMATION>
			                                            <WORKFLOWCATEGORY>TASK</WORKFLOWCATEGORY>
															<WORKFLOWSUBCATEGORY>GatherInformation</WORKFLOWSUBCATEGORY>
															<ROUTEMETHOD>NONE</ROUTEMETHOD>
		                                            </WORKFLOWINFORMATION>
	                                            </WORKFLOWPROCESS_WORKFLOWINFORMATION>
                                                <PREVIOUS_WORKFLOW TYPE='RELATION'>{5}</PREVIOUS_WORKFLOW>
	                                            <PROCESS_ACTIVITY TYPE='RELATION'>
		                                            <ACTIVITY>
			                                            <STATUS>New</STATUS>
			                                            <STARTDATE>
				                                            <YEAR>{0}</YEAR>
				                                            <MONTH>{1}</MONTH>
				                                            <DAY>{2}</DAY>                                                          
			                                            </STARTDATE>
			                                            <ACTIVITY_INFORMATION TYPE='RELATION'>
				                                            <ACTIVITYINFORMATION>
					                                            <COMPLETEDDURATION>0</COMPLETEDDURATION>
					                                            <PERCENTDONE>0</PERCENTDONE>
                                                            </ACTIVITYINFORMATION>
			                                            </ACTIVITY_INFORMATION>
		                                            </ACTIVITY>
	                                            </PROCESS_ACTIVITY>	                                                                                        
                                            </WORKFLOWPROCESS>", DateTime.Now.Year.ToString(), DateTime.Now.Month.ToString(), DateTime.Now.Day.ToString(), ALSpecialCharHandling.TrimAndReplaceSpecialChars(RO_GatherInfoBreadCrumb.DisplayText), str_ObjectIDSeries, TaskID);

                    ErrorXML = obj_MWBFacade.CopyTask(TaskID,DeliverableID, AssociationXML.ToString(), InputXML.ToString(),true, out NewTaskID);
                    return ErrorXML;    
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            private ERRORXML SaveTask(out bool alertGiven)
            {
                StringBuilder               UpdateActivityXML       = null;
                StringBuilder               TempPath                = null;
                StringBuilder               DisAssociateXML         = null;
                StringBuilder               UpdateTaskXML           = null;
                String                      TempFilePath            = null;
                String                      SelectedContributor     = null;
                String                      SelectedGroup           = null;
                String                      ActivityResourceID      = null;
                String                      ActualResourceID        = null;
                String                      OldUserID               = null;
                String                      ResponseID              = null;
                String                      StepStatus              = null;                
                int                         ActivityCount           = 0;
                bool                        ActivityModified        = true;
                bool                        DisAssociateUserOnly    = false;
                bool                        ContributorsSelected    = false;
                MktgWorkBenchFacadeClass    MktgFacadeObj           = null;       
                MWB_Helper                  MWB_HelperObj           = null;
                FormFacade                  FormFacadeObj           = null;
                XmlDocument                 TaskDoc                 = null;
                XmlDocument                 ActivityDoc             = null;
                XmlNode                     ActivityNode            = null;
                XmlNode                     OldUserNode             = null;
                XmlNode                     ResourceNode            = null;
                XmlNode                     ActivityResourceNode    = null;
                XmlNode                     DisAssociateResourceNode= null;
                XmlNode                     ResponseNode            = null;
                XmlNode                     ActivityContributorNode = null;                 
                XML                         StepXML                 = null;
                XML                         ReturnActivityXML       = null;
                XML                         ActivityResourceXML     = null;
                XML                         SaveTaskXML             = null;
                ERRORXML                    ErrorXML                = null;
                StringBuilder               NewContributorIDs       = null;
                StringBuilder               OldContributorIDs       = null; 
                StringBuilder               OldContributorXML       = null;
                StringBuilder               Alert_Message           = null;
				String						SelectedGroupName		= null;
				XPathDocument				ActResDoc				= null;
				StringBuilder				ActResFile				= null;
				String						strStdFormName			= null;
				String						strFormName				= null;
				String						strSelectFormName		= null;
				String						strActivityDefID		= null;
                //HemantK:For Component Facet Series
                String                      str_FormActionBarXML    = null; 
                StringBuilder               sb_FormActionBarXML     = null;
                Hashtable                   obj_SelectComponentIDs  = null;
                XPathDocument               xpathDoc_FormConfig     = null;
                XPathNavigator              xpathNav_ComponentFacet = null;
                String                      str_ComponentFacetName  = null;
                String                      str_ComponentFacetPK    = null;

                long                        l_StepDuration          = 0;
                Boolean                     bool_StepDurationChanged= false;
                StringBuilder               sb_DurationChanedStepIDs= null;
                long                        l_ProcessDuration       = 0;
                PMFacadeClass               PMFacadeObj             = null;
                StringDictionary            strDict_PlaceHolder     = null;
                
                try
                {
                    MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MktgFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_SelectComponentIDs = new Hashtable();
                    UpdateTaskXML       = new StringBuilder();
                    TempPath            = new StringBuilder();
                    UpdateActivityXML   = new StringBuilder();
                    DisAssociateXML     = new StringBuilder();
                    ActivityDoc         = new XmlDocument();
                    TaskDoc             = new XmlDocument();
                    OldContributorIDs   = new StringBuilder();
                    NewContributorIDs   = new StringBuilder();
                    OldContributorXML   = new StringBuilder();
                    sb_FormActionBarXML = new StringBuilder(500);
                    sb_DurationChanedStepIDs = new StringBuilder(50);
                    alertGiven			= false;
					//FormFacadeObj.ReturnOnlyRelatedInfo = true;

                    if ((__TaskStatus.Value.ToUpper() != "CANCELLED")&&(__TaskStatus.Value.ToUpper() != "COMPLETED"))
                    {
                        FormFacadeObj.SolutionName	= SolutionName;
                        TempFilePath				= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                        StepFormIDTable				= (Hashtable)ViewState["StepFormIDList"];
                        IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                        ActivityCount = 0;
                        TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
                        TaskDoc.Load(TempPath.ToString());
                        UpdateTaskXML.AppendFormat("<WORKFLOWPROCESS><WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>", TaskID);
                        UpdateTaskXML.AppendFormat("<PROCESS_ACTIVITY TYPE='RELATION'>");
                        OldContributorXML.Append("<USERCOLLECTION>");
						ActResFile	= new StringBuilder();
						ActResFile.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
						if(File.Exists(ActResFile.ToString()))
						{
							ActResDoc = new XPathDocument(ActResFile.ToString());
						}
						strStdFormName = "StepDetails_Editable";

                        sb_FormActionBarXML.Append("<ACTIONBARCOLLECTION>");

                        while (StepFormIDEnum.MoveNext())
                        {
                            ActivityCount++;
                            ActivityModified		= true;
                            DisAssociateUserOnly	= false;
                            ContributorsSelected    = false;
                            ResponseID				= null;
                            OldUserID               = null;
                            OldUserNode             = null;
                            Form StepForm			= (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());                            
							SelectedGroup			= MWB_HelperObj.GetSelectedActivityResourceID(ActResDoc, StepFormIDEnum.Key.ToString(), out SelectedGroupName);
                            SelectedContributor		= StepForm.GetValues("Contributor");
                            
                            if ((!String.IsNullOrEmpty(StepForm.ConfigurationXML)) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                            {
                                xpathDoc_FormConfig = new XPathDocument(new StringReader(StepForm.ConfigurationXML));
                                if (xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                                {
                                    obj_SelectComponentIDs.Add(StepFormIDEnum.Key.ToString(), true);
                                }
                                else
                                {
                                    obj_SelectComponentIDs.Add(StepFormIDEnum.Key.ToString(), false);
                                }

                                xpathNav_ComponentFacet = xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "' and @IsSeries='YES']");
                                if (xpathNav_ComponentFacet != null)
                                {
                                    str_ComponentFacetName = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                                    str_ComponentFacetPK = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                                }
                            }

                            StepObjInfoList = (List<ObjectInfo>)ViewState["StepObjectList" + StepFormIDEnum.Key.ToString()];
                            //if ((SelectedGroup.ToUpper() != "NONE") && (SelectedContributor.ToUpper() != "NONE"))
                            ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']");
                            if((!String.IsNullOrEmpty(ActivityNode.SelectSingleNode("STATUS").InnerText)) && (ActivityNode.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE"))
                            {
                                if ((!String.IsNullOrEmpty(SelectedContributor)) && (SelectedContributor.ToUpper() != "NONE"))
                                    ContributorsSelected = true;
                                if (ActivityNode != null)
                                {
									strActivityDefID	= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
									StepStatus			= ActivityNode.SelectSingleNode("STATUS").InnerText;
									strFormName			= strActivityDefID + "_Editable";
									MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectFormName);
									FormFacadeObj.FormName = strSelectFormName;

                                    if ((StepStatus.ToUpper() == "ACTIVE") && (!ContributorsSelected))
                                    {
                                        Alert_Message       = new StringBuilder(100);
                                        strDict_PlaceHolder = new StringDictionary();
                                        strDict_PlaceHolder.Add("ACTIVITYNAME", ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText);
                                        alertGiven = true;

                                        Alert_Message.Append(Localization.GetString("ALJSResource", ALParamObj.TenantName, "Alert_MWB_PleaseSelectContibutorFor_Shared",strDict_PlaceHolder));
                                        Ajax.WriteExecuteJavaScript("alert(DecodeSpecialCharactersForJS('" + ALSpecialCharHandling.EncodeSpecialCharactersForJS(Alert_Message.ToString()) + "'));");
                                        return ErrorXML;
                                    }

                                    //ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE");
                                    //if (ResponseNode != null)
                                    //    ResponseID = ResponseNode.SelectSingleNode("RESPONSEID").InnerText;
                                    MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
                                    if ((ActivityResourceID != null) && (ActualResourceID != null))
                                    {
                                        // group and contributor both changed.
                                        OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
                                        if (OldUserNode != null)
                                        {
                                            OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
                                        }

                                        if (SelectedGroup != ActivityResourceID)
                                        {
                                            DisAssociateXML.Remove(0, DisAssociateXML.Length);
                                            DisAssociateXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>", ActivityResourceID);
                                            if (OldUserID!= null)
											{
												DisAssociateXML.AppendFormat(@"<ACTUAL_RESOURCE TYPE='RELATION'>
																				<RESOURCE MODIFIED='TRUE'>
																				<RESOURCEID>{0}</RESOURCEID>
																				<RESOURCE_USER TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</RESOURCE_USER>
																				</RESOURCE>
																			</ACTUAL_RESOURCE>", ActualResourceID, OldUserID);
											}
                                            DisAssociateXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTUAL_RESOURCE>", ActualResourceID);
                                            //Put the old and new contributors in the hidden field so as to send them notifications
                                            
                                            if (!String.IsNullOrEmpty(__NewContributorIDs_HF.Value))
                                            {
                                                NewContributorIDs.Remove(0, NewContributorIDs.Length);
                                                NewContributorIDs.AppendFormat("{0},{1}", __NewContributorIDs_HF.Value, SelectedContributor);
                                                __NewContributorIDs_HF.Value = NewContributorIDs.ToString();
                                            }
                                            else
                                                __NewContributorIDs_HF.Value = SelectedContributor;

                                            if (OldUserNode != null)
                                            {
                                                if (!String.IsNullOrEmpty(__OldContributorIDs_HF.Value))
                                                {
                                                    OldContributorIDs.Remove(0, OldContributorIDs.Length);
                                                    OldContributorIDs.AppendFormat("{0},{1}", __OldContributorIDs_HF.Value, OldUserID);
                                                    __OldContributorIDs_HF.Value = OldContributorIDs.ToString();
                                                }
                                                else
                                                    __OldContributorIDs_HF.Value = OldUserID;

                                                OldContributorXML.AppendFormat("<OLDUSER>{0}<ACTIVITYID>{1}</ACTIVITYID></OLDUSER>", OldUserNode.OuterXml, ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                                            }
                                        }
                                        else if (OldUserID != SelectedContributor )
                                        {
                                            DisAssociateUserOnly = true;
                                            // the selected group is same but the contributor is changed.
                                            //Put the old and new contributors in the hidden field so as to send them notifications
                                            
                                            if (!String.IsNullOrEmpty(__NewContributorIDs_HF.Value))
                                            {
                                                NewContributorIDs.Remove(0, NewContributorIDs.Length);
                                                NewContributorIDs.AppendFormat("{0},{1}", __NewContributorIDs_HF.Value, SelectedContributor);
                                                __NewContributorIDs_HF.Value = NewContributorIDs.ToString();
                                            }
                                            else
                                                __NewContributorIDs_HF.Value = SelectedContributor;
                                            
                                            if (OldUserNode != null)
                                            {
                                                if (!String.IsNullOrEmpty(__OldContributorIDs_HF.Value))
                                                {
                                                    OldContributorIDs.Remove(0, OldContributorIDs.Length);
                                                    OldContributorIDs.AppendFormat("{0},{1}", __OldContributorIDs_HF.Value, OldUserID);
                                                    __OldContributorIDs_HF.Value = OldContributorIDs.ToString();
                                                }
                                                else
                                                    __OldContributorIDs_HF.Value = OldUserID;

                                                OldContributorXML.AppendFormat("<OLDUSER>{0}<ACTIVITYID>{1}</ACTIVITYID></OLDUSER>", OldUserNode.OuterXml, ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                                            }
                                        }
                                        else
                                        {
                                            ActivityResourceID = null;
                                            ActualResourceID = null;
                                            ActivityModified = false;
                                        }
                                    }
                                }
								ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", StepForm, StepObjInfoList, out StepXML);
								if(ErrorXML == null)
								{
                                    //HemantK:Get the Form ActionBar
                                    str_FormActionBarXML = GetFormActionBarXML(StepForm);
                                    if (!String.IsNullOrEmpty(str_FormActionBarXML))
                                    {
                                        sb_FormActionBarXML.Append(@"<ACTIONBAR> 
                                                                        <ACTIONBARFOR>ACTIVITY</ACTIONBARFOR>
                                                                        <ID>" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + "</ID>"
                                                                                + str_FormActionBarXML + "</ACTIONBAR>");
                                    }

                                    //Check for duration change
                                    if (ViewState["Duration_" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + ""] != null)
                                    {
                                        MWB_HelperObj.ValidateDueDate(ActivityNode.CreateNavigator(), StepForm.GetValues("Duration"), out alertGiven, out l_StepDuration);
                                        if ((alertGiven) && (ActivityNode.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE"))
                                        {
                                            Alert_Message = new StringBuilder(50);
                                            Alert_Message.Append(Localization.GetString("ALJSResource", ALParamObj.TenantName, "Alert_MWB_InvalidDuration_Shared") + " " + Localization.GetString("ALJSResource", ALParamObj.TenantName, "Alert_InvalidDuration_For_Shared") + " " + ALSpecialCharHandling.EncodeSpecialCharactersForJS(ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText) + ".");
                                            Ajax.WriteExecuteJavaScript("alert(DecodeSpecialCharactersForJS('" + Alert_Message.ToString() + "'));");
                                            return ErrorXML;
                                        }

                                        //Calculate actual duration.
                                        l_ProcessDuration = Math.Max(l_ProcessDuration, l_StepDuration);

                                        if ((ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION") != null) && (ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION").InnerText != l_StepDuration.ToString()))
                                        {
                                            ActivityDoc.LoadXml(StepXML);

                                            if (ActivityDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION") != null)
                                                ActivityDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION").InnerText = l_StepDuration.ToString();
                                            else
                                                ActivityDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION").InnerXml += "<DURATION>" + l_StepDuration.ToString() + "</DURATION>";

                                            StepXML = ActivityDoc.OuterXml;
                                            bool_StepDurationChanged = true;

                                            if (ActivityNode.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE")
                                                sb_DurationChanedStepIDs.Append(ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + ",");
                                        }
                                    }

									if(ActivityModified)
									{
										if((ActivityResourceID != null) || SelectedGroup.ToUpper() != "NONE")
										{
											if((SelectedGroup.ToUpper() != "NONE"))
												ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
											else
												ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + ActivityResourceID + "']");

											// here only the actual resource is modified.
											if(DisAssociateUserOnly && SelectedContributor.ToUpper() != "NONE")
											{
												MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, StepXML, SelectedGroupName, out ReturnActivityXML);
												ActivityDoc.LoadXml(ReturnActivityXML);
												ActivityNode = ActivityDoc.SelectSingleNode("ACTIVITY");
											}
											else
											{
												if(DisAssociateUserOnly)
												{
													MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, StepXML, SelectedGroupName, out ReturnActivityXML);
													ActivityDoc.LoadXml(ReturnActivityXML);
													ActivityNode = ActivityDoc.SelectSingleNode("ACTIVITY");
												}
												else
												{
													if((SelectedGroup.ToUpper() != "NONE"))
													{
														MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML, SelectedGroupName);
														MWB_HelperObj.prepareActivityXML(true, StepXML, ActivityResourceXML, out ReturnActivityXML);
														ActivityDoc.LoadXml(ReturnActivityXML);
														ActivityNode = ActivityDoc.SelectSingleNode("ACTIVITY");
													}
													else
													{
														MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, StepXML, SelectedGroupName, out ReturnActivityXML);
														ActivityDoc.LoadXml(ReturnActivityXML);
														ActivityNode = ActivityDoc.SelectSingleNode("ACTIVITY");
													}
												}

												if((ActivityResourceID != null) && (ActualResourceID != null))
													ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE");

												if(ActivityResourceNode != null)
												{
													if(OldUserNode != null)
													{
														ActivityContributorNode = ActivityDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
														((XmlElement)ActivityContributorNode).SetAttribute("TYPE", "RELATION");
														((XmlElement)ActivityContributorNode).SetAttribute("DISASSOCIATE", "TRUE");
														ActivityContributorNode.InnerText = OldUserNode.SelectSingleNode("USERID").InnerText;
														//ActivityNode.AppendChild(ActivityContributorNode);
														ActivityNode.PrependChild(ActivityContributorNode);
													}
													if(DisAssociateXML.Length > 0)
													{
														DisAssociateResourceNode = ActivityDoc.CreateElement("RESOURCE");
														((XmlElement)DisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");
														DisAssociateResourceNode.InnerXml = DisAssociateXML.ToString();
														ActivityResourceNode.AppendChild(DisAssociateResourceNode);
													}
												}
											}
											if(ActivityNode != null)
											{
                                                //if(ResponseID != null)
                                                //{
                                                //    ResponseNode = ActivityDoc.CreateElement("ACTIVITY_RESPONSE");
                                                //    ((XmlElement)ResponseNode).SetAttribute("TYPE", "RELATION");
                                                //    ((XmlElement)ResponseNode).SetAttribute("DISASSOCIATE", "TRUE");
                                                //    ResponseNode.InnerText = ResponseID;
                                                //    ActivityNode.AppendChild(ResponseNode);
                                                //}
                                                //else
												{
													ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
													if((ResponseNode != null) && (ResponseNode.HasChildNodes))
														ActivityNode.RemoveChild(ResponseNode);
												}
											}
											ReturnActivityXML = ActivityNode.OuterXml;
											// }
											UpdateActivityXML.AppendFormat("{0}", ReturnActivityXML);

											//Stamp notification for the new contributors selected.
											if(ActivityResourceID == null && (SelectedContributor.ToUpper() != "NONE"))
											{
												if(!String.IsNullOrEmpty(__NewContributorIDs_HF.Value))
												{
													NewContributorIDs.Remove(0, NewContributorIDs.Length);
													NewContributorIDs.AppendFormat("{0},{1}", __NewContributorIDs_HF.Value, SelectedContributor);
													__NewContributorIDs_HF.Value = NewContributorIDs.ToString();
												}
												else
													__NewContributorIDs_HF.Value = SelectedContributor;
											}

										}
									}
									else
									{										
										ActivityDoc.LoadXml(StepXML);
										ActivityNode = ActivityDoc.SelectSingleNode("ACTIVITY");
										((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
                                        ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
                                        if ((ResponseNode != null) && (ResponseNode.HasChildNodes))
                                            ActivityNode.RemoveChild(ResponseNode);
										ReturnActivityXML = ActivityNode.OuterXml;
										UpdateActivityXML.AppendFormat("{0}", ReturnActivityXML);
									}
								}
                            }
                            //else
                            //    ContributorsSelected = false;
                        }// END WHILE
                        OldContributorXML.Append("</USERCOLLECTION>"); 
                        UpdateTaskXML.AppendFormat("{0}", UpdateActivityXML.ToString());
                        UpdateTaskXML.Append("</PROCESS_ACTIVITY>");
                        UpdateTaskXML.Append("</WORKFLOWPROCESS>");
                        SaveTaskXML = UpdateTaskXML.ToString();

                        sb_FormActionBarXML.Append("</ACTIONBARCOLLECTION>");
                        
                        PMFacadeObj = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        if (l_ProcessDuration != 0 && checkBoxObj.Checked && PMFacadeObj.ConvertDaysToMinutes(Convert.ToInt64(textBoxObj.Text)) >= l_ProcessDuration)
                        {
                            Ajax.WriteExecuteJavaScript("javascript:ShowAlert('Alert_AdvanceReminderCheck_Shared');");
                            alertGiven = true;
                            return null;
                        }
                        
                        //Hemantk:Update the Component Facet series for Deliverable
                        ErrorXML = UpdateDeliverableComponentForTask(ref SaveTaskXML, sb_FormActionBarXML.ToString(), obj_SelectComponentIDs, str_ComponentFacetName, str_ComponentFacetPK);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            if (bool_StepDurationChanged)
                                ErrorXML = MktgFacadeObj.UpdateTask(TaskID, true, MWB_TimeLineEvents.TASK_DURATION_CHANGED, true, ref SaveTaskXML);
                            else
                                ErrorXML = MktgFacadeObj.UpdateTask(TaskID, false, MWB_TimeLineEvents.NONE, true, ref SaveTaskXML);

                            if (ErrorXML == null)
                            {
                                if ((!String.IsNullOrEmpty(__NewContributorIDs_HF.Value)))
                                    ErrorXML = StampNotificationForGatherInfoTask(TaskID, "ContributorChanged", OldContributorXML.ToString(), null);

                                if (sb_DurationChanedStepIDs.Length > 0)
                                    ErrorXML = StampNotificationForGatherInfoTask(TaskID, "DurationChanged", null, sb_DurationChanedStepIDs.ToString());
                            }
                        }
                    }
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepFormInputXMLForGroup(String StepID, String StepFormID, XML ItemListXML)
            {            
                XML             FormInputXML        = null;            
                XmlNode         FieldNode           = null;
                XmlNode         ValueNode           = null;
                String          TempPath            = null;
                StringBuilder   TempFilePath        = null;
                XmlDocument     FormInputDoc        = null; 
                String          ErrorXML            = null;
                String          ErrorPageURL        = null;
                try
                {
                    //FormfacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.TenantName, ALParamObj.Language);
                    FormInputDoc     = new XmlDocument();
                    TempStepForm     = (Form)Manual_Activities.FindControl(StepFormID);
                    TempFilePath     =  new StringBuilder(); 
                    TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    if (TempStepForm != null)
                    {
                        ErrorXML =  SaveStepForm(StepID, TempStepForm);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            FormInputXML = TempStepForm.InputXML;
                            if (FormInputXML != null)
                            {
                                FormInputDoc.LoadXml(FormInputXML);
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                if (FieldNode != null)
                                {
                                    FieldNode.InnerXml = ItemListXML;
                                    //ViewState[TempStepForm.ID] = TempStepForm.InputXML;
                                    FieldNode = null;
                                }

                                //Comment By : Bhalchandra.
                                //Clear Email ID field.
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FieldNode.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = "";
                                    //FieldNode.AppendChild(ValueNode);
                                }                               

                                TempStepForm.InputXML = FormInputDoc.OuterXml;
                                //TempStepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                                TempStepForm.ResetFacetSeriesFields();
                                TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID);
                                File.WriteAllText(TempFilePath.ToString(), FormInputDoc.OuterXml);
                            }
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepFormInputXMLForMailAddress(String StepID, String StepFormID,String MailID)
            { 
                XML             FormInputXML        = null;            
                XmlNode         FieldNode           = null;
                XmlNode         ValueNode           = null;
                String          TempPath            = null;
                StringBuilder   TempFilePath        = null;
                XmlDocument     FormInputDoc        = null;
                String          ErrorXML            = null;
                String          ErrorPageURL        = null;
                try
                {                                
                    FormInputDoc     = new XmlDocument();
                    TempStepForm     = (Form)Manual_Activities.FindControl(StepFormID);
                    TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);  
                    TempFilePath     = new StringBuilder();
                    if (TempStepForm != null)
                    {
                        ErrorXML =  SaveStepForm(StepID, TempStepForm);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            FormInputXML = TempStepForm.InputXML;
                            if (FormInputXML != null)
                            {
                                FormInputDoc.LoadXml(FormInputXML);

                                //Update the EmailID and Previous Contributors Name
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='PreviousContributor']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FieldNode.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = ViewState["PreviousContributor"].ToString();
                                }
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailID']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FieldNode.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = ViewState["EmailID"].ToString();
                                }

                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FieldNode.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = MailID;
                                    //FieldNode.AppendChild(ValueNode);
                                    TempStepForm.InputXML = FormInputDoc.OuterXml;
                                    //TempStepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                                    TempStepForm.ResetFacetSeriesFields();
                                    //ViewState[TempStepForm.ID] = TempStepForm.InputXML;
                                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID);
                                    File.WriteAllText(TempFilePath.ToString(), FormInputDoc.OuterXml);
                                }

                               
                            }
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setROResponseForm(XmlNode ActivityNode)
            {
                StringBuilder   StepFormID          = null;
                StringBuilder   ActivityColl        = null;
                StringBuilder   ParameterList       = null;
                String          FormConfigXMLPath   = null; 
                MWB_Helper      MWBHelperClassObj   = null;
                FormFacade      FormFacadeObj       = null;
                MktgWorkBenchFacadeClass MWBFacadeObject = null; 
                ERRORXML        ErrorXML            = null;
                XML             FormConfigXML       = null;
                XML             StepFormInputXML    = null;
                XmlDocument     TempDoc            = null;
                XmlAttribute    UploadAttr          = null;
                XmlNode         ResourceUserNode    = null;
                XmlNode         ValueNode           = null;
                XmlNode         TempNode            = null;
                XmlNode         UploadUrlNode       = null;
                XmlNode         ResponseNode        = null;            
                XmlNode         DueDateNode         = null;                 
                String          EmailID             = null;
                String          FirstName           = null;
                String          LoginName           = null;
                String          LastName            = null;
                String          MiddleInitial       = null;
                String          FormattedName       = null;
                String          PercentDoneClass    = null; 
                DateTime        DueDate;
                List<ObjectInfo> ResponseObjInfoList= null;
				String			strStdFormName		= null;
				String			strFormName			= null;
				String			strSelectFormName	= null;
				String			ActivityID			= null;
				String			ActivityDefID		= null;
                String          SearchXML           = null;

                try
                {
                    Form StepForm       = new Form();
                    StepFormID          = new StringBuilder();
                    ActivityColl        = new StringBuilder();
                    ParameterList       = new StringBuilder();
                    TempDoc             = new XmlDocument();
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    FormFacadeObj.SolutionName = SolutionName;
                    
                    FormFacadeObj.ShowConfiguredFields = true;
                    ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language);

					ActivityID		= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
					ActivityDefID	= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
					strStdFormName	= "StepDetails_ROResponse";
                    strFormName     = ActivityDefID + "_ROResponse";
                    StepFormID.AppendFormat("STEP_{0}", ActivityID);

                    //HemantK : RO Component Facet Series step was not getting sorted
                    if (StepFormIDTable.ContainsKey(ActivityID) == false)
                        StepFormIDTable.Add(ActivityID, StepFormID.ToString());

                    StepForm.ID                     = StepFormID.ToString();                    
                    StepForm.TenantName             = ALParamObj.TenantName;
                    StepForm.SolutionName           = SolutionName;
                    StepForm.ShowConfiguredFields	= true;
					StepForm.IsDynamicForm			= true;
                    StepForm.InputXMLType           = Assetlink.CustomControls.Form.InputType.InnerXML;
                    StepForm.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.InnerXML;
                    StepForm.ShowConfiguredFields   = true; 
                    FormConfigXMLPath               = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName,strFormName,out strSelectFormName);
                    FormConfigXML                   = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,true);
                    
					FormFacadeObj.FormName			= strSelectFormName;
                    FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out SearchXML);
                    //HemantK: check for the deliverable component facet series
                    ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, SearchXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        StepForm.ConfigurationXML       = FormConfigXML;
                        CheckComponentFacetSeriesStatus(StepForm);
                        FormFacadeObj.ShowConfiguredFields = true; 

                        ResourceUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
                        if (ResourceUserNode != null)
                        {
                            FirstName       = ResourceUserNode.SelectSingleNode("FIRSTNAME").InnerText;
                            LastName        = ResourceUserNode.SelectSingleNode("LASTNAME").InnerText;
                            MiddleInitial   = ResourceUserNode.SelectSingleNode("MIDDLEINITIAL").InnerText;
                            LoginName       = ResourceUserNode.SelectSingleNode("LOGINNAME").InnerText;
                            FormattedName   = ALCommon.FormatUserName(FirstName, LastName, MiddleInitial, LoginName, ALCommon.GetUserNameFormat());
                            EmailID         = ResourceUserNode.SelectSingleNode("EMAILID").InnerText;
                        }
                        TempNode = ActivityNode.SelectSingleNode("STATUS");
                        if (TempNode != null)
                        {
                            if ((TempNode.InnerText.ToUpper() != "COMPLETED")&&(HiddenPreviousWorkflow.Value.ToUpper()!="TRUE"))
                            {
                                ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE");
                                if (ResponseNode != null)
                                {
                                    TempNode = ResponseNode.ParentNode;
                                    TempNode.RemoveChild(ResponseNode);
                                }
                            }
                        }
                        ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>",ActivityNode.OuterXml);
                        ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                        TempDoc.LoadXml(StepFormInputXML);
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (TempNode != null)
                        {
                            ValueNode = TempDoc.CreateElement("Value");
                            ValueNode.InnerText = FormattedName;
                            TempNode.AppendChild(ValueNode);                    
                        }
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (TempNode != null)
                        {
                            ValueNode = TempDoc.CreateElement("Value");
                            ValueNode.InnerText = EmailID;
                            TempNode.AppendChild(ValueNode);  
                        }

                        updateFormFields("EmailID", ActivityNode, ref TempDoc);
                        updateFormFields("PostedBy", ActivityNode, ref TempDoc);

                        //Hide Duration
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
                        if (TempNode != null)
                        {
                            if (TempNode.Attributes.GetNamedItem("FieldVisible") == null)
                                ((XmlElement)TempNode).SetAttribute("FieldVisible", "false");
                            else
                                TempNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                        }
                        // set the download URL
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                        if (TempNode.Attributes.GetNamedItem("DownLoadURL") != null)
                        {
                            UploadUrlNode = TempNode.Attributes.GetNamedItem("DownLoadURL");
                            UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                        }
                        else
                        {
                            UploadAttr = TempDoc.CreateAttribute("DownLoadURL");
                            UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                            TempNode.Attributes.Append(UploadAttr);
                        }
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='ACTIVITYINFORMATION_PERCENTDONE_ACTIVITY_INFORMATION']");
                        if (TempNode != null)
                        {
                            //apply percentdone class
                            DueDate = DateTime.Today;

                            DueDateNode = ActivityNode.SelectSingleNode("DUEDATE");
                            DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                            MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(ActivityNode.SelectSingleNode("STATUS").InnerText, DueDate);

                            ((XmlElement)TempNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                        }

                        if (Manual_Activities.FindControl(StepForm.ID) != null)
                        {
                            Manual_Activities.Controls.Remove(Manual_Activities.FindControl(StepForm.ID));
                        }
                        StepForm.InputXML = TempDoc.OuterXml;
                        
                        StepForm.ConfigurationMode = true;                
                        ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                        Manual_Activities.Controls.Add(StepForm);
                    }
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepForm(XmlNode ActivityNode)
            {
                StringBuilder   StepFormID              = null;
                StringBuilder   ActivityColl            = null;
                StringBuilder   TempPath                = null;
                XmlDocument     FormXMLDoc              = null;
                MWB_Helper      MWBHelperClassObj       = null;
                FormFacade      FormFacadeObj           = null;
                String          FormConfigXMLPath       = null;         
                String          ResourceID              = null;
                String          ResourceType            = null;
                String          MailID                  = null;        
                String          TempFilePath            = null;
                ERRORXML        ErrorXML                = null;
                XmlNode         FieldNode               = null;
                XmlNode         ActualResourceNode      = null;
                XmlNode         ActivityResourceNode    = null;
                XmlNode         ValueNode               = null;
                XmlNode         xmlNode_SelectedComponents= null;
                XML             FormConfigXML           = null;
                XML             StepFormInputXML        = null;
                XML             ItemListXML             = null;
                XML             SearchXML               = null;
                bool			IsPreviousWorkflowPresent = false;				
				XML				UserCollectionXML		= null;
                StringBuilder	GroupListXML			= null;
                StringBuilder	ContributorFileName		= null;
				String			ActivityID				= null;
				StringBuilder	ParamURL				= null;
				StringBuilder	SelectedValueXml		= null;
				String			SelectedValueFileName	= null;
				XML				GroupXML				= null;
				String			GroupID					= null;
				XPathDocument	UserDoc					= null;
				GroupFacade		GroupFacadeObj			= null;
				String			strStdFormName			= null;
				String			strFormName				= null;
				String			strSelectFormName		= null;
				String			strActivityDefID		= null;
                String          str_SearchXML           = null;
                long            Duration                = 0;

                try
                {
                    Form StepForm       = new Form();                
                    StepFormID          = new StringBuilder();
                    ActivityColl        = new StringBuilder();
                    TempPath            = new StringBuilder();

					GroupListXML		= new StringBuilder();
					ContributorFileName	= new StringBuilder();
					SelectedValueXml	= new StringBuilder();
                    TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    GroupFacadeObj		= new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormXMLDoc          = new XmlDocument();
					strStdFormName		= "StepDetails_Editable";
					ActivityID			= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
					strActivityDefID	= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
					StepFormID.AppendFormat("STEP_{0}", ActivityID);
                    StepForm.ID = StepFormID.ToString();
                    
                    if (HiddenPreviousWorkflow.Value.ToUpper() == "TRUE")
						IsPreviousWorkflowPresent = true;
                    if (!IsPostBack)
                    {
                        ActivityIDOrderedList.Add(ActivityID);
                    }
					if (StepFormIDTable.ContainsKey(ActivityID) == false)
						StepFormIDTable.Add(ActivityID, StepFormID.ToString());
							                    
                    FormFacadeObj.SolutionName	= SolutionName;
					FormFacadeObj.UniqueID		= StepFormIDTable[ActivityID].ToString();
                    
                    StepForm.TenantName				= ALParamObj.TenantName;
                    StepForm.SolutionName           = SolutionName;  
                    StepForm.EnableSetFocus			= false;
					StepForm.IsDynamicForm			= true;
                    StepForm.InputXMLType		    = Assetlink.CustomControls.Form.InputType.InnerXML;
                    StepForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;
                    StepForm.ShowConfiguredFields   = true;
 
                    strFormName						= strActivityDefID + "_Editable";
					FormConfigXMLPath				= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName,out strSelectFormName);
					FormConfigXML					= MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, IsPreviousWorkflowPresent);

                    xmlNode_SelectedComponents = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                    if ((xmlNode_SelectedComponents != null) && (xmlNode_SelectedComponents.HasChildNodes))
                    {
                        //Save this return XML on NTFS in temp location                            
                        TempPath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ActivityID + str_SelectedComponentsIDFileName);
                        File.WriteAllText(TempPath.ToString(), xmlNode_SelectedComponents.InnerXml);
                        TempPath.Remove(0, TempPath.Length);
                    }
                    FormFacadeObj.ShowConfiguredFields = true;
                    FormFacadeObj.FormName = strSelectFormName;
                    FormFacadeObj.GetHierarchicalSearchXML("Edit", out str_SearchXML);
                    //HemantK: check for the deliverable component facet series
                    ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, str_SearchXML);
                    if (String.IsNullOrEmpty(ErrorXML))  
                    {
                        StepForm.ConfigurationXML       = FormConfigXML;
                        CheckComponentFacetSeriesStatus(StepForm);

                        ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>",ActivityNode.OuterXml);
                        
                        ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out StepObjInfoList);
                        if (ErrorXML == null)
                        {
						    ViewState["StepObjectList" + ActivityID] = StepObjInfoList;                                
                            ItemListXML = MWBHelperClassObj.PrepareFormInputXML(ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").OuterXml, "RESOURCETYPE", "RESOURCEID");

						    ParamURL				= new StringBuilder(150);
						    SelectedValueFileName	= StepFormID.ToString() + "_ContributorGroup_SelectedValueList.xml";
						    ParamURL.Append("SelectResourceType.aspx?");
						    //ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceType.UniqueID, SelectedValueFileName, ResourceTreeFile);
                            ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&TaskID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, TaskID, Hidden_SelectResourceType.UniqueID);

                            // check if this activity has any actual resources associated with it
                            ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                            if(ActivityResourceNode!=null)
                                ActualResourceNode   = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");
                            
                            FormXMLDoc.LoadXml(StepFormInputXML);
                            FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                            if (FieldNode != null)
                            {
							    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
							    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                            }

                            if (ActualResourceNode != null)
                            {
                                ResourceType	= ActualResourceNode.SelectSingleNode("RESOURCETYPE").InnerText;
							    GroupListFile	= StepFormID.ToString() + "_GroupUsers.xml";
							    SearchXML		= GetSearchXMLForGroupAndUsers(ResourceType);
							    TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);
							    ErrorXML		= GroupFacadeObj.GetGroupList(SearchXML, ref GroupXML);
							    if(ErrorXML == null)
							    {
								    if(GroupXML != null)
								    {
									    MWBHelperClassObj.GetGroupIDAndUserXML(GroupXML, out UserCollectionXML, out GroupID);											
									    File.WriteAllText(TempPath.ToString(), UserCollectionXML);
									    TempPath.Remove(0, TempPath.Length);
									    TempPath.AppendFormat("{0}{1}", TempFilePath, SelectedValueFileName);
									    SelectedValueXml.AppendFormat("<ValueList><Value ID='{0}' Text='{1}'/></ValueList>", GroupID, ALSolutionCommon.TrimAndReplaceSpecialChars(ResourceType));
									    File.WriteAllText(TempPath.ToString(), SelectedValueXml.ToString());
									    UserDoc		= new XPathDocument(new StringReader(UserCollectionXML));
									    ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
									    if(ItemListXML != null)
									    {
										    if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
										    {
											    ResourceID	= ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
											    ItemListXML	= MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
											    MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
										    }
									    }
								    }
								    else
								    {
                                        ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
								    }
							    }
                            }
                            else
                            {
                                ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                            }
                            FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                            if (FieldNode != null)
                            {
                                    FieldNode.InnerXml = ItemListXML;
                            }
                            if (MailID != null)
                            {
                                FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FormXMLDoc.CreateElement("Value");
                                    ValueNode.InnerText = MailID;
                                    FieldNode.AppendChild(ValueNode);
                                }                                
                            }

                            updateFormFields("EmailID", ActivityNode, ref FormXMLDoc);
                            updateFormFields("PostedBy", ActivityNode, ref FormXMLDoc);

                            //Set Duration
                            FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
                            if (FieldNode != null)
                            {
                                Duration = MWBHelperClassObj.GetStepDuration(ActivityNode.CreateNavigator());
                                ValueNode = FieldNode.SelectSingleNode("Value");
                                if (ValueNode != null)
                                    ValueNode.InnerText = Duration.ToString();
                                else
                                {
                                    ValueNode = FormXMLDoc.CreateElement("Value");
                                    ValueNode.InnerText = Duration.ToString();
                                    FieldNode.AppendChild(ValueNode);
                                }
                                StepForm.AddCustomValidator("Duration", "onblur", "javascript:ValidateDuration('$CONTROLID$')", false);
                                ViewState["Duration_" + ActivityID + ""] = Duration.ToString();   
                            }
                            
                            TempPath.Remove(0,TempPath.Length);
                            TempPath.AppendFormat("{0}{1}.xml", TempFilePath, StepFormID.ToString());                    
                            File.WriteAllText(TempPath.ToString(), FormXMLDoc.OuterXml);
                        }

                        if (Manual_Activities.FindControl(StepForm.ID) != null)
                        {
                            Manual_Activities.Controls.Remove(Manual_Activities.FindControl(StepForm.ID));
                        }

                        if (IsPostBack)
                        {
                            StepForm.ResetBinders = true;
                            StepForm.ResetFileUploadControls = true;
                        }

                        StepForm.InputXML = FormXMLDoc.OuterXml;
                        if (IsPostBack)
                        {
                            StepForm.ResetFacetSeriesFields();
                        }

                        Manual_Activities.Controls.Add(StepForm);
                        StepForm.ConfigurationMode = true;                 
                    }
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void gotoDeliverableROScreen()
            {
                StringBuilder               ParamURL                = null;
                StringBuilder               URL                     = null;            
                String                      EncryptURL              = null;
                try
                {
                    ParamURL = new StringBuilder();
                    URL = new StringBuilder();

                    ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID);
                    ParamURL.Append("&ResponseBreadCrumbs=" + str_ResponseBreadCrumbs + "");
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            /// <summary>
            /// This method redirects to the View Deliverable screen
            /// </summary>
            private void gotoViewDeliverableScreen()
            {
                StringBuilder   URL              = null;            
                String          EncryptURL       = null;

                URL         = new StringBuilder(50);
                EncryptURL  = ALSolutionCommonObj.EncodeURLForResponseRedirects("Manage_DeliverableList.aspx?" + ALSolutionCommon.AppendStandardParamforURL(ALParamObj));
                URL.Append("window.open('" + EncryptURL.ToString() + "','_self','');");
                Ajax.WriteExecuteJavaScript(URL.ToString());
            }

			private void gotoProjectROScreen()
			{
				StringBuilder   ParamURL         = null;
				StringBuilder   URL              = null;            
				String          EncryptURL       = null;
				ulong           ErrorID          = 0;
				StringBuilder   ErrorPageURL_Exp = null;

				try
				{
					ParamURL = new StringBuilder();
					URL      = new StringBuilder();

					ParamURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode={5}&Access={6}&PrevScreen={7}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ProjectID, Mode, Access,PrevScreen);
                    ParamURL.Append("&ResponseBreadCrumbs=" + str_ResponseBreadCrumbs + "");
					EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
					URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
					Ajax.WriteExecuteJavaScript(URL.ToString());
				}
				catch (Exception ExceptionObj)
				{
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateDiscussionTask.aspx", "gotoDeliverableROScreen", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilegoingtoRODeliverablescreen_Shared"));
					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if (!IsPostBack)
					{
						//Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
				}
			}

            private void gotoPerformListScreen()
            {
                StringBuilder ParamURL  = null;
                StringBuilder URL       = null;  
                String        EncryptURL = null;  
                try
                {
                    ParamURL = new StringBuilder();
                    URL      = new StringBuilder();
                    ParamURL.AppendFormat("PerformList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}",ALParamObj.TenantName,ALParamObj.Language,ALParamObj.SessionID,ALParamObj.UserID);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('"+"{0}"+"','_self','');",EncryptURL);
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj; 
                }
            }

            //Hemant K - This was added because, when any step gets completed and in Manage mode if try to change the contributor form name was getting changed.
            private void SetStepForm_InPostBack()
            {
                String          TempPath                = null; 
                StringBuilder   TempFilePath            = null;
                XML             SortXML                 = null; 
                XmlDocument     InputXMLDoc             = null;
                XmlDocument     TaskDoc                 = null;
                XmlNode         ProcessActivityNode     = null; 
                XmlNodeList     Activities              = null; 
                XPathExpression   xp_SortExpression       = null;
                XPathNodeIterator xp_SortNodeIter         = null;
                try
                {
                    TempFilePath   = new StringBuilder();
                    InputXMLDoc    = new XmlDocument();
                    TaskDoc        = new XmlDocument();
                    StepFormIDTable= new Hashtable();

                    TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        TaskDoc.Load(TempFilePath.ToString());
                        ProcessActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");

                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PREVIOUS_WORKFLOW/WORKFLOWPROCESS") != null)
                            HiddenPreviousWorkflow.Value = "TRUE";
                        else
                            HiddenPreviousWorkflow.Value = "FALSE";

                        xp_SortExpression   = XPathExpression.Compile("ACTIVITY[(translate(STARTACTIVITY,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='FALSE') and (translate(ENDACTIVITY, 'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='FALSE')]");
                        xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                        xp_SortNodeIter     = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                        while (xp_SortNodeIter.MoveNext())
                        {
                             SortXML     += xp_SortNodeIter.Current.OuterXml;
                        }
                        ProcessActivityNode.InnerXml    = SortXML;
                        Activities = ProcessActivityNode.SelectNodes("ACTIVITY");
                        if (Activities.Count > 0)
                        {
                            foreach (XmlNode Activity in Activities)
                            {
                               if (Access.ToUpper() == "READ")
                                {
                                    setROResponseForm(Activity);
                                }
                                else
                                {
                                    if (Activity.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE")
                                        createNewStepForm(Activity);
                                    else
                                        setROResponseForm(Activity);
                                }
                            }
                        }
                    }
                }
                catch (Exception ExcepitonObj)
                {
                    throw(ExcepitonObj);
                }
            }

            private void createNewStepForm(XmlNode ActivityNode)
            {
                StringBuilder TempFilePath              = null;
                StringBuilder ActivityColl              = null;
                XmlDocument   InputXMLDoc               = null;
                XmlDocument   FormXMLDoc                = null;
                XmlNode       ActivityResourceNode      = null;
                XmlNode       ActualResourceNode        = null;
                XmlNode       FieldNode                 = null;
                FormFacade    FormFacadeObj             = null;
                MWB_Helper    MWBHelperClassObj         = null;
                ERRORXML      ErrorXML                  = null;
                String        TempPath                  = null;
                String        FormConfigXMLPath         = null;
                String        FormConfigXML             = null;
                String        ResourceID                = null;
                String        MailID                    = null;
                XML           StepFormInputXML          = null;
                XML           ItemListXML               = null;
                XML           TempFormInputXML          = null;
                Form          StepForm                  = null;                
				String		  ActivityID				= null;
				String			SelectedValueFileName	= null;
				String			SelectedValueFile		= null;
				XML				SelectedValueXML		= null;
				StringBuilder	ParamURL				= null;
				XPathDocument	UserDoc					= null;
				String			strStdFormName			= null;
				String			strFormName				= null;
				String			strSelectFormName		= null;
				String			strActivityDefID		= null;
                String          str_SearchXML           = null;
                Boolean         IsPreviousWorkflowPresent  = false;

				try
                {
                    TempFilePath        = new StringBuilder();
                    InputXMLDoc         = new XmlDocument();
                    ActivityColl        = new StringBuilder();
                    FormXMLDoc          = new XmlDocument();
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    StepFormIDTable     = (Hashtable)ViewState["StepFormIDList"];
                    TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					strStdFormName		= "StepDetails_Editable";
					
                    FormFacadeObj.SolutionName  = SolutionName;

                    if (HiddenPreviousWorkflow.Value.ToUpper() == "TRUE")
                        IsPreviousWorkflowPresent = true;
                    if (ActivityNode != null)
                    {
						ActivityID				= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
						FormFacadeObj.UniqueID	= StepFormIDTable[ActivityID].ToString();
						StepForm = new Form();
                        ActualResourceNode = null;
                        
                        if (StepFormIDTable.ContainsKey(ActivityID))
                        {
                            strActivityDefID				= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
							strFormName						= strActivityDefID + "_Editable";
							StepForm.ID						= StepFormIDTable[ActivityID].ToString();
                            StepForm.TenantName				= ALParamObj.TenantName;
                            StepForm.SolutionName           = SolutionName;  
                            StepForm.EnableSetFocus			= false;
							StepForm.IsDynamicForm			= true;
                            StepForm.InputXMLType			= Assetlink.CustomControls.Form.InputType.InnerXML;
                            StepForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;
                            StepForm.ShowConfiguredFields   = true; 
                            FormConfigXMLPath               = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName,strFormName,out strSelectFormName);

                            FormConfigXML = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, IsPreviousWorkflowPresent);
                            FormFacadeObj.ShowConfiguredFields = true;
                            FormFacadeObj.FormName             = strSelectFormName;
                            FormFacadeObj.GetHierarchicalSearchXML("Edit", out str_SearchXML);
                            //HemantK: check for the deliverable component facet series
                            ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, str_SearchXML);
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                StepForm.ConfigurationXML       = FormConfigXML;
                                CheckComponentFacetSeriesStatus(StepForm);
                                
                                ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);
							    
							    // keep the Selected value XML in a String, since the form facade will over-write it
							    // after the form facade over writes it re-write it back to maintain the changes
							    SelectedValueFileName	= StepFormIDTable[ActivityID].ToString() + "_ContributorGroup_SelectedValueList.xml";
							    SelectedValueFile		= TempPath + SelectedValueFileName;
							    SelectedValueXML		= File.ReadAllText(SelectedValueFile);

							    //ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out StepObjInfoList);

							    TempFilePath.Remove(0, TempFilePath.Length);
							    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepForm.ID);
							    if(File.Exists(TempFilePath.ToString()))
							    {
								    StepFormInputXML = File.ReadAllText(TempFilePath.ToString());
							    }

                                if (ErrorXML == null)
                                {
								    File.WriteAllText(SelectedValueFile, SelectedValueXML);
								    ParamURL = new StringBuilder(150);
								    ParamURL.Append("SelectResourceType.aspx?");
								    //ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceType.UniqueID, SelectedValueFileName, ResourceTreeFile);
                                    ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&TaskID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, TaskID, Hidden_SelectResourceType.UniqueID);

                                    ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                                    if (ActivityResourceNode != null)
                                        ActualResourceNode = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");

                                    FormXMLDoc.LoadXml(StepFormInputXML);
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                    if (FieldNode != null)
                                    {
									    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
									    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                                    }
								    GroupListFile = StepFormIDTable[ActivityID].ToString() + "_GroupUsers.xml";
								    TempFilePath.Remove(0, TempFilePath.Length);
								    TempFilePath.AppendFormat("{0}{1}", TempPath, GroupListFile);
                                    if (ActualResourceNode != null)
                                    {
                                        if(File.Exists(TempFilePath.ToString()))
									    {
										    UserDoc		= new XPathDocument(new StringReader(File.ReadAllText(TempFilePath.ToString())));
										    ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
										    if(ItemListXML != null)
										    {
											    if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
											    {
												    ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
												    ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
												    MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);													
											    }
										    }
									    }
                                    }
                                    else
                                    {
                                        ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                                    }
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                    if (FieldNode != null)
                                        FieldNode.InnerXml = ItemListXML;


                                    updateFormFields("EmailID", ActivityNode, ref FormXMLDoc);
                                    updateFormFields("PostedBy", ActivityNode, ref FormXMLDoc);


                                    if (Manual_Activities.FindControl(StepForm.ID) != null)
                                    {
                                        Manual_Activities.Controls.Remove(Manual_Activities.FindControl(StepForm.ID));
                                    }

                                    if (IsPostBack)
                                        StepForm.ResetFacetSeriesFields(); 

                                    TempFilePath.Remove(0, TempFilePath.Length);
                                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepForm.ID);
                                    if (File.Exists(TempFilePath.ToString()))
                                    {
                                        TempFormInputXML = File.ReadAllText(TempFilePath.ToString());
                                        if (TempFormInputXML != null)
                                        {
                                            StepForm.InputXML = TempFormInputXML;
                                            File.WriteAllText(TempFilePath.ToString(), TempFormInputXML);
                                        }
                                        else
                                        {
                                            StepForm.InputXML = FormXMLDoc.OuterXml;
                                            File.WriteAllText(TempFilePath.ToString(), FormXMLDoc.OuterXml);
                                        }
                                    }
                                    else
                                    {
                                        StepForm.InputXML = FormXMLDoc.OuterXml;
                                        File.WriteAllText(TempFilePath.ToString(), FormXMLDoc.OuterXml);
                                    }
                                    Manual_Activities.Controls.Add(StepForm);
                                    ActivityColl.Remove(0, ActivityColl.Length);
                                    StepForm.ConfigurationMode = true;
                                }
                            }
                        }
					}// end outer if
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepFormEventHandler()
            {                
                Form StepForm   = null;
                try
                {                
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                    while (StepFormIDEnum.MoveNext())
                    {
                        StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                        StepForm.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);                
                        StepForm.SeriesActionBarClick += new EventHandler(StepForm_SeriesActionBarClick);
                        StepForm.AddCustomValidator("Duration", "onblur", "javascript:ValidateDuration('$CONTROLID$')", false);
                    }
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setParameters()
            {
                try
                {
                    strSeparator    = new String[1] { "$AL$" };
                    TaskID          = ALSolutionCommonObj.GetParamValue("TaskID");
                    DeliverableID   = ALSolutionCommonObj.GetParamValue("DeliverableID");
                    ProjectID       = ALSolutionCommonObj.GetParamValue("ProjectID");
                    Mode            = ALSolutionCommonObj.GetParamValue("Mode");            
                    Access			= ALSolutionCommonObj.GetParamValue("Access"); 
                    PrevScreen		= ALSolutionCommonObj.GetParamValue("PrevScreen");
                    BreadCrumbCtrlID = ALSolutionCommonObj.GetParamValue("BREADCRUMBCTRLID");
                    ParentBreadcrumbName = ALSolutionCommonObj.GetParamValue("PARENTBREADCRUMBNAME");
					SelectedTab = ALSolutionCommonObj.GetParamValue("SelectedTab");
					TaskReader	= ALSolutionCommonObj.GetParamValue("TaskReader");
                    str_StepAccess = ALSolutionCommonObj.GetParamValue("StepAccess");
                    str_ResponseBreadCrumbs = ALSolutionCommonObj.GetParamValue("ResponseBreadCrumbs");
                    if (String.IsNullOrEmpty(str_ResponseBreadCrumbs))
                    {
                        str_ResponseBreadCrumbs = "0";
                    }
					if(SelectedTab == null)
					{
						SelectedTab = "INFO";
					}
                    PackageDefinitionID = ALSolutionCommonObj.GetParamValue("PackageDefinitionID");
                    if (!String.IsNullOrEmpty(PackageDefinitionID))
                    {
                        __PackageDefinitionID.Value = PackageDefinitionID;
                    }
                    ProcessDefinitionID = ALSolutionCommonObj.GetParamValue("ProcessDefinitionID");
                    if (!String.IsNullOrEmpty(ProcessDefinitionID))
                    {
                        __ProcessDefinitionID.Value = ProcessDefinitionID;
                    }
                    if (!String.IsNullOrEmpty(DeliverableID))
                    {
                        ViewState["ParentDeliverableID"] = DeliverableID;
                    }
                    if (!String.IsNullOrEmpty(TaskID))
                    {
                        TaskFile                = TaskID + "_MWB_GatherInfoTask.xml";
                        GroupListFile           = TaskID + "_MWB_GroupListROGatherInfoTask.xml";
                        DisplayPredecessorFile  = TaskID + "_GatherInfoPredecessor.xml";
                        StepResourceFileName    = TaskID + "_ActivityResourceColl.xml";
                        ResourceTreeFile        = TaskID + "_ResourceGroupTree.xml";
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            } 

            private void setBreadcrumbs()
            {
                MktgWorkBenchFacadeClass    MWBFacadeObj            = null;
                String                      OutputXML               = null;
                String                      DeliverableName         = null; 
                String                      ProjectName             = null; 
                String                      EncryptURL              = null; 
                String                      EncryptURLForProject    = null; 
                StringBuilder               ParamURL                = null; 
                StringBuilder               SB_BreadCrumbXML        = null;
                XML                         BreadCrumbXML           = null; 
                XmlDocument                 OutputXmlDoc            = null;
                XmlDocument                 BreadCrumbXmlDoc        = null;
                XmlNode                     ProjectBreadCrumbNode   = null;
                XmlNode                     DelivBreadCrumbNode     = null; 
                XmlNode                     TaskBreadCrumbNode      = null; 
                XmlNode                     DeliverableTaskNode     = null;
                XmlNode                     CancelDeliverableNode   = null; 
                XmlNode                     ProjectNode             = null; 
                ERRORXML                    ErrorXML                = null;
                String                      ErrorPageURL            = null;
                StringBuilder               str_PrjUrl             = null;
                StringBuilder               str_DelUrl             = null;
                String                      EncryptUrl_Prj         = null;
                String                      EncryptUrl_Del         = null;
                                
                try
                {
                    OutputXmlDoc        = new XmlDocument();
                    BreadCrumbXmlDoc    = new XmlDocument();
                    ParamURL            = new StringBuilder();
                    SB_BreadCrumbXML    = new StringBuilder();
                    MWBFacadeObj        = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if ((Mode.ToUpper() == "MANAGE") && (!String.IsNullOrEmpty(ProjectID)) && (!String.IsNullOrEmpty(DeliverableID)))  
                    {
                        if (!String.IsNullOrEmpty(BreadCrumbCtrlID))  
                            RO_GatherInfoBreadCrumb.BreadcrumbUniqueID = BreadCrumbCtrlID;

                        RO_GatherInfoBreadCrumb.ParentBreadcrumbName = ParentBreadcrumbName;
                        RO_GatherInfoBreadCrumb.NavigateUrl = this.Request.Url.AbsoluteUri;
                        RO_GatherInfoBreadCrumb.InputXml = null;
                        RO_GatherInfoBreadCrumb.Name = "Task";

                        if (ParentBreadcrumbName.ToUpper() == "PROJECT")
                        {
                            ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, false, out OutputXML);
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                //Load the OutputXML and get the deliverable name
                                BreadCrumbXML = RO_GatherInfoBreadCrumb.InputXmlNode.OuterXml;
                                OutputXmlDoc.LoadXml(OutputXML);
                                DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK");
                                if (DeliverableTaskNode != null)
                                {
                                    //HemantK: for Component facet
                                    if (String.IsNullOrEmpty(DeliverableID))
                                    {
                                        DeliverableID = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                                        ViewState["ParentDeliverableID"] = DeliverableID;
                                    }
                                    DeliverableName = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                                    BreadCrumbXmlDoc.LoadXml(BreadCrumbXML);
                                    ProjectBreadCrumbNode = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb[@Name='Project']");
                                    TaskBreadCrumbNode = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb/BreadCrumb[@Name='Task']");
                                    if (TaskBreadCrumbNode != null)
                                        ProjectBreadCrumbNode.RemoveChild(TaskBreadCrumbNode);

                                    DelivBreadCrumbNode = BreadCrumbXmlDoc.CreateElement("BreadCrumb");
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("Name", "Deliverable");
                                    //Prepare URL for the Deliverable
                                    ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID);
                                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("NavigationUrl", EncryptURL);
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("DisplayText", DeliverableName);
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("Selected", "False");
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("Image", "");
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("RaiseEvent", "False");
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("BreadcrumbTextMode", "Text");
                                    ((XmlElement)DelivBreadCrumbNode).SetAttribute("Tooltip", "");

                                    if (ProjectBreadCrumbNode != null)
                                        ProjectBreadCrumbNode.AppendChild(DelivBreadCrumbNode);

                                    RO_GatherInfoBreadCrumb.ParentBreadcrumbName    = "Deliverable";
                                    RO_GatherInfoBreadCrumb.NavigateUrl             = this.Request.Url.AbsoluteUri;
                                    RO_GatherInfoBreadCrumb.InputXml                = BreadCrumbXmlDoc.InnerXml;
                                    RO_GatherInfoBreadCrumb.Name                    = "Task";
                                    //RO_GatherInfoBreadCrumb.DisplayText             = ViewState["TaskTitle"].ToString();
                                }
                            }
                            else
                            {
                                //Error getting parent Deliverable
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML,
                                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_GetParentsTask_Shared"),
                                    null, GetBackURL(), ref ErrorPageURL);
                                if (!IsPostBack)
                                {
                                    Response.Redirect(ErrorPageURL, true);
                                }
                                else
                                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                        else if (ParentBreadcrumbName.ToUpper() == "DELIVERABLE")
                        {
                            //It has come from the Deliverable screen or from the cancel delvierable screen
                            BreadCrumbXML = RO_GatherInfoBreadCrumb.InputXmlNode.OuterXml;
                            BreadCrumbXmlDoc.LoadXml(BreadCrumbXML);
                            CancelDeliverableNode = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb/BreadCrumb/BreadCrumb[@Name='CancelDeliverable']");
                            DelivBreadCrumbNode = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb/BreadCrumb[@Name='Deliverable']");
                            if (CancelDeliverableNode != null)
                            {
                                DelivBreadCrumbNode.RemoveChild(CancelDeliverableNode);

                                //Prepare URL for the Deliverable
                                ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID);
                                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("NavigationUrl", EncryptURL);
                            }
                            RO_GatherInfoBreadCrumb.ParentBreadcrumbName    = "Deliverable";
                            RO_GatherInfoBreadCrumb.NavigateUrl             = this.Request.Url.AbsoluteUri;
                            RO_GatherInfoBreadCrumb.InputXml                = BreadCrumbXmlDoc.InnerXml;
                            RO_GatherInfoBreadCrumb.Name                    = "Task";
                            //RO_GatherInfoBreadCrumb.DisplayText             = ViewState["TaskTitle"].ToString();
                        }
                        else if (String.IsNullOrEmpty(ParentBreadcrumbName))
                        {
                            //It has come from Email, So prepare BreadCrumbXML with URL
                            ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, true, out OutputXML);
                            if (String.IsNullOrEmpty(ErrorXML)) 
                            {
                                //Load the OutputXML and get the Project & Deliverable name
                                OutputXmlDoc.LoadXml(OutputXML);
                                
                                DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK");
                                if (DeliverableTaskNode != null)
                                {
                                    //HemantK: for Component facet
                                    if (String.IsNullOrEmpty(DeliverableID))
                                    {
                                        DeliverableID = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                                        ViewState["ParentDeliverableID"] = DeliverableID;
                                    }
                                    DeliverableName = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                                    ProjectNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE");
                                    if (ProjectNode != null)
                                        ProjectName = ProjectNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                                }

                                if ((!String.IsNullOrEmpty(ProjectName)) && (!String.IsNullOrEmpty(DeliverableName)))
                                {
                                    //Prepare URL for Project and Deliverable
                                    ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID);
                                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                                    ParamURL.Remove(0, ParamURL.Length);
                                    ParamURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode={5}&Access={6}&PrevScreen={7}&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ProjectID, Mode, Access, PrevScreen, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID);
                                    EncryptURLForProject = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                                    //Prepare input XML for breadcrumb
                                    SB_BreadCrumbXML.AppendFormat(@"<BreadCrumbs>
                                                                        <BreadCrumb Name='Project' NavigationUrl='{0}' DisplayText='{1}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                            <BreadCrumb Name='Deliverable' NavigationUrl='{2}' DisplayText='{3}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                            </BreadCrumb>
                                                                        </BreadCrumb>
                                                                    </BreadCrumbs>", EncryptURLForProject, ALSolutionCommon.TrimAndReplaceSpecialChars(ProjectName), EncryptURL, ALSolutionCommon.TrimAndReplaceSpecialChars(DeliverableName));
                                }
                                RO_GatherInfoBreadCrumb.ParentBreadcrumbName    = "Deliverable";
                                RO_GatherInfoBreadCrumb.NavigateUrl             = this.Request.Url.AbsoluteUri;
                                RO_GatherInfoBreadCrumb.InputXml                = SB_BreadCrumbXML.ToString();
                                RO_GatherInfoBreadCrumb.Name                    = "Task";
                                //RO_GatherInfoBreadCrumb.DisplayText             = ViewState["TaskTitle"].ToString();

                                //set the BreadCrumb id and Parent Bread crumb name in the hidden variables.
                                if (String.IsNullOrEmpty(__ParentBreadCrumbName.Value))
                                {
                                    __ParentBreadCrumbName.Value = "Deliverable";
                                }
                                if (String.IsNullOrEmpty(__BreadCrumbCtrlID.Value))
                                {
                                    __BreadCrumbCtrlID.Value = RO_GatherInfoBreadCrumb.BreadcrumbUniqueID;
                                }
                            }
                            else
                            {
                                //Error getting parent Deliverable
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML,
                                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_GetParentsTask_Shared"),
                                    null, GetBackURL(), ref ErrorPageURL);
                                if (!IsPostBack)
                                {
                                    Response.Redirect(ErrorPageURL, true);
                                }
                                else
                                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                    }
                    else
                    {
                        str_PrjUrl = new StringBuilder(10);
                        str_DelUrl = new StringBuilder(10);
                        //Mode is Perform
                        ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, true, out OutputXML);
                        if (String.IsNullOrEmpty(ErrorXML)) 
                        {
                            //Load the OutputXML and get the Project & Deliverable name
                            OutputXmlDoc.LoadXml(OutputXML);

                            DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK");
                            if (DeliverableTaskNode != null)
                            {
                                //HemantK: for Component facet
                                if (String.IsNullOrEmpty(DeliverableID))
                                {
                                    DeliverableID = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                                    ViewState["ParentDeliverableID"] = DeliverableID;
                                }
                                DeliverableName = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                                ProjectNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE");
                                if (ProjectNode != null)
                                    ProjectName = ProjectNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                            }

                            // if Flag Response BreadCrumbs is true then set the Project and Deliverable URL's
                            if (String.Compare(str_ResponseBreadCrumbs, "1", true) == 0)
                            {
                                str_PrjUrl.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode=PERFORM&Access=READ&PrevScreen=PERFORMLIST&BREADCRUMBCTRLID={5}&ResponseBreadCrumbs={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ProjectID, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID, str_ResponseBreadCrumbs);
                                EncryptUrl_Prj = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_PrjUrl.ToString());
                                str_DelUrl.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode=PERFORM&Access=READ&PARENTBREADCRUMBNAME=Project&PrevScreen=PERFORMLIST&BREADCRUMBCTRLID={6}&ResponseBreadCrumbs={7}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, RO_GatherInfoBreadCrumb.BreadcrumbUniqueID, str_ResponseBreadCrumbs);
                                EncryptUrl_Del = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_DelUrl.ToString());
                            }


                            if ((!String.IsNullOrEmpty(ProjectName)) && (!String.IsNullOrEmpty(DeliverableName)))
                            {
                                //Prepare input XML for breadcrumb
                                SB_BreadCrumbXML.AppendFormat(@"<BreadCrumbs>
                                                                    <BreadCrumb Name='Project' NavigationUrl='{0}' DisplayText='{1}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                        <BreadCrumb Name='Deliverable' NavigationUrl='{2}' DisplayText='{3}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                        </BreadCrumb>
                                                                    </BreadCrumb>
                                                                </BreadCrumbs>", EncryptUrl_Prj, ALSolutionCommon.TrimAndReplaceSpecialChars(ProjectName), EncryptUrl_Del, ALSolutionCommon.TrimAndReplaceSpecialChars(DeliverableName));
                            }
                            RO_GatherInfoBreadCrumb.ParentBreadcrumbName= "Deliverable";
                            RO_GatherInfoBreadCrumb.NavigateUrl         = this.Request.Url.AbsoluteUri;
                            RO_GatherInfoBreadCrumb.InputXml            = SB_BreadCrumbXML.ToString();
                            RO_GatherInfoBreadCrumb.Name                = "Task";
                            //RO_GatherInfoBreadCrumb.DisplayText         = ViewState["TaskTitle"].ToString();
                        }
                        else
                        {
                            //Error getting parent Deliverable
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML,
                                Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_GetParentsTask_Shared"),
                                null, GetBackURL(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            private void setControls()
            {                
                StringBuilder ActionBarXMLPath      = null;                            
                String        CultureInformation    = null;
                String        FormatXMLPath         = null;
                TabFacade	 tabFacadeObj			= null;

                try
                {
                    ActionBarXMLPath                = new StringBuilder();                    
                    Page_CreatePage.TenantName      = ALParamObj.TenantName;
                    Page_CreatePage.SectionHeading  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_ViewTask_Shared");
                    tabFacadeObj		            = new TabFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);

                    FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);

                    // set the tenant name of task panes
                    Left_1_tp_MarketingWorkBench.TenantName = ALParamObj.TenantName;
                    Left_2_tp_Manage_GatherInfoTask.TenantName = ALParamObj.TenantName;   
                    
                    Left_1_tp_MarketingWorkBench.TaskPaneName   = SolutionName;
                    Left_1_tp_MarketingWorkBench.SelectedSectionName = "Manage";

					if(Mode.ToUpper() == "MANAGE")
					{
						Left_1_tp_MarketingWorkBench.SelectedSectionName = "Manage";
						Left_2_tp_Manage_GatherInfoTask.TaskPaneName = "Manage";
					}
					else if(Mode.ToUpper() == "PERFORM")
					{
						Left_1_tp_MarketingWorkBench.SelectedSectionName = "Perform";
						Left_2_tp_Manage_GatherInfoTask.TaskPaneName = "Perform";
					}

                    RO_GatherInfoBreadCrumb = (ALBreadCrumb)this.Page_CreatePage.FindControl("ROGatherInfoTaskBreadcrumb");
                    RO_GatherInfoBreadCrumb.TenantName = ALParamObj.TenantName;
                    RO_GatherInfoBreadCrumb.BreadcrumbTextMode = ALBreadCrumb.BreadcrumbText.Text;  
                    
                    ROGatherInfoTaskTab = (ALTab)Page_CreatePage.FindControl("tabTask");
					ROGatherInfoTaskTab.TenantName = ALParamObj.TenantName;

                    tabFacadeObj.TabName        = "tabROTask";
					tabFacadeObj.ScreenName     = "ROTASK";
					tabFacadeObj.SolutionName   = SolutionName;
					tabFacadeObj.InitializeTab(ref ROGatherInfoTaskTab);
					
					Panel_TaskDetails	        = (ALPanel)ROGatherInfoTaskTab.FindControl("panelTaskDetails");
					Panel_Dependencies	        = (ALPanel)ROGatherInfoTaskTab.FindControl("panelDependencies");
					Panel_UserRoles		        = (ALPanel)ROGatherInfoTaskTab.FindControl("panelUserRoles");
                    Literal_TaskInitiator       = (Literal)Panel_UserRoles.FindControl("Literal_TaskInitiator");
                    Literal_TaskInitiator.Text  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_TaskInitiator:_Label_Shared");

					Frm_TaskDetails = (Form)Panel_TaskDetails.FindControl("Content_1_Frm_TaskDetails");
                    Frm_TaskDetails.TenantName = ALParamObj.TenantName;
                    Frm_TaskDetails.SolutionName = SolutionName;   
                    Frm_TaskDetails.CultureInformation = CultureInformation;
                    Frm_TaskDetails.PersonalizationFilePath = FormatXMLPath;
                    Frm_TaskDetails.SeriesActionBarClick +=new EventHandler(Frm_TaskDetails_SeriesActionBarClick);

					Lst_PredecessorList                 = (Assetlink.CustomControls.ListControl)Panel_Dependencies.FindControl("Content_2_lc_PredecessorList");
                    Lst_PredecessorList.TenantName      = ALParamObj.TenantName;
                    Lst_PredecessorList.SectionHeading  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_DependantOn_Shared");

					//Lst_PredecessorList.EventOnExpand   = true;
                    Lst_PredecessorList.PersonalizationFilePath	= FormatXMLPath;
                    //Lst_PredecessorList.CollapsedClick += new EventHandler(Lst_PredecessorList_CollapsedClick);
                    if (Mode.ToUpper() == "PERFORM")
						Panel_Dependencies.Visible = false;
					else
						Panel_Dependencies.Visible = true;					
					Ab_ROGatherInfoTask = (ActionBar)Panel_TaskDetails.FindControl("Content_6_ab_Task_ActionBar");
                    Ab_ROGatherInfoTask.TenantName = ALParamObj.TenantName;
                    
                    //ActionBarXMLPath.AppendFormat("{0}{1}\\MarketingWorkBench\\Configuration\\XML\\MarketingWorkBench_Manage_ROGatherInfoTask_Content_6_ab_Task_ActionBar_ActionBar.xml", InstalledPath, ALParamObj.TenantName);
                    //Ab_ROGatherInfoTask.InputXML = ActionBarXMLPath.ToString();
                    //Ab_ROGatherInfoTask.AddAttributes("btn_ReRoute","href","javascript:ValidateReRoute('$CONTROLID$','"+__TaskStatus.Value+"'');");
                    //Readers List
                    LC_TaskReaders = (CustomControls.ListControl)Panel_UserRoles.FindControl("List_TaskReaders");
                    LC_TaskReaders.TenantName = ALParamObj.TenantName;
                    LC_TaskReaders.EnableIterators = true;

                    //Initiator
					ALPanel_InitiatorSelection = (ALPanel)Panel_UserRoles.FindControl("ID_InitiatorSelection");
                    UC_InitiatorSelection      = (ALUC_ALUserSelection)ALPanel_InitiatorSelection.FindControl("ALUC_InitiatorSelection");

                    Binder_Attachments         = (Binder)Panel_TaskDetails.FindControl("Binder_Documents");
                    Manual_Activities          = (ALPanel)Panel_TaskDetails.FindControl("Panel_Steps");

                    ALPanel_HiddenFields    = (ALPanel)Page_CreatePage.FindControl("Panel_ID_HiddenFields");
                    __NewContributorIDs_HF  = (HiddenField)ALPanel_HiddenFields.FindControl("__NewContributorIDs");
                    __OldContributorIDs_HF  = (HiddenField)ALPanel_HiddenFields.FindControl("__OldContributorIDs");
                    Hidden_PredecessorFound = (HiddenField)ALPanel_HiddenFields.FindControl("__PredecessorsFound");
                    HiddenPreviousWorkflow  = (HiddenField)ALPanel_HiddenFields.FindControl("__PreviousWorkflow");

                    //Display Project Info : Anita Kale
                    Sbs_ProjectDetails                  = (SquareBlankSection)Panel_TaskDetails.FindControl("Content_1_sbs_Project_Details");
                    Sbs_ProjectDetails.TenantName       = ALParamObj.TenantName;
                    Sbs_ProjectDetails.SectionHeading   = Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_MWB_Project_Shared");
                    Panel_ProjectDetails                = (ALPanel)Sbs_ProjectDetails.FindControl("ALPanelProjectDetails");

                    if (!IsPostBack)
                        Sbs_ProjectDetails.IsMinimize   = true;

                    Frm_ROProjectDetails                            = (Form)Panel_ProjectDetails.FindControl("Content_2_Frm_Project_Details");
                    Frm_ROProjectDetails.TenantName                 = ALParamObj.TenantName;
                    Frm_ROProjectDetails.CultureInformation         = CultureInformation;
                    Frm_ROProjectDetails.PersonalizationFilePath    = FormatXMLPath;
                    Frm_ROProjectDetails.SolutionName               = SolutionName;
                    
                    //User Group List (Notification on process completion)
                    Lst_UserGroup               = (CustomControls.ListControl)Panel_UserRoles.FindControl("ListControl_ProcessComplete_UserGroup");
                    Lst_UserGroup.TenantName    = ALParamObj.TenantName;
                    Lst_UserGroup.EnableIterators = true;

                    //Textbox
                    textBoxObj = (TextBox)Panel_TaskDetails.FindControl("tb_NoOfDays");

                    //Checkbox
                    checkBoxObj = (CheckBox)Panel_TaskDetails.FindControl("cb_AdvanceNotification");                
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            private void setLeftPane()
            {
                LeftPaneFacade LeftPaneObj = null;
                try
                {
                    LeftPaneObj = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName);
                    LeftPaneObj.SolutionName = SolutionName;
                    LeftPaneObj.GetTaskPaneNode(this.Page, null);
                }
                catch (Exception ExceptionObject)
                {

                    throw ExceptionObject;
                }
            }

            private void GetDependencies()
            {				
			    XML							ReturnTaskXML	= null;
			    ERRORXML					ErrorXML		= null;
			    MktgWorkBenchFacadeClass	MWBFacadeObj	= null;
			    StringBuilder				TempPath		= null;                
			    String						TempFilePath    = null;
                String                      str_AttributesXML= null;
                String                      str_AssociationXML= null; 
                MWB_Helper                  MWB_HelperObj   = null;

                try
			    {
				    Lst_PredecessorList.IsMinimize	= false;
                    Lst_PredecessorList.EnableIterators = true;  
				    TempPath						= new StringBuilder();
				    TempFilePath					= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

				    if(String.IsNullOrEmpty(Hidden_PredecessorFound.Value))
				    {
					    MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                        MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                        MWB_HelperObj.getAssociationXMLForPredecessors_RO(out str_AttributesXML, out str_AssociationXML);
                        ErrorXML = MWBFacadeObj.GetTask(TaskID, str_AttributesXML, str_AssociationXML, out ReturnTaskXML);
                        if (ErrorXML == null)
                        {
                            Hidden_PredecessorFound.Value = "TRUE";
                            TempPath.AppendFormat("{0}{1}", TempFilePath, DisplayPredecessorFile);
                            File.WriteAllText(TempPath.ToString(), ReturnTaskXML);
                        }
				    }
				    else
				    {
					    TempPath.AppendFormat("{0}{1}", TempFilePath, DisplayPredecessorFile);
					    ReturnTaskXML = File.ReadAllText(TempPath.ToString());
				    }

				    if (ReturnTaskXML!=null)
					    PaintPredecessorList(ReturnTaskXML);
			    }
			    catch(Exception ExceptionObj)
			    {
				    throw ExceptionObj;
			    }
            }

            private void gotoProjectListScreen()
            {
                StringBuilder   ParamURL			= null;
                StringBuilder   URL					= null;
                String          EncryptURL			= null;
		        ulong			ErrorID				= 0;
                StringBuilder	ErrorPageURL_Exp	= null;

                try
                {
                    ParamURL    = new StringBuilder();
                    URL         = new StringBuilder();
                    ParamURL.AppendFormat("Manage_ProjectList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ROGatherInfoTask.aspx", "gotoProjectListScreen", ExceptionObject, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_ProjectDetails_Info_ExceptionwhilegoingtoProjectListScreen_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }
            
            private ERRORXML StampNotificationForGatherInfoTask(String TaskID, String Event, String OldUsersXML, String str_DurationChangedStepIDs)
            {
                String              ReturnTaskXML           = null;
                String              ContributorID           = null;
                String              TaskScreenURL           = null;
                String              NotificationXML         = null;
                String              ActivityID              = null;
                String              TempPath                = null; 
                String              ContributorIds          = null;
                String[]            ContributorIDList       = null;
                int                 TotalNumberOfContributor= 0;
                XML                 ErrorXML                = null;
                StringBuilder       TempFilePath            = null; 
                StringBuilder       AssociationXML          = null;
                StringBuilder       Message                 = null;
                StringBuilder       Subject                 = null;
                StringReader        retTaskXML              = null;
                StringReader        SR_ProcessActivity      = null; 
                XmlDocument         xp_retTaskXMLDoc        = null;    
                XmlDocument         xp_TaskProcessDoc       = null; 
                XPathDocument       xp_OldUserXMLDoc        = null; 
                XPathDocument       xp_ProcessTransitionDoc = null; 
                XPathNavigator      Root_OldUserXMLDoc      = null;
                XPathNavigator      Root_TaskProcessDoc     = null; 
                XPathNavigator      Root_ProcessTransition  = null; 
                XPathNavigator      TaskNavigator           = null;
                XPathNavigator      ActivityNav             = null;
                XPathNavigator      ContributorNav          = null;                
                XPathNavigator      TempNavigator           = null;                 
                XPathNodeIterator   Process_Activities      = null; 
                XPathNodeIterator   FileSystemIterator      = null;
                NotificationHelper  NotificationHelperObj   = null;
                EmailChannel        EmailChannelObj         = null;                

                MktgWorkBenchFacadeClass MWBFacadeObj       = null;
                MWB_Helper               MWB_HelperObj      = null; 
                NotificationFacadeClass NotificationFacadeObj = null;
                XmlNode                 ProjectManager        = null;
                XPathNavigator          DeliverableTaskNavigator = null;
                String                  str_ProcessAssoFacets = null;
                String                  str_NewContributorName= null;
                XPathNavigator          nav_Activity          = null;
                String                  str_ActivityID        = null;
                String                  NotificationTypeID    = null;
                SearchConfiguration     SearchConfigObj       = null;
                try
                {
                    MWBFacadeObj    = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    SearchConfigObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    if (Event.ToUpper() == "CONTRIBUTORCHANGED")
                    {
                        //Get the Task.
                        AssociationXML = new StringBuilder(50);
                        NotificationTypeID = "5003";
                        MWB_HelperObj.GetAssociatedFacetListForNotifications(NotificationTypeID, ProcessDefinitionID, SolutionName, out str_ProcessAssoFacets);
                        //str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                        //if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                        //{
                        //    AssociationXML.Append("<ASSOCIATION>" + str_ProcessAssoFacets + "");
                        //}
                        //else
                        //{
                        //    AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                        //}
                            AssociationXML.Append(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
                                                        <SEARCHALLFACETS>FALSE</SEARCHALLFACETS>
                                                        <TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
	                                                        </FILTERLIST>
                                                            <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                                                <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>ACTIVITYID</FIELDNAME>
                                                                        <ALIAS>ACTIVITYID</ALIAS>
			                                                        </EXPRESSION>
			                                                    </SELECTLIST>
                                                                <RELATIONSHIP NAME='ACTIVITY_CONTRIBUTOR'>
                                                                    <SELECTLIST>
			                                                            <EXPRESSION>
				                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                            <ALIAS>LOGINNAME</ALIAS>
			                                                            </EXPRESSION>
			                                                            <EXPRESSION>
				                                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                            <ALIAS>FIRSTNAME</ALIAS>
			                                                            </EXPRESSION>
			                                                            <EXPRESSION>
				                                                            <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                            </EXPRESSION>
			                                                            <EXPRESSION>
				                                                            <FIELDNAME>LASTNAME</FIELDNAME>
                                                                            <ALIAS>LASTNAME</ALIAS>
			                                                            </EXPRESSION>
		                                                            </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>                                                            
                                                            <RELATIONSHIP NAME='TASKINITIATOR'>
                                                                <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                        <ALIAS>LOGINNAME</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                        <ALIAS>FIRSTNAME</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                        <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>LASTNAME</FIELDNAME>
                                                                        <ALIAS>LASTNAME</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>EMAILID</FIELDNAME>
                                                                        <ALIAS>EMAILID</ALIAS>
			                                                        </EXPRESSION>
		                                                        </SELECTLIST>
                                                            </RELATIONSHIP>");

                        if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                            AssociationXML.Append(str_ProcessAssoFacets);

                        AssociationXML.Append(@"</TARGETENTITY>
                                                    </SEARCH>");

                           /* AssociationXML.Append(@"<PROCESS_ACTIVITY Type='RELATION'>
                                                        <ACTIVITYID/>
                                                        <ACTIVITY_CONTRIBUTOR Type='RELATION'>
                                                                <LOGINNAME/>
                                                                <FIRSTNAME/>
                                                                <MIDDLEINITIAL/>
                                                                <LASTNAME/>
                                                        </ACTIVITY_CONTRIBUTOR>
                                                    </PROCESS_ACTIVITY>
                                                    <TASKINITIATOR Type='RELATION'>
														<LOGINNAME/>
														<FIRSTNAME/>
														<MIDDLEINITIAL/>
														<LASTNAME/>
														<EMAILID/>
													</TASKINITIATOR>
                                                </ASSOCIATION>");
                        
                        ErrorXML = MWBFacadeObj.GetTask(TaskID, null, AssociationXML.ToString(), out ReturnTaskXML);*/                        
                        ErrorXML = SearchConfigObj.GetHierarchialData(AssociationXML.ToString(), ref ReturnTaskXML);
                        if (ErrorXML == null)
                        {
                            ReturnTaskXML = ReturnTaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", String.Empty);
                            ReturnTaskXML = ReturnTaskXML.Replace("</WORKFLOWPROCESSCOLLECTION>", String.Empty);
                            //Email Stamping for the contributor of 1st step from Task.
                            xp_retTaskXMLDoc = new XmlDocument();
                            xp_retTaskXMLDoc.LoadXml(ReturnTaskXML);
                            TaskNavigator = xp_retTaskXMLDoc.CreateNavigator();

                            //Load task xml from temp path.
                            //To get deliverable manager and project manager for the task.
                            xp_TaskProcessDoc   = new XmlDocument();
                            TempFilePath        = new StringBuilder();

                            TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                            TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                            xp_TaskProcessDoc.Load(TempFilePath.ToString());
                            Root_TaskProcessDoc = xp_TaskProcessDoc.CreateNavigator();
                            DeliverableTaskNavigator =   Root_TaskProcessDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK");
                            if (DeliverableTaskNavigator!=null)
                            {
                                TempNavigator = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS");
                                if (TempNavigator !=null)
                                    TempNavigator.AppendChild(DeliverableTaskNavigator.OuterXml);

                            }

                            FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");
                            while (FileSystemIterator.MoveNext())
                            {
                                TempNavigator = FileSystemIterator.Current;
                                TempNavigator.DeleteSelf();
                                FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");
                                
                            }

                            //Stamp notifications to new users
                            ContributorIds = __NewContributorIDs_HF.Value;
                            ContributorIDList = ContributorIds.Split(',');
                            TotalNumberOfContributor = ContributorIDList.Length;

                            for (int ContributorCnt = 0; ContributorCnt < TotalNumberOfContributor; ContributorCnt++)
                            {
                                ContributorID = ContributorIDList[ContributorCnt];
                                if (ContributorID != ALParamObj.UserID)
                                {
                                    ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITY_CONTRIBUTOR/USER/USERID/text() = '" + ContributorID + "']");
                                    if ((ActivityNav != null) && (ActivityNav.HasChildren))
                                    {
                                        ContributorNav = ActivityNav.SelectSingleNode("ACTIVITY_CONTRIBUTOR");
                                        if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                        {
                                            NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                            NotificationHelperObj.Init("5003", ALParamObj.UserID, __ProcessDefinitionID.Value);

                                            EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                            EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                            //By: Bhalchandra
                                            //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //By: Bhalchandra
                                            //Date : September,12 2007
                                            //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //Create ActingProjectManager attribute and set it to ACTINGPROJECTMANAGER Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/ACTINGPROJECTMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("ActingProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //Create TaskInitiator attribute and set it to TASKINITIATOR Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("TaskInitiator", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));
                                            
                                            NotificationHelperObj.AddChannel(EmailChannelObj);
                                            Message = new StringBuilder();
                                            //SenderName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName());
											//ReceiverName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav));
											Message.AppendFormat("<MESSAGE >{0}</MESSAGE>", TaskNavigator.InnerXml);

                                            Subject = new StringBuilder();
                                            Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                            ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                            TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "RESPONSE", ActivityID);

                                            ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                            ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                            ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                            ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                            if (ErrorXML == null && NotificationXML != null)
                                            {
                                                NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                                ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                            }
                                        }
                                    }
                                }
                            }

                            //Stamp Notification to old users
                            if ((!String.IsNullOrEmpty(__OldContributorIDs_HF.Value)))
                            {
                                TotalNumberOfContributor = 0;
                                ContributorIds = __OldContributorIDs_HF.Value;
                                ContributorIDList = ContributorIds.Split(',');
                                TotalNumberOfContributor = ContributorIDList.Length;
                                //Load the Input XML for the old users
                                retTaskXML = new StringReader(OldUsersXML);
                                xp_OldUserXMLDoc = new XPathDocument(retTaskXML);
                                Root_OldUserXMLDoc = xp_OldUserXMLDoc.CreateNavigator();

                                for (int Count = 0; Count < TotalNumberOfContributor; Count++)
                                {
                                    ContributorID = ContributorIDList[Count];
                                    if (ContributorID != ALParamObj.UserID)
                                    {
                                        ContributorNav = Root_OldUserXMLDoc.SelectSingleNode("USERCOLLECTION/OLDUSER[USER/USERID='" + ContributorID + "']");
                                        if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                        {
                                            NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                            NotificationHelperObj.Init("5007", ALParamObj.UserID, __ProcessDefinitionID.Value);

                                            EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                            EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                            str_ActivityID   = ContributorNav.SelectSingleNode("ACTIVITYID").Value;
                                            nav_Activity     = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='"+ str_ActivityID +"']/ACTIVITY_CONTRIBUTOR/USER");
                                            if (nav_Activity != null)
                                            {
                                                str_NewContributorName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(nav_Activity));
                                            }
                                            NotificationHelperObj.AddChannel(EmailChannelObj);
                                            Message = new StringBuilder();
											//SenderName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName());
											//ReceiverName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav));
                                            Message.AppendFormat("<MESSAGE NewContributor='{0}'>{1}</MESSAGE>", str_NewContributorName ,TaskNavigator.InnerXml);
                                            str_NewContributorName = null;
                                            Subject = new StringBuilder();
                                            Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                            ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                            ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());

                                            ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                            if (ErrorXML == null && NotificationXML != null)
                                            {
                                                NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                                ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else if (Event.ToUpper() == "TASKCANCELLED")
                    {
                        xp_TaskProcessDoc   = new XmlDocument();
                        TempFilePath        = new StringBuilder();

                        TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                        TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                        xp_TaskProcessDoc.Load(TempFilePath.ToString());
                        Root_TaskProcessDoc = xp_TaskProcessDoc.CreateNavigator();

                        TempNavigator = Root_TaskProcessDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                        if (TempNavigator != null)
                        {
                            SR_ProcessActivity = new StringReader(TempNavigator.OuterXml);
                            xp_ProcessTransitionDoc = new XPathDocument(SR_ProcessActivity);
                            Root_ProcessTransition = xp_ProcessTransitionDoc.CreateNavigator();
                            TempNavigator.DeleteSelf();
                        }

                        TempNavigator = Root_TaskProcessDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_TRANSITION");
                        if (TempNavigator != null)
                            TempNavigator.DeleteSelf();

                        FileSystemIterator = Root_TaskProcessDoc.Select("//FILESYSTEM");

                        while (FileSystemIterator.MoveNext())
                        {
                            TempNavigator = FileSystemIterator.Current;
                            TempNavigator.DeleteSelf();
                            FileSystemIterator = Root_TaskProcessDoc.Select("//FILESYSTEM");
                        }

                        TempNavigator = Root_TaskProcessDoc.SelectSingleNode("descendant::SUBFLOWACTIVITY");
                        if (TempNavigator != null)
                            TempNavigator.DeleteSelf();

                        if ((Root_ProcessTransition != null) && (Root_ProcessTransition.HasChildren))
                        {
                            Process_Activities = Root_ProcessTransition.Select("PROCESS_ACTIVITY/ACTIVITY[STATUS = 'Active' and (STARTACTIVITY/text() != 'True' and ENDACTIVITY/text() != 'True')]");
                            while (Process_Activities.MoveNext())
                            {
                                ActivityNav = Process_Activities.Current;
                                if (ActivityNav.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER") != null)
                                {
                                    ContributorID = ActivityNav.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID").Value;
                                    if (ContributorID != ALParamObj.UserID)
                                    {
                                        EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                        EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                        NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                        NotificationHelperObj.Init("5008", ALParamObj.UserID);
                                        NotificationHelperObj.AddChannel(EmailChannelObj);

                                        //By: Bhalchandra
                                        //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                        ProjectManager = xp_TaskProcessDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                        if (ProjectManager != null)
                                            ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                        //By: Bhalchandra
                                        //Date : September,12 2007
                                        //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                        ProjectManager = null;
                                        ProjectManager = xp_TaskProcessDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                        if (ProjectManager != null)
                                            ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

										//SenderName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName());
										//ReceiverName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ActivityNav.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER")));
										
                                        Message = new StringBuilder();
										Message.AppendFormat("<MESSAGE>{0}</MESSAGE>",Root_TaskProcessDoc.OuterXml);

                                        Subject = new StringBuilder();
                                        Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", Root_TaskProcessDoc.OuterXml);

                                        ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                        ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());

                                        ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);
                                        if (ErrorXML == null && NotificationXML != null)
                                        {
                                            NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                            ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else if (Event.ToUpper() == "DURATIONCHANGED")
                    {
                        //Get the Task.
                        AssociationXML = new StringBuilder(50);
                        MWB_HelperObj.GetAssociatedFacetListForNotifications(NotificationTypeID, ProcessDefinitionID, SolutionName, out str_ProcessAssoFacets);
                        //str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                        //if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                        //{
                        //    AssociationXML.Append("<ASSOCIATION>" + str_ProcessAssoFacets + "");
                        //}
                        //else
                        //{
                        //    AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                        //}
                        NotificationTypeID = "5042";

                        AssociationXML.Append(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
                                                        <SEARCHALLFACETS>FALSE</SEARCHALLFACETS>
                                                        <TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
	                                                        </FILTERLIST>");

                        if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                            AssociationXML.Append(str_ProcessAssoFacets);

                            AssociationXML.Append(@"<RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                                                <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>ACTIVITYID</FIELDNAME>
                                                                        <ALIAS>ACTIVITYID</ALIAS>
			                                                        </EXPRESSION>
		                                                        </SELECTLIST>
                                                                <RELATIONSHIP NAME='ACTIVITY_CONTRIBUTOR'>
                                                                    <SELECTLIST>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                            <ALIAS>LOGINNAME</ALIAS>
		                                                                </EXPRESSION>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                            <ALIAS>FIRSTNAME</ALIAS>
		                                                                </EXPRESSION>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
		                                                                </EXPRESSION>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                            <ALIAS>LASTNAME</ALIAS>
		                                                                </EXPRESSION>
	                                                                </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='TASKINITIATOR'>
                                                                <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                        <ALIAS>LOGINNAME</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                        <ALIAS>FIRSTNAME</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                        <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>LASTNAME</FIELDNAME>
                                                                        <ALIAS>LASTNAME</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>EMAILID</FIELDNAME>
                                                                        <ALIAS>EMAILID</ALIAS>
			                                                        </EXPRESSION>
		                                                        </SELECTLIST>
                                                            </RELATIONSHIP>

                                                            <RELATIONSHIP NAME='DELIVERABLE_TASK'>
                                                                <SELECTLIST>
	                                                                <EXPRESSION>
		                                                                <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                                        <ALIAS>PROCESSNAME</ALIAS>
	                                                                </EXPRESSION>
                                                                </SELECTLIST>
                                                                <RELATIONSHIP NAME='PROJECT_DELIVERABLE'>
                                                                    <SELECTLIST>
	                                                                    <EXPRESSION>
		                                                                    <FIELDNAME>PROCESSNAME</FIELDNAME>
                                                                            <ALIAS>PROCESSNAME</ALIAS>
	                                                                    </EXPRESSION>
                                                                    </SELECTLIST>
                                                                    <RELATIONSHIP NAME='PROJECTMANAGER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
                                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                    <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
                                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                  </RELATIONSHIP>
                                                                <RELATIONSHIP NAME='DELIVERABLEMANAGER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
                                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                              </RELATIONSHIP>");

                        AssociationXML.Append(@"</TARGETENTITY>
                                                    </SEARCH>");

                       /* AssociationXML.Append(@"<PROCESS_ACTIVITY Type='RELATION'>
                                                        <ACTIVITYID/>
                                                        <ACTIVITY_CONTRIBUTOR Type='RELATION'>
                                                                <LOGINNAME/>
                                                                <FIRSTNAME/>
                                                                <MIDDLEINITIAL/>
                                                                <LASTNAME/>
                                                        </ACTIVITY_CONTRIBUTOR>
                                                    </PROCESS_ACTIVITY>
                                                    <TASKINITIATOR Type='RELATION'>
                                                        <USERID/>
														<LOGINNAME/>
														<FIRSTNAME/>
														<MIDDLEINITIAL/>
														<LASTNAME/>
														<EMAILID/>
													</TASKINITIATOR>
                                                    <DELIVERABLE_TASK Type='RELATION' HIERARCHY='BOTTOMUP'>
                                                        <PROCESSNAME/>
                                                        <PROJECT_DELIVERABLE Type='RELATION' HIERARCHY='BOTTOMUP'>
                                                            <PROCESSNAME/>
                                                            <PROJECTMANAGER Type='RELATION'>
	                                                            <USERID/>
	                                                            <LOGINNAME/>
	                                                            <FIRSTNAME/>
	                                                            <MIDDLEINITIAL/>
	                                                            <LASTNAME/>
                                                            </PROJECTMANAGER>
                                                            <ACTINGPROJECTMANAGER Type='RELATION'>
	                                                            <USERID/>
	                                                            <LOGINNAME/>
	                                                            <FIRSTNAME/>
	                                                            <MIDDLEINITIAL/>
	                                                            <LASTNAME/>
                                                            </ACTINGPROJECTMANAGER>
                                                        </PROJECT_DELIVERABLE>
                                                        <DELIVERABLEMANAGER Type='RELATION'>
                                                            <USERID/>
                                                            <LOGINNAME/>
                                                            <FIRSTNAME/>
                                                            <MIDDLEINITIAL/>
                                                            <LASTNAME/>
                                                            <EMAILID/>
                                                        </DELIVERABLEMANAGER>
                                                    </DELIVERABLE_TASK>
                                                </ASSOCIATION>");

                        ErrorXML = MWBFacadeObj.GetTask(TaskID, null, AssociationXML.ToString(), out ReturnTaskXML);*/
                        ErrorXML = SearchConfigObj.GetHierarchialData(AssociationXML.ToString(), ref ReturnTaskXML);
                        if (ErrorXML == null)
                        {
                            ReturnTaskXML = ReturnTaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", String.Empty);
                            ReturnTaskXML = ReturnTaskXML.Replace("</WORKFLOWPROCESSCOLLECTION>", String.Empty);
                            //Email Stamping for the contributor of 1st step from Task.
                            xp_retTaskXMLDoc = new XmlDocument();
                            xp_retTaskXMLDoc.LoadXml(ReturnTaskXML);
                            TaskNavigator = xp_retTaskXMLDoc.CreateNavigator();

                            //Load task xml from temp path.
                            //To get deliverable manager and project manager for the task.
                            xp_TaskProcessDoc = new XmlDocument();
                            TempFilePath = new StringBuilder();

                            TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                            TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                            xp_TaskProcessDoc.Load(TempFilePath.ToString());
                            Root_TaskProcessDoc = xp_TaskProcessDoc.CreateNavigator();
                            DeliverableTaskNavigator = Root_TaskProcessDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK");
                            if (DeliverableTaskNavigator != null)
                            {
                                TempNavigator = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS");
                                if (TempNavigator != null)
                                    TempNavigator.AppendChild(DeliverableTaskNavigator.OuterXml);

                            }

                            FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");
                            while (FileSystemIterator.MoveNext())
                            {
                                TempNavigator = FileSystemIterator.Current;
                                TempNavigator.DeleteSelf();
                                FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");

                            }

                            //Stamp notifications to new users
                            ContributorIds = str_DurationChangedStepIDs.Remove(str_DurationChangedStepIDs.Length - 1, 1); 
                            ContributorIDList = ContributorIds.Split(',');
                            TotalNumberOfContributor = ContributorIDList.Length;

                            for (int ContributorCnt = 0; ContributorCnt < TotalNumberOfContributor; ContributorCnt++)
                            {
                                ContributorID = ContributorIDList[ContributorCnt];
                                
                                ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID/text() = '" + ContributorID + "']");
                                if ((ActivityNav != null) && (ActivityNav.HasChildren))
                                {
                                    ContributorNav = ActivityNav.SelectSingleNode("ACTIVITY_CONTRIBUTOR");
                                    if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                    {
                                        NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                        NotificationHelperObj.Init("5042", ALParamObj.UserID, __ProcessDefinitionID.Value);

                                        EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                        EmailChannelObj.AddRecipient("TO", ActivityNav.SelectSingleNode("ACTIVITY_CONTRIBUTOR/USER/USERID").Value, false);

                                        //By: Bhalchandra
                                        //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                        ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                        if (ProjectManager != null)
                                            ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                        //By: Bhalchandra
                                        //Date : September,12 2007
                                        //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                        ProjectManager = null;
                                        ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                        if (ProjectManager != null)
                                            ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                        //Create ActingProjectManager attribute and set it to ACTINGPROJECTMANAGER Node
                                        ProjectManager = null;
                                        ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/ACTINGPROJECTMANAGER");
                                        if (ProjectManager != null)
                                            ((XmlElement)ProjectManager).SetAttribute("ActingProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                        //Create TaskInitiator attribute and set it to TASKINITIATOR Node
                                        ProjectManager = null;
                                        ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                        if (ProjectManager != null)
                                            ((XmlElement)ProjectManager).SetAttribute("TaskInitiator", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                        NotificationHelperObj.AddChannel(EmailChannelObj);
                                        Message = new StringBuilder(100);
                                        Message.Append("<MESSAGE >" + TaskNavigator.InnerXml + "</MESSAGE>");

                                        Subject = new StringBuilder(100);
                                        Subject.Append("<SUBJECT>" + TaskNavigator.InnerXml + "</SUBJECT>");

                                        ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                        TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "RESPONSE", ActivityID);

                                        ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                        ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                        ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                        ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                        if (ErrorXML == null && NotificationXML != null)
                                        {
                                            NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                            ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    return ErrorXML;                    
                }
                catch(Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }
            
            private void setSelectedTab()
			{
				try
				{
					switch(SelectedTab.ToUpper())
					{
						case "INFO":
							ROGatherInfoTaskTab.SelectedTab		= Panel_TaskDetails;
							ROGatherInfoTaskTab.SelectedTabName = "Info";
							break;
						case "USER ROLES":
							ROGatherInfoTaskTab.SelectedTab		= Panel_UserRoles;
							ROGatherInfoTaskTab.SelectedTabName = "User Roles";
							break;
						case "DEPENDENCIES":
							ROGatherInfoTaskTab.SelectedTab		= Panel_Dependencies;
							ROGatherInfoTaskTab.SelectedTabName = "Dependencies";
							break;
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}
	
			private void GetUserRoles()
			{
				StringBuilder			 AssociationXML			 = null;
				StringBuilder			 AttributesXML			 = null;
				String                   TempFilePath            = null;
				MktgWorkBenchFacadeClass MWBFacadeObj            = null;  
				ERRORXML				 ErrorXML				 = null;
				XML						 ReturnTaskXML			 = null;
				XmlDocument				 TaskDoc				 = null;
				XmlNode					 TaskInitiator			 = null;
				String					 ErrorPageURL			 = null;
                XML                      xml_Users               = null;
                XML                      xml_Groups              = null;
                XmlNode                  xmlnode_User            = null;
                XmlNode                  xmlnode_Group           = null;
                XPathNavigator           nav_TaskReaderGroups    = null;
                XPathNavigator           nav_TaskReaderUsers     = null;

				try
				{
					AssociationXML = new StringBuilder();
					AttributesXML  = new StringBuilder();
					TempFilePath   = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

					AssociationXML.AppendFormat(@"<ASSOCIATION GetAllFacets='FALSE'>						
														<READERS Type='RELATION'>
															<LOGINNAME/>
															<FIRSTNAME/>
															<MIDDLEINITIAL/>
															<LASTNAME/>
															<EMAILID/>
                                                            <FILTERLIST>
	                                                            <FILTER>
		                                                            <EXPRESSION>STATUS</EXPRESSION>
		                                                            <OPERATOR>EQUALTO</OPERATOR>
		                                                            <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
		                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                            </FILTER>
                                                            </FILTERLIST>
														</READERS>
                                                        <PROCESSREADER_GROUPS Type='RELATION'>
                                                            <GROUPNAME/>
                                                            <GROUPID/>
                                                            <FILTERLIST>
                                                                <FILTER>
                                                                    <EXPRESSION>ISDELETED</EXPRESSION>
                                                                    <OPERATOR>EQUALTO</OPERATOR>
                                                                    <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                </FILTER>
                                                            </FILTERLIST>
                                                        </PROCESSREADER_GROUPS>
														<TASKINITIATOR Type='RELATION'>
															<LOGINNAME/>
															<FIRSTNAME/>
															<MIDDLEINITIAL/>
															<LASTNAME/>
															<EMAILID/>
														</TASKINITIATOR>
                                                        <PROCESSCOMPLETION_GROUP Type='RELATION'>
                                                            <GROUPNAME/>
                                                            <ISDELETED/>
                                                            <FILTERLIST>
	                                                            <FILTER>
		                                                            <EXPRESSION>ISDELETED</EXPRESSION>
		                                                            <OPERATOR>EQUALTO</OPERATOR>
		                                                            <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
		                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                            </FILTER>
                                                            </FILTERLIST>
                                                        </PROCESSCOMPLETION_GROUP>
                                                        <PROCESSCOMPLETION_USER Type='RELATION'>
                                                            <STATUS/>
                                                            <LOGINNAME/>
                                                            <FIRSTNAME/>
                                                            <MIDDLEINITIAL/>
                                                            <LASTNAME/>
                                                            <EMAILID/>
                                                            <FILTERLIST>
	                                                            <FILTER>
		                                                            <EXPRESSION>STATUS</EXPRESSION>
		                                                            <OPERATOR>EQUALTO</OPERATOR>
		                                                            <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
		                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                            </FILTER>
                                                            </FILTERLIST>
                                                        </PROCESSCOMPLETION_USER>
													</ASSOCIATION>");

					AttributesXML.Append(@"<WORKFLOWPROCESS>
												<WORKFLOWPROCESSID/>
										   </WORKFLOWPROCESS>");	
					MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					ErrorXML = MWBFacadeObj.GetTask(TaskID, AttributesXML.ToString(), AssociationXML.ToString(), out ReturnTaskXML);
					if (ErrorXML == null)
					{
						TaskDoc = new XmlDocument();
						TaskDoc.LoadXml(ReturnTaskXML);

                        //TaskXMLDoc Readers
                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS") != null)
                            nav_TaskReaderGroups = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS").CreateNavigator();

                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS") != null)
                            nav_TaskReaderUsers = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS").CreateNavigator();

                        setTaskReadersUserGroupList(nav_TaskReaderGroups, nav_TaskReaderUsers);

                        TaskInitiator = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
						setInitiatorSelectionControl(TaskInitiator);

                        //paint process completion users
                        xmlnode_User = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_USER");
                        if (xmlnode_User != null)
                            xml_Users = xmlnode_User.InnerXml;

                        xmlnode_Group = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_GROUP");
                        if (xmlnode_Group != null)
                            xml_Groups = xmlnode_Group.InnerXml;

                        populateUserGroupList(xml_Users, xml_Groups);
					}
					else
					{
						ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
						if(!IsPostBack)
						{
							Response.Redirect(ErrorPageURL, true);
						}
						else
							Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

		    private XML GetSearchXMLForGroupAndUsers(String GpName)
		    {
			    StringBuilder Search = null;
			    try
			    {
				    Search = new StringBuilder();
				    Search.AppendFormat(@"<INPUTXML>
										    <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
										    <SEARCHCOLLECTION>
										    <SEARCH>
										    <TARGETOBJECT>GROUP</TARGETOBJECT>
										    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
										    <ISCASESENSITIVE>False</ISCASESENSITIVE>
										    <SEARCHALLFACETS>False</SEARCHALLFACETS>
										    <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
										    <FILTERLIST>
											    <FILTER>
												    <FIELDNAME>GROUPNAME</FIELDNAME>
												    <OPERATOR>EQUALTO</OPERATOR>
												    <FIELDVALUE>{4}</FIELDVALUE>												
												    <ISCASESENSITIVE>False</ISCASESENSITIVE>
											    </FILTER>
											    <FILTER ApplyFilter=""Yes"">
												    <FILTERID>2</FILTERID>
												    <FIELDNAME>STATUS</FIELDNAME>
												    <OPERATOR>EQUALTO</OPERATOR>
												    <FIELDVALUE>ACTIVE</FIELDVALUE>
												    <NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
												    <ISCASESENSITIVE>False</ISCASESENSITIVE>
											    </FILTER>
										    </FILTERLIST>
										    <FIELDCOLLECTION>
											    <RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'>
													    <FIELD>USERID</FIELD>
													    <FIELD>USERNAME</FIELD>	
													    <FIELD>LOGINNAME</FIELD>
													    <FIELD>FIRSTNAME</FIELD>
													    <FIELD>LASTNAME</FIELD>
													    <FIELD>MIDDLEINITIAL</FIELD>
													    <FIELD>EMAILID</FIELD>											
												    </RELATEDENTITYFIELDS>
										    </FIELDCOLLECTION>
										    </SEARCH>
										    </SEARCHCOLLECTION>
									    </INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
				    return Search.ToString();
			    }
			    catch(Exception ExcepObj)
			    {
				    throw ExcepObj;
			    }
		    }

		    private XML GetSearchXML(String GpName)
		    {
			    StringBuilder Search = null;
			    try
			    {
				    Search = new StringBuilder();
				    Search.AppendFormat(@"<INPUTXML>
										    <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
										    <SEARCHCOLLECTION>
										    <SEARCH>
										    <TARGETOBJECT>USER</TARGETOBJECT>
										    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
										    <ISCASESENSITIVE>False</ISCASESENSITIVE>
										    <SEARCHALLFACETS>False</SEARCHALLFACETS>
										    <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
										    <FILTERLIST>
											    <FILTER>
												    <FIELDNAME>GROUPNAME</FIELDNAME>
												    <OPERATOR>EQUALTO</OPERATOR>
												    <FIELDVALUE>{4}</FIELDVALUE>
												    <NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
												    <ISCASESENSITIVE>False</ISCASESENSITIVE>
											    </FILTER>
											    <FILTER>
												    <FIELDNAME>STATUS</FIELDNAME>
												    <OPERATOR>EQUALTO</OPERATOR>
												    <FIELDVALUE>ACTIVE</FIELDVALUE>											
												    <ISCASESENSITIVE>False</ISCASESENSITIVE>
											    </FILTER>
										    </FILTERLIST>
										    <FIELDCOLLECTION>
												    <TARGETENTITYFIELDS>
													    <FIELD>USERID</FIELD>
													    <FIELD>LOGINNAME</FIELD>
													    <FIELD>FIRSTNAME</FIELD>
													    <FIELD>LASTNAME</FIELD>
													    <FIELD>MIDDLEINITIAL</FIELD>
													    <FIELD>EMAILID</FIELD>													
												    </TARGETENTITYFIELDS>
											    </FIELDCOLLECTION>
										    </SEARCH>
										    </SEARCHCOLLECTION>
									    </INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
				    return Search.ToString();
			    }
			    catch(Exception ExcepObj)
			    {
				    throw ExcepObj;
			    }
		    }

		    private void DeleteTempFiles()
		    {
			    String			TempPath				= null;
			    StringBuilder	TempFilePath			= null;
			    String			SelectedValueFileName	= null;
			    try
			    {
				    TempFilePath = new StringBuilder();
				    TempPath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				    TempFilePath.AppendFormat("{0}{1}",TempPath,TaskFile);
				    if(File.Exists(TempFilePath.ToString()))
					    File.Delete(TempFilePath.ToString());
				    TempFilePath.Remove(0, TempFilePath.Length);
				    TempFilePath.AppendFormat("{0}{1}", TempPath, StepResourceFileName);
				    if(File.Exists(TempFilePath.ToString()))
					    File.Delete(TempFilePath.ToString());
				    TempFilePath.Remove(0, TempFilePath.Length);
				    TempFilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
				    if(File.Exists(TempFilePath.ToString()))
					    File.Delete(TempFilePath.ToString());
				    TempFilePath.Remove(0, TempFilePath.Length);

                    if (ViewState["StepFormIDList"] != null)
                    {
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

                        while (StepFormIDEnum.MoveNext())
                        {
                            SelectedValueFileName = StepFormIDEnum.Value.ToString() + "_ContributorGroup_SelectedValueList.xml";
                            TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
                            if (File.Exists(TempFilePath.ToString()))
                                File.Delete(TempFilePath.ToString());
                            TempFilePath.Remove(0, TempFilePath.Length);
                            TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormIDEnum.Value.ToString());
                            if (File.Exists(TempFilePath.ToString()))
                                File.Delete(TempFilePath.ToString());
                            TempFilePath.Remove(0, TempFilePath.Length);
                            SelectedValueFileName = StepFormIDEnum.Value.ToString() + "_GroupUsers.xml";
                            TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
                            if (File.Exists(TempFilePath.ToString()))
                                File.Delete(TempFilePath.ToString());
                            TempFilePath.Remove(0, TempFilePath.Length);
                        }
                    }

                    //HemantK:To Delete Component Facet Series file
                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.AppendFormat("{0}{1}{2}", TempPath, TaskID, str_ComponentFacetFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());

                    //delete step files.
                    if (ViewState["ActivityIDList"] != null)
                    {
                        ActivityIDOrderedList = (List<string>)ViewState["ActivityIDList"];
                        for (int i = 0; i < ActivityIDOrderedList.Count; i++)
                        {
                            TempFilePath.Remove(0, TempFilePath.Length);
                            TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ActivityIDOrderedList[i] + str_SelectedComponentsIDFileName);
                            if (File.Exists(TempFilePath.ToString()))
                            {
                                File.Delete(TempFilePath.ToString());
                            }
                        }
                    }

                    //Anita Kale: To delete Temp file for Project Info form Input
                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.AppendFormat("{0}{1}{2}", TempPath, TaskID, str_ProjectInfoTempFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());
			    }
			    catch(Exception ExcepObj)
			    {
				    throw ExcepObj;
			    }
		    }

	        private void setControlProperties()
	        {
		        try
		        {
			        ROGatherInfoTaskTab.onTabClick += new ALTab.TabEventHandler(ROGatherInfoTaskTab_onTabClick);
			        Ab_ROGatherInfoTask.Click += new EventHandler(Ab_ROGatherInfoTask_Click);
		        }
		        catch(Exception ExcepObj)
		        {
			        throw ExcepObj;
		        }
	        }

            /// <summary>
            /// <CreatedOn>19 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To handle component facet series action bar clicks</Purpose>
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void StepForm_SeriesActionBarClick(object sender, EventArgs e)
            {                
	            ulong			ErrorID				= 0;                
                StringBuilder   ParamURL            = null;
                StringBuilder   URL                 = null;
                String          EncryptURL          = null;
                String          str_DeliverableId   = null;
                String          str_ActivityID      = null;

                try
                {
                    ParamURL        = new StringBuilder();
                    URL             = new StringBuilder(); 
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                    if (Parameters[1].Equals("SelectSeriesRecord"))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableId = ViewState["ParentDeliverableID"].ToString();
                        }
                        GetSelectedStepForm(Parameters[0], out str_ActivityID);
                        //Radha On 30/Dec/08: For selecting Component facet series record.
                        ParamURL.AppendFormat("Manage_SelectSigns.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&HiddenButtonID={4}&TaskID={5}&DeliverableID={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Btn_Hidden_SelectSigns.UniqueID, TaskID, str_DeliverableId);
                        ParamURL.Append("&OutPutFileName=" + str_ActivityID + str_SelectedComponentsIDFileName + "&SelectFor=STEP&StepID=" + str_ActivityID);
                        EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                        URL.AppendFormat("window.open('" + "{0}" + "','_new','left=120,top=120,width=1085,height=800,scrollbars=yes');", EncryptURL.ToString());
                        Ajax.WriteExecuteJavaScript(URL.ToString());
                    }
                    else if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                    {
                        GetSelectedStepForm(Parameters[0], out str_ActivityID);
                        getDigitalAssetsFromFacetIDs("STEP", str_ActivityID);
                    }
                    else if (Parameters[1].Equals("EditSeriesRecord"))
                    {
                        GetSelectedStepForm(Parameters[0], out str_ActivityID);
                        if ((ViewState["ComponentFacetFieldName"] != null) && (Parameters[0].Contains(ViewState["ComponentFacetFieldName"].ToString())))
                        {
                            GetEditPageUrl(str_ActivityID);
                        }
                        else
                        {
                            String EditPageUrl = TempStepForm.GetSeriesEditRecordsUrl();
                            if (!String.IsNullOrEmpty(EditPageUrl))
                            {
                                Ajax.WriteExecuteJavaScript(EditPageUrl);
                            }
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ROGatherInfoTask.aspx", "StepForm_SeriesActionBarClick", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlingComponentListactionbarclick_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ExceptionObj.Message, null, null, ref EncryptURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                }
            }

            /// <summary>
            /// <CreatedOn>22 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To re assign </Purpose>
            /// </summary>
            /// <param name="str_ActivityID"></param>
            /// <param name="str_StepFormXML"></param>
            /// <param name="str_FormConfigXML"></param>
            /// <param name="str_SelectedFormName"></param>
            private void CreateNewStepForm_ComponentList(String str_ActivityID, String str_StepFormXML, String str_FormConfigXML, String str_SelectedFormName, Boolean b_SetDeliverableComponentFacetSeries)
            {
                String          str_StepFormInputXML    = null; 
                String          SelectedValueFileName   = null; 
                String          str_SelectedValueFile   = null; 
                String          str_SelectedValueXML    = null; 
                //String          str_TempFormInputXML    = null; 
                StringBuilder   sb_ActivityCollection   = null; 
                StringBuilder   sb_TempFilePath         = null; 
                XmlDocument     InputXMLDoc             = null;
                XmlNode         node_Activity           = null; 
                FormFacade      FormFacadeObj           = null; 
                ERRORXML        ErrorXML                = null; 
                String          SearchXML               = null;
                XPathDocument   xp_CurrentFormInput     = null;
                XPathNavigator  nav_Field               = null; 
                XmlDocument     doc_NewFormInput        = null;
                XmlNode         node_Field              = null;
                XmlNode         ValueNode               = null;
                long            Duration                = 0;
                MWB_Helper      MWBHelperClassObj       = null;
     
                try
                {
                    FormFacadeObj           = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    MWBHelperClassObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    InputXMLDoc             = new XmlDocument();
                    sb_ActivityCollection   = new StringBuilder(500);
                    sb_TempFilePath         = new StringBuilder(50);

                    sb_TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile);
                    if (File.Exists(sb_TempFilePath.ToString()))
                    {
                        InputXMLDoc = new XmlDocument();
                        //InputXMLDoc.Load(sb_TempFilePath.ToString());
                        InputXMLDoc.LoadXml(str_StepFormXML);
                        //node_Activity = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + str_ActivityID + "']");
                        node_Activity = InputXMLDoc.DocumentElement;
                        if (node_Activity != null)
                        {
                            //str_TempFormInputXML = TempStepForm.InputXML;
                            xp_CurrentFormInput = new XPathDocument(new StringReader(TempStepForm.InputXML));
                            nav_Field = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='Contributor']");

                            // keep the Selected value XML in a String, since the form facade will over-write it
                            // after the form facade over writes it re-write it back to maintain the changes
                            SelectedValueFileName = StepFormIDTable[str_ActivityID].ToString() + "_ContributorGroup_SelectedValueList.xml";
                            str_SelectedValueFile = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedValueFileName;
                            str_SelectedValueXML  = File.ReadAllText(str_SelectedValueFile);

                            FormFacadeObj.SolutionName  = SolutionName;
                            FormFacadeObj.FormName      = str_SelectedFormName;
                            //HemantK: check for the deliverable component facet series
                            if ((b_SetDeliverableComponentFacetSeries) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                            {
                                FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                                ErrorXML = SetDeliverableComponentFacetSeries(ref node_Activity, ref str_FormConfigXML, SearchXML);
                            }
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                CheckComponentFacetSeriesStatus(TempStepForm);

                                sb_ActivityCollection.Append("<ACTIVITYCOLLECTION>" + node_Activity.OuterXml + "</ACTIVITYCOLLECTION>");
                                                               
                                FormFacadeObj.UniqueID = StepFormIDTable[str_ActivityID].ToString();
                                FormFacadeObj.ShowConfiguredFields = true;
                                FormFacadeObj.GetFormInputXML("Edit", sb_ActivityCollection.ToString(), out str_StepFormInputXML, out StepObjInfoList);
                                ViewState["StepObjectList" + str_ActivityID] = StepObjInfoList;

                                doc_NewFormInput = new XmlDocument();
                                doc_NewFormInput.LoadXml(str_StepFormInputXML);
                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    node_Field.InnerXml = nav_Field.InnerXml;
                                }

                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='Duration']");
                                if (node_Field != null)
                                {
                                    if (ViewState["Duration_" + str_ActivityID + ""] != null)
                                        Duration = Convert.ToInt64(ViewState["Duration_" + str_ActivityID + ""].ToString());
                                    else
                                        Duration = MWBHelperClassObj.GetStepDuration(node_Activity.CreateNavigator());

                                    ValueNode = node_Field.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = Duration.ToString();
                                    else
                                    {
                                        ValueNode = doc_NewFormInput.CreateElement("Value");
                                        ValueNode.InnerText = Duration.ToString();
                                        node_Field.AppendChild(ValueNode);
                                    }
                                }

                                updateFormFields("EmailID", node_Activity, ref doc_NewFormInput);
                                updateFormFields("PostedBy", node_Activity, ref doc_NewFormInput);


                                nav_Field = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    ((XmlElement)node_Field).SetAttribute("NamedHierarchyURL", nav_Field.GetAttribute("NamedHierarchyURL", ""));
                                    ((XmlElement)node_Field).SetAttribute("NamedHierarchyXML", "");
                                }

                                //Write again the Group XML file
                                File.WriteAllText(str_SelectedValueFile, str_SelectedValueXML);
                                if (IsPostBack)
                                {
                                    TempStepForm.ResetBinders = true;
                                    TempStepForm.ResetFileUploadControls = true;
                                }
                                TempStepForm.InputXML = doc_NewFormInput.OuterXml;
                                //TempStepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                                TempStepForm.ResetFacetSeriesFields();
                                TempStepForm.AddCustomValidator("Duration", "onblur", "javascript:ValidateDuration('$CONTROLID$')", false);
                                TempStepForm.ConfigurationMode = true;
                            }
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>18 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the selected form</Purpose>
            /// </summary>
            private void GetSelectedStepForm(String str_SenderString, out String str_ActivityID)
            {
                String FormID               = null;                

                try
                {
                    str_ActivityID = null; 
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

                    while (StepFormIDEnum.MoveNext())
                    {
                        if (str_SenderString.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            FormID = StepFormIDEnum.Value.ToString();
                            str_ActivityID = StepFormIDEnum.Key.ToString();
                            break;
                        }
                    }

                    if (FormID != null)
                    {
                        //Get the Step form for which save is clicked
                        TempStepForm = (Form)Manual_Activities.FindControl(FormID);
                        StepObjInfoList = (List<ObjectInfo>)ViewState["StepObjectList" + str_ActivityID];
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>8 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To update the deliverable component facet seires</Purpose>
            /// </summary>
            /// <param name="SaveTaskXML"></param>
            /// <returns></returns>
            private ERRORXML UpdateDeliComponentFacetSeries(ref String SaveTaskXML, String str_RootNode, String str_FormConfigXML)
            {
                ERRORXML        ErrorXMLString              = null; 
                String          str_DeliverableProcessId    = null; 
                String          str_ComponentFacetRShipName = null;
                MWB_Component   MWB_ComponentObj            = null; 
                String          SelectedComponentXML        = null;
                String          str_ComponentFacetName      = null;
                String          str_PrimaryKey              = null;
                XPathDocument   xpathDoc_ComponentFormConfig= null;
                XPathNavigator  xpathNav_ComponentFacet     = null;
                Boolean         b_SelectComponentFacetIDs   = false;                     
                try
                {
                    //Take out the Compoent Facet Series from the input xml and update the deliverable
                    //and return the InputXML by removing the Component Facet Series nodes.
                    if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        str_DeliverableProcessId    = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();

                        xpathDoc_ComponentFormConfig = new XPathDocument(new StringReader(str_FormConfigXML));
                        xpathNav_ComponentFacet = xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "' and @IsSeries='YES']");
                        if (xpathNav_ComponentFacet != null)
                        {
                            //Read the Sort order and sort column
                            str_ComponentFacetName = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                            str_PrimaryKey = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                            if (xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                            {
                                b_SelectComponentFacetIDs = true;
                            }
                        }
                        MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        ErrorXMLString = MWB_ComponentObj.SaveComponentFacetData(str_DeliverableProcessId, str_ComponentFacetRShipName, str_RootNode, ref SaveTaskXML, b_SelectComponentFacetIDs, str_ComponentFacetName, str_PrimaryKey, out SelectedComponentXML);      
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

		    /// <summary>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <CreatedOn>29 November 2008</CreatedOn>
            /// <Purpose>To put the deliverable component facet series data in inputxml</Purpose>
            /// </summary>
            /// <param name="InputXMLDoc"></param>
            /// <param name="FormConfigXML"></param>
            private ERRORXML SetDeliverableComponentFacetSeries(ref XmlNode ActivityNode, ref String FormConfigXML, String SearchXML)
            {
                String          str_DeliverableProcessId    = null; 
                String          str_ComponentFacetRShipName = null;
                String          str_InputXML                = null; 
                String          str_ComponentFacetFieldName = null; 
                XmlDocument     InputXMLDoc                 = null; 
                MWB_Component   MWB_ComponentObj            = null; 
                String          str_ComponentUserStatus     = null;
                String          str_ComponentSystemStatus   = null;
                XmlNode         node_ActivityDefinitionID   = null;
                String          str_ActivityDefinitionID    = null;
                ERRORXML        ErrorXMLString              = null;
                String          ErrorPageURL                = null;                 
                ulong           ErrorID                     = 0;
                String          str_ComponentAssetRShip     = null;
                String          str_PrimaryKey              = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    node_ActivityDefinitionID = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                    if (node_ActivityDefinitionID != null)
                    {
                        str_ActivityDefinitionID = node_ActivityDefinitionID.InnerText;  
                    }

                    if (!String.IsNullOrEmpty(FormConfigXML))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                            str_InputXML = ActivityNode.OuterXml;

                            //Check for the Deliverable details
                            if ((ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] != null) && (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""].ToString() != "No"))
                            {
                                str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                                ErrorXMLString = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "ACTIVITY", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                                if (String.IsNullOrEmpty(ErrorXMLString))
                                {
                                    InputXMLDoc = new XmlDocument();
                                    InputXMLDoc.LoadXml(str_InputXML);
                                    ActivityNode = InputXMLDoc.DocumentElement; 
                                }
                                else
                                {
                                    //Redirect to error page.
                                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                    if (!IsPostBack)
                                    {
                                        Response.Redirect(ErrorPageURL, true);
                                    }
                                    else
                                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                }
                            }
                            else
                            {
                                if (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] == null)
                                {
                                    ErrorXMLString = MWB_ComponentObj.GetComponentFacetForTaskActivity(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_ActivityDefinitionID, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, "ACTIVITY", str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, SearchXML, out str_PrimaryKey, out str_ComponentAssetRShip);
                                    if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(str_ComponentFacetRShipName)) && (!String.IsNullOrEmpty(str_ComponentFacetFieldName)))
                                    {
                                        ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "Yes";
                                        if (ViewState["ComponentFacetSeriesRShipName"] == null)
                                        {
                                            ViewState["ComponentFacetSeriesRShipName"] = str_ComponentFacetRShipName;
                                        }
                                        if (ViewState["ComponentFacetFieldName"] == null)
                                        {
                                            ViewState["ComponentFacetFieldName"] = str_ComponentFacetFieldName;
                                        }
                                        if (ViewState["ComponentFacetPrimaryKey"] == null)
                                        {
                                            ViewState["ComponentFacetPrimaryKey"] = str_PrimaryKey;
                                        }
                                        if ((!String.IsNullOrEmpty(str_ComponentAssetRShip)) && (ViewState["ComponentAssetRShipName"] == null))
                                        {
                                            ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                        }
                                        InputXMLDoc = new XmlDocument();
                                        InputXMLDoc.LoadXml(str_InputXML);
                                        ActivityNode = InputXMLDoc.DocumentElement; 
                                    }
                                    else if (!String.IsNullOrEmpty(ErrorXMLString))
                                    {
                                        //Redirect to error page.
                                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                        if (!IsPostBack)
                                        {
                                            Response.Redirect(ErrorPageURL, true);
                                        }
                                        else
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                    }
                                    else if (String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                    {
                                        ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "No";
                                    }
                                }
                            }

                            //Radha: For component facet series action bar.
                            if ((ViewState["ComponentUserStatus"] == null) && (!String.IsNullOrEmpty(str_ComponentUserStatus)))
                            {
                                ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                            }
                        }
                    }
                    return ErrorXMLString;
                }
                catch(ThreadAbortException)
                { return ErrorXMLString; }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ROGatherInfoTask.aspx", "SetDeliverableComponentFacetSeries", ExceptionObj, null, null);
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackURL(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXMLString;
                }
            }

            /// <summary>
            /// <CreatedOn>08 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To remove the component facet nodes from the given XML</Purpose>
            /// </summary>
            /// <param name="SaveXML">XML Document from which component facet nodes are to be removed</param>
            private void RemoveDeliverableComponentFacet(ref XML SaveXML)
            {
                String          str_ComponentFacetRShipName = null;
                MWB_Component   MWB_ComponentObj            = null;
                XmlDocument     xmlDoc_SaveXml              = null;
     
                try
                {
                    if ((ViewState["ComponentFacetSeriesRShipName"] != null) && (!String.IsNullOrEmpty(SaveXML))) 
                    {
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        xmlDoc_SaveXml = new XmlDocument();
                        xmlDoc_SaveXml.LoadXml(SaveXML);
                        MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        MWB_ComponentObj.RemoveComponentFacetNodes(xmlDoc_SaveXml, str_ComponentFacetRShipName, "WORKFLOWPROCESS", "ALL", null);
                        SaveXML = xmlDoc_SaveXml.OuterXml;
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>08 December 2008</CreatedOn> 
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To check the status of the Deliverable component facet series and depending on that set the form mode</Purpose>
            /// </summary>
            /// <param name="Frm_ToChange">Form whose mode is to be set</param>
            private void CheckComponentFacetSeriesStatus(Form Frm_ToChange)
            {
                try
                {
                    if ((!String.IsNullOrEmpty(str_ComponentFacetStatus)) && (str_ComponentFacetStatus.ToUpper() == "READONLY"))
                    {
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                            Frm_ToChange.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                        }
                    }
                    //Radha: Check whether component user status is final lock and mark the form as readonly.
                    else if ((ViewState["ComponentUserStatus"] != null) && (ViewState["ComponentUserStatus"].ToString().ToUpper().Equals("FINAL LOCK")))
                    {
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the Component facet for task</Purpose>
            /// </summary>
            /// <param name="TaskXMLDoc"></param>
            /// <param name="FormConfigXML"></param>
            /// <param name="FormConfigXMLType"></param>
            private ERRORXML GetComponentFacetForTask(ref XmlDocument TaskXMLDoc, ref String FormConfigXML, String SearchXML)
            {
                ERRORXML        ErrorXML                    = null; 
                String          str_ComponentFacetRShipName = null;
                String          str_DeliverableProcessId    = null;
                StringBuilder   sb_Del_ComponentFacetSeries = null;
                String          str_ComponentFacetFieldName = null; 
                Boolean         bool_GetDeliverable         = true; 
                MWB_Component   MWB_ComponentObj            = null;
                String          str_InputXML                = null; 
                String          str_ComponentUserStatus     = null;
                String          str_ComponentSystemStatus   = null;
                String          ErrorPageURL                = null;                 
                ulong           ErrorID                     = 0;
                String          str_ComponentAssetRShip     = null;
                String          str_PrimaryKey              = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
         
                    //Check for the facet series configured in the form by getting the Component Facet series facet and relationship name from the configuration
                    if ((ViewState["ComponentFacetSeriesFor_Task"] != null) && (ViewState["ComponentFacetSeriesFor_Task"].ToString() != "No"))
                    {
                        str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        bool_GetDeliverable = false;
                    }

                    str_InputXML = TaskXMLDoc.OuterXml;  
                    if (bool_GetDeliverable)
                    {
                        if (ViewState["ComponentFacetSeriesFor_Task"] == null)
                        {
                            //HemantK:Delete temp file for component facet series
                            sb_Del_ComponentFacetSeries = new StringBuilder(50);
                            sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                            if ((File.Exists(sb_Del_ComponentFacetSeries.ToString())) && (!IsPostBack))
                            {
                                File.Delete(sb_Del_ComponentFacetSeries.ToString());
                            }

                            if (ViewState["ParentDeliverableID"] != null)
                            {
                                str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                            }

                            ErrorXML = MWB_ComponentObj.GetComponentFacetForTask(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_PrimaryKey, out str_ComponentAssetRShip, SearchXML);
                            if ((String.IsNullOrEmpty(ErrorXML)))
                            {
                                if (!String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                {
                                    //Put Component Facet relationship name and Component Facet name in view state
                                    ViewState["ComponentFacetSeriesFor_Task"]   = "Yes";
                                    ViewState["ComponentFacetSeriesRShipName"]  = str_ComponentFacetRShipName;
                                    ViewState["ComponentFacetFieldName"]        = str_ComponentFacetFieldName;
                                    ViewState["ComponentFacetPrimaryKey"]       = str_PrimaryKey;
                                    if (!String.IsNullOrEmpty(str_ComponentAssetRShip))
                                    {
                                        ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                    }
                                    TaskXMLDoc.LoadXml(str_InputXML);
                                }
                                else
                                {
                                    ViewState["ComponentFacetSeriesFor_Task"] = "No"; ;
                                }
                            }
                            else
                            {
                                //Redirect to error page.
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                if (!IsPostBack)
                                {
                                    Response.Redirect(ErrorPageURL, true);
                                }
                                else
                                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                    }
                    else
                    {
                        str_InputXML = TaskXMLDoc.OuterXml;
                        ErrorXML = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "WORKFLOWPROCESS", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            TaskXMLDoc.LoadXml(str_InputXML);
                        }
                        else
                        {
                            //Redirect to error page.
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }

                    //Radha: For setting component series action bar depends upon the component user status.
                    if ((!String.IsNullOrEmpty(str_ComponentUserStatus)))
                    {
                        ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                    }
                    return ErrorXML; 
                }
                catch (ThreadAbortException)
                { return ErrorXML; }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_ROAssignmentTask.aspx", "GetComponentFacetForTask", ExceptionObj, null, null);
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackURL(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXML;
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To update the deliverable component facet</Purpose>
            /// </summary>
            /// <param name="SaveTaskXML"></param>
            /// <param name="str_ActionBarXML"></param>
            /// <returns></returns>
            private ERRORXML UpdateDeliverableComponentForTask(ref String SaveTaskXML, String str_ActionBarXML, Hashtable obj_SelectComponentIDs, String str_ComponentFacetName, String str_ComponentFacetPK)
            {
                ERRORXML      ErrorXMLString                = null; 
                MWB_Component MWB_ComponentObj              = null; 
                String        str_DeliverableProcessId      = null; 
                String        str_ComponentFacetRShipName   = null;
                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        
                        ErrorXMLString = MWB_ComponentObj.RemoveAndUpdateComponentFacet(str_DeliverableProcessId, str_ComponentFacetRShipName, "WORKFLOWPROCESS", ref SaveTaskXML, str_ActionBarXML, obj_SelectComponentIDs, str_ComponentFacetName, str_ComponentFacetPK,str_SelectedComponentsIDFileName);
                    }
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the Form Action bar</Purpose>
            /// </summary>
            /// <param name="ResponseForm"></param>
            /// <returns></returns>
            private String GetFormActionBarXML(Form TempForm)
            {
                String          str_ComponentFacetFieldName = null; 
     
                try
                {
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        str_ComponentFacetFieldName = ViewState["ComponentFacetFieldName"].ToString();

                        return TempForm.GetSeriesActionBar(str_ComponentFacetFieldName); 
                    }
                    else
                    {
                        return null; 
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>5 Feb 09</CreatedOn>
            /// <Author>Mugdha Moolay</Author>
            /// <Purpose>This method clears the drop down list if a resource type is deleted using the Remove Button. 
            ///  This function also updates the State XML used by the Select Resource Type pop-up</Purpose>
            /// </alsummary>
            /// <param name="ActivityID">The StepID for which resource is selected</param>
            /// <param name="str_FormID">The Dynamic Form ID</param>
            private void UpdateContributorDropDownList(String ActivityID,String str_FormID)
            {
                XML         ItemList            = null;
                MWB_Helper  obj_MWBHelper       = null;
                try
                {
                    ItemList = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                    setStepFormInputXMLForGroup(ActivityID, str_FormID, ItemList);
                    // Update the Resource File Name for the Activity
                    obj_MWBHelper = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_MWBHelper.UpdateStateXMLForResourceType(StepResourceFileName, ActivityID);
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>03 April 2009</CreatedOn>
            /// <Purpose>To download digital assets.</Purpose>
            /// </summary>
            private void getDigitalAssetsFromFacetIDs(String str_DownloadFor, String str_ActivityID)
            {
                String          selectedFacetIDs    = null;
                MWB_Component   objComponentFacade  = null;
                String          SearchOutputXML     = null;
                String          ErrorXML            = null;
                String          ErrorPageURL        = null;
                String          str_BatchDownloadAssetsFile  = null;
                String          str_ComponentSearchForm      = null;
                String          str_AlertMessage             = null;
                String          str_BatchDownloadURL         = null;

                try
                {
                    objComponentFacade      = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "TASK"))
                    {
                        selectedFacetIDs            = Frm_TaskDetails.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                        str_BatchDownloadAssetsFile = TaskID + "_BatchDownloadAssetsXml";
                    }
                    else if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "STEP"))
                    {
                        selectedFacetIDs            = TempStepForm.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                        str_BatchDownloadAssetsFile = str_ActivityID + "_BatchDownloadAssetsXml";
                    }


                    if (!String.IsNullOrEmpty(selectedFacetIDs))
                    {
                        if ((ViewState["ComponentFacetPrimaryKey"] != null) && (ViewState["ComponentAssetRShipName"] != null) && (ViewState["ParentDeliverableID"] != null))
                        {
                            objComponentFacade.SolutionName = SolutionName;
                            ErrorXML = objComponentFacade.GetComponentSearchFormName(ViewState["ParentDeliverableID"].ToString(), out str_ComponentSearchForm);

                            if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_ComponentSearchForm)))
                            {
                                ErrorXML = objComponentFacade.GetBatchDownloadDetails(selectedFacetIDs, ViewState["ComponentFacetPrimaryKey"].ToString(), ViewState["ComponentAssetRShipName"].ToString(), ref SearchOutputXML, str_ComponentSearchForm, str_BatchDownloadAssetsFile, out str_AlertMessage, out str_BatchDownloadURL);
                                if (String.IsNullOrEmpty(ErrorXML))
                                {
                                    if (!String.IsNullOrEmpty(str_AlertMessage))
                                        Ajax.WriteExecuteJavaScript("ShowAlert('" + str_AlertMessage + "');");
                                    else if (!String.IsNullOrEmpty(str_BatchDownloadURL))
                                        Ajax.WriteExecuteJavaScript("window.open('" + str_BatchDownloadURL + "','_new','left=120,top=120,width=1085,height=800,resizable=yes,scrollbars=yes');");
                                }
                            }
                        }
                        else
                        {
                            ErrorXML = "<ERROR><MESSAGE>" + Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_BatchUploadDigitalAssets_COMPOENTDIGITALASSETRELATIONNOTFOUND") + "</MESSAGE></ERROR>";
                        }
                        if (!String.IsNullOrEmpty(ErrorXML))// Redirect to Error
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ErrorXML, null, GetBackURL(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    if (str_DownloadFor.ToUpper() == "TASK")
                    {
                        Frm_TaskDetails.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }
                    else if (str_DownloadFor.ToUpper() == "STEP")
                    {
                        TempStepForm.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>14 April 2009</CreatedOn>
            /// <Purpose>To get the edit page url </Purpose>
            /// </summary>
            /// <param name="str_Source">It indicates Task Or Activity</param>
            /// <param name="str_ActivityID">Activity id</param>
            private void GetEditPageUrl(String str_ActivityID)
            {
                MWB_Component       MWB_ComponentObj        = null;
                String              ErrorXML                = null;
                String              str_AlertMsg            = null;
                StringBuilder       sb_Parameters           = null;
                String              EditPageUrl             = null;
                String              str_SelectedFormName    = null;                
                XPathDocument       xp_TaskDoc              = null;
                String              TempPath                = null;
                XPathNavigator      nav_ActivityInfoNode    = null;
                String              str_ActivityDefID       = null;
                String              str_FormName            = null;
                String              str_FormConfigXMLPath   = null;
                MWB_Helper          MWB_HelperObj           = null;
                try
                {
                    MWB_ComponentObj        = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    sb_Parameters           = new StringBuilder(400);
                    TempPath                = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile;
                    xp_TaskDoc              = new XPathDocument(TempPath);
                    nav_ActivityInfoNode    = xp_TaskDoc.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + str_ActivityID + "']/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                    if (nav_ActivityInfoNode != null)
                    {
                        str_ActivityDefID       = nav_ActivityInfoNode.Value;
                        str_FormName            = str_ActivityDefID + "_Editable";
                        str_FormConfigXMLPath   = MWB_HelperObj.GetFormConfigXMLPath("StepDetails_Editable", str_FormName, out str_SelectedFormName);
                    }
                    
                    if ((ViewState["ComponentFacetFieldName"] != null) && (ViewState["ParentDeliverableID"] != null) && (!String.IsNullOrEmpty(str_SelectedFormName)))
                    {
                        EditPageUrl = TempStepForm.GetSeriesEditRecordsUrl(ViewState["ComponentFacetFieldName"].ToString());
                                                              
                        sb_Parameters.Append("&DeliverableID="      + ViewState["ParentDeliverableID"].ToString()
                                               + "&TaskID="         + TaskID
                                               + "&ActivityID="     + str_ActivityID
                                               + "&CFRelionship="   + ViewState["ComponentFacetSeriesRShipName"].ToString()
                                               + "&FormName="       + str_SelectedFormName
                                               + "&ComponentFacetSeriesPrimaryKey=" + ViewState["ComponentFacetPrimaryKey"].ToString()
                                               + "&Source=ACTIVITY");

                        if (ViewState["ComponentAssetRShipName"] != null)
                        {
                            sb_Parameters.Append("&ComponentDigitalAssetRelationship=" + ViewState["ComponentAssetRShipName"].ToString());
                        }

                        ErrorXML = MWB_ComponentObj.GetComponentSystemStatus(ViewState["ParentDeliverableID"].ToString(), ref EditPageUrl, sb_Parameters.ToString(), out str_AlertMsg);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            if (!String.IsNullOrEmpty(str_AlertMsg))
                            {
                                Ajax.WriteExecuteJavaScript("alert('" + str_AlertMsg + "');");
                            }
                            else if (!String.IsNullOrEmpty(EditPageUrl))
                            {
                                Ajax.WriteExecuteJavaScript(EditPageUrl);
                            }
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <summary>
            /// <Author>Anita Kale</Author>
            /// <CreatedOn>18th May 2009</CreatedOn>
            /// <Purpose>sets project info form related to the task</Purpose>
            /// </summary>
            private void setProjectInfo()
            {
                FormFacade          formfacade_Project          = null;
                MWB_Helper          MWBHelperObj                = null;
                String              str_FormConfigXMLPath       = null;
                String              str_FormInputXML            = null;
                String              str_TempProjectInfofile     = null;
                ERRORXML            errorxml_Output             = null;
                
                try
                {
                    formfacade_Project                      = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    formfacade_Project.ShowConfiguredFields = true;
                    formfacade_Project.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.XMLPath.ToString();
                    str_TempProjectInfofile                 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID)+ TaskID + str_ProjectInfoTempFileName;
                    if (File.Exists(str_TempProjectInfofile) && ViewState["ProjectInfoFormConfigPath"]!=null)
                    {
                        str_FormConfigXMLPath   = ViewState["ProjectInfoFormConfigPath"].ToString();

                        //Form Input Xml type path
                        Frm_ROProjectDetails.InputXMLType  = Assetlink.CustomControls.Form.InputType.XMLPath;
                        Frm_ROProjectDetails.InputXML      = str_TempProjectInfofile;
                    }
                    else
                    {
                        MWBHelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        errorxml_Output = MWBHelperObj.GetProjectInfo(formfacade_Project, TaskID, "Task", ref str_FormConfigXMLPath, ref str_FormInputXML);

                        if (String.IsNullOrEmpty(errorxml_Output) && !String.IsNullOrEmpty(str_FormInputXML))
                        {
                            //Form Input Xml type InnerXML
                            Frm_ROProjectDetails.InputXMLType   = Assetlink.CustomControls.Form.InputType.InnerXML;
                            Frm_ROProjectDetails.InputXML       = str_FormInputXML;
                        }
                        else
                        {
                            //Redirect to error page
                            gotoErrorPage(Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_MWB_failedToGetProjectInfoForTask_Shared"));
                        }
                        this.ViewState["ProjectInfoFormConfigPath"] = str_FormConfigXMLPath;
                        if(!String.IsNullOrEmpty(str_TempProjectInfofile))
                            File.WriteAllText(str_TempProjectInfofile, str_FormInputXML);
                    }
                    
                    if (!String.IsNullOrEmpty(str_FormConfigXMLPath))
                    {
                        Frm_ROProjectDetails.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.XMLPath;
                        Frm_ROProjectDetails.ConfigurationXML       = str_FormConfigXMLPath;
                    }
                    else
                    {
                        //Redirect to error page
                        gotoErrorPage(Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_MWB_failedToGetProjectInfoFormConfigPath_Shared"));
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            /// <summary>
            /// <createddate>25 May 2009</createddate>
            /// <author>Jisha Rajendran</author>
            /// </summary>
            /// <param name="UsersNode">UserCollection Xml</param>
            /// <param name="GroupNode">Group Collection XML</param>
            /// <Purpose>This method prepares the User/group data xml and populates in the User/group list</Purpose>
            private void populateUserGroupList(XML UserDataXML, XML GroupDataXML)
            {
                MWB_Helper          MWB_HelperObj           = null;
                XML                 xml_List                = null;
                ListFacade          facade_ListControl      = null;
                XML                 xml_ListConfig          = null;                
                XPathDocument       xp_UserGroupColl        = null;
                XPathExpression     xpExp_UserGroup         = null;
                StringBuilder       sb_UserGroupColl        = null;
                XPathNodeIterator   nodeIter_RootNode       = null;
                XML                 xml_ExistingUserGroup   = null;                

                MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                //Prepare the User list xml
                if (!String.IsNullOrEmpty(UserDataXML))
                    MWB_HelperObj.AddUsersToUserGroupsListXML("<UserSelectionXML><SelectedUsersList>" + UserDataXML + "</SelectedUsersList></UserSelectionXML>",
                        ref xml_ExistingUserGroup);

                //Prepare the Group list xml
                if (!String.IsNullOrEmpty(GroupDataXML))
                    MWB_HelperObj.AddGroupsToUserGroupsListXML("<GroupSelectionXML><SelectedGroupsList>" + GroupDataXML + "</SelectedGroupsList></GroupSelectionXML>",
                                        ref xml_ExistingUserGroup);
                //Sort the data
                sb_UserGroupColl = new StringBuilder(200);
                sb_UserGroupColl.Append(@"<SEARCHOUTPUTXML><USERGROUPCOLLECTION>");
                if (!String.IsNullOrEmpty(xml_ExistingUserGroup))
                {
                    xp_UserGroupColl    = new XPathDocument(new StringReader(xml_ExistingUserGroup));
                    xpExp_UserGroup     = XPathExpression.Compile("USERGROUPCOLLECTION/USERGROUP");
                    xpExp_UserGroup.AddSort("USER_GROUP", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    xpExp_UserGroup.AddSort("USER_GROUP_NAME", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    nodeIter_RootNode   = xp_UserGroupColl.CreateNavigator().Select(xpExp_UserGroup);
                    foreach (XPathNavigator xpnav_UserGroup in nodeIter_RootNode)
                    {
                         sb_UserGroupColl.Append(xpnav_UserGroup.OuterXml);
                    }
                }
                sb_UserGroupColl.Append(@"</USERGROUPCOLLECTION></SEARCHOUTPUTXML>");

                facade_ListControl  = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                xml_ListConfig      = facade_ListControl.GetConfigurationXML(SolutionName, null, "UserGroupsForNotifications_RO");
                facade_ListControl.PrepareListXml(xml_ListConfig, sb_UserGroupColl.ToString(), out xml_List);
                Lst_UserGroup.Source = xml_List;
            }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>17th June 2009</CreatedOn>
            /// <Purpose>To save the step form details whenever contributor gets changed</Purpose>
            /// </summary>
            /// <param name="StepID">The StepID for which data gets saved.</param>
            /// <param name="TempStepForm">Step Form</param>
            private ERRORXML SaveStepForm(String StepID, Form TempStepForm)
            {
                FormFacade                  FormFacadeObj           = null;
                String                      StepXML                 = null;
                String                      ErrorXML                = null;
                MWB_Component               MWB_ComponentObj        = null;
                String                      str_FormConfigXML       = null;
                String                      str_FormActionBarXML    = null;
                String                      str_ComponentRShip      = null;
                String                      str_ActivityAssociatedFacets    = null;
                String                      str_SelectedFormName            = null;
                try
                {
                    FormFacadeObj           = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_ComponentObj        = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                        
                    MWB_ComponentObj.GetSelectedFormNameAndConfigForStep(StepID, TaskFile,false, out str_SelectedFormName, out str_FormConfigXML);

                    if ((!String.IsNullOrEmpty(str_SelectedFormName)) && (TempStepForm != null))
                    {
                        FormFacadeObj.FormName              = str_SelectedFormName;
                        FormFacadeObj.SolutionName          = SolutionName;
                        FormFacadeObj.ConfigurationXMLType  = "InnerXML";
                        FormFacadeObj.ConfigurationXML      = str_FormConfigXML;
                        StepObjInfoList                     = (List<ObjectInfo>)ViewState["StepObjectList" + StepID];

                        ErrorXML                    = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", TempStepForm, StepObjInfoList, out StepXML);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(StepXML)))
                        {
                            if ((ViewState["Duration_" + StepID + ""] != null) && (TempStepForm.GetValues("Duration") != ViewState["Duration_" + StepID + ""].ToString()))
                            {
                                ViewState["Duration_" + StepID + ""] = TempStepForm.GetValues("Duration");
                            }

                            if (ViewState["ComponentFacetSeriesRShipName"] != null)
                            {
                                str_ComponentRShip   = ViewState["ComponentFacetSeriesRShipName"].ToString();
                                str_FormActionBarXML = GetFormActionBarXML(TempStepForm);
                            }
                            if (ViewState["ActivityAssociatedFacets"] != null)
                            {
                                str_ActivityAssociatedFacets = ViewState["ActivityAssociatedFacets"].ToString();
                            }
                            ErrorXML = MWB_ComponentObj.RemoveAndUpdateComponentFacetForStepForm(StepID, ViewState["ParentDeliverableID"].ToString(), str_ComponentRShip, StepObjInfoList, str_FormActionBarXML, str_FormConfigXML, str_SelectedComponentsIDFileName, str_ActivityAssociatedFacets, ref StepXML);
                            if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(StepXML)))
                            {
                                CreateNewStepForm_ComponentList(StepID, StepXML, str_FormConfigXML, str_SelectedFormName, true);
                            }
                        }
                    }
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the GatherInfo Task Details</Purpose>
            /// </alsummary>
            /// <param name="str_ReturnTaskXML"></param>
            /// <param name="str_ActivityAssociatedFacets"></param>
            /// <returns></returns>
            private ERRORXML GetGatherInfoTask(out String str_ReturnTaskXML)
            {
                StringBuilder       sb_SearchInputXML           = null;
                MWB_Helper          MWB_HelperObj               = null;
                ERRORXML            ErrorXMLString              = null;
                String              str_ProcessAssociatedFacets = null;
                SearchConfiguration SearchConfigObj             = null; 
                String              stdFormName                 = null;
                String              dynamicFormName             = null;
                String              str_SelectedFormName        = null;
                FormFacade          FormFacadeObj               = null;
                String              FormConfigXMLPath           = null;
                String              RelEntityList               = null;
                Hashtable           ActDefList                  = null;
                XDocument           xDocTask                    = null;
                XElement            xEleTask                    = null;
                IEnumerable<XElement> iEnumAct                  = null;
                
                try
                {
                    str_ReturnTaskXML            = null;
                    //str_ActivityAssociatedFacets = null; 
                    ActDefList          = new Hashtable();
                    sb_SearchInputXML   = new StringBuilder(250);
                    MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    stdFormName         = "Task_Details";
                    if ((!String.IsNullOrEmpty(__PackageDefinitionID.Value)) && (!String.IsNullOrEmpty(__ProcessDefinitionID.Value)))
                    {
                        //ErrorXMLString = MWB_HelperObj.GetAssociatedAdditionalFacets(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, null, true, out str_ProcessAssociatedFacets, out str_ActivityAssociatedFacets);
                        //ErrorXMLString = MWB_HelperObj.GetActivityDefintionIDList(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, out ActDefList);

                        dynamicFormName = __ProcessDefinitionID.Value + "_" + stdFormName;
                        FormFacadeObj.SolutionName = SolutionName;

                        FormConfigXMLPath               = MWB_HelperObj.GetFormConfigXMLPath(stdFormName, dynamicFormName, out str_SelectedFormName);
                        FormFacadeObj.FormName          = str_SelectedFormName;
                        FormFacadeObj.ConfigurationXML  = FormConfigXMLPath;

                        ErrorXMLString = FormFacadeObj.GetRelatedObjectList(out str_ProcessAssociatedFacets, out RelEntityList);
                        

                        if (!String.IsNullOrEmpty(ErrorXMLString))
                        {
                            return ErrorXMLString;
                        }
                        if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                        {
                            String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                            for (int Index = 0; Index < Arr_Facets.Length; Index++)
                            {
                                ViewState["ProcessAssociatedFacets"] += "<" + Arr_Facets[Index] + " Type='RELATION' GetAllFacets='FALSE'/>";
                            }
                        //    ViewState["ProcessAssociatedFacets"] = str_ProcessAssociatedFacets;
                        //    MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ProcessAssociatedFacets);
                        }

                        //if (!String.IsNullOrEmpty(str_ActivityAssociatedFacets))
                        //{
                        //    str_ActivityAssociatedFacets = str_ActivityAssociatedFacets.Replace("<ACTIVITY_WEBSERVICE Type='RELATION' />", "");
                        //    ViewState["ActivityAssociatedFacets"] = str_ActivityAssociatedFacets;
                        //    MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ActivityAssociatedFacets);
                        //}
                    }

                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                            if (String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                            {
                                sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                            }
                            else
                            {
                                sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                            }
                                 sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
	                                                        </FILTERLIST>   
                                                            <RELATIONSHIP NAME='PROCESS_ASSETREFERENCES'>
                                                                <SELECTLIST>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>DIGITALASSETID</FIELDNAME>
				                                                        </EXPRESSION>
			                                                        </SELECTLIST>
                                                             </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='PREVIOUS_WORKFLOW'>
                                                                <SELECTLIST>
	                                                                <EXPRESSION>
		                                                                <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
		                                                                <ALIAS>WORKFLOWPROCESSID</ALIAS>
	                                                                </EXPRESSION>                                                                                                                                         
                                                                </SELECTLIST>
                                                            </RELATIONSHIP>     
                                                            <RELATIONSHIP NAME='TASKINITIATOR'>
                                                                    <SELECTLIST>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>USERID</FIELDNAME>
			                                                                <ALIAS>USERID</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
			                                                                <ALIAS>LOGINNAME</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
			                                                                <ALIAS>FIRSTNAME</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
			                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>LASTNAME</FIELDNAME>
			                                                                <ALIAS>LASTNAME</ALIAS>
		                                                                </EXPRESSION>                                                                    
	                                                                </SELECTLIST>
                                                                </RELATIONSHIP>                                          
                                                            <RELATIONSHIP NAME='DELIVERABLE_TASK' HIERARCHY='BOTTOMUP'>
                                                                <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>PROCESSNAME</FIELDNAME>
				                                                        <ALIAS>PROCESSNAME</ALIAS>
			                                                        </EXPRESSION>                                                                    
		                                                        </SELECTLIST>
                                                                <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
                                                                    <SELECTLIST>
			                                                            <EXPRESSION>
				                                                            <FIELDNAME>PROCESSNAME</FIELDNAME>
				                                                            <ALIAS>PROCESSNAME</ALIAS>
			                                                            </EXPRESSION>                                                                    
		                                                            </SELECTLIST>
                                                                    <RELATIONSHIP NAME='PROJECTMANAGER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>USERID</FIELDNAME>
				                                                                <ALIAS>USERID</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                    <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>USERID</FIELDNAME>
				                                                                <ALIAS>USERID</ALIAS>
			                                                                </EXPRESSION>      
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION>                                                                                                                                    
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                    <RELATIONSHIP NAME='READERS'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>USERID</FIELDNAME>
				                                                                <ALIAS>USERID</ALIAS>
			                                                                </EXPRESSION>                                                                                                                                         
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                </RELATIONSHIP>
                                                                <RELATIONSHIP NAME='DELIVERABLEMANAGER'>
                                                                    <SELECTLIST>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>USERID</FIELDNAME>
			                                                                <ALIAS>USERID</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
			                                                                <ALIAS>LOGINNAME</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
			                                                                <ALIAS>FIRSTNAME</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
			                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>LASTNAME</FIELDNAME>
			                                                                <ALIAS>LASTNAME</ALIAS>
		                                                                </EXPRESSION>                                                                    
	                                                                </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                                                <SELECTLIST>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>ACTIVITYID</FIELDNAME>
                                                                            <ALIAS>ACTIVITYID</ALIAS>
				                                                        </EXPRESSION>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>STATUS</FIELDNAME>
                                                                            <ALIAS>STATUS</ALIAS>
				                                                        </EXPRESSION>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>STARTACTIVITY</FIELDNAME>
                                                                            <ALIAS>STARTACTIVITY</ALIAS>
				                                                        </EXPRESSION>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>ENDACTIVITY</FIELDNAME>
                                                                            <ALIAS>ENDACTIVITY</ALIAS>
				                                                        </EXPRESSION>
			                                                        </SELECTLIST>
                                                                    <RELATIONSHIP NAME='ACTIVITY_INFORMATION'>
                                                                        <SELECTLIST>
				                                                                <EXPRESSION>
					                                                                <FIELDNAME>ACTIVITYINFORMATIONID</FIELDNAME>
                                                                                    <ALIAS>ACTIVITYINFORMATIONID</ALIAS>
				                                                                </EXPRESSION>
				                                                                <EXPRESSION>
					                                                                <FIELDNAME>ACTIVITYDEFINITIONID</FIELDNAME>
                                                                                    <ALIAS>ACTIVITYDEFINITIONID</ALIAS>
				                                                                </EXPRESSION>
			                                                                </SELECTLIST>
                                                                     </RELATIONSHIP>
                                                             </RELATIONSHIP>");
                    if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                    {
                        //sb_SearchInputXML.Append(str_ProcessAssociatedFacets);   
                        String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                        for (int Index = 0; Index < Arr_Facets.Length; Index++)
                        {
                            sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                        }
                    }

                    sb_SearchInputXML.Append(@"</TARGETENTITY>
                                            </SEARCH>");  
                    
				    ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskXML); 
                    if (ErrorXMLString == null)
                    {
                        xDocTask = XDocument.Parse(str_ReturnTaskXML);
                        xEleTask = xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS");
                        iEnumAct = xEleTask.XPathSelectElements("PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY='False' and ENDACTIVITY='False']");
                        foreach (XElement xEleAct in iEnumAct)
                        {
                            ActDefList.Add(xEleAct.Element("ACTIVITYID").Value, xEleAct.Element("STATUS").Value + "$AL$" + xEleAct.Element("ACTIVITY_INFORMATION").Element("ACTIVITYINFORMATION").Element("ACTIVITYDEFINITIONID").Value);
                        }
                        xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS").Element("PROCESS_ACTIVITY").Remove();
                        str_ReturnTaskXML = xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS").CreateNavigator().InnerXml;
                        ViewState["ActivityDefList"] = ActDefList; 
                    }
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the GatherInfo Task Activities Details</Purpose>
            /// </alsummary>
            /// <param name="str_ActivityAssociatedFacets"></param> 
            /// <param name="str_ReturnTaskActivitesXML"></param> 
            /// <returns></returns>
            private ERRORXML GetGatherInfoTaskActivities(out String str_ReturnTaskActivitesXML)
            {
                StringBuilder       sb_SearchInputXML           = null;
                ERRORXML            ErrorXMLString              = null;
                SearchConfiguration SearchConfigObj             = null; 
                MWB_Helper          MwbHelperObj                = null;                
                PMFacadeClass       PMFacadeObj                 = null;
                XML                 ProcessDefXML               = null;
                XDocument           xDocProcessDef              = null;
                try
                {
                    str_ReturnTaskActivitesXML  = null; 
                    sb_SearchInputXML   = new StringBuilder(250);
                    SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MwbHelperObj        = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXMLString = PMFacadeObj.GetProcessDefinitionByID(PackageDefinitionID, ProcessDefinitionID, out ProcessDefXML);

                    if (ErrorXMLString != null)
                        return ErrorXMLString;

                    Hashtable ActDefList = (Hashtable)ViewState["ActivityDefList"];
                    xDocProcessDef = XDocument.Parse(ProcessDefXML);

                    XElement xEleProcessDef = xDocProcessDef.Element("WORKFLOWPROCESS");
                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>ACTIVITY</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                                if (ActDefList == null)
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                                }
                                else
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                                }
                                 sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
                                                                    <RELATIONSHIPNAME>PROCESS_ACTIVITY</RELATIONSHIPNAME>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>			                                                
	                                                        </FILTERLIST>									
                                                            <RELATIONSHIP NAME='ACTIVITY_RESPONSE'>
                                                                <RELATIONSHIP NAME='POSTEDBY'>
                                                                    <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='ACTIVITY_RESOURCE'> 
                                                                <SELECTLIST>
	                                                                <EXPRESSION>
		                                                                <FIELDNAME>RESOURCEID</FIELDNAME>
		                                                                <ALIAS>RESOURCEID</ALIAS>
	                                                                </EXPRESSION>
                                                                    <EXPRESSION>
		                                                                <FIELDNAME>RESOURCETYPE</FIELDNAME>
		                                                                <ALIAS>RESOURCETYPE</ALIAS>
	                                                                </EXPRESSION>     
                                                                    <EXPRESSION>
		                                                                <FIELDNAME>RESOURCECOUNT</FIELDNAME>
		                                                                <ALIAS>RESOURCECOUNT</ALIAS>
	                                                                </EXPRESSION>
                                                                    <EXPRESSION>
		                                                                <FIELDNAME>USERASSIGNED</FIELDNAME>
		                                                                <ALIAS>USERASSIGNED</ALIAS>
	                                                                </EXPRESSION>                                                                                                                                      
                                                                </SELECTLIST>                                                           
                                                                <RELATIONSHIP NAME='ACTUAL_RESOURCE'>      
                                                                    <SELECTLIST>
	                                                                    <EXPRESSION>
		                                                                    <FIELDNAME>RESOURCEID</FIELDNAME>
		                                                                    <ALIAS>RESOURCEID</ALIAS>
	                                                                    </EXPRESSION>
                                                                        <EXPRESSION>
		                                                                    <FIELDNAME>RESOURCETYPE</FIELDNAME>
		                                                                    <ALIAS>RESOURCETYPE</ALIAS>
	                                                                    </EXPRESSION>                                                                                                                                                                                                               
                                                                    </SELECTLIST>                                                                 
                                                                    <RELATIONSHIP NAME='RESOURCE_USER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>");

                    FormFacade FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                     IDictionaryEnumerator iDicEnumAct = ActDefList.GetEnumerator();
                     while(iDicEnumAct.MoveNext())                                 
                     {
                         String ActObjVal           = iDicEnumAct.Value.ToString();
                         String[] Status_DefIDArr   = ActObjVal.Split(strSeparator,StringSplitOptions.RemoveEmptyEntries);
                         String ActStatus           = Status_DefIDArr[0];
                         String ActDefID            = Status_DefIDArr[1];

                         String str_StdFormName     = null;
                         String str_DynamicFormName = null;
                         String SelectedFormName    = null;
                         String relatedEntityList   = null;
                         String ActRelatedFacets    = null;

                         FormFacadeObj.SolutionName = SolutionName;
                         if ((Access.ToUpper() == "READ") || (Mode.ToUpper() == "PERFORM"))
                         {
                             str_StdFormName     = "StepDetails_ROResponse";
                             str_DynamicFormName = ActDefID + "_Response";
                         }
                         else if (Mode.ToUpper() == "MANAGE")
                         {
                             switch (ActStatus.ToUpper())
                             {
                                 case "NEW":
                                 case "DRAFT":
                                 case "ACTIVE":
                                     str_StdFormName     = "StepDetails_Editable";
                                     str_DynamicFormName = ActDefID + "_Editable";

                                     break;
                                 default:
                                     str_StdFormName     = "StepDetails_ROResponse";
                                     str_DynamicFormName = ActDefID + "_Response";
                                     break;
                             }
                         }


                         String FormConfigXMLPath       = MwbHelperObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out SelectedFormName);
                         FormFacadeObj.ConfigurationXML = FormConfigXMLPath;
                         FormFacadeObj.FormName         = SelectedFormName;
                         ERRORXML ErrorXml              = FormFacadeObj.GetRelatedObjectList(out ActRelatedFacets, out relatedEntityList);
                         ActRelatedFacets               = MwbHelperObj.GetActivityAssociatedFacets(xEleProcessDef, ActDefID, ActRelatedFacets);
                         String[] Arr_Facets            = ActRelatedFacets.Split(';');

                         for (int Index = 0; Index < Arr_Facets.Length; Index++)
                         {
                             if (!String.IsNullOrEmpty(Arr_Facets[Index]))
                             {
                                 if (!sb_SearchInputXML.ToString().Contains(Arr_Facets[Index]))
                                 {
                                     sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                                 }
                             }
                         }
                     }
                    //if (ActDefList!= null)
                    //{
                    //    //sb_SearchInputXML.Append(str_ActivityAssociatedFacets);   
                    //    foreach (String ActDefID in ActDefList)
                    //    {
                    //        FormFacade FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    //        String     str_StdFormName     = null;
                    //        String     str_DynamicFormName = null;
                    //        String     SelectedFormName    = null;
                    //        String     relatedEntityList   = null;
                    //        String     ActRelatedFacets    = null;
                    //        FormFacadeObj.SolutionName     = SolutionName;
                    //        str_StdFormName = "StepDetails_Editable";

                    //        str_DynamicFormName             = ActDefID + "_Editable" ;
                    //        String FormConfigXMLPath        = MwbHelperObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out SelectedFormName);
                    //        FormFacadeObj.ConfigurationXML  = FormConfigXMLPath;
                    //        FormFacadeObj.FormName          = SelectedFormName;
                    //        ERRORXML ErrorXml               = FormFacadeObj.GetRelatedObjectList(out ActRelatedFacets,out relatedEntityList);
                    //        ActRelatedFacets                = MwbHelperObj.GetActivityAssociatedFacets(xEleProcessDef, ActDefID, ActRelatedFacets);
                    //        String[] Arr_Facets             = ActRelatedFacets.Split(';');
                    //        for (int Index = 0; Index < Arr_Facets.Length; Index++)
                    //        {
                    //            if (!sb_SearchInputXML.ToString().Contains(Arr_Facets[Index]))
                    //            {
                    //                str_ActivityAssociatedFacets += "<" + Arr_Facets[Index] + " Type='RELATION' />";
                    //                sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                    //            }
                    //        }
                    //    }
                    //    ViewState["ActivityAssociatedFacets"] = str_ActivityAssociatedFacets;
                    //}


                    sb_SearchInputXML.Append(@"</TARGETENTITY>
                                            </SEARCH>");

                    ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskActivitesXML);
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the merge Assignment Task and Task Activities</Purpose>
            /// </alsummary>
            /// <param name="ReturnTaskXML"></param> 
            /// <param name="str_ActivitiesXML"></param> 
            /// <param name="str_TaskXML"></param> 
            /// <returns></returns>
            private void MergeTaskActivities(String str_TaskXML, String str_ActivitiesXML, out String ReturnTaskXML)
            {
                //if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION>"))
                //{
                //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", "");
                //}
                //else if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                //{
                //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
                //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESS>", "<WORKFLOWPROCESS xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");
                //}
                //str_TaskXML = str_TaskXML.Replace("</WORKFLOWPROCESS>", "");
                //str_TaskXML = str_TaskXML.Replace("</WORKFLOWPROCESSCOLLECTION>", "");

                if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION>"))
                {
                    str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION>", "<PROCESS_ACTIVITY>");
                }
                else if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                {
                    str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "<PROCESS_ACTIVITY>");
                }
                str_ActivitiesXML = str_ActivitiesXML.Replace("</ACTIVITYCOLLECTION>", "</PROCESS_ACTIVITY>");

                str_TaskXML = "<WORKFLOWPROCESS>" + str_TaskXML + str_ActivitiesXML + "</WORKFLOWPROCESS>";

                ReturnTaskXML = str_TaskXML;
            }

            private void UpdateTaskSteps()
            {
                
                String          str_TaskActivities  = null;
                StringBuilder   TempPath            = null;
                MWB_Helper      MWB_HelperObj       = null;
                XmlDocument     Task_Doc            = null;
                XmlNodeList     ActNodeList         = null;
                String          ActivityStatus      = null;
                XmlNode         ProcessActivityNode = null;
                XPathExpression   xp_SortExpression = null;
                XPathNodeIterator xp_SortNodeIter   = null;
                XML               str_SortXML       = null;
                
                try
                {
                    TempPath            = new StringBuilder(100);
                    MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    
                    //MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ActivityFacets);
                    GetGatherInfoTaskActivities( out str_TaskActivities);

                    if (str_TaskActivities.Contains("<ACTIVITYCOLLECTION>"))
                    {
                        str_TaskActivities = str_TaskActivities.Replace("<ACTIVITYCOLLECTION>", "");
                    }
                    else if (str_TaskActivities.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                    {
                        str_TaskActivities = str_TaskActivities.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
                    }
                    str_TaskActivities = str_TaskActivities.Replace("</ACTIVITYCOLLECTION>", "");

                    TempPath.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), TaskFile);
                    Task_Doc = new XmlDocument();
                    Task_Doc.Load(TempPath.ToString());
                    ProcessActivityNode = Task_Doc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                    ProcessActivityNode.InnerXml = str_TaskActivities;

                    xp_SortExpression = XPathExpression.Compile("ACTIVITY");
                    xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                    xp_SortNodeIter = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                    while (xp_SortNodeIter.MoveNext())
                    {
                        str_SortXML += xp_SortNodeIter.Current.OuterXml;
                    }
                    ProcessActivityNode.InnerXml = str_SortXML;

                    File.WriteAllText(TempPath.ToString(), Task_Doc.OuterXml);
                    
                    ActNodeList         = Task_Doc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[(translate(STARTACTIVITY,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 'FALSE') and (translate(ENDACTIVITY,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 'FALSE')]");                
                    foreach (XmlNode ActNode in ActNodeList)
                    {
                        ActivityStatus = ActNode.SelectSingleNode("STATUS").InnerText;

                        switch (ActivityStatus.ToUpper())
                        {
                            case "NEW":
                            case "ACTIVE":
                            case "DRAFT":
                                setStepForm(ActNode);
                                break;
                            case "CANCELLED":
                            case "COMPLETED":
                                setROResponseForm(ActNode);
                                break;
                        }
                    }                  
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

            /// <summary>
            /// <Purpose>Set notifiy in advance check box value and value for no. of days for prior notification</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <param name="str_TaskXML">Task's details</param>
            private void SetAdvanceReminderValues(String str_TaskXML)
            {
                XElement xElt_TaskData          = null;
                XElement xElt_workflowProcess   = null;
                XElement xElt_value             = null;

                xElt_TaskData           = XElement.Load(XmlReader.Create(new StringReader(str_TaskXML)));
                xElt_workflowProcess = xElt_TaskData.XPathSelectElement("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
                if (xElt_workflowProcess != null)
                {
                    //Set check box condition
                    xElt_value = xElt_workflowProcess.Element("NOTIFYINADVANCE");
                    if (xElt_value != null)
                    {
                        if (xElt_value.Value == "1")

                        {
                            checkBoxObj.Checked = true;
                        }
                        else
                        {
                            checkBoxObj.Checked = false;
                        }
                    }
                    checkBoxObj.Enabled = false;

                    //Set text box value for no. of days for prior notification                
                    xElt_value = xElt_workflowProcess.Element("NOTIFYNOOFDAYS");
                    if (xElt_value != null)
                    {
                        if (!String.IsNullOrEmpty(xElt_value.Value))
                        {
                            textBoxObj.Text = xElt_value.Value;
                        }
                        else
                        {
                            textBoxObj.Text = "1";
                        }
                    }                    
                    textBoxObj.Enabled  = false;                
                }
            }

            /// <summary>
            /// This method updates the PostedBy user name and the email id
            /// </summary>
            /// <param name="FieldName"></param>
            /// <param name="ActivityNode">Activity details</param>
            /// <param name="FormXMLDoc">Form Input Xml</param>
            private void updateFormFields(String FieldName, XmlNode ActivityNode, ref XmlDocument FormXMLDoc)
            {
                XmlNode     xmlnode_Field   = null;
                XmlNode     xmlnode_Value   = null;
                String      str_Username    = null;

                switch (FieldName)
                {
                    case "EmailID":
                        xmlnode_Field = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailID']");
                        if (xmlnode_Field != null)
                        {
                            XmlNode xmlnode_PC = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE/POSTEDBY/USER/EMAILID");
                            if (xmlnode_PC != null)
                            {
                                xmlnode_Value = xmlnode_Field.SelectSingleNode("Value");
                                if (xmlnode_Value == null)
                                    xmlnode_Value = FormXMLDoc.CreateElement("Value");
                                xmlnode_Value.InnerText = xmlnode_PC.InnerText;
                                xmlnode_Field.AppendChild(xmlnode_Value);
                            }
                        }
                        break;

                    case "PostedBy":
                        xmlnode_Field = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='PreviousContributor']");
                        if (xmlnode_Field != null)
                        {
                            XmlNode xmlnode_PC = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE/POSTEDBY/USER");
                            if (xmlnode_PC != null)
                            {
                                str_Username            = ALCommon.FormatUserName(xmlnode_PC.SelectSingleNode("FIRSTNAME").InnerText,
                                                                xmlnode_PC.SelectSingleNode("LASTNAME").InnerText, xmlnode_PC.SelectSingleNode("MIDDLEINITIAL").InnerText,
                                                                xmlnode_PC.SelectSingleNode("LOGINNAME").InnerText, ALCommon.GetUserNameFormat());
                                xmlnode_Value = xmlnode_Field.SelectSingleNode("Value");
                                if (xmlnode_Value == null)
                                    xmlnode_Value = FormXMLDoc.CreateElement("Value");
                                xmlnode_Value.InnerText = str_Username;
                                xmlnode_Field.AppendChild(xmlnode_Value);
                            }
                        }
                        break;
                }
            }

            private void getBaselineConfig()
            {
                String str_ShowBaseline = null;
                MktgWorkBenchFacadeClass MktgWorkBenchFacadeObj = null;
                MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MktgWorkBenchFacadeObj.ReadSolutionConfiguration(SolutionName, "CALCULATEANDSHOWBASELINE", out str_ShowBaseline);
                ViewState["ShowBaseline"] = str_ShowBaseline.ToUpper();
            }

            /// <alsummary>
            /// <createddate>04 April 2012</createddate>
            /// <author>Mr. Hemant Karkande</author>
            /// <purpose>Set the Task Readers User/Group list control.</purpose>
            /// </alsummary>
            private void setTaskReadersUserGroupList(XPathNavigator xpathNav_ProcessReadersGroup, XPathNavigator xpathNav_ProcessReadersUser)
            {
                ListFacade      obj_ListFacade      = null;
                String          str_ListConfig      = null;
                String          str_SearchInputXml  = null;
                String          str_ListSourceXml   = null;
                StringBuilder   sb_SelectedUsers    = null;
                MWB_Helper      obj_MWBHelperFacade = null; 

                obj_ListFacade = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                obj_MWBHelperFacade = new  MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language); 
                
                str_ListConfig = obj_ListFacade.GetConfigurationXML(SolutionName, null, "ROProcessReaders");
                
                //Prepare Selected Users input xml.
                sb_SelectedUsers = new StringBuilder(150);
                sb_SelectedUsers.Append("<UserSelectionXML><SelectedUsersList>");
                if (xpathNav_ProcessReadersUser != null)
                {
                    sb_SelectedUsers.Append(xpathNav_ProcessReadersUser.InnerXml);
                }
                sb_SelectedUsers.Append("</SelectedUsersList></UserSelectionXML>");

                //Prepare Selected Group Input xml.
                sb_SelectedUsers.Remove(0, sb_SelectedUsers.Length);
                sb_SelectedUsers.Append("<GroupSelectionXML><SelectedGroupsList>");
                if (xpathNav_ProcessReadersGroup != null)
                {
                    sb_SelectedUsers.Append(xpathNav_ProcessReadersGroup.InnerXml);
                }
                sb_SelectedUsers.Append("</SelectedGroupsList></GroupSelectionXML>");

                str_SearchInputXml = obj_MWBHelperFacade.PrepareUserGroupListSearchXml(xpathNav_ProcessReadersGroup, xpathNav_ProcessReadersUser);
                obj_ListFacade.PrepareListXml(str_ListConfig, str_SearchInputXml, out str_ListSourceXml);
                LC_TaskReaders.Source = str_ListSourceXml;
            }

            /// <summary>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <CreatedOn>19 April 2012</CreatedOn>
            /// <Purpose>To go back to the View Tasks screen</Purpose>
            /// </summary>
            private void gotoViewTasksScreen()
            {
                MWB_Helper MWBHelperObj = null;
                MWBHelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                Ajax.WriteExecuteJavaScript(MWBHelperObj.GetViewTasksScreenURL());
            }
       #endregion
    }
}