#region SystemIncludes
using System;
using System.Data;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.IO;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
#endregion

#region AssetlinkIncludes
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.Solutions.Facade.PMFacade;
using Assetlink.Solutions.Facade.NotificationFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Pages;
#endregion

//-----------------------------------------------------//
// File Name:   Perform_ResponseGatherInfoTask.aspx.cs //
// Author:      Ms. Mugdha Moolay.                     //
// Class:       Perform_ResponseGatherInfoTask         //
// Created On:  13th December 2006                     //
//-----------------------------------------------------//

namespace Assetlink.Solutions.MarketingWorkBench
{
    using XML       = String;
    using ERRORXML  = String;

    public partial class Perform_ResponseGatherInfoTask: ALAjaxPage
    {
        #region MemberVariables
            private ALSolutionCommon            ALSolutionCommonObj = null;
            //private Dictionary<String, String>  m_ParamList         = null;
            public ALParam                      ALParamObj          = null; 
            private List<ObjectInfo>            ObjInfoList         = null;
            private List<ObjectInfo>            ResponseObjInfoList =null;            
            private List<string>                ActivityIDOrderedList= null;             
            private String[]                    strSeparator         = null;
            private String                      TaskID               = null;
            private String                      StepID               = null;    
            private String                      PackageDefinitionID = null;
            private String                      ProcessDefinitionID = null;
            private String                      Mode                = null;
            private String                      SolutionName        = "MarketingWorkBench";
            private String                      TaskFile            = null;
            private String                      GroupListFile       = null;
            private	String					    TabClickFlag		= null;
			private String						SelectedTab			= null;
			private String						StepResourceFileName= null;
			private String						ResourceTreeFile	= null;
            private String                      str_ResponseBreadCrumbs = null;
            private String                      str_ComponentFacetFileName = "_ComponentFacet.xml";
            private String                      str_ComponentFacetStatus   = "Editable";
            private String                      str_SelectedComponentsIDFileName = "_SelectedComponentsID.xml";
            private String                      str_ProjectInfoTempFileName      = "_ProjectInfo.xml";
            private Hashtable                   StepROFormIDTable   = null;
            private String                      SectionPath         = "Template Vault\\";
        #endregion

        #region ControlsOnPage
            private Form                                 Frm_TaskDetails          = null;
                    Form                                 ResponseForm             = null;
		    private Form                                 Frm_ROProjectDetails     = null;	
            private   ActionBar                          Ab_ResponseTask          = null;
            private ALUC_ALUserSelection                 UC_InitiatorSelection    = null;
            private ALPanel                              ALPanel_InitiatorSelection = null;
            private Binder                               Binder_Attachments         = null;
            private ALPanel                              Manual_Activities          = null;
            private ALBreadCrumb                         Perform_BreadCrumb         = null; 
            private ALTab								  GatherInfoTaskTab			= null;
			private ALPanel								  Panel_TaskDetails			= null;
			private ALPanel								  Panel_UserRoles			= null;
            private ALPanel                               Panel_ProjectDetails      = null;
            private SquareBlankSection                    Sbs_ProjectDetails        = null;
            private CustomControls.ListControl           Lst_UserGroup              = null;
            private CustomControls.ListControl           Lst_TemplateDocument       = null;
            private CustomControls.ListControl           LC_TaskReaders             = null; 
            private ALPanel                              Panel_Templates            = null;
            private CheckBox                            checkBoxObj                 = null;
            private TextBox                             textBoxObj                  = null;
            private Literal                             Literal_TaskInitiator       = null;
     
            //Hemant Karkande : Do Not Delete this commented code
            //private Assetlink.CustomControls.ListControl Lst_PredecessorList = null;
        #endregion

        #region ProtectedMethods

            //protected override void CreateChildControls()
            //{
            //    try
            //    {
            //        String ResponseFormID = null;
            //        setParameters();
            //        setControls();
            //        setLeftPane();
            //        if(IsPostBack)
            //        {
            //            if (ViewState["TabClickFlag"] != null)
            //            {
            //                ResponseFormID = __ResponseFormID.Value;
            //                if (ResponseFormID != null)
            //                {
            //                    createResponseForm();
            //                    String EventGenerator = Ajax.EventGeneratorUniqueID;
            //                    if (EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton"))
            //                    {
            //                        UpdateContributorDropDownList();
            //                    }
            //                    StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
            //                    SetStepForm_InPostBack();
            //                }
            //            }
            //        }
            //        base.CreateChildControls();
            //    }
            //    catch(Exception ExcepObj)
            //    {				
            //        throw ExcepObj;
            //    }
            //}

		    protected void Page_Init(object sender, EventArgs e)
            {
                ALSolutionCommonObj = new ALSolutionCommon();
                ALParamObj = new ALParam();

                ALSolutionCommonObj.httpContext = HttpContext.Current;
                ALSolutionCommonObj.InitALParam(ref ALParamObj);

                ((ALMasterPage)this.Master).SessionID       = ALParamObj.SessionID;
                ((ALMasterPage)this.Master).UserID          = ALParamObj.UserID;
                ((ALMasterPage)this.Master).Language        = ALParamObj.Language;
                ((ALMasterPage)this.Master).TenantName      = ALParamObj.TenantName;
                ((ALMasterPage)this.Master).SolutionName    = SolutionName;
                ((ALMasterPage)this.Master).PageTitle       = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_MarketingWorkbench_Shared");
            }

            protected void Page_Load(object sender, EventArgs e)
            {
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbench Page (Page_Load):- Entered Page_Load() function.");
                String ResponseFormID = null;
                setParameters();
                setControls();
				setControlProperties();
                setLeftPane();
                Ajax.AsynchronousRequest = true;
                if (!IsPostBack)
                {
                    DeleteTempFiles();
					setSelectedTab();
					//setPageForTaskDetails();
					//setBreadcrumbs(); 
                }
                else
                {
                    if (ViewState["TabClickFlag"] != null)
                    {
                        ResponseFormID = __ResponseFormID.Value;
                        if (ResponseFormID != null)
                        {
                            createResponseForm(false);
                            String EventGenerator = Ajax.EventGeneratorUniqueID;
                            if ((!String.IsNullOrEmpty(EventGenerator)) &&(EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton")))
                            {
                                UpdateContributorDropDownList();
                            }
                            //StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
                            //SetStepForm_InPostBack();
                        }
                    }
                }
                //((ALMasterPage)this.Master).ParamList = m_ParamList;
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbench Page (Page_Load):- Leaving Page_Load() function.");
            }

            protected void Ab_ResponseTask_Click(object sender, EventArgs e)
            {
                ERRORXML ErrorXML		= null;
                String	 ErrorPageURL	= null;
                ulong			ErrorID				= 0;
                StringBuilder   ErrorPageURL_Exp	= null;
                try
                {
                    //
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btn_SaveAndClose"))
                    {
                        //Save Button Clicked
                        //Save the response of the contributor.
                       ErrorXML = SaveResponse(false);
					   if(ErrorXML == null)
					   {
						   DeleteTempFiles();
						   gotoPerformListScreen();
					   }
					   else
					   {
						   if(ErrorXML != null)
						   {
							   ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
							   if(!IsPostBack)
							   {
								   Response.Redirect(ErrorPageURL, true);
							   }
							   else
								   Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
						   }
					   }
                    }
                    else if (Parameters[1].Equals("btn_Submit"))
                    {
                        //Submit Button Clicked
                        //Save the response of the contributor.
						ErrorXML = SaveResponse(true);
						if(ErrorXML == null)
						{
							DeleteTempFiles();
							gotoPerformListScreen();
						}
						else
						{
							if(ErrorXML != null)
							{
								ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
								if(!IsPostBack)
								{
									Response.Redirect(ErrorPageURL, true);
								}
								else
									Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
							}
						}
                    }                  
                    else if (Parameters[1].Equals("btn_ForwardTask"))
                    {
                        ForwardTask_ShowDiv();
                    }
                    else if (Parameters[1].Equals("btn_Cancel"))
                    {
						DeleteTempFiles();
						gotoPerformListScreen();
                    }
                    else if (Parameters[1].Equals("btn_PrintTask"))
                    {
                       // ForwardTask_ShowDiv();
                    }
                }
                catch (Exception ExceptionObj)
                {
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfo_Task.aspx", "Ab_ResponseTask_Click", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_ActionBarClick_EXCEPTION_Shared"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            protected void Ab_ForwardTask_Click(object sender, EventArgs e)
            {
                ulong			ErrorID				= 0;
                StringBuilder   ErrorPageURL_Exp	= null;
                try
                {
                    String strSender    = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btnDone"))
                    {
                        SaveForwardTask();
                    }
                    //else if (Parameters[1].Equals("btnCancel"))
                    //{
                    //    Ajax.WriteExecuteJavaScript("hideContentDiv('"+Div_ForwardTask.ClientID+"');");
                    //}
                }
                catch (Exception ExceptionObj)
                {
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfo_Task.aspx", "Ab_ForwardTask_Click", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_ResponseGatherInfoTask_Exceptiononforwardtaskactionbarclick_Shared"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            protected void ForwardTask_SelectionChanged(object sender, EventArgs e)
            {
                DropDownList SelectedDropDown   = null;
                String      SelectedValue       = null;
                String      SelectedID          = null;
                String      ListID              = null;
                String      MailID              = null;
                String      SelectedContributor = null;
                ListItem    SelectedListItem    = null;
                XML         FormInputXML        = null;
                XmlDocument FormInputDoc        = null;
                XmlNode     FieldNode           = null;
                XmlNode     ValueNode           = null;
                MWB_Helper  MWB_HelperObj       = null;
                StringBuilder	TempPath		= null;
				String			TempFilePath	= null;
				String			FileName		= null;
				StringBuilder	GroupListXML	= null;
				UserFacade		UserFacadeObj	= null;
				ulong			ErrorID			= 0;
				StringBuilder	ErrorPageURL_Exp	= null;
                try
                {
                    SelectedDropDown = (DropDownList)sender;
                    SelectedListItem = SelectedDropDown.SelectedItem;
                    SelectedValue   = SelectedListItem.Text;
                    SelectedID      = SelectedListItem.Value;
                    ListID           = SelectedDropDown.ID;
                    FormInputDoc    = new XmlDocument();
					TempPath		= new StringBuilder();
					GroupListXML	= new StringBuilder();
					UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    TempFilePath	= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    //SelectedGroup       = Frm_ForwardTask.GetValues("ContributorGroup");
                    SelectedContributor = Frm_ForwardTask.GetValues("Contributor");
                    FileName = StepID + "_GroupUsers.xml";
					TempPath.AppendFormat("{0}{1}", TempFilePath, FileName);
                    if (ListID.Contains("Contributor"))
                    {
                        if (SelectedID.ToUpper() != "NONE")
                        {
							MWB_HelperObj.GetMailAddressForSelectedUser(SelectedID, FileName, out MailID);
                            //setStepFormInputXMLForMailAddress(FormID, MailID);
                        }
                        
                        FormInputXML = Frm_ForwardTask.InputXML;
                        if (FormInputXML!=null)
                        {
                            FormInputDoc.LoadXml(FormInputXML);
                            FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                            if (FieldNode != null)
                            {
                                ValueNode = FieldNode.SelectSingleNode("Value");
                                if (ValueNode!=null)
                                ValueNode.InnerText = MailID;
                            }                        
                        }
                    }
                    Frm_ForwardTask.InputXML = FormInputDoc.OuterXml;
                    //Frm_ForwardTask.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                    Frm_ForwardTask.ResetFacetSeriesFields();
                }
                catch (Exception ExceptionObj)
                {
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfo_Task.aspx", "ForwardTask_SelectionChanged", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_ActionBarClick_EXCEPTION_Shared"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }
            
            protected void GatherInfoTaskTab_onTabClick(object sender,TabClickEventarg e)
            {
				ALPanel			SelectedTab		 = null;
				ulong			ErrorID			 = 0;
				StringBuilder	ErrorPageURL_Exp = null;
				try
				{
					TabClickFlag = "TRUE";
					ViewState["TabClickFlag"] = "TRUE";
					SelectedTab  = (ALPanel)e.SelectedTab;
                    if (!IsPostBack)
                        setBreadcrumbs();
					switch(SelectedTab.Name.ToUpper())
					{
						case "INFO":
                            ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbench Page (GatherInfoTaskTab_onTabClick):- Before GetTaskDetails() function.");
							GetTaskDetails();
                            ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbench Page (GatherInfoTaskTab_onTabClick):- After GetTaskDetails() function.");
							break;
						case "USER ROLES":
							GetUserRoles();
							break;
					}
				}
                catch (System.Threading.ThreadAbortException)
                { }
				catch(Exception ExcepObj)
				{
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfo_Task.aspx", "GatherInfoTaskTab_onTabClick", ExcepObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_Response_Approvals_Task_Exceptionontabclick_Shared"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
				}
            }

			protected void Hidden_SelectResourceForwardTask_Click(object sender, EventArgs e)
			{
				StringBuilder	FilePath	 = null;
				XPathDocument	RecDoc		 = null;
				XPathNavigator	xpNav		 = null;
				String			SelectedValue= null;
				UserFacade		UserFacadeObj= null;
				XML				SearchXML	 = null;
				XML				UserXML		 = null;
				ERRORXML		ErrorXml	 = null;
				XPathDocument   UserDoc		 = null;
				MWB_Helper		MWB_HelperObj= null;
				String			StepID		 = null;
				String			StepFormID	 = null;
				String			ItemList	 = null;
				String			TempPath	 = null;
				String			FileName	 = null;
				XML				FormInputXML = null;
				XmlDocument		FormInputDoc = null;
				XmlNode			FieldNode	 = null;
				XmlNode			ValueNode	 = null;
				String			MailID		 = null;
				try
				{
					StepID			= Request["__EVENTARGUMENT"];
					FilePath		= new StringBuilder();
					UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					MWB_HelperObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					TempPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					FormInputDoc	= new XmlDocument();
					FilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
					
					if(File.Exists(FilePath.ToString()))
					{
						RecDoc = new XPathDocument(FilePath.ToString());
						xpNav  = RecDoc.CreateNavigator();
						xpNav  = xpNav.SelectSingleNode("//*/TreeNode[@Selected='True']");
						if(xpNav != null)
						{
							SelectedValue	= xpNav.GetAttribute("Text","") ;						

							SearchXML = GetSearchXML(SelectedValue);
							ErrorXml = UserFacadeObj.GetUserList(SearchXML, ref UserXML);
							
							if(ErrorXml == null)
							{
								UserDoc = new XPathDocument(new StringReader(UserXML));
								ItemList = MWB_HelperObj.GetContributorXML(UserDoc);
								StepFormID = Frm_ForwardTask.ID;
								// save the user file on ntfs
								FilePath.Remove(0, FilePath.Length);

                                FileName = StepID + "_GroupUsers.xml";
								FilePath.AppendFormat("{0}{1}", TempPath, FileName);
								File.WriteAllText(FilePath.ToString(), UserXML);
								FormInputXML = Frm_ForwardTask.InputXML;
								if (FormInputXML != null)
								{
									FormInputDoc.LoadXml(FormInputXML);
									FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
									if (FieldNode != null)
									{
										FieldNode.InnerXml = ItemList;                            
									}
									FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
									if (FieldNode != null)
									{
										ValueNode = FieldNode.SelectSingleNode("Value");
										if (ValueNode != null)
											ValueNode.InnerText = MailID;
									}  
								}
								Frm_ForwardTask.InputXML = FormInputDoc.OuterXml;
                                //Frm_ForwardTask.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                                Frm_ForwardTask.ResetFacetSeriesFields();
							}
						}
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

            protected override void Render(HtmlTextWriter writer)
            {
               
                try
                {
                    if (IsPostBack)
                    {
                        String EventGenerator = Ajax.EventGeneratorUniqueID;

                        if (!String.IsNullOrEmpty(TabClickFlag) && TabClickFlag.Equals("TRUE"))
                        {
                            if (GatherInfoTaskTab.SelectedTab != null)
                            {
                                Ajax.AddControlsToRender(GatherInfoTaskTab.SelectedTab);
                                Ajax.WriteExecuteJavaScript("javascript:" + GatherInfoTaskTab.HighlightTabJavaScript);
                            }
                        }

                        if (EventGenerator.Contains("Content_1_Frm_TaskDetails"))
                        {
                            Ajax.AddControlsToRender(Frm_TaskDetails);
                            if (EventGenerator.Contains("ExportSeriesRecord"))
                            {
                                String ExportUrl = Frm_TaskDetails.GetSeriesExportUrl();
                                if (!String.IsNullOrEmpty(ExportUrl))
                                    Ajax.WriteExecuteJavaScript(ExportUrl);
                            }
                            if (ViewState["ComponentFacetFieldName"] != null)
                            {
                                //loading digital assets for components dynamically.
                                Ajax.WriteExecuteJavaScript("javascript:" + (String)Frm_TaskDetails.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                            }
                        }

                        if (EventGenerator.Contains("PS") || EventGenerator.Contains("_Response") || EventGenerator.Contains(Btn_Hidden_SelectSigns.UniqueID))
                        {
                            Ajax.AddControlsToRender(ResponseForm);
                            if (EventGenerator.Contains("ExportSeriesRecord"))
                            {
                                String ExportUrl = ResponseForm.GetSeriesExportUrl();
                                if (!String.IsNullOrEmpty(ExportUrl))
                                    Ajax.WriteExecuteJavaScript(ExportUrl);
                            }
                            if (ViewState["ComponentFacetFieldName"] != null)
                            {
                                //loading digital assets for components dynamically.
                                Ajax.WriteExecuteJavaScript("javascript:" + (String)ResponseForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                            }
                        }
                        //if (EventGenerator.Contains("btn_ForwardTask") || EventGenerator.Contains("Frm_ForwardTask_DDL_StepDetails_Editable_ContributorGroup") || EventGenerator.Contains("Frm_ForwardTask_DDL_StepDetails_Editable_Contributor") || EventGenerator.Contains("Hidden_SelectResourceForwardTask") || EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton"))
                        if ((EventGenerator.Contains(Frm_ForwardTask.UniqueID)) || EventGenerator.Contains("btn_ForwardTask") || EventGenerator.Contains("Frm_ForwardTask_DDL_") || EventGenerator.Contains("Hidden_SelectResourceForwardTask") || EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton"))
                        {
                            Ajax.AddControlsToRender(Frm_ForwardTask);
                            if ((ViewState["ComponentFacetFieldName"] != null))
                            {
                                Ajax.WriteExecuteJavaScript("javascript:" + (String)Frm_ForwardTask.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                            }
                        }


                        if (EventGenerator.Contains("Binder_Documents"))
                            Ajax.AddControlsToRender(Binder_Attachments);

                        if (EventGenerator.Contains("Content_1_sbs_Project_Details"))
                            Ajax.AddControlsToRender(Sbs_ProjectDetails);

                        if (EventGenerator.Contains("LstTemplateDocument"))
                            Ajax.AddControlsToRender(Lst_TemplateDocument);

                        if (EventGenerator.Contains(LC_TaskReaders.UniqueID))
                            Ajax.AddControlsToRender(LC_TaskReaders);

                        ////2. Step ROForms.
                        StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
                        if (StepROFormIDTable != null && ViewState["ComponentFacetFieldName"]!= null)
                        {
                            IDictionaryEnumerator StepFormIDEnum = StepROFormIDTable.GetEnumerator();
                            while (StepFormIDEnum.MoveNext())
                            {
                                if (EventGenerator.Contains(StepFormIDEnum.Value.ToString()))
                                {
                                    Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                                    if (StepForm != null)
                                    {
                                        Ajax.AddControlsToRender(StepForm);
                                        writer.Write("<script type=\"text/javascript\">" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                                    }
                                }
                            }
                        }
                        Ajax.WriteControlHTMl(this.Page, writer);
                    }
                    else
                    {
                        base.Render(writer);
                        if ((ViewState["ComponentFacetFieldName"] != null))
                        {
                            //loading digital assets for components dynamically.
                            //1. Task Form.
                            writer.Write("<script type=\"text/javascript\">" + (String)Frm_TaskDetails.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                            renderStepForms(writer);
                        }
                    }
                }
                catch (Exception obj_Exception)
                {
                    throw obj_Exception;
                }
            }


            /// <alsummary>
            /// <createddate>24-March-2009</createddate>
            /// <author>Bhalchandra Kadam</author>
            /// <purpose>Update Component list with selected components</purpose>
            /// </alsummary>
            protected void Btn_Hidden_SelectSigns_Click(object sender, EventArgs e)
            {
                String          SelectedRowsFilePath   = null;
                String          str_ActivityID         = null;
                ERRORXML        ErrorXml               = null;
                Boolean         alertGiven             = false;

                try
                {
                     ErrorXml = SaveResponse(false);
                     if ((ErrorXml == null) && (!alertGiven))
                     {
                         UpdateTaskSteps();
                         SelectedRowsFilePath = Request["__EVENTARGUMENT"];
                         str_ActivityID = SelectedRowsFilePath.Split(',')[1];
                     }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>17 April 2009</createddate>
            /// <author>Radha A</author>
            /// <purpose>To Handle clicks on the Component Facet Series List Action bar.</purpose>
            /// </alsummary>
            protected void Frm_TaskDetails_SeriesActionBarClick(object sender, EventArgs e)
            {
                ulong       ErrorID         = 0;
                String      EncryptURL      = null;

                try
                {
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                    if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                    {
                        getDigitalAssetsFromFacetIDs("TASK");
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_RODiscussionTask.aspx", "Frm_TaskDetails_SeriesActionBarClick", ExceptionObject, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_ComponentListABClick_EXCEPTION_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ExceptionObject.Message, null, null, ref EncryptURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                }
            }

            /// <summary>
            /// <Author>Anita Kale</Author>
            /// <CreatedOn>18th May 2009</CreatedOn>
            /// <Purpose>Event Handler for Expansion of project Info Section</Purpose>
            /// </summary>
            protected void Sbs_ProjectDetails_CollapsedClick(object sender, EventArgs e)
            {
                Sbs_ProjectDetails.IsMinimize = false;
                setProjectInfo();
            }

        #endregion

        #region PrivateMethods

            private void GetTaskDetails()
            { 
                MWB_Helper               MWBHelperClassObj  = null;
                XmlDocument              InputXMLDoc        = null;
                XmlDocument              TempDoc            = null;
                XmlDocument              FormInputDoc       = null;
                ERRORXML                 ErrorXML           = null;
                XmlNode                  ActivityNode       = null;
                XmlNodeList              ActivityNodeList   = null;
                XmlNode                  FileSystemNode     = null;
                XmlNode					 ProcessActivityNode= null;
                XmlNode					 FieldNode          = null;                
                XML                      ReturnTaskXML      = null;
                XML                      FormInputXML       = null;
                StringBuilder            ProcessColl        = null;                
                StringBuilder            TempPath           = null;
                StringBuilder            ResourceTypeList   = null;
                FormFacade               FormFacadeObj      = null;  
                String                   TaskName           = null;                
                String                   FormConfigXMLPath  = null;
                String                   TempFilePath       = null;
                Hashtable                ResourceTable      = null;                
                String                   TaskStatus         = null;
				StringBuilder			 ActResourceXML		= null;
				XML						 ResourceXML		= null;
                String          str_StdFormName         = null;
                String          str_DynamicFormName     = null;
                String          str_SelectedFormName    = null;
                String          FormConfigXML           = null;
                String          SearchXML               = null;
                String          str_TaskXML             = null; 
                String          str_ActivitiesXML       = null; 
                
                XPathExpression         xp_SortExpression       = null;
                XPathNodeIterator       xp_SortNodeIter         = null;
                String                  str_SortXML             = null;
                

                try
                {
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);

                    ProcessColl         = new StringBuilder();                    
                    TempPath            = new StringBuilder();
                    ResourceTypeList    = new StringBuilder();
					ActResourceXML		= new StringBuilder();
                    ResourceTable       = new Hashtable();
                    StepROFormIDTable   = new Hashtable();
                    InputXMLDoc         = new XmlDocument();
                    TempDoc             = new XmlDocument();                    
                    ActivityIDOrderedList = new List<string>();
                    TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

					ActResourceXML.Append("<ACTIVITYCOLLECTION>");
                    FormFacadeObj.SolutionName  = SolutionName;
                    str_StdFormName             = "Task_Details";

                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- Before GetGatherInfoTask() function.");
                    ErrorXML = GetGatherInfoTask(out str_TaskXML);
                    //if (str_ActivityFacets != null)
                    //    ViewState["ActivityFacets"] = str_ActivityFacets;
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- After GetGatherInfoTask() function.");

                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- Before GetGatherInfoTaskActivities() function.");
                        ErrorXML = GetGatherInfoTaskActivities( out str_ActivitiesXML);
                        ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Perform_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- After GetGatherInfoTaskActivities() function.");
                    }

                    if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_TaskXML)) && (!String.IsNullOrEmpty(str_ActivitiesXML)))
                    {
                        MergeTaskActivities(str_TaskXML, str_ActivitiesXML, out ReturnTaskXML);
    
                        InputXMLDoc.LoadXml(ReturnTaskXML);
                        str_DynamicFormName = __ProcessDefinitionID.Value + "_" + str_StdFormName;
                        FormConfigXMLPath = MWBHelperClassObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out str_SelectedFormName);

                        FormConfigXML       = File.ReadAllText(FormConfigXMLPath);

                        FormFacadeObj.ShowConfiguredFields  = true;
                        FormFacadeObj.FormName              = str_SelectedFormName;
                        FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out SearchXML);
                        //HemantK:For Component Facet Series
                        ErrorXML = GetComponentFacetForTask(ref InputXMLDoc, ref FormConfigXML, SearchXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            CheckComponentFacetSeriesStatus(Frm_TaskDetails);

                            ProcessColl.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", InputXMLDoc.OuterXml);
                             
                            ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ProcessColl.ToString(), out FormInputXML, out ObjInfoList);
                            ViewState["ObjectList"] = ObjInfoList;
                            
                            PackageDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID").InnerText;
                            ProcessDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").InnerText;
                            TaskName = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                            //ViewState["TaskTitle"] = TaskName;
                            Perform_BreadCrumb.DisplayText = TaskName;
                            TaskStatus = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/STATUS").InnerText;

                            if (FormConfigXML != null)
                            {
                                Frm_TaskDetails.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                                Frm_TaskDetails.ConfigurationXML     = FormConfigXML;
                                
                                // display the initiator
                                //Initiator = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                setInitiatorSelectionControl(null);
                                //Display Attachments
                                FileSystemNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM");
                                XmlNode AssetNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ASSETREFERENCES");
                                setAttachments(FileSystemNode, AssetNode);
                                setTemplateDocument();
                                // Select all the manual activities.
							    //ActivityNodeList = InputXMLDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE='Task']");
							    //foreach (XmlNode Activity_Node in ActivityNodeList)
							    //{
							    //    ResourceNodeList = Activity_Node.SelectNodes("ACTIVITY_RESOURCE/RESOURCE");
							    //    foreach (XmlNode ResourceNode in ResourceNodeList)
							    //    {
							    //        if (ResourceTable.ContainsKey(ResourceNode.SelectSingleNode("RESOURCEID").InnerText) == false)
							    //            ResourceTable.Add(ResourceNode.SelectSingleNode("RESOURCEID").InnerText, ResourceNode.SelectSingleNode("RESOURCETYPE").InnerText);
							    //    }
							    //}
							    // ResourceTypeList.AppendFormat(";");
							    //IDictionaryEnumerator ResourceEnum = ResourceTable.GetEnumerator();

							    //while (ResourceEnum.MoveNext())
							    //{
							    //    ResourceTypeList.AppendFormat("{0};", ResourceEnum.Value.ToString());
							    //}
							    //SearchXML = MWBHelperClassObj.GetSearchXMLForListOfEntities("GROUP", "GROUPNAME", "GROUP.GROUP_MEMBERUSER", "USERID;LOGINNAME;FIRSTNAME;LASTNAME;MIDDLEINITIAL", ResourceTypeList.ToString());
							    ////SearchXML = MWBHelperClassObj.GetSearchXMLForResourceTypeGroups(ResourceTypeList.ToString());
							    //ErrorXML = GroupFacadeObj.GetGroupList(SearchXML, ref GroupListXML);
							    //if (ErrorXML == null)
							    //{
							    //    TempDoc = null;
							    //    TempPath.Remove(0, TempPath.Length);
							    //    TempDoc         = new XmlDocument();
							    //    TempDoc.LoadXml(GroupListXML);
							    //    TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);
							    //    TempDoc.Save(TempPath.ToString());
							    //}

                                //Hemant Karkande : Do Not Delete this commented code
                                //PaintPredecessorList(ReturnTaskXML);

                                //apply percentdone class
                                ApplyPercentDoneClass(InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/STATUS").InnerText, InputXMLDoc, ref FormInputXML);
                                FormInputDoc = new XmlDocument();
                                FormInputDoc.LoadXml(FormInputXML);
                                if (TaskStatus.ToUpper() != "COMPLETED" && TaskStatus.ToUpper() != "CANCELLED")
                                {                                                                      
                                    FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALENDDATE']");
                                    if (FieldNode != null)
                                    {
                                        ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                    }                                    
                                }

                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASESTARTDATE']");
                                if (FieldNode != null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASEENDDATE']");
                                if (FieldNode != null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                                FormInputXML = FormInputDoc.OuterXml;

                                Frm_TaskDetails.InputXML = FormInputXML;
							    ProcessActivityNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");

                                xp_SortExpression   = XPathExpression.Compile("ACTIVITY");
                                xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                                xp_SortNodeIter     = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                                while (xp_SortNodeIter.MoveNext())
                                {
                                    str_SortXML += xp_SortNodeIter.Current.OuterXml;
                                }
                                ProcessActivityNode.InnerXml = str_SortXML;
    							
							    TempPath.Remove(0, TempPath.Length);
							    TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
							    InputXMLDoc.Save(TempPath.ToString());

                                // Set the response page for the contributor.
                                // get the userid of the logged in user 
                                // select that activity where the actual resource users' id =  userid
                                ActivityNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "' and ACTIVITYID='" + StepID + "']");
                                if (ActivityNode!=null)                            
                                {
								    ResourceXML = MWBHelperClassObj.GetActivityResourceXML(ActivityNode);
								    if(!String.IsNullOrEmpty(ResourceXML))
								    {
									    ActResourceXML.Append(ResourceXML);
								    }
								    setActivityResponsePage(ActivityNode,false);
								    setActionBar(true);
							    }
							    else
							    {
                                    gotoErrorPage(Localization.GetString("ALResource", ALParamObj.TenantName, "Unauthorised_Access_Shared"));
								    return;
							    }

                                // for all the other activities , set readonly forms.
                                //ActivityNodeList = InputXMLDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[descendant::RESOURCE_USER/USER/USERID!='" + ALParamObj.UserID + "']");
                                ActivityNodeList = InputXMLDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID!='" + StepID + "' and STARTACTIVITY='False'  and ENDACTIVITY='False' ]");
                                foreach( XmlNode ActNode in ActivityNodeList)
                                {
                                    setROResponseForm(ActNode);
                                }
                            }
                            ViewState["StepROFormIDList"] = StepROFormIDTable;
						    ActResourceXML.Append("</ACTIVITYCOLLECTION>");
						    TempPath.Remove(0, TempPath.Length);
						    TempPath.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
						    File.WriteAllText(TempPath.ToString(), ActResourceXML.ToString());
                        }
                        //Assign values for prior notification
                        SetAdvanceReminderValues(ReturnTaskXML);
                    }
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    
                    throw ExceptionObj;
                }
            }

            private void ApplyPercentDoneClass(String TaskStatus, XmlDocument InputXMLDoc, ref String FormInputXML)
            {
                XmlDocument                 FormXMLDoc          = null;
                XmlNode                     FieldNode           = null;
                XmlNode                     DueDateNode         = null;
                String                      PercentDoneClass    = null;
                DateTime                    DueDate;
                MktgWorkBenchFacadeClass    MWBFacadeObject     = null;
		        ulong			            ErrorID				= 0;
                StringBuilder	            ErrorPageURL_Exp	= null;

                try
                {
                    FormXMLDoc = new XmlDocument();
                    FormXMLDoc.LoadXml(FormInputXML);

                    if (TaskStatus.ToUpper() != "NEW" && TaskStatus.ToUpper() != "DRAFT")
                    {
                        DueDate = DateTime.Today;

                        DueDateNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DUEDATE");
                        DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESSINFO_PERCENTDONE_PROCESS_INFORMATION']");

                        MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(TaskStatus, DueDate);

                        ((XmlElement)FieldNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                        FormInputXML = FormXMLDoc.OuterXml;
                    }
                    
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfoTask.aspx", "ApplyPercentDoneClass", ExceptionObj, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_DeliverableDetails_Exceptionwhileshowingactualdatesforthedeliverable_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private ERRORXML SaveResponse(bool SubmitResponse)
            {
                StringBuilder   UpdateTaskXML   = null;
                MWB_Helper      MWB_HelperObj   = null;
                String          ResponseFormID  = null;
                FormFacade      FormFacadeObj   = null;
                ERRORXML        ErrorXML        = null;
                XML             ResponseXML     = null;
                XML             SaveTaskXML         = null;
                                
                XmlDocument                 ResponseDoc             = null;
                XmlDocument                 ActivityDoc             = null;
                XmlDocument                 TaskDoc                 = null;
                StringBuilder               TempPath                = null;                
                StringBuilder               UpdateActivityXML       = null;
                StringBuilder               PostedOnDate            = null;
                String                      TempFilePath            = null;
                String                      ActivityID              = null;
                XmlNode                     ResponseNode            = null;
                XmlNode                     PostedByNode            = null;
                XmlNode                     ResponsePostedOn        = null;
                XmlNode                     ActivityNode            = null;    
                XmlNode                     StatusNode              = null;
                XmlNode                     xmlNode_SelectedComponents= null;
                XmlAttribute                TypeAttribute           = null;                
                MktgWorkBenchFacadeClass    MktgFacadeObj           = null;
				String						strFormName				= null;
				String						strStdFormName			= null;
				String						strSelectedFormName		= null;
				String						strActivityDefID		= null;
                 //HemantK:For Component Facet Series
                String                      str_FormActionBarXML    = null; 
                StringBuilder               sb_FormActionBarXML     = null; 
                String                      str_ComponentRShip      = null;
                //Radha: For updating selected components.                
                StringBuilder               sb_ActivityInfo         = null;
                String                      str_ActivityInfoId      = null;
                String                      str_ComponentObjectName = null;
                String                      str_ComponentPrimaryKey = null;
                Hashtable                   obj_SelectComponentIDs  = null;
                MWB_Component               obj_Component           = null;
                String                      str_ResponseFormConfigFile= null;
                XPathDocument               xpathDoc_FormConfig       = null;
                           
                try
                {
                    obj_Component = new MWB_Component (ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MktgFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    UpdateTaskXML = new StringBuilder();
                    TempPath            = new StringBuilder();
                    UpdateTaskXML       = new StringBuilder();
                    UpdateActivityXML   = new StringBuilder();
                    PostedOnDate        = new StringBuilder();
                    ActivityDoc         = new XmlDocument();
                    TaskDoc             = new XmlDocument();
                    ResponseDoc         = new XmlDocument();
                    sb_FormActionBarXML = new StringBuilder(500);
                    sb_ActivityInfo     = new StringBuilder(700);
                    obj_SelectComponentIDs = new Hashtable();
                    
                    TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    ResponseFormID      = __ResponseFormID.Value;
                    TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
                    TaskDoc.Load(TempPath.ToString());                    
                    UpdateTaskXML.AppendFormat("<WORKFLOWPROCESS><WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>", TaskID);
                    UpdateTaskXML.AppendFormat("<PROCESS_ACTIVITY TYPE='RELATION'>");
                    
                    sb_FormActionBarXML.Append("<ACTIONBARCOLLECTION>");  

                    if (ResponseFormID != null)
                    {
//                        obj_SelectComponentIDs.Add(StepID, true);

						strStdFormName			= "StepDetails_Response";
						ActivityNode			= TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']");
						strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
                        str_ActivityInfoId      = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYINFORMATIONID").InnerText;
						strFormName				= strActivityDefID + "_Response";
                        str_ResponseFormConfigFile  = MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
						FormFacadeObj.FormName	= strSelectedFormName;					
						
                        FormFacadeObj.SolutionName = SolutionName;
                        Form ResponseForm = (Form)Manual_Activities.FindControl(ResponseFormID);
                        //ResponseForm.ID = ResponseFormID;
						ResponseObjInfoList = (List<ObjectInfo>)ViewState["ResponseObjInfo"];

                        //HemantK:Get the Form ActionBar
                        str_FormActionBarXML = GetFormActionBarXML(ResponseForm);
                        if (!String.IsNullOrEmpty(str_FormActionBarXML))
                        {
                            sb_FormActionBarXML.Append(@"<ACTIONBAR> 
                                                            <ACTIONBARFOR>ACTIVITY</ACTIONBARFOR>
                                                            <ID>" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + "</ID>"
                                                                + str_FormActionBarXML + "</ACTIONBAR>");
                        }

                        ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", ResponseForm, ResponseObjInfoList, out ResponseXML);
                        if (ErrorXML == null)
                        {
                            PostedOnDate.AppendFormat(@"<YEAR>{0}</YEAR>
                                                        <MONTH>{1}</MONTH>
                                                        <DAY>{2}</DAY>
                                                        <HOUR>{3}</HOUR>
                                                        <MINUTE>{4}</MINUTE>
                                                        <SECOND>{5}</SECOND>", DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second);
                            ResponseXML = ResponseXML.Replace("<ACTIVITY>", "<ACTIVITY MODIFIED='TRUE'>");
                            ResponseDoc.LoadXml(ResponseXML);
                            xmlNode_SelectedComponents = ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                            //if (xmlNode_SelectedComponents != null)
                            //{
                            //    xmlNode_SelectedComponents.ParentNode.RemoveChild(xmlNode_SelectedComponents);
                            //}

                            //Get component facet name and its primary key 
                            if ((ViewState["ComponentFacetSeriesRShipName"] != null) && (ResponseObjInfoList != null))
                            {
                                str_ComponentRShip = ViewState["ComponentFacetSeriesRShipName"].ToString();
                                for (int ObjectIndex = 0; ObjectIndex < ResponseObjInfoList.Count; ObjectIndex++)
                                {
                                    if (ResponseObjInfoList[ObjectIndex].RelationShipName == str_ComponentRShip)
                                    {
                                        str_ComponentObjectName = ResponseObjInfoList[ObjectIndex].ObjectName;
                                        str_ComponentPrimaryKey = ResponseObjInfoList[ObjectIndex].PrimaryKeyName;
                                        break;
                                    }
                                }
                                if ((SubmitResponse) && (!String.IsNullOrEmpty(str_ComponentPrimaryKey)) && (!String.IsNullOrEmpty(str_ComponentObjectName)))
                                {
                                    obj_Component.UpdateSelectedComponentsXmlForActivity(TaskID, ActivityNode, str_ComponentFacetFileName, str_ComponentRShip, str_ComponentObjectName, str_ComponentPrimaryKey, str_SelectedComponentsIDFileName);
                                    if ((ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS") != null) && (ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS") != null))
                                    {
                                        ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS").InnerXml += ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS").InnerXml; 
                                    }
                                }
                            }
                            if ((File.Exists(str_ResponseFormConfigFile)) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                            {
                                xpathDoc_FormConfig     = new XPathDocument(str_ResponseFormConfigFile);
                                if (xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                                {
                                    obj_SelectComponentIDs.Add(StepID, true);
                                }
                                else
                                {
                                    obj_SelectComponentIDs.Add(StepID, false);
                                }
                            }

                            if (SubmitResponse)
                            {
                                ActivityNode = ResponseDoc.SelectSingleNode("ACTIVITY");
                                StatusNode = ResponseDoc.CreateElement("STATUS");
                                ActivityNode.AppendChild(StatusNode);
                                StatusNode.InnerText = "Completed";								
                                ActivityID = ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
                            }
                            ResponseNode = ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_RESPONSE/RESPONSE");
                            ResponsePostedOn = ResponseDoc.CreateElement("RESPONSEPOSTEDON");
                            ResponsePostedOn.InnerXml = PostedOnDate.ToString();
                            ResponseNode.AppendChild(ResponsePostedOn);
                            if (ResponseNode.Attributes.GetNamedItem("MODIFIED") == null) //If response is created for the first time
                            {
                                PostedByNode = ResponseDoc.CreateElement("POSTEDBY");
                                ResponseNode.AppendChild(PostedByNode);
                                TypeAttribute = ResponseDoc.CreateAttribute("TYPE");
                                TypeAttribute.InnerText = "RELATION";
                                PostedByNode.Attributes.Append(TypeAttribute);
                                PostedByNode.InnerText = ALParamObj.UserID;
                            }
                            else //IF response was saved or after the ReRoute
                            {
                                PostedByNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']/ACTIVITY_RESPONSE/RESPONSE/POSTEDBY");
                                if (PostedByNode != null)
                                {
                                    if (PostedByNode.SelectSingleNode("USER/USERID").InnerText != ALParamObj.UserID)
                                    {
                                        String str_PostedBy = null;
                                        str_PostedBy = "<POSTEDBY TYPE='RELATION' DISASSOCIATE='TRUE'>" + PostedByNode.SelectSingleNode("USER/USERID").InnerText + "</POSTEDBY>";
                                        str_PostedBy += "<POSTEDBY TYPE='RELATION'>" + ALParamObj.UserID + "</POSTEDBY>";

                                        ResponseNode.InnerXml += str_PostedBy;
                                    }
                                }
                            }
                        }
                        UpdateActivityXML.AppendFormat("{0}", ResponseDoc.OuterXml);
                    }
                    
                    UpdateTaskXML.AppendFormat("{0}", UpdateActivityXML.ToString());
					UpdateTaskXML.Append("</PROCESS_ACTIVITY></WORKFLOWPROCESS>");
                    
                    //SaveTaskXML = ResponseDoc.OuterXml;
					SaveTaskXML = UpdateTaskXML.ToString();
                    sb_FormActionBarXML.Append("</ACTIONBARCOLLECTION>");

                    //Hemantk:Update the Component Facet series for Deliverable
                    ErrorXML = UpdateDeliverableComponentForTask(ref SaveTaskXML, sb_FormActionBarXML.ToString(), obj_SelectComponentIDs, str_ComponentObjectName, str_ComponentPrimaryKey);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        //Radha 02/02/09: To update selected components xml. 
                        //if ((!String.IsNullOrEmpty(SelectedComponentsXML)) && (!String.IsNullOrEmpty(str_ActivityInfoId)))
                        //{
                        //    sb_ActivityInfo.Append("<ACTIVITY_INFORMATION TYPE='RELATION'>"
                        //                                + @"<ACTIVITYINFORMATION MODIFIED='TRUE'>"
                        //                                        + @"<ACTIVITYINFORMATIONID>" + str_ActivityInfoId + @"</ACTIVITYINFORMATIONID>"
                        //                                        + @"<SELECTEDCOMPONENTS>" + SelectedComponentsXML + @"</SELECTEDCOMPONENTS>"
                        //                                + @"</ACTIVITYINFORMATION>"
                        //                            +@"</ACTIVITY_INFORMATION>");
                            
                        //    TaskDoc.LoadXml(SaveTaskXML);
                        //    ActivityNode            = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + ActivityID + "']");
                        //    ActivityNode.InnerXml  += sb_ActivityInfo.ToString();
                        //    SaveTaskXML             = TaskDoc.InnerXml;
                        //}
                        //ErrorXML = MktgFacadeObj.UpdateStep(CalculateTimeLine, false, false, ref SaveTaskXML);
                        ErrorXML = MktgFacadeObj.UpdateTask(TaskID, false, MWB_TimeLineEvents.NONE, false, ref SaveTaskXML);
                    }
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setActivityResponsePage(XmlNode ActivityNode, Boolean b_ResetFacetSeriesFields)
            {
                StringBuilder   StepFormID          = null;
                StringBuilder   ActivityColl        = null;
                StringBuilder   ParameterList       = null;
                StringBuilder   InputXMLPath        = null;
				StringBuilder	TempFilePath		= null;
                String          FormConfigXMLPath   = null; 
                String          TempPath            = null;
                MWB_Helper      MWBHelperClassObj   = null;
                FormFacade      FormFacadeObj       = null;
                ERRORXML        ErrorXML            = null;
                XML             FormConfigXML       = null;
                XML             StepFormInputXML    = null;
                XmlDocument     StepDoc             = null;
                XmlAttribute    UploadAttr          = null;
                XmlNode         FieldNode           = null;
                XmlNode         UploadUrlNode       = null;
                XmlNode         xmlNode_SelectedComponents= null;
				String			strFormName			= null;
				String			strStdFormName		= null;
				String			strSelectedFormName	= null;
				String			strActivityDefID	= null;
                String          SearchXML           = null;
                Int32           int_ControlIndex    = 0;
                try
                {
                    ResponseForm        = new Form();
                    StepFormID          = new StringBuilder();
                    ActivityColl        = new StringBuilder();
                    ParameterList       = new StringBuilder();
                    InputXMLPath        = new StringBuilder();
					TempFilePath		= new StringBuilder();
                    StepDoc             = new XmlDocument();                
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    FormFacadeObj.SolutionName = SolutionName;
					strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
					strFormName				= strActivityDefID+ "_Response";
					strStdFormName			= "StepDetails_Response";
					FormConfigXMLPath       = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
					FormFacadeObj.FormName = strSelectedFormName;
					
					
                    StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                    ResponseForm.ID = StepFormID.ToString();
                    __ResponseFormID.Value          = StepFormID.ToString();
                    ResponseForm.TenantName = ALParamObj.TenantName;
                    ResponseForm.SolutionName = SolutionName;
					ResponseForm.IsDynamicForm = true;
                    FormFacadeObj.ShowConfiguredFields = true;

                    ResponseForm.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                    ResponseForm.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;

                    ResponseForm.SeriesActionBarClick +=new EventHandler(ResponseForm_SeriesActionBarClick); 

                    FormConfigXML                   = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,true);

                    xmlNode_SelectedComponents = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                    if ((!IsPostBack) && (xmlNode_SelectedComponents != null) && (xmlNode_SelectedComponents.HasChildNodes))
                    {
                        //Save this return XML on NTFS in temp location                            
                        TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + StepID + str_SelectedComponentsIDFileName);
                        File.WriteAllText(TempFilePath.ToString(), xmlNode_SelectedComponents.InnerXml);
                        TempFilePath.Remove(0, TempFilePath.Length);
                    }
                    FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                    ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, SearchXML);
                    if (ErrorXML == null)
                    {
                        TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID.ToString());
                        if ((File.Exists(TempFilePath.ToString())) && (IsPostBack))
                        {
                            StepFormInputXML = File.ReadAllText(TempFilePath.ToString());
                        }
                        else
                        {
                            //HemantK: check for the deliverable component facet series
                            CheckComponentFacetSeriesStatus(ResponseForm);
                            ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);
                            ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                            ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                        }
                        ResponseForm.ConfigurationXML = FormConfigXML;

                        StepDoc.LoadXml(StepFormInputXML);
                        FieldNode = StepDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                        if (FieldNode != null)
                        {
                            //&ControlID={5} , Btn_StepAttachments.UniqueID
                            ParameterList.AppendFormat("&TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName);
                            if (FieldNode.Attributes.GetNamedItem("UploadURL") != null)
                            {
                                UploadUrlNode = FieldNode.Attributes.GetNamedItem("UploadURL");
                                UploadUrlNode.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                            }
                            else
                            {
                                UploadAttr = StepDoc.CreateAttribute("UploadURL");
                                UploadAttr.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                                FieldNode.Attributes.Append(UploadAttr);
                            }

                            // set the download URL
                            if (FieldNode.Attributes.GetNamedItem("DownLoadURL") != null)
                            {
                                UploadUrlNode = FieldNode.Attributes.GetNamedItem("DownLoadURL");
                                UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                            }
                            else
                            {
                                UploadAttr = StepDoc.CreateAttribute("DownLoadURL");
                                UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                                FieldNode.Attributes.Append(UploadAttr);
                            }
                        }                       
                        if ((IsPostBack) &&(b_ResetFacetSeriesFields))
                        {
                            ResponseForm.ResetBinders = true;
                            ResponseForm.ResetFileUploadControls = true;
                        }

                        ResponseForm.InputXML = StepDoc.OuterXml;
                        if (Manual_Activities.FindControl(ResponseForm.ID) != null)
                        {
                            int_ControlIndex = Manual_Activities.Controls.IndexOf(Manual_Activities.FindControl(ResponseForm.ID));
                            Manual_Activities.Controls.RemoveAt(int_ControlIndex);
                            Manual_Activities.Controls.AddAt(int_ControlIndex, ResponseForm);
                        }
                        else
                        {
                            Manual_Activities.Controls.Add(ResponseForm);
                        }
                        ResponseForm.ConfigurationMode = true;
                        //Manual_Activities.Controls.Add(ResponseForm);
                        File.WriteAllText(TempFilePath.ToString(), StepDoc.OuterXml);
                    }
                    if (!IsPostBack)
                        setForwardTaskForm(ActivityNode);
                    if (b_ResetFacetSeriesFields)
                        ResponseForm.ResetFacetSeriesFields();
                    //ACTIVI
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setROResponseForm(XmlNode ActivityNode)
            {
                StringBuilder   StepFormID          = null;
                StringBuilder   ActivityColl        = null;
                StringBuilder   ParameterList       = null;
                String          FormConfigXMLPath   = null; 
                MWB_Helper      MWBHelperClassObj   = null;
                FormFacade      FormFacadeObj       = null;
                MktgWorkBenchFacadeClass MWBFacadeObject = null; 
                ERRORXML        ErrorXML            = null;
                XML             FormConfigXML       = null;
                XML             StepFormInputXML    = null;
                String          EmailID             = null;
                String          FirstName           = null;
                String          LoginName           = null;
                String          LastName            = null;
                String          MiddleInitial       = null;
                String          FormattedName       = null;
                String          PercentDoneClass    = null; 
                XmlNode         ResourceUserNode    = null;
                XmlNode         ValueNode           = null;
                XmlNode         TempNode            = null;
                XmlNode         UploadUrlNode       = null;
                XmlNode         DueDateNode         = null;
                XmlNode         ResponseNode        = null; 
                XmlAttribute    UploadAttr          = null;
                XmlDocument     TempDoc             = null;
                DateTime        DueDate;
				String			strFormName				= null;
				String			strStdFormName			= null;
				String			strSelectedFormName		= null;
				String			strActivityDefID		= null;
			    String          SearchXML               = null;
                String          str_ActivityID          = null;

                try
                {
                    Form StepForm       = new Form();
                    StepFormID          = new StringBuilder();
                    ActivityColl        = new StringBuilder();
                    ParameterList       = new StringBuilder();
                    TempDoc             = new XmlDocument();
                    ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language);
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    FormFacadeObj.SolutionName = SolutionName;
                    
                    FormFacadeObj.ShowConfiguredFields = true;
                    StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                    StepForm.ID                     = StepFormID.ToString();
					StepForm.IsMinimize				= true;
                    __ResponseFormID.Value          = StepFormID.ToString();
                    StepForm.TenantName             = ALParamObj.TenantName;
					strActivityDefID				= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
					strStdFormName					= "StepDetails_ROResponse";
					strFormName						= strActivityDefID + "_ROResponse";
					StepForm.IsDynamicForm			= true;
                    StepForm.InputXMLType           = Assetlink.CustomControls.Form.InputType.InnerXML;
                    StepForm.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.InnerXML;
                    StepForm.ShowConfiguredFields   = true; 
                    FormConfigXMLPath               = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName,strFormName,out strSelectedFormName);
                    FormConfigXML                   = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,true);
					FormFacadeObj.FormName			= strSelectedFormName;
                    FormFacadeObj.ShowConfiguredFields = true;
                    str_ActivityID = ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
                    if (!IsPostBack)
                    {
                        if (!StepROFormIDTable.Contains(str_ActivityID))
                        {
                            StepROFormIDTable.Add(str_ActivityID, StepFormID.ToString());
                        }
                    }
                    ResourceUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");

                    //Check the status of the activity if active then remove the Response node
                    if (ActivityNode.SelectSingleNode("STATUS").InnerText.ToUpper() == "ACTIVE")
                    {
                        ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE");
                        if ((ResponseNode != null) && (ResponseNode.HasChildNodes))
                            ActivityNode.RemoveChild(ResponseNode.ParentNode);   
                    }

                    if (ResourceUserNode != null)
                    {
                        FirstName = ResourceUserNode.SelectSingleNode("FIRSTNAME").InnerText;
                        LastName = ResourceUserNode.SelectSingleNode("LASTNAME").InnerText;
                        MiddleInitial = ResourceUserNode.SelectSingleNode("MIDDLEINITIAL").InnerText;
                        LoginName = ResourceUserNode.SelectSingleNode("LOGINNAME").InnerText;
                        FormattedName = ALCommon.FormatUserName(FirstName, LastName, MiddleInitial, LoginName, ALCommon.GetUserNameFormat());
                        EmailID = ResourceUserNode.SelectSingleNode("EMAILID").InnerText;
                    }
                    FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out SearchXML);
                    //HemantK: check for the deliverable component facet series
                    ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, SearchXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        StepForm.ConfigurationXML       = FormConfigXML;
                        //CheckComponentFacetSeriesStatus(StepForm);
                        //Radha: To remove actionbar for other contributors.
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            StepForm.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                        }

                        ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>",ActivityNode.OuterXml);
                        ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                        TempDoc.LoadXml(StepFormInputXML);
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (TempNode != null)
                        {
                            ValueNode = TempDoc.CreateElement("Value");
                            ValueNode.InnerText = FormattedName;
                            TempNode.AppendChild(ValueNode);
                        }
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (TempNode != null)
                        {
                            ValueNode = TempDoc.CreateElement("Value");
                            ValueNode.InnerText = EmailID;
                            TempNode.AppendChild(ValueNode);
                        }
                        // set the download URL
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                        if (TempNode.Attributes.GetNamedItem("DownLoadURL") != null)
                        {
                            UploadUrlNode = TempNode.Attributes.GetNamedItem("DownLoadURL");
                            UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                        }
                        else
                        {
                            UploadAttr = TempDoc.CreateAttribute("DownLoadURL");
                            UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                            TempNode.Attributes.Append(UploadAttr);
                        }
                        TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='ACTIVITYINFORMATION_PERCENTDONE_ACTIVITY_INFORMATION']");
                        if (TempNode != null)
                        {
                            //apply percentdone class
                            DueDate = DateTime.Today;

                            DueDateNode = ActivityNode.SelectSingleNode("DUEDATE");
                            DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                            MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(ActivityNode.SelectSingleNode("STATUS").InnerText, DueDate);

                            ((XmlElement)TempNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                        }
                        if (Manual_Activities.FindControl(StepForm.ID) != null)
                        {
                            Manual_Activities.Controls.Remove(StepForm);
                        }
                            
                        StepForm.InputXML = TempDoc.OuterXml;
                        StepForm.ConfigurationMode = false;
                        StepForm.ShowConfiguredFields = true;
                        //ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                        Manual_Activities.Controls.Add(StepForm);        
                    }
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
           }

            private void createResponseForm(Boolean b_ResetFacetSeries)
            {
                StringBuilder   TempPath        = null;
                String          TempFilePath    = null;
                XmlDocument     TaskDoc         = null;
                XmlNode         ActivityNode    = null;
                try
                {
                    TempFilePath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    TempPath     = new StringBuilder();
                    TaskDoc      = new XmlDocument();
                    TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
                    if (File.Exists(TempPath.ToString()))
                    {
                        TaskDoc.Load(TempPath.ToString());
                        //ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[descendant::RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "']");
                        ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "' and ACTIVITYID='" + StepID + "']");
                        if (ActivityNode!=null)
                            setActivityResponsePage(ActivityNode, b_ResetFacetSeries);
                    }
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setInitiatorSelectionControl(XmlNode InitiatorNode)
            {
                StringBuilder PrevSelectedUserXML = null;
                 String		  OldUserXML		  = null;
				bool			IsFirstTime		  = false;
                try
                {
                    PrevSelectedUserXML = new StringBuilder();
                    if (InitiatorNode != null)
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList>{0}</SelectedUsersList></UserSelectionXML>", InitiatorNode.InnerXml);
                    else
                        PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList></SelectedUsersList></UserSelectionXML>");

					OldUserXML = UC_InitiatorSelection.PrevSelectedUserXML;
					if(String.Compare(OldUserXML, PrevSelectedUserXML.ToString(), true) != 0)
						IsFirstTime = true;

					if(IsFirstTime)
						UC_InitiatorSelection.FirstTime = "TRUE";
					
                    UC_InitiatorSelection.TenantName          = ALParamObj.TenantName;
                    UC_InitiatorSelection.SessionID           = ALParamObj.SessionID;
                    UC_InitiatorSelection.UserID              = ALParamObj.UserID;
                    UC_InitiatorSelection.Language            = ALParamObj.Language;
                    UC_InitiatorSelection.InstanceName        = "GatherInfoTask_Initiator";
                    UC_InitiatorSelection.Layout              = "SIMPLE";
                    UC_InitiatorSelection.Mode                = "READONLY";
                    UC_InitiatorSelection.SolutionName        = SolutionName;
                    UC_InitiatorSelection.PrevSelectedUserXML = PrevSelectedUserXML.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setAttachments(XmlNode FileSystemNode, XmlNode AssetReferences)
            { 
                StringBuilder UploadUrlPath     = null;
                StringBuilder DownLoadUrlPath   = null;
                StringBuilder ParameterList     = null;
                String        FileSystemXml     = "";
                try
                {
                    UploadUrlPath                   = new StringBuilder();
                    DownLoadUrlPath                 = new StringBuilder();
                    ParameterList                   = new StringBuilder();
					ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName,ALParamObj.Language);
                    UploadUrlPath.AppendFormat("../../Common/ASPX/UploadFiles.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                    ParameterList.Remove(0, ParameterList.Length);
                    ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language);
                    DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                    Binder_Attachments.TenantName           = ALParamObj.TenantName;
                    Binder_Attachments.SolutionName         = "MarketingWorkBench";
                    Binder_Attachments.BinderListHeading    = Localization.GetString("ALResource", ALParamObj.TenantName, "Attachments_shared");
                    Binder_Attachments.Layout               = Binder.LayoutType.BinderList_WithThumbnails;
                    Binder_Attachments.Mode                 = Binder.Modes.ReadOnly;
                    Binder_Attachments.InputXMLType         = Binder.InputType.InnerXML;
                    Binder_Attachments.ListConfigurationName= "TaskAttachmentsForResponseScreen";
                    Binder_Attachments.FieldName            = "ATTACHMENTS";
                    //Binder_Attachments.ConfigName = "PROJECT_ATTACH";
                    Binder_Attachments.UploadUrl            = UploadUrlPath.ToString();
                    Binder_Attachments.DownloadUrl          = DownLoadUrlPath.ToString();
                    Binder_Attachments.EnableAssetSelection = true;
                    Binder_Attachments.DigitalAssetRelationShip = "PROCESS_ASSETREFERENCES";

                    Attachment.TenantName   = ALParamObj.TenantName;
                    Attachment.SessionID    = ALParamObj.SessionID;
                    Attachment.UserID       = ALParamObj.UserID;
                    Attachment.ThemeName    = Page.Theme;
                    Attachment.Language     = ALParamObj.Language;
                    Attachment.BinderFieldName = "ATTACHMENTS";
                    
                    if (FileSystemNode != null)
                        FileSystemXml = FileSystemNode.OuterXml;

                    if (AssetReferences != null)
                    {
                        if (FileSystemNode == null)
                        {
                            Attachment.PrepareInputXMLWithAssetReferences(null, AssetReferences.CreateNavigator(), ref FileSystemXml);
                        }
                        else
                        {
                            Attachment.PrepareInputXMLWithAssetReferences(FileSystemNode.CreateNavigator(), AssetReferences.CreateNavigator(), ref FileSystemXml);
                        }
                    }
                    
                    Binder_Attachments.InputXML = FileSystemXml;
                    //if (FileSystemNode.SelectNodes("BINDER").Count > 0)
                    //{
                    //    Binder_Attachments.BinderOperation = "Update";
                    //    Binder_Attachments.InputXML = FileSystemNode.OuterXml;
                    //}
                    //else
                    //{
                    //    Binder_Attachments.BinderOperation = "Update";
                    //    Binder_Attachments.InputXML = null;
                    //}
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void ForwardTask_ShowDiv()
            {
                try
                {                    
                    Ajax.WriteExecuteJavaScript(Popup_ForwardTask.ShowPopupWindowJavascript);
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            private void setForwardTaskForm(XmlNode ActivityNode)
            {
                StringBuilder   ActivityColl        = null;
                FormFacade      FormFacadeObj       = null;
                String          FormConfigXMLPath   = null;
                String          ResourceID          = null;
                String          ResourceType        = null;
                String          MailID              = null;
                MWB_Helper      MWBHelperClassObj   = null;
                XML             StepFormInputXML    = null;
                XML             ItemListXML         = null;
                ERRORXML        ErrorXML            = null;
                XmlDocument     FormXMLDoc          = null;
                XmlNode         ActivityResourceNode= null;
                XmlNode         ActualResourceNode  = null;
                XmlNode         FieldNode           = null;
                XmlNode         ValueNode           = null;
                XmlNode			FormNode			= null;
                XmlNode			ResponseSectionNode	= null;
                GroupFacade		GroupFacadeObj		= null;
                StringBuilder	GroupListXML		= null;
                StringBuilder	ContributorFileName	= null;
                StringBuilder	TempPath			= null;
				String			TempFilePath		= null;
				XML				UserCollectionXML	= null;
				StringBuilder	ParamURL				= null;
				XML				SearchXML				= null;
				XML				GroupXML				= null;
				String			GroupID					= null;
				String			SelectedValueFile		= null;
				String			SelectedValueFileName	= null;
				String			SelectedValueXML		= null;
				StringBuilder	SelectedValueXml		= null;
				String			ActivityID				= null;
				XPathDocument	UserDoc					= null;
				String			strFormName				= null;
				String			strStdFormName			= null;
				String			strSelectedFormName		= null;
				String			strActivityDefID		= null;
                XmlNodeList     SectionNodeList         = null;
                int             Order                   = 0;
                try
                {
                    ActivityColl                    = new StringBuilder();
                    GroupListXML					= new StringBuilder();
					ContributorFileName				= new StringBuilder();
					TempPath						= new StringBuilder();
					SelectedValueXml				= new StringBuilder();
                    FormXMLDoc                      = new XmlDocument();
					TempFilePath					= ALSolutionCommon.GetTempPath(ALParamObj.SessionID); 
                    MWBHelperClassObj               = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    FormFacadeObj                   = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    GroupFacadeObj					= new GroupFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    Frm_ForwardTask.TenantName      = ALParamObj.TenantName;
                    Frm_ForwardTask.SolutionName    = SolutionName;                
                    FormFacadeObj.ShowConfiguredFields = true;
                    FormFacadeObj.SolutionName      = SolutionName;                    
                    Frm_ForwardTask.InputXML        = StepFormInputXML;
					FormFacadeObj.UniqueID			= StepID;
					ActivityID				= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
                    SelectedValueFileName   = StepID + "_ContributorGroup_SelectedValueList.xml";
					SelectedValueFile		= TempFilePath + SelectedValueFileName;
					if(File.Exists(SelectedValueFile))
						SelectedValueXML = File.ReadAllText(SelectedValueFile);

                    strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
					strStdFormName			= "StepDetails_Editable";
					strFormName				= strActivityDefID + "_Editable";
					FormConfigXMLPath		= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName,out strSelectedFormName);
					FormFacadeObj.FormName	= strSelectedFormName;    
                    if (File.Exists(FormConfigXMLPath))
                    {
						//Frm_ForwardTask.ConfigurationXML = FormConfigXMLPath;
						FormXMLDoc.Load(FormConfigXMLPath);
						FormNode = FormXMLDoc.DocumentElement;
						ResponseSectionNode = FormNode.SelectSingleNode("Section[@Heading='PREVIOUS_RESPONSE']");
						if(ResponseSectionNode != null)
						{
							FormNode.RemoveChild(ResponseSectionNode);
						}
                        Order = Convert.ToInt32(((XmlElement)ResponseSectionNode).GetAttribute("Order"));
                        SectionNodeList = FormNode.SelectNodes("Section[@Order > '" + Order.ToString() + "']");
                        foreach (XmlNode SectionNode in SectionNodeList)
                        {
                            ((XmlElement)SectionNode).SetAttribute("Order", Order++.ToString());
                        }
						Frm_ForwardTask.ConfigurationXML = FormXMLDoc.InnerXml;
                    }
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        Frm_ForwardTask.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }
                    ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);                
                    ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                    ViewState["ForwardTaskObjInfo"] = ResponseObjInfoList;
                    if (ErrorXML == null)
                    {
                        ItemListXML = MWBHelperClassObj.PrepareFormInputXML(ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").OuterXml, "RESOURCETYPE", "RESOURCEID");

                        // check if this activity has any actual resources associated with it
                        ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                        if (ActivityResourceNode != null)
                            ActualResourceNode = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");

						ParamURL = new StringBuilder(150);
						ParamURL.Append("SelectResourceType.aspx?");
						//ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceForwardTask.UniqueID, SelectedValueFileName, ResourceTreeFile);
                        ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&StepID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepID, Hidden_SelectResourceForwardTask.UniqueID);

                        FormXMLDoc.LoadXml(StepFormInputXML);
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                        if (FieldNode != null)
                        {
							((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
							((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                        }
                        GroupListFile = StepID + "_GroupUsers.xml";
						TempPath.Remove(0, TempPath.Length);
						TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);

                        if (ActualResourceNode != null)
                        {
                            ResourceType			= ActualResourceNode.SelectSingleNode("RESOURCETYPE").InnerText;
							SearchXML				= GetSearchXMLForGroupAndUsers(ResourceType);
													
							ErrorXML = GroupFacadeObj.GetGroupList(SearchXML, ref GroupXML);
							if(ErrorXML == null)
							{
								if(GroupXML != null)
								{
									MWBHelperClassObj.GetGroupIDAndUserXML(GroupXML, out UserCollectionXML, out GroupID);
									File.WriteAllText(TempPath.ToString(), UserCollectionXML);
									TempPath.Remove(0, TempPath.Length);
									TempPath.AppendFormat("{0}{1}", TempFilePath, SelectedValueFileName);
									SelectedValueXml.AppendFormat("<ValueList><Value ID='{0}' Text='{1}'/></ValueList>", GroupID, ALSolutionCommon.TrimAndReplaceSpecialChars(ResourceType));
									File.WriteAllText(TempPath.ToString(), SelectedValueXml.ToString());
									UserDoc = new XPathDocument(new StringReader(UserCollectionXML));
									ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
									if(ItemListXML != null)
									{
										if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
										{
											ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
											ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
											MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
										}
									}
								}
								else
								{
                                    ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
								}
							}
                        }
                        else
                        {
                            ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                        }
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (FieldNode != null)
                        {
                            FieldNode.InnerXml = ItemListXML;
                        }
                        if (MailID != null)
                        {
                            FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                            if (FieldNode != null)
                            {
                                ValueNode = FormXMLDoc.CreateElement("Value");
                                ValueNode.InnerText = MailID;
                                FieldNode.AppendChild(ValueNode);
                            }
                        }
                        //Hide Duration
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
                        if (FieldNode != null)
                        {
                            if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                            else
                                FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                        }
                        //Frm_ForwardTask.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);
                        Frm_ForwardTask.InputXML = FormXMLDoc.OuterXml;                                     
                    }
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void SaveForwardTask()
            {
                MktgWorkBenchFacadeClass   MktgFacadeObj   = null;
                StringBuilder   TempPath                = null;
                StringBuilder   DisAssociateXML         = null;
                StringBuilder   OldUserXML              = null; 
                String          TempFilePath            = null;
                String          SelectedGroup           = null;
                String          SelectedContributor     = null;
                String          ActualResourceID        = null;
                String          OldUserID               = null;                
                FormFacade      FormFacadeObj           = null;
                XML             FormOutputXML           = null;
                XML             TempXML                 = null;
                XML             ActivityResourceXML     = null;
                XML             SaveStepXML             = null;            
                ERRORXML        ErrorXML                = null;
                XmlDocument     TaskDoc                 = null;
                XmlDocument     TempDoc                 = null;
                XmlNode         ActivityNode            = null;
                XmlNode         OldUserNode             = null;
                XmlNode         ActivityResourceNode    = null;
                XmlNode         DisAssociateResourceNode= null;
                XmlNode         ActivityResponseNode    = null;
                XmlNode         ResourceNode            = null;
                XmlNode         ActivityContributorNode = null; 
                MWB_Helper      MWB_HelperObj           = null;
                String          ActivityResourceID      = null;
                bool            ActivityModified        = true;
                bool            DisAssociateUserOnly    = false;
                String			ErrorPageURL			= null;
				String			SelectedGroupName		= null;
				String			InputActivityID			= null;
				XPathDocument	ActResDoc				= null;
				StringBuilder	ActResFile				= null;
				String			strFormName				= null;
				String			strStdFormName			= null;
				String			strSelectedFormName		= null;
				String			strActivityDefID		= null;
                try
                {
                    TempPath        = new StringBuilder();
                    DisAssociateXML = new StringBuilder();
                    OldUserXML      = new StringBuilder();
                    TaskDoc         = new XmlDocument();
                    TempDoc         = new XmlDocument();                    
                    MktgFacadeObj   = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj   = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					strStdFormName	= "StepDetails_Editable";
                   
                    FormFacadeObj.SolutionName = SolutionName;
                    TempFilePath    = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    TempPath.AppendFormat("{0}{1}",TempFilePath,TaskFile);
					//SelectedGroup       = Frm_ForwardTask.GetValues("ContributorGroup");
                    SelectedContributor = Frm_ForwardTask.GetValues("Contributor");
                    ResponseObjInfoList = (List<ObjectInfo>)ViewState["ForwardTaskObjInfo"];

					ActResFile = new StringBuilder();
					ActResFile.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
					if(File.Exists(ActResFile.ToString()))
					{
						ActResDoc = new XPathDocument(ActResFile.ToString());
					}

					if(File.Exists(TempPath.ToString()))
					{						
						TaskDoc.Load(TempPath.ToString());
						ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "' and ACTIVITYID='" + StepID + "']");
						if(ActivityNode != null)
						{
							InputActivityID		= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
							strActivityDefID	= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
							strFormName			= strActivityDefID + "_Edtiable";
							MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
							FormFacadeObj.FormName	= strSelectedFormName;
							SelectedGroup			= MWB_HelperObj.GetSelectedActivityResourceID(ActResDoc, InputActivityID , out SelectedGroupName);
							if((SelectedGroup.ToUpper() != "NONE") && (SelectedContributor.ToUpper() != "NONE"))
							{								
								ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");								
								MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
								if((ActivityResourceID != null) && (ActualResourceID != null))
								{
									// group and contributor both changed.
                                    OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
									if(OldUserNode != null)
									{
										OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
									}
									OldUserXML.AppendFormat("<OLDUSER>");
									DisAssociateXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>", ActivityResourceID);
									if(SelectedGroup != ActivityResourceID)
									{
										if(OldUserID != null)
										{
											DisAssociateXML.AppendFormat(@"<ACTUAL_RESOURCE TYPE='RELATION'>
																			<RESOURCE MODIFIED='TRUE'>
																			<RESOURCEID>{0}</RESOURCEID>
																			<RESOURCE_USER TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</RESOURCE_USER>
																			</RESOURCE>
																		</ACTUAL_RESOURCE>", ActualResourceID, OldUserID);
										}
										DisAssociateXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTUAL_RESOURCE>", ActualResourceID);
										OldUserXML.AppendFormat("{0}", OldUserNode.OuterXml);
									}
									else if((OldUserID != null) && (OldUserID != SelectedContributor))
									{										
										DisAssociateUserOnly = true;
										// the selected group is same but the contributor is changed.
										OldUserXML.AppendFormat("{0}", OldUserNode.OuterXml);
									}
									else
									{
										ActivityResourceID = null;
										ActualResourceID = null;
										ActivityModified = false;
									}
									OldUserXML.AppendFormat("</OLDUSER>");
								}
								if(ActivityModified)
								{
									ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
									ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", Frm_ForwardTask, ResponseObjInfoList, out FormOutputXML);
									if(ErrorXML == null)
									{
										// here only the actual resource is modified.
										if(DisAssociateUserOnly)
										{
											MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, FormOutputXML, SelectedGroupName, out TempXML);
											TempDoc.LoadXml(TempXML);
											ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
										}
										else
										{
											MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML,SelectedGroupName);
											MWB_HelperObj.prepareActivityXML(true, FormOutputXML, ActivityResourceXML, out TempXML);
											TempDoc.LoadXml(TempXML);
											ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
											if((ActivityResourceID != null) && (ActualResourceID != null))
												ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE");
											if(ActivityResourceNode != null)
											{
												if(OldUserNode != null)
												{
													ActivityContributorNode = TempDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
													((XmlElement)ActivityContributorNode).SetAttribute("TYPE", "RELATION");
													((XmlElement)ActivityContributorNode).SetAttribute("DISASSOCIATE", "TRUE");
													ActivityContributorNode.InnerText = OldUserNode.SelectSingleNode("USERID").InnerText;
													//ActivityNode.AppendChild(ActivityContributorNode);
													ActivityNode.PrependChild(ActivityContributorNode);
												}

												DisAssociateResourceNode = TempDoc.CreateElement("RESOURCE");
												((XmlElement)DisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");

												DisAssociateResourceNode.InnerXml = DisAssociateXML.ToString();
												ActivityResourceNode.AppendChild(DisAssociateResourceNode);
											}
										}										
										ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
										if((ActivityResponseNode != null) && (ActivityResponseNode.HasChildNodes))
											ActivityNode.RemoveChild(ActivityResponseNode);
										//}
										SaveStepXML = ActivityNode.OuterXml;
										ErrorXML = MktgFacadeObj.UpdateStep(false, false, false, ref SaveStepXML);
									}// end if error xml                                   
								}// end if for ActivityModified								
								if(ErrorXML == null)
								{
									if(ActivityModified)
										StampNotificationForGatherInfoTask(TaskID, StepID, OldUserXML.ToString(), "TASKFORWARD");
									DeleteTempFiles();
									gotoPerformListScreen();
								}
								else
								{

									ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
									if(!IsPostBack)
									{
										Response.Redirect(ErrorPageURL, true);
									}
									else
										Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");

								}
							}
							else
                                Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_Perform_Response_Assignment_Task_Pleaseselectacontributor');");
						}
					}
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void gotoPerformListScreen()
            {
                StringBuilder ParamURL  = null;
                StringBuilder URL       = null;  
                String        EncryptURL = null;  
                try
                {
                    ParamURL = new StringBuilder();
                    URL      = new StringBuilder();
                    ParamURL.AppendFormat("PerformList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}",ALParamObj.TenantName,ALParamObj.Language,ALParamObj.SessionID,ALParamObj.UserID);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('"+"{0}"+"','_self','');",EncryptURL);
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj; 
                }
            }

            private void setParameters()
            {
                try
                {
                    strSeparator = new string[1] { "$AL$" };
                    TaskID  = ALSolutionCommonObj.GetParamValue("TaskID");
                    Mode    = ALSolutionCommonObj.GetParamValue("Mode");
                    StepID  = ALSolutionCommonObj.GetParamValue("StepID");
                    SelectedTab  = ALSolutionCommonObj.GetParamValue("SelectedTab");
                    str_ResponseBreadCrumbs = ALSolutionCommonObj.GetParamValue("ResponseBreadCrumbs");
                    if (String.IsNullOrEmpty(str_ResponseBreadCrumbs))
                    {
                        str_ResponseBreadCrumbs = "0";
                    }
					if(SelectedTab == null)
						SelectedTab = "INFO";
                    PackageDefinitionID = ALSolutionCommonObj.GetParamValue("PackageDefinitionID");
                    if (!String.IsNullOrEmpty(PackageDefinitionID))
                    {
                        __PackageDefinitionID.Value = PackageDefinitionID;
                    }
                    ProcessDefinitionID = ALSolutionCommonObj.GetParamValue("ProcessDefinitionID");
                    if (!String.IsNullOrEmpty(ProcessDefinitionID))
                    {
                        __ProcessDefinitionID.Value = ProcessDefinitionID;
                    }
                    if (!String.IsNullOrEmpty(StepID))
                    {
                        TaskFile                = StepID + "_MWB_GatherInfoTask.xml";
                        GroupListFile           = StepID + "_MWB_GatherInfoGroupList.xml";
                        StepResourceFileName    = StepID + "_ActivityResourceColl.xml";
                        ResourceTreeFile        = StepID + "_ResourceGroupTree.xml";
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw (ExceptionObject);
                }
            }

            private void setControls()
            {                
                StringBuilder ActionBarXMLPath      = null;                
                String        CultureInformation    = null;
                String        FormatXMLPath         = null;
                MWB_Helper    MWB_HelperObj         = null;
                TabFacade	  TabFacadeObj		  = null; 

                try
                {
                    ActionBarXMLPath                = new StringBuilder();                    
                    Page_CreatePage.TenantName      = ALParamObj.TenantName;
                    Page_CreatePage.SectionHeading  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Perform_TaskResponse_Shared");
                    TabFacadeObj		            = new TabFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);

                    FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);

                    // set the tenant name of task panes
                    Left_1_tp_MarketingWorkBench.TenantName = ALParamObj.TenantName;

                    Left_1_tp_MarketingWorkBench.TaskPaneName           = SolutionName;
                    Left_1_tp_MarketingWorkBench.SelectedSectionName    = "Perform";  

                    Left_2_tp_PerformGatherInfoTask.TenantName  = ALParamObj.TenantName;
                    Left_2_tp_PerformGatherInfoTask.TaskPaneName = "Perform";

                    Perform_BreadCrumb = (ALBreadCrumb)this.Page_CreatePage.FindControl("PerformGatherInfoTaskBreadcrumb");
                    Perform_BreadCrumb.TenantName = ALParamObj.TenantName;  
                    
                    GatherInfoTaskTab = (ALTab)Page_CreatePage.FindControl("tabTaskResponse");
					GatherInfoTaskTab.TenantName = ALParamObj.TenantName;

                    TabFacadeObj.TabName        = "tabTaskResponse";
					TabFacadeObj.ScreenName     = "TASKRESPONSE";
					TabFacadeObj.SolutionName   = SolutionName;
					TabFacadeObj.InitializeTab(ref GatherInfoTaskTab);

					Panel_TaskDetails           = (ALPanel)GatherInfoTaskTab.FindControl("panelTaskDetails");
					Panel_UserRoles             = (ALPanel)GatherInfoTaskTab.FindControl("panelUserRoles");

                    Literal_TaskInitiator       = (Literal)Panel_UserRoles.FindControl("Literal_TaskInitiator");
                    Literal_TaskInitiator.Text  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_TaskInitiator:_Label_Shared");

					Frm_TaskDetails = (Form)Panel_TaskDetails.FindControl("Content_1_Frm_TaskDetails");
                    Frm_TaskDetails.TenantName = ALParamObj.TenantName;
                    Frm_TaskDetails.SolutionName = SolutionName;   
                    Frm_TaskDetails.CultureInformation = CultureInformation;
                    Frm_TaskDetails.PersonalizationFilePath = FormatXMLPath;
                    Frm_TaskDetails.SeriesActionBarClick +=new EventHandler(Frm_TaskDetails_SeriesActionBarClick);

                    //Hemant Karkande : Do Not Delete this commented code
                    //Lst_PredecessorList = (Assetlink.CustomControls.ListControl)Page_CreatePage.FindControl("Content_2_lc_PredecessorList");
                    //Lst_PredecessorList.TenantName = ALParamObj.TenantName;                    

					Ab_ResponseTask = (ActionBar)Panel_TaskDetails.FindControl("Content_6_ab_Task_ActionBar");
                    Ab_ResponseTask.TenantName = ALParamObj.TenantName;
                    										
                    Ab_ResponseTask.AddAttributes("btn_Submit", "href", "javascript:ValidateForm('$CONTROLID$', '"+ StepID +"')");

                    //Readers List
                    LC_TaskReaders = (CustomControls.ListControl)Panel_UserRoles.FindControl("List_TaskReaders");
                    LC_TaskReaders.TenantName = ALParamObj.TenantName;
                    LC_TaskReaders.EnableIterators = true;

                    //Initiator
					ALPanel_InitiatorSelection = (ALPanel)Panel_UserRoles.FindControl("ID_InitiatorSelection");
                    UC_InitiatorSelection      = (ALUC_ALUserSelection)ALPanel_InitiatorSelection.FindControl("ALUC_InitiatorSelection");

                    Binder_Attachments         = (Binder)Panel_TaskDetails.FindControl("Binder_Documents");
                    Manual_Activities          = (ALPanel)Panel_TaskDetails.FindControl("PS");

                    ActionBarXMLPath.Remove(0, ActionBarXMLPath.Length);
					ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "ForwardTaskActionBarXML"));
                    Ab_ForwardTask.InputXML = ActionBarXMLPath.ToString();
                    
                    //Ab_ForwardTask.AddAttributes("btnCancel", "href", "javascript:hideContentDiv('" + Div_ForwardTask.ClientID + "');");
                    Ab_ForwardTask.AddAttributes("btnCancel", "href", "javascript:" + Popup_ForwardTask.ClosePopupJavascript);

                    MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    //ID_Start_Header.Text = MWB_HelperObj.GetHeaderHTML("Forward Task", Div_ForwardTask.ClientID);
                    Popup_ForwardTask.TenantName        = ALParamObj.TenantName;
                    Popup_ForwardTask.CaptionText       = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Perform_Response_DiscussionTaskcs_Info_ForwardTask_Shared");
                    Popup_ForwardTask.PopupDisplayMode  = ePopupDisplayMode.Simple;
                    Popup_ForwardTask.Style.Add(HtmlTextWriterStyle.Display, "None");

                    //Display Project Info : Anita Kale
                    Sbs_ProjectDetails                  = (SquareBlankSection)Panel_TaskDetails.FindControl("Content_1_sbs_Project_Details");
                    Sbs_ProjectDetails.TenantName       = ALParamObj.TenantName;
                    Sbs_ProjectDetails.SectionHeading   = Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_MWB_Project_Shared");
                    Panel_ProjectDetails                = (ALPanel)Sbs_ProjectDetails.FindControl("ALPanelProjectDetails");

                    if (!IsPostBack)
                        Sbs_ProjectDetails.IsMinimize   = true;

                    Frm_ROProjectDetails                            = (Form)Panel_ProjectDetails.FindControl("Content_2_Frm_Project_Details");
                    Frm_ROProjectDetails.TenantName                 = ALParamObj.TenantName;
                    Frm_ROProjectDetails.CultureInformation         = CultureInformation;
                    Frm_ROProjectDetails.PersonalizationFilePath    = FormatXMLPath;
                    Frm_ROProjectDetails.SolutionName               = SolutionName;

                    //User Group List (Notification on process completion)
                    Lst_UserGroup                   = (CustomControls.ListControl)Panel_UserRoles.FindControl("ListControl_ProcessComplete_UserGroup");
                    Lst_UserGroup.TenantName        = ALParamObj.TenantName;
                    Panel_Templates      = (ALPanel)Panel_TaskDetails.FindControl("PanelTemplates");
                    Lst_TemplateDocument = (CustomControls.ListControl)Panel_Templates.FindControl("LstTemplateDocument");
                    Lst_TemplateDocument.TenantName = ALParamObj.TenantName;
         
                    //Textbox
                    textBoxObj = (TextBox)Panel_TaskDetails.FindControl("tb_NoOfDays");

                    //Checkbox
                    checkBoxObj = (CheckBox)Panel_TaskDetails.FindControl("cb_AdvanceNotification");
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            private void setBreadcrumbs()
            {
                MktgWorkBenchFacadeClass    MWBFacadeObj            = null;
                String                      OutputXML               = null;
                String                      DeliverableName         = null; 
                String                      ProjectName             = null; 
                StringBuilder               SB_BreadCrumbXML        = null; 
                XmlDocument                 OutputXmlDoc            = null;
                XmlNode                     DeliverableTaskNode     = null;
                XmlNode                     ProjectNode             = null; 
                ERRORXML                    ErrorXML                = null;
                String                      ErrorPageURL            = null;
                StringBuilder               str_PrjUrl              = null;
                StringBuilder               str_DelUrl              = null;
                String                      EncryptUrl_Prj          = null;
                String                      EncryptUrl_Del          = null;
                ulong                       ErrorID                 = 0;
                StringBuilder               ErrorPageURL_Exp        = null;

                try
                {
                    OutputXmlDoc        = new XmlDocument();
                    SB_BreadCrumbXML    = new StringBuilder(100);
                    str_PrjUrl          = new StringBuilder(100);
                    str_DelUrl          = new StringBuilder(100);

                    MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, true, out OutputXML);
                    if (String.IsNullOrEmpty(ErrorXML)) 
                    {
                        //Load the OutputXML and get the Project & Deliverable name
                        OutputXmlDoc.LoadXml(OutputXML);

                        DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK");
                        if (DeliverableTaskNode != null)
                        {
                            //HemantK: for Component facet
                            ViewState["ParentDeliverableID"] = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;

                            DeliverableName = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                            __DeliverableID.Value = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                            ProjectNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE");
                            if (ProjectNode != null)
                            {
                                ProjectName = ProjectNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                                __ProjectID.Value = ProjectNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                            }
                        }

                        if (String.Compare(str_ResponseBreadCrumbs, "1", true) == 0)
                        {
                            str_PrjUrl.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode=PERFORM&Access=READ&PrevScreen=PERFORMLIST&BREADCRUMBCTRLID={5}&ResponseBreadCrumbs={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, __ProjectID.Value, Perform_BreadCrumb.BreadcrumbUniqueID, str_ResponseBreadCrumbs);
                            EncryptUrl_Prj = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_PrjUrl.ToString());
                            str_DelUrl.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode=PERFORM&Access=READ&PARENTBREADCRUMBNAME=Project&PrevScreen=PERFORMLIST&BREADCRUMBCTRLID={6}&ResponseBreadCrumbs={7}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, __DeliverableID.Value, __ProjectID.Value, Perform_BreadCrumb.BreadcrumbUniqueID, str_ResponseBreadCrumbs);
                            EncryptUrl_Del = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_DelUrl.ToString());
                        }

                        if ((!String.IsNullOrEmpty(ProjectName)) && (!String.IsNullOrEmpty(DeliverableName)))
                        {
                            //Prepare input XML for breadcrumb
                            SB_BreadCrumbXML.AppendFormat(@"<BreadCrumbs>
                                                                <BreadCrumb Name='Project' NavigationUrl='{0}' DisplayText='{1}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                    <BreadCrumb Name='Deliverable' NavigationUrl='{2}' DisplayText='{3}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                    </BreadCrumb>
                                                                </BreadCrumb>
                                                            </BreadCrumbs>", EncryptUrl_Prj, ALSolutionCommon.TrimAndReplaceSpecialChars(ProjectName), EncryptUrl_Del, ALSolutionCommon.TrimAndReplaceSpecialChars(DeliverableName));
                        }
                        Perform_BreadCrumb.ParentBreadcrumbName = "Deliverable";
                        Perform_BreadCrumb.NavigateUrl          = this.Request.Url.AbsoluteUri;
                        Perform_BreadCrumb.InputXml             = SB_BreadCrumbXML.ToString();
                        Perform_BreadCrumb.Name                 = "Task";
                        //Perform_BreadCrumb.DisplayText          = ViewState["TaskTitle"].ToString();
                    }
                    else
                    {
                        //Error getting parent Deliverable
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML,
                            Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_GetParentsTask_Shared"),
                            null, GetBackURL(), ref ErrorPageURL);

                        if (!IsPostBack)
                        {
                            Response.Redirect(ErrorPageURL, true);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_GatherInfoTask.aspx", "setBreadcrumbs", ExceptionObject, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateDiscussionTask_Exceptionwhilesettingbreadcrumbs_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");

                    throw (ExceptionObject);
                }
            }

            private void setLeftPane()
            {
                LeftPaneFacade LeftPaneObj = null;
                ulong ErrorID = 0;
                StringBuilder ErrorPageURL_Exp = null;

                try
                {
                    LeftPaneObj = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName);
                    LeftPaneObj.SolutionName = SolutionName;
                    LeftPaneObj.GetTaskPaneNode(this.Page, null);
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Request_RequestDetails.aspx", "setLeftPane", ExceptionObject, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_ProjectDetails_Info_ExceptionwhilesettingtheleftpaneforProjectDetailsPage_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void StampNotificationForGatherInfoTask(String TaskID, String InputActivityID, String OldUserXML, String Event)
            {
                String              ReturnTaskXML           = null;
                String              ContributorID           = null;
                String              TaskScreenURL           = null;
                String              NotificationXML         = null;
                String              ActivityID              = null;
                String              OldUserID               = null; 
                XML                 ErrorXML                = null;
                StringBuilder       AssociationXML          = null;
                StringBuilder       Message                 = null;
                StringBuilder       Subject                 = null;
                StringBuilder       FinalMessage            = null;
                StringReader        SR_OldUserXML           = null; 
                XmlDocument         xp_retTaskXMLDoc        = null;    
                XPathDocument       xp_OldUserXMLDoc        = null; 
                XPathNavigator      Root_OldUserXMLDoc      = null;
                XPathNavigator      OldUserNavigator        = null; 
                XPathNavigator      TaskNavigator           = null;
                XPathNavigator      ActivityNav             = null;
                XPathNavigator      ContributorNav          = null;
                XPathNavigator      TempNavigator           = null;
                XPathNavigator      TaskInitiatorNav        = null;
                XPathNavigator      WFProcessNode           = null; 
                XPathNodeIterator   FileSystemIterator      = null;
                NotificationHelper  NotificationHelperObj   = null;
                EmailChannel        EmailChannelObj         = null;
                String              TaskInitiatorID         = null;
                String              TaskInitiatorName       = null; 
                MktgWorkBenchFacadeClass MWBFacadeObj       = null;
                MWB_Helper               MWB_HelperObj      = null; 
                NotificationFacadeClass NotificationFacadeObj = null;

                XML                         TenantXml                   = null;
                XPathDocument               xPathTenantDoc              = null;
                XPathNavigator              xPathTenantNavigator        = null;
                XPathNavigator              xPathTempNavigator          = null;
                InfrastructureFacadeClass   InfrastructureFacadeObject  = null;
                String                      SenderFullName              = null;
                String                      SenderMailID                = null;
                XmlNode                     ProjectManager              = null;
                 String						SenderName					= null;				
                String                      str_ProcessAssoFacets       = null;
                String                      NotificationTypeID          = null;
                    try
                    {
                        //Get the Task.
                        AssociationXML = new StringBuilder(250);
                        MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        
                        //str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                        //if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                        //{
                        //    AssociationXML.Append("<ASSOCIATION>" + str_ProcessAssoFacets + "");
                        //}
                        //else
                        //{
                        //    AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                        //}
                        NotificationTypeID = "5009";
                        MWB_HelperObj.GetAssociatedFacetListForNotifications(NotificationTypeID, ProcessDefinitionID, SolutionName, out str_ProcessAssoFacets);

                        AssociationXML.AppendFormat(@"<SEARCH>
												    <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>                                                      
	                                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
	                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                        {
                            AssociationXML.Append("<SEARCHALLFACETS>FALSE</SEARCHALLFACETS>");
                        }
                        else
                        {
                            AssociationXML.Append("<SEARCHALLFACETS>TRUE</SEARCHALLFACETS>");
                        }

                        AssociationXML.Append(@"<AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                                     <TARGETENTITY>
													<PRIVILEGENAME>READ</PRIVILEGENAME>");
                        if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                        {
                            AssociationXML.Append(str_ProcessAssoFacets);
                        }

                        AssociationXML.Append(@"<FILTERLIST>
										    <FILTER>
											    <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
											    <OPERATOR>EQUALTO</OPERATOR>
											    <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
											    <ISCASESENSITIVE>False</ISCASESENSITIVE>
										    </FILTER>
									    </FILTERLIST>
                                        <RELATIONSHIP NAME='TASKINITIATOR'>
                                            <SELECTLIST>
										        <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									        </SELECTLIST>	
                                        </RELATIONSHIP>
                                        <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                            <SELECTLIST>
										        <EXPRESSION>
											        <FIELDNAME>ACTIVITYID</FIELDNAME>
											        <ALIAS>ACTIVITYID</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>STATUS</FIELDNAME>
											        <ALIAS>STATUS</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>STARTACTIVITY</FIELDNAME>
											        <ALIAS>STARTACTIVITY</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>ENDACTIVITY</FIELDNAME>
											        <ALIAS>ENDACTIVITY</ALIAS>
										        </EXPRESSION>
									        </SELECTLIST>
                                            <RELATIONSHIP NAME='ACTIVITY_CONTRIBUTOR'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                        </RELATIONSHIP>
                                        <RELATIONSHIP NAME='DELIVERABLE_TASK' HIERARCHY='BOTTOMUP'>
                                            <SELECTLIST>
									            <EXPRESSION>
										            <FIELDNAME>PROCESSNAME</FIELDNAME>
										            <ALIAS>PROCESSNAME</ALIAS>
									            </EXPRESSION>
								            </SELECTLIST>
                                            <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
                                                <SELECTLIST>
									                <EXPRESSION>
										                <FIELDNAME>PROCESSNAME</FIELDNAME>
										                <ALIAS>PROCESSNAME</ALIAS>
									                </EXPRESSION>
								                </SELECTLIST>
                                            <RELATIONSHIP NAME='PROJECTMANAGER'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                            <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                            </RELATIONSHIP>
                                            <RELATIONSHIP NAME='DELIVERABLEMANAGER'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
                                                <EXPRESSION>
											        <FIELDNAME>EMAILID</FIELDNAME>
											        <ALIAS>EMAILID</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                        </RELATIONSHIP></TARGETENTITY></SEARCH>");
                           /* AssociationXML.Append(@"<TASKINITIATOR Type='RELATION'>
		                                                <LOGINNAME/>
		                                                <FIRSTNAME/>
		                                                <MIDDLEINITIAL/>
		                                                <LASTNAME/>
	                                                </TASKINITIATOR>
	                                                <PROCESS_ACTIVITY Type='RELATION'>
		                                                <ACTIVITYID/>
		                                                <ACTIVITY_CONTRIBUTOR Type='RELATION'/>
	                                                </PROCESS_ACTIVITY>
	                                                <DELIVERABLE_TASK Type='RELATION' HIERARCHY='BOTTOMUP'>
		                                                <PROCESSNAME/>
		                                                <PROJECT_DELIVERABLE Type='RELATION' HIERARCHY='BOTTOMUP'>
			                                                <PROCESSNAME/>
			                                                <PROJECTMANAGER Type='RELATION'>
				                                                <USERID/>
				                                                <LOGINNAME/>
				                                                <FIRSTNAME/>
				                                                <MIDDLEINITIAL/>
				                                                <LASTNAME/>
			                                                </PROJECTMANAGER>
			                                                <ACTINGPROJECTMANAGER Type='RELATION'>
				                                                <USERID/>
				                                                <LOGINNAME/>
				                                                <FIRSTNAME/>
				                                                <MIDDLEINITIAL/>
				                                                <LASTNAME/>
			                                                </ACTINGPROJECTMANAGER>
		                                                </PROJECT_DELIVERABLE>
		                                                <DELIVERABLEMANAGER Type='RELATION'>
			                                                <USERID/>
			                                                <LOGINNAME/>
			                                                <FIRSTNAME/>
			                                                <MIDDLEINITIAL/>
			                                                <LASTNAME/>
			                                                <EMAILID/>
		                                                </DELIVERABLEMANAGER>
	                                                </DELIVERABLE_TASK>
                                                </ASSOCIATION>");

                        MWBFacadeObj    = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        
                        ErrorXML = MWBFacadeObj.GetTask(TaskID, null, AssociationXML.ToString(), out ReturnTaskXML);*/
                        SearchConfiguration SearchConfigObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        ErrorXML  = SearchConfigObj.GetHierarchialData(AssociationXML.ToString(), ref ReturnTaskXML);
                        if (ErrorXML == null)
                        {
                            ReturnTaskXML = ReturnTaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", String.Empty);
                            ReturnTaskXML = ReturnTaskXML.Replace("</WORKFLOWPROCESSCOLLECTION>", String.Empty);
                            //Email Stamping for the contributor of 1st step from Task.
                            //retTaskXML          = new StringReader(ReturnTaskXML);
                            xp_retTaskXMLDoc    = new XmlDocument();
                            xp_retTaskXMLDoc.LoadXml(ReturnTaskXML);
                            TaskNavigator       = xp_retTaskXMLDoc.CreateNavigator();

                            FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");

                            while (FileSystemIterator.MoveNext())
                            {
                                TempNavigator = FileSystemIterator.Current;
                                TempNavigator.DeleteSelf();
                                FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");
                                
                            }

                            
                            if (Event.ToUpper() == "TASKFORWARD")
                            {
                                SR_OldUserXML = new StringReader(OldUserXML);
                                xp_OldUserXMLDoc = new XPathDocument(SR_OldUserXML);
                                Root_OldUserXMLDoc = xp_OldUserXMLDoc.CreateNavigator();
                                OldUserNavigator = Root_OldUserXMLDoc.SelectSingleNode("OLDUSER");
                                OldUserID = OldUserNavigator.SelectSingleNode("USER/USERID").Value;

                                ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID/text() ='" + InputActivityID + "']");
                                if ((ActivityNav != null) && (ActivityNav.HasChildren))
                                {
                                    ContributorNav = ActivityNav.SelectSingleNode("ACTIVITY_CONTRIBUTOR");
                                    if ((ContributorNav != null) && (ContributorNav.HasChildren))
                                    {
                                        ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;
                                       // if (ContributorID != ALParamObj.UserID)
                                        {
                                            NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                            NotificationHelperObj.Init("5009", OldUserID, __ProcessDefinitionID.Value);

                                            EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                            EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                            //By: Bhalchandra
                                            //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //By: Bhalchandra
                                            //Date : September,12 2007
                                            //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //Create ActingProjectManager attribute and set it to ACTINGPROJECTMANAGER Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/ACTINGPROJECTMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("ActingProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //Create TaskInitiator attribute and set it to TASKINITIATOR Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("TaskInitiator", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            NotificationHelperObj.AddChannel(EmailChannelObj);
                                            //Get the TaskInitiator Node

                                            Message		= new StringBuilder();
                                            SenderName	= ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName());
                                            //ReceiverName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav));
                                            Message.AppendFormat("<MESSAGE Sender='{0}'>{1}</MESSAGE>", SenderName, TaskNavigator.InnerXml);

                                            Subject = new StringBuilder();
                                            Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                            ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                            TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "RESPONSE", ActivityID);

                                            ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                            ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                            ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                            ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                            if (ErrorXML == null && NotificationXML != null)
                                            {
                                                NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                                ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                            }
                                        }
                                    }
                                }
                            }
                            else if (Event.ToUpper() == "TASKCOMPLITION")
                            {
                                ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID/text() ='" + InputActivityID + "']");
                                //while (Contributors_Activities.MoveNext())
                                {
                                    WFProcessNode = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS");
                                    if ((ActivityNav != null) && (ActivityNav.HasChildren))
                                    {
                                        TaskInitiatorNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                        if ((TaskInitiatorNav != null) && (TaskInitiatorNav.HasChildren))
                                        {
                                            TaskInitiatorName = MWB_HelperObj.getUserName(TaskInitiatorNav);
                                            TaskInitiatorID = TaskInitiatorNav.SelectSingleNode("USER/USERID").Value;
                                        }

                                        InfrastructureFacadeObject = new InfrastructureFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                                        #region Get Sender Details
                                        ErrorXML = InfrastructureFacadeObject.GetTenantXml(ref TenantXml);

                                        if (ErrorXML == null)
                                        {
                                            xPathTenantDoc = new XPathDocument(new StringReader(TenantXml));
                                            xPathTenantNavigator = xPathTenantDoc.CreateNavigator();

                                            xPathTempNavigator = xPathTenantNavigator.SelectSingleNode("/CONFIGURATION/CHANNELSETTINGS/CHANNEL[@NAME='EMAIL']/MAILBOXUSER");
                                            if (xPathTempNavigator != null)
                                                SenderFullName = xPathTempNavigator.Value;
                                            xPathTempNavigator = null;

                                            xPathTempNavigator = xPathTenantNavigator.SelectSingleNode("/CONFIGURATION/CHANNELSETTINGS/CHANNEL[@NAME='EMAIL']/MAILBOXEMAILID");
                                            if (xPathTempNavigator != null)
                                                SenderMailID = xPathTempNavigator.Value;
                                            xPathTempNavigator = null;

                                        }
                                        #endregion

                                        {
                                            EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                            EmailChannelObj.AddRecipient("TO", TaskInitiatorID, false);

                                            NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);

                                            NotificationHelperObj.Init("5005", "102"); //Mail sent on behalf of system so we user admin as sender;
                                            NotificationHelperObj.AddChannel(EmailChannelObj);

                                            //By: Bhalchandra
                                            //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //By: Bhalchandra
                                            //Date : September,12 2007
                                            //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                            ProjectManager = null;
                                            ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                            if (ProjectManager != null)
                                                ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                            //Get the Activity id
                                            ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                            FinalMessage = new StringBuilder();
                                            FinalMessage.AppendFormat("<WORKFLOWPROCESS>");
                                            FinalMessage.AppendFormat("{0}", WFProcessNode.InnerXml);
                                            FinalMessage.AppendFormat("<PROCESS_RESPONSE>");
                                            FinalMessage.AppendFormat("<RESPONSE>");
                                            FinalMessage.AppendFormat("<RESPONSETEXT>{0}</RESPONSETEXT>", "Task Completed");
                                            FinalMessage.AppendFormat("</RESPONSE>");
                                            FinalMessage.AppendFormat("</PROCESS_RESPONSE>");
                                            FinalMessage.AppendFormat("</WORKFLOWPROCESS>");
                                            Message = new StringBuilder();
                                            Message.AppendFormat("<MESSAGE>{0}</MESSAGE>", TaskNavigator.InnerXml);

                                            Subject = new StringBuilder();
                                            Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", FinalMessage.ToString());


                                            TaskScreenURL = GetEmailScreenURL();

                                            ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                            ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                            ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);
                                            ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);
                                            if (ErrorXML == null && NotificationXML != null)
                                            {
                                                NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                                ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                                if (ErrorXML != null)
                                                {
                                                    //ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, Request.Url.ToString(), ref ErrorPageURL);
                                                    //if (!IsPostBack)
                                                    //{
                                                    //    //Response.Redirect(ErrorPageURL);
                                                    //}
                                                    //else
                                                    //  Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                                }
                                            }
											//ErrorXML = MWBFacadeObj.UpdateTask(TaskID, true, MWB_TimeLineEvents.CALCULATE_COMPLETE_TIMELINE, false, ref TempXml);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    catch(Exception ExceptionObj)
                    {
                        throw ExceptionObj;
                    }
                }
        
            private String GetEmailScreenURL()
            {
                String          DefaultPageMode             = null;
                String          CommunicationProtocol       = null;
                String          InternetAddress             = null;
                StringBuilder   DefaultPageParameterList    = null;
                StringBuilder   ParameterList               = null;
                StringBuilder   SolutionPageUrl             = null;
                StringBuilder   DefaultPageUrl              = null;

                try
                {   
                    DefaultPageMode       = "EMAIL";
                    CommunicationProtocol = ALCommon.GetCommunicationProtocol();
                    InternetAddress       = ALCommon.GetInternetAddress();
                    
                    SolutionPageUrl  = new StringBuilder();
                    SolutionPageUrl.AppendFormat("{0}{1}/{2}/{3}/ASPX/WorkBenchLinkHandler.ashx", CommunicationProtocol, InternetAddress, ALParamObj.TenantName, SolutionName);

                    ParameterList = new StringBuilder();
                    ParameterList.AppendFormat("Mode=MANAGE&SourceID={0}&SourceType=TASK", TaskID);

                    DefaultPageParameterList = new StringBuilder();
                    DefaultPageParameterList.AppendFormat("Language={0}&Mode={1}&SolutionPage={2}&Param={3}", ALParamObj.Language, DefaultPageMode, SolutionPageUrl, ALCommon.Encrypt(ParameterList.ToString()));
                    
                    DefaultPageUrl = new StringBuilder();
                    DefaultPageUrl.AppendFormat("{0}{1}/{2}/default.aspx?{3}", CommunicationProtocol, InternetAddress, ALParamObj.TenantName, DefaultPageParameterList.ToString());
                    
                    DefaultPageUrl = DefaultPageUrl.Replace("&", "%26");

                    return DefaultPageUrl.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            private void setActionBar(bool IsResponder)
            {
				StringBuilder	ActionBarXMLPath		= null;
				XmlDocument		ActionbarDoc			= null;				
				XmlNode			ActionControlListNode	= null;
				try
				{
					ActionBarXMLPath = new StringBuilder();
					ActionbarDoc	 = new XmlDocument();					
					ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Perform_ResponseGatherInfoTask_Content_6_ab_Task_ActionBar_ActionBar"));
					Ab_ResponseTask.InputXML = ActionBarXMLPath.ToString();
					ActionbarDoc.Load(ActionBarXMLPath.ToString());
					if (!IsResponder)
					{
						ActionControlListNode = ActionbarDoc.SelectSingleNode("ActionControlList");
						ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_SaveAndClose']"));
						ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_Submit']"));
						ActionControlListNode.RemoveChild(ActionControlListNode.SelectSingleNode("ActionControl[@Name='btn_ForwardTask']"));
					}
					Ab_ResponseTask.InputXML = ActionbarDoc.InnerXml;
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
            }
            
            private void gotoErrorPage(String ErrorMessage)
			{			
				StringBuilder   BackURL			= null;
				String			strErrorPageUrl	= null;
				StringBuilder	ErrorPageUrl	= null;
				try
				{
                    BackURL         = new StringBuilder();
					ErrorPageUrl	= new StringBuilder();

                    BackURL.AppendFormat("/{0}/Common/ASPX/DefaultScene_DefaultPage.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID);
					ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "WORKFLOWPROCESS", null, ErrorMessage, null, BackURL.ToString(), ref strErrorPageUrl);				
                    if (!IsPostBack)
                    {
                        Response.Redirect(strErrorPageUrl, true);
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + strErrorPageUrl + "','_self','');");

				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
			}
	
			private String GetBackURL()
			{
				StringBuilder ParamURL  = null;
				//StringBuilder URL       = null;              
				try
				{
					ParamURL = new StringBuilder();
					//URL = new StringBuilder();
					ParamURL.AppendFormat("/{0}/{4}/ASPX/PerformList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID,SolutionName);
					return ParamURL.ToString();
				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
			}		
									
			private void setSelectedTab()
			{
				try
				{
					switch(SelectedTab.ToUpper())
					{
						case "INFO":
							GatherInfoTaskTab.SelectedTab = Panel_TaskDetails;
							GatherInfoTaskTab.SelectedTabName = "Info";
							break;
						case "USER ROLES":
							GatherInfoTaskTab.SelectedTab = Panel_UserRoles;
							GatherInfoTaskTab.SelectedTabName = "User Roles";
							break;					
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}
			
			private void GetUserRoles()
			{
				MktgWorkBenchFacadeClass MWBFacadeObj		= null; 
				ERRORXML				 ErrorXML			= null;
				StringBuilder			 AssociationXML		= null;
				StringBuilder			 AttributesXML		= null;			
				XML						 ReturnTaskXML		= null;
				XmlNode					 TaskInitiatorNode	= null;
				XmlDocument				 TaskDoc			= null;
				String					 ErrorPageURL		= null;
                XML                      xml_Users          = null;
                XML                      xml_Groups         = null;
                XmlNode                  xmlnode_User       = null;
                XmlNode                  xmlnode_Group      = null;
                XPathNavigator          nav_TaskReaderGroups= null;
                XPathNavigator          nav_TaskReaderUsers = null;

				try
				{
					MWBFacadeObj	= new MktgWorkBenchFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
					AssociationXML	= new StringBuilder();
					AttributesXML	= new StringBuilder();
					AttributesXML.Append(@"<WORKFLOWPROCESS>
											<WORKFLOWPROCESSID/>
										   </WORKFLOWPROCESS>");
					AssociationXML.AppendFormat(@"<ASSOCIATION>
													<READERS Type='RELATION'>
														<LOGINNAME/>
														<FIRSTNAME/>
														<MIDDLEINITIAL/>
														<LASTNAME/>
                                                        <FILTERLIST>
                                                            <FILTER>
	                                                            <EXPRESSION>STATUS</EXPRESSION>
	                                                            <OPERATOR>EQUALTO</OPERATOR>
	                                                            <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
	                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
                                                            </FILTER>
                                                        </FILTERLIST>
													</READERS>
                                                    <PROCESSREADER_GROUPS Type='RELATION'>
                                                        <GROUPID />
                                                        <GROUPNAME />
                                                        <FILTERLIST>
                                                            <FILTER>
                                                                <EXPRESSION>ISDELETED</EXPRESSION>
                                                                <OPERATOR>EQUALTO</OPERATOR>
                                                                <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            </FILTER>
                                                        </FILTERLIST>
                                                    </PROCESSREADER_GROUPS>
													<TASKINITIATOR Type='RELATION'>
														<LOGINNAME/>
														<FIRSTNAME/>
														<MIDDLEINITIAL/>
														<LASTNAME/>
													</TASKINITIATOR>
                                                    <PROCESSCOMPLETION_GROUP Type='RELATION'>
                                                        <GROUPNAME/>
                                                        <ISDELETED/>
                                                        <FILTERLIST>
	                                                        <FILTER>
		                                                        <EXPRESSION>ISDELETED</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                        </FILTER>
                                                        </FILTERLIST>
                                                    </PROCESSCOMPLETION_GROUP>
                                                    <PROCESSCOMPLETION_USER Type='RELATION'>
                                                        <STATUS/>
                                                        <LOGINNAME/>
                                                        <FIRSTNAME/>
                                                        <MIDDLEINITIAL/>
                                                        <LASTNAME/>
                                                        <EMAILID/>
                                                        <FILTERLIST>
	                                                        <FILTER>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                        </FILTER>
                                                        </FILTERLIST>
                                                    </PROCESSCOMPLETION_USER>
												  </ASSOCIATION>");
					ErrorXML = MWBFacadeObj.GetTask(TaskID, AttributesXML.ToString(), AssociationXML.ToString(), out ReturnTaskXML);
					if (ErrorXML == null)
					{
						TaskDoc		= new XmlDocument();
						TaskDoc.LoadXml(ReturnTaskXML);

                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS") != null)
                            nav_TaskReaderGroups = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS").CreateNavigator();

                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS") != null)
                            nav_TaskReaderUsers = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS").CreateNavigator();

                        setTaskReadersUserGroupList(nav_TaskReaderGroups, nav_TaskReaderUsers);

                        TaskInitiatorNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
						setInitiatorSelectionControl(TaskInitiatorNode);

                        //paint process completion users
                        xmlnode_User    = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_USER");
                        if (xmlnode_User != null)
                            xml_Users   = xmlnode_User.InnerXml;

                        xmlnode_Group   = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_GROUP");
                        if (xmlnode_Group != null)
                            xml_Groups = xmlnode_Group.InnerXml;
                        populateUserGroupList(xml_Users, xml_Groups);
					}
					else
					{
						ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
						if(!IsPostBack)
						{
							Response.Redirect(ErrorPageURL, true);
						}
						else
							Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
					}
				}
				catch(Exception Excepobj)
				{
					throw Excepobj;
				}
			}

			private XML GetSearchXML(String GpName)
			{
				StringBuilder Search = null;
				try
				{
					Search = new StringBuilder();
					Search.AppendFormat(@"<INPUTXML>
											<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
											<SEARCHCOLLECTION>
											<SEARCH>
											<TARGETOBJECT>USER</TARGETOBJECT>
											<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
											<ISCASESENSITIVE>False</ISCASESENSITIVE>
											<SEARCHALLFACETS>False</SEARCHALLFACETS>
											<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
											<FILTERLIST>
												<FILTER>
													<FIELDNAME>GROUPNAME</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>{4}</FIELDVALUE>
													<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
												<FILTER>
													<FIELDNAME>STATUS</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>ACTIVE</FIELDVALUE>											
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
											</FILTERLIST>
											<FIELDCOLLECTION>
												<TARGETENTITYFIELDS>
													<FIELD>USERID</FIELD>
													<FIELD>LOGINNAME</FIELD>
													<FIELD>FIRSTNAME</FIELD>
													<FIELD>LASTNAME</FIELD>
													<FIELD>MIDDLEINITIAL</FIELD>
													<FIELD>EMAILID</FIELD>													
												</TARGETENTITYFIELDS>
											</FIELDCOLLECTION>
											</SEARCH>
											</SEARCHCOLLECTION>
										</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
					return Search.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private XML GetSearchXMLForGroupAndUsers(String GpName)
			{
				StringBuilder Search = null;
				try
				{
					Search = new StringBuilder();
					Search.AppendFormat(@"<INPUTXML>
											<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
											<SEARCHCOLLECTION>
											<SEARCH>
											<TARGETOBJECT>GROUP</TARGETOBJECT>
											<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
											<ISCASESENSITIVE>False</ISCASESENSITIVE>
											<SEARCHALLFACETS>False</SEARCHALLFACETS>
											<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
											<FILTERLIST>
												<FILTER>
													<FIELDNAME>GROUPNAME</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>{4}</FIELDVALUE>												
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
												<FILTER ApplyFilter=""Yes"">
													<FILTERID>2</FILTERID>
													<FIELDNAME>STATUS</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>ACTIVE</FIELDVALUE>
													<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
											</FILTERLIST>
											<FIELDCOLLECTION>
                                                <TARGETENTITYFIELDS>
                                                    <FIELD>GROUPID</FIELD>
                                                </TARGETENTITYFIELDS>
												<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'>
														<FIELD>USERID</FIELD>
														<FIELD>LOGINNAME</FIELD>
														<FIELD>FIRSTNAME</FIELD>
														<FIELD>LASTNAME</FIELD>
														<FIELD>MIDDLEINITIAL</FIELD>
														<FIELD>EMAILID</FIELD>											
													</RELATEDENTITYFIELDS>
											</FIELDCOLLECTION>
											</SEARCH>
											</SEARCHCOLLECTION>
										</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
					return Search.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private void DeleteTempFiles()
			{
				String			TempPath				= null;
				StringBuilder	TempFilePath			= null;
				String			SelectedValueFileName	= null;
				try
				{
					TempFilePath = new StringBuilder();
					TempPath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					TempFilePath.AppendFormat("{0}{1}",TempPath,TaskFile);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);
					TempFilePath.AppendFormat("{0}{1}", TempPath, StepResourceFileName);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);
					TempFilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);

                    SelectedValueFileName = StepID + "_GroupUsers.xml";
					TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);

                    SelectedValueFileName = StepID + "_ContributorGroup_SelectedValueList.xml";
					TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);

                    if (ResponseForm != null)
                    {
                        TempFilePath.AppendFormat("{0}{1}.xml", TempPath, ResponseForm.ID);
                        if (File.Exists(TempFilePath.ToString()))
                            File.Delete(TempFilePath.ToString());
                        TempFilePath.Remove(0, TempFilePath.Length);
                    }

                    //HemantK:To Delete Component Facet Series file
                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.AppendFormat("{0}{1}{2}", TempPath, TaskID, str_ComponentFacetFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());
                    
                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + StepID + str_SelectedComponentsIDFileName);
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        File.Delete(TempFilePath.ToString());
                    }

                    //Anita Kale: To delete Temp file for Project Info form Input
                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.AppendFormat("{0}{1}{2}", TempPath, TaskID, str_ProjectInfoTempFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());

				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private void setControlProperties()
			{
				try
				{
					GatherInfoTaskTab.onTabClick += new ALTab.TabEventHandler(GatherInfoTaskTab_onTabClick);
					Ab_ResponseTask.Click += new EventHandler(Ab_ResponseTask_Click);
					Ab_ForwardTask.Click += new EventHandler(Ab_ForwardTask_Click);
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}
        
            /// <alsummary>
            /// <createddate>03 December 2008</createddate>
            /// <author>Hemant Karkande</author>
            /// <purpose>To Handle clicks on the Component Facet Series List Action bar.</purpose>
            /// </alsummary>
            private void ResponseForm_SeriesActionBarClick(object sender, EventArgs e)
            {                
		        ulong			ErrorID				= 0;
                StringBuilder	ErrorPageURL_Exp	= null;
                StringBuilder   ParamURL            = null;
                StringBuilder   URL                 = null;
                String          EncryptURL          = null;
                String          str_DeliverableId   = null;

                try
                {
                    ParamURL        = new StringBuilder();
                    URL             = new StringBuilder(); 
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                    if (Parameters[1].Equals("SaveSeriesRecord"))
                    {
                        //ErrorXML = SaveComponentList();
                        //if (!String.IsNullOrEmpty(ErrorXML))
                        //{
                        //    //Redirect to error page.
                        //    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_COMPONENTFACETUPDATEFAILED"), null, GetBackURL(), ref EncryptURL);
                        //    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                        //}
                    }
                    else if (Parameters[1].Equals("SelectSeriesRecord"))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableId = ViewState["ParentDeliverableID"].ToString();
                        }
                        ParamURL.AppendFormat("Manage_SelectSigns.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&HiddenButtonID={4}&TaskID={5}&DeliverableID={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Btn_Hidden_SelectSigns.UniqueID, TaskID, str_DeliverableId);
                        ParamURL.Append("&OutPutFileName=" + StepID + str_SelectedComponentsIDFileName + "&SelectFor=STEP&StepID=" + StepID);
                        EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                        URL.AppendFormat("window.open('" + "{0}" + "','_new','left=120,top=120,width=1085,height=800,scrollbars=yes');", EncryptURL.ToString());
                        Ajax.WriteExecuteJavaScript(URL.ToString());
                    }
                    else if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                    {
                        getDigitalAssetsFromFacetIDs("STEP");
                    }
                    else if (Parameters[1].Equals("EditSeriesRecord"))
                    {
                        if ((ViewState["ComponentFacetFieldName"] != null) && (Parameters[0].Contains(ViewState["ComponentFacetFieldName"].ToString())))
                        {
                            GetEditPageUrl();
                        }
                        else
                        {
                            String EditPageUrl = ResponseForm.GetSeriesEditRecordsUrl();
                            if (!String.IsNullOrEmpty(EditPageUrl))
                            {
                                Ajax.WriteExecuteJavaScript(EditPageUrl);
                            }
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_GatherInfo_Task.asp.cs", "ResponseForm_SeriesActionBarClick", ExceptionObject, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_RODeliverableDetails_ExceptionwhilesavingComponentList_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }    
             }

            /// <summary>
            /// <CreatedOn>03 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To save the list</Purpose>
            /// </summary>
            private ERRORXML SaveComponentList()
            {
                ERRORXML        ErrorXML                    = null; 
                String          strActivityDefID            = null; 
                String          strStdFormName              = null; 
                String          ResponseFormID              = null; 
                String          strSelectedFormName         = null; 
                String          strFormName                 = null;                 
                StringBuilder   sb_TempPath                 = null; 
                StringBuilder   sb_Del_ComponentFacetSeries = null; 
                XML             ResponseXML                 = null; 
                FormFacade      FormFacadeObj               = null;
                MWB_Helper      MWB_HelperObj               = null; 
                XmlDocument     doc_InputXML                = null;
                XmlNode         node_Activity               = null;
                XPathDocument   xp_ResponseXML              = null;
                XPathNavigator  nav_Response                = null; 
                XmlNode         node_Response               = null; 
                
                try
                {
                    FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    sb_TempPath   = new StringBuilder(50);

                    sb_TempPath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile);
                    if (File.Exists(sb_TempPath.ToString()))
                    {
                        //Get the Form data XML
                        doc_InputXML = new XmlDocument();
                        doc_InputXML.Load(sb_TempPath.ToString());    

                        strStdFormName  = "StepDetails_Response";
                        ResponseFormID  = __ResponseFormID.Value;
                        node_Activity   = doc_InputXML.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']");
                        strActivityDefID= node_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
                        strFormName     = strActivityDefID + "_Response";

                        MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
                        FormFacadeObj.FormName = strSelectedFormName;
                        FormFacadeObj.SolutionName = SolutionName;
                        
                        ResponseObjInfoList = (List<ObjectInfo>)ViewState["ResponseObjInfo"];
                        ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", ResponseForm, ResponseObjInfoList, out ResponseXML);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(ResponseXML)))
                        {
                            ErrorXML = UpdateDeliComponentFacetSeries(ref ResponseXML, "ACTIVITY");
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                sb_TempPath.Remove(0, sb_TempPath.Length);
                                sb_TempPath.AppendFormat("{0}{1}.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ResponseFormID);
                                if (File.Exists(sb_TempPath.ToString()))
                                {
                                    File.Delete(sb_TempPath.ToString());
                                }

                                //Delete the component file
                                sb_Del_ComponentFacetSeries = new StringBuilder(50);
                                sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                                if (File.Exists(sb_Del_ComponentFacetSeries.ToString()))
                                {
                                    File.Delete(sb_Del_ComponentFacetSeries.ToString());
                                }

                                //Put the response if any in the activity node to manage the state
                                xp_ResponseXML = new XPathDocument(new StringReader(ResponseXML));
                                nav_Response = xp_ResponseXML.CreateNavigator().SelectSingleNode("ACTIVITY/ACTIVITY_RESPONSE");
                                if ((nav_Response != null) && (nav_Response.HasChildren))
                                {
                                    node_Response = node_Activity.SelectSingleNode("ACTIVITY_RESPONSE");
                                    if (node_Response != null)
                                    {
                                        node_Response.InnerXml = nav_Response.InnerXml;
                                    }
                                    else
                                    {
                                        node_Response = doc_InputXML.CreateElement("ACTIVITY_RESPONSE");
                                        ((XmlElement)node_Response).SetAttribute("TYPE", "RELATION");
                                        node_Response.InnerXml = nav_Response.InnerXml;
                                        node_Activity.AppendChild(node_Response);
                                    }
                                }

                                nav_Response = xp_ResponseXML.CreateNavigator().SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                                if (nav_Response != null)
                                {
                                    node_Response = node_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                                    if (node_Response != null)
                                    {
                                        node_Response.InnerXml = nav_Response.InnerXml;
                                    }
                                }

                                //set the response form again.
                                setActivityResponseForm_ComponentList(node_Activity,true);
                            }
                        }
                    }
                    return ErrorXML; 
                }
                catch (ThreadAbortException)
                { return ErrorXML; }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>08 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To set the activity response form</Purpose>
            /// </summary>
            /// <param name="node_Activity">Activity node</param>
            private void setActivityResponseForm_ComponentList(XmlNode  node_Activity, Boolean b_SetDeliverableComponentFacet)
            {
                StringBuilder   StepFormID          = null;
                StringBuilder   ActivityColl        = null;
                StringBuilder   ParameterList       = null;
			    StringBuilder	TempFilePath		= null;
                String          FormConfigXMLPath   = null; 
                String          TempPath            = null;
                MWB_Helper      MWBHelperClassObj   = null;
                FormFacade      FormFacadeObj       = null;
                ERRORXML        ErrorXML            = null;
                XML             FormConfigXML       = null;
                XML             StepFormInputXML    = null;
                XmlDocument     StepDoc             = null;
                XmlAttribute    UploadAttr          = null;
                XmlNode         FieldNode           = null;
                XmlNode         UploadUrlNode       = null;
			    String			strFormName			= null;
			    String			strStdFormName		= null;
			    String			strSelectedFormName	= null;
			    String			strActivityDefID	= null;
                String          SearchXML           = null;
                
                try
                {
                    StepFormID          = new StringBuilder(100);
                    ActivityColl        = new StringBuilder(100);
                    ParameterList       = new StringBuilder(100);
				    TempFilePath		= new StringBuilder(100);
                    StepDoc             = new XmlDocument();
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

                    strActivityDefID    = node_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
                    strFormName			= strActivityDefID+ "_Response";
                    strStdFormName		= "StepDetails_Response";
                    FormConfigXMLPath   = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);

                    FormFacadeObj.FormName      = strSelectedFormName;
                    FormFacadeObj.SolutionName  = SolutionName;
                    StepFormID.AppendFormat("STEP_{0}", node_Activity.SelectSingleNode("ACTIVITYID").InnerText);

                    FormFacadeObj.ShowConfiguredFields	= true;
                    FormConfigXML = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, node_Activity.SelectSingleNode("ACTIVITYNAME").InnerText, true);
                    
                    //HemantK: check for the deliverable component facet series
                    if ( b_SetDeliverableComponentFacet)
                    {
                        FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                        ErrorXML = SetDeliverableComponentFacetSeries(ref node_Activity, ref FormConfigXML, SearchXML);
                    }
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", node_Activity.OuterXml);
				        ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
				        ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                        if (ErrorXML == null)
                        {
                            StepDoc.LoadXml(StepFormInputXML);
                            FieldNode = StepDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                            if (FieldNode != null)
                            {
                                ParameterList.AppendFormat("&TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName);
                                if (FieldNode.Attributes.GetNamedItem("UploadURL") != null)
                                {
                                    UploadUrlNode = FieldNode.Attributes.GetNamedItem("UploadURL");                            
                                    UploadUrlNode.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                                }
                                else
                                {
                                    UploadAttr = StepDoc.CreateAttribute("UploadURL");
                                    UploadAttr.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                                    FieldNode.Attributes.Append(UploadAttr);
                                }
                                if (FieldNode.Attributes.GetNamedItem("DownLoadURL") != null)
                                {
                                    UploadUrlNode = FieldNode.Attributes.GetNamedItem("DownLoadURL");
                                    UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                                }
                                else
                                {
                                    UploadAttr = StepDoc.CreateAttribute("DownLoadURL");
                                    UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                                    FieldNode.Attributes.Append(UploadAttr);
                                }
                            }
                            ResponseForm.InputXML = StepDoc.OuterXml;
                            //ResponseForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                            ResponseForm.ResetFacetSeriesFields();
                            TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID.ToString());
					        File.WriteAllText(TempFilePath.ToString(), StepFormInputXML);
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <CreatedOn>29 November 2008</CreatedOn>
            /// <Purpose>To put the deliverable component facet series data in inputxml</Purpose>
            /// </summary>
            /// <param name="InputXMLDoc"></param>
            /// <param name="FormConfigXML"></param>
            private ERRORXML SetDeliverableComponentFacetSeries(ref XmlNode ActivityNode, ref String FormConfigXML, String SearchXML)
            {
                String          str_DeliverableProcessId    = null; 
                String          str_ComponentFacetRShipName = null;
                String          str_InputXML                = null; 
                XmlDocument     InputXMLDoc                 = null; 
                String          str_ComponentFacetFieldName = null; 
                MWB_Component   MWB_ComponentObj            = null; 
                String          str_ComponentUserStatus     = null;
                String          str_ComponentSystemStatus   = null;
                XmlNode         node_ActivityDefinitionID   = null;
                String          str_ActivityDefinitionID    = null;
                ERRORXML        ErrorXMLString              = null;
                String          ErrorPageURL                = null;                 
                ulong           ErrorID                     = 0;
                String          str_ComponentAssetRShip     = null;
                String          str_PrimaryKey              = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    node_ActivityDefinitionID = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                    if (node_ActivityDefinitionID != null)
                    {
                        str_ActivityDefinitionID = node_ActivityDefinitionID.InnerText;
                    }

                    if (!String.IsNullOrEmpty(FormConfigXML))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                            str_InputXML = ActivityNode.OuterXml;

                            //Check for the Deliverable details
                            if ((ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] != null) && (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""].ToString() != "No"))
                            {
                                str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                                ErrorXMLString = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "ACTIVITY", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                                if (String.IsNullOrEmpty(ErrorXMLString))
                                {
                                    InputXMLDoc = new XmlDocument();
                                    InputXMLDoc.LoadXml(str_InputXML);
                                    ActivityNode = InputXMLDoc.DocumentElement;
                                }
                                else
                                {
                                    //Redirect to error page.
                                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                    if (!IsPostBack)
                                    {
                                        Response.Redirect(ErrorPageURL, true);
                                    }
                                    else
                                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                }
                            }
                            else
                            {
                                if (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] == null)
                                {
                                    ErrorXMLString = MWB_ComponentObj.GetComponentFacetForTaskActivity(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_ActivityDefinitionID, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, "ACTIVITY", str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, SearchXML, out str_PrimaryKey, out str_ComponentAssetRShip);
                                    if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(str_ComponentFacetRShipName)) && (!String.IsNullOrEmpty(str_ComponentFacetFieldName)))
                                    {
                                        ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "Yes";
                                        if (ViewState["ComponentFacetSeriesRShipName"] == null)
                                        {
                                            ViewState["ComponentFacetSeriesRShipName"] = str_ComponentFacetRShipName;
                                        }
                                        if (ViewState["ComponentFacetFieldName"] == null)
                                        {
                                            ViewState["ComponentFacetFieldName"] = str_ComponentFacetFieldName;
                                        }
                                        if (ViewState["ComponentFacetPrimaryKey"] == null)
                                        {
                                            ViewState["ComponentFacetPrimaryKey"] = str_PrimaryKey;
                                        }
                                        if ((!String.IsNullOrEmpty(str_ComponentAssetRShip)) && (ViewState["ComponentAssetRShipName"] == null))
                                        {
                                            ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                        }
                                        InputXMLDoc = new XmlDocument();
                                        InputXMLDoc.LoadXml(str_InputXML);
                                        ActivityNode = InputXMLDoc.DocumentElement;
                                    }
                                    else if (!String.IsNullOrEmpty(ErrorXMLString))
                                    {
                                        //Redirect to error page.
                                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                        if (!IsPostBack)
                                        {
                                            Response.Redirect(ErrorPageURL, true);
                                        }
                                        else
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                    }
                                    else if (String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                    {
                                        ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "No";
                                    }
                                }
                            }

                            //Radha: For component facet series action bar.
                            if ((ViewState["ComponentUserStatus"] == null) && (!String.IsNullOrEmpty(str_ComponentUserStatus)))
                            {
                                ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                            }
                        }
                    }
                    return ErrorXMLString;
                }
                catch (ThreadAbortException)
                { return ErrorXMLString; }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfoTask.aspx", "SetDeliverableComponentFacetSeries", ExceptionObj, null, null);
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackURL(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXMLString;
                }
            }

            /// <summary>
            /// <CreatedOn>8 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To update the deliverable component facet seires</Purpose>
            /// </summary>
            /// <param name="SaveTaskXML"></param>
            /// <returns></returns>
            private ERRORXML UpdateDeliComponentFacetSeries(ref String SaveTaskXML, String str_RootNode)
            {
                ERRORXML        ErrorXMLString              = null; 
                String          str_DeliverableProcessId    = null; 
                String          str_ComponentFacetRShipName = null;
                MWB_Component   MWB_ComponentObj            = null; 
                String          str_selectedcomponents      = null;
                String          str_ComponentFacetName      = null;
                String          str_PrimaryKey              = null;
                XPathDocument   xpathDoc_ComponentFormConfig= null;
                XPathNavigator  xpathNav_ComponentFacet     = null;
                Boolean         b_UpdateTaskActivity        = false;                
     
                try
                {
                    //Take out the Compoent Facet Series from the input xml and update the deliverable
                    //and return the InputXML by removing the Component Facet Series nodes.
                    if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        str_DeliverableProcessId    = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        
                        xpathDoc_ComponentFormConfig = new XPathDocument(new StringReader(ResponseForm.ConfigurationXML));
                        xpathNav_ComponentFacet = xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "' and @IsSeries='YES']");
                        if (xpathNav_ComponentFacet != null)
                        {
                            //Read the Sort order and sort column
                            str_ComponentFacetName  = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                            str_PrimaryKey          = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                            if (xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                            {
                                b_UpdateTaskActivity = true;
                            }
                        }
                        MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        ErrorXMLString = MWB_ComponentObj.SaveComponentFacetData(str_DeliverableProcessId, str_ComponentFacetRShipName, str_RootNode, ref SaveTaskXML, b_UpdateTaskActivity, str_ComponentFacetName, str_PrimaryKey, out str_selectedcomponents);
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }        

            /// <summary>
            /// <CreatedOn>08 December 2008</CreatedOn> 
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To check the status of the Deliverable component facet series and depending on that set the form mode</Purpose>
            /// </summary>
            /// <param name="Frm_ToChange">Form whose mode is to be set</param>
            private void CheckComponentFacetSeriesStatus(Form Frm_ToChange)
            {
                try
                {
                    if ((!String.IsNullOrEmpty(str_ComponentFacetStatus)) && (str_ComponentFacetStatus.ToUpper() == "READONLY"))
                    {
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                            Frm_ToChange.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                        }
                    }
                    else if ((ViewState["ComponentUserStatus"] != null) && (ViewState["ComponentUserStatus"].ToString().ToUpper().Equals("FINAL LOCK")))
                    {
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the Component facet for task</Purpose>
            /// </summary>
            /// <param name="TaskXMLDoc"></param>
            /// <param name="FormConfigXMLPath"></param>
            /// <param name="FormConfigXMLType"></param>
            private ERRORXML GetComponentFacetForTask(ref XmlDocument TaskXMLDoc, ref String FormConfigXML, String SearchXML)
            {
                ERRORXML        ErrorXML                    = null; 
                String          str_ComponentFacetRShipName = null;
                String          str_DeliverableProcessId    = null;
                StringBuilder   sb_Del_ComponentFacetSeries = null;
                String          str_ComponentFacetFieldName = null; 
                Boolean         bool_GetDeliverable         = true; 
                MWB_Component   MWB_ComponentObj            = null;
                String          str_InputXML                = null; 
                String          str_ComponentUserStatus     = null;
                String          str_ComponentSystemStatus   = null;
                String          ErrorPageURL                = null;                 
                ulong           ErrorID                     = 0;
                String          str_ComponentAssetRShip     = null;
                String          str_PrimaryKey              = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
         
                    //Check for the facet series configured in the form by getting the Component Facet series facet and relationship name from the configuration
                    if ((ViewState["ComponentFacetSeriesFor_Task"] != null) && (ViewState["ComponentFacetSeriesFor_Task"].ToString() != "No"))
                    {
                        str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        bool_GetDeliverable = false;
                    }

                    str_InputXML = TaskXMLDoc.OuterXml;  
                    if (bool_GetDeliverable)
                    {
                        if (ViewState["ComponentFacetSeriesFor_Task"] == null)
                        {
                            //HemantK:Delete temp file for component facet series
                            sb_Del_ComponentFacetSeries = new StringBuilder(50);
                            sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                            if ((File.Exists(sb_Del_ComponentFacetSeries.ToString())) && (!IsPostBack))
                            {
                                File.Delete(sb_Del_ComponentFacetSeries.ToString());
                            }

                            if (ViewState["ParentDeliverableID"] != null)
                            {
                                str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                            }

                            ErrorXML = MWB_ComponentObj.GetComponentFacetForTask(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_PrimaryKey, out str_ComponentAssetRShip, SearchXML);
                            if ((String.IsNullOrEmpty(ErrorXML)))
                            {
                                if (!String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                {
                                    //Put Component Facet relationship name and Component Facet name in view state
                                    ViewState["ComponentFacetSeriesFor_Task"]   = "Yes";
                                    ViewState["ComponentFacetSeriesRShipName"]  = str_ComponentFacetRShipName;
                                    ViewState["ComponentFacetFieldName"]        = str_ComponentFacetFieldName;
                                    ViewState["ComponentFacetPrimaryKey"]       = str_PrimaryKey;
                                    if (!String.IsNullOrEmpty(str_ComponentAssetRShip))
                                    {
                                        ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                    }
                                    TaskXMLDoc.LoadXml(str_InputXML);
                                }
                                else
                                {
                                    ViewState["ComponentFacetSeriesFor_Task"] = "No"; ;
                                }
                            }
                            else
                            {
                                //Redirect to error page.
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                if (!IsPostBack)
                                {
                                    Response.Redirect(ErrorPageURL, true);
                                }
                                else
                                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                    }
                    else
                    {
                        str_InputXML = TaskXMLDoc.OuterXml;
                        ErrorXML = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "WORKFLOWPROCESS", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            TaskXMLDoc.LoadXml(str_InputXML);
                        }
                        else
                        {
                            //Redirect to error page.
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }

                    //Radha: For setting component series action bar depends upon the component user status.
                    if ((!String.IsNullOrEmpty(str_ComponentUserStatus)))
                    {
                        ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                    }
                    return ErrorXML; 
                }
                catch (ThreadAbortException)
                { return ErrorXML; }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_ResponseGatherInfoTask.aspx", "GetComponentFacetForTask", ExceptionObj, null, null);
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackURL(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXML;
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To update the deliverable component facet</Purpose>
            /// </summary>
            /// <param name="SaveTaskXML"></param>
            /// <param name="str_ActionBarXML"></param>
            /// <returns></returns>
            private ERRORXML UpdateDeliverableComponentForTask(ref String SaveTaskXML, String str_ActionBarXML, Hashtable obj_SelectComponentIDs,  String str_ComponentObjectName, String str_ComponentPrimaryKey)
            {
                ERRORXML      ErrorXMLString                = null; 
                MWB_Component MWB_ComponentObj              = null; 
                String        str_DeliverableProcessId      = null; 
                String        str_ComponentFacetRShipName   = null;
                XmlDocument   xmlDoc_SaveTaskXml            = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        xmlDoc_SaveTaskXml = new XmlDocument();
                        xmlDoc_SaveTaskXml.LoadXml(SaveTaskXML);
                        ErrorXMLString = MWB_ComponentObj.RemoveAndUpdateComponentFacet(str_DeliverableProcessId, str_ComponentFacetRShipName, "WORKFLOWPROCESS", ref SaveTaskXML, str_ActionBarXML, obj_SelectComponentIDs, str_ComponentObjectName, str_ComponentPrimaryKey,str_SelectedComponentsIDFileName);
                        //MWB_ComponentObj.RemoveComponentFacetNodes(xmlDoc_SaveTaskXml, str_ComponentFacetRShipName, "WORKFLOWPROCESS", "ALL", null);
                        //SaveTaskXML =  xmlDoc_SaveTaskXml.OuterXml;
                    }
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the Form Action bar</Purpose>
            /// </summary>
            /// <param name="ResponseForm"></param>        
            /// <returns></returns>
            private String GetFormActionBarXML(Form TempForm)
            {
                String          str_ComponentFacetFieldName = null; 
     
                try
                {
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        str_ComponentFacetFieldName = ViewState["ComponentFacetFieldName"].ToString();

                        return TempForm.GetSeriesActionBar(str_ComponentFacetFieldName); 
                    }
                    else
                    {
                        return null; 
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>5 Feb 09</CreatedOn>
            /// <Author>Mugdha Moolay</Author>
            /// <Purpose>This method clears the drop down list if a resource type is deleted using the Remove Button. 
            ///  This function also updates the State XML used by the Select Resource Type pop-up</Purpose>
            /// </alsummary>
            /// <param name="ActivityID">The StepID for which resource is selected</param>
            /// <param name="str_FormID">The Dynamic Form ID</param>
            private void UpdateContributorDropDownList()
            {                
                MWB_Helper  obj_MWBHelper       = null;
                try
                {                    
                    setStepFormInputXMLForGroup();
                    // Update the Resource File Name for the Activity 
                    // Update the Resource File Name for the Activity
                    obj_MWBHelper = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_MWBHelper.UpdateStateXMLForResourceType(StepResourceFileName, StepID);              
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

        private void setStepFormInputXMLForGroup()
        {            
            XML             FormInputXML        = null;            
            XmlNode         FieldNode           = null;
            XmlNode         ValueNode           = null;
            String          TempPath            = null;
            StringBuilder   TempFilePath        = null;
            XmlDocument     FormInputDoc        = null;            
            XML             ItemList            = null;
            try
            {
                ItemList = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                FormInputDoc     = new XmlDocument();                
                TempFilePath     =  new StringBuilder(); 
                TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                if (Frm_ForwardTask!= null)
                {
                    FormInputXML = Frm_ForwardTask.InputXML;
                    if (FormInputXML!=null)
                    {
                        FormInputDoc.LoadXml(FormInputXML);
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (FieldNode != null)
                        {
                            FieldNode.InnerXml = ItemList;                            
                            FieldNode = null;
                        }                        
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (FieldNode != null)
                        {
                            ValueNode = FieldNode.SelectSingleNode("Value");
                            if (ValueNode != null)
                                ValueNode.InnerText = "";                            
                        }
                        Frm_ForwardTask.InputXML = FormInputDoc.OuterXml;
                        //Frm_ForwardTask.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                        Frm_ForwardTask.ResetFacetSeriesFields();
                    }
                }
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
       }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>03 April 2009</CreatedOn>
            /// <Purpose>To download digital assets.</Purpose>
            /// </summary>
            private void getDigitalAssetsFromFacetIDs(String str_DownloadFor)
            {
                 String          selectedFacetIDs    = null;
                 MWB_Component   objComponentFacade  = null;
                 String          SearchOutputXML     = null;
                 String          ErrorXML            = null;
                 String          ErrorPageURL        = null;
                 String          str_BatchDownloadAssetsFile  = null;
                 String          str_ComponentSearchForm      = null;
                 String          str_AlertMessage             = null;
                 String          str_BatchDownloadURL         = null;

                 try
                 {
                     objComponentFacade     = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                     if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "TASK"))
                     {
                         selectedFacetIDs            = Frm_TaskDetails.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                         str_BatchDownloadAssetsFile = TaskID + "_BatchDownloadAssetsXml";
                     }
                     else if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "STEP"))
                     {
                         selectedFacetIDs            = ResponseForm.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                         str_BatchDownloadAssetsFile = StepID + "_BatchDownloadAssetsXml";
                     }
                     if (!String.IsNullOrEmpty(selectedFacetIDs))
                     {
                         if ((ViewState["ComponentFacetPrimaryKey"] != null) && (ViewState["ComponentAssetRShipName"] != null) && (ViewState["ParentDeliverableID"] != null))
                         {
                             objComponentFacade.SolutionName = SolutionName;
                             ErrorXML = objComponentFacade.GetComponentSearchFormName(ViewState["ParentDeliverableID"].ToString(), out str_ComponentSearchForm);

                             if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_ComponentSearchForm)))
                             {
                                 ErrorXML = objComponentFacade.GetBatchDownloadDetails(selectedFacetIDs, ViewState["ComponentFacetPrimaryKey"].ToString(), ViewState["ComponentAssetRShipName"].ToString(), ref SearchOutputXML, str_ComponentSearchForm, str_BatchDownloadAssetsFile, out str_AlertMessage, out str_BatchDownloadURL);
                                 if (String.IsNullOrEmpty(ErrorXML))
                                 {
                                     if (!String.IsNullOrEmpty(str_AlertMessage))
                                         Ajax.WriteExecuteJavaScript("ShowAlert('" + str_AlertMessage + "');");
                                     else if (!String.IsNullOrEmpty(str_BatchDownloadURL))
                                         Ajax.WriteExecuteJavaScript("window.open('" + str_BatchDownloadURL + "','_new','left=120,top=120,width=1085,height=800,resizable=yes,scrollbars=yes');");
                                 }
                             }
                         }
                         else
                         {
                             ErrorXML = "<ERROR><MESSAGE>" + Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_BatchUploadDigitalAssets_COMPOENTDIGITALASSETRELATIONNOTFOUND") + "</MESSAGE></ERROR>";
                         }
                         if (!String.IsNullOrEmpty(ErrorXML))// Redirect to Error
                         {
                             ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "DELIVERABLE", null, ErrorXML, null, GetBackURL(), ref ErrorPageURL);
                             Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                         }
                     }
                     if (str_DownloadFor.ToUpper() == "TASK")
                     {
                         Frm_TaskDetails.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                     }
                     else if (str_DownloadFor.ToUpper() == "STEP")
                     {
                         ResponseForm.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                     }
                 }
                 catch (Exception ExceptionObj)
                 {
                     throw ExceptionObj;
                 }
            }

            /// <summary>
        /// <Author>Radha A</Author>
        /// <CreatedOn>14 April 2009</CreatedOn>
        /// <Purpose>To get the edit page url </Purpose>
        /// </summary>
        /// <param name="str_Source">It indicates Task Or Activity</param>
        /// <param name="str_ActivityID">Activity id</param>
        private void GetEditPageUrl()
        {
            MWB_Component       MWB_ComponentObj        = null;
            String              ErrorXML                = null;
            String              str_AlertMsg            = null;
            StringBuilder       sb_Parameters           = null;
            String              EditPageUrl             = null;
            String              str_SelectedFormName    = null;            
            XPathDocument       xp_TaskDoc              = null;
            String              TempPath                = null;
            XPathNavigator      nav_ActivityInfoNode    = null;
            String              str_ActivityDefID       = null;
            String              str_FormName            = null;
            String              str_FormConfigXMLPath   = null;
            MWB_Helper          MWB_HelperObj           = null;
            try
            {
                MWB_ComponentObj        = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MWB_HelperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                sb_Parameters           = new StringBuilder(400);
                TempPath                = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile;
                xp_TaskDoc              = new XPathDocument(TempPath);
                nav_ActivityInfoNode    = xp_TaskDoc.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                if (nav_ActivityInfoNode != null)
                {
                    str_ActivityDefID       = nav_ActivityInfoNode.Value;
                    str_FormName            = str_ActivityDefID + "_Response";
                    str_FormConfigXMLPath   = MWB_HelperObj.GetFormConfigXMLPath("StepDetails_Response", str_FormName, out str_SelectedFormName);
                }

                if ((ViewState["ComponentFacetFieldName"] != null) && (ViewState["ParentDeliverableID"] != null) && (!String.IsNullOrEmpty(str_SelectedFormName)))
                {
                    EditPageUrl = ResponseForm.GetSeriesEditRecordsUrl(ViewState["ComponentFacetFieldName"].ToString());

                    sb_Parameters.Append("&DeliverableID="      + ViewState["ParentDeliverableID"].ToString()
                                           + "&TaskID="         + TaskID
                                           + "&ActivityID="     + StepID
                                           + "&CFRelionship="   + ViewState["ComponentFacetSeriesRShipName"].ToString()
                                           + "&FormName="       + str_SelectedFormName
                                           + "&ComponentFacetSeriesPrimaryKey=" + ViewState["ComponentFacetPrimaryKey"].ToString()
                                           + "&Source=ACTIVITY");

                    if (ViewState["ComponentAssetRShipName"] != null)
                    {
                        sb_Parameters.Append("&ComponentDigitalAssetRelationship=" + ViewState["ComponentAssetRShipName"].ToString());
                    }

                    ErrorXML = MWB_ComponentObj.GetComponentSystemStatus(ViewState["ParentDeliverableID"].ToString(), ref EditPageUrl, sb_Parameters.ToString(), out str_AlertMsg);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        if (!String.IsNullOrEmpty(str_AlertMsg))
                        {
                            Ajax.WriteExecuteJavaScript("alert('" + str_AlertMsg + "');");
                        }
                        else if (!String.IsNullOrEmpty(EditPageUrl))
                        {
                            Ajax.WriteExecuteJavaScript(EditPageUrl);
                        }
                    }
                }
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

            private void SetStepForm_InPostBack()
            {
                String          TempPath                = null; 
                StringBuilder   TempFilePath            = null;
                XmlDocument     InputXMLDoc             = null;
                XmlDocument     TaskDoc                 = null;           
                XmlNodeList     Activities              = null; 
                try
                {
                    TempFilePath   = new StringBuilder();
                    InputXMLDoc    = new XmlDocument();
                    TaskDoc        = new XmlDocument();

                    TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        TaskDoc.Load(TempFilePath.ToString());
                        Activities = TaskDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY != 'True' and ENDACTIVITY != 'True' and (ACTIVITYID != '" + StepID + "')]");
                        if (Activities.Count > 0)
                        {
                            StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
                            foreach (XmlNode Activity in Activities)
                                setROResponseForm(Activity);  
                        }
                    }
                }
                catch (Exception ExcepitonObj)
                {
                    throw(ExcepitonObj);
                }
            }


            private void renderStepForms(HtmlTextWriter writer)
            {
                writer.Write("<script type=\"text/javascript\">" + (String)ResponseForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                ////2. Step ROForms.
                StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
                if (StepROFormIDTable != null)
                {
                    IDictionaryEnumerator StepFormIDEnum = StepROFormIDTable.GetEnumerator();
                    while (StepFormIDEnum.MoveNext())
                    {
                        Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                        if (StepForm != null)
                        {
                            writer.Write("<script type=\"text/javascript\">" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                        }
                    }
                }
            }

            /// <summary>
            /// <Author>Anita Kale</Author>
            /// <CreatedOn>18th May 2009</CreatedOn>
            /// <Purpose>sets project info form related to the task</Purpose>
            /// </summary>
            private void setProjectInfo()
            {
                FormFacade          formfacade_Project          = null;
                MWB_Helper          MWBHelperObj                = null;
                String              str_FormConfigXMLPath       = null;
                String              str_FormInputXML            = null;
                String              str_TempProjectInfofile     = null;
                ERRORXML            errorxml_Output             = null;
                
                try
                {
                    formfacade_Project                      = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    formfacade_Project.ShowConfiguredFields = true;
                    formfacade_Project.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.XMLPath.ToString();
                    str_TempProjectInfofile                 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID)+ TaskID + str_ProjectInfoTempFileName;
                    if (File.Exists(str_TempProjectInfofile) && ViewState["ProjectInfoFormConfigPath"]!=null)
                    {
                        str_FormConfigXMLPath   = ViewState["ProjectInfoFormConfigPath"].ToString();

                        //Form Input Xml type path
                        Frm_ROProjectDetails.InputXMLType  = Assetlink.CustomControls.Form.InputType.XMLPath;
                        Frm_ROProjectDetails.InputXML      = str_TempProjectInfofile;
                    }
                    else
                    {
                        MWBHelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        errorxml_Output = MWBHelperObj.GetProjectInfo(formfacade_Project, TaskID, "Task", ref str_FormConfigXMLPath, ref str_FormInputXML);

                        if (String.IsNullOrEmpty(errorxml_Output) && !String.IsNullOrEmpty(str_FormInputXML))
                        {
                            //Form Input Xml type InnerXML
                            Frm_ROProjectDetails.InputXMLType   = Assetlink.CustomControls.Form.InputType.InnerXML;
                            Frm_ROProjectDetails.InputXML       = str_FormInputXML;
                        }
                        else
                        {
                            //Redirect to error page
                            gotoErrorPage(Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_MWB_failedToGetProjectInfoForTask_Shared"));
                        }
                        this.ViewState["ProjectInfoFormConfigPath"] = str_FormConfigXMLPath;
                        if(!String.IsNullOrEmpty(str_TempProjectInfofile))
                            File.WriteAllText(str_TempProjectInfofile, str_FormInputXML);
                    }
                    
                    if (!String.IsNullOrEmpty(str_FormConfigXMLPath))
                    {
                        Frm_ROProjectDetails.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.XMLPath;
                        Frm_ROProjectDetails.ConfigurationXML       = str_FormConfigXMLPath;
                    }
                    else
                    {
                        //Redirect to error page
                        gotoErrorPage(Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_MWB_failedToGetProjectInfoFormConfigPath_Shared"));
                    }
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            /// <summary>
            /// <createddate>26 May 2009</createddate>
            /// <author>Jisha Rajendran</author>
            /// </summary>
            /// <param name="UsersNode">UserCollection Xml</param>
            /// <param name="GroupNode">Group Collection XML</param>
            /// <Purpose>This method prepares the User/group data xml and populates in the User/group list</Purpose>
            private void populateUserGroupList(XML UserDataXML, XML GroupDataXML)
            {
                MWB_Helper          MWB_HelperObj           = null;
                XML                 xml_List                = null;
                ListFacade          facade_ListControl      = null;
                XML                 xml_ListConfig          = null;                
                XPathDocument       xp_UserGroupColl        = null;
                XPathExpression     xpExp_UserGroup         = null;
                StringBuilder       sb_UserGroupColl        = null;
                XPathNodeIterator   nodeIter_RootNode       = null;
                XML                 xml_ExistingUserGroup   = null;                

                MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                //Prepare the User list xml
                if (!String.IsNullOrEmpty(UserDataXML))
                    MWB_HelperObj.AddUsersToUserGroupsListXML("<UserSelectionXML><SelectedUsersList>" + UserDataXML + "</SelectedUsersList></UserSelectionXML>",
                        ref xml_ExistingUserGroup);

                //Prepare the Group list xml
                if (!String.IsNullOrEmpty(GroupDataXML))
                    MWB_HelperObj.AddGroupsToUserGroupsListXML("<GroupSelectionXML><SelectedGroupsList>" + GroupDataXML + "</SelectedGroupsList></GroupSelectionXML>",
                                        ref xml_ExistingUserGroup);

                //Sort the data
                sb_UserGroupColl = new StringBuilder(200);
                sb_UserGroupColl.Append(@"<SEARCHOUTPUTXML><USERGROUPCOLLECTION>");
                if (!String.IsNullOrEmpty(xml_ExistingUserGroup))
                {
                    xp_UserGroupColl    = new XPathDocument(new StringReader(xml_ExistingUserGroup));
                    xpExp_UserGroup     = XPathExpression.Compile("USERGROUPCOLLECTION/USERGROUP");
                    xpExp_UserGroup.AddSort("USER_GROUP", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    xpExp_UserGroup.AddSort("USER_GROUP_NAME", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    nodeIter_RootNode   = xp_UserGroupColl.CreateNavigator().Select(xpExp_UserGroup);
                    foreach (XPathNavigator xpnav_UserGroup in nodeIter_RootNode)
                    {
                         sb_UserGroupColl.Append(xpnav_UserGroup.OuterXml);
                    }
                }
                sb_UserGroupColl.Append(@"</USERGROUPCOLLECTION></SEARCHOUTPUTXML>");

                facade_ListControl  = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                xml_ListConfig      = facade_ListControl.GetConfigurationXML(SolutionName, null, "UserGroupsForNotifications_RO");
                facade_ListControl.PrepareListXml(xml_ListConfig, sb_UserGroupColl.ToString(), out xml_List);
                Lst_UserGroup.Source = xml_List;
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the GatherInfo Task Details</Purpose>
            /// </alsummary>
            /// <param name="str_ReturnTaskXML"></param>
            /// <param name="str_ActivityAssociatedFacets"></param>
            /// <returns></returns>
            private ERRORXML GetGatherInfoTask(out String str_ReturnTaskXML)
            {
                StringBuilder       sb_SearchInputXML           = null;
                MWB_Helper          MWB_HelperObj               = null;
                ERRORXML            ErrorXMLString              = null;
                String              str_ProcessAssociatedFacets = null;
                SearchConfiguration SearchConfigObj             = null; 
                String              stdFormName                 = null;
                String              dynamicFormName             = null;
                String              str_SelectedFormName        = null;
                FormFacade          FormFacadeObj               = null;
                String              FormConfigXMLPath           = null;
                String              RelEntityList               = null;
                XDocument           xDocTask                    = null;
                XElement            xEleTask                    = null;
                String              FormActRelatedFacets        = null;
                IEnumerable<XElement> iEnumAct                  = null;
                Hashtable           ActDefList                  = null;
                try
                {
                    str_ReturnTaskXML            = null;
                    //str_ActivityAssociatedFacets = null; 
                    ActDefList = new Hashtable();

                    sb_SearchInputXML   = new StringBuilder(250);
                    MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    stdFormName         = "Task_Details";
                    if ((!String.IsNullOrEmpty(__PackageDefinitionID.Value)) && (!String.IsNullOrEmpty(__ProcessDefinitionID.Value)))
                    {
                        //ErrorXMLString = MWB_HelperObj.GetAssociatedAdditionalFacets(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, null, true, out str_ProcessAssociatedFacets, out str_ActivityAssociatedFacets);
                        //ErrorXMLString = MWB_HelperObj.GetActivityDefintionIDList(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, out ActDefList);

                        //if (!String.IsNullOrEmpty(ErrorXMLString))
                        //{
                        //    return ErrorXMLString;
                        //}
                        
                        dynamicFormName = __ProcessDefinitionID.Value + "_" + stdFormName;
                        FormFacadeObj.SolutionName = SolutionName;

                        FormConfigXMLPath               = MWB_HelperObj.GetFormConfigXMLPath(stdFormName, dynamicFormName, out str_SelectedFormName);
                        FormFacadeObj.FormName          = str_SelectedFormName;
                        FormFacadeObj.ConfigurationXML  = FormConfigXMLPath;

                        ErrorXMLString = FormFacadeObj.GetRelatedObjectList(out str_ProcessAssociatedFacets, out RelEntityList);
                        if (!String.IsNullOrEmpty(ErrorXMLString))
                        {
                            return ErrorXMLString;
                        }
                        //if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                        //{
                        //    String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                        //    for (int Index = 0; Index < Arr_Facets.Length; Index++)
                        //    {
                        //        ViewState["ProcessAssociatedFacets"] += "<" + Arr_Facets[Index] + " Type='RELATION' GetAllFacets='FALSE'/>";
                        //    }
                        //   // MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ProcessAssociatedFacets);
                        //}

                        //if (!String.IsNullOrEmpty(str_ActivityAssociatedFacets))
                        //{
                            //str_ActivityAssociatedFacets = str_ActivityAssociatedFacets.Replace("<ACTIVITY_WEBSERVICE Type='RELATION' />", "");
                           // ViewState["ActivityAssociatedFacets"] = str_ActivityAssociatedFacets;
                            //MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ActivityAssociatedFacets);
                        //}
                    }

                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                                if (String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                                }
                                else
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                                }
                                 sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>			                                                
	                                                        </FILTERLIST>
                                                            <RELATIONSHIP NAME='PROCESS_ASSETREFERENCES'>
                                                                <SELECTLIST>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>DIGITALASSETID</FIELDNAME>
				                                                        </EXPRESSION>
			                                                        </SELECTLIST>
                                                             </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                                                <SELECTLIST>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>ACTIVITYID</FIELDNAME>
                                                                            <ALIAS>ACTIVITYID</ALIAS>
				                                                        </EXPRESSION>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>STATUS</FIELDNAME>
                                                                            <ALIAS>STATUS</ALIAS>
				                                                        </EXPRESSION>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>STARTACTIVITY</FIELDNAME>
                                                                            <ALIAS>STARTACTIVITY</ALIAS>
				                                                        </EXPRESSION>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>ENDACTIVITY</FIELDNAME>
                                                                            <ALIAS>ENDACTIVITY</ALIAS>
				                                                        </EXPRESSION>
			                                                        </SELECTLIST>
                                                                    <RELATIONSHIP NAME='ACTIVITY_INFORMATION'>
                                                                        <SELECTLIST>
				                                                                <EXPRESSION>
					                                                                <FIELDNAME>ACTIVITYINFORMATIONID</FIELDNAME>
                                                                                    <ALIAS>ACTIVITYINFORMATIONID</ALIAS>
				                                                                </EXPRESSION>
				                                                                <EXPRESSION>
					                                                                <FIELDNAME>ACTIVITYDEFINITIONID</FIELDNAME>
                                                                                    <ALIAS>ACTIVITYDEFINITIONID</ALIAS>
				                                                                </EXPRESSION>
			                                                                </SELECTLIST>
                                                                     </RELATIONSHIP>
                                                             </RELATIONSHIP>");

                    if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                    {
                        //sb_SearchInputXML.Append(str_ProcessAssociatedFacets);   
                        String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                        for (int Index = 0; Index < Arr_Facets.Length; Index++)
                        {
                            sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                        }
                    }

                    sb_SearchInputXML.Append(@"</TARGETENTITY>
                                            </SEARCH>");  
                    
				    ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskXML);

                    if (ErrorXMLString == null)
                    {
                        xDocTask = XDocument.Parse(str_ReturnTaskXML);
                        xEleTask = xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS");
                        iEnumAct = xEleTask.XPathSelectElements("PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY='False' and ENDACTIVITY='False']");
                        foreach (XElement xEleAct in iEnumAct)
                        {
                            ActDefList.Add(xEleAct.Element("ACTIVITYID").Value, xEleAct.Element("STATUS").Value + "$AL$" + xEleAct.Element("ACTIVITY_INFORMATION").Element("ACTIVITYINFORMATION").Element("ACTIVITYDEFINITIONID").Value);
                        }
                        xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS").Element("PROCESS_ACTIVITY").Remove();
                        str_ReturnTaskXML = xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS").CreateNavigator().InnerXml;
                    }
                    
                    ViewState["ActivityDefList"] = ActDefList; 
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the GatherInfo Task Activities Details</Purpose>
            /// </alsummary>
            /// <param name="str_ActivityAssociatedFacets"></param> 
            /// <param name="str_ReturnTaskActivitesXML"></param> 
            /// <returns></returns>
            private ERRORXML GetGatherInfoTaskActivities(out String str_ReturnTaskActivitesXML)
            {
                StringBuilder       sb_SearchInputXML           = null;
                ERRORXML            ErrorXMLString              = null;
                SearchConfiguration SearchConfigObj             = null; 
                MWB_Helper          MwbHelperObj                = null;
                PMFacadeClass       PMFacadeObj                 = null;
                XML                 ProcessDefXML               = null;
                XDocument           xDocProcessDef              = null;
                
                //sString              str_ActivityAssociatedFacets= null;
                try
                {
                    str_ReturnTaskActivitesXML  = null; 
                    sb_SearchInputXML   = new StringBuilder(250);
                    SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MwbHelperObj        = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXMLString      = PMFacadeObj.GetProcessDefinitionByID(PackageDefinitionID, ProcessDefinitionID, out ProcessDefXML);

                    if (ErrorXMLString != null)
                        return ErrorXMLString;

                    Hashtable ActDefList = (Hashtable)ViewState["ActivityDefList"];
                    
                    xDocProcessDef = XDocument.Parse(ProcessDefXML);

                    XElement xEleProcessDef = xDocProcessDef.Element("WORKFLOWPROCESS");

                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>ACTIVITY</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                                if (ActDefList == null)
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                                }
                                else
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                                }
                                 sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
                                                                    <RELATIONSHIPNAME>PROCESS_ACTIVITY</RELATIONSHIPNAME>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>			                                                
	                                                        </FILTERLIST>									
                                                            <RELATIONSHIP NAME='ACTIVITY_RESPONSE'>
                                                                <RELATIONSHIP NAME='POSTEDBY'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='ACTIVITY_RESOURCE'>                                                                                                                          
                                                                <SELECTLIST>
		                                                            <EXPRESSION>
			                                                            <FIELDNAME>RESOURCEID</FIELDNAME>
			                                                            <ALIAS>RESOURCEID</ALIAS>
		                                                            </EXPRESSION>
                                                                    <EXPRESSION>
			                                                            <FIELDNAME>RESOURCETYPE</FIELDNAME>
			                                                            <ALIAS>RESOURCETYPE</ALIAS>
		                                                            </EXPRESSION>                                                                    
	                                                            </SELECTLIST>
                                                                <RELATIONSHIP NAME='ACTUAL_RESOURCE'>      
                                                                    <SELECTLIST>
		                                                                <EXPRESSION>
			                                                                <FIELDNAME>RESOURCEID</FIELDNAME>
			                                                                <ALIAS>RESOURCEID</ALIAS>
		                                                                </EXPRESSION>
                                                                        <EXPRESSION>
			                                                                <FIELDNAME>RESOURCETYPE</FIELDNAME>
			                                                                <ALIAS>RESOURCETYPE</ALIAS>
		                                                                </EXPRESSION>                                                                    
	                                                                </SELECTLIST>
                                                                    <RELATIONSHIP NAME='RESOURCE_USER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>");

                                 FormFacade FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                                 IDictionaryEnumerator iDicEnumAct = ActDefList.GetEnumerator();
                                 while(iDicEnumAct.MoveNext())                                 
                                 {
                                     String ActObjVal           = iDicEnumAct.Value.ToString();
                                     String[] Status_DefIDArr   = ActObjVal.Split(strSeparator,StringSplitOptions.RemoveEmptyEntries);
                                     String ActStatus           = Status_DefIDArr[0];
                                     String ActDefID            = Status_DefIDArr[1];

                                     String str_StdFormName     = null;
                                     String str_DynamicFormName = null;
                                     String SelectedFormName    = null;
                                     String relatedEntityList   = null;
                                     String ActRelatedFacets    = null;

                                     FormFacadeObj.SolutionName = SolutionName;

                                     if (iDicEnumAct.Key.ToString() == StepID)
                                     {
                                         str_StdFormName     = "StepDetails_Response";
                                         str_DynamicFormName = ActDefID + "_Response";
                                     }
                                     else
                                     {
                                         str_StdFormName        = "StepDetails_ROResponse";
                                         str_DynamicFormName    = ActDefID + "_Response";                                     
                                     }
                                     //switch (ActStatus.ToUpper())
                                     //{ 
                                     //    case "ACTIVE":
                                     //        str_StdFormName            = "StepDetails_Response";                                             
                                     //        str_DynamicFormName        = ActDefID + "_Response";
                                                                                          
                                     //        break;
                                     //    default:
                                     //        str_StdFormName        = "StepDetails_ROResponse";                                             
                                     //        str_DynamicFormName    = ActDefID + "_Response";
                                     //        break;
                                     //}

                                     String FormConfigXMLPath       = MwbHelperObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out SelectedFormName);
                                     FormFacadeObj.ConfigurationXML = FormConfigXMLPath;
                                     FormFacadeObj.FormName         = SelectedFormName;
                                     ERRORXML ErrorXml              = FormFacadeObj.GetRelatedObjectList(out ActRelatedFacets, out relatedEntityList);
                                     ActRelatedFacets               = MwbHelperObj.GetActivityAssociatedFacets(xEleProcessDef, ActDefID, ActRelatedFacets);
                                     String[] Arr_Facets            = ActRelatedFacets.Split(';');

                                     for (int Index = 0; Index < Arr_Facets.Length; Index++)
                                     {
                                         if (!String.IsNullOrEmpty(Arr_Facets[Index]))
                                         {
                                             if (!sb_SearchInputXML.ToString().Contains(Arr_Facets[Index]))
                                             {
                                                 sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                                             }
                                         }
                                     }
                                 }

                    //if (ActDefList!=null)
                    //{
                    //   // sb_SearchInputXML.Append(str_ActivityAssociatedFacets);   
                    //    foreach (String ActDefID in ActDefList)
                    //    {
                    //        //FormFacade FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    //        String     str_StdFormName     = null;
                    //        //String     str_DynamicFormName = null;
                    //        //String     SelectedFormName    = null;
                    //        //String     relatedEntityList   = null;
                    //        String     ActRelatedFacets    = null;

                            

                    //        str_StdFormName = "StepDetails_Editable";
                    //        GetAssociatedFacetsFromForm(xEleProcessDef, ActDefID, str_StdFormName, out FormActRelatedFacets);
                    //        if (!String.IsNullOrEmpty(FormActRelatedFacets))
                    //            ActRelatedFacets += ";" + FormActRelatedFacets;

                    //        str_StdFormName = "StepDetails_Response";
                    //        GetAssociatedFacetsFromForm(xEleProcessDef, ActDefID, str_StdFormName, out FormActRelatedFacets);

                    //        if (!String.IsNullOrEmpty(FormActRelatedFacets))
                    //            ActRelatedFacets += ";" + FormActRelatedFacets;
                    //        //str_DynamicFormName             = ActDefID + "_Editable";

                    //        //String FormConfigXMLPath        = MwbHelperObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out SelectedFormName);
                    //        //FormFacadeObj.ConfigurationXML  = FormConfigXMLPath;
                    //        //FormFacadeObj.FormName          = SelectedFormName;
                    //        //ERRORXML ErrorXml               = FormFacadeObj.GetRelatedObjectList(out ActRelatedFacets, out relatedEntityList);
                    //        //ActRelatedFacets                = MwbHelperObj.GetActivityAssociatedFacets(xEleProcessDef, ActDefID, ActRelatedFacets);
                    //        String[] Arr_Facets             = ActRelatedFacets.Split(';');
                    //        for (int Index = 0; Index < Arr_Facets.Length; Index++)
                    //        {
                    //            if (!String.IsNullOrEmpty(Arr_Facets[Index]))
                    //            {
                    //                if (!sb_SearchInputXML.ToString().Contains(Arr_Facets[Index]))
                    //                {
                    //                    //str_ActivityAssociatedFacets += "<" + Arr_Facets[Index] + " Type='RELATION' />";
                    //                    sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                    //                }
                    //            }
                    //        }
                    //    }
                        
                    //}

                    sb_SearchInputXML.Append(@"</TARGETENTITY>
                                            </SEARCH>");

                    ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskActivitesXML);
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the merge Assignment Task and Task Activities</Purpose>
            /// </alsummary>
            /// <param name="ReturnTaskXML"></param> 
            /// <param name="str_ActivitiesXML"></param> 
            /// <param name="str_TaskXML"></param> 
            /// <returns></returns>
            private void MergeTaskActivities(String str_TaskXML, String str_ActivitiesXML, out String ReturnTaskXML)
            {
                //if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION>"))
                //{
                //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", "");
                //}
                //else if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                //{
                //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
                //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESS>", "<WORKFLOWPROCESS xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");
                //}
                //str_TaskXML = str_TaskXML.Replace("</WORKFLOWPROCESS>", "");
                //str_TaskXML = str_TaskXML.Replace("</WORKFLOWPROCESSCOLLECTION>", "");

                if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION>"))
                {
                    str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION>", "<PROCESS_ACTIVITY>");
                }
                else if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                {
                    str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "<PROCESS_ACTIVITY>");
                }
                str_ActivitiesXML = str_ActivitiesXML.Replace("</ACTIVITYCOLLECTION>", "</PROCESS_ACTIVITY>");

                str_TaskXML = "<WORKFLOWPROCESS>" + str_TaskXML + str_ActivitiesXML + "</WORKFLOWPROCESS>";

                ReturnTaskXML = str_TaskXML;
            }

        private void setTemplateDocument()
        {            
            XML                         OutputXml        = null;
            ERRORXML                    ErrorXml         = null;
            MktgWorkBenchFacadeClass    Obj_MWBFacade    = null;


            try
            {
                Obj_MWBFacade   = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXml        = Obj_MWBFacade.GetDigitalAssetBySectionPath(SectionPath + ProcessDefinitionID, ref OutputXml);                
                showTemplateDocumentList(OutputXml);
            }
            catch (Exception ExcepObj)
            {                
                throw ExcepObj;
            }
        }

        private void showTemplateDocumentList(XML TemplateDocXML)
        {
            XPathDocument       UploadOutputDoc     = null;
            XPathNavigator      UploadNaviagator    = null;            
            XPathNodeIterator   UploadIterator      = null;            
            StringBuilder       InputXML            = null;
            ListFacade          ListFacadeObj       = null;
            XML                 ConfigXML           = null;
            XML                 OutputXML           = null;
            XmlDocument         xmlDoc              = null;
            XmlNodeList         xmlNodeList         = null;
            XmlElement          xmlElement          = null;
            try
            {                
                InputXML         = new StringBuilder(20);
                ListFacadeObj    = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);             

                if (!String.IsNullOrEmpty(TemplateDocXML))
                {
                    UploadOutputDoc  = new XPathDocument(new StringReader(TemplateDocXML));
                    UploadNaviagator = UploadOutputDoc.CreateNavigator();

                    UploadIterator = UploadNaviagator.Select("DIGITALASSETCOLLECTION/DIGITALASSET");
                    if (UploadIterator.Count > 0)
                    {
                        Panel_Templates.Visible = true;
                        Lst_TemplateDocument.Visible = true;
                        InputXML.Append("<SEARCHOUTPUTXML>");
                        InputXML.Append(UploadNaviagator.OuterXml);
                        InputXML.Append("</SEARCHOUTPUTXML>");
                        ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "TemplateDocument");
                        ListFacadeObj.PrepareListXml(ConfigXML, InputXML.ToString(), out OutputXML);

                        #region SetDownloadUrl
                        xmlDoc = new XmlDocument();
                        xmlDoc.LoadXml(OutputXML);
                        xmlNodeList = xmlDoc.SelectNodes("/List/Data/Group/Row");
                        foreach (XmlNode tmpxmlNode in xmlNodeList)
                        {
                            xmlElement = (XmlElement)tmpxmlNode.SelectSingleNode("Column[@Name='NAME']");
                            xmlElement.SetAttribute("Url", GetTemplateDocumentUrl(tmpxmlNode, UploadNaviagator.OuterXml));
                        }
                        OutputXML = xmlDoc.OuterXml;
                        #endregion

                        Lst_TemplateDocument.Source = OutputXML;
                    }
                }
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        private string GetTemplateDocumentUrl(XmlNode xmlRowNode,String DigitalAssetXML)
        {

            XmlElement              xmlElement                  = null;
            XPathDocument           xpathDocument               = null;
            XPathNavigator          xPathNavigator              = null;
            XPathNavigator          tmpNavigator                = null;
            XPathNavigator          AssertRenditionNavigator    = null;            
            String                  xpathQuery                  = null;
            String                  xpathAssertQuery            = null;
            StringBuilder           ParameterList               = null;
            StringBuilder           DownLoadUrlPath             = null;
            Boolean                 b_IsFileOnMediaServer       = false;

            try
            {

                xpathDocument       = new XPathDocument(new StringReader(DigitalAssetXML));
                xPathNavigator      = xpathDocument.CreateNavigator();
                ParameterList       = new StringBuilder();
                DownLoadUrlPath     = new StringBuilder();
                xmlElement          = (XmlElement)xmlRowNode.SelectSingleNode("Column[@Name='DIGITALASSETID']");
                
                xpathQuery          = ("DIGITALASSETCOLLECTION/DIGITALASSET[DIGITALASSETID='" + xmlElement.InnerText + "']");
                xpathAssertQuery    = ("DIGITALASSET_CURRENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION[RENDITIONTYPE='Original']/FILESYSTEM/FILE");
                
                tmpNavigator                = xPathNavigator.SelectSingleNode(xpathQuery);
                AssertRenditionNavigator    = tmpNavigator.SelectSingleNode(xpathAssertQuery);

				ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=PROCESSFILE&ObjectID={5}&SchemaID={6}&FileName={7}&DownloadFileName={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, AssertRenditionNavigator.SelectSingleNode("OBJECTID").Value, AssertRenditionNavigator.SelectSingleNode("SCHEMAID").Value, Server.UrlEncode(AssertRenditionNavigator.SelectSingleNode("NAME").Value));
                //DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                if (AssertRenditionNavigator.SelectSingleNode("ONMEDIASERVER") != null)
                {
                    b_IsFileOnMediaServer = Convert.ToBoolean(AssertRenditionNavigator.SelectSingleNode("ONMEDIASERVER").Value);
                    ParameterList.Append("&IsFileOnMediaServer=" + b_IsFileOnMediaServer.ToString());
                    if (b_IsFileOnMediaServer)
                    {
                        ParameterList.Append("&FileID=" + AssertRenditionNavigator.SelectSingleNode("FILEID").Value);
                        ParameterList.Append("&FilePath=" + AssertRenditionNavigator.SelectSingleNode("PATH").Value);
                    }
                    DownLoadUrlPath.Append(ALSolutionCommon.PrepareFileDownloadURL(b_IsFileOnMediaServer, ALParamObj.TenantName));
                    DownLoadUrlPath.Append("Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                }

                return DownLoadUrlPath.ToString();

            }
            catch (Exception ExceptionObject)
            {
                
                throw ExceptionObject;
            }
        }

        private void UpdateTaskSteps()
        {
            String          str_ActivityFacets  = null;
            String          str_TaskActivities  = null;
            StringBuilder   TempFilePath        = null;
            StringBuilder   StepFormID          = null;
            String          TempPath            = null;
            XmlDocument     Task_Doc            = null;
            XmlNodeList     ActNodeList         = null;
            XmlNode         ActivityNode        = null;
            XmlNode         ProcessActivityNode = null;
            XPathExpression   xp_SortExpression = null;
            XPathNodeIterator xp_SortNodeIter   = null;
            XML               str_SortXML       = null;
            List<String>      ActDefList        = null;
            try
            {
                TempFilePath        = new StringBuilder(100);
                StepFormID          = new StringBuilder(100);
                
                TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                GetGatherInfoTaskActivities(out str_TaskActivities);

                if (str_TaskActivities.Contains("<ACTIVITYCOLLECTION>"))
                {
                    str_TaskActivities = str_TaskActivities.Replace("<ACTIVITYCOLLECTION>", "");
                }
                else if (str_TaskActivities.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                {
                    str_TaskActivities = str_TaskActivities.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
                }
                str_TaskActivities = str_TaskActivities.Replace("</ACTIVITYCOLLECTION>", "");

                TempFilePath.AppendFormat("{0}{1}",TempPath , TaskFile);
                
                Task_Doc            = new XmlDocument();
                Task_Doc.Load(TempFilePath.ToString());
                ProcessActivityNode = Task_Doc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                ProcessActivityNode.InnerXml = str_TaskActivities;
                xp_SortExpression = XPathExpression.Compile("ACTIVITY");
                xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                xp_SortNodeIter = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                while (xp_SortNodeIter.MoveNext())
                {
                    str_SortXML += xp_SortNodeIter.Current.OuterXml;
                }
                ProcessActivityNode.InnerXml = str_SortXML;

                File.WriteAllText(TempFilePath.ToString(), Task_Doc.OuterXml);
                ActNodeList         = Task_Doc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID!='" + StepID + "' and (translate(STARTACTIVITY,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 'FALSE') and (translate(ENDACTIVITY,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 'FALSE')]");
                ActivityNode	    = Task_Doc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE='Task' and ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "' and ACTIVITYID='" + StepID + "']");
                if (ActivityNode != null)
                {
                    //get the Sequence Number of The Activity for which response will be submitted.
                    // Add a check so that the next activity after this activity will have Contributors Selected
                    TempFilePath.Remove(0,TempFilePath.Length);
                    StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID.ToString());
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        File.Delete(TempFilePath.ToString());
                    }
                    setActivityResponsePage(ActivityNode, true);                    
                }               
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

             /// <summary>
        /// <Purpose>Set notifiy in advance check box value and value for no. of days for prior notification</Purpose>
        /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
        /// </summary>
        /// <param name="str_TaskXML">Task's details</param>
        private void SetAdvanceReminderValues(String str_TaskXML)
        {
            XElement xElt_TaskData          = null;
            XElement xElt_workflowProcess   = null;
            XElement xElt_value             = null;

            xElt_TaskData           = XElement.Load(XmlReader.Create(new StringReader(str_TaskXML)));
            xElt_workflowProcess    = xElt_TaskData.XPathSelectElement("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
            if (xElt_workflowProcess != null)
            {
                //Set check box condition
                xElt_value = xElt_workflowProcess.Element("NOTIFYINADVANCE");
                if (xElt_value != null)
                {
                    if (xElt_value.Value == "1")
                    {
                        checkBoxObj.Checked = true;
                    }
                    else
                    {
                        checkBoxObj.Checked = false;
                    }
                }
                checkBoxObj.Enabled = false;                    

                //Set text box value for no. of days for prior notification                
                xElt_value = xElt_workflowProcess.Element("NOTIFYNOOFDAYS");
                if (xElt_value != null)
                {
                    if (!String.IsNullOrEmpty(xElt_value.Value))
                    {
                        textBoxObj.Text = xElt_value.Value;
                    }
                    else
                    {
                        textBoxObj.Text = "1";
                    }
                }                    
                textBoxObj.Enabled  = false;                
            }
        }        

        /// <alsummary>
        /// <createddate>04 April 2012</createddate>
        /// <author>Mr. Hemant Karkande</author>
        /// <purpose>Set the Task Readers User/Group list control.</purpose>
        /// </alsummary>
        private void setTaskReadersUserGroupList(XPathNavigator xpathNav_ProcessReadersGroup, XPathNavigator xpathNav_ProcessReadersUser)
        {
            ListFacade      obj_ListFacade      = null;
            String          str_ListConfig      = null;
            String          str_SearchInputXml  = null;
            String          str_ListSourceXml   = null;
            StringBuilder   sb_SelectedUsers    = null;
            MWB_Helper      obj_MWBHelperFacade = null; 

            obj_ListFacade = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            obj_MWBHelperFacade = new  MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language); 
            
            str_ListConfig = obj_ListFacade.GetConfigurationXML(SolutionName, null, "ROProcessReaders");
            
            //Prepare Selected Users input xml.
            sb_SelectedUsers = new StringBuilder(150);
            sb_SelectedUsers.Append("<UserSelectionXML><SelectedUsersList>");
            if (xpathNav_ProcessReadersUser != null)
            {
                sb_SelectedUsers.Append(xpathNav_ProcessReadersUser.InnerXml);
            }
            sb_SelectedUsers.Append("</SelectedUsersList></UserSelectionXML>");

            //Prepare Selected Group Input xml.
            sb_SelectedUsers.Remove(0, sb_SelectedUsers.Length);
            sb_SelectedUsers.Append("<GroupSelectionXML><SelectedGroupsList>");
            if (xpathNav_ProcessReadersGroup != null)
            {
                sb_SelectedUsers.Append(xpathNav_ProcessReadersGroup.InnerXml);
            }
            sb_SelectedUsers.Append("</SelectedGroupsList></GroupSelectionXML>");

            str_SearchInputXml = obj_MWBHelperFacade.PrepareUserGroupListSearchXml(xpathNav_ProcessReadersGroup, xpathNav_ProcessReadersUser);
            obj_ListFacade.PrepareListXml(str_ListConfig, str_SearchInputXml, out str_ListSourceXml);
            LC_TaskReaders.Source = str_ListSourceXml;
        }

        #endregion

        //Hemant Karkande : Do Not Delete this commented code
        //private void PaintPredecessorList(XML TaskXML)
        //    {
        //        ERRORXML                    ErrorXMLString          = null;
        //        MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;
        //        ListFacade                  ListFacadeObj           = null;
        //        XmlDocument                 AssociationXMLDoc       = null;
        //        XmlDocument                 InputXMLDoc             = null; 
        //        XmlNode                     AssociationNode         = null;
        //        XmlNode                     Process_ActivityNode    = null;
        //        XmlNode                     Activity_InfoNode       = null;
        //        XmlNode                     SubFlowActivity         = null; 
        //        XmlNode                     Process_TransitionNode  = null;
        //        XmlNode                     FromActivityNode        = null;
        //        XmlNode                     ToActivityNode          = null;
        //        XmlNode                     WFProcessNode           = null; 
        //        XmlNode                     SearchXMLNode           = null; 
        //        XmlNode                     RDF_RelationShipNode    = null; 
        //        XmlAttribute                TypeAttribute           = null; 
        //        XML                         ReturnProjectXML        = null;
        //        XML                         PredecessorListXML      = null; 
        //        XML                         FinalListXML            = null; 
        //        XML                         ConfigXML               = null; 
        //        String                      ParentActivityID        = null; 
        //        String                      RDF_RelationshipName    = null; 
        //        String                      EncryptURL              = null; 
        //        StringBuilder               ParamURL                = null;
        //        StringBuilder               URL                     = null; 
     
        //        try
        //        {
        //            AssociationXMLDoc       = new XmlDocument();
        //            InputXMLDoc             = new XmlDocument();
        //            ParamURL                = new StringBuilder();
        //            URL                     = new StringBuilder();
        //            MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        //            ListFacadeObj           = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        
                    
        //            AssociationXMLDoc = null;
        //            AssociationXMLDoc = new XmlDocument();
        //            AssociationXMLDoc.LoadXml(TaskXML);

        //            WFProcessNode = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS");
        //            if ((WFProcessNode != null) && (WFProcessNode.HasChildNodes))
        //            {
        //                //Get RDF relationship name
        //                RDF_RelationShipNode = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/RDFRELATIONSHIPNAME");
        //                if ((RDF_RelationShipNode != null) && (RDF_RelationShipNode.InnerText != ""))
        //                    RDF_RelationshipName = RDF_RelationShipNode.InnerText;
        //                else
        //                    RDF_RelationshipName = "None";
        //                __RDFRelationShipName.Value = RDF_RelationshipName;

        //                ParentActivityID = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/ACTIVITYID").InnerText;   
        //                //Now get the Predecessors for the current deliverable
        //                Process_ActivityNode = null;
        //                ErrorXMLString = GetPredecessors(WFProcessNode, ParentActivityID, ref Process_ActivityNode);
        //                if (ErrorXMLString != null)
        //                {
        //                    //Error Getting Predecessors paint empty list
        //                    ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                    Lst_PredecessorList.Source = PredecessorListXML;
        //                }
        //                else
        //                {
        //                    if ((Process_ActivityNode != null) && (Process_ActivityNode.HasChildNodes))
        //                    {
        //                        //Prepare Predecessor List.
        //                        SearchXMLNode = InputXMLDoc.CreateElement("SEARCHOUTPUTXML");
        //                        InputXMLDoc.AppendChild(SearchXMLNode);
        //                        SearchXMLNode.AppendChild(InputXMLDoc.ImportNode(Process_ActivityNode, true));
        //                        //Get the Configuration XML from ListConfigurationXML
        //                        //ListFacadeObj.AddParameter("ProjectID", ParentProjectID);
        //                        PackageDefinitionID = __PackageDefinitionID.Value;
        //                        ProcessDefinitionID = __ProcessDefinitionID.Value;
        //                        ListFacadeObj.AddParameter("PackageDefinitionID", PackageDefinitionID);
        //                        ListFacadeObj.AddParameter("ProcessDefinitionID", ProcessDefinitionID);
        //                        ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "PredecessorListForROTask");
        //                        if (ConfigXML != null)
        //                        {
        //                            ListFacadeObj.PrepareListXml(ConfigXML, InputXMLDoc.OuterXml, out PredecessorListXML);
        //                            if (PredecessorListXML != null)
        //                            {                                    
        //                                //ParamURL.AppendFormat("Manage_DefineConditions.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionId={4}&ProcessDefinitionId={5}&ParentID={6}&TaskID={7}&RDFRelationshipName={8}&ToActivityID={9}&FromActivityID=", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID, ParentDeliverableID, TaskID, RDF_RelationshipName, ParentActivityID);
        //                                ParamURL.AppendFormat("Manage_DefineConditions.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionId={4}&ProcessDefinitionId={5}&ParentID=111&TaskID={6}&RDFRelationshipName={7}&ToActivityID={8}&FormMode=READONLY&FromActivityID=", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID, TaskID, RDF_RelationshipName, ParentActivityID);

        //                                MktgWorkBenchFacadeObj.InnsertConditionImages(PredecessorListXML, ParamURL.ToString(), out FinalListXML);
        //                                MktgWorkBenchFacadeObj.InsertPercentCompleteClass("DUEDATE", ref FinalListXML);  
        //                                Lst_PredecessorList.Source = FinalListXML;
        //                            }
        //                            else
        //                            {
        //                                //There are no Predecessors paint empty list
        //                                ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                                Lst_PredecessorList.Source = PredecessorListXML;
        //                            }
        //                        }
        //                    }
        //                    else
        //                    {
        //                        //There are no Predecessors paint empty list
        //                        ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                        Lst_PredecessorList.Source = PredecessorListXML;
        //                    }
        //                }
        //            }
        //            else
        //            {
        //                ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                Lst_PredecessorList.Source = PredecessorListXML;
        //            }
        //        }
        //        catch (Exception ExceptionObj)
        //        {
        //            throw(ExceptionObj);
        //        }
        //    }

        //private ERRORXML GetPredecessors(XmlNode WFProcessNode, String ActIDForTask, ref XmlNode Predecessor_ActivityNode)
        //    {
        //        ERRORXML                ErrorXMLString          = null;
        //        XmlDocument             ReturnXMLDoc            = null;
        //        XmlNode                 R_Process_ActivityNode  = null;
        //        XmlNode                 Process_ActivityNode    = null;
        //        XmlNode                 Process_TransitionNode  = null;
        //        XmlNode                 ActivityNode            = null; 
        //        XmlNode                 OperationNode           = null; 
        //        XmlNodeList             TransitionNodes         = null; 
        //        String                  PrdecessorID            = null; 
     
        //        try
        //        {
        //            ReturnXMLDoc = new XmlDocument();
        //            Predecessor_ActivityNode = ReturnXMLDoc.CreateElement("PROCESS_ACTIVITY");

        //            //Select Process Activities and Process Transition nodes
        //            Process_ActivityNode    = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY");
        //            Process_TransitionNode  = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");

        //            //Select Predecessors
        //            TransitionNodes = Process_TransitionNode.SelectNodes("TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID='" + ActIDForTask + "']");
        //            foreach (XmlNode Transition in TransitionNodes)
        //            {
        //                OperationNode = Transition.Attributes.GetNamedItem("Operation");
        //                if ((OperationNode != null) && (OperationNode.InnerText.ToUpper() != "DELETED"))
        //                {
        //                    PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
        //                    ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
        //                    if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE") 
        //                        Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
        //                }
        //                else if (OperationNode == null)
        //                {
        //                    PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
        //                    ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
        //                    if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE") 
        //                        Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
        //                }
        //            }
        //            return ErrorXMLString;
        //        }
        //        catch (Exception ExceptionObj)
        //        {
        //            throw(ExceptionObj);
        //        }
        //    }
    }
}