#region SystemIncludes
using System;
using System.Data;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.IO;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Collections.Specialized;
#endregion

#region AssetlinkIncludes
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.Solutions.Facade.PMFacade;
using Assetlink.Solutions.Facade.NotificationFacade;
using Assetlink.Solutions.Facade.InfrastructureFacade;
using Assetlink.Solutions.Pages;
#endregion

//---------------------------------------------------------//
// File Name:   Perform_Response_Assignment_Task.aspx.cs   //
// Author:      Ms. Mugdha Moolay.                         //
// Class:       Manage_CreateAssignmentTask                //
// Created On:  2nd December 2006                          //
//---------------------------------------------------------//

namespace Assetlink.Solutions.MarketingWorkBench
{

     using XML       = String;
     using ERRORXML  = String;

    public partial class Perform_Response_Assignment_Task: ALAjaxPage
    {
        #region Member Variables
            private ALSolutionCommon ALSolutionCommonObj   = null;
            //private Dictionary<String, String> m_ParamList = null;
            public ALParam ALParamObj                      = null;
            private List<ObjectInfo>   ObjInfoList         = null;
            private List<ObjectInfo>   ResponseObjInfoList = null; 
            private List<ObjectInfo>    StepObjInfoList    = null; 
            private String  TaskID                         = null; 
            private String  StepID                          = null;               
			private String  PackageDefinitionID             = null;
			private String  ProcessDefinitionID             = null;
            private Hashtable  StepFormIDTable              = null;
            private Hashtable  StepROFormIDTable            = null;
            private List<string>ActivityIDOrderedList       = null; 
            private String  Mode                            = null;            
            private String TaskFile                         = null;
            private String GroupListFile                    = null;
            private String SolutionName                     = "MarketingWorkBench";
            private String[] strSeparator                   = null;
			private	String	TabClickFlag					= null;
			private String	SelectedTab						= null;
			private Boolean DigitalAssetPresent = false;
			private String	StepResourceFileName			= null;
			private String	ResourceTreeFile				= null;
            private String  str_ResponseBreadCrumbs         = null;    
            private String  str_ComponentFacetFileName      = "_ComponentFacet.xml";
            private String  str_ComponentFacetStatus        = "Editable";
            private String  str_SelectedComponentsIDFileName= "_SelectedComponentsID.xml";
            private String  str_ProjectInfoTempFileName     = "_ProjectInfo.xml";
            private String  SectionPath                     = "Template Vault\\";
        #endregion

        #region ControlsOnPage
          private   Form                                    Frm_TaskDetails     = null;
                    Form                                    TempStepForm        = null;
                    Form                                    ResponseForm        = null;		
	        private Form                                    Frm_ROProjectDetails= null;
             //Hemant Karkande : Do Not Delete this commented code
            //private Assetlink.CustomControls.ListControl    Lst_Predecessors    = null;  
            private   ActionBar                               Ab_ResponseTask     = null;
            private   ALPanel                                 Manual_Activities   = null;
            private ALUC_ALUserSelection                    UC_InitiatorSelection       = null;
            private ALPanel                                 ALPanel_InitiatorSelection  = null;
            private Binder                                  Binder_Attachments          = null;
            private SquareBlankSection                      SBS_CatalogFile             = null;
            private ActionBar                               AB_CatalogFile              = null; 
            private Label                                   Label_CatalogFile           = null; 
            private Label                                   Label_RefreshCtrl           = null;             
            private Assetlink.Widgets.ALWD_DAM_AssetListWidget.AssetList Widget_AssetListWidget = null;                 
            private ALPanel                                 ALPanel_AssetWidget         = null; 
            private	HiddenField								ContributorSelected			= null;
            private ALBreadCrumb                            Perform_BreadCrumb          = null;  
            private ALTab									AssignmentTaskTab			= null;
			private ALPanel									Panel_TaskDetails			= null;
			private ALPanel									Panel_UserRoles				= null;
            private ALPanel                                 Panel_ProjectDetails        = null;
            private SquareBlankSection                      Sbs_ProjectDetails          = null;
			Assetlink.Widgets.ALWD_DAM_AssetListWidget.AssetList AssetListWidget		= null;
			SquareBlankSection                              SBS_AssetWidget             = null;
            private CustomControls.ListControl              Lst_UserGroup               = null;
            private CustomControls.ListControl              Lst_TemplateDocument        = null;
            private CustomControls.ListControl              LC_TaskReaders              = null; 
            private ALPanel                                 Panel_Templates             = null;
            private CheckBox                                checkBoxObj                 = null;
            private TextBox                                 textBoxObj                  = null;
            private Literal                                 Literal_TaskInitiator       = null;
        #endregion

        #region Protected Methods

		protected override void CreateChildControls()
		{
			try
			{
				String ResponseFormID = null;
				setParameters();
				setControls();
				setLeftPane();
				Ajax.AsynchronousRequest = true;
				if(IsPostBack)
				{
					if(ViewState["TabClickFlag"] != null)
					{
						ResponseFormID = __ResponseFormID.Value;
						if(ResponseFormID != null)
						{
							createResponseForm();
						}
                        StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
						SetStepForm_InPostBack();
						createNewStepForm();
						setStepFormEventHandler();
					}
					String EventGenerator   = Ajax.EventGeneratorUniqueID;
                    if ((!String.IsNullOrEmpty(EventGenerator)) &&(EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton")))
                    {
                        UpdateContributorDropDownList();
                    }
                    else
                    {
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

                        while (StepFormIDEnum.MoveNext())
                        {
                            if ((!String.IsNullOrEmpty(EventGenerator)) &&(EventGenerator.Contains(StepFormIDEnum.Value.ToString() + "_HiddenMSDELETEButton")))
                            {
                                UpdateContributorDropDownList(StepFormIDEnum.Key.ToString(), StepFormIDEnum.Value.ToString());
                                break;
                            }
                        }
                    }
					if(Request["__EVENTARGUMENT"].ToString().Contains("DELETE") && (EventGenerator.Contains("DAMContentList_Div_Action_Menu")))
					{
						//Get items that has been cataloged for this deliverable.
						//String SBSID = "SBS_CatalogFile_" + StepID;
						//SBS_CatalogFile = (SquareBlankSection)Manual_Activities.FindControl(SBSID);
						//SBS_CatalogFile.TenantName = ALParamObj.TenantName;
						InitializeAssetlistWidget();
					}
					else
						Widget_AssetListWidget.RenderContents();
				}
				base.CreateChildControls();
			}
			catch(Exception ExcepObj)
			{				
				throw ExcepObj;
			}
		}
		
        protected void Page_Init(object sender, EventArgs e)
        {
            ALSolutionCommonObj = new ALSolutionCommon();
            ALParamObj = new ALParam();

	        ALSolutionCommonObj.httpContext = HttpContext.Current;
    	    ALSolutionCommonObj.InitALParam(ref ALParamObj);

            ((ALMasterPage)this.Master).SessionID       = ALParamObj.SessionID;
            ((ALMasterPage)this.Master).UserID          = ALParamObj.UserID;
            ((ALMasterPage)this.Master).Language        = ALParamObj.Language;
            ((ALMasterPage)this.Master).TenantName      = ALParamObj.TenantName;
            ((ALMasterPage)this.Master).SolutionName    = SolutionName;
            ((ALMasterPage)this.Master).PageTitle       = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_MarketingWorkbench_Shared");
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Entered Page_Load() function.");
            setParameters();
            setControls();
			setControlProperties();
            setLeftPane();
            Ajax.AsynchronousRequest = true; 
            if (!IsPostBack)
            {
                DeleteTempFiles();
				setSelectedTab();
                RegisterAssetListWidgetJavaScript();                
            }
            Page.ClientScript.RegisterHiddenField("ProcessingHtm", Page.ClientScript.GetWebResourceUrl((typeof(ALPopupControl)), "Assetlink.CustomControls.Processing.htm") + "&ThemeName=" + Page.Theme);

            ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Leaving Page_Load() function.");
        }

        void RegisterAssetListWidgetJavaScript()
        {
            if (!Page.ClientScript.IsClientScriptIncludeRegistered("AssetWidgetClientScript"))
                Page.ClientScript.RegisterClientScriptInclude("AssetWidgetClientScript", "/" + ALParamObj.TenantName + "/Widgets/DAM_AssetWidget/JS/AssetWidget.js");

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("AssetListWidgetClientScript"))
                Page.ClientScript.RegisterClientScriptInclude("AssetListWidgetClientScript", "/" + ALParamObj.TenantName + "/Widgets/DAM_AssetListWidget/JS/AssetListWidget.js");

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("DAM_WidgetCommonClientScript"))
                Page.ClientScript.RegisterClientScriptInclude("DAM_WidgetCommonClientScript", "/" + ALParamObj.TenantName + "/Common/JS/DAM_WidgetCommon.js");

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("ALTooltipClientScript"))
                Page.ClientScript.RegisterClientScriptInclude("ALTooltipClientScript", "/SASMOMJS/ALTooltip.js");
         }

        protected void Ab_ResponseTask_Click(object sender, EventArgs e)
        {
            ERRORXML        ErrorXML			= null;
            bool			alertGiven			= false;
            String			ErrorPageURL		= null;
            ulong			ErrorID				= 0 ;
            StringBuilder	ErrorPageURL_Exp	= null;
            try
            {
                String strSender    = (String)sender;
                String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
				if(Parameters[1].Equals("btn_SaveAndClose"))
                {
                    //Save Button Clicked
                    //Save the response of the contributor.
                    ErrorXML = SaveResponse("Draft",false,out alertGiven);
					if((ErrorXML == null) && (!alertGiven))
					{
						DeleteTempFiles();
						gotoPerformListScreen();
					}
					else
					{
						if(ErrorXML != null)
						{
							ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
							if(!IsPostBack)
							{
								Response.Redirect(ErrorPageURL, true);
							}
							else
								Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
						}
					}
                }
                else if (Parameters[1].Equals("btn_Submit"))
                {
                    //Submit Button Clicked
                    //Save the response of the contributor.
					ErrorXML = SaveResponse("Draft", true, out alertGiven);
					if((ErrorXML == null) && (!alertGiven))
					{
						DeleteTempFiles();
						gotoPerformListScreen();
					}
					else
					{
						if(ErrorXML != null)
						{
							ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
							if(!IsPostBack)
							{
								Response.Redirect(ErrorPageURL, true);
							}
							else
								Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
						}
					}
                }                
                else if (Parameters[1].Equals("btn_ForwardTask"))
                {
                    ForwardTask_ShowDiv();
                }
                else if (Parameters[1].Equals("btn_Cancel"))
                {
					DeleteTempFiles();
					gotoPerformListScreen();
                }
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "Ab_ResponseTask_Click", ExceptionObj, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_ActionBarClick_EXCEPTION_Shared"));

				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        protected void StepForm_SelectionChanged(object sender, EventArgs e)
        {
            String          FormID              = null;
            DropDownList    SelectedDropDown    = null;
            String          ListID              = null;
            String          SelectedValue       = null;
            String          SelectedID          = null;
            MWB_Helper      MWB_HelperObj       = null;            
            String          SelectedContributor = null;
            String			FileName			= null;
            ListItem        SelectedListItem    = null;
            String          MailID              = null;
            UserFacade		UserFacadeObj		= null;
            StringBuilder	GroupListXML		= null;
            StringBuilder	TempPath			= null;
            String			TempFilePath		= null;            
            ulong			ErrorID			= 0;
            StringBuilder	ErrorPageURL_Exp	= null;
            try
            {
                MWB_HelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                UserFacadeObj	 = new UserFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                TempPath		 = new StringBuilder();
				GroupListXML	 = new StringBuilder();
                SelectedDropDown = (DropDownList)sender;
                ListID           = SelectedDropDown.ID;
                SelectedListItem = SelectedDropDown.SelectedItem;
                SelectedValue    = SelectedListItem.Text;
                SelectedID		 = SelectedListItem.Value;
                TempFilePath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                                                
                while (StepFormIDEnum.MoveNext())
                {
                    if (ListID.Contains(StepFormIDEnum.Value.ToString()))
                    {
                        FormID = StepFormIDEnum.Value.ToString();
                        break;
                    }
                }               
                if (FormID!=null)
                {                    
                    TempStepForm        = (Form)Manual_Activities.FindControl(FormID);                    
                    SelectedContributor = TempStepForm.GetValues("Contributor");
 
					if (ListID.Contains("Contributor"))
                    {
                        if (SelectedID.ToUpper() != "NONE")
                        {
							FileName = FormID + "_GroupUsers.xml";
							MWB_HelperObj.GetMailAddressForSelectedUser(SelectedID, FileName, out MailID);
                            //setStepFormInputXMLForMailAddress(FormID, MailID);
                        }
                        setStepFormInputXMLForMailAddress(FormID, MailID);
                    }              
                }
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "StepForm_SelectionChanged", ExceptionObj, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Perform_Response_Assignment_Task_Exceptiononformselectionchange"));

				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        protected void Ab_ForwardTask_Click(object sender, EventArgs e)
        {
            ulong			ErrorID			= 0;
            StringBuilder	ErrorPageURL_Exp = null;
            
            try
            {
                String strSender    = (String)sender;
                String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                if (Parameters[1].Equals("btnDone"))
                {
                    SaveForwardTask();
                }
                //else if (Parameters[1].Equals("btnCancel"))
                //{
                //    Ajax.WriteExecuteJavaScript("hideContentDiv('"+Div_ForwardTask.ClientID+"');");
                //}
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "Ab_ForwardTask_Click", ExceptionObj, null,
                    Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Perform_Response_Assignment_Task_Exceptiononforwardtaskclick"));
				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        protected void ForwardTask_SelectionChanged(object sender, EventArgs e)
        {
            DropDownList SelectedDropDown   = null;
            String      SelectedValue       = null;
            String      SelectedID          = null;
            String      ListID              = null;
            String      MailID              = null;
            
            String      SelectedContributor = null;
            ListItem    SelectedListItem    = null;
            
            XML         FormInputXML        = null;
            XmlDocument FormInputDoc        = null;
            XmlNode     FieldNode           = null;
            XmlNode     ValueNode           = null;
            MWB_Helper  MWB_HelperObj       = null;
            String		FileName			= null;
            StringBuilder	GroupListXML	= null;
            UserFacade	UserFacadeObj		= null;
            StringBuilder	TempPath		= null;
            String			TempFilePath	= null;            
            ulong			ErrorID			= 0;
            StringBuilder	ErrorPageURL_Exp= null;
            try
            {
				GroupListXML	= new StringBuilder();
				TempPath		= new StringBuilder();
				TempFilePath	= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				UserFacadeObj	= new UserFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language); 
                SelectedDropDown = (DropDownList)sender;
                SelectedListItem = SelectedDropDown.SelectedItem;
                SelectedValue   = SelectedListItem.Text;
                SelectedID      = SelectedListItem.Value;
                ListID           = SelectedDropDown.ID;
                FormInputDoc    = new XmlDocument();
                MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                //SelectedGroup       = Frm_ForwardTask.GetValues("ContributorGroup");
                SelectedContributor = Frm_ForwardTask.GetValues("Contributor");
                FileName = StepID + "_GroupUsers.xml";
				TempPath.AppendFormat("{0}{1}",TempFilePath,FileName);
               
				if (ListID.Contains("Contributor"))
                {
                    if (SelectedID.ToUpper() != "NONE")
                    {
						MWB_HelperObj.GetMailAddressForSelectedUser(SelectedID, FileName, out MailID);
                        //setStepFormInputXMLForMailAddress(FormID, MailID);
                    }					
                    FormInputXML = Frm_ForwardTask.InputXML;
                    if (FormInputXML!=null)
                    {
                        FormInputDoc.LoadXml(FormInputXML);
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (FieldNode != null)
                        {
                            ValueNode = FieldNode.SelectSingleNode("Value");
                            if (ValueNode!=null)
                            ValueNode.InnerText = MailID;                            
                        }                        
                    }
                }
                Frm_ForwardTask.InputXML = FormInputDoc.OuterXml;
                //Frm_ForwardTask.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                Frm_ForwardTask.ResetFacetSeriesFields();
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "ForwardTask_SelectionChanged", ExceptionObj, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_Response_Assignment_Task_ExceptionOnForwardFormSelectionChange"));

				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        protected void AB_CatalogFile_Click(object sender, EventArgs e)
        {
            StringBuilder CatalogFileURL    = null; 
            StringBuilder URL               = null; 
            String        EncryptURL        = null; 
            ulong			ErrorID			= 0;
            StringBuilder	ErrorPageURL_Exp	= null;
            try
            {
                String strSender = (String)sender;
                String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                if (Parameters[1].Equals("btn_Upload"))
                {
                    CatalogFileURL = new StringBuilder();
                    URL            = new StringBuilder();
                    CatalogFileURL = new StringBuilder();
                    CatalogFileURL.AppendFormat("Perform_Response_Assignment_Task_UploadFile.aspx?", ALParamObj.TenantName);
                    CatalogFileURL.AppendFormat("SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&TenantName=" + ALParamObj.TenantName + "&Language=" + ALParamObj.Language + "&UT=" + DateTime.Now.TimeOfDay.Hours.ToString() + DateTime.Now.TimeOfDay.Minutes.ToString() + DateTime.Now.TimeOfDay.Seconds.ToString() + DateTime.Now.TimeOfDay.Milliseconds.ToString());
                    CatalogFileURL.AppendFormat("&SolutionName={0}", SolutionName);
                    CatalogFileURL.AppendFormat("&SectionPath=MWB Vault\\{0}", StepID);
                    CatalogFileURL.AppendFormat("&ActivityID={0}", StepID);
                    //CatalogFileURL.AppendFormat("&ExistingItemID={0}", __DigtalAssetID.Value);
                    CatalogFileURL.AppendFormat("&HiddenBtnID={0}", Hidden_Btn_CatalogItem.UniqueID);  
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(CatalogFileURL.ToString());
                    URL.AppendFormat("javascript:OpenNewWindow('{0}','','');", EncryptURL);
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                else if (Parameters[1].Equals("btn_Refresh"))
                {
                    Btn_Refresh_DigitalAsset_Click();
                }
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "AB_CatalogFile_Click", ExceptionObj, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_Response_Assignment_Task_Exceptiononcatalogfileclick"));

				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        protected void Btn_CatalogItem_Click(object sender, EventArgs e)
        {
            StringBuilder               UpdateActivityXML       = null;
            StringBuilder               AssociationXML          = null; 
            StringBuilder               TempPath                = null;
            XML                         ActivityXML             = null;
            XmlDocument                 ReturnXMLDoc            = null; 
            XmlDocument                 TempXMLDoc              = null;
            XmlNode                     ActivityNode            = null;         
            XmlNode                     tmpActivityNode         = null;
            XmlNode                     ItemNode                = null;
            XmlNode                     tmpItemNode             = null;
            ERRORXML                    ErrorXMLString          = null; 
            MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null; 
            ulong						ErrorID					= 0;
            StringBuilder				ErrorPageURL_Exp		= null;
            try
            {
                UpdateActivityXML       = new StringBuilder();
                MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        

                Label_CatalogFile.Text = "";
                //Get the Activity details againg
                AssociationXML = new StringBuilder();
                ReturnXMLDoc   = new XmlDocument();
                AssociationXML.AppendFormat("<ASSOCIATION>");
                    AssociationXML.AppendFormat("<ACTIVITY_ITEM Type='RELATION'/>");
                AssociationXML.AppendFormat("</ASSOCIATION>");

                ErrorXMLString = MktgWorkBenchFacadeObj.GetStep(StepID, AssociationXML.ToString(), out ActivityXML);
                if (ErrorXMLString == null)
                {
                    ReturnXMLDoc.LoadXml(ActivityXML);
                    ActivityNode = ReturnXMLDoc.DocumentElement;

                    TempPath = new StringBuilder(150);
                    TempPath.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), TaskFile);
                    if (File.Exists(TempPath.ToString()))
                    {
                        //Load temp path file

                        TempXMLDoc = new XmlDocument();
                        TempXMLDoc.Load(TempPath.ToString());
                        tmpActivityNode = TempXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']/ACTIVITY_ITEM");
                        ItemNode = ActivityNode.SelectSingleNode("ACTIVITY_ITEM");
                        if ((tmpActivityNode == null)&&(ItemNode!=null))
                        {
                            tmpItemNode = TempXMLDoc.CreateElement("ACTIVITY_ITEM");
                            tmpActivityNode = TempXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']");
                            tmpItemNode.InnerXml = ItemNode.InnerXml;
                            tmpActivityNode.AppendChild(tmpItemNode);
                        }
                        else
                        if (tmpActivityNode != null && ItemNode != null)
                        {
                            tmpActivityNode.RemoveAll();
                            tmpActivityNode.InnerXml = ItemNode.InnerXml;
                        }
                        TempXMLDoc.Save(TempPath.ToString());
                    }

                    //setDigitalAsset(ActivityNode, true);
					setDigitalAsset(ActivityNode);
                }
                else
                {
                    //Label_CatalogFile.Text = "File has been submitted for cataloging, click on the refresh button to see whether file has been cataloged.";
                    //setDigitalAsset(null, true);
					setDigitalAsset(null); 
                }
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "Btn_CatalogItem_Click", ExceptionObj, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_Response_Assignment_Task_Exceptiononcatalogitemclick"));
				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        protected void Btn_Refresh_DigitalAsset_Click()
        {
            StringBuilder               AssociationXML          = null; 
            XmlDocument                 ReturnXMLDoc            = null; 
            XmlNode                     ActivityNode            = null; 
            XmlNode                     ItemNode                = null; 
            XML                         ActivityXML             = null; 
            ERRORXML                    ErrorXMLString          = null; 
            MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;
            ulong						ErrorID					= 0;
            StringBuilder				ErrorPageURL_Exp		= null;
            StringBuilder               TempPath                = null;
            XmlDocument                 TempXMLDoc              = null;
            XmlNode                     tmpActivityNode         = null;

            try
            {
                AssociationXML          = new StringBuilder();
                ReturnXMLDoc            = new XmlDocument();
                MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        
                AssociationXML.AppendFormat("<ASSOCIATION>");
                    AssociationXML.AppendFormat("<ACTIVITY_ITEM Type='RELATION'/>");
                AssociationXML.AppendFormat("</ASSOCIATION>");

                ErrorXMLString = MktgWorkBenchFacadeObj.GetStep(StepID, AssociationXML.ToString(), out ActivityXML);
                if (ErrorXMLString == null)
                {
                    //Label_CatalogFile.Text = "File has been submitted for cataloging, click on the refresh button to see whether file has been cataloged.";
                    ReturnXMLDoc.LoadXml(ActivityXML);
                    ActivityNode = ReturnXMLDoc.DocumentElement;
                    
                    TempPath = new StringBuilder();
                    TempPath.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), TaskFile);
                    if (File.Exists(TempPath.ToString()))
                    {
                        //Load temp path file
                        
                        TempXMLDoc = new XmlDocument();
                        TempXMLDoc.Load(TempPath.ToString());
                        tmpActivityNode =  TempXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']/ACTIVITY_ITEM");
                        ItemNode        = ActivityNode.SelectSingleNode("ACTIVITY_ITEM");
                        if (tmpActivityNode != null && ItemNode != null)
                        {
                           tmpActivityNode.RemoveAll();
                           tmpActivityNode.InnerXml = ItemNode.InnerXml;
                        }
                       TempXMLDoc.Save(TempPath.ToString());
                    }

                    //setDigitalAsset(ActivityNode, true);
					setDigitalAsset(ActivityNode);
                }
                else
                {
                    //Label_CatalogFile.Text = "File has been submitted for cataloging, click on the refresh button to see whether file has been cataloged.";
                    //setDigitalAsset(null, true);
					setDigitalAsset(null); 
                }
            }
            catch (Exception ExceptionObj)
            {
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "Btn_Refresh_DigitalAsset_Click", ExceptionObj, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_Response_Assignment_Task_Exceptiononcatalogitemclick"));
                
				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

		protected void AssignmentTaskTab_onTabClick(object sender, TabClickEventarg e)
        {
			ALPanel			SelectedTab		 = null;
			ulong			ErrorID			 = 0;
			StringBuilder	ErrorPageURL_Exp = null;			
			try
			{
				TabClickFlag = "TRUE";
				ViewState["TabClickFlag"] = "TRUE";
				SelectedTab  = (ALPanel)e.SelectedTab;
                if (!IsPostBack)
                    setBreadcrumbs(); 
				switch(SelectedTab.Name.ToUpper())
				{
					case "INFO":
						GetTaskDetails();
						break;
					case "USER ROLES":
						GetUserRoles();
						break;
				}                              
			}
            catch (System.Threading.ThreadAbortException)
            { }
			catch(Exception Excepobj)
			{
				ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "AssignmentTaskTab_onTabClick", Excepobj, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Perform_Response_Approvals_Task_Exceptionontabclick_Shared"));

				ErrorPageURL_Exp = new StringBuilder();
				ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				if(!IsPostBack)
				{
					Response.Redirect(ErrorPageURL_Exp.ToString());
				}
				else
					Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
			}
        }

		protected void Hidden_SelectResourceType_Click(object sender, EventArgs e)
		{
			StringBuilder	FilePath	 = null;
			XPathDocument	RecDoc		 = null;
			XPathNavigator	xpNav		 = null;
			String			SelectedValue= null;
			UserFacade		UserFacadeObj= null;
			XML				SearchXML	 = null;
			XML				UserXML		 = null;
			ERRORXML		ErrorXml	 = null;
			XPathDocument   UserDoc		 = null;
			MWB_Helper		MWB_HelperObj= null;
			String			StepID		 = null;
			String			StepFormID	 = null;
			String			ItemList	 = null;
			String			TempPath	 = null;
			String			FileName	 = null;
			try
			{
				StepID			= Request["__EVENTARGUMENT"];
				FilePath		= new StringBuilder();
				UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
				MWB_HelperObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
				TempPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				FilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
				if(File.Exists(FilePath.ToString()))
				{
					RecDoc = new XPathDocument(FilePath.ToString());
					xpNav  = RecDoc.CreateNavigator();
					xpNav  = xpNav.SelectSingleNode("//*/TreeNode[@Selected='True']");
					if(xpNav != null)
					{
						SelectedValue	= xpNav.GetAttribute("Text","") ;						

						SearchXML = GetSearchXML(SelectedValue);
						ErrorXml = UserFacadeObj.GetUserList(SearchXML, ref UserXML);
						if(ErrorXml == null)
						{
							UserDoc			= new XPathDocument(new StringReader (UserXML));
							ItemList		= MWB_HelperObj.GetContributorXML(UserDoc);
							StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
							IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
							while (StepFormIDEnum.MoveNext())
							{
								StepFormID = StepFormIDEnum.Value.ToString();
								if (StepFormID.Contains(StepID))
									break;
							}
							if(StepFormID != null)
							{
								// save the user file on ntfs
								FilePath.Remove(0, FilePath.Length);
								
								FileName = StepFormID + "_GroupUsers.xml";
								FilePath.AppendFormat("{0}{1}", TempPath, FileName);
								File.WriteAllText(FilePath.ToString(), UserXML);
								setStepFormInputXMLForGroup(StepFormID, ItemList);
							}
						}
					}
				}
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		protected void Hidden_SelectResourceForwardTask_Click(object sender, EventArgs e)
		{
			StringBuilder	FilePath	 = null;
			XPathDocument	RecDoc		 = null;
			XPathNavigator	xpNav		 = null;
			String			SelectedValue= null;
			UserFacade		UserFacadeObj= null;
			XML				SearchXML	 = null;
			XML				UserXML		 = null;
			ERRORXML		ErrorXml	 = null;
			XPathDocument   UserDoc		 = null;
			MWB_Helper		MWB_HelperObj= null;
			String			StepID		 = null;
			String			StepFormID	 = null;
			String			ItemList	 = null;
			String			TempPath	 = null;
			String			FileName	 = null;
			XML				FormInputXML = null;
			XmlDocument		FormInputDoc = null;
			XmlNode			FieldNode	 = null;
			XmlNode			ValueNode	 = null;
			String			MailID		 = null;
			try
			{
				StepID			= Request["__EVENTARGUMENT"];
				FilePath		= new StringBuilder();
				UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
				MWB_HelperObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
				TempPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				FormInputDoc	= new XmlDocument();
				FilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
				
				if(File.Exists(FilePath.ToString()))
				{
					RecDoc = new XPathDocument(FilePath.ToString());
					xpNav  = RecDoc.CreateNavigator();
					xpNav  = xpNav.SelectSingleNode("//*/TreeNode[@Selected='True']");
					if(xpNav != null)
					{
						SelectedValue	= xpNav.GetAttribute("Text","") ;						

						SearchXML = GetSearchXML(SelectedValue);
						ErrorXml = UserFacadeObj.GetUserList(SearchXML, ref UserXML);
						
						if(ErrorXml == null)
						{
							UserDoc = new XPathDocument(new StringReader(UserXML));
							ItemList = MWB_HelperObj.GetContributorXML(UserDoc);
							StepFormID = Frm_ForwardTask.ID;
							// save the user file on ntfs
							FilePath.Remove(0, FilePath.Length);

                            FileName = StepID + "_GroupUsers.xml";
							FilePath.AppendFormat("{0}{1}", TempPath, FileName);
							File.WriteAllText(FilePath.ToString(), UserXML);
							FormInputXML = Frm_ForwardTask.InputXML;
							if (FormInputXML != null)
							{
								FormInputDoc.LoadXml(FormInputXML);
								FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
								if (FieldNode != null)
								{
									FieldNode.InnerXml = ItemList;                            
								}
								FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
								if (FieldNode != null)
								{
									ValueNode = FieldNode.SelectSingleNode("Value");
									if (ValueNode != null)
										ValueNode.InnerText = MailID;
								}  
							}
							Frm_ForwardTask.InputXML = FormInputDoc.OuterXml;
                            //Frm_ForwardTask.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                            Frm_ForwardTask.ResetFacetSeriesFields();
						}
					}
				}
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

        protected override void Render(HtmlTextWriter writer)
        {
            String[]            SBS_ID_List = null; 
            SquareBlankSection  TempSBS     = null; 
            if (IsPostBack)
            {				
				String EventGenerator = Ajax.EventGeneratorUniqueID;

				if(!String.IsNullOrEmpty(TabClickFlag) && TabClickFlag.Equals("TRUE"))
				{
					if(AssignmentTaskTab.SelectedTab != null)
					{
						Ajax.AddControlsToRender(AssignmentTaskTab.SelectedTab);
						Ajax.WriteExecuteJavaScript("javascript:" + AssignmentTaskTab.HighlightTabJavaScript);
					}
				}

                if (EventGenerator.Contains("PS") || EventGenerator.Contains("_Response") || EventGenerator.Contains(Btn_Hidden_SelectSigns.UniqueID))
                {
                    Ajax.AddControlsToRender(ResponseForm);
                    if (EventGenerator.Contains("ExportSeriesRecord"))
                    {
                        String ExportUrl = ResponseForm.GetSeriesExportUrl();
                        if (!String.IsNullOrEmpty(ExportUrl))
                            Ajax.WriteExecuteJavaScript(ExportUrl);
                    }
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        //loading digital assets for components dynamically.
                        Ajax.WriteExecuteJavaScript("javascript:" + (String)ResponseForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                    }
                }

                if (EventGenerator.Contains("btn_Refresh") || EventGenerator.Contains("Hidden_Btn_CatalogItem"))
                    Ajax.AddControlsToRender(SBS_CatalogFile);

                if (EventGenerator.Contains("AssetListIteratorTop") || EventGenerator.Contains("AssetListIteratorBottom"))
                {
                    if (EventGenerator.Contains("SBS_CatalogFile_"))  
                        Ajax.AddControlsToRender(SBS_CatalogFile);
                }
                
                //if (EventGenerator.Contains("btn_ForwardTask") || EventGenerator.Contains("Frm_ForwardTask_DDL_StepDetails_Editable_ContributorGroup") || EventGenerator.Contains("Frm_ForwardTask_DDL_StepDetails_Editable_Contributor") || EventGenerator.Contains("Hidden_SelectResourceForwardTask") || EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton"))
                if ((EventGenerator.Contains(Frm_ForwardTask.UniqueID)) || EventGenerator.Contains("btn_ForwardTask") || EventGenerator.Contains("Frm_ForwardTask_DDL_") || EventGenerator.Contains("Hidden_SelectResourceForwardTask") || EventGenerator.Contains("Frm_ForwardTask_HiddenMSDELETEButton"))
                {
                    Ajax.AddControlsToRender(Frm_ForwardTask);
                    if ((ViewState["ComponentFacetFieldName"] != null))
                    {
                        Ajax.WriteExecuteJavaScript("javascript:" + (String)Frm_ForwardTask.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                    }
                }

                if (EventGenerator.Contains("Binder_Documents"))
                    Ajax.AddControlsToRender(Binder_Attachments);

                if (Request["__EVENTARGUMENT"].ToString().Contains("DELETE") && (EventGenerator.Contains("DAMContentList_Div_Action_Menu")) || (EventGenerator.Contains("ID_Popup_AssetInformation_IconList")))//|| EventGenerator.Contains("SBS_CatalogFile")
                    Ajax.AddControlsToRender(SBS_CatalogFile);

                if (EventGenerator.Contains("Content_1_sbs_Project_Details"))
                {
                    Ajax.AddControlsToRender(Sbs_ProjectDetails);
                }

                if (EventGenerator.Contains("Content_1_Frm_Task_Details"))
                {
                    Ajax.AddControlsToRender(Frm_TaskDetails);
                    if (EventGenerator.Contains("ExportSeriesRecord"))
                    {
                        String ExportUrl = Frm_TaskDetails.GetSeriesExportUrl();
                        if (!String.IsNullOrEmpty(ExportUrl))
                            Ajax.WriteExecuteJavaScript(ExportUrl);
                    }
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        //loading digital assets for components dynamically.
                        Ajax.WriteExecuteJavaScript("javascript:" + (String)Frm_TaskDetails.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                    }
                }

                if (EventGenerator.Contains("LstTemplateDocument"))
                    Ajax.AddControlsToRender(Lst_TemplateDocument);

                if (EventGenerator.Contains(LC_TaskReaders.UniqueID))
                    Ajax.AddControlsToRender(LC_TaskReaders);
                
                Ajax.AddControlsToRender(TempStepForm);
                if (EventGenerator.Contains("AssetListIteratorTop") || EventGenerator.Contains("AssetListIteratorBottom") || (EventGenerator.Contains("ID_Popup_AssetInformation_IconList")))
                {
                    //Check for the SBS id's
                    if ((!String.IsNullOrEmpty(__SBS_IDs.Value)) && (!EventGenerator.Contains("SBS_CatalogFile_")))
                    {
                        //split on the comma and take the SBS id's
                        SBS_ID_List = __SBS_IDs.Value.Split(',');
                        for (int Index = 0; Index < SBS_ID_List.Length; Index++)
                        {
                            if (EventGenerator.Contains(SBS_ID_List[Index]))
                            {
                                TempSBS = (SquareBlankSection)Manual_Activities.FindControl(SBS_ID_List[Index]);
                                Ajax.AddControlsToRender(TempSBS);
                            }
                        }
                    }
                }

                //For the Iterators of the Editable step forms.
                StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                if (StepFormIDTable != null)
                {
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                    while (StepFormIDEnum.MoveNext())
                    {
                        if (EventGenerator.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                            if (StepForm != null)
                            {
                                Ajax.AddControlsToRender(StepForm);
                                if ((ViewState["ComponentFacetFieldName"] != null))
                                {
                                    Ajax.WriteExecuteJavaScript("javascript:" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                                }
                            }
                        }
                    }
                }
                
                //For the Iterators of the read only step forms.
                StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
                if (StepFormIDTable != null)
                {
                    IDictionaryEnumerator StepFormIDEnum = StepROFormIDTable.GetEnumerator();
                    while (StepFormIDEnum.MoveNext())
                    {
                        if (EventGenerator.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                            if (StepForm != null)
                            {
                                Ajax.AddControlsToRender(StepForm);
                                if ((ViewState["ComponentFacetFieldName"] != null))
                                {
                                    Ajax.WriteExecuteJavaScript("javascript:" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                                }
                            }
                        }
                    }
                }
                DAMCommonFunctions.ExecuteLoadImage(this.Page);
				Ajax.AddControlsToRender(Panel_ContributorSelected);				
                Ajax.WriteControlHTMl(this.Page, writer);
            }
            else
            {
                base.Render(writer);
                if ((ViewState["ComponentFacetFieldName"] != null))
                {
                    //loading digital assets for components dynamically.
                    //1. Task Form.
                    writer.Write("<script type=\"text/javascript\">" + (String)Frm_TaskDetails.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                    renderStepForms(writer);
                }                
            }		
        }



        /// <alsummary>
        /// <createddate>24-March-2009</createddate>
        /// <author>Bhalchandra Kadam</author>
        /// <purpose>Update Component list with selected components</purpose>
        /// </alsummary>
        protected void Btn_Hidden_SelectSigns_Click(object sender, EventArgs e)
        {
            
            ERRORXML ErrorXml   = null;            
            Boolean  alertGiven = false;
            try
            {
                ErrorXml = SaveResponse("DRAFT", false, out alertGiven);
                if (ErrorXml == null)
                {
                    UpdateTaskSteps();
                }                
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        /// <alsummary>
        /// <createddate>17 April 2009</createddate>
        /// <author>Radha A</author>
        /// <purpose>To Handle clicks on the Component Facet Series List Action bar.</purpose>
        /// </alsummary>
        protected void Frm_TaskDetails_SeriesActionBarClick(object sender, EventArgs e)
        {
            ulong       ErrorID         = 0;
            String      EncryptURL      = null;

            try
            {
                String strSender = (String)sender;
                String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                {
                    getDigitalAssetsFromFacetIDs("TASK");
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_RODiscussionTask.aspx", "Frm_TaskDetails_SeriesActionBarClick", ExceptionObject, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlingComponentListactionbarclick_Shared"));

                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ExceptionObject.Message, null, null, ref EncryptURL);
                Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
            }
        }

        /// <summary>
        /// <Author>Anita Kale</Author>
        /// <CreatedOn>18th May 2009</CreatedOn>
        /// <Purpose>Event Handler for Expansion of project Info Section</Purpose>
        /// </summary>
        protected void Sbs_ProjectDetails_CollapsedClick(object sender, EventArgs e)
        {
            Sbs_ProjectDetails.IsMinimize = false;
            setProjectInfo();
        }
        #endregion

        #region Private Methods

        private void setParameters()
        {
            try
            {
                strSeparator = new string[1] { "$AL$" };
                TaskID       = ALSolutionCommonObj.GetParamValue("TaskID");
                Mode         = ALSolutionCommonObj.GetParamValue("Mode");
                StepID       = ALSolutionCommonObj.GetParamValue("StepID");
				SelectedTab  = ALSolutionCommonObj.GetParamValue("SelectedTab");
                str_ResponseBreadCrumbs = ALSolutionCommonObj.GetParamValue("ResponseBreadCrumbs");
                if (String.IsNullOrEmpty(str_ResponseBreadCrumbs))
                {
                    str_ResponseBreadCrumbs = "0";
                }
				if(SelectedTab == null)
					SelectedTab = "INFO";
                PackageDefinitionID = ALSolutionCommonObj.GetParamValue("PackageDefinitionID");
                if (!String.IsNullOrEmpty(PackageDefinitionID))
                {
                    __PackageDefinitionID.Value = PackageDefinitionID;
                }
                ProcessDefinitionID = ALSolutionCommonObj.GetParamValue("ProcessDefinitionID");
                if (!String.IsNullOrEmpty(ProcessDefinitionID))
                {
                    __ProcessDefinitionID.Value = ProcessDefinitionID;
                }
                if (!String.IsNullOrEmpty(StepID))
                {
                    TaskFile                = StepID + "_MWB_TaskFile.xml";
                    GroupListFile           = StepID + "_MWB_GroupList.xml";
                    StepResourceFileName    = StepID + "_ActivityResourceColl.xml";
                    ResourceTreeFile        = StepID + "_ResourceGroupTree.xml";
                }
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }
        }

        private void setControls()
        {             
            StringBuilder ActionBarXMLPath      = null;                        
            String        CultureInformation    = null;
            String        FormatXMLPath         = null;
            MWB_Helper    MWB_HelperObj         = null;   
			TabFacade	  TabFacadeObj		  = null;

            try
            {
                ActionBarXMLPath    = new StringBuilder();                
				TabFacadeObj		= new TabFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                FormatXMLPath		= ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);
				Page_CreatePage.TenantName      = ALParamObj.TenantName;
                Page_CreatePage.SectionHeading  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Perform_TaskResponse_Shared");
                // set the tenant name of task panes
                Left_1_tp_MarketingWorkBench.TenantName             = ALParamObj.TenantName;
                Left_1_tp_MarketingWorkBench.SelectedSectionName    = Mode;
                Left_1_tp_MarketingWorkBench.TaskPaneName           = SolutionName; 

                // set the input XML paths of task panes.
                
                Left_2_tp_PefromAssignmentTask.TenantName   = ALParamObj.TenantName;
                Left_2_tp_PefromAssignmentTask.TaskPaneName = "Perform";

                Perform_BreadCrumb = (ALBreadCrumb)this.Page_CreatePage.FindControl("PerformAssignmentTaskBreadcrumb");
                Perform_BreadCrumb.TenantName = ALParamObj.TenantName;
                
				AssignmentTaskTab = (ALTab)Page_CreatePage.FindControl("tabTaskResponse");
				AssignmentTaskTab.TenantName = ALParamObj.TenantName;

                TabFacadeObj.TabName        = "tabTaskResponse";
				TabFacadeObj.ScreenName     = "TASKRESPONSE";
				TabFacadeObj.SolutionName   = SolutionName;
				TabFacadeObj.InitializeTab(ref AssignmentTaskTab);

                Panel_TaskDetails           = (ALPanel)AssignmentTaskTab.FindControl("panelTaskDetails");
				Panel_UserRoles	            = (ALPanel)AssignmentTaskTab.FindControl("panelUserRoles");
                
                Literal_TaskInitiator       = (Literal)Panel_UserRoles.FindControl("Literal_TaskInitiator");
                Literal_TaskInitiator.Text  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_TaskInitiator:_Label_Shared");

				Frm_TaskDetails = (Form)Panel_TaskDetails.FindControl("Content_1_Frm_Task_Details");
                Frm_TaskDetails.TenantName = ALParamObj.TenantName;
                Frm_TaskDetails.CultureInformation = CultureInformation;
                Frm_TaskDetails.PersonalizationFilePath = FormatXMLPath;
				Frm_TaskDetails.SolutionName			= SolutionName;
                Frm_TaskDetails.SeriesActionBarClick    +=new EventHandler(Frm_TaskDetails_SeriesActionBarClick);
				
                //Hemant Karkande : Do Not Delete this commented code
                //Lst_Predecessors = (Assetlink.CustomControls.ListControl)Page_CreatePage.FindControl("Content_2_lc_PredecessorList");
                //Lst_Predecessors.TenantName = ALParamObj.TenantName;                

				Ab_ResponseTask = (ActionBar)Panel_TaskDetails.FindControl("Content_6_ab_Task_ActionBar");
                Ab_ResponseTask.TenantName = ALParamObj.TenantName;

				ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Manage_Response_Assignment_Task_Content_6_ab_Task_ActionBar_ActionBar"));
                Ab_ResponseTask.InputXML = ActionBarXMLPath.ToString();
                Ab_ResponseTask.AddAttributes("btn_Submit", "href", "javascript:ValidateForm('$CONTROLID$', '" + StepID + "')");

                Manual_Activities = (ALPanel)Panel_TaskDetails.FindControl("PS");
                
                ActionBarXMLPath.Remove(0, ActionBarXMLPath.Length);
				ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "ForwardTaskActionBarXML"));
                Ab_ForwardTask.InputXML = ActionBarXMLPath.ToString();
                
                Ab_ForwardTask.AddAttributes("btnCancel", "href", "javascript:"+Popup_ForwardTask.ClosePopupJavascript);

                //Readers List
                LC_TaskReaders = (CustomControls.ListControl)Panel_UserRoles.FindControl("List_TaskReaders");
                LC_TaskReaders.TenantName = ALParamObj.TenantName;
                LC_TaskReaders.EnableIterators = true;

                //Initiator
				ALPanel_InitiatorSelection = (ALPanel)Panel_UserRoles.FindControl("ID_InitiatorSelection");
                UC_InitiatorSelection = (ALUC_ALUserSelection)ALPanel_InitiatorSelection.FindControl("ALUC_InitiatorSelection");

				Binder_Attachments = (Binder)Panel_TaskDetails.FindControl("Binder_Documents");
                
                MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);         
                
				ContributorSelected = (HiddenField)Panel_ContributorSelected.FindControl("__ContributorSelected");
				Popup_ForwardTask.TenantName        = ALParamObj.TenantName;
                Popup_ForwardTask.CaptionText       = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_ForwardTask");
				Popup_ForwardTask.PopupDisplayMode  = ePopupDisplayMode.Simple;
				Popup_ForwardTask.Style.Add(HtmlTextWriterStyle.Display, "None");

                //Display Project Info : Anita Kale
                Sbs_ProjectDetails                  = (SquareBlankSection)Panel_TaskDetails.FindControl("Content_1_sbs_Project_Details");
                Sbs_ProjectDetails.TenantName       = ALParamObj.TenantName;
                Sbs_ProjectDetails.SectionHeading   = Localization.GetString("ALResource", ALParamObj.TenantName, "RPT_MWB_Project_Shared");
                Panel_ProjectDetails                = (ALPanel)Sbs_ProjectDetails.FindControl("ALPanelProjectDetails");

                if (!IsPostBack)
                    Sbs_ProjectDetails.IsMinimize   = true;

                Frm_ROProjectDetails                            = (Form)Panel_ProjectDetails.FindControl("Content_2_Frm_Project_Details");
                Frm_ROProjectDetails.TenantName                 = ALParamObj.TenantName;
                Frm_ROProjectDetails.CultureInformation         = CultureInformation;
                Frm_ROProjectDetails.PersonalizationFilePath    = FormatXMLPath;
                Frm_ROProjectDetails.SolutionName               = SolutionName;

                 //User Group List (Notification on process completion)
                Lst_UserGroup                   = (CustomControls.ListControl)Panel_UserRoles.FindControl("ListControl_ProcessComplete_UserGroup");
                Lst_UserGroup.TenantName        = ALParamObj.TenantName;
                Panel_Templates                 = (ALPanel)Panel_TaskDetails.FindControl("PanelTemplates");
                Lst_TemplateDocument            = (CustomControls.ListControl)Panel_Templates.FindControl("LstTemplateDocument");
                Lst_TemplateDocument.TenantName = ALParamObj.TenantName;

                //Textbox
                textBoxObj = (TextBox)Panel_TaskDetails.FindControl("tb_NoOfDays");

                //Checkbox
                checkBoxObj = (CheckBox)Panel_TaskDetails.FindControl("cb_AdvanceNotification");
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        private void setBreadcrumbs()
        {
            MktgWorkBenchFacadeClass    MWBFacadeObj            = null;
            String                      OutputXML               = null;
            String                      DeliverableName         = null; 
            String                      ProjectName             = null; 
            StringBuilder               SB_BreadCrumbXML        = null; 
            XmlDocument                 OutputXmlDoc            = null;
            XmlNode                     DeliverableTaskNode     = null;
            XmlNode                     ProjectNode             = null; 
            ERRORXML                    ErrorXML                = null;
            String                      ErrorPageURL            = null;
            StringBuilder               str_PrjUrl              = null;
            StringBuilder               str_DelUrl              = null;
            String                      EncryptUrl_Prj          = null;
            String                      EncryptUrl_Del          = null;
            ulong                       ErrorID                 = 0;
            StringBuilder               ErrorPageURL_Exp        = null;

            try
            {
                OutputXmlDoc        = new XmlDocument();
                SB_BreadCrumbXML    = new StringBuilder(100);
                str_PrjUrl          = new StringBuilder(100);
                str_DelUrl          = new StringBuilder(100);
                MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, true, out OutputXML);
                if (String.IsNullOrEmpty(ErrorXML)) 
                {
                    //Load the OutputXML and get the Project & Deliverable name
                    OutputXmlDoc.LoadXml(OutputXML);
                    
                    DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK");
                    if (DeliverableTaskNode != null)
                    {
                        //HemantK: for Component facet
                        ViewState["ParentDeliverableID"] = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;

                        DeliverableName = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                        __DeliverableID.Value = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                        ProjectNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE");
                        if (ProjectNode != null)
                        {
                            ProjectName = ProjectNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                            __ProjectID.Value = ProjectNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                        }
                    }
                    if (String.Compare(str_ResponseBreadCrumbs, "1", true) == 0)
                    {
                        str_PrjUrl.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode=PERFORM&Access=READ&PrevScreen=PERFORMLIST&BREADCRUMBCTRLID={5}&ResponseBreadCrumbs={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, __ProjectID.Value, Perform_BreadCrumb.BreadcrumbUniqueID, str_ResponseBreadCrumbs);
                        EncryptUrl_Prj = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_PrjUrl.ToString());
                        str_DelUrl.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode=PERFORM&Access=READ&PARENTBREADCRUMBNAME=Project&PrevScreen=PERFORMLIST&BREADCRUMBCTRLID={6}&ResponseBreadCrumbs={7}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, __DeliverableID.Value, __ProjectID.Value, Perform_BreadCrumb.BreadcrumbUniqueID, str_ResponseBreadCrumbs);
                        EncryptUrl_Del = ALSolutionCommonObj.EncodeURLForResponseRedirects(str_DelUrl.ToString());
                    }

                    if ((!String.IsNullOrEmpty(ProjectName)) && (!String.IsNullOrEmpty(DeliverableName)))
                    {
                        //Prepare input XML for breadcrumb
                        SB_BreadCrumbXML.AppendFormat(@"<BreadCrumbs>
                                                            <BreadCrumb Name='Project' NavigationUrl='{0}' DisplayText='{1}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                <BreadCrumb Name='Deliverable' NavigationUrl='{2}' DisplayText='{3}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                </BreadCrumb>
                                                            </BreadCrumb>
                                                        </BreadCrumbs>", EncryptUrl_Prj, ALSolutionCommon.TrimAndReplaceSpecialChars(ProjectName), EncryptUrl_Del, ALSolutionCommon.TrimAndReplaceSpecialChars(DeliverableName));
                    }
                    Perform_BreadCrumb.ParentBreadcrumbName = "Deliverable";
                    Perform_BreadCrumb.NavigateUrl          = this.Request.Url.AbsoluteUri;
                    Perform_BreadCrumb.InputXml             = SB_BreadCrumbXML.ToString();
                    Perform_BreadCrumb.Name                 = "Task";
                    //Perform_BreadCrumb.DisplayText          = ViewState["TaskTitle"].ToString();
                }
                else
                {
                    //Error getting parent Deliverable
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_GetParentsTask_Shared"),
                        null, GetBackURL(), ref ErrorPageURL);

                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL, true);
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
            }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_AssignmentTask.aspx", "setBreadcrumbs", ExceptionObject, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateDiscussionTask_Exceptionwhilesettingbreadcrumbs_Shared"));

                ErrorPageURL_Exp = new StringBuilder();
                ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL_Exp.ToString());
                }
                else
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");

                throw (ExceptionObject);
            }
        }
        
        private void setSelectedTab()
		{
			try
			{
				switch(SelectedTab.ToUpper())
				{
					case "INFO":
						AssignmentTaskTab.SelectedTab = Panel_TaskDetails;
						AssignmentTaskTab.SelectedTabName = "Info";
						break;
					case "USER ROLES":
						AssignmentTaskTab.SelectedTab = Panel_UserRoles;
						AssignmentTaskTab.SelectedTabName = "User Roles";
						break;					
				}
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

        private void gotoPerformListScreen()
        {
            StringBuilder ParamURL  = null;
            StringBuilder URL       = null;  
            String        EncryptURL = null;  
            try
            {
                ParamURL = new StringBuilder();
                URL      = new StringBuilder();
                ParamURL.AppendFormat("PerformList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}",ALParamObj.TenantName,ALParamObj.Language,ALParamObj.SessionID,ALParamObj.UserID);
                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                URL.AppendFormat("window.open('"+"{0}"+"','_self','');",EncryptURL);
                Ajax.WriteExecuteJavaScript(URL.ToString());
            }
            catch (Exception ExceptionObj)
            {                    
                throw ExceptionObj; 
            }
        }

		private void GetTaskDetails()
        {
            MWB_Helper               MWBHelperClassObj  = null;
            XmlDocument              InputXMLDoc        = null;
            XmlDocument              TempDoc            = null;
            XmlDocument              FormInputDoc       = null;
            ERRORXML                 ErrorXML           = null;
            XmlNode                  ActivityNode       = null;
            XmlNodeList              ActivityNodeList   = null;
            XmlNode                  FileSystemNode     = null;
            XmlNode					 ProcessActivityNode= null;
            XmlNode					 FieldNode          = null;            
            XML                      ReturnTaskXML      = null;
            XML                      FormInputXML       = null;
            StringBuilder            ProcessColl        = null;
            StringBuilder            ResourceTypeList   = null;
            StringBuilder            TempPath           = null;
            FormFacade               FormFacadeObj      = null;  
            String                   TaskName           = null;
            Hashtable                ResourceTable      = null;
            String                   FormConfigXMLPath  = null;
            String                   ActivityStatus     = null;
            String                   TempFilePath       = null;
            int						 SeqNo				= 0;
            int                      ActivityCount      = 0;
            String					 ErrorPageURL		= null;
            XML						 SortXML			= null;
            String                   TaskStatus         = null;
			StringBuilder			ActResourceXML		= null;
			XML						ResourceXML			= null;
            String                  str_StdFormName     = null;
            String                  str_DynamicFormName = null;
            String                  str_SelectedFormName= null;
            String                  FormConfigXML       = null;
            String                  SearchXML           = null;
            String                  str_TaskXML         = null;
            String                  str_TaskActivities  = null;
            
            XPathExpression         xp_SortExpression   = null;
            XPathNodeIterator       xp_SortNodeIter     = null;
            
            try
            {
                MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                
                ProcessColl         = new StringBuilder();
                ResourceTypeList    = new StringBuilder();
                TempPath            = new StringBuilder();
				ActResourceXML		= new StringBuilder();
                InputXMLDoc         = new XmlDocument();
                TempDoc             = new XmlDocument();
                ResourceTable       = new Hashtable();
                StepFormIDTable     = new Hashtable();
                StepROFormIDTable   = new Hashtable();
                ActivityIDOrderedList = new List<string>();
                TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

                str_StdFormName     = "Task_Details";
                FormFacadeObj.SolutionName  = SolutionName;
                str_DynamicFormName         = __ProcessDefinitionID.Value + "_" + str_StdFormName;
                FormConfigXMLPath           = MWBHelperClassObj.GetFormConfigXMLPath(str_StdFormName,str_DynamicFormName,out str_SelectedFormName);
                FormFacadeObj.FormName      = str_SelectedFormName;
                FormFacadeObj.ShowConfiguredFields = true;

                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Before GetAssignmentTask() function.");
                ErrorXML = GetAssignmentTask(out str_TaskXML);
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- After GetAssignmentTask() function.");

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Before GetAssignmentTaskActivities() function.");
                    ErrorXML = GetAssignmentTaskActivities(out str_TaskActivities);
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- After GetAssignmentTaskActivities() function.");
                }

                if ((ErrorXML == null) && (!String.IsNullOrEmpty(str_TaskXML)) && (!String.IsNullOrEmpty(str_TaskActivities)))    
                {
                    MergeTaskActivities(str_TaskXML, str_TaskActivities, out ReturnTaskXML);    

                    InputXMLDoc.LoadXml(ReturnTaskXML);
                    TaskName = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                    //ViewState["TaskTitle"] = TaskName;
                    Perform_BreadCrumb.DisplayText = TaskName;
                    TaskStatus = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/STATUS").InnerText;

                    FormConfigXML = File.ReadAllText(FormConfigXMLPath);
                    FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out SearchXML);
                    //HemantK:For Component Facet Series
                    ErrorXML = GetComponentFacetForTask(ref InputXMLDoc, ref FormConfigXML, SearchXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        CheckComponentFacetSeriesStatus(Frm_TaskDetails);  

                        ProcessColl.AppendFormat("<WORKFLOWPROCESSCOLLECTION>{0}</WORKFLOWPROCESSCOLLECTION>", InputXMLDoc.OuterXml);
                        ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ProcessColl.ToString(), out FormInputXML, out ObjInfoList);
                        ViewState["ObjectList"] = ObjInfoList;

                        if (FormConfigXML != null)
                        {
                            Frm_TaskDetails.ConfigurationXML = FormConfigXML;                        
                            
                            // display the initiator
                            //Initiator = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                            setInitiatorSelectionControl(null);
                            //Display Attachments
                            FileSystemNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM");
                            XmlNode AssetNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ASSETREFERENCES");
                            setAttachments(FileSystemNode, AssetNode);
                            // Display the template documents
                            setTemplateDocument();
                            //apply percentdone class
                            ApplyPercentDoneClass(InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/STATUS").InnerText, InputXMLDoc, ref FormInputXML);
                            if (TaskStatus.ToUpper() != "COMPLETED" && TaskStatus.ToUpper() != "CANCELLED")
                            {
                                FormInputDoc = new XmlDocument();
                                FormInputDoc.LoadXml(FormInputXML);
                                //FieldNode = FormInputDoc.SelectSingleNode("descendant::Field[@Name='WORKFLOWPROCESS_ACTUALSTARTDATE']");
                                //if (FieldNode != null)
                                //{
                                //    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                //}
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALENDDATE']");
                                if (FieldNode != null)
                                {
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                                }

                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASESTARTDATE']");
                                if (FieldNode != null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASEENDDATE']");
                                if (FieldNode != null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                                FormInputXML = FormInputDoc.OuterXml;
                            }
                            Frm_TaskDetails.InputXML = FormInputXML;
                            //Write the form input xml on ntfs.
                        }
					    ActResourceXML.Append("<ACTIVITYCOLLECTION>");
					    ProcessActivityNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");

                        xp_SortExpression   = XPathExpression.Compile("ACTIVITY");
                        xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                        xp_SortNodeIter     = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                        while (xp_SortNodeIter.MoveNext())
                        {
                             SortXML     += xp_SortNodeIter.Current.OuterXml;
                        }
                        ProcessActivityNode.InnerXml = SortXML;

					    TempPath.Remove(0, TempPath.Length);
					    TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
					    InputXMLDoc.Save(TempPath.ToString());
    					
                        // Select all the manual activities.
                        ActivityNodeList = InputXMLDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE='Task']");					
                        
                        //Hemant Karkande : Do Not Delete this commented code
                        //PaintPredecessorList(ReturnTaskXML);

                        ActivityCount = 0;
					    ActivityNodeList = ProcessActivityNode.SelectNodes("ACTIVITY[IMPLEMENTATIONTYPE='Task' and ACTIVITYID!='" + StepID + "']");
					    ActivityNode	 = ProcessActivityNode.SelectSingleNode("ACTIVITY[IMPLEMENTATIONTYPE='Task' and ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "' and ACTIVITYID='" + StepID + "']");
                        if (ActivityNode != null)
                        {
                            //get the Sequence Number of The Activity for which response will be submitted.
                            // Add a check so that the next activity after this activity will have Contributors Selected
                            setActivityResponsePage(ActivityNode,false);
						    SeqNo = Convert.ToInt32(ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText);
                            createHtmlForDigitalAsset();
                            //setDigitalAsset(ActivityNode, false); 
						    setDigitalAsset(ActivityNode);
						    ResourceXML = MWBHelperClassObj.GetActivityResourceXML(ActivityNode);
						    if(!String.IsNullOrEmpty(ResourceXML))
						    {
							    ActResourceXML.Append(ResourceXML);
						    }
                        }
                        else
                        {						
						    // The user is not authorised to View this Page.
                            gotoErrorPage(Localization.GetString("ALResource", ALParamObj.TenantName, "Unauthorised_Access_Shared"));
						    return;
					    }
    					
                        foreach (XmlNode Activity_Node in ActivityNodeList)
                        {
                            ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Entered For Loop function.");             
                            ActivityStatus = Activity_Node.SelectSingleNode("STATUS").InnerText;
                            switch (ActivityStatus.ToUpper())
                            {                                                                                     
                                case "NEW":
                                case "DRAFT":
										    ResourceXML = MWBHelperClassObj.GetActivityResourceXML(Activity_Node);
										    if(!String.IsNullOrEmpty(ResourceXML))
										    {
											    ActResourceXML.Append(ResourceXML);
										    }
                                            ActivityCount++;
										    setEditableStepForms(Activity_Node, ActivityCount, SeqNo);
                                            break;
                                case "COMPLETED":
                                case "CANCELLED":
                                            setROResponseForm(Activity_Node);                             
                                            break;
                            }
                            ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Exited For Loop function.");             
                        }
					    ActResourceXML.Append("</ACTIVITYCOLLECTION>");
					    TempPath.Remove(0, TempPath.Length);
					    TempPath.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
					    File.WriteAllText(TempPath.ToString(), ActResourceXML.ToString());

                        ViewState["StepFormIDList"] = StepFormIDTable;
                        ViewState["ActivityIDList"] = ActivityIDOrderedList;
                        ViewState["StepROFormIDList"] = StepROFormIDTable;
					    if (!DigitalAssetPresent)
						    RegisterHiddenFields();
                    }
                    //Assign values for prior notification
                    SetAdvanceReminderValues(ReturnTaskXML);
                }
                else
                {
					ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL, true);
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }

            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void createHtmlForDigitalAsset()
        {
            StringBuilder  HTML_ForSBS      = null; 
            StringBuilder  ActionBarXMLPath = null;                
            try
            {
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- Before createHtmlForDigitalAsset() function."); 
                HTML_ForSBS                 = new StringBuilder();
                ActionBarXMLPath            = new StringBuilder();
                SBS_CatalogFile             = new SquareBlankSection();
                Label_CatalogFile           = new Label();
                Label_RefreshCtrl           = new Label(); 
                //Btn_Refresh_DigitalAsset    = new ALButton();
                ALPanel_AssetWidget         = new ALPanel();
                Widget_AssetListWidget      = new Assetlink.Widgets.ALWD_DAM_AssetListWidget.AssetList();  
                AB_CatalogFile              = new ActionBar();

                
                ALPanel_AssetWidget.ID          = "Panel_AssetWidget";
                SBS_CatalogFile.ID              = "SBS_CatalogFile_" + StepID;
                SBS_CatalogFile.TenantName      = ALParamObj.TenantName;
                SBS_CatalogFile.SectionHeading  = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Perform_Response_Assignment_Task_AssetstobeCataloged");
                //BY      : Bhalchandra
                //Date    : 13 September
                //Comment : Cataloged items was not getting displayed on postback due to Table hierarchy problem.
                //          So this tables html is commented.

                //HTML_ForSBS.AppendFormat("<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">");
                //HTML_ForSBS.AppendFormat("<tr>");
                //HTML_ForSBS.AppendFormat("<td>");
                //HTML_ForSBS.AppendFormat("<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">");
                //HTML_ForSBS.AppendFormat("<tr>");
                //HTML_ForSBS.AppendFormat("<td style=\"width:65%;\">");

                //SBS_CatalogFile.ItemContainer.Controls.Add(new LiteralControl(HTML_ForSBS.ToString()));

                Label_CatalogFile.ID	    = "LBL_CatalogFile_Msg";
                Label_CatalogFile.CssClass  = "Text";
                Label_CatalogFile.Text      = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Perform_Response_Assignment_Task_Nofilehasbeencataloged"); 
                SBS_CatalogFile.ItemContainer.Controls.Add(Label_CatalogFile);

                //HTML_ForSBS.Remove(0, HTML_ForSBS.Length);
                //HTML_ForSBS.AppendFormat("</td>");
                //HTML_ForSBS.AppendFormat("<td style=\"width:35%;\" align=\"left\">");

                //SBS_CatalogFile.ItemContainer.Controls.Add(new LiteralControl(HTML_ForSBS.ToString()));

                //Btn_Refresh_DigitalAsset.TenantName     = ALParamObj.TenantName;
                //Btn_Refresh_DigitalAsset.Click          +=new EventHandler(Btn_Refresh_DigitalAsset_Click);
                //Btn_Refresh_DigitalAsset.CssClass       = "SectionButtonBar";
                //Btn_Refresh_DigitalAsset.ToolTip        = "Refresh"; 
                //Btn_Refresh_DigitalAsset.UIType         = ALButton.ALButtonType.ALSmallButton;  
                //Btn_Refresh_DigitalAsset.Text           = "Refresh";
                //Btn_Refresh_DigitalAsset.ID             = "ID_Refresh_DigitalAsset";                 

                //SBS_CatalogFile.ItemContainer.Controls.Add(Btn_Refresh_DigitalAsset);

                //HTML_ForSBS.Remove(0, HTML_ForSBS.Length);
                ////HTML_ForSBS.AppendFormat("</td>");
                //HTML_ForSBS.AppendFormat("</tr>");
                //HTML_ForSBS.AppendFormat("<tr>");
                //HTML_ForSBS.AppendFormat("<td colspan=\"2\" align=\"left\">");
                //SBS_CatalogFile.ItemContainer.Controls.Add(new LiteralControl(HTML_ForSBS.ToString()));

                Widget_AssetListWidget.ID			= "Response_Assetlist";
                Widget_AssetListWidget.TenantName   = ALParamObj.TenantName;
                Widget_AssetListWidget.SessionID    = ALParamObj.SessionID;
                Widget_AssetListWidget.UserID       = ALParamObj.UserID;
                Widget_AssetListWidget.Language     = ALParamObj.Language;
                Widget_AssetListWidget.WidgetName   = "DAM_AssetListWidget";
                Widget_AssetListWidget.UsePopupControlForAssetInformation = false;
                Widget_AssetListWidget.Layout       = Assetlink.Widgets.WidgetCommon.AssetList_Layout.LIST;  
                Widget_AssetListWidget.ScreenMode   = Assetlink.Widgets.WidgetCommon.AssetList_ScreenMode.SEARCHRESULT_ASSETLIST;
                Widget_AssetListWidget.ContentType  = Assetlink.Widgets.WidgetCommon.AssetList_ContentType.ASSETS;
                Widget_AssetListWidget.SearchResultAssetListParameters = new Assetlink.Widgets.WidgetCommon.SearchAssetListMode();
                Widget_AssetListWidget.SearchResultAssetListParameters.InputType = Assetlink.Widgets.WidgetCommon.SEARCHRESULT_ASSETLIST_InputType.ASSETIDLIST;
                Widget_AssetListWidget.ShowPageActions  = false;
                Widget_AssetListWidget.ShowSectionPath  = false;
                Widget_AssetListWidget.ShowHeading      = false;
                Widget_AssetListWidget.GetFromServer    = true;
                Widget_AssetListWidget.ShowTopBar       = false;
                Widget_AssetListWidget.RowCount         = 5;
                Widget_AssetListWidget.ColumnCount      = 2;
                Widget_AssetListWidget.AssetMediaActions = "MOREINFO,VIEWORIGINAL,DOWNLOADPREVIEW,DELETE";
                Widget_AssetListWidget.ShowExpiredAssets = true;
                Widget_AssetListWidget.isCheckMaxSearchResult = false;
              //  Widget_AssetListWidget.RenderContents();
                ALPanel_AssetWidget.Controls.Add(Widget_AssetListWidget);
    
                SBS_CatalogFile.ItemContainer.Controls.Add(ALPanel_AssetWidget);
                
                //HTML_ForSBS.Remove(0, HTML_ForSBS.Length);
                //HTML_ForSBS.AppendFormat("</td>");
                //HTML_ForSBS.AppendFormat("</tr>");
                //HTML_ForSBS.AppendFormat("</table>");
                //HTML_ForSBS.AppendFormat("</td>");
                //HTML_ForSBS.AppendFormat("</tr>");
                //HTML_ForSBS.AppendFormat("<tr>");
                //HTML_ForSBS.AppendFormat("<td>");
                //SBS_CatalogFile.ItemContainer.Controls.Add(new LiteralControl(HTML_ForSBS.ToString()));

                AB_CatalogFile.ID = "AB_ID_CatalogFile"; 
                AB_CatalogFile.TenantName   = ALParamObj.TenantName;
                AB_CatalogFile.InputXMLType = ActionBar.XMLType.XMLPath;
                AB_CatalogFile.Click        += new EventHandler(AB_CatalogFile_Click); 
                
				ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Perform_Response_AssignmentTask_Content_2_ab_CatalogFile_ActionBar"));
                AB_CatalogFile.InputXML = ActionBarXMLPath.ToString();

                SBS_CatalogFile.ItemContainer.Controls.Add(AB_CatalogFile);
                //HTML_ForSBS.Remove(0, HTML_ForSBS.Length);
                //HTML_ForSBS.AppendFormat("</td>");
                //HTML_ForSBS.AppendFormat("</tr>");
                //HTML_ForSBS.AppendFormat("<tr>");
                //HTML_ForSBS.AppendFormat("<td class=\"TextHighlighted\">If you have cataloged any item and it is not coming up in the Cataloged Item list, then please click on the Refresh button to refresh the list.");
                Label_RefreshCtrl.ID        = "LBL_RefreshCtrl_Msg";
                Label_RefreshCtrl.CssClass  = "SmallTextHighlightedWarning";
                Label_RefreshCtrl.Text      = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_Perform_Response_Assignment_Task_Iftheuploadedassetsarenotdisplayedinthelist,clickontheRefreshbutton"); 
                //HTML_ForSBS.AppendFormat("If you have cataloged any item and it is not coming up in the Cataloged Item list, then please click on the Refresh button to refresh the list.");
                //HTML_ForSBS.AppendFormat("</td>");  
                //HTML_ForSBS.AppendFormat("</tr>");
                //HTML_ForSBS.AppendFormat("</table>");
                SBS_CatalogFile.ItemContainer.Controls.Add(Label_RefreshCtrl);

                Manual_Activities.Controls.Add(SBS_CatalogFile);
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbench Page (ResponseAssignment):- After createHtmlForDigitalAsset() function."); 
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        private void setDigitalAsset(XmlNode ActivityNode)
        {
            XmlNode         Activity_ItemNode   = null; 
            String          DigtalAssetIDList   = null; 
            XmlNodeList     DigitalAssetNodes   = null;
            try
            {				
                if (ActivityNode != null)
                {
                    Activity_ItemNode = ActivityNode.SelectSingleNode("ACTIVITY_ITEM");
                    if ((Activity_ItemNode != null) && (Activity_ItemNode.HasChildNodes)) 
                    {
                        DigitalAssetNodes = Activity_ItemNode.SelectNodes("DIGITALASSET");
                        if (DigitalAssetNodes.Count > 0)
                        {
							DigitalAssetPresent = true;
                            Widget_AssetListWidget.Visible = true;
                            //Prepare comma separated list of digital asset id's
                            DigtalAssetIDList = PrepareAssetList(Activity_ItemNode);
                            Widget_AssetListWidget.SearchResultAssetListParameters.AssetIDList = DigtalAssetIDList;
                            Label_CatalogFile.Visible = false;
                            //Btn_Refresh_DigitalAsset.Visible = false;
                        }
                        else
                        {
                            Widget_AssetListWidget.Visible = false;
                            Label_CatalogFile.Visible = true;
                            //if (ItemCataloged)
                            //    Btn_Refresh_DigitalAsset.Visible = true;
                            //else
                            //    Btn_Refresh_DigitalAsset.Visible = false;
                        }
                    }
                    else
                    {
                        Widget_AssetListWidget.Visible = false;
                        Label_CatalogFile.Visible = true;
                        //if (ItemCataloged)
                        //    Btn_Refresh_DigitalAsset.Visible = true;
                        //else
                        //    Btn_Refresh_DigitalAsset.Visible = false;
                    }
                }
                else
                {
                    Widget_AssetListWidget.Visible = false;
                    Label_CatalogFile.Visible = true;
                    //if (ItemCataloged)
                    //    Btn_Refresh_DigitalAsset.Visible = true;
                    //else
                    //    Btn_Refresh_DigitalAsset.Visible = false; 
                }

            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        private String PrepareAssetList(XmlNode ActivityItemNode)
        {
            XmlNodeList     DigitalAssetNodeList    = null;
            StringBuilder   AssetIDList             = null; 
 
            try
            {
                AssetIDList = new StringBuilder();

                DigitalAssetNodeList = ActivityItemNode.SelectNodes("DIGITALASSET");
                foreach (XmlNode DigitalAsset in DigitalAssetNodeList)
                {
                    AssetIDList.AppendFormat("{0},", DigitalAsset.SelectSingleNode("DIGITALASSETID").InnerText);  
                }
                AssetIDList.Remove(AssetIDList.Length - 1, 1);
                return AssetIDList.ToString(); 
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        private void ApplyPercentDoneClass(String TaskStatus, XmlDocument InputXMLDoc, ref String FormInputXML)
        {
            XmlDocument                 FormXMLDoc          = null;
            XmlNode                     FieldNode           = null;
            XmlNode                     DueDateNode         = null;
            String                      PercentDoneClass    = null;
            DateTime                    DueDate;
            MktgWorkBenchFacadeClass    MWBFacadeObject     = null;
		    ulong			            ErrorID				= 0;
            StringBuilder	            ErrorPageURL_Exp	= null;

            try
            {
                FormXMLDoc = new XmlDocument();
                FormXMLDoc.LoadXml(FormInputXML);

                if (TaskStatus.ToUpper() != "NEW" && TaskStatus.ToUpper() != "DRAFT")
                {
                    DueDate = DateTime.Today;

                    DueDateNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DUEDATE");
                    DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESSINFO_PERCENTDONE_PROCESS_INFORMATION']");

                    MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(TaskStatus, DueDate);

                    ((XmlElement)FieldNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                    FormInputXML = FormXMLDoc.OuterXml;
                }
                
            }
            catch (Exception ExceptionObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "ApplyPercentDoneClass", ExceptionObj, null,
                    Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_DeliverableDetails_Exceptionwhileshowingactualdatesforthedeliverable_Shared"));

                ErrorPageURL_Exp = new StringBuilder();
                ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                if (!IsPostBack)
                {
                    //Response.Redirect(ErrorPageURL_Exp.ToString());
                }
                else
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }
        }

        private void setActivityResponsePage(XmlNode ActivityNode,Boolean b_ResetFacetSeries)
        {
            StringBuilder   StepFormID          = null;
            StringBuilder   ActivityColl        = null;
            StringBuilder   ParameterList       = null;
            StringBuilder   InputXMLPath        = null;
			StringBuilder	TempFilePath		= null;
            String          FormConfigXMLPath   = null; 
            String          TempPath            = null;
            MWB_Helper      MWBHelperClassObj   = null;
            FormFacade      FormFacadeObj       = null;
            ERRORXML        ErrorXML            = null;
            XML             FormConfigXML       = null;
            XML             StepFormInputXML    = null;
            XmlDocument     StepDoc             = null;
            XmlAttribute    UploadAttr          = null;
            XmlNode         FieldNode           = null;
            XmlNode         UploadUrlNode       = null;
            XmlNode         xmlNode_SelectedComponents= null;
			String			strFormName			= null;
			String			strStdFormName		= null;
			String			strSelectedFormName	= null;
			String			strActivityDefID	= null;
            String          SearchXML           = null;            
            Int32           int_ControlIndex    = 0;

            try
            {
                ResponseForm        = new Form();
                StepFormID          = new StringBuilder(100);
                ActivityColl        = new StringBuilder(100);
                ParameterList       = new StringBuilder(100);
                InputXMLPath        = new StringBuilder(100);
				TempFilePath		= new StringBuilder(100);
                StepDoc             = new XmlDocument();                
                MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                FormFacadeObj.SolutionName = SolutionName;
				strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
				strFormName				= strActivityDefID+ "_Response";
				strStdFormName			= "StepDetails_Response";
				FormConfigXMLPath       = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
				FormFacadeObj.FormName	= strSelectedFormName;

                StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                ResponseForm.ID						= StepFormID.ToString();
               __ResponseFormID.Value				= StepFormID.ToString();
                ResponseForm.TenantName				= ALParamObj.TenantName;
                ResponseForm.SolutionName			= SolutionName;
				ResponseForm.IsDynamicForm			= true;
                ResponseForm.ShowConfiguredFields   = true;  
                FormFacadeObj.ShowConfiguredFields	= true;
                ResponseForm.InputXMLType			= Assetlink.CustomControls.Form.InputType.InnerXML;				
                ResponseForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;                               
                FormConfigXML						= MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,true);
                

                ResponseForm.SeriesActionBarClick +=new EventHandler(ResponseForm_SeriesActionBarClick);                
                xmlNode_SelectedComponents = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                if ((!IsPostBack)&&(xmlNode_SelectedComponents != null) && (xmlNode_SelectedComponents.HasChildNodes))
                {
                    //Save this return XML on NTFS in temp location                            
                    TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + StepID + str_SelectedComponentsIDFileName);
                    File.WriteAllText(TempFilePath.ToString(), xmlNode_SelectedComponents.InnerXml);
                    TempFilePath.Remove(0, TempFilePath.Length);
                }

                FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, SearchXML);
                if (ErrorXML == null)
                {
                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID.ToString());
                    if ((File.Exists(TempFilePath.ToString())) && (IsPostBack))
                    {
                        StepFormInputXML = File.ReadAllText(TempFilePath.ToString());
                    }
                    else
                    {
                        //HemantK: check for the deliverable component facet series
                        CheckComponentFacetSeriesStatus(ResponseForm);
                        ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);
                        ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                        ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                    }
                    ResponseForm.ConfigurationXML = FormConfigXML;

                    StepDoc.LoadXml(StepFormInputXML);
                    FieldNode = StepDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                    if (FieldNode != null)
                    {
                        ParameterList.AppendFormat("&TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}&ControlID={5}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName, Btn_StepAttachments.UniqueID);
                        if (FieldNode.Attributes.GetNamedItem("UploadURL") != null)
                        {
                            UploadUrlNode = FieldNode.Attributes.GetNamedItem("UploadURL");
                            UploadUrlNode.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                        }
                        else
                        {
                            UploadAttr = StepDoc.CreateAttribute("UploadURL");
                            UploadAttr.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                            FieldNode.Attributes.Append(UploadAttr);
                        }
                        if (FieldNode.Attributes.GetNamedItem("DownLoadURL") != null)
                        {
                            UploadUrlNode = FieldNode.Attributes.GetNamedItem("DownLoadURL");
                            UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                        }
                        else
                        {
                            UploadAttr = StepDoc.CreateAttribute("DownLoadURL");
                            UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                            FieldNode.Attributes.Append(UploadAttr);
                        }
                    }                                       
                    if ((IsPostBack) && (b_ResetFacetSeries))
                    {
                        ResponseForm.ResetBinders = true;
                        ResponseForm.ResetFileUploadControls = true;
                    }
                    ResponseForm.InputXML = StepDoc.OuterXml;
                    ResponseForm.ConfigurationMode = true;
                    if (Manual_Activities.FindControl(ResponseForm.ID) != null)
                    {
                        int_ControlIndex = Manual_Activities.Controls.IndexOf(Manual_Activities.FindControl(ResponseForm.ID));
                        Manual_Activities.Controls.RemoveAt(int_ControlIndex);
                        Manual_Activities.Controls.AddAt(int_ControlIndex, ResponseForm);
                    }
                    else
                    {
                        Manual_Activities.Controls.Add(ResponseForm);
                    }

                    File.WriteAllText(TempFilePath.ToString(), StepFormInputXML);
                    if (b_ResetFacetSeries)
                        ResponseForm.ResetFacetSeriesFields();
                }
                if (!IsPostBack)
                    setForwardTaskForm(ActivityNode);
                
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void setEditableStepForms(XmlNode ActivityNode,int ActivityCount,int SeqNo)
        {
            MWB_Helper      MWBHelperClassObj   = null;
            FormFacade      FormFacadeObj       = null;
            StringBuilder   StepFormID          = null;
            StringBuilder   ActivityColl        = null;
            StringBuilder   TempPath            = null;
            StringBuilder	GroupListXML		= null;
            String          FormConfigXMLPath   = null;
            String          ResourceID          = null;
            String          ResourceType        = null;
            String          MailID              = null;
            String          TempFilePath        = null;
            XML             FormConfigXML       = null;
            XML             StepFormInputXML    = null;
            XML             ItemListXML         = null;
            XmlNode         ActivityResourceNode = null;
            XmlNode         ActualResourceNode   = null;
            XmlNode         FieldNode            = null;
            XmlNode         ValueNode            = null;
            XmlNode         xmlNode_SelectedComponents= null;
            XmlDocument     FormXMLDoc           = null;
            ERRORXML        ErrorXML             = null;            
            StringBuilder	ContributorFileName	 = null; 
            XML				UserCollectionXML	 = null;
			String			ActivityID			 = null;
			StringBuilder	ParamURL				= null;
			StringBuilder	SelectedValueXml		= null;
			String			SelectedValueFileName	= null;
			XML				GroupXML				= null;
			String			GroupID					= null;
			XPathDocument	UserDoc					= null;
			GroupFacade		GroupFacadeObj			= null;
			XML				SearchXML				= null;
			String			strFormName				= null;
			String			strStdFormName			= null;
			String			strSelectedFormName		= null;
			String			strActivityDefID		= null;
            String          str_SearchXML           = null;
            
            try
            {
                Form StepForm       = new Form();                
                StepFormID          = new StringBuilder();
                ActivityColl        = new StringBuilder();
                TempPath            = new StringBuilder();
				GroupListXML		= new StringBuilder();
				ContributorFileName	= new StringBuilder();
				SelectedValueXml	= new StringBuilder();
                FormXMLDoc          = new XmlDocument();
                MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                GroupFacadeObj		= new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

				ActivityID			= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
				strActivityDefID	= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
				strStdFormName		= "StepDetails_Editable";
				strFormName			= strActivityDefID + "_Editable" ;
				
				StepFormID.AppendFormat("STEP_{0}", ActivityID);
                StepForm.ID = StepFormID.ToString();
				
                ActivityIDOrderedList.Add(ActivityID);
                TempFilePath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                
                if (StepFormIDTable.ContainsKey(ActivityID)==false)
                    StepFormIDTable.Add(ActivityID, StepFormID.ToString());
                //StepForm.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);                            
                StepForm.TenantName				= ALParamObj.TenantName;
				StepForm.SolutionName			= SolutionName;
				StepForm.IsDynamicForm			= true;
                StepForm.InputXMLType			= Assetlink.CustomControls.Form.InputType.InnerXML;
                StepForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;
                StepForm.ShowConfiguredFields   = true; 
				FormConfigXMLPath				= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName,out strSelectedFormName);
                FormConfigXML					= MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,false);
                
                FormFacadeObj.SolutionName	= SolutionName;
				FormFacadeObj.UniqueID		= StepFormIDTable[ActivityID].ToString();
                FormFacadeObj.FormName		= strSelectedFormName;
                FormFacadeObj.ShowConfiguredFields = true;

                xmlNode_SelectedComponents = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                if ((xmlNode_SelectedComponents != null) && (xmlNode_SelectedComponents.HasChildNodes))
                {
                    //Save this return XML on NTFS in temp location                            
                    TempPath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ActivityID + str_SelectedComponentsIDFileName);
                    File.WriteAllText(TempPath.ToString(), xmlNode_SelectedComponents.InnerXml);
                    TempPath.Remove(0, TempPath.Length);
                }
                FormFacadeObj.GetHierarchicalSearchXML("Edit", out str_SearchXML);
                //HemantK: check for the deliverable component facet series
                ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, str_SearchXML);
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    StepForm.ConfigurationXML   = FormConfigXML;
                    //CheckComponentFacetSeriesStatus(StepForm);
                    //Radha: To remove actionbar to other contributors.
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        StepForm.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                        StepForm.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }

                    ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);
                    ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out StepObjInfoList);
                    if (ErrorXML == null)
                    {
					    if(Convert.ToInt32((ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText)) == SeqNo + 1)
					    {						
						    ViewState["NextActivitySeqNo"] = Convert.ToInt32((ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText));
					    }
					    ViewState["StepObjectList" + ActivityID] = StepObjInfoList;
                        
					    ParamURL = new StringBuilder(150);
					    SelectedValueFileName = StepFormID.ToString() + "_ContributorGroup_SelectedValueList.xml";
					    ParamURL.Append("SelectResourceType.aspx?");
					    //ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceType.UniqueID, SelectedValueFileName, ResourceTreeFile);
                        ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&StepID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepID, Hidden_SelectResourceType.UniqueID);
      
					    //ItemListXML = MWBHelperClassObj.PrepareFormInputXML(ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").OuterXml, "RESOURCETYPE", "RESOURCEID");

                        // check if this activity has any actual resources associated with it
                        ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                        if(ActivityResourceNode!=null)
                            ActualResourceNode   = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");
    					
                        FormXMLDoc.LoadXml(StepFormInputXML);
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                        if (FieldNode != null)
                        {
						    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
						    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                        }

                        if (ActualResourceNode != null)
                        {
						    ResourceType	= ActualResourceNode.SelectSingleNode("RESOURCETYPE").InnerText;
						    GroupListFile	= StepFormID.ToString() + "_GroupUsers.xml";
						    SearchXML		= GetSearchXMLForGroupAndUsers(ResourceType);
						    TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);
						    ErrorXML		= GroupFacadeObj.GetGroupList(SearchXML, ref GroupXML);
						    if(ErrorXML == null)
						    {
							    if(GroupXML != null)
							    {
								    MWBHelperClassObj.GetGroupIDAndUserXML(GroupXML, out UserCollectionXML, out GroupID);											
								    File.WriteAllText(TempPath.ToString(), UserCollectionXML);
								    TempPath.Remove(0, TempPath.Length);
								    TempPath.AppendFormat("{0}{1}", TempFilePath, SelectedValueFileName);
								    SelectedValueXml.AppendFormat("<ValueList><Value ID='{0}' Text='{1}'/></ValueList>", GroupID, ALSolutionCommon.TrimAndReplaceSpecialChars(ResourceType));
								    File.WriteAllText(TempPath.ToString(), SelectedValueXml.ToString());
								    UserDoc		= new XPathDocument(new StringReader(UserCollectionXML));
								    ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
								    if(ItemListXML != null)
								    {
									    if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
									    {
										    ResourceID	= ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
										    ItemListXML	= MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
										    MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
									    }
								    }
							    }
							    else
							    {
                                    ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
							    }
						    }
                        }
                        else
                        {
                            ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                            if (Convert.ToInt32((ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText)) == SeqNo +1)
                            {
							    ContributorSelected.Value = "FALSE";
							    //ViewState["NextActivitySeqNo"] = Convert.ToInt32((ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText));
						    }
						    //else
						    //{
						    //    ContributorSelected.Value = "TRUE";
						    //}							
                        }
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (FieldNode != null)
                        {                                    
                            FieldNode.InnerXml = ItemListXML;
                        }
                        if (MailID != null)
                        {
                            FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                            if (FieldNode != null)
                            {
                                ValueNode = FormXMLDoc.CreateElement("Value");
                                ValueNode.InnerText = MailID;
                                FieldNode.AppendChild(ValueNode);
                            }                                
                        }
                        //Hide Duration
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
                        if (FieldNode != null)
                        {
                            if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                                ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                            else
                                FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                        }
                        StepForm.InputXML = FormXMLDoc.OuterXml;
                        TempPath.Remove(0,TempPath.Length);
                        TempPath.AppendFormat("{0}{1}.xml", TempFilePath, StepFormID.ToString());
                        //ViewState[StepForm.ID] = FormXMLDoc.OuterXml;
                        File.WriteAllText(TempPath.ToString(), FormXMLDoc.OuterXml);
                    }
                    Manual_Activities.Controls.Add(StepForm);
                    if (IsPostBack)
                    {
                        StepForm.ResetFacetSeriesFields();
                    }
                    StepForm.ConfigurationMode = true;
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private ERRORXML SaveResponse(String Status, bool SubmitResponse,out bool alertGiven)
        {
            StringBuilder   UpdateTaskXML   = null;
            MWB_Helper      MWB_HelperObj   = null;
            String          ResponseFormID  = null;
            FormFacade      FormFacadeObj   = null;
            ERRORXML        ErrorXML        = null;
            XML             ResponseXML     = null;
            XML             StepXML         = null;
            XML             ActivityResourceXML = null;
            XML             SaveTaskXML         = null;
            
            XmlDocument                 TaskDoc                 = null;
            XmlDocument                 ResponseDoc             = null;
            XmlDocument                 ActivityDoc             = null;
            StringBuilder               TempPath                = null;
            StringBuilder               DisAssociateXML         = null;            
            StringBuilder               UpdateActivityXML       = null;
            StringBuilder               PostedOnDate            = null;
            StringBuilder				UpdateActInstr			= null;
            String                      TempFilePath            = null;
            String                      SelectedGroup           = null;
            String                      SelectedContributor     = null;
            String                      OldUserID               = null;
            String                      ActualResourceID        = null;
            String                      ActivityResourceID      = null;
            String						Instructions			= null;
            String                      ActivityID              = null; 
            int							NextActSeqNo			= 0;            
            int                         ActivitySeqNumber       = 0;
            int                         EndActivitySeqNumber    = 0;            
            XmlNode                     ActivityNode            = null;    
            XmlNode                     ResourceNode            = null;               
            XmlNode                     StatusNode              = null;           
            XmlNode                     ActivityResourceNode    = null;            
            XmlNode                     DisAssociateResourceNode= null;
            XmlNode                     ResponseNode            = null;
            XmlNode                     PostedByNode            = null;
            XmlNode                     OldUserNode             = null;
            XmlNode                     ResponsePostedOn        = null;
            XmlNode                     ActivityResponseNode    = null;
            XmlNode						ActivityContributorNode	= null;                
            bool                        ActivityModified        = true;
            bool                        DisAssociateUserOnly    = false;            
            MktgWorkBenchFacadeClass    MktgFacadeObj           = null; 
            Boolean						CreateNewActualRes		= false;
            Boolean						AddNewUser				= false;            
            Boolean						DisAssociateUserAndGroup= false;
            Boolean                     DisAssociateGroup       = false;
            XML							TempXML					= null;
            XmlDocument					TempDoc					= null;
			String						SelectedGroupName		= null;
			XPathDocument				ActResDoc				= null;
			StringBuilder				ActResFile				= null;
			String						strFormName				= null;
			String						strStdFormName			= null;
			String						strSelectedFormName		= null;
			String						strActivityDefID		= null;
            //HemantK:For Component Facet Series
            String                      str_FormActionBarXML    = null; 
            StringBuilder               sb_FormActionBarXML     = null; 
            String                      str_ComponentRShip      = null;
            StringBuilder               sb_ActivityInfo         = null;
            String                      str_ActivityInfoId      = null;
            String                      str_ComponentObjectName = null;
            String                      str_ComponentPrimaryKey = null;
            Hashtable                   obj_SelectComponentIDs  = null;
            XPathDocument               xpathDoc_FormConfig     = null;
            String                      str_FormConfigXmlPath   = null;
            MWB_Component               obj_Component           = null;
            XmlNode                     xmlNode_SelectedComponents= null;
            String                      str_ResponseFormConfigFile= null;
            
            try
            {
                FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                obj_Component = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MktgFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                UpdateTaskXML = new StringBuilder();
                TempPath            = new StringBuilder();
                DisAssociateXML     = new StringBuilder();
                UpdateTaskXML       = new StringBuilder();
                UpdateActivityXML   = new StringBuilder();
                PostedOnDate        = new StringBuilder();
                ActivityDoc         = new XmlDocument();
                TaskDoc             = new XmlDocument();
                ResponseDoc         = new XmlDocument();
				TempDoc				= new XmlDocument();
                sb_ActivityInfo     = new StringBuilder(700);
                sb_FormActionBarXML = new StringBuilder(500);
                obj_SelectComponentIDs = new Hashtable();

				alertGiven			= false;
				strStdFormName		= "StepDetails_Response";
                TempFilePath        = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                ResponseFormID      = __ResponseFormID.Value;
                TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
                TaskDoc.Load(TempPath.ToString());                
                UpdateTaskXML.AppendFormat("<WORKFLOWPROCESS><WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>", TaskID);
                UpdateTaskXML.AppendFormat("<PROCESS_ACTIVITY TYPE='RELATION'>");

                sb_FormActionBarXML.Append("<ACTIONBARCOLLECTION>");  
                if (ResponseFormID != null)
                {
                    ActivityNode			= TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']");
					strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
                    str_ActivityInfoId      = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYINFORMATIONID").InnerText;
					strFormName				= strActivityDefID + "_Response";

                    str_ResponseFormConfigFile = MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);

					FormFacadeObj.FormName		= strSelectedFormName;
                    FormFacadeObj.SolutionName	= SolutionName;
                    Form ResponseForm			= (Form)Manual_Activities.FindControl(ResponseFormID);
                    ResponseForm.ID				= ResponseFormID;
                    ResponseObjInfoList			= (List<ObjectInfo>)ViewState["ResponseObjInfo"];

                    //HemantK:Get the Form ActionBar
                    str_FormActionBarXML = GetFormActionBarXML(ResponseForm);
                    if (!String.IsNullOrEmpty(str_FormActionBarXML))
                    {
                        sb_FormActionBarXML.Append(@"<ACTIONBAR> 
                                                        <ACTIONBARFOR>ACTIVITY</ACTIONBARFOR>
                                                        <ID>" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + "</ID>"
                                                        + str_FormActionBarXML + "</ACTIONBAR>");
                    }
//                    obj_SelectComponentIDs.Add(ActivityNode.SelectSingleNode("ACTIVITYID").InnerText, false);
                    ErrorXML					= FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", ResponseForm, ResponseObjInfoList, out ResponseXML);
                    if (ErrorXML == null)
                    {
                        PostedOnDate.AppendFormat(@"<YEAR>{0}</YEAR>
                                                        <MONTH>{1}</MONTH>
                                                        <DAY>{2}</DAY>
                                                        <HOUR>{3}</HOUR>
                                                        <MINUTE>{4}</MINUTE>
                                                        <SECOND>{5}</SECOND>", DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second);
                        ResponseXML = ResponseXML.Replace("<ACTIVITY>", "<ACTIVITY MODIFIED='TRUE'>");
                        ResponseDoc.LoadXml(ResponseXML);
                        xmlNode_SelectedComponents = ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                        //if (xmlNode_SelectedComponents != null)
                        //{
                        //    xmlNode_SelectedComponents.ParentNode.RemoveChild(xmlNode_SelectedComponents);
                        //}

                        //Get component facet name and its primary key 
                        if ((ViewState["ComponentFacetSeriesRShipName"] != null) && (ResponseObjInfoList != null))
                        {
                            str_ComponentRShip = ViewState["ComponentFacetSeriesRShipName"].ToString();
                            for (int ObjectIndex = 0; ObjectIndex < ResponseObjInfoList.Count; ObjectIndex++)
                            {
                                if (ResponseObjInfoList[ObjectIndex].RelationShipName == str_ComponentRShip)
                                {
                                    str_ComponentObjectName = ResponseObjInfoList[ObjectIndex].ObjectName;
                                    str_ComponentPrimaryKey = ResponseObjInfoList[ObjectIndex].PrimaryKeyName;
                                    break;
                                }
                            }
                            if ((SubmitResponse) && (!String.IsNullOrEmpty(str_ComponentPrimaryKey)) && (!String.IsNullOrEmpty(str_ComponentObjectName)))
                            {
                                obj_Component.UpdateSelectedComponentsXmlForActivity(TaskID, ActivityNode, str_ComponentFacetFileName, str_ComponentRShip, str_ComponentObjectName, str_ComponentPrimaryKey, str_SelectedComponentsIDFileName);
                                if ((ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS") != null) && (ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS") != null))
                                {
                                    ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS").InnerXml += ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS").InnerXml;
                                }
                            }
                        }
                        if ((File.Exists(str_ResponseFormConfigFile)) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                        {
                            xpathDoc_FormConfig = new XPathDocument(str_ResponseFormConfigFile);
                            if (xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                            {
                                obj_SelectComponentIDs.Add(StepID, true);
                            }
                            else
                            {
                                obj_SelectComponentIDs.Add(StepID, false);
                            }
                        }

                        if (SubmitResponse)
                        {
                            ActivityNode = ResponseDoc.SelectSingleNode("ACTIVITY");
                            StatusNode = ResponseDoc.CreateElement("STATUS");
                            ActivityNode.AppendChild(StatusNode);
                            StatusNode.InnerText = "Completed";

                           
                           ActivityID = ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
                           ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + ActivityID  + "']" );
                           ActivitySeqNumber = Convert.ToInt16 ( ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText);
                           ActivityNode = null;

                           ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ENDACTIVITY='True']");
                           EndActivitySeqNumber  = Convert.ToInt16 ( ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText);
                        }
                        ResponseNode = ResponseDoc.SelectSingleNode("ACTIVITY/ACTIVITY_RESPONSE/RESPONSE");
                        ResponsePostedOn = ResponseDoc.CreateElement("RESPONSEPOSTEDON");
                        ResponsePostedOn.InnerXml = PostedOnDate.ToString();
                        ResponseNode.AppendChild(ResponsePostedOn);
                        if (ResponseNode.Attributes.GetNamedItem("MODIFIED") == null)
                        {
                            PostedByNode = ResponseDoc.CreateElement("POSTEDBY");
                            ResponseNode.AppendChild(PostedByNode);
							((XmlElement)PostedByNode).SetAttribute("TYPE", "RELATION");
                            PostedByNode.InnerText = ALParamObj.UserID;
                        }
                        else //IF response was saved or after the ReRoute
                        {
                            PostedByNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + ActivityID  + "']/ACTIVITY_RESPONSE/RESPONSE/POSTEDBY");
                            if (PostedByNode != null)
                            {
                                if (PostedByNode.SelectSingleNode("USER/USERID").InnerText != ALParamObj.UserID)
                                {
                                    String str_PostedBy = null;

                                    str_PostedBy = "<POSTEDBY TYPE='RELATION' DISASSOCIATE='TRUE'>" + PostedByNode.SelectSingleNode("USER/USERID").InnerText + "</POSTEDBY>";
                                    str_PostedBy += "<POSTEDBY TYPE='RELATION'>" + ALParamObj.UserID + "</POSTEDBY>";
                                    ResponseNode.InnerXml += str_PostedBy;
                                }
                            }
                        }
                    }

                    UpdateActivityXML.AppendFormat("{0}", ResponseDoc.OuterXml);
                }

                // Check for any new contributors
                StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];

                IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

				ActResFile	= new StringBuilder();
				ActResFile.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
				if(File.Exists(ActResFile.ToString()))
				{
					ActResDoc = new XPathDocument(ActResFile.ToString());
				}
				strStdFormName = "StepDetails_Editable";
                while (StepFormIDEnum.MoveNext())
                {
                    ActivityModified			= true;
                    DisAssociateUserOnly		= false;							
					DisAssociateUserAndGroup	= false;							
					CreateNewActualRes			= false;
					AddNewUser					= false;
                    OldUserNode					= null;
                    OldUserID					= null;
					ActivityNode				= TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']");
					if(ActivityNode != null)
					{
						strActivityDefID = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
						strFormName		 = strActivityDefID + "_Editable";
					}

					Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                    str_FormConfigXmlPath = MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
                    FormFacadeObj.FormName      = strSelectedFormName;

                    if ((File.Exists(str_FormConfigXmlPath)) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        xpathDoc_FormConfig = new XPathDocument(str_FormConfigXmlPath);
                        if (xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                        {
                            obj_SelectComponentIDs.Add(StepFormIDEnum.Key.ToString(), true);
                        }
                        else
                        {
                            obj_SelectComponentIDs.Add(StepFormIDEnum.Key.ToString(), false);
                        }
                    }
                    //HemantK:Get the Form ActionBar
                    str_FormActionBarXML = GetFormActionBarXML(StepForm);
                    if (!String.IsNullOrEmpty(str_FormActionBarXML))
                    {
                        sb_FormActionBarXML.Append(@"<ACTIONBAR> 
                                                        <ACTIONBARFOR>ACTIVITY</ACTIONBARFOR>
                                                        <ID>" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + "</ID>"
                                                        + str_FormActionBarXML + "</ACTIONBAR>");
                    }

					SelectedGroup				= MWB_HelperObj.GetSelectedActivityResourceID(ActResDoc, StepFormIDEnum.Key.ToString(), out SelectedGroupName);
                    SelectedContributor			= StepForm.GetValues("Contributor");							
					Instructions				= ALSpecialCharHandling.TrimAndReplaceSpecialChars(StepForm.GetValues("ACTIVITY_INSTRUCTIONS"));            
		
                    StepObjInfoList = (List<ObjectInfo>)ViewState["StepObjectList" + StepFormIDEnum.Key.ToString()];

					// Case - I : When Selected Group not equal "None" and SelectedContributor not equal to "None"
					// Here disassociate the actual resource from the Activity resource, and also activity contributor
					// this will also disassociate the resource user relationship from the actual resource.
					if(SelectedGroup.ToUpper() != "NONE")
					{								
						if (ActivityNode != null)
						{
							NextActSeqNo = Convert.ToInt32(ViewState["NextActivitySeqNo"]);
							if((NextActSeqNo == Convert.ToInt32(ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText)) &&(SelectedContributor.ToUpper() == "NONE"))
							{
								ContributorSelected.Value = "FALSE";
							}
							else if((NextActSeqNo == Convert.ToInt32(ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText)) && (SelectedContributor.ToUpper() != "NONE"))
								ContributorSelected.Value = "TRUE";									
							if (SelectedContributor.ToUpper() != "NONE")
							{
								MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);	
								if ((ActivityResourceID != null) && (ActualResourceID != null))
								{
									// group and contributor both changed.
									OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
									if (OldUserNode != null)
									{
										OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
									}
									if ((SelectedGroup != ActivityResourceID))
									{												
										DisAssociateUserAndGroup = true;
									}
									else if (OldUserID != SelectedContributor)
									{
										// the selected group is same but the contributor is changed. 
										if (OldUserID !=null)
											DisAssociateUserOnly = true;
										else
											AddNewUser = true;
									}
									else
									{
										ActivityResourceID = null;
										ActualResourceID = null;
										ActivityModified = false;
									}
								}
								else  if (ActualResourceID == null)
								{
									// create new actual resource
									CreateNewActualRes = true;
								}
							}
							else  // here Selected Group value not equal to "None" but Selected contributor value = "None"
							{
								MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
								if((ActivityResourceID != null) && (ActualResourceID != null))
								{
                                    OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
									if(OldUserNode != null)
									{
										OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
										DisAssociateUserOnly = true;
									}

                                    if (SelectedGroup != ActivityResourceID)
                                    {
                                        DisAssociateGroup = true;

                                        //Resource Type is changed when no contributor is selected. In this case new Resource type was not getting added.
                                        //Hence doe is added to add new resource type delete old one.
                                        CreateNewActualRes = true;
                                    }
								}
								else // here only the resource type is selected.
								{
									CreateNewActualRes = true;

                                    //DisAssociate Old Resource Type if new resource type is selected
                                    if (SelectedGroup != ActivityResourceID)
                                    {
                                        DisAssociateGroup = true;
                                    }
								}
							}
						}
					}
					else //  here selected Group Value = "None"
					{
						NextActSeqNo = Convert.ToInt32(ViewState["NextActivitySeqNo"]);
						if((NextActSeqNo == Convert.ToInt32(ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText)) && (SelectedContributor.ToUpper() == "NONE"))
						{
							ContributorSelected.Value = "FALSE";
						}
						else
						if((NextActSeqNo == Convert.ToInt32(ActivityNode.SelectSingleNode("SEQUENCENUMBER").InnerText)) && (SelectedContributor.ToUpper() != "NONE"))
							ContributorSelected.Value = "TRUE";
						// if selected value is None then we need to check if there were any previously selected group and users
						// if yes then they will be disassociated.
														
						MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
						if ((ActivityResourceID!=null) && (ActualResourceID!=null))
						{
							DisAssociateUserAndGroup = true;
							OldUserNode = ActivityNode.SelectSingleNode("descendant::RESOURCE_USER/USER");
							if(OldUserNode != null)
							{
								OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
								DisAssociateUserOnly = true;
							}
						}								
					}
					if (ActivityModified)
					{
						ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", StepForm, StepObjInfoList, out StepXML);
						if(ErrorXML != null)
							return ErrorXML;
						if (DisAssociateUserAndGroup)
						{
							if ((ActivityResourceID != null) && (ActualResourceID != null))
							{										
								if (ActivityNode!=null)
								{
									// Now check whether new group and user is selected.
									if ((SelectedGroup.ToUpper()!="NONE") &&(SelectedContributor.ToUpper()!="NONE"))
									{
										ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
										MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML,SelectedGroupName);
										MWB_HelperObj.prepareActivityXML(true, StepXML, ActivityResourceXML, out TempXML);
										TempDoc.LoadXml(TempXML);
										ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");											
									}
									else
									{
										TempDoc.LoadXml(StepXML);
										ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
									}
									((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
									DisAssociateXML.Remove(0, DisAssociateXML.Length);
									DisAssociateXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>", ActivityResourceID);
									if (OldUserID!= null)
									{
										DisAssociateXML.AppendFormat(@"<ACTUAL_RESOURCE TYPE='RELATION'>
																		<RESOURCE MODIFIED='TRUE'>
																			<RESOURCEID>{0}</RESOURCEID>
																			<RESOURCE_USER TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</RESOURCE_USER>
																		</RESOURCE>
																	</ACTUAL_RESOURCE>", ActualResourceID, OldUserID);
									}
									DisAssociateXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTUAL_RESOURCE>", ActualResourceID);
									DisAssociateResourceNode = TempDoc.CreateElement("RESOURCE");
									((XmlElement)DisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");
									DisAssociateResourceNode.InnerXml = DisAssociateXML.ToString();
									if(OldUserNode != null)
									{
										ActivityContributorNode = TempDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
										((XmlElement)ActivityContributorNode).SetAttribute("TYPE", "RELATION");
										((XmlElement)ActivityContributorNode).SetAttribute("DISASSOCIATE", "TRUE");
										ActivityContributorNode.InnerText = OldUserNode.SelectSingleNode("USERID").InnerText;
                                        //ActivityNode.AppendChild(ActivityContributorNode);
                                        ActivityNode.PrependChild(ActivityContributorNode);
									}
									ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE");
									if(ActivityResourceNode == null)
									{
										ActivityResourceNode = TempDoc.CreateElement("ACTIVITY_RESOURCE");
										((XmlElement)ActivityResourceNode).SetAttribute("TYPE", "RELATION");
										ActivityNode.AppendChild(ActivityResourceNode);
									}
									ActivityResourceNode.AppendChild(DisAssociateResourceNode); 
									//ProcessActivityNode.AppendChild(FormDataDocument.ImportNode(ActivityNode, true));
									ActivityResponseNode =  ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
									if (ActivityResponseNode!=null)
									ActivityNode.RemoveChild(ActivityResponseNode);
									UpdateTaskXML.Append(ActivityNode.OuterXml);
								}																																								
							}
						}
						else if((DisAssociateUserOnly)||(AddNewUser))
						{
							MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, StepXML, SelectedGroupName, out TempXML);
							TempDoc.LoadXml(TempXML);
							ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
							if(ActivityNode != null)
							{										
								ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
								if(ActivityResponseNode != null)
									ActivityNode.RemoveChild(ActivityResponseNode);
								UpdateTaskXML.Append(ActivityNode.OuterXml);
							}
						}
						else if (CreateNewActualRes)
						{
							ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
							MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML,SelectedGroupName);
							MWB_HelperObj.prepareActivityXML(true, StepXML, ActivityResourceXML, out TempXML);
							TempDoc.LoadXml(TempXML);
							ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
							if(ActivityNode != null)
							{										
								ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
								if(ActivityResponseNode != null)
									ActivityNode.RemoveChild(ActivityResponseNode);

                                if (DisAssociateGroup)
                                {
                                    XmlNode TmpDisAssociateResourceNode = TempDoc.CreateElement("RESOURCE");
                                    ((XmlElement)TmpDisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");
                                    TmpDisAssociateResourceNode.InnerXml = "<RESOURCEID>" + ActivityResourceID + "</RESOURCEID><ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>" + ActualResourceID + "</ACTUAL_RESOURCE>";

                                    ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").AppendChild(TmpDisAssociateResourceNode);
                                }
								UpdateTaskXML.Append(ActivityNode.OuterXml);										
							}
						}
						else
						{
							// only update the instructions.
							UpdateActInstr = null;
							UpdateActInstr = new StringBuilder();
							UpdateActInstr.Append("<ACTIVITY MODIFIED='TRUE'>");
							UpdateActInstr.AppendFormat("<ACTIVITYID>{0}</ACTIVITYID>", StepFormIDEnum.Key.ToString());
							UpdateActInstr.Append("<INSTRUCTIONS>");
							UpdateActInstr.Append(Instructions);
							UpdateActInstr.Append("</INSTRUCTIONS>");
							UpdateActInstr.Append("</ACTIVITY>");									
							UpdateTaskXML.Append(UpdateActInstr.ToString());
						}																
					}
					else
					{
						// only update the instructions.
						UpdateActInstr = null;
						UpdateActInstr = new StringBuilder();
						UpdateActInstr.Append("<ACTIVITY MODIFIED='TRUE'>");
						UpdateActInstr.AppendFormat("<ACTIVITYID>{0}</ACTIVITYID>", StepFormIDEnum.Key.ToString());
						UpdateActInstr.Append("<INSTRUCTIONS>");
						UpdateActInstr.Append(Instructions);
						UpdateActInstr.Append("</INSTRUCTIONS>");
						UpdateActInstr.Append("</ACTIVITY>");								
						UpdateTaskXML.Append(UpdateActInstr.ToString());
					}														
                }
		
                UpdateTaskXML.AppendFormat("{0}", UpdateActivityXML.ToString());
                UpdateTaskXML.Append("</PROCESS_ACTIVITY>");
                UpdateTaskXML.Append("</WORKFLOWPROCESS>");
                SaveTaskXML = UpdateTaskXML.ToString();
				
				if ((SubmitResponse) && (ContributorSelected.Value.ToUpper() == "FALSE"))
				{
					alertGiven = true;
                    Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_Perform_Response_Assignment_Task_Pleaseselectthenextcontributor');");
					return ErrorXML;
				}

                sb_FormActionBarXML.Append("</ACTIONBARCOLLECTION>");

                //Hemantk:Update the Component Facet series for Deliverable
                ErrorXML = UpdateDeliverableComponentForTask(ref SaveTaskXML, sb_FormActionBarXML.ToString(), obj_SelectComponentIDs, str_ComponentObjectName, str_ComponentPrimaryKey); 
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    ErrorXML = MktgFacadeObj.UpdateTask(TaskID, false, MWB_TimeLineEvents.NONE, false, ref SaveTaskXML);
                }
                return ErrorXML;
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void SaveForwardTask()
        {
            MktgWorkBenchFacadeClass    MktgFacadeObj   = null;
            StringBuilder   TempPath                = null;
            StringBuilder   DisAssociateXML         = null;
            StringBuilder   OldUserXML              = null; 
            String          TempFilePath            = null;
            String          SelectedGroup           = null;
            String          SelectedContributor     = null;
            String          ActualResourceID        = null;
            String          OldUserID               = null;
            String          InputActivityID         = null; 
            FormFacade      FormFacadeObj           = null;
            XML             FormOutputXML           = null;
            XML             TempXML                 = null;
            XML             ActivityResourceXML     = null;
            XML             SaveStepXML             = null;            
            ERRORXML        ErrorXML                = null;
            XmlDocument     TaskDoc                 = null;
            XmlDocument     TempDoc                 = null;
            XmlNode         ActivityNode            = null;
            XmlNode         OldUserNode             = null;
            XmlNode         ActivityResourceNode    = null;
            XmlNode         DisAssociateResourceNode= null;
            XmlNode         ResourceNode            = null;
            XmlNode         ActivityResponseNode    = null;
            XmlNode         ActivityContributorNode = null; 
            MWB_Helper      MWB_HelperObj           = null;
            String          ActivityResourceID      = null;
            String          ResponseID              = null;
            bool            ActivityModified        = true;
            bool            DisAssociateUserOnly    = false;            
			String			SelectedGroupName		= null;
			XPathDocument	ActResDoc				= null;
			StringBuilder	ActResFile				= null;
			String			strFormName				= null;
			String			strStdFormName			= null;
			String			strSelectedFormName		= null;
			String			strActivityDefID		= null;
           
            try
            {
                TempPath        = new StringBuilder();
                DisAssociateXML = new StringBuilder();
                OldUserXML      = new StringBuilder();
                TaskDoc         = new XmlDocument();
                TempDoc         = new XmlDocument();
                MktgFacadeObj   = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                FormFacadeObj   = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                strStdFormName	= "StepDetails_Editable";
                FormFacadeObj.SolutionName = SolutionName;
                TempFilePath    = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                TempPath.AppendFormat("{0}{1}",TempFilePath,TaskFile);
				                
                StepObjInfoList     = (List<ObjectInfo>)ViewState["ForwardTaskObjInfo"];
				ActResFile			= new StringBuilder();
				ActResFile.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
				if(File.Exists(ActResFile.ToString()))
				{
					ActResDoc = new XPathDocument(ActResFile.ToString());
				}

                if (File.Exists(TempPath.ToString()))
                {
                    TaskDoc.Load(TempPath.ToString());
					ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[STATUS='Active']");
					if(ActivityNode != null)
					{
						InputActivityID = ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
						strActivityDefID = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
						strFormName		 = strActivityDefID + "_Edtiable";
						MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
						FormFacadeObj.FormName = strSelectedFormName;
						
						SelectedContributor = Frm_ForwardTask.GetValues("Contributor");
						SelectedGroup = MWB_HelperObj.GetSelectedActivityResourceID(ActResDoc, InputActivityID, out SelectedGroupName);
						if((SelectedGroup.ToUpper() != "NONE") && (SelectedContributor.ToUpper() != "NONE"))
						{
							ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
							if((ActivityResponseNode != null) && (ActivityResponseNode.HasChildNodes))
							{
								ResponseID = ActivityResponseNode.SelectSingleNode("RESPONSE/RESPONSEID").InnerText;
							}
							MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
							if((ActivityResourceID != null) && (ActualResourceID != null))
							{
								// group and contributor both changed.
								OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
								if(OldUserNode != null)
								{
									OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
								}
								OldUserXML.AppendFormat("<OLDUSER>");
								if(SelectedGroup != ActivityResourceID)
								{
									DisAssociateXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>", ActivityResourceID);
									if(OldUserID != null)
									{
										DisAssociateXML.AppendFormat(@"<ACTUAL_RESOURCE TYPE='RELATION'>
																		<RESOURCE MODIFIED='TRUE'>
																		<RESOURCEID>{0}</RESOURCEID>
																		<RESOURCE_USER TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</RESOURCE_USER>
																		</RESOURCE>
																	</ACTUAL_RESOURCE>", ActualResourceID, OldUserID);
									}
									DisAssociateXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTUAL_RESOURCE>", ActualResourceID);
									OldUserXML.AppendFormat("{0}", OldUserNode.OuterXml);
								}
								else if((OldUserID != null) && (OldUserID != SelectedContributor))
								{									
									DisAssociateUserOnly = true;
									// the selected group is same but the contributor is changed.
									OldUserXML.AppendFormat("{0}", OldUserNode.OuterXml);
								}
								else
								{
									ActivityResourceID = null;
									ActualResourceID = null;
									ActivityModified = false;
								}
								OldUserXML.AppendFormat("</OLDUSER>");
							}
							if(ActivityModified)
							{
								ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
								ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", Frm_ForwardTask, StepObjInfoList, out FormOutputXML);
								if(ErrorXML == null)
								{
									// here only the actual resource is modified.
									if(DisAssociateUserOnly)
									{
										MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, FormOutputXML, SelectedGroupName, out TempXML);
										TempDoc.LoadXml(TempXML);
										ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
									}
									else
									{
										MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML, SelectedGroupName);
										MWB_HelperObj.prepareActivityXML(true, FormOutputXML, ActivityResourceXML, out TempXML);
										TempDoc.LoadXml(TempXML);
										ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
										if((ActivityResourceID != null) && (ActualResourceID != null))
											ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE");
										if(ActivityResourceNode != null)
										{
											if(OldUserNode != null)
											{
												ActivityContributorNode = TempDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
												((XmlElement)ActivityContributorNode).SetAttribute("TYPE", "RELATION");
												((XmlElement)ActivityContributorNode).SetAttribute("DISASSOCIATE", "TRUE");
												ActivityContributorNode.InnerText = OldUserNode.SelectSingleNode("USERID").InnerText;
												ActivityNode.PrependChild(ActivityContributorNode);
											}

											DisAssociateResourceNode = TempDoc.CreateElement("RESOURCE");
											((XmlElement)DisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");

											DisAssociateResourceNode.InnerXml = DisAssociateXML.ToString();
											ActivityResourceNode.AppendChild(DisAssociateResourceNode);
										}
									}									
									ActivityResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
									if(ActivityResponseNode != null)
										ActivityNode.RemoveChild(ActivityResponseNode);
									//}
									SaveStepXML = ActivityNode.OuterXml;
									ErrorXML = MktgFacadeObj.UpdateStep(false, true, false, ref SaveStepXML);
								}// end if error xml
							}// end if for ActivityModified                            
							if(ErrorXML == null)
							{
								if(ActivityModified)
									StampNotificationForAssignmentTask(TaskID, "TaskForwarded", InputActivityID, OldUserXML.ToString());
								DeleteTempFiles();
								gotoPerformListScreen();
							}
						}
						else
                            Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_Perform_Response_Assignment_Task_Pleaseselectacontributor');");
					}
                }
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void ForwardTask_ShowDiv()
        {                        
            try
            {               
				//Ajax.WriteExecuteJavaScript("showContentDiv('" + Div_ForwardTask.ClientID + "',600,400);");
				Ajax.WriteExecuteJavaScript(Popup_ForwardTask.ShowPopupWindowJavascript);
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void setStepFormInputXMLForGroup(String StepFormID, XML ItemListXML)
        {            
            XML             FormInputXML        = null;    
            XmlDocument     FormInputDoc        = null;
            XmlNode         FieldNode           = null;
            XmlNode         ValueNode           = null; 
            String          TempPath            = null;
            StringBuilder   TempFilePath        = null;
            try
            {
                //FormfacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.TenantName, ALParamObj.Language);
                FormInputDoc     = new XmlDocument();
                TempStepForm     = (Form)Manual_Activities.FindControl(StepFormID);
                TempFilePath     =  new StringBuilder(); 
                TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                if (TempStepForm != null)
                {
                    FormInputXML = TempStepForm.InputXML;
                    if (FormInputXML!=null)
                    {
                        FormInputDoc.LoadXml(FormInputXML);
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (FieldNode != null)
                            FieldNode.InnerXml = ItemListXML;

                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (FieldNode != null)
                        {
                            ValueNode = FieldNode.SelectSingleNode("Value");
                            if (ValueNode != null)
                                ValueNode.InnerText = "";
                            else
                            {
                                ValueNode = FormInputDoc.CreateElement("Value");
                                ValueNode.InnerText = "";
                                FieldNode.AppendChild(ValueNode);   
                            }
                        }

                        TempStepForm.InputXML = FormInputDoc.OuterXml;
                        TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID);
                        File.WriteAllText(TempFilePath.ToString(), FormInputDoc.OuterXml);
                        //TempStepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                        TempStepForm.ResetFacetSeriesFields();
                    }
                }
                
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void setStepFormInputXMLForMailAddress(String StepFormID,String MailID)
        { 
            XML             FormInputXML        = null;         
            XmlDocument     FormInputDoc        = null;
            XmlNode         FieldNode           = null;
            XmlNode         ValueNode           = null;
            String          TempPath            = null;
            StringBuilder   TempFilePath        = null;
            try
            {                                
                FormInputDoc     = new XmlDocument();
                TempStepForm     = (Form)Manual_Activities.FindControl(StepFormID);
                TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);  
                TempFilePath     = new StringBuilder();
                if (TempStepForm != null)
                {
                    FormInputXML = TempStepForm.InputXML;
                    if (FormInputXML!=null)
                    {
                        FormInputDoc.LoadXml(FormInputXML);
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (FieldNode != null)
                        {
                            ValueNode = FieldNode.SelectSingleNode("Value");
                            if (ValueNode!=null)
                            ValueNode.InnerText = MailID;
                            //FieldNode.AppendChild(ValueNode);
                            TempStepForm.InputXML = FormInputDoc.OuterXml;
                            //ViewState[TempStepForm.ID] = TempStepForm.InputXML;
                            TempFilePath.AppendFormat("{0}{1}.xml",TempPath,StepFormID);
                            File.WriteAllText(TempFilePath.ToString(), FormInputDoc.OuterXml);
                            //TempStepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                            TempStepForm.ResetFacetSeriesFields();
                        }                        
                    }
                }
                
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void setROResponseForm(XmlNode ActivityNode)
        {
            StringBuilder   StepFormID          = null;
            StringBuilder   ActivityColl        = null;
            StringBuilder   ParameterList       = null;
            String          FormConfigXMLPath   = null; 
            String          DigtalAssetIDList   = null;
            MWB_Helper      MWBHelperClassObj   = null;
            FormFacade      FormFacadeObj       = null;
            MktgWorkBenchFacadeClass MWBFacadeObject = null; 
            ERRORXML        ErrorXML            = null;
            XML             FormConfigXML       = null;
            XML             StepFormInputXML    = null;
            String          EmailID             = null;
            String          FirstName           = null;
            String          LoginName           = null;
            String          LastName            = null;
            String          MiddleInitial       = null;
            String          FormattedName       = null;
            String          PercentDoneClass    = null; 
            XmlNode         ResourceUserNode    = null;
            XmlNode         ValueNode           = null;
            XmlNode         UploadUrlNode       = null;
            XmlNode         TempNode            = null;
            XmlNode         DueDateNode         = null;
            XmlNode         Activity_ItemNode   = null;
            XmlNodeList     DigitalAssetNodes   = null;
            XmlDocument     TempDoc             = null;
            XmlAttribute    UploadAttr          = null;
            DateTime        DueDate;
			String			strFormName				= null;
			String			strStdFormName			= null;
			String			strSelectedFormName		= null;
			String			strActivityDefID		= null;
            String          str_SearchXML           = null;
            String          str_ActivityID          = null;
            StringDictionary strdict_PlaceHolder    = null;

            Int32           int_ControlIndex        = 0;
            try
            {
                Form StepForm       = new Form();
                StepFormID          = new StringBuilder();
                ActivityColl        = new StringBuilder();
                ParameterList       = new StringBuilder();
                TempDoc             = new XmlDocument();
                MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language, ALParamObj.SolutionName, Theme);
                FormFacadeObj.SolutionName = SolutionName;
                ParameterList.AppendFormat("TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName);
                
                StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                StepForm.ID                     = StepFormID.ToString();
                if (!IsPostBack)
                {
                    StepForm.IsMinimize = true;
                }
				strActivityDefID				= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
				strStdFormName					= "StepDetails_ROResponse";
				strFormName						= strActivityDefID + "_ROResponse";
                StepForm.TenantName             = ALParamObj.TenantName;
				StepForm.SolutionName			= SolutionName;
				StepForm.IsDynamicForm			= true;
                StepForm.InputXMLType           = Assetlink.CustomControls.Form.InputType.InnerXML;
                StepForm.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.InnerXML;
                StepForm.ShowConfiguredFields   = true; 
                FormConfigXMLPath               = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName,strFormName,out strSelectedFormName);
                FormConfigXML                   = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,true);
				FormFacadeObj.FormName			= strSelectedFormName;
                FormFacadeObj.ShowConfiguredFields = true;
                str_ActivityID                  = ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
                if(!StepROFormIDTable.ContainsKey(str_ActivityID))
                {
                    StepROFormIDTable.Add(str_ActivityID, StepFormID.ToString());
                }
                ResourceUserNode                = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
                if (ResourceUserNode != null)
                {
                    FirstName = ResourceUserNode.SelectSingleNode("FIRSTNAME").InnerText;
                    LastName = ResourceUserNode.SelectSingleNode("LASTNAME").InnerText;
                    MiddleInitial = ResourceUserNode.SelectSingleNode("MIDDLEINITIAL").InnerText;
                    LoginName = ResourceUserNode.SelectSingleNode("LOGINNAME").InnerText;
                    FormattedName = ALCommon.FormatUserName(FirstName, LastName, MiddleInitial, LoginName, ALCommon.GetUserNameFormat());
                    EmailID = ResourceUserNode.SelectSingleNode("EMAILID").InnerText;
                }
                FormFacadeObj.GetHierarchicalSearchXML("ReadOnly", out str_SearchXML);
                //HemantK: check for the deliverable component facet series
                ErrorXML = SetDeliverableComponentFacetSeries(ref ActivityNode, ref FormConfigXML, str_SearchXML);
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    StepForm.ConfigurationXML           = FormConfigXML;
                    //CheckComponentFacetSeriesStatus(StepForm);
                    //Radha: To remove actionbar for other contributors.
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        StepForm.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                        StepForm.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }

                    ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>",ActivityNode.OuterXml);
                    ErrorXML = FormFacadeObj.GetFormInputXML("ReadOnly", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                    TempDoc.LoadXml(StepFormInputXML);
                    TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                    if (TempNode != null)
                    {
                        ValueNode = TempDoc.CreateElement("Value");
                        ValueNode.InnerText = FormattedName;
                        TempNode.AppendChild(ValueNode);
                    }
                    TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                    if (TempNode != null)
                    {
                        ValueNode = TempDoc.CreateElement("Value");
                        ValueNode.InnerText = EmailID;
                        TempNode.AppendChild(ValueNode);
                    }
                    TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                    if (TempNode != null)
                    {
                        if (TempNode.Attributes.GetNamedItem("DownLoadURL") != null)
                        {
                            UploadUrlNode = TempNode.Attributes.GetNamedItem("DownLoadURL");
                            UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                        }
                        else
                        {
                            UploadAttr = TempDoc.CreateAttribute("DownLoadURL");
                            UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                            TempNode.Attributes.Append(UploadAttr);
                        }
                    }
                    TempNode = TempDoc.SelectSingleNode("FieldList/Field[@Name='ACTIVITYINFORMATION_PERCENTDONE_ACTIVITY_INFORMATION']");
                    if (TempNode != null)
                    {
                        //apply percentdone class
                        DueDate = DateTime.Today;

                        DueDateNode = ActivityNode.SelectSingleNode("DUEDATE");
                        DueDate = new DateTime(Convert.ToInt32(DueDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(DueDateNode.SelectSingleNode("DAY").InnerText));

                        MWBFacadeObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(ActivityNode.SelectSingleNode("STATUS").InnerText, DueDate);

                        ((XmlElement)TempNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                    }
                    StepForm.InputXML = TempDoc.OuterXml;
                    StepForm.ConfigurationMode = true;                
                    //ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                    //Manual_Activities.Controls.Add(StepForm);  
          
                    //Check whether any item has been cataloged for this step
                    Activity_ItemNode = ActivityNode.SelectSingleNode("ACTIVITY_ITEM");
                    if ((Activity_ItemNode != null) && (Activity_ItemNode.HasChildNodes))  
                    {					
					    if (Activity_ItemNode.SelectNodes("DIGITALASSET").Count > 0)
                        {
                            AssetListWidget = new Assetlink.Widgets.ALWD_DAM_AssetListWidget.AssetList();

                            StepFormID.Remove(0, StepFormID.Length);
                            StepFormID.AppendFormat("AssetListWidget_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                            AssetListWidget.ID = StepFormID.ToString();
                            AssetListWidget.TenantName = ALParamObj.TenantName;
                            AssetListWidget.SessionID = ALParamObj.SessionID;
                            AssetListWidget.UserID = ALParamObj.UserID;
                            AssetListWidget.Language = ALParamObj.Language;
                            AssetListWidget.WidgetName = "DAM_AssetListWidget";
                            AssetListWidget.UsePopupControlForAssetInformation = false;
                            AssetListWidget.Layout = Assetlink.Widgets.WidgetCommon.AssetList_Layout.LIST;
                            AssetListWidget.ScreenMode = Assetlink.Widgets.WidgetCommon.AssetList_ScreenMode.SEARCHRESULT_ASSETLIST;
                            AssetListWidget.ContentType = Assetlink.Widgets.WidgetCommon.AssetList_ContentType.ASSETS;
                            AssetListWidget.SearchResultAssetListParameters = new Assetlink.Widgets.WidgetCommon.SearchAssetListMode();
                            AssetListWidget.SearchResultAssetListParameters.InputType = Assetlink.Widgets.WidgetCommon.SEARCHRESULT_ASSETLIST_InputType.ASSETIDLIST;
                            AssetListWidget.ShowPageActions = false;
                            AssetListWidget.ShowSectionPath = false;
                            AssetListWidget.ShowHeading = false;
                            AssetListWidget.GetFromServer = true;
                            AssetListWidget.ShowTopBar = false;
                            AssetListWidget.RowCount = 5;
                            AssetListWidget.ColumnCount = 2;
                            AssetListWidget.AssetMediaActions = "MOREINFO,VIEWORIGINAL,DOWNLOADPREVIEW";
                            AssetListWidget.DisplayModeForMoreInfo = Assetlink.Widgets.ALWD_DAM_AssetListWidget.AssetList.DisplayModeType.READONLY;   
                            AssetListWidget.isCheckMaxSearchResult = false;
                            AssetListWidget.ShowExpiredAssets = true;

                            //Prepare comma separated list of digital asset Id's
                            DigtalAssetIDList = PrepareAssetList(Activity_ItemNode);
                            AssetListWidget.SearchResultAssetListParameters.AssetIDList = DigtalAssetIDList;

                            DigitalAssetPresent = true;
                            //Panel_ManualActivities.Controls.Add(AssetWidget); 

                            //SquareBlankSection SBS_Wrapper = new SquareBlankSection();
                            //SBS_Wrapper.TenantName      = ALParamObj.TenantName;
                            //SBS_Wrapper.SectionHeading = ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText;

                            SBS_AssetWidget = new SquareBlankSection();
                            StringBuilder SBS_Name = new StringBuilder();
						    SBS_AssetWidget.ID = "SBS_" + StepFormID.ToString();
                            if (!IsPostBack)
                            {
                                if (String.IsNullOrEmpty(__SBS_IDs.Value))
                                {
                                    __SBS_IDs.Value = SBS_AssetWidget.ID;
                                }
                                else
                                {
                                    __SBS_IDs.Value = __SBS_IDs.Value + "," + SBS_AssetWidget.ID;
                                }
                            }

						    SBS_AssetWidget.IsMinimize = true;
                            strdict_PlaceHolder = new StringDictionary();
                            strdict_PlaceHolder.Add("ACTIVITYNAME",ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText);
                            SBS_Name.Append(Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_ItemsCatalogedfor_Shared", strdict_PlaceHolder));
                            SBS_AssetWidget.TenantName = ALParamObj.TenantName;
                            SBS_AssetWidget.SectionHeading = SBS_Name.ToString();
                            SBS_AssetWidget.DisplayBorder = true;
                            SBS_AssetWidget.ImageAlignment = SquareBlankSection.m_ImageAlignment.left;
                            SBS_AssetWidget.ItemContainer.Controls.Add(AssetListWidget);

                            if (Manual_Activities.FindControl(StepForm.ID) != null)
                            {
                                int_ControlIndex = Manual_Activities.Controls.IndexOf(Manual_Activities.FindControl(StepForm.ID));
                                Manual_Activities.Controls.RemoveAt(int_ControlIndex);
                                StepForm.InputXML = TempDoc.OuterXml;
                                Manual_Activities.Controls.AddAt(int_ControlIndex, StepForm);
                            }
                            else
                            {
                                StepForm.InputXML = TempDoc.OuterXml;
                                Manual_Activities.Controls.Add(StepForm);
                            }                            
                            Manual_Activities.Controls.Add(SBS_AssetWidget);
                        }
                    }

                    if (!DigitalAssetPresent)
                    {
                        if (Manual_Activities.FindControl(StepForm.ID) != null)
                        {
                            int_ControlIndex = Manual_Activities.Controls.IndexOf(Manual_Activities.FindControl(StepForm.ID));
                            Manual_Activities.Controls.RemoveAt(int_ControlIndex);
                            StepForm.InputXML = TempDoc.OuterXml;
                            Manual_Activities.Controls.AddAt(int_ControlIndex, StepForm);
                        }
                        else
                        {
                            StepForm.InputXML = TempDoc.OuterXml;
                            Manual_Activities.Controls.Add(StepForm);
                        }                                               
                    }
                }
            }
           catch (ThreadAbortException)
           { }
           catch (Exception ExceptionObj)
           {                
               throw ExceptionObj;
           }
        }

        private void setForwardTaskForm(XmlNode ActivityNode)
        {
            StringBuilder   ActivityColl			= null;
            FormFacade      FormFacadeObj			= null;
            String          FormConfigXMLPath		= null;
            String          ResourceID				= null;
            String          ResourceType			= null;
            String          MailID					= null;
            MWB_Helper      MWBHelperClassObj		= null;
            XML             StepFormInputXML		= null;
            XML             ItemListXML				= null;
            ERRORXML        ErrorXML				= null;
            XmlDocument     FormXMLDoc				= null;
            XmlNode         ActivityResourceNode	= null;
            XmlNode         ActualResourceNode		= null;
            XmlNode         FieldNode				= null;
            XmlNode         ValueNode				= null;
            XmlNode			FormNode				= null;
            XmlNode			ResponseSectionNode		= null;
            StringBuilder	GroupListXML			= null;
            StringBuilder	ContributorFileName		= null;            
			GroupFacade		GroupFacadeObj			= null;
            StringBuilder	TempPath				= null;
            String			TempFilePath			= null;
            XML				UserCollectionXML		= null;
			StringBuilder	ParamURL				= null;
			XML				SearchXML				= null;
			XML				GroupXML				= null;
			String			GroupID					= null;
			String			SelectedValueFile		= null;
			String			SelectedValueFileName	= null;
			String			SelectedValueXML		= null;
			StringBuilder	SelectedValueXml		= null;
			String			ActivityID				= null;
			XPathDocument	UserDoc					= null;
			String			strFormName				= null;
			String			strStdFormName			= null;
			String			strSelectedFormName		= null;
			String			strActivityDefID		= null;
            XmlNodeList     SectionNodeList         = null;
            int             Order                   = 0;
            try
            {
                ActivityColl                    = new StringBuilder();
				GroupListXML					= new StringBuilder();
				ContributorFileName				= new StringBuilder();
				TempPath						= new StringBuilder();
				SelectedValueXml				= new StringBuilder();
                FormXMLDoc                      = new XmlDocument();
                MWBHelperClassObj               = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                FormFacadeObj                   = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                GroupFacadeObj					= new GroupFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                Frm_ForwardTask.TenantName      = ALParamObj.TenantName;
                Frm_ForwardTask.SolutionName    = SolutionName;     
                TempFilePath					= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);           
                FormFacadeObj.ShowConfiguredFields = true;
                FormFacadeObj.SolutionName      = SolutionName;
                
                Frm_ForwardTask.InputXML        = StepFormInputXML;
				FormFacadeObj.UniqueID			= StepID;
                ActivityID				= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
				strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
				strStdFormName			= "StepDetails_Editable";
				strFormName				= strActivityDefID + "_Editable";
				FormConfigXMLPath		= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName,out strSelectedFormName);
                if (File.Exists(FormConfigXMLPath))
                {
					//Frm_ForwardTask.ConfigurationXML = FormConfigXMLPath;
					FormXMLDoc.Load(FormConfigXMLPath);
					FormNode = FormXMLDoc.DocumentElement;
					ResponseSectionNode = FormNode.SelectSingleNode("Section[@Heading='PREVIOUS_RESPONSE']");
					if(ResponseSectionNode != null)
					{
						FormNode.RemoveChild(ResponseSectionNode);
					}

                    Order = Convert.ToInt32(((XmlElement)ResponseSectionNode).GetAttribute("Order"));
                    SectionNodeList = FormNode.SelectNodes("Section[@Order > '" + Order.ToString() + "']");
                    foreach (XmlNode SectionNode in SectionNodeList)
                    {
                        ((XmlElement)SectionNode).SetAttribute("Order", Order++.ToString());
                    }
					Frm_ForwardTask.ConfigurationXML = FormXMLDoc.InnerXml;
					
                }
				FormFacadeObj.FormName	= strSelectedFormName;
                SelectedValueFileName   = StepID + "_ContributorGroup_SelectedValueList.xml";
				SelectedValueFile		= TempFilePath + SelectedValueFileName;
				if(File.Exists(SelectedValueFile))
					SelectedValueXML = File.ReadAllText(SelectedValueFile);
                if (ViewState["ComponentFacetFieldName"] != null)
                {
                    Frm_ForwardTask.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                    Frm_ForwardTask.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                }
                ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);                
                ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
                ViewState["ForwardTaskObjInfo"] = ResponseObjInfoList;
                if (ErrorXML == null)
                {
                    ItemListXML = MWBHelperClassObj.PrepareFormInputXML(ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").OuterXml, "RESOURCETYPE", "RESOURCEID");

                    // check if this activity has any actual resources associated with it
                    ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                    if (ActivityResourceNode != null)
                        ActualResourceNode = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");					
                    FormXMLDoc.LoadXml(StepFormInputXML);
					ParamURL = new StringBuilder(150);
					ParamURL.Append("SelectResourceType.aspx?");
					//ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceForwardTask.UniqueID, SelectedValueFileName, ResourceTreeFile);
                    ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&StepID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepID, Hidden_SelectResourceForwardTask.UniqueID);
                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");

                    if (FieldNode != null)
                    {
						((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
						((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                    }

                    GroupListFile   = StepID + "_GroupUsers.xml";
					TempPath.Remove(0, TempPath.Length);
					
					TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);

                    if (ActualResourceNode != null)
                    {
						ResourceType			= ActualResourceNode.SelectSingleNode("RESOURCETYPE").InnerText;
						SearchXML				= GetSearchXMLForGroupAndUsers(ResourceType);
												
					    ErrorXML = GroupFacadeObj.GetGroupList(SearchXML, ref GroupXML);
						if(ErrorXML == null)
						{
							if(GroupXML != null)
							{
								MWBHelperClassObj.GetGroupIDAndUserXML(GroupXML, out UserCollectionXML, out GroupID);
								File.WriteAllText(TempPath.ToString(), UserCollectionXML);
								TempPath.Remove(0, TempPath.Length);
								TempPath.AppendFormat("{0}{1}", TempFilePath, SelectedValueFileName);
								SelectedValueXml.AppendFormat("<ValueList><Value ID='{0}' Text='{1}'/></ValueList>", GroupID, ALSolutionCommon.TrimAndReplaceSpecialChars(ResourceType));
								File.WriteAllText(TempPath.ToString(), SelectedValueXml.ToString());
								UserDoc = new XPathDocument(new StringReader(UserCollectionXML));
								ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
								if(ItemListXML != null)
								{
									if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
									{
										ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
										ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
										MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
									}
								}
							}
							else
							{
                                ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
							}
						}
                    }
                    else
                    {
                        ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                    }
                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                    if (FieldNode != null)
                    {
                        FieldNode.InnerXml = ItemListXML;
                    }
                    if (MailID != null)
                    {
                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (FieldNode != null)
                        {
                            ValueNode = FormXMLDoc.CreateElement("Value");
                            ValueNode.InnerText = MailID;
                            FieldNode.AppendChild(ValueNode);
                        }
                    }
                    //Hide Duration
                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
                    if (FieldNode != null)
                    {
                        if (FieldNode.Attributes.GetNamedItem("FieldVisible") == null)
                            ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                        else
                            FieldNode.Attributes.GetNamedItem("FieldVisible").InnerText = "false";
                    }
                    //Frm_ForwardTask.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);
                    Frm_ForwardTask.InputXML = FormXMLDoc.OuterXml;                                     
                }
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void createResponseForm()
        {
            StringBuilder   TempPath        = null;
            String          TempFilePath    = null;
            XmlDocument     TaskDoc         = null;
            XmlNode         ActivityNode    = null;
            try
            {
                TempFilePath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                TempPath     = new StringBuilder();
                TaskDoc      = new XmlDocument();
                TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
                if (File.Exists(TempPath.ToString()))
                {
                    TaskDoc.Load(TempPath.ToString());
                    ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "'and STATUS='Active']");
                    if (ActivityNode!=null)
                    setActivityResponsePage(ActivityNode,false);
                    
                    createHtmlForDigitalAsset();
                    //setDigitalAsset(ActivityNode, false);   
					setDigitalAsset(ActivityNode);   
                }
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void createNewStepForm()
        {
            StringBuilder   TempFilePath            = null;
            StringBuilder   ActivityColl            = null;
            XmlDocument     InputXMLDoc             = null;
            XmlDocument     TaskDoc                 = null;
            XmlDocument     FormXMLDoc              = null;
            XmlNode         ActivityResourceNode    = null;
            XmlNode         ActualResourceNode      = null;
            XmlNode         FieldNode               = null;
            XmlNode         ActivityNode            = null;
            FormFacade      FormFacadeObj       = null;
            MWB_Helper      MWBHelperClassObj   = null;
            String          TempPath            = null;
            String          FormConfigXMLPath   = null;
            String          FormConfigXML       = null;
            String          ResourceID          = null;            
            String          MailID              = null;
            XML             ItemListXML         = null;
            XML             TempFormInputXML    = null;
            Form            StepForm            = null;
			String			SelectedValueFileName	= null;
			String			SelectedValueFile		= null;
			XML				SelectedValueXML		= null;
			StringBuilder	ParamURL				= null;
			String			ActivityID				= null;
			XPathDocument	UserDoc					= null;
			String			strFormName				= null;
			String			strStdFormName			= null;
			String			strSelectedFormName		= null;
			String			strActivityDefID		= null;
			String			str_StepFormID			= null;
            Int32           int_ControlIndex        = 0;
            try
            {
                TempFilePath		= new StringBuilder();
                InputXMLDoc			= new XmlDocument();
                TaskDoc				= new XmlDocument();
                ActivityColl		= new StringBuilder();
                FormXMLDoc			= new XmlDocument();
                FormFacadeObj		= new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                MWBHelperClassObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                StepFormIDTable		= (Hashtable)ViewState["StepFormIDList"];
                TempPath			= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);                                
                FormFacadeObj.SolutionName  = SolutionName;
                strStdFormName				= "StepDetails_Editable";
                if (File.Exists(TempFilePath.ToString()))
                {
                     TaskDoc.Load(TempFilePath.ToString());
                    ActivityIDOrderedList = (List<string>)ViewState["ActivityIDList"];
                    //IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                    for (int i = 0; i < ActivityIDOrderedList.Count; i++)
                    {
                        StepForm = new Form();                        
                        if (StepFormIDTable.ContainsKey(ActivityIDOrderedList[i]))
                        {
							ActivityID = ActivityIDOrderedList[i];
							str_StepFormID = StepFormIDTable[ActivityID].ToString();
							StepForm.ID = str_StepFormID;
							ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + ActivityID + "']");
                            if (ActivityNode != null)
                            {
								strActivityDefID				= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
								strFormName						= strActivityDefID + "_Editable";								
								StepForm.TenantName             = ALParamObj.TenantName;
								StepForm.SolutionName			= SolutionName;
								StepForm.IsDynamicForm			= true;
                                StepForm.InputXMLType           = Assetlink.CustomControls.Form.InputType.InnerXML;
                                StepForm.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.InnerXML;
                                FormConfigXMLPath               = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName,strFormName,out strSelectedFormName);
								FormFacadeObj.FormName			= strSelectedFormName;
                                FormConfigXML                   = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,false);
								FormFacadeObj.UniqueID			= StepFormIDTable[ActivityID].ToString();
                                StepForm.ConfigurationXML       = FormConfigXML;

								// keep the Selected value XML in a String, since the form facade will over-write it
								// after the form facade over writes it re-write it back to maintain the changes
								SelectedValueFileName	= StepFormIDTable[ActivityID].ToString() + "_ContributorGroup_SelectedValueList.xml";
								SelectedValueFile		= TempPath + SelectedValueFileName;
								SelectedValueXML		= File.ReadAllText(SelectedValueFile);

                                ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", ActivityNode.OuterXml);
                               // ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out StepObjInfoList);
								TempFilePath.Remove(0, TempFilePath.Length);
								TempFilePath.AppendFormat("{0}{1}.xml", TempPath, str_StepFormID);
                                if (File.Exists(TempFilePath.ToString()))
                                {
									FormXMLDoc.LoadXml(File.ReadAllText(TempFilePath.ToString()));
									File.WriteAllText(SelectedValueFile, SelectedValueXML);
                                    ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE");
                                    ActualResourceNode = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");

									ParamURL = new StringBuilder(150);
									ParamURL.Append("SelectResourceType.aspx?");
									//ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceType.UniqueID, SelectedValueFileName, ResourceTreeFile);

                                    ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&StepID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepID, Hidden_SelectResourceType.UniqueID);                                    
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                    if (FieldNode != null)
                                    {
										((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
										((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                                    }
									GroupListFile = StepFormIDTable[ActivityIDOrderedList[i]].ToString() + "_GroupUsers.xml";
									TempFilePath.Remove(0, TempFilePath.Length);
									TempFilePath.AppendFormat("{0}{1}", TempPath, GroupListFile);

                                    if (ActualResourceNode != null)
                                    {
                                        if(File.Exists(TempFilePath.ToString()))
										{
											UserDoc		= new XPathDocument(new StringReader(File.ReadAllText(TempFilePath.ToString())));
											ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
											if(ItemListXML != null)
											{
												if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
												{
													ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
													ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
													MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);													
												}
											}
										}
                                    }
                                    else
                                    {
                                        ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                                    }
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                    if (FieldNode != null)
                                    {
                                        //ItemListXML = "<Item Selected='Yes'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                                        FieldNode.InnerXml = ItemListXML;
                                    }
                                    //Radha: To remove actionbar to other contributors.
                                    if (ViewState["ComponentFacetFieldName"] != null)
                                    {
                                        StepForm.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                                        StepForm.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                                    }
                                    TempFilePath.Remove(0, TempFilePath.Length);
                                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepForm.ID);

                                    if (Manual_Activities.FindControl(StepForm.ID) != null)
                                    {
                                        int_ControlIndex = Manual_Activities.Controls.IndexOf(Manual_Activities.FindControl(StepForm.ID));
                                        Manual_Activities.Controls.RemoveAt(int_ControlIndex);                                        
                                        Manual_Activities.Controls.AddAt(int_ControlIndex, StepForm);
                                    }
                                    else
                                    {
                                        Manual_Activities.Controls.Add(StepForm);
                                    }


                                    if (File.Exists(TempFilePath.ToString()))
                                    {
                                        TempFormInputXML = File.ReadAllText(TempFilePath.ToString());
                                        if (TempFormInputXML != null)
                                        {
                                            StepForm.InputXML = TempFormInputXML;
                                            File.WriteAllText(TempFilePath.ToString(), TempFormInputXML);
                                        }
                                        else
                                        {
                                            StepForm.InputXML = FormXMLDoc.OuterXml;
                                            File.WriteAllText(TempFilePath.ToString(), FormXMLDoc.OuterXml);
                                        }
                                    }
                                    else
                                    {
                                        StepForm.InputXML = FormXMLDoc.OuterXml;
                                        File.WriteAllText(TempFilePath.ToString(), FormXMLDoc.OuterXml);
                                    }
                                    
                                    StepForm.ConfigurationMode = true;
                                    ActivityColl.Remove(0, ActivityColl.Length);
                                }                                
                            } //end inner if
                        }// end outer if
                    }// end for
                }// end if for outer if for task.
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void setStepFormEventHandler()
        {            
            Form StepForm   = null;
            try
            {                
                StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                if (StepFormIDTable!=null)
                {
					IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
					while (StepFormIDEnum.MoveNext())
					{
						StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
						StepForm.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);   
					}
                }
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private void setLeftPane()
        {
            LeftPaneFacade  LeftPaneObj  = null;
            try
            {                
                LeftPaneObj = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language,SolutionName);
                LeftPaneObj.SolutionName = SolutionName;
                LeftPaneObj.GetTaskPaneNode(this.Page, null);
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        private void setInitiatorSelectionControl(XmlNode InitiatorNode)
        {
            StringBuilder PrevSelectedUserXML = null;
            String		  OldUserXML		  = null;
            bool			IsFirstTime		  = false;
            try
            {
                PrevSelectedUserXML = new StringBuilder();
                if (InitiatorNode != null)
                    PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList>{0}</SelectedUsersList></UserSelectionXML>", InitiatorNode.InnerXml);
                else
                    PrevSelectedUserXML.AppendFormat("<UserSelectionXML><SelectedUsersList></SelectedUsersList></UserSelectionXML>");

				OldUserXML = UC_InitiatorSelection.PrevSelectedUserXML;
				if(String.Compare(OldUserXML, PrevSelectedUserXML.ToString(), true) != 0)
					IsFirstTime = true;

				if(IsFirstTime)
					UC_InitiatorSelection.FirstTime = "TRUE";

                UC_InitiatorSelection.TenantName          = ALParamObj.TenantName;
                UC_InitiatorSelection.SessionID           = ALParamObj.SessionID;
                UC_InitiatorSelection.UserID              = ALParamObj.UserID;
                UC_InitiatorSelection.Language            = ALParamObj.Language;
                UC_InitiatorSelection.InstanceName        = "GatherInfoTask_Initiator";
                UC_InitiatorSelection.Layout              = "SIMPLE";
                UC_InitiatorSelection.Mode                = "READONLY";
                UC_InitiatorSelection.SolutionName        = SolutionName;
                UC_InitiatorSelection.PrevSelectedUserXML = PrevSelectedUserXML.ToString();
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }
        }

        private void setAttachments(XmlNode FileSystemNode, XmlNode AssetReferences)
        { 
            StringBuilder UploadUrlPath     = null;
            StringBuilder DownLoadUrlPath   = null;
            StringBuilder ParameterList     = null;
            String        FileSystemXml     = "";
            try
            {
                UploadUrlPath                   = new StringBuilder();
                DownLoadUrlPath                 = new StringBuilder();
                ParameterList                   = new StringBuilder();
				ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName,ALParamObj.Language);
                UploadUrlPath.AppendFormat("../../Common/ASPX/UploadFiles.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                ParameterList.Remove(0, ParameterList.Length);
                ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language);
                DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                Binder_Attachments.TenantName           = ALParamObj.TenantName;
                Binder_Attachments.SolutionName         = "MarketingWorkBench";
                Binder_Attachments.BinderListHeading    = Localization.GetString("ALResource", ALParamObj.TenantName, "Attachments_shared");
                Binder_Attachments.Layout               = Binder.LayoutType.BinderList_WithThumbnails;
                Binder_Attachments.Mode                 = Binder.Modes.ReadOnly;
                Binder_Attachments.InputXMLType         = Binder.InputType.InnerXML;
                Binder_Attachments.ListConfigurationName= "TaskAttachmentsForResponseScreen";
                Binder_Attachments.FieldName            = "ATTACHMENTS";
                //Binder_Attachments.ConfigName = "PROJECT_ATTACH";
                Binder_Attachments.UploadUrl            = UploadUrlPath.ToString();
                Binder_Attachments.DownloadUrl          = DownLoadUrlPath.ToString();
                Binder_Attachments.EnableAssetSelection = true;
                Binder_Attachments.DigitalAssetRelationShip = "PROCESS_ASSETREFERENCES";

                Attachment.TenantName   = ALParamObj.TenantName;
                Attachment.SessionID    = ALParamObj.SessionID;
                Attachment.UserID       = ALParamObj.UserID;
                Attachment.ThemeName    = Page.Theme;
                Attachment.Language     = ALParamObj.Language;
                Attachment.BinderFieldName = "ATTACHMENTS";

                if (FileSystemNode != null)
                    FileSystemXml = FileSystemNode.OuterXml;

                if (AssetReferences != null)
                {
                    if (FileSystemNode == null)
                    {
                        Attachment.PrepareInputXMLWithAssetReferences(null, AssetReferences.CreateNavigator(), ref FileSystemXml);
                    }
                    else
                    {
                        Attachment.PrepareInputXMLWithAssetReferences(FileSystemNode.CreateNavigator(), AssetReferences.CreateNavigator(), ref FileSystemXml);
                    }
                }

                Binder_Attachments.InputXML = FileSystemXml;
                //if (FileSystemNode.SelectNodes("BINDER").Count > 0)
                //{
                //    Binder_Attachments.BinderOperation = "Update";
                //    Binder_Attachments.InputXML = FileSystemNode.OuterXml;
                //}
                //else
                //{
                //    Binder_Attachments.BinderOperation = "Update";
                //    Binder_Attachments.InputXML = null;
                //}
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        private ERRORXML StampNotificationForAssignmentTask(String TaskID, String Event, String InputActivityID, String OldUserXML)
        {
            String              ReturnTaskXML           = null;
            String              ContributorID           = null;
            String              TaskScreenURL           = null;
            String              NotificationXML         = null;
            String              ActivityID              = null;
            String              OldUserID               = null; 
            String              TaskInitiatorID         = null;
            String              TaskInitiatorName       = null; 
            XML                 ErrorXML                = null;
            StringBuilder       AssociationXML          = null;
            StringBuilder       Message                 = null;
            StringBuilder       Subject                 = null;
            StringBuilder       FinalMessage            = null; 
            StringReader        retTaskXML              = null;
            StringReader        SR_OldUserXML           = null; 
            XmlDocument         xp_retTaskXMLDoc        = null;    
            XPathDocument       xp_OldUserXMLDoc        = null; 
            XPathNavigator      TaskNavigator           = null;
            XPathNavigator      ActivityNav             = null;
            XPathNavigator      ContributorNav          = null;
            XPathNavigator      TaskInitiatorNav        = null;
            XPathNavigator      Root_OldUserXMLDoc      = null;
            XPathNavigator      OldUserNavigator        = null; 
            XPathNavigator      TempNavigator           = null;            
            XPathNodeIterator   FileSystemIterator      = null;
            NotificationHelper  NotificationHelperObj   = null;
            EmailChannel        EmailChannelObj         = null;            
            MktgWorkBenchFacadeClass MWBFacadeObj       = null;
            MWB_Helper               MWB_HelperObj      = null; 
            NotificationFacadeClass NotificationFacadeObj = null;
            
            XML                         TenantXml                   = null;
            XPathDocument               xPathTenantDoc              = null;
            XPathNavigator              xPathTenantNavigator        = null;
            XPathNavigator              xPathTempNavigator          = null;
            XPathNavigator              WFProcessNode               = null; 
            InfrastructureFacadeClass   InfrastructureFacadeObject  = null;
            String                      SenderFullName              = null;
            String                      SenderMailID                = null;
            PMFacadeClass				PMFacadeObj					= null;			
            XmlNode                     ProjectManager              = null;
            String                      str_ProcessAssoFacets       = null;
            String                      NotificationTypeID          = null;
            try
            {
                //Get the Task.      
                MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
				AssociationXML = new StringBuilder(200);

                NotificationTypeID = "5009";
                MWB_HelperObj.GetAssociatedFacetListForNotifications(NotificationTypeID, ProcessDefinitionID, SolutionName, out str_ProcessAssoFacets);
                //str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                //if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                //{
                //    AssociationXML.Append("<ASSOCIATION>" + str_ProcessAssoFacets + "");
                //}
                //else
                //{
                //    AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                //}

                AssociationXML.AppendFormat(@"<SEARCH>
												    <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>                                                      
	                                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
	                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                {
                    AssociationXML.Append("<SEARCHALLFACETS>FALSE</SEARCHALLFACETS>");
                }
                else
                {
                    AssociationXML.Append("<SEARCHALLFACETS>TRUE</SEARCHALLFACETS>");
                }

                AssociationXML.Append(@"<AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                                     <TARGETENTITY>
													<PRIVILEGENAME>READ</PRIVILEGENAME>");
                if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                {
                    AssociationXML.Append(str_ProcessAssoFacets);
                }

                AssociationXML.Append(@"<FILTERLIST>
										    <FILTER>
											    <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
											    <OPERATOR>EQUALTO</OPERATOR>
											    <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
											    <ISCASESENSITIVE>False</ISCASESENSITIVE>
										    </FILTER>
									    </FILTERLIST>
                                        <RELATIONSHIP NAME='TASKINITIATOR'>
                                            <SELECTLIST>
										        <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									        </SELECTLIST>	
                                        </RELATIONSHIP>
                                        <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                            <SELECTLIST>
										        <EXPRESSION>
											        <FIELDNAME>ACTIVITYID</FIELDNAME>
											        <ALIAS>ACTIVITYID</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>STATUS</FIELDNAME>
											        <ALIAS>STATUS</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>STARTACTIVITY</FIELDNAME>
											        <ALIAS>STARTACTIVITY</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>ENDACTIVITY</FIELDNAME>
											        <ALIAS>ENDACTIVITY</ALIAS>
										        </EXPRESSION>
									        </SELECTLIST>
                                            <RELATIONSHIP NAME='ACTIVITY_CONTRIBUTOR'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                        </RELATIONSHIP>
                                        <RELATIONSHIP NAME='DELIVERABLE_TASK' HIERARCHY='BOTTOMUP'>
                                            <SELECTLIST>
									            <EXPRESSION>
										            <FIELDNAME>PROCESSNAME</FIELDNAME>
										            <ALIAS>PROCESSNAME</ALIAS>
									            </EXPRESSION>
								            </SELECTLIST>
                                            <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
                                                <SELECTLIST>
									                <EXPRESSION>
										                <FIELDNAME>PROCESSNAME</FIELDNAME>
										                <ALIAS>PROCESSNAME</ALIAS>
									                </EXPRESSION>
								                </SELECTLIST>
                                            <RELATIONSHIP NAME='PROJECTMANAGER'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                            <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                            </RELATIONSHIP>
                                            <RELATIONSHIP NAME='DELIVERABLEMANAGER'>
                                                <SELECTLIST>
										            <EXPRESSION>
											        <FIELDNAME>LOGINNAME</FIELDNAME>
											        <ALIAS>LOGINNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>FIRSTNAME</FIELDNAME>
											        <ALIAS>FIRSTNAME</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
											        <ALIAS>MIDDLEINITIAL</ALIAS>
										        </EXPRESSION>
										        <EXPRESSION>
											        <FIELDNAME>LASTNAME</FIELDNAME>
											        <ALIAS>LASTNAME</ALIAS>
										        </EXPRESSION>
                                                <EXPRESSION>
											        <FIELDNAME>EMAILID</FIELDNAME>
											        <ALIAS>EMAILID</ALIAS>
										        </EXPRESSION>
									            </SELECTLIST>
                                            </RELATIONSHIP>
                                        </RELATIONSHIP></TARGETENTITY></SEARCH>");
                

                /*AssociationXML.Append(@"<TASKINITIATOR Type='RELATION'>
		                                        <LOGINNAME/>
		                                        <FIRSTNAME/>
		                                        <MIDDLEINITIAL/>
		                                        <LASTNAME/>
	                                        </TASKINITIATOR>
	                                        <PROCESS_ACTIVITY Type='RELATION'>
		                                        <ACTIVITYID/>
		                                        <STATUS/>
		                                        <STARTACTIVITY/>
		                                        <ENDACTIVITY/>
		                                        <ACTIVITY_CONTRIBUTOR Type='RELATION'>
			                                        <LOGINNAME/>
			                                        <FIRSTNAME/>
			                                        <MIDDLEINITIAL/>
			                                        <LASTNAME/>
		                                        </ACTIVITY_CONTRIBUTOR>
	                                        </PROCESS_ACTIVITY>
	                                        <DELIVERABLE_TASK Type='RELATION' HIERARCHY='BOTTOMUP'>
		                                        <PROCESSNAME/>
		                                        <PROJECT_DELIVERABLE Type='RELATION' HIERARCHY='BOTTOMUP'>
			                                        <PROCESSNAME/>
			                                        <PROJECTMANAGER Type='RELATION'>
				                                        <USERID/>
				                                        <LOGINNAME/>
				                                        <FIRSTNAME/>
				                                        <MIDDLEINITIAL/>
				                                        <LASTNAME/>
			                                        </PROJECTMANAGER>
			                                        <ACTINGPROJECTMANAGER Type='RELATION'>
				                                        <USERID/>
				                                        <LOGINNAME/>
				                                        <FIRSTNAME/>
				                                        <MIDDLEINITIAL/>
				                                        <LASTNAME/>
			                                        </ACTINGPROJECTMANAGER>
		                                        </PROJECT_DELIVERABLE>
		                                        <DELIVERABLEMANAGER Type='RELATION'>
			                                        <USERID/>
			                                        <LOGINNAME/>
			                                        <FIRSTNAME/>
			                                        <MIDDLEINITIAL/>
			                                        <LASTNAME/>
			                                        <EMAILID/>
		                                        </DELIVERABLEMANAGER>
	                                        </DELIVERABLE_TASK>
                                        </ASSOCIATION>");
                MWBFacadeObj    = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                
                ErrorXML = MWBFacadeObj.GetTask(TaskID, null, AssociationXML.ToString(), out ReturnTaskXML);*/
                SearchConfiguration SearchConfigObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXML = SearchConfigObj.GetHierarchialData(AssociationXML.ToString(), ref ReturnTaskXML);
                if (ErrorXML == null)
                {
                    ReturnTaskXML = ReturnTaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", String.Empty);
                    ReturnTaskXML = ReturnTaskXML.Replace("</WORKFLOWPROCESSCOLLECTION>", String.Empty);
                    //Email Stamping for the contributor of 1st step from Task.
                    retTaskXML          = new  StringReader(ReturnTaskXML);
                    xp_retTaskXMLDoc    = new  XmlDocument() ;
                    xp_retTaskXMLDoc.LoadXml (ReturnTaskXML );
                    TaskNavigator       = xp_retTaskXMLDoc.CreateNavigator();

                    FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");

                    while (FileSystemIterator.MoveNext())
                    {
                        TempNavigator = FileSystemIterator.Current;
                        TempNavigator.DeleteSelf();
                        FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");
                        
                    }

                    if (Event.ToUpper() == "ACTIVATENEXTCONRTIBUTOR")
                    {
                        TaskInitiatorNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                        if ((TaskInitiatorNav != null) && (TaskInitiatorNav.HasChildren))
                        {
                            TaskInitiatorName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(TaskInitiatorNav));
                            TaskInitiatorID = TaskInitiatorNav.SelectSingleNode("USER/USERID").Value;
                        }

                        ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[STATUS/text() ='Active' and (STARTACTIVITY/text() !='True' and ENDACTIVITY/text() !='True')]");
                        if ((ActivityNav != null) && (ActivityNav.HasChildren) && (!String.IsNullOrEmpty(TaskInitiatorName)) && (!String.IsNullOrEmpty(TaskInitiatorID)))
                        {
                            ContributorNav = ActivityNav.SelectSingleNode("ACTIVITY_CONTRIBUTOR");
                            if ((ContributorNav != null) && (ContributorNav.HasChildren))
                            {
                                ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;
                                //if (ContributorID != ALParamObj.UserID)
                                {
                                    NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                    NotificationHelperObj.Init("5003", TaskInitiatorID);

                                    EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                    EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                      //By: Bhalchandra
                                    //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    //By: Bhalchandra
                                    //Date : September,12 2007
                                    //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                    ProjectManager = null;
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    NotificationHelperObj.AddChannel(EmailChannelObj);
                                    //Get the TaskInitiator Node

                                    Message = new StringBuilder();
                                    Message.AppendFormat("<MESSAGE>{0}</MESSAGE>", TaskNavigator.InnerXml);

                                    Subject = new StringBuilder();
                                    Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                    ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                    TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "RESPONSE", ActivityID);

                                    ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                    ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                    ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                    ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                    if (ErrorXML == null && NotificationXML != null)
                                    {
                                        NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                        ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                    }
                                }
                            }
                        }
                    }
                    else if (Event.ToUpper() == "TASKFORWARDED")
                    {
                        SR_OldUserXML       = new StringReader(OldUserXML);
                        xp_OldUserXMLDoc    = new XPathDocument(SR_OldUserXML);
                        Root_OldUserXMLDoc  = xp_OldUserXMLDoc.CreateNavigator();
                        OldUserNavigator    = Root_OldUserXMLDoc.SelectSingleNode("OLDUSER");
                        OldUserID           = OldUserNavigator.SelectSingleNode("USER/USERID").Value;

                        ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID/text() ='" + InputActivityID + "']");
                        if ((ActivityNav != null) && (ActivityNav.HasChildren))
                        {
                            ContributorNav = ActivityNav.SelectSingleNode("ACTIVITY_CONTRIBUTOR");
                            if ((ContributorNav != null) && (ContributorNav.HasChildren))
                            {
                                ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;
                                if (ContributorID != ALParamObj.UserID)
                                {
                                    NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                    NotificationHelperObj.Init("5009", OldUserID, __ProcessDefinitionID.Value);

                                    EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                    EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                    //By: Bhalchandra
                                    //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    //By: Bhalchandra
                                    //Date : September,12 2007
                                    //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                    ProjectManager = null;
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    //Create ActingProjectManager attribute and set it to  ACTINGPROJECTMANAGER Node
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/ACTINGPROJECTMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("ActingProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    //Create TaskInitiator attribute and set it to  TASKINITIATOR Node
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("TaskInitiator", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    NotificationHelperObj.AddChannel(EmailChannelObj);
                                    //Get the TaskInitiator Node

                                    Message = new StringBuilder();
                                    Message.AppendFormat("<MESSAGE Sender='{0}'>{1}</MESSAGE>", ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName()),  TaskNavigator.InnerXml);

                                    Subject = new StringBuilder();
                                    Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                    ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                    TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "RESPONSE", ActivityID);

                                    ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                    ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                    ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                    ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                    if (ErrorXML == null && NotificationXML != null)
                                    {
                                        NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                        ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                    }
                                }
                            }
                        }
                    }
                    else if (Event.ToUpper() == "TASKCOMPLITION")
                    {
						PMFacadeObj = new PMFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                        ActivityNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID/text() ='" + InputActivityID + "']");
                        //while (Contributors_Activities.MoveNext())
                        {
                            WFProcessNode = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS");
                            if ((ActivityNav != null) && (ActivityNav.HasChildren))
                            {
                                TaskInitiatorNav = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
                                if ((TaskInitiatorNav != null) && (TaskInitiatorNav.HasChildren))
                                {
                                    TaskInitiatorName = MWB_HelperObj.getUserName(TaskInitiatorNav);
                                    TaskInitiatorID = TaskInitiatorNav.SelectSingleNode("USER/USERID").Value;
                                }

                               // if ((TaskInitiatorID != null) )
                                

                                InfrastructureFacadeObject = new InfrastructureFacadeClass( ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language  );
                                
                                #region Get Sender Details
                                ErrorXML = InfrastructureFacadeObject.GetTenantXml(ref TenantXml);
                                
                                if (ErrorXML == null)
                                {
                                    xPathTenantDoc = new XPathDocument( new StringReader (TenantXml  ));
                                    xPathTenantNavigator = xPathTenantDoc.CreateNavigator();

                                    xPathTempNavigator = xPathTenantNavigator.SelectSingleNode("/CONFIGURATION/CHANNELSETTINGS/CHANNEL[@NAME='EMAIL']/MAILBOXUSER");
                                    if (xPathTempNavigator != null)
                                        SenderFullName =  ALSolutionCommon.TrimAndReplaceSpecialChars(xPathTempNavigator.Value);
                                    xPathTempNavigator = null;

                                    xPathTempNavigator = xPathTenantNavigator.SelectSingleNode("/CONFIGURATION/CHANNELSETTINGS/CHANNEL[@NAME='EMAIL']/MAILBOXEMAILID");
                                    if (xPathTempNavigator != null)
                                        SenderMailID = xPathTempNavigator.Value;
                                    xPathTempNavigator = null;
                                    
                                }
                                #endregion
                                {
                                    EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                    EmailChannelObj.AddRecipient("TO", TaskInitiatorID, false);
                                     
                                    NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                    
                                    NotificationHelperObj.Init("5005", "102" ); //Mail sent on behalf of system so we user admin as sender;
                                    NotificationHelperObj.AddChannel(EmailChannelObj);

                                    //By: Bhalchandra
                                    //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));
                                    
                                    //By: Bhalchandra
                                    //Date : September,12 2007
                                    //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                    ProjectManager = null;
                                    ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                    if (ProjectManager != null)
                                        ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                    //Get the Activity id
                                    ActivityID = ActivityNav.SelectSingleNode("ACTIVITYID").Value;

                                    FinalMessage = new StringBuilder();
                                    FinalMessage.AppendFormat("<WORKFLOWPROCESS>");
                                    FinalMessage.AppendFormat("{0}", WFProcessNode.InnerXml);
                                    FinalMessage.AppendFormat("<PROCESS_RESPONSE>");
                                    FinalMessage.AppendFormat("<RESPONSE>");
                                    FinalMessage.AppendFormat("<RESPONSETEXT>{0}</RESPONSETEXT>", "Task Completed");
                                    FinalMessage.AppendFormat("</RESPONSE>");
                                    FinalMessage.AppendFormat("</PROCESS_RESPONSE>");
                                    FinalMessage.AppendFormat("</WORKFLOWPROCESS>");
                                    Message = new StringBuilder();
                                    Message.AppendFormat("<MESSAGE>{0}</MESSAGE>", TaskNavigator.InnerXml);

                                    Subject = new StringBuilder();
                                    Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", FinalMessage.ToString());

                                    TaskScreenURL = GetEmailScreenURL();

                                    ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                    ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                    ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);
                                    ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);
                                    if (ErrorXML == null && NotificationXML != null)
                                    {
                                        NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                        ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                        if (ErrorXML != null)
                                        {
                                            //ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, Request.Url.ToString(), ref ErrorPageURL);
                                            //if (!IsPostBack)
                                            //{
                                            //    //Response.Redirect(ErrorPageURL);
                                            //}
                                            //else
                                              //  Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                        }
										//ErrorXML = MWBFacadeObj.UpdateTask(TaskID, true, MWB_TimeLineEvents.CALCULATE_COMPLETE_TIMELINE, false, ref TempXml);
                                    }
                                }
                            }
                        }
                    }
                }
                return ErrorXML;
            }
            catch(Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }
        
        private String GetEmailScreenURL()
        {
            String          DefaultPageMode             = null;
            String          CommunicationProtocol       = null;
            String          InternetAddress             = null;
            StringBuilder   DefaultPageParameterList    = null;
            StringBuilder   ParameterList               = null;
            StringBuilder   SolutionPageUrl             = null;
            StringBuilder   DefaultPageUrl              = null;

            try
            {   
                DefaultPageMode       = "EMAIL";
                CommunicationProtocol = ALCommon.GetCommunicationProtocol();
                InternetAddress       = ALCommon.GetInternetAddress();
                
                SolutionPageUrl  = new StringBuilder();
                SolutionPageUrl.AppendFormat("{0}{1}/{2}/{3}/ASPX/WorkBenchLinkHandler.ashx", CommunicationProtocol, InternetAddress, ALParamObj.TenantName, SolutionName);

                ParameterList = new StringBuilder();
                ParameterList.AppendFormat("Mode=MANAGE&SourceID={0}&SourceType=TASK", TaskID);

                DefaultPageParameterList = new StringBuilder();
                DefaultPageParameterList.AppendFormat("Language={0}&Mode={1}&SolutionPage={2}&Param={3}", ALParamObj.Language, DefaultPageMode, SolutionPageUrl, ALCommon.Encrypt(ParameterList.ToString()));
                
                DefaultPageUrl = new StringBuilder();
                DefaultPageUrl.AppendFormat("{0}{1}/{2}/default.aspx?{3}", CommunicationProtocol, InternetAddress, ALParamObj.TenantName, DefaultPageParameterList.ToString());
                
                DefaultPageUrl = DefaultPageUrl.Replace("&", "%26");

                return DefaultPageUrl.ToString();
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        private void gotoErrorPage(String ErrorMessage)
        {			
			StringBuilder   BackURL			= null;
			String			strErrorPageUrl	= null;
			StringBuilder	ErrorPageUrl	= null;
			try
			{
                BackURL         = new StringBuilder();
				ErrorPageUrl	= new StringBuilder();

                BackURL.AppendFormat("/{0}/Common/ASPX/DefaultScene_DefaultPage.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID);
				ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "WORKFLOWPROCESS", null, ErrorMessage, null, BackURL.ToString(), ref strErrorPageUrl);
                if (!IsPostBack)
                {
                    Response.Redirect(strErrorPageUrl, true);
                }
                else
                    Ajax.WriteExecuteJavaScript("window.open('" + strErrorPageUrl + "','_self','');");
			}
			catch(Exception ExceptionObj)
			{
				throw ExceptionObj;
			}
        }
        
        private String GetBackURL()
        {
			StringBuilder ParamURL  = null;
            //StringBuilder URL       = null;              
			try
			{
				ParamURL = new StringBuilder();
				//URL = new StringBuilder();
				ParamURL.AppendFormat("/{0}/{4}/ASPX/PerformList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID,SolutionName);
				return ParamURL.ToString();
			}
			catch(Exception ExceptionObj)
			{
				throw ExceptionObj;
			}
        }
        
		private void InitializeAssetlistWidget()
        {
            StringBuilder            SearchInputXML         = null;
            SearchConfiguration      SearchConfigObj        = null;
            XmlDocument	   		     TempDoc			    = null;
            XmlNode                  ProcessItemNode        = null;
            XML                      OutputXML              = null;
            ERRORXML                 ErrorXMLString         = null;
            String                   DigtalAssetIDList      = null; 

            try
            {
                SearchConfigObj = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                SearchInputXML = new StringBuilder();
                SearchInputXML.AppendFormat(@"<SEARCH>
                                                <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>                                                      
                                                <TARGETOBJECT>ACTIVITY</TARGETOBJECT>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                <TARGETENTITY>
                                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                    <FILTERLIST>
	                                                    <FILTER>
		                                                    <FILTERID>1</FILTERID>
		                                                    <EXPRESSION>ACTIVITYID</EXPRESSION>
		                                                    <OPERATOR>EQUALTO</OPERATOR>
		                                                    <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
		                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                    </FILTER>
                                                    </FILTERLIST>
                                                    <SELECTLIST>
	                                                    <EXPRESSION>
		                                                    <FIELDNAME>ACTIVITYID</FIELDNAME>
		                                                    <ALIAS>ACTIVITYID</ALIAS>
	                                                    </EXPRESSION>
                                                    </SELECTLIST>		                                                    
                                                    <RELATIONSHIP NAME='ACTIVITY_ITEM'>
                                                        <FILTERLIST>
	                                                        <FILTER>
		                                                        <FILTERID>1</FILTERID>
		                                                        <EXPRESSION>MARKEDASDELETED</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                        </FILTERLIST>
                                                    </RELATIONSHIP>
                                                </TARGETENTITY>
                                            </SEARCH>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, StepID);
                        
                ErrorXMLString = SearchConfigObj.GetHierarchialData(SearchInputXML.ToString(), ref OutputXML);

                if (ErrorXMLString == null)
                {
                    TempDoc = new XmlDocument();
                    TempDoc.LoadXml(OutputXML);

                    ProcessItemNode = TempDoc.SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY/ACTIVITY_ITEM");
                    if ((ProcessItemNode != null) && (ProcessItemNode.HasChildNodes))
                    {
                        Widget_AssetListWidget.Visible = true; 
                        //Prepare AssetID's comma separated list
                        //SBS_CatalogFile.Visible = true;
                        DigtalAssetIDList = PrepareAssetList(ProcessItemNode);
                        Widget_AssetListWidget.SearchResultAssetListParameters.AssetIDList = DigtalAssetIDList;

                        Widget_AssetListWidget.AssetMediaActions = "MOREINFO,VIEWORIGINAL,DOWNLOADPREVIEW,DELETE";

                        Widget_AssetListWidget.RenderContents();
                    }
                    else
                    {
                        //SBS_CatalogFile.Visible = false;
                        //Widget_AssetListWidget.SearchResultAssetListParameters.AssetIDList = null;
                        //Widget_AssetListWidget.RenderContents();
                        Widget_AssetListWidget.Visible = false;
                    }
                }
            }
            catch (Exception ExceptionObj)
            {
                throw (ExceptionObj);
            }
        }
        
        private void GetUserRoles()
        {
			MktgWorkBenchFacadeClass MWBFacadeObj		= null; 
			ERRORXML				 ErrorXML			= null;
			StringBuilder			 AssociationXML		= null;
			StringBuilder			 AttributesXML		= null;			
			XML						 ReturnTaskXML		= null;
			XmlNode					 TaskInitiatorNode	= null;
			XmlDocument				 TaskDoc			= null;
			String					 ErrorPageURL		= null;
            XML                      xml_Users          = null;
            XML                      xml_Groups         = null;
            XmlNode                  xmlnode_User       = null;
            XmlNode                  xmlnode_Group      = null;
            XPathNavigator          nav_TaskReaderGroups= null;
            XPathNavigator          nav_TaskReaderUsers = null;

			try
			{
				MWBFacadeObj	= new MktgWorkBenchFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
				AssociationXML	= new StringBuilder();
				AttributesXML	= new StringBuilder();
				AttributesXML.Append(@"<WORKFLOWPROCESS>
										<WORKFLOWPROCESSID/>
									   </WORKFLOWPROCESS>");
				AssociationXML.AppendFormat(@"<ASSOCIATION>
												<READERS Type='RELATION'>
													<LOGINNAME/>
													<FIRSTNAME/>
													<MIDDLEINITIAL/>
													<LASTNAME/>
                                                    <FILTERLIST>
                                                        <FILTER>
	                                                        <EXPRESSION>STATUS</EXPRESSION>
	                                                        <OPERATOR>EQUALTO</OPERATOR>
	                                                        <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
	                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
                                                        </FILTER>
                                                    </FILTERLIST>
												</READERS>
                                                <PROCESSREADER_GROUPS Type='RELATION'>
                                                    <GROUPID />
                                                    <GROUPNAME />
                                                    <FILTERLIST>
                                                        <FILTER>
                                                            <EXPRESSION>ISDELETED</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </PROCESSREADER_GROUPS>
												<TASKINITIATOR Type='RELATION'>
													<LOGINNAME/>
													<FIRSTNAME/>
													<MIDDLEINITIAL/>
													<LASTNAME/>
												</TASKINITIATOR>
                                                <PROCESSCOMPLETION_GROUP Type='RELATION'>
                                                        <GROUPNAME/>
                                                        <ISDELETED/>
                                                        <FILTERLIST>
	                                                        <FILTER>
		                                                        <EXPRESSION>ISDELETED</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                        </FILTER>
                                                        </FILTERLIST>
                                                </PROCESSCOMPLETION_GROUP>
                                                <PROCESSCOMPLETION_USER Type='RELATION'>
                                                        <STATUS/>
                                                        <LOGINNAME/>
                                                        <FIRSTNAME/>
                                                        <MIDDLEINITIAL/>
                                                        <LASTNAME/>
                                                        <EMAILID/>
                                                        <FILTERLIST>
	                                                        <FILTER>
		                                                        <EXPRESSION>STATUS</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                        </FILTER>
                                                        </FILTERLIST>
                                                    </PROCESSCOMPLETION_USER>
											  </ASSOCIATION>");
				ErrorXML = MWBFacadeObj.GetTask(TaskID, AttributesXML.ToString(), AssociationXML.ToString(), out ReturnTaskXML);
				if (ErrorXML == null)
				{
					TaskDoc		= new XmlDocument();
					TaskDoc.LoadXml(ReturnTaskXML);

                    if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS") != null)
                        nav_TaskReaderGroups = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS").CreateNavigator();

                    if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS") != null)
                        nav_TaskReaderUsers = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS").CreateNavigator();

                    setTaskReadersUserGroupList(nav_TaskReaderGroups, nav_TaskReaderUsers);

                    TaskInitiatorNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR");
					setInitiatorSelectionControl(TaskInitiatorNode);

                     //paint process completion users
                    xmlnode_User    = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_USER");
                    if (xmlnode_User != null)
                        xml_Users   = xmlnode_User.InnerXml;

                    xmlnode_Group   = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_GROUP");
                    if (xmlnode_Group != null)
                        xml_Groups = xmlnode_Group.InnerXml;
                    populateUserGroupList(xml_Users, xml_Groups);
				}
				else
				{
					ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackURL(), ref ErrorPageURL);
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL, true);
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
				}
			}
			catch(Exception Excepobj)
			{
				throw Excepobj;
			}
        }
        
        private void SetStepForm_InPostBack()
        {
            String          TempPath                = null; 
            StringBuilder   TempFilePath            = null;
            XmlDocument     InputXMLDoc             = null;
            XmlDocument     TaskDoc                 = null;           
            XmlNodeList     Activities              = null; 
            try
            {
                TempFilePath   = new StringBuilder();
                InputXMLDoc    = new XmlDocument();
                TaskDoc        = new XmlDocument();

                TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                if (File.Exists(TempFilePath.ToString()))
                {
                    TaskDoc.Load(TempFilePath.ToString());
                    Activities = TaskDoc.SelectNodes("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY != 'True' and ENDACTIVITY != 'True' and (STATUS = 'Completed' or STATUS = 'Cancelled')]");
                    if (Activities.Count > 0)
                    {
                        foreach (XmlNode Activity in Activities)
                            setROResponseForm(Activity);  
                    }
                }
            }
            catch (Exception ExcepitonObj)
            {
                throw(ExcepitonObj);
            }
        }

		private void RegisterHiddenFields()
		{
			try
			{
				Page.ClientScript.RegisterHiddenField("AssetActionMenuCommonParams", "");
				Page.ClientScript.RegisterHiddenField("ViewPreviewCommonParams", "");
                Page.ClientScript.RegisterHiddenField("ProcessingImagePath", "");
                Page.ClientScript.RegisterHiddenField("ResponseDivWidth", "");
                Page.ClientScript.RegisterHiddenField("ResponseDivHeight", "");
                Page.ClientScript.RegisterHiddenField("MouseOverPopupDiv", "");
                Page.ClientScript.RegisterHiddenField("MouseOverPopupInnerDivID", "");
                Page.ClientScript.RegisterHiddenField("IsRefreshParentScreen", "");
                Page.ClientScript.RegisterHiddenField("ImageHandlerUrl", "");
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private XML GetSearchXMLForGroupAndUsers(String GpName)
		{
			StringBuilder Search = null;
			try
			{
				Search = new StringBuilder();
				Search.AppendFormat(@"<INPUTXML>
										<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
										<SEARCHCOLLECTION>
										<SEARCH>
										<TARGETOBJECT>GROUP</TARGETOBJECT>
										<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
										<ISCASESENSITIVE>False</ISCASESENSITIVE>
										<SEARCHALLFACETS>False</SEARCHALLFACETS>
										<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
										<FILTERLIST>
											<FILTER>
												<FIELDNAME>GROUPNAME</FIELDNAME>
												<OPERATOR>EQUALTO</OPERATOR>
												<FIELDVALUE>{4}</FIELDVALUE>												
												<ISCASESENSITIVE>False</ISCASESENSITIVE>
											</FILTER>
											<FILTER ApplyFilter=""Yes"">
												<FILTERID>2</FILTERID>
												<FIELDNAME>STATUS</FIELDNAME>
												<OPERATOR>EQUALTO</OPERATOR>
												<FIELDVALUE>ACTIVE</FIELDVALUE>
												<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
												<ISCASESENSITIVE>False</ISCASESENSITIVE>
											</FILTER>
										</FILTERLIST>
										<FIELDCOLLECTION>
                                            <TARGETENTITYFIELDS>
                                                    <FIELD>GROUPID</FIELD>
                                            </TARGETENTITYFIELDS>
											<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'>
													<FIELD>USERID</FIELD>
													<FIELD>LOGINNAME</FIELD>
													<FIELD>FIRSTNAME</FIELD>
													<FIELD>LASTNAME</FIELD>
													<FIELD>MIDDLEINITIAL</FIELD>
													<FIELD>EMAILID</FIELD>											
												</RELATEDENTITYFIELDS>
										</FIELDCOLLECTION>
										</SEARCH>
										</SEARCHCOLLECTION>
									</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
				return Search.ToString();
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		
		}

		private XML GetSearchXML(String GpName)
		{
			StringBuilder Search = null;
			try
			{
				Search = new StringBuilder();
				Search.AppendFormat(@"<INPUTXML>
										<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
										<SEARCHCOLLECTION>
										<SEARCH>
										<TARGETOBJECT>USER</TARGETOBJECT>
										<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
										<ISCASESENSITIVE>False</ISCASESENSITIVE>
										<SEARCHALLFACETS>False</SEARCHALLFACETS>
										<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
										<FILTERLIST>
											<FILTER>
												<FIELDNAME>GROUPNAME</FIELDNAME>
												<OPERATOR>EQUALTO</OPERATOR>
												<FIELDVALUE>{4}</FIELDVALUE>
												<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
												<ISCASESENSITIVE>False</ISCASESENSITIVE>
											</FILTER>
											<FILTER>
												<FIELDNAME>STATUS</FIELDNAME>
												<OPERATOR>EQUALTO</OPERATOR>
												<FIELDVALUE>ACTIVE</FIELDVALUE>											
												<ISCASESENSITIVE>False</ISCASESENSITIVE>
											</FILTER>
										</FILTERLIST>
										<FIELDCOLLECTION>
												<TARGETENTITYFIELDS>
													<FIELD>USERID</FIELD>
													<FIELD>LOGINNAME</FIELD>
													<FIELD>FIRSTNAME</FIELD>
													<FIELD>LASTNAME</FIELD>
													<FIELD>MIDDLEINITIAL</FIELD>
													<FIELD>EMAILID</FIELD>													
												</TARGETENTITYFIELDS>
											</FIELDCOLLECTION>
										</SEARCH>
										</SEARCHCOLLECTION>
									</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
				return Search.ToString();
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private void DeleteTempFiles()
		{
			String			TempPath				= null;
			StringBuilder	TempFilePath			= null;
			String			SelectedValueFileName	= null;
			try
			{
				TempFilePath = new StringBuilder();
				TempPath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
				TempFilePath.AppendFormat("{0}{1}",TempPath,TaskFile);
				if(File.Exists(TempFilePath.ToString()))
					File.Delete(TempFilePath.ToString());
				TempFilePath.Remove(0, TempFilePath.Length);
				TempFilePath.AppendFormat("{0}{1}", TempPath, StepResourceFileName);
				if(File.Exists(TempFilePath.ToString()))
					File.Delete(TempFilePath.ToString());
				TempFilePath.Remove(0, TempFilePath.Length);
				TempFilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
				if(File.Exists(TempFilePath.ToString()))
					File.Delete(TempFilePath.ToString());
				TempFilePath.Remove(0, TempFilePath.Length);

                SelectedValueFileName = StepID + "_GroupUsers.xml";
				TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
				if(File.Exists(TempFilePath.ToString()))
					File.Delete(TempFilePath.ToString());
				TempFilePath.Remove(0, TempFilePath.Length);

                SelectedValueFileName = StepID + "_ContributorGroup_SelectedValueList.xml";
				TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
				if(File.Exists(TempFilePath.ToString()))
					File.Delete(TempFilePath.ToString());
				TempFilePath.Remove(0, TempFilePath.Length);

                if (ResponseForm != null)
                {
                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, ResponseForm.ID);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());
                    TempFilePath.Remove(0, TempFilePath.Length);
                }

                if (ViewState["StepFormIDList"] != null)
                {
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

                    while (StepFormIDEnum.MoveNext())
                    {
                        SelectedValueFileName = StepFormIDEnum.Value.ToString() + "_ContributorGroup_SelectedValueList.xml";
                        TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
                        if (File.Exists(TempFilePath.ToString()))
                            File.Delete(TempFilePath.ToString());
                        TempFilePath.Remove(0, TempFilePath.Length);
                        TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormIDEnum.Value.ToString());
                        if (File.Exists(TempFilePath.ToString()))
                            File.Delete(TempFilePath.ToString());
                        TempFilePath.Remove(0, TempFilePath.Length);
                        SelectedValueFileName = StepFormIDEnum.Value.ToString() + "_GroupUsers.xml";
                        TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
                        if (File.Exists(TempFilePath.ToString()))
                            File.Delete(TempFilePath.ToString());
                        TempFilePath.Remove(0, TempFilePath.Length);
                    }
                }

                //HemantK:To Delete Component Facet Series file
                TempFilePath.Remove(0, TempFilePath.Length);
                TempFilePath.AppendFormat("{0}{1}{2}", TempPath, TaskID, str_ComponentFacetFileName);
                if (File.Exists(TempFilePath.ToString()))
                    File.Delete(TempFilePath.ToString());

                //delete step files.
                if (ViewState["ActivityIDList"] != null)
                {
                    ActivityIDOrderedList = (List<string>)ViewState["ActivityIDList"];
                    for (int i = 0; i < ActivityIDOrderedList.Count; i++)
                    {
                        TempFilePath.Remove(0, TempFilePath.Length);
                        TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ActivityIDOrderedList[i] + str_SelectedComponentsIDFileName);
                        if (File.Exists(TempFilePath.ToString()))
                        {
                            File.Delete(TempFilePath.ToString());
                        }
                    }
                }

                //Anita Kale: To delete Temp file for Project Info form Input
                TempFilePath.Remove(0, TempFilePath.Length);
                TempFilePath.AppendFormat("{0}{1}{2}", TempPath, TaskID, str_ProjectInfoTempFileName);
                if (File.Exists(TempFilePath.ToString()))
                    File.Delete(TempFilePath.ToString());
			}
			catch(Exception ExcepObj)
			{
				throw ExcepObj;
			}
		}

		private void setControlProperties()
		{
			try
			{
				AssignmentTaskTab.onTabClick += new ALTab.TabEventHandler(AssignmentTaskTab_onTabClick);
				Ab_ResponseTask.Click += new EventHandler(Ab_ResponseTask_Click);
				Ab_ForwardTask.Click += new EventHandler(Ab_ForwardTask_Click);
			}
			catch(Exception ExcepObj)
			{				
				throw ExcepObj;
			}
		}

        /// <alsummary>
        /// <createddate>03 December 2008</createddate>
        /// <author>Hemant Karkande</author>
        /// <purpose>To Handle clicks on the Component Facet Series List Action bar.</purpose>
        /// </alsummary>
        private void ResponseForm_SeriesActionBarClick(object sender, EventArgs e)
        {
            ulong			ErrorID				= 0;
            StringBuilder	ErrorPageURL_Exp	= null;
            StringBuilder   ParamURL            = null;
            StringBuilder   URL                 = null;
            String          EncryptURL          = null; 
            String          str_DeliverableId   = null;

            try
            {
                ParamURL        = new StringBuilder();
                URL             = new StringBuilder(); 
                String strSender = (String)sender;
                String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                if (Parameters[1].Equals("SaveSeriesRecord"))
                {
                    //ErrorXML = SaveComponentList();
                    //if (!String.IsNullOrEmpty(ErrorXML))
                    //{
                    //    //Redirect to error page.
                    //    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_COMPONENTFACETUPDATEFAILED"), null, GetBackURL(), ref EncryptURL);
                    //    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                    //}
                }
                else if (Parameters[1].Equals("SelectSeriesRecord"))
                {
                    if (ViewState["ParentDeliverableID"] != null)
                    {
                        str_DeliverableId = ViewState["ParentDeliverableID"].ToString();
                    }
                    ParamURL.AppendFormat("Manage_SelectSigns.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&HiddenButtonID={4}&TaskID={5}&DeliverableID={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Btn_Hidden_SelectSigns.UniqueID, TaskID, str_DeliverableId);
                    ParamURL.Append("&OutPutFileName=" + StepID + str_SelectedComponentsIDFileName + "&SelectFor=STEP&StepID=" + StepID);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_new','left=120,top=120,width=1085,height=800,scrollbars=yes');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                else if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                {
                    getDigitalAssetsFromFacetIDs("STEP");
                }
                else if (Parameters[1].Equals("EditSeriesRecord"))
                {
                    if ((ViewState["ComponentFacetFieldName"] != null) && (Parameters[0].Contains(ViewState["ComponentFacetFieldName"].ToString())))
                    {
                        GetEditPageUrl();
                    }
                    else
                    {
                        GetSelectedStepForm(Parameters[0]);
                        String EditPageUrl = TempStepForm.GetSeriesEditRecordsUrl();
                        if (!String.IsNullOrEmpty(EditPageUrl))
                        {
                            Ajax.WriteExecuteJavaScript(EditPageUrl);
                        }
                    }
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObject)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.asp.cs", "ResponseForm_SeriesActionBarClick", ExceptionObject, null,
                    Localization.GetString("ALResource", ALParamObj.TenantName, "ERR_MWB_Manage_RODeliverableDetails_ExceptionwhilesavingComponentList_Shared"));

                ErrorPageURL_Exp = new StringBuilder();
                ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
            }    
         }

        /// <summary>
        /// <CreatedOn>03 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To save the list</Purpose>
        /// </summary>
        private ERRORXML SaveComponentList()
        {
            ERRORXML        ErrorXML                    = null; 
            String          strActivityDefID            = null; 
            String          strStdFormName              = null; 
            String          ResponseFormID              = null; 
            String          strSelectedFormName         = null; 
            String          strFormName                 = null; 
            StringBuilder   sb_TempPath                 = null; 
            StringBuilder   sb_Del_ComponentFacetSeries = null; 
            XML             ResponseXML                 = null; 
            FormFacade      FormFacadeObj               = null;
            MWB_Helper      MWB_HelperObj               = null; 
            XmlDocument     doc_InputXML                = null;
            XmlNode         node_Activity               = null; 
            XPathDocument   xp_ResponseXML              = null;
            XPathNavigator  nav_Response                = null; 
            XmlNode         node_Response               = null; 
            
            try
            {
                FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                sb_TempPath   = new StringBuilder(50);

                sb_TempPath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile);
                if (File.Exists(sb_TempPath.ToString()))
                {
                    //Get the Form data XML
                    doc_InputXML = new XmlDocument();
                    doc_InputXML.Load(sb_TempPath.ToString());    

                    strStdFormName  = "StepDetails_Response";
                    ResponseFormID  = __ResponseFormID.Value;
                    node_Activity   = doc_InputXML.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']");
                    strActivityDefID= node_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
                    strFormName     = strActivityDefID + "_Response";

                    MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
                    FormFacadeObj.FormName = strSelectedFormName;
                    FormFacadeObj.SolutionName = SolutionName;
                    
                    ResponseObjInfoList = (List<ObjectInfo>)ViewState["ResponseObjInfo"];
                    ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", ResponseForm, ResponseObjInfoList, out ResponseXML);
                    if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(ResponseXML)))
                    {
                        ErrorXML = UpdateDeliComponentFacetSeries(ref ResponseXML, "ACTIVITY");
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            sb_TempPath.Remove(0, sb_TempPath.Length);
                            sb_TempPath.AppendFormat("{0}{1}.xml", ALSolutionCommon.GetTempPath(ALParamObj.SessionID), ResponseFormID);
                            if (File.Exists(sb_TempPath.ToString()))
                            {
                                File.Delete(sb_TempPath.ToString());
                            }

                            //Delete the component file
                            sb_Del_ComponentFacetSeries = new StringBuilder(50);
                            sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                            if (File.Exists(sb_Del_ComponentFacetSeries.ToString()))
                            {
                                File.Delete(sb_Del_ComponentFacetSeries.ToString());
                            }

                            //Put the response if any in the activity node to manage the state
                            xp_ResponseXML = new XPathDocument(new StringReader(ResponseXML));
                            nav_Response = xp_ResponseXML.CreateNavigator().SelectSingleNode("ACTIVITY/ACTIVITY_RESPONSE");
                            if ((nav_Response != null) && (nav_Response.HasChildren))
                            {
                                node_Response = node_Activity.SelectSingleNode("ACTIVITY_RESPONSE");
                                if (node_Response != null)
                                {
                                    node_Response.InnerXml = nav_Response.InnerXml;
                                }
                                else
                                {
                                    node_Response = doc_InputXML.CreateElement("ACTIVITY_RESPONSE");
                                    ((XmlElement)node_Response).SetAttribute("TYPE", "RELATION");
                                    node_Response.InnerXml = nav_Response.InnerXml;
                                    node_Activity.AppendChild(node_Response);
                                }
                            }

                            nav_Response = xp_ResponseXML.CreateNavigator().SelectSingleNode("ACTIVITY/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                            if (nav_Response != null)
                            {
                                node_Response = node_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                                if (node_Response != null)
                                {
                                    node_Response.InnerXml = nav_Response.InnerXml;
                                }
                            }

                            //set the response form again.
                            setActivityResponseForm_ComponentList(node_Activity,true);
                        }
                    }
                }
                return ErrorXML; 
            }
            catch (ThreadAbortException)
            { return ErrorXML; }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        /// <summary>
        /// <CreatedOn>08 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To set the activity response form</Purpose>
        /// </summary>
        /// <param name="node_Activity">Activity node</param>
        private void setActivityResponseForm_ComponentList(XmlNode node_Activity, Boolean b_SetDeliverableComponentFacet)
        {
            StringBuilder   StepFormID          = null;
            StringBuilder   ActivityColl        = null;
            StringBuilder   ParameterList       = null;
			StringBuilder	TempFilePath		= null;
            String          FormConfigXMLPath   = null; 
            String          TempPath            = null;
            MWB_Helper      MWBHelperClassObj   = null;
            FormFacade      FormFacadeObj       = null;
            ERRORXML        ErrorXML            = null;
            XML             FormConfigXML       = null;
            XML             StepFormInputXML    = null;
            XmlDocument     StepDoc             = null;
            XmlAttribute    UploadAttr          = null;
            XmlNode         FieldNode           = null;
            XmlNode         UploadUrlNode       = null;
			String			strFormName			= null;
			String			strStdFormName		= null;
			String			strSelectedFormName	= null;
			String			strActivityDefID	= null;
            String          SearchXML           = null;

            try
            {
                StepFormID          = new StringBuilder(100);
                ActivityColl        = new StringBuilder(100);
                ParameterList       = new StringBuilder(100);
				TempFilePath		= new StringBuilder(100);
                StepDoc             = new XmlDocument();
                MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                FormFacadeObj       = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language,ALParamObj.SolutionName,Theme);
                TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

                strActivityDefID    = node_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
                strFormName			= strActivityDefID+ "_Response";
                strStdFormName		= "StepDetails_Response";
                FormConfigXMLPath   = MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);


                FormFacadeObj.FormName = strSelectedFormName;
                FormFacadeObj.SolutionName = SolutionName;
                StepFormID.AppendFormat("STEP_{0}", node_Activity.SelectSingleNode("ACTIVITYID").InnerText);

                FormFacadeObj.ShowConfiguredFields	= true;
                FormConfigXML = MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, node_Activity.SelectSingleNode("ACTIVITYNAME").InnerText, true);
               
                //HemantK: check for the deliverable component facet series
                if (b_SetDeliverableComponentFacet)
                {
                    FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                    ErrorXML = SetDeliverableComponentFacetSeries(ref node_Activity, ref FormConfigXML, SearchXML);
                }
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    ActivityColl.AppendFormat("<ACTIVITYCOLLECTION>{0}</ACTIVITYCOLLECTION>", node_Activity.OuterXml);
				    ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ActivityColl.ToString(), out StepFormInputXML, out ResponseObjInfoList);
				    ViewState["ResponseObjInfo"] = ResponseObjInfoList;
                    if (ErrorXML == null)
                    {
                        StepDoc.LoadXml(StepFormInputXML);
                        FieldNode = StepDoc.SelectSingleNode("FieldList/Field[@Name='RESPONSE_RESPONSEATTACHMENTS_ACTIVITY_RESPONSE']");
                        if (FieldNode != null)
                        {
                            ParameterList.AppendFormat("&TenantName={0}&Language={1}&SessionID={2}&UserID={3}&SolutionName={4}&ControlID={5}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, SolutionName, Btn_StepAttachments.UniqueID);
                            if (FieldNode.Attributes.GetNamedItem("UploadURL") != null)
                            {
                                UploadUrlNode = FieldNode.Attributes.GetNamedItem("UploadURL");                            
                                UploadUrlNode.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                            }
                            else
                            {
                                UploadAttr = StepDoc.CreateAttribute("UploadURL");
                                UploadAttr.InnerText = "../../Common/ASPX/UploadFiles.aspx?Param=" + ParameterList.ToString();
                                FieldNode.Attributes.Append(UploadAttr);
                            }
                            if (FieldNode.Attributes.GetNamedItem("DownLoadURL") != null)
                            {
                                UploadUrlNode = FieldNode.Attributes.GetNamedItem("DownLoadURL");
                                UploadUrlNode.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                            }
                            else
                            {
                                UploadAttr = StepDoc.CreateAttribute("DownLoadURL");
                                UploadAttr.InnerText = "../../Common/ASPX/FileDownload.aspx?Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString());
                                FieldNode.Attributes.Append(UploadAttr);
                            }
                        }
                        ResponseForm.InputXML = StepDoc.OuterXml;
                        //ResponseForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                        ResponseForm.ResetFacetSeriesFields();
                        TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID.ToString());
					    File.WriteAllText(TempFilePath.ToString(), StepFormInputXML);
                    }
                }
            }
            catch (ThreadAbortException)
            { }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        /// <summary>
        /// <Author>Mr. Hemant Karkande</Author>
        /// <CreatedOn>29 November 2008</CreatedOn>
        /// <Purpose>To put the deliverable component facet series data in inputxml</Purpose>
        /// </summary>
        /// <param name="InputXMLDoc"></param>
        /// <param name="FormConfigXML"></param>
        private ERRORXML SetDeliverableComponentFacetSeries(ref XmlNode ActivityNode, ref String FormConfigXML, String SearchXML)
        {
            String          str_DeliverableProcessId    = null; 
            String          str_ComponentFacetRShipName = null;
            String          str_InputXML                = null; 
            XmlDocument     InputXMLDoc                 = null; 
            String          str_ComponentFacetFieldName = null; 
            MWB_Component   MWB_ComponentObj            = null; 
            String          str_ComponentUserStatus     = null;
            String          str_ComponentSystemStatus   = null;
            XmlNode         node_ActivityDefinitionID   = null;
            String          str_ActivityDefinitionID    = null;
            ERRORXML        ErrorXMLString              = null;
            String          ErrorPageURL                = null; 
            ulong           ErrorID                     = 0;
            String          str_ComponentAssetRShip     = null;
            String          str_PrimaryKey              = null;

            try
            {
                MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                node_ActivityDefinitionID = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                if (node_ActivityDefinitionID != null)
                {
                    str_ActivityDefinitionID = node_ActivityDefinitionID.InnerText;
                }

                if (!String.IsNullOrEmpty(FormConfigXML))
                {
                    if (ViewState["ParentDeliverableID"] != null)
                    {
                        str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        str_InputXML = ActivityNode.OuterXml;

                        //Check for the Deliverable details
                        if ((ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] != null) && (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""].ToString() != "No"))
                        {
                            str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                            ErrorXMLString = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "ACTIVITY", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                            if (String.IsNullOrEmpty(ErrorXMLString))
                            {
                                InputXMLDoc = new XmlDocument();
                                InputXMLDoc.LoadXml(str_InputXML);
                                ActivityNode = InputXMLDoc.DocumentElement;
                            }
                            else
                            {
                                //Redirect to error page.
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                if (!IsPostBack)
                                {
                                    Response.Redirect(ErrorPageURL, true);
                                }
                                else
                                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                        else
                        {
                            if (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] == null)
                            {
                                ErrorXMLString = MWB_ComponentObj.GetComponentFacetForTaskActivity(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_ActivityDefinitionID, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, "ACTIVITY", str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, SearchXML, out str_PrimaryKey, out str_ComponentAssetRShip);
                                if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(str_ComponentFacetRShipName)) && (!String.IsNullOrEmpty(str_ComponentFacetFieldName)))
                                {
                                    ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "Yes";
                                    if (ViewState["ComponentFacetSeriesRShipName"] == null)
                                    {
                                        ViewState["ComponentFacetSeriesRShipName"] = str_ComponentFacetRShipName;
                                    }
                                    if (ViewState["ComponentFacetFieldName"] == null)
                                    {
                                        ViewState["ComponentFacetFieldName"] = str_ComponentFacetFieldName;
                                    }
                                    if (ViewState["ComponentFacetPrimaryKey"] == null)
                                    {
                                        ViewState["ComponentFacetPrimaryKey"] = str_PrimaryKey;
                                    }
                                    if ((!String.IsNullOrEmpty(str_ComponentAssetRShip)) && (ViewState["ComponentAssetRShipName"] == null))
                                    {
                                        ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                    }
                                    InputXMLDoc = new XmlDocument();
                                    InputXMLDoc.LoadXml(str_InputXML);
                                    ActivityNode = InputXMLDoc.DocumentElement;
                                }
                                else if (!String.IsNullOrEmpty(ErrorXMLString))
                                {
                                    //Redirect to error page.
                                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                                    if (!IsPostBack)
                                    {
                                        Response.Redirect(ErrorPageURL, true);
                                    }
                                    else
                                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                }
                                else if (String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                {
                                    ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "No";
                                }
                            }
                        }

                        //Radha: For component facet series action bar.
                        if ((ViewState["ComponentUserStatus"] == null) && (!String.IsNullOrEmpty(str_ComponentUserStatus)))
                        {
                            ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                        }
                    }
                }
                return ErrorXMLString;
            }
            catch (ThreadAbortException)
            { return ErrorXMLString; }
            catch (Exception ExceptionObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "SetDeliverableComponentFacetSeries", ExceptionObj, null, null);
                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackURL(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
                return ErrorXMLString;
            }
        }

        /// <summary>
        /// <CreatedOn>8 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To update the deliverable component facet seires</Purpose>
        /// </summary>
        /// <param name="SaveTaskXML"></param>
        /// <returns></returns>
        private ERRORXML UpdateDeliComponentFacetSeries(ref String SaveTaskXML, String str_RootNode)
        {
            ERRORXML        ErrorXMLString              = null; 
            String          str_DeliverableProcessId    = null; 
            String          str_ComponentFacetRShipName = null;
            MWB_Component   MWB_ComponentObj            = null;
            String          SelectedComponentXML        = null;
            String          str_ComponentFacetName      = null;
            String          str_PrimaryKey              = null;
            XPathDocument   xpathDoc_ComponentFormConfig= null;
            XPathNavigator  xpathNav_ComponentFacet     = null;
            Boolean         b_UpdateTaskActivity        = false;
            
            try
            {
                //Take out the Compoent Facet Series from the input xml and update the deliverable
                //and return the InputXML by removing the Component Facet Series nodes.
                if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                {
                    str_DeliverableProcessId    = ViewState["ParentDeliverableID"].ToString();
                    str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                    
                    xpathDoc_ComponentFormConfig = new XPathDocument(new StringReader(ResponseForm.ConfigurationXML));
                    xpathNav_ComponentFacet = xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "' and @IsSeries='YES']");
                    if (xpathNav_ComponentFacet != null)
                    {
                        //Read the Sort order and sort column
                        str_ComponentFacetName  = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                        str_PrimaryKey          = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                        if (xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                        {
                            b_UpdateTaskActivity = true;
                        }
                    }
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXMLString   = MWB_ComponentObj.SaveComponentFacetData(str_DeliverableProcessId, str_ComponentFacetRShipName, str_RootNode, ref SaveTaskXML, b_UpdateTaskActivity, str_ComponentFacetName, str_PrimaryKey, out SelectedComponentXML);
                }
                return ErrorXMLString;
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }        

        /// <summary>
        /// <CreatedOn>08 December 2008</CreatedOn> 
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To check the status of the Deliverable component facet series and depending on that set the form mode</Purpose>
        /// </summary>
        /// <param name="Frm_ToChange">Form whose mode is to be set</param>
        private void CheckComponentFacetSeriesStatus(Form Frm_ToChange)
        {
            try
            {
                if ((!String.IsNullOrEmpty(str_ComponentFacetStatus)) && (str_ComponentFacetStatus.ToUpper() == "READONLY"))
                {
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                        Frm_ToChange.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }
                }
                else if ((ViewState["ComponentUserStatus"] != null) && (ViewState["ComponentUserStatus"].ToString().ToUpper().Equals("FINAL LOCK")))
                {
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                    }
                }
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        /// <summary>
        /// <CreatedOn>09 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To get the Component facet for task</Purpose>
        /// </summary>
        /// <param name="TaskXMLDoc"></param>
        /// <param name="FormConfigXMLPath"></param>
        /// <param name="FormConfigXMLType"></param>
        private ERRORXML GetComponentFacetForTask(ref XmlDocument TaskXMLDoc, ref String FormConfigXML, String SearchXML)
        {
            ERRORXML        ErrorXML                    = null; 
            String          str_ComponentFacetRShipName = null;
            String          str_DeliverableProcessId    = null;
            StringBuilder   sb_Del_ComponentFacetSeries = null;
            String          str_ComponentFacetFieldName = null; 
            Boolean         bool_GetDeliverable         = true; 
            MWB_Component   MWB_ComponentObj            = null;
            String          str_InputXML                = null;
            String          str_ComponentUserStatus     = null;
            String          str_ComponentSystemStatus   = null;
            String          ErrorPageURL                = null; 
            ulong           ErrorID                     = 0;
            String          str_ComponentAssetRShip     = null;
            String          str_PrimaryKey              = null;

            try
            {
                MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
         
                //Check for the facet series configured in the form by getting the Component Facet series facet and relationship name from the configuration
                if ((ViewState["ComponentFacetSeriesFor_Task"] != null) && (ViewState["ComponentFacetSeriesFor_Task"].ToString() != "No"))
                {
                    str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                    str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                    bool_GetDeliverable = false;
                }

                str_InputXML = TaskXMLDoc.OuterXml;  
                if (bool_GetDeliverable)
                {
                    if (ViewState["ComponentFacetSeriesFor_Task"] == null)
                    {
                        //HemantK:Delete temp file for component facet series
                        sb_Del_ComponentFacetSeries = new StringBuilder(50);
                        sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                        if ((File.Exists(sb_Del_ComponentFacetSeries.ToString())) && (!IsPostBack))
                        {
                            File.Delete(sb_Del_ComponentFacetSeries.ToString());
                        }

                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        }

                        ErrorXML = MWB_ComponentObj.GetComponentFacetForTask(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_PrimaryKey, out str_ComponentAssetRShip, SearchXML);
                        if ((String.IsNullOrEmpty(ErrorXML)))
                        {
                            if (!String.IsNullOrEmpty(str_ComponentFacetRShipName))
                            {
                                //Put Component Facet relationship name and Component Facet name in view state
                                ViewState["ComponentFacetSeriesFor_Task"]   = "Yes";
                                ViewState["ComponentFacetSeriesRShipName"]  = str_ComponentFacetRShipName;
                                ViewState["ComponentFacetFieldName"]        = str_ComponentFacetFieldName;
                                ViewState["ComponentFacetPrimaryKey"]       = str_PrimaryKey;
                                if (!String.IsNullOrEmpty(str_ComponentAssetRShip))
                                {
                                    ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                }
                                TaskXMLDoc.LoadXml(str_InputXML);
                            }
                            else
                            {
                                ViewState["ComponentFacetSeriesFor_Task"] = "No"; ;
                            }
                        }
                        else
                        {
                            //Redirect to error page.
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                }
                else
                {
                    str_InputXML = TaskXMLDoc.OuterXml;
                    ErrorXML = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "WORKFLOWPROCESS", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        TaskXMLDoc.LoadXml(str_InputXML);
                    }
                    else
                    {
                        //Redirect to error page.
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackURL(), ref ErrorPageURL);
                        if (!IsPostBack)
                        {
                            Response.Redirect(ErrorPageURL, true);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }

                //Radha: For setting component series action bar depends upon the component user status.
                if ((!String.IsNullOrEmpty(str_ComponentUserStatus)))
                {
                    ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                }
                return ErrorXML; 
            }
            catch (ThreadAbortException)
            { return ErrorXML; }
            catch (Exception ExceptionObj)
            {
                ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Perform_Response_Assignment_Task.aspx", "GetComponentFacetForTask", ExceptionObj, null, null);
                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackURL(), ref ErrorPageURL);
                if (!IsPostBack)
                {
                    Response.Redirect(ErrorPageURL);
                }
                else
                {
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                }
                return ErrorXML;
            }
        }

        /// <summary>
        /// <CreatedOn>09 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To update the deliverable component facet</Purpose>
        /// </summary>
        /// <param name="SaveTaskXML"></param>
        /// <param name="str_ActionBarXML"></param>
        /// <returns></returns>
        private ERRORXML UpdateDeliverableComponentForTask(ref String SaveTaskXML, String str_ActionBarXML, Hashtable obj_SelectComponentIDs, String str_ComponentFacetName, String str_ComponentFacetPK)
        {
            ERRORXML      ErrorXMLString                = null; 
            MWB_Component MWB_ComponentObj              = null; 
            String        str_DeliverableProcessId      = null; 
            String        str_ComponentFacetRShipName   = null;
            try
            {
                MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                {
                    str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                    str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();

                    ErrorXMLString = MWB_ComponentObj.RemoveAndUpdateComponentFacet(str_DeliverableProcessId, str_ComponentFacetRShipName, "WORKFLOWPROCESS", ref SaveTaskXML, str_ActionBarXML, obj_SelectComponentIDs, str_ComponentFacetName, str_ComponentFacetPK, str_SelectedComponentsIDFileName);
                    //xmlDoc_SaveTaskXml = new XmlDocument();
                    //xmlDoc_SaveTaskXml.LoadXml(SaveTaskXML);
                    //MWB_ComponentObj.RemoveComponentFacetNodes(xmlDoc_SaveTaskXml, str_ComponentFacetRShipName, "WORKFLOWPROCESS", "ALL", null);
                    //SaveTaskXML = xmlDoc_SaveTaskXml.OuterXml;
                }
                return ErrorXMLString; 
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        /// <summary>
        /// <CreatedOn>09 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To get the Form Action bar</Purpose>
        /// </summary>
        /// <param name="ResponseForm"></param>        
        /// <returns></returns>
        private String GetFormActionBarXML(Form TempForm)
        {
            String          str_ComponentFacetFieldName = null; 
 
            try
            {
                if (ViewState["ComponentFacetFieldName"] != null)
                {
                    str_ComponentFacetFieldName = ViewState["ComponentFacetFieldName"].ToString();

                    return TempForm.GetSeriesActionBar(str_ComponentFacetFieldName); 
                }
                else
                {
                    return null; 
                }
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        /// <alsummary>
        /// <CreatedOn>5 Feb 09</CreatedOn>
        /// <Author>Mugdha Moolay</Author>
        /// <Purpose>This method clears the drop down list if a resource type is deleted using the Remove Button. 
        ///  This function also updates the State XML used by the Select Resource Type pop-up</Purpose>
        /// </alsummary>
        /// <param name="ActivityID">The StepID for which resource is selected</param>
        /// <param name="str_FormID">The Dynamic Form ID</param>
        private void UpdateContributorDropDownList(String ActivityID,String str_FormID)
        {
            XML         ItemList            = null;
            MWB_Helper  obj_MWBHelper       = null;
            try
            {
                ItemList = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                setStepFormInputXMLForGroup(str_FormID, ItemList);
                // Update the Resource File Name for the Activity 
                // Update the Resource File Name for the Activity
                obj_MWBHelper = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                obj_MWBHelper.UpdateStateXMLForResourceType(StepResourceFileName, ActivityID);              
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        private void UpdateContributorDropDownList()
        {
            MWB_Helper  obj_MWBHelper       = null;
            try
            {                    
                setStepFormInputXMLForGroup();
                // Update the Resource File Name for the Activity 
                // Update the Resource File Name for the Activity
                obj_MWBHelper = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                obj_MWBHelper.UpdateStateXMLForResourceType(StepResourceFileName, StepID);              
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        private void setStepFormInputXMLForGroup()
        {            
            XML             FormInputXML        = null;            
            XmlNode         FieldNode           = null;
            XmlNode         ValueNode           = null;
            String          TempPath            = null;
            StringBuilder   TempFilePath        = null;
            XmlDocument     FormInputDoc        = null;
            XML             ItemList            = null;
            try
            {
                ItemList         = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                FormInputDoc     = new XmlDocument();                
                TempFilePath     =  new StringBuilder(); 
                TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                if (Frm_ForwardTask!= null)
                {
                    FormInputXML = Frm_ForwardTask.InputXML;
                    if (FormInputXML!=null)
                    {
                        FormInputDoc.LoadXml(FormInputXML);
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                        if (FieldNode != null)
                        {
                            FieldNode.InnerXml = ItemList;                            
                            FieldNode = null;
                        }                        
                        FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                        if (FieldNode != null)
                        {
                            ValueNode = FieldNode.SelectSingleNode("Value");
                            if (ValueNode != null)
                                ValueNode.InnerText = "";                            
                        }

                        Frm_ForwardTask.InputXML = FormInputDoc.OuterXml;
                        //Frm_ForwardTask.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                        Frm_ForwardTask.ResetFacetSeriesFields();
                    }
                }
                
            }
            catch (Exception ExceptionObj)
            {                
                throw ExceptionObj;
            }
        }

        /// <summary>
        /// <Author>Radha A</Author>
        /// <CreatedOn>03 April 2009</CreatedOn>
        /// <Purpose>To download digital assets.</Purpose>
        /// </summary>
        private void getDigitalAssetsFromFacetIDs(String str_DownloadFor)
        {
             String          selectedFacetIDs    = null;
             MWB_Component   objComponentFacade  = null;
             String          SearchOutputXML     = null;
             String          ErrorXML            = null;
             String          ErrorPageURL        = null;
             String          str_BatchDownloadAssetsFile  = null;
             String          str_ComponentSearchForm      = null;
             String          str_AlertMessage             = null;
             String          str_BatchDownloadURL         = null;

             try
             {
                 objComponentFacade     = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                 if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "TASK"))
                 {
                     selectedFacetIDs            = Frm_TaskDetails.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                     str_BatchDownloadAssetsFile = TaskID + "_BatchDownloadAssetsXml";
                 }
                 else if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "STEP"))
                 {
                     selectedFacetIDs            = ResponseForm.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                     str_BatchDownloadAssetsFile = StepID + "_BatchDownloadAssetsXml";
                 }

                 if (!String.IsNullOrEmpty(selectedFacetIDs))
                 {
                     if ((ViewState["ComponentFacetPrimaryKey"] != null) && (ViewState["ComponentAssetRShipName"] != null) && (ViewState["ParentDeliverableID"] != null))
                     {
                         objComponentFacade.SolutionName = SolutionName;
                         ErrorXML = objComponentFacade.GetComponentSearchFormName(ViewState["ParentDeliverableID"].ToString(), out str_ComponentSearchForm);

                         if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_ComponentSearchForm)))
                         {
                             ErrorXML = objComponentFacade.GetBatchDownloadDetails(selectedFacetIDs, ViewState["ComponentFacetPrimaryKey"].ToString(), ViewState["ComponentAssetRShipName"].ToString(), ref SearchOutputXML, str_ComponentSearchForm, str_BatchDownloadAssetsFile, out str_AlertMessage, out str_BatchDownloadURL);
                             if (String.IsNullOrEmpty(ErrorXML))
                             {
                                 if (!String.IsNullOrEmpty(str_AlertMessage))
                                     Ajax.WriteExecuteJavaScript("ShowAlert('" + str_AlertMessage + "');");
                                 else if (!String.IsNullOrEmpty(str_BatchDownloadURL))
                                     Ajax.WriteExecuteJavaScript("window.open('" + str_BatchDownloadURL + "','_new','left=120,top=120,width=1085,height=800,resizable=yes,scrollbars=yes');");
                             }
                         }
                     }
                     else
                     {
                         ErrorXML = "<ERROR><MESSAGE>" + Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_BatchUploadDigitalAssets_COMPOENTDIGITALASSETRELATIONNOTFOUND") + "</MESSAGE></ERROR>";
                     }
                     if (!String.IsNullOrEmpty(ErrorXML))// Redirect to Error
                     {
                         ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "DELIVERABLE", null, ErrorXML, null, GetBackURL(), ref ErrorPageURL);
                         Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                     }
                 }
                 if (str_DownloadFor.ToUpper() == "TASK")
                 {
                     Frm_TaskDetails.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                 }
                 else if (str_DownloadFor.ToUpper() == "STEP")
                 {
                     ResponseForm.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                 }
             }
             catch (Exception ExceptionObj)
             {
                 throw ExceptionObj;
             }
        }

        /// <summary>
        /// <Author>Radha A</Author>
        /// <CreatedOn>14 April 2009</CreatedOn>
        /// <Purpose>To get the edit page url </Purpose>
        /// </summary>
        /// <param name="str_Source">It indicates Task Or Activity</param>
        /// <param name="str_ActivityID">Activity id</param>
        private void GetEditPageUrl()
        {
            MWB_Component       MWB_ComponentObj        = null;
            String              ErrorXML                = null;
            String              str_AlertMsg            = null;
            StringBuilder       sb_Parameters           = null;
            String              EditPageUrl             = null;
            String              str_SelectedFormName    = null;
            XPathDocument       xp_TaskDoc              = null;
            String              TempPath                = null;
            XPathNavigator      nav_ActivityInfoNode    = null;
            String              str_ActivityDefID       = null;
            String              str_FormName            = null;
            String              str_FormConfigXMLPath   = null;
            MWB_Helper          MWB_HelperObj           = null;
            try
            {
                MWB_ComponentObj        = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MWB_HelperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                sb_Parameters           = new StringBuilder(400);
                TempPath                = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile;
                xp_TaskDoc              = new XPathDocument(TempPath);
                nav_ActivityInfoNode    = xp_TaskDoc.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepID + "']/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                if (nav_ActivityInfoNode != null)
                {
                    str_ActivityDefID       = nav_ActivityInfoNode.Value;
                    str_FormName            = str_ActivityDefID + "_Response";
                    str_FormConfigXMLPath   = MWB_HelperObj.GetFormConfigXMLPath("StepDetails_Response", str_FormName, out str_SelectedFormName);
                }

                if ((ViewState["ComponentFacetFieldName"] != null) && (ViewState["ParentDeliverableID"] != null) && (!String.IsNullOrEmpty(str_SelectedFormName)))
                {
                    EditPageUrl = ResponseForm.GetSeriesEditRecordsUrl(ViewState["ComponentFacetFieldName"].ToString());

                    sb_Parameters.Append("&DeliverableID="      + ViewState["ParentDeliverableID"].ToString()
                                           + "&TaskID="         + TaskID
                                           + "&ActivityID="     + StepID
                                           + "&CFRelionship="   + ViewState["ComponentFacetSeriesRShipName"].ToString()
                                           + "&FormName="       + str_SelectedFormName
                                           + "&ComponentFacetSeriesPrimaryKey=" + ViewState["ComponentFacetPrimaryKey"].ToString()
                                           + "&Source=ACTIVITY");

                    if (ViewState["ComponentAssetRShipName"] != null)
                    {
                        sb_Parameters.Append("&ComponentDigitalAssetRelationship=" + ViewState["ComponentAssetRShipName"].ToString());
                    }

                    ErrorXML = MWB_ComponentObj.GetComponentSystemStatus(ViewState["ParentDeliverableID"].ToString(), ref EditPageUrl, sb_Parameters.ToString(), out str_AlertMsg);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        if (!String.IsNullOrEmpty(str_AlertMsg))
                        {
                            Ajax.WriteExecuteJavaScript("alert('" + str_AlertMsg + "');");
                        }
                        else if (!String.IsNullOrEmpty(EditPageUrl))
                        {
                            Ajax.WriteExecuteJavaScript(EditPageUrl);
                        }
                    }
                }
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        private void renderStepForms(HtmlTextWriter writer)
        {

            //2. Editable Forms.
            StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
            if (StepFormIDTable != null)
            {
                IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                while (StepFormIDEnum.MoveNext())
                {
                    Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                    if (StepForm != null)
                    {
                        writer.Write("<script type=\"text/javascript\">" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                    }
                }
            }

            //3. Response Form.
            writer.Write("<script type=\"text/javascript\">" + (String)ResponseForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
            //4. ROResponse Form.
            //For the Iterators of the read only step forms.
            StepROFormIDTable = (Hashtable)ViewState["StepROFormIDList"];
            if (StepFormIDTable != null)
            {
                IDictionaryEnumerator StepFormIDEnum = StepROFormIDTable.GetEnumerator();
                while (StepFormIDEnum.MoveNext())
                {
                    Form StepForm = (Form)Manual_Activities.FindControl(StepFormIDEnum.Value.ToString());
                    if (StepForm != null)
                    {
                        Ajax.WriteExecuteJavaScript("javascript:" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                    }
                }
            }
        }

        /// <summary>
        /// <CreatedOn>18 December 2008</CreatedOn>
        /// <Author>Hemant Karkande</Author>
        /// <Purpose>To get the selected form</Purpose>
        /// </summary>
        private void GetSelectedStepForm(String str_SenderString)
        {
            String FormID               = null;

            try
            {
                if (str_SenderString.Contains(ResponseForm.ID))
                {
                    FormID = ResponseForm.ID;
                }
                else
                {

                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                    while (StepFormIDEnum.MoveNext())
                    {
                        if (str_SenderString.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            FormID = StepFormIDEnum.Value.ToString();
                            break;
                        }
                    }
                }

                if (FormID != null)
                {
                    TempStepForm = (Form)Manual_Activities.FindControl(FormID);
                }
            }
            catch (Exception ExceptionObj)
            {
                throw(ExceptionObj);
            }
        }

        /// <summary>
        /// <Author>Anita Kale</Author>
        /// <CreatedOn>18th May 2009</CreatedOn>
        /// <Purpose>sets project info form related to the task</Purpose>
        /// </summary>
        private void setProjectInfo()
        {
            
            FormFacade          formfacade_Project          = null;
            MWB_Helper          MWBHelperObj                = null;
            String              str_FormConfigXMLPath       = null;
            String              str_FormInputXML            = null;
            String              str_TempProjectInfofile     = null;
            ERRORXML            errorxml_Output             = null;
            
            try
            {
                formfacade_Project                      = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                formfacade_Project.ShowConfiguredFields = true;
                formfacade_Project.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.XMLPath.ToString();

                str_TempProjectInfofile                 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID)+ TaskID + str_ProjectInfoTempFileName;
                if (File.Exists(str_TempProjectInfofile) && ViewState["ProjectInfoFormConfigPath"] != null)
                {
                    str_FormConfigXMLPath   = ViewState["ProjectInfoFormConfigPath"].ToString();

                    //Form Input Xml type path
                    Frm_ROProjectDetails.InputXMLType  = Assetlink.CustomControls.Form.InputType.XMLPath;
                    Frm_ROProjectDetails.InputXML      = str_TempProjectInfofile;
                }
                else
                {
                    MWBHelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    errorxml_Output = MWBHelperObj.GetProjectInfo(formfacade_Project, TaskID, "Task", ref str_FormConfigXMLPath, ref str_FormInputXML);

                    if (String.IsNullOrEmpty(errorxml_Output) && !String.IsNullOrEmpty(str_FormInputXML))
                    {
                        //Form Input Xml type InnerXML
                        Frm_ROProjectDetails.InputXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                        Frm_ROProjectDetails.InputXML = str_FormInputXML;
                    }
                    else
                    {
                        //Redirect to error page
                        gotoErrorPage(Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_MWB_failedToGetProjectInfoForTask_Shared"));
                    }
                    this.ViewState["ProjectInfoFormConfigPath"] = str_FormConfigXMLPath;
                    File.WriteAllText(str_TempProjectInfofile, str_FormInputXML);
                }
                
                if (!String.IsNullOrEmpty(str_FormConfigXMLPath))
                {
                    Frm_ROProjectDetails.ConfigurationXMLType   = Assetlink.CustomControls.Form.InputType.XMLPath;
                    Frm_ROProjectDetails.ConfigurationXML       = str_FormConfigXMLPath;
                }
                else
                {
                    //Redirect to error page
                    gotoErrorPage(Localization.GetString("ALErrorResource", ALParamObj.TenantName, "Err_MWB_failedToGetProjectInfoFormConfigPath_Shared"));
                }
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        /// <summary>
        /// <createddate>26 May 2009</createddate>
        /// <author>Jisha Rajendran</author>
        /// </summary>
        /// <param name="UsersNode">UserCollection Xml</param>
        /// <param name="GroupNode">Group Collection XML</param>
        /// <Purpose>This method prepares the User/group data xml and populates in the User/group list</Purpose>
        private void populateUserGroupList(XML UserDataXML, XML GroupDataXML)
        {
            MWB_Helper          MWB_HelperObj           = null;
            XML                 xml_List                = null;
            ListFacade          facade_ListControl      = null;
            XML                 xml_ListConfig          = null;                
            XPathDocument       xp_UserGroupColl        = null;
            XPathExpression     xpExp_UserGroup         = null;
            StringBuilder       sb_UserGroupColl        = null;
            XPathNodeIterator   nodeIter_RootNode       = null;
            XML                 xml_ExistingUserGroup   = null;                

            MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

            //Prepare the User list xml
            if (!String.IsNullOrEmpty(UserDataXML))
                MWB_HelperObj.AddUsersToUserGroupsListXML("<UserSelectionXML><SelectedUsersList>" + UserDataXML + "</SelectedUsersList></UserSelectionXML>",
                    ref xml_ExistingUserGroup);

            //Prepare the Group list xml
            if (!String.IsNullOrEmpty(GroupDataXML))
                MWB_HelperObj.AddGroupsToUserGroupsListXML("<GroupSelectionXML><SelectedGroupsList>" + GroupDataXML + "</SelectedGroupsList></GroupSelectionXML>",
                                    ref xml_ExistingUserGroup);

            //Sort the data
            sb_UserGroupColl = new StringBuilder(200);
            sb_UserGroupColl.Append(@"<SEARCHOUTPUTXML><USERGROUPCOLLECTION>");
            if (!String.IsNullOrEmpty(xml_ExistingUserGroup))
            {
                xp_UserGroupColl    = new XPathDocument(new StringReader(xml_ExistingUserGroup));
                xpExp_UserGroup     = XPathExpression.Compile("USERGROUPCOLLECTION/USERGROUP");
                xpExp_UserGroup.AddSort("USER_GROUP", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                xpExp_UserGroup.AddSort("USER_GROUP_NAME", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                nodeIter_RootNode   = xp_UserGroupColl.CreateNavigator().Select(xpExp_UserGroup);
                foreach (XPathNavigator xpnav_UserGroup in nodeIter_RootNode)
                {
                     sb_UserGroupColl.Append(xpnav_UserGroup.OuterXml);
                }
            }
            sb_UserGroupColl.Append(@"</USERGROUPCOLLECTION></SEARCHOUTPUTXML>");

            facade_ListControl  = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            xml_ListConfig      = facade_ListControl.GetConfigurationXML(SolutionName, null, "UserGroupsForNotifications_RO");
            facade_ListControl.PrepareListXml(xml_ListConfig, sb_UserGroupColl.ToString(), out xml_List);
            Lst_UserGroup.Source = xml_List;
        }

        /// <alsummary>
        /// <CreatedOn>29 June 2009</CreatedOn>
        /// <Author>Mr. Hemant Karkande</Author>
        /// <Purpose>To get the Assignment Task Details</Purpose>
        /// </alsummary>
        /// <param name="str_ReturnTaskXML"></param>
        /// <param name="str_ActivityAssociatedFacets"></param>
        /// <returns></returns>
        private ERRORXML GetAssignmentTask(out String str_ReturnTaskXML)
        {
            StringBuilder       sb_SearchInputXML           = null;
            MWB_Helper          MWB_HelperObj               = null;
            ERRORXML            ErrorXMLString              = null;
            String              str_ProcessAssociatedFacets = null;
            SearchConfiguration SearchConfigObj             = null; 
            FormFacade          FormFacadeObj               = null;
            String              dynamicFormName             = null;
            String              stdFormName                 = null;
            String              FormConfigXMLPath           = null;
            String              str_SelectedFormName        = null;
            String              RelEntityList               = null;
            Hashtable           ActDefList                  = null;
            XDocument           xDocTask                    = null;
            XElement            xEleTask                    = null;
            IEnumerable<XElement> iEnumAct                  = null;
            try
            {
                str_ReturnTaskXML            = null;
                //str_ActivityAssociatedFacets = null; 
                ActDefList          = new Hashtable();
                sb_SearchInputXML   = new StringBuilder(250);
                MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                
                FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                if ((!String.IsNullOrEmpty(__PackageDefinitionID.Value)) && (!String.IsNullOrEmpty(__ProcessDefinitionID.Value)))
                {
                    
                    stdFormName = "Task_Details";
                    //ErrorXMLString = MWB_HelperObj.GetActivityDefintionIDList(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, out ActDefList);

                    ViewState["ActivityFacets"] = ActDefList;
                    dynamicFormName = __ProcessDefinitionID.Value + "_" + stdFormName;
                    FormFacadeObj.SolutionName = SolutionName;

                    FormConfigXMLPath = MWB_HelperObj.GetFormConfigXMLPath(stdFormName, dynamicFormName, out str_SelectedFormName);
                    FormFacadeObj.FormName = str_SelectedFormName;
                    FormFacadeObj.ConfigurationXML = FormConfigXMLPath;

                    ErrorXMLString = FormFacadeObj.GetRelatedObjectList(out str_ProcessAssociatedFacets, out RelEntityList);

                    if (!String.IsNullOrEmpty(ErrorXMLString))
                    {
                        return ErrorXMLString;
                    }

                }                
                
                sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                    <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                        if (String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                        {
                            sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                        }
                        else
                        {
                            sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                        }
                             sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                    <FILTERLIST>
		                                                    <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                    </FILTER>			                                                
	                                                    </FILTERLIST>
                                                        <RELATIONSHIP NAME='PROCESS_ASSETREFERENCES'>
                                                            <SELECTLIST>
			                                                    <EXPRESSION>
				                                                    <FIELDNAME>DIGITALASSETID</FIELDNAME>
			                                                    </EXPRESSION>
		                                                    </SELECTLIST>
                                                        </RELATIONSHIP>
                                                        <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                                            <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>ACTIVITYID</FIELDNAME>
                                                                        <ALIAS>ACTIVITYID</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>STATUS</FIELDNAME>
                                                                        <ALIAS>STATUS</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>STARTACTIVITY</FIELDNAME>
                                                                        <ALIAS>STARTACTIVITY</ALIAS>
			                                                        </EXPRESSION>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>ENDACTIVITY</FIELDNAME>
                                                                        <ALIAS>ENDACTIVITY</ALIAS>
			                                                        </EXPRESSION>
		                                                        </SELECTLIST>
                                                                <RELATIONSHIP NAME='ACTIVITY_INFORMATION'>
                                                                    <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>ACTIVITYINFORMATIONID</FIELDNAME>
                                                                                <ALIAS>ACTIVITYINFORMATIONID</ALIAS>
			                                                                </EXPRESSION>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>ACTIVITYDEFINITIONID</FIELDNAME>
                                                                                <ALIAS>ACTIVITYDEFINITIONID</ALIAS>
			                                                                </EXPRESSION>
		                                                                </SELECTLIST>
                                                                 </RELATIONSHIP>
                                                             </RELATIONSHIP>");
                if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                {
                    //sb_SearchInputXML.Append(str_ProcessAssociatedFacets);   
                    String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                    for (int Index = 0; Index < Arr_Facets.Length; Index++)
                    {
                        sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                    }
                }

                sb_SearchInputXML.Append(@"</TARGETENTITY>
                                        </SEARCH>");  
                
				ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskXML);
                
                if (ErrorXMLString == null)
                {
                    xDocTask = XDocument.Parse(str_ReturnTaskXML);
                    xEleTask = xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS");
                    iEnumAct = xEleTask.XPathSelectElements("PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY='False' and ENDACTIVITY='False']");
                    foreach (XElement xEleAct in iEnumAct)
                    {
                        ActDefList.Add(xEleAct.Element("ACTIVITYID").Value, xEleAct.Element("STATUS").Value + "$AL$" + xEleAct.Element("ACTIVITY_INFORMATION").Element("ACTIVITYINFORMATION").Element("ACTIVITYDEFINITIONID").Value);
                    }
                    xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS").Element("PROCESS_ACTIVITY").Remove();
                    str_ReturnTaskXML = xDocTask.Element("WORKFLOWPROCESSCOLLECTION").Element("WORKFLOWPROCESS").CreateNavigator().InnerXml;
                    ViewState["ActivityDefList"] = ActDefList;
                }
                return ErrorXMLString;

            }
            catch (Exception ExceptionObj)
            {
                throw (ExceptionObj);
            }
        }

        /// <alsummary>
        /// <CreatedOn>29 June 2009</CreatedOn>
        /// <Author>Mr. Hemant Karkande</Author>
        /// <Purpose>To get the Assignment Task Activities Details</Purpose>
        /// </alsummary>
        /// <param name="str_ActivityAssociatedFacets"></param> 
        /// <param name="str_ReturnTaskActivitesXML"></param> 
        /// <returns></returns>
        private ERRORXML GetAssignmentTaskActivities(out String str_ReturnTaskActivitesXML)
        {
            StringBuilder       sb_SearchInputXML           = null;
            ERRORXML            ErrorXMLString              = null;
            SearchConfiguration SearchConfigObj             = null; 
            MWB_Helper          MwbHelperObj                = null;
            PMFacadeClass       PMFacadeObj                 = null;
            XML                 ProcessDefXML               = null;
            XDocument           xDocProcessDef              = null;
            
            Hashtable           ActDefList                  = null;
            try
            {
                str_ReturnTaskActivitesXML  = null; 
                sb_SearchInputXML   = new StringBuilder(250);
                SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MwbHelperObj        = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXMLString = PMFacadeObj.GetProcessDefinitionByID(PackageDefinitionID, ProcessDefinitionID, out ProcessDefXML);

                if (ErrorXMLString != null)
                    return ErrorXMLString;

                xDocProcessDef       = XDocument.Parse(ProcessDefXML);
                ActDefList = (Hashtable)ViewState["ActivityDefList"];

                XElement xEleProcessDef = xDocProcessDef.Element("WORKFLOWPROCESS");
                sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                    <TARGETOBJECT>ACTIVITY</TARGETOBJECT>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                if (ActDefList != null)
                {
                    sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                }
                else
                {
                    sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                }
                             sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                    <FILTERLIST>
		                                                    <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
                                                                <RELATIONSHIPNAME>PROCESS_ACTIVITY</RELATIONSHIPNAME>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                    </FILTER>			                                                
	                                                    </FILTERLIST>																						  	
                                                        <SELECTLIST>
		                                                    <EXPRESSION>
			                                                    <FIELDNAME>ACTIVITYID</FIELDNAME>
			                                                    <ALIAS>ACTIVITYID</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>STARTACTIVITY</FIELDNAME>
			                                                    <ALIAS>STARTACTIVITY</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>ENDACTIVITY</FIELDNAME>
			                                                    <ALIAS>ENDACTIVITY</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>ACTIVITYNAME</FIELDNAME>
			                                                    <ALIAS>ACTIVITYNAME</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>STATUS</FIELDNAME>
			                                                    <ALIAS>STATUS</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>INSTRUCTIONS</FIELDNAME>
			                                                    <ALIAS>INSTRUCTIONS</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>SEQUENCENUMBER</FIELDNAME>
			                                                    <ALIAS>SEQUENCENUMBER</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>IMPLEMENTATIONTYPE</FIELDNAME>
			                                                    <ALIAS>IMPLEMENTATIONTYPE</ALIAS>
		                                                    </EXPRESSION>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>DUEDATE</FIELDNAME>
			                                                    <ALIAS>DUEDATE</ALIAS>
		                                                    </EXPRESSION>                                                           
	                                                    </SELECTLIST>
                                                        <RELATIONSHIP NAME='ACTIVITY_ITEM'>
                                                            <SELECTLIST>
                                                                <EXPRESSION>
	                                                                <FIELDNAME>DIGITALASSETID</FIELDNAME>
	                                                                <ALIAS>DIGITALASSETID</ALIAS>
                                                                </EXPRESSION>
                                                            </SELECTLIST>
                                                            <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>MARKEDASDELETED</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>			                                                
	                                                        </FILTERLIST>
                                                        </RELATIONSHIP>
                                                        <RELATIONSHIP NAME='ACTIVITY_RESPONSE'>
                                                                <RELATIONSHIP NAME='POSTEDBY'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                </RELATIONSHIP>
                                                        </RELATIONSHIP>
                                                        <RELATIONSHIP NAME='ACTIVITY_RESOURCE'>
                                                            <SELECTLIST>
		                                                        <EXPRESSION>
			                                                        <FIELDNAME>RESOURCEID</FIELDNAME>
			                                                        <ALIAS>RESOURCEID</ALIAS>
		                                                        </EXPRESSION>
                                                                <EXPRESSION>
			                                                        <FIELDNAME>RESOURCETYPE</FIELDNAME>
			                                                        <ALIAS>RESOURCETYPE</ALIAS>
		                                                        </EXPRESSION>                                                                    
	                                                        </SELECTLIST>                                                            
                                                            <RELATIONSHIP NAME='ACTUAL_RESOURCE'>
                                                                <SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>RESOURCEID</FIELDNAME>
				                                                        <ALIAS>RESOURCEID</ALIAS>
			                                                        </EXPRESSION>
                                                                    <EXPRESSION>
				                                                        <FIELDNAME>RESOURCETYPE</FIELDNAME>
				                                                        <ALIAS>RESOURCETYPE</ALIAS>
			                                                        </EXPRESSION>                                                                    
		                                                        </SELECTLIST>                                                                
                                                                <RELATIONSHIP NAME='RESOURCE_USER'>
                                                                    <SELECTLIST>
			                                                            <EXPRESSION>
				                                                            <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                            <ALIAS>LOGINNAME</ALIAS>
			                                                            </EXPRESSION>
                                                                        <EXPRESSION>
				                                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                            <ALIAS>FIRSTNAME</ALIAS>
			                                                            </EXPRESSION>     
                                                                        <EXPRESSION>
				                                                            <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                            <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                            </EXPRESSION>
                                                                        <EXPRESSION>
				                                                            <FIELDNAME>LASTNAME</FIELDNAME>
				                                                            <ALIAS>LASTNAME</ALIAS>
			                                                            </EXPRESSION> 
                                                                        <EXPRESSION>
				                                                            <FIELDNAME>EMAILID</FIELDNAME>
				                                                            <ALIAS>EMAILID</ALIAS>
			                                                            </EXPRESSION>                                                                    
		                                                            </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>
                                                        </RELATIONSHIP>");

                 FormFacade FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);   
                 IDictionaryEnumerator iDicEnumAct = ActDefList.GetEnumerator();
                 while(iDicEnumAct.MoveNext())                                 
                 {
                     String ActObjVal           = iDicEnumAct.Value.ToString();
                     String[] Status_DefIDArr   = ActObjVal.Split(strSeparator,StringSplitOptions.RemoveEmptyEntries);
                     String ActStatus           = Status_DefIDArr[0];
                     String ActDefID            = Status_DefIDArr[1];

                     String str_StdFormName     = null;
                     String str_DynamicFormName = null;
                     String SelectedFormName    = null;
                     String relatedEntityList   = null;
                     String ActRelatedFacets    = null;

                     FormFacadeObj.SolutionName = SolutionName;
                     if ((iDicEnumAct.Key.ToString() == StepID) && (ActStatus.ToUpper() == "ACTIVE"))
                     {
                         str_StdFormName     = "StepDetails_Response";
                         str_DynamicFormName = ActDefID + "_Response";                         
                     }
                     else
                     {
                         switch (ActStatus.ToUpper())
                         {
                             case "NEW":
                             case "DRAFT":                             
                                 str_StdFormName     = "StepDetails_Editable";
                                 str_DynamicFormName = ActDefID + "_Editable";
                                 break;
                             default:
                                 str_StdFormName     = "StepDetails_ROResponse";
                                 str_DynamicFormName = ActDefID + "_Response";
                                 break;
                         }
                     }


                     String FormConfigXMLPath       = MwbHelperObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out SelectedFormName);
                     FormFacadeObj.ConfigurationXML = FormConfigXMLPath;
                     FormFacadeObj.FormName         = SelectedFormName;
                     ERRORXML ErrorXml              = FormFacadeObj.GetRelatedObjectList(out ActRelatedFacets, out relatedEntityList);
                     ActRelatedFacets               = MwbHelperObj.GetActivityAssociatedFacets(xEleProcessDef, ActDefID, ActRelatedFacets);
                     String[] Arr_Facets            = ActRelatedFacets.Split(';');

                     for (int Index = 0; Index < Arr_Facets.Length; Index++)
                     {
                         if (!String.IsNullOrEmpty(Arr_Facets[Index]))
                         {
                             if (!sb_SearchInputXML.ToString().Contains(Arr_Facets[Index]))
                             {
                                 sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                             }
                         }
                     }
                 }

                

                sb_SearchInputXML.Append(@"</TARGETENTITY>
                                        </SEARCH>");
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbech Page (GetAssignmentTaskActivities):- Before GetHierarchialData() function.");
                ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskActivitesXML);
                ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbech Page (GetAssignmentTaskActivities):- Before GetHierarchialData() function.");

                //ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbech Page (GetAssignmentTaskActivities):- InputXML: " + sb_SearchInputXML.ToString());
                //ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "ResponseAssignment", ALParamObj.SessionID, "Workbech Page (GetAssignmentTaskActivities):- OutputXML: " + str_ReturnTaskActivitesXML);

                return ErrorXMLString; 
            }
            catch (Exception ExceptionObj)
            {
                throw (ExceptionObj);
            }
        }

        /// <alsummary>
        /// <CreatedOn>29 June 2009</CreatedOn>
        /// <Author>Mr. Hemant Karkande</Author>
        /// <Purpose>To get the merge Assignment Task and Task Activities</Purpose>
        /// </alsummary>
        /// <param name="ReturnTaskXML"></param> 
        /// <param name="str_ActivitiesXML"></param> 
        /// <param name="str_TaskXML"></param> 
        /// <returns></returns>
        private void MergeTaskActivities(String str_TaskXML, String str_ActivitiesXML, out String ReturnTaskXML)
        {
            //if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION>"))
            //{
            //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", "");
            //}
            //else if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
            //{
            //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
            //    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESS>", "<WORKFLOWPROCESS xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");
            //}
            //str_TaskXML = str_TaskXML.Replace("</WORKFLOWPROCESS></WORKFLOWPROCESSCOLLECTION>", "");

            if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION>"))
            {
                str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION>", "<PROCESS_ACTIVITY>");
            }
            else if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
            {
                str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "<PROCESS_ACTIVITY>");
            }
            str_ActivitiesXML = str_ActivitiesXML.Replace("</ACTIVITYCOLLECTION>", "</PROCESS_ACTIVITY>");

            str_TaskXML = "<WORKFLOWPROCESS>" + str_TaskXML + str_ActivitiesXML + "</WORKFLOWPROCESS>";

            ReturnTaskXML = str_TaskXML;
        }

        private void setTemplateDocument()
        {
            XML                         OutputXml        = null;
            ERRORXML                    ErrorXml         = null;
            MktgWorkBenchFacadeClass    Obj_MWBFacade    = null;
            try
            {
                Obj_MWBFacade   = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXml        = Obj_MWBFacade.GetDigitalAssetBySectionPath(SectionPath + ProcessDefinitionID, ref OutputXml);                
                showTemplateDocumentList(OutputXml);
            }
            catch (Exception ExcepObj)
            {                
                throw ExcepObj;
            }
        }

        private void showTemplateDocumentList(XML TemplateDocXML)
        {
            XPathDocument       UploadOutputDoc     = null;
            XPathNavigator      UploadNaviagator    = null;            
            XPathNodeIterator   UploadIterator      = null;
            StringBuilder       InputXML            = null;
            ListFacade          ListFacadeObj       = null;
            XML                 ConfigXML           = null;
            XML                 OutputXML           = null;
            XmlDocument         xmlDoc              = null;
            XmlNodeList         xmlNodeList         = null;
            XmlElement          xmlElement          = null;
            try
            {                
                InputXML         = new StringBuilder(20);
                ListFacadeObj    = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);                

                if (!String.IsNullOrEmpty(TemplateDocXML))
                {
                    UploadOutputDoc  = new XPathDocument(new StringReader(TemplateDocXML));
                    UploadNaviagator = UploadOutputDoc.CreateNavigator();

                    UploadIterator = UploadNaviagator.Select("DIGITALASSETCOLLECTION/DIGITALASSET");
                    if (UploadIterator.Count > 0)
                    {
                        Panel_Templates.Visible = true;
                        Lst_TemplateDocument.Visible = true;
                        InputXML.Append("<SEARCHOUTPUTXML>");
                        InputXML.Append(UploadNaviagator.OuterXml);
                        InputXML.Append("</SEARCHOUTPUTXML>");
                        ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "TemplateDocument");
                        ListFacadeObj.PrepareListXml(ConfigXML, InputXML.ToString(), out OutputXML);

                        #region SetDownloadUrl
                        xmlDoc = new XmlDocument();
                        xmlDoc.LoadXml(OutputXML);
                        xmlNodeList = xmlDoc.SelectNodes("/List/Data/Group/Row");
                        foreach (XmlNode tmpxmlNode in xmlNodeList)
                        {
                            xmlElement = (XmlElement)tmpxmlNode.SelectSingleNode("Column[@Name='NAME']");
                            xmlElement.SetAttribute("Url", GetTemplateDocumentUrl(tmpxmlNode, UploadNaviagator.OuterXml));
                        }
                        OutputXML = xmlDoc.OuterXml;
                        #endregion

                        Lst_TemplateDocument.Source = OutputXML;
                    }
                }                
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

        private string GetTemplateDocumentUrl(XmlNode xmlRowNode,String DigitalAssetXML)
        {

            XmlElement              xmlElement                  = null;
            XPathDocument           xpathDocument               = null;
            XPathNavigator          xPathNavigator              = null;
            XPathNavigator          tmpNavigator                = null;
            XPathNavigator          AssertRenditionNavigator    = null;            
            String                  xpathQuery                  = null;
            String                  xpathAssertQuery            = null;
            StringBuilder           ParameterList               = null;
            StringBuilder           DownLoadUrlPath             = null;
            Boolean                 b_IsFileOnMediaServer       = false;

            try
            {

                xpathDocument       = new XPathDocument(new StringReader(DigitalAssetXML));
                xPathNavigator      = xpathDocument.CreateNavigator();
                ParameterList       = new StringBuilder();
                DownLoadUrlPath     = new StringBuilder();
                xmlElement          = (XmlElement)xmlRowNode.SelectSingleNode("Column[@Name='DIGITALASSETID']");
                
                xpathQuery          = ("DIGITALASSETCOLLECTION/DIGITALASSET[DIGITALASSETID='" + xmlElement.InnerText + "']");
                xpathAssertQuery    = ("DIGITALASSET_CURRENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION[RENDITIONTYPE='Original']/FILESYSTEM/FILE");
                
                tmpNavigator                = xPathNavigator.SelectSingleNode(xpathQuery);
                AssertRenditionNavigator    = tmpNavigator.SelectSingleNode(xpathAssertQuery);

				ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=PROCESSFILE&ObjectID={5}&SchemaID={6}&FileName={7}&DownloadFileName={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, AssertRenditionNavigator.SelectSingleNode("OBJECTID").Value, AssertRenditionNavigator.SelectSingleNode("SCHEMAID").Value, Server.UrlEncode(AssertRenditionNavigator.SelectSingleNode("NAME").Value));
                //DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                if (AssertRenditionNavigator.SelectSingleNode("ONMEDIASERVER") != null)
                {
                    b_IsFileOnMediaServer = Convert.ToBoolean(AssertRenditionNavigator.SelectSingleNode("ONMEDIASERVER").Value);
                    ParameterList.Append("&IsFileOnMediaServer=" + b_IsFileOnMediaServer.ToString());
                    if (b_IsFileOnMediaServer)
                    {
                        ParameterList.Append("&FileID=" + AssertRenditionNavigator.SelectSingleNode("FILEID").Value);
                        ParameterList.Append("&FilePath=" + AssertRenditionNavigator.SelectSingleNode("PATH").Value);
                    }
                    DownLoadUrlPath.Append(ALSolutionCommon.PrepareFileDownloadURL(b_IsFileOnMediaServer, ALParamObj.TenantName));
                    DownLoadUrlPath.Append("Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                }

                return DownLoadUrlPath.ToString();

            }
            catch (Exception ExceptionObject)
            {
                
                throw ExceptionObject;
            }
        }


        private void UpdateTaskSteps()
        {            
            String          str_TaskActivities  = null;
            StringBuilder   TempFilePath        = null;
            StringBuilder   StepFormID          = null;
            String          TempPath            = null;
            XmlDocument     Task_Doc            = null;
            XmlNode         ActivityNode        = null;
            XmlNode         ProcessActNode      = null;
            XPathExpression   xp_SortExpression = null;
            XPathNodeIterator xp_SortNodeIter   = null;
            String            SortXML           = null;
            
            try
            {
                TempFilePath        = new StringBuilder(100);
                StepFormID          = new StringBuilder(100);
             
                TempPath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                GetAssignmentTaskActivities(out str_TaskActivities);

                if (str_TaskActivities.Contains("<ACTIVITYCOLLECTION>"))
                {
                    str_TaskActivities = str_TaskActivities.Replace("<ACTIVITYCOLLECTION>", "");
                }
                else if (str_TaskActivities.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                {
                    str_TaskActivities = str_TaskActivities.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
                }
                str_TaskActivities = str_TaskActivities.Replace("</ACTIVITYCOLLECTION>", "");

                TempFilePath.AppendFormat("{0}{1}",TempPath , TaskFile);                
                Task_Doc            = new XmlDocument();
                Task_Doc.Load(TempFilePath.ToString());
                ProcessActNode = Task_Doc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                ProcessActNode.InnerXml = str_TaskActivities;

                xp_SortExpression = XPathExpression.Compile("ACTIVITY");
                xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Number);
                xp_SortNodeIter = ProcessActNode.CreateNavigator().Select(xp_SortExpression);
                while (xp_SortNodeIter.MoveNext())
                {
                    SortXML += xp_SortNodeIter.Current.OuterXml;
                }
                ProcessActNode.InnerXml = SortXML;
                File.WriteAllText(TempFilePath.ToString(), Task_Doc.OuterXml);

			    ActivityNode	 = Task_Doc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE='Task' and ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER/USERID='" + ALParamObj.UserID + "' and ACTIVITYID='" + StepID + "']");
                if (ActivityNode != null)
                {
                    TempFilePath.Remove(0, TempFilePath.Length);
                    StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID.ToString());
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        File.Delete(TempFilePath.ToString());
                    }
                    
                    //get the Sequence Number of The Activity for which response will be submitted.
                    // Add a check so that the next activity after this activity will have Contributors Selected
                    setActivityResponsePage(ActivityNode,true);                    
                    SetStepForm_InPostBack();
                    createNewStepForm();
                }
                
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
            
        }

            /// <summary>
        /// <Purpose>Set notifiy in advance check box value and value for no. of days for prior notification</Purpose>
        /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
        /// </summary>
        /// <param name="str_TaskXML">Task's details</param>
        private void SetAdvanceReminderValues(String str_TaskXML)
        {
            XElement xElt_TaskData          = null;
            XElement xElt_workflowProcess   = null;
            XElement xElt_value             = null;

            xElt_TaskData           = XElement.Load(XmlReader.Create(new StringReader(str_TaskXML)));
            xElt_workflowProcess    = xElt_TaskData.XPathSelectElement("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
            if (xElt_workflowProcess != null)
            {
                //Set check box condition
                xElt_value = xElt_workflowProcess.Element("NOTIFYINADVANCE");
                if (xElt_value != null)
                {
                    if (xElt_value.Value == "1")
                    {
                        checkBoxObj.Checked = true;
                    }
                    else
                    {
                        checkBoxObj.Checked = false;
                    }
                }
                checkBoxObj.Enabled = false;                    

                //Set text box value for no. of days for prior notification                
                xElt_value = xElt_workflowProcess.Element("NOTIFYNOOFDAYS");
                if (xElt_value != null)
                {
                    if (!String.IsNullOrEmpty(xElt_value.Value))
                    {
                        textBoxObj.Text = xElt_value.Value;
                    }
                    else
                    {
                        textBoxObj.Text = "1";
                    }
                }                    
                textBoxObj.Enabled  = false;                
            }
        }        

        /// <alsummary>
        /// <createddate>04 April 2012</createddate>
        /// <author>Mr. Hemant Karkande</author>
        /// <purpose>Set the Task Readers User/Group list control.</purpose>
        /// </alsummary>
        private void setTaskReadersUserGroupList(XPathNavigator xpathNav_ProcessReadersGroup, XPathNavigator xpathNav_ProcessReadersUser)
        {
            ListFacade      obj_ListFacade      = null;
            String          str_ListConfig      = null;
            String          str_SearchInputXml  = null;
            String          str_ListSourceXml   = null;
            StringBuilder   sb_SelectedUsers    = null;
            MWB_Helper      obj_MWBHelperFacade = null; 

            obj_ListFacade = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
            obj_MWBHelperFacade = new  MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language); 
            
            str_ListConfig = obj_ListFacade.GetConfigurationXML(SolutionName, null, "ROProcessReaders");
            
            //Prepare Selected Users input xml.
            sb_SelectedUsers = new StringBuilder(150);
            sb_SelectedUsers.Append("<UserSelectionXML><SelectedUsersList>");
            if (xpathNav_ProcessReadersUser != null)
            {
                sb_SelectedUsers.Append(xpathNav_ProcessReadersUser.InnerXml);
            }
            sb_SelectedUsers.Append("</SelectedUsersList></UserSelectionXML>");

            //Prepare Selected Group Input xml.
            sb_SelectedUsers.Remove(0, sb_SelectedUsers.Length);
            sb_SelectedUsers.Append("<GroupSelectionXML><SelectedGroupsList>");
            if (xpathNav_ProcessReadersGroup != null)
            {
                sb_SelectedUsers.Append(xpathNav_ProcessReadersGroup.InnerXml);
            }
            sb_SelectedUsers.Append("</SelectedGroupsList></GroupSelectionXML>");

            str_SearchInputXml = obj_MWBHelperFacade.PrepareUserGroupListSearchXml(xpathNav_ProcessReadersGroup, xpathNav_ProcessReadersUser);
            obj_ListFacade.PrepareListXml(str_ListConfig, str_SearchInputXml, out str_ListSourceXml);
            LC_TaskReaders.Source = str_ListSourceXml;
        }

        #region Commented Code
        //Hemant Karkande : Do Not Delete this commented code
        //private void PaintPredecessorList(XML TaskXML)
        //{
        //    ERRORXML                    ErrorXMLString          = null;
        //    MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;
        //    ListFacade                  ListFacadeObj           = null;
        //    XmlDocument                 AssociationXMLDoc       = null;
        //    XmlDocument                 InputXMLDoc             = null; 
        //    XmlNode                     AssociationNode         = null;
        //    XmlNode                     Process_ActivityNode    = null;
        //    XmlNode                     Activity_InfoNode       = null;
        //    XmlNode                     SubFlowActivity         = null; 
        //    XmlNode                     Process_TransitionNode  = null;
        //    XmlNode                     FromActivityNode        = null;
        //    XmlNode                     ToActivityNode          = null;
        //    XmlNode                     WFProcessNode           = null; 
        //    XmlNode                     SearchXMLNode           = null; 
        //    XmlNode                     RDF_RelationShipNode    = null; 
        //    XmlAttribute                TypeAttribute           = null; 
        //    XML                         ReturnProjectXML        = null;
        //    XML                         PredecessorListXML      = null; 
        //    XML                         FinalListXML            = null; 
        //    XML                         ConfigXML               = null; 
        //    String                      ParentActivityID        = null; 
        //    String                      RDF_RelationshipName    = null; 
        //    String                      EncryptURL              = null; 
        //    StringBuilder               ParamURL                = null;
        //    StringBuilder               URL                     = null; 

        //    try
        //    {
        //        AssociationXMLDoc       = new XmlDocument();
        //        InputXMLDoc             = new XmlDocument();
        //        ParamURL                = new StringBuilder();
        //        URL                     = new StringBuilder();
        //        MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
        //        ListFacadeObj           = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        

        //        AssociationXMLDoc = null;
        //        AssociationXMLDoc = new XmlDocument();
        //        AssociationXMLDoc.LoadXml(TaskXML);

        //        WFProcessNode = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS");
        //        if ((WFProcessNode != null) && (WFProcessNode.HasChildNodes))
        //        {
        //            ParentActivityID = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/ACTIVITYID").InnerText;   
        //            //Now get the Predecessors for the current deliverable
        //            Process_ActivityNode = null;
        //            ErrorXMLString = GetPredecessors(WFProcessNode, ParentActivityID, ref Process_ActivityNode);
        //            if (ErrorXMLString != null)
        //            {
        //                //Error Getting Predecessors paint empty list
        //                ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                Lst_Predecessors.Source = PredecessorListXML;
        //            }
        //            else
        //            {
        //                if ((Process_ActivityNode != null) && (Process_ActivityNode.HasChildNodes))
        //                {
        //                    //Prepare Predecessor List.
        //                    SearchXMLNode = InputXMLDoc.CreateElement("SEARCHOUTPUTXML");
        //                    InputXMLDoc.AppendChild(SearchXMLNode);
        //                    SearchXMLNode.AppendChild(InputXMLDoc.ImportNode(Process_ActivityNode, true));
        //                    //Get the Configuration XML from ListConfigurationXML
        //                    //ListFacadeObj.AddParameter("ProjectID", ParentProjectID);
        //                    PackageDefinitionID = __PackageDefinitionID.Value;
        //                    ProcessDefinitionID = __ProcessDefinitionID.Value;
        //                    ListFacadeObj.AddParameter("PackageDefinitionID", PackageDefinitionID);
        //                    ListFacadeObj.AddParameter("ProcessDefinitionID", ProcessDefinitionID);
        //                    ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "PredecessorListForROTask");
        //                    if (ConfigXML != null)
        //                    {
        //                        ListFacadeObj.PrepareListXml(ConfigXML, InputXMLDoc.OuterXml, out PredecessorListXML);
        //                        if (PredecessorListXML != null)
        //                        {
        //                            //Get RDF relationship name
        //                            RDF_RelationShipNode = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/RDFRELATIONSHIPNAME");
        //                            if ((RDF_RelationShipNode != null) && (RDF_RelationShipNode.InnerText != ""))
        //                                RDF_RelationshipName = RDF_RelationShipNode.InnerText;
        //                            else
        //                                RDF_RelationshipName = "None";
        //                            __RDFRelationShipName.Value = RDF_RelationshipName;

        //                            //ParamURL.AppendFormat("Manage_DefineConditions.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionId={4}&ProcessDefinitionId={5}&ParentID={6}&TaskID={7}&RDFRelationshipName={8}&ToActivityID={9}&FromActivityID=", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID, ParentDeliverableID, TaskID, RDF_RelationshipName, ParentActivityID);
        //                            ParamURL.AppendFormat("Manage_DefineConditions.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&PackageDefinitionId={4}&ProcessDefinitionId={5}&ParentID=111&TaskID={6}&RDFRelationshipName={7}&ToActivityID={8}&FormMode=READONLY&FromActivityID=", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, PackageDefinitionID, ProcessDefinitionID, TaskID, RDF_RelationshipName, ParentActivityID);

        //                            MktgWorkBenchFacadeObj.InnsertConditionImages(PredecessorListXML, ParamURL.ToString(), out FinalListXML);
        //                            MktgWorkBenchFacadeObj.InsertPercentCompleteClass("DUEDATE", ref FinalListXML); 
        //                            Lst_Predecessors.Source = FinalListXML;
        //                        }
        //                        else
        //                        {
        //                            //There are no Predecessors paint empty list
        //                            ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                            Lst_Predecessors.Source = PredecessorListXML;
        //                        }
        //                    }
        //                }
        //                else
        //                {
        //                    //There are no Predecessors paint empty list
        //                    ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //                    Lst_Predecessors.Source = PredecessorListXML;
        //                }
        //            }
        //        }
        //        else
        //        {
        //            ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForROTask", ref PredecessorListXML);
        //            Lst_Predecessors.Source = PredecessorListXML;
        //        }
        //    }
        //    catch (Exception ExceptionObj)
        //    {
        //        throw(ExceptionObj);
        //    }
        //}

        //private ERRORXML GetPredecessors(XmlNode WFProcessNode, String ActIDForTask, ref XmlNode Predecessor_ActivityNode)
        //{
        //    ERRORXML                ErrorXMLString          = null;
        //    XmlDocument             ReturnXMLDoc            = null;
        //    XmlNode                 R_Process_ActivityNode  = null;
        //    XmlNode                 Process_ActivityNode    = null;
        //    XmlNode                 Process_TransitionNode  = null;
        //    XmlNode                 ActivityNode            = null; 
        //    XmlNode                 OperationNode           = null; 
        //    XmlNodeList             TransitionNodes         = null; 
        //    String                  PrdecessorID            = null; 

        //    try
        //    {
        //        ReturnXMLDoc = new XmlDocument();
        //        Predecessor_ActivityNode = ReturnXMLDoc.CreateElement("PROCESS_ACTIVITY");

        //        //Select Process Activities and Process Transition nodes
        //        Process_ActivityNode    = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY");
        //        Process_TransitionNode  = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");

        //        //Select Predecessors
        //        TransitionNodes = Process_TransitionNode.SelectNodes("TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID='" + ActIDForTask + "']");
        //        foreach (XmlNode Transition in TransitionNodes)
        //        {
        //            OperationNode = Transition.Attributes.GetNamedItem("Operation");
        //            if ((OperationNode != null) && (OperationNode.InnerText.ToUpper() != "DELETED"))
        //            {
        //                PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
        //                ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
        //                if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE") 
        //                    Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
        //            }
        //            else if (OperationNode == null)
        //            {
        //                PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
        //                ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
        //                if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE") 
        //                    Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
        //            }
        //        }
        //        return ErrorXMLString;
        //    }
        //    catch (Exception ExceptionObj)
        //    {
        //        throw(ExceptionObj);
        //    }
        //}
        #endregion
        #endregion
    }
}