
/*	Prashant Darade		April 30, 2012 08:54 AM	*/

CREATE PROCEDURE LOAD_PLANNER_DATA_TO_ODS_SP (@MOM_DB_NAME NVARCHAR(75))
AS
	SET NOCOUNT ON

	DECLARE @ODS_DB_NAME NVARCHAR(75),@FISCAL_MONTH NVARCHAR(2), @DB_NAME NVARCHAR(75)
	
	SELECT  @FISCAL_MONTH = CONFIGVALUE  FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'FISCALMONTH'

	SELECT @ODS_DB_NAME = @MOM_DB_NAME+'_ODS'
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSPLANDETAILS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMARKETINGACTIVITY')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSINVOICE')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSINVOICELINEITEMS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOMMITMENT')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOMMITMENTLINEITEMS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSLLMARKETINGACTIVITY')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMADISTRIBUTIONCHANNEL')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMAOBJECTIVES')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMATARGETSEGMENTS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSPLANOBJECTIVES')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMAPRODUCTINFO')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSBUSINESSUNIT')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOSTCENTERALLOCATION')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALOM_ODSNAMEDHIERARCHY')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'BU_HIERARCHY')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'MA_HIERARCHY')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALOM_RELATIONSHIPTYPES')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTACTUALS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTIMATES')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTLINEITEM')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTWORKFLOW')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSRATECARD')
		
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_BUDGETS_BY_BU')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_CHANNEL_COSTCATEGORY')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_CHANNEL_BUDGETSNACT')
	
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCLAIM')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCLAIM_DA')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSLABEL_CLAIM')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSLABEL_CLAIM_DA')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_RESCAT_ANALYSIS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_REQALLOC_ANALYSIS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_ALLOCATION')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_SUBMISSIONDETAILS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_SPACESKUDETAILS')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_DP_SKL_SKUDETAILS')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSFORECASTINFO')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_TIMESHEETS')
	
	
	
	
	DELETE  FROM ALOM_ASSEMBLY 
	WHERE  
	ALOM_ASSEMBLY.ASSEMBLYID <> (SELECT MIN(A2.ASSEMBLYID) FROM ALOM_ASSEMBLY A2
					WHERE 
					A2.CONTAINERID = ALOM_ASSEMBLY.CONTAINERID AND A2.CONTAINSID = ALOM_ASSEMBLY.CONTAINSID
					AND A2.RELATIONSHIPTYPEID = ALOM_ASSEMBLY.RELATIONSHIPTYPEID
					GROUP BY A2.RELATIONSHIPTYPEID,A2.CONTAINERID,A2.CONTAINSID
					HAVING COUNT(*) > 1)
	
	DELETE  FROM ALOM_ASSOENTITYFACET 
	WHERE  
	ALOM_ASSOENTITYFACET.ASSOCIATIONID <> (SELECT MIN(ASF2.ASSOCIATIONID) FROM ALOM_ASSOENTITYFACET ASF2
					WHERE 
					ASF2.ENTITYID = ALOM_ASSOENTITYFACET.ENTITYID AND ASF2.FACETID = ALOM_ASSOENTITYFACET.FACETID
					AND ASF2.RELATIONSHIPTYPEID = ALOM_ASSOENTITYFACET.RELATIONSHIPTYPEID
					GROUP BY ASF2.RELATIONSHIPTYPEID,ASF2.ENTITYID,ASF2.FACETID
					HAVING COUNT(*) > 1)
				

	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSBUSINESSUNIT
	(BU_ID,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,BU_LEVEL5_ID,
	BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	BU_NAME,BU_DESCRIPTION,BU_REGION,BU_CURRENCY,BU_CREATEDONDATE,QBU_CREATEDONDATE,
	BU_LASTUPDATEDON,QBU_LASTUPDATEDONDATE,BU_LEVEL_NO,BU_PATH,BU_IS_OBSOLETE)
	SELECT 	BU.BUSINESSUNITID AS BUSINESSUNITID,
	0	AS BU_LEVEL1_ID,0	AS BU_LEVEL2_ID,
	0	AS BU_LEVEL3_ID,0	AS BU_LEVEL4_ID,
	0	AS BU_LEVEL5_ID,''''	AS BU_LEVEL1_NAME,
	''''	AS BU_LEVEL2_NAME,''''	AS BU_LEVEL3_NAME,
	''''	AS BU_LEVEL4_NAME,''''	AS BU_LEVEL5_NAME,
	BU.NAME  AS BUSINESSUNITNAME,
	BU.DESCRIPTION  AS BUDESCRIPTION,BU.REGION BUSINESSUNITREGION,
	BU.CURRENCYTYPE  AS BUCURRENCYTYPE,
	BU.CREATEDON  AS BUCREATEDON,
	dbo.ODSGetQuarterOfDate(BU.CREATEDON, '+@FISCAL_MONTH+') AS QBUCREATEDONDATE,
	BU.LASTUPDATEDON  AS BULASTUPDATEDON,
	dbo.ODSGetQuarterOfDate(BU.LASTUPDATEDON, '+@FISCAL_MONTH+')  AS QBULASTUPDATEDONDATE,
	BU.BUSINESSUNITLEVEL  AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BUSINESSUNITPATH, BU.ISOBSOLETE  AS BU_IS_OBSOLETE
	FROM  ALENT_BUSINESSUNIT BU ')

	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSPLANDETAILS
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,
	BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	BU_ID,BU_NAME,BU_DESCRIPTION,BU_REGION,BU_CURRENCY,BU_CREATEDONDATE,QBU_CREATEDONDATE,
	BU_LASTUPDATEDONDATE,QBU_LASTUPDATEDONDATE,BU_LEVEL_NO,BU_PATH,PLAN_DESCRIPTION,
	PLAN_FROMDATE,QPLAN_FROMDATE,PLAN_TODATE,QPLAN_TODATE,PLAN_STATUS,PLAN_CURRENTVERSION,
	PLAN_VERSIONO,PLAN_CURRENCY,PLAN_CREATEDONDATE,QPLAN_CREATEDONDATE,PLAN_LASTUPDATEDONDATE,
	QPLAN_LASTUPDATEDONDATE,P_FS_ID,P_BUDGETEDCURRENCY,P_BUDGETED_AMOUNT,P_PLANNED_CURRENCY,
	P_PLANNED_AMOUNT,P_COMMITTED_CURRENCY,P_COMMITTED_AMOUNT,P_SPENT_CURRENCY,P_SPENT_AMOUNT,
	P_AVAILABLE_CURRENCY,P_AVAILABLE_AMOUNT,P_UNALLOCATED_CURRENCY,P_UNALLOCATED_AMOUNT,
	P_LASTUPDATEDONDATE,QP_LASTUPDATEDONDATE,P_ALLOCATEDTOSPEND_CURRENCY,P_ALLOCATEDTOSPEND_AMOUNT,
	P_ACTUALS_CURRENCY,P_ACTUALS_AMOUNT,P_ALLOCTOSPENDROLLUP_CURRENCY,P_ALLOCTOSPENDROLLUP_AMOUNT,
	P_COMMITTEDROLLUP_CURRENCY,P_COMMITTEDROLLUP_AMOUNT,P_SPENTROLLUP_CURRENCY,P_SPENTROLLUP_AMOUNT,
	P_ACTUALSROLLUP_CURRENCY,P_ACTUALSROLLUP_AMOUNT,P_AVAILABLEROLLUP_CURRENCY,P_AVAILABLEROLLUP_AMOUNT,P_FSDESCRIPTION)
	SELECT
	PLANDETAILS.PLANID AS PLAN_ID,
	PLANDETAILS.TITLE  AS PLAN_TITLE,
	PLANDETAILS.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
	0	AS BU_LEVEL2_ID,
	0	AS BU_LEVEL3_ID,
	0	AS BU_LEVEL4_ID,
	0	AS BU_LEVEL5_ID,
	''''	AS BU_LEVEL1_NAME,
	''''	AS BU_LEVEL2_NAME,
	''''	AS BU_LEVEL3_NAME,
	''''	AS BU_LEVEL4_NAME,
	''''	AS BU_LEVEL5_NAME,
	BU.BUSINESSUNITID AS BU_ID,
	BU."NAME"  AS BU_NAME,
	BU.DESCRIPTION  AS BU_DESCRIPTION,
	BU.REGION  AS BU_REGION,
	BU.CURRENCYTYPE   AS BU_CURRENCY,
	BU.CREATEDON    AS BU_CREATEDONDATE,
	dbo.ODSGetQuarterOfDate(BU.CREATEDON, '+@FISCAL_MONTH+') AS QBU_CREATEDONDATE,
	BU.LASTUPDATEDON  AS BU_LASTUPDATEDONDATE,
	dbo.ODSGetQuarterOfDate(BU.LASTUPDATEDON, '+@FISCAL_MONTH+')  AS QBU_LASTUPDATEDONDATE,
	BU.BUSINESSUNITLEVEL   AS BU_LEVEL,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END   AS BU_PATH,
	PLANDETAILS.DESCRIPTION  AS PLAN_DESCRIPTION,
	PLANDETAILS.FROMDATE   AS PLAN_FROMDATE,
	dbo.ODSGetQuarterOfDate(PLANDETAILS.FROMDATE, '+@FISCAL_MONTH+') AS QPLAN_FROMDATE,
	PLANDETAILS.TODATE   AS PLAN_TODATE,
	dbo.ODSGetQuarterOfDate(PLANDETAILS.TODATE, '+@FISCAL_MONTH+') AS QPLAN_TODATE,
	PLANDETAILS."STATUS"   AS PLAN_STATUS,
	PLANDETAILS.CURRENTVERSION   AS PLAN_CURRENTVERSION,
	PLANDETAILS.VERSIONNUMBER  AS PLAN_VERSIONO,
	PLANDETAILS.CURRENCYTYPE   AS PLAN_CURRENCY,
	PLANDETAILS.CREATEDON   AS  PLAN_CREATEDONDATE,
	dbo.ODSGetQuarterOfDate(PLANDETAILS.CREATEDON, '+@FISCAL_MONTH+') AS QPLAN_CREATEDONDATE,
	PLANDETAILS.LASTUPDATEDON  AS PLAN_LASTUPDATEDONDATE,
	dbo.ODSGetQuarterOfDate(PLANDETAILS.LASTUPDATEDON, '+@FISCAL_MONTH+') AS QPLAN_LASTUPDATEDONDATE,
	PLANFS.FINANCIALSUMMARYID  AS P_FS_ID,
	PLANFS.BUDGETED_C  AS P_BUDGETEDCURRENCY,
	PLANFS.BUDGETED_A  AS P_BUDGETED_AMOUNT,
	PLANFS.PLANNED_C  AS  P_PLANNED_CURRENCY,
	PLANFS.PLANNED_A  AS  P_PLANNED_AMOUNT,
	PLANFS.COMMITTED_C   AS P_COMMITTED_CURRENCY,
	PLANFS.COMMITTED_A   AS P_COMMITTED_AMOUNT,
	PLANFS.SPENT_C  AS P_SPENT_CURRENCY,
	PLANFS.SPENT_A  AS P_SPENT_AMOUNT,
	PLANFS.AVAILABLE_C  AS P_AVAILABLE_CURRENCY,
	PLANFS.AVAILABLE_A  AS P_AVAILABLE_AMOUNT,
	PLANFS.UNALLOCATED_C  AS P_UNALLOCATED_CURRENCY,
	PLANFS.UNALLOCATED_A  AS P_UNALLOCATED_AMOUNT,
	PLANFS.LASTUPDATEDON  AS P_LASTUPDATEDONDATE,
	dbo.ODSGetQuarterOfDate(PLANFS.LASTUPDATEDON, '+@FISCAL_MONTH+')  AS QP_LASTUPDATEDONDATE,
	PLANFS.ALLOCATEDTOSPEND_C   AS P_ALLOCATEDTOSPEND_CURRENCY,
	PLANFS.ALLOCATEDTOSPEND_A   AS P_ALLOCATEDTOSPEND_AMOUNT,
	PLANFS.ACTUALS_C  AS P_ACTUALS_CURRENCY,
	PLANFS.ACTUALS_A  AS P_ACTUALS_AMOUNT,
	PLANFS.ALLOCATEDTOSPENDROLLUP_C  ,
	PLANFS.ALLOCATEDTOSPENDROLLUP_A  ,
	PLANFS.COMMITTEDROLLUP_C  AS P_COMMITTEDROLLUP_CURRENCY,
	PLANFS.COMMITTEDROLLUP_A  AS P_COMMITTEDROLLUP_AMOUNT,
	PLANFS.SPENTROLLUP_C   AS P_SPENTROLLUP_CURRENCY,
	PLANFS.SPENTROLLUP_A   AS P_SPENTROLLUP_AMOUNT,
	PLANFS.ACTUALSROLLUP_C  AS P_ACTUALSROLLUP_CURRENCY,
	PLANFS.ACTUALSROLLUP_A  AS P_ACTUALSROLLUP_AMOUNT,
	PLANFS.AVAILABLEROLLUP_C  AS P_AVAILABLEROLLUP_CURRENCY,
	PLANFS.AVAILABLEROLLUP_A  AS P_AVAILABLEROLLUP_AMOUNT,
	PLANFS.DESCRIPTION  AS P_FSDESCRIPTION
	FROM 
	ALENT_PLAN PLANDETAILS 
	INNER JOIN ALOM_ASSEMBLY A0 ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLANDETAILS.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID
	INNER JOIN ALOM_ASSOENTITYFACET AEF1 ON AEF1.RELATIONSHIPTYPEID = 43297593141162 AND AEF1.ENTITYID = PLANDETAILS.PLANID
	INNER JOIN ALFCT_FINANCIALSUMMARY PLANFS ON AEF1.FACETID = PLANFS.FINANCIALSUMMARYID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMARKETINGACTIVITY
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,BU_LEVEL5_ID,
	BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,MA_LEVEL1_NUMBER,
	MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,MA_LEVEL1_NAME,MA_LEVEL2_NAME,
	MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,
	MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,PARENT_MA_ID,PARENT_MA_LEVEL,MA_ID,MA_NAME,
	MA_DESCRIPTION,MA_TYPE,MA_STATUS,MA_PLANNEDSTARTDATE,QMA_PLANNEDSTARTDATE,MA_PLANNEDENDDATE,
	QMA_PLANNEDENDDATE,MA_ACTUALSTARTDATE,QMA_ACTUALSTARTDATE,MA_ACTUALENDDATE,QMA_ACTUALENDDATE,
	MA_LEVEL_NO,MA_NUMBER,MA_CURRENCY,MA_BUDGETAPPROVED,MA_CREATEDONDATE,QMA_CREATEDONDATE,MA_LASTUPDATEDONDATE,
	QMA_LASTUPDATEDONDATE,MA_BUDGETINITIATEDONDATE,QMA_BUDGETINITIATEDONDATE,MA_STATUSBEFOREREVIEW,
	MA_PATH,MA_BUDGETAPPROVEDONDATE,QMA_BUDGETAPPROVEDONDATE,MA_FS_ID,MA_BUDGETED_CURRENCY,MA_BUDGETED_AMOUNT,
	MA_PLANNED_CURRENCY,MA_PLANNED_AMOUNT,MA_COMMITTED_CURRENCY,MA_COMMITTED_AMOUNT,MA_SPENT_CURRENCY,
	MA_SPENT_AMOUNT,MA_AVAILABLE_CURRENCY,MA_AVAILABLE_AMOUNT,MA_UNALLOCATED_CURRENCY,MA_UNALLOCATED_AMOUNT,
	MA_FS_LASTUPDATEDONDATE,QMA_FS_LASTUPDATEDONDATE,MA_ALLOCATEDTOSPEND_CURRENCY,MA_ALLOCATEDTOSPEND_AMOUNT,
	MA_ACTUALS_CURRENCY,MA_ACTUALS_AMOUNT,MA_ALLOCTOSPENDROLLUP_CURR,MA_ALLOCTOSPENDROLLUP_AMOUNT,
	MA_COMMITTEDROLLUP_CURRENCY,MA_COMMITTEDROLLUP_AMOUNT,MA_SPENTROLLUP_CURRENCY,MA_SPENTROLLUP_AMOUNT,
	MA_ACTUALSROLLUP_CURRENCY,MA_ACTUALSROLLUP_AMOUNT,MA_AVAILABLEROLLUP_CURRENCY,MA_AVAILABLEROLLUP_AMOUNT,
	MA_FS_DESCRIPTION)
	SELECT
		PLANDETAILS.PLANID	AS PLANID,
		PLANDETAILS.TITLE   AS PLAN_TITLE,
		PLANDETAILS.FISCALYEAR   AS FISCALYEAR,
		0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
		BU.BUSINESSUNITID	AS BU_ID,
		BU.NAME			AS BU_NAME,
		BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
		CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
		CAST(NULL AS BIGINT) AS PARENT_MA_ID, 
		1 AS PARENT_MA_LEVEL, 
		CHILDMA.MARKETINGACTIVITYID AS MA_ID,
		CHILDMA.NAME   AS MA_NAME,
		CHILDMA.DESCRIPTION  AS MA_DESCRIPTION,
		CHILDMA.ACTIVITYTYPE  AS MA_TYPE,
		CHILDMA.STATUS  AS MA_STATUS,
		CHILDMA.PLANNEDSTARTDATE  AS MA_PLANNEDSTARTDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.PLANNEDSTARTDATE, '+@FISCAL_MONTH+')  AS QMA_PLANNEDSTARTDATE,
		CHILDMA.PLANNEDENDDATE   AS MA_PLANNEDENDDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.PLANNEDENDDATE, '+@FISCAL_MONTH+')   AS QMA_PLANNEDENDDATE,
		CHILDMA.ACTUALSTARTDATE  AS MA_ACTUALSTARTDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.ACTUALSTARTDATE, '+@FISCAL_MONTH+')  AS QMA_ACTUALSTARTDATE,
		CHILDMA.ACTUALENDDATE   AS MA_ACTUALENDDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.ACTUALENDDATE, '+@FISCAL_MONTH+')   AS QMA_ACTUALENDDATE,
		CHILDMA.ACTIVITYLEVEL  AS MA_LEVEL_NO,
		CHILDMA.ACTIVITYNUMBER  AS MA_NUMBER,
		CHILDMA.CURRENCYTYPE  AS  MA_CURRENCY,
		CHILDMA.BUDGETAPPROVED  AS MA_BUDGETAPPROVED,
		CHILDMA.CREATEDON  AS MA_CREATEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.CREATEDON, '+@FISCAL_MONTH+')  AS QMA_CREATEDONDATE,
		CHILDMA.LASTUPDATEDON   AS MA_LASTUPDATEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.LASTUPDATEDON, '+@FISCAL_MONTH+')   AS QMA_LASTUPDATEDONDATE,
		CHILDMA.BUDGETINITIATEDON   AS MA_BUDGETINITIATEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.BUDGETINITIATEDON, '+@FISCAL_MONTH+')   AS QMA_BUDGETINITIATEDONDATE,
		CHILDMA.STATUSBEFOREREVIEW  AS MA_STATUSBEFOREREVIEW,
		CASE WHEN CHARINDEX(''$ALP$'',CHILDMA.ACTIVITYPATH) > 0 THEN REPLACE(CHILDMA.ACTIVITYPATH,''$ALP$'','' >> '') ELSE  CHILDMA.ACTIVITYPATH END AS MA_PATH,
		CHILDMA.BUDGETAPPROVEDON  AS  MA_BUDGETAPPROVEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.BUDGETAPPROVEDON, '+@FISCAL_MONTH+')  AS  QMA_BUDGETAPPROVEDONDATE,
		MAFINANCIALSUMMARY.FINANCIALSUMMARYID  AS MA_FS_ID,
		MAFINANCIALSUMMARY.BUDGETED_C  AS MA_BUDGETED_CURRENCY,
		MAFINANCIALSUMMARY.BUDGETED_A  AS MA_BUDGETED_AMOUNT,
		MAFINANCIALSUMMARY.PLANNED_C  AS  MA_PLANNED_CURRENCY,
		MAFINANCIALSUMMARY.PLANNED_A  AS  MA_PLANNED_AMOUNT,
		MAFINANCIALSUMMARY.COMMITTED_C   AS MA_COMMITTED_CURRENCY,
		MAFINANCIALSUMMARY.COMMITTED_A   AS MA_COMMITTED_AMOUNT,
		MAFINANCIALSUMMARY.SPENT_C  AS MA_SPENT_CURRENCY,
		MAFINANCIALSUMMARY.SPENT_A  AS MA_SPENT_AMOUNT,
		MAFINANCIALSUMMARY.AVAILABLE_C  AS MA_AVAILABLE_CURRENCY,
		MAFINANCIALSUMMARY.AVAILABLE_A  AS MA_AVAILABLEY_AMOUNT,
		MAFINANCIALSUMMARY.UNALLOCATED_C  AS MA_UNALLOCATED_CURRENCY,
		MAFINANCIALSUMMARY.UNALLOCATED_A  AS MA_UNALLOCATED_AMOUNT,
		MAFINANCIALSUMMARY.LASTUPDATEDON  AS MA_FS_LASTUPDATEDONDATE,
		dbo.ODSGetQuarterOfDate(MAFINANCIALSUMMARY.LASTUPDATEDON, '+@FISCAL_MONTH+')  AS QMA_FS_LASTUPDATEDONDATE,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPEND_C   AS MA_ALLOCATEDTOSPEND_CURRENCY,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPEND_A   AS MA_ALLOCATEDTOSPEND_AMOUNT,
		MAFINANCIALSUMMARY.ACTUALS_C  AS MA_ACTUALS_CURRENCY,
		MAFINANCIALSUMMARY.ACTUALS_A  AS MA_ACTUALS_AMOUNT,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPENDROLLUP_C  ,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPENDROLLUP_A  ,
		MAFINANCIALSUMMARY.COMMITTEDROLLUP_C  AS MA_COMMITTEDROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.COMMITTEDROLLUP_A  AS MA_COMMITTEDROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.SPENTROLLUP_C   AS MA_SPENTROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.SPENTROLLUP_A   AS MA_SPENTROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.ACTUALSROLLUP_C  AS MA_ACTUALSROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.ACTUALSROLLUP_A  AS MA_ACTUALSROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.AVAILABLEROLLUP_C  AS MA_AVAILABLEROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.AVAILABLEROLLUP_A  AS MA_AVAILABLEROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.DESCRIPTION  AS MA_FS_DESCRIPTION
	FROM 
	ALENT_PLAN PLANDETAILS 
	INNER JOIN ALOM_ASSEMBLY A0 ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLANDETAILS.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID
	INNER JOIN ALOM_ASSOENTITYFACET AEF1 ON AEF1.RELATIONSHIPTYPEID = 43297593141162 AND AEF1.ENTITYID = PLANDETAILS.PLANID
	INNER JOIN ALFCT_FINANCIALSUMMARY PLANFS ON AEF1.FACETID = PLANFS.FINANCIALSUMMARYID
	INNER JOIN ALOM_ASSEMBLY A ON A.RELATIONSHIPTYPEID = 38934607864244 AND A.CONTAINERID = PLANDETAILS.PLANID
	INNER JOIN ALENT_MARKETINGACTIVITY CHILDMA ON A.CONTAINSID = CHILDMA.MARKETINGACTIVITYID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2 ON AEF2.RELATIONSHIPTYPEID = 92717298333215 AND AEF2.ENTITYID = CHILDMA.MARKETINGACTIVITYID 
	LEFT OUTER JOIN ALFCT_FINANCIALSUMMARY MAFINANCIALSUMMARY ON AEF2.FACETID = MAFINANCIALSUMMARY.FINANCIALSUMMARYID
	UNION
	SELECT
		PLANDETAILS.PLANID	AS PLANID,
		PLANDETAILS.TITLE   AS PLAN_TITLE,
		PLANDETAILS.FISCALYEAR   AS FISCALYEAR,
		0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
		BU.BUSINESSUNITID	AS BU_ID,
		BU.NAME			AS BU_NAME,
		BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
		CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
		PARENTMA.MARKETINGACTIVITYID PARENT_MA_ID, 
		PARENTMA.ACTIVITYLEVEL PARENT_MA_LEVEL, 
		CHILDMA.MARKETINGACTIVITYID AS MA_ID,
		CHILDMA.NAME   AS MA_NAME,
		CHILDMA.DESCRIPTION  AS MA_DESCRIPTION,
		CHILDMA.ACTIVITYTYPE  AS MA_TYPE,
		CHILDMA.STATUS  AS MA_STATUS,
		CHILDMA.PLANNEDSTARTDATE  AS MA_PLANNEDSTARTDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.PLANNEDSTARTDATE, '+@FISCAL_MONTH+') AS QMA_PLANNEDSTARTDATE,
		CHILDMA.PLANNEDENDDATE   AS MA_PLANNEDENDDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.PLANNEDENDDATE, '+@FISCAL_MONTH+') AS QMA_PLANNEDENDDATE,
		CHILDMA.ACTUALSTARTDATE  AS MA_ACTUALSTARTDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.ACTUALSTARTDATE, '+@FISCAL_MONTH+') AS QMA_ACTUALSTARTDATE,
		CHILDMA.ACTUALENDDATE   AS MA_ACTUALENDDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.ACTUALENDDATE, '+@FISCAL_MONTH+') AS QMA_ACTUALENDDATE,
		CHILDMA.ACTIVITYLEVEL  AS MA_LEVEL_NO,
		CHILDMA.ACTIVITYNUMBER  AS MA_NUMBER,
		CHILDMA.CURRENCYTYPE  AS  MA_CURRENCYTYPE,
		CHILDMA.BUDGETAPPROVED  AS MA_BUDGETAPPROVED,
		CHILDMA.CREATEDON  AS MA_CREATEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.CREATEDON, '+@FISCAL_MONTH+') AS QMA_CREATEDONDATE,
		CHILDMA.LASTUPDATEDON   AS MA_LASTUPDATEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.LASTUPDATEDON, '+@FISCAL_MONTH+') AS QMA_LASTUPDATEDONDATE,
		CHILDMA.BUDGETINITIATEDON   AS MA_BUDGETINITIATEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.BUDGETINITIATEDON, '+@FISCAL_MONTH+') AS QMA_BUDGETINITIATEDONDATE,
		CHILDMA.STATUSBEFOREREVIEW  AS MA_STATUSBEFOREREVIEW,
		CASE WHEN CHARINDEX(''$ALP$'',CHILDMA.ACTIVITYPATH) > 0 THEN REPLACE(CHILDMA.ACTIVITYPATH,''$ALP$'','' >> '') ELSE  CHILDMA.ACTIVITYPATH END   AS MA_PATH,
		CHILDMA.BUDGETAPPROVEDON  AS  MA_BUDGETAPPROVEDONDATE,
		dbo.ODSGetQuarterOfDate(CHILDMA.BUDGETAPPROVEDON, '+@FISCAL_MONTH+') AS QMA_BUDGETAPPROVEDONDATE,
		MAFINANCIALSUMMARY.FINANCIALSUMMARYID  AS MA_FS_ID,
		MAFINANCIALSUMMARY.BUDGETED_C  AS MA_BUDGETED_CURRENCY,
		MAFINANCIALSUMMARY.BUDGETED_A  AS MA_BUDGETED_AMOUNT,
		MAFINANCIALSUMMARY.PLANNED_C  AS  MA_PLANNED_CURRENCY,
		MAFINANCIALSUMMARY.PLANNED_A  AS  MA_PLANNED_AMOUNT,
		MAFINANCIALSUMMARY.COMMITTED_C   AS MA_COMMITTED_CURRENCY,
		MAFINANCIALSUMMARY.COMMITTED_A   AS MA_COMMITTED_AMOUNT,
		MAFINANCIALSUMMARY.SPENT_C  AS MA_SPENT_CURRENCY,
		MAFINANCIALSUMMARY.SPENT_A  AS MA_SPENT_AMOUNT,
		MAFINANCIALSUMMARY.AVAILABLE_C  AS MA_AVAILABLE_CURRENCY,
		MAFINANCIALSUMMARY.AVAILABLE_A  AS MA_AVAILABLE_AMOUNT,
		MAFINANCIALSUMMARY.UNALLOCATED_C  AS MA_UNALLOCATED_CURRENCY,
		MAFINANCIALSUMMARY.UNALLOCATED_A  AS MA_UNALLOCATED_AMOUNT,
		MAFINANCIALSUMMARY.LASTUPDATEDON  AS MA_FS_LASTUPDATEDONDATE,
		dbo.ODSGetQuarterOfDate(MAFINANCIALSUMMARY.LASTUPDATEDON, '+@FISCAL_MONTH+') AS QMA_FS_LASTUPDATEDONDATE,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPEND_C   AS MA_ALLOCATEDTOSPEND_CURRENCY,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPEND_A   AS MA_ALLOCATEDTOSPEND_AMOUNT,
		MAFINANCIALSUMMARY.ACTUALS_C  AS MA_ACTUALS_CURRENCY,
		MAFINANCIALSUMMARY.ACTUALS_A  AS MA_ACTUALS_AMOUNT,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPENDROLLUP_C  ,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPENDROLLUP_A  ,
		MAFINANCIALSUMMARY.COMMITTEDROLLUP_C  AS MA_COMMITTEDROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.COMMITTEDROLLUP_A  AS MA_COMMITTEDROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.SPENTROLLUP_C   AS MA_SPENTROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.SPENTROLLUP_A   AS MA_SPENTROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.ACTUALSROLLUP_C  AS MA_ACTUALSROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.ACTUALSROLLUP_A  AS MA_ACTUALSROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.AVAILABLEROLLUP_C  AS MA_AVAILABLEROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.AVAILABLEROLLUP_A  AS MA_AVAILABLEROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.DESCRIPTION  AS MA_FS_DESCRIPTION
	FROM
	ALENT_PLAN PLANDETAILS 
	INNER JOIN ALOM_ASSEMBLY A0 ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLANDETAILS.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID
	INNER JOIN ALOM_ASSOENTITYFACET AEF1 ON AEF1.RELATIONSHIPTYPEID = 43297593141162 AND AEF1.ENTITYID = PLANDETAILS.PLANID
	INNER JOIN ALFCT_FINANCIALSUMMARY PLANFS ON AEF1.FACETID = PLANFS.FINANCIALSUMMARYID

	INNER JOIN ALOM_ASSEMBLY A ON A.RELATIONSHIPTYPEID = 198303327217807 AND A.CONTAINERID = PLANDETAILS.PLANID
	INNER JOIN ALENT_MARKETINGACTIVITY CHILDMA ON A.CONTAINSID = CHILDMA.MARKETINGACTIVITYID

	INNER JOIN ALOM_ASSEMBLY A1 ON A1.RELATIONSHIPTYPEID = 56942662476619 AND A1.CONTAINSID = CHILDMA.MARKETINGACTIVITYID
	INNER JOIN ALENT_MARKETINGACTIVITY PARENTMA ON A1.CONTAINERID = PARENTMA.MARKETINGACTIVITYID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2 ON AEF2.RELATIONSHIPTYPEID = 92717298333215 AND 
		AEF2.ENTITYID = CHILDMA.MARKETINGACTIVITYID
	LEFT OUTER JOIN ALFCT_FINANCIALSUMMARY MAFINANCIALSUMMARY ON AEF2.FACETID = MAFINANCIALSUMMARY.FINANCIALSUMMARYID ')


	EXEC ('  INSERT INTO   '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSLLMARKETINGACTIVITY
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,BU_LEVEL5_ID,
	BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,MA_LEVEL1_NUMBER,
	MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,MA_LEVEL1_NAME,MA_LEVEL2_NAME,
	MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,
	MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,PARENT_MA_ID,PARENT_MA_LEVEL,LL_MA_ID,LL_MA_NAME,
	LL_MA_DESCRIPTION,LL_MA_TYPE,LL_MA_STATUS,LL_MA_PLANNEDSTARTDATE,LL_QMA_PLANNEDSTARTDATE,LL_MA_PLANNEDENDDATE,
	LL_QMA_PLANNEDENDDATE,LL_MA_ACTUALSTARTDATE,LL_QMA_ACTUALSTARTDATE,LL_MA_ACTUALENDDATE,LL_QMA_ACTUALENDDATE,
	LL_MA_LEVEL_NO,LL_MA_NUMBER,LL_MA_CURRENCYTYPE,LL_MA_BUDGETAPPROVED,LL_MA_CREATEDONDATE,LL_QMA_CREATEDONDATE,
	LL_MA_LASTUPDATEDONDATE,LL_QMA_LASTUPDATEDONDATE,LL_MA_BUDGETINITIATEDONDATE,LL_QMA_BUDGETINITIATEDONDATE,
	LL_MA_STATUSBEFOREREVIEW,LL_MA_PATH,LL_MA_BUDGETAPPROVEDONDATE,LL_QMA_BUDGETAPPROVEDONDATE,LL_MA_FS_ID,
	LL_MA_BUDGETED_CURRENCY,LL_MA_BUDGETED_AMOUNT,LL_MA_PLANNED_CURRENCY,LL_MA_PLANNED_AMOUNT,LL_MA_COMMITTED_CURRENCY,
	LL_MA_COMMITTED_AMOUNT,LL_MA_SPENT_CURRENCY,LL_MA_SPENT_AMOUNT,LL_MA_AVAILABLE_CURRENCY,LL_MA_AVAILABLE_AMOUNT,
	LL_MA_UNALLOCATED_CURRENCY,LL_MA_UNALLOCATED_AMOUNT,LL_MA_FS_LASTUPDATEDONDATE,LL_QMA_FS_LASTUPDATEDONDATE,
	LL_MA_ALLOCTOSPEND_CURRENCY,LL_MA_ALLOCATEDTOSPEND_AMOUNT,LL_MA_ACTUALS_CURRENCY,LL_MA_ACTUALS_AMOUNT,
	LL_MA_ALLOCTOSPENDROLLUP_CURR,LL_MA_ALLOCTOSPENDROLLUP_AMT,LL_MA_COMMITTEDROLLUP_CURRENCY,
	LL_MA_COMMITTEDROLLUP_AMOUNT,LL_MA_SPENTROLLUP_CURRENCY,LL_MA_SPENTROLLUP_AMOUNT,LL_MA_ACTUALSROLLUP_CURRENCY,
	LL_MA_ACTUALSROLLUP_AMOUNT,LL_MA_AVAILABLEROLLUP_CURRENCY,LL_MA_AVAILABLEROLLUP_AMOUNT,LL_MA_FS_DESCRIPTION)
	SELECT	
		PLAN1.PLANID AS PLANID,
		PLAN1.TITLE  AS PLAN_TITLE,
		PLAN1.FISCALYEAR   AS FISCALYEAR,
		0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
		BU.BUSINESSUNITID	AS BU_ID,
		BU.NAME			AS BU_NAME,
		BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
		CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
		PARENT_MA.MARKETINGACTIVITYID AS PARENT_MA_ID, 
		PARENT_MA.ACTIVITYLEVEL AS PARENT_MA_LEVEL, 
		MA.MARKETINGACTIVITYID AS LL_MA_ID,
		MA.NAME   AS LL_MA_NAME,
		MA.DESCRIPTION  AS LL_MA_DESCRIPTION,
		CASE WHEN CHARINDEX(''$ALP$'',MA.ACTIVITYTYPE) > 0 THEN REPLACE(MA.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA.ACTIVITYTYPE END AS LL_MA_TYPE,
		MA.STATUS  AS LL_MA_STATUS,
		MA.PLANNEDSTARTDATE  AS LL_MA_PLANNEDSTARTDATE,
		dbo.ODSGetQuarterOfDate(MA.PLANNEDSTARTDATE, '+@FISCAL_MONTH+') AS LL_QMA_PLANNEDSTARTDATE,
		MA.PLANNEDENDDATE   AS LL_MA_PLANNEDENDDATE,
		dbo.ODSGetQuarterOfDate(MA.PLANNEDENDDATE, '+@FISCAL_MONTH+') AS LL_QMA_PLANNEDENDDATE,
		MA.ACTUALSTARTDATE  AS LL_MA_ACTUALSTARTDATE,
		dbo.ODSGetQuarterOfDate(MA.ACTUALSTARTDATE, '+@FISCAL_MONTH+') AS LL_QMA_ACTUALSTARTDATE,
		MA.ACTUALENDDATE   AS LL_MA_ACTUALENDDATE,
		dbo.ODSGetQuarterOfDate(MA.ACTUALENDDATE, '+@FISCAL_MONTH+') AS LL_QMA_ACTUALENDDATE,
		MA.ACTIVITYLEVEL  AS LL_MA_LEVEL_NO,
		MA.ACTIVITYNUMBER  AS LL_MA_NUMBER,
		MA.CURRENCYTYPE  AS  LL_MA_CURRENCYTYPE,
		MA.BUDGETAPPROVED  AS LL_MA_BUDGETAPPROVED,
		MA.CREATEDON  AS LL_MA_CREATEDONDATE,
		dbo.ODSGetQuarterOfDate(MA.CREATEDON, '+@FISCAL_MONTH+') AS LL_QMA_CREATEDONDATE,
		MA.LASTUPDATEDON   AS LL_MA_LASTUPDATEDONDATE,
		dbo.ODSGetQuarterOfDate(MA.LASTUPDATEDON, '+@FISCAL_MONTH+') AS LL_QMA_LASTUPDATEDONDATE,
		MA.BUDGETINITIATEDON   AS LL_MA_BUDGETINITIATEDONDATE,
		dbo.ODSGetQuarterOfDate(MA.BUDGETINITIATEDON, '+@FISCAL_MONTH+') AS LL_QMA_BUDGETINITIATEDONDATE,
		MA.STATUSBEFOREREVIEW  AS LL_MA_STATUSBEFOREREVIEW,
		CASE WHEN CHARINDEX(''$ALP$'',MA.ACTIVITYPATH) > 0 THEN REPLACE(MA.ACTIVITYPATH,''$ALP$'','' >> '') ELSE  MA.ACTIVITYPATH END   AS LL_MA_PATH,
		MA.BUDGETAPPROVEDON  AS  LL_MA_BUDGETAPPROVEDONDATE,
		dbo.ODSGetQuarterOfDate(MA.BUDGETAPPROVEDON, '+@FISCAL_MONTH+') AS LL_QMA_BUDGETAPPROVEDONDATE,
		MAFINANCIALSUMMARY.FINANCIALSUMMARYID  AS LL_MA_FS_ID,
		MAFINANCIALSUMMARY.BUDGETED_C  AS LL_MA_BUDGETED_CURRENCY,
		MAFINANCIALSUMMARY.BUDGETED_A  AS LL_MA_BUDGETED_AMOUNT,
		MAFINANCIALSUMMARY.PLANNED_C  AS  LL_MA_PLANNED_CURRENCY,
		MAFINANCIALSUMMARY.PLANNED_A  AS  LL_MA_PLANNED_AMOUNT,
		MAFINANCIALSUMMARY.COMMITTED_C   AS LL_MA_COMMITTED_CURRENCY,
		MAFINANCIALSUMMARY.COMMITTED_A   AS LL_MA_COMMITTED_AMOUNT,
		MAFINANCIALSUMMARY.SPENT_C  AS LL_MA_SPENT_CURRENCY,
		MAFINANCIALSUMMARY.SPENT_A  AS LL_MA_SPENT_AMOUNT,
		MAFINANCIALSUMMARY.AVAILABLE_C  AS LL_MA_AVAILABLE_CURRENCY,
		MAFINANCIALSUMMARY.AVAILABLE_A  AS LL_MA_AVAILABLE_AMOUNT,
		MAFINANCIALSUMMARY.UNALLOCATED_C  AS LL_MA_UNALLOCATED_CURRENCY,
		MAFINANCIALSUMMARY.UNALLOCATED_A  AS LL_MA_UNALLOCATED_AMOUNT,
		MAFINANCIALSUMMARY.LASTUPDATEDON  AS LL_MA_FS_LASTUPDATEDONDATE,
		dbo.ODSGetQuarterOfDate(MAFINANCIALSUMMARY.LASTUPDATEDON, '+@FISCAL_MONTH+') AS LL_QMA_FS_LASTUPDATEDONDATE,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPEND_C   ,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPEND_A   AS LL_MA_ALLOCATEDTOSPEND_AMOUNT,
		MAFINANCIALSUMMARY.ACTUALS_C  AS LL_MA_ACTUALS_CURRENCY,
		MAFINANCIALSUMMARY.ACTUALS_A  AS LL_MA_ACTUALS_AMOUNT,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPENDROLLUP_C  ,
		MAFINANCIALSUMMARY.ALLOCATEDTOSPENDROLLUP_A  ,
		MAFINANCIALSUMMARY.COMMITTEDROLLUP_C  AS LL_MA_COMMITTEDROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.COMMITTEDROLLUP_A  AS LL_MA_COMMITTEDROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.SPENTROLLUP_C   AS LL_MA_SPENTROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.SPENTROLLUP_A   AS LL_MA_SPENTROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.ACTUALSROLLUP_C  AS LL_MA_ACTUALSROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.ACTUALSROLLUP_A  AS LL_MA_ACTUALSROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.AVAILABLEROLLUP_C  AS LL_MA_AVAILABLEROLLUP_CURRENCY,
		MAFINANCIALSUMMARY.AVAILABLEROLLUP_A  AS LL_MA_AVAILABLEROLLUP_AMOUNT,
		MAFINANCIALSUMMARY.DESCRIPTION  AS LL_MA_FS_DESCRIPTION
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU
	ON A0.CONTAINSID = BU.BUSINESSUNITID
	INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 198303327217807 AND A1.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_MARKETINGACTIVITY MA 
	ON A1.CONTAINSID = MA.MARKETINGACTIVITYID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2 ON AEF2.RELATIONSHIPTYPEID = 92717298333215 AND 
		AEF2.ENTITYID = MA.MARKETINGACTIVITYID
	LEFT OUTER JOIN ALFCT_FINANCIALSUMMARY MAFINANCIALSUMMARY ON AEF2.FACETID = MAFINANCIALSUMMARY.FINANCIALSUMMARYID
	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 56942662476619 AND A2.CONTAINSID = MA.MARKETINGACTIVITYID
	INNER JOIN ALENT_MARKETINGACTIVITY PARENT_MA
	ON A2.CONTAINERID = PARENT_MA.MARKETINGACTIVITYID
	WHERE MA.BUDGETAPPROVED = 1 ')


	EXEC (' INSERT INTO   '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSINVOICELINEITEMS
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,
	BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,
	MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
	MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,
	INV_ID,MA_ID,MA_NUMBER,MA_TYPE,MA_LEVEL_NO,COSTCATEGORYID,COSTCATEGORY_NAME,COSTCATEGORY_NO,
	COSTCATEGORY_DESCRIPTION,COSTCATEGORY_ISOBSOLETE,LI_ID,LI_DESCRIPTION,LI_RATE_CURRENCY,LI_RATE_AMOUNT,LI_CURRENCY,
	LI_AMOUNT,LI_QUANTITY,LI_SEQUENCEORDER,FA_NAME,FA_NUMBER,VENDORSID,VENDORNAME,VENDORDESCRIPTION,
	VENDORTYPE,VENDORURL)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	INVOICE1.INVOICEID	AS INV_ID,
	MA1.MARKETINGACTIVITYID	AS MA_ID,
	MA1.ACTIVITYNUMBER	AS MA_ACTIVITYNUMBER,
	--
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL	AS MA_LEVEL_NO,
	CC.COSTCATEGORYID	AS COSTCATEGORYID,
	CASE WHEN CHARINDEX(''_'',CC.NAME) > 0 THEN SUBSTRING(CC.NAME,CHARINDEX(''_'',CC.NAME)+1,LEN(CC.NAME)-CHARINDEX(''_'',CC.NAME))
	WHEN CHARINDEX(''-'',CC.NAME) > 0 THEN LTRIM(SUBSTRING(CC.NAME,CHARINDEX(''-'',CC.NAME)+1,LEN(CC.NAME)-CHARINDEX(''-'',CC.NAME)))
	ELSE CC.NAME END	AS COSTCATEGORY_NAME,
	CC.COSTCATEGORYNUMBER	AS COSTCATEGORY_NO,
	CC.DESCRIPTION	AS COSTCATEGORY_DESCRIPTION,
	CC.ISOBSOLETE  AS COSTCATEGORY_ISOBSOLETE,
	LINEITEMS1.LINEITEMSID	AS LI_ID,
	LINEITEMS1.DESCRIPTION	AS LI_DESCRIPTION,
	LINEITEMS1.RATE_C	AS LI_RATE_CURRENCY,
	LINEITEMS1.RATE_A	AS LI_RATE_AMOUNT,
	LINEITEMS1.ITEMAMOUNT_C	AS  LI_CURRENCY,
	LINEITEMS1.ITEMAMOUNT_A	AS LI_AMOUNT,
	LINEITEMS1.QUANTITY	AS LI_QUANTITY,
	LINEITEMS1.SEQUENCEORDER	AS LI_SEQUENCEORDER,
	FA.NAME		AS FA_NAME,
	FA.FINANCIALACCOUNTNUMBER	AS	FA_NUMBER,
	VENDORS1.VENDORSID	AS VENDORSID,
	VENDORS1.NAME	AS VENDORNAME,
	VENDORS1.DESCRIPTION	AS VENDORDESCRIPTION,
	VENDORS1.VENDORTYPE	AS VENDORTYPE,
	VENDORS1.URL	AS VENDORURL
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID

	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A2.CONTAINSID = MA1.MARKETINGACTIVITYID

	INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID IN (258169431586434,54043127184334) AND A1.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_INVOICE INVOICE1
	ON A1.CONTAINSID = INVOICE1.INVOICEID

	INNER JOIN ALOM_ASSEMBLY A4 
	ON A4.RELATIONSHIPTYPEID = 120841619528864 AND A4.CONTAINERID = INVOICE1.INVOICEID
	INNER JOIN ALENT_VENDORS VENDORS1
	ON A4.CONTAINSID = VENDORS1.VENDORSID

	INNER JOIN ALOM_ASSOENTITYFACET AEF1
	ON AEF1.RELATIONSHIPTYPEID = 175658777878214 AND AEF1.ENTITYID = INVOICE1.INVOICEID
	INNER JOIN ALFCT_LINEITEMS LINEITEMS1
	ON AEF1.FACETID = LINEITEMS1.LINEITEMSID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2
	ON AEF2.RELATIONSHIPTYPEID = 155952577195191 AND AEF2.FACETID = LINEITEMS1.LINEITEMSID
	LEFT OUTER JOIN ALENT_COSTCATEGORY CC
	ON AEF2.ENTITYID = CC.COSTCATEGORYID

	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 241217859337743 AND A3.CONTAINERID = CC.COSTCATEGORYID
	LEFT OUTER JOIN ALENT_FINANCIALACCOUNT FA
	ON A3.CONTAINSID = FA.FINANCIALACCOUNTID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSINVOICE
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,
	BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,
	MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
	MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,
	MA_ID,MA_NUMBER,MA_TYPE,MA_LEVEL_NO,COMM_ID,INV_ID,INV_NUMBER,INV_TITLE,INV_DESCRIPTION,
	INV_CURRENCY,INV_STATUS,INV_PAIDAMOUNT_CURRENCY,INV_PAIDAMOUNT_AMOUNT,INV_RECONCILEDAMOUNT_CURRENCY,
	INV_RECONCILEDAMOUNT_AMOUNT,INV_NOTES,INV_CREATEDONDATE,Q_INV_CREATEDONDATE,INV_RECEIVEDONDATE,
	Q_INV_RECEIVEDONDATE,INV_DUEONDATE,Q_INV_DUEONDATE,INV_PAIDONDATE,Q_INV_PAIDONDATE,INV_RECONCILEDONDATE,
	Q_INV_RECONCILEDONDATE,INV_LASTUPDATEDONDATE,Q_INV_LASTUPDATEDONDATE,VENDORSID,VENDORNAME,
	VENDORDESCRIPTION,VENDORTYPE,VENDORURL)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	--
	MA1.MARKETINGACTIVITYID AS MA_ID,
	MA1.ACTIVITYNUMBER AS MA_NUMBER,
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL	AS MA_LEVEL_NO,
	NULL	AS COMM_ID,
	--
	INVOICE1.INVOICEID	AS  INV_ID,
	INVOICE1.INVOICENUMBER	AS  INV_NUMBER,
	INVOICE1.TITLE	AS  INV_TITLE,
	INVOICE1.DESCRIPTION	AS  INV_DESCRIPTION,
	INVOICE1.CURRENCYTYPE	AS  INV_CURRENCY,
	INVOICE1.STATUS	AS  INV_STATUS,
	INVOICE1.PAIDAMOUNT_C	AS  INV_PAIDAMOUNT_CURRENCY,
	INVOICE1.PAIDAMOUNT_A	AS  INV_PAIDAMOUNT_AMOUNT,
	INVOICE1.RECONCILEDAMOUNT_C	AS  INV_RECONCILEDAMOUNT_CURRENCY,
	INVOICE1.RECONCILEDAMOUNT_A	AS  INV_RECONCILEDAMOUNT_AMOUNT,
	INVOICE1.NOTES	AS  INV_NOTES,
	INVOICE1.INVOICECREATEDON	AS  INV_CREATEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICECREATEDON, '+@FISCAL_MONTH+') AS Q_INV_CREATEDONDATE,
	INVOICE1.INVOICERECEIVEDON	AS  INV_RECEIVEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICERECEIVEDON, '+@FISCAL_MONTH+') AS Q_INV_RECEIVEDONDATE,
	INVOICE1.INVOICEDUEON	AS  INV_DUEONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICEDUEON, '+@FISCAL_MONTH+') AS Q_INV_DUEONDATE,
	INVOICE1.INVOICEPAIDON	AS  INV_PAIDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICEPAIDON, '+@FISCAL_MONTH+') AS Q_INV_PAIDONDATE,
	INVOICE1.INVOICERECONCILEDON AS  INV_RECONCILEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICERECONCILEDON, '+@FISCAL_MONTH+') AS Q_INV_RECONCILEDONDATE,
	INVOICE1.LASTUPDATEDON	AS  INV_LASTUPDATEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.LASTUPDATEDON, '+@FISCAL_MONTH+') AS Q_INV_LASTUPDATEDONDATE,
	VENDORS1.VENDORSID	AS VENDORSID,
	VENDORS1.NAME	AS VENDORNAME,
	VENDORS1.DESCRIPTION	AS VENDORDESCRIPTION,
	VENDORS1.VENDORTYPE	AS VENDORTYPE,
	VENDORS1.URL	AS VENDORURL
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID

	INNER JOIN ALOM_ASSEMBLY A1
	ON A1.CONTAINERID = PLAN1.PLANID AND A1.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A1.CONTAINSID = MA1.MARKETINGACTIVITYID

	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 258169431586434 AND A2.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_INVOICE INVOICE1
	ON A2.CONTAINSID = INVOICE1.INVOICEID

	INNER JOIN ALOM_ASSEMBLY A3 
	ON A3.RELATIONSHIPTYPEID = 120841619528864 AND A3.CONTAINERID = INVOICE1.INVOICEID
	INNER JOIN ALENT_VENDORS VENDORS1
	ON A3.CONTAINSID = VENDORS1.VENDORSID
	UNION
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	MA1.MARKETINGACTIVITYID AS MA_ID,
	MA1.ACTIVITYNUMBER AS MA_NUMBER,
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL  AS MA_LEVEL_NO,
	COMMIT1.COMMITMENTID	AS COMM_ID,
	--
	INVOICE1.INVOICEID	AS INV_ID,
	INVOICE1.INVOICENUMBER	AS INV_NUMBER,
	INVOICE1.TITLE	AS INV_TITLE,
	INVOICE1.DESCRIPTION	AS INV_DESCRIPTION,
	INVOICE1.CURRENCYTYPE	AS INV_CURRENCY,
	INVOICE1.STATUS	AS INV_STATUS,
	INVOICE1.PAIDAMOUNT_C	AS INV_PAIDAMOUNT_CURRENCY,
	INVOICE1.PAIDAMOUNT_A	AS INV_PAIDAMOUNT_AMOUNT,
	INVOICE1.RECONCILEDAMOUNT_C	AS INV_RECONCILEDAMOUNT_CURRENCY,
	INVOICE1.RECONCILEDAMOUNT_A	AS INV_RECONCILEDAMOUNT_AMOUNT,
	INVOICE1.NOTES	AS INV_NOTES,
	INVOICE1.INVOICECREATEDON	AS INV_CREATEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICECREATEDON, '+@FISCAL_MONTH+') AS Q_INV_CREATEDONDATE,
	INVOICE1.INVOICERECEIVEDON	AS INV_RECEIVEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICERECEIVEDON, '+@FISCAL_MONTH+') AS Q_INV_RECEIVEDONDATE,
	INVOICE1.INVOICEDUEON	AS INV_DUEONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICEDUEON, '+@FISCAL_MONTH+') AS Q_INV_DUEONDATE,
	INVOICE1.INVOICEPAIDON	AS INV_PAIDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICEPAIDON, '+@FISCAL_MONTH+') AS Q_INV_PAIDONDATE,
	INVOICE1.INVOICERECONCILEDON AS INV_RECONCILEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.INVOICERECONCILEDON, '+@FISCAL_MONTH+') AS Q_INV_RECONCILEDONDATE,
	INVOICE1.LASTUPDATEDON	AS INV_LASTUPDATEDONDATE,
	dbo.ODSGetQuarterOfDate(INVOICE1.LASTUPDATEDON, '+@FISCAL_MONTH+') AS Q_INV_LASTUPDATEDONDATE,
	VENDORS1.VENDORSID	AS VENDORID,
	VENDORS1.NAME	AS VENDORNAME,
	VENDORS1.DESCRIPTION	AS VENDORDESCRIPTION,
	VENDORS1.VENDORTYPE	AS VENDORTYPE,
	VENDORS1.URL	AS VENDORURL
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID

	INNER JOIN ALOM_ASSEMBLY A1
	ON A1.CONTAINERID = PLAN1.PLANID AND A1.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A1.CONTAINSID = MA1.MARKETINGACTIVITYID

	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 125025473564370 AND A2.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_COMMITMENT COMMIT1
	ON A2.CONTAINSID = COMMIT1.COMMITMENTID

	INNER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 107998402773333 AND A3.CONTAINERID = COMMIT1.COMMITMENTID
	INNER JOIN ALENT_INVOICE INVOICE1
	ON A3.CONTAINSID = INVOICE1.INVOICEID

	INNER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 120841619528864 AND A4.CONTAINERID = INVOICE1.INVOICEID
	INNER JOIN ALENT_VENDORS VENDORS1
	ON A4.CONTAINSID = VENDORS1.VENDORSID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOMMITMENT
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,
	BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,
	MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
	MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,
	MA_ID,MA_NUMBER,MA_TYPE,MA_LEVEL_NO,VENDORSID,VENDORNAME,VENDORDESCRIPTION,VENDORTYPE,VENDORURL,
	COMM_ID,COMM_NUMBER,COMM_TITLE,COMM_DESCRIPTION,COMM_CURRENCYTYPE,COMM_AMOUNT_CURRENCY,
	COMM_AMOUNT,COMM_STATUS,COMM_CREATEDON,QCOMMIT_CREATEDON,COMMITTEDON,QCOMMITTEDON,COMM_DUEON,
	QCOMMIT_DUEON,COMM_LASTUPDATEDON,QCOMMIT_LASTUPDATEDON,COMM_CLOSURENOTES,OS_COMM_AMOUNT_CURRENCY,
	OS_COMM_AMOUNT,COMM_CONTINUEDFLAG)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	--
	MA1.MARKETINGACTIVITYID	AS MA_ID,
	MA1.ACTIVITYNUMBER	AS MA_NUMBER,
	--
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL	AS MA_LEVEL_NO,
	--
	VENDORS1.VENDORSID	AS VENDORSID,
	VENDORS1.NAME	AS VENDORNAME,
	VENDORS1.DESCRIPTION  AS VENDORDESCRIPTION,
	VENDORS1.VENDORTYPE  AS VENDORTYPE,
	VENDORS1.URL  AS VENDORURL,
	COMMIT1.COMMITMENTID	AS  COMM_ID,
	COMMIT1.COMMITMENTNUMBER	AS  COMM_NUMBER,
	COMMIT1.TITLE	AS  COMM_TITLE,
	COMMIT1.DESCRIPTION	AS  COMM_DESCRIPTION,
	COMMIT1.CURRENCYTYPE	AS  COMM_CURRENCYTYPE,
	COMMIT1.INITIALCOMMITTEDAMOUNT_C	AS COMM_AMOUNT_CURRENCY,
	COMMIT1.INITIALCOMMITTEDAMOUNT_A	AS COMM_AMOUNT,
	COMMIT1.STATUS	AS  COMM_STATUS,
	COMMIT1.CREATEDON	AS  COMM_CREATEDON,
	dbo.ODSGetQuarterOfDate(COMMIT1.CREATEDON, '+@FISCAL_MONTH+') AS  QCOMMIT_CREATEDON,
	COMMIT1.COMMITTEDON	AS COMMITTEDON,
	dbo.ODSGetQuarterOfDate(COMMIT1.COMMITTEDON, '+@FISCAL_MONTH+') AS QCOMMITTEDON,
	COMMIT1.DUEON	AS  COMM_DUEON,
	dbo.ODSGetQuarterOfDate(COMMIT1.DUEON, '+@FISCAL_MONTH+') AS QCOMMIT_DUEON,
	COMMIT1.LASTUPDATEDON	AS  COMM_LASTUPDATEDON,
	dbo.ODSGetQuarterOfDate(COMMIT1.LASTUPDATEDON, '+@FISCAL_MONTH+') AS QCOMMIT_LASTUPDATEDON,
	COMMIT1.CLOSURENOTES	AS  COMM_CLOSURENOTES,
	COMMIT1.OUTSTANDINGCOMMITTEDAMOUNT_C	AS OS_COMM_AMOUNT_CURRENCY,
	COMMIT1.OUTSTANDINGCOMMITTEDAMOUNT_A	AS OS_COMM_AMOUNT,
	COMMIT1.CONTINUEDFLAG	AS  COMM_CONTINUEDFLAG
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID

	INNER JOIN ALOM_ASSEMBLY A1
	ON A1.CONTAINERID = PLAN1.PLANID AND A1.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A1.CONTAINSID = MA1.MARKETINGACTIVITYID

	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 125025473564370 AND A2.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_COMMITMENT COMMIT1
	ON A2.CONTAINSID = COMMIT1.COMMITMENTID

	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 108560141899931 AND A3.CONTAINERID = COMMIT1.COMMITMENTID
	LEFT OUTER JOIN ALENT_VENDORS VENDORS1
	ON A3.CONTAINSID = VENDORS1.VENDORSID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOMMITMENTLINEITEMS
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,BU_LEVEL5_ID,
	BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,MA_LEVEL1_NUMBER,
	MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,MA_LEVEL1_NAME,
	MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
	MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,
	BU_PATH,MA_ID,MA_NUMBER,MA_TYPE,MA_LEVEL_NO,COMM_ID,COSTCATEGORYID,COSTCATEGORY_NAME,
	COSTCATEGORY_DESCRIPTION,COSTCATEGORY_NO,COSTCATEGORY_ISOBSOLETE,LI_ID,LI_DESCRIPTION,LI_RATE_CURRENCY,
	LI_RATE_AMOUNT,LI_RATEUNITS,LI_QUANTITY,LI_AMOUNT_CURRENCY,LI_AMOUNT,LI_SEQUENCEORDER,
	FA_NAME,FA_NUMBER,VENDORSID,VENDORNAME,VENDORDESCRIPTION,VENDORTYPE,VENDORURL)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
		0	AS BU_LEVEL2_ID,
		0	AS BU_LEVEL3_ID,
		0	AS BU_LEVEL4_ID,
		0	AS BU_LEVEL5_ID,
		''''	AS BU_LEVEL1_NAME,
		''''	AS BU_LEVEL2_NAME,
		''''	AS BU_LEVEL3_NAME,
		''''	AS BU_LEVEL4_NAME,
		''''	AS BU_LEVEL5_NAME,
		0	AS MA_LEVEL1_NUMBER,
		0	AS MA_LEVEL2_NUMBER,
		0	AS MA_LEVEL3_NUMBER,
		0	AS MA_LEVEL4_NUMBER,
		0	AS MA_LEVEL5_NUMBER,
		''''	AS MA_LEVEL1_NAME,
		''''	AS MA_LEVEL2_NAME,
		''''	AS MA_LEVEL3_NAME,
		''''	AS MA_LEVEL4_NAME,
		''''	AS MA_LEVEL5_NAME,
		''''	AS MA_TYPE_LEVEL1_NAME,
		''''	AS MA_TYPE_LEVEL2_NAME,
		''''	AS MA_TYPE_LEVEL3_NAME,
		''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	MA1.MARKETINGACTIVITYID	AS MA_ID,
	MA1.ACTIVITYNUMBER	AS MA_NUMBER,
	--
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL	AS MA_LEVEL_NO,
	COMMIT1.COMMITMENTID	AS COMM_ID,
	CC.COSTCATEGORYID	AS COSTCATEGORYID,
	CASE WHEN CHARINDEX(''_'',CC.NAME) > 0 THEN SUBSTRING(CC.NAME,CHARINDEX(''_'',CC.NAME)+1,LEN(CC.NAME)-CHARINDEX(''_'',CC.NAME))
	WHEN CHARINDEX(''-'',CC.NAME) > 0 THEN LTRIM(SUBSTRING(CC.NAME,CHARINDEX(''-'',CC.NAME)+1,LEN(CC.NAME)-CHARINDEX(''-'',CC.NAME)))
	ELSE CC.NAME END	AS COSTCATEGORYNAME,
	CC.DESCRIPTION	AS COSTCATEGORYDESCRIPTION,
	CC.COSTCATEGORYNUMBER	AS COSTCATEGORYNUMBER,
	CC.ISOBSOLETE  AS COSTCATEGORY_ISOBSOLETE,
	LINEITEMS.LINEITEMSID	AS LI_ID,
	LINEITEMS.DESCRIPTION	AS LI_DESCRIPTION,
	LINEITEMS.RATE_C	AS LI_RATE_CURRENCY,
	LINEITEMS.RATE_A	AS LI_RATE_AMOUNT,
	LINEITEMS.RATEUNITS	AS LI_RATEUNITS,
	LINEITEMS.QUANTITY	AS LI_QUANTITY,
	LINEITEMS.ITEMAMOUNT_C	AS LI_AMOUNT_CURRENCY,
	LINEITEMS.ITEMAMOUNT_A	AS LI_AMOUNT,
	LINEITEMS.SEQUENCEORDER	AS LI_SEQUENCEORDER,
	FA.NAME		AS FA_NAME,
	FA.FINANCIALACCOUNTNUMBER	AS	FA_NUMBER,
	VENDORS1.VENDORSID	AS VENDORSID,
	VENDORS1.NAME	AS VENDORNAME,
	VENDORS1.DESCRIPTION	AS VENDORDESCRIPTION,
	VENDORS1.VENDORTYPE	AS VENDORTYPE,
	VENDORS1.URL	AS VENDORURL
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID

	INNER JOIN ALOM_ASSEMBLY A1
	ON A1.CONTAINERID = PLAN1.PLANID AND A1.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A1.CONTAINSID = MA1.MARKETINGACTIVITYID

	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 125025473564370 AND A2.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_COMMITMENT COMMIT1
	ON A2.CONTAINSID = COMMIT1.COMMITMENTID

	INNER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 25553974373469 AND ASF1.ENTITYID = COMMIT1.COMMITMENTID
	INNER JOIN ALFCT_LINEITEMS LINEITEMS
	ON ASF1.FACETID = LINEITEMS.LINEITEMSID

	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 108560141899931 AND A4.CONTAINERID = COMMIT1.COMMITMENTID
	LEFT OUTER JOIN ALENT_VENDORS VENDORS1
	ON A4.CONTAINSID = VENDORS1.VENDORSID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2
	ON AEF2.RELATIONSHIPTYPEID = 155952577195191 AND AEF2.FACETID = LINEITEMS.LINEITEMSID
	LEFT OUTER JOIN ALENT_COSTCATEGORY CC
	ON AEF2.ENTITYID = CC.COSTCATEGORYID

	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 241217859337743 AND A3.CONTAINERID = CC.COSTCATEGORYID
	LEFT OUTER JOIN ALENT_FINANCIALACCOUNT FA
	ON A3.CONTAINSID = FA.FINANCIALACCOUNTID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMADISTRIBUTIONCHANNEL
	(MA_ID,MA_NUMBER,DISTRIBUTIONCHANNELSID,DISTRIBUTIONCHANNELNAME,DISTRIBUTIONCHANNELDESCRIPTION)
	SELECT 
	MA.MARKETINGACTIVITYID AS MA_ID, 
	MA.ACTIVITYNUMBER AS MA_NUMBER,
	DC.DISTRIBUTIONCHANNELSID,
	DC.NAME DISTRIBUTIONCHANNELNAME,
	DC.DESCRIPTION  AS DISTRIBUTIONCHANNELDESCRIPTION
	FROM 
	ALENT_MARKETINGACTIVITY MA INNER JOIN ALOM_ASSOENTITYFACET AEF 
	ON AEF.RELATIONSHIPTYPEID = 12390788725169 AND AEF.ENTITYID = MA.MARKETINGACTIVITYID
	INNER JOIN ALFCT_DISTRIBUTIONCHANNELS DC 
	ON AEF.FACETID = DC.DISTRIBUTIONCHANNELSID ')

	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMAPRODUCTINFO
	(MA_ID,MA_NUMBER,PRODUCTINFORMATIONID,PRODUCTINFONAME,PRODUCTINFODESCRIPTION)
	SELECT MA.MARKETINGACTIVITYID AS MA_ID, 
	MA.ACTIVITYNUMBER AS MA_NUMBER,
	PINFO.PRODUCTINFORMATIONID,
	PINFO.NAME  AS PRODUCTINFONAME,
	PINFO.DESCRIPTION AS PRODUCTINFODESCRIPTION
	FROM 
	ALENT_MARKETINGACTIVITY MA INNER JOIN ALOM_ASSOENTITYFACET AEF 
	ON AEF.RELATIONSHIPTYPEID = 87243085828068 AND AEF.ENTITYID = MA.MARKETINGACTIVITYID
	INNER JOIN ALFCT_PRODUCTINFORMATION PINFO ON AEF.FACETID = PINFO.PRODUCTINFORMATIONID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOSTCENTERALLOCATION
	(PLANID,PLAN_TITLE,FISCALYEAR,MA_ID,MA_NAME,MA_NUMBER,MABUDGETALLOCATIONID,MACOSTCENTERNAME,
	MAALLOCATEDAMOUNT_CURRENCY,MABUDGETALLOCATED_AMOUNT,MAUNUTILISEDAMOUNT_CURRENCY,
	MAUNUTILISED_AMOUNT,BALASTUPDATEDON,QBALASTUPDATEDON)
	SELECT
		PLAN1.PLANID	AS PLANID,
		PLAN1.TITLE   AS PLAN_TITLE,
		PLAN1.FISCALYEAR   AS FISCALYEAR,
		0	AS MA_ID,
		CAST('''' AS NVARCHAR(256))	AS MA_NAME,
		CAST(''''  AS NVARCHAR(255))		AS MA_NUMBER,
		BA.BUDGETALLOCATIONID AS MABUDGETALLOCATIONID,
		BA.COSTCENTERNAME	AS MACOSTCENTERNAME,
		BA.ALLOCATEDAMOUNT_C ,
		BA.ALLOCATEDAMOUNT_A AS MABUDGETALLOCATED_AMOUNT,
		BA.UNUTILISEDAMOUNT_C ,
		BA.UNUTILISEDAMOUNT_A AS MAUNUTILISED_AMOUNT,
		BA.LASTUPDATEDON  AS BALASTUPDATEDON,
		dbo.ODSGetQuarterOfDate(BA.LASTUPDATEDON, '+@FISCAL_MONTH+') AS QBALASTUPDATEDON
	FROM
	ALENT_PLAN  PLAN1 INNER JOIN ALOM_ASSOENTITYFACET ASF3
	ON ASF3.RELATIONSHIPTYPEID = 149106294198097 AND ASF3.ENTITYID = PLAN1.PLANID
	INNER JOIN ALFCT_BUDGETALLOCATION BA
	ON ASF3.FACETID = BA.BUDGETALLOCATIONID
	UNION
	SELECT 
		0	AS PLANID,
		CAST('''' AS NVARCHAR(256))	AS PLAN_TITLE,
		CAST(''''  AS BIGINT)		AS FISCALYEAR,
		MA.MARKETINGACTIVITYID AS MA_ID,
		MA.NAME   AS MA_NAME,
		MA.ACTIVITYNUMBER  AS MA_NUMBER,
		BA.BUDGETALLOCATIONID AS MABUDGETALLOCATIONID,
		BA.COSTCENTERNAME	AS MACOSTCENTERNAME,
		BA.ALLOCATEDAMOUNT_C AS MAALLOCATEDAMOUNT_CURRENCYTYPE,
		BA.ALLOCATEDAMOUNT_A AS MABUDGETALLOCATEDAMOUNT,
		BA.UNUTILISEDAMOUNT_C AS MAUNUTILISEDAMOUNT_CURRENCYTYPE,
		BA.UNUTILISEDAMOUNT_A AS MAUNUTILISEDAMOUNT,
		BA.LASTUPDATEDON  AS BALASTUPDATEDON,
		dbo.ODSGetQuarterOfDate(BA.LASTUPDATEDON, '+@FISCAL_MONTH+') AS QBALASTUPDATEDON
	FROM
	ALENT_MARKETINGACTIVITY MA INNER JOIN ALOM_ASSOENTITYFACET ASF3
	ON ASF3.RELATIONSHIPTYPEID = 240469225016081 AND ASF3.ENTITYID = MA.MARKETINGACTIVITYID
	INNER JOIN ALFCT_BUDGETALLOCATION BA
	ON ASF3.FACETID = BA.BUDGETALLOCATIONID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMAOBJECTIVES
	(MA_ID,MA_NUMBER,OBJECTIVESID,OBJECTIVESDESCRIPTION,OBJECTIVESNAME)
	SELECT 
	MARKETINGACTIVITYID AS MA_ID, 
	MA.ACTIVITYNUMBER AS MA_NUMBER,
	O.OBJECTIVESID,O.DESCRIPTION AS OBJECTIVESDESCRIPTION,O.NAME OBJECTIVENAME
	FROM 
	ALENT_MARKETINGACTIVITY MA INNER JOIN ALOM_ASSOENTITYFACET AEF 
	ON AEF.RELATIONSHIPTYPEID = 82847119884827 AND AEF.ENTITYID = MA.MARKETINGACTIVITYID
	INNER JOIN ALFCT_OBJECTIVES O 
	ON AEF.FACETID = O.OBJECTIVESID ')


	EXEC ('  INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSPLANOBJECTIVES
	(PLANID,PLAN_TITLE,OBJECTIVESID,OBJECTIVESDESCRIPTION,OBJECTIVENAME)
	SELECT P.PLANID, P.TITLE AS PLAN_TITLE , O.OBJECTIVESID,O.DESCRIPTION AS OBJECTIVESDESCRIPTION, O.NAME
	FROM 
	ALENT_PLAN P INNER JOIN ALOM_ASSOENTITYFACET AEF 
	ON AEF.RELATIONSHIPTYPEID = 172068930634736 AND AEF.ENTITYID = P.PLANID
	INNER JOIN ALFCT_OBJECTIVES O 
	ON AEF.FACETID = O.OBJECTIVESID ')


	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSMATARGETSEGMENTS
	(MA_ID,MA_NUMBER,TARGETSEGMENTSID,TARGETSEGMENTSDESCRIPTION,TARGETSEGMENTNAME)
	SELECT 
	MARKETINGACTIVITYID AS MA_ID, 
	MA.ACTIVITYNUMBER AS MA_NUMBER,
	TS.TARGETSEGMENTSID,
	TS.DESCRIPTION AS TARGETSEGMENTSDESCRIPTION,
	TS.NAME TARGETSEGMENTNAME
	FROM 
	ALENT_MARKETINGACTIVITY MA INNER JOIN ALOM_ASSOENTITYFACET AEF 
	ON AEF.RELATIONSHIPTYPEID = 245362286781523 AND AEF.ENTITYID = MA.MARKETINGACTIVITYID
	INNER JOIN ALFCT_TARGETSEGMENTS TS ON AEF.FACETID = TS.TARGETSEGMENTSID ')

	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALOM_ODSNAMEDHIERARCHY
	(NAMEDHIERARCHYID,NAME,DESCRIPTION,PARENTID,NOOFCHILDREN,DEFAULTORDER,OBSOLETE,PATH,ISBUILTIN)
	SELECT NAMEDHIERARCHYID,NAME,DESCRIPTION,PARENTID,NOOFCHILDREN,DEFAULTORDER,OBSOLETE,PATH,ISBUILTIN 
	FROM ALOM_NAMEDHIERARCHY ')

	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'BU_HIERARCHY
	SELECT BU1.BUSINESSUNITID BU1_ID,BU1.NAME  BU1_NAME,
	BU2.BUSINESSUNITID BU2_ID,BU2.NAME BU2_NAME,
	BU3.BUSINESSUNITID BU3_ID,BU3.NAME BU3_NAME,
	BU4.BUSINESSUNITID BU4_ID,BU4.NAME BU4_NAME,
	BU5.BUSINESSUNITID BU5_ID,BU5.NAME BU5_NAME
	FROM
	ALENT_BUSINESSUNIT BU1 LEFT OUTER JOIN ALOM_ASSEMBLY A1
	ON BU1.BUSINESSUNITLEVEL = 0 AND A1.RELATIONSHIPTYPEID = 159996574572355 AND A1.CONTAINERID = BU1.BUSINESSUNITID
	LEFT OUTER JOIN ALENT_BUSINESSUNIT BU2
	ON A1.CONTAINSID = BU2.BUSINESSUNITID
	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 159996574572355 AND A2.CONTAINERID = BU2.BUSINESSUNITID
	LEFT OUTER JOIN ALENT_BUSINESSUNIT BU3
	ON A2.CONTAINSID = BU3.BUSINESSUNITID

	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 159996574572355 AND A3.CONTAINERID = BU3.BUSINESSUNITID
	LEFT OUTER JOIN ALENT_BUSINESSUNIT BU4
	ON A3.CONTAINSID = BU4.BUSINESSUNITID

	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 159996574572355 AND A4.CONTAINERID = BU4.BUSINESSUNITID
	LEFT OUTER JOIN ALENT_BUSINESSUNIT BU5
	ON A4.CONTAINSID = BU5.BUSINESSUNITID ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'MA_HIERARCHY
	SELECT MA1.MARKETINGACTIVITYID MAID_L1,MA1.NAME MANAME_L1,MA1.ACTIVITYNUMBER MA1_NUMBER,
	MA2.MARKETINGACTIVITYID MAID_L2,MA2.NAME MANAME_L2,MA2.ACTIVITYNUMBER MA2_NUMBER,
	MA3.MARKETINGACTIVITYID MAID_L3,MA3.NAME MANAME_L3,MA3.ACTIVITYNUMBER MA3_NUMBER,
	MA4.MARKETINGACTIVITYID MAID_L4,MA4.NAME MANAME_L4,MA4.ACTIVITYNUMBER MA4_NUMBER,
	MA5.MARKETINGACTIVITYID MAID_L5,MA5.NAME MANAME_L5,MA5.ACTIVITYNUMBER MA5_NUMBER
	FROM
	ALENT_PLAN PLAN1 LEFT OUTER JOIN ALOM_ASSEMBLY A1
	ON A1.CONTAINERID = PLAN1.PLANID AND A1.RELATIONSHIPTYPEID = 38934607864244
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A1.CONTAINSID = MA1.MARKETINGACTIVITYID
	LEFT OUTER join ALOM_ASSEMBLY A2
	ON MA1.MARKETINGACTIVITYID = A2.CONTAINERID AND A2.RELATIONSHIPTYPEID = 56942662476619
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA2
	ON A2.CONTAINSID = MA2.MARKETINGACTIVITYID
	LEFT OUTER join ALOM_ASSEMBLY A3
	ON MA2.MARKETINGACTIVITYID = A3.CONTAINERID AND A3.RELATIONSHIPTYPEID = 56942662476619
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA3
	ON A3.CONTAINSID = MA3.MARKETINGACTIVITYID
	LEFT OUTER join ALOM_ASSEMBLY A4
	ON MA3.MARKETINGACTIVITYID = A4.CONTAINERID AND A4.RELATIONSHIPTYPEID = 56942662476619
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA4
	ON A4.CONTAINSID = MA4.MARKETINGACTIVITYID
	LEFT OUTER join ALOM_ASSEMBLY A5
	ON MA4.MARKETINGACTIVITYID = A5.CONTAINERID AND A5.RELATIONSHIPTYPEID = 56942662476619
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA5
	ON A5.CONTAINSID = MA5.MARKETINGACTIVITYID ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALOM_RELATIONSHIPTYPES  
	(RELATIONSHIPTYPEID,CONTAINERTYPEID,CONTAINERTYPE,CONTAINSTYPEID,CONTAINSTYPE,RELATIONSHIPNAME,RELATIONSHIPTYPE,RELATIONSHIPDISPLAYNAME,ISSERIES,ISODS)
	SELECT  RELATIONSHIPTYPEID,CONTAINERTYPEID,CONTAINERTYPE,CONTAINSTYPEID,CONTAINSTYPE,RELATIONSHIPNAME,RELATIONSHIPTYPE,RELATIONSHIPDISPLAYNAME,ISSERIES,ISODS 
	FROM ALOM_RELATIONSHIPTYPES WHERE RELATIONSHIPNAME LIKE ''ODS_%''')
	
	/*  ODS ESTIMATE TABLES  */
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTIMATES  
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,
	BU_LEVEL4_ID,BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,
	BU_LEVEL4_NAME,BU_LEVEL5_NAME,MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,
	MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,
	MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,
	MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,MA_ID,MA_NUMBER,MA_TYPE,
	MA_LEVEL_NO,EST_ID,EST_TITLE,EST_STATUS,EST_NUMBER,EST_STARTDATE,EST_ENDDATE,EST_CURRENCYTYPE,
	EST_COST_C,EST_COST_A,EST_MODE,EST_CREATEDON,EST_LASTUPDATEDON,EST_QUANTITY,EST_PREVIOUSSTATUS,
	EST_CREATEDBY,VENDORID,VENDORNAME,VENDORDESCRIPTION,VENDORTYPE,VENDORISOBSOLETE,VENDORNUMBER,VENDORURL)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
	0	AS BU_LEVEL2_ID,
	0	AS BU_LEVEL3_ID,
	0	AS BU_LEVEL4_ID,
	0	AS BU_LEVEL5_ID,
	''''	AS BU_LEVEL1_NAME,
	''''	AS BU_LEVEL2_NAME,
	''''	AS BU_LEVEL3_NAME,
	''''	AS BU_LEVEL4_NAME,
	''''	AS BU_LEVEL5_NAME,
	0	AS MA_LEVEL1_NUMBER,
	0	AS MA_LEVEL2_NUMBER,
	0	AS MA_LEVEL3_NUMBER,
	0	AS MA_LEVEL4_NUMBER,
	0	AS MA_LEVEL5_NUMBER,
	''''	AS MA_LEVEL1_NAME,
	''''	AS MA_LEVEL2_NAME,
	''''	AS MA_LEVEL3_NAME,
	''''	AS MA_LEVEL4_NAME,
	''''	AS MA_LEVEL5_NAME,
	''''	AS MA_TYPE_LEVEL1_NAME,
	''''	AS MA_TYPE_LEVEL2_NAME,
	''''	AS MA_TYPE_LEVEL3_NAME,
	''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	MA1.MARKETINGACTIVITYID	AS MA_ID,
	MA1.ACTIVITYNUMBER	AS MA_NUMBER,
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL	AS MA_LEVEL_NO,
	EST.ESTIMATEID   AS  EST_ID,
	EST.TITLE   AS  EST_TITLE,
	EST.STATUS   AS  EST_STATUS,
	EST.ESTIMATENUMBER   AS  EST_NUMBER,
	EST.ESTIMATESTARTDATE   AS  EST_STARTDATE,
	EST.ESTIMATEENDDATE   AS  EST_ENDDATE,
	EST.CURRENCYTYPE   AS  EST_CURRENCYTYPE,
	EST.ESTIMATECOST_C   AS  EST_COST_C,
	EST.ESTIMATECOST_A   AS  EST_COST_A,
	EST.ESTIMATEMODE   AS  EST_MODE,
	EST.CREATEDON   AS  EST_CREATEDON,
	EST.LASTUPDATEDON   AS  EST_LASTUPDATEDON,
	EST.ESTIMATEQUANTITY   AS  EST_QUANTITY,
	EST.PREVIOUSSTATUS   AS  EST_PREVIOUSSTATUS,
	(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
		THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
		ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  EST_CREATEDBY,
	VENDORS.VENDORSID   AS  VENDORID,
	VENDORS.NAME   AS  VENDORNAME,
	VENDORS.DESCRIPTION   AS  VENDORDESCRIPTION,
	VENDORS.VENDORTYPE   AS  VENDORTYPE,
	VENDORS.ISOBSOLETE   AS  VENDORISOBSOLETE,
	VENDORS.VENDORNUMBER   AS  VENDORNUMBER,
	VENDORS.URL   AS  VENDORURL
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID
	
	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A2.CONTAINSID = MA1.MARKETINGACTIVITYID
	
	INNER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 164680007970996 AND A3.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_ESTIMATE EST
	ON A3.CONTAINSID = EST.ESTIMATEID
	
	INNER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 156752756800802 AND A5.CONTAINERID = EST.ESTIMATEID
	INNER JOIN ALENT_USER USER1
	ON A5.CONTAINSID = USER1.USERID
	
	INNER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 268753845302731 AND A4.CONTAINERID = EST.ESTIMATEID
	INNER JOIN ALENT_VENDORS VENDORS
	ON A4.CONTAINSID = VENDORS.VENDORSID ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTLINEITEM 
	(PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,BU_LEVEL4_ID,
	BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,
	MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
	MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,
	MA_ID,MA_NUMBER,MA_TYPE,MA_LEVEL_NO,EST_ID,EST_TITLE,EST_STATUS,EST_NUMBER,EST_STARTDATE,
	EST_ENDDATE,VENDORID,VENDORNAME,VENDORTYPE,VENDORNUMBER,WI_ID,WI_TITLE,WI_NUMBER,WI_COST_C,
	WI_COST_A,WI_CREATEDON,WI_LASTUPDATEDON,WI_QUANTITY,WI_ISLOCKED,WI_LOCKEDON,WI_LOCKEDSESSIONID,
	WI_INFOID,WI_CATEGORY,WI_STRATEGICVALUE,WI_TYPE,WI_NOTE,WLI_ID,WLI_RES_CAT_NAME,WLI_CATEGORYDESCRIPTION,
	WLI_UNITOFMEASUREMENT,WLI_MIN_VOLUME,WLI_MAX_VOLUME,WLI_RATE_C,WLI_RATE_A,WLI_QUANTITY,WLI_TOTALCOST_C,
	WLI_TOTALCOST_A,WLI_BILLINGTYPE,WLI_RES_CAT_PATH,WLI_RES_CAT_LEVEL1_NAME,WLI_RES_CAT_LEVEL2_NAME,
	WLI_RES_CAT_LEVEL3_NAME,WLI_RES_CAT_LEVEL4_NAME,WLI_RES_CAT_LEVEL5_NAME)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	0	AS BU_LEVEL1_ID,
	0	AS BU_LEVEL2_ID,
	0	AS BU_LEVEL3_ID,
	0	AS BU_LEVEL4_ID,
	0	AS BU_LEVEL5_ID,
	''''	AS BU_LEVEL1_NAME,
	''''	AS BU_LEVEL2_NAME,
	''''	AS BU_LEVEL3_NAME,
	''''	AS BU_LEVEL4_NAME,
	''''	AS BU_LEVEL5_NAME,
	0	AS MA_LEVEL1_NUMBER,
	0	AS MA_LEVEL2_NUMBER,
	0	AS MA_LEVEL3_NUMBER,
	0	AS MA_LEVEL4_NUMBER,
	0	AS MA_LEVEL5_NUMBER,
	''''	AS MA_LEVEL1_NAME,
	''''	AS MA_LEVEL2_NAME,
	''''	AS MA_LEVEL3_NAME,
	''''	AS MA_LEVEL4_NAME,
	''''	AS MA_LEVEL5_NAME,
	''''	AS MA_TYPE_LEVEL1_NAME,
	''''	AS MA_TYPE_LEVEL2_NAME,
	''''	AS MA_TYPE_LEVEL3_NAME,
	''''	AS MA_TYPE_LEVEL4_NAME,
	BU.BUSINESSUNITID	AS BU_ID,
	BU.NAME			AS BU_NAME,
	BU.BUSINESSUNITLEVEL    AS BU_LEVEL_NO,
	CASE WHEN CHARINDEX(''$'',BU.PATH) > 0 THEN REPLACE(BU.PATH,''$'','' >> '') ELSE BU.PATH END  AS BU_PATH,
	MA1.MARKETINGACTIVITYID	AS MA_ID,
	MA1.ACTIVITYNUMBER	AS MA_NUMBER,
	CASE WHEN CHARINDEX(''$ALP$'',MA1.ACTIVITYTYPE) > 0 THEN REPLACE(MA1.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA1.ACTIVITYTYPE END  AS MA_TYPE,
	MA1.ACTIVITYLEVEL	AS MA_LEVEL_NO,
	EST.ESTIMATEID   AS  EST_ID,
	EST.TITLE   AS  EST_TITLE,
	EST.STATUS   AS  EST_STATUS,
	EST.ESTIMATENUMBER   AS  EST_NUMBER,
	EST.ESTIMATESTARTDATE   AS  EST_STARTDATE,
	EST.ESTIMATEENDDATE   AS  EST_ENDDATE,
	VENDORS.VENDORSID   AS  VENDORID,
	VENDORS.NAME   AS  VENDORNAME,
	VENDORS.VENDORTYPE   AS  VENDORTYPE,
	VENDORS.VENDORNUMBER   AS  VENDORNUMBER,
	WI.WORKITEMID     AS  WI_ID,
	WI.TITLE     AS  WI_TITLE,
	WI.WORKITEMNUMBER     AS  WI_NUMBER,
	WI.WORKITEMCOST_C     AS  WI_COST_C,
	WI.WORKITEMCOST_A     AS  WI_COST_A,
	WI.CREATEDON     AS  WI_CREATEDON,
	WI.LASTUPDATEDON     AS  WI_LASTUPDATEDON,
	WI.WORKITEMQUANTITY     AS  WI_QUANTITY,
	WI.ISLOCKED     AS  WI_ISLOCKED,
	WI.LOCKEDON     AS  WI_LOCKEDON,
	WI.LOCKEDSESSIONID     AS  WI_LOCKEDSESSIONID,
	WII.WORKITEMINFOID     AS  WI_INFOID,
	WII.CATEGORY     AS  WI_CATEGORY,
	WII.STRATEGICVALUE     AS  WI_STRATEGICVALUE,
	WII.WORKITEMTYPE     AS  WI_TYPE,
	WII.NOTE     AS  WI_NOTE,
	WLI.WORKLINEITEMSID     AS  WLI_ID,
	WLI.RESOURCECATEGORYNAME     AS  WLI_RES_CAT_NAME,
	WLI.CATEGORYDESCRIPTION     AS  WLI_CATEGORYDESCRIPTION,
	WLI.UNITOFMEASUREMENT     AS  WLI_UNITOFMEASUREMENT,
	WLI.MIN_VOLUME     AS  WLI_MIN_VOLUME,
	WLI.MAX_VOLUME     AS  WLI_MAX_VOLUME,
	WLI.RATE_C     AS  WLI_RATE_C,
	WLI.RATE_A     AS  WLI_RATE_A,
	WLI.QUANTITY     AS  WLI_QUANTITY,
	WLI.TOTALCOST_C     AS  WLI_TOTALCOST_C,
	WLI.TOTALCOST_A     AS  WLI_TOTALCOST_A,
	WLI.BILLINGTYPE     AS  WLI_BILLINGTYPE,
	WLI.PATH     AS  WLI_RES_CAT_PATH,
	CAST('''' AS NVARCHAR(200))     AS  WLI_RES_CAT_LEVEL1_NAME,
	CAST('''' AS NVARCHAR(200))     AS  WLI_RES_CAT_LEVEL2_NAME,
	CAST('''' AS NVARCHAR(200))     AS  WLI_RES_CAT_LEVEL3_NAME,
	CAST('''' AS NVARCHAR(200))     AS  WLI_RES_CAT_LEVEL4_NAME,
	CAST('''' AS NVARCHAR(200))     AS  WLI_RES_CAT_LEVEL5_NAME
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_BUSINESSUNIT BU ON A0.CONTAINSID = BU.BUSINESSUNITID
	
	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_MARKETINGACTIVITY MA1
	ON A2.CONTAINSID = MA1.MARKETINGACTIVITYID
	
	INNER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 164680007970996 AND A3.CONTAINERID = MA1.MARKETINGACTIVITYID
	INNER JOIN ALENT_ESTIMATE EST
	ON A3.CONTAINSID = EST.ESTIMATEID
	
	INNER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 268753845302731 AND A4.CONTAINERID = EST.ESTIMATEID
	INNER JOIN ALENT_VENDORS VENDORS
	ON A4.CONTAINSID = VENDORS.VENDORSID
	
	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 205485409039418 AND A5.CONTAINERID = EST.ESTIMATEID
	LEFT OUTER JOIN ALENT_WORKITEM WI
	ON A5.CONTAINSID = WI.WORKITEMID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 15048980469304 AND ASF1.ENTITYID = WI.WORKITEMID
	LEFT OUTER JOIN ALFCT_WORKITEMINFO WII
	ON ASF1.FACETID = WII.WORKITEMINFOID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID = 276583860982877 AND ASF2.ENTITYID = WI.WORKITEMID
	LEFT OUTER JOIN ALFCT_WORKLINEITEMS WLI
	ON ASF2.FACETID = WLI.WORKLINEITEMSID ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTACTUALS
	(PLANID,PLAN_TITLE,FISCALYEAR,EST_ID,EST_TITLE,EST_STATUS,EST_NUMBER,EST_STARTDATE,EST_ENDDATE,
	VENDORID,VENDORNAME,VENDORTYPE,VENDORNUMBER,WI_ID,WI_TITLE,WI_NUMBER,ACT_LIID,ACT_MONTH,
	ACT_YEAR,ACT_TYPE,ACT_RES_CAT_NAME,ACT_CAT_DESCRIPTION,ACT_RES_CAT_PATH,UNITOFMEASUREMENT,
	ACT_RATE_C,ACT_RATE_A,ACT_QUANTITY,ACT_TOTALCOST_C,ACT_TOTALCOST_A,ACT_BILLINGTYPE,ACT_CREATEDON,
	ACT_ACTUALSINFOID,ACT_PLANNAME,ACT_WORKITEMNUMBER,ACT_ISUNBUDGETEDPLAN)
	SELECT
	PLAN1.PLANID	AS PLANID,
	PLAN1.TITLE   AS PLAN_TITLE,
	PLAN1.FISCALYEAR   AS FISCALYEAR,
	EST.ESTIMATEID   AS  EST_ID,
	EST.TITLE   AS  EST_TITLE,
	EST.STATUS   AS  EST_STATUS,
	EST.ESTIMATENUMBER   AS  EST_NUMBER,
	EST.ESTIMATESTARTDATE   AS  EST_STARTDATE,
	EST.ESTIMATEENDDATE   AS  EST_ENDDATE,
	VENDORS.VENDORSID   AS  VENDORID,
	VENDORS.NAME   AS  VENDORNAME,
	VENDORS.VENDORTYPE   AS  VENDORTYPE,
	VENDORS.VENDORNUMBER   AS  VENDORNUMBER,
	WI.WORKITEMID     AS  WI_ID,
	WI.TITLE     AS  WI_TITLE,
	WI.WORKITEMNUMBER     AS  WI_NUMBER,
	ALI.ACTUALLINEITEMSID  AS ACT_LIID,
	ALI.ACTUALSMONTH    AS   ACT_MONTH,
	ALI.ACTUALSYEAR    AS   ACT_YEAR,
	ALI.ACTUALSTYPE    AS   ACT_TYPE,
	ALI.RESOURCECATEGORYNAME    AS   ACT_RES_CAT_NAME,
	ALI.CATEGORYDESCRIPTION    AS   ACT_CAT_DESCRIPTION,
	ALI.RESOURCECATEGORYPATH    AS   ACT_RES_CAT_PATH,
	ALI.UNITOFMEASUREMENT    AS   UNITOFMEASUREMENT,
	ALI.RATE_C    AS   ACT_RATE_C,
	ALI.RATE_A    AS   ACT_RATE_A,
	ALI.QUANTITY    AS   ACT_QUANTITY,
	ALI.TOTALCOST_C    AS   ACT_TOTALCOST_C,
	ALI.TOTALCOST_A    AS   ACT_TOTALCOST_A,
	ALI.BILLINGTYPE    AS   ACT_BILLINGTYPE,
	ALI.CREATEDON    AS   ACT_CREATEDON,
	ACTINFO.ACTUALSINFOID    AS   ACT_ACTUALSINFOID,
	ACTINFO.PLANNAME    AS   ACT_PLANNAME,
	ACTINFO.WORKITEMNUMBER    AS   ACT_WORKITEMNUMBER,
	ACTINFO.ISUNBUDGETEDPLAN    AS   ACT_ISUNBUDGETEDPLAN
	FROM
	ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A0 
	ON A0.RELATIONSHIPTYPEID = 180896289078822 AND A0.CONTAINERID = PLAN1.PLANID
	INNER JOIN ALENT_ESTIMATE EST
	ON A0.CONTAINSID = EST.ESTIMATEID
	
	INNER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 268753845302731 AND A4.CONTAINERID = EST.ESTIMATEID
	INNER JOIN ALENT_VENDORS VENDORS
	ON A4.CONTAINSID = VENDORS.VENDORSID
	
	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 205485409039418 AND A5.CONTAINERID = EST.ESTIMATEID
	LEFT OUTER JOIN ALENT_WORKITEM WI
	ON A5.CONTAINSID = WI.WORKITEMID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 4898830958341 AND ASF1.ENTITYID = WI.WORKITEMID
	LEFT OUTER JOIN ALFCT_ACTUALLINEITEMS ALI
	ON ASF1.FACETID = ALI.ACTUALLINEITEMSID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID = 155904229371956 AND ASF2.ENTITYID = ALI.ACTUALLINEITEMSID
	LEFT OUTER JOIN ALFCT_ACTUALSINFO ACTINFO
	ON ASF2.FACETID = ACTINFO.ACTUALSINFOID ')
	
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSESTWORKFLOW
	(EST_ID,EST_TITLE,EST_STATUS,EST_NUMBER,EST_STARTDATE,EST_ENDDATE,VENDORID,VENDORNAME,
	VENDORTYPE,VENDORNUMBER,WF_ID,WF_TITLE,WF_STARTDATE,WF_DUEDATE,WF_COMPLETEDON,WF_STATUS,
	WF_PERCENTDONE,WF_USERID,WF_CREATOR,STEPID,STEPTITLE,STEP_SEQ_NO,STEP_STARTDATE,
	STEP_DUEDATE,STEP_COMPLETEDON,STEP_STATUS,STEP_PERCENTDONE,STEP_SUMMARYVALUE,
	CNT_USERID,CNT_NAME,CNT_RESPONSE,CNT_RESPONSEPOSTEDON)
	SELECT
	EST.ESTIMATEID   AS  EST_ID,
	EST.TITLE   AS  EST_TITLE,
	EST.STATUS   AS  EST_STATUS,
	EST.ESTIMATENUMBER   AS  EST_NUMBER,
	EST.ESTIMATESTARTDATE   AS  EST_STARTDATE,
	EST.ESTIMATEENDDATE   AS  EST_ENDDATE,
	VENDORS.VENDORSID   AS  VENDORID,
	VENDORS.NAME   AS  VENDORNAME,
	VENDORS.VENDORTYPE   AS  VENDORTYPE,
	VENDORS.VENDORNUMBER   AS  VENDORNUMBER,
	WFP1.WORKFLOWPROCESSID   AS  WF_ID,
	WFP1.PROCESSNAME   AS  WF_TITLE,
	WFP1.STARTDATE   AS  WF_STARTDATE,
	WFP1.DUEDATE   AS  WF_DUEDATE,
	WFP1.ACTUALENDDATE   AS  WF_COMPLETEDON,
	WFP1.STATUS   AS  WF_STATUS,
	WFP_INFO.PERCENTDONE   AS  WF_PERCENTDONE,
	USER2.USERID   AS  WF_USERID,
	(CASE WHEN (USER2.firstname IS NOT NULL AND LEN(USER2.firstname) > 0) AND (USER2.lastname IS NOT NULL AND LEN(USER2.lastname) > 0) 
		THEN USER2.firstname+'' ''+USER2.lastname 	ELSE CASE WHEN (USER2.firstname IS NOT NULL AND LEN(USER2.firstname) > 0) THEN USER2.firstname 
		ELSE CASE WHEN (USER2.lastname IS NOT NULL AND LEN(USER2.lastname) > 0) THEN USER2.lastname ELSE USER2.LOGINNAME END END END )   AS  WF_CREATOR,
	ACT1.ACTIVITYID   AS  STEPID,
	ACT1.ACTIVITYNAME   AS  STEPTITLE,
	ACT1.SEQUENCENUMBER   AS  STEP_SEQ_NO,
	ACT1.STARTDATE   AS  STEP_STARTDATE,
	ACT1.DUEDATE   AS  STEP_DUEDATE,
	ACT1.ACTUALENDDATE   AS  STEP_COMPLETEDON,
	ACT1.STATUS   AS  STEP_STATUS,
	ACTINFO.PERCENTDONE   AS  STEP_PERCENTDONE,
	ACTINFO.SUMMARYVALUE   AS  STEP_SUMMARYVALUE,
	USER1.USERID  AS  CNT_USERID,
	(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
		THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
		ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  CNT_NAME,
	RESP.RESPONSETEXT   AS  CNT_RESPONSE,
	RESP.RESPONSEPOSTEDON     AS  CNT_RESPONSEPOSTEDON
	FROM
	ALENT_ESTIMATE EST INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 268753845302731 AND A1.CONTAINERID = EST.ESTIMATEID
	INNER JOIN ALENT_VENDORS VENDORS
	ON A1.CONTAINSID = VENDORS.VENDORSID
	
	INNER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 268547174253012 AND A2.CONTAINERID = EST.ESTIMATEID
	INNER JOIN ALENT_WORKFLOWPROCESS WFP1
	ON A2.CONTAINSID = WFP1.WORKFLOWPROCESSID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 109574871933848 AND ASF1.ENTITYID = WFP1.WORKFLOWPROCESSID
	LEFT OUTER JOIN ALFCT_WORKFLOWPROCESSINFO WFP_INFO
	ON ASF1.FACETID = WFP_INFO.WORKFLOWPROCESSINFOID
	
	LEFT OUTER JOIN ALOM_ASSEMBLY A6
	ON A6.RELATIONSHIPTYPEID = 1549518477 AND A6.CONTAINERID = WFP1.WORKFLOWPROCESSID
	LEFT OUTER JOIN ALENT_USER USER2
	ON A6.CONTAINSID = USER2.USERID
	
	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 154010190849386 AND A3.CONTAINERID = WFP1.WORKFLOWPROCESSID
	LEFT OUTER JOIN ALENT_ACTIVITY ACT1
	ON A3.CONTAINSID = ACT1.ACTIVITYID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID =  79760151954703 AND ASF2.ENTITYID = ACT1.ACTIVITYID
	LEFT OUTER JOIN ALFCT_ACTIVITYINFORMATION ACTINFO
	ON ASF2.FACETID = ACTINFO.ACTIVITYINFORMATIONID
	
	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 202900281682436 AND A5.CONTAINERID = ACT1.ACTIVITYID
	LEFT OUTER JOIN ALENT_RESPONSE RESP
	ON A5.CONTAINSID = RESP.RESPONSEID
	
	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 39756732918528 AND A4.CONTAINERID = RESP.RESPONSEID
	LEFT OUTER JOIN ALENT_USER USER1
	ON A4.CONTAINSID = USER1.USERID ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSRATECARD
	(VENDORID,VENDORNAME,VENDORDESCRIPTION,VENDORTYPE,VENDORNUMBER,VENDORISOBSOLETE,VENDORCURRENCYTYPE,
	VENDORCREATEDON,VENDORLASTUPDATEDON,VENDORURL,RCI_ITEMID,RCI_ITEMTYPE,RCI_PATH,RCI_LEVEL1_NAME,RCI_LEVEL2_NAME,
	RCI_LEVEL3_NAME,RCI_LEVEL4_NAME,RCI_LEVEL5_NAME,RCI_UNITOFMEASURE,RCI_RATE_C,RCI_RATE_A,RCI_MIN_VOLUME,
	RCI_MAX_VOLUME,RCI_ISDELETED,RCI_COMMENT,RES_DEFID,RES_SKILLLEVEL,RES_COUNTRY,RES_ISEXTERNAL,
	RES_ISUNKNOWNRESOURCE,RES_UNITSOFMEASURE)
	SELECT
	VENDORS.VENDORSID   AS  VENDORID,
	VENDORS.NAME   AS  VENDORNAME,
	VENDORS.DESCRIPTION   AS  VENDORDESCRIPTION,
	VENDORS.VENDORTYPE   AS  VENDORTYPE,
	VENDORS.VENDORNUMBER   AS  VENDORNUMBER,
	VENDORS.ISOBSOLETE   AS  VENDORISOBSOLETE,
	VENDORS.CURRENCYTYPE  AS  VENDORCURRENCYTYPE,
	VENDORS.CREATEDON  AS  VENDORCREATEDON,
	VENDORS.LASTUPDATEDON  AS  VENDORLASTUPDATEDON,
	VENDORS.URL   AS  VENDORURL,
	RCI.RATECARDITEMID  AS RCI_ITEMID,
	RCI.ITEMTYPE  AS RCI_ITEMTYPE,
	RCI.PATH  AS RCI_PATH,
	CAST('''' AS NVARCHAR(200))     AS  RCI_LEVEL1_NAME,
	CAST('''' AS NVARCHAR(200))     AS  RCI_LEVEL2_NAME,
	CAST('''' AS NVARCHAR(200))     AS  RCI_LEVEL3_NAME,
	CAST('''' AS NVARCHAR(200))     AS  RCI_LEVEL4_NAME,
	CAST('''' AS NVARCHAR(200))     AS  RCI_LEVEL5_NAME,
	RCI.UNITOFMEASURE  AS RCI_UNITOFMEASURE,
	RCI.RATE_C  AS RCI_RATE_C,
	RCI.RATE_A  AS RCI_RATE_A,
	RCI.MIN_VOLUME  AS RCI_MIN_VOLUME,
	RCI.MAX_VOLUME  AS RCI_MAX_VOLUME,
	RCI.ISDELETED  AS RCI_ISDELETED,
	RCI.COMMENT  AS RCI_COMMENT,
	RES.RESOURCEDEFID  AS RES_DEFID,
	RES.SKILLLEVEL  AS RES_SKILLLEVEL,
	RES.COUNTRY  AS RES_COUNTRY,
	RES.ISEXTERNAL  AS RES_ISEXTERNAL,
	RES.ISUNKNOWNRESOURCE  AS RES_ISUNKNOWNRESOURCE,
	RES.UNITSOFMEASURE  AS RES_UNITSOFMEASURE
	FROM
	ALENT_VENDORS VENDORS LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 102798348477075 AND ASF1.ENTITYID = VENDORS.VENDORSID
	LEFT OUTER JOIN ALFCT_RATECARDITEM RCI
	ON ASF1.FACETID = RCI.RATECARDITEMID
	
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID = 200683698991424 AND ASF2.FACETID = RCI.RATECARDITEMID
	LEFT OUTER JOIN ALENT_RESOURCEDEF RES
	ON ASF2.ENTITYID = RES.RESOURCEDEFID ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_BUDGETS_BY_BU 
	SELECT * FROM ALENT_BUDGETS_BY_BU ')
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_CHANNEL_COSTCATEGORY 
	SELECT * FROM ALENT_CHANNEL_COSTCATEGORY ')
	
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_CHANNEL_BUDGETSNACT  
	SELECT * FROM ALENT_CHANNEL_BUDGETSNACTUALS ')
	
	
	/* 	CLAIMS MANAGEMENT ODS DATA LOAD		*/
	
	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCLAIM 
	(CLAIMID,CLAIM_NAME,CLAIM_TEXT,CLAIM_CATEGORY,CLAIM_STATUS,CLAIM_CREATEDON,
	CLAIM_LASTUPDATEDON,CLAIM_APPROVEDON,CLAIM_REASONFOROBSOLETE,CLAIM_DISCLOSURESTATEMENT,
	CLAIM_CREATOR_NAME,CLAIM_LASTMODIFIEDBY_NAME,CLAIM_ADDITIONALINFO_ID,CLAIM_REGULATIONS)
	SELECT
	CLM.CLAIMID,CLM.NAME,CLM.CLAIMTEXT,CLM.CATEGORY,CLM.STATUS,CLM.CREATEDON,CLM.LASTUPDATEDON,CLM.CLAIMAPPROVEDON,
	CLM.REASONFOROBSOLETE,CLM.CLAIMDISCLOSURESTATEMENT,
	(CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) AND (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) 
		THEN USER1.FIRSTNAME+'' ''+USER1.LASTNAME 	ELSE CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) THEN USER1.FIRSTNAME 
		ELSE CASE WHEN (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) THEN USER1.LASTNAME ELSE USER1.LOGINNAME END END END ) AS CLAIM_CREATOR_NAME,
	(CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) AND (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) 
		THEN USER2.FIRSTNAME+'' ''+USER2.LASTNAME 	ELSE CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) THEN USER2.FIRSTNAME 
		ELSE CASE WHEN (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) THEN USER2.LASTNAME ELSE USER2.LOGINNAME END END END ) AS CLAIM_LASTMODIFIEDBY_NAME,
	ADDINFO.ADDITIONALINFOID ,ADDINFO.REGULATIONS					
	FROM
	ALENT_CLAIM CLM INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 178851881686140 AND A1.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_USER USER1
	ON A1.CONTAINSID = USER1.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 277304178563175 AND A2.CONTAINERID = CLM.CLAIMID
	INNER JOIN ALENT_USER USER2
	ON A2.CONTAINSID = USER2.USERID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID =  221326656195218 AND ASF1.ENTITYID = CLM.CLAIMID
	LEFT OUTER JOIN ALFCT_CLAIMADDITIONALINFO ADDINFO
	ON ASF1.FACETID = ADDINFO.ADDITIONALINFOID ')

	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCLAIM_DA 
	(CLAIMID,CLAIM_NAME,CLAIM_TEXT,CLAIM_CATEGORY,CLAIM_STATUS,CLAIM_CREATEDON,CLAIM_LASTUPDATEDON,
	CLAIM_APPROVEDON,CLAIM_REASONFOROBSOLETE,CLAIM_DISCLOSURESTATEMENT,CLAIM_CREATOR_NAME,
	CLAIM_LASTMODIFIEDBY_NAME,CLAIM_ADDITIONALINFO_ID,CLAIM_REGULATIONS,CLAIM_DIGITALASSET_ID)
	SELECT
	CLM.CLAIMID,CLM.NAME,CLM.CLAIMTEXT,CLM.CATEGORY,CLM.STATUS,CLM.CREATEDON,CLM.LASTUPDATEDON,CLM.CLAIMAPPROVEDON,
	CLM.REASONFOROBSOLETE,CLM.CLAIMDISCLOSURESTATEMENT,
	(CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) AND (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) 
		THEN USER1.FIRSTNAME+'' ''+USER1.LASTNAME 	ELSE CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) THEN USER1.FIRSTNAME 
		ELSE CASE WHEN (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) THEN USER1.LASTNAME ELSE USER1.LOGINNAME END END END ) AS CLAIM_CREATOR_NAME,
	(CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) AND (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) 
		THEN USER2.FIRSTNAME+'' ''+USER2.LASTNAME 	ELSE CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) THEN USER2.FIRSTNAME 
		ELSE CASE WHEN (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) THEN USER2.LASTNAME ELSE USER2.LOGINNAME END END END ) AS CLAIM_LASTMODIFIEDBY_NAME,
	ADDINFO.ADDITIONALINFOID ,ADDINFO.REGULATIONS,DA.DIGITALASSETID					
	FROM
	ALENT_CLAIM CLM INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 178851881686140 AND A1.CONTAINERID = CLM.CLAIMID
	INNER JOIN ALENT_USER USER1
	ON A1.CONTAINSID = USER1.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 277304178563175 AND A2.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_USER USER2
	ON A2.CONTAINSID = USER2.USERID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID =  221326656195218 AND ASF1.ENTITYID = CLM.CLAIMID
	LEFT OUTER JOIN ALFCT_CLAIMADDITIONALINFO ADDINFO
	ON ASF1.FACETID = ADDINFO.ADDITIONALINFOID
	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 149283283696974 AND A3.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_DIGITALASSET DA
	ON A3.CONTAINSID = DA.DIGITALASSETID ')

	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSLABEL_CLAIM
	(LABELID,LABEL_NAME,LABEL_DESCRIPTION,LABEL_STATUS,LABEL_OBSOLETEDATE,LABEL_CREATEDON,
	LABEL_LASTUPDATEDON,LABEL_APPROVEDON,LABEL_DISCLOSURE,LABEL_CREATOR_NAME,LABEL_LASTMODIFIEDBY_NAME,
	LABELINFOID,LABEL_PRODUCTNAME,CLAIMID,CLAIM_NAME,CLAIM_TEXT,CLAIM_CATEGORY,CLAIM_STATUS,
	CLAIM_CREATEDON,CLAIM_LASTUPDATEDON,CLAIM_APPROVEDON,CLAIM_REASONFOROBSOLETE,
	CLAIM_DISCLOSURESTATEMENT,CLAIM_CREATOR_NAME,CLAIM_LASTMODIFIEDBY_NAME,CLAIM_ADDITIONALINFO_ID,CLAIM_REGULATIONS)
	SELECT
	LABEL.LABELID,LABEL.LABELNAME,LABEL.DESCRIPTION,LABEL.STATUS,LABEL.OBSOLETEDATE,LABEL.CREATEDON,
	LABEL.LASTUPDATEDON,LABEL.LABELAPPROVEDON,LABEL.LABEL_DISCLOSURE,
	(CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) AND (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) 
		THEN USER1.FIRSTNAME+'' ''+USER1.LASTNAME 	ELSE CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) THEN USER1.FIRSTNAME 
		ELSE CASE WHEN (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) THEN USER1.LASTNAME ELSE USER1.LOGINNAME END END END ) AS LABEL_CREATOR_NAME,
	(CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) AND (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) 
		THEN USER2.FIRSTNAME+'' ''+USER2.LASTNAME 	ELSE CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) THEN USER2.FIRSTNAME 
		ELSE CASE WHEN (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) THEN USER2.LASTNAME ELSE USER2.LOGINNAME END END END ) AS LABEL_LASTMODIFIEDBY_NAME,
	LABINFO.LABELINFOID,LABINFO.PRODUCTNAME,		
	CLM.CLAIMID,CLM.NAME,CLM.CLAIMTEXT,CLM.CATEGORY,CLM.STATUS,CLM.CREATEDON,CLM.LASTUPDATEDON,CLM.CLAIMAPPROVEDON,
	CLM.REASONFOROBSOLETE,CLM.CLAIMDISCLOSURESTATEMENT,
	(CASE WHEN (USER3.FIRSTNAME IS NOT NULL AND LEN(USER3.FIRSTNAME) > 0) AND (USER3.LASTNAME IS NOT NULL AND LEN(USER3.LASTNAME) > 0) 
	THEN USER3.FIRSTNAME+'' ''+USER3.LASTNAME 	ELSE CASE WHEN (USER3.FIRSTNAME IS NOT NULL AND LEN(USER3.FIRSTNAME) > 0) THEN USER3.FIRSTNAME 
	ELSE CASE WHEN (USER3.LASTNAME IS NOT NULL AND LEN(USER3.LASTNAME) > 0) THEN USER3.LASTNAME ELSE USER3.LOGINNAME END END END ) AS CLAIM_CREATOR_NAME,
	(CASE WHEN (USER4.FIRSTNAME IS NOT NULL AND LEN(USER4.FIRSTNAME) > 0) AND (USER4.LASTNAME IS NOT NULL AND LEN(USER4.LASTNAME) > 0) 
	THEN USER4.FIRSTNAME+'' ''+USER4.LASTNAME 	ELSE CASE WHEN (USER4.FIRSTNAME IS NOT NULL AND LEN(USER4.FIRSTNAME) > 0) THEN USER4.FIRSTNAME 
	ELSE CASE WHEN (USER4.LASTNAME IS NOT NULL AND LEN(USER4.LASTNAME) > 0) THEN USER4.LASTNAME ELSE USER4.LOGINNAME END END END ) AS CLAIM_LASTMODIFIEDBY_NAME,
	ADDINFO.ADDITIONALINFOID ,ADDINFO.REGULATIONS
	FROM
	ALENT_LABEL LABEL INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 167974063680209 AND A1.CONTAINERID = LABEL.LABELID
	INNER JOIN ALENT_USER USER1
	ON A1.CONTAINSID = USER1.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 56100900305305 AND A2.CONTAINERID = LABEL.LABELID
	LEFT OUTER JOIN ALENT_USER USER2
	ON A2.CONTAINSID = USER2.USERID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 50193254404128 AND ASF1.ENTITYID = LABEL.LABELID
	LEFT OUTER JOIN ALFCT_LABELINFO LABINFO
	ON ASF1.FACETID = LABINFO.LABELINFOID
	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID =  224442881652564 AND A3.CONTAINERID = LABEL.LABELID
	LEFT OUTER JOIN ALENT_CLAIM CLM
	ON A3.CONTAINSID = CLM.CLAIMID
	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 178851881686140 AND A4.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_USER USER3
	ON A4.CONTAINSID = USER3.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 277304178563175 AND A5.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_USER USER4
	ON A5.CONTAINSID = USER4.USERID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID =  221326656195218 AND ASF2.ENTITYID = CLM.CLAIMID
	LEFT OUTER JOIN ALFCT_CLAIMADDITIONALINFO ADDINFO
	ON ASF2.FACETID = ADDINFO.ADDITIONALINFOID ')

	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSLABEL_CLAIM_DA
	(LABELID,LABEL_NAME,LABEL_DESCRIPTION,LABEL_STATUS,LABEL_OBSOLETEDATE,LABEL_CREATEDON,
	LABEL_LASTUPDATEDON,LABEL_APPROVEDON,LABEL_DISCLOSURE,LABEL_CREATOR_NAME,LABEL_LASTMODIFIEDBY_NAME,
	LABEL_DIGITALASSET_ID,LABELINFOID,LABEL_PRODUCTNAME,CLAIMID,CLAIM_NAME,CLAIM_TEXT,CLAIM_CATEGORY,
	CLAIM_STATUS,CLAIM_CREATEDON,CLAIM_LASTUPDATEDON,CLAIM_APPROVEDON,CLAIM_REASONFOROBSOLETE,
	CLAIM_DISCLOSURESTATEMENT,CLAIM_CREATOR_NAME,CLAIM_LASTMODIFIEDBY_NAME,CLAIM_ADDITIONALINFO_ID,CLAIM_REGULATIONS)
	SELECT
	LABEL.LABELID,LABEL.LABELNAME,LABEL.DESCRIPTION,LABEL.STATUS,LABEL.OBSOLETEDATE,LABEL.CREATEDON,
	LABEL.LASTUPDATEDON,LABEL.LABELAPPROVEDON,LABEL.LABEL_DISCLOSURE,
	(CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) AND (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) 
		THEN USER1.FIRSTNAME+'' ''+USER1.LASTNAME 	ELSE CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) THEN USER1.FIRSTNAME 
		ELSE CASE WHEN (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) THEN USER1.LASTNAME ELSE USER1.LOGINNAME END END END ) AS LABEL_CREATOR_NAME,
	(CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) AND (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) 
		THEN USER2.FIRSTNAME+'' ''+USER2.LASTNAME 	ELSE CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) THEN USER2.FIRSTNAME 
		ELSE CASE WHEN (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) THEN USER2.LASTNAME ELSE USER2.LOGINNAME END END END ) AS LABEL_LASTMODIFIEDBY_NAME,
	DA1.DIGITALASSETID,LABINFO.LABELINFOID,LABINFO.PRODUCTNAME,		
	CLM.CLAIMID,CLM.NAME,CLM.CLAIMTEXT,CLM.CATEGORY,CLM.STATUS,CLM.CREATEDON,CLM.LASTUPDATEDON,CLM.CLAIMAPPROVEDON,
	CLM.REASONFOROBSOLETE,CLM.CLAIMDISCLOSURESTATEMENT,
	(CASE WHEN (USER3.FIRSTNAME IS NOT NULL AND LEN(USER3.FIRSTNAME) > 0) AND (USER3.LASTNAME IS NOT NULL AND LEN(USER3.LASTNAME) > 0) 
	THEN USER3.FIRSTNAME+'' ''+USER3.LASTNAME 	ELSE CASE WHEN (USER3.FIRSTNAME IS NOT NULL AND LEN(USER3.FIRSTNAME) > 0) THEN USER3.FIRSTNAME 
	ELSE CASE WHEN (USER3.LASTNAME IS NOT NULL AND LEN(USER3.LASTNAME) > 0) THEN USER3.LASTNAME ELSE USER3.LOGINNAME END END END ) AS CLAIM_CREATOR_NAME,
	(CASE WHEN (USER4.FIRSTNAME IS NOT NULL AND LEN(USER4.FIRSTNAME) > 0) AND (USER4.LASTNAME IS NOT NULL AND LEN(USER4.LASTNAME) > 0) 
	THEN USER4.FIRSTNAME+'' ''+USER4.LASTNAME 	ELSE CASE WHEN (USER4.FIRSTNAME IS NOT NULL AND LEN(USER4.FIRSTNAME) > 0) THEN USER4.FIRSTNAME 
	ELSE CASE WHEN (USER4.LASTNAME IS NOT NULL AND LEN(USER4.LASTNAME) > 0) THEN USER4.LASTNAME ELSE USER4.LOGINNAME END END END ) AS CLAIM_LASTMODIFIEDBY_NAME,
	ADDINFO.ADDITIONALINFOID ,ADDINFO.REGULATIONS 
	FROM
	ALENT_LABEL LABEL INNER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 167974063680209 AND A1.CONTAINERID = LABEL.LABELID
	INNER JOIN ALENT_USER USER1
	ON A1.CONTAINSID = USER1.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 56100900305305 AND A2.CONTAINERID = LABEL.LABELID
	LEFT OUTER JOIN ALENT_USER USER2
	ON A2.CONTAINSID = USER2.USERID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 50193254404128 AND ASF1.ENTITYID = LABEL.LABELID
	LEFT OUTER JOIN ALFCT_LABELINFO LABINFO
	ON ASF1.FACETID = LABINFO.LABELINFOID
	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 238838194660137 AND A4.CONTAINERID = LABEL.LABELID
	LEFT OUTER JOIN ALENT_DIGITALASSET DA1
	ON A4.CONTAINSID = DA1.DIGITALASSETID
	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID =  224442881652564 AND A3.CONTAINERID = LABEL.LABELID
	LEFT OUTER JOIN ALENT_CLAIM CLM
	ON A3.CONTAINSID = CLM.CLAIMID
	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 178851881686140 AND A5.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_USER USER3
	ON A5.CONTAINSID = USER3.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A6
	ON A6.RELATIONSHIPTYPEID = 277304178563175 AND A6.CONTAINERID = CLM.CLAIMID
	LEFT OUTER JOIN ALENT_USER USER4
	ON A6.CONTAINSID = USER4.USERID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID =  221326656195218 AND ASF2.ENTITYID = CLM.CLAIMID
	LEFT OUTER JOIN ALFCT_CLAIMADDITIONALINFO ADDINFO
	ON ASF2.FACETID = ADDINFO.ADDITIONALINFOID ')
	
	
	/*	RESOURCE PLANNER DATA LOAD	*/
	
	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_ALLOCATION
	(ALLOCATIONID,ALLOCATION_ALLOCATED,ALLOCATION_ACTUALS,ALLOCATION_FROMDATE,ALLOCATION_TODATE,
	ALLOCATION_RATE_C,ALLOCATION_RATE_A,ALLOCATION_UNITOFMEASURE,ALLOCATION_TYPE,ALLOCATION_PERCENTAGE,
	ALLOCATION,ALLOCATION_COMMENTS,ALLOCATION_HOURSPERDAY,
	PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,
	BU_LEVEL4_ID,BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,
	BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	MA_LEVEL1_ID,MA_LEVEL2_ID,MA_LEVEL3_ID,MA_LEVEL4_ID,MA_LEVEL5_ID,
	MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,
	MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,
	MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,MA_ID,MA_NAME,MA_TYPE,MA_STATUS,MA_LEVEL_NO,
	MA_PATH,RESOURCEREQUEST_ID,RESREQUEST_FROMDATE,RESREQUEST_TODATE,RESREQUEST_ALLOCATION,RESREQUEST_UNITOFMEASURE,
	RESREQUEST_COMMENTS,RESREQUEST_STATUS,RESOURCEDEF_ID,RESDEF_NAME,RESDEF_DESCRIPTION,RESDEF_RATE_C,
	RESDEF_RATE_A,RESDEF_SKILLLEVEL,RESDEF_COUNTRY,RESDEF_USERASSIGNED,RESDEF_ISEXTERNAL,RESDEF_ISUNKNOWNRESOURCE,
	RESDEF_UNITSOFMEASURE,RESDEF_AVAIL_ON_SUNDAY,RESDEF_AVAIL_ON_MONDAY,RESDEF_AVAIL_ON_TUESDAY,RESDEF_AVAIL_ON_WEDNESDAY,
	RESDEF_AVAIL_ON_THURSDAY,RESDEF_AVAIL_ON_FRIDAY,RESDEF_AVAIL_ON_SATURDAY,RESDEF_USER_ID,RESEDEF_USER_NAME,RESOURCECATID,
	RESCAT_NAME,RESCAT_DESCRIPTION,RESCAT_UNITOFMEASURE,RESCAT_LEVEL_NO,RESCAT_PATH,RESCAT_USER_ID,RESCAT_HEAD_NAME,
	ISRESOBSOLETE,ISRESCATOBSOLETE)
	SELECT
	DISTINCT ALLOC.ALLOCATIONID,ALLOC.ALLOCATED,ALLOC.ACTUALS,ALLOC.FROMDATE,ALLOC.TODATE,ALLOC.RATE_C,
	ALLOC.RATE_A,ALLOC.UNITOFMEASURE,ALLOC.ALLOCATIONTYPE,ALLOC.PERCENTAGEALLOCATION,
	ALLOC.ALLOCATION,ALLOC.COMMENTS,ALLOC.HOURSPERDAY,
	PLAN1.PLANID,PLAN1.TITLE,PLAN1.FISCALYEAR,
	'''','''','''','''','''','''','''','''','''','''',
	'''','''','''','''','''','''','''','''','''','''',
	'''','''','''','''',
	BU.BUSINESSUNITID,BU.NAME,
	MA.MARKETINGACTIVITYID,MA.NAME,
	CASE WHEN CHARINDEX(''$ALP$'',MA.ACTIVITYTYPE) > 0 THEN REPLACE(MA.ACTIVITYTYPE,''$ALP$'','' >> '') ELSE  MA.ACTIVITYTYPE END,
	MA.STATUS,MA.ACTIVITYLEVEL,
	CASE WHEN CHARINDEX(''$ALP$'',MA.ACTIVITYPATH) > 0 THEN REPLACE(MA.ACTIVITYPATH,''$ALP$'','' >> '') ELSE  MA.ACTIVITYPATH END,
	RESREQ.RESOURCEREQUESTID,RESREQ.FROMDATE,RESREQ.TODATE,RESREQ.ALLOCATION,RESREQ.UNITOFMEASURE,
	RESREQ.COMMENTS,RESREQ.STATUS,
	RESDEF.RESOURCEDEFID,RESDEF.RESDEFNAME,RESDEF.DESCRIPTION,RESDEF.RATE_C,RESDEF.RATE_A,
	RESDEF.SKILLLEVEL,RESDEF.COUNTRY,RESDEF.USERASSIGNED,RESDEF.ISEXTERNAL,RESDEF.ISUNKNOWNRESOURCE,
	RESDEF.UNITSOFMEASURE,RESDEF.AVAIL_ON_SUNDAY,RESDEF.AVAIL_ON_MONDAY,RESDEF.AVAIL_ON_TUESDAY,
	RESDEF.AVAIL_ON_WEDNESDAY,RESDEF.AVAIL_ON_THURSDAY,RESDEF.AVAIL_ON_FRIDAY,RESDEF.AVAIL_ON_SATURDAY,
	USER1.USERID,
	(CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) AND (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) 
				THEN USER1.FIRSTNAME+'' ''+USER1.LASTNAME 	ELSE CASE WHEN (USER1.FIRSTNAME IS NOT NULL AND LEN(USER1.FIRSTNAME) > 0) THEN USER1.FIRSTNAME 
				ELSE CASE WHEN (USER1.LASTNAME IS NOT NULL AND LEN(USER1.LASTNAME) > 0) THEN USER1.LASTNAME ELSE USER1.LOGINNAME END END END ),

	RESCAT.RESOURCECATID,RESCAT.RESOURCECATNAME,RESCAT.DESCRIPTION,RESCAT.UNITSOFMEASURE,RESCAT.RESCATLEVEL,
	RESCAT.RESCATPATH,USER2.USERID,
	(CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) AND (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) 
				THEN USER2.FIRSTNAME+'' ''+USER2.LASTNAME 	ELSE CASE WHEN (USER2.FIRSTNAME IS NOT NULL AND LEN(USER2.FIRSTNAME) > 0) THEN USER2.FIRSTNAME 
				ELSE CASE WHEN (USER2.LASTNAME IS NOT NULL AND LEN(USER2.LASTNAME) > 0) THEN USER2.LASTNAME ELSE USER2.LOGINNAME END END END ),
	RESDEF.ISOBSOLETE,RESCAT.ISOBSOLETE
	FROM
	ALFCT_ALLOCATION ALLOC LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 118193322814736 AND ASF1.FACETID = ALLOC.ALLOCATIONID
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA
	ON ASF1.ENTITYID = MA.MARKETINGACTIVITYID
	--
	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A5.CONTAINSID = MA.MARKETINGACTIVITYID
	LEFT OUTER JOIN ALENT_PLAN PLAN1
	ON A5.CONTAINERID = PLAN1.PLANID
	LEFT OUTER JOIN ALOM_ASSEMBLY A6
	ON A6.RELATIONSHIPTYPEID = 141014623932230 AND A6.CONTAINERID = PLAN1.PLANID
	LEFT OUTER JOIN ALENT_BUSINESSUNIT BU
	ON A6.CONTAINSID = BU.BUSINESSUNITID
	--
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID = 174053874850081 AND ASF2.FACETID = ALLOC.ALLOCATIONID
	LEFT OUTER JOIN ALENT_RESOURCEREQUEST RESREQ
	ON ASF2.ENTITYID = RESREQ.RESOURCEREQUESTID
	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF3
	ON ASF3.RELATIONSHIPTYPEID = 278730232827908 AND ASF3.FACETID = ALLOC.ALLOCATIONID
	LEFT OUTER JOIN ALENT_RESOURCEDEF RESDEF
	ON ASF3.ENTITYID = RESDEF.RESOURCEDEFID
	LEFT OUTER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 226857822355998 AND A1.CONTAINERID = RESDEF.RESOURCEDEFID
	LEFT OUTER JOIN ALENT_USER USER1
	ON A1.CONTAINSID = USER1.USERID
	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 49863501508000 AND A3.CONTAINSID = RESDEF.RESOURCEDEFID
	LEFT OUTER JOIN ALENT_RESOURCECAT RESCAT
	ON A3.CONTAINERID = RESCAT.RESOURCECATID
	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 172581561815655 AND A2.CONTAINERID = RESCAT.RESOURCECATID
	LEFT OUTER JOIN ALENT_USER USER2
	ON A2.CONTAINSID = USER2.USERID ')
	
	
	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_RESCAT_ANALYSIS
	(RESCAT_ALLOC_DETAILS_ID,PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,
	BU_LEVEL4_ID,BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
	MA_LEVEL1_ID,MA_LEVEL2_ID,MA_LEVEL3_ID,MA_LEVEL4_ID,MA_LEVEL5_ID,MA_LEVEL1_NAME,MA_LEVEL2_NAME,
	MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,
	MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,PARENT_ID,INSTANCE_ID,MA_NAME,MA_TYPE,MA_STATUS,MA_LEVEL_NO,RESOURCECATID,
	RESOURCECATNAME,RESOURCECAT_LEVEL_NO,RESCAT_LEVEL1_NAME,RESCAT_LEVEL2_NAME,RESCAT_LEVEL3_NAME,
	RESCAT_LEVEL4_NAME,RESCAT_LEVEL5_NAME,RESCAT_DESCRIPTION,RESCAT_PATH,YEAR,JAN_ALLOC_HRS,FEB_ALLOC_HRS,
	MAR_ALLOC_HRS,APR_ALLOC_HRS,MAY_ALLOC_HRS,JUN_ALLOC_HRS,JUL_ALLOC_HRS,AUG_ALLOC_HRS,SEP_ALLOC_HRS,
	OCT_ALLOC_HRS,NOV_ALLOC_HRS,DEC_ALLOC_HRS,JAN_ROLLUP_ALLOC_HRS,FEB_ROLLUP_ALLOC_HRS,MAR_ROLLUP_ALLOC_HRS,
	APR_ROLLUP_ALLOC_HRS,MAY_ROLLUP_ALLOC_HRS,JUN_ROLLUP_ALLOC_HRS,JUL_ROLLUP_ALLOC_HRS,AUG_ROLLUP_ALLOC_HRS,
	SEP_ROLLUP_ALLOC_HRS,OCT_ROLLUP_ALLOC_HRS,NOV_ROLLUP_ALLOC_HRS,DEC_ROLLUP_ALLOC_HRS,
	JAN_ACTUAL_HRS,FEB_ACTUAL_HRS,
	MAR_ACTUAL_HRS,APR_ACTUAL_HRS,MAY_ACTUAL_HRS,JUN_ACTUAL_HRS,JUL_ACTUAL_HRS,AUG_ACTUAL_HRS,SEP_ACTUAL_HRS,
	OCT_ACTUAL_HRS,NOV_ACTUAL_HRS,DEC_ACTUAL_HRS,JAN_ROLLUP_ACTUAL_HRS,FEB_ROLLUP_ACTUAL_HRS,MAR_ROLLUP_ACTUAL_HRS,
	APR_ROLLUP_ACTUAL_HRS,MAY_ROLLUP_ACTUAL_HRS,JUN_ROLLUP_ACTUAL_HRS,JUL_ROLLUP_ACTUAL_HRS,AUG_ROLLUP_ACTUAL_HRS,
	SEP_ROLLUP_ACTUAL_HRS,OCT_ROLLUP_ACTUAL_HRS,NOV_ROLLUP_ACTUAL_HRS,DEC_ROLLUP_ACTUAL_HRS,RESCAT_HEAD_USER_ID,RESCAT_HEAD_NAME,
	ISRESCATOBSOLETE)
	SELECT * FROM ALENT_RPT_RESCAT_ANALYSIS ')
	
	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_REQALLOC_ANALYSIS
	(REQ_ALLOC_DETAILS_ID,PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,
	BU_LEVEL4_ID,BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,
	BU_LEVEL4_NAME,BU_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,
	MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,MA_ID,MA_NAME,
	MA_TYPE,MA_STATUS,RESOURCECATID,RESOURCECATNAME,RESOURCECAT_LEVEL_NO,
	RESCAT_LEVEL1_NAME,RESCAT_LEVEL2_NAME,RESCAT_LEVEL3_NAME,RESCAT_LEVEL4_NAME,
	RESCAT_LEVEL5_NAME,RESCAT_DESCRIPTION,RESCAT_PATH,TOTAL_REQUESTED_HOURS,TOTAL_ALLOCATED_HOURS,
	TOTAL_ACTUAL_HOURS,RESCAT_HEAD_USER_ID,RESCAT_HEAD_NAME,
	ISRESCATOBSOLETE)
	SELECT * FROM ALENT_RPT_REQALLOC_ANALYSIS ')
	
	/*  PROMOTIONAL PLANNER  ODS DATA   */
	
	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_SUBMISSIONDETAILS
	(SUBMISSIONID,SUB_NAME,SUB_DESCRIPTION,SUB_STARTDATE,SUB_ENDDATE,SUB_STATUS,SUB_CREATEDON,
	SUB_LASTMODIFIEDON,SUB_DISPLAYSTATUS,SUB_CREATOR,SUBMISSIONINFOID,SUBINFO_FOCUS,SUBINFO_SEASON,
	SUBINFO_EVENT,SUBINFO_ROLE,DIGITALASSET_ID,SUB_AUTH_GROUPNAME,SUB_AUTH_USER,SUB_READER_GROUP,
	SUB_READER_USER,WORKFLOWPROCESS_ID,VEHICLEID,VEHICLE_NAME,VEHICLE_DESCRIPTION,VEHICLE_CREATEDON,
	VEHICLE_LASTMODIFIEDON,VEHICLE_SEQUENCENO,VEHICLE_MARKASDELETED,VEHICLE_MODE,VEHICLE_TEMPLATETYPE,
	VEHICLETYPEID,VEHTYPE_NAME,VEHTYPE_DESCRIPTION,VEHTYPE_TEMPLATETYPE,MA_ID,SPACEID,SPACE_NAME,
	SPACE_SEQUENCEORDER,SPACE_TYPE,PLANNERINFOID,PLANNER_FIXTURELOCATION,PLANNER_CONSUMERMESSAGE,
	PLANNER_THEME,PLANNER_LOB,PLANNER_CATEGORY,PRINTINFOID,PRINTINFO_CONSUMERMESSAGE,PRINTINFO_THEME,
	PRINTINFO_LOB,PRINTINFO_CATEGORY,SPACE_CREATOR)
	SELECT 
	SUB.SUBMISSIONID,SUB.NAME,SUB.DESCRIPTION,SUB.STARTDATE,SUB.ENDDATE,SUB.STATUS,SUB.CREATEDON,SUB.LASTMODIFIEDON,SUB.DISPLAYSTATUS,
	CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
		THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
		ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END,
	SUBINFO.SUBMISSIONINFOID,SUBINFO.FOCUS,SUBINFO.SEASON,SUBINFO.EVENT,SUBINFO.ROLE,DA.DIGITALASSETID,
	AUTH_GRP1.GROUPNAME,
	CASE WHEN (AUTH_U2.FIRSTNAME IS NOT NULL AND LEN(AUTH_U2.FIRSTNAME) > 0) AND (AUTH_U2.LASTNAME IS NOT NULL AND LEN(AUTH_U2.LASTNAME) > 0) 
		THEN AUTH_U2.FIRSTNAME+'' ''+AUTH_U2.LASTNAME 	ELSE CASE WHEN (AUTH_U2.FIRSTNAME IS NOT NULL AND LEN(AUTH_U2.FIRSTNAME) > 0) THEN AUTH_U2.FIRSTNAME 
		ELSE CASE WHEN (AUTH_U2.LASTNAME IS NOT NULL AND LEN(AUTH_U2.LASTNAME) > 0) THEN AUTH_U2.LASTNAME ELSE AUTH_U2.LOGINNAME END END END,
	READ_GRP1.GROUPNAME,
	CASE WHEN (READ_U2.FIRSTNAME IS NOT NULL AND LEN(READ_U2.FIRSTNAME) > 0) AND (READ_U2.LASTNAME IS NOT NULL AND LEN(READ_U2.LASTNAME) > 0) 
		THEN READ_U2.FIRSTNAME+'' ''+READ_U2.LASTNAME 	ELSE CASE WHEN (READ_U2.FIRSTNAME IS NOT NULL AND LEN(READ_U2.FIRSTNAME) > 0) THEN AUTH_U2.FIRSTNAME 
		ELSE CASE WHEN (READ_U2.LASTNAME IS NOT NULL AND LEN(READ_U2.LASTNAME) > 0) THEN READ_U2.LASTNAME ELSE READ_U2.LOGINNAME END END END,
	WFP1.WORKFLOWPROCESSID,
	VEH.VEHICLEID,VEH.NAME,VEH.DESCRIPTION,VEH.CREATEDON,VEH.LASTMODIFIEDON,VEH.SEQUENCENO,VEH.MARKASDELETED,VEH.MODE,VEH.TEMPLATETYPE,
	VEH_TYPE.VEHICLETYPEID,VEH_TYPE.NAME,VEH_TYPE.DESCRIPTION,VEH_TYPE.TEMPLATETYPE,
	MA.MARKETINGACTIVITYID,
	SP.SPACEID,SP.NAME,SP.SEQUENCEORDER,SP.TYPE,
	PLANNERINFO.PLANNERINFOID,PLANNERINFO.FIXTURELOCATION,PLANNERINFO.CONSUMERMESSAGE,PLANNERINFO.THEME,PLANNERINFO.LOB,PLANNERINFO.CATEGORY,
	PRINTINFO.PRINTINFOID,PRINTINFO.CONSUMERMESSAGE,PRINTINFO.THEME,PRINTINFO.LOB,PRINTINFO.CATEGORY,
	CASE WHEN (U3.FIRSTNAME IS NOT NULL AND LEN(U3.FIRSTNAME) > 0) AND (U3.LASTNAME IS NOT NULL AND LEN(U3.LASTNAME) > 0) 
		THEN U3.FIRSTNAME+'' ''+U3.LASTNAME 	ELSE CASE WHEN (U3.FIRSTNAME IS NOT NULL AND LEN(U3.FIRSTNAME) > 0) THEN U3.FIRSTNAME 
		ELSE CASE WHEN (U3.LASTNAME IS NOT NULL AND LEN(U3.LASTNAME) > 0) THEN U3.LASTNAME ELSE U3.LOGINNAME END END END
	FROM
	ALENT_SUBMISSION SUB LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 263264354702527 AND ASF1.ENTITYID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALFCT_SUBMISSIONINFO SUBINFO
	ON ASF1.FACETID = SUBINFO.SUBMISSIONINFOID

	LEFT OUTER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 263829430200104 AND A1.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_USER U1
	ON A1.CONTAINSID = U1.USERID

	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 185607970927821 AND A2.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_DIGITALASSET DA
	ON A2.CONTAINSID = DA.DIGITALASSETID

	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 21814217341707 AND A3.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_GROUP AUTH_GRP1
	ON A3.CONTAINSID = AUTH_GRP1.GROUPID

	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 233470189631434 AND A4.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_USER AUTH_U2
	ON A4.CONTAINSID = AUTH_U2.USERID

	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 17977868346484 AND A5.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_GROUP READ_GRP1
	ON A5.CONTAINSID = READ_GRP1.GROUPID

	LEFT OUTER JOIN ALOM_ASSEMBLY A6
	ON A6.RELATIONSHIPTYPEID = 269635438246446 AND A6.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_USER READ_U2
	ON A6.CONTAINSID = READ_U2.USERID

	LEFT OUTER JOIN ALOM_ASSEMBLY A7
	ON A7.RELATIONSHIPTYPEID = 73201535931148 AND A7.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_WORKFLOWPROCESS WFP1
	ON A7.CONTAINSID = WFP1.WORKFLOWPROCESSID

	LEFT OUTER JOIN ALOM_ASSEMBLY A8
	ON A8.RELATIONSHIPTYPEID = 239039342495012 AND A8.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_VEHICLE VEH
	ON A8.CONTAINSID = VEH.VEHICLEID

	LEFT OUTER JOIN ALOM_ASSEMBLY A9
	ON A9.RELATIONSHIPTYPEID = 281142027159220 AND A9.CONTAINERID = VEH.VEHICLEID
	LEFT OUTER JOIN ALENT_VEHICLETYPE VEH_TYPE
	ON A9.CONTAINSID = VEH_TYPE.VEHICLETYPEID

	LEFT OUTER JOIN ALOM_ASSEMBLY A10
	ON A10.RELATIONSHIPTYPEID = 3929352143190 AND A10.CONTAINERID = VEH.VEHICLEID
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA
	ON A10.CONTAINSID = MA.MARKETINGACTIVITYID

	LEFT OUTER JOIN ALOM_ASSEMBLY A11
	ON A11.RELATIONSHIPTYPEID = 278877105640137 AND A11.CONTAINERID = VEH.VEHICLEID
	LEFT OUTER JOIN ALENT_SPACE SP
	ON A11.CONTAINSID = SP.SPACEID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID = 25725912627949 AND ASF2.ENTITYID = SP.SPACEID
	LEFT OUTER JOIN ALFCT_PLANNERINFO PLANNERINFO
	ON ASF2.FACETID = PLANNERINFO.PLANNERINFOID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF3
	ON ASF3.RELATIONSHIPTYPEID = 68828291710497 AND ASF3.ENTITYID = SP.SPACEID
	LEFT OUTER JOIN ALFCT_PRINTINFO PRINTINFO
	ON ASF3.FACETID = PRINTINFO.PRINTINFOID

	LEFT OUTER JOIN ALOM_ASSEMBLY A12
	ON A12.RELATIONSHIPTYPEID = 90193584771450 AND A12.CONTAINERID = SP.SPACEID
	LEFT OUTER JOIN ALENT_USER U3
	ON A12.CONTAINSID = U3.USERID
	
	UNION
	
	SELECT 
	SUB.SUBMISSIONID,SUB.NAME,SUB.DESCRIPTION,SUB.STARTDATE,SUB.ENDDATE,SUB.STATUS,SUB.CREATEDON,SUB.LASTMODIFIEDON,SUB.DISPLAYSTATUS,
	CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
		THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
		ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END,
	SUBINFO.SUBMISSIONINFOID,SUBINFO.FOCUS,SUBINFO.SEASON,SUBINFO.EVENT,SUBINFO.ROLE,DA.DIGITALASSETID,
	AUTH_GRP1.GROUPNAME,
	CASE WHEN (AUTH_U2.FIRSTNAME IS NOT NULL AND LEN(AUTH_U2.FIRSTNAME) > 0) AND (AUTH_U2.LASTNAME IS NOT NULL AND LEN(AUTH_U2.LASTNAME) > 0) 
		THEN AUTH_U2.FIRSTNAME+'' ''+AUTH_U2.LASTNAME 	ELSE CASE WHEN (AUTH_U2.FIRSTNAME IS NOT NULL AND LEN(AUTH_U2.FIRSTNAME) > 0) THEN AUTH_U2.FIRSTNAME 
		ELSE CASE WHEN (AUTH_U2.LASTNAME IS NOT NULL AND LEN(AUTH_U2.LASTNAME) > 0) THEN AUTH_U2.LASTNAME ELSE AUTH_U2.LOGINNAME END END END,
	READ_GRP1.GROUPNAME,
	CASE WHEN (READ_U2.FIRSTNAME IS NOT NULL AND LEN(READ_U2.FIRSTNAME) > 0) AND (READ_U2.LASTNAME IS NOT NULL AND LEN(READ_U2.LASTNAME) > 0) 
		THEN READ_U2.FIRSTNAME+'' ''+READ_U2.LASTNAME 	ELSE CASE WHEN (READ_U2.FIRSTNAME IS NOT NULL AND LEN(READ_U2.FIRSTNAME) > 0) THEN AUTH_U2.FIRSTNAME 
		ELSE CASE WHEN (READ_U2.LASTNAME IS NOT NULL AND LEN(READ_U2.LASTNAME) > 0) THEN READ_U2.LASTNAME ELSE READ_U2.LOGINNAME END END END,
	WFP1.WORKFLOWPROCESSID,
	VEH.VEHICLEID,VEH.NAME,VEH.DESCRIPTION,VEH.CREATEDON,VEH.LASTMODIFIEDON,VEH.SEQUENCENO,VEH.MARKASDELETED,VEH.MODE,VEH.TEMPLATETYPE,
	VEH_TYPE.VEHICLETYPEID,VEH_TYPE.NAME,VEH_TYPE.DESCRIPTION,VEH_TYPE.TEMPLATETYPE,
	MA.MARKETINGACTIVITYID,
	SP.SPACEID,SP.NAME,SP.SEQUENCEORDER,SP.TYPE,
	PLANNERINFO.PLANNERINFOID,PLANNERINFO.FIXTURELOCATION,PLANNERINFO.CONSUMERMESSAGE,PLANNERINFO.THEME,PLANNERINFO.LOB,PLANNERINFO.CATEGORY,
	PRINTINFO.PRINTINFOID,PRINTINFO.CONSUMERMESSAGE,PRINTINFO.THEME,PRINTINFO.LOB,PRINTINFO.CATEGORY,
	CASE WHEN (U3.FIRSTNAME IS NOT NULL AND LEN(U3.FIRSTNAME) > 0) AND (U3.LASTNAME IS NOT NULL AND LEN(U3.LASTNAME) > 0) 
		THEN U3.FIRSTNAME+'' ''+U3.LASTNAME 	ELSE CASE WHEN (U3.FIRSTNAME IS NOT NULL AND LEN(U3.FIRSTNAME) > 0) THEN U3.FIRSTNAME 
		ELSE CASE WHEN (U3.LASTNAME IS NOT NULL AND LEN(U3.LASTNAME) > 0) THEN U3.LASTNAME ELSE U3.LOGINNAME END END END
	FROM
	ALENT_SUBMISSION SUB LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
	ON ASF1.RELATIONSHIPTYPEID = 263264354702527 AND ASF1.ENTITYID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALFCT_SUBMISSIONINFO SUBINFO
	ON ASF1.FACETID = SUBINFO.SUBMISSIONINFOID

	LEFT OUTER JOIN ALOM_ASSEMBLY A1
	ON A1.RELATIONSHIPTYPEID = 263829430200104 AND A1.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_USER U1
	ON A1.CONTAINSID = U1.USERID

	LEFT OUTER JOIN ALOM_ASSEMBLY A2
	ON A2.RELATIONSHIPTYPEID = 185607970927821 AND A2.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_DIGITALASSET DA
	ON A2.CONTAINSID = DA.DIGITALASSETID

	LEFT OUTER JOIN ALOM_ASSEMBLY A3
	ON A3.RELATIONSHIPTYPEID = 21814217341707 AND A3.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_GROUP AUTH_GRP1
	ON A3.CONTAINSID = AUTH_GRP1.GROUPID

	LEFT OUTER JOIN ALOM_ASSEMBLY A4
	ON A4.RELATIONSHIPTYPEID = 233470189631434 AND A4.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_USER AUTH_U2
	ON A4.CONTAINSID = AUTH_U2.USERID

	LEFT OUTER JOIN ALOM_ASSEMBLY A5
	ON A5.RELATIONSHIPTYPEID = 17977868346484 AND A5.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_GROUP READ_GRP1
	ON A5.CONTAINSID = READ_GRP1.GROUPID

	LEFT OUTER JOIN ALOM_ASSEMBLY A6
	ON A6.RELATIONSHIPTYPEID = 269635438246446 AND A6.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_USER READ_U2
	ON A6.CONTAINSID = READ_U2.USERID

	LEFT OUTER JOIN ALOM_ASSEMBLY A7
	ON A7.RELATIONSHIPTYPEID = 73201535931148 AND A7.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_WORKFLOWPROCESS WFP1
	ON A7.CONTAINSID = WFP1.WORKFLOWPROCESSID

	LEFT OUTER JOIN ALOM_ASSEMBLY A8
	ON A8.RELATIONSHIPTYPEID = 239039342495012 AND A8.CONTAINERID = SUB.SUBMISSIONID
	LEFT OUTER JOIN ALENT_VEHICLE VEH
	ON A8.CONTAINSID = VEH.VEHICLEID

	LEFT OUTER JOIN ALOM_ASSEMBLY A9
	ON A9.RELATIONSHIPTYPEID = 281142027159220 AND A9.CONTAINERID = VEH.VEHICLEID
	LEFT OUTER JOIN ALENT_VEHICLETYPE VEH_TYPE
	ON A9.CONTAINSID = VEH_TYPE.VEHICLETYPEID

	LEFT OUTER JOIN ALOM_ASSEMBLY A10
	ON A10.RELATIONSHIPTYPEID = 3929352143190 AND A10.CONTAINERID = VEH.VEHICLEID
	LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA
	ON A10.CONTAINSID = MA.MARKETINGACTIVITYID

	LEFT OUTER JOIN ALOM_ASSEMBLY A11
	ON A11.RELATIONSHIPTYPEID = 278877105640137 AND A11.CONTAINERID = VEH.VEHICLEID
	LEFT OUTER JOIN ALENT_SPACE SP0
	ON A11.CONTAINSID = SP0.SPACEID
	LEFT OUTER JOIN ALOM_ASSEMBLY A111
	ON A111.RELATIONSHIPTYPEID = 74447882250297 AND A111.CONTAINERID = SP0.SPACEID
	LEFT OUTER JOIN ALENT_SPACE SP
	ON A111.CONTAINSID = SP.SPACEID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
	ON ASF2.RELATIONSHIPTYPEID = 25725912627949 AND ASF2.ENTITYID = SP.SPACEID
	LEFT OUTER JOIN ALFCT_PLANNERINFO PLANNERINFO
	ON ASF2.FACETID = PLANNERINFO.PLANNERINFOID

	LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF3
	ON ASF3.RELATIONSHIPTYPEID = 68828291710497 AND ASF3.ENTITYID = SP.SPACEID
	LEFT OUTER JOIN ALFCT_PRINTINFO PRINTINFO
	ON ASF3.FACETID = PRINTINFO.PRINTINFOID

	LEFT OUTER JOIN ALOM_ASSEMBLY A12
	ON A12.RELATIONSHIPTYPEID = 90193584771450 AND A12.CONTAINERID = SP.SPACEID
	LEFT OUTER JOIN ALENT_USER U3
	ON A12.CONTAINSID = U3.USERID
	WHERE SP.SPACEID IS NOT NULL ')
	
		
	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_SPACESKUDETAILS
		(SPACEID,SPACE_NAME,SPACE_SEQUENCEORDER,SPACE_TYPE,MERCHANTSPACEID,MERCH_SPACE_SKUCOUNT,
		MERCH_SPACE_CREATOR,SKUTYPE,SKU_ID,SKU_DESCRIPTION,SKU_NUMBER,SKU_LOB,SKU_CATEGORY,
		SKU_SUBMITTED_BY,SKUINFO_EXIT_STRATEGY,SKUINFO_PICTURED_SKU,SKUINFO_PROMO_RETAIL,
		SKUINFO_ETHNIC_ITEM,SKUINFO_COMMENTS,SKUINFO_SIGNAGEREQUIRED,SKUINFO_COUPONREQUIRED,
		SKUINFO_SGN_DESCRIPTION,SKUINFO_SGN_STARTDATE,SKUINFO_SGN_ENDDATE,SKUINFO_SGN_PLANNEDCOOP,
		SKUINFO_SGN_COMMENTS,SKUINFO_CPN_DESCRIPTION,SKUINFO_CPN_STARTDATE,SKUINFO_CPN_ENDDATE,
		SKUINFO_CPN_PLANNEDCOOP,SKUINFO_CPN_COMMENTS,SKUINFO_NEWBASERETAILPRICE,SKUINFO_PROJ_SALESUNIT,
		SKUINFO_VERSION,SKUINFO_SPECIALCOST,SKUINFO_FUTURECOST,SUPP_COUPON_PLANNEDCOOP,SUPP_COUPON_ACTUALCOOP,SUPP_COUPON_SUPPLIERFUNDING,
		CPN_SUPPLIER_NUMBER,CPN_SUPPLIER_NAME,CPN_SUPPLIER_ISDELETED,CPN_SUPPLIER_CONTACTNAME,
		CPN_SUPPLIER_CONTACTPHONE,CPN_SUPPLIER_STATUS,CPN_SUPP_PAYMENT_METHOD,CPN_SUPPLIER_ADD_1,
		CPN_SUPPLIER_ADD_2,CPN_SUPPLIER_ADD_3,CPN_SUPPLIER_CITY,CPN_SUPPLIER_STATE,CPN_SUPPLIER_COUNTRY_ID,CPN_SUPPLIER_POST,
		SUPP_SIGNAGE_PLANNEDCOOP,SUPP_SIGNAGE_ACTUALCOOP,SUPP_SIGNAGE_SUPPLIERFUNDING,SGN_SUPPLIER_NUMBER,SGN_SUPPLIER_NAME,SGN_SUPPLIER_ISDELETED,
		SGN_SUPPLIER_CONTACTNAME,SGN_SUPPLIER_CONTACTPHONE,SGN_SUPPLIER_STATUS,SGN_SUPP_PAYMENT_METHOD,SGN_SUPPLIER_ADD_1,
		SGN_SUPPLIER_ADD_2,SGN_SUPPLIER_ADD_3,SGN_SUPPLIER_CITY,SGN_SUPPLIER_STATE,SGN_SUPPLIER_COUNTRY_ID,SGN_SUPPLIER_POST,
		SUPP_SPSKU_PLANNEDCOOP,SUPP_SPSKU_ACTUALCOOP,SUPP_SPSKU_SUPPLIERFUNDING,SPSKU_SUPPLIER_NUMBER,SPSKU_SUPPLIER_NAME,SPSKU_SUPPLIER_ISDELETED,
		SPSKU_SUPPLIER_CONTACTNAME,SPSKU_SUPPLIER_CONTACTPHONE,SPSKU_SUPPLIER_STATUS,SPSKU_SUPP_PAYMENT_METHOD,
		SPSKU_SUPPLIER_ADD_1,SPSKU_SUPPLIER_ADD_2,SPSKU_SUPPLIER_ADD_3,SPSKU_SUPPLIER_CITY,SPSKU_SUPPLIER_STATE,
		SPSKU_SUPPLIER_COUNTRY_ID,SPSKU_SUPPLIER_POST,SKU_STATUSINFOID,SKU_STATUS,SKU_DISPLAYSTATUS,SKU_STATUS_UPDATEDON)
		SELECT
		SP.SPACEID,SP.NAME,SP.SEQUENCEORDER,SP.TYPE,MERCH_SP.MERCHANTSPACEID,MERCH_SP.SKUCOUNT,
		CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
			THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
			ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END AS MERCH_SPACE_CREATOR,
		''DEALPACK'' AS SKU_TYPE,SP_DEALPK.DEALPACKID AS SKU_ID,SP_DEALPK.DESCRIPTION  AS SKU_DESCRIPTION,SP_DEALPK.DEALPACKNUMBER  AS SKU_NUMBER,
		'''' AS SKU_LOB, ''''  AS SKU_CATEGORY,
		CASE WHEN (U2.FIRSTNAME IS NOT NULL AND LEN(U2.FIRSTNAME) > 0) AND (U2.LASTNAME IS NOT NULL AND LEN(U2.LASTNAME) > 0) 
			THEN U2.FIRSTNAME+'' ''+U2.LASTNAME 	ELSE CASE WHEN (U2.FIRSTNAME IS NOT NULL AND LEN(U2.FIRSTNAME) > 0) THEN U2.FIRSTNAME 
			ELSE CASE WHEN (U2.LASTNAME IS NOT NULL AND LEN(U2.LASTNAME) > 0) THEN U2.LASTNAME ELSE U2.LOGINNAME END END END  AS SKU_SUBMITTED_BY,
		DEALPK_SP_SKUINFO.EXIT_STRATEGY,DEALPK_SP_SKUINFO.PICTURED_SKU,DEALPK_SP_SKUINFO.PROMO_RETAIL,
		DEALPK_SP_SKUINFO.ETHNIC_ITEM,DEALPK_SP_SKUINFO.COMMENTS,DEALPK_SP_SKUINFO.SIGNAGEREQUIRED,DEALPK_SP_SKUINFO.COUPONREQUIRED,
		DEALPK_SP_SKUINFO.SGN_DESCRIPTION,DEALPK_SP_SKUINFO.SGN_STARTDATE,DEALPK_SP_SKUINFO.SGN_ENDDATE,
		DEALPK_SP_SKUINFO.SGN_PLANNEDCOOP,DEALPK_SP_SKUINFO.SGN_COMMENTS,DEALPK_SP_SKUINFO.CPN_DESCRIPTION,DEALPK_SP_SKUINFO.CPN_STARTDATE,
		DEALPK_SP_SKUINFO.CPN_ENDDATE,DEALPK_SP_SKUINFO.CPN_PLANNEDCOOP,DEALPK_SP_SKUINFO.CPN_COMMENTS,
		DEALPK_SP_SKUINFO.NEWBASERETAILPRICE,DEALPK_SP_SKUINFO.PROJ_SALESUNIT,DEALPK_SP_SKUINFO.VERSION,DEALPK_SP_SKUINFO.SPECIALCOST,DEALPK_SP_SKUINFO.FUTURECOST,
		'''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''',
		'''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''',
		'''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''',
		STATUS_INFO.STATUSINFOID,STATUS_INFO.STATUS,STATUS_INFO.DISPLAYSTATUS,STATUS_INFO.UPDATEDON
		FROM
		ALENT_SPACE SP INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 104440846828760 AND A1.CONTAINERID = SP.SPACEID
		INNER JOIN ALENT_MERCHANTSPACE MERCH_SP
		ON A1.CONTAINSID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 233359019855197 AND A2.CONTAINERID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALENT_USER U1
		ON A2.CONTAINSID = U1.USERID
		INNER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 182010965220158 AND A3.CONTAINERID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALENT_SPACEDEALPACK SP_DEALPK
		ON A3.CONTAINSID = SP_DEALPK.DEALPACKID
		LEFT OUTER JOIN ALOM_ASSEMBLY A6
		ON A6.RELATIONSHIPTYPEID = 159779964176815 AND A6.CONTAINERID = SP_DEALPK.DEALPACKID
		LEFT OUTER JOIN ALENT_USER U2
		ON A6.CONTAINSID = U2.USERID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
		ON ASF1.RELATIONSHIPTYPEID = 236449225828644 AND ASF1.ENTITYID = SP_DEALPK.DEALPACKID
		LEFT OUTER JOIN ALFCT_SPACESKUINFO DEALPK_SP_SKUINFO
		ON ASF1.FACETID = DEALPK_SP_SKUINFO.SKUINFOID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
		ON ASF2.RELATIONSHIPTYPEID = 191952690328782 AND ASF2.ENTITYID = SP_DEALPK.DEALPACKID
		LEFT OUTER JOIN ALFCT_STATUSINFO STATUS_INFO
		ON ASF2.FACETID = STATUS_INFO.STATUSINFOID

		UNION ALL
		SELECT
		SP.SPACEID,SP.NAME,SP.SEQUENCEORDER,SP.TYPE,MERCH_SP.MERCHANTSPACEID,MERCH_SP.SKUCOUNT,
		CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
			THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
			ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END  AS MERCH_SPACE_CREATOR,
		''SPACESKU'' AS SKU_TYPE,MERCH_SPSKU.SKUID AS SKU_ID,MERCH_SPSKU.DESCRIPTION  AS SKU_DESCRIPTION,MERCH_SPSKU.SKUNUMBER AS SKU_NUMBER,MERCH_SPSKU.LOB AS SKU_LOB,
		MERCH_SPSKU.CATEGORY  AS SKU_CATEGORY, 
		CASE WHEN (U5.FIRSTNAME IS NOT NULL AND LEN(U5.FIRSTNAME) > 0) AND (U5.LASTNAME IS NOT NULL AND LEN(U5.LASTNAME) > 0) 
			THEN U5.FIRSTNAME+'' ''+U5.LASTNAME 	ELSE CASE WHEN (U5.FIRSTNAME IS NOT NULL AND LEN(U5.FIRSTNAME) > 0) THEN U5.FIRSTNAME 
			ELSE CASE WHEN (U5.LASTNAME IS NOT NULL AND LEN(U5.LASTNAME) > 0) THEN U5.LASTNAME ELSE U5.LOGINNAME END END END   SKU_SUBMITTED_BY,
		SPSKU_SPSKUINFO.EXIT_STRATEGY,SPSKU_SPSKUINFO.PICTURED_SKU,SPSKU_SPSKUINFO.PROMO_RETAIL,
		SPSKU_SPSKUINFO.ETHNIC_ITEM,SPSKU_SPSKUINFO.COMMENTS,SPSKU_SPSKUINFO.SIGNAGEREQUIRED,SPSKU_SPSKUINFO.COUPONREQUIRED,
		SPSKU_SPSKUINFO.SGN_DESCRIPTION,SPSKU_SPSKUINFO.SGN_STARTDATE,SPSKU_SPSKUINFO.SGN_ENDDATE,
		SPSKU_SPSKUINFO.SGN_PLANNEDCOOP,SPSKU_SPSKUINFO.SGN_COMMENTS,SPSKU_SPSKUINFO.CPN_DESCRIPTION,SPSKU_SPSKUINFO.CPN_STARTDATE,
		SPSKU_SPSKUINFO.CPN_ENDDATE,SPSKU_SPSKUINFO.CPN_PLANNEDCOOP,SPSKU_SPSKUINFO.CPN_COMMENTS,
		SPSKU_SPSKUINFO.NEWBASERETAILPRICE,SPSKU_SPSKUINFO.PROJ_SALESUNIT,SPSKU_SPSKUINFO.VERSION,SPSKU_SPSKUINFO.SPECIALCOST,SPSKU_SPSKUINFO.FUTURECOST,
		COUPON_SUPPINFO.PLANNEDCOOP,COUPON_SUPPINFO.ACTUALCOOP,COUPON_SUPPINFO.SUPPLIERFUNDING,
		CPN_SUPP.SUPPLIERNUMBER,CPN_SUPP.SUPPLIERNAME,CPN_SUPP.ISDELETED,CPN_SUPP_INFO.CONTACTNAME,
		CPN_SUPP_INFO.CONTACTPHONE,CPN_SUPP_INFO.SUPPLIERSTATUS,CPN_SUPP_INFO.PAYMENT_METHOD,CPN_SUPP_INFO.ADD_1,
		CPN_SUPP_INFO.ADD_2,CPN_SUPP_INFO.ADD_3,CPN_SUPP_INFO.CITY,CPN_SUPP_INFO.STATE,CPN_SUPP_INFO.COUNTRY_ID,CPN_SUPP_INFO.POST,
		SIGNAGE_SUPPINFO.PLANNEDCOOP,SIGNAGE_SUPPINFO.ACTUALCOOP,SIGNAGE_SUPPINFO.SUPPLIERFUNDING,
		SGN_SUPP.SUPPLIERNUMBER,SGN_SUPP.SUPPLIERNAME,SGN_SUPP.ISDELETED,SGN_SUPP_INFO.CONTACTNAME,
		SGN_SUPP_INFO.CONTACTPHONE,SGN_SUPP_INFO.SUPPLIERSTATUS,SGN_SUPP_INFO.PAYMENT_METHOD,SGN_SUPP_INFO.ADD_1,
		SGN_SUPP_INFO.ADD_2,SGN_SUPP_INFO.ADD_3,SGN_SUPP_INFO.CITY,SGN_SUPP_INFO.STATE,SGN_SUPP_INFO.COUNTRY_ID,SGN_SUPP_INFO.POST,
		SPSKU_SUPPINFO.PLANNEDCOOP,SPSKU_SUPPINFO.ACTUALCOOP,SPSKU_SUPPINFO.SUPPLIERFUNDING,
		SPSKU_SUPP.SUPPLIERNUMBER,SPSKU_SUPP.SUPPLIERNAME,SPSKU_SUPP.ISDELETED,SPSKU_SUPP_INFO.CONTACTNAME,
		SPSKU_SUPP_INFO.CONTACTPHONE,SPSKU_SUPP_INFO.SUPPLIERSTATUS,SPSKU_SUPP_INFO.PAYMENT_METHOD,SPSKU_SUPP_INFO.ADD_1,
		SPSKU_SUPP_INFO.ADD_2,SPSKU_SUPP_INFO.ADD_3,SPSKU_SUPP_INFO.CITY,SPSKU_SUPP_INFO.STATE,SPSKU_SUPP_INFO.COUNTRY_ID,SPSKU_SUPP_INFO.POST,
		STATUS_INFO.STATUSINFOID,STATUS_INFO.STATUS,STATUS_INFO.DISPLAYSTATUS,STATUS_INFO.UPDATEDON
		FROM
		ALENT_SPACE SP INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 104440846828760 AND A1.CONTAINERID = SP.SPACEID
		INNER JOIN ALENT_MERCHANTSPACE MERCH_SP
		ON A1.CONTAINSID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 233359019855197 AND A2.CONTAINERID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALENT_USER U1
		ON A2.CONTAINSID = U1.USERID
		INNER JOIN ALOM_ASSEMBLY A4
		ON A4.RELATIONSHIPTYPEID = 35758227497283 AND A4.CONTAINERID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALENT_SPACESKU MERCH_SPSKU
		ON A4.CONTAINSID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALOM_ASSEMBLY A11
		ON A11.RELATIONSHIPTYPEID = 263729557075358 AND A11.CONTAINERID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALENT_USER U5
		ON A11.CONTAINSID = U5.USERID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
		ON ASF2.RELATIONSHIPTYPEID = 198348331020165 AND ASF2.ENTITYID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO COUPON_SUPPINFO
		ON ASF2.FACETID = COUPON_SUPPINFO.SPACESKUSUPPLIERINFOID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF6
		ON ASF6.RELATIONSHIPTYPEID = 16883071957179 AND ASF6.FACETID = COUPON_SUPPINFO.SPACESKUSUPPLIERINFOID
		LEFT OUTER JOIN ALENT_SUPPLIER CPN_SUPP
		ON ASF6.ENTITYID = CPN_SUPP.SUPPLIERID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF7
		ON ASF7.RELATIONSHIPTYPEID = 81591767562663 AND ASF7.ENTITYID = CPN_SUPP.SUPPLIERID
		LEFT OUTER JOIN ALFCT_SUPPLIERINFO CPN_SUPP_INFO
		ON ASF7.FACETID = CPN_SUPP_INFO.SUPPLIERINFOID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF3
		ON ASF3.RELATIONSHIPTYPEID = 184014968158662 AND ASF3.ENTITYID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO SIGNAGE_SUPPINFO
		ON ASF3.FACETID = SIGNAGE_SUPPINFO.SPACESKUSUPPLIERINFOID


		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF8
		ON ASF8.RELATIONSHIPTYPEID = 117027347086441 AND ASF8.FACETID = SIGNAGE_SUPPINFO.SPACESKUSUPPLIERINFOID
		LEFT OUTER JOIN ALENT_SUPPLIER SGN_SUPP
		ON ASF8.ENTITYID = SGN_SUPP.SUPPLIERID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF9
		ON ASF9.RELATIONSHIPTYPEID = 81591767562663 AND ASF9.ENTITYID = SGN_SUPP.SUPPLIERID
		LEFT OUTER JOIN ALFCT_SUPPLIERINFO SGN_SUPP_INFO
		ON ASF9.FACETID = SGN_SUPP_INFO.SUPPLIERINFOID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF4
		ON ASF4.RELATIONSHIPTYPEID = 133066652071295 AND ASF4.ENTITYID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALFCT_SPACESKUINFO SPSKU_SPSKUINFO
		ON ASF4.FACETID = SPSKU_SPSKUINFO.SKUINFOID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF5
		ON ASF5.RELATIONSHIPTYPEID = 81730785471838 AND ASF5.ENTITYID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO SPSKU_SUPPINFO
		ON ASF5.FACETID = SPSKU_SUPPINFO.SPACESKUSUPPLIERINFOID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF10
		ON ASF10.RELATIONSHIPTYPEID = 103780178105647 AND ASF10.FACETID = SPSKU_SUPPINFO.SPACESKUSUPPLIERINFOID
		LEFT OUTER JOIN ALENT_SUPPLIER SPSKU_SUPP
		ON ASF10.ENTITYID = SPSKU_SUPP.SUPPLIERID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF11
		ON ASF11.RELATIONSHIPTYPEID = 81591767562663 AND ASF11.ENTITYID = SPSKU_SUPP.SUPPLIERID
		LEFT OUTER JOIN ALFCT_SUPPLIERINFO SPSKU_SUPP_INFO
		ON ASF11.FACETID = SPSKU_SUPP_INFO.SUPPLIERINFOID

		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF12
		ON ASF12.RELATIONSHIPTYPEID = 15671872327911 AND ASF12.ENTITYID = MERCH_SPSKU.SKUID
		LEFT OUTER JOIN ALFCT_STATUSINFO STATUS_INFO
		ON ASF12.FACETID = STATUS_INFO.STATUSINFOID


		UNION ALL
		SELECT
		SP.SPACEID,SP.NAME,SP.SEQUENCEORDER,SP.TYPE,MERCH_SP.MERCHANTSPACEID,MERCH_SP.SKUCOUNT,
		CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
			THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
			ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END  AS MERCH_SPACE_CREATOR,
		''SKULIST'',SP_SKULI.SKULISTID,SP_SKULI.DESCRIPTION,SP_SKULI.SKULISTNUMBER,'''','''',
		CASE WHEN (U4.FIRSTNAME IS NOT NULL AND LEN(U4.FIRSTNAME) > 0) AND (U4.LASTNAME IS NOT NULL AND LEN(U4.LASTNAME) > 0) 
			THEN U4.FIRSTNAME+'' ''+U4.LASTNAME 	ELSE CASE WHEN (U4.FIRSTNAME IS NOT NULL AND LEN(U4.FIRSTNAME) > 0) THEN U4.FIRSTNAME 
			ELSE CASE WHEN (U4.LASTNAME IS NOT NULL AND LEN(U4.LASTNAME) > 0) THEN U4.LASTNAME ELSE U4.LOGINNAME END END END ,
		SPSKULI_SPSKUINFO.EXIT_STRATEGY,SPSKULI_SPSKUINFO.PICTURED_SKU,SPSKULI_SPSKUINFO.PROMO_RETAIL,
		SPSKULI_SPSKUINFO.ETHNIC_ITEM,SPSKULI_SPSKUINFO.COMMENTS,SPSKULI_SPSKUINFO.SIGNAGEREQUIRED,SPSKULI_SPSKUINFO.COUPONREQUIRED,
		SPSKULI_SPSKUINFO.SGN_DESCRIPTION,SPSKULI_SPSKUINFO.SGN_STARTDATE,SPSKULI_SPSKUINFO.SGN_ENDDATE,
		SPSKULI_SPSKUINFO.SGN_PLANNEDCOOP,SPSKULI_SPSKUINFO.SGN_COMMENTS,SPSKULI_SPSKUINFO.CPN_DESCRIPTION,SPSKULI_SPSKUINFO.CPN_STARTDATE,
		SPSKULI_SPSKUINFO.CPN_ENDDATE,SPSKULI_SPSKUINFO.CPN_PLANNEDCOOP,SPSKULI_SPSKUINFO.CPN_COMMENTS,
		SPSKULI_SPSKUINFO.NEWBASERETAILPRICE,SPSKULI_SPSKUINFO.PROJ_SALESUNIT,SPSKULI_SPSKUINFO.VERSION,SPSKULI_SPSKUINFO.SPECIALCOST,SPSKULI_SPSKUINFO.FUTURECOST,
		'''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''',
		'''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''',
		'''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''','''',
		STATUS_INFO.STATUSINFOID,STATUS_INFO.STATUS,STATUS_INFO.DISPLAYSTATUS,STATUS_INFO.UPDATEDON
		FROM
		ALENT_SPACE SP INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 104440846828760 AND A1.CONTAINERID = SP.SPACEID
		INNER JOIN ALENT_MERCHANTSPACE MERCH_SP
		ON A1.CONTAINSID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 233359019855197 AND A2.CONTAINERID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALENT_USER U1
		ON A2.CONTAINSID = U1.USERID
		INNER JOIN ALOM_ASSEMBLY A5
		ON A5.RELATIONSHIPTYPEID = 178365968804051 AND A5.CONTAINERID = MERCH_SP.MERCHANTSPACEID
		INNER JOIN ALENT_SPACESKULIST SP_SKULI
		ON A5.CONTAINSID = SP_SKULI.SKULISTID
		LEFT OUTER JOIN ALOM_ASSEMBLY A9
		ON A9.RELATIONSHIPTYPEID = 118770991713375 AND A9.CONTAINERID = SP_SKULI.SKULISTID
		LEFT OUTER JOIN ALENT_USER U4
		ON A9.CONTAINSID = U4.USERID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF6
		ON ASF6.RELATIONSHIPTYPEID = 107474730058197 AND ASF6.ENTITYID = SP_SKULI.SKULISTID
		LEFT OUTER JOIN ALFCT_SPACESKUINFO SPSKULI_SPSKUINFO
		ON ASF6.FACETID = SPSKULI_SPSKUINFO.SKUINFOID 
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF7
		ON ASF7.RELATIONSHIPTYPEID = 14188740261461 AND ASF7.ENTITYID = SP_SKULI.SKULISTID
		LEFT OUTER JOIN ALFCT_STATUSINFO STATUS_INFO
		ON ASF7.FACETID = STATUS_INFO.STATUSINFOID ')
			
			
			
		EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_DP_SKL_SKUDETAILS
			(PARENT_SKU_ID,SKUID,SKU_DESCRIPTION,SKUNUMBER,SKU_LOB,SKU_CATEGORY,SKU_CREATEDON,
			SKU_ISOBSOLETE,SKU_LASTUPDATEDON,SKU_SUBMITTED_BY,SKUINFO_EXIT_STRATEGY,SKUINFO_PICTURED_SKU,
			SKUINFO_PROMO_RETAIL,SKUINFO_ETHNIC_ITEM,SKUINFO_COMMENTS,SKUINFO_SIGNAGEREQUIRED,
			SKUINFO_COUPONREQUIRED,SKUINFO_SGN_DESCRIPTION,SKUINFO_SGN_STARTDATE,SKUINFO_SGN_ENDDATE,
			SKUINFO_SGN_PLANNEDCOOP,SKUINFO_SGN_COMMENTS,SKUINFO_CPN_DESCRIPTION,SKUINFO_CPN_STARTDATE,
			SKUINFO_CPN_ENDDATE,SKUINFO_CPN_PLANNEDCOOP,SKUINFO_CPN_COMMENTS,SKUINFO_NEWBASERETAILPRICE,
			SKUINFO_PROJ_SALESUNIT,SKUINFO_VERSION,SKUINFO_SPECIALCOST,SKUINFO_FUTURECOST,SUPP_COUPON_PLANNEDCOOP,
			SUPP_COUPON_ACTUALCOOP,SUPP_COUPON_SUPPLIERFUNDING,CPN_SUPPLIER_NUMBER,CPN_SUPPLIER_NAME,CPN_SUPPLIER_ISDELETED,
			CPN_SUPPLIER_CONTACTNAME,CPN_SUPPLIER_CONTACTPHONE,CPN_SUPPLIER_STATUS,CPN_SUPP_PAYMENT_METHOD,
			CPN_SUPPLIER_ADD_1,CPN_SUPPLIER_ADD_2,CPN_SUPPLIER_ADD_3,CPN_SUPPLIER_CITY,CPN_SUPPLIER_STATE,
			CPN_SUPPLIER_COUNTRY_ID,CPN_SUPPLIER_POST,SUPP_SIGNAGE_PLANNEDCOOP,SUPP_SIGNAGE_ACTUALCOOP,SUPP_SIGNAGE_SUPPLIERFUNDING,
			SGN_SUPPLIER_NUMBER,SGN_SUPPLIER_NAME,SGN_SUPPLIER_ISDELETED,SGN_SUPPLIER_CONTACTNAME,
			SGN_SUPPLIER_CONTACTPHONE,SGN_SUPPLIER_STATUS,SGN_SUPP_PAYMENT_METHOD,SGN_SUPPLIER_ADD_1,
			SGN_SUPPLIER_ADD_2,SGN_SUPPLIER_ADD_3,SGN_SUPPLIER_CITY,SGN_SUPPLIER_STATE,SGN_SUPPLIER_COUNTRY_ID,
			SGN_SUPPLIER_POST,SUPP_SPSKU_PLANNEDCOOP,SUPP_SPSKU_ACTUALCOOP,SUPP_SPSKU_SUPPLIERFUNDING,SPSKU_SUPPLIER_NUMBER,SPSKU_SUPPLIER_NAME,
			SPSKU_SUPPLIER_ISDELETED,SPSKU_SUPPLIER_CONTACTNAME,SPSKU_SUPPLIER_CONTACTPHONE,SPSKU_SUPPLIER_STATUS,
			SPSKU_SUPP_PAYMENT_METHOD,SPSKU_SUPPLIER_ADD_1,SPSKU_SUPPLIER_ADD_2,SPSKU_SUPPLIER_ADD_3,SPSKU_SUPPLIER_CITY,
			SPSKU_SUPPLIER_STATE,SPSKU_SUPPLIER_COUNTRY_ID,SPSKU_SUPPLIER_POST)
			SELECT
			DEALPK.DEALPACKID,SPSKU.SKUID,SPSKU.DESCRIPTION,SPSKU.SKUNUMBER,SPSKU.LOB,SPSKU.CATEGORY,
			SPSKU.CREATEDON,SPSKU.ISOBSOLETE,SPSKU.LASTUPDATEDON,
			CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
				THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
				ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END  AS SKU_SUBMITTED_BY,
			SPSKU_SPSKUINFO.EXIT_STRATEGY,SPSKU_SPSKUINFO.PICTURED_SKU,SPSKU_SPSKUINFO.PROMO_RETAIL,
			SPSKU_SPSKUINFO.ETHNIC_ITEM,SPSKU_SPSKUINFO.COMMENTS,SPSKU_SPSKUINFO.SIGNAGEREQUIRED,SPSKU_SPSKUINFO.COUPONREQUIRED,
			SPSKU_SPSKUINFO.SGN_DESCRIPTION,SPSKU_SPSKUINFO.SGN_STARTDATE,SPSKU_SPSKUINFO.SGN_ENDDATE,
			SPSKU_SPSKUINFO.SGN_PLANNEDCOOP,SPSKU_SPSKUINFO.SGN_COMMENTS,SPSKU_SPSKUINFO.CPN_DESCRIPTION,SPSKU_SPSKUINFO.CPN_STARTDATE,
			SPSKU_SPSKUINFO.CPN_ENDDATE,SPSKU_SPSKUINFO.CPN_PLANNEDCOOP,SPSKU_SPSKUINFO.CPN_COMMENTS,
			SPSKU_SPSKUINFO.NEWBASERETAILPRICE,SPSKU_SPSKUINFO.PROJ_SALESUNIT,SPSKU_SPSKUINFO.VERSION,SPSKU_SPSKUINFO.SPECIALCOST,SPSKU_SPSKUINFO.FUTURECOST,
			COUPON_SUPPINFO.PLANNEDCOOP,COUPON_SUPPINFO.ACTUALCOOP,COUPON_SUPPINFO.SUPPLIERFUNDING,
			CPN_SUPP.SUPPLIERNUMBER,CPN_SUPP.SUPPLIERNAME,CPN_SUPP.ISDELETED,CPN_SUPP_INFO.CONTACTNAME,
			CPN_SUPP_INFO.CONTACTPHONE,CPN_SUPP_INFO.SUPPLIERSTATUS,CPN_SUPP_INFO.PAYMENT_METHOD,CPN_SUPP_INFO.ADD_1,
			CPN_SUPP_INFO.ADD_2,CPN_SUPP_INFO.ADD_3,CPN_SUPP_INFO.CITY,CPN_SUPP_INFO.STATE,CPN_SUPP_INFO.COUNTRY_ID,CPN_SUPP_INFO.POST,
			SIGNAGE_SUPPINFO.PLANNEDCOOP,SIGNAGE_SUPPINFO.ACTUALCOOP,SIGNAGE_SUPPINFO.SUPPLIERFUNDING,
			SGN_SUPP.SUPPLIERNUMBER,SGN_SUPP.SUPPLIERNAME,SGN_SUPP.ISDELETED,SGN_SUPP_INFO.CONTACTNAME,
			SGN_SUPP_INFO.CONTACTPHONE,SGN_SUPP_INFO.SUPPLIERSTATUS,SGN_SUPP_INFO.PAYMENT_METHOD,SGN_SUPP_INFO.ADD_1,
			SGN_SUPP_INFO.ADD_2,SGN_SUPP_INFO.ADD_3,SGN_SUPP_INFO.CITY,SGN_SUPP_INFO.STATE,SGN_SUPP_INFO.COUNTRY_ID,SGN_SUPP_INFO.POST,
			SPSKU_SUPPINFO.PLANNEDCOOP,SPSKU_SUPPINFO.ACTUALCOOP,SPSKU_SUPPINFO.SUPPLIERFUNDING,
			SPSKU_SUPP.SUPPLIERNUMBER,SPSKU_SUPP.SUPPLIERNAME,SPSKU_SUPP.ISDELETED,SPSKU_SUPP_INFO.CONTACTNAME,
			SPSKU_SUPP_INFO.CONTACTPHONE,SPSKU_SUPP_INFO.SUPPLIERSTATUS,SPSKU_SUPP_INFO.PAYMENT_METHOD,SPSKU_SUPP_INFO.ADD_1,
			SPSKU_SUPP_INFO.ADD_2,SPSKU_SUPP_INFO.ADD_3,SPSKU_SUPP_INFO.CITY,SPSKU_SUPP_INFO.STATE,SPSKU_SUPP_INFO.COUNTRY_ID,SPSKU_SUPP_INFO.POST
			
			FROM
			ALENT_SPACEDEALPACK DEALPK LEFT OUTER JOIN ALOM_ASSEMBLY A1
			ON A1.RELATIONSHIPTYPEID = 39957711323025 AND A1.CONTAINERID = DEALPK.DEALPACKID
			LEFT OUTER JOIN ALENT_SPACESKU SPSKU
			ON A1.CONTAINSID = SPSKU.SKUID
			
			LEFT OUTER JOIN ALOM_ASSEMBLY A2
			ON A2.RELATIONSHIPTYPEID = 263729557075358 AND A2.CONTAINERID = SPSKU.SKUID
			LEFT OUTER JOIN ALENT_USER U1
			ON A2.CONTAINSID = U1.USERID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
			ON ASF2.RELATIONSHIPTYPEID = 198348331020165 AND ASF2.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO COUPON_SUPPINFO
			ON ASF2.FACETID = COUPON_SUPPINFO.SPACESKUSUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF6
			ON ASF6.RELATIONSHIPTYPEID = 16883071957179 AND ASF6.FACETID = COUPON_SUPPINFO.SPACESKUSUPPLIERINFOID
			LEFT OUTER JOIN ALENT_SUPPLIER CPN_SUPP
			ON ASF6.ENTITYID = CPN_SUPP.SUPPLIERID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF7
			ON ASF7.RELATIONSHIPTYPEID = 81591767562663 AND ASF7.ENTITYID = CPN_SUPP.SUPPLIERID
			LEFT OUTER JOIN ALFCT_SUPPLIERINFO CPN_SUPP_INFO
			ON ASF7.FACETID = CPN_SUPP_INFO.SUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF3
			ON ASF3.RELATIONSHIPTYPEID = 184014968158662 AND ASF3.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO SIGNAGE_SUPPINFO
			ON ASF3.FACETID = SIGNAGE_SUPPINFO.SPACESKUSUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF8
			ON ASF8.RELATIONSHIPTYPEID = 117027347086441 AND ASF8.FACETID = SIGNAGE_SUPPINFO.SPACESKUSUPPLIERINFOID
			LEFT OUTER JOIN ALENT_SUPPLIER SGN_SUPP
			ON ASF8.ENTITYID = SGN_SUPP.SUPPLIERID
		
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF9
			ON ASF9.RELATIONSHIPTYPEID = 81591767562663 AND ASF9.ENTITYID = SGN_SUPP.SUPPLIERID
			LEFT OUTER JOIN ALFCT_SUPPLIERINFO SGN_SUPP_INFO
			ON ASF9.FACETID = SGN_SUPP_INFO.SUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF4
			ON ASF4.RELATIONSHIPTYPEID = 133066652071295 AND ASF4.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUINFO SPSKU_SPSKUINFO
			ON ASF4.FACETID = SPSKU_SPSKUINFO.SKUINFOID
			
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF5
			ON ASF5.RELATIONSHIPTYPEID = 81730785471838 AND ASF5.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO SPSKU_SUPPINFO
			ON ASF5.FACETID = SPSKU_SUPPINFO.SPACESKUSUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF10
			ON ASF10.RELATIONSHIPTYPEID = 103780178105647 AND ASF10.FACETID = SPSKU_SUPPINFO.SPACESKUSUPPLIERINFOID
			LEFT OUTER JOIN ALENT_SUPPLIER SPSKU_SUPP
			ON ASF10.ENTITYID = SPSKU_SUPP.SUPPLIERID
		
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF11
			ON ASF11.RELATIONSHIPTYPEID = 81591767562663 AND ASF11.ENTITYID = SPSKU_SUPP.SUPPLIERID
			LEFT OUTER JOIN ALFCT_SUPPLIERINFO SPSKU_SUPP_INFO
			ON ASF11.FACETID = SPSKU_SUPP_INFO.SUPPLIERINFOID
			
			UNION ALL
			
			SELECT
			SP_SKULI.SKULISTID,SPSKU.SKUID,SPSKU.DESCRIPTION,SPSKU.SKUNUMBER,SPSKU.LOB,SPSKU.CATEGORY,
			SPSKU.CREATEDON,SPSKU.ISOBSOLETE,SPSKU.LASTUPDATEDON,
			CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) AND (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) 
					THEN U1.FIRSTNAME+'' ''+U1.LASTNAME 	ELSE CASE WHEN (U1.FIRSTNAME IS NOT NULL AND LEN(U1.FIRSTNAME) > 0) THEN U1.FIRSTNAME 
				ELSE CASE WHEN (U1.LASTNAME IS NOT NULL AND LEN(U1.LASTNAME) > 0) THEN U1.LASTNAME ELSE U1.LOGINNAME END END END  AS SKU_SUBMITTED_BY,
			SPSKU_SPSKUINFO.EXIT_STRATEGY,SPSKU_SPSKUINFO.PICTURED_SKU,SPSKU_SPSKUINFO.PROMO_RETAIL,
			SPSKU_SPSKUINFO.ETHNIC_ITEM,SPSKU_SPSKUINFO.COMMENTS,SPSKU_SPSKUINFO.SIGNAGEREQUIRED,SPSKU_SPSKUINFO.COUPONREQUIRED,
			SPSKU_SPSKUINFO.SGN_DESCRIPTION,SPSKU_SPSKUINFO.SGN_STARTDATE,SPSKU_SPSKUINFO.SGN_ENDDATE,
			SPSKU_SPSKUINFO.SGN_PLANNEDCOOP,SPSKU_SPSKUINFO.SGN_COMMENTS,SPSKU_SPSKUINFO.CPN_DESCRIPTION,SPSKU_SPSKUINFO.CPN_STARTDATE,
			SPSKU_SPSKUINFO.CPN_ENDDATE,SPSKU_SPSKUINFO.CPN_PLANNEDCOOP,SPSKU_SPSKUINFO.CPN_COMMENTS,
			SPSKU_SPSKUINFO.NEWBASERETAILPRICE,SPSKU_SPSKUINFO.PROJ_SALESUNIT,SPSKU_SPSKUINFO.VERSION,SPSKU_SPSKUINFO.SPECIALCOST,SPSKU_SPSKUINFO.FUTURECOST,
			COUPON_SUPPINFO.PLANNEDCOOP,COUPON_SUPPINFO.ACTUALCOOP,COUPON_SUPPINFO.SUPPLIERFUNDING,
			CPN_SUPP.SUPPLIERNUMBER,CPN_SUPP.SUPPLIERNAME,CPN_SUPP.ISDELETED,CPN_SUPP_INFO.CONTACTNAME,
			CPN_SUPP_INFO.CONTACTPHONE,CPN_SUPP_INFO.SUPPLIERSTATUS,CPN_SUPP_INFO.PAYMENT_METHOD,CPN_SUPP_INFO.ADD_1,
			CPN_SUPP_INFO.ADD_2,CPN_SUPP_INFO.ADD_3,CPN_SUPP_INFO.CITY,CPN_SUPP_INFO.STATE,CPN_SUPP_INFO.COUNTRY_ID,CPN_SUPP_INFO.POST,
			SIGNAGE_SUPPINFO.PLANNEDCOOP,SIGNAGE_SUPPINFO.ACTUALCOOP,SIGNAGE_SUPPINFO.SUPPLIERFUNDING,
			SGN_SUPP.SUPPLIERNUMBER,SGN_SUPP.SUPPLIERNAME,SGN_SUPP.ISDELETED,SGN_SUPP_INFO.CONTACTNAME,
			SGN_SUPP_INFO.CONTACTPHONE,SGN_SUPP_INFO.SUPPLIERSTATUS,SGN_SUPP_INFO.PAYMENT_METHOD,SGN_SUPP_INFO.ADD_1,
			SGN_SUPP_INFO.ADD_2,SGN_SUPP_INFO.ADD_3,SGN_SUPP_INFO.CITY,SGN_SUPP_INFO.STATE,SGN_SUPP_INFO.COUNTRY_ID,SGN_SUPP_INFO.POST,
			SPSKU_SUPPINFO.PLANNEDCOOP,SPSKU_SUPPINFO.ACTUALCOOP,SPSKU_SUPPINFO.SUPPLIERFUNDING,
			SPSKU_SUPP.SUPPLIERNUMBER,SPSKU_SUPP.SUPPLIERNAME,SPSKU_SUPP.ISDELETED,SPSKU_SUPP_INFO.CONTACTNAME,
			SPSKU_SUPP_INFO.CONTACTPHONE,SPSKU_SUPP_INFO.SUPPLIERSTATUS,SPSKU_SUPP_INFO.PAYMENT_METHOD,SPSKU_SUPP_INFO.ADD_1,
			SPSKU_SUPP_INFO.ADD_2,SPSKU_SUPP_INFO.ADD_3,SPSKU_SUPP_INFO.CITY,SPSKU_SUPP_INFO.STATE,SPSKU_SUPP_INFO.COUNTRY_ID,SPSKU_SUPP_INFO.POST
			FROM
			ALENT_SPACESKULIST SP_SKULI LEFT OUTER JOIN ALOM_ASSEMBLY A1
			ON A1.RELATIONSHIPTYPEID = 254808987384454 AND A1.CONTAINERID = SP_SKULI.SKULISTID
			LEFT OUTER JOIN ALENT_SPACESKU SPSKU
			ON A1.CONTAINSID = SPSKU.SKUID
			
			LEFT OUTER JOIN ALOM_ASSEMBLY A2
			ON A2.RELATIONSHIPTYPEID = 263729557075358 AND A2.CONTAINERID = SPSKU.SKUID
			LEFT OUTER JOIN ALENT_USER U1
			ON A2.CONTAINSID = U1.USERID
		
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
			ON ASF2.RELATIONSHIPTYPEID = 198348331020165 AND ASF2.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO COUPON_SUPPINFO
			ON ASF2.FACETID = COUPON_SUPPINFO.SPACESKUSUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF6
			ON ASF6.RELATIONSHIPTYPEID = 16883071957179 AND ASF6.FACETID = COUPON_SUPPINFO.SPACESKUSUPPLIERINFOID
			LEFT OUTER JOIN ALENT_SUPPLIER CPN_SUPP
			ON ASF6.ENTITYID = CPN_SUPP.SUPPLIERID
		
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF7
			ON ASF7.RELATIONSHIPTYPEID = 81591767562663 AND ASF7.ENTITYID = CPN_SUPP.SUPPLIERID
			LEFT OUTER JOIN ALFCT_SUPPLIERINFO CPN_SUPP_INFO
			ON ASF7.FACETID = CPN_SUPP_INFO.SUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF3
			ON ASF3.RELATIONSHIPTYPEID = 184014968158662 AND ASF3.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO SIGNAGE_SUPPINFO
			ON ASF3.FACETID = SIGNAGE_SUPPINFO.SPACESKUSUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF8
			ON ASF8.RELATIONSHIPTYPEID = 117027347086441 AND ASF8.FACETID = SIGNAGE_SUPPINFO.SPACESKUSUPPLIERINFOID
			LEFT OUTER JOIN ALENT_SUPPLIER SGN_SUPP
			ON ASF8.ENTITYID = SGN_SUPP.SUPPLIERID
		
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF9
			ON ASF9.RELATIONSHIPTYPEID = 81591767562663 AND ASF9.ENTITYID = SGN_SUPP.SUPPLIERID
			LEFT OUTER JOIN ALFCT_SUPPLIERINFO SGN_SUPP_INFO
			ON ASF9.FACETID = SGN_SUPP_INFO.SUPPLIERINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF4
			ON ASF4.RELATIONSHIPTYPEID = 133066652071295 AND ASF4.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUINFO SPSKU_SPSKUINFO
			ON ASF4.FACETID = SPSKU_SPSKUINFO.SKUINFOID
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF5
			ON ASF5.RELATIONSHIPTYPEID = 81730785471838 AND ASF5.ENTITYID = SPSKU.SKUID
			LEFT OUTER JOIN ALFCT_SPACESKUSUPPLIERINFO SPSKU_SUPPINFO
			ON ASF5.FACETID = SPSKU_SUPPINFO.SPACESKUSUPPLIERINFOID 
			
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF10
			ON ASF10.RELATIONSHIPTYPEID = 103780178105647 AND ASF10.FACETID = SPSKU_SUPPINFO.SPACESKUSUPPLIERINFOID
			LEFT OUTER JOIN ALENT_SUPPLIER SPSKU_SUPP
			ON ASF10.ENTITYID = SPSKU_SUPP.SUPPLIERID
		
			LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF11
			ON ASF11.RELATIONSHIPTYPEID = 81591767562663 AND ASF11.ENTITYID = SPSKU_SUPP.SUPPLIERID
			LEFT OUTER JOIN ALFCT_SUPPLIERINFO SPSKU_SUPP_INFO
			ON ASF11.FACETID = SPSKU_SUPP_INFO.SUPPLIERINFOID')
		
		EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSFORECASTINFO
		(PLANID,PLAN_TITLE,FISCALYEAR,BU_ID,BU_NAME,BU_LEVEL_NO,BU_PATH,
		BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,BU_LEVEL4_NAME,BU_LEVEL5_NAME,
		MA_ID,MA_NAME,MA_DESCRIPTION,MA_TYPE,MA_STATUS,
		MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,
		MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,
		FORECASTINFORMATIONID,FORECAST_AMOUNT_CURRENCY,FORECAST_AMOUNT,FORECAST_PERIOD,
		FORECAST_NHVALUE,FORECAST_DURATION)
		SELECT
		PLAN1.PLANID,PLAN1.TITLE ,PLAN1.FISCALYEAR ,
		BU.BUSINESSUNITID,BU.NAME,BU.BUSINESSUNITLEVEL,BU.PATH,
		'''','''','''','''','''',
		MA1.MARKETINGACTIVITYID AS MA_ID,MA1.NAME ,MA1.DESCRIPTION,MA1.ACTIVITYTYPE ,MA1.STATUS ,
		''''  ,'''' ,'''' ,'''' ,'''' ,
		'''' ,'''' ,'''' ,'''' ,
		FCINFO.FORECASTINFORMATIONID,
		FCINFO.AMOUNT_C FORECASTINFO_AMOUNT_CURRENCY,
		FCINFO.AMOUNT_A FORECASTINFO_AMOUNT,
		FCINFO.PERIOD,
		FCINFO.NHVALUE,
		FCINFO.DURATION
		FROM
		ALENT_PLAN PLAN1 INNER JOIN ALOM_ASSEMBLY A1 
		ON A1.RELATIONSHIPTYPEID = 141014623932230 AND A1.CONTAINERID = PLAN1.PLANID
		INNER JOIN ALENT_BUSINESSUNIT BU ON A1.CONTAINSID = BU.BUSINESSUNITID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = PLAN1.PLANID
		INNER JOIN ALENT_MARKETINGACTIVITY MA1
		ON A2.CONTAINSID = MA1.MARKETINGACTIVITYID
		INNER JOIN ALOM_ASSOENTITYFACET ASF1
		ON ASF1.RELATIONSHIPTYPEID = 275091204012350 AND ASF1.ENTITYID = MA1.MARKETINGACTIVITYID
		INNER JOIN ALFCT_FORECASTINFORMATION FCINFO
		ON ASF1.FACETID = FCINFO.FORECASTINFORMATIONID ')
		
		EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_TIMESHEETS
		(TIMESHEET_DETAILS_ID,PLANID,PLAN_TITLE,FISCALYEAR,BU_LEVEL1_ID,BU_LEVEL2_ID,BU_LEVEL3_ID,
		BU_LEVEL4_ID,BU_LEVEL5_ID,BU_LEVEL1_NAME,BU_LEVEL2_NAME,BU_LEVEL3_NAME,
		BU_LEVEL4_NAME,BU_LEVEL5_NAME,
		MA_LEVEL1_ID,MA_LEVEL2_ID,MA_LEVEL3_ID,MA_LEVEL4_ID,MA_LEVEL5_ID,
		MA_LEVEL1_NAME,MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,
		MA_TYPE_LEVEL1_NAME,MA_TYPE_LEVEL2_NAME,
		MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,BU_ID,BU_NAME,MA_ID,MA_NAME,
		MA_TYPE,MA_STATUS,MA_LEVEL_NO,PROJECTID,PROJECT_NEXTID,PR_TITLE,PR_STARTDATE,
		PR_DUEDATE,PR_COMPLETEDON,PR_STATUS,PR_PERCENTDONE,PR_PM_USER_ID,
		PR_PM_NAME,PR_APM_USER_ID,PR_APM_NAME,TIMESHEETID,TS_STATUS,TS_COMMENTS,
		TS_CREATEDON_DATE,TS_REVIEWEDON_DATE,TS_SUBMITTEDON_DATE,TS_ANOMALY_CONST,
		FROMTIMESHEETDATE,TOTIMESHEETDATE,ISDAILY,TIMESHEET_CREATEDBY_NAME,
		TIMESHEET_REVIEWEDBY_NAME,TIMESHEETITEMSID,TSITEM_UTILIZATION,TSITEM_UNIT_OF_MEASURE,
		TSITEM_DESCRIPTION,TSITEM_MISC_TASK,RESOURCECATID,RESOURCECATNAME,RESOURCECAT_LEVEL_NO,
		RESCAT_LEVEL1_NAME,RESCAT_LEVEL2_NAME,RESCAT_LEVEL3_NAME,RESCAT_LEVEL4_NAME,RESCAT_LEVEL5_NAME,
		RESCAT_DESCRIPTION,RESCAT_PATH,RESCAT_HEAD_USER_ID,RESCAT_HEAD_NAME,ISRESCATOBSOLETE)
		SELECT * FROM TEMP_TIMESHEETS  ')
	
	SELECT  @DB_NAME = DB.NAME 
	FROM
	SYS.SYSPROCESSES SP INNER JOIN SYS.DATABASES DB
	ON SP.DBID = DB.DATABASE_ID AND SP.SPID = (SELECT @@SPID)
	
	DBCC SHRINKDATABASE (@DB_NAME)
GO
	



CREATE PROCEDURE ODS_PROJECT_DETAILS (@MOM_DB_NAME NVARCHAR(100))
AS

	SET NOCOUNT ON
	
	DECLARE @ODS_DB_NAME NVARCHAR(100)
	
	SELECT @ODS_DB_NAME = @MOM_DB_NAME+'_ODS'

	EXEC (N' TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSWORKFLOW')
	EXEC (N' TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_ACTIVITY_INFO')


	EXEC ('INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSWORKFLOW 
		SELECT DISTINCT PROJECT.WORKFLOWPROCESSID,
		ALPLAN.PLANID, ALPLAN.TITLE PLAN_TITLE, ALPLAN.STATUS PLAN_STATUS, ALPLAN.FISCALYEAR PLAN_FISCALYEAR, BU.NAME BU_NAME,
		MKT_ACT.NAME ACTIVITYNAME, REPLACE(MKT_ACT.ACTIVITYPATH,''$ALP$'','' >> '')+'' >> ''+MKT_ACT.NAME ACTIVITYPATH,  MKT_ACT.ACTIVITYLEVEL,
		PROJECT.WORKFLOWPROCESSUNIQUEID PROJECTID, PROJECT.PROCESSNAME PR_TITLE, PROJECT.STARTDATE PR_STARTDATE, PROJECT.DUEDATE PR_DUEDATE, 
		PROJECT.ACTUALENDDATE PR_COMPLETEDON, PROJECT.STATUS PR_STATUS, WPINFO_1.PERCENTDONE PR_PERCENTDONE, WPINFO_1.PROCESSDEFINITIONID PROJECTTYPEID, 
		PM.USERID PMUSERID, PM.LOGINNAME PM_LOGIN, PM.FIRSTNAME PM_FNAME, PM.MIDDLEINITIAL PM_MNAME, PM.LASTNAME PM_LNAME,
		APM.USERID APMUSERID, APM.LOGINNAME APM_LOGIN, APM.FIRSTNAME APM_FNAME, APM.MIDDLEINITIAL APM_MNAME, APM.LASTNAME APM_LNAME,NULL,
		NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
		NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,PROJECT.WORKFLOWPROCESSID,NULL,NULL,WINFO.WORKFLOWCATEGORY,WINFO.WORKFLOWSUBCATEGORY
		FROM  ALENT_WORKFLOWPROCESS PROJECT 
		INNER JOIN ALOM_ASSOENTITYFACET AEF INNER JOIN ALFCT_WORKFLOWINFORMATION WINFO 
		ON ( AEF.RELATIONSHIPTYPEID =  154951847894 AND AEF.FACETID = WINFO.WORKFLOWINFORMATIONID AND WINFO.WORKFLOWCATEGORY = ''PROJECT'')
		ON PROJECT.WORKFLOWPROCESSID = AEF.ENTITYID  
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF1 INNER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_1 
		ON AEF1.RELATIONSHIPTYPEID = 109574871933848 AND AEF1.FACETID = WPINFO_1.WORKFLOWPROCESSINFOID
		ON PROJECT.WORKFLOWPROCESSID = AEF1.ENTITYID
		LEFT OUTER JOIN ALOM_ASSEMBLY A1 /* ProjectManager */ INNER JOIN ALENT_USER PM 
		ON A1.RELATIONSHIPTYPEID = 1549518477 AND A1.CONTAINSID = PM.USERID
		ON PROJECT.WORKFLOWPROCESSID = A1.CONTAINERID
		LEFT OUTER JOIN ALOM_ASSEMBLY ASM1 /* ActingProjectManager */ INNER JOIN ALENT_USER APM 
		ON ASM1.RELATIONSHIPTYPEID = 1549518478 AND ASM1.CONTAINSID = APM.USERID 
		ON PROJECT.WORKFLOWPROCESSID = ASM1.CONTAINERID
		LEFT OUTER JOIN ALOM_ASSEMBLY A21 INNER JOIN ALENT_ACTIVITY ACT_PROJ 
			ON A21.RELATIONSHIPTYPEID = 154010190849386 AND A21.CONTAINSID = ACT_PROJ.ACTIVITYID 
				AND STARTACTIVITY = ''FALSE'' AND ENDACTIVITY = ''FALSE''
		ON PROJECT.WORKFLOWPROCESSID = A21.CONTAINERID
		LEFT OUTER JOIN ALOM_ASSEMBLY A11 ON A11.CONTAINSID = PROJECT.WORKFLOWPROCESSID AND A11.RELATIONSHIPTYPEID = 243764143699371 /* MARKETINGACTIVITY_PROJECT */
		LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MKT_ACT ON MKT_ACT.MARKETINGACTIVITYID = A11.CONTAINERID 
		LEFT OUTER JOIN  ALOM_ASSEMBLY A10 ON MKT_ACT.MARKETINGACTIVITYID = A10.CONTAINSID AND A10.RELATIONSHIPTYPEID in (38934607864244,198303327217807) /* MARKETING_ACTIVITIES_FOR_PLAN */
		LEFT OUTER JOIN ALENT_PLAN ALPLAN ON A10.CONTAINERID = ALPLAN.PLANID
		LEFT OUTER JOIN ALOM_ASSEMBLY A12 /* Plan-BU */ ON ALPLAN.PLANID = A12.CONTAINERID AND A12.RELATIONSHIPTYPEID = 141014623932230
		LEFT OUTER JOIN ALENT_BUSINESSUNIT BU ON A12.CONTAINSID = BU.BUSINESSUNITID ')
		
	--2 PROJECT+DELIVERABLES --244
		EXEC (N'INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSWORKFLOW 
		SELECT DISTINCT DELIVERABLE.WORKFLOWPROCESSID,
		ALPLAN.PLANID, ALPLAN.TITLE PLAN_TITLE, ALPLAN.STATUS PLAN_STATUS, ALPLAN.FISCALYEAR PLAN_FISCALYEAR, BU.NAME BU_NAME,
		MKT_ACT.NAME ACTIVITYNAME, REPLACE(MKT_ACT.ACTIVITYPATH,''$ALP$'','' >> '')+'' >> ''+MKT_ACT.NAME ACTIVITYPATH,  MKT_ACT.ACTIVITYLEVEL,
		PROJECT.WORKFLOWPROCESSUNIQUEID PROJECTID, PROJECT.PROCESSNAME PR_TITLE, PROJECT.STARTDATE PR_STARTDATE, PROJECT.DUEDATE PR_DUEDATE, 
		PROJECT.ACTUALENDDATE PR_COMPLETEDON, PROJECT.STATUS PR_STATUS, WPINFO_1.PERCENTDONE PR_PERCENTDONE, WPINFO_1.PROCESSDEFINITIONID , 
		PM.USERID PMUSERID, PM.LOGINNAME PM_LOGIN, PM.FIRSTNAME PM_FNAME, PM.MIDDLEINITIAL PM_MNAME, PM.LASTNAME PM_LNAME,
		APM.USERID APMUSERID, APM.LOGINNAME APM_LOGIN, APM.FIRSTNAME APM_FNAME, APM.MIDDLEINITIAL APM_MNAME, APM.LASTNAME APM_LNAME,
		--DELIVERABLE
		DELIVERABLE.WORKFLOWPROCESSUNIQUEID DELIVERABLEID, DELIVERABLE.PROCESSNAME DEL_TITLE, DELIVERABLE.STARTDATE DEL_STARTDATE, DELIVERABLE.DUEDATE DEL_DUEDATE,
		DELIVERABLE.ACTUALENDDATE DEL_COMPLETEDON, DELIVERABLE.STATUS DEL_STATUS, WPINFO_2.PERCENTDONE DEL_PERCENTDONE,WPINFO_2.PROCESSDEFINITIONID,  
		DEL_MGR.USERID DMUSERID, DEL_MGR.LOGINNAME DM_LOGIN, DEL_MGR.FIRSTNAME DM_FNAME, DEL_MGR.MIDDLEINITIAL DM_MNAME, DEL_MGR.LASTNAME DM_LNAME,
		NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
		PROJECT.WORKFLOWPROCESSID,DELIVERABLE.WORKFLOWPROCESSID,NULL,WINFON1.WORKFLOWCATEGORY,WINFON1.WORKFLOWSUBCATEGORY
		
		FROM  ALENT_WORKFLOWPROCESS PROJECT 
		INNER JOIN ALOM_ASSOENTITYFACET AEF INNER JOIN ALFCT_WORKFLOWINFORMATION WINFO 
		ON ( AEF.RELATIONSHIPTYPEID =  154951847894 AND AEF.FACETID = WINFO.WORKFLOWINFORMATIONID AND WINFO.WORKFLOWCATEGORY = ''PROJECT'')
		ON PROJECT.WORKFLOWPROCESSID = AEF.ENTITYID  
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF1 INNER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_1 
		ON AEF1.RELATIONSHIPTYPEID = 109574871933848 AND AEF1.FACETID = WPINFO_1.WORKFLOWPROCESSINFOID
		ON PROJECT.WORKFLOWPROCESSID = AEF1.ENTITYID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY A1 /* ProjectManager */ INNER JOIN ALENT_USER PM 
		ON A1.RELATIONSHIPTYPEID = 1549518477 AND A1.CONTAINSID = PM.USERID
		ON PROJECT.WORKFLOWPROCESSID = A1.CONTAINERID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY ASM1 /* ActingProjectManager */ INNER JOIN ALENT_USER APM 
		ON ASM1.RELATIONSHIPTYPEID = 1549518478 AND ASM1.CONTAINSID = APM.USERID 
		ON PROJECT.WORKFLOWPROCESSID = ASM1.CONTAINERID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY A21 INNER JOIN ALENT_ACTIVITY ACT_PROJ 
			ON A21.RELATIONSHIPTYPEID = 154010190849386 AND A21.CONTAINSID = ACT_PROJ.ACTIVITYID 
				AND STARTACTIVITY = ''FALSE'' AND ENDACTIVITY = ''FALSE''
		ON PROJECT.WORKFLOWPROCESSID = A21.CONTAINERID			
		
		-- DELIVERABLE
		INNER JOIN ALOM_ASSEMBLY A2 /* Deliverable */ ON ACT_PROJ.ACTIVITYID = A2.CONTAINERID AND A2.RELATIONSHIPTYPEID = 181099347959840
		INNER JOIN ALENT_WORKFLOWPROCESS DELIVERABLE ON A2.CONTAINSID = DELIVERABLE.WORKFLOWPROCESSID
		--
		INNER JOIN ALOM_ASSOENTITYFACET AEF22 ON AEF22.RELATIONSHIPTYPEID =  154951847894 AND AEF22.ENTITYID = DELIVERABLE.WORKFLOWPROCESSID
		INNER JOIN ALFCT_WORKFLOWINFORMATION WINFON1 ON AEF22.FACETID = WINFON1.WORKFLOWINFORMATIONID
		--
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2 ON DELIVERABLE.WORKFLOWPROCESSID = AEF2.ENTITYID AND AEF2.RELATIONSHIPTYPEID = 109574871933848
		LEFT OUTER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_2 ON AEF2.FACETID = WPINFO_2.WORKFLOWPROCESSINFOID
		LEFT OUTER JOIN  ALOM_ASSEMBLY A4 /* DELIVERABLE_MGR */	ON DELIVERABLE.WORKFLOWPROCESSID = A4.CONTAINERID AND A4.RELATIONSHIPTYPEID = 224755037807667
		LEFT OUTER JOIN ALENT_USER DEL_MGR ON A4.CONTAINSID = DEL_MGR.USERID 
		
		LEFT OUTER JOIN ALOM_ASSEMBLY A11 ON A11.CONTAINSID = PROJECT.WORKFLOWPROCESSID AND A11.RELATIONSHIPTYPEID = 243764143699371 /* MARKETINGACTIVITY_PROJECT */
		LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MKT_ACT ON MKT_ACT.MARKETINGACTIVITYID = A11.CONTAINERID 
		LEFT OUTER JOIN  ALOM_ASSEMBLY A10 ON MKT_ACT.MARKETINGACTIVITYID = A10.CONTAINSID AND A10.RELATIONSHIPTYPEID in (38934607864244,198303327217807) /* MARKETING_ACTIVITIES_FOR_PLAN */
		LEFT OUTER JOIN ALENT_PLAN ALPLAN ON A10.CONTAINERID = ALPLAN.PLANID
		LEFT OUTER JOIN ALOM_ASSEMBLY A12 /* Plan-BU */ ON ALPLAN.PLANID = A12.CONTAINERID AND A12.RELATIONSHIPTYPEID = 141014623932230
		LEFT OUTER JOIN ALENT_BUSINESSUNIT BU ON A12.CONTAINSID = BU.BUSINESSUNITID ')
	
	--3 PROJECT+DELIVERABLES+TASKS
		EXEC (N'INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSWORKFLOW
		SELECT DISTINCT TASK.WORKFLOWPROCESSID, 
		ALPLAN.PLANID, ALPLAN.TITLE PLAN_TITLE, ALPLAN.STATUS PLAN_STATUS, ALPLAN.FISCALYEAR PLAN_FISCALYEAR, BU.NAME BU_NAME,
		MKT_ACT.NAME ACTIVITYNAME, REPLACE(MKT_ACT.ACTIVITYPATH,''$ALP$'','' >> '')+'' >> ''+MKT_ACT.NAME ACTIVITYPATH,  MKT_ACT.ACTIVITYLEVEL,
		PROJECT.WORKFLOWPROCESSUNIQUEID PROJECTID, PROJECT.PROCESSNAME PR_TITLE, PROJECT.STARTDATE PR_STARTDATE, PROJECT.DUEDATE PR_DUEDATE, 
		PROJECT.ACTUALENDDATE PR_COMPLETEDON, PROJECT.STATUS PR_STATUS, WPINFO_1.PERCENTDONE PR_PERCENTDONE, WPINFO_1.PROCESSDEFINITIONID , 
		PM.USERID PMUSERID, PM.LOGINNAME PM_LOGIN, PM.FIRSTNAME PM_FNAME, PM.MIDDLEINITIAL PM_MNAME, PM.LASTNAME PM_LNAME,
		APM.USERID APMUSERID, APM.LOGINNAME APM_LOGIN, APM.FIRSTNAME APM_FNAME, APM.MIDDLEINITIAL APM_MNAME, APM.LASTNAME APM_LNAME,
		--DELIVERABLE
		DELIVERABLE.WORKFLOWPROCESSUNIQUEID DELIVERABLEID, DELIVERABLE.PROCESSNAME DEL_TITLE, DELIVERABLE.STARTDATE DEL_STARTDATE, DELIVERABLE.DUEDATE DEL_DUEDATE,
		DELIVERABLE.ACTUALENDDATE DEL_COMPLETEDON, DELIVERABLE.STATUS DEL_STATUS, WPINFO_2.PERCENTDONE DEL_PERCENTDONE,WPINFO_2.PROCESSDEFINITIONID,  
		DEL_MGR.USERID DMUSERID, DEL_MGR.LOGINNAME DM_LOGIN, DEL_MGR.FIRSTNAME DM_FNAME, DEL_MGR.MIDDLEINITIAL DM_MNAME, DEL_MGR.LASTNAME DM_LNAME,
		-- TASK
		TASK.WORKFLOWPROCESSUNIQUEID TASKID, TASK.PROCESSNAME TASK_TITLE, ACT_PROJ.SEQUENCENUMBER TASK_SEQ_NO, TASK.STARTDATE TASK_STARTDATE, TASK.DUEDATE TASK_DUEDATE, 
		TASK.ACTUALENDDATE TASK_COMPLETEDON, TASK.STATUS TASK_STATUS, WPINFO_3.PERCENTDONE TASK_PERCENTDONE,WPINFO_3.PROCESSDEFINITIONID, TASK_INITIATOR.USERID TIUSERID, 
		TASK_INITIATOR.LOGINNAME TI_LOGIN,	TASK_INITIATOR.FIRSTNAME TI_FNAME, TASK_INITIATOR.MIDDLEINITIAL TI_MNAME, TASK_INITIATOR.LASTNAME TI_LNAME,
		NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,PROJECT.WORKFLOWPROCESSID,DELIVERABLE.WORKFLOWPROCESSID,TASK.WORKFLOWPROCESSID,
		WINFON2.WORKFLOWCATEGORY,WINFON2.WORKFLOWSUBCATEGORY
		
		
		FROM  ALENT_WORKFLOWPROCESS PROJECT 
		INNER JOIN ALOM_ASSOENTITYFACET AEF INNER JOIN ALFCT_WORKFLOWINFORMATION WINFO 
		ON ( AEF.RELATIONSHIPTYPEID =  154951847894 AND AEF.FACETID = WINFO.WORKFLOWINFORMATIONID AND WINFO.WORKFLOWCATEGORY = ''PROJECT'')
		ON PROJECT.WORKFLOWPROCESSID = AEF.ENTITYID  
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF1 INNER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_1 
		ON AEF1.RELATIONSHIPTYPEID = 109574871933848 AND AEF1.FACETID = WPINFO_1.WORKFLOWPROCESSINFOID
		ON PROJECT.WORKFLOWPROCESSID = AEF1.ENTITYID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY A1 /* ProjectManager */ INNER JOIN ALENT_USER PM 
		ON A1.RELATIONSHIPTYPEID = 1549518477 AND A1.CONTAINSID = PM.USERID
		ON PROJECT.WORKFLOWPROCESSID = A1.CONTAINERID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY ASM1 /* ActingProjectManager */ INNER JOIN ALENT_USER APM 
		ON ASM1.RELATIONSHIPTYPEID = 1549518478 AND ASM1.CONTAINSID = APM.USERID 
		ON PROJECT.WORKFLOWPROCESSID = ASM1.CONTAINERID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY A21 INNER JOIN ALENT_ACTIVITY ACT_PROJ 
			ON A21.RELATIONSHIPTYPEID = 154010190849386 AND A21.CONTAINSID = ACT_PROJ.ACTIVITYID 
				AND STARTACTIVITY = ''FALSE'' AND ENDACTIVITY = ''FALSE''
		ON PROJECT.WORKFLOWPROCESSID = A21.CONTAINERID			
		-- DELIVERABLE
		INNER JOIN ALOM_ASSEMBLY A2 /* Deliverable */ ON ACT_PROJ.ACTIVITYID = A2.CONTAINERID AND A2.RELATIONSHIPTYPEID = 181099347959840
		INNER JOIN ALENT_WORKFLOWPROCESS DELIVERABLE ON A2.CONTAINSID = DELIVERABLE.WORKFLOWPROCESSID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2 ON DELIVERABLE.WORKFLOWPROCESSID = AEF2.ENTITYID AND AEF2.RELATIONSHIPTYPEID = 109574871933848
		LEFT OUTER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_2 ON AEF2.FACETID = WPINFO_2.WORKFLOWPROCESSINFOID
		LEFT OUTER JOIN  ALOM_ASSEMBLY A4 /* DELIVERABLE_MGR */	ON DELIVERABLE.WORKFLOWPROCESSID = A4.CONTAINERID AND A4.RELATIONSHIPTYPEID = 224755037807667
		LEFT OUTER JOIN ALENT_USER DEL_MGR ON A4.CONTAINSID = DEL_MGR.USERID 
		
		-- TASK
		INNER JOIN  ALOM_ASSEMBLY A5 /* Deliverable_Task */ ON DELIVERABLE.WORKFLOWPROCESSID = A5.CONTAINERID AND A5.RELATIONSHIPTYPEID = 104837164729839
		INNER JOIN ALENT_WORKFLOWPROCESS TASK ON A5.CONTAINSID = TASK.WORKFLOWPROCESSID
		--
		INNER JOIN ALOM_ASSOENTITYFACET AEF22 ON AEF22.RELATIONSHIPTYPEID =  154951847894 AND AEF22.ENTITYID = TASK.WORKFLOWPROCESSID
		INNER JOIN ALFCT_WORKFLOWINFORMATION WINFON2 ON AEF22.FACETID = WINFON2.WORKFLOWINFORMATIONID
		--
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF3 ON TASK.WORKFLOWPROCESSID = AEF3.ENTITYID AND AEF3.RELATIONSHIPTYPEID = 109574871933848
		LEFT OUTER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_3 ON AEF3.FACETID = WPINFO_3.WORKFLOWPROCESSINFOID
		
		/*
		LEFT OUTER JOIN (SELECT CONTAINERID,CONTAINSID,RELATIONSHIPTYPEID
							FROM ALOM_ASSEMBLY WHERE RELATIONSHIPTYPEID = 118382844651456
							AND ASSEMBLYID = (SELECT MIN(AS1.ASSEMBLYID) FROM ALOM_ASSEMBLY AS1
							WHERE AS1.CONTAINERID = ALOM_ASSEMBLY.CONTAINERID AND AS1.RELATIONSHIPTYPEID = 118382844651456)) A6
		LEFT OUTER JOIN ALENT_USER TASK_INITIATOR ON A6.CONTAINSID = TASK_INITIATOR.USERID
		*/
		
		LEFT OUTER JOIN  ALOM_ASSEMBLY A6 /* TASK_INITIATOR */ ON TASK.WORKFLOWPROCESSID = A6.CONTAINERID AND A6.RELATIONSHIPTYPEID = 118382844651456
		LEFT OUTER JOIN ALENT_USER TASK_INITIATOR ON A6.CONTAINSID = TASK_INITIATOR.USERID
		
		LEFT OUTER JOIN ALOM_ASSEMBLY A11 ON A11.CONTAINSID = PROJECT.WORKFLOWPROCESSID AND A11.RELATIONSHIPTYPEID = 243764143699371 /* MARKETINGACTIVITY_PROJECT */
		LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MKT_ACT ON MKT_ACT.MARKETINGACTIVITYID = A11.CONTAINERID 
		LEFT OUTER JOIN  ALOM_ASSEMBLY A10 ON MKT_ACT.MARKETINGACTIVITYID = A10.CONTAINSID AND A10.RELATIONSHIPTYPEID in (38934607864244,198303327217807) /* MARKETING_ACTIVITIES_FOR_PLAN */
		LEFT OUTER JOIN ALENT_PLAN ALPLAN ON A10.CONTAINERID = ALPLAN.PLANID
		LEFT OUTER JOIN ALOM_ASSEMBLY A12 /* Plan-BU */ ON ALPLAN.PLANID = A12.CONTAINERID AND A12.RELATIONSHIPTYPEID = 141014623932230
		LEFT OUTER JOIN ALENT_BUSINESSUNIT BU ON A12.CONTAINSID = BU.BUSINESSUNITID ')
		
	--4 PROJECT+DELIVERABLES+TASKS+STEPS
		EXEC (N'INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSWORKFLOW
		SELECT DISTINCT STEP.ACTIVITYID,
		ALPLAN.PLANID, ALPLAN.TITLE PLAN_TITLE, ALPLAN.STATUS PLAN_STATUS, ALPLAN.FISCALYEAR PLAN_FISCALYEAR, BU.NAME BU_NAME,
		MKT_ACT.NAME ACTIVITYNAME, REPLACE(MKT_ACT.ACTIVITYPATH,''$ALP$'','' >> '')+'' >> ''+MKT_ACT.NAME ACTIVITYPATH,  MKT_ACT.ACTIVITYLEVEL,
		PROJECT.WORKFLOWPROCESSUNIQUEID PROJECTID, PROJECT.PROCESSNAME PR_TITLE, PROJECT.STARTDATE PR_STARTDATE, PROJECT.DUEDATE PR_DUEDATE, 
		PROJECT.ACTUALENDDATE PR_COMPLETEDON, PROJECT.STATUS PR_STATUS, WPINFO_1.PERCENTDONE PR_PERCENTDONE, WPINFO_1.PROCESSDEFINITIONID , 
		PM.USERID PMUSERID, PM.LOGINNAME PM_LOGIN, PM.FIRSTNAME PM_FNAME, PM.MIDDLEINITIAL PM_MNAME, PM.LASTNAME PM_LNAME,
		APM.USERID APMUSERID, APM.LOGINNAME APM_LOGIN, APM.FIRSTNAME APM_FNAME, APM.MIDDLEINITIAL APM_MNAME, APM.LASTNAME APM_LNAME,
		--DELIVERABLE
		DELIVERABLE.WORKFLOWPROCESSUNIQUEID DELIVERABLEID, DELIVERABLE.PROCESSNAME DEL_TITLE, DELIVERABLE.STARTDATE DEL_STARTDATE, DELIVERABLE.DUEDATE DEL_DUEDATE,
		DELIVERABLE.ACTUALENDDATE DEL_COMPLETEDON, DELIVERABLE.STATUS DEL_STATUS, WPINFO_2.PERCENTDONE DEL_PERCENTDONE,WPINFO_2.PROCESSDEFINITIONID,  
		DEL_MGR.USERID DMUSERID, DEL_MGR.LOGINNAME DM_LOGIN, DEL_MGR.FIRSTNAME DM_FNAME, DEL_MGR.MIDDLEINITIAL DM_MNAME, DEL_MGR.LASTNAME DM_LNAME,
		-- TASK
		TASK.WORKFLOWPROCESSUNIQUEID TASKID, TASK.PROCESSNAME TASK_TITLE, ACT_PROJ.SEQUENCENUMBER TASK_SEQ_NO, TASK.STARTDATE TASK_STARTDATE, TASK.DUEDATE TASK_DUEDATE, 
		TASK.ACTUALENDDATE TASK_COMPLETEDON, TASK.STATUS TASK_STATUS, WPINFO_3.PERCENTDONE TASK_PERCENTDONE,WPINFO_3.PROCESSDEFINITIONID, TASK_INITIATOR.USERID TIUSERID, 
		TASK_INITIATOR.LOGINNAME TI_LOGIN,	TASK_INITIATOR.FIRSTNAME TI_FNAME, TASK_INITIATOR.MIDDLEINITIAL TI_MNAME, TASK_INITIATOR.LASTNAME TI_LNAME,
		--STEP
		STEP.ACTIVITYID STEPID, STEP.ACTIVITYNAME STEPTITLE, STEP.SEQUENCENUMBER STEP_SEQ_NO, STEP.STARTDATE STEP_STARTDATE, STEP.DUEDATE STEP_DUEDATE, 
		STEP.ACTUALENDDATE STEP_COMPLETEDON, STEP.STATUS STEP_STATUS, ACT_INFO.PERCENTDONE STEP_PERCENTDONE,ACT_INFO.ACTIVITYDEFINITIONID, ACT_INFO.SUMMARYVALUE STEP_SUMMARYVALUE, 
		PROJECT.WORKFLOWPROCESSID,DELIVERABLE.WORKFLOWPROCESSID,TASK.WORKFLOWPROCESSID,''STEP'',NULL
		
		FROM  ALENT_WORKFLOWPROCESS PROJECT 
		INNER JOIN ALOM_ASSOENTITYFACET AEF INNER JOIN ALFCT_WORKFLOWINFORMATION WINFO 
		ON ( AEF.RELATIONSHIPTYPEID =  154951847894 AND AEF.FACETID = WINFO.WORKFLOWINFORMATIONID AND WINFO.WORKFLOWCATEGORY = ''PROJECT'')
		ON PROJECT.WORKFLOWPROCESSID = AEF.ENTITYID  
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF1 INNER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_1 
		ON AEF1.RELATIONSHIPTYPEID = 109574871933848 AND AEF1.FACETID = WPINFO_1.WORKFLOWPROCESSINFOID
		ON PROJECT.WORKFLOWPROCESSID = AEF1.ENTITYID
	
		LEFT OUTER JOIN ALOM_ASSEMBLY A1 /* ProjectManager */ INNER JOIN ALENT_USER PM 
		ON A1.RELATIONSHIPTYPEID = 1549518477 AND A1.CONTAINSID = PM.USERID
		ON PROJECT.WORKFLOWPROCESSID = A1.CONTAINERID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY ASM1 /* ActingProjectManager */ INNER JOIN ALENT_USER APM 
		ON ASM1.RELATIONSHIPTYPEID = 1549518478 AND ASM1.CONTAINSID = APM.USERID 
		ON PROJECT.WORKFLOWPROCESSID = ASM1.CONTAINERID
			
		LEFT OUTER JOIN ALOM_ASSEMBLY A21 INNER JOIN ALENT_ACTIVITY ACT_PROJ 
			ON A21.RELATIONSHIPTYPEID = 154010190849386 AND A21.CONTAINSID = ACT_PROJ.ACTIVITYID 
				AND STARTACTIVITY = ''FALSE'' AND ENDACTIVITY = ''FALSE''
		ON PROJECT.WORKFLOWPROCESSID = A21.CONTAINERID			
		
		-- DELIVERABLE
		INNER JOIN ALOM_ASSEMBLY A2 /* Deliverable */ ON ACT_PROJ.ACTIVITYID = A2.CONTAINERID AND A2.RELATIONSHIPTYPEID = 181099347959840
		INNER JOIN ALENT_WORKFLOWPROCESS DELIVERABLE ON A2.CONTAINSID = DELIVERABLE.WORKFLOWPROCESSID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF2 ON DELIVERABLE.WORKFLOWPROCESSID = AEF2.ENTITYID AND AEF2.RELATIONSHIPTYPEID = 109574871933848
		LEFT OUTER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_2 ON AEF2.FACETID = WPINFO_2.WORKFLOWPROCESSINFOID
		LEFT OUTER JOIN  ALOM_ASSEMBLY A4 /* DELIVERABLE_MGR */	ON DELIVERABLE.WORKFLOWPROCESSID = A4.CONTAINERID AND A4.RELATIONSHIPTYPEID = 224755037807667
		LEFT OUTER JOIN ALENT_USER DEL_MGR ON A4.CONTAINSID = DEL_MGR.USERID 
		
		-- TASK
		INNER JOIN  ALOM_ASSEMBLY A5 /* Deliverable_Task */ ON DELIVERABLE.WORKFLOWPROCESSID = A5.CONTAINERID AND A5.RELATIONSHIPTYPEID = 104837164729839
		INNER JOIN ALENT_WORKFLOWPROCESS TASK ON A5.CONTAINSID = TASK.WORKFLOWPROCESSID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF3 ON TASK.WORKFLOWPROCESSID = AEF3.ENTITYID AND AEF3.RELATIONSHIPTYPEID = 109574871933848
		LEFT OUTER JOIN ALFCT_WORKFLOWPROCESSINFO WPINFO_3 ON AEF3.FACETID = WPINFO_3.WORKFLOWPROCESSINFOID
		/*
		LEFT OUTER JOIN (SELECT CONTAINERID,CONTAINSID,RELATIONSHIPTYPEID
							FROM ALOM_ASSEMBLY WHERE RELATIONSHIPTYPEID = 118382844651456
							AND ASSEMBLYID = (SELECT MIN(AS1.ASSEMBLYID) FROM ALOM_ASSEMBLY AS1
							WHERE AS1.CONTAINERID = ALOM_ASSEMBLY.CONTAINERID AND AS1.RELATIONSHIPTYPEID = 118382844651456)) A6
		ON TASK.WORKFLOWPROCESSID = A6.CONTAINERID 	
		*/
		LEFT OUTER JOIN  ALOM_ASSEMBLY A6 /* TASK_INITIATOR */ ON TASK.WORKFLOWPROCESSID = A6.CONTAINERID AND A6.RELATIONSHIPTYPEID = 118382844651456
		LEFT OUTER JOIN ALENT_USER TASK_INITIATOR ON A6.CONTAINSID = TASK_INITIATOR.USERID
			
		--STEP
		INNER JOIN ALOM_ASSEMBLY A22  
		ON A22.RELATIONSHIPTYPEID = 154010190849386 AND TASK.WORKFLOWPROCESSID = A22.CONTAINERID 
		INNER JOIN ALENT_ACTIVITY STEP
		ON 	A22.CONTAINSID = STEP.ACTIVITYID
		AND STEP.STARTACTIVITY = ''FALSE'' AND STEP.ENDACTIVITY = ''FALSE''
		/*
		LEFT OUTER JOIN ALOM_ASSEMBLY A13 ON A13.RELATIONSHIPTYPEID = 202900281682436 AND A13.CONTAINERID = STEP.ACTIVITYID
		LEFT OUTER JOIN ALENT_RESPONSE RESP ON A13.CONTAINSID = RESP.RESPONSEID
		*/
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF4 ON STEP.ACTIVITYID = AEF4.ENTITYID AND AEF4.RELATIONSHIPTYPEID = 79760151954703
		LEFT OUTER JOIN ALFCT_ACTIVITYINFORMATION ACT_INFO ON AEF4.FACETID = ACT_INFO.ACTIVITYINFORMATIONID 
		/*
		LEFT OUTER JOIN  ALOM_ASSEMBLY A8 /* ACTIVITY_CONTRIBUTOR */ ON STEP.ACTIVITYID = A8.CONTAINERID AND A8.RELATIONSHIPTYPEID = 118382844651457
		LEFT OUTER JOIN ALENT_USER STEP_CONTRIBUTOR ON A8.CONTAINSID = STEP_CONTRIBUTOR.USERID
		*/
		-- 
		LEFT OUTER JOIN ALOM_ASSEMBLY A11 ON A11.CONTAINSID = PROJECT.WORKFLOWPROCESSID AND A11.RELATIONSHIPTYPEID = 243764143699371 /* MARKETINGACTIVITY_PROJECT */
		LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MKT_ACT ON MKT_ACT.MARKETINGACTIVITYID = A11.CONTAINERID 
		LEFT OUTER JOIN  ALOM_ASSEMBLY A10 ON MKT_ACT.MARKETINGACTIVITYID = A10.CONTAINSID AND A10.RELATIONSHIPTYPEID in (38934607864244,198303327217807) /* MARKETING_ACTIVITIES_FOR_PLAN */
		LEFT OUTER JOIN ALENT_PLAN ALPLAN ON A10.CONTAINERID = ALPLAN.PLANID
		LEFT OUTER JOIN ALOM_ASSEMBLY A12 /* Plan-BU */ ON ALPLAN.PLANID = A12.CONTAINERID AND A12.RELATIONSHIPTYPEID = 141014623932230
		LEFT OUTER JOIN ALENT_BUSINESSUNIT BU ON A12.CONTAINSID = BU.BUSINESSUNITID ')
		--ORDER BY PR_STARTDATE, PR_TITLE, DEL_STARTDATE, DEL_TITLE, TASK_STARTDATE, TASK_SEQ_NO, TASK_TITLE, STEP_STARTDATE, STEP_SEQ_NO, STEPTITLE 
		
				
		EXEC (N'INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_ACTIVITY_INFO 
		(ACTIVITY_ID,CUSERID,CLOGINNAME,CFNAME,CMNAME,CLNAME,CRESPONSE_ID,CRESPONSE_TEXT,CRESPONSE_POSTEDON)
		SELECT ACTIVITY.ACTIVITYID,USER1.USERID,USER1.LOGINNAME CLOGINNAME, USER1.FIRSTNAME CFNAME, USER1.MIDDLEINITIAL CMNAME, USER1.LASTNAME ,
		RESP.RESPONSEID, RESP.RESPONSETEXT , RESP.RESPONSEPOSTEDON
		FROM
		ALENT_ACTIVITY ACTIVITY  LEFT OUTER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 118382844651457 AND ACTIVITY.ACTIVITYID = A1.CONTAINERID
		LEFT OUTER JOIN ALENT_USER USER1
		ON A1.CONTAINSID = USER1.USERID
		LEFT OUTER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 202900281682436 AND A2.CONTAINERID = ACTIVITY.ACTIVITYID
		LEFT OUTER JOIN ALENT_RESPONSE RESP
		ON A2.CONTAINSID = RESP.RESPONSEID ')
	
GO


/*	ODS DAM STORED PROCEDURE SCRIPT		*/

/*	Prashant Darade		February 22, 2012 15:03 PM	*/

CREATE PROCEDURE LOAD_DAM_DATA_TO_ODS_SP (@MOM_DB_NAME NVARCHAR(75))
AS
	SET NOCOUNT ON

	DECLARE @ODS_DB_NAME NVARCHAR(75)

	SELECT @ODS_DB_NAME = @MOM_DB_NAME+'_ODS'
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSSECTION')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSDIGITALASSET')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOLLECTION')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'SECTION_HIERARCHY')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_AUDITLOG_DAM')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER_LOGIN_LOGOUT')
	
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSSECTION 
		(VAULTID,VAULTTYPE,VA_NAME,VA_MOUNTPOINT,VA_DESCRIPTION,VA_MAXALLOWEDDISKSPACE,
		VA_TOTALUSEDSPACE,VA_ONMEDIASERVER,SECTIONID,SEC_NAME,SEC_PATH,SEC_LEVEL1_NAME,
		SEC_LEVEL2_NAME,SEC_LEVEL3_NAME,SEC_LEVEL4_NAME,SEC_LEVEL5_NAME,SEC_LEVEL6_NAME,
		SEC_LEVEL7_NAME,SEC_LEVEL8_NAME,SEC_LEVEL9_NAME,SEC_LEVEL10_NAME,SEC_DESCRIPTION,
		SEC_ISROOTSECTION,SEC_ISSYSTEMVAULT,SEC_MARKEDASDELETED,SEC_ASSETCOUNTINPATH,
		SEC_ASSETCOUNTINSECTION,SEC_OWNERNAME,SECPOL_ID,SECPOL_NAME,SECPOL_DESCRIPTION)
		SELECT
		VA.VAULTID   AS	VAULTID,
		VA.VAULTTYPE  AS  VAULTTYPE,
		VA.NAME		AS	VA_NAME,
		VA.MOUNTPOINT	AS	VA_MOUNTPOINT,
		VA.DESCRIPTION	AS	VA_DESCRIPTION,
		VA.MAXALLOWEDDISKSPACE	AS  VA_MAXALLOWEDDISKSPACE,
		VA.TOTALUSEDSPACE	AS	VA_TOTALUSEDSPACE,
		VA.ONMEDIASERVER	AS	VA_ONMEDIASERVER,
		SEC.SECTIONID  AS	SECTIONID,
		SEC.NAME   AS 	SEC_NAME,
		SEC.PATH  AS 	SEC_PATH,
		'''' AS 	SEC_LEVEL1_NAME,
		'''' AS 	SEC_LEVEL2_NAME,
		''''  AS 	SEC_LEVEL3_NAME,
		''''  AS 	SEC_LEVEL4_NAME,
		''''  AS	SEC_LEVEL5_NAME,
		''''  AS	SEC_LEVEL6_NAME,
		''''  AS 	SEC_LEVEL7_NAME,
		''''  AS 	SEC_LEVEL8_NAME,
		''''  AS 	SEC_LEVEL9_NAME,
		''''  AS 	SEC_LEVEL10_NAME,
		SEC.DESCRIPTION  AS	SEC_DESCRIPTION,
		SEC.ISROOTSECTION  AS	SEC_ISROOTSECTION,
		SEC.ISSYSTEMVAULT  AS	SEC_ISSYSTEMVAULT,
		SEC.MARKEDASDELETED	SEC_MARKEDASDELETED,
		SEC.ASSETCOUNTINPATH  AS	SEC_ASSETCOUNTINPATH,
		SEC.ASSETCOUNTINSECTION  AS	SEC_ASSETCOUNTINSECTION,
		(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
			THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
			ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  SEC_OWNERNAME,
		SECPOL.SECURITYPOLICYID AS 	SECPOL_ID,
		SECPOL.POLICYNAME  AS 	SECPOL_NAME,
		SECPOL.POLICYDESCRIPTION  AS	SECPOL_DESCRIPTION
		FROM
		ALENT_VAULT VA INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 111100004770838 AND A1.CONTAINERID = VA.VAULTID
		INNER JOIN ALENT_SECTION SEC 
		ON A1.CONTAINSID = SEC.SECTIONID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 109473180943464 AND A2.CONTAINERID = SEC.SECTIONID
		INNER JOIN ALENT_USER USER1
		ON A2.CONTAINSID = USER1.USERID
		INNER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 35121011878728 AND A3.CONTAINERID = SEC.SECTIONID
		INNER JOIN ALENT_SECURITYPOLICY SECPOL
		ON A3.CONTAINSID = SECPOL.SECURITYPOLICYID ')
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSDIGITALASSET
		(VAULTID,VAULTTYPE,VA_NAME,VA_MOUNTPOINT,SECTIONID,SEC_NAME,SEC_PATH,SEC_LEVEL1_NAME,SEC_LEVEL2_NAME,
		SEC_LEVEL3_NAME,SEC_LEVEL4_NAME,SEC_LEVEL5_NAME,SEC_LEVEL6_NAME,SEC_LEVEL7_NAME,SEC_LEVEL8_NAME,
		SEC_LEVEL9_NAME,SEC_LEVEL10_NAME,SEC_DESCRIPTION,SEC_MARKEDASDELETED,SECPOL_ID,SECPOL_NAME,
		MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,MA_LEVEL1_NAME,
		MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
		MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,MA_ID,MA_NAME,MA_DESCRIPTION,
		MA_TYPE,MA_STATUS,DIGITALASSETID,DA_NAME,DA_DESCRIPTION,DA_CREATEDON,DA_VERSIONCATALOGEDON,
		DA_EXPIRYDATE,DA_ASSETEXPIRED,DA_DOWNLOADCOUNT,DA_LASTUPDATEDON,DA_MARKEDASDELETED,
		DA_FROZENON,DA_HASCHILDS,DA_ISCHILD,DA_ISFROZEN,DA_ISLOCKED,DA_LOCKEDON,DA_OWNERNAME,
		DA_NEXTVERSIONNUMBER,DA_CUR_VERSIONID,DA_CUR_VER_NUMBER,DA_CUR_VER_MODIFIEDON,DA_CUR_VER_DESCRIPTION,
		DA_ORG_ASSETRENDITIONID,DA_ORG_FILENAME,DA_ORG_FILEFORMAT,DA_ORG_FILESIZE,DA_ORG_MEDIACREATEDIN,
		DA_ORG_HEIGHT,DA_ORG_WIDTH,DA_ORG_DEPTH,DA_ORG_DPI,DA_PRV_ASSETRENDITIONID,DA_PRV_FILENAME,
		DA_PRV_FILEFORMAT,DA_PRV_FILESIZE,DA_PRV_MEDIACREATEDIN,DA_PRV_HEIGHT,DA_PRV_WIDTH,
		DA_PRV_DEPTH,DA_PRV_DPI,DA_THB_ASSETRENDITIONID,DA_THB_FILENAME,DA_THB_FILEFORMAT,
		DA_THB_FILESIZE,DA_THB_MEDIACREATEDIN,DA_THB_HEIGHT,DA_THB_WIDTH,DA_THB_DEPTH,DA_THB_DPI)
		SELECT
		VA.VAULTID   AS	VAULTID,
		VA.VAULTTYPE  AS  VAULTTYPE,
		VA.NAME		AS	VA_NAME,
		VA.MOUNTPOINT	AS	VA_MOUNTPOINT,
		SEC.SECTIONID  AS	SECTIONID,
		SEC.NAME   AS 	SEC_NAME,
		SEC.PATH  AS 	SEC_PATH,
		'''' AS 	SEC_LEVEL1_NAME,
		'''' AS 	SEC_LEVEL2_NAME,
		''''  AS 	SEC_LEVEL3_NAME,
		''''  AS 	SEC_LEVEL4_NAME,
		''''  AS	SEC_LEVEL5_NAME,
		''''  AS	SEC_LEVEL6_NAME,
		''''  AS 	SEC_LEVEL7_NAME,
		''''  AS 	SEC_LEVEL8_NAME,
		''''  AS 	SEC_LEVEL9_NAME,
		''''  AS 	SEC_LEVEL10_NAME,
		SEC.DESCRIPTION  AS	SEC_DESCRIPTION,
		SEC.MARKEDASDELETED	SEC_MARKEDASDELETED,
		SECPOL.SECURITYPOLICYID AS 	SECPOL_ID,
		SECPOL.POLICYNAME  AS 	SECPOL_NAME,
		''''  AS MA_LEVEL1_NUMBER,
		''''  AS MA_LEVEL2_NUMBER,
		''''  AS MA_LEVEL3_NUMBER,
		''''  AS MA_LEVEL4_NUMBER,
		''''  AS MA_LEVEL5_NUMBER,
		''''  AS MA_LEVEL1_NAME,
		''''  AS MA_LEVEL2_NAME,
		''''  AS MA_LEVEL3_NAME,
		''''  AS MA_LEVEL4_NAME,
		''''  AS MA_LEVEL5_NAME,
		''''  AS MA_TYPE_LEVEL1_NAME,
		''''  AS MA_TYPE_LEVEL2_NAME,
		''''  AS MA_TYPE_LEVEL3_NAME,
		''''  AS MA_TYPE_LEVEL4_NAME,
		MA.MARKETINGACTIVITYID  AS MA_ID,
		MA.NAME  AS MA_NAME,
		MA.DESCRIPTION  AS MA_DESCRIPTION,
		MA.ACTIVITYTYPE  AS MA_TYPE,
		MA.STATUS  AS  MA_STATUS,
		DA.DIGITALASSETID   AS DIGITALASSETID,
		DA.NAME    AS DA_NAME,
		DA.DESCRIPTION    AS DA_DESCRIPTION,
		DA.CREATEDON    AS DA_CREATEDON,
		DA.DATECATALOGED    AS DA_VERSIONCATALOGEDON,
		DA.EXPIRYDATE    AS DA_EXPIRYDATE,
		DA.ASSETEXPIRED    AS DA_ASSETEXPIRED,
		DA.DOWNLOADCOUNT    AS DA_DOWNLOADCOUNT,
		DA.LASTUPDATEDON    AS DA_LASTUPDATEDON,
		DA.MARKEDASDELETED    AS DA_MARKEDASDELETED,
		DA.FROZENON    AS DA_FROZENON,
		DA.HASCHILDS    AS DA_HASCHILDS,
		DA.ISCHILD    AS DA_ISCHILD,
		DA.ISFROZEN    AS DA_ISFROZEN,
		DA.ISLOCKED    AS DA_ISLOCKED,
		DA.LOCKEDON    AS DA_LOCKEDON,
		(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
			THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
			ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  DA_OWNERNAME,
		DA.NEXTVERSIONNUMBER  AS DA_NEXTVERSIONNUMBER,
		CR.CONTENTREVISIONID  AS DA_CUR_VERSIONID,
		CR.VERSIONNUMBER  AS  DA_CUR_VER_NUMBER,
		CR.MODIFIEDON   AS DA_CUR_VER_MODIFIEDON,
		CR.DESCRIPTION   AS  DA_CUR_VER_DESCRIPTION,
		AR1.ASSETRENDITIONID  AS DA_ORG_ASSETRENDITIONID,
		AR1.NAME  AS DA_ORG_FILENAME,
		AR1.FILEFORMAT  AS DA_ORG_FILEFORMAT,
		AR1.FILESIZE  AS DA_ORG_FILESIZE,
		AR1.MEDIACREATEDIN  AS DA_ORG_MEDIACREATEDIN,
		AR1.HEIGHT  AS DA_ORG_HEIGHT,
		AR1.WIDTH  AS DA_ORG_WIDTH,
		AR1.DEPTH  AS DA_ORG_DEPTH,
		AR1.DPI  AS DA_ORG_DPI,
		AR2.ASSETRENDITIONID  AS DA_PRV_ASSETRENDITIONID,
		AR2.NAME  AS DA_PRV_FILENAME,
		AR2.FILEFORMAT  AS DA_PRV_FILEFORMAT,
		AR2.FILESIZE  AS DA_PRV_FILESIZE,
		AR2.MEDIACREATEDIN  AS DA_PRV_MEDIACREATEDIN,
		AR2.HEIGHT  AS DA_PRV_HEIGHT,
		AR2.WIDTH  AS DA_PRV_WIDTH,
		AR2.DEPTH  AS DA_PRV_DEPTH,
		AR2.DPI  AS DA_PRV_DPI,
		AR3.ASSETRENDITIONID  AS DA_THB_ASSETRENDITIONID,
		AR3.NAME  AS DA_THB_FILENAME,
		AR3.FILEFORMAT  AS DA_THB_FILEFORMAT,
		AR3.FILESIZE  AS DA_THB_FILESIZE,
		AR3.MEDIACREATEDIN  AS DA_THB_MEDIACREATEDIN,
		AR3.HEIGHT  AS DA_THB_HEIGHT,
		AR3.WIDTH  AS DA_THB_WIDTH,
		AR3.DEPTH  AS DA_THB_DEPTH,
		AR3.DPI  AS DA_THB_DPI
		FROM
		ALENT_VAULT VA INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 111100004770838 AND A1.CONTAINERID = VA.VAULTID
		INNER JOIN ALENT_SECTION SEC 
		ON A1.CONTAINSID = SEC.SECTIONID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 35121011878728 AND A2.CONTAINERID = SEC.SECTIONID
		INNER JOIN ALENT_SECURITYPOLICY SECPOL
		ON A2.CONTAINSID = SECPOL.SECURITYPOLICYID
		INNER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 94152543310967 AND A3.CONTAINERID = SEC.SECTIONID
		LEFT OUTER JOIN ALENT_DIGITALASSET DA
		ON A3.CONTAINSID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALOM_ASSEMBLY A4
		ON A4.RELATIONSHIPTYPEID = 159621997915744 AND A4.CONTAINSID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA
		ON A4.CONTAINERID = MA.MARKETINGACTIVITYID
		LEFT OUTER JOIN ALOM_ASSEMBLY A9
		ON A9.RELATIONSHIPTYPEID = 157956613799693 AND A9.CONTAINSID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_USER  USER1
		ON A9.CONTAINERID = USER1.USERID
		LEFT OUTER JOIN ALOM_ASSEMBLY A5
		ON A5.RELATIONSHIPTYPEID = 68650608701457 AND A5.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_CONTENTREVISION CR
		ON A5.CONTAINSID = CR.CONTENTREVISIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A6
		ON A6.RELATIONSHIPTYPEID = 102414976430820 AND A6.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_ASSETRENDITION AR1
		ON A6.CONTAINSID = AR1.ASSETRENDITIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A7
		ON A7.RELATIONSHIPTYPEID = 157260760446174 AND A7.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_ASSETRENDITION AR2
		ON A7.CONTAINSID = AR2.ASSETRENDITIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A8
		ON A8.RELATIONSHIPTYPEID = 154146076479866 AND A8.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_ASSETRENDITION AR3
		ON A8.CONTAINSID = AR3.ASSETRENDITIONID  ')
	
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOLLECTION 
		(VAULTID,VAULTTYPE,VA_NAME,VA_MOUNTPOINT,SECTIONID,SEC_NAME,SEC_PATH,SEC_LEVEL1_NAME,SEC_LEVEL2_NAME,
		SEC_LEVEL3_NAME,SEC_LEVEL4_NAME,SEC_LEVEL5_NAME,SEC_LEVEL6_NAME,SEC_LEVEL7_NAME,SEC_LEVEL8_NAME,
		SEC_LEVEL9_NAME,SEC_LEVEL10_NAME,SEC_DESCRIPTION,SEC_MARKEDASDELETED,COLLECTIONID,COL_DESCRIPTION,
		COL_MARKEDASDELETED,COL_NAME,COL_OWNERNAME)
		SELECT 
		VA.VAULTID   AS	VAULTID,
		VA.VAULTTYPE  AS  VAULTTYPE,
		VA.NAME		AS	VA_NAME,
		VA.MOUNTPOINT	AS	VA_MOUNTPOINT,
		SEC.SECTIONID  AS	SECTIONID,
		SEC.NAME   AS 	SEC_NAME,
		SEC.PATH  AS 	SEC_PATH,
		'''' AS 	SEC_LEVEL1_NAME,
		'''' AS 	SEC_LEVEL2_NAME,
		''''  AS 	SEC_LEVEL3_NAME,
		''''  AS 	SEC_LEVEL4_NAME,
		''''  AS	SEC_LEVEL5_NAME,
		''''  AS	SEC_LEVEL6_NAME,
		''''  AS 	SEC_LEVEL7_NAME,
		''''  AS 	SEC_LEVEL8_NAME,
		''''  AS 	SEC_LEVEL9_NAME,
		''''  AS 	SEC_LEVEL10_NAME,
		SEC.DESCRIPTION  AS	SEC_DESCRIPTION,
		SEC.MARKEDASDELETED	SEC_MARKEDASDELETED,
		COL.COLLECTIONID AS 	COLLECTIONID,
		COL.DESCRIPTION AS	COL_DESCRIPTION,
		COL.MARKEDASDELETED AS	COL_MARKEDASDELETED,
		COL.NAME AS	COL_NAME,
		(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
			THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
			ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  COL_OWNERNAME
		FROM
		ALENT_VAULT VA INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 111100004770838 AND A1.CONTAINERID = VA.VAULTID
		INNER JOIN ALENT_SECTION SEC 
		ON A1.CONTAINSID = SEC.SECTIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 148170386940134 AND A2.CONTAINERID = SEC.SECTIONID
		LEFT OUTER JOIN ALENT_COLLECTION COL
		ON A2.CONTAINSID = COL.COLLECTIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 209721613476979 AND A3.CONTAINSID = COL.COLLECTIONID
		LEFT OUTER JOIN ALENT_USER USER1
		ON A3.CONTAINERID = USER1.USERID ')
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'SECTION_HIERARCHY 
		SELECT
		SEC1.SECTIONID AS SEC_ID1,SEC1.NAME  AS SEC1_NAME,
		SEC2.SECTIONID AS SEC_ID2,SEC2.NAME  AS SEC2_NAME,
		SEC3.SECTIONID AS SEC_ID3,SEC3.NAME  AS SEC3_NAME,
		SEC4.SECTIONID AS SEC_ID4,SEC4.NAME  AS SEC4_NAME,
		SEC5.SECTIONID AS SEC_ID5,SEC5.NAME  AS SEC5_NAME,
		SEC6.SECTIONID AS SEC_ID6,SEC6.NAME  AS SEC6_NAME,
		SEC7.SECTIONID AS SEC_ID7,SEC7.NAME  AS SEC7_NAME,
		SEC8.SECTIONID AS SEC_ID8,SEC8.NAME  AS SEC8_NAME,
		SEC9.SECTIONID AS SEC_ID9,SEC9.NAME  AS SEC9_NAME,
		SEC10.SECTIONID AS SEC_ID10,SEC10.NAME  AS SEC10_NAME
		FROM
		ALENT_SECTION SEC1 LEFT OUTER JOIN ALOM_ASSEMBLY A1
		ON A1.CONTAINERID = SEC1.SECTIONID AND A1.RELATIONSHIPTYPEID = 218499833336991
		AND SEC1.ISROOTSECTION = 1
		LEFT OUTER JOIN ALENT_SECTION SEC2
		ON A1.CONTAINSID = SEC2.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A2
		ON SEC2.SECTIONID = A2.CONTAINERID AND A2.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC3
		ON A2.CONTAINSID = SEC3.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A3
		ON SEC3.SECTIONID = A3.CONTAINERID AND A3.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC4
		ON A3.CONTAINSID = SEC4.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A4
		ON SEC4.SECTIONID = A4.CONTAINERID AND A4.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC5
		ON A4.CONTAINSID = SEC5.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A5
		ON SEC5.SECTIONID = A5.CONTAINERID AND A5.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC6
		ON A5.CONTAINSID = SEC6.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A6
		ON SEC6.SECTIONID = A6.CONTAINERID AND A6.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC7
		ON A6.CONTAINSID = SEC7.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A7
		ON SEC7.SECTIONID = A7.CONTAINERID AND A7.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC8
		ON A7.CONTAINSID = SEC8.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A8
		ON SEC8.SECTIONID = A8.CONTAINERID AND A8.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC9
		ON A8.CONTAINSID = SEC9.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A9
		ON SEC9.SECTIONID = A9.CONTAINERID AND A9.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC10
		ON A9.CONTAINSID = SEC10.SECTIONID ')
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_AUDITLOG_DAM
		(USERID,USER_BROWSER_IP, REQUEST_INFORMATION, SESSIONID,ACTION_NAME, APPLICATION_NAME, LOGINNAME,FIRSTNAME,
		LASTNAME,VAULTNAME,SECTIONPATH,SECTION_NAME,ASSET_NAME,ASSET_ID,LOG_TIMESTAMP,REASONFORDOWNLOAD,EXPIRYDATE,
		DOWNLOADEDVERSIONNUMBER,CURRENT_VERSIONNUMBER)
		SELECT
		USERID,USER_BROWSER_IP, REQUEST_INFORMATION, SESSIONID, 
		ACTION_NAME, APPLICATION_NAME, LOGINNAME,FIRSTNAME,
		LASTNAME,VAULTNAME,SECTIONPATH,
		CASE WHEN CHARINDEX(''\'',SECTIONPATH) > 0 THEN  REVERSE(SUBSTRING(REVERSE(SECTIONPATH),1,CHARINDEX(''\'',REVERSE(SECTIONPATH))-1)) ELSE SECTIONPATH END,
		ENTITY_NAME AS ASSET_NAME,
		ENTITY_ID AS ASSET_ID,LOG_TIMESTAMP,REASONFORDOWNLOAD,EXPIRYDATE,
		DOWNLOADEDVERSIONNUMBER,VERSIONNUMBER CURRENT_VERSIONNUMBER
		FROM
		ALFCT_AUDITLOG_DAM  LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
		ON ASF1.RELATIONSHIPTYPEID = 131965436044366 AND ALFCT_AUDITLOG_DAM.LOGID = ASF1.FACETID
		LEFT OUTER JOIN ALENT_AUDITLOG
		ON ALENT_AUDITLOG.AUDITLOGID = ASF1.ENTITYID
		LEFT OUTER JOIN ALOM_ASSEMBLY ASM1
		ON ALENT_AUDITLOG.AUDITLOGID = ASM1.CONTAINSID AND ASM1.RELATIONSHIPTYPEID = 256648081835824
		LEFT OUTER JOIN ALENT_AUDITPREFERENCES
		ON ASM1.CONTAINERID = ALENT_AUDITPREFERENCES.AUDITTYPEID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
		ON ALENT_AUDITLOG.AUDITLOGID = ASF2.ENTITYID AND ASF2.RELATIONSHIPTYPEID = 107003218182035
		LEFT OUTER JOIN ALFCT_AUDITLOG_DAMRFD
		ON ASF2.FACETID = ALFCT_AUDITLOG_DAMRFD.RFDID
		INNER JOIN ALOM_ASSEMBLY AS ASM
		ON ALENT_AUDITLOG.AUDITLOGID = ASM.CONTAINERID
		LEFT OUTER JOIN ALENT_USER
		ON ALENT_USER.USERID = ASM.CONTAINSID
		AND ASM.RELATIONSHIPTYPEID = 4441195388676
		LEFT OUTER JOIN ALOM_ASSEMBLY ASS1
		ON ALFCT_AUDITLOG_DAM.ENTITY_ID = ASS1.CONTAINERID AND ASS1.RELATIONSHIPTYPEID = 68650608701457
		LEFT OUTER JOIN ALENT_CONTENTREVISION
		ON ASS1.CONTAINSID = CONTENTREVISIONID ')
		
			
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER
		(USERID,LOGINNAME,PASSWORD,FIRSTNAME,MIDDLEINITIAL,LASTNAME,EMAILID,USERLANGUAGE,
		STATUS,ACCOUNTLOCKEDDATE,PASSWORDCHANGEDDATE,ACCOUNTCREATIONDATE,LOGINFAILURECOUNT,
		COMPANY,DEPARTMENT,TITLE,ADDRESS,CITY,STATE,ZIP,COUNTRY,PHONENUMBER,FAXNUMBER,
		AUTHENTICATIONMODE,AUTHENTICATIONPROVIDER,LASTLOGINDATE,DEFAULTSOLUTIONPAGE,
		PROFILEPICTUREPOSITION,APPLICATIONCONTEXT,INACTIVE_DAYS)
		SELECT ALENT_USER.*,CASE WHEN LASTLOGINDATE IS NOT NULL OR LASTLOGINDATE <> '''' THEN DATEDIFF(DD,LASTLOGINDATE,GETDATE()) END
		FROM ALENT_USER  ')
		
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER_LOGIN_LOGOUT
		(USERID,LOGINNAME,FIRSTNAME,LASTNAME,EMAILID,SESSIONID,USER_LOG_IN_TIME,USER_LOG_OUT_TIME,USER_TIMEUSAGE_IN_SECOND,USER_BROWSER_IP)
		SELECT	USR.USERID,USR.LOGINNAME, USR.FIRSTNAME, USR.LASTNAME, USR.EMAILID, AUDIT_IN.SESSIONID AS SESSIONID, 
		AUDIT_IN.LOG_TIMESTAMP AS USER_LOG_IN_TIME, AUDIT_OUT.LOG_TIMESTAMP AS USER_LOG_OUT_TIME, 
		DATEDIFF(SECOND, AUDIT_IN.LOG_TIMESTAMP, AUDIT_OUT.LOG_TIMESTAMP) AS USER_TIMEUSAGE_IN_SECOND, AUDIT_IN.USER_BROWSER_IP AS USER_BROWSER_IP
		FROM
		ALENT_AUDITLOG AS AUDIT_IN INNER JOIN ALOM_ASSEMBLY ASSM1 
		ON ASSM1.CONTAINSID = AUDIT_IN.AUDITLOGID AND ASSM1.RELATIONSHIPTYPEID = 256648081835824
		INNER JOIN ALENT_AUDITPREFERENCES APRF_IN 
		ON APRF_IN.AUDITTYPEID = ASSM1.CONTAINERID AND APRF_IN.AUDITTYPEID = 159766456853075
		INNER JOIN ALOM_ASSEMBLY ASSM_USR ON ASSM_USR.CONTAINERID = AUDIT_IN.AUDITLOGID AND ASSM_USR.RELATIONSHIPTYPEID = 4441195388676
		INNER JOIN ALENT_USER USR ON USR.USERID = ASSM_USR.CONTAINSID 
		LEFT OUTER JOIN ALENT_AUDITLOG AS AUDIT_OUT 
		INNER JOIN ALOM_ASSEMBLY ASSM2 ON ASSM2.CONTAINSID = AUDIT_OUT.AUDITLOGID AND ASSM2.RELATIONSHIPTYPEID = 256648081835824
		INNER JOIN ALENT_AUDITPREFERENCES APRF_OUT 
		ON APRF_OUT.AUDITTYPEID = ASSM2.CONTAINERID AND APRF_OUT.AUDITTYPEID = 959503052974 
		ON AUDIT_OUT.SESSIONID = AUDIT_IN.SESSIONID AND AUDIT_OUT.AUDITLOGID <> AUDIT_IN.AUDITLOGID
		ORDER BY AUDIT_IN.LOG_TIMESTAMP ')
		
GO

/*  Fix for defect # S0904344: CRP:Adhoc report not giving accurate data */


ALTER PROCEDURE LOAD_DAM_DATA_TO_ODS_SP (@MOM_DB_NAME NVARCHAR(75))
AS
	SET NOCOUNT ON

	DECLARE @ODS_DB_NAME NVARCHAR(75)

	SELECT @ODS_DB_NAME = @MOM_DB_NAME+'_ODS'
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSSECTION')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSDIGITALASSET')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOLLECTION')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'SECTION_HIERARCHY')
	
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_AUDITLOG_DAM')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER')
	EXEC ('TRUNCATE TABLE '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER_LOGIN_LOGOUT')
	
	
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSSECTION 
		(VAULTID,VAULTTYPE,VA_NAME,VA_MOUNTPOINT,VA_DESCRIPTION,VA_MAXALLOWEDDISKSPACE,
		VA_TOTALUSEDSPACE,VA_ONMEDIASERVER,SECTIONID,SEC_NAME,SEC_PATH,SEC_LEVEL1_NAME,
		SEC_LEVEL2_NAME,SEC_LEVEL3_NAME,SEC_LEVEL4_NAME,SEC_LEVEL5_NAME,SEC_LEVEL6_NAME,
		SEC_LEVEL7_NAME,SEC_LEVEL8_NAME,SEC_LEVEL9_NAME,SEC_LEVEL10_NAME,SEC_DESCRIPTION,
		SEC_ISROOTSECTION,SEC_ISSYSTEMVAULT,SEC_MARKEDASDELETED,SEC_ASSETCOUNTINPATH,
		SEC_ASSETCOUNTINSECTION,SEC_OWNERNAME,SECPOL_ID,SECPOL_NAME,SECPOL_DESCRIPTION)
		SELECT
		VA.VAULTID   AS	VAULTID,
		VA.VAULTTYPE  AS  VAULTTYPE,
		VA.NAME		AS	VA_NAME,
		VA.MOUNTPOINT	AS	VA_MOUNTPOINT,
		VA.DESCRIPTION	AS	VA_DESCRIPTION,
		VA.MAXALLOWEDDISKSPACE	AS  VA_MAXALLOWEDDISKSPACE,
		VA.TOTALUSEDSPACE	AS	VA_TOTALUSEDSPACE,
		VA.ONMEDIASERVER	AS	VA_ONMEDIASERVER,
		SEC.SECTIONID  AS	SECTIONID,
		SEC.NAME   AS 	SEC_NAME,
		SEC.PATH  AS 	SEC_PATH,
		'''' AS 	SEC_LEVEL1_NAME,
		'''' AS 	SEC_LEVEL2_NAME,
		''''  AS 	SEC_LEVEL3_NAME,
		''''  AS 	SEC_LEVEL4_NAME,
		''''  AS	SEC_LEVEL5_NAME,
		''''  AS	SEC_LEVEL6_NAME,
		''''  AS 	SEC_LEVEL7_NAME,
		''''  AS 	SEC_LEVEL8_NAME,
		''''  AS 	SEC_LEVEL9_NAME,
		''''  AS 	SEC_LEVEL10_NAME,
		SEC.DESCRIPTION  AS	SEC_DESCRIPTION,
		SEC.ISROOTSECTION  AS	SEC_ISROOTSECTION,
		SEC.ISSYSTEMVAULT  AS	SEC_ISSYSTEMVAULT,
		SEC.MARKEDASDELETED	SEC_MARKEDASDELETED,
		SEC.ASSETCOUNTINPATH  AS	SEC_ASSETCOUNTINPATH,
		SEC.ASSETCOUNTINSECTION  AS	SEC_ASSETCOUNTINSECTION,
		(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
			THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
			ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  SEC_OWNERNAME,
		SECPOL.SECURITYPOLICYID AS 	SECPOL_ID,
		SECPOL.POLICYNAME  AS 	SECPOL_NAME,
		SECPOL.POLICYDESCRIPTION  AS	SECPOL_DESCRIPTION
		FROM
		ALENT_VAULT VA INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 111100004770838 AND A1.CONTAINERID = VA.VAULTID
		INNER JOIN ALENT_SECTION SEC 
		ON A1.CONTAINSID = SEC.SECTIONID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 109473180943464 AND A2.CONTAINERID = SEC.SECTIONID
		INNER JOIN ALENT_USER USER1
		ON A2.CONTAINSID = USER1.USERID
		INNER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 35121011878728 AND A3.CONTAINERID = SEC.SECTIONID
		INNER JOIN ALENT_SECURITYPOLICY SECPOL
		ON A3.CONTAINSID = SECPOL.SECURITYPOLICYID ')
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSDIGITALASSET
		(VAULTID,VAULTTYPE,VA_NAME,VA_MOUNTPOINT,SECTIONID,SEC_NAME,SEC_PATH,SEC_LEVEL1_NAME,SEC_LEVEL2_NAME,
		SEC_LEVEL3_NAME,SEC_LEVEL4_NAME,SEC_LEVEL5_NAME,SEC_LEVEL6_NAME,SEC_LEVEL7_NAME,SEC_LEVEL8_NAME,
		SEC_LEVEL9_NAME,SEC_LEVEL10_NAME,SEC_DESCRIPTION,SEC_MARKEDASDELETED,SECPOL_ID,SECPOL_NAME,
		MA_LEVEL1_NUMBER,MA_LEVEL2_NUMBER,MA_LEVEL3_NUMBER,MA_LEVEL4_NUMBER,MA_LEVEL5_NUMBER,MA_LEVEL1_NAME,
		MA_LEVEL2_NAME,MA_LEVEL3_NAME,MA_LEVEL4_NAME,MA_LEVEL5_NAME,MA_TYPE_LEVEL1_NAME,
		MA_TYPE_LEVEL2_NAME,MA_TYPE_LEVEL3_NAME,MA_TYPE_LEVEL4_NAME,MA_ID,MA_NAME,MA_DESCRIPTION,
		MA_TYPE,MA_STATUS,DIGITALASSETID,DA_NAME,DA_DESCRIPTION,DA_CREATEDON,DA_VERSIONCATALOGEDON,
		DA_EXPIRYDATE,DA_ASSETEXPIRED,DA_DOWNLOADCOUNT,DA_LASTUPDATEDON,DA_MARKEDASDELETED,
		DA_FROZENON,DA_HASCHILDS,DA_ISCHILD,DA_ISFROZEN,DA_ISLOCKED,DA_LOCKEDON,DA_OWNERNAME,
		DA_NEXTVERSIONNUMBER,DA_CUR_VERSIONID,DA_CUR_VER_NUMBER,DA_CUR_VER_MODIFIEDON,DA_CUR_VER_DESCRIPTION,
		DA_ORG_ASSETRENDITIONID,DA_ORG_FILENAME,DA_ORG_FILEFORMAT,DA_ORG_FILESIZE,DA_ORG_MEDIACREATEDIN,
		DA_ORG_HEIGHT,DA_ORG_WIDTH,DA_ORG_DEPTH,DA_ORG_DPI,DA_PRV_ASSETRENDITIONID,DA_PRV_FILENAME,
		DA_PRV_FILEFORMAT,DA_PRV_FILESIZE,DA_PRV_MEDIACREATEDIN,DA_PRV_HEIGHT,DA_PRV_WIDTH,
		DA_PRV_DEPTH,DA_PRV_DPI,DA_THB_ASSETRENDITIONID,DA_THB_FILENAME,DA_THB_FILEFORMAT,
		DA_THB_FILESIZE,DA_THB_MEDIACREATEDIN,DA_THB_HEIGHT,DA_THB_WIDTH,DA_THB_DEPTH,DA_THB_DPI)
		SELECT
		VA.VAULTID   AS	VAULTID,
		VA.VAULTTYPE  AS  VAULTTYPE,
		VA.NAME		AS	VA_NAME,
		VA.MOUNTPOINT	AS	VA_MOUNTPOINT,
		SEC.SECTIONID  AS	SECTIONID,
		SEC.NAME   AS 	SEC_NAME,
		SEC.PATH  AS 	SEC_PATH,
		'''' AS 	SEC_LEVEL1_NAME,
		'''' AS 	SEC_LEVEL2_NAME,
		''''  AS 	SEC_LEVEL3_NAME,
		''''  AS 	SEC_LEVEL4_NAME,
		''''  AS	SEC_LEVEL5_NAME,
		''''  AS	SEC_LEVEL6_NAME,
		''''  AS 	SEC_LEVEL7_NAME,
		''''  AS 	SEC_LEVEL8_NAME,
		''''  AS 	SEC_LEVEL9_NAME,
		''''  AS 	SEC_LEVEL10_NAME,
		SEC.DESCRIPTION  AS	SEC_DESCRIPTION,
		SEC.MARKEDASDELETED	SEC_MARKEDASDELETED,
		SECPOL.SECURITYPOLICYID AS 	SECPOL_ID,
		SECPOL.POLICYNAME  AS 	SECPOL_NAME,
		''''  AS MA_LEVEL1_NUMBER,
		''''  AS MA_LEVEL2_NUMBER,
		''''  AS MA_LEVEL3_NUMBER,
		''''  AS MA_LEVEL4_NUMBER,
		''''  AS MA_LEVEL5_NUMBER,
		''''  AS MA_LEVEL1_NAME,
		''''  AS MA_LEVEL2_NAME,
		''''  AS MA_LEVEL3_NAME,
		''''  AS MA_LEVEL4_NAME,
		''''  AS MA_LEVEL5_NAME,
		''''  AS MA_TYPE_LEVEL1_NAME,
		''''  AS MA_TYPE_LEVEL2_NAME,
		''''  AS MA_TYPE_LEVEL3_NAME,
		''''  AS MA_TYPE_LEVEL4_NAME,
		MA.MARKETINGACTIVITYID  AS MA_ID,
		MA.NAME  AS MA_NAME,
		MA.DESCRIPTION  AS MA_DESCRIPTION,
		MA.ACTIVITYTYPE  AS MA_TYPE,
		MA.STATUS  AS  MA_STATUS,
		DA.DIGITALASSETID   AS DIGITALASSETID,
		DA.NAME    AS DA_NAME,
		DA.DESCRIPTION    AS DA_DESCRIPTION,
		DA.CREATEDON    AS DA_CREATEDON,
		DA.DATECATALOGED    AS DA_VERSIONCATALOGEDON,
		DA.EXPIRYDATE    AS DA_EXPIRYDATE,
		DA.ASSETEXPIRED    AS DA_ASSETEXPIRED,
		DA.DOWNLOADCOUNT    AS DA_DOWNLOADCOUNT,
		DA.LASTUPDATEDON    AS DA_LASTUPDATEDON,
		DA.MARKEDASDELETED    AS DA_MARKEDASDELETED,
		DA.FROZENON    AS DA_FROZENON,
		DA.HASCHILDS    AS DA_HASCHILDS,
		DA.ISCHILD    AS DA_ISCHILD,
		DA.ISFROZEN    AS DA_ISFROZEN,
		DA.ISLOCKED    AS DA_ISLOCKED,
		DA.LOCKEDON    AS DA_LOCKEDON,
		(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
			THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
			ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  DA_OWNERNAME,
		DA.NEXTVERSIONNUMBER  AS DA_NEXTVERSIONNUMBER,
		CR.CONTENTREVISIONID  AS DA_CUR_VERSIONID,
		CR.VERSIONNUMBER  AS  DA_CUR_VER_NUMBER,
		CR.MODIFIEDON   AS DA_CUR_VER_MODIFIEDON,
		CR.DESCRIPTION   AS  DA_CUR_VER_DESCRIPTION,
		AR1.ASSETRENDITIONID  AS DA_ORG_ASSETRENDITIONID,
		AR1.NAME  AS DA_ORG_FILENAME,
		AR1.FILEFORMAT  AS DA_ORG_FILEFORMAT,
		AR1.FILESIZE  AS DA_ORG_FILESIZE,
		AR1.MEDIACREATEDIN  AS DA_ORG_MEDIACREATEDIN,
		AR1.HEIGHT  AS DA_ORG_HEIGHT,
		AR1.WIDTH  AS DA_ORG_WIDTH,
		AR1.DEPTH  AS DA_ORG_DEPTH,
		AR1.DPI  AS DA_ORG_DPI,
		AR2.ASSETRENDITIONID  AS DA_PRV_ASSETRENDITIONID,
		AR2.NAME  AS DA_PRV_FILENAME,
		AR2.FILEFORMAT  AS DA_PRV_FILEFORMAT,
		AR2.FILESIZE  AS DA_PRV_FILESIZE,
		AR2.MEDIACREATEDIN  AS DA_PRV_MEDIACREATEDIN,
		AR2.HEIGHT  AS DA_PRV_HEIGHT,
		AR2.WIDTH  AS DA_PRV_WIDTH,
		AR2.DEPTH  AS DA_PRV_DEPTH,
		AR2.DPI  AS DA_PRV_DPI,
		AR3.ASSETRENDITIONID  AS DA_THB_ASSETRENDITIONID,
		AR3.NAME  AS DA_THB_FILENAME,
		AR3.FILEFORMAT  AS DA_THB_FILEFORMAT,
		AR3.FILESIZE  AS DA_THB_FILESIZE,
		AR3.MEDIACREATEDIN  AS DA_THB_MEDIACREATEDIN,
		AR3.HEIGHT  AS DA_THB_HEIGHT,
		AR3.WIDTH  AS DA_THB_WIDTH,
		AR3.DEPTH  AS DA_THB_DEPTH,
		AR3.DPI  AS DA_THB_DPI
		FROM
		ALENT_VAULT VA INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 111100004770838 AND A1.CONTAINERID = VA.VAULTID
		INNER JOIN ALENT_SECTION SEC 
		ON A1.CONTAINSID = SEC.SECTIONID
		INNER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 35121011878728 AND A2.CONTAINERID = SEC.SECTIONID
		INNER JOIN ALENT_SECURITYPOLICY SECPOL
		ON A2.CONTAINSID = SECPOL.SECURITYPOLICYID
		INNER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 94152543310967 AND A3.CONTAINERID = SEC.SECTIONID
		LEFT OUTER JOIN ALENT_DIGITALASSET DA
		ON A3.CONTAINSID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALOM_ASSEMBLY A4
		ON A4.RELATIONSHIPTYPEID = 159621997915744 AND A4.CONTAINSID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_MARKETINGACTIVITY MA
		ON A4.CONTAINERID = MA.MARKETINGACTIVITYID
		LEFT OUTER JOIN ALOM_ASSEMBLY A9
		ON A9.RELATIONSHIPTYPEID = 157956613799693 AND A9.CONTAINSID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_USER  USER1
		ON A9.CONTAINERID = USER1.USERID
		LEFT OUTER JOIN ALOM_ASSEMBLY A5
		ON A5.RELATIONSHIPTYPEID = 68650608701457 AND A5.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_CONTENTREVISION CR
		ON A5.CONTAINSID = CR.CONTENTREVISIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A6
		ON A6.RELATIONSHIPTYPEID = 102414976430820 AND A6.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_ASSETRENDITION AR1
		ON A6.CONTAINSID = AR1.ASSETRENDITIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A7
		ON A7.RELATIONSHIPTYPEID = 157260760446174 AND A7.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_ASSETRENDITION AR2
		ON A7.CONTAINSID = AR2.ASSETRENDITIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A8
		ON A8.RELATIONSHIPTYPEID = 154146076479866 AND A8.CONTAINERID = DA.DIGITALASSETID
		LEFT OUTER JOIN ALENT_ASSETRENDITION AR3
		ON A8.CONTAINSID = AR3.ASSETRENDITIONID  ')
	
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODSCOLLECTION 
		(VAULTID,VAULTTYPE,VA_NAME,VA_MOUNTPOINT,SECTIONID,SEC_NAME,SEC_PATH,SEC_LEVEL1_NAME,SEC_LEVEL2_NAME,
		SEC_LEVEL3_NAME,SEC_LEVEL4_NAME,SEC_LEVEL5_NAME,SEC_LEVEL6_NAME,SEC_LEVEL7_NAME,SEC_LEVEL8_NAME,
		SEC_LEVEL9_NAME,SEC_LEVEL10_NAME,SEC_DESCRIPTION,SEC_MARKEDASDELETED,COLLECTIONID,COL_DESCRIPTION,
		COL_MARKEDASDELETED,COL_NAME,COL_OWNERNAME)
		SELECT 
		VA.VAULTID   AS	VAULTID,
		VA.VAULTTYPE  AS  VAULTTYPE,
		VA.NAME		AS	VA_NAME,
		VA.MOUNTPOINT	AS	VA_MOUNTPOINT,
		SEC.SECTIONID  AS	SECTIONID,
		SEC.NAME   AS 	SEC_NAME,
		SEC.PATH  AS 	SEC_PATH,
		'''' AS 	SEC_LEVEL1_NAME,
		'''' AS 	SEC_LEVEL2_NAME,
		''''  AS 	SEC_LEVEL3_NAME,
		''''  AS 	SEC_LEVEL4_NAME,
		''''  AS	SEC_LEVEL5_NAME,
		''''  AS	SEC_LEVEL6_NAME,
		''''  AS 	SEC_LEVEL7_NAME,
		''''  AS 	SEC_LEVEL8_NAME,
		''''  AS 	SEC_LEVEL9_NAME,
		''''  AS 	SEC_LEVEL10_NAME,
		SEC.DESCRIPTION  AS	SEC_DESCRIPTION,
		SEC.MARKEDASDELETED	SEC_MARKEDASDELETED,
		COL.COLLECTIONID AS 	COLLECTIONID,
		COL.DESCRIPTION AS	COL_DESCRIPTION,
		COL.MARKEDASDELETED AS	COL_MARKEDASDELETED,
		COL.NAME AS	COL_NAME,
		(CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) AND (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) 
			THEN USER1.firstname+'' ''+USER1.lastname 	ELSE CASE WHEN (USER1.firstname IS NOT NULL AND LEN(USER1.firstname) > 0) THEN USER1.firstname 
			ELSE CASE WHEN (USER1.lastname IS NOT NULL AND LEN(USER1.lastname) > 0) THEN USER1.lastname ELSE USER1.LOGINNAME END END END )   AS  COL_OWNERNAME
		FROM
		ALENT_VAULT VA INNER JOIN ALOM_ASSEMBLY A1
		ON A1.RELATIONSHIPTYPEID = 111100004770838 AND A1.CONTAINERID = VA.VAULTID
		INNER JOIN ALENT_SECTION SEC 
		ON A1.CONTAINSID = SEC.SECTIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A2
		ON A2.RELATIONSHIPTYPEID = 148170386940134 AND A2.CONTAINERID = SEC.SECTIONID
		LEFT OUTER JOIN ALENT_COLLECTION COL
		ON A2.CONTAINSID = COL.COLLECTIONID
		LEFT OUTER JOIN ALOM_ASSEMBLY A3
		ON A3.RELATIONSHIPTYPEID = 209721613476979 AND A3.CONTAINSID = COL.COLLECTIONID
		LEFT OUTER JOIN ALENT_USER USER1
		ON A3.CONTAINERID = USER1.USERID ')
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'SECTION_HIERARCHY 
		SELECT
		SEC1.SECTIONID AS SEC_ID1,SEC1.NAME  AS SEC1_NAME,
		SEC2.SECTIONID AS SEC_ID2,SEC2.NAME  AS SEC2_NAME,
		SEC3.SECTIONID AS SEC_ID3,SEC3.NAME  AS SEC3_NAME,
		SEC4.SECTIONID AS SEC_ID4,SEC4.NAME  AS SEC4_NAME,
		SEC5.SECTIONID AS SEC_ID5,SEC5.NAME  AS SEC5_NAME,
		SEC6.SECTIONID AS SEC_ID6,SEC6.NAME  AS SEC6_NAME,
		SEC7.SECTIONID AS SEC_ID7,SEC7.NAME  AS SEC7_NAME,
		SEC8.SECTIONID AS SEC_ID8,SEC8.NAME  AS SEC8_NAME,
		SEC9.SECTIONID AS SEC_ID9,SEC9.NAME  AS SEC9_NAME,
		SEC10.SECTIONID AS SEC_ID10,SEC10.NAME  AS SEC10_NAME
		FROM
		ALENT_SECTION SEC1 LEFT OUTER JOIN ALOM_ASSEMBLY A1
		ON A1.CONTAINERID = SEC1.SECTIONID AND A1.RELATIONSHIPTYPEID = 218499833336991
		AND SEC1.ISROOTSECTION = 1
		LEFT OUTER JOIN ALENT_SECTION SEC2
		ON A1.CONTAINSID = SEC2.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A2
		ON SEC2.SECTIONID = A2.CONTAINERID AND A2.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC3
		ON A2.CONTAINSID = SEC3.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A3
		ON SEC3.SECTIONID = A3.CONTAINERID AND A3.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC4
		ON A3.CONTAINSID = SEC4.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A4
		ON SEC4.SECTIONID = A4.CONTAINERID AND A4.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC5
		ON A4.CONTAINSID = SEC5.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A5
		ON SEC5.SECTIONID = A5.CONTAINERID AND A5.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC6
		ON A5.CONTAINSID = SEC6.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A6
		ON SEC6.SECTIONID = A6.CONTAINERID AND A6.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC7
		ON A6.CONTAINSID = SEC7.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A7
		ON SEC7.SECTIONID = A7.CONTAINERID AND A7.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC8
		ON A7.CONTAINSID = SEC8.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A8
		ON SEC8.SECTIONID = A8.CONTAINERID AND A8.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC9
		ON A8.CONTAINSID = SEC9.SECTIONID
		
		LEFT OUTER join ALOM_ASSEMBLY A9
		ON SEC9.SECTIONID = A9.CONTAINERID AND A9.RELATIONSHIPTYPEID = 218499833336991
		LEFT OUTER JOIN ALENT_SECTION SEC10
		ON A9.CONTAINSID = SEC10.SECTIONID ')
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_AUDITLOG_DAM
		(USERID,USER_BROWSER_IP, REQUEST_INFORMATION, SESSIONID,ACTION_NAME, APPLICATION_NAME, LOGINNAME,FIRSTNAME,
		LASTNAME,VAULTNAME,SECTIONPATH,SECTION_NAME,ASSET_NAME,ASSET_ID,LOG_TIMESTAMP,REASONFORDOWNLOAD,EXPIRYDATE,
		DOWNLOADEDVERSIONNUMBER,CURRENT_VERSIONNUMBER)
		SELECT
		USERID,USER_BROWSER_IP, REQUEST_INFORMATION, SESSIONID, 
		ACTION_NAME, APPLICATION_NAME, LOGINNAME,FIRSTNAME,
		LASTNAME,VAULTNAME,SECTIONPATH,
		CASE WHEN CHARINDEX(''\'',SECTIONPATH) > 0 THEN  REVERSE(SUBSTRING(REVERSE(SECTIONPATH),1,CHARINDEX(''\'',REVERSE(SECTIONPATH))-1)) ELSE SECTIONPATH END,
		ENTITY_NAME AS ASSET_NAME,
		ENTITY_ID AS ASSET_ID,LOG_TIMESTAMP,REASONFORDOWNLOAD,EXPIRYDATE,
		DOWNLOADEDVERSIONNUMBER,VERSIONNUMBER CURRENT_VERSIONNUMBER
		FROM
		ALFCT_AUDITLOG_DAM  LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF1
		ON ASF1.RELATIONSHIPTYPEID = 131965436044366 AND ALFCT_AUDITLOG_DAM.LOGID = ASF1.FACETID
		LEFT OUTER JOIN ALENT_AUDITLOG
		ON ALENT_AUDITLOG.AUDITLOGID = ASF1.ENTITYID
		LEFT OUTER JOIN ALOM_ASSEMBLY ASM1
		ON ALENT_AUDITLOG.AUDITLOGID = ASM1.CONTAINSID AND ASM1.RELATIONSHIPTYPEID = 256648081835824
		LEFT OUTER JOIN ALENT_AUDITPREFERENCES
		ON ASM1.CONTAINERID = ALENT_AUDITPREFERENCES.AUDITTYPEID
		LEFT OUTER JOIN ALOM_ASSOENTITYFACET ASF2
		ON ALENT_AUDITLOG.AUDITLOGID = ASF2.ENTITYID AND ASF2.RELATIONSHIPTYPEID = 107003218182035
		LEFT OUTER JOIN ALFCT_AUDITLOG_DAMRFD
		ON ASF2.FACETID = ALFCT_AUDITLOG_DAMRFD.RFDID
		INNER JOIN ALOM_ASSEMBLY AS ASM
		ON ALENT_AUDITLOG.AUDITLOGID = ASM.CONTAINERID
		LEFT OUTER JOIN ALENT_USER
		ON ALENT_USER.USERID = ASM.CONTAINSID
		AND ASM.RELATIONSHIPTYPEID = 4441195388676
		LEFT OUTER JOIN ALOM_ASSEMBLY ASS1
		ON ALFCT_AUDITLOG_DAM.ENTITY_ID = ASS1.CONTAINERID AND ASS1.RELATIONSHIPTYPEID = 68650608701457
		LEFT OUTER JOIN ALENT_CONTENTREVISION
		ON ASS1.CONTAINSID = CONTENTREVISIONID ')
		
			
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER
		(USERID,LOGINNAME,PASSWORD,FIRSTNAME,MIDDLEINITIAL,LASTNAME,EMAILID,USERLANGUAGE,
		STATUS,ACCOUNTLOCKEDDATE,PASSWORDCHANGEDDATE,ACCOUNTCREATIONDATE,LOGINFAILURECOUNT,
		COMPANY,DEPARTMENT,TITLE,ADDRESS,CITY,STATE,ZIP,COUNTRY,PHONENUMBER,FAXNUMBER,
		AUTHENTICATIONMODE,AUTHENTICATIONPROVIDER,LASTLOGINDATE,DEFAULTSOLUTIONPAGE,
		PROFILEPICTUREPOSITION,APPLICATIONCONTEXT,INACTIVE_DAYS)
		SELECT U1.USERID,U1.LOGINNAME,U1.PASSWORD,U1.FIRSTNAME,U1.MIDDLEINITIAL,U1.LASTNAME,U1.EMAILID,U1.USERLANGUAGE,
		U1.STATUS,U1.ACCOUNTLOCKEDDATE,U1.PASSWORDCHANGEDDATE,U1.ACCOUNTCREATIONDATE,U1.LOGINFAILURECOUNT,
		U1.COMPANY,U1.DEPARTMENT,U1.TITLE,U1.ADDRESS,U1.CITY,U1.STATE,U1.ZIP,U1.COUNTRY,U1.PHONENUMBER,U1.FAXNUMBER,
		U1.AUTHENTICATIONMODE,U1.AUTHENTICATIONPROVIDER,U1.LASTLOGINDATE,U1.DEFAULTSOLUTIONPAGE,
		U1.PROFILEPICTUREPOSITION,U1.APPLICATIONCONTEXT,
		CASE WHEN A.LOGIN_TIMESTAMP IS NOT NULL OR A.LOGIN_TIMESTAMP <> '''' THEN DATEDIFF(DD,A.LOGIN_TIMESTAMP,GETDATE()) END
		FROM 
		ALENT_USER U1 LEFT OUTER JOIN 
		(SELECT U2.USERID AS USERID,MAX(AUDIT_IN.LOG_TIMESTAMP) AS LOGIN_TIMESTAMP
		FROM
		ALENT_AUDITLOG AS AUDIT_IN INNER JOIN ALOM_ASSEMBLY ASSM1 
		ON ASSM1.CONTAINSID = AUDIT_IN.AUDITLOGID AND ASSM1.RELATIONSHIPTYPEID = 256648081835824
		INNER JOIN ALENT_AUDITPREFERENCES APRF_IN 
		ON APRF_IN.AUDITTYPEID = ASSM1.CONTAINERID AND APRF_IN.AUDITTYPEID = 159766456853075
		INNER JOIN ALOM_ASSEMBLY ASSM_USR ON ASSM_USR.CONTAINERID = AUDIT_IN.AUDITLOGID AND ASSM_USR.RELATIONSHIPTYPEID = 4441195388676
		INNER JOIN ALENT_USER U2 ON U2.USERID = ASSM_USR.CONTAINSID 
		LEFT OUTER JOIN ALENT_AUDITLOG AS AUDIT_OUT 
		INNER JOIN ALOM_ASSEMBLY ASSM2 ON ASSM2.CONTAINSID = AUDIT_OUT.AUDITLOGID AND ASSM2.RELATIONSHIPTYPEID = 256648081835824
		INNER JOIN ALENT_AUDITPREFERENCES APRF_OUT 
		ON APRF_OUT.AUDITTYPEID = ASSM2.CONTAINERID AND APRF_OUT.AUDITTYPEID = 959503052974 
		ON AUDIT_OUT.SESSIONID = AUDIT_IN.SESSIONID AND AUDIT_OUT.AUDITLOGID <> AUDIT_IN.AUDITLOGID
		GROUP BY U2.USERID) A
		ON U1.USERID = A.USERID ')
		
		
	EXEC (' INSERT INTO  '+@ODS_DB_NAME+'.DBO.'+'ALENT_ODS_USER_LOGIN_LOGOUT
		(USERID,LOGINNAME,FIRSTNAME,LASTNAME,EMAILID,SESSIONID,USER_LOG_IN_TIME,USER_LOG_OUT_TIME,USER_TIMEUSAGE_IN_SECOND,USER_BROWSER_IP)
		SELECT	USR.USERID,USR.LOGINNAME, USR.FIRSTNAME, USR.LASTNAME, USR.EMAILID, AUDIT_IN.SESSIONID AS SESSIONID, 
		AUDIT_IN.LOG_TIMESTAMP AS USER_LOG_IN_TIME, AUDIT_OUT.LOG_TIMESTAMP AS USER_LOG_OUT_TIME, 
		DATEDIFF(SECOND, AUDIT_IN.LOG_TIMESTAMP, AUDIT_OUT.LOG_TIMESTAMP) AS USER_TIMEUSAGE_IN_SECOND, AUDIT_IN.USER_BROWSER_IP AS USER_BROWSER_IP
		FROM
		ALENT_AUDITLOG AS AUDIT_IN INNER JOIN ALOM_ASSEMBLY ASSM1 
		ON ASSM1.CONTAINSID = AUDIT_IN.AUDITLOGID AND ASSM1.RELATIONSHIPTYPEID = 256648081835824
		INNER JOIN ALENT_AUDITPREFERENCES APRF_IN 
		ON APRF_IN.AUDITTYPEID = ASSM1.CONTAINERID AND APRF_IN.AUDITTYPEID = 159766456853075
		INNER JOIN ALOM_ASSEMBLY ASSM_USR ON ASSM_USR.CONTAINERID = AUDIT_IN.AUDITLOGID AND ASSM_USR.RELATIONSHIPTYPEID = 4441195388676
		INNER JOIN ALENT_USER USR ON USR.USERID = ASSM_USR.CONTAINSID 
		LEFT OUTER JOIN ALENT_AUDITLOG AS AUDIT_OUT 
		INNER JOIN ALOM_ASSEMBLY ASSM2 ON ASSM2.CONTAINSID = AUDIT_OUT.AUDITLOGID AND ASSM2.RELATIONSHIPTYPEID = 256648081835824
		INNER JOIN ALENT_AUDITPREFERENCES APRF_OUT 
		ON APRF_OUT.AUDITTYPEID = ASSM2.CONTAINERID AND APRF_OUT.AUDITTYPEID = 959503052974 
		ON AUDIT_OUT.SESSIONID = AUDIT_IN.SESSIONID AND AUDIT_OUT.AUDITLOGID <> AUDIT_IN.AUDITLOGID
		ORDER BY AUDIT_IN.LOG_TIMESTAMP ')
		
GO