#region SystemIncludes
using System;
using System.Data;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.IO;
using System.Collections.Generic;
using System.Globalization;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
#endregion

#region AssetlinkInclude
using Assetlink.Solutions;
using Assetlink.CustomControls;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.MktgWorkBenchFacade;
using Assetlink.Solutions.Facade.PMFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.NotificationFacade; 
using Assetlink.Solutions.Pages;
using Assetlink.CustomControls.HelperClasses;
#endregion

//-----------------------------------------------------//
// File Name:   Manage_CreateGatherInfoTask.aspx.cs    //
// Author:      Ms. Mugdha Moolay.                     //
// Class:       Manage_CreateGatherInfoTask            //
// Created On:  13th December 2006                     //
//-----------------------------------------------------//

namespace Assetlink.Solutions.MarketingWorkBench
{
     using XML       = String;     
     using ERRORXML  = String;

    public partial class Manage_CreateGatherInfoTask : ALAjaxPage
    {
        #region Member Variables
            private ALSolutionCommon            ALSolutionCommonObj     = null;
            //private Dictionary<String, String>  m_ParamList             = null;
            public  ALParam                     ALParamObj              = null;
            private Hashtable                   StepFormIDTable         = null;
            private String                      DeliverableID           = null;
            private String                      ProjectID               = null;
            private String                      TaskID                  = null;
            private String                      Mode                    = null;
            private List<ObjectInfo>            ObjInfoList             = null;
            private List<ObjectInfo>            StepObjInfoList         = null;
            private List<string>                ActivityIDOrderedList   = null; 
            private String                      PackageDefinitionID     = null;
            private String                      ProcessDefinitionID     = null;      
            private String[]                    strSeparator            = null;
            private String                      FormMode                = "Edit";
            private String                      SolutionName            = "MarketingWorkBench";
            private String                      TaskFile                = null;
            private String                      PredecessorInputFile    = null;
            private String                      PredecessorOutputFile   = null;
            private String                      GroupListFile           = null;
            private String                      DisplayPredecessorFile	= null;
            private HiddenField				    Hidden_PredecessorFound = null;
            private String						Access					= "READ";
            //For Template Document            
            private String                      SectionPath             = "Template Vault\\";
            private String                      ParentBreadcrumbName    = null;
            private String                      BreadcrumbCtrlID        = null;
			private	String						PrevScreen				= null;
			private	String						TabClickFlag			= null;
			private String						SelectedTab				= null;
            private	Boolean				        alertGivenFlag			= false;
			private String						StepResourceFileName	= null;
			private String						ResourceTreeFile		= null;
            private String                      str_SubflowActivityID   = null;
            private String                      str_TaskStatus          = null;
            private String                      str_ComponentFacetFileName = "_ComponentFacet.xml";
            private String                      str_ComponentFacetStatus   = "Editable";
            private String                      str_SelectedComponentsIDFileName = "_SelectedComponentsID.xml";
            private Boolean                     b_RenderTaskForm        = false;
            private const String                SelectedGroupsFileName      = "_ProcessComplete_SelectedGroups.xml";
            private const String                SelectedUsersFileName       = "_ProcessComplete_SelectedUsers.xml";
            private const String                SelectedUserGroupsFileName  = "_ProcessComplete_SelectedUsersGroups.xml";
            private String                      SelectedReaderGroupsFileName    = null;
            private String                      SelectedReaderUsersFileName     = null;
            private String                      SelectedReaderUserGroupsFileName= null;
        #endregion

        #region ControlsOnPage
            private Form                    Frm_GatherInfo              = null;
            private Form                    TempStepForm                = null;
            private ActionBar               Ab_GatherInfoTask           = null;
            private ALPanel                 Panel_ManualActivities      = null;   
            private Binder                  BinderControl               = null;               
            private ALBreadCrumb            GatherInfoTaskBreadcrumb    = null;
            private ALTab					GatherInfoTaskTab			= null;
            private ALPanel					Panel_TaskDetails			= null;
			private	ALPanel					Panel_UserRoles				= null;
			private ALPanel					Panel_Dependencies			= null;
			private ALPanel					Panel_Form					= null;
			private HiddenField				Hidden_GiveAlert			= null;
			private	HiddenField				Hidden_SaveDate				= null;
            private HiddenField             Hidden_CalculateTimeLine    = null;
            private HiddenField             Hidden_ActivityInfoTable    = null; 

            private Assetlink.CustomControls.ListControl Lst_PredecessorList    = null;
            private Assetlink.CustomControls.ListControl Lst_TemplateDocument   = null;
            private CustomControls.ListControl           LC_TaskReaders         = null; 
            private CustomControls.ListControl           Lst_UserGroup          = null;
            private ALPanel                              Panel_Templates        = null;
            private CheckBox                            checkBoxObj             = null;
            private TextBox                             textBoxObj              = null;
        #endregion

        #region Properties

        private String ProcessCompletionUsers
        {
            get
            {
                String Buffer = (String)ViewState["ProcessCompletionUsers"];
                return ((Buffer == null) ? String.Empty : Buffer);
            }
            set
            {
                this.ViewState["ProcessCompletionUsers"] = value;
            }
        }

        private String ProcessCompletionGroups
        {
            get
            {
                String Buffer = (String)ViewState["ProcessCompletionGroups"];
                return ((Buffer == null) ? String.Empty : Buffer);
            }
            set
            {
                this.ViewState["ProcessCompletionGroups"] = value;
            }
        }

        #endregion

        #region Protected Methods

			protected override void CreateChildControls()
			{
                Boolean b_ResetFacetSeriesFields = false;
				try
				{
					setParameters();
					setControls();
					setLeftPane(); 
					if(IsPostBack)
					{
						String EventGenerator = Ajax.EventGeneratorUniqueID;
                        if (ViewState["TabClickFlag"]!=null)
						{
                            if ((!String.IsNullOrEmpty(EventGenerator)) && (EventGenerator.Contains("tabEditTask_panelTaskDetails") && (!EventGenerator.Contains("EditDoneSeriesRecords"))))
                            {
                                b_ResetFacetSeriesFields = true;
                            }
                            createNewStepForm(b_ResetFacetSeriesFields);
                            setStepFormEventHandler();
						}
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        if (StepFormIDTable != null)
                        {
                            IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();                                                    
                            while (StepFormIDEnum.MoveNext())
                            {
                                if ((!String.IsNullOrEmpty(EventGenerator)) &&(EventGenerator.Contains(StepFormIDEnum.Value.ToString() + "_HiddenMSDELETEButton")))
                                {
                                    UpdateContributorDropDownList(StepFormIDEnum.Key.ToString(), StepFormIDEnum.Value.ToString());
                                    break;
                                }
                            }
                        }
					}	
					base.CreateChildControls();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

            protected void Page_Init(object sender, EventArgs e)
            {
                ALSolutionCommonObj = new ALSolutionCommon();
                ALParamObj = new ALParam();

	            ALSolutionCommonObj.httpContext = HttpContext.Current;
    	        ALSolutionCommonObj.InitALParam(ref ALParamObj);

                ((ALMasterPage)this.Master).SessionID       = ALParamObj.SessionID;
                ((ALMasterPage)this.Master).UserID          = ALParamObj.UserID;
                ((ALMasterPage)this.Master).Language        = ALParamObj.Language;
                ((ALMasterPage)this.Master).TenantName      = ALParamObj.TenantName;
	            ((ALMasterPage)this.Master).SolutionName    = SolutionName;
                ((ALMasterPage)this.Master).PageTitle       = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_MarketingWorkbench_Shared");
            }

            protected void Page_Load(object sender, EventArgs e)
            {
                try
                {
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (Page_Load):- Before PageLoad() function.");
                    setParameters();
                    setControls();
                    setLeftPane();
					setControlProperties();
                    if (!IsPostBack)
                    {
                        DeleteTempFiles();
						setSelectedTab();
                        getBaselineConfig();
						//setPageInEditMode();
						//setBreadcrumbs();
						//this.ViewState["INFOTABCLICKED"]		= "false";
						this.ViewState["USERROLESTABCLICKED"]	= "false";
						this.ViewState["DEP_TABCLICKED"]		= "false";
						//Hidden_SaveDate.Value = "false"; // for tab
                    }
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (Page_Load):- After PageLoad() function.");            
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }      
            }

            protected void PredecessorList_AB_Click(object sender, EventArgs e)
            {                
               ulong			ErrorID = 0;
               StringBuilder	ErrorPageURL_Exp = null;
               try
                {
                    String strSender    = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btn_SelectPredecessor"))
                    {
                        select_Predecessors();
                    }
                    else if (Parameters[1].Equals("btn_DeletePredecessor"))
                    {
                        //Delete Predecessor Button Clicked
                        btn_DeletePredecessor_Clicked(sender, e);
                    }
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "PredecessorList_AB_Click", ExceptionObj, null,
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateGatherInfoTask_Exceptiononpredecessoractionbarclick"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");                    
                }           
            }

            protected void Btn_SelectPredecessorOk_Click(object sender, EventArgs e)
            {
			    ulong					 ErrorID				     = 0;
			    StringBuilder			 ErrorPageURL_Exp		     = null;
                MktgWorkBenchFacadeClass obj_MktgWorkBenchFacade     = null;
                String                   str_ErrorPageURL            = null;
                String					 str_ChangeActivityLock	     = null;
			    String					 str_PredecessorListInputXml = null;
                String                   str_InputFileModified       = null;
                ERRORXML                 ErrorXml                    = null;

                try
                {
                    obj_MktgWorkBenchFacade = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    str_ChangeActivityLock = Request["__EVENTARGUMENT"];
                    obj_MktgWorkBenchFacade.SolutionName = SolutionName;
                    ErrorXml = obj_MktgWorkBenchFacade.AddPredecessors(PredecessorInputFile, PredecessorOutputFile, DisplayPredecessorFile, str_ChangeActivityLock, TaskID, DeliverableID, "PredecessorListForTask", true, out str_InputFileModified, out str_PredecessorListInputXml);
                    if (String.IsNullOrEmpty(ErrorXml))
                    {
                        if (!String.IsNullOrEmpty(str_InputFileModified))
                        {
                            ID_SelcetPredecessor_UC.InputFileModified = str_InputFileModified;
                        }
                        if (!String.IsNullOrEmpty(str_PredecessorListInputXml))
                        {
                            Lst_PredecessorList.Source = str_PredecessorListInputXml;
                        }
                        ShowUpdatedDates();
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_AddPredecessorsFailed"), null, GetBackUrl(), ref str_ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                    }
					Ajax.WriteExecuteJavaScript(Popup_SelectPredecessorsTask_GatherInfo.ClosePopupJavascript);
                }
                catch (Exception ExceptionObject)
                {
				    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "Btn_SelectPredecessorOk_Click", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_SelPredecessors_EXCEPTION_Shared"));

				    ErrorPageURL_Exp = new StringBuilder();
				    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
				    if(!IsPostBack)
				    {
					    Response.Redirect(ErrorPageURL_Exp.ToString());
				    }
				    else
					    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            protected void Btn_SelectPredecessorCancel_Click(object sender, EventArgs e)
        {
            try
            {
                Ajax.WriteExecuteJavaScript(Popup_SelectPredecessorsTask_GatherInfo.ClosePopupJavascript);
            }
            catch (Exception ExceptionObject)
            {
                throw ExceptionObject;
            }
        }

            protected void btn_DeletePredecessor_Clicked(object sender, EventArgs e)
            {
                ulong						ErrorID						= 0;
                StringBuilder				ErrorPageURL_Exp			= null;
                ERRORXML                    ErrorXml                    = null;
                MktgWorkBenchFacadeClass    obj_MWBFacade               = null;
                String                      str_PredecessorListInputXml = null;
                String                      str_ErrorPageURL            = null;

                try
                {
                    obj_MWBFacade = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_MWBFacade.SolutionName = SolutionName;
                    ErrorXml = obj_MWBFacade.DeletePredecessors(PredecessorInputFile, DisplayPredecessorFile, Request["__EVENTARGUMENT"], TaskID, DeliverableID, "PredecessorListForTask", true, out str_PredecessorListInputXml);
                    if (String.IsNullOrEmpty(ErrorXml))
                    {
                        ID_SelcetPredecessor_UC.InputFileModified = "TRUE";
                        if (!String.IsNullOrEmpty(str_PredecessorListInputXml))
                        {
                            Lst_PredecessorList.Source = str_PredecessorListInputXml;
                            ShowUpdatedDates();
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_DeletePredecessorsFailed"), null, GetBackUrl(), ref str_ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObj)
                {
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "btn_DeletePredecessor_Clicked", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_DelPredecessors_EXCEPTION_Shared"));
					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            protected void StepForm_SelectionChanged(object sender, EventArgs e)
            {
                String          FormID              = null;
                DropDownList    SelectedDropDown    = null;
                String          ListID              = null;
                String          SelectedValue       = null;
                String          SelectedID          = null;
                MWB_Helper      MWB_HelperObj       = null;
                String          SelectedContributor = null;
                ListItem        SelectedListItem    = null;
                String          MailID              = null;                
                UserFacade		UserFacadeObj		= null;
				StringBuilder	GroupListXML		= null;
				StringBuilder	TempPath			= null;
                String			TempFilePath		= null;
				String			FileName			= null;
				ulong			ErrorID				= 0;
				StringBuilder	ErrorPageURL_Exp	= null;
                String          StepID              = null;
                try
                {
                    MWB_HelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    UserFacadeObj	 = new UserFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
					GroupListXML	 = new StringBuilder();
                    SelectedDropDown = (DropDownList)sender;
                    ListID           = SelectedDropDown.ID;
                    SelectedListItem = SelectedDropDown.SelectedItem;
                    SelectedValue    = SelectedListItem.Text;
                    SelectedID		 = SelectedListItem.Value;
					TempFilePath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					TempPath		 = new StringBuilder();
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                                                    
                    while (StepFormIDEnum.MoveNext())
                    {
                        if (ListID.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            FormID = StepFormIDEnum.Value.ToString();
                            StepID = StepFormIDEnum.Key.ToString();
                            break;
                        }
                    }
                    if (FormID!=null)
                    {                    
                        TempStepForm        = (Form)Panel_ManualActivities.FindControl(FormID);                            
                        SelectedContributor = TempStepForm.GetValues("Contributor");
						FileName			= FormID + "_GroupUsers.xml";
						TempPath.AppendFormat("{0}{1}", TempFilePath, FileName);
                        if (ListID.Contains("Contributor"))
                        {
                            if (SelectedID.ToUpper() != "NONE")
                            {
								MWB_HelperObj.GetMailAddressForSelectedUser(SelectedID, FileName, out MailID);                                    
                            }                                
                            setStepFormInputXMLForMailAddress(StepID, FormID, MailID);
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "StepForm_SelectionChanged", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateGatherInfoTask_Exceptiononstepformselectionchangeevent"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }
        
            protected void Ab_GatherInfoTask_Click(object sender, EventArgs e)
            {
                ERRORXML	ErrorXML     = null;
                String		ErrorPageURL = null;
                StringBuilder	ErrorPageURL_Exp = null;
                ulong			ErrorID			 = 0;
                Boolean         b_ShowOnSavePopup= false;
                MWB_Helper      helperObj        = null;
                Boolean         b_StartDateToday = false;
                try
                {
                    helperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    String strSender    = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);
                    if (Parameters[1].Equals("btn_Save"))
                    {
                        CheckIfStartDateToday(ref b_StartDateToday);
                        if (b_StartDateToday)
                        {
                            ErrorXML = helperObj.CheckForAutoIndependentTask(TaskID, ref b_ShowOnSavePopup);
                        }
                        if (b_ShowOnSavePopup)
                        {
                            //Set urls for popups
                            SetOnSavePopupUrl("SAVE");
                            Ajax.WriteExecuteJavaScript(Popup_OnSave.ShowPopupWindowJavascript);
                        }
                        else
                        {
                            ErrorXML = HandleSave();
                        }
                        if (ErrorXML != null)
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            return;
                        }
                    }
                    else if (Parameters[1].Equals("btn_SaveAndClose"))
                    {
                        CheckIfStartDateToday(ref b_StartDateToday);
                        if (b_StartDateToday)
                        {
                            ErrorXML = helperObj.CheckForAutoIndependentTask(TaskID, ref b_ShowOnSavePopup);
                        }
                         if (b_ShowOnSavePopup)
                         {
                             //Set urls for popups
                             SetOnSavePopupUrl("SAVEANDCLOSE");
                             Ajax.WriteExecuteJavaScript(Popup_OnSave.ShowPopupWindowJavascript);
                         }
                         else
                         {
                             ErrorXML = HandleSaveandClose();
                         }
						if(ErrorXML != null)
						{
							ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
							if(!IsPostBack)
							{
								Response.Redirect(ErrorPageURL, true);
							}
							else
								Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
							return;
						}
                    }
                    else if (Parameters[1].Equals("btn_Submit"))
                    {
						HandleSubmit();
                        if(ErrorXML != null)
						{
							ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
							if(!IsPostBack)
							{
								Response.Redirect(ErrorPageURL, true);
							}
							else
								Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
							return;
						}
                    }
                    else if (Parameters[1].Equals("btn_Cancel"))
                    {
						DeleteTempFiles();
						if (PrevScreen.ToUpper() == "ROPROJECT")
							gotoProjectROScreen();
						else
							gotoDeliverableROScreen();
                    }
                }
                catch (Exception ExceptionObj)
                {
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "Ab_GatherInfoTask_Click", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_ActionBarClick_EXCEPTION_Shared"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void GetDependencies()
            {								
				XML							ReturnTaskXML	= null;
				ERRORXML					ErrorXML		= null;
				MktgWorkBenchFacadeClass	MWBFacadeObj	= null;
                MWB_Helper                  MWB_HelperObj   = null; 
				StringBuilder				TempPath		= null;                
				String						TempFilePath    = null;
				XPathDocument				TempDoc			= null;
				XPathNavigator				TempNav			= null;
				StringReader				StrTempReader	= null;
                String                      ErrorPageURL    = null;
                String                      str_AttributesXML = null;
                String                      str_AssociationXML= null;

				try
				{
					Lst_PredecessorList.IsMinimize	= false;                    
					TempPath						= new StringBuilder();
					TempFilePath					= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

					if(String.IsNullOrEmpty(Hidden_PredecessorFound.Value))
					{
						MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
                        MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                        MWB_HelperObj.getAssociationXMLForPredecessors_Editable(out str_AttributesXML, out str_AssociationXML);
                        ErrorXML = MWBFacadeObj.GetTask(TaskID, str_AttributesXML, str_AssociationXML, out ReturnTaskXML);
                        if (ErrorXML == null)
                        {
                            StrTempReader = new StringReader(ReturnTaskXML);
                            TempDoc = new XPathDocument(StrTempReader);
                            TempNav = TempDoc.CreateNavigator();
                            //TempNav = TempNav.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS");
                            TempPath.AppendFormat("{0}{1}", TempFilePath, DisplayPredecessorFile);
                            File.WriteAllText(TempPath.ToString(), ReturnTaskXML);

                            TempNav = TempNav.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS");
                            if ((TempNav != null) && (TempNav.HasChildren))
                            {
                                //Save this return XML on NTFS in temp location                            
                                TempPath.Remove(0, TempPath.Length);
                                TempPath.AppendFormat("{0}{1}", TempFilePath, PredecessorInputFile);
                                File.WriteAllText(TempPath.ToString(), TempNav.OuterXml);
                                ID_SelcetPredecessor_UC.InputFileModified = "TRUE";

                            }// end if. 

                            Hidden_PredecessorFound.Value = "TRUE";
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
					}
					else
					{
						TempPath.AppendFormat("{0}{1}", TempFilePath, DisplayPredecessorFile);
						ReturnTaskXML = File.ReadAllText(TempPath.ToString());
					}
					if (ReturnTaskXML!=null)
						PaintPredecessorList(ReturnTaskXML);
				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
            }
            
            protected void GatherInfoTaskTab_onTabClick(object sender,TabClickEventarg e)
            {
				ALPanel			SelectedTab			= null;
				StringBuilder	ErrorPageURL_Exp	= null;
				ulong			ErrorID				= 0;
				Boolean			DatafetchedFlag		= false;
				Boolean			alertGiven			= false;				
				ERRORXML		ErrorXML			= null;
				String			ErrorPageURL		= null;
				String			TaskStatus			= null;		
		        String          str_PrevSelectedTab = null; 

				try
				{
					TabClickFlag = "TRUE";
					ViewState["TabClickFlag"] = "TRUE";
					SelectedTab = (ALPanel)e.SelectedTab;
                    str_PrevSelectedTab = GatherInfoTaskTab.PreviouslySelectedTabName; 

					switch(SelectedTab.Name.ToUpper())
					{
						case "INFO":
                                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GatherInfoTaskTab_onTabClick):- Before TransferData() function. in INFO tab");
                                    ErrorXML = TransferData();
                                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GatherInfoTaskTab_onTabClick):- After TransferData() function. in INFO tab");
                                    if (ErrorXML == null)
                                    {
                                        ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GatherInfoTaskTab_onTabClick):- Before GetTaskDetails() function. in INFO tab");
                                        GetTaskDetails();
                                        ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GatherInfoTaskTab_onTabClick):- After GetTaskDetails() function. in INFO tab");
                                        if (IsPostBack)
                                        {
                                            Frm_GatherInfo.ResetFacetSeriesFields();
                                        }
                                    }
                                    else 
                                    {
                                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                        if (!IsPostBack)
                                        {
                                            Response.Redirect(ErrorPageURL, true);
                                        }
                                        else
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                        return;
                                    }
									break;
						case "USER ROLES":
									DatafetchedFlag = Convert.ToBoolean(this.ViewState["USERROLESTABCLICKED"]);
									//SaveData		= Convert.ToBoolean(Hidden_SaveDate.Value);
                                    TaskStatus      = (String)ViewState["TaskStatus"];
                                    //if(SaveData)
                                    //{
										// Save the task here.
                                    if ((!String.IsNullOrEmpty(str_PrevSelectedTab)) && (str_PrevSelectedTab.ToUpper() == "INFO"))
                                    {
                                        ErrorXML = SaveTask(TaskStatus, out alertGiven);
                                        if (ErrorXML != null)
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            if (!IsPostBack)
                                            {
                                                Response.Redirect(ErrorPageURL, true);
                                            }
                                            else
                                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            return;
                                        }
                                        if (!alertGiven)
                                        {
                                            //Hidden_SaveDate.Value = "false";
                                            RefreshBreadCrumb();
                                            UpdateTaskStepsAndAttachments();
                                        }
                                        else
                                        {
                                            alertGivenFlag = alertGiven;
                                            //Hidden_GiveAlert.Value = "true";
                                        }
                                    }
									//}
									if (!DatafetchedFlag  && !alertGiven)
									{								
										GetUserRoles();
										this.ViewState["USERROLESTABCLICKED"] = "true";
									}								
									break;
						case "DEPENDENCIES":
									DatafetchedFlag		= Convert.ToBoolean(this.ViewState["DEP_TABCLICKED"]);
									//SaveData			= Convert.ToBoolean(Hidden_SaveDate.Value);
                                    TaskStatus          = (String)ViewState["TaskStatus"];
                                    //if(SaveData)
                                    //{
                                    //    // Save the task here.
                                    if ((!String.IsNullOrEmpty(str_PrevSelectedTab)) && (str_PrevSelectedTab.ToUpper() == "INFO"))
                                    {
                                        ErrorXML = SaveTask(TaskStatus, out alertGiven);
                                        if (ErrorXML != null)
                                        {
                                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                                            if (!IsPostBack)
                                            {
                                                Response.Redirect(ErrorPageURL, true);
                                            }
                                            else
                                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                            return;
                                        }

                                        if (!alertGiven)
                                        {
                                            //Hidden_SaveDate.Value = "false";
                                            RefreshBreadCrumb();
                                            UpdateTaskStepsAndAttachments();
                                        }
                                        else
                                        {
                                            alertGivenFlag = alertGiven;
                                            //Hidden_GiveAlert.Value = "true";
                                        }
                                    }
									//}								
									if (!DatafetchedFlag && !alertGiven)
									{
										GetDependencies();
										this.ViewState["DEP_TABCLICKED"] = "true";
									}								
									break;
					}
                    if (!IsPostBack)
					    setBreadcrumbs();
				}
                catch (ThreadAbortException)
                { }
				catch(Exception ExcepObj)
				{
					ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "GatherInfoTaskTab_onTabClick", ExcepObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Perform_Response_Approvals_Task_Exceptionontabclick_Shared"));

					ErrorPageURL_Exp = new StringBuilder();
					ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
					if(!IsPostBack)
					{
						Response.Redirect(ErrorPageURL_Exp.ToString());
					}
					else
						Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
				}
            }
            
            protected void HiddenBtn_SubmitTask_Click(object sender, EventArgs e)
            {
                Boolean         CalculateTimeLine   = false;
                XML             InputXML            = null;
                String          TempPath            = null;
                String          Activity_Info_Table = null; 
                StringBuilder   TempFilePath        = null; 
                String          ErrorPageURL        = null; 
                ERRORXML        ErrorXMLString      = null;
                ulong           ErrorID             = 0;
                StringBuilder   ErrorPageURL_Exp    = null;
                MktgWorkBenchFacadeClass MktgWorkBenchFacadeObj = null;
     
                try
                {
                    TempFilePath            = new StringBuilder(100);
                    MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    TempPath                = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

                    TempFilePath.AppendFormat("{0}SubmitGatherInfoTaskFile_{1}.xml", TempPath, TaskID);
                    //Remove the Dependencies first and then Update the Task
                    ErrorXMLString = MktgWorkBenchFacadeObj.RemoveDependencies(TaskID, "Deliverable", false);
                    if (String.IsNullOrEmpty(ErrorXMLString))
                    {
                        //Load the XML saved on the NTFS and then call the update
                        if (File.Exists(TempFilePath.ToString()))
                        {
                            InputXML            = File.ReadAllText(TempFilePath.ToString());
                            if (!String.IsNullOrEmpty(Hidden_CalculateTimeLine.Value))
                            {
                                CalculateTimeLine = Convert.ToBoolean(Hidden_CalculateTimeLine.Value);
                            }
                            if (!String.IsNullOrEmpty(Hidden_ActivityInfoTable.Value))
                            {
                                Activity_Info_Table = Hidden_ActivityInfoTable.Value;
                            }
                            //Update the task
                            //ErrorXMLString = MktgWorkBenchFacadeObj.SubmitGatherInfoTask(TaskID, CalculateTimeLine, MWB_TimeLineEvents.TASK_DURATION_CHANGED, Activity_Info_Table, ref InputXML);
                            ErrorXMLString = MktgWorkBenchFacadeObj.UpdateTask(TaskID, CalculateTimeLine, MWB_TimeLineEvents.TASK_DURATION_CHANGED, false, ref InputXML);
                            if (String.IsNullOrEmpty(ErrorXMLString))
                            {
                                //StampNotificationForGatherInfoTask(TaskID);
                                if (PrevScreen.ToUpper() == "ROPROJECT")
                                        gotoProjectROScreen();
                                    else
                                        gotoDeliverableROScreen();
                            }
                            else
                            {
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXMLString, null, null, GetBackUrl(), ref ErrorPageURL);
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXMLString, null, null, GetBackUrl(), ref ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        File.Delete(TempFilePath.ToString());   
                    }
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "HiddenBtn_SubmitTask_Click", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_Exceptionwhilesubmittingtask_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

			protected void Hidden_SelectResourceType_Click(object sender, EventArgs e)
			{			
				StringBuilder	FilePath	 = null;
				XPathDocument	RecDoc		 = null;
				XPathNavigator	xpNav		 = null;
				String			SelectedValue= null;
				UserFacade		UserFacadeObj= null;
				XML				SearchXML	 = null;
				XML				UserXML		 = null;
				ERRORXML		ErrorXml	 = null;
				XPathDocument   UserDoc		 = null;
				MWB_Helper		MWB_HelperObj= null;
				String			StepID		 = null;
				String			StepFormID	 = null;
				String			ItemList	 = null;
				String			TempPath	 = null;
				String			FileName	 = null;			
				try
				{
					StepID			= Request["__EVENTARGUMENT"];
					FilePath		= new StringBuilder();
					UserFacadeObj	= new UserFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					MWB_HelperObj	= new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
					TempPath		= ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					FilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
					if(File.Exists(FilePath.ToString()))
					{
						RecDoc = new XPathDocument(FilePath.ToString());
						xpNav  = RecDoc.CreateNavigator();
						xpNav  = xpNav.SelectSingleNode("//*/TreeNode[@Selected='True']");
						if(xpNav != null)
						{
							SelectedValue	= xpNav.GetAttribute("Text","") ;						

							SearchXML = GetSearchXML(SelectedValue);
							ErrorXml = UserFacadeObj.GetUserList(SearchXML, ref UserXML);
							if(ErrorXml == null)
							{
								UserDoc			= new XPathDocument(new StringReader (UserXML));
								ItemList		= MWB_HelperObj.GetContributorXML(UserDoc);
								StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
								IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
								while (StepFormIDEnum.MoveNext())
								{
									StepFormID = StepFormIDEnum.Value.ToString();
									if (StepFormID.Contains(StepID))
										break;
								}
								if(StepFormID != null)
								{
									// save the user file on ntfs
									FilePath.Remove(0, FilePath.Length);
									
									FileName = StepFormID + "_GroupUsers.xml";
									FilePath.AppendFormat("{0}{1}", TempPath, FileName);
									File.WriteAllText(FilePath.ToString(), UserXML);
									setStepFormInputXMLForGroup(StepID, StepFormID, ItemList);
								}
							}
						}
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

            protected override void Render(HtmlTextWriter writer)
            {
                if (IsPostBack)
                {
                    String EventGenerator = Ajax.EventGeneratorUniqueID;


                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    if (StepFormIDTable != null)
                    {
                        IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                        while (StepFormIDEnum.MoveNext())
                        {
                            if (EventGenerator.Contains(StepFormIDEnum.Value.ToString()))
                            {
                                Form StepForm = (Form)Panel_ManualActivities.FindControl(StepFormIDEnum.Value.ToString());
                                if (StepForm != null)
                                {
                                    Ajax.AddControlsToRender(StepForm);
                                    if (EventGenerator.Contains("ExportSeriesRecord"))
                                    {
                                        String ExportUrl = StepForm.GetSeriesExportUrl();
                                        if (!String.IsNullOrEmpty(ExportUrl))
                                            Ajax.WriteExecuteJavaScript(ExportUrl);
                                    }
                                    if (ViewState["ComponentFacetFieldName"] != null)
                                    {
                                        //loading digital assets for components dynamically.
                                        Ajax.WriteExecuteJavaScript("javascript:" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                                    }
                                }
                            }
                        }
                    }

                    if (!String.IsNullOrEmpty(TabClickFlag) && TabClickFlag.Equals("TRUE") && !alertGivenFlag)
                    {
                        if (GatherInfoTaskTab.SelectedTab != null)
                        {
                            Ajax.AddControlsToRender(GatherInfoTaskTab.SelectedTab);
                            Ajax.WriteExecuteJavaScript("javascript:" + GatherInfoTaskTab.HighlightTabJavaScript);
                            Ajax.AddControlsToRender(GatherInfoTaskBreadcrumb);
                        }
                    }

                    if (EventGenerator.Contains("SelectPredecessor_Ok") || EventGenerator.Contains("SelectPredecessor_BtnSelect") || EventGenerator.Contains("btn_SelectPredecessor_Remove") || EventGenerator.Contains("btn_SelectPredecessors") || EventGenerator.Contains("Content_2_lc_ListOfPredecessors_Min_Btn") || EventGenerator.Contains("btn_SelectPredecessor"))
                    {
                        Ajax.AddControlsToRender(Frm_GatherInfo);
                        Ajax.AddControlsToRender(ID_SelcetPredecessor_UC);
                    }
                    if (EventGenerator.Contains("btn_DeletePredecessor") || EventGenerator.Contains("SelectPredecessor_Ok") || EventGenerator.Contains("Content_2_lc_ListOfPredecessors_Min_Btn") || EventGenerator.Contains("Content_2_lc_ListOfPredecessors"))
                    {
                        Ajax.AddControlsToRender(Frm_GatherInfo);
                        Ajax.AddControlsToRender(Lst_PredecessorList);
                    }
                    Ajax.AddControlsToRender(TempStepForm);
                    if (EventGenerator.Contains("btn_Save"))
                    {
                        Ajax.AddControlsToRender(Frm_GatherInfo);
                        Ajax.AddControlsToRender(GatherInfoTaskBreadcrumb);
                        Ajax.AddControlsToRender(BinderControl);
                    }

                    if (EventGenerator.Contains("Content_1_Frm_GatherInfo_TaskDetails") || b_RenderTaskForm)
                    {
                        Ajax.AddControlsToRender(Frm_GatherInfo);
                        if (EventGenerator.Contains("ExportSeriesRecord"))
                        {
                            String ExportUrl = Frm_GatherInfo.GetSeriesExportUrl();
                            if (!String.IsNullOrEmpty(ExportUrl))
                                Ajax.WriteExecuteJavaScript(ExportUrl);
                        }
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            //loading digital assets for components dynamically.
                            Ajax.WriteExecuteJavaScript("javascript:" + (String)Frm_GatherInfo.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction"));
                        }
                    }

                    if (EventGenerator.Contains("Btn_Hidden_Attachment") || (EventGenerator.Contains("DeleteAttachments")) || (EventGenerator.Contains("Binder_Attachments")))
                        Ajax.AddControlsToRender(BinderControl);

                    if (EventGenerator.Contains("LstTemplateDocument"))
                        Ajax.AddControlsToRender(Lst_TemplateDocument);

                    //Render the Process Completion User group list
                    if ((EventGenerator.Contains(Btn_Hidden_GroupSelection.UniqueID)) || (EventGenerator.Contains(Btn_Hidden_UserSelection.UniqueID))
                        || (EventGenerator.Contains("btn_PCDelete")) || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperNext") || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperLast") || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperFirst") || EventGenerator.Contains("ProcessComplete_UserGroup_List_UpperPrev"))
                    {
                        Ajax.AddControlsToRender(Lst_UserGroup);
                    }

                    if ((EventGenerator.Contains(LC_TaskReaders.UniqueID)) || (EventGenerator.Contains(Btn_Hidden_TaskReaderGroup.UniqueID)) || (EventGenerator.Contains(Btn_Hidden_TaskReaderUser.UniqueID)))
                        Ajax.AddControlsToRender(LC_TaskReaders);

                    Ajax.AddControlsToRender(ID_Submit);
                    Ajax.WriteControlHTMl(this.Page, writer);
                }
                else
                {
                    base.Render(writer);
                    if ((ViewState["ComponentFacetFieldName"] != null))
                    {
                        //loading digital assets for components dynamically.
                        writer.Write("<script type=\"text/javascript\">" + (String)Frm_GatherInfo.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        if (StepFormIDTable != null)
                        {
                            IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                            while (StepFormIDEnum.MoveNext())
                            {
                                Form StepForm = (Form)Panel_ManualActivities.FindControl(StepFormIDEnum.Value.ToString());
                                if (StepForm != null)
                                {
                                    writer.Write("<script type=\"text/javascript\">" + (String)StepForm.GetFieldListControlProperty(ViewState["ComponentFacetFieldName"].ToString(), "LoadDigitalAssetJavaScriptfunction") + "</script>");
                                }
                            }
                        }
                    }
                }
            }

            /// <alsummary>
            /// <createddate>16-Dec-2008</createddate>
            /// <author>Radha A</author>
            /// <purpose>To receive selected sign id's</purpose>
            /// </alsummary>
            protected void Btn_Hidden_SelectSigns_Click(object sender, EventArgs e)
            {
                String          SelectedRowsFilePath    = null;
                String          str_ActivityID          = null;
                Boolean         alertGiven              = false;
                String          TaskStatus              = null;
                ERRORXML        ErrorXml                = null;
                String          str_ErrorPageURL        = null;
                try
                {
                    SelectedRowsFilePath = Request["__EVENTARGUMENT"];
                    if (!String.IsNullOrEmpty(SelectedRowsFilePath))
                    {
                        if (String.Compare(SelectedRowsFilePath.Split(',')[0], "STEP", true) == 0)
                        {
                            GetSelectedStepForm("STEP_" + SelectedRowsFilePath.Split(',')[1], out str_ActivityID);
                        }
                    }
                    alertGiven = false;
                    TaskStatus = (String)ViewState["TaskStatus"];
                    ErrorXml = SaveTask(TaskStatus, out alertGiven);
                    if (ErrorXml == null && (!alertGiven))
                    {
                        RefreshBreadCrumb();
                        UpdateTaskStepsAndAttachments();
                        b_RenderTaskForm = true;
                    }
                    else if (ErrorXml !=null)
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXml, null, null, GetBackUrl(), ref str_ErrorPageURL);
                        Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }
            
            /// <summary>
            ///  <createddate>21 May 2009</createddate>
            /// <author>Jisha Rajendran</author>		
            /// <purpose>To handle action bar click event of Process completion user/group list.</purpose>
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void Lst_UserGroup_ActionBarClick(object sender, EventArgs e)
            {
                ulong           ul_ErrorID          = 0;
                String          str_ErrorPageURL    = null;
                String          EncryptURL          = null;
                XML             xml_Error           = null;
                MWB_Helper      MWB_HelperObj       = null;
                try
                {
                    MWB_HelperObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if (sender.ToString().Contains("btn_PCAddGroups"))
                    {
                        EncryptURL = MWB_HelperObj.GetGroupSelectionPageUrl(TaskID + SelectedGroupsFileName, Btn_Hidden_GroupSelection.UniqueID, Page.Theme);
                        Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_new','left=150,top=150,width=600,height=540,scrollbars=yes');");
                    }

                    else if (sender.ToString().Contains("btn_PCDelete"))
                        populateUserGroupList(null, null, "DELETE");

                    else if (sender.ToString().Contains("btn_PCAddUsers"))
                    {
                        EncryptURL = MWB_HelperObj.GetUserSelectionPageUrl(TaskID + SelectedUsersFileName, Btn_Hidden_UserSelection.UniqueID, Page.Theme);
                        Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_new','left=150,top=150,width=600,height=540,scrollbars=yes');");
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateDiscussionTask.aspx", "BtnHidden_UserSelection_Click", obj_Exception, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlingactionbarclickesontheUserGrouplist_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                }
            }
            
            /// <summary>
            /// <createddate>21 May 2009</createddate>
            /// <author>Jisha Rajendran</author>		
            /// <purpose>Associates the selected group with the process and updates it in the user/group list.</purpose>        
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void BtnHidden_GroupSelection_Click(object sender, EventArgs e)
            {
                ulong           ul_ErrorID              = 0;
                String          str_ErrorPageURL        = null;
                MWB_Helper      MWB_HelperObj           = null;
                String          str_SelectedGroupPath   = null;
                XML             xml_Error               = null;

                try
                {
                    MWB_HelperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    str_SelectedGroupPath   = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + SelectedGroupsFileName;
                    
                    //Check whether Group Selection file is present on the NTFS or not
                    if (File.Exists(str_SelectedGroupPath.ToString()))
                    {
                        xml_Error = populateUserGroupList(null, File.ReadAllText(str_SelectedGroupPath.ToString()), "UPDATE");
                        if (!String.IsNullOrEmpty(xml_Error))
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                        }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateDiscussionTask.aspx", "BtnHidden_UserSelection_Click", obj_Exception, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlinghiddenbuttonclickforGorupselection_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                }
            }

            /// <summary>
            /// <createddate>21 May 2009</createddate>
            /// <author>Jisha Rajendran</author>		
            /// <purpose>Associates the selected user with the process and updates it in the user/group list.</purpose>        
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void BtnHidden_UserSelection_Click(object sender, EventArgs e)
            {
                ulong           ul_ErrorID              = 0;
                String          str_ErrorPageURL        = null;
                MWB_Helper      MWB_HelperObj           = null;
                String          str_SelectedUserPath    = null;
                XML             xml_Error               = null;

                try
                {
                    MWB_HelperObj           = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    str_SelectedUserPath    = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + SelectedUsersFileName;
                    
                    //Check whether User Selection file is present on the NTFS or not
                    if (File.Exists(str_SelectedUserPath.ToString()))
                    {
                        xml_Error = populateUserGroupList(File.ReadAllText(str_SelectedUserPath.ToString()), null, "UPDATE");
                        if (!String.IsNullOrEmpty(xml_Error))
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                        }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateDiscussionTask.aspx", "BtnHidden_UserSelection_Click", obj_Exception, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlinghiddenbuttonclickforUserselection_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                }
            }

            /// <summary>
            /// <CreatedOn>04 April 2012</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To handle action bar click on the Task Reader list</Purpose>
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void LC_TaskReaders_ActionBarClick(object sender, EventArgs e)
            {
                String[]                    str_Parameter                   = null;
                String                      str_DeleteUserGroupIDs          = null;
                String                      str_ErrorPageURL                = null;
                XML                         xml_TaskXML                     = null; 
                ulong                       ul_ErrorID                      = 0;
                XPathDocument               xpathDoc_SelectedUsersOutputXml = null;            
                ERRORXML                    ErrorXml                        = null;
                MktgWorkBenchFacadeClass    obj_MWBFacade                   = null;

                try
                {
                    str_Parameter = sender.ToString().Split(strSeparator, StringSplitOptions.RemoveEmptyEntries);
                    if (String.Compare(str_Parameter[1], "btn_Delete", true) == 0)
                    {
                        str_DeleteUserGroupIDs = Request["__EVENTARGUMENT"];
                        if ((!String.IsNullOrEmpty(str_DeleteUserGroupIDs)))
                        {
                            obj_MWBFacade = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            ErrorXml = obj_MWBFacade.UpdateReaders(TaskID, ProcessDefinitionID, null, str_DeleteUserGroupIDs, LC_TaskReaders.Source, false, "Task", "USERGROUP", out xml_TaskXML);
                            if (String.IsNullOrEmpty(ErrorXml))
                            {
                                xpathDoc_SelectedUsersOutputXml = new XPathDocument(new StringReader(xml_TaskXML));
                                if (String.IsNullOrEmpty(ErrorXml))
                                    setTaskReadersUserGroupList(xpathDoc_SelectedUsersOutputXml.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS"), xpathDoc_SelectedUsersOutputXml.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/READERS"));
                            }
                            else
                            {
                                ul_ErrorID = ALSolutionCommon.DumpErrorInfo("Manage_CreateApprovalsTask.aspx", "LC_TaskReaders_ActionBarClick", ErrorXml);
                                ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXml, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_UpdateTaskFailed"), "", GetBackUrl(), ref str_ErrorPageURL);
                                Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                            }
                        }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "LC_TaskReaders_ActionBarClick", obj_Exception, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateApprovalsTask_ExceptioninhandlingUserGrouplistButtonClicks_Shared"));
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXml, null, null, GetBackUrl(), ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                }
            }

            /// <summary>
            /// <createddate>04 April 2012</createddate>
            /// <author>Mr. Hemant Karkande</author>		
            /// <purpose>Associates the selected group with the process and updates it in the user/group list.</purpose>        
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void BtnHidden_TaskReaderGroupSelection_Click(object sender, EventArgs e)
            {
                ulong                       ul_ErrorID                  = 0;
                String                      str_ErrorPageURL            = null;
                String                      str_SelectedUserGroupPath   = null;
                ERRORXML                    xml_Error                   = null;
                XML                         xml_ReturnXML               = null; 
                XPathDocument               xp_SelectedUserGroup        = null; 
                MktgWorkBenchFacadeClass    obj_MWBFacade               = null; 

                try
                {
                    obj_MWBFacade       = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_MWBFacade.SolutionName = SolutionName;
                    str_SelectedUserGroupPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderGroupsFileName;
                    
                    //Check whether User Selection file is present on the NTFS or not
                    if (File.Exists(str_SelectedUserGroupPath.ToString()))
                    {
                        xml_Error = obj_MWBFacade.UpdateReaders(TaskID, ProcessDefinitionID, str_SelectedUserGroupPath.ToString(), null, LC_TaskReaders.Source, false, "Task", "Group", out xml_ReturnXML);  
                        if (!String.IsNullOrEmpty(xml_Error))
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                        }
                        else
                        {
                            if (!String.IsNullOrEmpty(xml_ReturnXML))
                            {
                                xp_SelectedUserGroup = new XPathDocument(new StringReader(xml_ReturnXML));
                                setTaskReadersUserGroupList(xp_SelectedUserGroup.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS"), xp_SelectedUserGroup.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/READERS"));
                            }
                        }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "BtnHidden_TaskReaderUserSelection_Click", obj_Exception, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateApprovalsTask_ExceptioninhandlingUserGrouplistButtonClicks_Shared"));
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                }
            }

            /// <summary>
            /// <createddate>04 April 2012</createddate>
            /// <author>Mr. Hemant Karkande</author>		
            /// <purpose>Associates the selected user with the process and updates it in the user/group list.</purpose>        
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void BtnHidden_TaskReaderUserSelection_Click(object sender, EventArgs e)
            {
                ulong                       ul_ErrorID                  = 0;
                String                      str_ErrorPageURL            = null;
                String                      str_SelectedUserGroupPath   = null;
                ERRORXML                    xml_Error                   = null;
                XML                         xml_ReturnXML               = null; 
                XPathDocument               xp_SelectedUserGroup        = null; 
                MktgWorkBenchFacadeClass    obj_MWBFacade               = null; 

                try
                {
                    obj_MWBFacade       = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    obj_MWBFacade.SolutionName = SolutionName;
                    str_SelectedUserGroupPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderUsersFileName;
                    
                    //Check whether User Selection file is present on the NTFS or not
                    if (File.Exists(str_SelectedUserGroupPath.ToString()))
                    {
                        xml_Error = obj_MWBFacade.UpdateReaders(TaskID, ProcessDefinitionID, str_SelectedUserGroupPath.ToString(), null, LC_TaskReaders.Source, false, "Task", "User", out xml_ReturnXML);  
                        if (!String.IsNullOrEmpty(xml_Error))
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                        }
                        else
                        {
                            if (!String.IsNullOrEmpty(xml_ReturnXML))
                            {
                                xp_SelectedUserGroup = new XPathDocument(new StringReader(xml_ReturnXML));
                                setTaskReadersUserGroupList(xp_SelectedUserGroup.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS"), xp_SelectedUserGroup.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/READERS"));
                            }
                        }
                    }
                }
                catch (Exception obj_Exception)
                {
                    ul_ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "BtnHidden_TaskReaderUserSelection_Click", obj_Exception, null,
                        Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_Manage_CreateApprovalsTask_ExceptioninhandlingUserGrouplistButtonClicks_Shared"));
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", xml_Error, null, null, GetBackUrl(), ref str_ErrorPageURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + str_ErrorPageURL + "','_self','');");
                }
            }

        #endregion

        #region Private Methods

            private void setBreadcrumbs()
            {
                MktgWorkBenchFacadeClass    MWBFacadeObj            = null;
                String                      OutputXML               = null;
                String                      DeliverableName         = null; 
                String                      EncryptURL              = null; 
                String                      ProjectName             = null; 
                String                      EncryptURLForProject    = null; 
                StringBuilder               ParamURL                = null; 
                StringBuilder               SB_BreadCrumbXML        = null; 
                XML                         BreadCrumbXML           = null; 
                XmlDocument                 OutputXmlDoc            = null;
                XmlDocument                 BreadCrumbXmlDoc        = null;
                XmlNode                     ProjectBreadCrumbNode   = null;
                XmlNode                     DelivBreadCrumbNode     = null; 
                XmlNode                     TaskBreadCrumbNode      = null; 
                XmlNode                     DeliverableTaskNode     = null;
                XmlNode                     CancelDeliverableNode   = null; 
                XmlNode                     ProjectNode             = null; 
                ERRORXML                    ErrorXML                = null;
                String                      ErrorPageURL            = null;
                ulong                       ErrorID                 = 0;
                StringBuilder               ErrorPageURL_Exp        = null;

                try
                {
                    OutputXmlDoc        = new XmlDocument();
                    BreadCrumbXmlDoc    = new XmlDocument();
                    ParamURL            = new StringBuilder();
                    SB_BreadCrumbXML    = new StringBuilder();
                    MWBFacadeObj        = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if (!String.IsNullOrEmpty(BreadcrumbCtrlID))
                    {
                        GatherInfoTaskBreadcrumb.BreadcrumbUniqueID = BreadcrumbCtrlID;
                    }
                        
                    if (!String.IsNullOrEmpty(ParentBreadcrumbName))
                    {
                        GatherInfoTaskBreadcrumb.ParentBreadcrumbName = ParentBreadcrumbName;
                    }
                    GatherInfoTaskBreadcrumb.NavigateUrl = this.Request.Url.AbsoluteUri;
                    GatherInfoTaskBreadcrumb.InputXml    = null;
                    GatherInfoTaskBreadcrumb.Name        = "Task";

                    if (ParentBreadcrumbName.ToUpper() == "PROJECT")
                    {
                        ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, false, out OutputXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            //Load the OutputXML and get the deliverable name
                            BreadCrumbXML = GatherInfoTaskBreadcrumb.InputXmlNode.OuterXml;
                            OutputXmlDoc.LoadXml(OutputXML);
                            DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK");
                            if (DeliverableTaskNode != null)
                            {
                                //HemantK: for Component facet
                                if (String.IsNullOrEmpty(DeliverableID))
                                {
                                    DeliverableID = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                                    ViewState["ParentDeliverableID"] = DeliverableID;
                                }
                                DeliverableName = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/PROCESSNAME").InnerText;
                                BreadCrumbXmlDoc.LoadXml(BreadCrumbXML);
                                ProjectBreadCrumbNode = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb[@Name='Project']");
                                TaskBreadCrumbNode = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb/BreadCrumb[@Name='Task']");
                                if (TaskBreadCrumbNode != null)
                                    ProjectBreadCrumbNode.RemoveChild(TaskBreadCrumbNode);

                                DelivBreadCrumbNode = BreadCrumbXmlDoc.CreateElement("BreadCrumb");
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("Name", "Deliverable");
                                //Prepare URL for the Deliverable
                                ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, BreadcrumbCtrlID);
                                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("NavigationUrl", EncryptURL);
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("DisplayText", DeliverableName);
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("Selected", "False");
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("Image", "");
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("RaiseEvent", "False");
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("BreadcrumbTextMode", "Text");
                                ((XmlElement)DelivBreadCrumbNode).SetAttribute("Tooltip", "");

                                if (ProjectBreadCrumbNode != null)
                                    ProjectBreadCrumbNode.AppendChild(DelivBreadCrumbNode);

                                GatherInfoTaskBreadcrumb.ParentBreadcrumbName   = "Deliverable";
                                GatherInfoTaskBreadcrumb.NavigateUrl            = this.Request.Url.AbsoluteUri;
                                GatherInfoTaskBreadcrumb.InputXml               = BreadCrumbXmlDoc.InnerXml;
                                GatherInfoTaskBreadcrumb.Name                   = "Task";
                                GatherInfoTaskBreadcrumb.DisplayText            = ViewState["TaskTitle"].ToString();
                            }
                        }
                        else
                        {
                            //Error getting parent Deliverable
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, 
                                Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_GetParentsTask_Shared"),
                                null, GetBackUrl(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    else if ((String.IsNullOrEmpty(ParentBreadcrumbName)) && (!String.IsNullOrEmpty(PrevScreen)) && (PrevScreen.ToUpper() == "DASHBOARD"))    
                    {
                        //It has come from Dashboard, So prepare BreadCrumbXML with URL
                        ErrorXML = MWBFacadeObj.GetParentsForTask(TaskID, true, out OutputXML);
                        if (String.IsNullOrEmpty(ErrorXML)) 
                        {
                            //Load the OutputXML and get the Project & Deliverable name
                            OutputXmlDoc.LoadXml(OutputXML);
                            //Author    : Bhalchandra Kadam
                            //Comment   : This code path not executes, so xpath expression not changed.
                            DeliverableTaskNode = OutputXmlDoc.SelectSingleNode("descendant::DELIVERABLE_TASK");
                            if (DeliverableTaskNode != null)
                            {
                                //HemantK: for Component facet
                                if (String.IsNullOrEmpty(DeliverableID))
                                {
                                    DeliverableID = DeliverableTaskNode.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESSID").InnerText;
                                    ViewState["ParentDeliverableID"] = DeliverableID;
                                }
                                DeliverableName = DeliverableTaskNode.SelectSingleNode("descendant::PROCESSNAME").InnerText;
                                ProjectNode = OutputXmlDoc.SelectSingleNode("descendant::PROJECT_DELIVERABLE");
                                if (ProjectNode != null)
                                    ProjectName = ProjectNode.SelectSingleNode("descendant::PROCESSNAME").InnerText;
                            }

                            if ((!String.IsNullOrEmpty(ProjectName)) && (!String.IsNullOrEmpty(DeliverableName)))
                            {
                                //Prepare URL for Project and Deliverable
                                ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, GatherInfoTaskBreadcrumb.BreadcrumbUniqueID);
                                EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                                ParamURL.Remove(0, ParamURL.Length);
                                ParamURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode={5}&Access={6}&PrevScreen={7}&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ProjectID, Mode, Access, PrevScreen, GatherInfoTaskBreadcrumb.BreadcrumbUniqueID);
                                EncryptURLForProject = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                                //Prepare input XML for breadcrumb
                                SB_BreadCrumbXML.AppendFormat(@"<BreadCrumbs>
                                                                    <BreadCrumb Name='Project' NavigationUrl='{0}' DisplayText='{1}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                        <BreadCrumb Name='Deliverable' NavigationUrl='{2}' DisplayText='{3}' Selected='False' Image='' RaiseEvent='False' BreadcrumbTextMode='Text' Tooltip=''>
                                                                        </BreadCrumb>
                                                                    </BreadCrumb>
                                                                </BreadCrumbs>", EncryptURLForProject, ALSolutionCommon.TrimAndReplaceSpecialChars(ProjectName), EncryptURL, ALSolutionCommon.TrimAndReplaceSpecialChars(DeliverableName));
                            }
                            GatherInfoTaskBreadcrumb.ParentBreadcrumbName   = "Deliverable";
                            GatherInfoTaskBreadcrumb.NavigateUrl            = this.Request.Url.AbsoluteUri;
                            GatherInfoTaskBreadcrumb.InputXml               = SB_BreadCrumbXML.ToString();
                            GatherInfoTaskBreadcrumb.Name                   = "Task";
                            GatherInfoTaskBreadcrumb.DisplayText            = ViewState["TaskTitle"].ToString();
                            BreadcrumbCtrlID                                = GatherInfoTaskBreadcrumb.BreadcrumbUniqueID;  
                        }
                        else
                        {
                            //Error getting parent Deliverable
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, 
                                Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_GetParentsTask_Shared"),
                                null, GetBackUrl(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    else
                    {
                        //It has come from the Deliverable screen or from the cancel delvierable screen
                        BreadCrumbXML = GatherInfoTaskBreadcrumb.InputXmlNode.OuterXml;
                        BreadCrumbXmlDoc.LoadXml(BreadCrumbXML);
                        CancelDeliverableNode   = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb/BreadCrumb/BreadCrumb[@Name='CancelDeliverable']");
                        DelivBreadCrumbNode     = BreadCrumbXmlDoc.SelectSingleNode("BreadCrumbs/BreadCrumb/BreadCrumb[@Name='Deliverable']");
                        if (CancelDeliverableNode != null)
                        {
                            DelivBreadCrumbNode.RemoveChild(CancelDeliverableNode);
                            //Prepare URL for the Deliverable
                            ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, BreadcrumbCtrlID);
                            EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());

                            ((XmlElement)DelivBreadCrumbNode).SetAttribute("NavigationUrl", EncryptURL);
                        }
                        
                        GatherInfoTaskBreadcrumb.ParentBreadcrumbName   = "Deliverable";
                        GatherInfoTaskBreadcrumb.NavigateUrl            = this.Request.Url.AbsoluteUri;
                        GatherInfoTaskBreadcrumb.InputXml               = BreadCrumbXmlDoc.InnerXml;
                        GatherInfoTaskBreadcrumb.Name                   = "Task";
                        GatherInfoTaskBreadcrumb.DisplayText            = ViewState["TaskTitle"].ToString();
                    }
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "setBreadcrumbs", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_Exceptionwhilesettingbreadcrumbs_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }    

            private String GetBackUrl()
            {
                StringBuilder ParamURL = null;                
                try
                {
                    ParamURL = new StringBuilder(); 
                    ParamURL.AppendFormat("/{0}/{8}/ASPX/Manage_CreateGatherInfoTask.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&TaskID={4}&ProjectID={5}&Mode={6}&DeliverableID={7}&Access={9}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, TaskID, ProjectID, Mode, DeliverableID, SolutionName, Access);
                    ParamURL.AppendFormat("&PARENTBREADCRUMBNAME={0}&BREADCRUMBCTRLID={1}&PrevScreen={2}&PackageDefinitionID={3}&ProcessDefinitionID={4}", ParentBreadcrumbName, BreadcrumbCtrlID, PrevScreen, __PackageDefinitionID.Value, __ProcessDefinitionID.Value);
                    return ParamURL.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            private void setParameters()
        {
            try
            {
                strSeparator            = new String[1] { "$AL$" };
                DeliverableID           = ALSolutionCommonObj.GetParamValue("DeliverableID");
                ProjectID               = ALSolutionCommonObj.GetParamValue("ProjectID");
                TaskID                  = ALSolutionCommonObj.GetParamValue("TaskID");                
                Mode                    = ALSolutionCommonObj.GetParamValue("Mode");
                Access				    = ALSolutionCommonObj.GetParamValue("Access");
                ParentBreadcrumbName    = ALSolutionCommonObj.GetParamValue("PARENTBREADCRUMBNAME");
                BreadcrumbCtrlID        = ALSolutionCommonObj.GetParamValue("BREADCRUMBCTRLID");
                PrevScreen				= ALSolutionCommonObj.GetParamValue("PrevScreen");
                SelectedTab				= ALSolutionCommonObj.GetParamValue("SelectedTab");
                str_SubflowActivityID   = ALSolutionCommonObj.GetParamValue("SubflowActivityID");
                str_TaskStatus          = ALSolutionCommonObj.GetParamValue("TaskStatus");
                if (String.IsNullOrEmpty(SelectedTab))
					SelectedTab = "INFO";
                PackageDefinitionID = ALSolutionCommonObj.GetParamValue("PackageDefinitionID");
                if (!String.IsNullOrEmpty(PackageDefinitionID))
                {
                    __PackageDefinitionID.Value = PackageDefinitionID;
                }
                ProcessDefinitionID = ALSolutionCommonObj.GetParamValue("ProcessDefinitionID");
                if (!String.IsNullOrEmpty(ProcessDefinitionID))
                {
                    __ProcessDefinitionID.Value = ProcessDefinitionID;
                }
                if (!String.IsNullOrEmpty(DeliverableID))
                {
                    ViewState["ParentDeliverableID"] = DeliverableID;
                }
                if (!String.IsNullOrEmpty(TaskID))
                {
                    TaskFile                = TaskID + "_MWB_GatherInfoTask.xml";
                    PredecessorInputFile    = TaskID + "_GatherInfoPredecessorInput.xml";
                    PredecessorOutputFile   = TaskID + "_GatherInfoPredecessorOutput.xml";
                    GroupListFile           = TaskID + "_GatherInfoGroupList.xml";
                    DisplayPredecessorFile  = TaskID + "_GatherInfoPredecessor.xml";                    
                    StepResourceFileName    = TaskID + "_ActivityResourceColl.xml";
                    ResourceTreeFile        = TaskID + "_ResourceGroupTree.xml";
                    SelectedReaderGroupsFileName    = TaskID + "_ProcessReader_SelectedGroups.xml";
                    SelectedReaderUsersFileName     = TaskID + "_ProcessReader_SelectedUsers.xml";
                    SelectedReaderUserGroupsFileName= TaskID + "_ProcessReader_SelectedUsersGroups.xml";
                }
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }
        }

            private void setControls()
            {
                StringBuilder ListControlXMLPath    = null;
                StringBuilder ActionBarXMLPath      = null;                            
                String        CultureInformation    = null;
                String        FormatXMLPath         = null;
                StringBuilder sb_JsFunction			= null;
                TabFacade	  TabFacadeObj			= null;

                try
                {
                    ListControlXMLPath  = new StringBuilder();                
                    ActionBarXMLPath    = new StringBuilder();                    
                    sb_JsFunction		= new StringBuilder();
                    TabFacadeObj		= new TabFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);	
                    Page_CreatePage.TenantName = ALParamObj.TenantName;
                    Page_CreatePage.SectionHeading = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_EditTask_Shared");

                    FormatXMLPath = ALCommon.GetFormatDetails(ALParamObj.TenantName, out CultureInformation);

                    // set the tenant name of task panes
                    Left_1_tp_MarketingWorkBench.TenantName = ALParamObj.TenantName;
                    Left_2_tp_Manage_GI.TenantName          = ALParamObj.TenantName;
                    
                    GatherInfoTaskBreadcrumb = (ALBreadCrumb)Page_CreatePage.FindControl("GatherInfoTaskBreadcrumb");
                    GatherInfoTaskBreadcrumb.TenantName = ALParamObj.TenantName;
                    GatherInfoTaskBreadcrumb.BreadcrumbTextMode = ALBreadCrumb.BreadcrumbText.Text;

                    Hidden_GiveAlert		= (HiddenField)ID_Submit.FindControl("__GiveAlert");
					Hidden_SaveDate			= (HiddenField)ID_Submit.FindControl("__SaveData");
                    Hidden_CalculateTimeLine= (HiddenField)ID_Submit.FindControl("__CalculateTimeLine");    
                    Hidden_ActivityInfoTable= (HiddenField)ID_Submit.FindControl("__Activity_Info_Table");    
                    
                    GatherInfoTaskTab				= (ALTab)Page_CreatePage.FindControl("tabEditTask");
					GatherInfoTaskTab.TenantName	= ALParamObj.TenantName;
                    TabFacadeObj.TabName            = "tabEditTask";
					TabFacadeObj.ScreenName		    = "EDITTASK";
					TabFacadeObj.SolutionName	    = SolutionName;
					TabFacadeObj.InitializeTab(ref GatherInfoTaskTab);
					
					Panel_TaskDetails		= (ALPanel)GatherInfoTaskTab.FindControl("panelTaskDetails");
					Panel_Dependencies		= (ALPanel)GatherInfoTaskTab.FindControl("panelDependencies");
					Panel_UserRoles			= (ALPanel)GatherInfoTaskTab.FindControl("panelUserRoles");
					Panel_Form				= (ALPanel)Panel_TaskDetails.FindControl("PanelForm");

                    Frm_GatherInfo                        = (Form)Panel_Form.FindControl("Content_1_Frm_GatherInfo_TaskDetails");
                    Frm_GatherInfo.TenantName             = ALParamObj.TenantName;
                    Frm_GatherInfo.EnableSetFocus		  = true;
                    Frm_GatherInfo.CultureInformation     = CultureInformation;
                    Frm_GatherInfo.PersonalizationFilePath= FormatXMLPath;
                    Frm_GatherInfo.SolutionName           = SolutionName;
                    //Frm_GatherInfo.AddCustomValidator("WORKFLOWPROCESS_PROCESSNAME", "onblur", "ValidateName('$CONTROLID$', '" + Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_TaskTitle_Shared") + "')", false);
                    Frm_GatherInfo.AddCustomValidator("WORKFLOWPROCESS_PROCESSNAME", "onblur", "ValidateName('$CONTROLID$', '" + ALSpecialCharHandling.EncodeSpecialCharactersForJS(Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_TaskTitle_Shared")) + "')", false);

                    Lst_PredecessorList                   = (Assetlink.CustomControls.ListControl)Panel_Dependencies.FindControl("Content_2_lc_ListOfPredecessors");
                    Lst_PredecessorList.TenantName        = ALParamObj.TenantName;
                    Lst_PredecessorList.SectionHeading    = Localization.GetString("ALResource", ALParamObj.TenantName, "MWB_DependantOn_Shared");
					ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Manage_CreateGatherInfoTask_Content_2_lc_ListOfPredecessors_Editable_PredecessorListForTask_ActionBar"));
                    Lst_PredecessorList.ActionBarXML    = ActionBarXMLPath.ToString();
					Lst_PredecessorList.EnableIterators = true;
                    Lst_PredecessorList.PersonalizationFilePath	= FormatXMLPath;

                    //Set LstTemplateDocument List
                    Panel_Templates      = (ALPanel)Panel_TaskDetails.FindControl("PanelTemplates");
                    Lst_TemplateDocument = (Assetlink.CustomControls.ListControl)Panel_Templates.FindControl("LstTemplateDocument");
                    Lst_TemplateDocument.TenantName = ALParamObj.TenantName;

                    //Bhalchandra - This event has been handled in the page load.
					Hidden_PredecessorFound	= (HiddenField)ID_Submit.FindControl("__PredecessorsFound");					
                    Ab_GatherInfoTask       = (ActionBar)Panel_TaskDetails.FindControl("Content_7_ab_GatherInfo_ActionBar");
                    ActionBarXMLPath.Remove(0, ActionBarXMLPath.Length);
					ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Manage_CreateGatherInfoTask_Content_6_ab_GatherInfo_ActionBar_ActionBar"));
                    Ab_GatherInfoTask.InputXML          = ActionBarXMLPath.ToString();
                    Ab_GatherInfoTask.AddAttributes("btn_Submit", "href", "javascript:ValidateForm('$CONTROLID$')");
                   
                    Panel_ManualActivities = (ALPanel)Panel_TaskDetails.FindControl("Panel_Steps");

                    // set properties of Select predecessor user control.
                    ID_SelcetPredecessor_UC.InputFileName = PredecessorInputFile;
                    ID_SelcetPredecessor_UC.ProcessID = TaskID;
                    ID_SelcetPredecessor_UC.OutPutFileName = PredecessorOutputFile;
					ID_SelcetPredecessor_UC.PredecessorType = "TASK";

					BinderControl = (Binder)Panel_TaskDetails.FindControl("Binder_Attachments");
                    BinderControl.TenantName = ALParamObj.TenantName;

                    Popup_SelectPredecessorsTask_GatherInfo.TenantName      = ALParamObj.TenantName;
                    Popup_SelectPredecessorsTask_GatherInfo.CaptionText     = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_SelectTasks_Shared");
                    Popup_SelectPredecessorsTask_GatherInfo.PopupDisplayMode= ePopupDisplayMode.Simple;
                    Popup_SelectPredecessorsTask_GatherInfo.Style.Add(HtmlTextWriterStyle.Display, "None");
                    
                    //Set Readers Control
                    LC_TaskReaders                  = (CustomControls.ListControl)Panel_UserRoles.FindControl("List_TaskReaders");
                    LC_TaskReaders.TenantName       = ALParamObj.TenantName;
                    LC_TaskReaders.ActionBarClick   +=new EventHandler(LC_TaskReaders_ActionBarClick);
                    LC_TaskReaders.EnableIterators  = true;
             
                    //User Group List (Notification on process completion)
                    Lst_UserGroup                   = (CustomControls.ListControl)Panel_UserRoles.FindControl("ListControl_ProcessComplete_UserGroup");
                    Lst_UserGroup.TenantName        = ALParamObj.TenantName;                    
                    ActionBarXMLPath.Remove(0, ActionBarXMLPath.Length);
                    ActionBarXMLPath.Append(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, "", "MarketingWorkBench_Manage_UserGroup_ActionBar"));
                    Lst_UserGroup.ActionBarXML      = ActionBarXMLPath.ToString();
                    Lst_UserGroup.EnableIterators = true;

                    //Textbox
                    textBoxObj = (TextBox)Panel_TaskDetails.FindControl("tb_NoOfDays");
                    textBoxObj.Attributes.Add("onkeyup", "javascript:ValidateNumber(this);");
                    textBoxObj.Attributes.Add("onblur", "javascript:ValidateNumberNotEmpty(this);");

                    //Checkbox
                    checkBoxObj = (CheckBox)Panel_TaskDetails.FindControl("cb_AdvanceNotification");

                    //On save popup
                    Popup_OnSave.TenantName          = ALParamObj.TenantName;                
                    Popup_OnSave.CaptionText         = Localization.GetString("ALResource",ALParamObj.TenantName,"MWB_OnSavePopup");
                    Popup_OnSave.PopupDisplayMode    = ePopupDisplayMode.Simple;
                    Popup_OnSave.PopupHeight         = 108;
                    Popup_OnSave.PopupWidth          = 350;
                    Popup_OnSave.ShowCloseIcon       = true;
                    Popup_OnSave.Style.Add(HtmlTextWriterStyle.Display, "None");
                    this.Page.ClientScript.RegisterHiddenField("OnSavePopupID", "Div_" + Popup_OnSave.ClientID);

                    HIDDEN_BTN_OnSavePopup.TenantName = ALParamObj.TenantName;
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }    
            }

            private void setLeftPane()
            {
                Hashtable Pane_Sec_HT = null;
                LeftPaneFacade LeftPaneObj = null;
                ulong ErrorID = 0;
                StringBuilder ErrorPageURL_Exp = null;

                try
                {
                    LeftPaneObj = new LeftPaneFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, SolutionName);
                    Pane_Sec_HT = new Hashtable();
                    LeftPaneObj.GetTaskPaneNode(this.Page, null);
                }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateDiscussionTask.aspx", "setLeftPane", ExceptionObject, null, 
                        Localization.GetString("ALResource",ALParamObj.TenantName,"ERR_MWB_Manage_ROProjectDetails_Exceptionwhilesettingtheleftpane_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }
            
            private void setSelectedTab()
			{
				try
				{
					switch(SelectedTab.ToUpper())
					{
						case "INFO":
							GatherInfoTaskTab.SelectedTab	  = Panel_TaskDetails;
							GatherInfoTaskTab.SelectedTabName = "Info";						
							break;
							
						case "USER ROLES":
							GatherInfoTaskTab.SelectedTab		= Panel_UserRoles;
							GatherInfoTaskTab.SelectedTabName	= "User Roles";
							
							break;
						case "DEPENDENCIES":
							GatherInfoTaskTab.SelectedTab		= Panel_Dependencies;
							GatherInfoTaskTab.SelectedTabName	= "Dependencies";
							
							break;
					}
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

            private void GetTaskDetails()
            {
                String                      FormConfigXMLPath = null;
                String                      StepFormInputXML  = null;
                //MktgWorkBenchFacadeClass    MWBFacadeObj      = null;  
                MWB_Helper                  MWBHelperClassObj = null;            
                PMFacadeClass               PMFacadeObj       = null;
                XML                         ReturnTaskXML     = null;
                XML                         ItemListXML       = null;  
                XML                         FormConfigXML     = null;
                XML                         SearchXML         = null;                
                ERRORXML                    ErrorXML          = null;
                XmlDocument                 InputXMLDoc       = null;      
                XmlDocument                 FormXMLDoc        = null;
                XmlDocument                 TempDoc           = null;
                XmlNodeList                 ActivityNodeList  = null;            
                XmlNode                     FieldNode         = null;
                XmlNode                     ActivityCollNode        = null;
                XmlNode                     ActualResourceNode      = null;
                XmlNode                     ActivityResourceNode    = null;
                XmlNode                     ValueNode               = null;
                XmlNode                     ProcessActivityNode     = null;
                XmlNode                     ActivityInfoNode        = null;
                XmlNode                     xmlNode_SelectedComponents= null;
                FormFacade                  FormFacadeObj           = null;                
                String                      TempFilePath            = null;
                String                      ResourceID              = null;    
                String                      ResourceType            = null;
                String                      MailID                  = null;
                String                      CurrentDuration         = null;
                String                      ErrorPageURL            = null;
                StringBuilder               TempPath                = null;
                StringBuilder               StepFormID              = null;
                StringBuilder				GroupListXML			= null;
                Hashtable                   ResourceTable           = null;                
                GroupFacade                  GroupFacadeObj         = null;
                bool						IsPreviousWorkFlowPresent = false;                                
                long                        Days                    = 0;
                long                        RemMins                 = 0;                
				XML							UserCollectionXML		= null;
				XML							GroupXML				= null;
				XML							ResourceXML				= null;
				StringBuilder				ActResourceXML			= null;
				StringBuilder				ParamURL				= null;
				String						ActivityID				= null;
				String						SelectedValueFileName	= null;
				XPathDocument				UserDoc					= null;
				StringBuilder				SelectedValueXml		= null;
				String						GroupID					= null;	
				String						strFormName				= null;
				String						strStdFormName			= null;
				String						strSelectedFormName		= null;
				String						strActivityDefID		= null;
                String                      str_SearchXML           = null;
                String                      str_TaskXML             = null; 
                String                      str_ActivitiesXML       = null; 
                String                      str_ActivityFacets      = null; 
                XPathExpression             xp_SortExpression       = null;
                XPathNodeIterator           xp_SortNodeIter         = null;
                String                      str_SortXML             = null;
                List<String>                ActDefList              = null;
                try
                {
                    InputXMLDoc             = new XmlDocument();   
                    FormXMLDoc              = new XmlDocument();
                    TempDoc                 = new XmlDocument();
                    StepFormIDTable         = new Hashtable();
                    ResourceTable           = new Hashtable();
                    TempPath                = new StringBuilder();
                    ActResourceXML			= new StringBuilder();
                    TempFilePath            = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);                    
                    FormFacadeObj           = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    //MWBFacadeObj            = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBHelperClassObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    GroupFacadeObj          = new GroupFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj             = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.TenantName);        
                    FormFacadeObj.SolutionName  = SolutionName;
                    
					ActResourceXML.Append("<ACTIVITYCOLLECTION>");

                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- Before GetGatherInfoTask() function.");
                    ErrorXML = GetGatherInfoTask(out str_TaskXML, out ActDefList, out IsPreviousWorkFlowPresent);
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- After GetGatherInfoTask() function.");

                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- Before GetGatherInfoTaskActivities() function.");
                        ErrorXML = GetGatherInfoTaskActivities(ActDefList, out str_ActivitiesXML);
                        ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetTaskDetails):- After GetGatherInfoTaskActivities() function.");
                    }

                    if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_TaskXML)) && (!String.IsNullOrEmpty(str_ActivitiesXML))) 
                    {
                        MergeTaskActivities(str_TaskXML, str_ActivitiesXML, out ReturnTaskXML);

                        InputXMLDoc.LoadXml(ReturnTaskXML);

                        if (InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR/USER/USERID") != null)
                        {
                            ViewState["TIUserID"] = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/TASKINITIATOR/USER/USERID").InnerText;
                        }

                        setFormXML(InputXMLDoc,true);

                        if (String.IsNullOrEmpty(__PackageDefinitionID.Value))
                        {
                            PackageDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PACKAGEDEFINITIONID").InnerText;
                            __PackageDefinitionID.Value = PackageDefinitionID;
                        }
                        if (String.IsNullOrEmpty(__ProcessDefinitionID.Value))
                        {
                            ProcessDefinitionID = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID").InnerText;
                            __ProcessDefinitionID.Value = ProcessDefinitionID;
                        }

                        // sort all the activities by sequence number.
                        ProcessActivityNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");
                        xp_SortExpression   = XPathExpression.Compile("ACTIVITY");
                        xp_SortExpression.AddSort("SEQUENCENUMBER", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                        xp_SortNodeIter     = ProcessActivityNode.CreateNavigator().Select(xp_SortExpression);
                        while (xp_SortNodeIter.MoveNext())
                        {
                            str_SortXML     += xp_SortNodeIter.Current.OuterXml;
                        }
                        ProcessActivityNode.InnerXml   = str_SortXML;
                        
                        TempPath.AppendFormat("{0}{1}", TempFilePath, TaskFile);
                        InputXMLDoc.Save(TempPath.ToString());

                        setTemplateDocument();
                        if (IsPostBack)
                            BinderControl.Reset = true;
                        setAttachments(InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM"), InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ASSETREFERENCES"));

                        if (IsPostBack)
                            BinderControl.Reset = false;
                        xmlNode_SelectedComponents = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/SELECTEDCOMPONENTS");
                        if ((xmlNode_SelectedComponents != null) && (xmlNode_SelectedComponents.HasChildNodes))
                        {
                            //Save this return XML on NTFS in temp location                            
                            TempPath.Remove(0, TempPath.Length);
                            TempPath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_SelectedComponentsIDFileName);
                            File.WriteAllText(TempPath.ToString(), xmlNode_SelectedComponents.InnerXml);
                        }

                        // Select all the manual activities.
                        ActivityNodeList		= ProcessActivityNode.SelectNodes("ACTIVITY[TASKTYPE='TaskManual']");
                        ActivityIDOrderedList	= new List<string>();
						strStdFormName			= "StepDetails_Editable";
                        foreach (XmlNode ActivityNode in ActivityNodeList)
                        {
                            ActualResourceNode		= null;
                            ActivityResourceNode	= null;
                            MailID					= null;
                            Form StepForm			= new Form();
                            StepFormID				= null;
                            StepFormID				= new StringBuilder();
							GroupListXML			= new StringBuilder();
							SelectedValueXml		= new StringBuilder();
							ActivityID				= ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
							strActivityDefID		= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
							strFormName				= strActivityDefID + "_Editable";
							TempPath.Remove(0, TempPath.Length);
                            StepFormID.AppendFormat("STEP_{0}", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                            StepForm.ID = StepFormID.ToString();
                            ActivityIDOrderedList.Add(ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
                            if (StepFormIDTable.ContainsKey(ActivityNode.SelectSingleNode("ACTIVITYID").InnerText) == false)
                                StepFormIDTable.Add(ActivityNode.SelectSingleNode("ACTIVITYID").InnerText, StepFormID.ToString());

                            StepForm.TenantName				= ALParamObj.TenantName;
                            StepForm.SolutionName           = SolutionName; 
							StepForm.IsDynamicForm			= true;
                            StepForm.EnableSetFocus			= false;
                            StepForm.InputXMLType			= Assetlink.CustomControls.Form.InputType.InnerXML;
                            StepForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;
                            
                            StepForm.ShowConfiguredFields   = true; 

							FormConfigXMLPath	= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
							FormConfigXML		= MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, IsPreviousWorkFlowPresent);

                            InputXMLDoc					= null;
                            InputXMLDoc					= new XmlDocument();
                            ActivityCollNode			= InputXMLDoc.CreateElement("ACTIVITYCOLLECTION");
                            InputXMLDoc.AppendChild(ActivityCollNode);
                            ActivityCollNode.InnerXml	= ActivityNode.OuterXml;
							FormFacadeObj.FormName		= strSelectedFormName;
							FormFacadeObj.UniqueID		= StepFormID.ToString();

                            FormFacadeObj.ShowConfiguredFields = true;
                            FormFacadeObj.ConfigurationXMLType = "InnerXML";
                            FormFacadeObj.ConfigurationXML = FormConfigXML;

                            xmlNode_SelectedComponents = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/SELECTEDCOMPONENTS");
                            if ((xmlNode_SelectedComponents != null) && (xmlNode_SelectedComponents.HasChildNodes))
                            {
                                //Save this return XML on NTFS in temp location                            
                                TempPath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ActivityID + str_SelectedComponentsIDFileName);
                                File.WriteAllText(TempPath.ToString(), xmlNode_SelectedComponents.InnerXml);
                                TempPath.Remove(0, TempPath.Length);
                            }
                            FormFacadeObj.GetHierarchicalSearchXML("Edit", out str_SearchXML);
                            //HemantK: check for the deliverable component facet series
                            ErrorXML = SetDeliverableComponentFacetSeries(ref InputXMLDoc, ref FormConfigXML, ActivityNode.CreateNavigator(), str_SearchXML);
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                StepForm.ConfigurationXML   = FormConfigXML;
                                CheckComponentFacetSeriesStatus(StepForm);

							    ResourceXML = MWBHelperClassObj.GetActivityResourceXML(ActivityNode);
							    if(!String.IsNullOrEmpty(ResourceXML))
							    {
								    ActResourceXML.Append(ResourceXML);
							    }
							    ParamURL = new StringBuilder(150);
							    SelectedValueFileName = StepFormID.ToString() + "_ContributorGroup_SelectedValueList.xml";
							    ParamURL.Append("SelectResourceType.aspx?");
							    //ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceType.UniqueID, SelectedValueFileName, ResourceTreeFile);
                                ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&TaskID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, TaskID, Hidden_SelectResourceType.UniqueID);

                                ErrorXML = FormFacadeObj.GetFormInputXML("Edit", InputXMLDoc.OuterXml, out StepFormInputXML, out StepObjInfoList);
                                if (ErrorXML == null)
                                {
                                    ViewState["StepObjectList" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText] = StepObjInfoList;
                                    ItemListXML = MWBHelperClassObj.PrepareFormInputXML(ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").OuterXml, "RESOURCETYPE", "RESOURCEID");

                                    // check if this activity has any actual resources associated with it
                                    ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                                    if (ActivityResourceNode != null)
                                        ActualResourceNode = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");
                                   
                                    FormXMLDoc.LoadXml(StepFormInputXML);
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                    if (FieldNode != null)
                                    {
									    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
									    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
                                    }

                                    if (ActualResourceNode != null)
                                    {
									    ResourceType	= ActualResourceNode.SelectSingleNode("RESOURCETYPE").InnerText;
									    GroupListFile	= StepFormID.ToString() + "_GroupUsers.xml";										
									    SearchXML		= GetSearchXMLForGroupAndUsers(ResourceType);
									    ErrorXML		= GroupFacadeObj.GetGroupList(SearchXML, ref GroupXML);
									    TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);
									    if(ErrorXML == null)
									    {
										    if(GroupXML != null)
										    {											
											    MWBHelperClassObj.GetGroupIDAndUserXML(GroupXML, out UserCollectionXML, out GroupID);
    											
											    File.WriteAllText(TempPath.ToString(), UserCollectionXML);
											    TempPath.Remove(0, TempPath.Length);
											    TempPath.AppendFormat("{0}{1}", TempFilePath, SelectedValueFileName);
											    SelectedValueXml.AppendFormat("<ValueList><Value ID='{0}' Text='{1}'/></ValueList>", GroupID, ALSolutionCommon.TrimAndReplaceSpecialChars(ResourceType));
											    File.WriteAllText(TempPath.ToString(), SelectedValueXml.ToString());											
    											
											    UserDoc = new XPathDocument(new StringReader(UserCollectionXML));
											    ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
											    if(ItemListXML != null)
											    {
												    if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
												    {
													    ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
													    ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
													    MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
												    }
											    }
										    }
										    else
										    {
                                                ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
										    }
									    }
                                    }
                                    else
                                    {
                                        ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                                    }
                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                    if (FieldNode != null)
                                    {
                                        FieldNode.InnerXml = ItemListXML;
                                    }
                                    if (MailID != null)
                                    {
                                        FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                                        if (FieldNode != null)
                                        {
                                            ValueNode = FormXMLDoc.CreateElement("Value");
                                            ValueNode.InnerText = MailID;
                                            FieldNode.AppendChild(ValueNode);
                                        }
                                    }

                                    //Put the duration
                                    ActivityInfoNode = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION");
                                    if (ActivityInfoNode != null)
                                    {
                                        CurrentDuration = ActivityInfoNode.SelectSingleNode("DURATION").InnerText;
                                        if (!String.IsNullOrEmpty(CurrentDuration))
                                            Days = PMFacadeObj.ConvertMinutesToDays(Convert.ToInt64(CurrentDuration), out RemMins);
                                        else
                                            Days = 2;
                                    }
                                    else
                                        Days = 2;

                                    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
                                    if (FieldNode != null)
                                    {
                                        ValueNode = FieldNode.SelectSingleNode("Value");
                                        if (ValueNode != null)
                                            ValueNode.InnerText = Days.ToString();
                                        else
                                        {
                                            ValueNode = FormXMLDoc.CreateElement("Value");
                                            ValueNode.InnerText = Days.ToString();
                                            FieldNode.AppendChild(ValueNode);
                                        }
                                    }
                                    updateFormFields("EmailID", ActivityNode, ref FormXMLDoc);
                                    updateFormFields("PostedBy", ActivityNode, ref FormXMLDoc);

                                    TempPath.Remove(0, TempPath.Length);
                                    TempPath.AppendFormat("{0}{1}.xml", TempFilePath, StepFormID.ToString());
                                    File.WriteAllText(TempPath.ToString(), FormXMLDoc.OuterXml);
                                }
                                if (Panel_ManualActivities.FindControl(StepForm.ID) != null)
                                {
                                    Panel_ManualActivities.Controls.Remove(Panel_ManualActivities.FindControl(StepForm.ID));
                                }

                                if (IsPostBack)
                                {
                                    StepForm.ResetBinders = true;
                                    StepForm.ResetFileUploadControls = true;
                                }

                                StepForm.InputXML = FormXMLDoc.OuterXml;
                                Panel_ManualActivities.Controls.Add(StepForm);

                                StepForm.ConfigurationMode = true;
                                StepForm.AddCustomValidator("Duration", "onblur", "javascript:ValidateDuration('$CONTROLID$')", false);
                                if (IsPostBack)
                                {
                                    StepForm.ResetFacetSeriesFields();
                                }
                            }
                        } // end for loop for manual activities.                        
                        ViewState["StepFormIDList"] = StepFormIDTable;
                        ViewState["ActivityIDList"] = ActivityIDOrderedList;
						ActResourceXML.Append("</ACTIVITYCOLLECTION>");
						TempPath.Remove(0, TempPath.Length);
						TempPath.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
						File.WriteAllText(TempPath.ToString(),ActResourceXML.ToString());

                        //Assign values for prior notification
                        SetAdvanceReminderValues(ReturnTaskXML);
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                        if (!IsPostBack)
                        {
                            Response.Redirect(ErrorPageURL, true);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            private void setFormXML(XmlDocument TaskXMLDoc, Boolean b_GetComponentFacetForTask)
            {
                FormFacade  FormFacadeObj        = null;
                MWB_Helper  MWBHelperClassObj    = null;
                XmlDocument FormInputDoc         = null;
                XmlNode     FieldNode            = null;
                String      ProcessColl          = null;
                XML         ErrorXML             = null;
                XML         FormInputXML         = null;
                XmlNode     WorkflowProcessNode  = null;
                String      TaskName             = null;
                String      TaskStatus           = null;
                String      FormConfigXMLPath    = null;                
                XmlNode     Task_StartDate       = null;
                DateTime    StartDate;
                String      str_StdFormName      = null;
                String      str_DynamicFormName  = null;
                String      str_SelectedFormName = null;
                String      FormConfigXML        = null;
                MWB_Component   obj_MWB_Component= null;
                String      SearchXML            = null;
                String      str_ShowBaseline     = "NO";
                try
                {
                    obj_MWB_Component   = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWBHelperClassObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);                    
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    str_StdFormName     = "Task_Details";
                    
                    FormFacadeObj.SolutionName  = SolutionName;

                    WorkflowProcessNode         = TaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS");
                    TaskName                    = WorkflowProcessNode.SelectSingleNode("PROCESSNAME").InnerText;
                    ViewState["TaskTitle"]      = TaskName;
                    str_ShowBaseline            = ViewState["ShowBaseline"].ToString();    
                    TaskStatus = WorkflowProcessNode.SelectSingleNode("STATUS").InnerText;
                    ViewState["TaskStatus"] = TaskStatus;

                    Task_StartDate = WorkflowProcessNode.SelectSingleNode("STARTDATE");

                    if ((Task_StartDate != null) && (Task_StartDate.HasChildNodes))
                    {
                        StartDate = new DateTime(Convert.ToInt32(Task_StartDate.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(Task_StartDate.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(Task_StartDate.SelectSingleNode("DAY").InnerText));
                        ViewState["StartDate"] = StartDate;
                    }

                    str_DynamicFormName = __ProcessDefinitionID.Value + "_" + str_StdFormName;
                    FormConfigXMLPath = MWBHelperClassObj.GetFormConfigXMLPath(str_StdFormName,str_DynamicFormName, out str_SelectedFormName);
                    if (FormConfigXMLPath != null)
                    {
                        Frm_GatherInfo.ConfigurationXMLType = Assetlink.CustomControls.Form.InputType.InnerXML;
                        FormInputDoc = new XmlDocument();
                        FormInputDoc.Load(FormConfigXMLPath);
                        FieldNode = FormInputDoc.SelectSingleNode("Form/Section/Column/Field[@Name='WORKFLOWPROCESS_STARTDATE']");

                        if (FieldNode.Attributes.GetNamedItem("Disable") != null)
                            ((XmlElement)FieldNode).SetAttribute("Disable", "NO");

                        FormConfigXML = FormInputDoc.InnerXml;
                        FormFacadeObj.FormName              = str_SelectedFormName;
                        FormFacadeObj.ShowConfiguredFields  = true;
                        ViewState["SelectedFormName"]       = str_SelectedFormName;
                        //HemantK:For Component Facet Series
                        if (b_GetComponentFacetForTask)
                        {
                            FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                            ErrorXML = GetComponentFacetForTask(ref TaskXMLDoc, ref FormConfigXML, SearchXML);
                        }
                        else
                        {
                            if ((ViewState["ComponentFacetSeriesRShipName"] != null) && (ViewState["ComponentUserStatus"] != null) && (String.Compare(ViewState["ComponentUserStatus"].ToString(), "Active", true) != 0))
                            {
                                obj_MWB_Component.SetSeriesActionBarForTask(ViewState["ComponentFacetSeriesRShipName"].ToString(), ViewState["ComponentUserStatus"].ToString(), ref FormConfigXML);
                            }
                        }

                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            CheckComponentFacetSeriesStatus(Frm_GatherInfo);

                            ProcessColl = "<WORKFLOWPROCESSCOLLECTION>" + TaskXMLDoc.OuterXml + "</WORKFLOWPROCESSCOLLECTION>";
                            ErrorXML = FormFacadeObj.GetFormInputXML("Edit", ProcessColl, out FormInputXML, out ObjInfoList);
                            ViewState["ObjectList"] = ObjInfoList;

                            Frm_GatherInfo.ConfigurationXML = FormConfigXML;                            
                            FormInputDoc.LoadXml(FormInputXML);

                            FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALSTARTDATE']");
                            if (FieldNode != null)
                                ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                            FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALENDDATE']");
                            if (FieldNode != null)
                                ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                            if (str_ShowBaseline == "NO")
                            {
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASESTARTDATE']");
                                if (FieldNode != null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");

                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_BASEENDDATE']");
                                if (FieldNode != null)
                                    ((XmlElement)FieldNode).SetAttribute("FieldVisible", "false");
                            }

                            if (IsPostBack)
                            {
                                Frm_GatherInfo.ResetBinders = true;
                                Frm_GatherInfo.ResetFileUploadControls = true;  
                            }

                            Frm_GatherInfo.InputXML = FormInputDoc.OuterXml;
                            if (IsPostBack)
                            {
                                Frm_GatherInfo.ResetFacetSeriesFields();
                            }
                        }
                    }
                }
                catch(ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }
            
            private void GetUserRoles()
		    {
			    StringBuilder			 AssociationXML			 = null;
                StringBuilder			 AttributesXML			 = null;
                String                   TempFilePath            = null;
                MktgWorkBenchFacadeClass MWBFacadeObj            = null;  
                ERRORXML				 ErrorXML				 = null;
                XML						 ReturnTaskXML			 = null;
                XmlDocument				 TaskDoc				 = null;
                String					 ErrorPageURL			 = null;
                XmlNode                  xmlnode_User            = null;
                XmlNode                  xmlnode_Group           = null;
                XML                      xml_Users               = null;
                XML                      xml_Groups              = null;
                XPathNavigator           nav_TaskReaderGroups    = null;
                XPathNavigator           nav_TaskReaderUsers     = null; 

			    try
			    {
				    AssociationXML = new StringBuilder();
				    AttributesXML  = new StringBuilder();
                    TempFilePath   = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);

                    AssociationXML.AppendFormat(@"<ASSOCIATION GetAllFacets='FALSE'>						
	                                                    <READERS Type='RELATION'>
		                                                    <LOGINNAME/>
		                                                    <FIRSTNAME/>
		                                                    <MIDDLEINITIAL/>
		                                                    <LASTNAME/>
		                                                    <EMAILID/>
                                                            <FILTERLIST>
	                                                            <FILTER>
		                                                            <EXPRESSION>STATUS</EXPRESSION>
		                                                            <OPERATOR>EQUALTO</OPERATOR>
		                                                            <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
		                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                            </FILTER>
                                                            </FILTERLIST>
	                                                    </READERS>
                                                        <PROCESSREADER_GROUPS Type='RELATION'>
                                                            <GROUPID />
                                                            <GROUPNAME />
                                                            <FILTERLIST>
                                                                <FILTER>
                                                                    <EXPRESSION>ISDELETED</EXPRESSION>
                                                                    <OPERATOR>EQUALTO</OPERATOR>
                                                                    <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                </FILTER>
                                                            </FILTERLIST>
                                                        </PROCESSREADER_GROUPS>
                                                        <PROCESSCOMPLETION_GROUP Type='RELATION'>
                                                        <GROUPNAME/>
                                                        <ISDELETED/>
                                                        <FILTERLIST>
	                                                        <FILTER>
		                                                        <EXPRESSION>ISDELETED</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                        </FILTER>
                                                        </FILTERLIST>
                                                        </PROCESSCOMPLETION_GROUP>
                                                        <PROCESSCOMPLETION_USER Type='RELATION'>
                                                            <STATUS/>
                                                            <LOGINNAME/>
                                                            <FIRSTNAME/>
                                                            <MIDDLEINITIAL/>
                                                            <LASTNAME/>
                                                            <EMAILID/>
                                                            <FILTERLIST>
	                                                            <FILTER>
		                                                            <EXPRESSION>STATUS</EXPRESSION>
		                                                            <OPERATOR>EQUALTO</OPERATOR>
		                                                            <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>
		                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>		                                                        
	                                                            </FILTER>
                                                            </FILTERLIST>
                                                        </PROCESSCOMPLETION_USER>
                                                    </ASSOCIATION>");

				    AttributesXML.Append(@"<WORKFLOWPROCESS>
											    <WORKFLOWPROCESSID/>
									       </WORKFLOWPROCESS>");	
                    MWBFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
				    ErrorXML = MWBFacadeObj.GetTask(TaskID, AttributesXML.ToString(), AssociationXML.ToString(), out ReturnTaskXML);
                    if (ErrorXML == null)
                    {
					    TaskDoc = new XmlDocument();
					    TaskDoc.LoadXml(ReturnTaskXML);

                        //paint readers
                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS") != null)
                            nav_TaskReaderGroups = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSREADER_GROUPS").CreateNavigator();

                        if (TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS") != null)
                            nav_TaskReaderUsers = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/READERS").CreateNavigator();

                        setTaskReadersUserGroupList(nav_TaskReaderGroups, nav_TaskReaderUsers);

                        //paint process completion users
                        xmlnode_User = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_USER");
                        if (xmlnode_User != null)
                            xml_Users = xmlnode_User.InnerXml;

                        xmlnode_Group = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESSCOMPLETION_GROUP");
                        if (xmlnode_Group != null)
                            xml_Groups = xmlnode_Group.InnerXml;

                        populateUserGroupList(xml_Users, xml_Groups, "CREATE");
                        setAssociatedProcessCompletionUserGroups(xmlnode_User, xmlnode_Group);
                    }
				    else
				    {
					    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
					    if(!IsPostBack)
					    {
						    Response.Redirect(ErrorPageURL, true);
					    }
					    else
						    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
				    }
			    }
			    catch(Exception ExcepObj)
			    {
				    throw ExcepObj;
			    }
		    }

            private void PaintPredecessorList(XML TaskXML)
            {
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;
                ListFacade                  ListFacadeObj           = null;
                XmlDocument                 AssociationXMLDoc       = null;
                XmlDocument                 InputXMLDoc             = null; 
                XmlNode                     Process_ActivityNode    = null;
                XmlNode                     WFProcessNode           = null; 
                XmlNode                     SearchXMLNode           = null;                 
                XML                         PredecessorListXML      = null; 
                XML                         ConfigXML               = null; 
                String                      ParentActivityID        = null;                 
                StringBuilder               ParamURL                = null;
                StringBuilder               URL                     = null; 
     
                try
                {
                    AssociationXMLDoc       = new XmlDocument();
                    InputXMLDoc             = new XmlDocument();
                    ParamURL                = new StringBuilder();
                    URL                     = new StringBuilder();
                    MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ListFacadeObj           = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        
                    
                    AssociationXMLDoc = null;
                    AssociationXMLDoc = new XmlDocument();
                    AssociationXMLDoc.LoadXml(TaskXML);

                    WFProcessNode = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS");
					
                    if ((WFProcessNode != null) && (WFProcessNode.HasChildNodes))
                    {
                        //Get RDF relationship name
                        ParentActivityID = AssociationXMLDoc.SelectSingleNode("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY/ACTIVITYID").InnerText;   
                        //Now get the Predecessors for the current deliverable
                        Process_ActivityNode = null;
                        GetPredecessors(WFProcessNode, ParentActivityID, ref Process_ActivityNode);
						    if ((Process_ActivityNode != null) && (Process_ActivityNode.HasChildNodes))
                            {
                                //Prepare Predecessor List.
                                SearchXMLNode = InputXMLDoc.CreateElement("SEARCHOUTPUTXML");
                                InputXMLDoc.AppendChild(SearchXMLNode);
                                SearchXMLNode.AppendChild(InputXMLDoc.ImportNode(Process_ActivityNode, true));
                                //Get the Configuration XML from ListConfigurationXML
                                ListFacadeObj.AddParameter("ProjectID", ProjectID);
                                PackageDefinitionID = __PackageDefinitionID.Value;
                                ProcessDefinitionID = __ProcessDefinitionID.Value;
                                ListFacadeObj.AddParameter("PackageDefinitionID", PackageDefinitionID);
                                ListFacadeObj.AddParameter("ProcessDefinitionID", ProcessDefinitionID);
                                ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "PredecessorListForTask");
                                if (ConfigXML != null)
                                {
                                    ListFacadeObj.PrepareListXml(ConfigXML, InputXMLDoc.OuterXml, out PredecessorListXML);
                                    if (PredecessorListXML != null)
                                    {                                   
										MktgWorkBenchFacadeObj.InsertPercentCompleteClass("DUEDATE", ref PredecessorListXML);
										Lst_PredecessorList.Source = PredecessorListXML;
                                    }
                                    else
                                    {
                                        //There are no Predecessors paint empty list
                                        ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForTask", ref PredecessorListXML);
                                        Lst_PredecessorList.Source = PredecessorListXML;
                                    }
                                }
                            }
                            else
                            {
                                //There are no Predecessors paint empty list
                                ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForTask", ref PredecessorListXML);
                                Lst_PredecessorList.Source = PredecessorListXML;
                            }
                        //}
                    }
                    else
                    {
                        ListFacadeObj.ReturnHeaderForEmptyList(SolutionName, null, "PredecessorListForTask", ref PredecessorListXML);
                        Lst_PredecessorList.Source = PredecessorListXML;
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            private void GetPredecessors(XmlNode WFProcessNode, String ActIDForTask, ref XmlNode Predecessor_ActivityNode)
            {
                XmlDocument             ReturnXMLDoc            = null;
                XmlNode                 Process_ActivityNode    = null;
                XmlNode                 Process_TransitionNode  = null;
                XmlNode                 ActivityNode            = null; 
                XmlNode                 OperationNode           = null; 
                XmlNodeList             TransitionNodes         = null; 
                String                  PrdecessorID            = null; 
     
                try
                {
                    ReturnXMLDoc = new XmlDocument();
                    Predecessor_ActivityNode = ReturnXMLDoc.CreateElement("PROCESS_ACTIVITY");

                    //Select Process Activities and Process Transition nodes
                    Process_ActivityNode    = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY");
                    Process_TransitionNode  = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");

                    //Select Predecessors
                    TransitionNodes = Process_TransitionNode.SelectNodes("TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID='" + ActIDForTask + "']");
                    foreach (XmlNode Transition in TransitionNodes)
                    {
                        OperationNode = Transition.Attributes.GetNamedItem("Operation");
                        if ((OperationNode != null) && (OperationNode.InnerText.ToUpper() != "DELETED"))
                        {
                            PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                            ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
                            if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE")
                            {
                                Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
                            }

                        }
                        else if (OperationNode == null)
                        {
                            PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                            ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
                            if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE")
                            {
                                Predecessor_ActivityNode.AppendChild(ReturnXMLDoc.ImportNode(ActivityNode, true));
                            }
                        }
                    }                    
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            private void select_Predecessors()
            {
                try
                {                    
                    Ajax.WriteExecuteJavaScript(Popup_SelectPredecessorsTask_GatherInfo.ShowPopupWindowJavascript);
                }
                catch (Exception ExceptionObj)
                {
                    
                    throw ExceptionObj;
                }
            }

            private ERRORXML ShowUpdatedDates()
            {
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;  
                ERRORXML                    ErrorXMLString          = null; 
                XML                         ReturnTaskXML           = null;
                XmlDocument                 InputXMLDoc             = null; 
                String                      AssociationXML          = null;
                String                      str_ProcessAssoFacets   = null; 

                try
                {
                    MktgWorkBenchFacadeObj  = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                    if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                    {
                        AssociationXML = "<ASSOCIATION>" + str_ProcessAssoFacets + "</ASSOCIATION>";
                    }
                    else
                    {
                        AssociationXML = "<ASSOCIATION GetAllFacets='TRUE'></ASSOCIATION>";
                    }

                    ErrorXMLString = MktgWorkBenchFacadeObj.GetTask(TaskID, null, AssociationXML, out ReturnTaskXML);
                    if (ErrorXMLString == null)
                    {
                        InputXMLDoc = new XmlDocument();
                        InputXMLDoc.LoadXml(ReturnTaskXML);
                        setFormXML(InputXMLDoc,true);
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            private ERRORXML SaveTask(String Status,out bool alertGiven)
            {
                XML                         StepXML                 = null;
                XML                         FormOutputXML           = null;
                XML                         SaveTaskXML             = null;
                XML                         ActivityResourceXML     = null;            
                XML                         TempXML                 = null;
                ERRORXML                    ErrorXML                = null;
                FormFacade                  FormFacadeObj           = null;
                XmlDocument                 FormDataDocument        = null;
                XmlDocument                 TaskDoc                 = null;            
                XmlDocument                 TempDoc                 = null;            
                XmlNode                     WorkflowProcessNode     = null; 
                XmlNode                     ActivityNode            = null;    
                XmlNode                     ResourceNode            = null;
                XmlNode                     ProcessActivityNode     = null;            
                XmlNode                     StatusNode              = null;
                XmlNode                     TaskInitiator           = null;                
                XmlNode                     ActivityResourceNode    = null;
                XmlNode                     DisAssociateResourceNode= null;
                XmlNode                     OldUserNode             = null;
                XmlNode                     ActivityContributorNode = null;
                XmlNode                     ActivityInfoNode        = null; 
                XmlNode                     UpdateActivityNode      = null; 
                StringBuilder               WorkFlowCategory        = null;
                StringBuilder               DisAssociateXML         = null;
                StringBuilder               UpdateActivityXML       = null; 
                String                      TempPath                = null;                
                StringBuilder               TempFilePath            = null;
                StringBuilder               ProjectXML              = null;                
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeObj  = null;
                MWB_Helper                  MWB_HelperObj           = null;
                PMFacadeClass               PMFacadeObj             = null; 
                String                      SelectedGroup           = null;
                String                      SelectedContributor     = null;
                String                      ActualResourceID        = null;
                String                      ActivityResourceID      = null;
                String                      OldUserID               = null;
                String                      StepDuration            = null; 
                List<String>				CancelledActivities		= null;
                long                        StepDurantionInMin      = 0;
                String                      StepCurrentDuration     = null; 
                Boolean                     ActivityModified        = true;
                Boolean                     DisAssociateUserOnly    = false;
                Boolean                     ContributorsSelected    = false;
                Boolean                     IsSubmitValid           = true;
                Boolean                     CalculateTimeLine       = false; 
                Boolean                     StepDurationChanged     = false; 
                Boolean						DisAssociateUserAndGroup= false;
				Boolean						CreateNewActualRes		= false;
				Boolean						AddNewUser				= false;
                Boolean                     DisAssociateGroup       = false;
				StringBuilder               Activity_InfoID_Table   = null; 
                String                      TempString              = null;
                String                      ConfirmationAlert       = null; 
                DateTime                    CurrentStartDate, NewStartDate;
                DateTime                    AllowedStartDate;
                StringBuilder               Alert_Message           = null;
                XmlNode                     DateNode                = null;
                XmlNode                     StartDateNode           = null;
                XmlNode                     StartDateLockedNode     = null;
                XmlNode                     WFProcessInfoNode       = null;
                XmlNode						Act_ResNode				= null;
                XmlNode						ResNode					= null;
                XmlDocument					ActDoc					= null;
				String						SelectedGroupName		= null;
				XPathDocument				ActResDoc				= null;
				StringBuilder				ActResFile				= null;
				String						strFormName				= null;
				String						strStdFormName			= null;
				String						SelectedFormName		= null;
				String						strActivityDefID		= null;
                //HemantK:For Component Facet Series
                String                      str_FormActionBarXML    = null; 
                StringBuilder               sb_FormActionBarXML     = null;
                XmlNode                     Activity_ResponseNode   = null;
                Hashtable                   obj_SelectComponentIDs  = null;
                XPathDocument               xpathDoc_FormConfig     = null;
                XPathNavigator              xpathNav_ComponentFacet = null;
                String                      str_ComponentFacetName  = null;
                String                      str_ComponentFacetPK    = null;
                String                      str_FormConfigXML       = null;
                String                      str_PlaceHoldersKeys    = null;
                String                      str_PlaceHoldersValues  = null;
                String                      FormConfigXMLPath       = null;
                Boolean                     IsPreviousWorkFlowPresent = false;
                long                        i_Duration               = 0;
                Boolean                     b_AppendProcessActivityNoe = false;
                String                      str_CultureInformation  = null;
                String                      str_FormatDetails       = null;
                CultureInfo                 obj_CultureInfo         = null;

                try
                {
                    FormDataDocument            = new XmlDocument();
                    TaskDoc                     = new XmlDocument();                
                    TempDoc                     = new XmlDocument();
                    WorkFlowCategory            = new StringBuilder();
                    TempFilePath                = new StringBuilder();
                    DisAssociateXML             = new StringBuilder();
                    ProjectXML                  = new StringBuilder();
					CancelledActivities			= new List<String>();
                    Activity_InfoID_Table       = new StringBuilder();
                    sb_FormActionBarXML         = new StringBuilder(500);
					alertGiven					= false;
                    TempPath                    = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    TempFilePath.AppendFormat("{0}{1}",TempPath,TaskFile);
                    FormFacadeObj               = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);                
                    MktgWorkBenchFacadeObj      = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj               = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj                 = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    FormFacadeObj.FormName      = ViewState["SelectedFormName"].ToString();
                    FormFacadeObj.SolutionName  = SolutionName;
                    obj_SelectComponentIDs      = new Hashtable();
                    //FormFacadeObj.ReturnOnlyRelatedInfo = true;


                    str_FormatDetails = ALCommon.GetFormatDetails(ALParamObj.TenantName, out str_CultureInformation);
                    obj_CultureInfo = new CultureInfo(str_CultureInformation);


                    if (ViewState["PrevWorkflow"].ToString().ToUpper() == "TRUE")
                        IsPreviousWorkFlowPresent = true;

                    ObjInfoList = (List<ObjectInfo>)ViewState["ObjectList"];
                    
                    sb_FormActionBarXML.Append("<ACTIONBARCOLLECTION>");

                    ErrorXML = FormFacadeObj.GetFormDataXML(FormMode.ToUpper(), "DATAFIELD", Frm_GatherInfo, ObjInfoList, out FormOutputXML);
                    if (ErrorXML == null)
                    {
                        if ((!String.IsNullOrEmpty(Frm_GatherInfo.ConfigurationXML)) && (ViewState["ComponentFacetSeriesRShipName"] != null ))
                        {
                            xpathDoc_FormConfig = new XPathDocument(new StringReader(Frm_GatherInfo.ConfigurationXML));
                            if (xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                            {
                                obj_SelectComponentIDs.Add(TaskID, true);
                            }
                            else
                            {
                                obj_SelectComponentIDs.Add(TaskID, false);
                            }

                            xpathNav_ComponentFacet = xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "' and @IsSeries='YES']");
                            if (xpathNav_ComponentFacet != null)
                            {
                                str_ComponentFacetName  = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                                str_ComponentFacetPK    = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                            }
                        }
                        FormDataDocument.LoadXml(FormOutputXML);
                        WorkflowProcessNode = FormDataDocument.SelectSingleNode("WORKFLOWPROCESS");
                        StatusNode          = WorkflowProcessNode.SelectSingleNode("STATUS");
                        StatusNode.InnerText = Status;

                        if (Status.ToUpper() == "ACTIVE")
                        {
                            if (ViewState["TIUserID"] == null)
                            {
                                WorkflowProcessNode.InnerXml += "<TASKINITIATOR TYPE='RELATION'>" + ALParamObj.UserID + "</TASKINITIATOR>";
                                //TaskInitiator = FormDataDocument.CreateElement("TASKINITIATOR");
                                //TaskInitiator.InnerText = ALParamObj.UserID;
                                //((XmlElement)TaskInitiator).SetAttribute("TYPE", "RELATION");
                                //WorkflowProcessNode.AppendChild(TaskInitiator);
                            }
                            else if (ViewState["TIUserID"].ToString() != ALParamObj.UserID)
                            {
                                WorkflowProcessNode.InnerXml += "<TASKINITIATOR TYPE='RELATION' DISASSOCIATE='TRUE'>" + ViewState["TIUserID"].ToString() + "</TASKINITIATOR><TASKINITIATOR TYPE='RELATION'>" + ALParamObj.UserID + "</TASKINITIATOR>";
                            }
                        }
                        
                        ProcessActivityNode = WorkflowProcessNode.SelectSingleNode("PROCESS_ACTIVITY");
                        if (ProcessActivityNode == null)
                        {
                            ProcessActivityNode = FormDataDocument.CreateElement("PROCESS_ACTIVITY");
							((XmlElement)ProcessActivityNode).SetAttribute("TYPE", "RELATION");
                            //WorkflowProcessNode.AppendChild(ProcessActivityNode);
                            b_AppendProcessActivityNoe = true;
                        }
                        TempXML = BinderControl.OutputXML;
                        if (TempXML != null)
                        {
                            WorkflowProcessNode.InnerXml += TempXML;
                        }

                        //HemantK:Get the Form ActionBar
                        str_FormActionBarXML = GetFormActionBarXML(Frm_GatherInfo);
                        if (!String.IsNullOrEmpty(str_FormActionBarXML))
                        {
                            sb_FormActionBarXML.Append(@"<ACTIONBAR> 
                                                        <ACTIONBARFOR>WORKFLOWPROCESS</ACTIONBARFOR>
                                                        <ID>" + WorkflowProcessNode.SelectSingleNode("WORKFLOWPROCESSID").InnerText + "</ID>"
                                                            + str_FormActionBarXML + "</ACTIONBAR>");
                        }

                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        TaskDoc.Load(TempFilePath.ToString());
                        IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                        ActResFile	= new StringBuilder();
						ActResFile.AppendFormat("{0}{1}", TempPath, StepResourceFileName);
						if(File.Exists(ActResFile.ToString()))
						{
							ActResDoc = new XPathDocument(ActResFile.ToString());
						}
                        if (FormMode.ToUpper() == "EDIT")
                        {
							strStdFormName = "StepDetails_Editable";
							ContributorsSelected = false;
						    while (StepFormIDEnum.MoveNext())
                            {
                                ActivityModified			= true;
                                DisAssociateUserOnly		= false;
                                StepDurationChanged			= false;                                
							    DisAssociateUserAndGroup	= false;							    
							    CreateNewActualRes			= false;
							    AddNewUser					= false;
                                DisAssociateGroup           = false;
                                OldUserNode					= null;
                                OldUserID					= null;
                                Form StepForm = (Form)Panel_ManualActivities.FindControl(StepFormIDEnum.Value.ToString());
                                if ((!String.IsNullOrEmpty(StepForm.ConfigurationXML)) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                                {
                                    xpathDoc_FormConfig = new XPathDocument(new StringReader(StepForm.ConfigurationXML));
                                    if (xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                                    {
                                        obj_SelectComponentIDs.Add(StepFormIDEnum.Key.ToString(), true);
                                    }
                                    else
                                    {
                                        obj_SelectComponentIDs.Add(StepFormIDEnum.Key.ToString(), false);
                                    }

                                    if ((String.IsNullOrEmpty(str_ComponentFacetName)) || (String.IsNullOrEmpty(str_ComponentFacetPK)))
                                    {
                                        xpathNav_ComponentFacet = xpathDoc_FormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + ViewState["ComponentFacetSeriesRShipName"].ToString() + "' and @IsSeries='YES']");
                                        if (xpathNav_ComponentFacet != null)
                                        {
                                            str_ComponentFacetName = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                                            str_ComponentFacetPK = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                                        }
                                    }
                                }
                                //Here SelectedGroup and SelctedContributor is the ID
                                //So it is not TrimAndReplaced.
                                //SelectedGroup       = StepForm.GetValues("ContributorGroup");
								SelectedGroup = MWB_HelperObj.GetSelectedActivityResourceID(ActResDoc, StepFormIDEnum.Key.ToString(), out SelectedGroupName);
                                SelectedContributor = StepForm.GetValues("Contributor");
                                StepDuration        = StepForm.GetValues("Duration");
							    //Instructions		= ALSpecialCharHandling.TrimAndReplaceSpecialChars(StepForm.GetValues("ACTIVITY_INSTRUCTIONS"));            
    				
                                StepDurantionInMin = PMFacadeObj.ConvertDaysToMinutes(Convert.ToInt64(StepDuration));                                     

                                StepObjInfoList = (List<ObjectInfo>)ViewState["StepObjectList" + StepFormIDEnum.Key.ToString()];
                                ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']");
                                ActivityInfoNode = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION");
                                if (ActivityInfoNode != null)
                                {
									strActivityDefID	                = ActivityInfoNode.SelectSingleNode("ACTIVITYDEFINITIONID").InnerText;
									strFormName			                = strActivityDefID + "_Editable";
                                    FormConfigXMLPath                   = MWB_HelperObj.GetFormConfigXMLPath(strStdFormName, strFormName, out SelectedFormName);
									FormFacadeObj.FormName              = SelectedFormName;                                    
                                    str_FormConfigXML                   = MWB_HelperObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, IsPreviousWorkFlowPresent);
                                    FormFacadeObj.ConfigurationXMLType  = "InnerXML";
                                    FormFacadeObj.ConfigurationXML      = str_FormConfigXML;
									StepCurrentDuration = ActivityInfoNode.SelectSingleNode("DURATION").InnerText;
                                    if (!StepCurrentDuration.Equals(StepDurantionInMin.ToString()))
                                    {
                                        UpdateActivityXML = new StringBuilder();
                                        UpdateActivityXML.AppendFormat(@"<ACTIVITYID>{0}</ACTIVITYID>
                                            <ACTIVITY_INFORMATION TYPE='RELATION'>
                                                <ACTIVITYINFORMATION MODIFIED='TRUE'>
                                                    <ACTIVITYINFORMATIONID>{1}</ACTIVITYINFORMATIONID>
                                                    <DURATION>{2}</DURATION>
                                                </ACTIVITYINFORMATION>
                                            </ACTIVITY_INFORMATION>", ActivityNode.SelectSingleNode("ACTIVITYID").InnerText, ActivityInfoNode.SelectSingleNode("ACTIVITYINFORMATIONID").InnerText, StepDurantionInMin.ToString());

                                            UpdateActivityNode = FormDataDocument.CreateElement("ACTIVITY");
                                        ((XmlElement)UpdateActivityNode).SetAttribute("MODIFIED", "TRUE");
                                        UpdateActivityNode.InnerXml = UpdateActivityXML.ToString();
                                        UpdateActivityXML = null;
                                        StepDurationChanged = true;
                                        CalculateTimeLine = true; 
                                    }
                                }

							    // Case - I : When Selected Group not equal "None" and SelectedContributor not equal to "None"
							    // Here disassociate the actual resource from the Activity resource, and also activity contributor
							    // this will also disassociate the resource user relationship from the actual resource.
							    if(SelectedGroup.ToUpper() != "NONE")
							    {								
								    if (ActivityNode != null)
								    {
									    //if ((StepFormIDEnum.Key.ToString() == __ActivityIDForFirstStep.Value) &&(SelectedContributor.ToUpper() != "NONE"))
									    //    ContributorForFirstStep = true;
									    if (SelectedContributor.ToUpper() != "NONE")
									    {
                                            //Calculate actual duration.
                                            i_Duration = Math.Max(i_Duration, StepDurantionInMin);

										    MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);	
										    if ((ActivityResourceID != null) && (ActualResourceID != null))
										    {
											    ContributorsSelected = true;
											    // group and contributor both changed.
											    OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
											    if (OldUserNode != null)
											    {
												    OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
											    }
											    if ((SelectedGroup != ActivityResourceID))
											    {												
												    DisAssociateUserAndGroup = true;
											    }
											    else if (OldUserID != SelectedContributor)
											    {
												    // the selected group is same but the contributor is changed. 
												    if (OldUserID !=null)
													    DisAssociateUserOnly = true;
												    else
													    AddNewUser = true;
											    }
											    else
											    {
												    ActivityResourceID = null;
												    ActualResourceID = null;
												    ActivityModified = false;
											    }
										    }
										    else  if (ActualResourceID == null)
										    {
											    // create new actual resource
											    ContributorsSelected = true;
											    CreateNewActualRes = true;
										    }
									    }
									    else  // here Selected Group value not equal to "None" but Selected contributor value = "None"
									    {
										    MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
										    if((ActivityResourceID != null) && (ActualResourceID != null) && (SelectedGroup == ActivityResourceID))
										    {
                                                OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
											    if(OldUserNode != null)
											    {
												    OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
												    DisAssociateUserOnly = true;
											    }
											    //if (SelectedGroup!=ActivityResourceID)
											    //    CreateNewActualRes	= true;
										    }
										    else // here only the resource type is selected.
										    {
											    CreateNewActualRes = true;											
											    if((ActivityResourceID != null) && (ActualResourceID != null))
											    {
												    // Case: When the Group and User are selected but only the group is changed.
                                                    OldUserNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER/USER");
												    if(OldUserNode != null)
												    {
													    OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
													    DisAssociateUserAndGroup = true;
												    }
                                                    else
                                                    //case: When Group is selected and no user is selected and only group is changed
                                                    if ((SelectedGroup != ActivityResourceID))
                                                    {
                                                        DisAssociateGroup = true;
                                                    }
											    }
										    }
									    }
								    }
							    }
							    else //  here selected Group Value = "None"
							    {
								    // if selected value is None then we need to check if there were any previously selected group and users
								    // if yes then they will be disassociated.
								    MWB_HelperObj.getResourceIDToBeDisAssociated(ActivityNode, out ActivityResourceID, out ActualResourceID);
								    if ((ActivityResourceID!=null) && (ActualResourceID!=null))
								    {
									    DisAssociateUserAndGroup = true;
									    OldUserNode = ActivityNode.SelectSingleNode("descendant::RESOURCE_USER/USER");
									    if(OldUserNode != null)
									    {
										    OldUserID = OldUserNode.SelectSingleNode("USERID").InnerText;
										    DisAssociateUserOnly = true;
									    }
								    }								
							    }
								ErrorXML = FormFacadeObj.GetFormDataXML(FormMode.ToUpper(), "DATAFIELD", StepForm, StepObjInfoList, out StepXML);
								if(ErrorXML != null)
									return ErrorXML;

                                //HemantK:Get the Form ActionBar
                                str_FormActionBarXML = GetFormActionBarXML(StepForm);
                                if (!String.IsNullOrEmpty(str_FormActionBarXML))
                                {
                                    sb_FormActionBarXML.Append(@"<ACTIONBAR> 
                                                                <ACTIONBARFOR>ACTIVITY</ACTIONBARFOR>
                                                                <ID>" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText + "</ID>"
                                                                    + str_FormActionBarXML + "</ACTIONBAR>");
                                }


							    if (ActivityModified)
							    {								    
								    if (DisAssociateUserAndGroup)
								    {
									    if ((ActivityResourceID != null) && (ActualResourceID != null))
									    {
										    if (ActivityNode!=null)
										    {
											    if(CreateNewActualRes)
											    {
												    ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
											    }
											    // Now check whether new group and user is selected.
    											
											    if ((SelectedGroup.ToUpper()!="NONE") &&(SelectedContributor.ToUpper()!="NONE"))
											    {
												    ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
												    MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML,SelectedGroupName);
												    MWB_HelperObj.prepareActivityXML(true, StepXML, ActivityResourceXML, out TempXML);
												    TempDoc.LoadXml(TempXML);
												    ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");                                                    
											    }
											    else
											    {
												    TempDoc.LoadXml(StepXML);
												    ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");                                                   
											    }
											    ((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
											    DisAssociateXML.Remove(0, DisAssociateXML.Length);
											    DisAssociateXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>", ActivityResourceID);
											    if (OldUserID!= null)
											    {
												    DisAssociateXML.AppendFormat(@"<ACTUAL_RESOURCE TYPE='RELATION'>
																					<RESOURCE MODIFIED='TRUE'>
																					<RESOURCEID>{0}</RESOURCEID>
																					<RESOURCE_USER TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</RESOURCE_USER>
																					</RESOURCE>
																				</ACTUAL_RESOURCE>", ActualResourceID, OldUserID);
											    }
											    DisAssociateXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTUAL_RESOURCE>", ActualResourceID);
											    DisAssociateResourceNode = TempDoc.CreateElement("RESOURCE");
											    ((XmlElement)DisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");
											    DisAssociateResourceNode.InnerXml = DisAssociateXML.ToString();
											    if(OldUserNode != null)
											    {
												    ActivityContributorNode = TempDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
												    ((XmlElement)ActivityContributorNode).SetAttribute("TYPE", "RELATION");
												    ((XmlElement)ActivityContributorNode).SetAttribute("DISASSOCIATE", "TRUE");
												    ActivityContributorNode.InnerText = OldUserNode.SelectSingleNode("USERID").InnerText;
												    ActivityNode.AppendChild(ActivityContributorNode);
											    }
											    ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE");
											    if(ActivityResourceNode == null)
											    {
												    ActivityResourceNode = TempDoc.CreateElement("ACTIVITY_RESOURCE");
												    ((XmlElement)ActivityResourceNode).SetAttribute("TYPE", "RELATION");
												    ActivityNode.AppendChild(ActivityResourceNode);
											    }
											    ActivityResourceNode.AppendChild(DisAssociateResourceNode);

											    if(CreateNewActualRes)
											    {												
												    MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML,SelectedGroupName);
												    MWB_HelperObj.prepareActivityXML(true, StepXML, ActivityResourceXML, out TempXML);
												    ActDoc = new XmlDocument();
												    ActDoc.LoadXml(TempXML);
												    Act_ResNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE");
												    ResNode    = ActDoc.SelectSingleNode("ACTIVITY/ACTIVITY_RESOURCE/RESOURCE");
												    //actContNode = ActDoc.SelectSingleNode("ACTIVITY/ACTIVITY_CONTRIBUTOR");
												    //ActivityNode.AppendChild(TempDoc.ImportNode(actContNode,true));
												    Act_ResNode.AppendChild(TempDoc.ImportNode(ResNode, true));                                                    
											    }
                                                Activity_ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
                                                if (Activity_ResponseNode != null)
                                                {
                                                    ActivityNode.RemoveChild(Activity_ResponseNode);
                                                }
											    ProcessActivityNode.AppendChild(FormDataDocument.ImportNode(ActivityNode, true));                                                
										    }																																								
									    }
								    }
								    else if((DisAssociateUserOnly)||(AddNewUser))
								    {
									    MWB_HelperObj.prepareActivity_ActualResourceXML(ActivityResourceID, ActualResourceID, OldUserID, SelectedContributor, StepXML, SelectedGroupName, out TempXML);
									    TempDoc.LoadXml(TempXML);
									    ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
									    if(ActivityNode != null)
									    {
                                            Activity_ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
                                            if (Activity_ResponseNode != null)
                                            {
                                                ActivityNode.RemoveChild(Activity_ResponseNode);
                                            }
                                            ProcessActivityNode.AppendChild(FormDataDocument.ImportNode(ActivityNode, true));										                                                
									    }																
								    }
								    else if (CreateNewActualRes)
								    {
									    ResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + SelectedGroup + "']");
									    MWB_HelperObj.prepareActivityResourceXML(SelectedGroup, SelectedContributor, ResourceNode.OuterXml, out ActivityResourceXML,SelectedGroupName);
									    MWB_HelperObj.prepareActivityXML(true, StepXML, ActivityResourceXML, out TempXML);
									    TempDoc.LoadXml(TempXML);
									    ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
									    if(ActivityNode != null)
									    {
                                            Activity_ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
                                            if (Activity_ResponseNode != null)
                                            {
                                                ActivityNode.RemoveChild(Activity_ResponseNode);
                                            }

                                            if (DisAssociateGroup)
                                            {
                                                if (ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").SelectSingleNode("RESOURCE[RESOURCEID/text()='" + ActivityResourceID + "']") == null)
                                                {
                                                    XmlNode TmpDisAssociateResourceNode = TempDoc.CreateElement("RESOURCE");
                                                    ((XmlElement)TmpDisAssociateResourceNode).SetAttribute("MODIFIED", "TRUE");
                                                    TmpDisAssociateResourceNode.InnerXml = "<RESOURCEID>" + ActivityResourceID + "</RESOURCEID><ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>" + ActualResourceID + "</ACTUAL_RESOURCE>";

                                                    ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE").AppendChild(TmpDisAssociateResourceNode);
                                                }
                                            }

                                            ProcessActivityNode.AppendChild(FormDataDocument.ImportNode(ActivityNode, true));										                                               
									    }
								    }
								    else
								    {										
										TempDoc.LoadXml(StepXML);
										ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
										((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
                                        Activity_ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
                                        if (Activity_ResponseNode != null)
                                        {
                                            ActivityNode.RemoveChild(Activity_ResponseNode);
                                        }
										ProcessActivityNode.AppendChild(FormDataDocument.ImportNode(ActivityNode, true));                                        
								    }																
							    }
							    else
							    {								    
									TempDoc.LoadXml(StepXML);
									ActivityNode = TempDoc.SelectSingleNode("ACTIVITY");
									((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
                                    Activity_ResponseNode = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE");
                                    if (Activity_ResponseNode != null)
                                    {
                                        ActivityNode.RemoveChild(Activity_ResponseNode);
                                    }
								    ProcessActivityNode.AppendChild(FormDataDocument.ImportNode(ActivityNode, true));                                    
							    }
							    if(Status.ToUpper() == "ACTIVE" && SelectedContributor.ToUpper() == "NONE")
							    {
								    CancelledActivities.Add(StepFormIDEnum.Key.ToString());
								    if(ActivityInfoNode != null)
								    {

									    if(!String.IsNullOrEmpty(Activity_InfoID_Table.ToString()))
									    {
										    TempString = Activity_InfoID_Table.ToString();
										    Activity_InfoID_Table.AppendFormat(",{0}_{1}_{2}", StepFormIDEnum.Key.ToString(), ActivityInfoNode.SelectSingleNode("ACTIVITYINFORMATIONID").InnerText, StepDurantionInMin.ToString());
									    }
									    else
										    Activity_InfoID_Table.AppendFormat("{0}_{1}_{2}", StepFormIDEnum.Key.ToString(), ActivityInfoNode.SelectSingleNode("ACTIVITYINFORMATIONID").InnerText, StepDurantionInMin.ToString());
								    }
							    }
							    if ((StepDurationChanged) )
                                {
                                //&& (ResourceUpdated)
                                    ActivityNode = ProcessActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']");
                                    if (ActivityNode != null)
                                    {
                                        ActivityInfoNode = UpdateActivityNode.SelectSingleNode("ACTIVITY_INFORMATION");
                                        ActivityNode.AppendChild(ActivityInfoNode);   
                                    }
                                }
							    //else if ((StepDurationChanged) && (!ResourceUpdated)) 
							    //    ProcessActivityNode.AppendChild(UpdateActivityNode);   

                                if (Status.ToUpper() == "ACTIVE")
                                {
                                    //Add disassociation nodes for old resource types whose associations were not deleted due to the bug S0812244. 
                                    //Here currently selected resource type and resource will be used and other association will be deleted.
                                    if (MWB_HelperObj.CheckIfMultipleResourcesAreAssociated(ActResDoc, StepFormIDEnum.Key.ToString()))
                                    {
                                        String ActResourceXML = MWB_HelperObj.ProcessActivityResourceXML(ActResDoc, TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']"), StepFormIDEnum.Key.ToString(), SelectedGroup);

                                        if (ProcessActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']/ACTIVITY_RESOURCE") != null)
                                        {
                                            ProcessActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID='" + StepFormIDEnum.Key.ToString() + "']/ACTIVITY_RESOURCE").InnerXml += ActResourceXML;
                                        }
                                    }
                                }

                            }					
                            WorkflowProcessNode.RemoveChild(WorkflowProcessNode.SelectSingleNode("DUEDATE"));

                            StartDateNode = WorkflowProcessNode.SelectSingleNode("STARTDATE");
                            if ((StartDateNode != null) && (StartDateNode.HasChildNodes))
                                NewStartDate = new DateTime(Convert.ToInt32(StartDateNode.SelectSingleNode("YEAR").InnerText), Convert.ToInt32(StartDateNode.SelectSingleNode("MONTH").InnerText), Convert.ToInt32(StartDateNode.SelectSingleNode("DAY").InnerText));
                            else
                                NewStartDate = new DateTime(1, 1, 1);                            

                            if (Status.ToUpper() != "ACTIVE")
                            {
                                ErrorXML = MktgWorkBenchFacadeObj.GetAllowedStartDateForTask(TaskID, DeliverableID, out AllowedStartDate);

                                if (NewStartDate < AllowedStartDate)
                                {
                                    Alert_Message = new StringBuilder();
                                    alertGiven = true;

                                    str_PlaceHoldersKeys    += "$AL$DATE$AL$";
                                    str_PlaceHoldersValues += "$AL$" + ALCommon.FormatLongDateField(ALCommon.GetFormatXMLPath(ALParamObj.TenantName), AllowedStartDate.Day.ToString(), AllowedStartDate.Month.ToString(), AllowedStartDate.Year.ToString(), obj_CultureInfo, String.Empty) + "$AL$";
                                    Ajax.WriteExecuteJavaScript("Javascript:ShowAlertFunctionCall('Alert_MWB_TaskStartDateMessage_Shared', '" + str_PlaceHoldersKeys + "','" + str_PlaceHoldersValues + "');");

                                    Ajax.WriteExecuteJavaScript(Alert_Message.ToString());
                                    return ErrorXML;
                                }
                                else
                                {
                                    //Check for Date change
                                    CurrentStartDate = Convert.ToDateTime(ViewState["StartDate"]);
                                    if (CurrentStartDate != NewStartDate)
                                    {
                                        StartDateLockedNode = FormDataDocument.CreateElement("STARTDATELOCKED");
                                        StartDateLockedNode.InnerText = "1";

                                        WFProcessInfoNode = WorkflowProcessNode.SelectSingleNode("PROCESS_INFORMATION/WORKFLOWPROCESSINFO");
                                        WFProcessInfoNode.AppendChild(StartDateLockedNode);

                                        if (CalculateTimeLine == false)
                                            CalculateTimeLine = true;
                                    }
                                    else
                                    {
                                        WorkflowProcessNode.RemoveChild(WorkflowProcessNode.SelectSingleNode("STARTDATE"));
                                    }
                                }
                            }
                            else
                            {
                                if (i_Duration != 0 && checkBoxObj.Checked && PMFacadeObj.ConvertDaysToMinutes(Convert.ToInt64(textBoxObj.Text)) >= i_Duration)
                                {
                                    Ajax.WriteExecuteJavaScript("javascript:ShowAlert('Alert_AdvanceReminderCheck_Shared');");
                                    Ajax.WriteExecuteJavaScript("javascript:EnableButton('" + Ab_GatherInfoTask.GetClientIDByName("btn_Submit") + "','" + ALSpecialCharHandling.EncodeSpecialCharactersForJS("javascript:ValidateForm('" + Ab_GatherInfoTask.GetUniqueIDByName("btn_Submit") + "');") + "')");
                                    alertGiven = true;
                                    return null;
                                }

                                //Check whether task start date is equal to today's date when the status is to be changed to Active.
                                if (NewStartDate != DateTime.Today)
                                {
                                    StartDateNode.SelectSingleNode("DAY").InnerText     = DateTime.Today.Day.ToString();
                                    StartDateNode.SelectSingleNode("MONTH").InnerText   = DateTime.Today.Month.ToString();
                                    StartDateNode.SelectSingleNode("YEAR").InnerText    = DateTime.Today.Year.ToString();

                                    StartDateLockedNode = FormDataDocument.CreateElement("STARTDATELOCKED");
                                    StartDateLockedNode.InnerText = "1";

                                    WFProcessInfoNode = WorkflowProcessNode.SelectSingleNode("PROCESS_INFORMATION/WORKFLOWPROCESSINFO");
                                    WFProcessInfoNode.AppendChild(StartDateLockedNode);

                                    if (CalculateTimeLine == false)
                                        CalculateTimeLine = true;
                                }
                                else
                                {
                                    WorkflowProcessNode.RemoveChild(WorkflowProcessNode.SelectSingleNode("STARTDATE"));
                                }
                            }

                            //Add values for NOTIFYINADVANCE and NOTIFYNOOFDAYS fields.                        
                            AddAdvanceReminderValues(FormDataDocument);

                            if (b_AppendProcessActivityNoe)
                            {
                                WorkflowProcessNode.AppendChild(ProcessActivityNode);
                            }

                            SaveTaskXML = FormDataDocument.OuterXml;

                            sb_FormActionBarXML.Append("</ACTIONBARCOLLECTION>");
                            //Hemantk:Update the Component Facet series for Deliverable
                            ErrorXML = UpdateDeliverableComponentForTask(ref SaveTaskXML, sb_FormActionBarXML.ToString(), obj_SelectComponentIDs, str_ComponentFacetName, str_ComponentFacetPK);
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                if (Status.ToUpper() == "ACTIVE")
                                {
                                    IsSubmitValid = MktgWorkBenchFacadeObj.IsSubmitValid(TaskID);
                                }

                                if ((!ContributorsSelected) && (Status.ToUpper() == "ACTIVE"))
                                {
                                    alertGiven = true;
                                    Ajax.WriteExecuteJavaScript("ShowAlert('Alert_MWB_Manage_CreateGatherInfoTask_Pleaseselectatleastonecontributor');");
                                    Ajax.WriteExecuteJavaScript("javascript:EnableButton('" + Ab_GatherInfoTask.GetClientIDByName("btn_Submit") + "','" + ALSpecialCharHandling.EncodeSpecialCharactersForJS("javascript:ValidateForm('" + Ab_GatherInfoTask.GetUniqueIDByName("btn_Submit") + "');") + "');");
                                    return ErrorXML;
                                }
                                else
                                {
                                    if (IsSubmitValid)
                                    {
                                        DateNode = WorkflowProcessNode.SelectSingleNode("DUEDATE");
                                        if (DateNode != null)
                                            WorkflowProcessNode.RemoveChild(DateNode);
                                        
                                        ErrorXML = MktgWorkBenchFacadeObj.UpdateTask(TaskID, CalculateTimeLine, MWB_TimeLineEvents.TASK_DURATION_CHANGED, false, ref SaveTaskXML);
                                    }
                                    else
                                    {
                                        TempFilePath.Remove(0, TempFilePath.Length);
                                        TempFilePath.AppendFormat("{0}SubmitGatherInfoTaskFile_{1}.xml", TempPath, TaskID);
                                        File.WriteAllText(TempFilePath.ToString(), SaveTaskXML);
                                        Hidden_CalculateTimeLine.Value = CalculateTimeLine.ToString();
                                        Hidden_ActivityInfoTable.Value = Activity_InfoID_Table.ToString();

                                        alertGiven          = true;
                                        ConfirmationAlert   = Localization.GetString("ALJSResource",ALParamObj.TenantName,"Cnfm_MWB_RemoveTaskDependencies_Shared");
                                        Ajax.WriteExecuteJavaScript("SubmitTask('" + Btn_Hidden_SubmitTask.UniqueID + "','" +ALSpecialCharHandling.EncodeSpecialCharactersForJS( ConfirmationAlert )+ "','" + Ab_GatherInfoTask.GetClientIDByName("btn_Submit") + "','" + ALSpecialCharHandling.EncodeSpecialCharactersForJS("javascript:ValidateForm('" + Ab_GatherInfoTask.GetUniqueIDByName("btn_Submit") + "');") + "')");
                                    }
                                }
                            }
                        }                    
                    }
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {                 
                    throw ExceptionObj;
                }
            }

            private void setAttachments(XmlNode FileSystemNode, XmlNode AssetReferences)
            {
                StringBuilder UploadUrlPath     = null;
                StringBuilder DownLoadUrlPath   = null;
                StringBuilder ParameterList     = null;
                String        FileSystemXml     = "";
                try
                {
                    UploadUrlPath                   = new StringBuilder();
                    DownLoadUrlPath                 = new StringBuilder();
                    ParameterList                   = new StringBuilder();
					ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&ControlID={4}&Language={5}&ThemeName={6}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, Btn_Hidden_Attachment.UniqueID, ALParamObj.Language, Page.Theme);
                    UploadUrlPath.AppendFormat("../../Common/ASPX/UploadFiles.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                    
                    ParameterList.Remove(0, ParameterList.Length);
					ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&ThemeName={5}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, Page.Theme);
                    DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));

                    BinderControl.TenantName            = ALParamObj.TenantName;
                    BinderControl.SolutionName          = SolutionName;    
                    BinderControl.BinderListHeading     = Localization.GetString("ALResource",ALParamObj.TenantName,"Attachments_shared");
                    BinderControl.Layout                = Binder.LayoutType.BinderList_WithThumbnails;
                    BinderControl.Mode                  = Binder.Modes.Editable;
                    BinderControl.InputXMLType          = Binder.InputType.InnerXML;
                    BinderControl.ListConfigurationName = "TaskAttachments";
                    BinderControl.FieldName             = "ATTACHMENTS";
                    BinderControl.ConfigName            = "GATHERINFOTASK_ATTACH";
                    BinderControl.UploadUrl             = UploadUrlPath.ToString();
                    BinderControl.DownloadUrl           = DownLoadUrlPath.ToString();
                    BinderControl.EnableAssetSelection  = true;
                    BinderControl.DigitalAssetRelationShip = "PROCESS_ASSETREFERENCES";

                    Attachment.TenantName   = ALParamObj.TenantName;
                    Attachment.SessionID    = ALParamObj.SessionID;
                    Attachment.UserID       = ALParamObj.UserID;
                    Attachment.ThemeName    = Page.Theme;
                    Attachment.Language     = ALParamObj.Language;
                    Attachment.BinderFieldName = "ATTACHMENTS";

                    if (FileSystemNode != null)
                        FileSystemXml = FileSystemNode.OuterXml;

                    if (AssetReferences != null)
                    {
                        if (FileSystemNode == null)
                        {
                            Attachment.PrepareInputXMLWithAssetReferences(null, AssetReferences.CreateNavigator(), ref FileSystemXml);
                        }
                        else
                        {
                            Attachment.PrepareInputXMLWithAssetReferences(FileSystemNode.CreateNavigator(), AssetReferences.CreateNavigator(), ref FileSystemXml);
                        }
                    }

                    if (FileSystemNode.SelectNodes("BINDER").Count > 0)
                    {
                        BinderControl.BinderOperation = "Update";
                        BinderControl.InputXML = FileSystemXml;
                    }
                    else
                    {
                        BinderControl.BinderOperation = "Create";
                        BinderControl.InputXML = FileSystemXml;
                    }
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepFormInputXMLForGroup(String StepID, String StepFormID, XML ItemListXML)
            {            
                XML             FormInputXML        = null;            
                XmlNode         FieldNode           = null;
                XmlNode			ValueNode			= null;
                String          TempPath            = null;
                StringBuilder   TempFilePath        = null;
                XmlDocument     FormInputDoc        = null;
                String          ErrorXML            = null;
                String          ErrorPageURL        = null;
                try
                {
                    FormInputDoc     = new XmlDocument();
                    TempStepForm     = (Form)Panel_ManualActivities.FindControl(StepFormID);
                    TempFilePath     =  new StringBuilder(); 
                    TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    if (TempStepForm != null)
                    {
                        ErrorXML =  SaveStepForm(StepID, TempStepForm);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            FormInputXML = TempStepForm.InputXML;
                            if (FormInputXML != null)
                            {
                                FormInputDoc.LoadXml(FormInputXML);
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                if (FieldNode != null)
                                {
                                    FieldNode.InnerXml = ItemListXML;                                 
                                }                                
                                //Comment By : Bhalchandra.
                                //Clear Email ID field.
                                FieldNode = null;
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FieldNode.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = "";
                                }
                                TempStepForm.InputXML = FormInputDoc.OuterXml;
                                TempStepForm.ResetFacetSeriesFields();
                                TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID);
                                File.WriteAllText(TempFilePath.ToString(), FormInputDoc.OuterXml);
                            }
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepFormInputXMLForMailAddress(String StepID, String StepFormID,String MailID)
            { 
                XML             FormInputXML        = null;            
                XmlNode         FieldNode           = null;
                XmlNode         ValueNode           = null;
                String          TempPath            = null;
                StringBuilder   TempFilePath        = null;
                XmlDocument     FormInputDoc        = null;
                String          ErrorXML            = null;
                String          ErrorPageURL        = null;
                try
                {                                
                    FormInputDoc     = new XmlDocument();
                    TempStepForm     = (Form)Panel_ManualActivities.FindControl(StepFormID);
                    TempPath         = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);  
                    TempFilePath     = new StringBuilder();
                    if (TempStepForm != null)
                    {
                        ErrorXML =  SaveStepForm(StepID, TempStepForm);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            FormInputXML = TempStepForm.InputXML;
                            if (FormInputXML != null)
                            {
                                FormInputDoc.LoadXml(FormInputXML);
                                FieldNode = FormInputDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
                                if (FieldNode != null)
                                {
                                    ValueNode = FieldNode.SelectSingleNode("Value");
                                    if (ValueNode != null)
                                        ValueNode.InnerText = MailID;                                 
                                }      
                                TempStepForm.InputXML = FormInputDoc.OuterXml;
                                TempStepForm.ResetFacetSeriesFields();
                                TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormID);
                                File.WriteAllText(TempFilePath.ToString(), FormInputDoc.OuterXml);
                            }
                        }
                        else
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void createNewStepForm(Boolean b_ResetFacetSeriesFields)
            {
                Form            StepForm            = null;
                XML             FormConfigXML       = null;
                XML             ItemListXML         = null;                
                XML             TempFormInputXML    = null;
                ERRORXML        ErrorXML            = null;
                XmlDocument     InputXMLDoc         = null;
                XmlDocument     TaskDoc             = null;
                XmlDocument     FormXMLDoc          = null;
                XmlNode         ActivityCollNode    = null;
                XmlNode         FieldNode           = null;
                XmlNode         ActivityNode        = null;
                XmlNode         ActivityResourceNode= null;
                XmlNode         ActualResourceNode  = null;
                StringBuilder   TempFilePath        = null;            
                String          TempPath            = null;
                String          FormConfigXMLPath   = null;
                String          ResourceID          = null;
                String          MailID              = null;
                MWB_Helper      MWBHelperClassObj   = null;
                FormFacade      FormFacadeObj       = null;
                bool			IsPreviousWorkflowPresent = false;
				String			ActivityID			= null;
				String			SelectedValueFile	= null;
				XML				SelectedValueXML	= null;
				String			SelectedValueFileName= null;
				XPathDocument	UserDoc				 = null;
				String			strFormName			= null;
				String			strStdFormName		= null;
				String			strSelectedFormName	= null;
				String			strActivityDefID	= null;
				String			str_StepFormID		= null;
                String          SearchXML           = null;
								
                try
                {                
                    TempFilePath   = new StringBuilder();
                    InputXMLDoc    = new XmlDocument();
                    TaskDoc        = new XmlDocument();
                    FormXMLDoc      = new XmlDocument();
                    FormFacadeObj   = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    MWBHelperClassObj = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    TempPath       = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
                    TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);                                
                    FormFacadeObj.SolutionName = SolutionName;
                    if (ViewState["PrevWorkflow"].ToString().ToUpper() == "TRUE")
						IsPreviousWorkflowPresent = true;
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        TaskDoc.Load(TempFilePath.ToString());
                        ActivityIDOrderedList = (List<string>)ViewState["ActivityIDList"];
                        //IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                        for (int i= 0;i<ActivityIDOrderedList.Count;i++)
                        //while(StepFormIDEnum.MoveNext())                   
                        {
                            StepForm		=  new Form ();
							strStdFormName	= "StepDetails_Editable";
                            if (StepFormIDTable.ContainsKey(ActivityIDOrderedList[i]))
                            {
                                str_StepFormID = StepFormIDTable[ActivityIDOrderedList[i]].ToString();
								StepForm.ID = str_StepFormID;
                                ActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + ActivityIDOrderedList[i] + "']");
                                if (ActivityNode != null)
                                {
                                    //StepForm.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);
                                    StepForm.TenantName				= ALParamObj.TenantName;
                                    StepForm.SolutionName           = SolutionName; 
                                    StepForm.EnableSetFocus			= false;
									StepForm.IsDynamicForm			= true;
                                    StepForm.InputXMLType			= Assetlink.CustomControls.Form.InputType.InnerXML;
                                    StepForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;
                                    StepForm.ShowConfiguredFields   = true;
                                    strActivityDefID				= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
									strFormName						= strActivityDefID + "_Editable";								
									FormConfigXMLPath				= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName, strFormName, out strSelectedFormName);
									FormConfigXML					= MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, IsPreviousWorkflowPresent);

                                    InputXMLDoc						= null;
                                    InputXMLDoc						= new XmlDocument();
                                    ActivityCollNode				= InputXMLDoc.CreateElement("ACTIVITYCOLLECTION");
                                    InputXMLDoc.AppendChild(ActivityCollNode);
                                    ActivityCollNode.InnerXml	= ActivityNode.OuterXml;
                                    FormFacadeObj.FormName		= strSelectedFormName;
									FormFacadeObj.UniqueID		= StepFormIDTable[ActivityIDOrderedList[i]].ToString();
                                    FormFacadeObj.ShowConfiguredFields = true;
                                    FormFacadeObj.ConfigurationXMLType = "InnerXML";
                                    FormFacadeObj.ConfigurationXML  = FormConfigXML;
									ActivityID					    = ActivityNode.SelectSingleNode("ACTIVITYID").InnerText;

                                    FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                                    //HemantK: check for the deliverable component facet series
                                    ErrorXML = SetDeliverableComponentFacetSeries(ref InputXMLDoc, ref FormConfigXML, ActivityNode.CreateNavigator(), SearchXML);
                                    if (String.IsNullOrEmpty(ErrorXML))
                                    {
                                        StepForm.ConfigurationXML   = FormConfigXML;
                                        CheckComponentFacetSeriesStatus(StepForm);  


									    // keep the Selected value XML in a String, since the form facade will over-write it
									    // after the form facade over writes it re-write it back to maintain the changes
									    SelectedValueFileName	= StepFormIDTable[ActivityIDOrderedList[i]].ToString() + "_ContributorGroup_SelectedValueList.xml";
									    SelectedValueFile		= TempPath + SelectedValueFileName;
									    SelectedValueXML		= File.ReadAllText(SelectedValueFile);

                                        //ErrorXML = FormFacadeObj.GetFormInputXML("Edit", InputXMLDoc.OuterXml, out StepFormInputXML, out ObjInfoList);

									    // Load the temporary file of form
									    TempFilePath.Remove(0, TempFilePath.Length);
									    TempFilePath.AppendFormat("{0}{1}.xml", TempPath, str_StepFormID);
									    if(File.Exists(TempFilePath.ToString()))
									    {
										    FormXMLDoc.LoadXml(File.ReadAllText(TempFilePath.ToString()));
									    //}
									    //if (ErrorXML == null)
									    //{
										    File.WriteAllText(SelectedValueFile, SelectedValueXML);										
                                            ActivityResourceNode	= ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE");
                                            ActualResourceNode		= ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");										
                                            
										    GroupListFile = StepFormIDTable[ActivityIDOrderedList[i]].ToString() + "_GroupUsers.xml";
										    TempFilePath.Remove(0, TempFilePath.Length);
										    TempFilePath.AppendFormat("{0}{1}", TempPath, GroupListFile);

                                            if (ActualResourceNode != null)
                                            {
                                                if(File.Exists(TempFilePath.ToString()))
											    {
												    UserDoc		= new XPathDocument(new StringReader(File.ReadAllText(TempFilePath.ToString())));
												    ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
												    if(ItemListXML != null)
												    {
													    if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
													    {
														    ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
														    ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
														    MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
														    //if (__ActivityIDForFirstStep.Value == ActivityID)
														    //    __ContributorSelected.Value = "TRUE";
													    }
												    }
											    }										
                                            }
                                            else
                                            {
                                                ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                                            }
                                            FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                            if (FieldNode != null)
                                            {
                                                //ItemListXML = "<Item Selected='Yes'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                                                FieldNode.InnerXml = ItemListXML;
                                            }

                                            TempFilePath.Remove(0, TempFilePath.Length);
                                            TempFilePath.AppendFormat("{0}{1}.xml",TempPath,StepForm.ID);
                                            if (File.Exists(TempFilePath.ToString()))
                                            {
                                                TempFormInputXML = File.ReadAllText(TempFilePath.ToString());
                                                if (TempFormInputXML != null)
                                                {
                                                    StepForm.InputXML = TempFormInputXML;
                                                    File.WriteAllText(TempFilePath.ToString(), TempFormInputXML);
                                                }
                                                else
                                                {
                                                    StepForm.InputXML = FormXMLDoc.OuterXml;
                                                    File.WriteAllText(TempFilePath.ToString(), FormXMLDoc.OuterXml);
                                                }
                                            }
                                            else
                                            {
                                                StepForm.InputXML = FormXMLDoc.OuterXml;
                                                File.WriteAllText(TempFilePath.ToString(), FormXMLDoc.OuterXml);
                                            }

                                            updateFormFields("EmailID", ActivityNode, ref FormXMLDoc);
                                            updateFormFields("PostedBy", ActivityNode, ref FormXMLDoc);
                                        }
                                        Panel_ManualActivities.Controls.Add(StepForm);
                                        StepForm.ConfigurationMode = true;
									    StepForm.AddCustomValidator("Duration", "onblur", "javascript:ValidateDuration('$CONTROLID$')", false);
                                        //StepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                                        if (b_ResetFacetSeriesFields)
                                        {
                                            StepForm.ResetFacetSeriesFields();
                                        }
                                    }
                                }
                            }
                        }
                    } 
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }

            private void setStepFormEventHandler()
            {                
                Form StepForm = null;
                try
                {
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();
                    while (StepFormIDEnum.MoveNext())
                    {
                        StepForm = (Form)Panel_ManualActivities.FindControl(StepFormIDEnum.Value.ToString());
                        StepForm.FormSelectionChanged += new EventHandler(StepForm_SelectionChanged);
                        StepForm.SeriesActionBarClick += new EventHandler(StepForm_SeriesActionBarClick);
                        StepForm.ResetBinders = true;
                        StepForm.ResetFileUploadControls = true;  
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            private void gotoDeliverableROScreen()
            {
                StringBuilder               ParamURL                = null;
                StringBuilder               URL                     = null;            
                String                      EncryptURL              = null;
                try
                {
                    ParamURL = new StringBuilder();
                    URL      = new StringBuilder();

                    ParamURL.AppendFormat("Manage_RODeliverableDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&DeliverableID={4}&ProjectID={5}&Mode={6}&Access={7}&PARENTBREADCRUMBNAME=Project&BREADCRUMBCTRLID={8}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, DeliverableID, ProjectID, Mode, Access, GatherInfoTaskBreadcrumb.BreadcrumbUniqueID);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObj)
                {                
                    throw ExceptionObj;
                }
            }
            
            private void gotoProjectROScreen()
            {
				StringBuilder   ParamURL         = null;
                StringBuilder   URL              = null;            
                String          EncryptURL       = null;
                ulong           ErrorID          = 0;
                StringBuilder   ErrorPageURL_Exp = null;

                try
                {
                    ParamURL = new StringBuilder();
                    URL      = new StringBuilder();

					ParamURL.AppendFormat("Manage_ROProjectDetails.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&ProjectID={4}&Mode={5}&Access={6}&PrevScreen={7}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, ProjectID, Mode, Access,PrevScreen);
                    EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                    URL.AppendFormat("window.open('" + "{0}" + "','_self','');", EncryptURL.ToString());
                    Ajax.WriteExecuteJavaScript(URL.ToString());
                }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateDiscussionTask.aspx", "gotoDeliverableROScreen", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilegoingtoRODeliverablescreen_Shared"));

                    ErrorPageURL_Exp = new StringBuilder();
                    ErrorPageURL_Exp.AppendFormat("/{0}/Common/ASPX/ShowError.aspx?ErrorID={1}", ALParamObj.TenantName, ErrorID.ToString());
                    if (!IsPostBack)
                    {
                        //Response.Redirect(ErrorPageURL_Exp.ToString());
                    }
                    else
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL_Exp.ToString() + "','_self','');");
                }
            }

            private void StampNotificationForGatherInfoTask(string TaskID)
            {
                String              ReturnTaskXML           = null;
                String              ContributorID           = null;
                String              TaskScreenURL           = null;
                String              NotificationXML         = null;
                String              ActivityID              = null;
                String              ReaderID                = null;
                String              Reciver                 = null; 
                XML                 ErrorXML                = null;
                StringBuilder       AssociationXML          = null;
                StringBuilder       Message                 = null;
                StringBuilder       Subject                 = null;                
                XmlDocument         xp_retTaskXMLDoc        = null;    
                XPathNavigator      TaskNavigator           = null;                
                XPathNavigator      ContributorNav          = null;
                XPathNavigator      Reader                  = null;
                XPathNavigator      TempNavigator           = null;
                XPathNodeIterator   Contributors            = null;
                XPathNodeIterator   Readers                 = null;
                XPathNodeIterator   FileSystemIterator      = null;
                NotificationHelper  NotificationHelperObj   = null;
                EmailChannel        EmailChannelObj         = null;
                String              ErrorPageURL            = null;
                MktgWorkBenchFacadeClass MWBFacadeObj       = null;
                MWB_Helper               MWB_HelperObj      = null; 
                NotificationFacadeClass NotificationFacadeObj = null;
                XmlNode                 ProjectManager        = null;
                String						SenderName		  = null;
				String					ReceiverName		  = null;
                String              str_ProcessAssoFacets   = null;

                try
                {
                    //Get the Task.
                    AssociationXML = new StringBuilder(200);
                    str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                    if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                    {
                        AssociationXML.Append("<ASSOCIATION>" + str_ProcessAssoFacets + "");
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                    }
                        AssociationXML.Append(@"<READERS Type='RELATION'>
		                                            <LOGINNAME/>
		                                            <FIRSTNAME/>
		                                            <MIDDLEINITIAL/>
		                                            <LASTNAME/>
	                                            </READERS>
	                                            <PROCESS_ACTIVITY Type='RELATION'>
		                                            <ACTIVITYID/>
		                                            <ACTIVITY_CONTRIBUTOR Type='RELATION'>
			                                            <LOGINNAME/>
			                                            <FIRSTNAME/>
			                                            <MIDDLEINITIAL/>
			                                            <LASTNAME/>
		                                            </ACTIVITY_CONTRIBUTOR>
	                                            </PROCESS_ACTIVITY>
	                                            <DELIVERABLE_TASK Type='RELATION' HIERARCHY='BOTTOMUP'>
		                                            <PROCESSNAME/>
		                                            <PROJECT_DELIVERABLE Type='RELATION' HIERARCHY='BOTTOMUP'>
			                                            <PROCESSNAME/>
			                                            <PROJECTMANAGER Type='RELATION'>
				                                            <USERID/>
				                                            <LOGINNAME/>
				                                            <FIRSTNAME/>
				                                            <MIDDLEINITIAL/>
				                                            <LASTNAME/>
			                                            </PROJECTMANAGER>
		                                            </PROJECT_DELIVERABLE>
		                                            <DELIVERABLEMANAGER Type='RELATION'>
			                                            <USERID/>
			                                            <LOGINNAME/>
			                                            <FIRSTNAME/>
			                                            <MIDDLEINITIAL/>
			                                            <LASTNAME/>
			                                            <EMAILID/>
		                                            </DELIVERABLEMANAGER>
	                                            </DELIVERABLE_TASK>
                                            </ASSOCIATION>");

                    MWBFacadeObj    = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);        
                    ErrorXML = MWBFacadeObj.GetTask(TaskID, null, AssociationXML.ToString(), out ReturnTaskXML);
                    if (ErrorXML == null)
                    {
                        //Email Stamping for the contributor of 1st step from Task.
                        xp_retTaskXMLDoc = new XmlDocument();
                        xp_retTaskXMLDoc.LoadXml(ReturnTaskXML);
                        TaskNavigator = xp_retTaskXMLDoc.CreateNavigator();

                        FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");

                        while (FileSystemIterator.MoveNext())
                        {
                            TempNavigator = FileSystemIterator.Current;
                            TempNavigator.DeleteSelf();
                            FileSystemIterator = TaskNavigator.Select("//FILESYSTEM");
                        }

                        Contributors = TaskNavigator.Select("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY/ACTIVITY_CONTRIBUTOR");

                        while (Contributors.MoveNext())
                        {
                            ContributorNav = Contributors.Current;
                            ContributorID = ContributorNav.SelectSingleNode("USER/USERID").Value;
							//if (ContributorID != ALParamObj.UserID)
							//{
                                NotificationHelperObj = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                                NotificationHelperObj.Init("5003", ALParamObj.UserID);

                                EmailChannelObj = new EmailChannel(PriorityType.NORMAL, false);
                                EmailChannelObj.AddRecipient("TO", ContributorID, false);

                                //By: Bhalchandra
                                //Create ProjectManager attribute and set it to  PROJECTMANAGER Node
                                ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS/PROJECTMANAGER");
                                if (ProjectManager != null)
                                    ((XmlElement)ProjectManager).SetAttribute("ProjectManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                //By: Bhalchandra
                                //Date : September,12 2007
                                //Create DeliverableManger attribute and set it to  DELIVERABLEMANAGER Node
                                ProjectManager = null;
                                ProjectManager = xp_retTaskXMLDoc.SelectSingleNode("WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/DELIVERABLEMANAGER");
                                if (ProjectManager != null)
                                    ((XmlElement)ProjectManager).SetAttribute("DeliverableManager", MWB_HelperObj.getUserName(ProjectManager.SelectSingleNode("USER").CreateNavigator()));

                                NotificationHelperObj.AddChannel(EmailChannelObj);
                                Message = new StringBuilder();
                                
                                SenderName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName());
                                ReceiverName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(ContributorNav));
								Message.AppendFormat("<MESSAGE Sender='{0}' Reciever='{1}'>{2}</MESSAGE>", SenderName,ReceiverName , TaskNavigator.InnerXml);

                                Subject = new StringBuilder();
                                Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                ContributorNav.MoveToParent();
                                ActivityID = ContributorNav.SelectSingleNode("ACTIVITYID").Value;

                                TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "RESPONSE", ActivityID);

                                ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                if (ErrorXML == null && NotificationXML != null)
                                {
                                    NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                    ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                }
                           // }
                        }
                        //Email Stamping for the Readers of the Task.
                        Readers = TaskNavigator.Select("WORKFLOWPROCESS/READERS/USER");
                        if (Readers.Count > 0)
                        {
                            EmailChannelObj         = new EmailChannel(PriorityType.NORMAL, false);
                            NotificationHelperObj   = new NotificationHelper(Convert.ToUInt64(ALParamObj.UserID), Convert.ToUInt64(ALParamObj.SessionID), ALParamObj.Language, ALParamObj.TenantName);
                            NotificationHelperObj.Init("5004", ALParamObj.UserID);

                            if (Readers.Count == 1)
                            {
                                Reader = TaskNavigator.SelectSingleNode("WORKFLOWPROCESS/READERS/USER");
                                if (Reader != null)
                                {
                                    Reciver = ALCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getUserName(Reader));
                                }
                                else
                                {
                                    Reciver = "All";
                                }
                            }
                            else
                            {
                                Reciver = "All";
                            }


                            while (Readers.MoveNext())
                            {
                                Reader = Readers.Current;

                                ReaderID = Reader.SelectSingleNode("USERID").Value;
                                EmailChannelObj.AddRecipient("TO", ReaderID, false);
                            }

                                NotificationHelperObj.AddChannel(EmailChannelObj);
                                Message = new StringBuilder();
								SenderName = ALSolutionCommon.TrimAndReplaceSpecialChars(MWB_HelperObj.getLogedInUserName());
                                Message.AppendFormat("<MESSAGE Sender='{0}' Reciever='{2}'>{1}</MESSAGE>", SenderName, TaskNavigator.InnerXml, Reciver);

                                Subject = new StringBuilder();
                                Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", TaskNavigator.InnerXml);

                                TaskScreenURL = MWB_HelperObj.GetEmailScreenURL(SolutionName, TaskID, "READONLY", null);

                                ErrorXML = NotificationHelperObj.AddSubject(Subject.ToString());
                                ErrorXML = NotificationHelperObj.AddMessage(Message.ToString());
                                ErrorXML = NotificationHelperObj.AddLink("TaskScreenURL", TaskScreenURL);

                                ErrorXML = NotificationHelperObj.GetNotificationXML(ref NotificationXML);

                                if (ErrorXML == null && NotificationXML != null)
                                {
                                    NotificationFacadeObj = new NotificationFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                                    ErrorXML = NotificationFacadeObj.StampNotification(NotificationXML);
                                }
                            //}
                        }
                    }
                    else
                    {
                        ALSolutionCommonObj.PrepareErrorPageUrl(SolutionName, null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);
                        if (!IsPostBack)
                        {
                            Response.Redirect(ErrorPageURL, true);
                        }
                        else
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
                catch(Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            private void setTemplateDocument()
            {                
                XML                         OutputXml                       = null;
                ERRORXML                    ErrorXml                        = null;
                MktgWorkBenchFacadeClass    MktgWorkBenchFacadeClassObject  = null;

                
                MktgWorkBenchFacadeClassObject = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                ErrorXml = MktgWorkBenchFacadeClassObject.GetDigitalAssetBySectionPath (SectionPath + ProcessDefinitionID,  ref OutputXml);
                showTemplateDocumentList(OutputXml);
            }

            /// <alsummary>
            /// <createddate>25-April-07</createddate>
            /// <author>Bhalchandra Kadam</author>
            /// <purpose>This method shows all the template documents for a brief type in a list</purpose>
            /// </alsummary>
            private void showTemplateDocumentList(XML TemplateDocXML)
            {
                XPathDocument       UploadOutputDoc     = null;
                XPathNavigator      UploadNaviagator    = null;
                XPathNodeIterator   UploadIterator      = null;                
                StringBuilder       InputXML            = null;
                ListFacade          ListFacadeObj       = null;
                XML                 ConfigXML           = null;
                XML                 OutputXML           = null;
                XmlDocument         xmlDoc              = null;
                XmlNodeList         xmlNodeList         = null;
                XmlElement          xmlElement          = null;
                try
                {                    
                    InputXML         = new StringBuilder();
                    ListFacadeObj = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);                    

                    if (!String.IsNullOrEmpty(TemplateDocXML))
                    {
                        UploadOutputDoc  = new XPathDocument(new StringReader(TemplateDocXML));
                        UploadNaviagator = UploadOutputDoc.CreateNavigator();

                        UploadIterator = UploadNaviagator.Select("DIGITALASSETCOLLECTION/DIGITALASSET");
                        if (UploadIterator.Count > 0)
                        {
                            Panel_Templates.Visible = true;
                            Lst_TemplateDocument.Visible = true;
                            InputXML.AppendFormat("<SEARCHOUTPUTXML>");
                            InputXML.Append(UploadNaviagator.OuterXml);
                            InputXML.AppendFormat("</SEARCHOUTPUTXML>");
                            ConfigXML = ListFacadeObj.GetConfigurationXML(SolutionName, null, "TemplateDocument");
                            ListFacadeObj.PrepareListXml(ConfigXML, InputXML.ToString(), out OutputXML);

                            #region SetDownloadUrl
                            xmlDoc = new XmlDocument();
                            xmlDoc.LoadXml(OutputXML);
                            xmlNodeList = xmlDoc.SelectNodes("/List/Data/Group/Row");
                            foreach (XmlNode tmpxmlNode in xmlNodeList)
                            {
                                xmlElement = (XmlElement)tmpxmlNode.SelectSingleNode("Column[@Name='NAME']");
                                xmlElement.SetAttribute("Url", GetTemplateDocumentUrl(tmpxmlNode, UploadNaviagator.OuterXml));
                            }
                            OutputXML = xmlDoc.OuterXml;
                            #endregion

                            Lst_TemplateDocument.Source = OutputXML;
                        }
                    }                    
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            /// <alsummary>
            /// <createddate>26-April-07</createddate>
            /// <author>Bhalchandra Kadam</author>
            /// <param name="DigitalAssetXML">Contains Digital Asset Collection XML Nodes</param>
            /// <param name="xmlRowNode">ListControls Data Row xml node</param>
            /// <purpose>This method gets the URL for the uploated templated documents</purpose>
            /// </alsummary>
            private string GetTemplateDocumentUrl(XmlNode xmlRowNode,String DigitalAssetXML)
            {

                XmlElement              xmlElement                  = null;
                XPathDocument           xpathDocument               = null;
                XPathNavigator          xPathNavigator              = null;
                XPathNavigator          tmpNavigator                = null;
                XPathNavigator          AssertRenditionNavigator    = null;
                String                  xpathQuery                  = null;
                String                  xpathAssertQuery            = null;
                StringBuilder           ParameterList               = null;
                StringBuilder           DownLoadUrlPath             = null;
                Boolean                 b_IsFileOnMediaServer       = false;

                try
                {

                    xpathDocument       = new XPathDocument(new StringReader(DigitalAssetXML));
                    xPathNavigator      = xpathDocument.CreateNavigator();
                    ParameterList       = new StringBuilder();
                    DownLoadUrlPath     = new StringBuilder();
                    xmlElement          = (XmlElement)xmlRowNode.SelectSingleNode("Column[@Name='DIGITALASSETID']");
                    
                    xpathQuery          = ("DIGITALASSETCOLLECTION/DIGITALASSET[DIGITALASSETID='" + xmlElement.InnerText + "']");
                    xpathAssertQuery    = ("DIGITALASSET_CURRENTREVISION/CONTENTREVISION/CONTENTREVISION_RENDITION/ASSETRENDITION[RENDITIONTYPE='Original']/FILESYSTEM/FILE");
                    
                    tmpNavigator                = xPathNavigator.SelectSingleNode(xpathQuery);
                    AssertRenditionNavigator    = tmpNavigator.SelectSingleNode(xpathAssertQuery);

                    ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&FieldName=PROCESSFILE&ObjectID={5}&SchemaID={6}&FileName={7}&DownloadFileName={7}", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, SolutionName, ALParamObj.Language, AssertRenditionNavigator.SelectSingleNode("OBJECTID").Value, AssertRenditionNavigator.SelectSingleNode("SCHEMAID").Value, Server.UrlEncode(AssertRenditionNavigator.SelectSingleNode("NAME").Value));
                    //DownLoadUrlPath.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                    if (AssertRenditionNavigator.SelectSingleNode("ONMEDIASERVER") != null)
                    {
                        b_IsFileOnMediaServer = Convert.ToBoolean(AssertRenditionNavigator.SelectSingleNode("ONMEDIASERVER").Value);
                        ParameterList.Append("&IsFileOnMediaServer=" + b_IsFileOnMediaServer.ToString());
                        if (b_IsFileOnMediaServer)
                        {
                            ParameterList.Append("&FileID=" + AssertRenditionNavigator.SelectSingleNode("FILEID").Value);
                            ParameterList.Append("&FilePath=" + AssertRenditionNavigator.SelectSingleNode("PATH").Value);
                        }
                        DownLoadUrlPath.Append(ALSolutionCommon.PrepareFileDownloadURL(b_IsFileOnMediaServer, ALParamObj.TenantName));
                        DownLoadUrlPath.Append("Param=" + ALSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                    }
                    return DownLoadUrlPath.ToString();

                }
                catch (Exception ExceptionObject)
                {
                    
                    throw ExceptionObject;
                }
            }

			/// <alsummary>
			/// <createddate>06-Sept-07</createddate>
			/// <author>Mugdha Moolay</author>
			/// <purpose>This function will be used to update the status, (From New to Draft)
			/// title of the task and BreadCrumbs when the user has clicked on the
			/// Save button or on the Dependencies or User Roles Tab.</purpose>
			/// </alsummary>
			/// <returns>void</returns>
			private void RefreshForm(String NewStatus)
			{						                        
				ERRORXML	 ErrorXML			 = null;
				XML			 FormInputXML		 = null;
				XmlDocument	 FormDoc			 = null;
				XmlNode		 TaskNameNode		 = null;
				XmlNode		 TaskStatusNode		 = null;
				String		 NewTaskTitle	     = null;
				try
				{               
					FormInputXML = Frm_GatherInfo.InputXML;
					if (ErrorXML == null)
					{
						FormDoc = new XmlDocument();
						FormDoc.LoadXml(FormInputXML);
						TaskNameNode = FormDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_PROCESSNAME']");
						if (TaskNameNode!=null)
						{
							NewTaskTitle = TaskNameNode.InnerText;
							ViewState["TaskTitle"] = NewTaskTitle;
						}
						TaskStatusNode = FormDoc.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_STATUS']");
						if (TaskStatusNode!=null)
						{
							TaskStatusNode.SelectSingleNode("Value").InnerText = "Draft";
						}
						Frm_GatherInfo.InputXML = FormDoc.OuterXml;
                        //Frm_GatherInfo.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                        Frm_GatherInfo.ResetFacetSeriesFields();
					}                
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}
			
			private ERRORXML UpdateTaskStepsAndAttachments()
			{
				MktgWorkBenchFacadeClass	MWBFacadeObj	= null;				
				StringBuilder				AssociationXML	= null;
				StringBuilder				TempFilePath	= null;
				XML							TaskXML			= null;
				ERRORXML					ErrorXML		= null;
				XmlDocument					TaskDoc			= null;
				XmlDocument					TempDoc			= null;
				XmlNode						ProcessActivityNode	= null;                
				String						TempPath			= null;
                String                      str_ProcessAssoFacets   = null; 
                String                      str_ActivityAssoFacets  = null;
                try
				{
					MWBFacadeObj	= new MktgWorkBenchFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
					AssociationXML	= new StringBuilder(100);
					TempFilePath	= new StringBuilder(50);
					TempPath = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					TempFilePath.AppendFormat("{0}{1}", TempPath, TaskFile);
                    str_ProcessAssoFacets = ViewState["ProcessAssociatedFacets"].ToString();
                    str_ActivityAssoFacets = ViewState["ActivityAssociatedFacets"].ToString();

                    if (!String.IsNullOrEmpty(str_ProcessAssoFacets))
                    {
                        AssociationXML.Append(@"<ASSOCIATION>" + str_ProcessAssoFacets + "");
                    }
                    else
                    {
                        AssociationXML.Append("<ASSOCIATION GetAllFacets='TRUE'>");
                    }
                    AssociationXML.Append(@"<PROCESS_ASSETREFERENCES Type='RELATION'>
                                                <DIGITALASSETID/>
                                            </PROCESS_ASSETREFERENCES>");
                    if (!String.IsNullOrEmpty(str_ActivityAssoFacets))
                    {
                        AssociationXML.Append("<PROCESS_ACTIVITY Type='RELATION'>" + str_ActivityAssoFacets + "");
                    }
                    else
                    {
                        AssociationXML.Append("<PROCESS_ACTIVITY Type='RELATION' GetAllFacets='TRUE'>");
                    }
					        AssociationXML.Append(@"<ACTIVITY_RESOURCE Type='RELATION'>
														<RESOURCEID/>
														<RESOURCETYPE/>
														<RESOURCECOUNT/>
														<USERASSIGNED/>
														<ACTUAL_RESOURCE Type='RELATION'>
															<RESOURCEID/>
															<RESOURCETYPE/>
															<RESOURCE_USER Type='RELATION'>
																<LOGINNAME/>
																<FIRSTNAME/>
																<MIDDLEINITIAL/>
																<LASTNAME/>
																<EMAILID/>
															</RESOURCE_USER>
														</ACTUAL_RESOURCE>
													</ACTIVITY_RESOURCE>
                                                    <ACTIVITY_RESPONSE Type='RELATION'/>
												</PROCESS_ACTIVITY>	                                        
											</ASSOCIATION>");
	                                        
					ErrorXML = MWBFacadeObj.GetTask(TaskID, null, AssociationXML.ToString(), out TaskXML);
					if (ErrorXML == null)
					{
						TaskDoc			= new XmlDocument();
						TempDoc			= new XmlDocument();					
						TaskDoc.LoadXml(TaskXML);
						BinderControl.Reset = true;
                        setAttachments(TaskDoc.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM"), TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ASSETREFERENCES"));
						BinderControl.Reset = false;					
						ProcessActivityNode = TaskDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY");										
						setTaskSteps(ProcessActivityNode);
						ViewState["StepFormIDList"] = StepFormIDTable;
						ViewState["ActivityIDList"] = ActivityIDOrderedList;

                        setFormXML(TaskDoc,true);

						// Update the temporary Task File
						TempDoc.Load(TempFilePath.ToString());
						TempDoc.SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY").InnerXml = ProcessActivityNode.InnerXml;
						TempDoc.Save(TempFilePath.ToString());
					}
					return ErrorXML;
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private ERRORXML setTaskSteps(XmlNode ProcessActivityNode)
			{
				XmlNode		ActualResourceNode		= null;
				XmlNode		ActivityResourceNode	= null;
				XmlNode		ActivityInfoNode		= null;
				String		MailID					= null;
				StringBuilder	GroupListXML		= null;
				StringBuilder	TempPath			= null;
				StringBuilder	ContributorFileName = null;
				String			FormConfigXMLPath	= null;
				MWB_Helper		MWBHelperClassObj	= null;
				XML				FormConfigXML		= null;
				XML				StepFormInputXML	= null;
				XmlDocument		InputXMLDoc			= null;
				XmlNode			ActivityCollNode	= null;
				FormFacade		FormFacadeObj		= null;
				ERRORXML		ErrorXML			= null;			
				XML				ItemListXML			= null;
				XML				UserCollectionXML	= null;
				String			ResourceID			= null;
				XmlDocument		FormXMLDoc			= null;
				XmlNode			FieldNode			= null;
				XmlNode			ValueNode			= null;
				String			ResourceType		= null;				
				String			CurrentDuration		= null;
				PMFacadeClass	PMFacadeObj			= null;
				String			TempFilePath		= null;
				Form			StepForm			= null;
				XmlNode			ActivityNode		= null;
				XML				ResourceXML			= null;
				XML				SearchXML			= null;
				StringBuilder	ActResourceXML		= null;
				StringBuilder	ParamURL			= null;
				GroupFacade		GroupFacadeObj		= null;
				XML				GroupXML			= null;
				String			GroupID				= null;
				String			SelectedValueFileName= null;
				XPathDocument	UserDoc			    = null;
				String			ActivityID			= null;
				StringBuilder	SelectedValueXml	= null;
				long			Days				= 0;
				long			RemMins				= 0;
				String			strFormName			= null;
				String			strStdFormName		= null;
				String			strSelectedFormName	= null;
				String			strActivityDefID	= null;                
                StringBuilder   sb_TempFilePath     = null; 
                String          str_SearchXML       = null;
				try
				{
					MWBHelperClassObj	  = new MWB_Helper(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
					FormFacadeObj		  = new FormFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language,ALParamObj.SolutionName,Theme);
					GroupFacadeObj		  = new GroupFacade(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
					PMFacadeObj			  = new PMFacadeClass(ALParamObj.SessionID,ALParamObj.UserID,ALParamObj.TenantName,ALParamObj.Language);
					FormXMLDoc			  = new XmlDocument();
					ActResourceXML		  = new StringBuilder();
                    sb_TempFilePath       = new StringBuilder(50);

					ActResourceXML.Append("<ACTIVITYCOLLECTION>");
					//ActivityIDOrderedList = new List<string>();
					
					FormFacadeObj.SolutionName = SolutionName;
					TempFilePath		  = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);


					ActivityIDOrderedList = (List<string>)ViewState["ActivityIDList"];
					StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];

					for(int i = 0; i < ActivityIDOrderedList.Count; i++)
					{
						ActualResourceNode      = null;
						ActivityResourceNode    = null;
						MailID                  = null;
						GroupListXML			= new StringBuilder(150);
						TempPath				= new StringBuilder(100);
						ContributorFileName		= new StringBuilder(50);
						SelectedValueXml		= new StringBuilder(100);
						ParamURL				= new StringBuilder(150);
						strStdFormName			= "StepDetails_Editable";

						if (StepFormIDTable.ContainsKey(ActivityIDOrderedList[i]))
						{
							ActivityID = ActivityIDOrderedList[i];
							StepForm = (Form)Panel_ManualActivities.FindControl(StepFormIDTable[ActivityIDOrderedList[i]].ToString());
							if (StepForm!=null)
							{
								ActivityNode = ProcessActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID='" + ActivityIDOrderedList[i] + "']");
								if (ActivityNode!=null)
								{
									strActivityDefID				= ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID").InnerText;
									strFormName						= strActivityDefID + "_Editable";
									StepForm.EnableSetFocus			= false;
									StepForm.TenantName				= ALParamObj.TenantName;
                                    StepForm.SolutionName           = SolutionName;  
									StepForm.InputXMLType			= Assetlink.CustomControls.Form.InputType.InnerXML;
									StepForm.ConfigurationXMLType	= Assetlink.CustomControls.Form.InputType.InnerXML;
                                    StepForm.ShowConfiguredFields   = true;
									FormConfigXMLPath				= MWBHelperClassObj.GetFormConfigXMLPath(strStdFormName,strFormName,out strSelectedFormName);
									FormConfigXML					= MWBHelperClassObj.SetFormDisplayNameInConfigurationXML(FormConfigXMLPath, ActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText,false);
									
									InputXMLDoc = null;
									InputXMLDoc = new XmlDocument();
									ActivityCollNode = InputXMLDoc.CreateElement("ACTIVITYCOLLECTION");
									InputXMLDoc.AppendChild(ActivityCollNode);
									ActivityCollNode.InnerXml = ActivityNode.OuterXml;
									FormFacadeObj.FormName = strSelectedFormName;
									FormFacadeObj.UniqueID = StepFormIDTable[ActivityIDOrderedList[i]].ToString();
                                    FormFacadeObj.ShowConfiguredFields  = true;
                                    FormFacadeObj.ConfigurationXMLType  = "InnerXML";
                                    FormFacadeObj.ConfigurationXML      = FormConfigXML;

                                    FormFacadeObj.GetHierarchicalSearchXML("Edit", out str_SearchXML);
                                    //HemantK: check for the deliverable component facet series
                                    ErrorXML = SetDeliverableComponentFacetSeries(ref InputXMLDoc, ref FormConfigXML, ActivityNode.CreateNavigator(), str_SearchXML);
                                    if (String.IsNullOrEmpty(ErrorXML))
                                    {
                                        StepForm.ConfigurationXML       = FormConfigXML;
                                        CheckComponentFacetSeriesStatus(StepForm);

									    ErrorXML = FormFacadeObj.GetFormInputXML("Edit", InputXMLDoc.OuterXml, out StepFormInputXML, out StepObjInfoList);
									    if (ErrorXML == null)
									    {
										    //ALCommon.WriteLog(ALParamObj.TenantName, "Marketing Workbench", "Edit_Assignment Details", ALParamObj.SessionID, "Workbech Page (setPageInEditMode):Inside if Block.");
										    //ViewState["StepObjectList" + ActivityNode.SelectSingleNode("ACTIVITYID").InnerText] = StepObjInfoList;                                
										    ResourceXML = MWBHelperClassObj.GetActivityResourceXML(ActivityNode);
										    if(!String.IsNullOrEmpty(ResourceXML))
										    {
											    ActResourceXML.Append(ResourceXML);
										    }
										    SelectedValueFileName = StepFormIDTable[ActivityIDOrderedList[i]].ToString() + "_ContributorGroup_SelectedValueList.xml";
										    ParamURL.Append("SelectResourceType.aspx?");
										    //ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&ResourceFileName={5}&HiddenBtnID={6}&SelectedValueFileName={7}&ResourceTreeFile={8}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, StepResourceFileName, Hidden_SelectResourceType.UniqueID, SelectedValueFileName, ResourceTreeFile);
                                            ParamURL.AppendFormat("SessionID={0}&UserID={1}&Language={2}&TenantName={3}&ActivityID={4}&TaskID={5}&HiddenBtnID={6}&FromScreen=TASK", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.Language, ALParamObj.TenantName, ActivityID, TaskID, Hidden_SelectResourceType.UniqueID);

										    // check if this activity has any actual resources associated with it
										    ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
										    if(ActivityResourceNode!=null)
											    ActualResourceNode   = ActivityResourceNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");
    										
										    FormXMLDoc.LoadXml(StepFormInputXML);
										    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
										    if (FieldNode != null)
										    {
											    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyURL", ParamURL.ToString());
											    ((XmlElement)FieldNode).SetAttribute("NamedHierarchyXML", "");
										    }

										    if (ActualResourceNode != null)
										    {
											    ResourceType = ActualResourceNode.SelectSingleNode("RESOURCETYPE").InnerText;
											    GroupListFile = StepFormIDTable[ActivityIDOrderedList[i]].ToString() + "_GroupUsers.xml";
											    TempPath.Remove(0, TempPath.Length);

											    TempPath.AppendFormat("{0}{1}", TempFilePath, GroupListFile);										
											    SearchXML	= GetSearchXMLForGroupAndUsers(ResourceType);
											    ErrorXML	= GroupFacadeObj.GetGroupList(SearchXML, ref GroupXML);
											    if(ErrorXML == null)
											    {
												    if(GroupXML != null)
												    {											
													    MWBHelperClassObj.GetGroupIDAndUserXML(GroupXML, out UserCollectionXML, out GroupID);
    													
													    File.WriteAllText(TempPath.ToString(), UserCollectionXML);
													    TempPath.Remove(0, TempPath.Length);
													    TempPath.AppendFormat("{0}{1}", TempFilePath, SelectedValueFileName);
													    SelectedValueXml.AppendFormat("<ValueList><Value ID='{0}' Text='{1}'/></ValueList>", GroupID, ALSolutionCommon.TrimAndReplaceSpecialChars(ResourceType));
													    File.WriteAllText(TempPath.ToString(), SelectedValueXml.ToString());											
    													
													    UserDoc		= new XPathDocument(new StringReader(UserCollectionXML));
													    ItemListXML = MWBHelperClassObj.GetContributorXML(UserDoc);
													    if(ItemListXML != null)
													    {
														    if(ActualResourceNode.SelectSingleNode("RESOURCE_USER") != null)
														    {
															    ResourceID = ActualResourceNode.SelectSingleNode("RESOURCE_USER/USER/USERID").InnerText;
															    ItemListXML = MWBHelperClassObj.getItemListXMLForSelectedValue(ItemListXML, ResourceID);
															    MWBHelperClassObj.GetMailAddressForSelectedUser(ResourceID, GroupListFile, out MailID);
															    //if (__ActivityIDForFirstStep.Value == ActivityID)
															    //    __ContributorSelected.Value = "TRUE";
														    }
													    }
												    }
												    else
												    {
                                                        ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
												    }
											    }	
										    }
										    else
										    {
                                                ItemListXML = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
										    }
										    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Contributor']");
										    if (FieldNode != null)
										    {                                    
											    FieldNode.InnerXml = ItemListXML;
										    }
										    if (MailID != null)
										    {
											    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailAddress']");
											    if (FieldNode != null)
											    {
												    ValueNode = FormXMLDoc.CreateElement("Value");
												    ValueNode.InnerText = MailID;
												    FieldNode.AppendChild(ValueNode);
											    }                                
										    }

                                            updateFormFields("EmailID", ActivityNode, ref FormXMLDoc);
                                            updateFormFields("PostedBy", ActivityNode, ref FormXMLDoc);

										    //Put the duration
										    ActivityInfoNode = ActivityNode.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION");
										    if (ActivityInfoNode != null)
										    {
											    CurrentDuration = ActivityInfoNode.SelectSingleNode("DURATION").InnerText;
											    if (!String.IsNullOrEmpty(CurrentDuration))
												    Days = PMFacadeObj.ConvertMinutesToDays(Convert.ToInt64(CurrentDuration), out RemMins);
											    else
												    Days = 2;
										    }
										    else
											    Days = 2;

										    FieldNode = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='Duration']");
										    if (FieldNode != null)
										    {
											    ValueNode = FieldNode.SelectSingleNode("Value");
											    if (ValueNode != null)
												    ValueNode.InnerText = Days.ToString();
											    else
											    {
												    ValueNode = FormXMLDoc.CreateElement("Value");
												    ValueNode.InnerText = Days.ToString();
												    FieldNode.AppendChild(ValueNode);
											    }
										    }

                                            if (IsPostBack)
                                            {
                                                StepForm.ResetBinders = true;
                                                StepForm.ResetFileUploadControls = true;                                                
                                            }

										    StepForm.InputXML = FormXMLDoc.OuterXml;
                                            if (IsPostBack)
                                            { 
                                                StepForm.ResetFacetSeriesFields();
                                            }
										    TempPath.Remove(0,TempPath.Length);
										    TempPath.AppendFormat("{0}{1}.xml", TempFilePath, StepForm.ID);
										    //ViewState[StepForm.ID] = FormXMLDoc.OuterXml;
										    File.WriteAllText(TempPath.ToString(), FormXMLDoc.OuterXml);
									    }
									    else
										    return ErrorXML;
                                    }
								}
							}
						}
					}
					ActResourceXML.Append("</ACTIVITYCOLLECTION>");
					TempPath.Remove(0, TempPath.Length);
					TempPath.AppendFormat("{0}{1}", TempFilePath, StepResourceFileName);
					File.WriteAllText(TempPath.ToString(), ActResourceXML.ToString());
					return ErrorXML;
				}
                catch (ThreadAbortException)
                { return ErrorXML; }
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}
			
			/// <alsummary>
			/// <author>Mugdha Moolay</author>
			/// <createddate>31-Aug-07</createddate>
			/// <purpose>This function will be used to update the BreadCrumbs with the task title when the user has clicked on the
			/// Save button or on the Dependencies or User Roles Tab.</purpose>
			/// </alsummary>
			private void RefreshBreadCrumb()
			{
				String TaskTitle = null;	
				try
				{
					TaskTitle = Frm_GatherInfo.GetValues("WORKFLOWPROCESS_PROCESSNAME");
					GatherInfoTaskBreadcrumb.DisplayText = TaskTitle;
					ViewState["TaskTitle"] = TaskTitle;
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private void setControlProperties()
			{
				try
				{
					GatherInfoTaskTab.onTabClick += new ALTab.TabEventHandler(GatherInfoTaskTab_onTabClick);
					Lst_PredecessorList.ActionBarClick += new EventHandler(PredecessorList_AB_Click);
					Ab_GatherInfoTask.Click += new EventHandler(Ab_GatherInfoTask_Click); ;
					ID_SelcetPredecessor_UC.OkClick += new EventHandler(Btn_SelectPredecessorOk_Click);
					ID_SelcetPredecessor_UC.CancelClick += new EventHandler(Btn_SelectPredecessorCancel_Click);
                    Frm_GatherInfo.SeriesActionBarClick += new EventHandler(Frm_GatherInfo_SeriesActionBarClick);
                    Lst_UserGroup.ActionBarClick += new EventHandler(Lst_UserGroup_ActionBarClick);
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private XML GetSearchXML(String GpName)
			{
				StringBuilder Search = null;
				try
				{
					Search = new StringBuilder();
					Search.AppendFormat(@"<INPUTXML>
											<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
											<SEARCHCOLLECTION>
											<SEARCH>
											<TARGETOBJECT>USER</TARGETOBJECT>
											<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
											<ISCASESENSITIVE>False</ISCASESENSITIVE>
											<SEARCHALLFACETS>False</SEARCHALLFACETS>
											<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
											<FILTERLIST>
												<FILTER>
													<FIELDNAME>GROUPNAME</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>{4}</FIELDVALUE>
													<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
												<FILTER>
												<FIELDNAME>STATUS</FIELDNAME>
												<OPERATOR>EQUALTO</OPERATOR>
												<FIELDVALUE>ACTIVE</FIELDVALUE>											
												<ISCASESENSITIVE>False</ISCASESENSITIVE>
											</FILTER>
											</FILTERLIST>
											<FIELDCOLLECTION>
												<TARGETENTITYFIELDS>
													<FIELD>USERID</FIELD>
													<FIELD>LOGINNAME</FIELD>
													<FIELD>FIRSTNAME</FIELD>
													<FIELD>LASTNAME</FIELD>
													<FIELD>MIDDLEINITIAL</FIELD>
													<FIELD>EMAILID</FIELD>													
												</TARGETENTITYFIELDS>
											</FIELDCOLLECTION>
											</SEARCH>
											</SEARCHCOLLECTION>
										</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
					return Search.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			private XML GetSearchXMLForGroupAndUsers(String GpName)
			{
				StringBuilder Search = null;
				try
				{
					Search = new StringBuilder();
					Search.AppendFormat(@"<INPUTXML>
											<SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
											<SEARCHCOLLECTION>
											<SEARCH>
											<TARGETOBJECT>GROUP</TARGETOBJECT>
											<TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
											<ISCASESENSITIVE>False</ISCASESENSITIVE>
											<SEARCHALLFACETS>False</SEARCHALLFACETS>
											<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
											<FILTERLIST>
												<FILTER>
													<FIELDNAME>GROUPNAME</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>{4}</FIELDVALUE>												
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
												<FILTER ApplyFilter=""Yes"">
													<FILTERID>2</FILTERID>
													<FIELDNAME>STATUS</FIELDNAME>
													<OPERATOR>EQUALTO</OPERATOR>
													<FIELDVALUE>ACTIVE</FIELDVALUE>
													<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>
													<ISCASESENSITIVE>False</ISCASESENSITIVE>
												</FILTER>
											</FILTERLIST>
											<FIELDCOLLECTION>
                                                <TARGETENTITYFIELDS>
                                                        <FIELD>GROUPID</FIELD>
                                                </TARGETENTITYFIELDS>
												<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'>
														<FIELD>USERID</FIELD>
														<FIELD>LOGINNAME</FIELD>
														<FIELD>FIRSTNAME</FIELD>
														<FIELD>LASTNAME</FIELD>
														<FIELD>MIDDLEINITIAL</FIELD>
														<FIELD>EMAILID</FIELD>											
													</RELATEDENTITYFIELDS>
											</FIELDCOLLECTION>
											</SEARCH>
											</SEARCHCOLLECTION>
										</INPUTXML>", ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALSolutionCommon.TrimAndReplaceSpecialChars(GpName));
					return Search.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			
			}

			private void DeleteTempFiles()
			{
				String			TempPath				= null;
				StringBuilder	TempFilePath			= null;
				String			SelectedValueFileName	= null;
				try
				{
					TempFilePath = new StringBuilder();
					TempPath	 = ALSolutionCommon.GetTempPath(ALParamObj.SessionID);
					TempFilePath.AppendFormat("{0}{1}",TempPath,TaskFile);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);
					TempFilePath.AppendFormat("{0}{1}", TempPath, StepResourceFileName);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);
					TempFilePath.AppendFormat("{0}{1}", TempPath, ResourceTreeFile);
					if(File.Exists(TempFilePath.ToString()))
						File.Delete(TempFilePath.ToString());
					TempFilePath.Remove(0, TempFilePath.Length);

                    if (ViewState["StepFormIDList"] != null)
                    {
                        StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                        IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

                        while (StepFormIDEnum.MoveNext())
                        {
                            SelectedValueFileName = StepFormIDEnum.Value.ToString() + "_ContributorGroup_SelectedValueList.xml";
                            TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
                            if (File.Exists(TempFilePath.ToString()))
                                File.Delete(TempFilePath.ToString());
                            TempFilePath.Remove(0, TempFilePath.Length);
                            TempFilePath.AppendFormat("{0}{1}.xml", TempPath, StepFormIDEnum.Value.ToString());
                            if (File.Exists(TempFilePath.ToString()))
                                File.Delete(TempFilePath.ToString());
                            TempFilePath.Remove(0, TempFilePath.Length);
                            SelectedValueFileName = StepFormIDEnum.Value.ToString() + "_GroupUsers.xml";
                            TempFilePath.AppendFormat("{0}{1}", TempPath, SelectedValueFileName);
                            if (File.Exists(TempFilePath.ToString()))
                                File.Delete(TempFilePath.ToString());
                            TempFilePath.Remove(0, TempFilePath.Length);
                        }
                    }

                    //HemantK:To Delete Component Facet Series file
                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.Append(TempPath + TaskID + str_ComponentFacetFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());

                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_SelectedComponentsIDFileName);
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        File.Delete(TempFilePath.ToString());
                    }
                    //delete step files.
                    if (ViewState["ActivityIDList"] != null)
                    {
                        ActivityIDOrderedList = (List<string>)ViewState["ActivityIDList"];
                        for (int i = 0; i < ActivityIDOrderedList.Count; i++)
                        {
                            TempFilePath.Remove(0, TempFilePath.Length);
                            TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + ActivityIDOrderedList[i] + str_SelectedComponentsIDFileName);
                            if (File.Exists(TempFilePath.ToString()))
                            {
                                File.Delete(TempFilePath.ToString());
                            }
                        }
                    }

                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderGroupsFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());

                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderUsersFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());

                    TempFilePath.Remove(0, TempFilePath.Length);
                    TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderUserGroupsFileName);
                    if (File.Exists(TempFilePath.ToString()))
                        File.Delete(TempFilePath.ToString());
					
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

            /// <summary>
            /// <CreatedOn>19 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To handle component facet series action bar clicks</Purpose>
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            protected void StepForm_SeriesActionBarClick(object sender, EventArgs e)
            {                
	            ulong			ErrorID				= 0;                
                StringBuilder   ParamURL            = null;
                StringBuilder   URL                 = null;
                String          EncryptURL          = null;
                String          str_DeliverableId   = null;
                String          str_ActivityID      = null;

                try
                {
                    ParamURL        = new StringBuilder();
                    URL             = new StringBuilder(); 
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                    if (Parameters[1].Equals("SelectSeriesRecord"))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableId = ViewState["ParentDeliverableID"].ToString();
                        }
                        GetSelectedStepForm(Parameters[0], out str_ActivityID);
                        //Radha On 30/Dec/08: For selecting Component facet series record.
                        ParamURL.AppendFormat("Manage_SelectSigns.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&HiddenButtonID={4}&TaskID={5}&DeliverableID={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Btn_Hidden_SelectSigns.UniqueID, TaskID, str_DeliverableId);
                        ParamURL.Append("&OutPutFileName=" + str_ActivityID + str_SelectedComponentsIDFileName + "&SelectFor=STEP&StepID=" + str_ActivityID);
                        EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                        URL.AppendFormat("window.open('" + "{0}" + "','_new','left=120,top=120,width=1085,height=800,scrollbars=yes');", EncryptURL.ToString());
                        Ajax.WriteExecuteJavaScript(URL.ToString());
                    }
                    else if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                    {
                        GetSelectedStepForm(Parameters[0], out str_ActivityID);
                        getDigitalAssetsFromFacetIDs("STEP", str_ActivityID);
                    }
                    else if (Parameters[1].Equals("EditSeriesRecord"))
                    {
                        GetSelectedStepForm(Parameters[0], out str_ActivityID);
                        //Redirect to standar page for additional info facet series.
                        if ((ViewState["ComponentFacetFieldName"] != null) && (Parameters[0].Contains(ViewState["ComponentFacetFieldName"].ToString())))
                        {
                            GetEditPageUrl("ACTIVITY", str_ActivityID);
                        }
                        else
                        {
                            String EditPageUrl = TempStepForm.GetSeriesEditRecordsUrl();
                            if (!String.IsNullOrEmpty(EditPageUrl))
                            {
                                Ajax.WriteExecuteJavaScript(EditPageUrl);
                            }
                        }

                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "StepForm_SeriesActionBarClick", ExceptionObj, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlingComponentListactionbarclick_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ExceptionObj.Message, null, null, ref EncryptURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                }
            }
            
            /// <summary>
            /// <CreatedOn>22 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To re assign </Purpose>
            /// </summary>
            /// <param name="str_ActivityID"></param>
            /// <param name="str_StepFormXML"></param>
            /// <param name="str_FormConfigXML"></param>
            /// <param name="str_SelectedFormName"></param>
            private void CreateNewStepForm_ComponentList(String str_ActivityID, String str_StepFormXML, String str_FormConfigXML, String str_SelectedFormName,Boolean b_SetDeliverableComponentFacetSeries)
            {
                String          str_StepFormInputXML    = null; 
                String          SelectedValueFileName   = null; 
                String          str_SelectedValueFile   = null; 
                String          str_SelectedValueXML    = null; 
                //String          str_TempFormInputXML    = null; 
                StringBuilder   sb_ActivityCollection   = null; 
                StringBuilder   sb_TempFilePath         = null; 
                XmlDocument     InputXMLDoc             = null;
                XPathDocument   xp_TaskXML              = null; 
                XPathNavigator  nav_Activity            = null;
                FormFacade      FormFacadeObj           = null; 
                ERRORXML        ErrorXML                = null; 
                String          SearchXML               = null;
                XPathDocument   xp_CurrentFormInput     = null;
                XPathNavigator  nav_Field               = null; 
                XmlDocument     doc_NewFormInput        = null;
                XmlNode         node_Field              = null;
     
                try
                {
                    FormFacadeObj           = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SolutionName, Theme);
                    InputXMLDoc             = new XmlDocument();
                    sb_ActivityCollection   = new StringBuilder(500);
                    sb_TempFilePath         = new StringBuilder(50);

                    sb_TempFilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile);
                    if (File.Exists(sb_TempFilePath.ToString()))
                    {
                        xp_TaskXML = new XPathDocument(sb_TempFilePath.ToString());
                        
                        nav_Activity = xp_TaskXML.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + str_ActivityID + "']");
                        if (nav_Activity != null)
                        {
                            //str_TempFormInputXML = TempStepForm.InputXML;
                            xp_CurrentFormInput = new XPathDocument(new StringReader(TempStepForm.InputXML));
                            nav_Field = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='Contributor']");

                            // keep the Selected value XML in a String, since the form facade will over-write it
                            // after the form facade over writes it re-write it back to maintain the changes
                            SelectedValueFileName = StepFormIDTable[str_ActivityID].ToString() + "_ContributorGroup_SelectedValueList.xml";
                            str_SelectedValueFile = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedValueFileName;
                            str_SelectedValueXML = File.ReadAllText(str_SelectedValueFile);

                            sb_ActivityCollection.Append("<ACTIVITYCOLLECTION>" + str_StepFormXML + "</ACTIVITYCOLLECTION>");
                            InputXMLDoc.LoadXml(sb_ActivityCollection.ToString());

                            FormFacadeObj.SolutionName  = SolutionName;
                            FormFacadeObj.FormName      = str_SelectedFormName;
                            //HemantK: check for the deliverable component facet series
                            if ((b_SetDeliverableComponentFacetSeries) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                            {
                                FormFacadeObj.GetHierarchicalSearchXML("Edit", out SearchXML);
                                ErrorXML = SetDeliverableComponentFacetSeries(ref InputXMLDoc, ref str_FormConfigXML, nav_Activity, SearchXML);
                            }

                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                CheckComponentFacetSeriesStatus(TempStepForm);
                                                               
                                FormFacadeObj.UniqueID = StepFormIDTable[str_ActivityID].ToString();
                                FormFacadeObj.ShowConfiguredFields = true;
                                FormFacadeObj.GetFormInputXML("Edit", InputXMLDoc.OuterXml, out str_StepFormInputXML, out StepObjInfoList);
                                ViewState["StepObjectList" + str_ActivityID] = StepObjInfoList;

                                doc_NewFormInput = new XmlDocument();
                                doc_NewFormInput.LoadXml(str_StepFormInputXML);
                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='Contributor']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    node_Field.InnerXml = nav_Field.InnerXml;
                                }

                                nav_Field = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='Duration']");
                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='Duration']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    node_Field.InnerXml = nav_Field.InnerXml;
                                }

                                nav_Field = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='ContributorGroup']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    ((XmlElement)node_Field).SetAttribute("NamedHierarchyURL", nav_Field.GetAttribute("NamedHierarchyURL", ""));
                                    ((XmlElement)node_Field).SetAttribute("NamedHierarchyXML", "");
                                }

                                nav_Field   = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='EmailID']");
                                node_Field  = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='EmailID']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    XPathNavigator xnav_PC = nav_Activity.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE/POSTEDBY/USER/EMAILID");
                                    if (xnav_PC != null)
                                    {
                                        XmlNode xmlnode_Value   = doc_NewFormInput.CreateElement("Value");
                                        xmlnode_Value.InnerText = xnav_PC.Value;
                                        node_Field.AppendChild(xmlnode_Value);
                                    }
                                }

                                nav_Field = xp_CurrentFormInput.CreateNavigator().SelectSingleNode("FieldList/Field[@Name='PreviousContributor']");
                                node_Field = doc_NewFormInput.SelectSingleNode("FieldList/Field[@Name='PreviousContributor']");
                                if ((node_Field != null) && (nav_Field != null))
                                {
                                    XPathNavigator xnav_PC = nav_Activity.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE/POSTEDBY/USER");

                                    if (xnav_PC != null)
                                    {
                                        String Username = ALCommon.FormatUserName(xnav_PC.SelectSingleNode("FIRSTNAME").Value,
                                                            xnav_PC.SelectSingleNode("LASTNAME").Value, xnav_PC.SelectSingleNode("MIDDLEINITIAL").Value,
                                                            xnav_PC.SelectSingleNode("LOGINNAME").Value, ALCommon.GetUserNameFormat());

                                        XmlNode xmlnode_Value = doc_NewFormInput.CreateElement("Value");
                                        if (xnav_PC != null)
                                            xmlnode_Value.InnerText = Username;
                                        node_Field.AppendChild(xmlnode_Value);
                                    }
                                }

                                //Write again the Group XML file
                                File.WriteAllText(str_SelectedValueFile, str_SelectedValueXML);
                                if (IsPostBack)
                                {
                                    TempStepForm.ResetBinders = true;
                                    TempStepForm.ResetFileUploadControls = true;
                                }
                                TempStepForm.InputXML = doc_NewFormInput.OuterXml; 
                                //TempStepForm.InvokeFieldListControlMethod(ViewState["ComponentFacetFieldName"].ToString(), "Reset", null);
                                TempStepForm.ResetFacetSeriesFields();
                                TempStepForm.AddCustomValidator("Duration", "onblur", "javascript:ValidateDuration('$CONTROLID$')", false);
                                TempStepForm.ConfigurationMode = true;
                            }
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>18 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the selected form</Purpose>
            /// </summary>
            private void GetSelectedStepForm(String str_SenderString, out String str_ActivityID)
            {
                String FormID               = null;
                try
                {
                    str_ActivityID = null; 
                    StepFormIDTable = (Hashtable)ViewState["StepFormIDList"];
                    IDictionaryEnumerator StepFormIDEnum = StepFormIDTable.GetEnumerator();

                    while (StepFormIDEnum.MoveNext())
                    {
                        if (str_SenderString.Contains(StepFormIDEnum.Value.ToString()))
                        {
                            FormID = StepFormIDEnum.Value.ToString();
                            str_ActivityID = StepFormIDEnum.Key.ToString();
                            break;
                        }
                    }

                    if (FormID != null)
                    {
                        //Get the Step form for which save is clicked
                        TempStepForm = (Form)Panel_ManualActivities.FindControl(FormID);
                        StepObjInfoList = (List<ObjectInfo>)ViewState["StepObjectList" + str_ActivityID];
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <createddate>03 December 2008</createddate>
            /// <author>Hemant Karkande</author>
            /// <purpose>To Handle clicks on the Component Facet Series List Action bar.</purpose>
            /// </alsummary>
            protected void Frm_GatherInfo_SeriesActionBarClick(object sender, EventArgs e)
            {                
	            ulong			ErrorID				= 0;                
                StringBuilder   ParamURL            = null;
                StringBuilder   URL                 = null;
                String          EncryptURL          = null; 
                String          str_DeliverableId   = null;

                try
                {
                    ParamURL        = new StringBuilder();
                    URL             = new StringBuilder(); 
                    String strSender = (String)sender;
                    String[] Parameters = strSender.Split(strSeparator, 3, StringSplitOptions.RemoveEmptyEntries);

                    if (Parameters[1].Equals("SelectSeriesRecord"))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableId = ViewState["ParentDeliverableID"].ToString();
                        }
                        //Radha On 30/Dec/08: For selecting Component facet series record.
                        ParamURL.AppendFormat("Manage_SelectSigns.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}&HiddenButtonID={4}&TaskID={5}&DeliverableID={6}", ALParamObj.TenantName, ALParamObj.Language, ALParamObj.SessionID, ALParamObj.UserID, Btn_Hidden_SelectSigns.UniqueID, TaskID, str_DeliverableId);
                        ParamURL.Append("&OutPutFileName=" + TaskID + str_SelectedComponentsIDFileName + "&SelectFor=TASK");
                        EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
                        URL.AppendFormat("window.open('" + "{0}" + "','_new','left=120,top=120,width=1085,height=800,scrollbars=yes');", EncryptURL.ToString());
                        Ajax.WriteExecuteJavaScript(URL.ToString());
                    }
                    else if (Parameters[1].Equals("BatchDownloadDigitalAssets"))
                    {
                        getDigitalAssetsFromFacetIDs("TASK", null);
                    }
                    else if (Parameters[1].Equals("EditSeriesRecord"))
                    {
                        //Redirect to standar page for additional info facet series.
                        if ((ViewState["ComponentFacetFieldName"] != null) && (Parameters[0].Contains(ViewState["ComponentFacetFieldName"].ToString())))
                        {
                            GetEditPageUrl("TASK", null);
                        }
                        else
                        {
                            String EditPageUrl = Frm_GatherInfo.GetSeriesEditRecordsUrl();
                            if (!String.IsNullOrEmpty(EditPageUrl))
                            {
                                Ajax.WriteExecuteJavaScript(EditPageUrl);
                            }
                        }
                    }
                }
                catch (ThreadAbortException)
                { }
                catch (Exception ExceptionObject)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "Frm_TaskDetails_SeriesActionBarClick", ExceptionObject, null, 
                        Localization.GetString("ALErrorResource",ALParamObj.TenantName,"ERR_MWB_Manage_CreateDiscussionTask_ExceptionwhilehandlingComponentListactionbarclick_Shared"));

                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, ExceptionObject.Message, null, null, ref EncryptURL);
                    Ajax.WriteExecuteJavaScript("window.open('" + EncryptURL + "','_self','');");
                }    
             }

            /// <summary>
            /// <CreatedOn>03 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To save the List</Purpose>
            /// </summary>
            private ERRORXML SaveComponentList_Task()
            {
                ERRORXML        ErrorXML                    = null; 
                String          strSelectedFormName         = null; 
                StringBuilder   sb_Del_ComponentFacetSeries = null; 
                XML             ResponseXML                 = null; 
                FormFacade      FormFacadeObj               = null;
                XmlDocument     doc_InputXML                = null;
                
                try
                {
                    FormFacadeObj = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    strSelectedFormName = ViewState["SelectedFormName"].ToString();
                    
                    FormFacadeObj.FormName = strSelectedFormName;
                    FormFacadeObj.SolutionName = SolutionName;

                    ObjInfoList = (List<ObjectInfo>)ViewState["ObjectList"];
                    ErrorXML = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", Frm_GatherInfo, ObjInfoList, out ResponseXML);
                    if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(ResponseXML)))
                    {
                        ErrorXML = UpdateDeliComponentFacetSeries(ref ResponseXML, "WORKFLOWPROCESS",Frm_GatherInfo.ConfigurationXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            //Delete the component file
                            sb_Del_ComponentFacetSeries = new StringBuilder(50);
                            sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                            if (File.Exists(sb_Del_ComponentFacetSeries.ToString()))
                            {
                                File.Delete(sb_Del_ComponentFacetSeries.ToString());
                            }

                            doc_InputXML = new XmlDocument();
                            doc_InputXML.LoadXml(ResponseXML);  
                            setFormXML(doc_InputXML,true); 
                        }
                    }
                    return ErrorXML; 
                }
                catch (ThreadAbortException)
                { return ErrorXML; }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>8 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To update the deliverable component facet seires</Purpose>
            /// </summary>
            /// <param name="SaveTaskXML"></param>
            /// <returns></returns>
            private ERRORXML UpdateDeliComponentFacetSeries(ref String SaveTaskXML, String str_RootNode, String str_FormConfigXML)
            {
                ERRORXML        ErrorXMLString              = null; 
                String          str_DeliverableProcessId    = null; 
                String          str_ComponentFacetRShipName = null;
                MWB_Component   MWB_ComponentObj            = null; 
                String          SelectedComponentXML        = null;
                String          str_ComponentFacetName      = null;
                String          str_PrimaryKey              = null;
                XPathDocument   xpathDoc_ComponentFormConfig= null;
                XPathNavigator  xpathNav_ComponentFacet     = null;
                Boolean         b_UpdateTaskActivity        = false;     
                try
                {
                    //Take out the Compoent Facet Series from the input xml and update the deliverable
                    //and return the InputXML by removing the Component Facet Series nodes.
                    if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        str_DeliverableProcessId    = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        
                        xpathDoc_ComponentFormConfig = new XPathDocument(new StringReader(str_FormConfigXML));
                        xpathNav_ComponentFacet = xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/RELATEDFACETS/FACET[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "' and @IsSeries='YES']");
                        if (xpathNav_ComponentFacet != null)
                        {
                            //Read the Sort order and sort column
                            str_ComponentFacetName  = xpathNav_ComponentFacet.GetAttribute("TYPENAME", "");
                            str_PrimaryKey          = xpathNav_ComponentFacet.GetAttribute("PRIMARYKEY", "");
                            if (xpathDoc_ComponentFormConfig.CreateNavigator().SelectSingleNode("Form/Section/Column/Field[@RELATIONSHIPNAME='" + str_ComponentFacetRShipName + "']/Configuration/ActionControlList/ActionControl[(translate(@Name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SELECTSERIESRECORD') and (translate(@Visible,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]") != null)
                            {
                                b_UpdateTaskActivity = true;
                            }
                        }
                        MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        ErrorXMLString = MWB_ComponentObj.SaveComponentFacetData(str_DeliverableProcessId, str_ComponentFacetRShipName, str_RootNode, ref SaveTaskXML, b_UpdateTaskActivity, str_ComponentFacetName, str_PrimaryKey, out SelectedComponentXML);
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <CreatedOn>28 November 2008</CreatedOn>
            /// <Purpose>To put the deliverable component facet series data in inputxml</Purpose>
            /// </summary>
            /// <param name="InputXMLDoc"></param>
            /// <param name="FormConfigXML"></param>
            private ERRORXML SetDeliverableComponentFacetSeries(ref XmlDocument InputXMLDoc, ref String FormConfigXML, XPathNavigator nav_Activity, String SearchXML)
            {
                String          str_DeliverableProcessId    = null; 
                String          str_ComponentFacetRShipName = null;
                String          str_ComponentFacetFieldName = null; 
                String          str_ActivityDefinitionID    = null; 
                String          str_InputXML                = null; 
                String          str_ComponentUserStatus     = null;
                String          str_ComponentSystemStatus   = null;
                MWB_Component   MWB_ComponentObj            = null;
                XPathNavigator  nav_ActivityDefinitionID    = null; 
                ERRORXML        ErrorXMLString              = null; 
                String          ErrorPageURL                = null;                 
                ulong           ErrorID                     = 0;
                String          str_ComponentAssetRShip     = null;
                String          str_PrimaryKey              = null;

                try
                {
                    MWB_ComponentObj    = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    nav_ActivityDefinitionID = nav_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                    if (nav_ActivityDefinitionID != null)
                    {
                        str_ActivityDefinitionID = nav_ActivityDefinitionID.Value;
                    }

                    if (!String.IsNullOrEmpty(FormConfigXML))
                    {
                        if (ViewState["ParentDeliverableID"] != null)
                        {
                            str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                            str_InputXML = InputXMLDoc.OuterXml;

                            //Check for the Deliverable details
                            if ((ViewState["ComponentFacetSeriesFor_"+str_ActivityDefinitionID+""] != null) && (ViewState["ComponentFacetSeriesFor_"+str_ActivityDefinitionID+""].ToString() != "No"))
                            {
                                str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                                ErrorXMLString = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "ACTIVITYCOLLECTION/ACTIVITY", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                                if (String.IsNullOrEmpty(ErrorXMLString))
                                {
                                    InputXMLDoc.LoadXml(str_InputXML);
                                }
                                else
                                {
                                    //Redirect to error page.
                                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackUrl(), ref ErrorPageURL);
                                    if (!IsPostBack)
                                    {
                                        Response.Redirect(ErrorPageURL, true);
                                    }
                                    else
                                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                }
                            }
                            else
                            {
                                if (ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] == null)
                                {
                                    ErrorXMLString = MWB_ComponentObj.GetComponentFacetForTaskActivity(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_ActivityDefinitionID, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, "ACTIVITYCOLLECTION/ACTIVITY", str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, SearchXML, out str_PrimaryKey, out str_ComponentAssetRShip);
                                    if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(str_ComponentFacetRShipName)) && (!String.IsNullOrEmpty(str_ComponentFacetFieldName)))
                                    {
                                        ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "Yes";
                                        if (ViewState["ComponentFacetSeriesRShipName"] == null)
                                        {
                                            ViewState["ComponentFacetSeriesRShipName"] = str_ComponentFacetRShipName;
                                        }
                                        if (ViewState["ComponentFacetFieldName"] == null)
                                        {
                                            ViewState["ComponentFacetFieldName"] = str_ComponentFacetFieldName;
                                        }
                                        if (ViewState["ComponentFacetPrimaryKey"] == null)
                                        {
                                            ViewState["ComponentFacetPrimaryKey"] = str_PrimaryKey;
                                        }
                                        if ((!String.IsNullOrEmpty(str_ComponentAssetRShip)) && (ViewState["ComponentAssetRShipName"] == null))
                                        {
                                            ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                        }
                                        InputXMLDoc.LoadXml(str_InputXML);
                                    }
                                    else if (!String.IsNullOrEmpty(ErrorXMLString))
                                    {
                                        //Redirect to error page.
                                        ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "STEP", ErrorXMLString, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED"), null, GetBackUrl(), ref ErrorPageURL);
                                        if (!IsPostBack)
                                        {
                                            Response.Redirect(ErrorPageURL, true);
                                        }
                                        else
                                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                                    }
                                    else if (String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                    {
                                        ViewState["ComponentFacetSeriesFor_" + str_ActivityDefinitionID + ""] = "No";
                                    }
                                }
                            }
                            
                            //Radha: For component facet series action bar.
                            if ((ViewState["ComponentUserStatus"] == null) && (!String.IsNullOrEmpty(str_ComponentUserStatus)))
                            {
                                ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                            }
                            
                        }
                    }
                    return ErrorXMLString;
                }
                catch(ThreadAbortException)
                { return ErrorXMLString; }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "SetDeliverableComponentFacetSeries", ExceptionObj, null, null);
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_STEP_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXMLString;
                }
            }

            /// <summary>
            /// <CreatedOn>08 December 2008</CreatedOn> 
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To check the status of the Deliverable component facet series and depending on that set the form mode</Purpose>
            /// </summary>
            /// <param name="Frm_ToChange">Form whose mode is to be set</param>
            private void CheckComponentFacetSeriesStatus(Form Frm_ToChange)
            {
                try
                {
                    if ((!String.IsNullOrEmpty(str_ComponentFacetStatus)) && (str_ComponentFacetStatus.ToUpper() == "READONLY"))
                    {
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                            Frm_ToChange.AddSeriesActionBar(ViewState["ComponentFacetFieldName"].ToString(), null);
                        }
                    }
                    else if ((ViewState["ComponentUserStatus"] != null) && (ViewState["ComponentUserStatus"].ToString().ToUpper().Equals("FINAL LOCK")))
                    {
                        if (ViewState["ComponentFacetFieldName"] != null)
                        {
                            Frm_ToChange.MarkSeriesFieldAsReadOnly(ViewState["ComponentFacetFieldName"].ToString());
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the Component facet for task</Purpose>
            /// </summary>
            /// <param name="TaskXMLDoc"></param>
            /// <param name="FormConfigXMLPath"></param>
            private ERRORXML GetComponentFacetForTask(ref XmlDocument TaskXMLDoc, ref String FormConfigXML, String SearchXML)
            {
                ERRORXML        ErrorXML                    = null; 
                String          str_ComponentFacetRShipName = null;
                String          str_DeliverableProcessId    = null;
                StringBuilder   sb_Del_ComponentFacetSeries = null;
                String          str_ComponentFacetFieldName = null; 
                Boolean         bool_GetDeliverable         = true; 
                MWB_Component   MWB_ComponentObj            = null;
                String          str_InputXML                = null; 
                String          str_ComponentUserStatus     = null;
                String          str_ComponentSystemStatus   = null;
                String          ErrorPageURL                = null;                 
                ulong           ErrorID                     = 0;
                String          str_PrimaryKey              = null;
                String          str_ComponentAssetRShip     = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    //Check for the facet series configured in the form by getting the Component Facet series facet and relationship name from the configuration
                    if ((ViewState["ComponentFacetSeriesFor_Task"] != null) && (ViewState["ComponentFacetSeriesFor_Task"].ToString() != "No"))
                    {
                        str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString(); 
                        bool_GetDeliverable = false; 
                    }

                    str_InputXML = TaskXMLDoc.OuterXml;
                    if (bool_GetDeliverable)
                    {
                        if (ViewState["ComponentFacetSeriesFor_Task"] == null)
                        {
                            //HemantK:Delete temp file for component facet series
                            sb_Del_ComponentFacetSeries = new StringBuilder(50);
                            sb_Del_ComponentFacetSeries.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID + str_ComponentFacetFileName);
                            if ((File.Exists(sb_Del_ComponentFacetSeries.ToString())) && (!IsPostBack))
                            {
                                File.Delete(sb_Del_ComponentFacetSeries.ToString());
                            }

                            if (ViewState["ParentDeliverableID"] != null)
                            {
                                str_DeliverableProcessId = ViewState["ParentDeliverableID"].ToString();
                            }

                            //Radha: For getting Component User status and System status.
                            ErrorXML = MWB_ComponentObj.GetComponentFacetForTask(TaskID, __PackageDefinitionID.Value, __ProcessDefinitionID.Value, str_DeliverableProcessId, ref str_InputXML, ref FormConfigXML, str_ComponentFacetFileName, out str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_PrimaryKey, out str_ComponentAssetRShip, SearchXML);
                            if ((String.IsNullOrEmpty(ErrorXML)))
                            {
                                if (!String.IsNullOrEmpty(str_ComponentFacetRShipName))
                                {
                                    //Put Component Facet relationship name and Component Facet name in view state
                                    ViewState["ComponentFacetSeriesFor_Task"]   = "Yes";
                                    ViewState["ComponentFacetSeriesRShipName"]  = str_ComponentFacetRShipName;
                                    ViewState["ComponentFacetFieldName"]        = str_ComponentFacetFieldName;
                                    ViewState["ComponentFacetPrimaryKey"]       = str_PrimaryKey;
                                    if (!String.IsNullOrEmpty(str_ComponentAssetRShip))
                                    {
                                        ViewState["ComponentAssetRShipName"] = str_ComponentAssetRShip;
                                    }
                                    TaskXMLDoc.LoadXml(str_InputXML);
                                }
                                else
                                {
                                    ViewState["ComponentFacetSeriesFor_Task"] = "No"; ;
                                }
                            }
                            else
                            {
                                //Redirect to error page.
                                ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackUrl(), ref ErrorPageURL);
                                if (!IsPostBack)
                                {
                                    Response.Redirect(ErrorPageURL, true);
                                }
                                else
                                    Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                            }
                        }
                    }
                    else
                    {
                        str_InputXML = TaskXMLDoc.OuterXml;
                        ErrorXML = MWB_ComponentObj.SetDeliverableDataInInputXML(ref str_InputXML, "WORKFLOWPROCESS", TaskID, str_DeliverableProcessId, str_ComponentFacetFileName, ref FormConfigXML, str_ComponentFacetRShipName, out str_ComponentFacetFieldName, out str_ComponentUserStatus, out str_ComponentSystemStatus, out str_ComponentAssetRShip, SearchXML);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            TaskXMLDoc.LoadXml(str_InputXML);
                        }
                        else
                        {
                            //Redirect to error page.
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED"), null, GetBackUrl(), ref ErrorPageURL);
                            if (!IsPostBack)
                            {
                                Response.Redirect(ErrorPageURL, true);
                            }
                            else
                                Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    //Radha: For setting component series action bar depends upon the component user status.
                    if ((!String.IsNullOrEmpty(str_ComponentUserStatus)))
                    {
                        ViewState["ComponentUserStatus"] = str_ComponentUserStatus;
                    }
                    
                    return ErrorXML; 
                }
                catch (ThreadAbortException)
                { return ErrorXML; }
                catch (Exception ExceptionObj)
                {
                    ErrorID = ALSolutionCommon.DumpExceptionInfo(this.Page, "Manage_CreateGatherInfoTask.aspx", "GetComponentFacetForTask", ExceptionObj, null, null);
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", null, Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_TASK_COMPONENTFACETGETFAILED_EXCEPTION"), null, GetBackUrl(), ref ErrorPageURL);
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                    return ErrorXML;
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To update the deliverable component facet</Purpose>
            /// </summary>
            /// <param name="SaveTaskXML"></param>
            /// <param name="str_ActionBarXML"></param>
            /// <returns></returns>
            private ERRORXML UpdateDeliverableComponentForTask(ref String SaveTaskXML, String str_ActionBarXML, Hashtable obj_SelectComponentIDs, String str_ComponentFacetName, String str_ComponentFacetPK)
            {
                ERRORXML      ErrorXMLString                = null; 
                MWB_Component MWB_ComponentObj              = null; 
                String        str_DeliverableProcessId      = null; 
                String        str_ComponentFacetRShipName   = null;                

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if ((ViewState["ParentDeliverableID"] != null) && (ViewState["ComponentFacetSeriesRShipName"] != null))
                    {
                        str_DeliverableProcessId    = ViewState["ParentDeliverableID"].ToString();
                        str_ComponentFacetRShipName = ViewState["ComponentFacetSeriesRShipName"].ToString();
                        ErrorXMLString = MWB_ComponentObj.RemoveAndUpdateComponentFacet(str_DeliverableProcessId, str_ComponentFacetRShipName, "WORKFLOWPROCESS", ref SaveTaskXML, str_ActionBarXML, obj_SelectComponentIDs, str_ComponentFacetName, str_ComponentFacetPK,str_SelectedComponentsIDFileName);
                    }
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                    {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>09 December 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the Form Action bar</Purpose>
            /// </summary>
            /// <param name="ResponseForm"></param>
            /// <returns></returns>
            private String GetFormActionBarXML(Form TempForm)
            {
                String          str_ComponentFacetFieldName = null; 
     
                try
                {
                    if (ViewState["ComponentFacetFieldName"] != null)
                    {
                        str_ComponentFacetFieldName = ViewState["ComponentFacetFieldName"].ToString();

                        return TempForm.GetSeriesActionBar(str_ComponentFacetFieldName); 
                    }
                    else
                    {
                        return null; 
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>4 Feb 09</CreatedOn>
            /// <Author>Mugdha Moolay</Author>
            /// <Purpose>This method clears the drop down list if a resource type is deleted using the Remove Button. 
            ///  This function also updates the State XML used by the Select Resource Type pop-up</Purpose>
            /// </alsummary>
            /// <param name="ActivityID">The StepID for which resource is selected</param>
            /// <param name="str_FormID">The Dynamic Form ID</param>
            private void UpdateContributorDropDownList(String ActivityID,String str_FormID)
            {
                XML         ItemList            = null;
                MWB_Helper  obj_MWBHelper       = null;
                //String      str_TempFilePath    = null; 
                //XmlDocument ResourceDoc         = null;
                //XmlNode     ActivityNode        = null;
                //XmlNode     ResNode             = null;
                try
                {
                    ItemList = "<Item Selected='Yes' DisplayTextID='MWB_Manage_AssignContributor_SelectContributor_Shared'><DisplayValue>Select Contributor</DisplayValue><Value>None</Value></Item>";
                    setStepFormInputXMLForGroup(ActivityID, str_FormID, ItemList);
                    obj_MWBHelper = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    // Update the Resource File Name for the Activity
                    obj_MWBHelper.UpdateStateXMLForResourceType(StepResourceFileName, ActivityID);
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>03 April 2009</CreatedOn>
            /// <Purpose>To download digital assets.</Purpose>
            /// </summary>
            private void getDigitalAssetsFromFacetIDs(String str_DownloadFor, String str_ActivityID)
            {
                String          selectedFacetIDs    = null;
                MWB_Component   objComponentFacade  = null;
                String          SearchOutputXML     = null;
                String          ErrorXML            = null;
                String          ErrorPageURL        = null;
                String          str_BatchDownloadAssetsFile  = null;
                String          str_ComponentSearchForm      = null;
                String          str_AlertMessage             = null;
                String          str_BatchDownloadURL         = null;

                try
                {
                    objComponentFacade      = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                       
                    if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "TASK"))
                    {
                        selectedFacetIDs            = Frm_GatherInfo.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                        str_BatchDownloadAssetsFile = TaskID + "_BatchDownloadAssetsXml";
                    }
                    else if ((!String.IsNullOrEmpty(str_DownloadFor)) && (str_DownloadFor.ToUpper() == "STEP"))
                    {
                        selectedFacetIDs            = TempStepForm.GetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString());
                        str_BatchDownloadAssetsFile = str_ActivityID + "_BatchDownloadAssetsXml";
                    }

                    if (!String.IsNullOrEmpty(selectedFacetIDs))
                    {
                        if ((ViewState["ComponentFacetPrimaryKey"] != null) && (ViewState["ComponentAssetRShipName"] != null) && (ViewState["ParentDeliverableID"] != null))
                        {
                            objComponentFacade.SolutionName = SolutionName;
                            ErrorXML  = objComponentFacade.GetComponentSearchFormName(ViewState["ParentDeliverableID"].ToString(), out str_ComponentSearchForm);

                            if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(str_ComponentSearchForm)))
                            {
                                ErrorXML = objComponentFacade.GetBatchDownloadDetails(selectedFacetIDs, ViewState["ComponentFacetPrimaryKey"].ToString(), ViewState["ComponentAssetRShipName"].ToString(), ref SearchOutputXML, str_ComponentSearchForm, str_BatchDownloadAssetsFile, out str_AlertMessage, out str_BatchDownloadURL);
                                if (String.IsNullOrEmpty(ErrorXML))
                                {
                                    if (!String.IsNullOrEmpty(str_AlertMessage))
                                        Ajax.WriteExecuteJavaScript("ShowAlert('" + str_AlertMessage + "');");
                                    else if (!String.IsNullOrEmpty(str_BatchDownloadURL))
                                        Ajax.WriteExecuteJavaScript("window.open('" + str_BatchDownloadURL + "','_new','left=120,top=120,width=1085,height=800,resizable=yes,scrollbars=yes');");
                                }
                            }
                        }
                        else
                        {
                            ErrorXML     = "<ERROR><MESSAGE>" + Localization.GetString("ALErrorResource", ALParamObj.TenantName, "ERR_MWB_BatchUploadDigitalAssets_COMPOENTDIGITALASSETRELATIONNOTFOUND") + "</MESSAGE></ERROR>";
                        }
                        if (!String.IsNullOrEmpty(ErrorXML))// Redirect to Error
                        {
                            ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "DELIVERABLE", null, ErrorXML, null, GetBackUrl(), ref ErrorPageURL);
                            Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                        }
                    }
                    if (str_DownloadFor.ToUpper() == "TASK")
                    {
                        Frm_GatherInfo.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }
                    else if (str_DownloadFor.ToUpper() == "STEP")
                    {
                        TempStepForm.SetSelectedRecordIDs(ViewState["ComponentFacetFieldName"].ToString(), null);
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>14 April 2009</CreatedOn>
            /// <Purpose>To get the edit page url </Purpose>
            /// </summary>
            /// <param name="str_Source">It indicates Task Or Activity</param>
            /// <param name="str_ActivityID">Activity id</param>
            private void GetEditPageUrl(String str_Source, String str_ActivityID)
            {
                MWB_Component       MWB_ComponentObj        = null;
                String              ErrorXML                = null;
                String              str_AlertMsg            = null;
                StringBuilder       sb_Parameters           = null;
                String              EditPageUrl             = null;
                String              str_SelectedFormName    = null;                
                XPathDocument       xp_TaskDoc              = null;
                String              TempPath                = null;
                XPathNavigator      nav_ActivityInfoNode    = null;
                String              str_ActivityDefID       = null;
                String              str_FormName            = null;
                String              str_FormConfigXMLPath   = null;
                MWB_Helper          MWB_HelperObj           = null;

                try
                {
                    MWB_ComponentObj = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_HelperObj    = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    sb_Parameters    = new StringBuilder(400);
                    if ((ViewState["ComponentFacetFieldName"] != null) && (ViewState["ParentDeliverableID"] != null))
                    {
                        if (str_Source.ToUpper() == "TASK")
                        {
                            EditPageUrl          = Frm_GatherInfo.GetSeriesEditRecordsUrl(ViewState["ComponentFacetFieldName"].ToString());
                            str_SelectedFormName = ViewState["SelectedFormName"].ToString();
                        }
                        else if (str_Source.ToUpper() == "ACTIVITY")
                        {
                            EditPageUrl             = TempStepForm.GetSeriesEditRecordsUrl(ViewState["ComponentFacetFieldName"].ToString());
                            TempPath                = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskFile;
                            xp_TaskDoc              = new XPathDocument(TempPath);
                            nav_ActivityInfoNode    = xp_TaskDoc.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID='" + str_ActivityID + "']/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYDEFINITIONID");
                            if (nav_ActivityInfoNode != null)
                            {
                                str_ActivityDefID     = nav_ActivityInfoNode.Value;
                                str_FormName          = str_ActivityDefID + "_Editable";
                                str_FormConfigXMLPath = MWB_HelperObj.GetFormConfigXMLPath("StepDetails_Editable", str_FormName, out str_SelectedFormName);
                            }
                        }
                        sb_Parameters.Append("&DeliverableID="      + ViewState["ParentDeliverableID"].ToString()
                                               + "&TaskID="         + TaskID
                                               + "&ActivityID="     + str_ActivityID
                                               + "&CFRelionship="   + ViewState["ComponentFacetSeriesRShipName"].ToString()
                                               + "&FormName="       + str_SelectedFormName
                                               + "&ComponentFacetSeriesPrimaryKey=" + ViewState["ComponentFacetPrimaryKey"].ToString()
                                               + "&Source="         + str_Source);

                        if (ViewState["ComponentAssetRShipName"] != null)
                        {
                            sb_Parameters.Append("&ComponentDigitalAssetRelationship=" + ViewState["ComponentAssetRShipName"].ToString());
                        }

                        ErrorXML = MWB_ComponentObj.GetComponentSystemStatus(ViewState["ParentDeliverableID"].ToString(), ref EditPageUrl, sb_Parameters.ToString(), out str_AlertMsg);
                        if (String.IsNullOrEmpty(ErrorXML))
                        {
                            if (!String.IsNullOrEmpty(str_AlertMsg))
                            {
                                Ajax.WriteExecuteJavaScript("alert('" + str_AlertMsg + "');");
                            }
                            else if (!String.IsNullOrEmpty(EditPageUrl))
                            {
                                Ajax.WriteExecuteJavaScript(EditPageUrl);
                            }
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <summary>
            /// <createddate>21 May 2009</createddate>
            /// <author>Jisha Rajendran</author>
            /// </summary>
            /// <param name="UsersNode">UserCollection Xml</param>
            /// <param name="GroupNode">Group Collection XML</param>
            /// <param name="OperationFlag">Create , Update or Delete</param>
            /// <Purpose>This method prepares the User/group data xml and populates in the User/group list</Purpose>
            private ERRORXML populateUserGroupList(XML UserDataXML, XML GroupDataXML, String OperationFlag)
            {
                MWB_Helper                  MWB_HelperObj           = null;
                StringBuilder               sb_TempXml              = null;
                XML                         xml_List                = null;
                ListFacade                  facade_ListControl      = null;
                XML                         xml_ListConfig          = null;                
                String                      str_CommonPath          = null;
                XPathDocument               xp_UserGroupColl        = null;
                XPathExpression             xpExp_UserGroup         = null;
                StringBuilder               sb_UserGroupColl        = null;
                XPathNodeIterator           nodeIter_RootNode       = null;
                XML                         xml_ExistingUserGroup   = null;
                MktgWorkBenchFacadeClass    facade_MktgWorkBench    = null;
                XML                         xml_Error               = null;
                String                      str_ExistingID          = null;
                String                      str_UserIDList          = null;
                String                      str_GroupIDList         = null;

                MWB_HelperObj   = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                str_CommonPath  = ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + TaskID;  

                if (File.Exists(str_CommonPath + SelectedUserGroupsFileName))
                    xml_ExistingUserGroup = File.ReadAllText(str_CommonPath + SelectedUserGroupsFileName);

                switch (OperationFlag.ToUpper())
                {
                    case "CREATE":
                        //Prepare the User list xml and save to temp file
                        sb_TempXml      = new StringBuilder(100);
                        sb_TempXml.Append("<UserSelectionXML><SelectedUsersList>" + UserDataXML + "</SelectedUsersList></UserSelectionXML>");                    
                        if (!String.IsNullOrEmpty(UserDataXML))
                            MWB_HelperObj.AddUsersToUserGroupsListXML(sb_TempXml.ToString(), ref xml_ExistingUserGroup);

                        File.WriteAllText(str_CommonPath + SelectedUsersFileName, sb_TempXml.ToString());//Path to save the selected user list

                        //Prepare the Group list xml and save this file
                        sb_TempXml      = sb_TempXml.Remove(0, sb_TempXml.Length);
                        sb_TempXml.Append("<GroupSelectionXML><SelectedGroupsList>" + GroupDataXML + "</SelectedGroupsList></GroupSelectionXML>");
                        if (!String.IsNullOrEmpty(GroupDataXML))
                            MWB_HelperObj.AddGroupsToUserGroupsListXML(sb_TempXml.ToString(), ref xml_ExistingUserGroup);

                        File.WriteAllText(str_CommonPath + SelectedGroupsFileName, sb_TempXml.ToString());//Path to save the selected group list
                        break;

                    case "UPDATE":
                        facade_MktgWorkBench = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        if (!String.IsNullOrEmpty(UserDataXML))
                        {
                            str_ExistingID  = ProcessCompletionUsers;
                            xml_Error       = facade_MktgWorkBench.AssociateUserGroupWithProcess(TaskID, UserDataXML, "PROCESSCOMPLETION_USER", ref str_ExistingID);
                            if (!String.IsNullOrEmpty(xml_Error))
                                return xml_Error;
                            ProcessCompletionUsers = str_ExistingID;
                            MWB_HelperObj.AddUsersToUserGroupsListXML(UserDataXML, ref xml_ExistingUserGroup);
                        }
                        if (!String.IsNullOrEmpty(GroupDataXML))
                        {
                            str_ExistingID  = ProcessCompletionGroups;
                            xml_Error       = facade_MktgWorkBench.AssociateUserGroupWithProcess(TaskID, GroupDataXML, "PROCESSCOMPLETION_GROUP", ref str_ExistingID);
                            if (!String.IsNullOrEmpty(xml_Error))
                                return xml_Error;
                            ProcessCompletionGroups = str_ExistingID;
                            MWB_HelperObj.AddGroupsToUserGroupsListXML(GroupDataXML, ref xml_ExistingUserGroup);
                        }
                        break;

                    case "DELETE":

                        facade_MktgWorkBench    = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                        str_UserIDList          = ProcessCompletionUsers;
                        str_GroupIDList         = ProcessCompletionGroups;
                        xml_Error               = facade_MktgWorkBench.DeleteProcessCompletionUserGroup(TaskID, Request["__EVENTARGUMENT"], ref str_UserIDList, ref str_GroupIDList);
                        if (!String.IsNullOrEmpty(xml_Error))
                            return xml_Error;
                        ProcessCompletionUsers  = str_UserIDList;
                        ProcessCompletionGroups = str_GroupIDList;

                        //Update the List
                        if (File.Exists(str_CommonPath + SelectedUsersFileName))
                            UserDataXML     = File.ReadAllText(str_CommonPath + SelectedUsersFileName);
                        if (File.Exists(str_CommonPath + SelectedGroupsFileName))
                            GroupDataXML    = File.ReadAllText(str_CommonPath + SelectedGroupsFileName);

                        MWB_HelperObj.RemoveSelectedUserGroups(Request["__EVENTARGUMENT"], ref xml_ExistingUserGroup, ref UserDataXML, ref GroupDataXML);

                        File.WriteAllText(str_CommonPath + SelectedUsersFileName, UserDataXML);
                        File.WriteAllText(str_CommonPath + SelectedGroupsFileName, GroupDataXML);
                        
                        break;
                }             
                //Save the User Group Data collection on NTFS
                File.WriteAllText(str_CommonPath + SelectedUserGroupsFileName, xml_ExistingUserGroup);

                //Display the list
                sb_UserGroupColl = new StringBuilder(200);
                sb_UserGroupColl.Append(@"<SEARCHOUTPUTXML><USERGROUPCOLLECTION>");
                if (!String.IsNullOrEmpty(xml_ExistingUserGroup))
                {
                    xp_UserGroupColl    = new XPathDocument(new StringReader(xml_ExistingUserGroup));
                    xpExp_UserGroup     = XPathExpression.Compile("USERGROUPCOLLECTION/USERGROUP");
                    xpExp_UserGroup.AddSort("USER_GROUP", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text); 
                    xpExp_UserGroup.AddSort("USER_GROUP_NAME", System.Xml.XPath.XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);               
                    nodeIter_RootNode   = xp_UserGroupColl.CreateNavigator().Select(xpExp_UserGroup);
                    foreach (XPathNavigator xpnav_UserGroup in nodeIter_RootNode)
                    {
                         sb_UserGroupColl.Append(xpnav_UserGroup.OuterXml);
                    }
                }
                sb_UserGroupColl.Append(@"</USERGROUPCOLLECTION></SEARCHOUTPUTXML>");

                facade_ListControl  = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                xml_ListConfig      = facade_ListControl.GetConfigurationXML(SolutionName, null, "UserGroupsForNotifications");
                facade_ListControl.PrepareListXml(xml_ListConfig, sb_UserGroupColl.ToString(), out xml_List);
                Lst_UserGroup.Source = xml_List;
                return null;
            }

            /// <summary>
            /// <createddate>21 May 2009</createddate>
            /// <author>Jisha Rajendran</author>
            /// </summary>
            /// <param name="UserNode"></param>
            /// <param name="UserGroup"></param>
            /// <Purpose>This method will set the ProcessCompletion users and groups id's in the viewstate</Purpose>
            private void setAssociatedProcessCompletionUserGroups(XmlNode UserNode, XmlNode UserGroup)
            {
                XmlNodeList     xmlnodelist_Temp    = null;
                StringBuilder   sb_IDList           = null;

                if (UserNode != null)
                {
                    sb_IDList = new StringBuilder(100);
                    xmlnodelist_Temp = UserNode.SelectNodes("USER/USERID");
                    foreach (XmlNode xmlnode_UserID in xmlnodelist_Temp)
                    {
                        sb_IDList.Append(xmlnode_UserID.InnerText + ",");
                    }
                    ProcessCompletionUsers = sb_IDList.ToString();
                }

                if (UserGroup != null)
                {
                    sb_IDList = new StringBuilder(100);
                    xmlnodelist_Temp = UserGroup.SelectNodes("GROUP/GROUPID");
                    foreach (XmlNode xmlnode_GroupID in xmlnodelist_Temp)
                    {
                        sb_IDList.Append(xmlnode_GroupID.InnerText + ",");
                    }
                    ProcessCompletionGroups = sb_IDList.ToString();
                }
            }

            /// <summary>
            /// <Author>Radha A</Author>
            /// <CreatedOn>17th June 2009</CreatedOn>
            /// <Purpose>To save the step form details whenever contributor gets changed</Purpose>
            /// </summary>
            /// <param name="StepID">The StepID for which data gets saved.</param>
            /// <param name="TempStepForm">Step Form</param>
            private ERRORXML SaveStepForm(String StepID, Form TempStepForm)
            {
                FormFacade                  FormFacadeObj           = null;
                String                      StepXML                 = null;
                String                      ErrorXML                = null;
                MWB_Component               MWB_ComponentObj        = null;
                String                      str_SelectedFormName    = null;
                String                      str_FormConfigXML       = null;
                String                      str_FormActionBarXML    = null;
                String                      str_ComponentRShip      = null;
                Boolean                     b_ShowResponse          = false;
                String                      str_ActivityAssociatedFacets    = null;
                try
                {
                    FormFacadeObj           = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MWB_ComponentObj        = new MWB_Component(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    if (ViewState["PrevWorkflow"].ToString().ToUpper() == "TRUE")
                        b_ShowResponse = true;

                    MWB_ComponentObj.GetSelectedFormNameAndConfigForStep(StepID, TaskFile, b_ShowResponse, out str_SelectedFormName, out str_FormConfigXML);

                    if ((!String.IsNullOrEmpty(str_SelectedFormName)) && (TempStepForm != null))
                    {
                        FormFacadeObj.FormName      = str_SelectedFormName;
                        FormFacadeObj.SolutionName  = SolutionName;
                        FormFacadeObj.ConfigurationXMLType = "InnerXML";
                        FormFacadeObj.ConfigurationXML = str_FormConfigXML;
                        StepObjInfoList             = (List<ObjectInfo>)ViewState["StepObjectList" + StepID];

                        ErrorXML                    = FormFacadeObj.GetFormDataXML("Edit", "DATAFIELD", TempStepForm, StepObjInfoList, out StepXML);
                        if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(StepXML)))
                        {
                            if (ViewState["ComponentFacetSeriesRShipName"] != null)
                            {
                                str_ComponentRShip = ViewState["ComponentFacetSeriesRShipName"].ToString();
                                str_FormActionBarXML = GetFormActionBarXML(TempStepForm);
                            }
                            if (ViewState["ActivityAssociatedFacets"] != null)
                            {
                                str_ActivityAssociatedFacets = ViewState["ActivityAssociatedFacets"].ToString();
                            }
                            ErrorXML = MWB_ComponentObj.RemoveAndUpdateComponentFacetForStepForm(StepID, ViewState["ParentDeliverableID"].ToString(), str_ComponentRShip, StepObjInfoList, str_FormActionBarXML,str_FormConfigXML, str_SelectedComponentsIDFileName, str_ActivityAssociatedFacets, ref StepXML);
                            if ((String.IsNullOrEmpty(ErrorXML)) && (!String.IsNullOrEmpty(StepXML)))
                            {
                                CreateNewStepForm_ComponentList(StepID, StepXML, str_FormConfigXML, str_SelectedFormName, true);
                            }
                        }
                    }
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }
        
            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the Gather Info Task Details</Purpose>
            /// </alsummary>
            /// <param name="str_ReturnTaskXML"></param>
            /// <param name="str_ActivityAssociatedFacets"></param>
            /// <returns></returns>
            private ERRORXML GetGatherInfoTask(out String str_ReturnTaskXML, out List<String> ActDefList, out Boolean IsPreviousWorkFlowPresent)
            {
                StringBuilder       sb_SearchInputXML           = null;
                MWB_Helper          MWB_HelperObj               = null;
                ERRORXML            ErrorXMLString              = null;
                String              str_ProcessAssociatedFacets = null;
                SearchConfiguration SearchConfigObj             = null; 
                String              stdFormName                 = null;
                String              dynamicFormName             = null;
                String              str_SelectedFormName        = null;
                FormFacade          FormFacadeObj               = null;
                String              FormConfigXMLPath           = null;
                String              RelEntityList               = null;
                
                try
                {
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTask):- Start GetGatherInfoTask() function.");

                    IsPreviousWorkFlowPresent    = false;
                    str_ReturnTaskXML            = null;
                    //str_ActivityAssociatedFacets = null; 
                    ActDefList          = new List<string>();
                    sb_SearchInputXML   = new StringBuilder(250);
                    MWB_HelperObj       = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language); 
                    FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);

                    stdFormName = "Task_Details";
                    if ((!String.IsNullOrEmpty(__PackageDefinitionID.Value)) && (!String.IsNullOrEmpty(__ProcessDefinitionID.Value)))
                    {
                        //ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTask):- Before GetAssociatedAdditionalFacets() function.");
                        //ErrorXMLString = MWB_HelperObj.GetAssociatedAdditionalFacets(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, null, true, out str_ProcessAssociatedFacets, out str_ActivityAssociatedFacets);
                        //ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTask):- After GetAssociatedAdditionalFacets() function.");
                        ErrorXMLString = MWB_HelperObj.GetActivityDefintionIDList(__PackageDefinitionID.Value, __ProcessDefinitionID.Value, out ActDefList);

                        if (!String.IsNullOrEmpty(ErrorXMLString))
                        {
                            return ErrorXMLString;
                        }
                        
                        dynamicFormName = __ProcessDefinitionID.Value + "_" + stdFormName;
                        FormFacadeObj.SolutionName = SolutionName;

                        FormConfigXMLPath       = MWB_HelperObj.GetFormConfigXMLPath(stdFormName, dynamicFormName, out str_SelectedFormName);
                        FormFacadeObj.FormName  = str_SelectedFormName;
                        FormFacadeObj.ConfigurationXML = FormConfigXMLPath;
                        ErrorXMLString = FormFacadeObj.GetRelatedObjectList(out str_ProcessAssociatedFacets, out RelEntityList);
                        if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                        {
                            String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                            for (int Index = 0; Index < Arr_Facets.Length; Index++)
                            {
                                ViewState["ProcessAssociatedFacets"] += "<" + Arr_Facets[Index] + " Type='RELATION' GetAllFacets='FALSE'/>";
                            }
                        //    ViewState["ProcessAssociatedFacets"] = str_ProcessAssociatedFacets;
                        //    MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ProcessAssociatedFacets);
                        }

                        //if (!String.IsNullOrEmpty(str_ActivityAssociatedFacets))
                        //{
                        //    str_ActivityAssociatedFacets = str_ActivityAssociatedFacets.Replace("<ACTIVITY_WEBSERVICE Type='RELATION' />", "");
                        //    ViewState["ActivityAssociatedFacets"] = str_ActivityAssociatedFacets;
                        //    MWB_HelperObj.ConvertRelatedFacetsToGetHierarchialData(ref str_ActivityAssociatedFacets);
                        //}
                    }

                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                                        if (String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                                        {
                                            sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                                        }
                                        else
                                        {
                                            sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                                        }
                                 sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>			                                                
	                                                        </FILTERLIST>
                                                            <RELATIONSHIP NAME='PROCESS_ASSETREFERENCES'>
                                                                <SELECTLIST>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>DIGITALASSETID</FIELDNAME>
				                                                        </EXPRESSION>
			                                                        </SELECTLIST>
                                                             </RELATIONSHIP>
                                                            <RELATIONSHIP NAME='PREVIOUS_WORKFLOW'>
                                                                    <SELECTLIST>
				                                                        <EXPRESSION>
					                                                        <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
					                                                        <ALIAS>WORKFLOWPROCESSID</ALIAS>
				                                                        </EXPRESSION>
			                                                        </SELECTLIST>
                                                                </RELATIONSHIP>
                                                             <RELATIONSHIP NAME='TASKINITIATOR'>
                                                                <SELECTLIST>
				                                                    <EXPRESSION>
					                                                    <FIELDNAME>USERID</FIELDNAME>
                                                                        <ALIAS>USERID</ALIAS>
				                                                    </EXPRESSION>
			                                                    </SELECTLIST>
                                                            </RELATIONSHIP>");
                    if (!String.IsNullOrEmpty(str_ProcessAssociatedFacets))
                    {
                        //sb_SearchInputXML.Append(str_ProcessAssociatedFacets);
                        String[] Arr_Facets = str_ProcessAssociatedFacets.Split(';');
                        for (int Index = 0; Index < Arr_Facets.Length; Index++)
                        {
                            sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                        }
                    }

                    sb_SearchInputXML.Append(@"</TARGETENTITY>
                                            </SEARCH>");

                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTask):- Before GetHierarchialData() function.");
                    ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskXML);
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTask):- After GetHierarchialData() function.");

                    if (str_ReturnTaskXML.Contains("PREVIOUS_WORKFLOW"))
                    {
                        ViewState["PrevWorkflow"] = "TRUE";
                        IsPreviousWorkFlowPresent = true;
                    }
                    else
                    {
                        ViewState["PrevWorkflow"] = "FALSE";
                        IsPreviousWorkFlowPresent = false;
                    }

                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTask):- End GetGatherInfoTask() function.");
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the Gather Info Task Activities Details</Purpose>
            /// </alsummary>
            /// <param name="str_ActivityAssociatedFacets"></param> 
            /// <param name="str_ReturnTaskActivitesXML"></param> 
            /// <returns></returns>
            private ERRORXML GetGatherInfoTaskActivities(List<String> ActDefList, out String str_ReturnTaskActivitesXML)
            {
                StringBuilder       sb_SearchInputXML           = null;
                ERRORXML            ErrorXMLString              = null;
                SearchConfiguration SearchConfigObj             = null; 
                MWB_Helper          MwbHelperObj                = null;
                String              str_ActFacets               = null;
                PMFacadeClass       PMFacadeObj                 = null;
                XML                 ProcessDefXML               = null;
                XDocument           xDocProcessDef              = null;
                try
                {
                    str_ReturnTaskActivitesXML  = null; 
                    sb_SearchInputXML   = new StringBuilder(250);
                    SearchConfigObj     = new SearchConfiguration(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    MwbHelperObj        = new MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    PMFacadeObj         = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    ErrorXMLString = PMFacadeObj.GetProcessDefinitionByID(PackageDefinitionID, ProcessDefinitionID, out ProcessDefXML);

                    if (ErrorXMLString != null)
                        return ErrorXMLString;

                    xDocProcessDef = XDocument.Parse(ProcessDefXML);

                    XElement xEleProcessDef = xDocProcessDef.Element("WORKFLOWPROCESS");

                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                                        <SESSIONINFO SessionID='" + ALParamObj.SessionID + "' UserID='" + ALParamObj.UserID + "' TenantName='" + ALParamObj.TenantName + "' Language='" + ALParamObj.Language + @"'/>
                                                        <TARGETOBJECT>ACTIVITY</TARGETOBJECT>
                                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                        <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>");
                                if (ActDefList == null)
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>True</SEARCHALLFACETS>");
                                }
                                else
                                {
                                    sb_SearchInputXML.Append("<SEARCHALLFACETS>False</SEARCHALLFACETS>");
                                }
                                 sb_SearchInputXML.Append(@"<TARGETENTITY>
	                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                                        <FILTERLIST>
		                                                        <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>" + TaskID + @"</EXPRESSIONVALUE>
                                                                    <RELATIONSHIPNAME>PROCESS_ACTIVITY</RELATIONSHIPNAME>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>			                                                
	                                                        </FILTERLIST>                                            
                                                            <RELATIONSHIP NAME='ACTIVITY_RESOURCE'>   
                                                                <SELECTLIST>
	                                                                <EXPRESSION>
		                                                                <FIELDNAME>RESOURCEID</FIELDNAME>
		                                                                <ALIAS>RESOURCEID</ALIAS>
	                                                                </EXPRESSION>
                                                                    <EXPRESSION>
		                                                                <FIELDNAME>RESOURCETYPE</FIELDNAME>
		                                                                <ALIAS>RESOURCETYPE</ALIAS>
	                                                                </EXPRESSION>     
                                                                </SELECTLIST>                                                               
                                                                <RELATIONSHIP NAME='ACTUAL_RESOURCE'>
                                                                    <SELECTLIST>
	                                                                    <EXPRESSION>
		                                                                    <FIELDNAME>RESOURCEID</FIELDNAME>
		                                                                    <ALIAS>RESOURCEID</ALIAS>
	                                                                    </EXPRESSION>
                                                                        <EXPRESSION>
		                                                                    <FIELDNAME>RESOURCETYPE</FIELDNAME>
		                                                                    <ALIAS>RESOURCETYPE</ALIAS>
	                                                                    </EXPRESSION>     
                                                                    </SELECTLIST>                                                                    
                                                                    <RELATIONSHIP NAME='RESOURCE_USER'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                    </RELATIONSHIP>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>");
                    if (ActDefList != null)
                    {
                        //sb_SearchInputXML.Append(str_ActivityAssociatedFacets);   
                        foreach (String ActDefID in ActDefList)
                        {
                            FormFacade FormFacadeObj       = new FormFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                            String     str_StdFormName     = null;
                            String     str_DynamicFormName = null;
                            String     SelectedFormName    = null;
                            String     relatedEntityList   = null;
                            String     ActRelatedFacets    = null;
                            FormFacadeObj.SolutionName     = SolutionName;
                            str_StdFormName = "StepDetails_Editable";

                            str_DynamicFormName             = ActDefID + "_Editable";
                            String FormConfigXMLPath        = MwbHelperObj.GetFormConfigXMLPath(str_StdFormName, str_DynamicFormName, out SelectedFormName);
                            FormFacadeObj.ConfigurationXML  = FormConfigXMLPath;
                            FormFacadeObj.FormName          = SelectedFormName;
                            ERRORXML ErrorXml               = FormFacadeObj.GetRelatedObjectList(out ActRelatedFacets,out relatedEntityList);
                            ActRelatedFacets                = MwbHelperObj.GetActivityAssociatedFacets(xEleProcessDef, ActDefID, ActRelatedFacets);
                            String[] Arr_Facets             = ActRelatedFacets.Split(';');
                            for (int Index = 0; Index < Arr_Facets.Length; Index++)
                            {
                                if (!sb_SearchInputXML.ToString().Contains(Arr_Facets[Index]))
                                {
                                    sb_SearchInputXML.Append("<RELATIONSHIP NAME='" + Arr_Facets[Index] + "'/>");
                                     str_ActFacets+= "<" + Arr_Facets[Index] + " Type='RELATION' />";
                                }
                            }
                        }
                        ViewState["ActivityAssociatedFacets"] = str_ActFacets;
                    }

                    if (ViewState["PrevWorkflow"].ToString().ToUpper() == "TRUE")
                    {
                        sb_SearchInputXML.Append(@"<RELATIONSHIP NAME='ACTIVITY_RESPONSE'>
                                                                <RELATIONSHIP NAME='POSTEDBY'>
                                                                        <SELECTLIST>
			                                                                <EXPRESSION>
				                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
				                                                                <ALIAS>LOGINNAME</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
				                                                                <ALIAS>FIRSTNAME</ALIAS>
			                                                                </EXPRESSION>     
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
				                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
			                                                                </EXPRESSION>
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>LASTNAME</FIELDNAME>
				                                                                <ALIAS>LASTNAME</ALIAS>
			                                                                </EXPRESSION> 
                                                                            <EXPRESSION>
				                                                                <FIELDNAME>EMAILID</FIELDNAME>
				                                                                <ALIAS>EMAILID</ALIAS>
			                                                                </EXPRESSION>                                                                    
		                                                                </SELECTLIST>
                                                                </RELATIONSHIP>
                                                            </RELATIONSHIP>");
                    }

                    sb_SearchInputXML.Append(@"</TARGETENTITY>
                                            </SEARCH>");

                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTaskActivities):- Before GetHierarchialData() function.");
                    ErrorXMLString = SearchConfigObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_ReturnTaskActivitesXML);
                    ALCommon.WriteLog(ALParamObj.TenantName, SolutionName, "Edit_GatherInfoDetails", ALParamObj.SessionID, "Workbech Page (GetGatherInfoTaskActivities):- After GetHierarchialData() function.");
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>29 June 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the merge Assignment Task and Task Activities</Purpose>
            /// </alsummary>
            /// <param name="ReturnTaskXML"></param> 
            /// <param name="str_ActivitiesXML"></param> 
            /// <param name="str_TaskXML"></param> 
            /// <returns></returns>
            private void MergeTaskActivities(String str_TaskXML, String str_ActivitiesXML, out String ReturnTaskXML)
            {
                if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION>"))
                {
                    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION>", "");
                }
                else if (str_TaskXML.Contains("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                {
                    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESSCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "");
                    str_TaskXML = str_TaskXML.Replace("<WORKFLOWPROCESS>", "<WORKFLOWPROCESS xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");
                }
                str_TaskXML = str_TaskXML.Replace("</WORKFLOWPROCESS></WORKFLOWPROCESSCOLLECTION>", "");

                if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION>"))
                {
                    str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION>", "<PROCESS_ACTIVITY>");
                }
                else if (str_ActivitiesXML.Contains("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"))
                {
                    str_ActivitiesXML = str_ActivitiesXML.Replace("<ACTIVITYCOLLECTION xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">", "<PROCESS_ACTIVITY>");
                }
                str_ActivitiesXML = str_ActivitiesXML.Replace("</ACTIVITYCOLLECTION>", "</PROCESS_ACTIVITY>");

                str_TaskXML = str_TaskXML + str_ActivitiesXML + "</WORKFLOWPROCESS>";

                ReturnTaskXML = str_TaskXML;
            }

            /// <summary>
            /// <CreatedOn>30 Oct 09</CreatedOn>
            /// <Author>Mugdha Moolay Gadre</Author>
            /// <Purpose>This method transfer data to the task using the Activity that refers the to process with 'TaskID'</Purpose>
            /// </summary>
            /// <returns>An ErrorXML if an Error occurs</returns>
            private ERRORXML TransferData()
            {
                PMFacadeClass PmFacadeObj = null;
                ERRORXML      ErrorXML    = null;
                try
                {
                    PmFacadeObj = new PMFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                    if (!String.IsNullOrEmpty(str_SubflowActivityID))
                    {
                        ErrorXML = PmFacadeObj.TransferDataOnProcessInitialisation(str_SubflowActivityID, str_TaskStatus);
                    }
                    return ErrorXML;
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

            /// <summary>
            /// This method updates the PostedBy user name and the email id
            /// </summary>
            /// <param name="FieldName"></param>
            /// <param name="ActivityNode">Activity details</param>
            /// <param name="FormXMLDoc">Form Input Xml</param>
            private void updateFormFields(String FieldName, XmlNode ActivityNode, ref XmlDocument FormXMLDoc)
            {
                XmlNode     xmlnode_Field   = null;
                XmlNode     xmlnode_Value   = null;
                String      str_Username    = null;

                switch (FieldName)
                {
                    case "EmailID":
                        xmlnode_Field = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='EmailID']");
                        if (xmlnode_Field != null)
                        {
                            XmlNode xmlnode_PC = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE/POSTEDBY/USER/EMAILID");
                            if (xmlnode_PC != null)
                            {
                                xmlnode_Value = xmlnode_Field.SelectSingleNode("Value");
                                if (xmlnode_Value == null)
                                    xmlnode_Value = FormXMLDoc.CreateElement("Value");
                                xmlnode_Value.InnerText = xmlnode_PC.InnerText;
                                xmlnode_Field.AppendChild(xmlnode_Value);
                            }
                        }
                        break;

                    case "PostedBy":
                        xmlnode_Field = FormXMLDoc.SelectSingleNode("FieldList/Field[@Name='PreviousContributor']");
                        if (xmlnode_Field != null)
                        {
                            XmlNode xmlnode_PC = ActivityNode.SelectSingleNode("ACTIVITY_RESPONSE/RESPONSE/POSTEDBY/USER");
                            if (xmlnode_PC != null)
                            {
                                str_Username            = ALCommon.FormatUserName(xmlnode_PC.SelectSingleNode("FIRSTNAME").InnerText,
                                                                xmlnode_PC.SelectSingleNode("LASTNAME").InnerText, xmlnode_PC.SelectSingleNode("MIDDLEINITIAL").InnerText,
                                                                xmlnode_PC.SelectSingleNode("LOGINNAME").InnerText, ALCommon.GetUserNameFormat());
                                xmlnode_Value = xmlnode_Field.SelectSingleNode("Value");
                                if (xmlnode_Value == null)
                                    xmlnode_Value = FormXMLDoc.CreateElement("Value");
                                xmlnode_Value.InnerText = str_Username;
                                xmlnode_Field.AppendChild(xmlnode_Value);
                            }
                        }
                        break;
                }
            }

            /// <summary>
            /// <Purpose>Set notifiy in advance check box value and value for no. of days for prior notification</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <param name="str_TaskXML">Task's details</param>
            private void SetAdvanceReminderValues(String str_TaskXML)
            {
                XElement xElt_TaskData          = null;
                XElement xElt_workflowProcess   = null;
                XElement xElt_value             = null;

                xElt_TaskData           = XElement.Load(XmlReader.Create(new StringReader(str_TaskXML)));
                xElt_workflowProcess    = xElt_TaskData.XPathSelectElement("WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
                if (xElt_workflowProcess != null)
                {
                    //Set check box condition
                    xElt_value = xElt_workflowProcess.Element("NOTIFYINADVANCE");
                    if (xElt_value != null)
                    {
                        if (xElt_value.Value == "1")
                        {
                            checkBoxObj.Checked = true;
                        }
                        else
                        {
                            checkBoxObj.Checked = false;
                        }
                    }

                    //Set text box value for no. of days for prior notification
                    xElt_value = xElt_workflowProcess.Element("NOTIFYNOOFDAYS");
                    if (xElt_value != null)
                    {
                        if (!String.IsNullOrEmpty(xElt_value.Value))
                        {
                            textBoxObj.Text = xElt_value.Value;
                        }
                        else
                        {
                            textBoxObj.Text = "1";
                        }
                    }
                }
            }

            /// <summary>
            /// <Purpose>Add values for NOTIFYINADVANCE and NOTIFYNOOFDAYS fields. </Purpose>
            /// </summary>
            /// <param name="FormDataDocument">Form data</param>
            private void AddAdvanceReminderValues(XmlDocument FormDataDocument)
            {
                XmlElement                  xmlElt_Temp               = null;
                XmlElement                  xmlElt_WorflowInformation = null;


                xmlElt_WorflowInformation   = (XmlElement)FormDataDocument.SelectSingleNode("WORKFLOWPROCESS/WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION");
                if (xmlElt_WorflowInformation != null)
                {
                    xmlElt_Temp             = (XmlElement)FormDataDocument.CreateElement("NOTIFYINADVANCE");
                    if (checkBoxObj.Checked)
                    {
                        xmlElt_Temp.InnerText = "1";
                    }
                    else
                    {
                        xmlElt_Temp.InnerText = "0";
                    }
                    xmlElt_WorflowInformation.AppendChild(xmlElt_Temp);

                    xmlElt_Temp             = (XmlElement)FormDataDocument.CreateElement("NOTIFYNOOFDAYS");
                    xmlElt_Temp.InnerText   = textBoxObj.Text;
                    xmlElt_WorflowInformation.AppendChild(xmlElt_Temp);
                }
            }

            /// <summary>
            /// <Purpose>Set url for popup for giving options for auto independet task</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            private void SetOnSavePopupUrl(String str_SaveClose)
            { 
                String                  str_PopupUrl                = null;                  
                String                  str_StdParams               = null;

                str_StdParams             = ALSolutionCommon.AppendStandardParamforURL(ALParamObj);

                //Set the popup url
                str_PopupUrl = str_StdParams + "&PopupID=" + Popup_OnSave.UniqueID + "&HiddenButtonID=" + HIDDEN_BTN_OnSavePopup.UniqueID
                                + "&SaveClose=" + str_SaveClose; 
                str_PopupUrl              = ALSolutionCommonObj.EncryptURL(str_PopupUrl);
                str_PopupUrl              = "SelectAutoStartOption.aspx?Param=" + str_PopupUrl;
                Popup_OnSave.NavigateURL  = str_PopupUrl; 
               
                Popup_OnSave.PopupHeight  = 108;
                Popup_OnSave.PopupWidth   = 350;
            }

            /// <summary>
            /// <Purpose>Handling options selected on on save popup</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <param name="sender">Sender objcet</param>
            /// <param name="e">Event arguments</param>
            protected void btnHiddenOnSavePopup_click(Object sender, EventArgs e)
            {
                String      EventArgument           = null;
                String[]    arr_EventArgs           = null;
                String      ErrorXML                = null;
                String      ErrorPageURL            = null;
                
                //Call js for checking if contributors added
                EventArgument = Request["__EVENTARGUMENT"];
                arr_EventArgs = EventArgument.Split(new char[] { '$' });
                if (arr_EventArgs[0].Equals("RB_STARTTODAY_CLICKED"))
                {
                    //Submit
                    Ajax.WriteExecuteJavaScript("Submit_Task('" + Frm_GatherInfo.ID + "', '" + HIDDEN_BTN_OnSavePopup.UniqueID + "', 'false', '', '')");
                }

                if (arr_EventArgs[0].Equals("RB_STARTONNEXTDAY_CLICKED") && arr_EventArgs[1].Equals("SAVEANDCLOSE"))
                {
                    ErrorXML = HandleSaveandClose();
                }
                
                if (arr_EventArgs[0].Equals("RB_STARTONNEXTDAY_CLICKED") && arr_EventArgs[1].Equals("SAVE"))
                {
                    ErrorXML = HandleSave();
                }

                if (arr_EventArgs[0].Equals("SUBMITTASK"))
                {
                    ErrorXML = HandleSubmit();
                }

                if (ErrorXML != null)
                {                    
                    ALSolutionCommonObj.PrepareErrorPageUrl("MarketingWorkBench", null, "TASK", ErrorXML, null, null, GetBackUrl(), ref ErrorPageURL);                    
                    if (!IsPostBack)
                    {
                        Response.Redirect(ErrorPageURL, true);
                    }
                    else
                    {
                        Ajax.WriteExecuteJavaScript("window.open('" + ErrorPageURL + "','_self','');");
                    }
                }
            }

            /// <summary>
            /// <Purpose>Check if start date entered is today</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <param name="b_StartDateToday">Falg is set to true or false</param>
            private void CheckIfStartDateToday(ref Boolean b_StartDateToday)
            {
                String          str_startDate       = null;
                String[]        arr_StartDate       = null;           
                DateTime        dt_StartDate;

                str_startDate = Frm_GatherInfo.GetValues("WORKFLOWPROCESS_STARTDATE");
                if (!String.IsNullOrEmpty(str_startDate))
                {
                    arr_StartDate   = str_startDate.Split(new char[] { '$' });
                    arr_StartDate   = arr_StartDate[1].Split(new char[] { '/' });
                    dt_StartDate    = new DateTime(Convert.ToInt32(arr_StartDate[2]), Convert.ToInt32(arr_StartDate[1]), Convert.ToInt32(arr_StartDate[0]));
                    if (dt_StartDate == DateTime.Today)
                    {
                        b_StartDateToday = true;
                    }
                }
            }
        
            /// <summary>
            /// <Purpose>To handle save</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <returns>Error xml if any</returns>
            private String HandleSave()
            {
                bool            alertGiven          = false;
                String          ErrorXML            = null;
                String			TaskStatus			= null;

                ErrorXML = SaveTask("Draft", out alertGiven);
                if (ErrorXML == null)
                {
                    if (!alertGiven)
                    {
                        TaskStatus = (String)ViewState["TaskStatus"];
                        if (TaskStatus.ToUpper() != "DRAFT")
                        {
                            RefreshForm("Draft");
                        }
                        ViewState["TaskStatus"] = "DRAFT";
                        UpdateTaskStepsAndAttachments();
                        RefreshBreadCrumb();
                    }
                }
                return ErrorXML;
            }

            /// <summary>
            /// <Purpose>To handle save and close</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <returns>Error xml if any</returns>
            private String HandleSaveandClose()
            {
                bool            alertGiven          = false;
                String          ErrorXML            = null;

                //Save
                ErrorXML = SaveTask("Draft", out alertGiven);
                if ((ErrorXML == null) && (!alertGiven))
                {
                    DeleteTempFiles();
                    if (PrevScreen.ToUpper() == "ROPROJECT")
                    {
                        gotoProjectROScreen();
                    }
                    else
                    {
                        gotoDeliverableROScreen();
                    }
                }
                return ErrorXML;
            }

            /// <summary>
            /// <Purpose>To handle Submit</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <returns>Error xml if any</returns>
            private String HandleSubmit()
            { 
                bool            alertGiven          = false;
                String          ErrorXML            = null;

                Ajax.WriteExecuteJavaScript("javascript:DisableButton('" + Ab_GatherInfoTask.GetClientIDByName("btn_Submit") + "');");
                ErrorXML = SaveTask("Active", out alertGiven);
                if ((ErrorXML == null) && (!alertGiven))
                {
                    DeleteTempFiles();
                    if (PrevScreen.ToUpper() == "ROPROJECT")
                    {
                        gotoProjectROScreen();
                    }
                    else
                    {
                        gotoDeliverableROScreen();
                    }
                }
                return ErrorXML;
            }

            private void getBaselineConfig()
            {
                String str_ShowBaseline = null;
                MktgWorkBenchFacadeClass MktgWorkBenchFacadeObj = null;
                MktgWorkBenchFacadeObj = new MktgWorkBenchFacadeClass(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                MktgWorkBenchFacadeObj.ReadSolutionConfiguration(SolutionName, "CALCULATEANDSHOWBASELINE", out str_ShowBaseline);
                ViewState["ShowBaseline"] = str_ShowBaseline.ToUpper();
            }

            /// <alsummary>
            /// <createddate>04 April 2012</createddate>
            /// <author>Mr. Hemant Karkande</author>
            /// <purpose>Set the Task Readers User/Group list control.</purpose>
            /// </alsummary>
            private void setTaskReadersUserGroupList(XPathNavigator xpathNav_ProcessReadersGroup, XPathNavigator xpathNav_ProcessReadersUser)
            {
                ListFacade      obj_ListFacade      = null;
                String          str_ListConfig      = null;
                String          str_SearchInputXml  = null;
                String          str_ListSourceXml   = null;
                StringBuilder   sb_SelectedUsers    = null;
                XmlDocument     xmlDoc_ActionBarXml = null;
                XmlNode         xmlNode_Attribute   = null;
                StringBuilder   sb_FilePath         = null;
                StringBuilder   sb_URL              = null;
                MWB_Helper      obj_MWBHelperFacade = null; 

                obj_ListFacade = new ListFacade(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language);
                obj_MWBHelperFacade = new  MWB_Helper(ALParamObj.SessionID, ALParamObj.UserID, ALParamObj.TenantName, ALParamObj.Language); 
                
                if (String.Compare(Access, "Read", true) == 0)
                {
                    LC_TaskReaders.ActionBarXML = null;
                    str_ListConfig = obj_ListFacade.GetConfigurationXML(SolutionName, null, "ROProcessReaders");
                }
                else
                {
                    sb_FilePath = new StringBuilder(100);
                    sb_URL      = new StringBuilder(150);
                    xmlDoc_ActionBarXml = new XmlDocument();
                    xmlDoc_ActionBarXml.Load(ALSolutionCommon.GetConfigurationXMLPath(ALParamObj.TenantName, SolutionName, null, "MarketingWorkBench_Manage_ReadersList_ActionBar"));
                    xmlNode_Attribute = xmlDoc_ActionBarXml.SelectSingleNode("ActionControlList/ActionControl[@Name='btn_AddGroup']/Attributes/Attribute[Name='href']/Value");
                    if (xmlNode_Attribute != null)
                    {
                        sb_FilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderGroupsFileName);
                        
                        sb_URL.Append("/" + ALParamObj.TenantName + "/Common/ASPX/GroupSelection.aspx?TenantName=" + ALParamObj.TenantName + "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&Language=" + ALParamObj.Language +
                            "&InputXMLPath=" + sb_FilePath.ToString() + "&ReturnTargetID=" + Btn_Hidden_TaskReaderGroup.UniqueID + "&IsPopUp=TRUE&ThemeName=" + Page.Theme);
                        xmlNode_Attribute.InnerText = "javascript:OpenNewWindow('" + ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_URL.ToString()) + "','','');";
                    }
                    xmlNode_Attribute = xmlDoc_ActionBarXml.SelectSingleNode("ActionControlList/ActionControl[@Name='btn_AddUser']/Attributes/Attribute[Name='href']/Value");
                    if (xmlNode_Attribute != null)
                    {
                        sb_FilePath.Remove(0, sb_FilePath.Length);
                        sb_FilePath.Append(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderUsersFileName);

                        sb_URL.Remove(0, sb_URL.Length);
                        sb_URL.Append("/" + ALParamObj.TenantName + "/Common/ASPX/UserSelection.aspx?TenantName=" + ALParamObj.TenantName + "&SessionID=" + ALParamObj.SessionID + "&UserID=" + ALParamObj.UserID + "&Language=" + ALParamObj.Language
                            + "&InputXMLPath=" + sb_FilePath.ToString() + "&ReturnTargetID=" + Btn_Hidden_TaskReaderUser.UniqueID + "&SelectionMode=MultiSelect&DoSubmit=True&IsPopUp=TRUE&ThemeName=" + Page.Theme);

                        xmlNode_Attribute.InnerText = "javascript:OpenNewWindow('" + ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_URL.ToString()) + "','','');";
                    }
                    LC_TaskReaders.ActionBarXMLType = Assetlink.CustomControls.ListControl.SourceType.InnerXML;
                    LC_TaskReaders.ActionBarXML = xmlDoc_ActionBarXml.OuterXml;
                    str_ListConfig = obj_ListFacade.GetConfigurationXML(SolutionName, null, "ProcessReaders");
                }
                
                //Prepare Selected Users input xml.
                sb_SelectedUsers = new StringBuilder(150);
                sb_SelectedUsers.Append("<UserSelectionXML><SelectedUsersList>");
                if (xpathNav_ProcessReadersUser != null)
                {
                    sb_SelectedUsers.Append(xpathNav_ProcessReadersUser.InnerXml);
                }
                sb_SelectedUsers.Append("</SelectedUsersList></UserSelectionXML>");
                File.WriteAllText(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderUsersFileName, sb_SelectedUsers.ToString());

                //Prepare Selected Group Input xml.
                sb_SelectedUsers.Remove(0, sb_SelectedUsers.Length);
                sb_SelectedUsers.Append("<GroupSelectionXML><SelectedGroupsList>");
                if (xpathNav_ProcessReadersGroup != null)
                {
                    sb_SelectedUsers.Append(xpathNav_ProcessReadersGroup.InnerXml);
                }
                sb_SelectedUsers.Append("</SelectedGroupsList></GroupSelectionXML>");
                File.WriteAllText(ALSolutionCommon.GetTempPath(ALParamObj.SessionID) + SelectedReaderGroupsFileName, sb_SelectedUsers.ToString());

                str_SearchInputXml = obj_MWBHelperFacade.PrepareUserGroupListSearchXml(xpathNav_ProcessReadersGroup, xpathNav_ProcessReadersUser);
                obj_ListFacade.PrepareListXml(str_ListConfig, str_SearchInputXml, out str_ListSourceXml);
                LC_TaskReaders.Source = str_ListSourceXml;
            }
        #endregion
    }
}