using System;
using System.Collections.Generic;
using System.Xml;
using System.IO;
using System.Text;
using System.Xml.XPath;
using System.Web;
using System.Collections.Specialized;
using System.Linq;
using System.Collections;
using System.Xml.Linq;

#region Assetlink
    using Assetlink.Solutions.Facade.CommonFacade;
    using Assetlink.Solutions.Facade.PMFacade;   
    using Assetlink.WebServices.ALSearchWS;	
#endregion

namespace Assetlink.Solutions.Facade.MktgWorkBenchFacade
{
    using ERRORXML  = System.String;
    using XML       = System.String;

    public class MWB_Helper : BaseFacade
    {
        private const int SOBJECTWIDTH = 170;
        private const int SOBJECTHEIGHT = 120;

			#region Constructor
            public MWB_Helper(String SessionID, String UserID, String TenantName, String CurrentLanguage)
                : base(SessionID, UserID, TenantName, CurrentLanguage)
            { 
            
            }
		    public MWB_Helper(String SessionID, String UserID, String TenantName, String CurrentLanguage,String PageTheme)
                : base(SessionID, UserID, TenantName, CurrentLanguage,"",PageTheme)
            {				
            }
        #endregion

        #region PublicMethods
            
            /// <alsummary>
            /// <createddate>14-NOV-06</createddate>
            /// <author>Mugdha Moolay</author>
            /// <purpose></purpose>
            /// </alsummary>
            /// <param name="InputXML"></param>
            /// <param name="DisplayFieldName"></param>
            /// <param name="ValueFieldName"></param>
            /// <returns></returns>
            public XML PrepareFormInputXML(XML InputXML,String DisplayFieldName,String ValueFieldName )
            {                                        
                XmlNode     RootNode            = null;
                XmlNodeList ChildNodeList       = null;                    
                XmlNode     DisplayFieldNameNode= null;
                XmlNode     ValueFieldNameNode  = null;
                XmlDocument InputDoc            = null;
                XmlDocument SortDoc             = null;
                StringBuilder ItemList          = null;
                String        ReturnXML         = null;
                XPathDocument       xp_SortDoc        = null;
                XPathExpression     xp_SortExpression = null;
                XPathNodeIterator   xp_SortNodeIter   = null;
                
                try
                {                        
                    InputDoc    = new XmlDocument();                            
                    SortDoc     = new XmlDocument();
                    ItemList    = new StringBuilder();
                    InputDoc.LoadXml(InputXML);
                    RootNode        = InputDoc.DocumentElement;
                    ChildNodeList   = RootNode.ChildNodes;
                    ItemList.AppendFormat("<ItemList>");
                    foreach (XmlNode ChildNode in ChildNodeList)
                    {
                        DisplayFieldNameNode = ChildNode.SelectSingleNode(DisplayFieldName);
                        ValueFieldNameNode = ChildNode.SelectSingleNode(ValueFieldName);
                        ItemList.AppendFormat("<Item Selected='No'><DisplayValue>{0}</DisplayValue><Value>{1}</Value></Item>", ALCommon.TrimAndReplaceSpecialChars(DisplayFieldNameNode.InnerText), ValueFieldNameNode.InnerText);
                    }
                    ItemList.AppendFormat("</ItemList>");

                    xp_SortDoc              = new XPathDocument(new StringReader(ItemList.ToString()));
                    xp_SortExpression       = XPathExpression.Compile("ItemList/Item");
                    xp_SortExpression.AddSort("DisplayValue", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    xp_SortNodeIter         = xp_SortDoc.CreateNavigator().Select(xp_SortExpression);
                    while (xp_SortNodeIter.MoveNext())
                    {
                        ReturnXML         += xp_SortNodeIter.Current.OuterXml;
                    }
                    ReturnXML               = "<Item Selected='Yes'><DisplayValue>" + Localization.GetString("ALResource",TenantName,"SelectGroup_Shared") + "</DisplayValue><Value>None</Value></Item>" + ReturnXML;
                    
                    return ReturnXML;
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>6-oct-06</createddate>
            /// <author>Mugdha Moolay</author>
            /// <purpose>This method will sets the appropriate formConfig xml to the form control
            /// depending upon the project type and the associated facets that required to be 
            /// displayed.
            /// </purpose>
            ///  <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes>
            /// </alsummary>
            public String GetFormConfigXMLPath(String DefaultFormName,String CustomFormName)
            {            
                StringBuilder   FormConfigXMLPath               = null;
                StringBuilder   DefaultFormConfigXMLPath        = null;
                String          InstalledPath                   = null;
                String          str_DefaultFormConfigXmlName    = null;
                String          str_CustomFormConfigXmlName     = null;
                
                try
                {                               
                    FormConfigXMLPath           = new StringBuilder();
                    DefaultFormConfigXMLPath    = new StringBuilder();
                    InstalledPath = ALSolutionCommon.GetInstallationDir();
                    //Project_Details_FormConfiguration.xml
                    str_DefaultFormConfigXmlName = DefaultFormName + "_FormConfiguration";
                    DefaultFormConfigXMLPath.Append(ALSolutionCommon.GetFormConfigurationXMLPath(TenantName, "MarketingWorkBench", str_DefaultFormConfigXmlName));

                    if ((CustomFormName != null) && (CustomFormName != ""))
                    {
                        str_CustomFormConfigXmlName = CustomFormName + "_FormConfiguration";
                        FormConfigXMLPath.Append(ALSolutionCommon.GetFormConfigurationXMLPath(TenantName, "MarketingWorkBench", str_CustomFormConfigXmlName));

                        if (File.Exists(FormConfigXMLPath.ToString()))
                        {
                            return FormConfigXMLPath.ToString();
                        }
                    }                
                     return DefaultFormConfigXMLPath.ToString();

                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            /// <alsummary>
            /// <createddate>14-Nov-06</createddate>
            /// <author>Mugdha Moolay</author>
            /// <purpose>this method sets the display name of a form</purpose>
            /// </alsummary>
            /// <param name="FormConfigPath"></param>
            /// <param name="DisplayText"></param>
            /// <returns></returns>
            public XML SetFormDisplayNameInConfigurationXML(String FormConfigPath,String DisplayText,bool ShowResponse)
            {
                XmlDocument FormConfigDoc		= null;
                XmlNode     FormNode			= null;
                XmlNode     DisplayTextNode		= null;
                XmlNode		ResponseSectionNode = null;
                XmlNode     node_DisplayHeading = null; 
				XmlNodeList SectionNodeList     = null;
                int         int_SectionOrder    = 0;
                try
                {
                    FormConfigDoc   = new XmlDocument();
                    FormConfigDoc.Load(FormConfigPath);
                    FormNode        = FormConfigDoc.DocumentElement;
                    DisplayTextNode = FormNode.Attributes.GetNamedItem("DisplayText");
                    DisplayTextNode.InnerText = DisplayText;

                    node_DisplayHeading = FormNode.Attributes.GetNamedItem("DisplayFormHeading");
                    node_DisplayHeading.InnerText = "true";

                    if (!ShowResponse)
                    {
						ResponseSectionNode = FormNode.SelectSingleNode("Section[@Heading='PREVIOUS_RESPONSE']");
						if (ResponseSectionNode!=null)
						{
							FormNode.RemoveChild(ResponseSectionNode);
                            SectionNodeList = FormNode.SelectNodes("Section");
                            foreach (XmlNode SectionNode in SectionNodeList)
                            {
                                int_SectionOrder = int.Parse(((XmlElement)SectionNode).GetAttribute("Order"));
                                if (int_SectionOrder != 1)
                                {
                                    int_SectionOrder--;
                                    ((XmlElement)SectionNode).SetAttribute("Order",int_SectionOrder.ToString());                                    
                                }
                            }
						}
                    }
                    return FormConfigDoc.OuterXml;
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>16-Nov-06</createddate>
            /// <author>Mugdha moolay</author>
            /// <purpose></purpose>
            /// </alsummary>
            /// <param name="InputXML"></param>
            /// <param name="DisplayFieldName"></param>
            /// <param name="ValueFieldName"></param>
            /// <returns></returns>
            public XML GetSearchXMLForListOfEntities(String TargetObject,String FieldName,String RelatedEntityNavPath, String RelatedEntityFieldList, String TargetEntityList)
            {
                StringBuilder   SearchXML           = null;
                String []       EntityIDList        = null;
                String[]        FieldList           = null;                        
                int             Total               = 0;


                try
                {
                        EntityIDList = TargetEntityList.Split(';');
                        SearchXML   = new StringBuilder();
                        SearchXML.AppendFormat("<INPUTXML><SESSIONINFO TenantName='{0}' Language='{1}' UserID='{2}' SessionID='{3}'/>", TenantName, CurrentLanguage, UserID, SessionID);
                        SearchXML.AppendFormat("<SEARCHCOLLECTION><SEARCH><TARGETOBJECT>{0}</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE><FILTERLIST>", TargetObject);
                        SearchXML.AppendFormat("<FILTER>");
                        SearchXML.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", FieldName);
                        SearchXML.AppendFormat("<OPERATOR>IN</OPERATOR>");
                        SearchXML.AppendFormat("<FIELDVALUE>(");
                        Total = EntityIDList.Length;
                        for (int i = 0; i < Total; i++)
                        {                                
                            if (i < Total - 1)
                                SearchXML.AppendFormat("'{0}' , ", EntityIDList[i]);
                            else
                                SearchXML.AppendFormat("'{0}'", EntityIDList[i]);

                        }
                        SearchXML.AppendFormat(")</FIELDVALUE>");
                        SearchXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                        SearchXML.AppendFormat("<NAVIGATIONPATH>{0}</NAVIGATIONPATH>", TargetObject);
                        SearchXML.AppendFormat("</FILTER>");
                        if (TargetObject.ToUpper() == "GROUP")
                        {
							SearchXML.AppendFormat("<FILTER>");
							//SearchXML.AppendFormat("<FILTERID>");
							SearchXML.AppendFormat("<FIELDNAME>ISDELETED</FIELDNAME>");
							SearchXML.AppendFormat("<OPERATOR>EQUALTO</OPERATOR>");
							SearchXML.AppendFormat("<FIELDVALUE>0</FIELDVALUE>");
							SearchXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
							SearchXML.AppendFormat("<NAVIGATIONPATH>{0}</NAVIGATIONPATH>", TargetObject);
							SearchXML.AppendFormat("</FILTER>");
							SearchXML.AppendFormat("<FILTER ApplyFilter='Yes'>");
							if(!String.IsNullOrEmpty(RelatedEntityNavPath) && (RelatedEntityNavPath.ToUpper() == "GROUP.GROUP_MEMBERUSER"))
							{
								SearchXML.AppendFormat("<FIELDNAME>STATUS</FIELDNAME>");
								SearchXML.AppendFormat("<OPERATOR>EQUALTO</OPERATOR>");
								SearchXML.AppendFormat("<FIELDVALUE>ACTIVE</FIELDVALUE>");
								SearchXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
								SearchXML.AppendFormat("<NAVIGATIONPATH>GROUP.GROUP_MEMBERUSER</NAVIGATIONPATH>");
								SearchXML.AppendFormat("</FILTER>");
							}
                        }
                        SearchXML.AppendFormat("</FILTERLIST>");

                        if ((RelatedEntityNavPath != null) && (RelatedEntityNavPath != ""))
                        {
                            SearchXML.AppendFormat("<FIELDCOLLECTION>");
                            SearchXML.AppendFormat("<RELATEDENTITYFIELDS NavigationPath='{0}' ApplyFilter='YES'>", RelatedEntityNavPath);
                            FieldList = RelatedEntityFieldList.Split(';');
                            Total = FieldList.Length;
                            for (int i = 0; i < Total; i++)
                            {
                                SearchXML.AppendFormat("<FIELD>{0}</FIELD>", FieldList[i]);
                            }
                            SearchXML.AppendFormat("</RELATEDENTITYFIELDS>");
                            SearchXML.AppendFormat("</FIELDCOLLECTION>");			
                        }                 
			            
                        SearchXML.AppendFormat("</SEARCH>");
                        SearchXML.AppendFormat("</SEARCHCOLLECTION>");
                        SearchXML.AppendFormat("</INPUTXML>");
                        return SearchXML.ToString();                        
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// 
            /// </alsummary>
            /// <param name="GroupName"></param>
            /// <param name="TempXMLFileName"></param>
            /// <param name="ItemList"></param>
            public void  GetContributorListFromGroup(String FileName,out String ItemList)
            {
                StringBuilder  TempFilePath = null;
                String         TempPath     = null;
                StringBuilder ItemListXML   = null;
                XmlDocument   GroupXMLDoc   = null;  
                XmlDocument   SortDoc       = null;
                XmlNodeList   UserNodeList  = null;  
                String        UserID        = null;
                String        LoginName     = null;  
                String        UserNameFormat= null;
                String        FirstName     = null;
                String        LastName      = null;  
                String        MiddleName    = null;                    
                String        FormattedName = null;
                String        SortedXML     = null;
                XPathDocument       xp_SortDoc        = null;
                XPathExpression     xp_SortExpression = null;
                XPathNodeIterator   xp_SortNodeIter   = null;
                
                try
                {                        
                    GroupXMLDoc  = new XmlDocument();
                    ItemListXML  = new StringBuilder();
                    TempFilePath = new StringBuilder();
                    SortDoc      = new XmlDocument();
                    ItemList     = null;         
                    TempPath = ALSolutionCommon.GetTempPath(SessionID);
					TempFilePath.AppendFormat("{0}{1}", TempPath, FileName);               
					if(File.Exists(TempFilePath.ToString()))                        
                    {
						GroupXMLDoc.Load(TempFilePath.ToString());
                        ItemListXML.AppendFormat("<ItemList>");
						UserNodeList = GroupXMLDoc.SelectNodes("descendant::USER");
						if(UserNodeList.Count > 0)
                        {								
                            UserNameFormat = ALCommon.GetUserNameFormat();
                            foreach (XmlNode UserNode in UserNodeList)
                            {
                                UserID = UserNode.SelectSingleNode("USERID").InnerText;
                                LoginName = UserNode.SelectSingleNode("LOGINNAME").InnerText;
                                FirstName = UserNode.SelectSingleNode("FIRSTNAME").InnerText;
                                MiddleName = UserNode.SelectSingleNode("MIDDLEINITIAL").InnerText;
                                LastName = UserNode.SelectSingleNode("LASTNAME").InnerText;
                                FormattedName = ALCommon.FormatUserName(FirstName, LastName, MiddleName, LoginName, UserNameFormat);
                                ItemListXML.AppendFormat("<Item Selected='No'><DisplayValue>{0}</DisplayValue><Value>{1}</Value></Item>", ALCommon.TrimAndReplaceSpecialChars(FormattedName), UserID);
                            }
                            ItemListXML.AppendFormat("</ItemList>");

                            xp_SortDoc              = new XPathDocument(new StringReader(ItemListXML.ToString()));
                            xp_SortExpression       = XPathExpression.Compile("ItemList/Item");
                            xp_SortExpression.AddSort("DisplayValue", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                            xp_SortNodeIter         = xp_SortDoc.CreateNavigator().Select(xp_SortExpression);
                            while (xp_SortNodeIter.MoveNext())
                            {
                                SortedXML         += xp_SortNodeIter.Current.OuterXml;
                            }
                            ItemList               = "<Item Selected='Yes'><DisplayValue>" + Localization.GetString("ALResource",TenantName,"MWB_Manage_AssignContributor_SelectContributor_Shared") + "</DisplayValue><Value>None</Value></Item>" + SortedXML;
                        }
                        else
                        {
                            ItemList = "<Item Selected='Yes'><DisplayValue>" + Localization.GetString("ALResource", TenantName, "MWB_Manage_AssignContributor_SelectContributor_Shared") + "</DisplayValue><Value>None</Value></Item>";
                        }
                    }
					else // The group is deleted or does not exist
					{
                        ItemList = "<Item Selected='Yes'><DisplayValue>" + Localization.GetString("ALResource", TenantName, "MWB_Manage_AssignContributor_SelectContributor_Shared") + "</DisplayValue><Value>None</Value></Item>";
					}
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// 
            /// </alsummary>
            /// <param name="UserID"></param>
            /// <param name="TempXMLFileName"></param>
            /// <param name="MailAddress"></param>
            public void GetMailAddressForSelectedUser(String UserID, String TempXMLFileName, out String MailAddress)
            {
                StringBuilder   TempFilePath = null;
                String          TempPath     = null;
                XmlDocument    GroupXMLDoc   = null;  
                XmlNode        UserNode      = null; 
                try
                {
                    GroupXMLDoc  = new XmlDocument();                        
                    TempFilePath = new StringBuilder();
                    MailAddress = null;
                    TempPath = ALSolutionCommon.GetTempPath(SessionID);
                    TempFilePath.AppendFormat("{0}{1}", TempPath, TempXMLFileName);
                    if (File.Exists(TempFilePath.ToString()))
                    {
                        GroupXMLDoc.Load(TempFilePath.ToString());
                        UserNode = GroupXMLDoc.SelectSingleNode("descendant::USER[USERID='"+UserID+"']");
                        if (UserNode != null)
                        {
                            MailAddress = UserNode.SelectSingleNode("EMAILID").InnerText;
                        }
                        else
                            MailAddress = null;
                    }
                }
                catch (Exception ExceptionObj)
                {
                    MailAddress = null;
                    throw ExceptionObj;
                }            
            }

            /// <alsummary>
            /// <createddate>18-Nov-06</createddate>
            /// <author>Mugdha Moolay</author>
            /// <purpose></purpose>
            /// </alsummary>
            /// <param name="ResourceID"></param>
            /// <param name="ContributorID"></param>
            /// <param name="StepXML"></param>
            /// <param name="SelectedActivityResourceXML"></param>
            /// <param name="ReturnActivityXML"></param>
            public void prepareActivityResourceXML(String ResourceID, String ContributorID,XML SelectedActivityResourceXML, out XML ReturnActivityResourceXML,String ActualResName)
            {
                XmlDocument     ResourceXMLDoc      = null;                    
                XmlAttribute    TypeAttr            = null;
                StringBuilder   ActivityXML         = null;                    
                XmlNode         UserAssignedNode    = null;                    
                XmlNode         ResourceIDNode      = null;
                XmlNode         ResourceNode        = null;
                XmlNode         ResourceUserNode    = null;
                XmlNode         UserCountNode       = null;
                XmlNode         ActualResourceNode  = null;
				XmlNode			ResourceTypeNode	= null;
                try
                {
                    ResourceXMLDoc = new XmlDocument();
                    ActivityXML = new StringBuilder();                        
                  //  ActivityXML.AppendFormat("<ACTIVITY_RESOURCE>");                       
                    
                    ActivityXML.AppendFormat("<RESOURCE MODIFIED='TRUE'>");
                        ActivityXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>",ResourceID);
                    ActivityXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION'>");

                    // remove the resourceIDNode , set UserAssigned = true and resourceCount = 0
                    ResourceXMLDoc.LoadXml(SelectedActivityResourceXML);
                    ResourceNode = ResourceXMLDoc.DocumentElement;
                    
                    // if the resource node has aby previously selected actual resource and resource user the
                    // remove those nodes
                    // this case will occur when the selected group is same and the contributor is changed 
                    // (when a step is having contributors already to it and is modified.)
                    ActualResourceNode = ResourceNode.SelectSingleNode("ACTUAL_RESOURCE");
                    if (ActualResourceNode != null)
                        ResourceNode.RemoveChild(ActualResourceNode);
                    ResourceUserNode = ResourceNode.SelectSingleNode("RESOURCE_USER");
                    if (ResourceUserNode != null)
                        ResourceNode.RemoveChild(ResourceUserNode);

                    ResourceIDNode = ResourceNode.SelectSingleNode("RESOURCEID");
                    ResourceNode.RemoveChild(ResourceIDNode);

                    UserCountNode = ResourceNode.SelectSingleNode("RESOURCECOUNT");
                    if (UserCountNode != null)
                        UserCountNode.InnerText = "0";
                    else
                    {
                        UserCountNode = ResourceXMLDoc.CreateElement("RESOURCECOUNT");
                        UserCountNode.InnerText = "0";
                        ResourceNode.AppendChild(UserCountNode);
                    }
                    
                    UserAssignedNode = ResourceNode.SelectSingleNode("USERASSIGNED");
                    if (UserAssignedNode != null)
                        UserAssignedNode.InnerText = "FALSE";
                    else
                    {
                        UserAssignedNode = ResourceXMLDoc.CreateElement("USERASSIGNED");
                        UserAssignedNode.InnerText = "FALSE";
                        ResourceNode.AppendChild(UserAssignedNode);
                    }
                    
					ResourceTypeNode = ResourceNode.SelectSingleNode("RESOURCETYPE");
                    if (ResourceTypeNode != null)
                        ResourceTypeNode.InnerText = ActualResName;
                    else
                    {
                        ResourceTypeNode = ResourceXMLDoc.CreateElement("RESOURCETYPE");
                        ResourceTypeNode.InnerText = ActualResName;
                        ResourceNode.AppendChild(ResourceTypeNode);
                    }
                    					
                    if ((ContributorID.ToUpper() != "NONE"))
                    {
						UserCountNode.InnerText = "1";
						UserAssignedNode.InnerText = "TRUE";
						ResourceUserNode = ResourceXMLDoc.CreateElement("RESOURCE_USER");
                        TypeAttr = ResourceXMLDoc.CreateAttribute("TYPE");
                        TypeAttr.InnerText = "RELATION";
                        ResourceUserNode.Attributes.Append(TypeAttr);
                        ResourceUserNode.InnerText = ContributorID;
                        ResourceNode.AppendChild(ResourceUserNode);
                    }
                    ActivityXML.Append(ResourceNode.OuterXml);                       
                    ActivityXML.AppendFormat("</ACTUAL_RESOURCE>");
                    ActivityXML.AppendFormat("</RESOURCE>");
                   // ActivityXML.AppendFormat("</ACTIVITY_RESOURCE>");
                    ReturnActivityResourceXML = ActivityXML.ToString();
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }            
            }

            public void prepareActivityXML(bool Modified,  XML StepXML, XML ActivityResourceXML, out XML ReturnActivtityXML)
            {
                XmlDocument     StepDoc                 = null;
                XmlNode         ActivityNode            = null;
                XmlNode         ActivityResourceNode    = null;                    
                StringBuilder   TempXML                 = null;
                XmlNode         ResourceUserNode        = null;
                XmlNode         ActivityContributorNode = null;
                try
                {
                    StepDoc = new XmlDocument();
                    TempXML = new StringBuilder();
                    StepDoc.LoadXml(StepXML);
                    ActivityNode = StepDoc.SelectSingleNode("ACTIVITY");                        
                    if (Modified)
                    {
                        //ModifiedAttr = StepDoc.CreateAttribute("MODIFIED");
                        //ModifiedAttr.InnerText = "TRUE";
                        ((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
                        //ActivityNode.Attributes.Append(ModifiedAttr);
                    }                        
                    ActivityResourceNode = StepDoc.CreateElement("ACTIVITY_RESOURCE");
                    ((XmlElement)ActivityResourceNode).SetAttribute("TYPE", "RELATION");                       
                    ActivityNode.AppendChild(ActivityResourceNode);
                    ActivityResourceNode.InnerXml = ActivityResourceXML;
                    ResourceUserNode = ActivityResourceNode.SelectSingleNode("RESOURCE/ACTUAL_RESOURCE/RESOURCE/RESOURCE_USER");
                    if (ResourceUserNode != null)
                    {
                        ActivityContributorNode = StepDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
                        ((XmlElement)ActivityContributorNode).SetAttribute("TYPE", "RELATION");
                        ActivityContributorNode.InnerText = ResourceUserNode.InnerText;
                        ActivityNode.AppendChild(ActivityContributorNode);
                    }
                    ReturnActivtityXML = StepDoc.OuterXml;
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj; 
                }
            }

            public XML GetSearchXMLForResourceTypeGroups(String CommaSeparatedListOfGroups)
            {
                StringBuilder SearchXML = null;
                String[] ResourceIDList = null;                   
                int Total = 0;

                try
                {

                    ResourceIDList = CommaSeparatedListOfGroups.Split(';');
                    SearchXML = new StringBuilder();
                    SearchXML.AppendFormat("<INPUTXML><SESSIONINFO TenantName='{0}' Language='{1}' UserID='{2}' SessionID='{3}'/>", TenantName, CurrentLanguage, UserID, SessionID);
                    SearchXML.AppendFormat("<SEARCHCOLLECTION><SEARCH><TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE><FILTERLIST>");
                    SearchXML.AppendFormat("<FILTER>");
                    SearchXML.AppendFormat("<FIELDNAME>GROUPNAME</FIELDNAME>");
                    SearchXML.AppendFormat("<OPERATOR>IN</OPERATOR>");
                    SearchXML.AppendFormat("<FIELDVALUE>(");
                    Total = ResourceIDList.Length;
                    for (int i = 0; i < Total; i++)
                    {
                        if (i < Total - 1)
                            SearchXML.AppendFormat("'{0}' , ", ResourceIDList[i]);
                        else
                            SearchXML.AppendFormat("'{0}'", ResourceIDList[i]);

                    }
                    SearchXML.AppendFormat(")</FIELDVALUE>");
                    SearchXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                    SearchXML.AppendFormat("<NAVIGATIONPATH>GROUP</NAVIGATIONPATH>");
                    SearchXML.AppendFormat("</FILTER>");
                    SearchXML.AppendFormat("</FILTERLIST>");
                    SearchXML.AppendFormat("<FIELDCOLLECTION>");
                    SearchXML.AppendFormat("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'>");
                    SearchXML.AppendFormat("<FIELD>USERID</FIELD>");
                    SearchXML.AppendFormat("<FIELD>LOGINNAME</FIELD>");
                    SearchXML.AppendFormat("</RELATEDENTITYFIELDS>");
                    SearchXML.AppendFormat("</FIELDCOLLECTION>");
                    SearchXML.AppendFormat("</SEARCH>");
                    SearchXML.AppendFormat("</SEARCHCOLLECTION>");
                    SearchXML.AppendFormat("</INPUTXML>");
                    return SearchXML.ToString();
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            public XML GetSearchXMLForResourceUsers(String ResourceID)
            {
                StringBuilder SearchXML = null;                  
                try
                {

                    //ResourceIDList = CommaSeparatedListOfResources.Split(';');
                    SearchXML = new StringBuilder();
                    SearchXML.AppendFormat("<INPUTXML><SESSIONINFO TenantName='{0}' Language='{1}' UserID='{2}' SessionID='{3}'/>", TenantName, CurrentLanguage, UserID, SessionID);
                    SearchXML.AppendFormat("<SEARCHCOLLECTION><SEARCH><TARGETOBJECT>USER</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE><FILTERLIST>");
                    SearchXML.AppendFormat("<FILTER>");
                    SearchXML.AppendFormat("<FIELDNAME>RESOURCEID</FIELDNAME>");
                    SearchXML.AppendFormat("<OPERATOR>EQUALTO</OPERATOR>");
                    SearchXML.AppendFormat("<FIELDVALUE>{0}</FIELDVALUE>", ResourceID);                                            
                    SearchXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                    SearchXML.AppendFormat("<NAVIGATIONPATH>USER.RESOURCE_USER</NAVIGATIONPATH>");
                    SearchXML.AppendFormat("</FILTER>");
                    SearchXML.AppendFormat("</FILTERLIST>");
                    SearchXML.AppendFormat("<FIELDCOLLECTION>");
                    SearchXML.AppendFormat("<TARGETENTITYFIELDS>");
                    SearchXML.AppendFormat("<FIELD>USERID</FIELD>");
                    SearchXML.AppendFormat("<FIELD>FIRSTNAME</FIELD>");
                    SearchXML.AppendFormat("<FIELD>LASTNAME</FIELD>");
                    SearchXML.AppendFormat("<FIELD>LOGINNAME</FIELD>");
                    SearchXML.AppendFormat("<FIELD>MIDDLEINITIAL</FIELD>");
                    SearchXML.AppendFormat("</TARGETENTITYFIELDS>");
                    SearchXML.AppendFormat("</FIELDCOLLECTION>");
                    SearchXML.AppendFormat("</SEARCH>");
                    SearchXML.AppendFormat("</SEARCHCOLLECTION>");
                    SearchXML.AppendFormat("</INPUTXML>");
                    return SearchXML.ToString();
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
         }

            public XML GetUserListForActualResources(XML SearchXML , out XML UserListXML)
            {
                Search      SearchObj = null;
                ERRORXML    ErrorXML  = null;  
                try
                {
                    SearchObj   = new Search();
                    UserListXML = null;
                    ErrorXML    = SearchObj.DoSearch(SearchXML, ref UserListXML);
                    return ErrorXML;
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>27-Nov-06</createddate>
            /// <author>Mugdha Moolay</author>
            /// <purpose>This Helper function sets the 'Selected' attribute of the 
            /// ItemNode to yes where Value Node = ResourceID</purpose>
            /// </alsummary>
            /// <param name="ItemListXML"></param>
            /// <param name="ResourceID"></param>
            /// <returns></returns>
            public XML getItemListXMLForSelectedValue(XML ItemListXML, String SelectedItemID)
            {
                XmlDocument ItemListDoc = null;
                XmlNode     ItemNode    = null;
                XmlNode     RootNode    = null;
                try
                {
                    ItemListDoc = new XmlDocument();
                    RootNode    = ItemListDoc.CreateElement("ITEMCOLLECTION");
                    ItemListDoc.AppendChild(RootNode);
                    RootNode.InnerXml= ItemListXML;
                    ItemNode = RootNode.SelectSingleNode("Item[@Selected='Yes']");
                    if (ItemNode != null)
                    {
                        ItemNode.Attributes.GetNamedItem("Selected").InnerText = "No";
                    }
                    ItemNode = RootNode.SelectSingleNode("Item[Value='" + SelectedItemID + "']");
                    if (ItemNode != null)
                    {
                        if (ItemNode.Attributes.GetNamedItem("Selected") != null)
                        {
                            ItemNode.Attributes.GetNamedItem("Selected").InnerText = "Yes";
                        }
                    }
                    return ItemListDoc.DocumentElement.InnerXml;
                }
                catch (Exception ExceptionObj)
                {                       
                    throw ExceptionObj;
                }
            }

            public void getResourceIDToBeDisAssociated(XmlNode ActivityNode, out String ActivityResourceID,out String ActualResourceID)
            {
                XmlNode     ActualResourceNode      =   null;
                XmlNode     ActivityResourceNode    =   null;

                try
                {
                    ActivityResourceID  = null;
                    ActualResourceID    = null;
                    if (ActivityNode != null)
                    {
                        ActualResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE");
                        if (ActualResourceNode != null)
                        {
                            ActivityResourceNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[ACTUAL_RESOURCE/RESOURCE]");
                            ActualResourceID     = ActualResourceNode.SelectSingleNode("RESOURCEID").InnerText;
                            ActivityResourceID = ActivityResourceNode.SelectSingleNode("RESOURCEID").InnerText; 
                        }
                    }
                
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>30-Nov-06</createddate>
            /// <author>Mugdha Moolay</author>
            /// <purpose>Thie Method prepares an activity xml that is to be 
            /// modified and only when the step contributor is to be changed.
            /// </purpose>
            /// </alsummary>
            /// <param name="ActivityID">The activity xml that contains activity</param>                
            /// <param name="ActivityResourceID"></param>
            /// <param name="ActualResourceID"></param>
            /// <param name="OldUserID">The user id to be disassociated</param>
            /// <param name="SelectedContributor">The New UserID to be associated</param>
            /// <param name="ReturnActivityXML"></param>
            public void prepareActivity_ActualResourceXML(String ActivityResourceID, String ActualResourceID,String OldUserID, String SelectedContributor, XML StepXML, String SelectedGroupName, out XML ReturnActivityXML)
            {
                StringBuilder   DisAssociateXML     = null; 
                XmlDocument		TempDoc				= null;                   
                XmlNode			ActivityNode		= null;
                XmlNode			ActivityResourceNode= null;
                XmlNode			ActContributor		= null;
                
                try 
                {
					TempDoc			= new XmlDocument();
                    DisAssociateXML = new StringBuilder();                        
                    ReturnActivityXML   = null;                        
                    if (!String.IsNullOrEmpty(StepXML))
                    {
						TempDoc.LoadXml(StepXML);
						
						ActivityNode = TempDoc.DocumentElement;
						((XmlElement)ActivityNode).SetAttribute("MODIFIED", "TRUE");
						ActivityResourceNode = TempDoc.CreateElement("ACTIVITY_RESOURCE");
						((XmlElement)ActivityResourceNode).SetAttribute("TYPE", "RELATION");
						
							DisAssociateXML.AppendFormat(@"<RESOURCE MODIFIED='TRUE'>
															<RESOURCEID>{0}</RESOURCEID>
															<ACTUAL_RESOURCE TYPE='RELATION'>
															<RESOURCE MODIFIED='TRUE'>
															<RESOURCEID>{1}</RESOURCEID>
															<RESOURCETYPE>{2}</RESOURCETYPE>", ActivityResourceID, ActualResourceID, ALSolutionCommon.TrimAndReplaceSpecialChars(SelectedGroupName));
                                        if (OldUserID != null)
											DisAssociateXML.AppendFormat("<RESOURCE_USER TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</RESOURCE_USER>", OldUserID);
                                            if (SelectedContributor.ToUpper() != "NONE")
											    DisAssociateXML.AppendFormat("<RESOURCE_USER TYPE='RELATION'>{0}</RESOURCE_USER>", SelectedContributor);
										DisAssociateXML.Append(@"</RESOURCE>
																</ACTUAL_RESOURCE>
																</RESOURCE>");
						   
						   ActivityResourceNode.InnerXml = DisAssociateXML.ToString();
						   ActivityNode.AppendChild(ActivityResourceNode);
                           if (OldUserID != null)
                           {
                               ActContributor = TempDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
                               ((XmlElement)ActContributor).SetAttribute("TYPE", "RELATION");
                               ((XmlElement)ActContributor).SetAttribute("DISASSOCIATE", "TRUE");
                               ActContributor.InnerText = OldUserID;
                               ActivityNode.AppendChild(ActContributor);
                           }
						   ActContributor= null;
                           if (SelectedContributor.ToUpper() != "NONE")
                           {
                               ActContributor = TempDoc.CreateElement("ACTIVITY_CONTRIBUTOR");
                               ((XmlElement)ActContributor).SetAttribute("TYPE", "RELATION");
                               ActContributor.InnerText = SelectedContributor;
                               ActivityNode.AppendChild(ActContributor);
                           }
						   //DisAssociateXML.AppendFormat("<ACTIVITY_CONTRIBUTOR TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTIVITY_CONTRIBUTOR>", OldUserID);
						   //DisAssociateXML.AppendFormat("<ACTIVITY_CONTRIBUTOR TYPE='RELATION'>{0}</ACTIVITY_CONTRIBUTOR>", SelectedContributor); 
						  // DisAssociateXML.AppendFormat("</ACTIVITY>");
						ReturnActivityXML = TempDoc.OuterXml;                        
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            public bool IsSaveValid(String DeliverableID)
            {
                XmlDocument                 DeliverableDoc          = null;
                Boolean                     IsValid                 = true;
                MktgWorkBenchFacadeClass    MWBFacadeObj            = null;
                XML                         AssociationXML          = null;
                XML                         ReturnDeliverableXML    = null;
                ERRORXML                    ErrorXML                = null;
                XmlNode                     ProcessTransitionNode   = null;
                String                      DeliverableActivityID   = null;
                String                      XpathQuery              = null;
                XmlNodeList                 ActivityNodeList        = null;
                XmlNode                     ActivityNode            = null;
                try
                {
                    DeliverableDoc  = new XmlDocument();                        
                    MWBFacadeObj    = new MktgWorkBenchFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);
                    AssociationXML  = getAssociationXMLForDeliverable();
                    ErrorXML        = MWBFacadeObj.GetDeliverable(DeliverableID, null, AssociationXML, out ReturnDeliverableXML);
                    if (ErrorXML == null)
                    {
                        DeliverableDoc.LoadXml(ReturnDeliverableXML);
                        DeliverableActivityID = DeliverableDoc.SelectSingleNode("descendant::SUBFLOWACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                        XpathQuery  = "TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID='"+DeliverableActivityID+"']";
                        ProcessTransitionNode = DeliverableDoc.SelectSingleNode("descendant::SUBFLOWACTIVITY/ACTIVITY/PROCESS_ACTIVITY/WORKFLOWPROCESS/PROCESS_TRANSITION");
                        if (ProcessTransitionNode != null)
                        {
                            ActivityNodeList =  ProcessTransitionNode.SelectNodes(XpathQuery);
                            foreach (XmlNode TransitionNode in ActivityNodeList)
                            {
                                ActivityNode = TransitionNode.SelectSingleNode("FROMACTIVITY/ACTIVITY");
                                if (ActivityNode != null)
                                {
                                    if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() == "FALSE")
                                    {
                                        if ((ActivityNode.SelectSingleNode("STATUS").InnerText.ToUpper() != "COMPLETED") && ((ActivityNode.SelectSingleNode("STATUS").InnerText.ToUpper() != "CANCELLED")))
                                        {
                                            IsValid = false;
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    return IsValid;
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            private XML getAssociationXMLForDeliverable()
            {
                StringBuilder AssociationXML = null;
                try
                {
                    AssociationXML = new StringBuilder(250);
                    AssociationXML.Append(@"<ASSOCIATION>
                                            <SUBFLOWACTIVITY Type='RELATION'>
                                                <PROCESS_ACTIVITY Type='RELATION'>
                                                    <PROCESS_TRANSITION Type='RELATION'>
                                                        <FROMACTIVITY Type='RELATION'>                                            
                                                               <ACTIVITYID/>
                                                               <STARTACTIVITY/>
                                                               <STATUS/>
                                                        </FROMACTIVITY>
                                                        <TOACTIVITY Type='RELATION'>
                                                            <ACTIVITYID/>
                                                            <STARTACTIVITY/>
                                                            <STATUS/>
                                                        </TOACTIVITY>
                                                    </PROCESS_TRANSITION>
                                                </PROCESS_ACTIVITY>
                                            </SUBFLOWACTIVITY>
                                        </ASSOCIATION>");

                    return AssociationXML.ToString();
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }

            public XML getAllResponsesInProcess(String InputXML)
            {
                XPathDocument       InputXMLDoc             = null; 
                StringReader        SR_InputXML             = null; 
                XPathNavigator      RootNode                = null; 
                XPathNavigator      ActivityNode            = null;                     
                XPathNavigator      ResponseNode            = null; 
                XPathNodeIterator   Process_ActivityNodes   = null;
                XPathNodeIterator   Activity_ResponseNodes  = null; 
                StringBuilder       ReturnXML               = null; 
                
                try
                {
                    SR_InputXML = new StringReader(InputXML);
                    InputXMLDoc = new XPathDocument(SR_InputXML);
                    RootNode    = InputXMLDoc.CreateNavigator();
					ReturnXML = new StringBuilder();
					ReturnXML.AppendFormat("<SEARCHOUTPUTXML>");
					ReturnXML.AppendFormat("<RESPONSECOLLECTION>");
                    Process_ActivityNodes = RootNode.Select("descendant::PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY/text() != 'True' and ENDACTIVITY/text() != 'True']");
                    if (Process_ActivityNodes.Count > 0)
                    {                            
                        while (Process_ActivityNodes.MoveNext())
                        {
                            ActivityNode = Process_ActivityNodes.Current;
                            Activity_ResponseNodes = ActivityNode.Select("ACTIVITY_RESPONSE/RESPONSE");
                            if (Activity_ResponseNodes.Count > 0)
                            {
                                while (Activity_ResponseNodes.MoveNext())
                                {
                                    ResponseNode = Activity_ResponseNodes.Current; 
                                    ReturnXML.AppendFormat("{0}", ResponseNode.OuterXml);
                                }
                            }
                        }                            
                    }
					ReturnXML.AppendFormat("</RESPONSECOLLECTION>");
					ReturnXML.AppendFormat("</SEARCHOUTPUTXML>");
                    return ReturnXML.ToString();  
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }

            public XML InsertAttachmentHTML(String DiscussionTaskXML, String ListFacadeXML, String SolutionName)
            {
                XmlDocument         ListXMLDoc              = null;
                XmlNode             ListNode                = null; 
                XmlNode             AttachmentsNode         = null; 
                XmlNodeList         RowNodes                = null;
                String              ResponseID              = null;                    
                String              ObjectID                = null;                    
                String              FieldName               = null; 
                String              FileName                = null; 
                String              SchemaID                = null; 
                String              SequenceOrder           = null; 
                String              FileID                  = null; 
                String              BinderName              = null;
                String              BinderID                = null; 
                XPathDocument       InputXMLDoc             = null; 
                StringReader        SR_InputXML             = null; 
                XPathNavigator      RootNode                = null; 
                XPathNavigator      ResponseNode            = null; 
                XPathNavigator      Process_ActivityNode    = null;
                XPathNavigator      FileSystemNode          = null;
                XPathNavigator      FileNode                = null;                     
                XPathNodeIterator   FileNodes               = null;                     
                StringBuilder       InnerHTML               = null;                    
                StringBuilder       FileURL                 = null; 
                StringBuilder       ParameterList           = null; 
                ALSolutionCommon    AlSolutionCommonObj     = null; 
                int                 FileNodeCount           = 0;
                String              FileDisplayName         = null;
                
                try
                {
                    AlSolutionCommonObj = new ALSolutionCommon();
                    ListXMLDoc          = new XmlDocument();
                    SR_InputXML         = new StringReader(DiscussionTaskXML);
                    InputXMLDoc         = new XPathDocument(SR_InputXML);
                    RootNode    = InputXMLDoc.CreateNavigator();

                    Process_ActivityNode = RootNode.SelectSingleNode("descendant::RESPONSECOLLECTION");

                    ListXMLDoc.LoadXml(ListFacadeXML);
                    ListNode = ListXMLDoc.DocumentElement;
                    RowNodes = ListNode.SelectNodes("Data/Group/Row");

                    if (RowNodes.Count > 0)
                    {
                        foreach (XmlNode RowNode in RowNodes)
                        {
                            ResponseID = RowNode.SelectSingleNode("Column[@Name='RESPONSEID']").InnerText;
                            ResponseNode = Process_ActivityNode.SelectSingleNode("RESPONSE[RESPONSEID/text()='" + ResponseID + "']");
                            if (ResponseNode != null)
                            {
                                //Get the File system node and save it on the NTFS
                                FileSystemNode = ResponseNode.SelectSingleNode("FILESYSTEM");
                                if (FileSystemNode != null)
                                {
                                    if (FileSystemNode.SelectSingleNode("BINDER") != null)
                                    {
                                        BinderName = FileSystemNode.SelectSingleNode("BINDER/NAME").Value;
                                    }
                                    
                                    
                                    InnerHTML = new StringBuilder();
                                    InnerHTML.AppendFormat("<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\">");
                                        InnerHTML.AppendFormat("<tr>");
                                            InnerHTML.AppendFormat("<td valign=\"top\">");

                                    //Create HTML for each file node
                                    FileNodes = FileSystemNode.Select("descendant::FILE");
                                    FileNodeCount = FileNodes.Count;  
                                    while (FileNodes.MoveNext())
                                    {
                                        //Get the required URL parameters
                                        FileNode        = FileNodes.Current;
                                        FieldName       = FileNode.SelectSingleNode("FIELDNAME").Value;
                                        ObjectID        = FileNode.SelectSingleNode("OBJECTID").Value;
                                        FileName        = FileNode.SelectSingleNode("NAME").Value;   
                                        FileDisplayName = FileNode.SelectSingleNode("DISPLAYNAME").Value;   
                                        SchemaID        = FileNode.SelectSingleNode("SCHEMAID").Value;
                                        SequenceOrder   = FileNode.SelectSingleNode("SEQUENCEORDER").Value;  
                                        FileID          = FileNode.SelectSingleNode("FILEID").Value;
                                        BinderID        = FileNode.SelectSingleNode("BINDERID").Value;

                                        FileURL         = new StringBuilder();
                                        ParameterList   = new StringBuilder();

                                        ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&ObjectID={5}&FieldName={6}&SchemaID={7}&FileName={8}&DownloadFileName={8}&SequenceOrder={9}&FileID={10}&AddBinder=Yes&BinderName={11}&BinderID={12}", SessionID, UserID, TenantName, SolutionName, CurrentLanguage, ObjectID, FieldName, SchemaID, System.Web.HttpUtility.UrlEncode(FileName), SequenceOrder, FileID, BinderName, BinderID);
                                        FileURL.AppendFormat("../../Common/ASPX/FileDownload.aspx?Param={0}", AlSolutionCommonObj.EncryptURL(ParameterList.ToString()));
                                        InnerHTML.AppendFormat("<a href=\"{0}\" target=\"_blank\" class=\"TextLink\">{1}</a>", FileURL.ToString(), FileDisplayName);
                                        if (FileNodeCount != FileNodes.CurrentPosition)
                                            InnerHTML.AppendFormat(", ");    
                                            
                                        //Clear strings
                                        ParameterList = null;
                                        FileURL       = null;    
                                    }
                                    InnerHTML.AppendFormat("</td>");
                                    InnerHTML.AppendFormat("</tr>");
                                    InnerHTML.AppendFormat("</table>");
                                    AttachmentsNode = RowNode.SelectSingleNode("Column[@Name='ATTACHMENTS']");
                                    AttachmentsNode.InnerText = InnerHTML.ToString();

                                    InnerHTML = null;    
                                }
                            }
                        }//End or RowNodes foreach loop
                    }
                    return ListXMLDoc.OuterXml; 
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }
            
            /// <alsummary>
            /// <createddate>11-Jan-07</createddate>
            /// <author>Mugdha Moolay.</author>
            /// <purpose>This Functions Creates a Search XML required For the GetHierarchicalData method . It also
            ///  adds additionalfilters to the search xml by interpreting the output XML given by predefined Search.   
            /// </purpose>
            /// </alsummary>
            /// <param name="Ps_FilterXML">This is the predefined search output XML</param>
            /// <returns>A search XML required by GetHierarchicalData method </returns>
            public XML GetPerformListSearchXML(XML Ps_FilterXML, XML xml_SerchInput)
            {
                StringBuilder   TempXML                 = null; 
                StringBuilder   FilterCombination       = null;
                XmlDocument     xmldoc_SearchDoc        = null;
                XmlNode         xmlnode_TergetEntity    = null;
                try
                {
                    TempXML             = new StringBuilder(100);
                    FilterCombination   = new StringBuilder(200);
                    if (Ps_FilterXML != null)
                    {
                        PrepareFilterCombination(ref Ps_FilterXML, "PerformList"); 
                    }
                    if (!String.IsNullOrEmpty(Ps_FilterXML) && !String.IsNullOrEmpty(xml_SerchInput))
                    {
                        xmldoc_SearchDoc = new XmlDocument();
                        xmldoc_SearchDoc.LoadXml(xml_SerchInput);
                        xmlnode_TergetEntity = xmldoc_SearchDoc.SelectSingleNode("SEARCH/TARGETENTITY");
                        if (xmlnode_TergetEntity != null)
                        {
                            xmlnode_TergetEntity.InnerXml += Ps_FilterXML;
                        }
                        TempXML.Append(xmldoc_SearchDoc.OuterXml);
                    }          
                    return (TempXML.ToString());
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            public void  GetFilterCombination(XML Ps_FilterXML, int TotalFilterCount,out String ReturnFilterCombination,out String FilterList)
            {
                StringBuilder FilterXML         = null;
                StringBuilder FilterCombination = null;  
                XmlDocument   TempDoc           = null;    
                String        UIType            = null;  
                XmlNodeList   FilterNodeList    = null;                      
                try
                {
                    TempDoc   = new XmlDocument();                    
                    FilterCombination = new StringBuilder();
                    TotalFilterCount++;
                    if (Ps_FilterXML != null)
                    {
                        FilterXML = new StringBuilder();
                        TempDoc.LoadXml(Ps_FilterXML);
                        FilterNodeList = TempDoc.SelectNodes("descendant::Filter");
                        foreach (XmlNode FilterNode in FilterNodeList)
                        {
                            UIType = ((XmlElement)FilterNode).GetAttribute("UIType");
                            switch (UIType.ToUpper())
                            {
                                case "DATERANGE":
                                    if (FilterNode.SelectSingleNode("FilterValueList/FilterValue").HasChildNodes)
                                    {
                                        FilterCombination.AppendFormat("AND({0})", TotalFilterCount.ToString());
                                        FilterXML.AppendFormat("<FILTER>");
                                        FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
                                        FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
                                        FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
                                        FilterXML.AppendFormat("<EXPRESSIONVALUE>");
                                        FilterXML.AppendFormat("<VALUE Order='1'>{0}</VALUE>", FilterNode.SelectSingleNode("FilterValueList/FilterValue/StartDate").InnerXml.ToUpper());
                                        FilterXML.AppendFormat("<VALUE Order='2'>{0}</VALUE>", FilterNode.SelectSingleNode("FilterValueList/FilterValue/EndDate").InnerXml.ToUpper());
                                        FilterXML.AppendFormat("</EXPRESSIONVALUE>");
                                        FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                                        FilterXML.AppendFormat("</FILTER>");
                                        TotalFilterCount++;
                                    }
                                    break;
                                case "LISTBOX":
                                    if ((FilterNode.SelectSingleNode("FilterValueList/FilterValue").HasChildNodes) && (FilterNode.SelectSingleNode("FilterValueList/FilterValue/Value").InnerText != "All"))
                                    {

                                        switch (FilterNode.SelectSingleNode("FilterValueList/FilterValue/Value").InnerText.ToUpper())
                                        {
                                            case "INACTIVE":
                                                FilterCombination.AppendFormat("({0})", TotalFilterCount.ToString());
                                                FilterXML.AppendFormat("<FILTER>");
                                                FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
                                                FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
                                                FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
                                                FilterXML.AppendFormat("<EXPRESSIONVALUE>Completed</EXPRESSIONVALUE>");
                                                FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                                                FilterXML.AppendFormat("</FILTER>");
                                                TotalFilterCount++;
                                                FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
                                                FilterXML.AppendFormat("<FILTER>");
                                                FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
                                                FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
                                                FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
                                                FilterXML.AppendFormat("<EXPRESSIONVALUE>Cancelled</EXPRESSIONVALUE>");
                                                FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                                                FilterXML.AppendFormat("</FILTER>");
                                                TotalFilterCount++;
                                                break;
											case "INACTIVEBRIEFS":
												FilterCombination.AppendFormat("({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>Project Completed</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>Project Cancelled</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												break;
											case "ACTIVEBRIEFS":
												FilterCombination.AppendFormat("({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>DRAFT</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>REVIEW CLOSED</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>SUBMITTED FOR REVIEW</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>SUBMITTED</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>REJECTED</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												FilterCombination.AppendFormat("OR({0})", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<FILTER>");
												FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
												FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
												FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
												FilterXML.AppendFormat("<EXPRESSIONVALUE>ASSIGNED TO PROJECT</EXPRESSIONVALUE>");
												FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
												FilterXML.AppendFormat("</FILTER>");
												TotalFilterCount++;
												break;
												
                                            default:
                                                FilterCombination.AppendFormat("AND({0})", TotalFilterCount.ToString());
                                                FilterXML.AppendFormat("<FILTER>");
                                                FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
                                                FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
                                                FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
                                                FilterXML.AppendFormat("<EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>", FilterNode.SelectSingleNode("FilterValueList/FilterValue/Value").InnerText);
                                                FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                                                FilterXML.AppendFormat("</FILTER>");
                                                TotalFilterCount++;
                                                break;
                                        }
                                    }
                                    else
                                    {
                                        ReturnFilterCombination = null;
                                        FilterList = null;
                                    }
                                    break;
                                case "EDITBOX":
                                    if (FilterNode.SelectSingleNode("FilterValueList/FilterValue").InnerText != "")
                                    {
                                        FilterCombination.AppendFormat("({0})", TotalFilterCount.ToString());
                                        FilterXML.AppendFormat("<FILTER>");
                                        FilterXML.AppendFormat("<FILTERID>{0}</FILTERID>", TotalFilterCount.ToString());
                                        FilterXML.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", ((XmlElement)FilterNode).GetAttribute("Name"));
                                        FilterXML.AppendFormat("<OPERATOR>{0}</OPERATOR>", ((XmlElement)FilterNode).GetAttribute("Operator"));
                                        FilterXML.AppendFormat("<EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>", FilterNode.SelectSingleNode("FilterValueList/FilterValue").InnerText);
                                        FilterXML.AppendFormat("<ISCASESENSITIVE>False</ISCASESENSITIVE>");
                                        FilterXML.AppendFormat("</FILTER>");
                                        TotalFilterCount++;
                                    }
                                    break;
                            }

                        }
                        //FilterCombination.AppendFormat(")");
                        ReturnFilterCombination = FilterCombination.ToString();
                        FilterList = FilterXML.ToString();
                    }
                    else
                    {
                        FilterCombination.AppendFormat(")");
                        ReturnFilterCombination = null;
                        FilterList = null;
                    }
                }
                catch (Exception ExceptionObj)
                {                    
                    throw ExceptionObj;
                }
            }

            public XML GetCatalogedTaskXML(XML InputXML)
            {
                XPathDocument       InputXMLDoc             = null; 
                StringReader        SR_InputXML             = null; 
                XPathNavigator      RootNode                = null;
                XPathNavigator      WFProcessNode           = null;
                XPathNavigator      ActivityNode            = null; 
                XPathNavigator      EndActivityNode         = null; 
                XPathNavigator      Activity_ItemNode       = null; 
                XPathNodeIterator   WorkFlowProcessNodes    = null;
                StringBuilder       ReturnXML               = null;
                String              EndActivitySeqNumber    = null; 
                String              ActivityStatus          = null; 
                int                 SearchActivitySeqNumber = 0; 

                try
                {
                    ReturnXML   = new StringBuilder();
                    SR_InputXML = new StringReader(InputXML);
                    InputXMLDoc = new XPathDocument(SR_InputXML);
                    RootNode    = InputXMLDoc.CreateNavigator();

                    ReturnXML.AppendFormat("<WORKFLOWPROCESSCOLLECTION>"); 

                    //Select the workflowprocess nodes of the subflow activities
                    WorkFlowProcessNodes = RootNode.Select("descendant::SUBFLOWACTIVITY/WORKFLOWPROCESS[WORKFLOWPROCESS_WORKFLOWINFORMATION/WORKFLOWINFORMATION/WORKFLOWSUBCATEGORY = 'Assignment']");
                    while (WorkFlowProcessNodes.MoveNext())
                    {
                        WFProcessNode = WorkFlowProcessNodes.Current;
                        Activity_ItemNode = WFProcessNode.SelectSingleNode("descendant::PROCESS_ACTIVITY/ACTIVITY/ACTIVITY_ITEM");
                        if ((WFProcessNode.SelectSingleNode("STATUS").Value.ToUpper() == "COMPLETED") && (Activity_ItemNode != null) && (Activity_ItemNode.HasChildren))   
                        {
                            //Get the End Activity sequence number
                            EndActivityNode = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[ENDACTIVITY = 'True']");
                            EndActivitySeqNumber = EndActivityNode.SelectSingleNode("SEQUENCENUMBER").Value;
                            SearchActivitySeqNumber = (Convert.ToInt32(EndActivitySeqNumber) - 1);

                            ReturnXML.AppendFormat(@"<WORKFLOWPROCESS>
														<WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>
														<PROCESSNAME>{1}</PROCESSNAME>
														<PROCESS_ACTIVITY>",WFProcessNode.SelectSingleNode("WORKFLOWPROCESSID").Value,ALCommon.TrimAndReplaceSpecialChars(WFProcessNode.SelectSingleNode("PROCESSNAME").Value));

                            while (SearchActivitySeqNumber > 1)
                            {
                                ActivityNode = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[SEQUENCENUMBER = '" + SearchActivitySeqNumber.ToString() + "']");
                                ActivityStatus = ActivityNode.SelectSingleNode("STATUS").Value;
                                Activity_ItemNode = ActivityNode.SelectSingleNode("ACTIVITY_ITEM");
                                if ((ActivityStatus.ToUpper() == "COMPLETED") && ((Activity_ItemNode != null) && (Activity_ItemNode.HasChildren)))
                                {
                                    ReturnXML.AppendFormat("{0}", ActivityNode.OuterXml);
                                    SearchActivitySeqNumber--;
                                }
                                else
                                    SearchActivitySeqNumber--;
                            }
                            ReturnXML.AppendFormat("</PROCESS_ACTIVITY>");
                            ReturnXML.AppendFormat("</WORKFLOWPROCESS>");
                            SearchActivitySeqNumber = 0;
                        }
                    }
                    ReturnXML.AppendFormat("</WORKFLOWPROCESSCOLLECTION>"); 
                    return ReturnXML.ToString();
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);
                }
            }
        
            public XML GetHeaderHTML(String Title, String Div_ClientID)
            {
                StringBuilder HeaderHTML = null;

                try
                {
                    HeaderHTML = new StringBuilder();

                    HeaderHTML.AppendFormat("<tr class=\"PageTitleBar\"><td style=\"width: 3px;\"></td><td class=\"PageTitleText\">{0}</td><td align=\"right\"><a href=\"javascript:hideContentDiv('{1}','');\">", Title, Div_ClientID);
					HeaderHTML.AppendFormat("<img alt=\"Close...\" src=\"/{0}/App_Themes/{1}/Images/ico_Delete_Small.gif\" style=\"border:0\"/></a></td></tr>", TenantName, ThemeName);

                    return HeaderHTML.ToString();
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            //Hemant Karkande for Predecessors
            public XML GetPredecessors(XmlNode WFProcessNode, String ActivityID)
            {
                XmlNode                 Process_ActivityNode    = null;
                XmlNode                 Process_TransitionNode  = null;
                XmlNode                 ActivityNode            = null; 
                XmlNode                 OperationNode           = null; 
                XmlNodeList             TransitionNodes         = null; 
                String                  PrdecessorID            = null; 
                StringBuilder           ReturnXML               = null; 
     
                try
                {
                    ReturnXML = new StringBuilder();
                    ReturnXML.AppendFormat("<PROCESS_ACTIVITY>"); 

                    //Select Process Activities and Process Transition nodes
                    Process_ActivityNode    = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY");
                    Process_TransitionNode  = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");

                    //Select Predecessors
                    TransitionNodes = Process_TransitionNode.SelectNodes("TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID='" + ActivityID + "']");
                    foreach (XmlNode Transition in TransitionNodes)
                    {
                        OperationNode = Transition.Attributes.GetNamedItem("Operation");
                        if ((OperationNode != null) && (OperationNode.InnerText.ToUpper() != "DELETED"))
                        {
                            PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                            ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
                            if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE")
                                ReturnXML.AppendFormat("{0}", ActivityNode.OuterXml);  
                        }
                        else if (OperationNode == null)
                        {
                            PrdecessorID = Transition.SelectSingleNode("FROMACTIVITY/ACTIVITY/ACTIVITYID").InnerText;
                            ActivityNode = Process_ActivityNode.SelectSingleNode("ACTIVITY[ACTIVITYID/text()='" + PrdecessorID + "']");
                            if (ActivityNode.SelectSingleNode("STARTACTIVITY").InnerText.ToUpper() != "TRUE")
                                ReturnXML.AppendFormat("{0}", ActivityNode.OuterXml);  
                        }
                    }
                    ReturnXML.AppendFormat("</PROCESS_ACTIVITY>");
                    return ReturnXML.ToString();
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj); 
                }
            }

            //Hemant Karkande for Predecessors
            public ERRORXML DeletePredecessors(String FilePath, String[] SelectedPredecessorIDList, String ParentID, String ProcessID, ref String ReturnActivityID, ref XmlNode WFProcessNode)
            {
                ERRORXML    ErrorXMLString              = null; 
                XmlDocument RODeliverableXMLDoc         = null;
                XmlDocument OutPutXMLDoc                = null;     
                //XmlNode     WFProcessNode               = null;
                XmlNode     DestActivityNode            = null;
                XmlNode     Process_TransitionNode      = null;
                XmlNode     TransitionNode              = null; 
                XmlNode     TempTransitionNode          = null; 
                XmlNode     TempProcess_TransitionNode  = null; 
                String      ToActivityID                = null; 
                int         TotalNoOfPerdecessors       = 0;
                
                try
                {
                    RODeliverableXMLDoc = new XmlDocument();
                    OutPutXMLDoc        = new XmlDocument();

                    RODeliverableXMLDoc.Load(FilePath);  
                    TotalNoOfPerdecessors = SelectedPredecessorIDList.Length;

                    WFProcessNode = RODeliverableXMLDoc.SelectSingleNode("WORKFLOWPROCESS");

                    DestActivityNode = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[SUBFLOWACTIVITY/WORKFLOWPROCESS/WORKFLOWPROCESSID/text()= '" + ProcessID + "']");
                    ToActivityID = DestActivityNode.SelectSingleNode("ACTIVITYID").InnerText;
                    ReturnActivityID = ToActivityID;

                    TempProcess_TransitionNode = OutPutXMLDoc.CreateElement("PROCESS_TRANSITION");

                    Process_TransitionNode = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");

                    for (int PredecessorCnt = 0; PredecessorCnt < TotalNoOfPerdecessors; PredecessorCnt++)
                    {
                        TransitionNode = Process_TransitionNode.SelectSingleNode("TRANSITION[FROMACTIVITY/ACTIVITY/ACTIVITYID/text() = '" + SelectedPredecessorIDList[PredecessorCnt] + "' and TOACTIVITY/ACTIVITY/ACTIVITYID/text() = '" + ToActivityID + "']");
                        if (TransitionNode != null)
                        {
                            TempTransitionNode = TransitionNode.CloneNode(true);
                            ((XmlElement)TempTransitionNode).SetAttribute("Operation", "Deleted");
                            TempProcess_TransitionNode.AppendChild(OutPutXMLDoc.ImportNode(TempTransitionNode, true));
                            Process_TransitionNode.RemoveChild(TransitionNode);
                        }
                    }
                    RODeliverableXMLDoc.Save(FilePath);
                    //Update Process for the transitions
                    ErrorXMLString = UpdatePredecessors(TempProcess_TransitionNode, ParentID, FilePath);
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }
            
            //Hemant Karkande for Predecessors
            public ERRORXML SelectPredecessor_OK_Click(String TransitionXMLPath, String ROXMLPath, String ParentID, ref String ReturnActivityID, ref XmlNode WFProcessNode)
            {
                ERRORXML        ErrorXMLString          = null; 
                XmlDocument     ROXMLDoc                = null;
                XmlDocument     TrnsitionXMLDoc         = null; 
                //XmlNode         WFProcessNode           = null;
                XmlNode         Process_TransitionNode  = null; 
                XmlNode         TempNode                = null;
                XmlNode         ParentNode              = null; 
                XmlNodeList     ModifiedTranitions      = null; 
                try
                {
                    ROXMLDoc        = new XmlDocument();
                    TrnsitionXMLDoc = new XmlDocument();

                    ROXMLDoc.Load(ROXMLPath);

                    WFProcessNode = ROXMLDoc.SelectSingleNode("WORKFLOWPROCESS");
                    Process_TransitionNode = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");
                    WFProcessNode.RemoveChild(Process_TransitionNode);

                    TrnsitionXMLDoc.Load(TransitionXMLPath);
                    Process_TransitionNode = TrnsitionXMLDoc.DocumentElement;
                    TempNode = Process_TransitionNode.Clone();
                    ModifiedTranitions = Process_TransitionNode.SelectNodes("TRANSITION[@Operation='Deleted' or @Operation='New']");
                    if (ModifiedTranitions.Count > 0)
                    {
                        foreach (XmlNode Transition in ModifiedTranitions)
                        {
                            if (Transition.Attributes.GetNamedItem("Operation").InnerText.ToUpper() == "DELETED")
                            {
                                ParentNode = Transition.ParentNode;
                                ParentNode.RemoveChild(Transition);
                            }
                            else if (Transition.Attributes.GetNamedItem("Operation").InnerText.ToUpper() == "NEW")
                                Transition.Attributes.RemoveAll();
                        }
                    }
                    WFProcessNode.AppendChild(ROXMLDoc.ImportNode(Process_TransitionNode, true));
                    ROXMLDoc.Save(ROXMLPath);
                    ErrorXMLString = UpdatePredecessors(TempNode, ParentID, ROXMLPath);   
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }
            
            public String getUserName(XPathNavigator ParentNav)
            {
                String          LoginName   = null;
                String          FirstName   = null;
                String          MiddleName  = null;
                String          LastName    = null;
                String          UserName    = null;
                XPathNavigator  UserNav     = null; 
                try
                {
                    UserNav = ParentNav.SelectSingleNode("USER");
                    if (UserNav != null)
                    {
                        LoginName   = UserNav.SelectSingleNode("LOGINNAME").Value;
                        FirstName   = UserNav.SelectSingleNode("FIRSTNAME").Value;
                        MiddleName  = UserNav.SelectSingleNode("MIDDLEINITIAL").Value;
                        LastName    = UserNav.SelectSingleNode("LASTNAME").Value;
                    }
                    else
                    {
                        LoginName   = ParentNav.SelectSingleNode("LOGINNAME").Value;
                        FirstName   = ParentNav.SelectSingleNode("FIRSTNAME").Value;
                        MiddleName  = ParentNav.SelectSingleNode("MIDDLEINITIAL").Value;
                        LastName    = ParentNav.SelectSingleNode("LASTNAME").Value;
                    }
                    UserName = ALCommon.FormatUserName(FirstName, LastName, MiddleName, LoginName, ALCommon.GetUserNameFormat());
                    return UserName;
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            public String getLogedInUserName()
            {
                StringBuilder   UserXMLPath = null;
                XPathDocument   UserXMLDoc  = null;
                XPathNavigator  UserXMLNav  = null;
                String          LoginName   = null;
                String          FirstName   = null;
                String          MiddleName  = null;
                String          LastName    = null;
                String          UserName    = null;
                try
                {
                    UserXMLPath = new StringBuilder();
					UserXMLPath.Append(ALSolutionCommon.GetDataFolderPath(TenantName,UserID) + UserID + ".xml");
					
                    if (File.Exists(UserXMLPath.ToString()))
                    {
                        UserXMLDoc = new XPathDocument(UserXMLPath.ToString());
                        UserXMLNav = UserXMLDoc.CreateNavigator();
                        LoginName  = UserXMLNav.SelectSingleNode("USER/LOGINNAME").Value;
                        FirstName  = UserXMLNav.SelectSingleNode("USER/FIRSTNAME").Value;
                        MiddleName = UserXMLNav.SelectSingleNode("USER/MIDDLEINITIAL").Value;
                        LastName   = UserXMLNav.SelectSingleNode("USER/LASTNAME").Value;

                        UserName = ALCommon.FormatUserName(FirstName, LastName, MiddleName, LoginName, ALCommon.GetUserNameFormat());
                    }
                    return UserName;
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }
            
            public String GetEmailScreenURL(String SolutionName, String TaskID, String ScreenName, String ActivityID)
            {
                String          DefaultPageMode             = null;
                String          CommunicationProtocol       = null;
                String          InternetAddress             = null;
                StringBuilder   DefaultPageParameterList    = null;
                StringBuilder   ParameterList               = null;
                StringBuilder   SolutionPageUrl             = null;
                StringBuilder   DefaultPageUrl              = null;

                try
                {   
                    DefaultPageMode       = "EMAIL";
                    CommunicationProtocol = ALCommon.GetCommunicationProtocol();
                    InternetAddress       = ALCommon.GetInternetAddress();
                    
                    SolutionPageUrl  = new StringBuilder();
                    SolutionPageUrl.AppendFormat("{0}{1}/{2}/{3}/ASPX/WorkBenchLinkHandler.ashx", CommunicationProtocol, InternetAddress, TenantName, SolutionName);

                    if (ScreenName.ToUpper() == "RESPONSE")
                    {
                        ParameterList = new StringBuilder();
                        ParameterList.AppendFormat("Mode=PERFORM&SourceID={0}&SourceType=TASK&StepID={1}&PrevScreen=PERFORMLIST", TaskID, ActivityID);
                    }
                    else if (ScreenName.ToUpper() == "READONLY")
                    {
                        ParameterList = new StringBuilder();
						ParameterList.AppendFormat("Mode=MANAGE&SourceID={0}&SourceType=TASK&TaskReader=YES", TaskID);
                    }

                    DefaultPageParameterList = new StringBuilder();
                    DefaultPageParameterList.AppendFormat("Language={0}&Mode={1}&SolutionPage={2}&Param={3}", CurrentLanguage, DefaultPageMode, SolutionPageUrl, ALCommon.Encrypt(ParameterList.ToString()));
                    
                    DefaultPageUrl = new StringBuilder();
                    DefaultPageUrl.AppendFormat("{0}{1}/{2}/default.aspx?{3}", CommunicationProtocol, InternetAddress, TenantName, DefaultPageParameterList.ToString());
                    
                    DefaultPageUrl = DefaultPageUrl.Replace("&", "%26");

                    return DefaultPageUrl.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            public String GetEmailScreenURLForBrief(String SolutionName, String BriefID, String Mode)
            {
                String          DefaultPageMode             = null;
                String          CommunicationProtocol       = null;
                String          InternetAddress             = null;
                StringBuilder   DefaultPageParameterList    = null;
                StringBuilder   ParameterList               = null;
                StringBuilder   SolutionPageUrl             = null;
                StringBuilder   DefaultPageUrl              = null;

                try
                {   
                    DefaultPageMode       = "EMAIL";
                    CommunicationProtocol = ALCommon.GetCommunicationProtocol();
                    InternetAddress       = ALCommon.GetInternetAddress();
                    
                    SolutionPageUrl  = new StringBuilder();
                    SolutionPageUrl.AppendFormat("{0}{1}/{2}/{3}/ASPX/WorkBenchLinkHandler.ashx", CommunicationProtocol, InternetAddress, TenantName, SolutionName);

                    ParameterList = new StringBuilder();
                    ParameterList.AppendFormat("Mode={0}&BriefID={1}&SourceType=BRIEF", Mode, BriefID);

                    //if (ScreenName.ToUpper() == "RESPONSE")
                    //{
                    //    ParameterList = new StringBuilder();
                    //    ParameterList.AppendFormat("Mode=PERFORM&BriefID={0}&SourceType=BRIEF", BriefID);
                    //}
                    //else if (ScreenName.ToUpper() == "READONLY")
                    //{
                    //    ParameterList = new StringBuilder();
                    //    ParameterList.AppendFormat("Mode=MANAGE&BriefID={0}&SourceType=BRIEF", BriefID);
                    //}

                    DefaultPageParameterList = new StringBuilder();
                    DefaultPageParameterList.AppendFormat("Language={0}&Mode={1}&SolutionPage={2}&Param={3}", CurrentLanguage, DefaultPageMode, SolutionPageUrl, ALCommon.Encrypt(ParameterList.ToString()));
                    
                    DefaultPageUrl = new StringBuilder();
                    DefaultPageUrl.AppendFormat("{0}{1}/{2}/default.aspx?{3}", CommunicationProtocol, InternetAddress, TenantName, DefaultPageParameterList.ToString());
                    
                    DefaultPageUrl = DefaultPageUrl.Replace("&", "%26");

                    return DefaultPageUrl.ToString();
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }
            
            public XML GetNSearchFilterXML(XML PredefinedSearchXML,String SearchType)
            {
				XPathDocument		searchDoc		= null;
				XPathNavigator		searchNav		= null;
				XPathNavigator		filterValueNav	= null;
				XPathNavigator		filterNav		= null;
				XPathNavigator		valueNav		= null;
				XPathNavigator		StartDateNav	= null;
				XPathNavigator		EndDateNav		= null;
				XPathNodeIterator	FilterIterator	= null;
				StringReader		strPdSearchXml	= null;
				String				UIType			= null;
				String			    Operator		= null;
				StringBuilder		FilterList		= null;
				try
				{
					FilterList  = new StringBuilder();
					if (!String.IsNullOrEmpty(PredefinedSearchXML))
					{
						FilterList.AppendFormat("<FILTERLIST>");
						strPdSearchXml = new StringReader(PredefinedSearchXML);
						searchDoc	   = new XPathDocument(strPdSearchXml);
						searchNav	   = searchDoc.CreateNavigator();
						FilterIterator = searchNav.Select("descendant::Filter");
						while (FilterIterator.MoveNext())
						{
							filterNav = FilterIterator.Current;								
							UIType	  = filterNav.GetAttribute("UIType", "");
							Operator  = filterNav.GetAttribute("Operator","");
							switch (UIType.ToUpper())
							{
								case "LISTBOX":
								 switch (SearchType.ToUpper())
								 {
									case "PROJECTLIST":
											filterValueNav = filterNav.SelectSingleNode("FilterValueList/FilterValue");
											if((filterValueNav!=null)&&(filterValueNav.HasChildren)&&(filterValueNav.InnerXml.ToUpper().Equals("NONE")==false))
											{													
												valueNav = filterValueNav.SelectSingleNode("Value");
												if (valueNav !=null)														
												{
													switch (valueNav.InnerXml.ToUpper())
													{
														case "ACTIVE":
															FilterList.Append("<FILTER>");
															FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
															FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
															FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
															FilterList.AppendFormat("<EXPRESSIONVALUE>('Active','Draft','New','onHold')</EXPRESSIONVALUE>");
															FilterList.Append("</FILTER>");
																break;
														case "INACTIVE":
															FilterList.Append("<FILTER>");
																FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
																FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
																FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
																FilterList.AppendFormat("<EXPRESSIONVALUE>('Completed','Cancelled')</EXPRESSIONVALUE>");
															FilterList.Append("</FILTER>");
																break;
														default:
															break;																		
														
													}
													
												}													
											}
											break;
                                        case "PERFOMRLIST":
                                            filterValueNav = filterNav.SelectSingleNode("FilterValueList/FilterValue");
                                            if ((filterValueNav != null) && (filterValueNav.HasChildren) && (filterValueNav.InnerXml.ToUpper().Equals("NONE") == false))
                                            {
                                                valueNav = filterValueNav.SelectSingleNode("Value");
                                                if (valueNav != null)
                                                {
                                                    switch (valueNav.InnerXml.ToUpper())
                                                    {
                                                        case "ACTIVE":
                                                            FilterList.Append("<FILTER>");
                                                            FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
                                                            FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
                                                            FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
                                                            FilterList.AppendFormat("<EXPRESSIONVALUE>('Active', 'OnHold')</EXPRESSIONVALUE>");
                                                            FilterList.Append("</FILTER>");
                                                            break;
                                                        case "INACTIVE":
                                                            FilterList.Append("<FILTER>");
                                                            FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
                                                            FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
                                                            FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
                                                            FilterList.AppendFormat("<EXPRESSIONVALUE>('Completed','Cancelled')</EXPRESSIONVALUE>");
                                                            FilterList.Append("</FILTER>");
                                                            break;
                                                        default:
                                                            break;

                                                    }

                                                }
                                            }
                                            break;
                                        case "BRIEFREQUESTLIST":
											filterValueNav = filterNav.SelectSingleNode("FilterValueList/FilterValue");
											if((filterValueNav!=null)&&(filterValueNav.HasChildren)&&(filterValueNav.InnerXml.ToUpper().Equals("NONE")==false))
											{													
												valueNav = filterValueNav.SelectSingleNode("Value");
												if (valueNav !=null)														
												{
													switch (valueNav.InnerXml.ToUpper())
													{
                                                        case "ACTIVEBRIEFS":
															FilterList.Append("<FILTER>");
															FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
															FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
															FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
                                                            FilterList.AppendFormat("<EXPRESSIONVALUE>('Project Deleted','ASSIGNED TO PROJECT','REJECTED','SUBMITTED','SUBMITTED FOR REVIEW','REVIEW CLOSED','DRAFT', 'Project OnHold', 'Project Resumed')</EXPRESSIONVALUE>");
															FilterList.Append("</FILTER>");
																break;
														case "INACTIVEBRIEFS":
															FilterList.Append("<FILTER>");
																FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
																FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
																FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
                                                                FilterList.AppendFormat("<EXPRESSIONVALUE>('Project Cancelled','Project Completed')</EXPRESSIONVALUE>");
															FilterList.Append("</FILTER>");
																break;
														default:
															break;																		
														
													}
													
												}													
											}
											break;
                                        case "DELIVERABLELIST":
                                            filterValueNav = filterNav.SelectSingleNode("FilterValueList/FilterValue");
                                            if ((filterValueNav != null) && (filterValueNav.HasChildren) && (filterValueNav.InnerXml.ToUpper().Equals("NONE") == false))
                                            {
                                                valueNav = filterValueNav.SelectSingleNode("Value");
                                                if (valueNav != null)
                                                {
                                                    switch (valueNav.InnerXml.ToUpper())
                                                    {
                                                        case "ACTIVE":
                                                            FilterList.Append("<FILTER>");
                                                            FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
                                                            FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
                                                            FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
                                                            FilterList.AppendFormat("<EXPRESSIONVALUE>('Active','Draft','New','onHold')</EXPRESSIONVALUE>");
                                                            FilterList.Append("</FILTER>");
                                                            break;
                                                        case "INACTIVE":
                                                            FilterList.Append("<FILTER>");
                                                            FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
                                                            FilterList.AppendFormat("<OPERATOR>{0}</OPERATOR>", Operator);
                                                            FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
                                                            FilterList.AppendFormat("<EXPRESSIONVALUE>('Completed','Cancelled')</EXPRESSIONVALUE>");
                                                            FilterList.Append("</FILTER>");
                                                            break;
                                                        default:
                                                            break;
                                                    }

                                                }
                                            }
                                            break;
								 }
								 break;
								 case "DATERANGE":
										filterValueNav = filterNav.SelectSingleNode("FilterValueList/FilterValue");
									   StartDateNav =  filterValueNav.SelectSingleNode("StartDate");
									   EndDateNav	= filterValueNav.SelectSingleNode("EndDate");
									   
									 switch (SearchType.ToUpper())
									 {
										case "PROJECTLIST":
										case "BRIEFSFORREVIEW":
                                        case "BRIEFLIST":
                                        case "BRIEFREQUESTLIST":
                                        case "PERFOMRLIST":
												if(filterValueNav!=null)
												{														
													if((StartDateNav != null) && (EndDateNav!=null))
													{
														FilterList.Append("<FILTER>");
														FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
														FilterList.AppendFormat("<OPERATOR>INRANGE</OPERATOR>");
														FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
														FilterList.AppendFormat("<EXPRESSIONVALUE>");
															FilterList.AppendFormat("<VALUE Order='1'>{0}</VALUE>", filterNav.SelectSingleNode("FilterValueList/FilterValue/StartDate").InnerXml.ToUpper());
															FilterList.AppendFormat("<VALUE Order='2'>{0}</VALUE>", filterNav.SelectSingleNode("FilterValueList/FilterValue/EndDate").InnerXml.ToUpper());
														FilterList.AppendFormat("</EXPRESSIONVALUE>");
														FilterList.Append("</FILTER>");
													}
													else
													if(StartDateNav != null)
													{
														FilterList.Append("<FILTER>");
														FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
														FilterList.AppendFormat("<OPERATOR>GREATERTHANEQUALTO</OPERATOR>");
														FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
														FilterList.AppendFormat("<EXPRESSIONVALUE>");
															FilterList.AppendFormat(@"<VALUE>
                                                                        <DAY>{0}</DAY>
                                                                        <MONTH>{1}</MONTH>
                                                                        <YEAR>{2}</YEAR>
                                                                    </VALUE>", StartDateNav.SelectSingleNode("Day").InnerXml, StartDateNav.SelectSingleNode("Month").InnerXml, StartDateNav.SelectSingleNode("Year").InnerXml);	
														FilterList.AppendFormat("</EXPRESSIONVALUE>");
														FilterList.Append("</FILTER>");
													}
													else if(EndDateNav != null)
													{
														FilterList.Append("<FILTER>");
														FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
														FilterList.AppendFormat("<OPERATOR>LESSTHANEQUALTO</OPERATOR>");
														FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
														FilterList.AppendFormat("<EXPRESSIONVALUE>");
														FilterList.AppendFormat(@"<VALUE>
                                                                        <DAY>{0}</DAY>
                                                                        <MONTH>{1}</MONTH>
                                                                        <YEAR>{2}</YEAR>
                                                                    </VALUE>", EndDateNav.SelectSingleNode("Day").InnerXml, EndDateNav.SelectSingleNode("Month").InnerXml, EndDateNav.SelectSingleNode("Year").InnerXml);
														FilterList.AppendFormat("</EXPRESSIONVALUE>");
														FilterList.Append("</FILTER>");
													}														
													
												}
												break;
									 }										   
									break;
									case "EDITBOX":
										filterValueNav = filterNav.SelectSingleNode("FilterValueList/FilterValue");
										FilterList.Append("<FILTER>");
										FilterList.AppendFormat("<FILTERID>{0}</FILTERID>", filterNav.GetAttribute("FilterID", ""));
										FilterList.AppendFormat("<OPERATOR>LIKE</OPERATOR>");
										FilterList.AppendFormat("<EXPRESSION>{0}</EXPRESSION>", filterNav.GetAttribute("Name", ""));
										FilterList.AppendFormat("<EXPRESSIONVALUE>{0}",ALCommon.TrimAndReplaceSpecialChars(filterValueNav.Value));
										FilterList.AppendFormat("</EXPRESSIONVALUE>");
										FilterList.Append("</FILTER>");
									break;
							}								
						}
						FilterList.AppendFormat("</FILTERLIST>");						    
					}
					return FilterList.ToString();
				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
            }

            public static void DeleteOperationFromBinder(String FileName)
            {
                XmlDocument BinderFile = null;
                XmlNodeList FileList = null;
                try
                {
                    BinderFile = new XmlDocument();
                    BinderFile.Load(FileName);
                    FileList = BinderFile.DocumentElement.SelectNodes("//FILE");
                    foreach (XmlElement File in FileList)
                    {
                        if (File.HasAttribute("Operation"))
                        {
                            File.RemoveAttribute("Operation");
                        }
                    }
                    BinderFile.Save(FileName);
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

            public static void GetSolutionConfigXMLNavigator(String TenantName, String SolutionName, out XmlDocument SolutionConfigDoc)
            {
                String SolutionConfigPath = null;

                try
                {
                    SolutionConfigPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "", "SolutionConfiguration");

                    SolutionConfigDoc = new XmlDocument();
                    SolutionConfigDoc.Load(SolutionConfigPath);

                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }
            
            public void	GetGroupListXML(String ResourceTypeList,out XML GroupListXML)
            {
				String[]		EntityIDList = null;
				StringBuilder	ReturnXML	= null;		 
				
				try
				{
					ReturnXML	= new StringBuilder();
					EntityIDList = ResourceTypeList.Split(';');
					
					ReturnXML.Append("<GROUPLIST>");
					for(int i = 0; i < EntityIDList.Length; i++)
					{				
						ReturnXML.AppendFormat("<GROUPNAME>{0}</GROUPNAME>", EntityIDList[i]);

					}
					ReturnXML.Append("</GROUPLIST>");
					GroupListXML = ReturnXML.ToString();
				}
				catch(Exception ExceptionObj)
				{
					throw ExceptionObj;
				}
            }

            public XPathNavigator GetPM_APM_and_DM(String ProjectID, String DeliverableID, out String PMID, out String APMID, out String DMID, out Boolean b_PCAU)
            {
                SearchConfiguration SearchConfigObj = null; 
                ERRORXML            ErrorXML        = null;
                XML                 OutputXML       = null; 
                StringBuilder       SearchXML       = null;
                StringReader        SR_SearchXML    = null;
                XPathDocument       XP_SearchXML    = null;
                XPathNavigator      Root_SearchXML  = null;
                MktgWorkBenchFacadeClass obj_MWBFacade = null;
                //b_PCAU :Project Complete Access User.

                try
                {
                    b_PCAU = false;
                    PMID  = "0";
                    APMID = "0";
                    DMID  = "0";
                    OutputXML = null;
                    SearchXML = new StringBuilder();
                    SearchXML.AppendFormat(@"<SEARCH>
                                            <SESSIONINFO SessionID='{0}' UserID='{1}' TenantName='{2}' Language='{3}'/>
                                            <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                            <TARGETENTITY>
	                                            <PRIVILEGENAME>READ</PRIVILEGENAME>
	                                            <FILTERLIST>
		                                            <FILTER>
			                                            <FILTERID>1</FILTERID>
			                                            <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                            <OPERATOR>EQUALTO</OPERATOR>
			                                            <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
			                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                            </FILTER>
	                                            </FILTERLIST>
	                                            <SELECTLIST>
		                                            <EXPRESSION>
			                                            <FIELDNAME>PROCESSNAME</FIELDNAME>
			                                            <ALIAS>PROCESSNAME</ALIAS>
		                                            </EXPRESSION>
	                                            </SELECTLIST>
                                                <RELATIONSHIP NAME='PROJECTMANAGER'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
	                                                        <FIELDNAME>USERID</FIELDNAME>
	                                                        <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROCESSCOMPLETEACCESS_USER'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>USERID</FIELDNAME>
                                                            <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
                                                        <FILTER>
                                                            <EXPRESSION>STATUS</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>Active</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </RELATIONSHIP>
                                                 <RELATIONSHIP NAME='PROCESSCOMPLETEACCESS_GROUP'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>GROUPID</FIELDNAME>
                                                            <ALIAS>GROUPID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                    <FILTERLIST>
                                                        <FILTER>
                                                            <EXPRESSION>ISDELETED</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='ACTINGPROJECTMANAGER'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>USERID</FIELDNAME>
                                                            <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>", SessionID, UserID, TenantName, CurrentLanguage, ProjectID);
                    if (!String.IsNullOrEmpty(DeliverableID))  
                    {
                        SearchXML.AppendFormat(@"<RELATIONSHIP NAME='PROJECT_DELIVERABLE'>
                                                    <FILTERLIST>
		                                                <FILTER>
			                                                <FILTERID>1</FILTERID>
			                                                <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>
	                                                </FILTERLIST>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                            <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                    <RELATIONSHIP NAME='DELIVERABLEMANAGER'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>USERID</FIELDNAME>
                                                                <ALIAS>USERID</ALIAS>
                                                            </EXPRESSION>
                                                        </SELECTLIST>
                                                    </RELATIONSHIP>
                                                </RELATIONSHIP>", DeliverableID);   
                    }
                    SearchXML.AppendFormat(@"</TARGETENTITY>
                                        </SEARCH>");

                    SearchConfigObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    ErrorXML = SearchConfigObj.GetHierarchialData(SearchXML.ToString(), ref OutputXML);
                    if (String.IsNullOrEmpty(ErrorXML))
                    {
                        SR_SearchXML = new StringReader(OutputXML);
                        XP_SearchXML = new XPathDocument(SR_SearchXML);
                        Root_SearchXML = XP_SearchXML.CreateNavigator();

                        PMID = Root_SearchXML.SelectSingleNode("descendant::PROJECTMANAGER/USER/USERID").Value;
                        APMID = Root_SearchXML.SelectSingleNode("descendant::ACTINGPROJECTMANAGER/USER/USERID").Value;

                        if (!String.IsNullOrEmpty(DeliverableID))
                            DMID = Root_SearchXML.SelectSingleNode("descendant::DELIVERABLEMANAGER/USER/USERID").Value;

                        obj_MWBFacade = new MktgWorkBenchFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);
                        b_PCAU = obj_MWBFacade.isUserFromProjectCompleteAccessUserGroup(UserID, Root_SearchXML);
                    }
                    return Root_SearchXML;
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj); 
                }
            }
    
            /// <summary>
            /// <CreatedOn>19 March 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To preare filter combination</Purpose>
            /// </summary>
            /// <param name="Ps_InputXML">Filter List XML</param>
            public void PrepareFilterCombination(ref String Ps_InputXML, String ListScreenName)
            {
                XmlDocument     FilterListXMLDoc        = null;
                XmlNode         FilterListNode          = null;
                XmlNode         FilterCombinationNode   = null; 
                XmlNodeList     FilterNodeList          = null; 
                StringBuilder   FilterCombination       = null; 
                StringBuilder   UserID_FilterCombination= null; 
                String          str_DMFilterID          = null; 
 
                try
                {
                    FilterCombination           = new StringBuilder();
                    UserID_FilterCombination    = new StringBuilder();
                    FilterListXMLDoc            = new XmlDocument();

                    FilterListXMLDoc.LoadXml(Ps_InputXML);
                    FilterListNode = FilterListXMLDoc.DocumentElement;

                    FilterNodeList = FilterListNode.SelectNodes("FILTER");
                    if (FilterNodeList.Count > 1)
                    {
                        foreach (XmlNode FilterNode in FilterNodeList)
                        {
                            if (ListScreenName.ToUpper() == "PROJECTLIST" || ListScreenName.ToUpper() == "REQUESTLIST" || ListScreenName.ToUpper() == "TASKLIST")
                            {
                                if ((FilterNode.SelectSingleNode("EXPRESSION").InnerText.ToUpper() != "GROUPID") && (FilterNode.SelectSingleNode("EXPRESSION").InnerText.ToUpper() != "USERID"))
                                {
                                    if (FilterCombination.Length > 0)
                                    {
                                        FilterCombination.AppendFormat("AND({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                    else
                                    {
                                        FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                                else
                                {
                                    if (UserID_FilterCombination.Length > 0)
                                    {
                                        UserID_FilterCombination.AppendFormat("OR({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                    else
                                    {
                                        UserID_FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                            }
                            else if (ListScreenName.ToUpper() == "SEARCH_AND_COPY_DELIVERABLE")
                            {
                                if (FilterNode.SelectSingleNode("EXPRESSION").InnerText.ToUpper() != "USERID")
                                {
                                    if (FilterCombination.Length > 0)
                                    {
                                        FilterCombination.AppendFormat("AND({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                    else
                                    {
                                        FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                                else
                                {
                                    if (UserID_FilterCombination.Length > 0)
                                    {
                                        UserID_FilterCombination.AppendFormat("OR({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                    else
                                    {
                                        UserID_FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                            }
                            else if (ListScreenName.ToUpper() == "DELIVERABLELIST")
                            {
                                if ((FilterNode.SelectSingleNode("RELATIONSHIPNAME") != null) && (FilterNode.SelectSingleNode("RELATIONSHIPNAME").InnerText.ToUpper() == "DELIVERABLEMANAGER"))
                                {
                                    str_DMFilterID = FilterNode.SelectSingleNode("FILTERID").InnerText;
                                }
                                else if (FilterNode.SelectSingleNode("EXPRESSION").InnerText.ToUpper() == "WORKFLOWPROCESSID")
                                {
                                    if (FilterCombination.Length > 0)
                                    {
                                        if (!String.IsNullOrEmpty(str_DMFilterID))
                                        {
                                            FilterCombination.AppendFormat(")AND((" + str_DMFilterID + ")OR({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                        }
                                        else
                                        {
                                            FilterCombination.AppendFormat(")AND(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                        }
                                    }
                                    else
                                    {
                                        FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                                else
                                {
                                    if (FilterCombination.Length > 0)
                                    {
                                        FilterCombination.AppendFormat("AND({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                    else
                                    {
                                        FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                            }
                            else if (ListScreenName.ToUpper() == "DELIVERABLELIST_NO_DEL_ID")
                            {
                                if (FilterNode.SelectSingleNode("EXPRESSION").InnerText.ToUpper() != "WORKFLOWPROCESSID")
                                {

                                    if (FilterCombination.Length > 0)
                                    {
                                        FilterCombination.AppendFormat("AND({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                    else
                                    {
                                        FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                    }
                                }
                            }
                            else
                            {
                                if (FilterCombination.Length > 0)
                                {
                                    FilterCombination.AppendFormat("AND({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                }
                                else
                                {
                                    FilterCombination.AppendFormat("(({0})", FilterNode.SelectSingleNode("FILTERID").InnerText);
                                }
                            }
                        }

                        if (UserID_FilterCombination.Length > 0)
                        {
                            UserID_FilterCombination.Append(")"); 
                        }

                        if (FilterCombination.Length > 0)
                        {
                            if (UserID_FilterCombination.Length > 0)
                            {
                                FilterCombination.AppendFormat("AND{0}", UserID_FilterCombination.ToString());
                            }
                            FilterCombination.Append(")");

                            FilterCombinationNode           = FilterListXMLDoc.CreateElement("FILTERCOMBINATION");
                            FilterCombinationNode.InnerText = FilterCombination.ToString();
                            FilterListNode.AppendChild(FilterCombinationNode);
                        }
                        else if (UserID_FilterCombination.Length > 0) 
                        {
                            FilterCombination.AppendFormat("{0}", UserID_FilterCombination.ToString());

                            FilterCombinationNode           = FilterListXMLDoc.CreateElement("FILTERCOMBINATION");
                            FilterCombinationNode.InnerText = FilterCombination.ToString();
                            FilterListNode.AppendChild(FilterCombinationNode);
                        }
                    }
                    Ps_InputXML = FilterListXMLDoc.OuterXml;  
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>20 March 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To prepare back url for the Predefined search widget</Purpose>
            /// </summary>
            /// <param name="GoToDashBoardPage"></param>
            /// <returns></returns>
            public String PrepareBackURLforPredefinedSearch(Boolean GoToDashBoardPage)
            {
                StringBuilder BackURL = null; 
                try
                {
                    BackURL = new StringBuilder();
                    if (GoToDashBoardPage)
                    {
                        BackURL.AppendFormat("/{0}/Common/ASPX/DefaultScene_DefaultPage.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", TenantName, CurrentLanguage, SessionID, UserID);
                    }
                    else
                    {
                        BackURL.AppendFormat("/{0}/MarketingWorkBench/ASPX/Manage_ProjectList.aspx?TenantName={0}&Language={1}&SessionID={2}&UserID={3}", TenantName, CurrentLanguage, SessionID, UserID);
                    }
                    return BackURL.ToString(); 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

			/// <alsummary>
			/// <CreatedOn>4 Jun 08</CreatedOn>
			/// <Author>Mugdha Moolay</Author>
			/// <Purpose>This method prepares an XML consisting of all 
			/// the resource types for an Activity along with the selected Resource Type</Purpose>
			/// </alsummary>
			/// <param name="ActivityNode">The Activity node for which the resource XML is to be prepared.</param>
			/// <returns>The Activity Resource XML</returns>
			public String GetActivityResourceXML(XmlNode ActivityNode)
			{
				StringBuilder	ReturnActivityXML	= null;
				XmlNodeList		ResourceNodeList	= null;
				XmlNode			ActResNode			= null;
				String			ResourceType		= null;					
				String			SelecteResType		= null;
				try
				{
					ReturnActivityXML = new StringBuilder();
					if (ActivityNode!=null)
					{
						ReturnActivityXML.AppendFormat("<ACTIVITY ActivityID='{0}'>",ActivityNode.SelectSingleNode("ACTIVITYID").InnerText);
						ResourceNodeList = ActivityNode.SelectNodes("ACTIVITY_RESOURCE/RESOURCE");
						foreach(XmlNode RNode in ResourceNodeList)
						{
							if(RNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE") != null)
							{
								ActResNode = RNode.SelectSingleNode("ACTUAL_RESOURCE/RESOURCE");
								SelecteResType = ActResNode.SelectSingleNode("RESOURCETYPE").InnerText;
								ResourceType = RNode.SelectSingleNode("RESOURCETYPE").InnerText;
								ReturnActivityXML.AppendFormat(@"<RESOURCE ResourceID='{0}'  Selected='True' SelectedGroupName='{1}'>
																<RESOURCETYPE>{2}</RESOURCETYPE>
															",RNode.SelectSingleNode("RESOURCEID").InnerText,  ALCommon.TrimAndReplaceSpecialChars(SelecteResType), ALCommon.TrimAndReplaceSpecialChars(ResourceType));
								//Add code to set the selected resourcetype.
								ReturnActivityXML.Append("</RESOURCE>");
							}
							else
							{
								ReturnActivityXML.AppendFormat(@"<RESOURCE ResourceID='{0}'>
																<RESOURCETYPE>{1}</RESOURCETYPE>
															",RNode.SelectSingleNode("RESOURCEID").InnerText, ALCommon.TrimAndReplaceSpecialChars(RNode.SelectSingleNode("RESOURCETYPE").InnerText));
								//Add code to set the selected resourcetype.
								ReturnActivityXML.Append("</RESOURCE>");
							}
						}
						ReturnActivityXML.AppendFormat("</ACTIVITY>");							
					}
					return ReturnActivityXML.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			/// <alsummary>
			/// <CreatedOn>4 Jun 08</CreatedOn>
			/// <Author>Mugdha Moolay</Author>
			/// <Purpose>This method prepares the input XML reqired for the drop down list 
			/// of Contributors on Assignment and Gather Information Task.</Purpose>
			/// </alsummary>
			/// <param name="UserDoc">The XML that contains the uswr List</param>
			/// <returns>Item List XML required for the drop down list</returns>		
			public XML  GetContributorXML(XPathDocument UserDoc)
            {					
				StringBuilder ItemListXML   = null;				
				XmlDocument   SortDoc       = null;					
				XPathNavigator	  UserNav	= null;
				XPathNodeIterator UserIter  = null;
                String        UserID        = null;
                String        LoginName     = null;                    
                String        FirstName     = null;
                String        LastName      = null;  
                String        MiddleName    = null;                    
                String        FormattedName = null;
                String        SortedXML     = null;
                String		  ItemList		= null;
                XPathDocument       xp_SortDoc        = null;
                XPathExpression     xp_SortExpression = null;
                XPathNodeIterator   xp_SortNodeIter   = null;
                
                try
                {
					ItemListXML = new StringBuilder();
					SortDoc		= new XmlDocument();
					UserNav		= UserDoc.CreateNavigator();
					UserIter	= UserNav.Select("descendant::USER");
					if(UserIter.Count > 0)
					{
						ItemListXML.AppendFormat("<ItemList>");
						while(UserIter.MoveNext())
						{
							UserID		= UserIter.Current.SelectSingleNode("USERID").Value;
							LoginName	= UserIter.Current.SelectSingleNode("LOGINNAME").Value;
                            FirstName	= UserIter.Current.SelectSingleNode("FIRSTNAME").Value;
                            MiddleName  = UserIter.Current.SelectSingleNode("MIDDLEINITIAL").Value;
                            LastName	= UserIter.Current.SelectSingleNode("LASTNAME").Value;
							FormattedName = ALCommon.FormatUserName(FirstName, LastName, MiddleName, LoginName, ALCommon.GetUserNameFormat());
                            ItemListXML.AppendFormat("<Item Selected='No'><DisplayValue>{0}</DisplayValue><Value>{1}</Value></Item>", ALCommon.TrimAndReplaceSpecialChars(FormattedName), UserID);								
						}
                        ItemListXML.AppendFormat("</ItemList>");

						xp_SortDoc              = new XPathDocument(new StringReader(ItemListXML.ToString()));
                        xp_SortExpression       = XPathExpression.Compile("ItemList/Item");
                        xp_SortExpression.AddSort("DisplayValue", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                        xp_SortNodeIter         = xp_SortDoc.CreateNavigator().Select(xp_SortExpression);
                        while (xp_SortNodeIter.MoveNext())
                        {
                           SortedXML         += xp_SortNodeIter.Current.OuterXml;
                        }
                        ItemList = "<Item Selected='Yes'><DisplayValue>" + Localization.GetString("ALResource", TenantName, "MWB_Manage_AssignContributor_SelectContributor_Shared") + "</DisplayValue><Value>None</Value></Item>" + SortedXML;
					}
                    else
                    {
                        ItemList = "<Item Selected='Yes'><DisplayValue>" + Localization.GetString("ALResource", TenantName, "MWB_Manage_AssignContributor_SelectContributor_Shared") + "</DisplayValue><Value>None</Value></Item>";
                    }
					return ItemList;
                }
                catch (Exception ExceptionObj)
                {                        
                    throw ExceptionObj;
                }
            }				

			/// <alsummary>
			/// <CreatedOn>4-Jun-08</CreatedOn>
			/// <Author>Mugdha Moolay</Author>
			/// <Purpose>This funtion prepares the User Selection XML</Purpose>
			/// </alsummary>
			/// <param name="GroupXML">The group XML that contains all the users</param>
			/// <param name="UserCollectionXML">Return XML consisting of users</param>
			/// <param name="GroupID">The GroupID</param>
			public void GetGroupIDAndUserXML(XML GroupXML, out XML UserCollectionXML, out String GroupID)
			{
				XPathDocument	GpDoc		= null;
				XPathNavigator	GpNav		= null;
				StringBuilder	ReturnXml	= null;
				XPathNodeIterator xpIter	= null;
				try
				{
					ReturnXml = new StringBuilder();
					GroupID   = null;
					if(GroupXML!= null)
					{
						GpDoc	= new XPathDocument(new StringReader(GroupXML));
						GpNav	= GpDoc.CreateNavigator();
                        if (GpNav.SelectSingleNode("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUPID") != null)
						    GroupID = GpNav.SelectSingleNode("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUPID").Value;

						xpIter  = GpNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER");
						ReturnXml.Append("<SEARCHOUTPUTXML><USERCOLLECTION>");
						while(xpIter.MoveNext())
						{
							ReturnXml.Append(xpIter.Current.OuterXml);
						}
						ReturnXml.Append("</USERCOLLECTION></SEARCHOUTPUTXML>");
					}
					UserCollectionXML = ReturnXml.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			/// <alsummary>
			/// <CreatedOn></CreatedOn>
			/// </alsummary>
			/// <param name="StepID"></param>
			/// <param name="StepResourceFileName"></param>
			/// <param name="SelectedResName"></param>
			/// <returns></returns>
			public String GetSelectedActivityResourceID(XPathDocument ActResDoc, String StepID,out String SelectedResName)
			{					
				XPathNavigator	xpNav		= null;					
				StringBuilder	xpathQuery	= null;
				try
				{
					
					xpathQuery		= new StringBuilder();
					SelectedResName = null;
					if(ActResDoc != null)
					{
						xpathQuery.AppendFormat("ACTIVITYCOLLECTION/ACTIVITY[@ActivityID={0}]/RESOURCE[@Selected='True']", StepID);
						xpNav = ActResDoc.CreateNavigator();
						xpNav = xpNav.SelectSingleNode(xpathQuery.ToString());
						if(xpNav != null)
						{
							SelectedResName = xpNav.GetAttribute("SelectedGroupName", "");
							return xpNav.GetAttribute("ResourceID", "");
						}
					}
					return "NONE";
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			public XML InsertHTMLForAssignContributor(String HiddenBtnID, List<ModifyContributor> ModContList,  String ListSourceXML)
			{
				
				XmlDocument			ListSrcDoc			= null;
				XmlNodeList			RowNodes			= null;
				XmlNode				ColNode				= null;					
				String				RName				= null;
				String				ResourceID			= null;
				ModifyContributor	McObj				= null;
				ModifyContributor	DummyObj			= null;
				Predicate<ModifyContributor> FindResByName = null;
				ContributorFilter	CfObj				= null;
				try
				{
					ListSrcDoc			= new XmlDocument();						
					ListSrcDoc.LoadXml(ListSourceXML);
					RowNodes = ListSrcDoc.DocumentElement.SelectNodes("Data/Group/Row");
					foreach(XmlNode RowNode in RowNodes)
					{							
						
						ColNode			= RowNode.SelectSingleNode("Column[@Name='RESOURCETYPES']");							
						RName			= RowNode.SelectSingleNode("Column[@Name='RESOURCENAME']").InnerText;
						McObj			= new ModifyContributor("",RName);
						if(ModContList != null)
						{
							CfObj			= new ContributorFilter("", RName);
							FindResByName	= new Predicate<ModifyContributor>(CfObj.CompareDummyResourceName);
							DummyObj = ModContList.Find(FindResByName);
							if(DummyObj != null)
							{
								if(!String.IsNullOrEmpty(DummyObj.ActualResourceName))
									RName = DummyObj.ActualResourceName;
							}
						}
						ResourceID		= RowNode.SelectSingleNode("Column[@Name='RESOURCEID']").InnerText;
						ColNode.InnerText = getColumnHTMLForContributor(ResourceID,RName,HiddenBtnID);
					}
					return ListSrcDoc.OuterXml;
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			public XML getColumnHTMLForContributor(String ResourceID, String ResourceName, String HiddenBtnID)
			{
				StringBuilder		HtmlInput			= null;
				StringBuilder		ImagePath			= null;
				StringBuilder		Url					= null;
				StringBuilder		ParameterList		= null;
				StringBuilder		PageUrl				= null;
				ALSolutionCommon	AlSolutionCommonObj = null;
				try
				{
					HtmlInput		= null;
					Url				= null;
					ParameterList	= null;
					HtmlInput		= new StringBuilder(200);
					Url				= new StringBuilder(100);
					ParameterList	= new StringBuilder(80);
					PageUrl			= new StringBuilder(50);
					ImagePath			= new StringBuilder(50);						
					AlSolutionCommonObj = new ALSolutionCommon();
					ImagePath.AppendFormat("/{0}/App_Themes/{1}/images/icon_Large_Add_Values.gif", TenantName, ThemeName);
					ParameterList.AppendFormat("SessionID={0}&UserID={1}&TenantName={2}&SolutionName={3}&Language={4}&ResourceID={5}&HiddenBtnID={6}&FromScreen=AssignContributor", SessionID, UserID, TenantName, SolutionName, CurrentLanguage, ResourceID, HiddenBtnID);
					PageUrl.AppendFormat("SelectResourceType.aspx?Param={0}", AlSolutionCommonObj.EncryptURL(ParameterList.ToString()));
					Url.AppendFormat("javascript:OpenNewWindow('{0}','_new','left=150,top=150,width=500,height=500,scrollbars=yes')", PageUrl.ToString());
					HtmlInput.Append("<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%;\">");						
					HtmlInput.Append("<tr><td class=\"Text\" style=\"width:90%;\">");
					HtmlInput.Append(ALCommon.TrimAndReplaceSpecialChars(ResourceName));
					HtmlInput.Append("</td><td class=\"Text\">");
					HtmlInput.AppendFormat("<img src=\"/{0}/App_Themes/{1}/Images/spacer.gif\" alt=\"\" height=\"1px\"/></td><td>", TenantName, ThemeName);						
					HtmlInput.AppendFormat("<a href=\"{0}\"><img src=\"{1}\" alt=\"\" style='border: 0;'></img></a>", Url.ToString(), ImagePath.ToString());
					HtmlInput.Append("</td></tr></table>");						
					return HtmlInput.ToString();
				}
				catch(Exception ExcepObj)
				{
					throw ExcepObj;
				}
			}

			/// <alsummary>
			/// <createddate></createddate>
			/// <author>Mugdha Moolay</author>
			/// </alsummary>
			/// <param name="BuiltInFormName">The built in form name</param>
			/// <param name="DynamicFormName">The form generated per entity type</param>
			/// <param name="strSelectedFormName">The selected form name returned</param>
			/// <returns>The Form config XML path</returns>
			public String GetFormConfigXMLPath(String BuiltInFormName,String DynamicFormName,out String strSelectedFormName)
            {            
                StringBuilder   FormConfigXMLPath               = null;
                StringBuilder   DefaultFormConfigXMLPath        = null;
                String          InstalledPath                   = null;
                String          str_DefaultFormConfigXmlName    = null;
                String          str_CustomFormConfigXmlName     = null;
                
                try
                {                               
                    FormConfigXMLPath           = new StringBuilder();
                    DefaultFormConfigXMLPath    = new StringBuilder();
                    InstalledPath				= ALSolutionCommon.GetInstallationDir();
                    //Project_Details_FormConfiguration.xml
					str_DefaultFormConfigXmlName = BuiltInFormName + "_FormConfiguration";
                    DefaultFormConfigXMLPath.Append(ALSolutionCommon.GetFormConfigurationXMLPath(TenantName, "MarketingWorkBench", str_DefaultFormConfigXmlName));

					if((DynamicFormName != null) && (DynamicFormName != ""))
                    {
						str_CustomFormConfigXmlName = DynamicFormName + "_FormConfiguration";
                        FormConfigXMLPath.Append(ALSolutionCommon.GetFormConfigurationXMLPath(TenantName, "MarketingWorkBench", str_CustomFormConfigXmlName));

                        if (File.Exists(FormConfigXMLPath.ToString()))
                        {
							strSelectedFormName = DynamicFormName;
							return FormConfigXMLPath.ToString();
                        }
                    }
					strSelectedFormName = BuiltInFormName;
                    return DefaultFormConfigXMLPath.ToString();

                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

            /// <summary>
            /// <CreatedOn>20 Octobber 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To Get the Process and Activity additional facets</Purpose>
            /// </summary>
            /// <param name="str_PackageDefinitionID">Package Definition ID from which process is referred</param>
            /// <param name="str_ProcessDefinitionID">Process Definition ID for which associated facets are required</param>
            /// <param name="str_ActivityDefinitionID">Activity Definition ID if for any specific activity related facets are required otherwise it will return for all the activitites</param> 
            /// <param name="bool_ActivityFacetsReq">Indicates whether activity associated facets are required or not</param> 
            /// <param name="str_ProcessAssocatedFacets">Return Process Associated facets</param>
            /// <param name="str_ActivityAssociatedFacets">Retun Activity Associated facets</param>
            /// <returns>
            /// Null: if no error
            /// ERRORXML: if any error
            /// </returns>
            public ERRORXML GetAssociatedAdditionalFacets(String str_PackageDefinitionID, String str_ProcessDefinitionID, String str_ActivityDefinitionID, Boolean bool_ActivityFacetsReq, out String str_ProcessAssocatedFacets, out String str_ActivityAssociatedFacets)
            {
                ERRORXML            ErrorXMLString              = null;
                PMFacadeClass       PMFacadeObj                 = null; 
                XPathDocument       xp_ProcessDefinition        = null; 
                XPathNavigator      nav_WFProcess               = null;
                XPathNavigator      nav_Activity                = null;
                XPathNodeIterator   iter_ProcessAssoFacets      = null;
                XPathNodeIterator   iter_ActivityAssoFacets     = null; 
                XPathNodeIterator   iter_Activity               = null;
                StringBuilder       sb_ProcessAssociatedFacets  = null; 
                StringBuilder       sb_ActivityAssociatedFacets = null; 
                XML                 XML_ProcessDefinitionXML    = null; 
                XPathDocument       xp_ErrorDoc                 = null;
                XPathNavigator      xp_ErrorNav                 = null;

                try
                {
                    str_ProcessAssocatedFacets  = null;
                    str_ActivityAssociatedFacets= null;
                    sb_ActivityAssociatedFacets = new StringBuilder(100);
                    sb_ProcessAssociatedFacets  = new StringBuilder(100);
                    PMFacadeObj                 = new PMFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);    

                    //Get the Process Definition
                    ErrorXMLString = PMFacadeObj.GetProcessDefinitionByID(str_PackageDefinitionID, str_ProcessDefinitionID, out XML_ProcessDefinitionXML);
                    if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(XML_ProcessDefinitionXML)))
                    {
                        xp_ProcessDefinition = new XPathDocument(new StringReader(XML_ProcessDefinitionXML));
                        nav_WFProcess = xp_ProcessDefinition.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS");
                        if (nav_WFProcess != null)
                        {
                            //put process related standard facets
                            sb_ProcessAssociatedFacets.Append(@"<PROCESS_INFORMATION Type='RELATION' />
                                                                <WORKFLOWPROCESS_WORKFLOWINFORMATION Type='RELATION' />");
                            iter_ProcessAssoFacets = nav_WFProcess.Select("PROCESS_RELATEDFACETS/FACET");
                            while (iter_ProcessAssoFacets.MoveNext())
                            {
                                if ((iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME") != null) && (!String.IsNullOrEmpty(iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value)))
                                {
                                    sb_ProcessAssociatedFacets.Append("<" + iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + " Type='RELATION' GetAllFacets='FALSE' />");
                                }
                            }
                            str_ProcessAssocatedFacets = sb_ProcessAssociatedFacets.ToString();  
                        }

                        if (bool_ActivityFacetsReq)
                        {
                            sb_ActivityAssociatedFacets.Append(@"<ACTIVITY_INFORMATION Type='RELATION' />
                                                             <ACTIVITY_WEBSERVICE Type='RELATION' />");
                            //check whether Activity facets are required for any specific activity
                            if (!String.IsNullOrEmpty(str_ActivityDefinitionID))
                            {
                                nav_Activity = nav_WFProcess.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[ACTIVITYID = " + str_ActivityDefinitionID + "]");
                                if (nav_Activity != null)
                                {
                                    iter_ActivityAssoFacets = nav_Activity.Select("ACTIVITY_RELATEDFACETS/FACET");
                                    while (iter_ActivityAssoFacets.MoveNext())
                                    {
                                        sb_ActivityAssociatedFacets.Append("<" + iter_ActivityAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + " Type='RELATION' GetAllFacets='FALSE' />");
                                    }
                                }
                            }
                            else
                            {
                                //Get it for all the activities other than Start, End and Subflow activities
                                iter_Activity = nav_WFProcess.Select("PROCESS_ACTIVITY/ACTIVITY[IMPLEMENTATIONTYPE = 'Task']");
                                while (iter_Activity.MoveNext())
                                {
                                    nav_Activity = iter_Activity.Current;
                                    iter_ActivityAssoFacets = nav_Activity.Select("ACTIVITY_RELATEDFACETS/FACET");
                                    while (iter_ActivityAssoFacets.MoveNext())
                                    {
                                        if (!sb_ActivityAssociatedFacets.ToString().Contains("<" + iter_ActivityAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + " Type='RELATION'"))
                                        {
                                            sb_ActivityAssociatedFacets.Append("<" + iter_ActivityAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + " Type='RELATION' GetAllFacets='FALSE' />");
                                        }
                                    }
                                }
                            }
                            str_ActivityAssociatedFacets = sb_ActivityAssociatedFacets.ToString();
                        }
                    }
                    else if (!String.IsNullOrEmpty(ErrorXMLString))
                    {
                        xp_ErrorDoc         = new XPathDocument(new StringReader(ErrorXMLString));
                        xp_ErrorNav         = xp_ErrorDoc.CreateNavigator().SelectSingleNode("ERROR/MESSAGE");
                        if ((xp_ErrorNav != null) && (xp_ErrorNav.Value == "Process node with the given process id not found."))
                        {
                            ErrorXMLString = null;
                        }
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>21 October 2008</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To convert Process related facets to GetHierarchical Data XML</Purpose>
            /// </summary>
            /// <param name="str_ProcessAssociatedFacets">Process related facets from GetAssociatedAdditionalFacets()</param>
            public void ConvertRelatedFacetsToGetHierarchialData(ref String str_ProcessAssociatedFacets)
            {
                XPathDocument       xp_ProcessFacets        = null;
                XPathNodeIterator   iter_FacetList          = null;
                StringBuilder       sb_ConvertedFacetList   = null; 
     
                try
                {
                    sb_ConvertedFacetList = new StringBuilder(100);

                    str_ProcessAssociatedFacets = "<Root>" + str_ProcessAssociatedFacets + "</Root>";
                    xp_ProcessFacets = new XPathDocument(new StringReader(str_ProcessAssociatedFacets));
                    iter_FacetList = xp_ProcessFacets.CreateNavigator().Select("Root/child::node()");
                    while (iter_FacetList.MoveNext())
                    {
                        sb_ConvertedFacetList.Append("<RELATIONSHIP NAME='" + iter_FacetList.Current.Name + "'>");
                        if (iter_FacetList.Current.GetAttribute("GetAllFacets", "").Equals("TRUE"))
                        {
                            sb_ConvertedFacetList.Append(@"<SEARCHALLFACETS>TRUE</SEARCHALLFACETS>
                                                        </RELATIONSHIP>");
                        }
                        else
                        {
                            sb_ConvertedFacetList.Append("</RELATIONSHIP>");
                        }
                    }

                    if (sb_ConvertedFacetList.Length > 0)
                    {
                        str_ProcessAssociatedFacets = sb_ConvertedFacetList.ToString();  
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }


            /// <alsummary>
            /// <CreatedOn>5 Feb 09</CreatedOn>
            /// <Author>Mugdha Moolay</Author>
            /// <Purpose>This method updates the State XML used by the Select Resource Type pop-up if a resource type is deleted using the Remove Button.</Purpose>
            /// </alsummary>
            /// <param name="ActivityID">The StepID for which resource is selected</param>
            /// <param name="StepResourceFileName">The State XML File Name</param>
            public void UpdateStateXMLForResourceType(String StepResourceFileName, String ActivityID)
            {                
                String      str_TempFilePath    = null; 
                XmlDocument ResourceDoc         = null;
                XmlNode     ActivityNode        = null;
                XmlNode     ResNode             = null;
                try
                {                    
                    // Update the Resource File Name for the Activity
                    str_TempFilePath = ALSolutionCommon.GetTempPath(SessionID.ToString()) + StepResourceFileName;
                    if (File.Exists(str_TempFilePath))
                    {
                        ResourceDoc = new XmlDocument();
                        ResourceDoc.Load(str_TempFilePath);
                        ActivityNode = ResourceDoc.SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY[@ActivityID='" + ActivityID + "']");
                        if (ActivityNode != null)
                        {
                            ResNode = ActivityNode.SelectSingleNode("RESOURCE[@Selected='True']");
                            if (ResNode != null)
                            {
                                ((XmlElement)ResNode).RemoveAttribute("Selected");
                                ((XmlElement)ResNode).RemoveAttribute("SelectedGroupName");
                                ResourceDoc.Save(str_TempFilePath);
                            }
                        }
                    }                    
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }
            }

            /// <alsummary>
            /// <createddate>9 February 2009</createddate>
            /// <author>Bhalchandra Kadam</author>
            /// <purpose>Shows the brief Initiator.</purpose>
            /// </alsummary>
            public void ShowBriefInitiator(ref XmlNode xmlNode_FieldNode, String str_BriefInitiator, String str_BriefInitiatorID)
            {
                StringBuilder       sb_UrlPath              = null;
                ALSolutionCommon    ALSolutionCommonObj     = null;
                try
                {
                    //Show Brief Initiator
                    if (xmlNode_FieldNode != null)
                    {
                        ALSolutionCommonObj = new ALSolutionCommon();
                        sb_UrlPath          = new StringBuilder(200);
                        sb_UrlPath.Append("/" + TenantName + "/Common/ASPX/ROUserDetails.aspx?Language=" + CurrentLanguage + "&TenantName=" + TenantName
                            + "&UserID=" + UserID + "&SessionID=" + SessionID + "&RequestedUserID=" + str_BriefInitiatorID);
                        xmlNode_FieldNode.InnerXml = "<Value><a href='#' onclick=\"javascript:var windowtop = (window.parent.screen.height - 300)/2; var windowleft = (window.parent.screen.width - 700) /2; window.open('" + ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_UrlPath.ToString()) + "','_blank','menubar=0,toolbar=0,height=300,width=700,resizable=1,top=' + windowtop + ',left=' + windowleft);\" Class='TextLink'>" + str_BriefInitiator + "</a></Value>";
                    }
                    
                }
                catch (Exception obj_Exception)
                {
                    throw obj_Exception;
                }
            }
            
            /// <summary>
            /// <CreatedOn> 23 Feb 2009</CreatedOn>
            /// <Author> Radha A</Author>
            /// <Purpose> To get time stamp</Purpose>
            /// </summary>
            /// <returns> time stamp in string format</returns>
            public String GetTimeStamp()
            {
                String      str_TimeStamp   = null;
                DateTime    DateTimeObj = new DateTime();
                try
                {
                    DateTimeObj   = DateTime.Now;
                    str_TimeStamp = DateTimeObj.Day.ToString() + DateTimeObj.Month.ToString() + DateTimeObj.Year.ToString() + DateTimeObj.Hour.ToString() + DateTimeObj.Minute.ToString() + DateTimeObj.Second.ToString() + DateTimeObj.Millisecond.ToString();

                    return str_TimeStamp; 
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            // Kavita: To add in the separator configured for the activity path
            public void GetActivityPathSeparator(ref String ActivityPath)
            {
                XPathDocument   xpDoc_SolutionConfig        = null;
                XPathNavigator  xpNav_SolutionConfig        = null;
                XPathNavigator  xpNav_SolutionConfigRoot    = null;
                XPathNavigator  xpNav_ActivityPathSeparator = null;
                String          str_ActivityPathSeparator   = null;
                String          str_SolutionConfigXMLPath   = null;
                try
                {
                    str_SolutionConfigXMLPath   = ALSolutionCommon.GetConfigurationXMLPath(TenantName, "StrategicPlanner", "", "SolutionConfiguration");
                    xpDoc_SolutionConfig        = new XPathDocument(str_SolutionConfigXMLPath);
                    xpNav_SolutionConfig        = xpDoc_SolutionConfig.CreateNavigator();
                    xpNav_SolutionConfigRoot    = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration");
                    xpNav_ActivityPathSeparator = xpNav_SolutionConfigRoot.SelectSingleNode("ACTIVITYPATHCONFIGURATION/SEPARATOR");
                    if (xpNav_ActivityPathSeparator != null)
                    {
                        str_ActivityPathSeparator = xpNav_ActivityPathSeparator.Value;

                        ActivityPath = ActivityPath.Replace("$ALP$", " " + str_ActivityPathSeparator + " ");
                    }
                    else
                        ActivityPath = ActivityPath.Replace("$ALP$", " " + ">>" + " ");
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            // Kavita: To fetch the nomenclature for the marketing activity
            public String GetActivityNomenclature(String ActivityLevel)
            {
                XPathDocument   xpDoc_SolutionConfig        = null;
                XPathNavigator  xpNav_SolutionConfig        = null;
                XPathNavigator  xpNav_SolutionConfigRoot    = null;
                XPathNavigator  xpNav_ActivityLevelConfig   = null;
                XPathNavigator  xpNav_ActivityLevelName     = null;
                String          str_ActivityNomenclature    = null;
                String          str_SolutionConfigXMLPath   = null;

                try
                {
                    str_SolutionConfigXMLPath   = ALSolutionCommon.GetConfigurationXMLPath(TenantName, "StrategicPlanner", "", "SolutionConfiguration");
                    xpDoc_SolutionConfig        = new XPathDocument(str_SolutionConfigXMLPath);
                    xpNav_SolutionConfig        = xpDoc_SolutionConfig.CreateNavigator();
                    xpNav_SolutionConfigRoot    = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration");
                   
                    xpNav_ActivityLevelConfig   = xpNav_SolutionConfigRoot.SelectSingleNode("ACTIVITYLEVEL_NOMENCLATURE");
                    if (xpNav_ActivityLevelConfig != null)
                    {
                        xpNav_ActivityLevelName = xpNav_ActivityLevelConfig.SelectSingleNode("ACTIVITYLEVEL[@Level='" + ActivityLevel + "']");
                        if (xpNav_ActivityLevelName != null)
                            str_ActivityNomenclature = xpNav_ActivityLevelName.SelectSingleNode("SINGULARNAME").Value;
                    }
                    else
                        str_ActivityNomenclature = "Marketing Activity";



                    return str_ActivityNomenclature;
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }
            
          // Kavita: To fetch the nomenclature, activity path separator and the access control details for the marketing activity
            public String GetMarketingActivityInfo(String ActivityLevel, String ActivityID, ref String ActivityPath, ref Boolean bAccessPresent)
            {
                XPathDocument   xpDoc_SolutionConfig        = null;
                XPathNavigator  xpNav_SolutionConfig        = null;
                XPathNavigator  xpNav_SolutionConfigRoot    = null;
                XPathNavigator  xpNav_ActivityLevelConfig   = null;
                XPathNavigator  xpNav_ActivityLevelName     = null;
                XPathNavigator  xpNav_ActivityPathSeparator = null;
                String          str_ActivityPathSeparator   = null;
                String          str_ActivityNomenclature    = null;
                String          str_SolutionConfigXMLPath   = null;
                
                try
                {
                    str_SolutionConfigXMLPath   = ALSolutionCommon.GetConfigurationXMLPath(TenantName, "StrategicPlanner", "", "SolutionConfiguration");
                    xpDoc_SolutionConfig        = new XPathDocument(str_SolutionConfigXMLPath);
                    xpNav_SolutionConfig        = xpDoc_SolutionConfig.CreateNavigator();
                    xpNav_SolutionConfigRoot    = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration");

                    // Fetching the activity type separator
                    xpNav_ActivityPathSeparator = xpNav_SolutionConfigRoot.SelectSingleNode("ACTIVITYPATHCONFIGURATION/SEPARATOR");
                    if (xpNav_ActivityPathSeparator != null)
                    {
                        str_ActivityPathSeparator = xpNav_ActivityPathSeparator.Value;

                        ActivityPath = ActivityPath.Replace("$ALP$", " " + str_ActivityPathSeparator + " ");
                    }
                    else
                        ActivityPath = ActivityPath.Replace("$ALP$", " " + ">>" + " ");

                    // Fetching the nomenclature
                    xpNav_ActivityLevelConfig   = xpNav_SolutionConfigRoot.SelectSingleNode("ACTIVITYLEVEL_NOMENCLATURE");
                    if (xpNav_ActivityLevelConfig != null)
                    {
                        xpNav_ActivityLevelName = xpNav_ActivityLevelConfig.SelectSingleNode("ACTIVITYLEVEL[@Level='" + ActivityLevel + "']");
                        if (xpNav_ActivityLevelName != null)
                            str_ActivityNomenclature = xpNav_ActivityLevelName.SelectSingleNode("SINGULARNAME").Value;
                    }
                    else
                        str_ActivityNomenclature = "Marketing Activity";

                    // Access control check
                    bAccessPresent = CheckForMAAccess(ActivityID, xpNav_SolutionConfigRoot);

                    return str_ActivityNomenclature;
                }
                catch (Exception ExceptionObj)
                {
                    throw ExceptionObj;
                }
            }

            /// <alsummary>
            /// <createddate>09 February 2009</createddate>
            /// <author>Bhalchandra Kadam</author>
            /// <purpose>Hides the Form Field Marketing Activity.</purpose>
            /// </alsummary>
            public void hideMarketingActivity(ref XmlNode xmlNode_Field)
            {
                if (xmlNode_Field != null)
                {
                    ((XmlElement)xmlNode_Field).SetAttribute("FieldVisible", "False");
                }
            }

            /// <summary>
            /// <CreatedOn>15th May 2009</CreatedOn>
            /// <Author>Anita Kale</Author>
            /// <Purpose>This method will set the form for Project Info</Purpose>
            /// </summary>
            /// <param name="FormFacadeObject"></param>
            /// <param name="ObjectID">WorkflowProcessID</param>
            /// <param name="ObjectType">Type of Workflowprocess for which Project is to be set (Task or Deliverable)</param>
            /// <param name="ProjectFormConfigPath"></param>
            /// <param name="ProjectFormInputXML"></param>
            /// <returns></returns>
            public String GetProjectInfo(FormFacade FormFacadeObject, String ObjectID, String ObjectType, ref String ProjectFormConfigPath,ref String ProjectFormInputXML)
            {
                String              str_StdProjectFormName      = null;
                String              str_DynamicProjectFormName  = null;
                String              str_SelectedProjectFormName = null;
                String              str_ProjectTypeID           = null;
                String              str_ProjFormConfigXMLPath   = null;
                String              PercentDoneClass            = null;
                String              str_Status                  = null;
                String              str_ProjectID               = null;
                String              str_PMName                  = null;
                String              str_APMName                 = null;
                String              str_Nomenclature            = null;
                String              str_ActivityLevel           = null;
                String              str_ActivityPath            = null;
                StringBuilder       sb_SessionInfo              = null;
                StringBuilder       sb_FilterXML                = null;
                XML                 xml_ProjectXML              = null;
                XML                 xml_FormInput               = null;
                List<ObjectInfo>    facade_CommonObjectInfo     = null;
                ERRORXML            errorxml_Output             = null;
                XmlDocument         xmldoc_FormInput            = null;
                XmlDocument         xmldoc_SearchInput          = null;
                XmlNode             xmlnode_FieldNode           = null;
                XmlNode             xmlnode_SearchNode          = null;
                XmlNode             xmlnode_TargetEntity        = null;
                XPathDocument       xpathdoc_ProjectData        = null;
                XPathNavigator      xpathnav_ProjectNav         = null;
                XPathNavigator      xpathnav_TempNav            = null;
                XPathNavigator      xpathnav_DueDateNav         = null;
                XML                 xml_SearchInputXML          = null;
                MktgWorkBenchFacadeClass MWBFacadeObject        = null;
                SearchConfiguration SearchObj                   = null;
                StringDictionary    sd_PlaceHolder              = null;
                DateTime            DueDate;
                try
                {
                    str_StdProjectFormName = "Project_Info";
                    getProjectID(ObjectID ,ObjectType, out str_ProjectID, out str_ProjectTypeID);
                    
                    str_DynamicProjectFormName  = str_ProjectTypeID + "_" + str_StdProjectFormName;
                    str_ProjFormConfigXMLPath   = GetFormConfigXMLPath(str_StdProjectFormName, str_DynamicProjectFormName, out str_SelectedProjectFormName);
                    
                    FormFacadeObject.FormName           = str_SelectedProjectFormName;
                    FormFacadeObject.ConfigurationXML   = ProjectFormConfigPath = str_ProjFormConfigXMLPath;
                    errorxml_Output = FormFacadeObject.GetHierarchicalSearchXML("READONLY", out xml_SearchInputXML);
                   
                    if(String.IsNullOrEmpty(errorxml_Output))
                    {
                        xmldoc_SearchInput = new XmlDocument();
                        xmldoc_SearchInput.LoadXml(xml_SearchInputXML);
                        xmlnode_SearchNode = xmldoc_SearchInput.SelectSingleNode("SEARCH");
                        if (xmlnode_SearchNode != null)
                        {
                            //Append SessionInfo
                            sb_SessionInfo = new StringBuilder(50);
                            sb_SessionInfo.Append(@"<AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
                                                    <SESSIONINFO UserID='" + UserID + "' Language='" + CurrentLanguage +
                                                    "' TenantName='"+TenantName+"' SessionID='"+SessionID+"'/>");
                            xmlnode_SearchNode.InnerXml += sb_SessionInfo.ToString();

                            //Append Filter of ProjectID
                            xmlnode_TargetEntity = xmlnode_SearchNode.SelectSingleNode("TARGETENTITY");
                            if (xmlnode_TargetEntity != null)
                            {
                                sb_FilterXML = new StringBuilder(100);
                                sb_FilterXML.Append(@"<FILTERLIST>
					                                    <FILTER>
                                                            <FILTERID>1</FILTERID>
						                                    <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
						                                    <OPERATOR>EQUALTO</OPERATOR>
						                                    <EXPRESSIONVALUE>" + str_ProjectID + @"</EXPRESSIONVALUE>
						                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
					                                    </FILTER>
					                                 </FILTERLIST>
                                                     <PRIVILEGENAME>READ</PRIVILEGENAME>");
                                xmlnode_TargetEntity.InnerXml += sb_FilterXML.ToString();


                                //Append User details fields for Acting project Manager and ProjectManager
                                xmlnode_FieldNode = xmlnode_TargetEntity.SelectSingleNode("RELATIONSHIP[@NAME = 'ACTINGPROJECTMANAGER']/SELECTLIST");
                                if (xmlnode_FieldNode != null)
                                {
                                    xmlnode_FieldNode.InnerXml += @"<EXPRESSION>
					                                                <FIELDNAME>LASTNAME</FIELDNAME>
					                                                <ALIAS>LASTNAME</ALIAS>
				                                                </EXPRESSION>
				                                                <EXPRESSION>
					                                                <FIELDNAME>LOGINNAME</FIELDNAME>
					                                                <ALIAS>LOGINNAME</ALIAS>
				                                                </EXPRESSION>
                                                                <EXPRESSION>
					                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
					                                                <ALIAS>MIDDLEINITIAL</ALIAS>
				                                                </EXPRESSION>";
                                }

                                xmlnode_FieldNode = xmlnode_TargetEntity.SelectSingleNode("RELATIONSHIP[@NAME = 'PROJECTMANAGER']/SELECTLIST");
                                if (xmlnode_FieldNode != null)
                                {
                                    xmlnode_FieldNode.InnerXml += @"<EXPRESSION>
					                                                <FIELDNAME>LASTNAME</FIELDNAME>
					                                                <ALIAS>LASTNAME</ALIAS>
				                                                </EXPRESSION>
				                                                <EXPRESSION>
					                                                <FIELDNAME>LOGINNAME</FIELDNAME>
					                                                <ALIAS>LOGINNAME</ALIAS>
				                                                </EXPRESSION>
                                                                <EXPRESSION>
					                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
					                                                <ALIAS>MIDDLEINITIAL</ALIAS>
				                                                </EXPRESSION>";
                                }
                            }
                        }
                        xml_SearchInputXML = xmldoc_SearchInput.OuterXml;

                        //Get Project Details
                        SearchObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                        errorxml_Output = SearchObj.GetHierarchialData(xml_SearchInputXML, ref xml_ProjectXML);

                        //Get FormInput xml
                        errorxml_Output = FormFacadeObject.GetFormInputXML("READONLY", xml_ProjectXML, out xml_FormInput, out facade_CommonObjectInfo);
                        if (String.IsNullOrEmpty(errorxml_Output))
                        {
                            xmldoc_FormInput = new XmlDocument();
                            xmldoc_FormInput.LoadXml(xml_FormInput);

                            xpathdoc_ProjectData    = new XPathDocument(new StringReader(xml_ProjectXML));
                            xpathnav_ProjectNav     = xpathdoc_ProjectData.CreateNavigator();

                            //PercentDone Class
                            if(xpathnav_ProjectNav!=null)
                            {
                                //Get Status
                                xpathnav_TempNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/STATUS");
                                if (xpathnav_TempNav != null)
                                    str_Status = xpathnav_TempNav.InnerXml.ToString();

                                xpathnav_DueDateNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DUEDATE");
                                if (!String.IsNullOrEmpty(str_Status) && xpathnav_DueDateNav != null && xpathnav_DueDateNav.HasChildren)
                                {
                                    DueDate = new DateTime(Convert.ToInt32(xpathnav_DueDateNav.SelectSingleNode("YEAR").Value), Convert.ToInt32(xpathnav_DueDateNav.SelectSingleNode("MONTH").Value), Convert.ToInt32(xpathnav_DueDateNav.SelectSingleNode("DAY").Value));

                                    xmlnode_FieldNode = xmldoc_FormInput.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESSINFO_PERCENTDONE_PROCESS_INFORMATION']");
                                    if (xmlnode_FieldNode != null)
                                    {
                                        MWBFacadeObject = new MktgWorkBenchFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);
                                        PercentDoneClass = MWBFacadeObject.GetPercentDoneClass(str_Status, DueDate);
                                        ((XmlElement)xmlnode_FieldNode).SetAttribute("PercentDoneClass", PercentDoneClass);
                                    }
                                }
                            }

                            //Set Actual End date
                            if (!String.IsNullOrEmpty(str_Status) && ((str_Status.Equals("Completed", StringComparison.CurrentCultureIgnoreCase)) || (str_Status.Equals("Cancelled", StringComparison.CurrentCultureIgnoreCase))))
                            {
                                xmlnode_FieldNode = xmldoc_FormInput.SelectSingleNode("FieldList/Field[@Name='WORKFLOWPROCESS_ACTUALENDDATE']");
                                if (xmlnode_FieldNode != null)
                                    ((XmlElement)xmlnode_FieldNode).SetAttribute("FieldVisible", "True");
                            }

                            //set Project Manager
                            xpathnav_TempNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/PROJECTMANAGER");
                            if (xpathnav_TempNav != null)
                            {
                                str_PMName = ALSolutionCommon.TrimAndReplaceSpecialChars(getUserName(xpathnav_TempNav));
                                xmlnode_FieldNode = xmldoc_FormInput.SelectSingleNode("FieldList/Field[@Name='USER_FIRSTNAME_PROJECTMANAGER']");
                                if (xmlnode_FieldNode != null)
                                {
                                    xmlnode_FieldNode.InnerXml = "<Value>" + str_PMName + "</Value>";
                                }
                            }

                            //set Acting Project Manager only if project is completed or cancelled
                            xpathnav_TempNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/ACTINGPROJECTMANAGER");
                            if (xpathnav_TempNav != null)
                            {
                                str_APMName = ALSolutionCommon.TrimAndReplaceSpecialChars(getUserName(xpathnav_TempNav));
                                xmlnode_FieldNode = xmldoc_FormInput.SelectSingleNode("FieldList/Field[@Name='USER_FIRSTNAME_ACTINGPROJECTMANAGER']");
                                if (xmlnode_FieldNode != null)
                                {
                                    xmlnode_FieldNode.InnerXml = "<Value>" + str_APMName + "</Value>";
                                }
                            }

                           
                            //Chk Whether ActivityLevel is configured if yes get Nomenclaure else set label as ActivityName
                            xpathnav_TempNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/MARKETINGACTIVITY_PROJECT/MARKETINGACTIVITY/ACTIVITYLEVEL");
                            if (xpathnav_TempNav != null)
                            {
                                str_ActivityLevel = xpathnav_TempNav.InnerXml;
                                if (!String.IsNullOrEmpty(str_ActivityLevel))
                                {
                                    str_Nomenclature    = GetActivityNomenclature(str_ActivityLevel);
                                    if (!String.IsNullOrEmpty(str_Nomenclature))
                                    {
                                        sd_PlaceHolder = new StringDictionary();
                                        sd_PlaceHolder.Add("MARKETINGACTIVITYNAME", str_Nomenclature);
                                    }
                                }
                            }

                            //Set Associated Marketing Activity Name if Configured
                            xmlnode_FieldNode = xmldoc_FormInput.SelectSingleNode("FieldList/Field[@Name='MARKETINGACTIVITY_NAME_MARKETINGACTIVITY_PROJECT']");
                            if (xmlnode_FieldNode != null)
                            {
                                //If Activity Name is not available don't show the Activity Name Field
                                xpathnav_TempNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/MARKETINGACTIVITY_PROJECT/MARKETINGACTIVITY/NAME");
                                if (xpathnav_TempNav == null)
                                {
                                    ((XmlElement)xmlnode_FieldNode).SetAttribute("FieldVisible", "False");
                                }
                                else
                                {
                                    //if level is configured change nomenclature
                                    if(!String.IsNullOrEmpty(str_Nomenclature))
                                        ((XmlElement)xmlnode_FieldNode).SetAttribute("Label", Localization.GetString("ALResource", TenantName, "MWB_MarketingActivity_Shared", sd_PlaceHolder));
                                }
                            }

                            //Set Associated Marketing Activity Path if configured
                            xmlnode_FieldNode = xmldoc_FormInput.SelectSingleNode("FieldList/Field[@Name='MARKETINGACTIVITY_ACTIVITYPATH_MARKETINGACTIVITY_PROJECT']");
                            if (xmlnode_FieldNode != null)
                            {
                                //If Activity Name is not available don't show the Activity Name Field
                                xpathnav_TempNav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/MARKETINGACTIVITY_PROJECT/MARKETINGACTIVITY/ACTIVITYPATH");
                                if (xpathnav_TempNav == null)
                                    ((XmlElement)xmlnode_FieldNode).SetAttribute("FieldVisible", "False");
                                else
                                {
                                    //if level is configured change nomenclature
                                    if (!String.IsNullOrEmpty(str_Nomenclature))
                                        ((XmlElement)xmlnode_FieldNode).SetAttribute("Label", Localization.GetString("ALResource", TenantName, "MWB_ActivityPath_Shared", sd_PlaceHolder));

                                    //send value for replacing Activity path separator
                                    str_ActivityPath = xmlnode_FieldNode.InnerXml;
                                    GetActivityPathSeparator(ref str_ActivityPath);
                                    xmlnode_FieldNode.InnerXml = str_ActivityPath;
                                }
                            }

                            ProjectFormInputXML = xmldoc_FormInput.OuterXml;
                        }
                    }
                    return errorxml_Output;
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }

        
            /// <alsummary>
            /// <CreatedOn>13 May 2009</CreatedOn>
            /// <Autor>Hemant Karkande</Autor>
            /// <Purpose>To Prepare the List Data XML using the given Group XML</Purpose>
            /// </alsummary>
            /// <param name="XML_GroupXML">Group XML</param>
            /// <param name="XML_ListDataXML">Current List Data XML</param>
            public void AddGroupsToUserGroupsListXML(XML XML_GroupXML, ref XML XML_ListDataXML)
            {
                XmlDocument         doc_ListData        = null;
                XmlNode             node_UserGroupColle = null; 
                XmlNodeList         nodeList_UserGroups = null; 
                XPathDocument       xp_InputXMLDoc      = null;
                XPathNodeIterator   iter_Groups         = null; 
                StringBuilder       sb_GroupXML         = null; 
                StringBuilder       sb_ReturnXML        = null; 

                try
                {
                    sb_GroupXML = new StringBuilder(100);
                    sb_ReturnXML= new StringBuilder(150); 

                    if (!String.IsNullOrEmpty(XML_GroupXML))
                    {
                        xp_InputXMLDoc = new XPathDocument(new StringReader(XML_GroupXML));
                        iter_Groups = xp_InputXMLDoc.CreateNavigator().Select("GroupSelectionXML/SelectedGroupsList/GROUP");
                        if (iter_Groups.Count == 0)
                        {
                            iter_Groups = xp_InputXMLDoc.CreateNavigator().Select("GROUPCOLLECTION/GROUP");
                        }
                        while (iter_Groups.MoveNext())
                        {
                            sb_GroupXML.Append("<USERGROUP>"); 
                            if (iter_Groups.Current.SelectSingleNode("GROUPID") != null)
                            {
                                sb_GroupXML.Append(@"<USER_GROUP_ID>" + iter_Groups.Current.SelectSingleNode("GROUPID").Value + "</USER_GROUP_ID>");
                            }
                            if (iter_Groups.Current.SelectSingleNode("GROUPNAME") != null)
                            {
                                sb_GroupXML.Append(@"<USER_GROUP_NAME>" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(iter_Groups.Current.SelectSingleNode("GROUPNAME").Value) + "</USER_GROUP_NAME>");
                            }
                            sb_GroupXML.Append(@"<USER_GROUP>Group</USER_GROUP></USERGROUP>");
                        }

                        if (String.IsNullOrEmpty(XML_ListDataXML))
                        {
                            sb_ReturnXML.Append("<USERGROUPCOLLECTION>" + sb_GroupXML.ToString() + "</USERGROUPCOLLECTION>");
                            XML_ListDataXML = sb_ReturnXML.ToString(); 
                        }
                        else
                        {
                            doc_ListData = new XmlDocument();
                            doc_ListData.LoadXml(XML_ListDataXML);
                            node_UserGroupColle = doc_ListData.SelectSingleNode("USERGROUPCOLLECTION");
                            if (node_UserGroupColle != null)
                            {
                                nodeList_UserGroups = node_UserGroupColle.SelectNodes("USERGROUP[USER_GROUP = 'Group']");
                                foreach (XmlNode node_UserGroup in nodeList_UserGroups)
                                {
                                    node_UserGroupColle.RemoveChild(node_UserGroup);
                                }

                                node_UserGroupColle.InnerXml += sb_GroupXML.ToString();  
                            }
                            XML_ListDataXML = doc_ListData.OuterXml;
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>14 May 2009</CreatedOn>
            /// <Autor>Hemant Karkande</Autor>
            /// <Purpose>To Prepare the List Data XML using the given User XML</Purpose>
            /// </alsummary>
            /// <param name="XML_UserXML">Group XML</param>
            /// <param name="XML_ListDataXML">Current List Data XML</param>
            public void AddUsersToUserGroupsListXML(XML XML_UserXML, ref XML XML_ListDataXML)
            {
                XmlDocument         doc_ListData        = null;
                XmlNode             node_UserGroupColle = null; 
                XmlNodeList         nodeList_UserGroups = null; 
                XPathDocument       xp_InputXMLDoc      = null;
                XPathNodeIterator   iter_Users          = null;
                String              str_UserName        = null; 
                StringBuilder       sb_UserXML          = null; 
                StringBuilder       sb_ReturnXML        = null; 

                try
                {
                    sb_UserXML = new StringBuilder(100);
                    sb_ReturnXML= new StringBuilder(150);

                    if (!String.IsNullOrEmpty(XML_UserXML))
                    {
                        xp_InputXMLDoc = new XPathDocument(new StringReader(XML_UserXML));
                        iter_Users = xp_InputXMLDoc.CreateNavigator().Select("UserSelectionXML/SelectedUsersList/USER");
                        if (iter_Users.Count == 0)
                        {
                            iter_Users = xp_InputXMLDoc.CreateNavigator().Select("USERCOLLECTION/USER");
                        }
                        while (iter_Users.MoveNext())
                        {
                            sb_UserXML.Append("<USERGROUP>");
                            if (iter_Users.Current.SelectSingleNode("USERID") != null)
                            {
                                sb_UserXML.Append(@"<USER_GROUP_ID>" + iter_Users.Current.SelectSingleNode("USERID").Value + "</USER_GROUP_ID>");
                            }
                            if (iter_Users.Current.SelectSingleNode("LOGINNAME") != null)
                            {
                                //get the formated user name
                                str_UserName = getUserName(iter_Users.Current);
                                sb_UserXML.Append(@"<USER_GROUP_NAME>" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(str_UserName) + "</USER_GROUP_NAME>");
                            }
                            sb_UserXML.Append(@"<USER_GROUP>User</USER_GROUP></USERGROUP>");
                        }

                        if (String.IsNullOrEmpty(XML_ListDataXML))
                        {
                            sb_ReturnXML.Append("<USERGROUPCOLLECTION>" + sb_UserXML.ToString() + "</USERGROUPCOLLECTION>");
                            XML_ListDataXML = sb_ReturnXML.ToString(); 
                        }
                        else
                        {
                            doc_ListData = new XmlDocument();
                            doc_ListData.LoadXml(XML_ListDataXML);
                            node_UserGroupColle = doc_ListData.SelectSingleNode("USERGROUPCOLLECTION");
                            if (node_UserGroupColle != null)
                            {
                                nodeList_UserGroups = node_UserGroupColle.SelectNodes("USERGROUP[USER_GROUP = 'User']");
                                foreach (XmlNode node_UserGroup in nodeList_UserGroups)
                                {
                                    node_UserGroupColle.RemoveChild(node_UserGroup);
                                }

                                node_UserGroupColle.InnerXml += sb_UserXML.ToString();  
                            }
                            XML_ListDataXML = doc_ListData.OuterXml;
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>14 May 2009</CreatedOn>
            /// <Author>Hemant Karkande</Author>
            /// <Purpose>To get the User and Group comma seprated ID list</Purpose>
            /// </alsummary>
            /// <param name="XML_UserGroupCollection">UserGroup collection XML</param>
            /// <param name="str_UserIDList">return User ID List</param>
            /// <param name="str_GroupIDList">return Group ID List</param>
            public void GetUserGroupIDList(XML XML_UserGroupCollection, out String str_UserIDList, out String str_GroupIDList)
            {
                XPathDocument       xp_CollectionXML    = null;
                XPathNodeIterator   iter_UserGroup      = null;
                StringBuilder       sb_IDList           = null;

                try
                {
                    str_GroupIDList = null;
                    str_UserIDList  = null;
                    sb_IDList       = new StringBuilder(100);

                    if (!String.IsNullOrEmpty(XML_UserGroupCollection))
                    {
                        xp_CollectionXML = new XPathDocument(new StringReader(XML_UserGroupCollection));
                        
                        //Get the UserIDList first
                        iter_UserGroup = xp_CollectionXML.CreateNavigator().Select("USERGROUPCOLLECTION/USERGROUP[USER_GROUP = 'User']");
                        while (iter_UserGroup.MoveNext())
                        {
                            //USER_GROUP_ID
                            if (iter_UserGroup.Current.SelectSingleNode("USER_GROUP_ID") != null)
                            {
                                sb_IDList.Append(iter_UserGroup.Current.SelectSingleNode("USER_GROUP_ID").Value + ",");
                            }
                        }

                        if (sb_IDList.Length > 0)
                        {
                            str_UserIDList = sb_IDList.ToString();
                            str_UserIDList = str_UserIDList.Remove(str_UserIDList.LastIndexOf(","), 1);

                            sb_IDList.Remove(0, sb_IDList.Length); 
                        }

                        //Now Get the GroupIDList first
                        iter_UserGroup = xp_CollectionXML.CreateNavigator().Select("USERGROUPCOLLECTION/USERGROUP[USER_GROUP = 'Group']");
                        while (iter_UserGroup.MoveNext())
                        {
                            //USER_GROUP_ID
                            if (iter_UserGroup.Current.SelectSingleNode("USER_GROUP_ID") != null)
                            {
                                sb_IDList.Append(iter_UserGroup.Current.SelectSingleNode("USER_GROUP_ID").Value + ",");
                            }
                        }

                        if (sb_IDList.Length > 0)
                        {
                            str_GroupIDList = sb_IDList.ToString();
                            str_GroupIDList = str_GroupIDList.Remove(str_GroupIDList.LastIndexOf(","), 1);

                            sb_IDList.Remove(0, sb_IDList.Length);
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>19 May 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To Get the Users and Groups details using the given ID lists, and prepare the List data XML</Purpose>
            /// </alsummary>
            /// <param name="str_UserIDList">User ID List</param>
            /// <param name="str_GroupIDList"Group ID List</param>
            /// <param name="XML_UsersGroupsListData">Return List data XML</param>
            /// <returns>
            /// NULL : if no error.
            /// ERRORXML: if any.
            /// </returns>
            public ERRORXML GetUsersGroupsXML(String str_UserIDList, String str_GroupIDList, out XML XML_UsersGroupsListData, out XML XML_UserDetails, out XML XML_GroupDetails)
            {
                ERRORXML    ErrorXMLString      = null; 

                try
                {
                    XML_UsersGroupsListData = null;
                    XML_UserDetails         = null;
                    XML_GroupDetails        = null; 

                    //Get the Users Details
                    if (!String.IsNullOrEmpty(str_UserIDList))
                    {
                        ErrorXMLString = GetUsersDetails(str_UserIDList, out XML_UserDetails);
                        if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(XML_UserDetails)))
                        {
                            AddUsersToUserGroupsListXML(XML_UserDetails, ref XML_UsersGroupsListData);   
                        }
                        else if (!String.IsNullOrEmpty(ErrorXMLString))
                        {
                            return ErrorXMLString; 
                        }
                    }

                    //Get the Groups Details
                    if (!String.IsNullOrEmpty(str_GroupIDList)) 
                    {
                        ErrorXMLString = GetGroupsDetails(str_GroupIDList, out XML_GroupDetails);
                        if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(XML_GroupDetails)))
                        {
                            AddGroupsToUserGroupsListXML(XML_GroupDetails, ref XML_UsersGroupsListData);
                        }
                    }
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }
        
            /// <alsummary>
            /// <CreatedOn>19 May 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To Remove the given user/group</Purpose>
            /// </alsummary>
            /// <param name="str_SelectedUserGroupIDs">Comma seprated list of selected IDs</param>
            /// <param name="XML_UserGroups">Users/Groups XML</param>
            /// <param name="XML_SelectedUsers">User XML</param>
            /// <param name="XML_SelectedGroups">Group XML</param>
            public void RemoveSelectedUserGroups(String str_SelectedUserGroupIDs, ref XML XML_UserGroups, ref XML XML_SelectedUsers, ref XML XML_SelectedGroups)
            {
                XmlDocument     doc_UserGroup   = null;
                XmlDocument     doc_User        = null;
                XmlDocument     doc_Group       = null;
                XmlNode         node_User       = null;
                XmlNode         node_Group      = null;
                XmlNode         node_UserGroup  = null;
                String[]        arr_SelectedIDs = null; 

                try
                {
                    if (!String.IsNullOrEmpty(str_SelectedUserGroupIDs))
                    {
                        if (!String.IsNullOrEmpty(XML_UserGroups))
                        {
                            doc_UserGroup = new XmlDocument();
                            doc_UserGroup.LoadXml(XML_UserGroups);

                            arr_SelectedIDs = str_SelectedUserGroupIDs.Split(',');

                            for (int i_Count = 0; i_Count < arr_SelectedIDs.Length; i_Count++)
                            {
                                node_UserGroup = doc_UserGroup.SelectSingleNode("USERGROUPCOLLECTION/USERGROUP[USER_GROUP_ID = '" + arr_SelectedIDs[i_Count] + "']");
                                if (node_UserGroup != null)
                                {
                                    //Check whether it is a User
                                    if (node_UserGroup.SelectSingleNode("USER_GROUP").InnerText.ToUpper() == "USER")
                                    {
                                        if ((doc_User == null) && (!String.IsNullOrEmpty(XML_SelectedUsers)))
                                        {
                                            doc_User = new XmlDocument();
                                            doc_User.LoadXml(XML_SelectedUsers);
                                        }
                                        if (doc_User != null)
                                        {
                                            node_User = doc_User.SelectSingleNode("UserSelectionXML/SelectedUsersList/USER[USERID = '" + arr_SelectedIDs[i_Count] + "']");
                                            if (node_User != null)
                                            {
                                                node_User.ParentNode.RemoveChild(node_User);
                                            }
                                        }
                                    }
                                    else if (node_UserGroup.SelectSingleNode("USER_GROUP").InnerText.ToUpper() == "GROUP")
                                    {
                                        if ((doc_Group == null) && (!String.IsNullOrEmpty(XML_SelectedGroups)))
                                        {
                                            doc_Group = new XmlDocument();
                                            doc_Group.LoadXml(XML_SelectedGroups);
                                        }
                                        if (doc_Group != null)
                                        {
                                            node_Group = doc_Group.SelectSingleNode("GroupSelectionXML/SelectedGroupsList/GROUP[GROUPID = '" + arr_SelectedIDs[i_Count] + "']");
                                            if (node_Group != null)
                                            {
                                                node_Group.ParentNode.RemoveChild(node_Group);
                                            }
                                        }
                                    }

                                    node_UserGroup.ParentNode.RemoveChild(node_UserGroup);
                                }
                            }

                            XML_UserGroups = doc_UserGroup.OuterXml;

                            if (doc_User != null)
                            {
                                XML_SelectedUsers = doc_User.OuterXml;  
                            }

                            if (doc_Group != null)
                            {
                                XML_SelectedGroups = doc_Group.OuterXml;  
                            }
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>19 May 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To Get the User details for the given user id list</Purpose>
            /// </alsummary>
            /// <param name="str_UserIDList">Comma seprated User ID List</param>
            /// <param name="XML_UserDetails">User details for the given id's</param>
            /// <returns>
            /// NULL : if no error.
            /// ERRORXML: if any.
            /// </returns>
            /// This same function is used in the PM Facade also, so any change in this function
            /// will require a change in the PM Facade also.
            public ERRORXML GetUsersDetails(String str_UserIDList, out String XML_UserDetails)
            {
                ERRORXML            ErrorXMLString      = null; 
                StringBuilder       sb_SearchInputXML   = null;
                SearchConfiguration SearchObj           = null;

                try
                {
                    XML_UserDetails = null; 
                    SearchObj           = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    sb_SearchInputXML   = new StringBuilder(250);

                    sb_SearchInputXML.Append(@"<SEARCH>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <TARGETOBJECT>USER</TARGETOBJECT>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <SESSIONINFO Language='" + CurrentLanguage + "' TenantName='" + TenantName + "' UserID='" + UserID + "' SessionID='" + SessionID + "'/>"
                                                    + @"<TARGETENTITY>
                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <EXPRESSION>USERID</EXPRESSION>
			                                                    <OPERATOR>IN</OPERATOR>
			                                                    <EXPRESSIONVALUE>(" + str_UserIDList + ")</EXPRESSIONVALUE>"
                                                                + @"<ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                            <FILTER>
													            <EXPRESSION>STATUS</EXPRESSION>
													            <OPERATOR>EQUALTO</OPERATOR>
													            <EXPRESSIONVALUE>ACTIVE</EXPRESSIONVALUE>											
													            <ISCASESENSITIVE>False</ISCASESENSITIVE>
												            </FILTER>
                                                        </FILTERLIST> 
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>USERID</FIELDNAME>
                                                                <ALIAS>USERID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                                <ALIAS>FIRSTNAME</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MIDDLEINITIAL</FIELDNAME>
                                                                <ALIAS>MIDDLEINITIAL</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>LASTNAME</FIELDNAME>
                                                                <ALIAS>LASTNAME</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>LOGINNAME</FIELDNAME>
                                                                <ALIAS>LOGINNAME</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>EMAILID</FIELDNAME>
                                                                <ALIAS>EMAILID</ALIAS>
                                                            </EXPRESSION>
                                                        </SELECTLIST>
                                                    </TARGETENTITY>                                                    
                                                 </SEARCH>");
                    ErrorXMLString = SearchObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref XML_UserDetails);
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <alsummary>
            /// <CreatedOn>19 May 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To Get the Group details for the given group id list</Purpose>
            /// </alsummary>
            /// <param name="str_GroupIDList">Comma seprated Group id list</param>
            /// <param name="XML_GroupDetails">Return Group details</param>
            /// <returns>
            /// NULL : if no error.
            /// ERRORXML: if any.
            /// </returns>
            /// This same function is used in the PM Facade also, so any change in this function
            /// will require a change in the PM Facade also.
            public ERRORXML GetGroupsDetails(String str_GroupIDList, out String XML_GroupDetails)
            {
                ERRORXML            ErrorXMLString      = null; 
                StringBuilder       sb_SearchInputXML   = null;
                SearchConfiguration SearchObj           = null;
                try
                {
                    XML_GroupDetails = null; 
                    SearchObj           = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    sb_SearchInputXML   = new StringBuilder(250);

                    sb_SearchInputXML.Append(@"<SEARCH>
	                                                <SESSIONINFO SessionID='" + SessionID + "' UserID='" + UserID + "' TenantName='" + TenantName + "' Language='" + CurrentLanguage + @"'/>
	                                                <TARGETOBJECT>GROUP</TARGETOBJECT>
	                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
	                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <SEARCHALLFACETS>False</SEARCHALLFACETS>
	                                                <TARGETENTITY>
		                                                <PRIVILEGENAME>READ</PRIVILEGENAME>
		                                                <FILTERLIST>
                                                            <FILTER>
				                                                <EXPRESSION>GROUPID</EXPRESSION>
				                                                <OPERATOR>IN</OPERATOR>
				                                                <EXPRESSIONVALUE>(" + str_GroupIDList + @")</EXPRESSIONVALUE>
				                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                                                </FILTER>
			                                                <FILTER>
															    <EXPRESSION>ISDELETED</EXPRESSION>
															    <OPERATOR>EQUALTO</OPERATOR>
															    <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
															    <ISCASESENSITIVE>False</ISCASESENSITIVE>
														    </FILTER>
		                                                </FILTERLIST>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>GROUPID</FIELDNAME>
                                                                <ALIAS>GROUPID</ALIAS>
                                                            </EXPRESSION>
                                                            <EXPRESSION>
                                                                <FIELDNAME>GROUPNAME</FIELDNAME>
                                                                <ALIAS>GROUPNAME</ALIAS>
                                                            </EXPRESSION>
                                                        </SELECTLIST>
	                                                </TARGETENTITY>
                                                </SEARCH>");
                    ErrorXMLString = SearchObj.GetHierarchialData(sb_SearchInputXML.ToString(), ref XML_GroupDetails);
                    return ErrorXMLString; 
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>02 June 2009</CreatedOn>
            /// <Author>Ms. Jisha Rajendran</Author>
            /// <Purpose>Returns the URL for the User selection page in common</Purpose>  
            /// </summary>
            /// <param name="NTFSFileName">Name of the file for selected users</param>
            /// <param name="PostBackID">Unique ID for postback</param>
            /// <param name="Theme">Theme of page</param>
            /// <returns></returns>
            public String GetUserSelectionPageUrl(String NTFSFileName, String PostBackID, String Theme)
            {
                String              str_TempPath        = null;
                StringBuilder       sb_Params           = null;
                ALSolutionCommon    ALSolutionCommonObj = null;

                ALSolutionCommonObj = new ALSolutionCommon();
                str_TempPath        = ALSolutionCommon.GetTempPath(SessionID) + NTFSFileName;
                sb_Params           = new StringBuilder(50);

                sb_Params.Append("/" + TenantName + "/Common/ASPX/UserSelection.aspx?");
                sb_Params.Append("TenantName=" + TenantName + "&Language=" + CurrentLanguage + "&SessionID=" + SessionID + "&UserID=" + UserID);
                sb_Params.Append("&InputXMLPath=" + str_TempPath + "&ReturnTargetID=" + PostBackID + "&DoSubmit=True&ThemeName=" + Theme);

                return ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_Params.ToString());
            }

            /// <summary>
            /// <CreatedOn>02 June 2009</CreatedOn>
            /// <Author>Ms. Jisha Rajendran</Author>
            /// <Purpose>Returns the URL for the Group selection page in common</Purpose>  
            /// </summary>
            /// <param name="NTFSFileName">Name of the file for selected groups</param>
            /// <param name="PostBackID">Unique ID for postback</param>
            /// <param name="Theme">Theme of page</param>
            /// <returns></returns>
            public String GetGroupSelectionPageUrl(String NTFSFileName, String PostBackID, String Theme)
            {
                String              str_TempPath        = null;
                StringBuilder       sb_Params           = null;
                ALSolutionCommon    ALSolutionCommonObj = null;

                ALSolutionCommonObj = new ALSolutionCommon();
                str_TempPath        = ALSolutionCommon.GetTempPath(SessionID) + NTFSFileName;
                sb_Params           = new StringBuilder(50);

                sb_Params.Append("/" + TenantName + "/Common/ASPX/GroupSelection.aspx?");
                sb_Params.Append("TenantName=" + TenantName + "&Language=" + CurrentLanguage + "&SessionID=" + SessionID + "&UserID=" + UserID);
                sb_Params.Append("&InputXMLPath=" + str_TempPath + "&ReturnTargetID=" + PostBackID + "&IsPopUp=TRUE&ThemeName=" + Theme);

                return ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_Params.ToString());
            }

            /// <alsummary>
            /// <CreatedOn>14 July 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To prepare the association and attributes XML to get the dependencies for RO Screens</Purpose>
            /// </alsummary>
            public void getAssociationXMLForPredecessors_RO(out XML Attributes_XML, out XML Association_XML)
	        {
                Attributes_XML = null;
                Association_XML = null;

                StringBuilder sb_AttributesXML  = null;
                StringBuilder sb_AssociationXML = null;

                sb_AttributesXML  = new StringBuilder(25);
                sb_AssociationXML = new StringBuilder(250);

                sb_AttributesXML.Append(@"<WORKFLOWPROCESS>
									        <WORKFLOWPROCESSID/>
							              </WORKFLOWPROCESS>");

                sb_AssociationXML.Append(@"<ASSOCIATION>
                                            <SUBFLOWACTIVITY Type='RELATION'>
                                                <ACTIVITYID/>
                                                <PROCESS_ACTIVITY Type='RELATION'>
                                                    <WORKFLOWPROCESSID/>
                                                    <PROCESS_ACTIVITY Type='RELATION'>
                                                        <ACTIVITYID/>
                                                        <ACTIVITYNAME/>
                                                        <STATUS/>
                                                        <STARTACTIVITY/>
                                                        <ENDACTIVITY/>
                                                        <STARTDATE/>
                                                        <DUEDATE/>
                                                        <ACTUALENDDATE/>
                                                        <ACTIVITY_INFORMATION Type='RELATION'>
	                                                        <PERCENTDONE/>
                                                        </ACTIVITY_INFORMATION>				
                                                    </PROCESS_ACTIVITY>
                                                    <PROCESS_TRANSITION Type='RELATION'>
                                                        <TRANSITIONID/>
                                                        <FROMACTIVITY Type='RELATION'>
	                                                        <ACTIVITYID/>					
                                                        </FROMACTIVITY>
                                                        <TOACTIVITY Type='RELATION'>
	                                                        <ACTIVITYID/>					
                                                        </TOACTIVITY>
                                                    </PROCESS_TRANSITION>
                                                </PROCESS_ACTIVITY>
                                            </SUBFLOWACTIVITY>
                                        </ASSOCIATION>");

                Attributes_XML  = sb_AttributesXML.ToString();
                Association_XML = sb_AssociationXML.ToString();  
	        }

            /// <alsummary>
            /// <CreatedOn>14 July 2009</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To prepare the association and attributes XML to get the dependencies for Editable Screens</Purpose>
            /// </alsummary>
            public void getAssociationXMLForPredecessors_Editable(out XML Attributes_XML, out XML Association_XML)
	        {
                Attributes_XML = null;
                Association_XML = null;

                StringBuilder sb_AttributesXML  = null;
                StringBuilder sb_AssociationXML = null;

                sb_AttributesXML  = new StringBuilder(25);
                sb_AssociationXML = new StringBuilder(250);

                sb_AttributesXML.Append(@"<WORKFLOWPROCESS>
									        <WORKFLOWPROCESSID/>
							              </WORKFLOWPROCESS>");

                sb_AssociationXML.Append(@"<ASSOCIATION>
                                                <SUBFLOWACTIVITY Type='RELATION'>
                                                    <ACTIVITYID/>
                                                    <PROCESS_ACTIVITY Type='RELATION'>                                                        
                                                        <WORKFLOWPROCESSID/>
                                                        <PROCESS_ACTIVITY Type='RELATION'>
                                                            <ACTIVITYID/>
		                                                    <ACTIVITYNAME/>
		                                                    <STATUS/>
		                                                    <STARTACTIVITY/>
		                                                    <ENDACTIVITY/>
                                                            <STARTDATE/>
		                                                    <DUEDATE/>
		                                                    <ACTUALENDDATE/>
                                                            <ACTIVITY_INFORMATION Type='RELATION'>
	                                                            <PERCENTDONE/>
	                                                            <STARTDATELOCKED/>
                                                                <GRAPHICSINFO/>
                                                            </ACTIVITY_INFORMATION>
                                                            <SUBFLOWACTIVITY Type='RELATION'>
	                                                            <WORKFLOWPROCESSID/>
                                                            </SUBFLOWACTIVITY>
                                                        </PROCESS_ACTIVITY>
                                                        <PROCESS_TRANSITION Type='RELATION'>
                                                            <TRANSITIONID/>
                                                            <GRAPHICSINFO/>
		                                                    <FROMACTIVITY Type='RELATION'>
                                                                <ACTIVITYID/>
			                                                    <ACTIVITYNAME/>
			                                                    <STATUS/>
			                                                    <STARTACTIVITY/>
			                                                    <ENDACTIVITY/>
		                                                    </FROMACTIVITY>
		                                                    <TOACTIVITY Type='RELATION'>
                                                                <ACTIVITYID/>
			                                                    <ACTIVITYNAME/>
			                                                    <STATUS/>
			                                                    <STARTACTIVITY/>
			                                                    <ENDACTIVITY/>
		                                                    </TOACTIVITY>
                                                        </PROCESS_TRANSITION>
                                                    </PROCESS_ACTIVITY>
                                                </SUBFLOWACTIVITY>
                                            </ASSOCIATION>");

                Attributes_XML  = sb_AttributesXML.ToString();
                Association_XML = sb_AssociationXML.ToString();  
	        }

            /// <summary>
            /// <CreatedOn>05 May 2010</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get the duration</Purpose>
            /// </summary>
            /// <param name="nav_Activity">Activity navigator</param>
            /// <returns>Duration in days</returns>
            public long GetStepDuration(XPathNavigator nav_Activity)
            {
                XPathNavigator nav_ActivityDuration = null; 
                String         str_Duration         = null;
                PMFacadeClass  PMFacadeObj          = null;
                long           RemMin               = 0; 

                try
                {
                    PMFacadeObj = new PMFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);
    
                    nav_ActivityDuration = nav_Activity.SelectSingleNode("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION");
                    if (nav_ActivityDuration != null)
                    {
                        str_Duration = nav_ActivityDuration.Value;
                        return (PMFacadeObj.ConvertMinutesToDays(Convert.ToInt64(str_Duration), out RemMin));   
                    }
                    return 0;
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>05 May 2010</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To Validate the new duration</Purpose>
            /// </summary>
            /// <param name="xp_Navigator">WorkflowProcess or Activity Navigator</param>
            /// <param name="str_NewStepDuration">New step duration in days</param>
            /// <param name="bool_GiveAlert">True: if Duration is invalid
            ///                              False: if Duration is valid</param>
            /// <param name="l_StepDurationInMin">Converted duration in minute</param>
            public void ValidateDueDate(XPathNavigator xp_Navigator, String str_NewStepDuration, out Boolean bool_GiveAlert, out long l_StepDurationInMin)
            {
                XPathNavigator      nav_StartDate           = null; 
                PMFacadeClass       PMFacadeObj             = null;
                DateTime            dt_StartDate, dt_DueDate;        
                int                 Year, Month, Day, Hour, Minute, Second;
                MktgWorkBenchFacadeClass obj_MWBFacade      = null;

                try
                {
                    bool_GiveAlert      = false;
                    l_StepDurationInMin = 0;

                    dt_DueDate      = new DateTime();
                    dt_StartDate    = new DateTime();
                    PMFacadeObj     = new PMFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);
                    obj_MWBFacade   = new MktgWorkBenchFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);   

                    if (!String.IsNullOrEmpty(str_NewStepDuration))
                    {
                        //Check whether given duration is valid or not
                        l_StepDurationInMin = PMFacadeObj.ConvertDaysToMinutes(Convert.ToInt64(str_NewStepDuration));

                        nav_StartDate = xp_Navigator.SelectSingleNode("descendant::ORGSTARTDATE");
                        if ((nav_StartDate != null) && (nav_StartDate.HasChildren))
                        {
                            Year    = Convert.ToInt32(nav_StartDate.SelectSingleNode("YEAR").Value);
                            Month   = Convert.ToInt32(nav_StartDate.SelectSingleNode("MONTH").Value);
                            Day     = Convert.ToInt32(nav_StartDate.SelectSingleNode("DAY").Value);
                            Hour    = Convert.ToInt32(nav_StartDate.SelectSingleNode("HOUR").Value);
                            Minute  = Convert.ToInt32(nav_StartDate.SelectSingleNode("MINUTE").Value);
                            Second  = Convert.ToInt32(nav_StartDate.SelectSingleNode("SECOND").Value);

                            dt_StartDate = new DateTime(Year, Month, Day, Hour, Minute, Second);

                            obj_MWBFacade.GetDueDate(dt_StartDate, l_StepDurationInMin.ToString(), out dt_DueDate);
                            if (dt_DueDate < DateTime.Today)
                            {
                                //Due date is less than todays date, give invalid duration alert
                                bool_GiveAlert = true;
                            }
                        }
                    }
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            public void ValidateDuration(String str_ListXML, String str_ReferenceXML, Boolean bool_ConvertDuration, ref String str_Alert, ref String str_DurationChangedActivityIDs)
            {
                XPathDocument       xp_ReferenceXML = null; 
                XPathDocument       xp_ListSource   = null;
                XPathNavigator      nav_Process     = null;
                XPathNavigator      nav_Activity    = null; 
                XPathNodeIterator   iter_Rows       = null; 
                long                l_NewDuration   = 0;
                long                l_PrevDuration  = 0; 
                StringBuilder       sb_XPathQuery   = null; 
                StringBuilder       sb_ActivityIDs  = null; 
                String              ActivityStatus  = null; 
                String              ActivityID      = null; 
                Boolean             bool_GiveAlert  = false; 
                PMFacadeClass       PMFacadeObj     = null; 
         
                try
                {
                    PMFacadeObj   = new PMFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);     
                    sb_XPathQuery = new StringBuilder(25);
                    sb_ActivityIDs= new StringBuilder(10);
                    xp_ListSource = new XPathDocument(new StringReader(str_ListXML));
                    iter_Rows = xp_ListSource.CreateNavigator().Select("List/Data/Group/Row");

                    xp_ReferenceXML = new XPathDocument(new StringReader(str_ReferenceXML));
                    nav_Process = xp_ReferenceXML.CreateNavigator();  

                    if (iter_Rows.Count != 0)
                    {
                        foreach (XPathNavigator nav_Row in iter_Rows)
                        {
                            ActivityID = nav_Row.SelectSingleNode("Column[@Name='ACTIVITYID']").Value;
                            ActivityStatus = nav_Row.SelectSingleNode("Column[@Name='STATUS']").Value;

                            if (ActivityStatus.ToUpper() == "ACTIVE")
                            {
                                sb_XPathQuery.Remove(0, sb_XPathQuery.Length);
                                sb_XPathQuery.Append("descendant::ACTIVITY[ACTIVITYID='" + ActivityID + "']/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/DURATION");

                                if (nav_Process.SelectSingleNode(sb_XPathQuery.ToString()) == null)
                                    continue;

                                l_PrevDuration = Convert.ToInt64(nav_Process.SelectSingleNode(sb_XPathQuery.ToString()).Value);
                                if (bool_ConvertDuration)
                                    l_PrevDuration = PMFacadeObj.ConvertDaysToMinutes(Convert.ToInt64(l_PrevDuration));


                                sb_XPathQuery.Remove(0, sb_XPathQuery.Length);
                                sb_XPathQuery.AppendFormat("descendant::ACTIVITY[ACTIVITYID='{0}']/ACTIVITY_INFORMATION/ACTIVITYINFORMATION/ACTIVITYINFORMATIONID", ActivityID);

                                nav_Activity = nav_Process.SelectSingleNode("descendant::ACTIVITY[ACTIVITYID='" + ActivityID + "']");
                                if (nav_Activity != null)
                                {
                                    ValidateDueDate(nav_Activity, nav_Row.SelectSingleNode("Column[@Name='DURATION']").Value, out bool_GiveAlert, out l_NewDuration);
                                    if ((bool_GiveAlert) && (l_PrevDuration != l_NewDuration))
                                    {
                                        str_Alert = Localization.GetString("ALJSResource", TenantName, "Alert_MWB_InvalidDuration_Shared") + " " + Localization.GetString("ALJSResource", TenantName, "Alert_InvalidDuration_For_Shared") + " " + nav_Activity.SelectSingleNode("ACTIVITYNAME").Value + ".";
                                        break;
                                    }
                                    else if (l_PrevDuration != l_NewDuration)
                                        sb_ActivityIDs.Append(ActivityID + ",");   
                                }
                            }
                        }
                    }
                    if (sb_ActivityIDs.Length > 0)
                        str_DurationChangedActivityIDs = sb_ActivityIDs.Remove(sb_ActivityIDs.Length - 1, 1).ToString();    
                }
                catch (Exception ExceptionObj)
                {
                    throw(ExceptionObj);
                }
            }

            /// <summary>
            /// <CreatedOn>12 April 2010</CreatedOn>
            /// <Author>Mr. Hemant Karkande</Author>
            /// <Purpose>To get Additional facets for the given Package and Process definition id</Purpose>
            /// </summary>
            /// <param name="str_PackageDefinitionID">Package Definition ID</param>
            /// <param name="str_ProcessDefinitionID">Process Definition ID</param>
            /// <param name="str_ProcessAssocatedFacets">Return associated Additional facets</param>
            public ERRORXML GetProcessAdditionalFacets(String str_PackageDefinitionID, String str_ProcessDefinitionID, ref String str_ProcessAssocatedFacets)
            {
                ERRORXML            ErrorXMLString              = null;            
                XPathDocument       xp_ProcessDefinition        = null; 
                XPathNavigator      nav_WFProcess               = null;
                XPathNodeIterator   iter_ProcessAssoFacets      = null;
                StringBuilder       sb_ProcessAssociatedFacets  = null; 
                XML                 XML_ProcessDefinitionXML    = null; 
                String              str_ToCheck                 = null; 
                PMFacadeClass       PMFacadeObj                 = null;

                sb_ProcessAssociatedFacets      = new StringBuilder(100);
                PMFacadeObj                     = new PMFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);    

                //Get the Process Definition
                ErrorXMLString = PMFacadeObj.GetProcessDefinitionByID(str_PackageDefinitionID, str_ProcessDefinitionID, out XML_ProcessDefinitionXML);
                if ((String.IsNullOrEmpty(ErrorXMLString)) && (!String.IsNullOrEmpty(XML_ProcessDefinitionXML)))
                {
                    xp_ProcessDefinition = new XPathDocument(new StringReader(XML_ProcessDefinitionXML));
                    nav_WFProcess = xp_ProcessDefinition.CreateNavigator().SelectSingleNode("WORKFLOWPROCESS");

                    if (nav_WFProcess != null)
                    {
                        iter_ProcessAssoFacets = nav_WFProcess.Select("PROCESS_RELATEDFACETS/FACET");
                        while (iter_ProcessAssoFacets.MoveNext())
                        {
                            if ((iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME") != null) && (!String.IsNullOrEmpty(iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value)))
                            {
                                if (!String.IsNullOrEmpty(str_ProcessAssocatedFacets))
                                {
                                    str_ToCheck = "NAME='" + iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + "'";
                                    if (!str_ProcessAssocatedFacets.Contains(str_ToCheck))
                                        sb_ProcessAssociatedFacets.Append("<RELATIONSHIP NAME='" + iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + "' GetAllFacets='TRUE' />");
                                }
                                else
                                    sb_ProcessAssociatedFacets.Append("<RELATIONSHIP NAME='" + iter_ProcessAssoFacets.Current.SelectSingleNode("RELATIONSHIPNAME").Value + "' GetAllFacets='TRUE' />");
                            }
                        }

                        if (sb_ProcessAssociatedFacets.Length > 0)
                            str_ProcessAssocatedFacets += sb_ProcessAssociatedFacets.ToString();
                    }
                }
                return ErrorXMLString;
            }

            /// <summary>
            /// <Purpose>Check whether the task is auto and indepedent, also start date is today</Purpose>
            /// <CreatedBy>Amruta Borgaonkar</CreatedBy>
            /// </summary>
            /// <param name="str_TaskID">Task Id</param>
            /// <param name="b_TaskAutoIndependent">Flag will be set in this function</param>
            /// <returns>Error xml if any</returns>
            public ERRORXML CheckForAutoIndependentTask(String str_TaskID, ref Boolean b_TaskAutoIndependent)
            {                
                String                  str_SearchInput         = null;
                String                  str_SerachOutput        = null;
                SearchConfiguration     searchObj               = null;
                String                  str_Error               = null;
                XElement                xElt_TaskData           = null;
                XElement                xElt_Temp               = null;
                XElement                xElt_ProcessTransition  = null;
                XElement                xElt_TaskActivity       = null;
                String                  str_TaskActivityID      = null;
                XElement                xElt_Transition         = null;
                XElement                xElt_WorkFlowProcess    = null;

                str_SearchInput = @"<SEARCH>
                                        <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                        <SEARCHALLFACETS>FALSE</SEARCHALLFACETS>
                                        <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                        <SESSIONINFO Language='" + CurrentLanguage + @"' TenantName='" + TenantName + @"' UserID='" + UserID + @"' SessionID='" + SessionID + @"'/>
                                        <TARGETENTITY>
                                            <PRIVILEGENAME>READ</PRIVILEGENAME>
                                            <SELECTLIST>
                                                <EXPRESSION>
                                                    <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                    <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                </EXPRESSION>
                                            </SELECTLIST>
                                            <FILTERLIST>
	                                            <FILTER>
		                                            <FILTERID>1</FILTERID>
		                                            <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
		                                            <OPERATOR>EQUALTO</OPERATOR>
		                                            <EXPRESSIONVALUE>" + str_TaskID + @"</EXPRESSIONVALUE>
		                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                            </FILTER>
                                                <FILTER>
		                                            <FILTERID>2</FILTERID>
		                                            <EXPRESSION>STARTDATE</EXPRESSION>
		                                            <OPERATOR>EQUALTO</OPERATOR>
		                                            <EXPRESSIONVALUE>
			                                            <VALUE>
				                                            <DAY>" + DateTime.Now.Day + @"</DAY>
				                                            <MONTH>" + DateTime.Now.Month + @"</MONTH>
				                                            <YEAR>" + DateTime.Now.Year + @"</YEAR>
			                                            </VALUE>
		                                            </EXPRESSIONVALUE>
		                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                            </FILTER>
		                                    </FILTERLIST>   
                                            <RELATIONSHIP NAME='SUBFLOWACTIVITY'>
                                                <SELECTLIST>
                                                    <EXPRESSION>
                                                        <FIELDNAME>ACTIVITYID</FIELDNAME>
                                                        <ALIAS>ACTIVITYID</ALIAS>
                                                    </EXPRESSION>				                                                            
                                                </SELECTLIST>
                                                <RELATIONSHIP NAME='ACTIVITY_INFORMATION'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>ACTIVITYINFORMATIONID</FIELDNAME>
                                                            <ALIAS>ACTIVITYINFORMATIONID</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                            <FIELDNAME>STARTMODE</FIELDNAME>
                                                            <ALIAS>STARTMODE</ALIAS>
                                                        </EXPRESSION>                                                            
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='PROCESS_ACTIVITY'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
                                                            <ALIAS>WORKFLOWPROCESSID</ALIAS>
                                                        </EXPRESSION>				                                                            
                                                    </SELECTLIST>
                                                    <RELATIONSHIP NAME='PROCESS_TRANSITION'>
			                                            <SELECTLIST>
				                                            <EXPRESSION>
					                                            <FIELDNAME>TRANSITIONID</FIELDNAME>
					                                            <ALIAS>TRANSITIONID</ALIAS>
				                                            </EXPRESSION>
			                                            </SELECTLIST>
                                                        <RELATIONSHIP NAME='FROMACTIVITY'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>ACTIVITYID</FIELDNAME>
						                                            <ALIAS>ACTIVITYID</ALIAS>
					                                            </EXPRESSION>						                                            
					                                            <EXPRESSION>
						                                            <FIELDNAME>STARTACTIVITY</FIELDNAME>
						                                            <ALIAS>STARTACTIVITY</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>ENDACTIVITY</FIELDNAME>
						                                            <ALIAS>ENDACTIVITY</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
			                                            </RELATIONSHIP>
			                                            <RELATIONSHIP NAME='TOACTIVITY'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>ACTIVITYID</FIELDNAME>
						                                            <ALIAS>ACTIVITYID</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>STARTACTIVITY</FIELDNAME>
						                                            <ALIAS>STARTACTIVITY</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>ENDACTIVITY</FIELDNAME>
						                                            <ALIAS>ENDACTIVITY</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
                                                        </RELATIONSHIP>
                                                </RELATIONSHIP>
                                            </RELATIONSHIP>       
                                        </RELATIONSHIP>                                
                                    </TARGETENTITY>
                                </SEARCH>";
                searchObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                str_Error = searchObj.GetHierarchialData(str_SearchInput, ref str_SerachOutput);
                if (str_Error != null)
                {
                    return str_Error;
                }

                xElt_TaskData           = XElement.Load(XmlReader.Create(new StringReader(str_SerachOutput)));
                xElt_WorkFlowProcess    = xElt_TaskData.Element("WORKFLOWPROCESS");
                if (xElt_WorkFlowProcess == null)
                {
                    b_TaskAutoIndependent = false;
                    return str_Error;
                }

                xElt_TaskActivity       = xElt_TaskData.XPathSelectElement("WORKFLOWPROCESS/SUBFLOWACTIVITY/ACTIVITY");
                str_TaskActivityID      = xElt_TaskActivity.Element("ACTIVITYID").Value;

                //Check if mode is Automatic
                xElt_Temp           = xElt_TaskActivity.XPathSelectElement("ACTIVITY_INFORMATION/ACTIVITYINFORMATION/STARTMODE");
                if (xElt_Temp != null)
                {
                    if (xElt_Temp.Value.ToUpper() != "AUTOMATIC")
                    {
                        b_TaskAutoIndependent = false;
                        return str_Error;
                    }
                }                

                //Check if its dependent only on start activity.
                xElt_ProcessTransition  = xElt_TaskActivity.XPathSelectElement("PROCESS_ACTIVITY/WORKFLOWPROCESS/PROCESS_TRANSITION");
                xElt_Transition         = xElt_ProcessTransition.Elements("TRANSITION").
                                            Where<XElement>(i => i.XPathSelectElement("TOACTIVITY/ACTIVITY/ACTIVITYID").Value == str_TaskActivityID).
                                            Where<XElement>(i => i.XPathSelectElement("FROMACTIVITY/ACTIVITY/STARTACTIVITY").Value.ToUpper() != "TRUE").FirstOrDefault();
                if (xElt_Transition != null)
                {
                    b_TaskAutoIndependent = false;
                }
                else
                {
                    b_TaskAutoIndependent = true;
                }

                return str_Error;
            }

        /// <summary>
            /// <CreatedOn>2 Feb 2011</CreatedOn>
            /// <CreatedBy>Mugdha Gadre</CreatedBy>
            /// </summary>
            /// <param name="VEditorSnapshot">This XML always contains the current latest snapshot of XML given by the Visual Editor</param>
            /// <param name="DeliverableXML">The Deliverable Details XML</param>
            public XML GetUpdatedVisualWorkflowData_Ex(XML VEditorSnapshot, XML DelDiagramXML)
            {
                XmlDocument     VEditorDoc    = null;
                XmlDocument     DelDoc        = null;                
                XmlNode         SObjectsNode  = null;
                XmlNode         SConnsNode    = null;
                XmlNode         SObjectNode   = null;
                XmlNode         SConnNode     = null;
                XmlNodeList     SObjectList   = null;
                XmlNodeList     SConnList     = null;
                
                // The VWXML contains the list of objects that were newly added,or any transitions that were newly added.
                // it always contains the latest snapshot of workflow.
                // This VEditorSnapshot XML will be compared with the Deliverable XML.
                // Following Scenarios will be taken care of in this function:
                // *** If an SObject is found in VEditorSnapshot XML but not in Deliverable XML, then the Task Instance is not yet created
                // but the Object will have to be shown on the Visual Editor.
                // *** If a Task exists in the Deliverable XML but not in VEditorSnapshot XML then the task is deleted.
                // *** If a transition exists in VEditorSnapshot XML but not in Deliverable XML then it is newly added.
                // *** If a transition exists in Deliverable XML but not in VEditorSnapshot XML then the transition is deleted.

                if (!String.IsNullOrEmpty(VEditorSnapshot))
                {
                    VEditorDoc      = new  XmlDocument();
                    DelDoc          = new XmlDocument();
                    DelDoc.LoadXml(DelDiagramXML);
                    VEditorDoc.LoadXml(VEditorSnapshot);
                    SObjectsNode    = DelDoc.SelectSingleNode("Diagram/SObjects");
                    SConnsNode      = DelDoc.SelectSingleNode("Diagram/SConnections");
                    SObjectList     = VEditorDoc.SelectNodes("Diagram/SObjects/SObject");
                    foreach (XmlNode SObjN in SObjectList)
                    {
                        SObjectNode = SObjectsNode.SelectSingleNode("SObject[@id='" + ((XmlElement)SObjN).GetAttribute("id", "") + "']");
                        if (SObjectNode == null) // This means a task was dragged and dropped on the Visual Editor, 
                        // but no task type was selected and and instance was Created by hitting the GO button.
                        // This State of Visual Editor has to be maintained, hence add it to the Deliverable Diagram XML
                        {
                            SObjectsNode.AppendChild(DelDoc.ImportNode(SObjN, true));

                        }
                        else // update the height, width, x and y co-ordinates.
                        {
                            ((XmlElement)SObjectNode).SetAttribute("x", ((XmlElement)SObjN).GetAttribute("x", ""));
                            ((XmlElement)SObjectNode).SetAttribute("y", ((XmlElement)SObjN).GetAttribute("y", ""));
                            ((XmlElement)SObjectNode).SetAttribute("width", ((XmlElement)SObjN).GetAttribute("width", ""));
                            ((XmlElement)SObjectNode).SetAttribute("height", ((XmlElement)SObjN).GetAttribute("height", ""));
                        }
                    }

                    // Also Update the SConnections
                    SConnList = VEditorDoc.SelectNodes("Diagram/SConnections/SConnection");
                    foreach (XmlNode SCoNode in SConnList)
                    {
                        SConnNode = SConnsNode.SelectSingleNode("SConnection[id='" + ((XmlElement)SCoNode).GetAttribute("id","") + "']");
                        if (SConnNode == null)
                        {
                            // this is a newly added transition
                        }
                        else
                        { 
                            // Update the Connection points.
                            SConnNode.InnerXml = SCoNode.InnerXml;
                        }
                    }
                    return DelDoc.OuterXml;
                }
                return String.Empty;
            }



            /// <summary>
            /// <CreatedOn>2 Feb 2011</CreatedOn>
            /// <CreatedBy>Mugdha Gadre</CreatedBy>
            /// </summary>
            /// <param name="VEditorSnapshot">This XML always contains the current latest snapshot of XML given by the Visual Editor</param>
            /// <param name="DeliverableXML">The Deliverable Details XML</param>
            public XML GetUpdatedVisualWorkflowData(String NewSubflowActID, XML VEditorSnapshot, XML DelDiagramXML)
            {
                XmlDocument     VEditorDoc    = null;
                XmlDocument     DelDoc        = null;                
                XmlNode         SObjectsNode  = null;
                XmlNode         VESObjectsNode= null;
                XmlNode         VESObjectNode = null;
                XmlNode         VESConnsNode  = null;
                //XmlNode         SObjectNode   = null;
                XmlNode         VESConnNode   = null;
                //XmlNode         VEStartObj    = null;
                //XmlNode         VEEndObj      = null;
                //XmlNode         VEStartConNode= null;
                //XmlNode         VEEndConNode  = null;
                //XmlNode         NewSConnNode  = null;
                XmlNodeList     SConnList     = null;
                //XmlNodeList     StAnchorList  = null;
                //XmlNodeList     EndAnchorList = null;
                //String          str_StartID   = null;
                //String          str_EndID     = null;
                XmlNodeList     SObjList      = null;                
                StringBuilder   sb_SObjIDList = null;
               
                sb_SObjIDList = new StringBuilder(100);
                if (!String.IsNullOrEmpty(VEditorSnapshot))
                {
                    VEditorDoc      = new  XmlDocument();
                    DelDoc          = new XmlDocument();
                    DelDoc.LoadXml(DelDiagramXML);
                    VEditorDoc.LoadXml(VEditorSnapshot);
                    SObjectsNode    = DelDoc.SelectSingleNode("Diagram/SObjects");
                    SObjList        = DelDoc.SelectNodes("Diagram/SObjects/SObject");
                    VESObjectsNode  = VEditorDoc.SelectSingleNode("Diagram/SObjects");
                    //sb_SObjIDList.Append("Diagram/SObjects/SObject[");

                    //foreach (XmlNode SObj in SObjList)
                    //{
                    //    sb_SObjIDList.AppendFormat("@id != '" + ((XmlElement)SObj).GetAttribute("id","") + "' and ");
                    //}
                    //sb_SObjIDList = sb_SObjIDList.Replace("and", "]", sb_SObjIDList.ToString().LastIndexOf("and"), 3);

                    //SObjList = VEditorDoc.SelectNodes(sb_SObjIDList.ToString());
                    //foreach (XmlNode SObj in SObjList)
                    //{
                    //    VESObjectNode = VESObjectsNode.SelectSingleNode("SObject[@id='" + ((XmlElement)SObj).GetAttribute("id", "") + "']");
                    //    if (VESObjectNode != null)
                    //    {
                    //        VESObjectsNode.RemoveChild(VESObjectNode);
                    //    }
                    //    VESObjectsNode.AppendChild(VEditorDoc.ImportNode(SObj, true));
                    //}

                    XmlNode NewTaskNode =  DelDoc.SelectSingleNode("Diagram/SObjects/SObject[@id='" + NewSubflowActID + "']");
                    if (NewTaskNode != null)
                    {
                        VESObjectNode = VESObjectsNode.SelectSingleNode("SObject[@id='" + NewSubflowActID + "']");
                        if (VESObjectNode != null)
                        {
                            VESObjectsNode.RemoveChild(VESObjectNode);
                        }
                        VESObjectsNode.AppendChild(VEditorDoc.ImportNode(NewTaskNode, true));
                    }

                    SConnList = DelDoc.SelectNodes("Diagram/SConnections/SConnection[@From='" + NewSubflowActID + "' or @To='" + NewSubflowActID + "']");
                    VESConnsNode = VEditorDoc.SelectSingleNode("Diagram/SConnections");
                    foreach (XmlNode SCon in SConnList)
                    {
                        VESConnNode = VESConnsNode.SelectSingleNode("SConnection[@id='" + ((XmlElement)SCon).GetAttribute("id", "") + "']");
                        if (VESConnNode != null)
                        {
                            VESConnsNode.RemoveChild(VESConnNode);
                        }
                        VESConnsNode.AppendChild(VEditorDoc.ImportNode(SCon, true));
                    }
                    
                   /* 
                    VESObjectsNode  = VEditorDoc.SelectSingleNode("Diagram/SObjects");
                    
                    SObjectNode = SObjectsNode.SelectSingleNode("SObject[@id='" + NewSObjectID + "']");
                    if (SObjectNode != null)
                    {
                        VESObjectNode = VESObjectsNode.SelectSingleNode("SObject[@id='" + NewSObjectID + "']");
                        if (VESObjectNode != null)
                        {
                            VESObjectNode.InnerXml = SObjectNode.InnerXml;
                        }
                        else
                        {
                            VESObjectsNode.AppendChild(VEditorDoc.ImportNode(SObjectNode, true));
                        }
                    }

                    VEStartObj = VESObjectsNode.SelectSingleNode("SObject[@defid='StartActivity']");
                    if (VEStartObj != null)
                    {
                        str_StartID = ((XmlElement)VEStartObj).GetAttribute("id", "");
                        VEStartConNode = VESConnsNode.SelectSingleNode("SConnection[@From='" + str_StartID + "']");
                        StAnchorList = VEStartConNode.SelectNodes("Anchors/AnchorPoint");
                    }

                    VEEndObj = VESObjectsNode.SelectSingleNode("SObject[@defid='EndActivity']");
                    if (VEEndObj != null)
                    {
                        str_EndID = ((XmlElement)VEEndObj).GetAttribute("id", "");
                        VEEndConNode = VESConnsNode.SelectSingleNode("SConnection[@To='" + str_EndID + "']");
                        EndAnchorList = VEEndConNode.SelectNodes("Anchors/AnchorPoint");
                    }
                    SConnList = SConnsNode.SelectNodes("SConnection[@To='" + NewSObjectID + "']");

                    //SConnList = SConnsNode.SelectNodes("SConnection[@From='" + NewSObjectID + "' or @To='" + NewSObjectID + "']");

                    foreach (XmlNode SConNode in SConnList)
                    {
                       VESConnNode = VESConnsNode.SelectSingleNode("SConnection[id='" + ((XmlElement)SConNode).GetAttribute("id", "") + "']");
                       //SConNode.ReplaceChild(VEStartConNode.FirstChild, SConNode.FirstChild);
                       SConNode.FirstChild.ChildNodes[0].Attributes.RemoveAll();

                       foreach (XmlAttribute Atrr in StAnchorList[0].Attributes)
                       {
                           ((XmlElement)SConNode.FirstChild.ChildNodes[0]).SetAttribute(Atrr.Name, Atrr.Value);
                       }
                       
                       //SConNode.FirstChild.ChildNodes[1].InnerXml = StAnchorList[1].InnerXml;
                       //NewSConnNode = SConNode.FirstChild.ReplaceChild(StAnchorList[0], SConNode.FirstChild.ChildNodes[0]);
                       //SConNode.InnerXml = VEStartConNode.InnerXml;
                       if (VESConnNode != null)
                       {
                           VESConnNode.InnerXml = SConNode.InnerXml;
                       }
                       else
                       {
                           VESConnsNode.AppendChild(VEditorDoc.ImportNode(SConNode, true));
                       }
                    }

                    SConnList = SConnsNode.SelectNodes("SConnection[@From='" + NewSObjectID + "']");
                    foreach (XmlNode SConNode in SConnList)
                    {
                        VESConnNode = VESConnsNode.SelectSingleNode("SConnection[id='" + ((XmlElement)SConNode).GetAttribute("id", "") + "']");
                        //NewSConnNode = SConNode.FirstChild.ReplaceChild(EndAnchorList[0], SConNode.FirstChild.ChildNodes[0]);
                        //SConNode.FirstChild.ChildNodes[0].InnerXml = EndAnchorList[0].InnerXml;
                        SConNode.FirstChild.LastChild.Attributes.RemoveAll();
                       // SConNode.FirstChild.ChildNodes[1].InnerXml = EndAnchorList[1].InnerXml;
                        foreach (XmlAttribute Atrr in EndAnchorList[EndAnchorList.Count - 1].Attributes)
                        {
                            ((XmlElement)SConNode.FirstChild.LastChild).SetAttribute(Atrr.Name, Atrr.Value);
                        }

                        if (VESConnNode != null)
                        {
                            VESConnNode.InnerXml = SConNode.InnerXml;
                        }
                        else
                        {
                            VESConnsNode.AppendChild(VEditorDoc.ImportNode(SConNode, true));
                        }
                    }*/
                    return VEditorDoc.OuterXml;
                }
                return String.Empty;
            }

            /// <summary>
            /// <CreatedOn>2 Feb 2011</CreatedOn>
            /// <CreatedBy>Mugdha Gadre</CreatedBy>
            /// </summary>
            /// <param name="SObjectID"></param>
            /// <param name="DiagramXML"></param>
            /// <returns></returns>
            public XML GetGraphicsInfoXMLForSObject(String SObjectID, XML DiagramXML)
            {
                XPathDocument   xpDoc_Diag  = null;
                XPathNavigator  xpNav_SObj  = null;
                StringBuilder   sb_GrXML    = null;

                xpDoc_Diag  = new XPathDocument(new StringReader(DiagramXML));
                sb_GrXML    = new StringBuilder(10);     
                xpNav_SObj  = xpDoc_Diag.CreateNavigator().SelectSingleNode("Diagram/SObjects/SObject[@id='" + SObjectID + "']");

                if (xpNav_SObj != null)
                {
                    sb_GrXML.AppendFormat("<ACTIVITY><ACTIVITYID>{0}</ACTIVITYID><ACTIVITY_INFORMATION><ACTIVITYINFORMATION>", SObjectID);
                    sb_GrXML.Append("<GRAPHICSINFO><NodeGraphicsInfos><NodeGraphicsInfo Width=\"" + xpNav_SObj.GetAttribute("width", "") + "\"");
                    sb_GrXML.Append(" Height=\"" + xpNav_SObj.GetAttribute("height", "") + "\">");
                    sb_GrXML.Append("<Coordinates XCoordinate=\"" + xpNav_SObj.GetAttribute("x", "") + "\" YCoordinate=\"" + xpNav_SObj.GetAttribute("y", "") + "\"/>");
                    sb_GrXML.Append("</NodeGraphicsInfo></NodeGraphicsInfos></GRAPHICSINFO>");
                    sb_GrXML.Append("</ACTIVITYINFORMATION></ACTIVITY_INFORMATION></ACTIVITY>");
                    return sb_GrXML.ToString();
                }
                return String.Empty;
            }


        public void SetVisualWorkflowAttributes(ref String WorkflowXML)
        {
            XmlNodeList     SConnList       = null;
            XmlNodeList     SObjects        = null;
            String          str_FromID      = null;
            String          str_ToID        = null;
            String          str_Status      = null;
            String          str_ToStatus    = null;
            XmlNode         SObjectNode     = null;
            XmlNode         ToSObjectNode   = null;            
            XmlNode         DataNode        = null;
            Double          SObjWidth       = 0;
            Double          SObjHeight      = 0;
            Double          SrcXCoord       = 0;
            Double          SrcYCoord       = 0;
            Double          DestXCoord      = 0;
            Double          DestYCoord      = 0;
            Double          SrcActWidth     = 0;
            Double          SrcActHeight    = 0;
            Double          DestActWidth    = 0;
            Double          DestActHeight   = 0;
            Hashtable       SObjectsTable   = null;
            Boolean         changeTransition = false;
            
            XmlDocument WorkflowDoc = new XmlDocument();
            SObjectsTable           = new Hashtable();
            WorkflowDoc.LoadXml(WorkflowXML);
            SObjects = WorkflowDoc.SelectNodes("Diagram/SObjects/SObject");
            foreach(XmlNode SObjNode in SObjects)
            {
                if ((SObjNode.Attributes.GetNamedItem("defid").InnerText.ToUpper() != "STARTACTIVITY") && (SObjNode.Attributes.GetNamedItem("defid").InnerText.ToUpper() != "ENDACTIVITY"))
                {
                    SObjWidth = Convert.ToDouble(((XmlElement)SObjNode).GetAttribute("width", ""));
                    SObjHeight = Convert.ToDouble(((XmlElement)SObjNode).GetAttribute("height", ""));
                    if (SObjWidth < SOBJECTWIDTH)
                    {
                        ((XmlElement)SObjNode).SetAttribute("width", SOBJECTWIDTH.ToString());
                        SObjectsTable.Add(SObjNode.Attributes.GetNamedItem("id").InnerText, true);

                    }
                    if (SObjHeight < SOBJECTHEIGHT)
                    {
                        ((XmlElement)SObjNode).SetAttribute("height", SOBJECTHEIGHT.ToString());
                        if (!SObjectsTable.ContainsKey(SObjNode.Attributes.GetNamedItem("id").InnerText))
                            SObjectsTable.Add(SObjNode.Attributes.GetNamedItem("id").InnerText, true);
                    }
                }
            }

            SConnList  = WorkflowDoc.SelectNodes("Diagram/SConnections/SConnection");
            foreach (XmlNode SConn in SConnList)
            {
                if (!((XmlElement)SConn).HasAttribute("disablePorts") && !((XmlElement)SConn).HasAttribute("disableDelete"))
                {
                    changeTransition = false;
                    str_FromID = ((XmlElement)SConn).GetAttribute("From", "");
                    str_ToID = ((XmlElement)SConn).GetAttribute("To", "");
                    SObjectNode = WorkflowDoc.SelectSingleNode("Diagram/SObjects/SObject[@id='" + str_FromID + "']");
                    if (SObjectNode != null)
                    {
                        ToSObjectNode = WorkflowDoc.SelectSingleNode("Diagram/SObjects/SObject[@id='" + str_ToID + "']");
                        if (ToSObjectNode != null)
                        {
                            if ((SObjectsTable.ContainsKey(str_FromID)) && (Convert.ToBoolean(SObjectsTable[str_FromID])))
                            {
                                changeTransition = true;
                            }
                            if ((SObjectsTable.ContainsKey(str_ToID)) && (Convert.ToBoolean(SObjectsTable[str_ToID])))
                            {
                                changeTransition = true;
                            }

                            if (changeTransition)
                            {
                                SrcXCoord = Convert.ToDouble(SObjectNode.Attributes.GetNamedItem("x").InnerText);
                                SrcYCoord = Convert.ToDouble(SObjectNode.Attributes.GetNamedItem("y").InnerText);
                                SrcActWidth = Convert.ToDouble(SObjectNode.Attributes.GetNamedItem("width").InnerText);
                                SrcActHeight = Convert.ToDouble(SObjectNode.Attributes.GetNamedItem("height").InnerText);

                                DestXCoord = Convert.ToDouble(ToSObjectNode.Attributes.GetNamedItem("x").InnerText);
                                DestYCoord = Convert.ToDouble(ToSObjectNode.Attributes.GetNamedItem("y").InnerText);
                                DestActWidth = Convert.ToDouble(ToSObjectNode.Attributes.GetNamedItem("width").InnerText);
                                DestActHeight = Convert.ToDouble(ToSObjectNode.Attributes.GetNamedItem("height").InnerText);

                                SrcXCoord += SrcActWidth;
                                SrcYCoord += (SrcActHeight / 2);
                                DestYCoord += (DestActHeight / 2);
                                SConn.InnerXml = "<Anchors><AnchorPoint x=\"" + SrcXCoord + "\" y=\"" + SrcYCoord + "\"/><AnchorPoint x=\"" + DestXCoord + "\" y=\"" + DestYCoord + "\"/></Anchors>";
                            }
                        }
                        DataNode = SObjectNode.SelectSingleNode("Data");
                        str_Status = ((XmlElement)DataNode).GetAttribute("status", "");
                        switch (str_Status.ToUpper())
                        {

                            case "NEW":
                            case "DRAFT":
                            case "ACTIVE":
                                ((XmlElement)SConn).SetAttribute("disablePorts", "0");
                                ((XmlElement)SConn).SetAttribute("disableDelete", "0");
                                break;
                            case "COMPLETED":
                            case "CANCELLED":
                            case "ONHOLD":
                                if (ToSObjectNode != null)
                                {
                                    DataNode = ToSObjectNode.SelectSingleNode("Data");
                                    str_ToStatus = ((XmlElement)DataNode).GetAttribute("status", "");
                                    if ((str_ToStatus.ToUpper() == "NEW") || (str_ToStatus.ToUpper() == "DRAFT"))
                                    {
                                        ((XmlElement)SConn).SetAttribute("disablePorts", "0");
                                        ((XmlElement)SConn).SetAttribute("disableDelete", "0");
                                    }
                                    else
                                    {
                                        ((XmlElement)SConn).SetAttribute("disablePorts", "1");
                                        ((XmlElement)SConn).SetAttribute("disableDelete", "1");
                                    }
                                }
                                break;

                        }

                    }
                }
            }
            WorkflowXML = WorkflowDoc.OuterXml;
        }

        public String AddEmptyRowInGrid(String TaskType,String TaskStatus, String ApprovalsMode, int NumOfRows)
        {
            StringBuilder sb_EmptyRow = null;
            StringBuilder sb_Attr     = null; 
            ulong         New_ActID   = 0;  
            

            sb_EmptyRow = new StringBuilder(100);
            
            
            for (int Index = 1; Index <= NumOfRows; Index++)
            {

                if (TaskType.ToUpper() == "DISCUSSION")
                {
                    Assetlink.UniqueID.Read(ref New_ActID);
                    sb_EmptyRow.AppendFormat("<gridnode depth=\"0\" id=\"{0}\"><data>", New_ActID.ToString());
                    sb_EmptyRow.Append("<datafield name=\"STATUS\">");
                    sb_EmptyRow.Append("<name text=\"$STATUS\">");
                    if (TaskStatus.ToUpper() == "ACTIVE")
                    {
                        sb_EmptyRow.Append("<row><value text=\"Active\"/></row></name></datafield>");
                    }
                    else
                    {
                        sb_EmptyRow.Append("<row><value text=\"New\"/></row></name></datafield>");
                    }
                    sb_EmptyRow.Append("<datafield name=\"INSTRUCTIONS\"><name text=\"$INSTRUCTIONS\">");
                    sb_EmptyRow.Append("<row>");                    
                    sb_EmptyRow.Append("<value id=\"INSTRUCTIONS_" + New_ActID.ToString() + "\"  text=\"\"/>");
                    sb_EmptyRow.Append("</row>");
                    sb_EmptyRow.Append("</name>");
                    sb_EmptyRow.Append("</datafield>");
                    sb_EmptyRow.Append("<datafield name=\"CONTRIBUTOR\">");
                    sb_EmptyRow.Append("<name text=\"$CONTRIBUTOR\">");
                    sb_EmptyRow.Append("<row>");
                    sb_EmptyRow.Append("<value text=\"");

                    sb_Attr = new StringBuilder(50);

                    sb_Attr.Append("<div><table><tr><td>");
                    sb_Attr.AppendFormat("<div style=\"overflow: hidden;\" class=\"Text\" id=\"TD_{0}\">", New_ActID.ToString());

                    sb_Attr.Append("</div></td><td><div style=\"width:80px;\">");
                    sb_Attr.Append("<img src=\"../../App_Themes/Default/Images/Add_NewContributor.png\" alt=\"\" onclick=\"showtreeview('ALGridContributors','SelectResourceVW',this,'" + New_ActID.ToString() + "')\" />");
                    sb_Attr.Append("</div></td>");
                    //sb_Attr.Append("<td><div style=\"width:20px;\">");
                    //sb_Attr.Append("<img src=\"../../App_Themes/Default/Images/Remove_Contributor.png\" alt=\"\" onclick=\"RemoveResource('" + New_ActID.ToString() + "')\" />");
                    //sb_Attr.Append("</div></td>");
                    sb_Attr.Append("</tr></table></div>");
                    sb_EmptyRow.Append(ALSpecialCharHandling.TrimAndReplaceSpecialChars(sb_Attr.ToString()));

                    sb_EmptyRow.Append("\"></value></row></name></datafield></data></gridnode>");
                }
                else
                {
                    Assetlink.UniqueID.Read(ref New_ActID);
                    sb_EmptyRow.AppendFormat("<gridnode depth=\"0\" id=\"{0}\"><data><datafield name=\"ACTIVITYNAME\">", New_ActID.ToString());
                    sb_EmptyRow.Append("<name text=\"$ACTIVITYNAME\">");
                    sb_EmptyRow.Append("<row><value id=\"STEP_" + New_ActID.ToString() + "\" text=\"\"");
                    if ((TaskStatus.ToUpper() == "ACTIVE") && (ApprovalsMode.ToUpper() == "SIMULTANEOUS"))
                    {
                        sb_EmptyRow.Append(" showeditable=\"false\"");
                    }
                    sb_EmptyRow.Append("/>");
                    sb_EmptyRow.Append("</row></name></datafield>");
                    sb_EmptyRow.Append("<datafield name=\"STATUS\">");
                    sb_EmptyRow.Append("<name text=\"$STATUS\">");
                    if ((TaskType.ToUpper() == "ROUTE") || (TaskType.ToUpper() == "MULTI-FILEROUTE"))
                    {
                        if ((TaskStatus.ToUpper() == "ACTIVE") && (ApprovalsMode.ToUpper() == "SIMULTANEOUS"))
                        {
                            sb_EmptyRow.Append("<row><value text=\"Active\"/></row></name></datafield>");
                        }
                        else
                        {
                            sb_EmptyRow.Append("<row><value text=\"New\"/></row></name></datafield>");
                        }

                    }
                    else
                    {
                        sb_EmptyRow.Append("<row><value text=\"New\"/></row></name></datafield>");
                    }
                    
                    sb_EmptyRow.Append("<datafield name=\"DURATION\"><name text=\"$DURATION\">");
                    sb_EmptyRow.Append("<row><value id=\"DURATION_" + New_ActID.ToString() + "\" text=\"960\"/></row>");
                    sb_EmptyRow.Append("</name></datafield>");
                    sb_EmptyRow.Append("<datafield name=\"INSTRUCTIONS\"><name text=\"$INSTRUCTIONS\">");
                    sb_EmptyRow.Append("<row>");
                    sb_EmptyRow.Append("<value id=\"INSTRUCTIONS_" + New_ActID.ToString() + "\"  text=\"\"/>");
                    sb_EmptyRow.Append("</row>");
                    sb_EmptyRow.Append("</name>");
                    sb_EmptyRow.Append("</datafield>");
                    sb_EmptyRow.Append("<datafield name=\"CONTRIBUTOR\">");
                    sb_EmptyRow.Append("<name text=\"$CONTRIBUTOR\">");
                    sb_EmptyRow.Append("<row>");
                    sb_EmptyRow.Append("<value text=\"");

                    sb_Attr = new StringBuilder(50);

                    sb_Attr.Append("<div><table><tr><td>");
                    sb_Attr.AppendFormat("<div style=\"overflow: hidden;\" class=\"Text\" id=\"TD_{0}\">", New_ActID.ToString());

                    sb_Attr.Append("</div></td><td><div style=\"width:20px;\">");
                    sb_Attr.Append("<img src=\"../../App_Themes/Default/Images/Add_NewContributor.png\" alt=\"\" onclick=\"showtreeview('ALGridContributors','SelectResourceVW',this,'" + New_ActID.ToString() + "')\" />");
                    sb_Attr.Append("</div></td>");
                    //sb_Attr.Append("<td><div style=\"width:20px;\">");
                    //sb_Attr.Append("<img src=\"../../App_Themes/Default/Images/Remove_Contributor.png\" alt=\"\" onclick=\"RemoveResource('" + New_ActID.ToString() + "')\" />");
                    //sb_Attr.Append("</div></td>");
                    sb_Attr.Append("</tr></table></div>");
                    sb_EmptyRow.Append(ALSpecialCharHandling.TrimAndReplaceSpecialChars(sb_Attr.ToString()));

                    sb_EmptyRow.Append("\"></value></row></name></datafield></data></gridnode>");
                }
            }
            return sb_EmptyRow.ToString();
            //RaiseInsertRow(gridid,newargs,id,level,position)
        }

        public String GetCustomToolBar(String TenantName)
        {
            StringBuilder sb_Toolbar = new StringBuilder(100);
            sb_Toolbar.Append("<Toolbar>");
            sb_Toolbar.Append("<Image type='AssignContributor' w='800' h='350'>");

            Byte[] BinaryData;
            //String VirtualPath = "~/" + TenantName + "/App_Themes/Default/Images/AddContributor.jpg";
            String PhysicalPath = ALCommon.GetInstallationDir(); 
            PhysicalPath += TenantName + "\\App_Themes\\Default\\Images\\AddContributors.jpg";
            FileStream FstObj = new FileStream(PhysicalPath, FileMode.Open, FileAccess.Read);

            BinaryData = new Byte[FstObj.Length];
            FstObj.Read(BinaryData, 0, Convert.ToInt32(FstObj.Length));
            FstObj.Close();

            String Base64Data = System.Convert.ToBase64String(BinaryData);

            sb_Toolbar.Append("<Data>" + Base64Data + "</Data>");

            sb_Toolbar.Append("</Image>");            
            sb_Toolbar.Append("</Toolbar>");
            return sb_Toolbar.ToString();
        }

        public ERRORXML GetActivityDefintionIDList(String PackageDefinitionID, String ProcessDefinitionID, out List<String> ActDefList)
        {
            ERRORXML        ErrorXml        = null;
            PMFacadeClass   PmFacadeObj     = null;
            XML             ProcessDefXML   = null;
            XDocument       xDocProcess     = null;

            ActDefList  = new List<string>();
            PmFacadeObj = new PMFacadeClass(SessionID, UserID, TenantName, CurrentLanguage);
            ErrorXml    = PmFacadeObj.GetProcessDefinitionByID(PackageDefinitionID, ProcessDefinitionID, out ProcessDefXML);
            if (ErrorXml == null)
            {
                xDocProcess = XDocument.Parse(ProcessDefXML);
                IEnumerable<XElement> IEnumActEle =  xDocProcess.Element("WORKFLOWPROCESS").Element("PROCESS_ACTIVITY").Elements("ACTIVITY");
                foreach (XElement xeAct in IEnumActEle)
                { 
                    ActDefList.Add(xeAct.Element("ACTIVITYID").Value);
                }
            }

            return ErrorXml;
        }

        public void GetAssociatedFacetListForNotifications(String NotificationTypeIDs, String WorkflowTypeID,String SolutionName, out String AssociatedFacetList)
        {            
            String  str_Solution_ConfigXMLPath = null;
            AssociatedFacetList = String.Empty;

            str_Solution_ConfigXMLPath = ALCommon.GetSolutionConfigurationXMLPath(TenantName, SolutionName, "NotificationConfiguration");
            foreach (String str_NotificationTypeID in NotificationTypeIDs.Split(','))
            {
                if (File.Exists(str_Solution_ConfigXMLPath))
                {
                    XDocument xDocNotif = XDocument.Load(str_Solution_ConfigXMLPath);
                    //IEnumerable<XElement> xeNotif = from result in (xDocNotif.Elements("NOTIFICATIONCONFIGURATION").Elements("NotificationType")) where (result.Attribute("NotificationType").Value == str_NotificationTypeID && result.Element("WFType").Attribute("WFTypeID").Value == WorkflowTypeID) select result;
                    XElement xeNotif = xDocNotif.XPathSelectElement("NOTIFICATIONCONFIGURATION/NotificationType[@NotificationTypeID='" + str_NotificationTypeID + "']/WFType[@WFTypeID='" + WorkflowTypeID + "']");

                    //XElement FirstXeNotif = xeNotif.First();
                    if (xeNotif != null)
                    {
                        IEnumerable<XElement> iEnuXEle = xeNotif.Element("RELATEDFACETS").Elements();

                        foreach (XElement relatedFacets in iEnuXEle)
                        {
                            if (!AssociatedFacetList.Contains(relatedFacets.ToString()))
                                AssociatedFacetList += relatedFacets.ToString();
                        }
                    }
                }
            }
            AssociatedFacetList += @"<RELATIONSHIP NAME='PROCESS_INFORMATION'>
                                        <SELECTLIST>
							                <EXPRESSION>
								                <FIELDNAME>PERCENTDONE</FIELDNAME>
								                <ALIAS>PERCENTDONE</ALIAS>
							                </EXPRESSION>
							                <EXPRESSION>
								                <FIELDNAME>FINISHMODE</FIELDNAME>
								                <ALIAS>FINISHMODE</ALIAS>
							                </EXPRESSION>
							                <EXPRESSION>
								                <FIELDNAME>NOTIFYCONTRIBUTORSONRESPONSE</FIELDNAME>
								                <ALIAS>NOTIFYCONTRIBUTORSONRESPONSE</ALIAS>
							                </EXPRESSION>
							                <EXPRESSION>
								                <FIELDNAME>LASTREMINDERSENT</FIELDNAME>
								                <ALIAS>LASTREMINDERSENT</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>DURATIONUNIT</FIELDNAME>
								                <ALIAS>DURATIONUNIT</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>PROCESSDEFINITIONID</FIELDNAME>
								                <ALIAS>PROCESSDEFINITIONID</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>NOTIFYONRESPONSE</FIELDNAME>
								                <ALIAS>NOTIFYONRESPONSE</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>PROCESSCOST</FIELDNAME>
								                <ALIAS>PROCESSCOST</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>PACKAGEDEFINITIONID</FIELDNAME>
								                <ALIAS>PACKAGEDEFINITIONID</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>DURATION</FIELDNAME>
								                <ALIAS>DURATION</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>COMPLETEDDURATION</FIELDNAME>
								                <ALIAS>COMPLETEDDURATION</ALIAS>
							                </EXPRESSION>
                                        </SELECTLIST>
                                    </RELATIONSHIP>
                                    <RELATIONSHIP NAME='WORKFLOWPROCESS_WORKFLOWINFORMATION'>
                                        <SELECTLIST>
							                <EXPRESSION>
								                <FIELDNAME>ROUTEMETHOD</FIELDNAME>
								                <ALIAS>ROUTEMETHOD</ALIAS>
							                </EXPRESSION>
							                <EXPRESSION>
								                <FIELDNAME>WORKFLOWSUBCATEGORY</FIELDNAME>
								                <ALIAS>WORKFLOWSUBCATEGORY</ALIAS>
							                </EXPRESSION>
							                <EXPRESSION>
								                <FIELDNAME>REVISIONNUMBER</FIELDNAME>
								                <ALIAS>REVISIONNUMBER</ALIAS>
							                </EXPRESSION>
							                <EXPRESSION>
								                <FIELDNAME>REMINDERFREQUENCY</FIELDNAME>
								                <ALIAS>REMINDERFREQUENCY</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>NOTIFYINADVANCE</FIELDNAME>
								                <ALIAS>NOTIFYINADVANCE</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>NOTIFYNOOFDAYS</FIELDNAME>
								                <ALIAS>NOTIFYNOOFDAYS</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>APPROVALSJOBID</FIELDNAME>
								                <ALIAS>APPROVALSJOBID</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>NOTIFYIFJOBDELAYED</FIELDNAME>
								                <ALIAS>NOTIFYIFJOBDELAYED</ALIAS>
							                </EXPRESSION>
                                            <EXPRESSION>
								                <FIELDNAME>WORKFLOWCATEGORY</FIELDNAME>
								                <ALIAS>WORKFLOWCATEGORY</ALIAS>
							                </EXPRESSION>
                                        </SELECTLIST>
                                    </RELATIONSHIP>";
        }


        public void GetAssociatedFacetListForNotifications_Brief(String NotificationTypeIDs, String WorkflowTypeID,String SolutionName, out String AssociatedFacetList)
        {            
            String  str_Solution_ConfigXMLPath = null;
            AssociatedFacetList = String.Empty;

            str_Solution_ConfigXMLPath = ALCommon.GetSolutionConfigurationXMLPath(TenantName, SolutionName, "NotificationConfiguration");
            foreach (String str_NotificationTypeID in NotificationTypeIDs.Split(','))
            {
                if (File.Exists(str_Solution_ConfigXMLPath))
                {
                    XDocument xDocNotif = XDocument.Load(str_Solution_ConfigXMLPath);
                    //IEnumerable<XElement> xeNotif = from result in (xDocNotif.Elements("NOTIFICATIONCONFIGURATION").Elements("NotificationType")) where (result.Attribute("NotificationType").Value == str_NotificationTypeID && result.Element("WFType").Attribute("WFTypeID").Value == WorkflowTypeID) select result;
                    XElement xeNotif = xDocNotif.XPathSelectElement("NOTIFICATIONCONFIGURATION/NotificationType[@NotificationTypeID='" + str_NotificationTypeID + "']/WFType[@WFTypeID='" + WorkflowTypeID + "']");

                    //XElement FirstXeNotif = xeNotif.First();
                    if (xeNotif != null)
                    {
                        IEnumerable<XElement> iEnuXEle = xeNotif.Element("RELATEDFACETS").Elements();

                        foreach (XElement relatedFacets in iEnuXEle)
                        {
                            if (!AssociatedFacetList.Contains(relatedFacets.ToString()))
                                AssociatedFacetList += relatedFacets.ToString();
                        }
                    }
                }
            }            
        }
        /// <summary>
        /// <CreatedOn>2 Nov 2011</CreatedOn>        
        /// <Author>Mugdha Moolay</Author>
        /// <Purpose>This method is used to remove the component facets 
        /// from the list of associated FACETS with ACTIVITY(since they are not directly associated with ACTIVITY)</Purpose>
        /// </summary>
        /// <param name="xEleProcess">This Elements points to the Process Definition XML</param>
        /// <param name="ActivityDefID">The Activity Definition ID</param>
        /// <param name="ActAssociatedFacets">The List of facets associated with ACTIVITY</param>
        /// <returns>Update Activity Facet List</returns>
        public String GetActivityAssociatedFacets(XElement xEleProcess, String ActivityDefID, String ActAssociatedFacets)
        {
            StringBuilder FilteredActFacets = null;
            FilteredActFacets = new StringBuilder(100);
            XElement xEleAct = xEleProcess.Element("PROCESS_ACTIVITY").Elements("ACTIVITY").Single(result => result.Element("ACTIVITYID").Value == ActivityDefID);
            if ((xEleAct != null) && (xEleAct.Element("ACTIVITY_COMPONENTFACET") != null))
            {
                XElement xEleComponentFacet = xEleAct.Element("ACTIVITY_COMPONENTFACET").Element("FACET");
                if (xEleComponentFacet != null)
                {
                    String[] ActFacetArr = ActAssociatedFacets.Split(';');
                    foreach (String Facet in ActFacetArr)
                    {
                        if (Facet.ToUpper() != xEleComponentFacet.Element("RELATIONSHIPNAME").Value)
                        {
                            FilteredActFacets.Append(Facet+ ";");
                        }
                    }
                }
                else
                {
                    return ActAssociatedFacets;
                }
            }
            else
            {
                return ActAssociatedFacets;
            }
            if (FilteredActFacets.Length > 1)
            {
                FilteredActFacets.Remove(FilteredActFacets.Length - 1, 1);
            }
            return FilteredActFacets.ToString();
        }

        public Boolean CheckIfMultipleResourcesAreAssociated(XPathDocument xpResDoc, String ActivityID)
        {
            XPathNodeIterator xpItr = null;
            XPathNavigator xpActivityNav = null;

            xpActivityNav = xpResDoc.CreateNavigator().SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY [@ActivityID='" + ActivityID + "']");
            if (xpActivityNav != null)
            {
                xpItr = xpActivityNav.Select("RESOURCE [(translate(@Selected,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]");

                if(xpItr != null)
                {
                    if (xpItr.Count > 1)
                        return true;
                }
            }
            return false;
        }

        public String ProcessActivityResourceXML(XPathDocument xpResDoc, XmlNode ActivityNode, String ActivityID, String SelectedGroupID)
        {
            //multiple resource nodes are present as earlier if cond. is satisfied
            //Resource node may be present and disassociate node may be present.

            XPathNodeIterator xpItr = null;
            XPathNavigator xpActivityNav = null;
            StringBuilder ResourceXML = null;
            String ActivityResourceDisAssociationList = null;
            XmlNode TmpNode = null;

            xpActivityNav = xpResDoc.CreateNavigator().SelectSingleNode("ACTIVITYCOLLECTION/ACTIVITY [@ActivityID='" + ActivityID + "']");
            if (xpActivityNav != null)
            {
                xpItr = xpActivityNav.Select("RESOURCE [(translate(@Selected,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')='TRUE')]");

                while (xpItr.MoveNext())
                {
                    if(xpItr.Current.GetAttribute("ResourceID","") == SelectedGroupID)
                    continue;

                    //ACTIVITY_RESOURCE/RESOURCE/ACTUAL_RESOURCE/RESOURCE

                    if (ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + xpItr.Current.GetAttribute("ResourceID", "") + "']") != null)
                    {
                        TmpNode = ActivityNode.SelectSingleNode("ACTIVITY_RESOURCE/RESOURCE[RESOURCEID='" + xpItr.Current.GetAttribute("ResourceID", "") + "']/ACTUAL_RESOURCE/RESOURCE/RESOURCEID");

                        if(TmpNode != null)
                        {
                            ResourceXML = new StringBuilder(200);
                            ResourceXML.Append("<RESOURCE MODIFIED='TRUE'>");
                            ResourceXML.AppendFormat("<RESOURCEID>{0}</RESOURCEID>",xpItr.Current.GetAttribute("ResourceID",""));
                            ResourceXML.AppendFormat("<ACTUAL_RESOURCE TYPE='RELATION' DISASSOCIATE='TRUE'>{0}</ACTUAL_RESOURCE>",TmpNode.InnerText);
                            ResourceXML.Append("</RESOURCE>");

                            ActivityResourceDisAssociationList += ResourceXML.ToString();
                        }
                    }
                }
            }
            return ActivityResourceDisAssociationList;
        }

        /// <summary>
        /// <CreatedOn>30 March 2012</CreatedOn>
        /// <Author>Mr. Hemant Karkande</Author>
        /// <Purpose>To prepare search input XML for User Group list</Purpose>
        /// </summary>
        /// <param name="xpathNav_ProcessGroup">Process Group navigator</param>
        /// <param name="xpathNav_ProcessUser">Process User navigator</param>
        /// <returns></returns>
        public String PrepareUserGroupListSearchXml(XPathNavigator xpathNav_ProcessGroup, XPathNavigator xpathNav_ProcessUser)
        {
            StringBuilder       sb_SearchInputXml           = null;
            XPathNodeIterator   xpathNodeIter_UserGroups    = null;
            MWB_Helper          obj_MWBHelper               = null;
            XPathExpression     xpathExp_SelectSortedUG     = null;
            XPathDocument       xpathDoc_UG                 = null;

            sb_SearchInputXml = new StringBuilder(200);

            sb_SearchInputXml.Append("<SEARCHINPUTXML><USERGROUPCOLLECTION>");
            //Prepare search input xml for groups
            if (xpathNav_ProcessGroup != null)
            {
                xpathExp_SelectSortedUG = XPathExpression.Compile("GROUP");
                xpathExp_SelectSortedUG.AddSort("GROUPNAME", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);

                xpathNodeIter_UserGroups = xpathNav_ProcessGroup.Select(xpathExp_SelectSortedUG);
                while (xpathNodeIter_UserGroups.MoveNext())
                {
                    sb_SearchInputXml.Append(@"<USERGROUP>
                                                <USERGROUPID>" + xpathNodeIter_UserGroups.Current.SelectSingleNode("GROUPID").Value + @"_G</USERGROUPID>
                                                <USERGROUPNAME>" + ALSolutionCommon.TrimAndReplaceSpecialChars(xpathNodeIter_UserGroups.Current.SelectSingleNode("GROUPNAME").Value) + @"</USERGROUPNAME>
                                                <USERGROUPTYPE>Group</USERGROUPTYPE>
                                                <USERGROUPTYPEDISPLAY>" + Localization.GetString("ALResource", TenantName, "Group_Shared") + @"</USERGROUPTYPEDISPLAY>
                                              </USERGROUP>");
                }
            }
            xpathNodeIter_UserGroups = null;
            //Prepare search input xml for users.
            if (xpathNav_ProcessUser != null)
            {
                obj_MWBHelper = new MWB_Helper(SessionID, UserID, TenantName, CurrentLanguage);
                xpathNodeIter_UserGroups = xpathNav_ProcessUser.Select("USER");
                StringBuilder sb_temp =new StringBuilder (150);
                if (xpathNodeIter_UserGroups.Count > 0)
                {
                    sb_temp.Append("<USERGROUPCOLLECTION>");
                    while (xpathNodeIter_UserGroups.MoveNext())
                    {
                        sb_temp.Append(@"<USERGROUP>
                                            <USERGROUPID>" + xpathNodeIter_UserGroups.Current.SelectSingleNode("USERID").Value + @"_U</USERGROUPID>
                                            <USERGROUPNAME>" + ALSolutionCommon.TrimAndReplaceSpecialChars(obj_MWBHelper.getUserName(xpathNodeIter_UserGroups.Current)) + @"</USERGROUPNAME>
                                            <USERGROUPTYPE>User</USERGROUPTYPE>
                                            <USERGROUPTYPEDISPLAY>" + Localization.GetString("ALResource", TenantName, "User_Shared") + @"</USERGROUPTYPEDISPLAY>
                                        </USERGROUP>");
                    }
                    sb_temp.Append("</USERGROUPCOLLECTION>");
                    xpathDoc_UG = new XPathDocument(new StringReader(sb_temp.ToString()));

                    xpathExp_SelectSortedUG = XPathExpression.Compile("USERGROUPCOLLECTION/USERGROUP");
                    xpathExp_SelectSortedUG.AddSort("USERGROUPNAME", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);

                    xpathNodeIter_UserGroups = xpathDoc_UG.CreateNavigator().Select(xpathExp_SelectSortedUG);
                    while (xpathNodeIter_UserGroups.MoveNext())
                    {
                        sb_SearchInputXml.Append(xpathNodeIter_UserGroups.Current.OuterXml);
                    }
                }
            }
            sb_SearchInputXml.Append("</USERGROUPCOLLECTION></SEARCHINPUTXML>");

            return sb_SearchInputXml.ToString();
        }

        /// <summary>
        /// <Author>Mr. Hemant Karkande</Author>
        /// <Purpose>To Prepare View Tasks screen URL</Purpose>
        /// </summary>
        /// <returns>View Tasks screen URL</returns>
        public String GetViewTasksScreenURL()
        {
            StringBuilder       ParamURL            = null;
            StringBuilder       URL                 = null;
            String              EncryptURL          = null;
            ALSolutionCommon    ALSolutionCommonObj = null;

            ParamURL = new StringBuilder(50);
            URL = new StringBuilder(50);
            ALSolutionCommonObj = new ALSolutionCommon();
            ParamURL.Append("Manage_TaskList.aspx?TenantName=" + TenantName + "&Language=" + CurrentLanguage + "&SessionID=" + SessionID + "&UserID=" + UserID + "");
            EncryptURL = ALSolutionCommonObj.EncodeURLForResponseRedirects(ParamURL.ToString());
            URL.Append("window.open('" + "" + EncryptURL.ToString() + "" + "','_self','');");
            return URL.ToString();
        }
        #endregion

        # region Private Methods
            //Hemant Karkande for Predecessors
            /// <alsummary>
            /// <createddate>31 January 2007</createddate>
            /// <author>Hemant Karkande</author>
            /// <purpose>To update predecessors transitions for the project in the data base.</purpose>
            /// <featurelist>
            ///     <feature></feature>
            /// </featurelist>
            /// <xmlstructure><![CDATA[]]></xmlstructure>
            /// 	<xmlattributes>
            /// 		<node>
            ///	        <name/>
            ///	<parentnode/>
            ///	<attribute/>
            ///</node>
            /// </xmlattributes>
            /// </alsummary>        
            private ERRORXML UpdatePredecessors(XmlNode Process_TransitionNode, String ParentID, String FilePath)
            {
                ERRORXML                    ErrorXMLString          = null; 
                XmlDocument                 InputXMLDoc             = null; 
                XmlNode                     WFProcessNode           = null;
                XmlNode                     WFProcessIDNode         = null;
                XmlNode                     Diss_Process_Transition = null;
                XmlNode                     New_Process_Transition  = null; 
                XmlNode                     FromActivityNode        = null;
                XmlNode                     ToActivityNode          = null;
                XmlNode                     FromActivity            = null;
                XmlNode                     ToActivity              = null; 
                XmlNode                     ParentNode              = null; 
                XmlNode                     StartTransition         = null;
                XmlNode                     EndTransition           = null; 
                XmlNodeList                 ModifiedTranitions      = null; 
                XmlAttribute                TypeAttribute           = null;
                XmlAttribute                DisassociateAttribute   = null;
                XML                         UpdateProcessXML        = null; 
                String                      FromActivityID          = null;
                String                      ToActivityID            = null; 
                MktgWorkBenchFacadeClass    MktWorkBenchFacadeObj   = null; 
    			
                try
                {
                    InputXMLDoc             = new XmlDocument();
                    MktWorkBenchFacadeObj   = new MktgWorkBenchFacadeClass(SessionID, UserID, TenantName, CurrentLanguage); 

                    WFProcessNode = InputXMLDoc.CreateElement("WORKFLOWPROCESS");
                    InputXMLDoc.AppendChild(WFProcessNode);

                    WFProcessIDNode = InputXMLDoc.CreateElement("WORKFLOWPROCESSID");
                    WFProcessIDNode.InnerText = ParentID;
                    WFProcessNode.AppendChild(WFProcessIDNode);   

                    ModifiedTranitions = Process_TransitionNode.SelectNodes("TRANSITION[@Operation='Deleted' or @Operation='New']");
                    if (ModifiedTranitions.Count > 0)
                    {
                        foreach (XmlNode Transition in ModifiedTranitions)
                        {
                            if (Transition.Attributes.GetNamedItem("Operation").InnerText.ToUpper() == "DELETED")
                            {
                                Diss_Process_Transition = InputXMLDoc.CreateElement("PROCESS_TRANSITION");
                                TypeAttribute = InputXMLDoc.CreateAttribute("TYPE");
                                TypeAttribute.InnerText = "RELATION";
                                Diss_Process_Transition.Attributes.Append(TypeAttribute);

                                DisassociateAttribute = InputXMLDoc.CreateAttribute("DISASSOCIATE");
                                DisassociateAttribute.InnerText = "TRUE";
                                Diss_Process_Transition.Attributes.Append(DisassociateAttribute);

                                Diss_Process_Transition.InnerText = Transition.SelectSingleNode("TRANSITIONID").InnerText;
                                WFProcessNode.AppendChild(Diss_Process_Transition);

                                CheckForAtleastOnePredecessor(Transition, FilePath, out StartTransition, out EndTransition);
                                   
                                if ((StartTransition != null) && (StartTransition.HasChildNodes))
                                {
                                    FromActivityNode    = StartTransition.SelectSingleNode("FROMACTIVITY");
                                    FromActivity        = FromActivityNode.SelectSingleNode("ACTIVITY");
                                    FromActivityID      = FromActivity.SelectSingleNode("ACTIVITYID").InnerText;
                                    FromActivityNode.RemoveChild(FromActivity);
                                    FromActivityNode.InnerText = FromActivityID;

                                    ToActivityNode      = StartTransition.SelectSingleNode("TOACTIVITY");
                                    ToActivity          = ToActivityNode.SelectSingleNode("ACTIVITY");
                                    ToActivityID        = ToActivity.SelectSingleNode("ACTIVITYID").InnerText;
                                    ToActivityNode.RemoveChild(ToActivity);
                                    ToActivityNode.InnerText = ToActivityID;

                                    if (New_Process_Transition != null)
                                    {
                                        New_Process_Transition.AppendChild(InputXMLDoc.ImportNode(StartTransition, true));
                                    }
                                    else
                                    {
                                        New_Process_Transition  = InputXMLDoc.CreateElement("PROCESS_TRANSITION");
                                        TypeAttribute           = InputXMLDoc.CreateAttribute("TYPE");
                                        TypeAttribute.InnerText = "RELATION";
                                        New_Process_Transition.Attributes.Append(TypeAttribute);
                                        New_Process_Transition.AppendChild(InputXMLDoc.ImportNode(StartTransition, true));
                                        WFProcessNode.AppendChild(New_Process_Transition);
                                    }
                                }

                                if ((EndTransition != null) && (EndTransition.HasChildNodes))
                                {
                                    FromActivityNode    = EndTransition.SelectSingleNode("FROMACTIVITY");
                                    FromActivity        = FromActivityNode.SelectSingleNode("ACTIVITY");
                                    FromActivityID      = FromActivity.SelectSingleNode("ACTIVITYID").InnerText;
                                    FromActivityNode.RemoveChild(FromActivity);
                                    FromActivityNode.InnerText = FromActivityID;

                                    ToActivityNode      = EndTransition.SelectSingleNode("TOACTIVITY");
                                    ToActivity          = ToActivityNode.SelectSingleNode("ACTIVITY");
                                    ToActivityID        = ToActivity.SelectSingleNode("ACTIVITYID").InnerText;
                                    ToActivityNode.RemoveChild(ToActivity);
                                    ToActivityNode.InnerText = ToActivityID;

                                    if (New_Process_Transition != null)
                                    {
                                        New_Process_Transition.AppendChild(InputXMLDoc.ImportNode(EndTransition, true));
                                    }
                                    else
                                    {
                                        New_Process_Transition  = InputXMLDoc.CreateElement("PROCESS_TRANSITION");
                                        TypeAttribute           = InputXMLDoc.CreateAttribute("TYPE");
                                        TypeAttribute.InnerText = "RELATION";
                                        New_Process_Transition.Attributes.Append(TypeAttribute);
                                        New_Process_Transition.AppendChild(InputXMLDoc.ImportNode(EndTransition, true));
                                        WFProcessNode.AppendChild(New_Process_Transition);
                                    }
                                }

                                ParentNode = Transition.ParentNode;
                                ParentNode.RemoveChild(Transition); 
                            }
                            else if (Transition.Attributes.GetNamedItem("Operation").InnerText.ToUpper() == "NEW")
                            {
                                Transition.Attributes.RemoveAll();
                                FromActivityNode            = Transition.SelectSingleNode("FROMACTIVITY");
                                FromActivity                = FromActivityNode.SelectSingleNode("ACTIVITY");
                                FromActivityID              = FromActivity.SelectSingleNode("ACTIVITYID").InnerText;
                                FromActivityNode.RemoveChild(FromActivity);
                                FromActivityNode.InnerText = FromActivityID; 
                                
                                ToActivityNode           = Transition.SelectSingleNode("TOACTIVITY");
                                ToActivity               = ToActivityNode.SelectSingleNode("ACTIVITY");
                                ToActivityID             = ToActivity.SelectSingleNode("ACTIVITYID").InnerText;
                                ToActivityNode.RemoveChild(ToActivity);
                                ToActivityNode.InnerText = ToActivityID;

                                if (New_Process_Transition != null)
                                {
                                    New_Process_Transition.AppendChild(InputXMLDoc.ImportNode(Transition, true));
                                }
                                else
                                {
                                    New_Process_Transition  = InputXMLDoc.CreateElement("PROCESS_TRANSITION");
                                    TypeAttribute           = InputXMLDoc.CreateAttribute("TYPE");
                                    TypeAttribute.InnerText = "RELATION";
                                    New_Process_Transition.Attributes.Append(TypeAttribute);
                                    New_Process_Transition.AppendChild(InputXMLDoc.ImportNode(Transition, true));
                                    WFProcessNode.AppendChild(New_Process_Transition);
                                }
                            }
                        }
                        UpdateProcessXML = InputXMLDoc.OuterXml;
                        //ErrorXMLString = MktWorkBenchFacadeObj.UpdateProject(true, ref UpdateProcessXML);
                    }
                    return ErrorXMLString;
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj);  
                }
            }
            
            //Hemant Karkande for Predecessors
            private void CheckForAtleastOnePredecessor(XmlNode TransitionNode, String FilePath, out XmlNode StartNode, out XmlNode EndNode)
            {
                XmlDocument         InputXMLDoc                 = null;
                XmlDocument         ReturnXMLDoc                = null; 
                XmlNode             Process_TransitionNode      = null; 
                XmlNode             WFProcessNode               = null;
                XmlNode             StartActivityNode           = null; 
                XmlNode             NewTransitionNode           = null; 
                XmlNode             TempActivityNode            = null; 
                XmlNode             TempFromActivityNode        = null;
                XmlNode             EndActivityNode             = null; 
                XmlNodeList         PredecessorNodeList         = null; 
                String              ToActivityID                = null; 
                String              FromActivityID              = null; 
                StringBuilder       ReturnXML                   = null; 
                ulong               TransitionID                = 0;

                try
                {
                    InputXMLDoc     = new XmlDocument();
                    ReturnXMLDoc    = new XmlDocument();

                    InputXMLDoc.Load(FilePath);  
                    WFProcessNode = InputXMLDoc.SelectSingleNode("WORKFLOWPROCESS");  
                    //Get the To Activity id
                    TempActivityNode = TransitionNode.SelectSingleNode("TOACTIVITY/ACTIVITY");
                    ToActivityID     = TempActivityNode.SelectSingleNode("ACTIVITYID").InnerText;

                    //Get the From Activity id
                    TempFromActivityNode = TransitionNode.SelectSingleNode("FROMACTIVITY/ACTIVITY");
                    FromActivityID       = TempFromActivityNode.SelectSingleNode("ACTIVITYID").InnerText;

                    //Check for whether there is any predecessor for this activity or not
                    Process_TransitionNode = WFProcessNode.SelectSingleNode("PROCESS_TRANSITION");
                    PredecessorNodeList = Process_TransitionNode.SelectNodes("TRANSITION[TOACTIVITY/ACTIVITY/ACTIVITYID/text() = " + ToActivityID + "]");
                    if (PredecessorNodeList.Count == 0)
                    {
                        StartActivityNode = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[STARTACTIVITY/text() = 'True']");
                        if (StartActivityNode != null)
                        {
                            
                            ReturnXMLDoc = null;
                            ReturnXMLDoc = new XmlDocument();
                            ReturnXML = new StringBuilder();
                            
                            Assetlink.UniqueID.Read(ref TransitionID);

                            NewTransitionNode = ReturnXMLDoc.CreateElement("TRANSITION");
                            ReturnXMLDoc.AppendChild(NewTransitionNode);  

                            ReturnXML.AppendFormat("<TRANSITIONID>{0}</TRANSITIONID>", TransitionID.ToString());
                            ReturnXML.AppendFormat("<TRANSITIONNAME>From Activity {0} To Acivity {1}</TRANSITIONNAME>", StartActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, TempActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText);
                            ReturnXML.AppendFormat("<FROMACTIVITY TYPE='RELATION'>{0}</FROMACTIVITY>", StartActivityNode.OuterXml);
                            ReturnXML.AppendFormat("<TOACTIVITY TYPE='RELATION'>{0}</TOACTIVITY>", TempActivityNode.OuterXml);

                            NewTransitionNode.InnerXml = ReturnXML.ToString();  

                            Process_TransitionNode.AppendChild(InputXMLDoc.ImportNode(NewTransitionNode, true));
                            InputXMLDoc.Save(FilePath);
                            StartNode = NewTransitionNode;   
                        }
                        else
                            StartNode = null; 
                    }
                    else
                        StartNode = null;   

                    //Check for the End Activity
                    PredecessorNodeList = Process_TransitionNode.SelectNodes("TRANSITION[FROMACTIVITY/ACTIVITY/ACTIVITYID/text() = " + FromActivityID + "]");
                    if (PredecessorNodeList.Count == 0)
                    {
                        EndActivityNode = WFProcessNode.SelectSingleNode("PROCESS_ACTIVITY/ACTIVITY[ENDACTIVITY/text() = 'True']");
                        if (EndActivityNode != null)
                        {
                            ReturnXMLDoc = null;
                            ReturnXMLDoc = new XmlDocument();
                            NewTransitionNode = ReturnXMLDoc.CreateElement("TRANSITION");
                            ReturnXMLDoc.AppendChild(NewTransitionNode);

                            if (ReturnXML != null)
                                ReturnXML.Remove(0, ReturnXML.Length);
                            else
                                ReturnXML = new StringBuilder();

                            Assetlink.UniqueID.Read(ref TransitionID);

                            ReturnXML.AppendFormat("<TRANSITIONID>{0}</TRANSITIONID>", TransitionID.ToString());
                            ReturnXML.AppendFormat("<TRANSITIONNAME>From Activity {0} To Acivity {1}</TRANSITIONNAME>", TempFromActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText, EndActivityNode.SelectSingleNode("ACTIVITYNAME").InnerText);
                            ReturnXML.AppendFormat("<FROMACTIVITY TYPE='RELATION'>{0}</FROMACTIVITY>", TempFromActivityNode.OuterXml);
                            ReturnXML.AppendFormat("<TOACTIVITY TYPE='RELATION'>{0}</TOACTIVITY>", EndActivityNode.OuterXml);

                            NewTransitionNode.InnerXml = ReturnXML.ToString(); 
                              
                            Process_TransitionNode.AppendChild(InputXMLDoc.ImportNode(NewTransitionNode, true));
                            InputXMLDoc.Save(FilePath);
                            EndNode = NewTransitionNode;
                        }
                        else
                            EndNode = null;
                    }
                    else
                        EndNode = null;   
                }
                catch (Exception ExceptionObj)
                {
                    throw (ExceptionObj); 
                }
            }

            private Boolean CheckForMAAccess(String ActivityID, XPathNavigator xpNav_SolutionConfigRoot)
            {
                XPathDocument       xpDoc_UserDetails               = null;
                XPathNavigator      xpNav_UserDetails               = null;
                XPathNavigator      xpNav_CompleteAccessReq         = null;
                XPathNodeIterator   xpNodeItr_CompleteAccessGroups  = null;
                XPathNodeIterator   xpNodeItr_UserAccessPresent     = null;

                StringBuilder   sb_GroupIDs    = null;
                StringBuilder   SearchInputXML = null;

                ERRORXML ErrorXML   = null;
                XML      UserXML    = null;
                
                Boolean CompleteAccessRequired  = false;
                Boolean UserAccessPresent       = false;
                                         
                SearchConfiguration SearchObj   = null;
         
                try
                {
                    xpNav_CompleteAccessReq = xpNav_SolutionConfigRoot.SelectSingleNode("GROUPACCESS/COMPLELETEACCESS/COMPLELETEACCESSREQUIRED");
                    if (xpNav_CompleteAccessReq != null && xpNav_CompleteAccessReq.InnerXml.ToUpper().Equals("TRUE"))
                    {
                        CompleteAccessRequired = true;
                    }
                    if (CompleteAccessRequired)
                    {
                        xpNodeItr_CompleteAccessGroups = xpNav_SolutionConfigRoot.Select("GROUPACCESS/COMPLELETEACCESS/COMPLELETEACCESSGROUPLIST/FilterCollection/RestrictedGroupList/GROUPID");
                        if ( (xpNodeItr_CompleteAccessGroups != null) && (xpNodeItr_CompleteAccessGroups.Count > 0))
                        {
                            sb_GroupIDs = new StringBuilder(20);
                            sb_GroupIDs.Append("(");
                            while (xpNodeItr_CompleteAccessGroups.MoveNext())
                            {
                                sb_GroupIDs.AppendFormat("{0},", xpNodeItr_CompleteAccessGroups.Current.InnerXml);
                            }
                            sb_GroupIDs.Remove(sb_GroupIDs.Length-1, 1);
                            sb_GroupIDs.Append(")");
                        }
                    }

                    SearchObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    SearchInputXML = new StringBuilder();
                    SearchInputXML.AppendFormat(@"<SEARCH>
                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                <TARGETOBJECT>USER</TARGETOBJECT>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                                <TARGETENTITY>
                                                    <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                    <FILTERLIST>
                                                        <FILTER>
			                                                <FILTERID>1</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{2}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                </FILTER>
                                                    </FILTERLIST> 
                                                    <SELECTLIST>
                                                        <EXPRESSION>
                                                            <FIELDNAME>USERID</FIELDNAME>
                                                            <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>",CurrentLanguage, TenantName, UserID, SessionID);

                    if (sb_GroupIDs != null) // if complete access groups are present
                    {
                       SearchInputXML.AppendFormat(@"<RELATIONSHIP NAME='GROUP_MEMBERUSER'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>GROUPID</FIELDNAME>
                                                                <ALIAS>GROUPID</ALIAS>
                                                            </EXPRESSION>			                                            
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>GROUPID</EXPRESSION>
			                                                    <OPERATOR>IN</OPERATOR>
			                                                    <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                        </FILTERLIST>
                                                    </RELATIONSHIP>", sb_GroupIDs.ToString());
                    }


                    SearchInputXML.AppendFormat(@" <RELATIONSHIP NAME='MARKETING_ACTIVITY_OWNER'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                                            </EXPRESSION>			                                            
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                        </FILTERLIST> 
                                                    </RELATIONSHIP>
                                                    <RELATIONSHIP NAME='BUDGETMANAGER'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                                            </EXPRESSION>			                                            
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                        </FILTERLIST> 
                                                    </RELATIONSHIP>
                                                    <RELATIONSHIP NAME='MARKETING_ACTIVITY_READERS'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                                            </EXPRESSION>			                                            
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                        </FILTERLIST> 
                                                    </RELATIONSHIP>
                                                    <RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                                            </EXPRESSION>			                                            
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                        </FILTERLIST> 
                                                    </RELATIONSHIP>
                                                    <RELATIONSHIP NAME='MARKETING_ACTIVITY_CREATOR'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                                            </EXPRESSION>			                                            
                                                        </SELECTLIST>
                                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>				                                        
		                                                    </FILTER>
                                                        </FILTERLIST> 
                                                    </RELATIONSHIP>
                                                </TARGETENTITY>                                                    
                                              </SEARCH>",  ActivityID);
                    ErrorXML = SearchObj.GetHierarchialData(SearchInputXML.ToString(), ref UserXML);
                    if (ErrorXML == null)
                    {
                        xpDoc_UserDetails = new XPathDocument(new System.IO.StringReader(UserXML));
                        xpNav_UserDetails = xpDoc_UserDetails.CreateNavigator();
                        xpNav_UserDetails  = xpNav_UserDetails.SelectSingleNode("USERCOLLECTION/USER");

                        xpNodeItr_UserAccessPresent = xpNav_UserDetails.SelectChildren(XPathNodeType.All);
                        if (xpNodeItr_UserAccessPresent.Count > 0)
                        {
                            String str_NodeName = null;
                            while (xpNodeItr_UserAccessPresent.MoveNext())
                            {
                               str_NodeName = xpNodeItr_UserAccessPresent.Current.Name;
                               if (str_NodeName.ToUpper() == "GROUP_MEMBERUSER")
                               {
                                        UserAccessPresent = true;
                                        break;
                               }
                               if (str_NodeName.ToUpper() == "MARKETING_ACTIVITY_OWNER")
                               {
                                        UserAccessPresent = true;
                                        break;
                               }
                               if (str_NodeName.ToUpper() == "BUDGETMANAGER")
                               {
                                        UserAccessPresent = true;
                                        break;
                               }
                               if (str_NodeName.ToUpper() == "MARKETING_ACTIVITY_COORDINATOR")
                               {
                                        UserAccessPresent = true;
                                        break;
                               }
                               if (str_NodeName.ToUpper() == "MARKETING_ACTIVITY_READERS")
                               {
                                        UserAccessPresent = true;
                                        break;
                               }
                               if (str_NodeName.ToUpper() == "MARKETING_ACTIVITY_CREATOR")
                               {
                                        UserAccessPresent = true;
                                        break;
                               }
                            }
                        }
                    }
                    return UserAccessPresent;
                }
                catch (Exception ExcepObj)
                {
                    throw ExcepObj;
                }

            }

        
            /// <summary>
            /// <CreatedOn>15th May 2009</CreatedOn>
            /// <Author>Anita Kale</Author>
            /// <Purpose>To get ProjectID and ProjectTypeID depending on ObjectType is Deliverable or Task</Purpose>
            /// </summary>
            /// <param name="ObjectID">WorkflowProcessID</param>
            /// <param name="ObjectType">WorkflowProcessType (Task or Deliveable)</param>
            /// <param name="ProjectID"></param>
            /// <param name="ProjectTypeID"></param>
            private void getProjectID(String ObjectID,String ObjectType, out String ProjectID,out String ProjectTypeID)
            {
                ERRORXML                    errorxml_Output         = null;
                XPathDocument               xpathdoc_ProjectDoc     = null;
                XPathNavigator              xpathnav_ProjectNav     = null;
                XPathNavigator              xpathnav_DeliverableNav = null;
                XPathNavigator              xpathnav_ProcessDefNav  = null;
                XPathNavigator              xpathnav_Tempnav        = null;
                XML                         xml_ProjectXML          = null;
                StringBuilder               sb_SearchInputxml       = null;
                SearchConfiguration         SearchObj               = null;
                try
                {
                    #region Search
                    sb_SearchInputxml = new StringBuilder(100);
                            
                    //Chk Object Type is Task or Deliverable
                    //Depending on type get project
                    if (ObjectType.Equals("Task", StringComparison.CurrentCultureIgnoreCase))
                    {
                        #region Task
                        sb_SearchInputxml.AppendFormat(@"<SEARCH>
			                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
			                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
			                                <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
			                                <SESSIONINFO UserID='{0}' Language='{1}' TenantName='{2}' SessionID='{3}'/>
			                                <TARGETENTITY>
				                                <PRIVILEGENAME>READ</PRIVILEGENAME>
				                                <SELECTLIST>
					                                <EXPRESSION>
						                                <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
						                                <ALIAS>WORKFLOWPROCESSID</ALIAS>
					                                </EXPRESSION>
				                                </SELECTLIST>
				                                <FILTERLIST>
					                                <FILTER>
						                                <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
						                                <OPERATOR>EQUALTO</OPERATOR>
						                                <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
						                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
					                                </FILTER>
					                             </FILTERLIST>
                                                <RELATIONSHIP NAME='DELIVERABLE_TASK' HIERARCHY='BOTTOMUP'>
                                                    <SELECTLIST>
						                                <EXPRESSION>
							                                <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
							                                <ALIAS>WORKFLOWPROCESSID</ALIAS>
						                                </EXPRESSION>
						                            </SELECTLIST>
                                                    <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
						                                        <ALIAS>WORKFLOWPROCESSID</ALIAS>
					                                        </EXPRESSION>
					                                    </SELECTLIST>
                                                        <RELATIONSHIP NAME='PROCESS_INFORMATION'>
                                                            <SELECTLIST>
                                                                <EXPRESSION>
					                                                <FIELDNAME>PROCESSDEFINITIONID</FIELDNAME>
					                                                <ALIAS>PROCESSDEFINITIONID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
                                                        </RELATIONSHIP>
                                                    </RELATIONSHIP>
                                                </RELATIONSHIP>
			                                </TARGETENTITY>
		                                </SEARCH>", UserID, CurrentLanguage, TenantName, SessionID, ObjectID);
                    #endregion
                    }
                    else
                    {
                        #region Deliverable
                              
                        sb_SearchInputxml.AppendFormat(@"<SEARCH>
			                                <TARGETOBJECT>WORKFLOWPROCESS</TARGETOBJECT>
			                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
			                                <AUTHORIZATIONREQUIRED>False</AUTHORIZATIONREQUIRED>
			                                <SESSIONINFO UserID='{0}' Language='{1}' TenantName='{2}' SessionID='{3}'/>
			                                <TARGETENTITY>
				                                <PRIVILEGENAME>READ</PRIVILEGENAME>
				                                <SELECTLIST>
					                                <EXPRESSION>
						                                <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
						                                <ALIAS>WORKFLOWPROCESSID</ALIAS>
					                                </EXPRESSION>
				                                </SELECTLIST>
				                                <FILTERLIST>
					                                <FILTER>
						                                <EXPRESSION>WORKFLOWPROCESSID</EXPRESSION>
						                                <OPERATOR>EQUALTO</OPERATOR>
						                                <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
						                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
					                                </FILTER>
					                             </FILTERLIST>
                                                <RELATIONSHIP NAME='PROJECT_DELIVERABLE' HIERARCHY='BOTTOMUP'>
		                                            <SELECTLIST>
			                                            <EXPRESSION>
				                                            <FIELDNAME>WORKFLOWPROCESSID</FIELDNAME>
				                                            <ALIAS>WORKFLOWPROCESSID</ALIAS>
			                                            </EXPRESSION>
			                                        </SELECTLIST>
                                                    <RELATIONSHIP NAME='PROCESS_INFORMATION'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
			                                                    <FIELDNAME>PROCESSDEFINITIONID</FIELDNAME>
			                                                    <ALIAS>PROCESSDEFINITIONID</ALIAS>
		                                                    </EXPRESSION>
	                                                    </SELECTLIST>
                                                    </RELATIONSHIP>
                                                </RELATIONSHIP>
			                                </TARGETENTITY>
		                                </SEARCH>", UserID, CurrentLanguage, TenantName, SessionID, ObjectID);
                        #endregion
                    }
                                        
                    SearchObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    errorxml_Output = SearchObj.GetHierarchialData(sb_SearchInputxml.ToString(), ref xml_ProjectXML);
                    #endregion

                    #region Get Project Related Details
                    if (String.IsNullOrEmpty(errorxml_Output) && !String.IsNullOrEmpty(xml_ProjectXML))
                    {
                        xpathdoc_ProjectDoc     = new XPathDocument(new StringReader(xml_ProjectXML));
                        xpathnav_DeliverableNav = xpathdoc_ProjectDoc.CreateNavigator();
                        if (xpathnav_DeliverableNav != null)
                        {
                            if (ObjectType.Equals("Task", StringComparison.CurrentCultureIgnoreCase))
                            {
                                xpathnav_ProjectNav = xpathnav_DeliverableNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/DELIVERABLE_TASK/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS");
                            }
                            else
                            {
                                xpathnav_ProjectNav = xpathnav_DeliverableNav.SelectSingleNode("WORKFLOWPROCESSCOLLECTION/WORKFLOWPROCESS/PROJECT_DELIVERABLE/WORKFLOWPROCESS");
                            }
                            if (xpathnav_ProjectNav != null)
                            {
                                //Get Project ID
                                xpathnav_Tempnav = xpathnav_ProjectNav.SelectSingleNode("WORKFLOWPROCESSID");
                                if (xpathnav_Tempnav != null)
                                    ProjectID = xpathnav_Tempnav.Value;
                                else
                                    ProjectID = null;

                                //Get ProcessDefinitionID for Project
                                xpathnav_ProcessDefNav = xpathnav_ProjectNav.SelectSingleNode("PROCESS_INFORMATION/WORKFLOWPROCESSINFO/PROCESSDEFINITIONID");
                                if (xpathnav_ProcessDefNav != null)
                                    ProjectTypeID = xpathnav_ProcessDefNav.Value;
                                else
                                    ProjectTypeID = null;

                                return;
                            }
                        }
                    }
                    ProjectID       = null;
                    ProjectTypeID   = null;
                    
                    #endregion
                }
                catch (Exception ExceptionObject)
                {
                    throw ExceptionObject;
                }
            }
        #endregion
    }
}
