using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using System.Xml.Xsl;
using System.IO;
using System.Collections;
using System.Globalization;
using System.Threading;

#region Assetlink Include
using Assetlink;
using Assetlink.Solutions;
using Assetlink.Solutions.Facade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.CustomControls.HelperClasses;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.NotificationFacade;
using Assetlink.Solutions.Facade.TMSFacade;
#endregion

namespace Assetlink.Solutions.Facade.StrategicPlannerFacade
{
    using XML       = System.String;
    using ERRORXML  = System.String;
    public partial class StrategicPlanner_Helper
    {
        public bool FetchObsoleteValues = false;

        #region Forecast methods
        public void PrepareSearchXML(XPathNavigator PlanNav, ref String ForecastSearchXML, String ForecastFor)
        {
            StringBuilder SearchXML = null;
            StringBuilder ValuesAdded = null;
            StringBuilder ForecastPeriodAdded = null;

            XPathNavigator ForecastNav = null;
            XPathNodeIterator ValueIterator = null;
            XPathNavigator AmountNav = null;
            XPathNodeIterator ValueNodes = null;
            XPathNavigator TotalNav = null;
            XPathNavigator TotalAmount = null;

            String ColumnName = null;
            String XpathStringInfo = null;
            String xpathStringTotal = null;
            String str_IteratorValueWithXPath = null;
            String str_IteratorValueWithSpecial = null;
            int count = 0;

            try
            {

                ValuesAdded = new StringBuilder();
                SearchXML = new StringBuilder();
                ForecastPeriodAdded = new StringBuilder();
                SearchXML.Append("<SEARCHOUTPUTXML><FORECASTCOLLECTION>");
                switch (ForecastFor)
                {
                    case "PLAN":
                        XpathStringInfo = "//PLANCOLLECTION/PLAN/PLAN_FORECAST";
                        xpathStringTotal = "//PLANCOLLECTION/PLAN/PLAN_FORECASTTOTAL/FORECASTTOTALINFO";
                        break;
                    case "CAMPAIGN":
                    case "ACTIVITY":
                        XpathStringInfo = "//MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETINGACTIVITY_FORECAST";
                        xpathStringTotal = "//MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETINGACTIVITY_FORECASTTOTAL/FORECASTTOTALINFO";
                        break;
                }
                ForecastNav = PlanNav.SelectSingleNode(XpathStringInfo);
                if (ForecastNav != null)
                {
                    ValueIterator = ForecastNav.Select("FORECASTINFORMATION/NHVALUE");
                    while (ValueIterator.MoveNext())
                    {
                        str_IteratorValueWithXPath      = ALXmlUtil.GetXpathValueString(ValueIterator.Current.Value);
                        str_IteratorValueWithSpecial    = ALSpecialCharHandling.TrimAndReplaceSpecialChars(ValueIterator.Current.Value);
                        if (!(ValuesAdded.ToString().Contains("$AL$" + str_IteratorValueWithSpecial + "$AL$")))
                        {
                            count++;
                            ForecastPeriodAdded.Remove(0, ForecastPeriodAdded.Length);
                            SearchXML.Append("<FORECAST>");
                            ValueNodes = ForecastNav.Select("FORECASTINFORMATION[NHVALUE=" + str_IteratorValueWithXPath + "]");
                            SearchXML.AppendFormat("<FORECASTVALUE>{0}</FORECASTVALUE>", str_IteratorValueWithSpecial);
                            while (ValueNodes.MoveNext())
                            {
                                ColumnName = GetColumnName(ValueNodes.Current.SelectSingleNode("PERIOD").InnerXml);
                                if (!ForecastPeriodAdded.ToString().Contains("$" + ColumnName + "$") && (!String.IsNullOrEmpty(ColumnName)))
                                {
                                    AmountNav = ValueNodes.Current.SelectSingleNode("AMOUNT/AMOUNT");
                                    if (AmountNav != null)
                                    {
                                        SearchXML.AppendFormat("<{0}>{1}</{0}>", ColumnName, AmountNav.InnerXml);
                                    }
                                    ForecastPeriodAdded.AppendFormat("${0}$", ColumnName);
                                }
                            }
                            TotalNav = PlanNav.SelectSingleNode(xpathStringTotal + "[NHVALUE=" + str_IteratorValueWithXPath + "]");
                            if (TotalNav != null)
                            {
                                TotalAmount = TotalNav.SelectSingleNode("TOTALFORECASTED/AMOUNT");
                                if (TotalAmount != null)
                                {
                                    SearchXML.AppendFormat("<TOTAL>{0}</TOTAL>", TotalAmount.InnerXml);
                                }
                            }
                            SearchXML.AppendFormat("<FORECASTID>{0}</FORECASTID>", count.ToString());
                            SearchXML.Append("</FORECAST>");
                            ValuesAdded.AppendFormat("$AL${0}$AL$", str_IteratorValueWithSpecial);
                        }
                    }
                }
                SearchXML.Append("</FORECASTCOLLECTION></SEARCHOUTPUTXML>");
                ForecastSearchXML = SearchXML.ToString();
            }
            catch
            {

            }
        }

        public String GetColumnName(String ForecastPeriod)
        {
            switch (ForecastPeriod)
            {
                case "Q1":
                    return "QUARTER1";

                case "Q2":
                    return "QUARTER2";

                case "Q3":
                    return "QUARTER3";

                case "Q4":
                    return "QUARTER4";

                case "M1":
                    return "MONTH1";

                case "M2":
                    return "MONTH2";

                case "M3":
                    return "MONTH3";

                case "M4":
                    return "MONTH4";

                case "M5":
                    return "MONTH5";

                case "M6":
                    return "MONTH6";

                case "M7":
                    return "MONTH7";

                case "M8":
                    return "MONTH8";

                case "M9":
                    return "MONTH9";

                case "M10":
                    return "MONTH10";

                case "M11":
                    return "MONTH11";

                case "M12":
                    return "MONTH12";

                default:
                    return (ForecastPeriod);
            }
        }

        public String GetLocalizedMonthSTR(int iMonth, bool GetFullName)
        {
            String Month = null;
            DateTimeFormatInfo obj_DateTimeInfo = DateTimeFormatInfo.GetInstance(CultureInfo.GetCultureInfo(ALCommon.GetCurrentCulture()));
            try
            {
                if (GetFullName)
                {
                    Month = obj_DateTimeInfo.GetMonthName(iMonth);
                }
                else
                {
                    Month = obj_DateTimeInfo.GetAbbreviatedMonthName(iMonth);
                }
                return Month.ToUpper();
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        public String GetMonthSTR(int iMonth, bool GetFullName)
        {
            String Month = null;
            try
            {
                switch (iMonth)
                {
                    case 1:
                        Month = "JANUARY";
                        break;

                    case 2:
                        Month = "FEBRUARY";
                        break;

                    case 3:
                        Month = "MARCH";
                        break;

                    case 4:
                        Month = "APRIL";
                        break;
                    case 5:
                        Month = "MAY";
                        break;
                    case 6:
                        Month = "JUNE";
                        break;
                    case 7:
                        Month = "JULY";
                        break;
                    case 8:
                        Month = "AUGUST";
                        break;
                    case 9:
                        Month = "SEPTEMBER";
                        break;
                    case 10:
                        Month = "OCTOBER";
                        break;
                    case 11:
                        Month = "NOVEMBER";
                        break;
                    case 12:
                        Month = "DECEMBER";
                        break;
                }
                if (GetFullName)
                {
                    return Month;
                }
                else
                {
                    return Month.Substring(0, 3);
                }
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        
        /// <summary>
        /// <Author>Tina C. Jawale</Author>
        /// <Date>25 Aug 2008</Date>
        /// <MethodName>GetForecastConfiguration</MethodName>
        /// <Purpose>This method retrieves the FORECAST DURATION settings from SolutionConfiguration.XML 
        ///                 and adds these settings as parameters to XslArgumentsList object.</Purpose>
        /// </summary>
        /// <param name="str_TenantName">string containing Tenant Name</param>
        /// <param name="str_SolutionName">string containing Solution Name</param>
        /// <param name="str_Fiscal_Year">Fiscal year for which settings are to be fetched</param>
        /// <param name="xslArgumentListObj">Object of XsltArgumentList</param>
        /// <param name="str_ForecastTitle">referenced string containing Forecast Label</param>
        public void GetForecastConfiguration(String str_TenantName, String str_SolutionName,String str_Fiscal_Year, ref XsltArgumentList xslArgumentListObj, ref String str_ForecastTitle)
        {
            try
            {
                String str_forecastConfig_PLAN = null;
                String str_forecastConfig_ACTIVITYLEVEL1 = null;
                String str_forecastConfig_ACTIVITYLEVEL2 = null;
                String str_SolutionConfigXMLPath = ALSolutionCommon.GetConfigurationXMLPath(str_TenantName, str_SolutionName, "", "SolutionConfiguration");
                XPathDocument xPathDocObj = new XPathDocument(str_SolutionConfigXMLPath);
                XPathNavigator xPathNavigatorObj = xPathDocObj.CreateNavigator();

                xPathNavigatorObj = xPathNavigatorObj.SelectSingleNode("SolutionConfiguration/FORECASTINFO");
                if (xPathNavigatorObj != null)
                {
                    XPathNavigator xpNav_ForecastLabel = xPathNavigatorObj.SelectSingleNode("FORECASTTITLE");
                    if (xpNav_ForecastLabel != null)
                    {
                        str_ForecastTitle = xpNav_ForecastLabel.Value;
                        //FORECASTTITLE is saved after replacing special chars in Solution config so decoding is required
                        if (!String.IsNullOrEmpty(str_ForecastTitle))
                        {
                            ALSolutionCommon.DecodeSpecialCharacters(ref str_ForecastTitle);
                        }
                    }

                    //Fiscal Year is to get by parameter those changes will be done afterwords
                    GetForecastDurations(str_Fiscal_Year, ref str_forecastConfig_PLAN, ref str_forecastConfig_ACTIVITYLEVEL1, ref str_forecastConfig_ACTIVITYLEVEL2);

                    if (!String.IsNullOrEmpty(str_forecastConfig_PLAN) && !String.IsNullOrEmpty(str_forecastConfig_ACTIVITYLEVEL1)
                        && !String.IsNullOrEmpty(str_forecastConfig_ACTIVITYLEVEL2))
                    {
                        xslArgumentListObj = new XsltArgumentList();
                        xslArgumentListObj.AddParam("str_forecastConfig_PLAN", "", str_forecastConfig_PLAN);
                        xslArgumentListObj.AddParam("str_forecastConfig_ACTIVITYLEVEL1", "", str_forecastConfig_ACTIVITYLEVEL1);
                        xslArgumentListObj.AddParam("str_forecastConfig_ACTIVITYLEVEL2", "", str_forecastConfig_ACTIVITYLEVEL2);
                    }
                }
            }
            catch (Exception excepObj)
            {
                throw excepObj;
            }
        }

		/// <summary>
		/// <Author>Tina C. Jawale</Author>
		/// <Date>7 Nov 2008</Date>
		/// <Purpose>This method will update forecast grid's input xml as per the updations in dataset using XslCompiledTransform.</Purpose>
		/// </summary>
		public void UpdateForecastGridInputXML(String str_TenantName, String str_SolutionName, String str_SessionID, 
                String str_SandBoxID, String str_UserID, String str_Language, String str_DataSetInputXMLPath)
		{
			try
			{
				bool						b_IsBFReallocationRequired				= true;
				bool						b_IsAddForecastAttributesAtPlanLevel	= true;
				bool						b_IsMultiYearMA							= true;
				String						str_UIXSLTPath							= null;
				String						str_GridInputXMLPath					= null;
				String						str_StdParamsURL						= null;
				String						str_ForecastLabel						= null;
                String                      str_FiscalYear                          = null;
				XsltArgumentList			xslArgumentListObj						= null;
				XslCompiledTransform		xslCompiledTransObj						= null;
				ExtentionClassXSLTFacade 	ExtentionClassXSLTFacadeObj 			= null;
                Formats                     FormatsObject                           = null;
                CultureInfo                 CultureInfoObject                       = null;
                ALSolutionCommon            obj_SolutionCommon                      = null;
                int                         int_PeriodCount                         = 0;

                FormatsObject           = new Formats(ALSolutionCommon.GetConfigurationXMLPath(str_TenantName, "", "", "Formats"));
                CultureInfoObject       = new CultureInfo(Thread.CurrentThread.CurrentUICulture.ToString());
                obj_SolutionCommon      = new ALSolutionCommon();
				str_GridInputXMLPath    = ALSolutionCommon.GetTempPath(str_SessionID) + str_SandBoxID+"_ForecastReallocation_GridInput.xml";
				str_UIXSLTPath          = ALSolutionCommon.GetXSLTPath(str_TenantName, str_SolutionName) + "ForecastReallocation_UI.xslt";

				ExtentionClassXSLTFacadeObj = new ExtentionClassXSLTFacade(str_SessionID, str_UserID, str_TenantName, str_Language, str_SolutionName);
                getFiscalYear(str_DataSetInputXMLPath, ref str_FiscalYear);

				GetForecastConfiguration(str_TenantName, str_SolutionName,str_FiscalYear, ref xslArgumentListObj, ref str_ForecastLabel);
				GetPlanBulkUpdatesSettings(str_TenantName, str_SolutionName, ref b_IsBFReallocationRequired, ref b_IsAddForecastAttributesAtPlanLevel,
																			 ref b_IsMultiYearMA);
                GetForecastPeriodCount(str_FiscalYear, out int_PeriodCount);

				xslCompiledTransObj = new XslCompiledTransform();
				xslCompiledTransObj.Load(str_UIXSLTPath);

				XmlTextWriter xmlTextWriterObj = new XmlTextWriter(str_GridInputXMLPath, null);

				str_StdParamsURL = "&SessionID=" + str_SessionID + "&UserID=" + str_UserID 
                        + "&TenantName=" + str_TenantName + "&Language=" + str_Language + "&SandBoxID=" + str_SandBoxID;
                
                xslArgumentListObj.AddParam("str_ViewMore", "", str_StdParamsURL);
				xslArgumentListObj.AddParam("str_TenantName", "", str_TenantName);
				str_ForecastLabel = str_ForecastLabel.Replace(" ", "%20%");
				xslArgumentListObj.AddParam("str_ForecastLabel", "", ALSpecialCharHandling.TrimAndReplaceSpecialChars(str_ForecastLabel));
				xslArgumentListObj.AddParam("b_IsAddForecastAttributesAtPlanLevel", "", b_IsAddForecastAttributesAtPlanLevel);
                xslArgumentListObj.AddParam("DefaultInitialAmount", "", FormatsObject.FormatCurrencyField("0", CultureInfoObject));
                xslArgumentListObj.AddParam("ViewAll_Label", "", Localization.GetString("ALResource", str_TenantName, "SP_ViewAll_Shared"));
                xslArgumentListObj.AddParam("Total_Label","",Localization.GetString("ALResource",str_TenantName,"SP_Total_Label_Shared"));
                xslArgumentListObj.AddParam("Remove_Label", "", Localization.GetString("ALResource", str_TenantName, "Remove_Shared"));
                xslArgumentListObj.AddParam("Add_Label", "", Localization.GetString("ALResource", str_TenantName, "Add_Shared"));
                xslArgumentListObj.AddParam("PeriodCount", "", int_PeriodCount.ToString());
                xslArgumentListObj.AddExtensionObject("urn:Assetlink-SolutionCommon", obj_SolutionCommon);
				xslArgumentListObj.AddExtensionObject("urn:Assetlink-PlannerFacade", ExtentionClassXSLTFacadeObj);
				xslCompiledTransObj.Transform(str_DataSetInputXMLPath, xslArgumentListObj, xmlTextWriterObj);

				xmlTextWriterObj.Close();
			}
			catch (Exception excepObj)
			{
				throw excepObj;
			}
		}

		/// <summary>
		/// <Author>Tina C. Jawale</Author>
		/// <Date>7 Nov 2008</Date>
		/// <Purpose>This method will update the forecast grid's input xml for changing or adding 'textcss' attribute for the 'value' node.</Purpose>
		/// </summary>
		/// <param name="str_GridInputXMLPath"></param>
		/// 
		public void UpdateForecastGridInputForCSS(String str_SessionID, String str_SandBoxID)
		{
			String 				str_GridInputXMLPath 		= null;
			String 				str_SelectedCellIDXMLPath 	= null;
			String 				str_SelectedCellID 			= null;
			String 				str_Css_New 				= null;
			String 				str_Color 					= null;
			XmlDocument 		xmlDoc_GridInput 			= null;
			XmlDocument 		xmlDoc_SelectedCellIDList 	= null;
			XPathNavigator 		xpNav_Value 				= null;
			XPathNavigator 		xpNav_GridInput 			= null;
			XPathNavigator 		xpNav_SelectedCellIDList 	= null;
			XPathNavigator 		xpNav_SelectedCellID 		= null;
			XPathNodeIterator 	xpNodeIteratorObj		 	= null;

			str_SelectedCellIDXMLPath 	= ALSolutionCommon.GetTempPath(str_SessionID) + str_SandBoxID + "_SelectedCellIDList_Forecast.xml";
			str_GridInputXMLPath 		= ALSolutionCommon.GetTempPath(str_SessionID) + str_SandBoxID + "_ForecastReallocation_GridInput.xml";

			if (File.Exists(str_SelectedCellIDXMLPath))
			{
				xmlDoc_GridInput = new XmlDocument();
				xmlDoc_GridInput.Load(str_GridInputXMLPath);
				xpNav_GridInput = xmlDoc_GridInput.CreateNavigator();

				xmlDoc_SelectedCellIDList = new XmlDocument();
				xmlDoc_SelectedCellIDList.Load(str_SelectedCellIDXMLPath);
				xpNav_SelectedCellIDList = xmlDoc_SelectedCellIDList.CreateNavigator();

				xpNodeIteratorObj = xpNav_SelectedCellIDList.Select("SelectedCellIDList/SelectedCellID");

				if (xpNodeIteratorObj.Count > 0)
				{
					while (xpNodeIteratorObj.MoveNext())
					{
						xpNav_SelectedCellID = xpNodeIteratorObj.Current;
						str_SelectedCellID = xpNav_SelectedCellID.Value;
						if (str_SelectedCellID.ToUpper().Contains("ERROR"))
						{
							xpNav_Value 	= xpNav_GridInput.SelectSingleNode("//value[@id='" + xpNav_SelectedCellID.Value.Replace("ERROR$", "") + "']");
							str_Css_New 	= "AgTextHighlight_RO";
							str_Color 		= null;
						}
						else
						{
							xpNav_Value 	= xpNav_GridInput.SelectSingleNode("//value[@id='" + xpNav_SelectedCellID.Value + "']");
							str_Color 		= xpNav_SelectedCellID.GetAttribute("Color", "");
							str_Css_New 	= "AgTextBlue";
						}

						if (!String.IsNullOrEmpty(str_Color))
						{
							if (xpNav_Value != null)
							{
								if (xpNav_Value.MoveToAttribute("textcss", ""))
								{
                                    if (xpNav_Value.Value.Contains("Red"))
                                    {
                                        continue;
                                    }
                                    else
                                    {
                                        if (str_SelectedCellID.ToUpper().Contains("FORECASTTOTAL"))
                                        {
                                            xpNav_Value.SetValue(str_Css_New);
                                        }
                                        else if (str_SelectedCellID.ToUpper().Contains("TOTAL"))
                                            xpNav_Value.SetValue("AgTextBlue");
                                        else
                                            xpNav_Value.CreateAttribute("", "textcss", "", "AgTextLinkBlue");
                                    }
								}
								else
								{
										if (str_SelectedCellID.ToUpper().Contains("TOTAL"))
											xpNav_Value.CreateAttribute("", "textcss", "", "AgTextBlue");
										else
											xpNav_Value.CreateAttribute("", "textcss", "", "AgTextLinkBlue");
								}
							}//END - if (xpNav_Value != null)
						}//END - if(String.IsNullOrEmpty(str_Color))
						else
						{ 
							/* highlight error .*/
							if (str_SelectedCellID.ToUpper().Contains("ERROR"))
							{
								if (xpNav_Value != null)
								{
									if (xpNav_Value.MoveToAttribute("textcss", ""))
									{
										xpNav_Value.SetValue(str_Css_New);
									}
									else 
										xpNav_Value.CreateAttribute("", "textcss", "", str_Css_New);
								}
							}//END - str_SelectedCellID.ToUpper().Contains("ERROR")
						}
					}//END - while (xpNodeIteratorObj.MoveNext())
				}//END -  if (xpNodeIteratorObj.Count > 0)

				xmlDoc_GridInput.Save(str_GridInputXMLPath);
			}//END -  if (File.Exists(str_SelectedCellIDXMLPath))
		}
        #endregion

        #region PredefinedSearch_Methods

        public String GetActivityStatusValues(XPathNavigator xpNav_SolutionConfigRoot)
        {
            StringBuilder   sb_FilterList                   = null;
            String          str_SolutionConfigXMLPath       = null;
            String          str_StatusValue                 = null;
            
            XPathDocument       xpDoc_SolutionConfig    = null;
            XPathNavigator      xpNav_SolutionConfig    = null;
            XPathNavigator      xpNav_ActivityStatus    = null;
            XPathNodeIterator   xpNodeItr_StatusValues  = null;

            try
            {
                // If the solution configuration node is not passed then load the file
                if (xpNav_SolutionConfigRoot == null)
                {
                    str_SolutionConfigXMLPath   = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "", "SolutionConfiguration");
                    xpDoc_SolutionConfig        = new XPathDocument(str_SolutionConfigXMLPath);
                    xpNav_SolutionConfig        = xpDoc_SolutionConfig.CreateNavigator();
                    xpNav_SolutionConfigRoot    = xpNav_SolutionConfig.SelectSingleNode("SolutionConfiguration");
                }

                // Fetch the activity status node
                xpNav_ActivityStatus = xpNav_SolutionConfigRoot.SelectSingleNode("ACTIVITYSTATUS_FORSEARCH");
                if (xpNav_ActivityStatus == null)
                    return null;

                xpNodeItr_StatusValues = xpNav_ActivityStatus.Select("VALUE");

                if (xpNodeItr_StatusValues.Count == 0)
                    return null;
                else // Form the filter list
                {
                    sb_FilterList = new StringBuilder(800);
                    sb_FilterList.Append("<FilterValueList>");

                    while (xpNodeItr_StatusValues.MoveNext())
                    {
                        str_StatusValue = ALSolutionCommon.TrimAndReplaceSpecialChars(xpNodeItr_StatusValues.Current.InnerXml);
                        sb_FilterList.Append("<FilterValue><Value>");
                        sb_FilterList.Append(str_StatusValue);
                        sb_FilterList.Append("</Value><DisplayValue>");
                        sb_FilterList.Append(str_StatusValue);
                        sb_FilterList.Append("</DisplayValue></FilterValue>");

                        str_StatusValue = null;
                    }
                    sb_FilterList.Append("<FilterValue IsSelected='TRUE'><Value>None</Value><DisplayValue>None</DisplayValue></FilterValue>");
                    sb_FilterList.Append("</FilterValueList>");
                }

                if (sb_FilterList != null)
                    return sb_FilterList.ToString();
                else
                    return null;
            }
            catch(Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }
        #endregion

        /// <summary>
        /// <Purpose>This function retrieves the ATS info and converts it in the HTML format.</Purpose>
        /// </summary>
        /// <param name="strMartketingActivityID">Marketing activity ID</param>
        /// <param name="FormatsObj">Formats object for formatting</param>
        /// <param name="CultureInfoObj">The culture info Object</param>
        /// <param name="strActivityXML">The ref parameter to return the ATS info</param>
        /// <param name="strATSBreakup">The ref parameter to return the readonly view HTML.</param>
        /// <returns></returns>

        public ERRORXML GetReadonlyATSInfo(String strMartketingActivityID, Formats FormatsObj, CultureInfo CultureInfoObj, ref String strActivityXML, ref String strATSBreakup)
        {
            StringBuilder           sb_SearchInputXML       = null;
            MarketingActivityFacade MA_Obj                  = null;
            ERRORXML                ErrorXML                = null;
            XML strReturnActivityXML = null;
            try
            {
                MA_Obj = new MarketingActivityFacade(SessionID, UserID, TenantName, CurrentLanguage);
                sb_SearchInputXML = new StringBuilder(1000);
                sb_SearchInputXML.Append(@"<SEARCH>
                                                <TARGETOBJECT>MARKETINGACTIVITY</TARGETOBJECT>
                                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                <SESSIONINFO Language='" + CurrentLanguage + "' TenantName='" + TenantName + "' UserID='" + UserID + "' SessionID='" + SessionID + @"'/>
                                                <TARGETENTITY>
                                                   <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                     <FILTERLIST>			                                            
                                                        <FILTER>
                                                            <FILTERID>1</FILTERID>
                                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
                                                            <OPERATOR>EQUALTO</OPERATOR>
                                                            <EXPRESSIONVALUE>" + strMartketingActivityID + @"</EXPRESSIONVALUE>
                                                            </FILTER>
                                                        </FILTERLIST> 
                                                        <SELECTLIST>
                                                            <EXPRESSION>
                                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                                            </EXPRESSION>	
                                                        </SELECTLIST>
                                                        <RELATIONSHIP NAME='MARKETINGACTIVITY_ATSBREAKUP'>
                                                              <SELECTLIST>
                                                                    <EXPRESSION>
                                                                        <FIELDNAME>ATSBREAKUPID</FIELDNAME>
                                                                        <ALIAS>ATSBREAKUPID</ALIAS>
                                                                    </EXPRESSION>
                                                                    <EXPRESSION>
                                                                        <FIELDNAME>ATSAMOUNT</FIELDNAME>
                                                                        <ALIAS>ATSAMOUNT</ALIAS>
                                                                    </EXPRESSION>	
                                                               </SELECTLIST>
                                                        </RELATIONSHIP>
                                                    </TARGETENTITY>
                                                 </SEARCH>");
                ErrorXML = MA_Obj.GetMarketingActivity_ATSBreakup(sb_SearchInputXML.ToString(), ref strReturnActivityXML);
                if (ErrorXML == null)
                {

                    PrepareATSDisplayPopup(strReturnActivityXML, FormatsObj, CultureInfoObj, ref strATSBreakup);
                    strActivityXML = strReturnActivityXML;
                    
                }
                return ErrorXML;

            }
            catch (Exception Excepobj)
            {
                throw Excepobj;
            }
        }

        /// <summary>
        /// <Purpose>This function prepares the HTML view from data XML for ATS.</Purpose>
        /// </summary>
        /// <param name="strReturnActivityXML">Data XML for ATS.</param>
        /// <param name="FormatsObj">Formats object for formatting</param>
        /// <param name="CultureInfoObj">The culture info Object</param>
        /// <param name="DisplayHTML">The ref parameter to return the readonly view HTML</param>
        public void PrepareATSDisplayPopup(String strReturnActivityXML, Formats FormatsObj, CultureInfo CultureInfoObj, ref String DisplayHTML)
        {
            XPathNavigator              xpNav_Activity          = null;
            XPathNodeIterator           xpItr_ATSList           = null;
            XPathNavigator              xpNav_ATSRel            = null;
            StringBuilder               sb_DisplayHTML          = null;
            XPathNavigator              xpNav_Info              = null;
            XPathExpression             xpExp_ATSList           = null;
            String                      trCss                   = null;
            bool                        ATSProvided             = false;
            XPathDocument               xpDoc_Activity          = null;     
            
            try
            {
                trCss           = "AlternateFirstRowBar";
                xpDoc_Activity  = new XPathDocument(new StringReader(strReturnActivityXML));
                xpNav_Activity  = xpDoc_Activity.CreateNavigator();
                sb_DisplayHTML  = new StringBuilder(1000);
                xpNav_ATSRel    = xpNav_Activity.SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETINGACTIVITY_ATSBREAKUP");
                if(xpNav_ATSRel!=null)
                {
                    xpExp_ATSList   = XPathExpression.Compile("ATSBREAKUP");
                    xpExp_ATSList.AddSort("COSTCENTER_ATSBREAKUP/COSTCENTERS/NAME", XmlSortOrder.Ascending, XmlCaseOrder.None, "", XmlDataType.Text);
                    xpItr_ATSList   = xpNav_ATSRel.Select(xpExp_ATSList);

                    sb_DisplayHTML.Append("<table class=\"BorderSecond\" Cellspacing='1'><tr class=\"MainTitleBar\"><td colspan=\"2\"><span class=\"SectionHeaderLevel1TitleText\">" + Localization.GetString("ALResource", TenantName, "SP_ReadonlyATSTitle_Shared") + "</span></td></tr><tr class=\"SectionHeaderLevel1Bar\"><td><span class=\"SectionHeaderLevel1TitleText\">" + Localization.GetString("ALResource", TenantName, "SP_ReadonlyATS_CostCenterColumn_Title_Shared") + "</span></td><td><span class=\"SectionHeaderLevel1TitleText\">" + Localization.GetString("ALResource", TenantName, "SP_Amount_Shared") + "</span></td></tr>");
                    while (xpItr_ATSList.MoveNext())
                    {
                        ATSProvided = true;
                        xpNav_Info = xpItr_ATSList.Current.SelectSingleNode("COSTCENTERS_ATSBREAKUP/COSTCENTERS/NAME");
                        sb_DisplayHTML.Append("<tr class=\"" + trCss + "\">");
                        sb_DisplayHTML.Append("<td><span>" + ALCommon.TrimAndReplaceSpecialChars(xpNav_Info.Value) + "</span></td>");
                        xpNav_Info = xpItr_ATSList.Current.SelectSingleNode("ATSAMOUNT/AMOUNT");
                        sb_DisplayHTML.Append("<td><span>" + FormatsObj.FormatCurrencyField(xpNav_Info.Value, CultureInfoObj) + "</span></td>");
                        sb_DisplayHTML.Append("</tr>");
                        if (trCss.Equals("AlternateFirstRowBar"))
                        {
                            trCss = "AlternateSecondRowBar";
                        }
                        else
                        {
                            trCss = "AlternateFirstRowBar";
                        }
                    } 
                }
                if (!ATSProvided)
                {
                    sb_DisplayHTML.Remove(0, sb_DisplayHTML.Length);
                    sb_DisplayHTML.Append("<table class=\"BorderSecond\" Cellspacing='1'><tr class=\"MainTitleBar\"><td><span class=\"SectionHeaderLevel1TitleText\">" + Localization.GetString("ALResource", TenantName, "SP_ReadOnyATS_NotFoundMessage_Shared") + "</span></td></tr></table>");
                }
                else
                {
                    sb_DisplayHTML.Append("</table>");
                }
                DisplayHTML = sb_DisplayHTML.ToString();
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }

        }
        /// <summary>
        /// <Purpose>The function for providing the HTML view for ATS.</Purpose>
        /// </summary>
        /// <param name="strClientID">The ClientID for popup</param>
        /// <param name="FormatsObj">Object for formatting.</param>
        /// <param name="CultureInfoObj">Culture Object</param>
        /// <param name="strListXML">The prepared List XML.</param>
        public void ProcessActualsList(String strClientID, Formats FormatsObj, CultureInfo CultureInfoObj, ref String strListXML)
        {
            XmlDocument         ActualBreakUpDoc    = null;
            XPathNavigator      ActualsBreakupNav   = null;
            XPathNavigator      ATSNav              = null;            
            String              ATSLink             = null;
            ActualBreakUpDoc    = new XmlDocument();
            ActualBreakUpDoc.LoadXml(strListXML);
            ActualsBreakupNav   = ActualBreakUpDoc.CreateNavigator();
            ATSNav              = ActualsBreakupNav.SelectSingleNode("List/Data/Group/Row/Column[@Name='ALLOCATEDTOSPEND']/AMOUNT");
            if (ATSNav != null)
            {
                ATSLink = "<a href=\"#\" onmouseover='javascript:SP_ShowATSTooltip(event,\"" + strClientID + "\",10,600);' onmouseout='javascript:SP_HideATSTooltip(\"" + strClientID + "\");'>" + FormatsObj.FormatCurrencyField(ATSNav.Value, CultureInfoObj) + "</a>";
                ATSNav.MoveToParent();
                ATSNav.InnerXml = ATSLink;
            }
            strListXML          = ActualBreakUpDoc.OuterXml;
            
        }

        /// <summary>
        /// <Purpose>Method to create back Url</Purpose>
        /// <Createdby>Parita Harniya</Createdby>
        /// <Createdon>3 oct 2008</Createdon>
        /// </summary>
        /// <param name="FromScreen">from screen</param>
        /// <returns>back url</returns>
        public String GetBackURLForPlanner(String FromScreen)
        {
            StringBuilder   sb_BackURL    = null;
            StringBuilder   sb_Parameters = null;
            StringBuilder   sb_URL        = null;

            sb_URL          = new StringBuilder(25);
            sb_Parameters   = new StringBuilder(25);
            sb_BackURL      = new StringBuilder(25);

            if (!String.IsNullOrEmpty(FromScreen))
            {
                switch (FromScreen.ToUpper())
                {
                    case "PLANLIST":

                        sb_URL.AppendFormat("/{0}/StrategicPlanner/ASPX/Planner_Planlist.aspx?", TenantName);
                        sb_Parameters.AppendFormat("SessionID={0}&TenantName={1}&UserID={2}&Language={3}&SolutionName=StrategicPlanner", SessionID,
                                            TenantName, UserID, CurrentLanguage);
                        sb_BackURL.AppendFormat("{0}{1}", sb_URL.ToString(), sb_Parameters.ToString());
                        break;

                    case "ACTIVITYLIST":

                        sb_URL.AppendFormat("/{0}/StrategicPlanner/ASPX/Planner_Activitylist.aspx?", TenantName);
                        sb_Parameters.AppendFormat("SessionID={0}&TenantName={1}&UserID={2}&Language={3}&SolutionName=StrategicPlanner", SessionID,
                                            TenantName, UserID, CurrentLanguage);
                        sb_BackURL.AppendFormat("{0}{1}", sb_URL.ToString(), sb_Parameters.ToString());
                        break;

                    case "REVIEWLIST":

                        sb_URL.AppendFormat("/{0}/StrategicPlanner/ASPX/Planner_Reviewlist.aspx?", TenantName);
                        sb_Parameters.AppendFormat("SessionID={0}&TenantName={1}&UserID={2}&Language={3}&SolutionName=StrategicPlanner", SessionID,
                                            TenantName, UserID, CurrentLanguage);
                        sb_BackURL.AppendFormat("{0}{1}", sb_URL.ToString(), sb_Parameters.ToString());
                        break;

                    case "BUDGETLIST":

                        sb_URL.AppendFormat("/{0}/StrategicPlanner/ASPX/Planner_Budgetlist.aspx?", TenantName);
                        sb_Parameters.AppendFormat("SessionID={0}&TenantName={1}&UserID={2}&Language={3}&SolutionName=StrategicPlanner", SessionID,
                                            TenantName, UserID, CurrentLanguage);
                        sb_BackURL.AppendFormat("{0}{1}", sb_URL.ToString(), sb_Parameters.ToString());
                        break;
                }
            }

            return sb_BackURL.ToString();
        }

        /// <summary>
        /// <Purpose>This function is used to sort the List input xml in case if sorting us not used..</Purpose>
        /// </summary>
        /// <param name="strClientID">The ClientID for popup</param>
        /// <param name="FormatsObj">Object for formatting.</param>
        /// <param name="CultureInfoObj">Culture Object</param>
        /// <param name="strListXML">The prepared List XML.</param>
        public void SortXML(ref String str_ListXml, String str_SortColumn, String str_SortOrder, String str_SortDataType, String XsltPath)
        {
            #region Local Variables
            SortInfo                sortInfo            = null;
            XsltArgumentList        SortingArguments    = null;
            XPathDocument           xpdoc               = null;
            XPathNavigator          nav                 = null;
            XslCompiledTransform    transformObj        = null;
            StreamReader            sr_SortedXml        = null;
            Stream                  s_ListXml           = null;
            #endregion
            try
            {
                sortInfo                = new SortInfo();
                transformObj            = new XslCompiledTransform();
                sortInfo.SortColumn     = str_SortColumn;
                sortInfo.SortOrder      = str_SortOrder;
                sortInfo.SortDataType   = str_SortDataType;
                SortingArguments        = new XsltArgumentList();
                SortingArguments.AddExtensionObject("urn:ListControl", sortInfo);
                transformObj.Load(XsltPath);
                {
                    xpdoc               = new XPathDocument(new StringReader(str_ListXml));
                    nav                 = xpdoc.CreateNavigator();
                    s_ListXml           = new MemoryStream();
                    transformObj.Transform(nav, SortingArguments, s_ListXml);
                    s_ListXml.Position  = 0;
                    sr_SortedXml        = new StreamReader(s_ListXml);
                    str_ListXml         = sr_SortedXml.ReadToEnd();
                }

            }
            catch (Exception objException)
            {
                throw objException;
            }
        }

		/// <summary>
		/// <Author>Tina C. Jawale</Author>
		/// <Date>3 Oct 2008</Date>
		/// <Purpose>This method retrieves the nomenclature of the activity and returns it into Dictionary.
		///				It also returns last level of the activity.
		/// </Purpose>
		/// </summary>
		/// <param name="str_TenantName"></param>
		/// <param name="str_SolutionName"></param>
		/// <param name="dict_ActivityNomenclatureObj"></param>        
		public void GetActivityNomenclature(String str_TenantName, String str_SolutionName, ref String str_LastLevel, ref Dictionary<String, String> dict_ActivityNomenclatureObj)
		{
			try
			{
				XPathNavigator  xpNav_ActivityLevelObj  = null;
				XPathNavigator  xpNav_SingularName      = null;
				String          str_Level               = "0";

				String str_SolutionConfigXMLPath    = ALSolutionCommon.GetConfigurationXMLPath(str_TenantName, str_SolutionName, "", "SolutionConfiguration");
				XPathDocument xPathDocObj           = new XPathDocument(str_SolutionConfigXMLPath);
				XPathNavigator xPathNavigatorObj    = xPathDocObj.CreateNavigator();

				XPathNodeIterator xpathNodeIteratorObj = xPathNavigatorObj.Select("SolutionConfiguration/ACTIVITYLEVEL_NOMENCLATURE/ACTIVITYLEVEL");
				if (xpathNodeIteratorObj.Count > 0)
				{
					/* add one entry for PLAN by default.
					* this Dictionary contains activity level as Key and Singular name as value.
					*/
					if (dict_ActivityNomenclatureObj == null)
					{
						dict_ActivityNomenclatureObj = new Dictionary<String, String>();
					}
					dict_ActivityNomenclatureObj.Add("ACTIVITYLEVEL_0", Localization.GetString("ALResource", TenantName, "SP_Plan_Shared"));
					while (xpathNodeIteratorObj.MoveNext())
					{
						xpNav_ActivityLevelObj  = xpathNodeIteratorObj.Current;
						str_Level               = xpNav_ActivityLevelObj.GetAttribute("Level", "");
						xpNav_SingularName      = xpNav_ActivityLevelObj.SelectSingleNode("SINGULARNAME");
						dict_ActivityNomenclatureObj.Add("ACTIVITYLEVEL_" + str_Level, xpNav_SingularName.Value);
					}
				}
				str_LastLevel = str_Level;
			}//END - Try
			catch (Exception excepObj)
			{
				throw excepObj;
			}//END - catch
		}

		/// <summary>
		/// <Author>Tina C. Jawale</Author>
		/// <Date>21 Oct 2008</Date>
		/// <Purpose>This method returns the Bulk Updates settings from the SIloution Configuration.</Purpose>
		/// </summary>
		/// <param name="str_TenantName"></param>
		/// <param name="str_SolutionName"></param>
		public void GetPlanBulkUpdatesSettings(String str_TenantName, String str_SolutionName, ref bool b_IsBFReallocationRequired, ref bool b_IsAddForecastAttributes,
			 ref bool b_IsMultiYearMA)
		{
			try
			{
				String str_SolutionConfigXMLPath = ALSolutionCommon.GetConfigurationXMLPath(str_TenantName, str_SolutionName, "", "SolutionConfiguration");
				XPathDocument xPathDocObj = new XPathDocument(str_SolutionConfigXMLPath);
				XPathNavigator xPNav_SolutionConfigObj = xPathDocObj.CreateNavigator();

				XPathNavigator xpNav_Obj = xPNav_SolutionConfigObj.SelectSingleNode("SolutionConfiguration/BULKUPDATES/BUDGETANDFORECASTREALLOCATION");
				if (xpNav_Obj != null)
				{
					b_IsBFReallocationRequired = Convert.ToBoolean(xpNav_Obj.Value.ToString());
				}

				xpNav_Obj = xPNav_SolutionConfigObj.SelectSingleNode("SolutionConfiguration/BULKUPDATES/ADDNEWFORECASTATTRIBUTEATPLANLEVEL");
				if (xpNav_Obj != null)
				{
					b_IsAddForecastAttributes = Convert.ToBoolean(xpNav_Obj.Value.ToString());
				}

				xpNav_Obj = xPNav_SolutionConfigObj.SelectSingleNode("SolutionConfiguration/BULKUPDATES/MULTIYEARMA");
				if (xpNav_Obj != null)
				{
					b_IsMultiYearMA = Convert.ToBoolean(xpNav_Obj.Value.ToString());
				}
			}
			catch (Exception excepObj)
			{
				throw excepObj;
			}
		}

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Check if the status of topic(review) is inactive</Purpose>
        /// </summary>
        /// <returns>true if status is inactive else false</returns>
        public Boolean IsTopicStatusClosed(String str_TopicID)
        {
            String str_SearchXML = null;
            String str_ReviewXML = null;
            String str_ErrorXML = null;
            String str_TopicStatus = null;
            SearchConfiguration SearchObj = null;

            str_SearchXML = GenerateXMLForTopicStatus(str_TopicID);
            SearchObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
            str_ErrorXML = SearchObj.GetHierarchialData(str_SearchXML, ref str_ReviewXML);

            if (str_ErrorXML == null)
            {
                str_TopicStatus = ALCommon.GetInnerValue(ref str_ReviewXML, "<TOPICSTATUS>", "</TOPICSTATUS>");
                if (str_TopicStatus != null)
                {
                    if (str_TopicStatus.ToUpper().Equals("INACTIVE"))
                        return true;
                }
            }
            return false;
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Create Search XML for fetching status of topic(review)</Purpose>
        /// </summary>
        /// <returns>Search XML</returns>
        private String GenerateXMLForTopicStatus(String str_TopicID)
        {
            StringBuilder NSearchInputXML = null;

            NSearchInputXML = new StringBuilder();
            NSearchInputXML.AppendFormat(@"<SEARCH>
                                        <TARGETOBJECT>TOPIC</TARGETOBJECT>
                                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                        <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                        <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{4}'/>
                                        <TARGETENTITY>
                                            <PRIVILEGENAME>READ</PRIVILEGENAME>
                                            <SELECTLIST>
                                                <EXPRESSION>
                                                    <FIELDNAME>TOPICSTATUS</FIELDNAME>
                                                    <ALIAS>TOPICSTATUS</ALIAS>
                                                </EXPRESSION>
                                            </SELECTLIST>
                                            <FILTERLIST>			                                            
                                                <FILTER>
                                                    <FILTERID>1</FILTERID>
                                                    <EXPRESSION>TOPICID</EXPRESSION>
                                                    <OPERATOR>EQUALTO</OPERATOR>
                                                    <EXPRESSIONVALUE>{3}</EXPRESSIONVALUE>
                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                </FILTER>
                                            </FILTERLIST>  
                                        </TARGETENTITY>
                                    </SEARCH>", CurrentLanguage, TenantName, UserID, str_TopicID, SessionID);

            return NSearchInputXML.ToString();
        }

        /// <summary>
        /// <Purpose></Purpose>
        /// <Author>Parita Harniya</Author>
        /// <CreatedOn>20 Nov 2008</CreatedOn>
        /// </summary>
        /// <returns>Relationship node</returns>
        public String RelationshipNode_PlanAndSandboxDetails()
        {
            StringBuilder sb_RelationShipNodeForActivity = null;

            sb_RelationShipNodeForActivity = new StringBuilder(50);
            sb_RelationShipNodeForActivity.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITIES_FOR_PLAN'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>BULKUPDATESFLAG</FIELDNAME>
	                                                            <ALIAS>BULKUPDATESFLAG</ALIAS>
                                                            </EXPRESSION>
                                                        </SELECTLIST>
                                                        <RELATIONSHIP NAME='PLAN_SANDBOX'>
					                                        <SELECTLIST>
						                                        <EXPRESSION>
							                                        <FIELDNAME>SANDBOXTYPE</FIELDNAME>
							                                        <ALIAS>SANDBOXTYPE</ALIAS>
						                                        </EXPRESSION>
						                                        <EXPRESSION>
							                                        <FIELDNAME>CREATIONTIME</FIELDNAME>
							                                        <ALIAS>CREATIONTIME</ALIAS>
						                                        </EXPRESSION>
					                                        </SELECTLIST>
                                                            <RELATIONSHIP NAME='SANDBOX_DELEGATE'>
					                                            <SELECTLIST>
						                                            <EXPRESSION>
							                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
							                                            <ALIAS>FIRSTNAME</ALIAS>
						                                            </EXPRESSION>
						                                            <EXPRESSION>
							                                            <FIELDNAME>LASTNAME</FIELDNAME>
							                                            <ALIAS>LASTNAME</ALIAS>
						                                            </EXPRESSION>
						                                            <EXPRESSION>
							                                            <FIELDNAME>LOGINNAME</FIELDNAME>
							                                            <ALIAS>LOGINNAME</ALIAS>
						                                            </EXPRESSION>
					                                            </SELECTLIST>
                                                            </RELATIONSHIP>
                                                            <FILTERLIST>			                                            
                                                                <FILTER>
	                                                                <FILTERID>1</FILTERID>
	                                                                <EXPRESSION>STATUS</EXPRESSION>
	                                                                <OPERATOR>EQUALTO</OPERATOR>
	                                                                <EXPRESSIONVALUE>Draft</EXPRESSIONVALUE>
	                                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                </FILTER>
                                                            </FILTERLIST>
                                                        </RELATIONSHIP>
                                                        <RELATIONSHIP NAME='PLAN_CREATOR'>
					                                        <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
						                                            <ALIAS>FIRSTNAME</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>LASTNAME</FIELDNAME>
						                                            <ALIAS>LASTNAME</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>LOGINNAME</FIELDNAME>
						                                            <ALIAS>LOGINNAME</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
                                                        </RELATIONSHIP>
                                                    </RELATIONSHIP>
                                                    <RELATIONSHIP NAME='PLAN_MARKETINGACTIVITIES'>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
	                                                            <FIELDNAME>BULKUPDATESFLAG</FIELDNAME>
	                                                            <ALIAS>BULKUPDATESFLAG</ALIAS>
                                                            </EXPRESSION>
                                                        </SELECTLIST>
                                                        <RELATIONSHIP NAME='PLAN_SANDBOX'>
					                                        <SELECTLIST>
						                                        <EXPRESSION>
							                                        <FIELDNAME>SANDBOXTYPE</FIELDNAME>
							                                        <ALIAS>SANDBOXTYPE</ALIAS>
						                                        </EXPRESSION>
						                                        <EXPRESSION>
							                                        <FIELDNAME>CREATIONTIME</FIELDNAME>
							                                        <ALIAS>CREATIONTIME</ALIAS>
						                                        </EXPRESSION>
					                                        </SELECTLIST>
                                                            <RELATIONSHIP NAME='SANDBOX_DELEGATE'>
					                                            <SELECTLIST>
						                                            <EXPRESSION>
							                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
							                                            <ALIAS>FIRSTNAME</ALIAS>
						                                            </EXPRESSION>
						                                            <EXPRESSION>
							                                            <FIELDNAME>LASTNAME</FIELDNAME>
							                                            <ALIAS>LASTNAME</ALIAS>
						                                            </EXPRESSION>
						                                            <EXPRESSION>
							                                            <FIELDNAME>LOGINNAME</FIELDNAME>
							                                            <ALIAS>LOGINNAME</ALIAS>
						                                            </EXPRESSION>
					                                            </SELECTLIST>
                                                            </RELATIONSHIP>
                                                            <FILTERLIST>			                                            
                                                                <FILTER>
	                                                                <FILTERID>1</FILTERID>
	                                                                <EXPRESSION>STATUS</EXPRESSION>
	                                                                <OPERATOR>EQUALTO</OPERATOR>
	                                                                <EXPRESSIONVALUE>Draft</EXPRESSIONVALUE>
	                                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                </FILTER>
                                                            </FILTERLIST>
                                                        </RELATIONSHIP>
                                                        <RELATIONSHIP NAME='PLAN_CREATOR'>
					                                        <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
						                                            <ALIAS>FIRSTNAME</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>LASTNAME</FIELDNAME>
						                                            <ALIAS>LASTNAME</ALIAS>
					                                            </EXPRESSION>
					                                            <EXPRESSION>
						                                            <FIELDNAME>LOGINNAME</FIELDNAME>
						                                            <ALIAS>LOGINNAME</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
                                                        </RELATIONSHIP>
                                                    </RELATIONSHIP>");
            return sb_RelationShipNodeForActivity.ToString();
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Method to fetch user list taking care of access permissions like plan universe required, permitted group access.</Purpose>
        /// </summary>
        /// <param name="b_PlanUniverseRequired">Plan universe required flag</param>
        /// <param name="b_PermittedGroupRequired">Permitted group required flag</param>
        /// <param name="b_BUUniverseRequried">Business Unit Universe required flag</param>
        /// <param name="b_BudgetManagerGroupSelection">Budget Manager Group selection flag</param>
        /// <param name="str_PlanUniverseXML">Plan universe xml containing group and user list</param>
        /// <param name="str_PermittedGroupXML">Permitted group xml</param>
        /// <param name="str_BudgetManagerGroupXML">Budget manager groups xml</param>
        /// <param name="str_BusinessUnitID">Business Unit ID of the the Business unit of the plan.</param>
        /// <param name="str_UserListXML">Generated user list xml</param>
        /// <param name="str_SelectedUser_GroupXML">User selected xml with groups</param>
        /// <param name="b_AllSystemUsers">True if all system users</param>
        /// <returns>Error xml if any error occurs else null</returns>
        public ERRORXML GetUserList(Boolean b_PlanUniverseRequired, Boolean b_PermittedGroupRequired, Boolean b_BUUniverseRequried, Boolean b_BudgetManagerGroupSelection,
                                    String str_PlanUniverseXML, String str_PermittedGroupXML, String str_BudgetManagerGroupXML, String str_BusinessUnitID,
                                    ref String str_UserListXML, ref String str_SelectedUser_GroupXML, ref Boolean b_AllSystemUsers)
        {
            String              str_GroupList       = null;
            String              str_GroupList1      = null;
            String              str_SearchXML       = null;
            String              str_BUUserList      = null;
            UserFacade          UserFacadeObj       = null;
            ERRORXML            ErrorXML            = null;
    
            UserFacadeObj       = new UserFacade(SessionID, UserID, TenantName, CurrentLanguage);
            if (b_PlanUniverseRequired)
            {
                str_GroupList = GenerateGroupList(str_PlanUniverseXML);
                if (b_BudgetManagerGroupSelection)
                {
                    str_GroupList1  = GenerateGroupList(str_BudgetManagerGroupXML);
                    str_GroupList   = MergeGroups(str_GroupList, str_GroupList1);
                }
                if (str_GroupList.Contains("GROUPID"))
                {
                    ErrorXML = UserFacadeObj.GetAllUsersFromGroupHierarchyByGroupID(str_GroupList, false, out str_UserListXML);
                }
                if (String.IsNullOrEmpty(str_UserListXML))
                {
                    str_UserListXML = "<USERCOLLECTION />";
                }
                str_UserListXML = MergeUsers(str_PlanUniverseXML, str_UserListXML);
            }
            //If Business Unit Universe Access is true then show business unit universe users in the list
            else if (b_BUUniverseRequried)
            {
                ErrorXML = BUGroupsForPlan(str_BusinessUnitID, b_BUUniverseRequried, ref str_GroupList, ref str_BUUserList);
                if (b_BudgetManagerGroupSelection)
                {
                    str_GroupList1  = GenerateGroupList(str_BudgetManagerGroupXML);
                    str_GroupList   = MergeGroups(str_GroupList, str_GroupList1);
                }
                if (str_GroupList.Contains("GROUPID"))
                {
                    ErrorXML = UserFacadeObj.GetAllUsersFromGroupHierarchyByGroupID(str_GroupList, false, out str_UserListXML);
                }
                if (String.IsNullOrEmpty(str_UserListXML))
                {
                    str_UserListXML = "<USERCOLLECTION />";
                }
                str_UserListXML = MergeUsers(str_BUUserList, str_UserListXML);
            }
            else if (b_PermittedGroupRequired)
            {
                str_GroupList   = GenerateGroupList(str_PermittedGroupXML);
                if (b_BudgetManagerGroupSelection)
                {
                    str_GroupList1  = GenerateGroupList(str_BudgetManagerGroupXML);
                    str_GroupList   = MergeGroups(str_GroupList, str_GroupList1);
                }
                if (str_GroupList.Contains("GROUPID"))
                {
                    ErrorXML = UserFacadeObj.GetAllUsersFromGroupHierarchyByGroupID(str_GroupList, false, out str_UserListXML);
                }
                if(String.IsNullOrEmpty(str_UserListXML))
                {
                    str_UserListXML = "<USERCOLLECTION />";
                }
            }
            else
            {
                str_SearchXML   = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(TenantName, "StrategicPlanner", "", "GetUserList_SearchConfiguration"));
                str_SearchXML   = str_SearchXML.Replace("$AL$LANGUAGE$AL$", CurrentLanguage);
                str_SearchXML   = str_SearchXML.Replace("$AL$TENANTNAME$AL$", TenantName);
                str_SearchXML   = str_SearchXML.Replace("$AL$USERID$AL$", UserID);
                str_SearchXML   = str_SearchXML.Replace("$AL$SESSIONID$AL$", SessionID);
                ErrorXML        = UserFacadeObj.GetUserList(str_SearchXML, ref str_UserListXML);
                str_UserListXML = ALCommon.GetInnerValue(ref str_UserListXML, "<SEARCHOUTPUTXML>", "</SEARCHOUTPUTXML>");
                b_AllSystemUsers = true;
            }

            str_SelectedUser_GroupXML = CreateSelectedUsers_GroupsXML(str_UserListXML, str_GroupList, b_AllSystemUsers);
            return ErrorXML;
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Method to create User Selection XML containing permittedusers and restrictedgrouplist.</Purpose>
        /// </summary>
        /// <param name="str_UserListXML">List of users</param>
        /// <param name="str_GroupListXML">List of groups</param>
        /// <param name="b_AllSystemUsers">Is all system users</param>
        /// <returns>User Selection XML</returns>
        private String CreateSelectedUsers_GroupsXML(String str_UserListXML, String str_GroupListXML, Boolean b_AllSystemUsers)
        {
            XPathDocument       xpDoc_Users         = null;
            XPathNavigator      xpNav_Users         = null;
            XPathNodeIterator   xpNodeIte_Users     = null;
            XPathDocument       xpDoc_Groups        = null;
            XPathNavigator      xpNav_Groups        = null;
            XPathNodeIterator   xpNodeIte_Groups    = null;
            StringBuilder       sb_SelectedXML      = null;

            if (!b_AllSystemUsers)
            {
                xpDoc_Users = new XPathDocument(new StringReader(str_UserListXML));
                xpNav_Users = xpDoc_Users.CreateNavigator();
                xpDoc_Groups = new XPathDocument(new StringReader(str_GroupListXML));
                xpNav_Groups = xpDoc_Groups.CreateNavigator();
            }

            sb_SelectedXML      = new StringBuilder(300);
            sb_SelectedXML.Append(@"<UserSelectionXML>
                                       <FilterCollection>");
            sb_SelectedXML.Append("<PermittedUsers>");

            if (!b_AllSystemUsers)
            {
                xpNodeIte_Users = xpNav_Users.Select("USERCOLLECTION/USER/USERID");
                foreach (XPathNavigator xpNav_UserID in xpNodeIte_Users)
                {
                    sb_SelectedXML.AppendFormat("<Users><USERID>{0}</USERID></Users>", xpNav_UserID.Value);
                }
            }

            sb_SelectedXML.Append("</PermittedUsers>");

            sb_SelectedXML.Append("<RestrictedGroupList IncludeSubGroups='FALSE'>");

            if (!b_AllSystemUsers)
            {
                xpNodeIte_Groups = xpNav_Groups.Select("GROUPLIST/GROUPID");
                foreach (XPathNavigator xpNav_GroupID in xpNodeIte_Groups)
                {
                    sb_SelectedXML.AppendFormat("<GROUPID>{0}</GROUPID>", xpNav_GroupID.Value);
                }
            }

            sb_SelectedXML.Append("</RestrictedGroupList>");
            sb_SelectedXML.Append(@"</FilterCollection>
                                        </UserSelectionXML>");

            return sb_SelectedXML.ToString();            
        }

        private string MergeGroups(string str_GroupList, string str_GroupList1)
        {
            XmlDocument         xmlDoc_GroupList    = null;
            XPathDocument       xpDoc_GroupList1    = null;
            XPathNavigator      xpNav_GroupList1    = null;
            XPathNodeIterator   xpNodeIte_Groups    = null;

            xmlDoc_GroupList    = new XmlDocument();
            xmlDoc_GroupList.LoadXml(str_GroupList);

            xpDoc_GroupList1    = new XPathDocument(new StringReader(str_GroupList1));
            xpNav_GroupList1    = xpDoc_GroupList1.CreateNavigator();

            xpNodeIte_Groups    = xpNav_GroupList1.Select("GROUPLIST/GROUPID");
            foreach (XPathNavigator xpNav_GroupID in xpNodeIte_Groups)
            {
                if (!(str_GroupList.Contains(xpNav_GroupID.InnerXml)))
                {
                    xmlDoc_GroupList.SelectSingleNode("GROUPLIST").InnerXml += xpNav_GroupID.OuterXml;
                }
            }
            return xmlDoc_GroupList.InnerXml;
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Method to merge "user list generated by taking group id" and "plan universe user list".</Purpose>
        /// </summary>
        /// <param name="str_PlanUniverseXML">Plan universe xml</param>
        /// <param name="str_UserListXML">User list xml</param>
        /// <returns>Merge user list xml</returns>
        private String MergeUsers(string str_PlanUniverseXML, string str_UserListXML)
        {
            XPathDocument       xpDoc_PlanUniverse      = null;
            XPathNavigator      xpNav_PlanUniverse      = null;
            XPathNavigator      xpNav_UserID            = null;
            XPathNodeIterator   xpNodeIte_Users         = null;
            XmlDocument         xmlDoc_UserList         = null;
            Boolean             b_ContainsUserID        = false;

            xpDoc_PlanUniverse  = new XPathDocument(new StringReader(str_PlanUniverseXML));
            xpNav_PlanUniverse  = xpDoc_PlanUniverse.CreateNavigator();

            xmlDoc_UserList     = new XmlDocument();
            xmlDoc_UserList.LoadXml(str_UserListXML);

            xpNodeIte_Users     = xpNav_PlanUniverse.Select("FilterCollection/PermittedUsers/Users");
            foreach (XPathNavigator xpNav_Users in xpNodeIte_Users)
            {
                xpNav_UserID    = xpNav_Users.SelectSingleNode("USERID");
                if (xpNav_UserID != null)
                {
                    b_ContainsUserID = str_UserListXML.Contains(xpNav_UserID.Value);
                    if (!b_ContainsUserID)
                    {
                        xmlDoc_UserList.SelectSingleNode("USERCOLLECTION").InnerXml += "<USER>" + xpNav_Users.InnerXml + "</USER>";
                    }
                }
            }
            return xmlDoc_UserList.InnerXml;
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Method to search xml for user.</Purpose>
        /// </summary>
        /// <returns>Search xml</returns>
        private String GenerateSearchXMLForUser()
        {
            StringBuilder       sb_SearchXML        = null;
            sb_SearchXML        = new StringBuilder(100);

            sb_SearchXML.AppendFormat(@"<INPUTXML>
                                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                            <SEARCHCOLLECTION>
                                                <SEARCH>
                                                    <TARGETOBJECT>USER</TARGETOBJECT>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    <SEARCHSTRING/>
		                                            <SEARCHALLFACETS>false</SEARCHALLFACETS>
                                                    <FILTERLIST>			                                            
                                                        <FILTER>
	                                                        <FILTERID>1</FILTERID>
	                                                        <FIELDNAME>STATUS</FIELDNAME>
	                                                        <OPERATOR>EQUALTO</OPERATOR>
	                                                        <FIELDVALUE>ACTIVE</FIELDVALUE>
	                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                        <FILTER>
	                                                        <FILTERID>2</FILTERID>
	                                                        <FIELDNAME>STATUS</FIELDNAME>
	                                                        <OPERATOR>EQUALTO</OPERATOR>
	                                                        <FIELDVALUE>LOCKED</FIELDVALUE>
	                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        </FILTER>
                                                    </FILTERLIST>
                                                    <FIELDCOLLECTION>
                                                        <TARGETENTITYFIELDS>
                                                            <FIELD>FIRSTNAME</FIELD>
                                                            <FIELD>LASTNAME</FIELD>
                                                            <FIELD>LOGINNAME</FIELD>
                                                        </TARGETENTITYFIELDS>
                                                    </FIELDCOLLECTION>
                                                </SEARCH>
                                            </SEARCHCOLLECTION>
                                        </INPUTXML>", CurrentLanguage, TenantName, UserID, SessionID);
            return sb_SearchXML.ToString();
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Method to Group List xml.</Purpose>
        /// </summary>
        /// <param name="str_XML">xml containing group ids</param>
        /// <returns>Group list xml</returns>
        private String GenerateGroupList(String str_XML)
        {
            StringBuilder       sb_GroupList        = null;
            XPathDocument       xpDoc_XML           = null;
            XPathNavigator      xpNav_XML           = null;
            XPathNodeIterator   xpNodeIte_Group     = null;

            sb_GroupList        = new StringBuilder(100);
            xpDoc_XML           = new XPathDocument(new StringReader(str_XML));
            xpNav_XML           = xpDoc_XML.CreateNavigator();

            sb_GroupList.Append("<GROUPLIST>");

            if (xpNav_XML != null)
            {
                xpNodeIte_Group = xpNav_XML.Select("FilterCollection/RestrictedGroupList/GROUPID");

                foreach (XPathNavigator xpNav_Group in xpNodeIte_Group)
                {
                    sb_GroupList.AppendFormat("<GROUPID>{0}</GROUPID>", xpNav_Group.InnerXml);
                }
            }
            sb_GroupList.Append("</GROUPLIST>");
            return sb_GroupList.ToString();
        }

        /// <summary>
        /// <Purpose>Method to fetch search xml and filters.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_OldUserID">Old User ID</param>
        /// <param name="str_NewUserID">New USer ID</param>
        /// <param name="str_PlanID">Plan ID</param>
        /// <param name="str_BMSelectionType">Budget Manager Selection Type</param>
        /// <param name="str_OperationType">Operation Type</param>
        /// <returns>Search XML</returns>
        public String GetSearchXMLForCloneReplaceUser(String str_OldUserID, String str_NewUserID, String str_PlanID, String str_BMSelectionType, 
                        String str_OperationType)
        {
            StringBuilder   sb_FilterList   = null;
            String          str_SearchXML   = null;
            int             i_FilterCount   = 1;

            sb_FilterList = new StringBuilder(50);
            sb_FilterList.Append("<FILTERLIST>");

            if(!String.IsNullOrEmpty(str_OldUserID))
            {
                sb_FilterList.AppendFormat(@"<FILTER>
				                            <FILTERID>{0}</FILTERID>
				                            <EXPRESSION>USERID</EXPRESSION>
				                            <OPERATOR>EQUALTO</OPERATOR>
				                            <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
				                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                            </FILTER>", i_FilterCount, str_OldUserID);
                i_FilterCount++;
            }
            if(!String.IsNullOrEmpty(str_NewUserID))
            {
                sb_FilterList.AppendFormat(@"<FILTER>
				                            <FILTERID>{0}</FILTERID>
				                            <EXPRESSION>USERID</EXPRESSION>
				                            <OPERATOR>EQUALTO</OPERATOR>
				                            <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
				                            <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                            </FILTER>", i_FilterCount, str_NewUserID);
            }
            sb_FilterList.Append("</FILTERLIST>");

            if (str_OperationType.Equals("REPLACEUSER"))
            {
                str_SearchXML = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName,
                                                "", "GetUserRolesOfUserForPlan_ReplaceUser_SearchConfiguration"));
            }
            else if (str_OperationType.Equals("CLONEUSER"))
            {
                if (!String.IsNullOrEmpty(str_BMSelectionType) && str_BMSelectionType.Equals("SINGLESELECT"))
                {
                    str_SearchXML = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName,
                                                    "", "GetUserRolesOfUserForPlan_SingleSelectBudgetManager_SearchConfiguration"));
                }
                else
                {
                    str_SearchXML = File.ReadAllText(ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName,
                                                    "", "GetUserRolesOfUserForPlan_MultiSelectBudgetManager_SearchConfiguration"));
                }
            }

            if(!String.IsNullOrEmpty(str_SearchXML))
            {
                str_SearchXML = str_SearchXML.Replace("$AL$USERFILTERLIST$AL$", sb_FilterList.ToString());
                str_SearchXML = str_SearchXML.Replace("$AL$PLANID$AL$", str_PlanID);
                str_SearchXML = str_SearchXML.Replace("$AL$Language$AL$", CurrentLanguage);
                str_SearchXML = str_SearchXML.Replace("$AL$TenantName$AL$", TenantName);
                str_SearchXML = str_SearchXML.Replace("$AL$UserID$AL$", UserID);
                str_SearchXML = str_SearchXML.Replace("$AL$SessionID$AL$", SessionID);
            }
            return str_SearchXML;
        }

        /// <summary>
        /// <Purpose>Method to fetch user roles of user on plan.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_SearchXML">Search XML</param>
        /// <param name="str_OutputXML">User roles XML</param>
        /// <returns>Error if any else null</returns>
        public ERRORXML FetchUserRolesOfUserOnPlan(String str_SearchXML, ref String str_OutputXML)
        {
            ERRORXML retErrorXML = null;

            try
            {
                PlannerServiceObj.Timeout = 900000;
                retErrorXML = PlannerServiceObj.FetchUserRolesOfUserOnPlan(str_SearchXML, ref str_OutputXML);
                return retErrorXML;
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }
        }

        /// <summary>
        /// <Purpose>Method to check if the user roles are defined for user on plan.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_UserRolesXML">user roles xml</param>
        /// <returns>true if user roles are defined else false</returns>
        public Boolean CheckUserRolesDefinedForPlanHierachy(String str_UserRolesXML)
        {
            XPathDocument       xpDoc_UserRoles     = null;
            XPathNavigator      xpNav_UserRoles     = null;
            XPathNavigator      xpNav_PlanUserRoles = null;
            XPathNodeIterator   xpNodeIte_MA        = null;
            XPathNavigator      xpNav_MARelation    = null;

            xpDoc_UserRoles     = new XPathDocument(new StringReader(str_UserRolesXML));
            xpNav_UserRoles     = xpDoc_UserRoles.CreateNavigator();

            #region Check Plan Relations
            xpNav_PlanUserRoles = xpNav_UserRoles.SelectSingleNode("PLANCOLLECTION/PLAN/PLAN_AUTHORS");
            if (xpNav_PlanUserRoles != null)
            {
                return true;
            }

            xpNav_PlanUserRoles = xpNav_UserRoles.SelectSingleNode("PLANCOLLECTION/PLAN/PLAN_READERS");
            if (xpNav_PlanUserRoles != null)
            {
                return true;
            }

            xpNav_PlanUserRoles = xpNav_UserRoles.SelectSingleNode("PLANCOLLECTION/PLAN/PLAN_BUDGETMANAGER");
            if (xpNav_PlanUserRoles != null)
            {
                return true;
            }
            #endregion

            #region Check Marketing Activity Relations
            xpNodeIte_MA = xpNav_UserRoles.Select("//MARKETINGACTIVITY");
            foreach (XPathNavigator xpNav_MA in xpNodeIte_MA)
            {
                xpNav_MARelation = xpNav_MA.SelectSingleNode("MARKETING_ACTIVITY_COORDINATOR");
                if (xpNav_MARelation != null)
                {
                    return true;
                }
                
                xpNav_MARelation = xpNav_MA.SelectSingleNode("MARKETING_ACTIVITY_READERS");
                if (xpNav_MARelation != null)
                {
                    return true;
                }

                xpNav_MARelation = xpNav_MA.SelectSingleNode("BUDGETMANAGER");
                if (xpNav_MARelation != null)
                {
                    return true;
                }

                xpNav_MARelation = xpNav_MA.SelectSingleNode("MARKETING_ACTIVITY_OWNER");
                if (xpNav_MARelation != null)
                {
                    return true;
                }
            }
            #endregion

            return false;
        }

        /// <summary>
        /// <Purpose>Method to clone user roles of user on plan.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_OldUserID">Old User ID</param>
        /// <param name="str_NewUserID">New User ID</param>
        /// <param name="str_OldUserRolesXML">Old User Roles XML</param>
        /// <param name="str_NewUserRolesXML">New User Roles XML</param>
        /// <returns>Error if any else null</returns>
        public ERRORXML CloneUser(String str_OldUserID, String str_NewUserID, String str_SearchXML, ref String str_AuditInfoCloneUser)
        {
            ERRORXML retErrorXML = null;

            try
            {
            	PlannerServiceObj.Timeout = 900000;
                retErrorXML = PlannerServiceObj.CloneUser(str_OldUserID, str_NewUserID, str_SearchXML, ref str_AuditInfoCloneUser);
                return retErrorXML;
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }
        }

        /// <summary>
        /// <Purpose>Method to replace one user from the other in a plan.</Purpose>
        /// <Author>Rahul Gupta</Author>
        /// </summary>
        /// <param name="str_OldUserID">ID of the user to be replaced</param>
        /// <param name="str_NewUserID">ID of the user with which the old user will be replaced</param>
        /// <param name="str_OldUserRolesXML">Role of the old user in the plan xml</param>
        /// <param name="str_OldUserID">Role of the new user in the plan xml</param>
        /// <returns>error xml if error else null</returns>
        public ERRORXML ReplaceUser(String str_OldUserID, String str_NewUserID, String str_SearchXML, ref String str_AuditInfoReplaceUser)
        {
            ERRORXML ErrorXML = null;
            try
            {
                PlannerServiceObj.Timeout = 900000;
                ErrorXML = PlannerServiceObj.ReplaceUser(str_OldUserID, str_NewUserID, str_SearchXML, ref str_AuditInfoReplaceUser);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        /// <summary>
        /// <Purpose>Method to apply xslt to an xml</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_XML">XML on which to apply xslt</param>
        /// <param name="str_XSLTPath">xslt path</param>
        /// <returns>output xml</returns>
        public String ApplyXSLT(String str_XML, String str_XSLTPath)
        {
            StringBuilder           sb_Output           = null;
            XslCompiledTransform    XslCTransformObj    = null;
            XPathDocument           XpDoc               = null;
            XPathNavigator          XpNav               = null;
            XmlWriter               XmlWriterObj        = null;

            XslCTransformObj        = new XslCompiledTransform();
            XslCTransformObj.Load(str_XSLTPath);
            XpDoc                   = new XPathDocument(new StringReader(str_XML));
            XpNav                   = XpDoc.CreateNavigator();
            sb_Output               = new StringBuilder(100);
            XmlWriterObj            = XmlWriter.Create(sb_Output);
            XslCTransformObj.Transform(XpNav, XmlWriterObj);
            return sb_Output.ToString();
        }

        /// <summary>
        /// <Purpose>Overloaded method to apply xslt to an xml along with argument list</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_XML">XML on which to apply xslt</param>
        /// <param name="str_XSLTPath">xslt path</param>
        /// <param name="XsltArgumentListObj">Argument List</param>
        /// <returns>output xml</returns>
        public String ApplyXSLT(String str_XML, String str_XSLTPath, XsltArgumentList XsltArgumentListObj)
        {
            StringBuilder           sb_Output           = null;
            XslCompiledTransform    XslCTransformObj    = null;
            XPathDocument           XpDoc               = null;
            XPathNavigator          XpNav               = null;
            XmlWriter               XmlWriterObj        = null;

            XslCTransformObj        = new XslCompiledTransform();
            XslCTransformObj.Load(str_XSLTPath);
            XpDoc                   = new XPathDocument(new StringReader(str_XML));
            XpNav                   = XpDoc.CreateNavigator();
            sb_Output               = new StringBuilder(100);
            XmlWriterObj            = XmlWriter.Create(sb_Output);
            XslCTransformObj.Transform(XpNav, XsltArgumentListObj, XmlWriterObj);
            return sb_Output.ToString();
        }

        #region Delete User Related Methods

        /// <summary>
        /// <Purpose>Method to create search xml for plan for delete users.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_UserList">Xml containing user ids</param>
        /// <param name="str_OperationName">Type of operation</param>
        /// <param name="str_PlanID">Plan id</param>
        /// <returns>Search Xml</returns>
        public String CreateSearchXMLForDeleteUsers_ForPlan(String str_UserList, String str_OperationName, String str_PlanID)
        {
            #region Local Variables
            String              str_SearchConfigPath    = null;
            String              str_UserID              = null;
            StringBuilder       sb_PlanRelationNode     = null;
            StringBuilder       sb_MACoRelationNode     = null;
            StringBuilder       sb_MARdrRelationNode    = null;
            StringBuilder       sb_MABMRelationNode     = null;
            StringBuilder       sb_FilterNode           = null;
            StringBuilder       sb_PlanAuthorNode       = null;
            StringBuilder       sb_PlanReaderNode       = null;
            StringBuilder       sb_PlanBMNode           = null;
            StringBuilder       sb_MAMONode             = null;
            int                 i_Filter                = 1;
            String              str_SearchXML           = null;
            XPathDocument       xpDoc_UserList          = null;
            XPathNavigator      xpNav_UserList          = null;
            XPathNodeIterator   xpNodeIte_UserList      = null;
            #endregion

            if (!String.IsNullOrEmpty(str_UserList))
            {
                xpDoc_UserList = new XPathDocument(new StringReader(str_UserList));
                xpNav_UserList = xpDoc_UserList.CreateNavigator();
                xpNodeIte_UserList = xpNav_UserList.Select("USER/USERID");
            }

            str_SearchConfigPath    = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "", "GetUser_ForDelete_ForPlan_SearchConfiguration");

            if (File.Exists(str_SearchConfigPath))
            {
                str_SearchXML = File.ReadAllText(str_SearchConfigPath);
            }

            if (!String.IsNullOrEmpty(str_SearchXML) && !String.IsNullOrEmpty(str_OperationName) && !String.IsNullOrEmpty(str_UserList))
            {
                switch (str_OperationName)
                {
                    case "DELETE_PLAN_AUTHOR":

                        #region Delete Author Search XML
                        sb_PlanRelationNode = new StringBuilder();
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_AUTHORS'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_MACoRelationNode = new StringBuilder();
                        sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());
                        sb_MACoRelationNode.Append(sb_FilterNode.ToString());

			            sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_MACoRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());
                        #endregion

                        break;

                    case "DELETE_PLAN_READER":

                        #region Delete Reader Search XML
                        sb_PlanRelationNode = new StringBuilder(100);
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_READERS'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_MACoRelationNode = new StringBuilder(100);
                        sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode       = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());
                        sb_MACoRelationNode.Append(sb_FilterNode.ToString());

                        sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_MACoRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        
                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());
                        #endregion

                        break;

                    case "DELETE_PLAN_BUDGETMANAGER":

                        #region Delete Budget Manager Search XML
                        sb_PlanRelationNode = new StringBuilder();
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_BUDGETMANAGER'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_MABMRelationNode = new StringBuilder();
                        sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode       = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());
                        sb_MABMRelationNode.Append(sb_FilterNode.ToString());

                        sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_MABMRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MABMRelationNode.ToString());
                        #endregion

                        break;

                    case "DELETE_PLAN_UNIVERSEUSER":

                        #region Delete Budget Manager Search XML

                        #region Plan Relations
                        sb_PlanRelationNode = new StringBuilder();
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_PLANUNIVERSE_USER'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_PlanAuthorNode = new StringBuilder(100);
                        sb_PlanAuthorNode.Append(@"<RELATIONSHIP NAME='PLAN_AUTHORS'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_PlanReaderNode = new StringBuilder(100);
                        sb_PlanReaderNode.Append(@"<RELATIONSHIP NAME='PLAN_READERS'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_PlanBMNode = new StringBuilder(100);
                        sb_PlanBMNode.Append(@"<RELATIONSHIP NAME='PLAN_BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");
                        #endregion

                        #region Marketing Activity Relations
                        sb_MACoRelationNode = new StringBuilder(100);
                        sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_MAMONode = new StringBuilder(100);
                        sb_MAMONode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_OWNER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_MARdrRelationNode = new StringBuilder(100);
                        sb_MARdrRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_READERS'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_MABMRelationNode = new StringBuilder();
                        sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");
                        #endregion

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());
                        sb_PlanAuthorNode.Append(sb_FilterNode.ToString());
                        sb_PlanReaderNode.Append(sb_FilterNode.ToString());
                        sb_PlanBMNode.Append(sb_FilterNode.ToString());

                        sb_MARdrRelationNode.Append(sb_FilterNode.ToString());
                        sb_MACoRelationNode.Append(sb_FilterNode.ToString());
                        sb_MAMONode.Append(sb_FilterNode.ToString());
                        sb_MABMRelationNode.Append(sb_FilterNode.ToString());

                        sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_PlanAuthorNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_PlanReaderNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_PlanBMNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        sb_MARdrRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_MACoRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_MAMONode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        sb_MABMRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        
                        sb_PlanRelationNode.Append(sb_PlanAuthorNode.ToString());
                        sb_PlanRelationNode.Append(sb_PlanReaderNode.ToString());
                        sb_PlanRelationNode.Append(sb_PlanBMNode.ToString());

                        sb_MARdrRelationNode.Append(sb_MACoRelationNode.ToString());
                        sb_MARdrRelationNode.Append(sb_MAMONode.ToString());
                        sb_MARdrRelationNode.Append(sb_MABMRelationNode.ToString());

                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MARdrRelationNode.ToString());
                        #endregion

                        break;
                }
            }
            str_SearchXML = str_SearchXML.Replace("$AL$PLANID$AL$", str_PlanID);
            str_SearchXML = str_SearchXML.Replace("$AL$Language$AL$", CurrentLanguage);
            str_SearchXML = str_SearchXML.Replace("$AL$TenantName$AL$", TenantName);
            str_SearchXML = str_SearchXML.Replace("$AL$UserID$AL$", UserID);
            str_SearchXML = str_SearchXML.Replace("$AL$SessionID$AL$", SessionID);
            return str_SearchXML;
        }

        /// <summary>
        /// <Purpose>Method to create search xml for marketing activity for delete users.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_UserList">Xml containing user ids</param>
        /// <param name="str_OperationName">Type of operation</param>
        /// <param name="str_MarketingActivityID">Marketing activity id</param>
        /// <returns>Search Xml</returns>
        public String CreateSearchXMLForDeleteUsers_ForMarketingActivity(String str_UserList, String str_OperationName, 
                        String str_MarketingActivityID)
        {
            #region Local Variables
            String              str_SearchConfigPath    = null;
            String              str_UserID              = null;
            StringBuilder       sb_MACoRelationNode     = null;
            StringBuilder       sb_MARdrRelationNode    = null;
            StringBuilder       sb_MABMRelationNode     = null;
            StringBuilder       sb_MAMORelationNode     = null;
            StringBuilder       sb_FilterNode           = null;
            int                 i_Filter                = 1;
            String              str_SearchXML           = null;
            XPathDocument       xpDoc_UserList          = null;
            XPathNavigator      xpNav_UserList          = null;
            XPathNodeIterator   xpNodeIte_UserList      = null;
            #endregion

            if (!String.IsNullOrEmpty(str_UserList))
            {
                xpDoc_UserList      = new XPathDocument(new StringReader(str_UserList));
                xpNav_UserList      = xpDoc_UserList.CreateNavigator();
                xpNodeIte_UserList  = xpNav_UserList.Select("USER/USERID");
            }

            str_SearchConfigPath    = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "", 
                                        "GetUser_ForDelete_ForMarketingActivity_SearchConfiguration");

            if (File.Exists(str_SearchConfigPath))
            {
                str_SearchXML       = File.ReadAllText(str_SearchConfigPath);
            }

            if (!String.IsNullOrEmpty(str_SearchXML) && !String.IsNullOrEmpty(str_OperationName) && !String.IsNullOrEmpty(str_UserList))
            {
                switch (str_OperationName)
                {
                    case "DELETE_MA_COORDINATOR":

                        #region Delete Marketing Activity Coordinator Search XML

                        sb_MACoRelationNode = new StringBuilder();
                        sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MACoRelationNode.Append(sb_FilterNode.ToString());

                        sb_MACoRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());
                        #endregion

                        break;

                    case "DELETE_MA_READER":

                        #region Delete Reader Search XML
                        sb_MARdrRelationNode = new StringBuilder(100);
                        sb_MARdrRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_READERS'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode       = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MARdrRelationNode.Append(sb_FilterNode.ToString());

                        sb_MARdrRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MARdrRelationNode.ToString());
                        #endregion

                        break;

                    case "DELETE_MA_BUDGETMANAGER":

                        #region Delete Budget Manager Search XML
                        sb_MABMRelationNode = new StringBuilder();
                        sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode       = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MABMRelationNode.Append(sb_FilterNode.ToString());

                        sb_MABMRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MABMRelationNode.ToString());
                        #endregion

                        break;

                    case "DELETE_MA_MARKETINGOWNER":

                        #region Delete Marketing Activity Search XML
                        sb_MAMORelationNode = new StringBuilder();
                        sb_MAMORelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_OWNER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode       = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MAMORelationNode.Append(sb_FilterNode.ToString());

                        sb_MAMORelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MAMORelationNode.ToString());
                        #endregion

                        break;
                }
            }
            str_SearchXML = str_SearchXML.Replace("$AL$MARKETINGACTIVITYID$AL$", str_MarketingActivityID);
            str_SearchXML = str_SearchXML.Replace("$AL$Language$AL$", CurrentLanguage);
            str_SearchXML = str_SearchXML.Replace("$AL$TenantName$AL$", TenantName);
            str_SearchXML = str_SearchXML.Replace("$AL$UserID$AL$", UserID);
            str_SearchXML = str_SearchXML.Replace("$AL$SessionID$AL$", SessionID);
            return str_SearchXML;
        }

        /// <summary>
        /// <Purpose>Method to delete Cached XMLs for Marketing Activities of selected parent Plan/ Activity</Purpose>
        /// <Author>Priyanka Chadha</Author>
        /// </summary>
        /// <param name="arr_ActivityID">Arrey of Marketing Activity Ids</param>
        private void deleteActivityXMLFromCache(String[] arr_ActivityID)
        {
            foreach (string ActivityID in arr_ActivityID)
                ALPersistentCache.Remove(TenantName, SessionID.ToString(), "ActivityRO_" + ActivityID);
        }

        /// <summary>
        /// <Purpose>Method to delete user roles at all the lower roles for plan and its marketing activities.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_UserList">Xml containing user ids</param>
        /// <param name="str_OperationName">Type of operation</param>
        /// <param name="str_SearchXML">Search xml for user roles</param>
        /// <param name="b_DeleteAccessPlan">Allow Default Authors/Readers to be removed from Plan setting value</param>
        /// <param name="DefaultAuthorList">Xml containing users which are default Authors for plan</param>
        /// <param name="DefaultReaderList">Xml containing users which are default Reader for plan</param>
        /// <param name="str_NonDeletedUsers">List of users which were not deleted as they are default author or reader users</param>
        /// <param name="str_AuditInfo">Audit info
        /// Format: <USERAUDITINFO>
        ///             <USER_BROWSER_IP>{0}</USER_BROWSER_IP>
        ///             <REQUESTINFO>{1}</REQUESTINFO>
        ///             <USERID>{2}</USERID>
        ///         </USERAUDITINFO>
        /// </param>
        /// <returns>Error xml if any else null</returns>
        public ERRORXML DeleteUserAtLowerLevel_ForPlan(String str_UserList, String str_OperationName, String str_SearchXML, bool b_DeleteAccessPlan, String DefaultAuthorList, String DefaultReaderList, ref String str_NonDeletedUsers, ref String str_AuditInfo)
        {
            ERRORXML ErrorXML = null;
            String[] arr_PlanActivities = new String[0];
            try
            {
                PlannerServiceObj.Timeout = 1500000;
                ErrorXML = PlannerServiceObj.DeleteUserAtLowerLevel_ForPlan(str_UserList, str_OperationName, str_SearchXML, b_DeleteAccessPlan, DefaultAuthorList, DefaultReaderList, ref str_NonDeletedUsers, ref str_AuditInfo, out arr_PlanActivities);
                if (String.IsNullOrEmpty(ErrorXML) && arr_PlanActivities.Length > 0)
                {
                    deleteActivityXMLFromCache(arr_PlanActivities);
                }
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        /// <summary>
        /// <Purpose>Method to delete user roles at all the lower roles for marketing activity and its sub marketing activities.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_UserList">Xml containing user ids</param>
        /// <param name="str_OperationName">Type of operation</param>
        /// <param name="str_SearchXML">Search xml for user roles</param>
        /// <param name="str_AuditInfo">Audit info
        /// Format: <USERAUDITINFO>
        ///             <USER_BROWSER_IP>{0}</USER_BROWSER_IP>
        ///             <REQUESTINFO>{1}</REQUESTINFO>
        ///             <USERID>{2}</USERID>
        ///         </USERAUDITINFO>
        /// </param>
        /// <returns>Error xml if any else null</returns>
        public ERRORXML DeleteUserAtLowerLevel_ForMarketingActivity(String str_UserList, String str_OperationName, String str_SearchXML, 
                        ref String str_AuditInfo)
        {
            ERRORXML ErrorXML = null;
            String[] arr_MarketingActivities = new String[0];
            try
            {
                PlannerServiceObj.Timeout = 900000;
                ErrorXML = PlannerServiceObj.DeleteUserAtLowerLevel_ForMarketingActivity(str_UserList, str_OperationName, str_SearchXML,
                        ref str_AuditInfo, out arr_MarketingActivities);
                if (String.IsNullOrEmpty(ErrorXML) && arr_MarketingActivities.Length > 0)
                {
                    deleteActivityXMLFromCache(arr_MarketingActivities);
                }
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        #endregion

        #region Add User Related Methods

        /// <summary>
        /// <Purpose>Method to create search xml for plan/marketing activity to add users for all levels.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_EntityID">Marketing activity id</param>
        /// <param name="i_EntityLevel">Level of plan/marketing activity</param>
        /// <param name="str_OperationName">Type of operation</param>
        /// <param name="str_BMSelectionType">Budget manager selection type</param>
        /// <returns>Search Xml</returns>
        public String CreateSearchXMLForAddUsers_ForAllLevels(String str_EntityID, int i_EntityLevel, String str_OperationName, 
                        String str_BMSelectionType)
        {
            #region Local Variables
            String              str_SearchConfigPath        = null;
            StringBuilder       sb_MACoRelationNode         = null;
            StringBuilder       sb_MABMRelationNode         = null;
            StringBuilder       sb_MARdrRelationNode        = null;
            StringBuilder       sb_MAMORelationNode         = null;
            String              str_SearchXML               = null;
            #endregion

            #region Search Configuration
            if (i_EntityLevel == 0)
            {
                str_SearchConfigPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "",
                                            "GetUser_ForAddUser_ForPlan_SearchConfiguration");
            }
            else
            {
                str_SearchConfigPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "",
                                            "GetUser_ForAddUser_ForMarketingActivity_SearchConfiguration");

            }
            if (File.Exists(str_SearchConfigPath))
            {
                str_SearchXML = File.ReadAllText(str_SearchConfigPath);
            }
            #endregion

            if (!String.IsNullOrEmpty(str_SearchXML) && !String.IsNullOrEmpty(str_OperationName))
            {
                #region For Plan
                if (i_EntityLevel == 0)
                {
                    switch (str_OperationName)
                    {
                        case "ADD_PLAN_AUTHOR":

                            #region Add Author Search XML

                            sb_MACoRelationNode = new StringBuilder();
                            sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>USERID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                    </FILTER>
                                                        </FILTERLIST>
		                                            </RELATIONSHIP>");

                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());

                            #endregion

                            break;

                        case "ADD_PLAN_READER":

                            #region Add Reader Search XML

                            sb_MACoRelationNode = new StringBuilder(100);
                            sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>USERID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                    </FILTER>
                                                        </FILTERLIST>
		                                            </RELATIONSHIP>");

                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());

                            #endregion

                            break;

                        case "ADD_PLAN_BUDGETMANAGER":

                            #region Add Budget Manager Search XML

                            sb_MABMRelationNode = new StringBuilder();
                            if (!String.IsNullOrEmpty(str_BMSelectionType) && str_BMSelectionType.ToUpper().Equals("SINGLESELECT"))
                            {
                                sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
		                                            </RELATIONSHIP>");
                            }
                            else
                            {
                                sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>
                                                            <FILTER>
			                                                    <FILTERID>1</FILTERID>
			                                                    <EXPRESSION>USERID</EXPRESSION>
			                                                    <OPERATOR>EQUALTO</OPERATOR>
			                                                    <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                    </FILTER>
                                                        </FILTERLIST>
		                                            </RELATIONSHIP>");
                            }
                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MABMRelationNode.ToString());
                            #endregion

                            break;
                    }
                    str_SearchXML = str_SearchXML.Replace("$AL$PLANID$AL$", str_EntityID);
                }
                #endregion

                #region For Marketing Activity
                else
                {
                    switch (str_OperationName)
                    {
                        case "ADD_MA_COORDINATOR":

                            #region Add Marketing Activity Coordinator Search XML

                            sb_MACoRelationNode = new StringBuilder();
                            sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
				                                            <FILTERLIST>
                                                                <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>USERID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
                                                            </FILTERLIST>
		                                                </RELATIONSHIP>");

                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());
                            #endregion

                            break;

                        case "ADD_MA_READER":

                            #region Add Reader Search XML

                            sb_MARdrRelationNode = new StringBuilder(100);
                            sb_MARdrRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_READERS'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
				                                            <FILTERLIST>
                                                                <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>USERID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
                                                            </FILTERLIST>
		                                                </RELATIONSHIP>");

                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MARdrRelationNode.ToString());
                            #endregion

                            break;

                        case "ADD_MA_BUDGETMANAGER":

                            #region Add Budget Manager Search XML

                            sb_MABMRelationNode = new StringBuilder();
                            if (!String.IsNullOrEmpty(str_BMSelectionType) && str_BMSelectionType.ToUpper().Equals("SINGLESELECT"))
                            {
                                sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
		                                                </RELATIONSHIP>");
                            }
                            else
                            {
                                sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
				                                            <FILTERLIST>
                                                                <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>USERID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
                                                            </FILTERLIST>
		                                                </RELATIONSHIP>");
                            }
                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MABMRelationNode.ToString());
                            #endregion

                            break;

                        case "ADD_MA_MARKETINGOWNER":

                            #region Add Marketing Activity Search XML

                            sb_MAMORelationNode = new StringBuilder();
                            sb_MAMORelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_OWNER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
		                                                </RELATIONSHIP>");

                            str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MAMORelationNode.ToString());
                            #endregion

                            break;
                    }
                    str_SearchXML = str_SearchXML.Replace("$AL$MARKETINGACTIVITYID$AL$", str_EntityID);
                }
                #endregion
            }
            str_SearchXML = str_SearchXML.Replace("$AL$Language$AL$", CurrentLanguage);
            str_SearchXML = str_SearchXML.Replace("$AL$TenantName$AL$", TenantName);
            str_SearchXML = str_SearchXML.Replace("$AL$UserID$AL$", UserID);
            str_SearchXML = str_SearchXML.Replace("$AL$SessionID$AL$", SessionID);
            return str_SearchXML;
        }

        /// <summary>
        /// <Purpose>Method to create search xml for plan/marketing activity to add users for selected levels.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="ht_UserID_MAIDs">Hash table containing userids and selected marketing activity ids</param>
        /// <param name="str_User_Choice_XML">XML containing user collection of user id and selected option</param>
        /// <param name="str_OperationName">Type of operation</param>
        /// <param name="str_BMSelectionType">Budget manager selection type</param>
        /// <returns>Search Xml</returns>
        public String CreateUserID_MAIDs_SearchXMLForAddUsers_SelectedLevels(Hashtable ht_UserID_MAIDs, String str_User_Choice_XML, 
                        String str_OperationName, String str_BMSelectionType)
        {
            #region Local Variables
            StringBuilder       sb_MARelationNode           = null;
            StringBuilder       sb_SearchXML                = null;
            StringBuilder       sb_FilterList               = null;
            StringBuilder       sb_FinalSearchXML           = null;
            String[]            Sep                         = null;
            String              Parameter                   = null;
            String[]            ParamList                   = null;
            XmlDocument         xmlDoc_User_Choice          = null;
            XmlElement          xmlEle_UserNode             = null;
            #endregion

            xmlDoc_User_Choice = new XmlDocument();
            xmlDoc_User_Choice.LoadXml(str_User_Choice_XML);

            foreach (String str_UserID in ht_UserID_MAIDs.Keys)
            {
                Sep         = new String[1] { "$AL$" };
                Parameter   = ht_UserID_MAIDs[str_UserID].ToString();
                ParamList   = Parameter.Split(Sep, StringSplitOptions.RemoveEmptyEntries);

                xmlEle_UserNode = (XmlElement)xmlDoc_User_Choice.SelectSingleNode("USERCOLLECTION/USER[USERID='" + str_UserID + "']");
                if (xmlEle_UserNode != null)
                {
                    #region Creating Search XML
                    sb_SearchXML = new StringBuilder(200);
                    sb_SearchXML.AppendFormat(@"<SEARCH>
	                                <TARGETOBJECT>MARKETINGACTIVITY</TARGETOBJECT>
	                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
	                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
	                                <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
	                                <TARGETENTITY>
		                                <PRIVILEGENAME>READ</PRIVILEGENAME>
		                                <SELECTLIST>
			                                <EXPRESSION>
				                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
				                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
			                                </EXPRESSION>
			                                <EXPRESSION>
				                                <FIELDNAME>NAME</FIELDNAME>
				                                <ALIAS>NAME</ALIAS>
			                                </EXPRESSION>
		                                </SELECTLIST>", CurrentLanguage, TenantName, UserID, SessionID);

                    #region Creating Filter List
                    sb_FilterList = new StringBuilder(100);
                    sb_FilterList.Append("<FILTERLIST>");
                    for (int i = 0; i < ParamList.Length; i++)
                    {
                        sb_FilterList.AppendFormat(@"<FILTER>
				                                <FILTERID>{0}</FILTERID>
				                                <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
				                                <OPERATOR>EQUALTO</OPERATOR>
				                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
				                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
			                                </FILTER>", i + 1, ParamList[i]);
                    }
                    sb_FilterList.Append("</FILTERLIST>");
                    #endregion

                    #region Creating Relation
                    if (!String.IsNullOrEmpty(str_OperationName))
                    {
                        switch (str_OperationName)
                        {
                            case "ADD_PLAN_AUTHOR":

                                #region Add Author Search XML

                                sb_MARelationNode = new StringBuilder();
                                sb_MARelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
			                                        <SELECTLIST>
				                                        <EXPRESSION>
					                                        <FIELDNAME>USERID</FIELDNAME>
					                                        <ALIAS>USERID</ALIAS>
				                                        </EXPRESSION>
			                                        </SELECTLIST>
			                                        <FILTERLIST>
                                                        <FILTER>
		                                                    <FILTERID>1</FILTERID>
		                                                    <EXPRESSION>USERID</EXPRESSION>
		                                                    <OPERATOR>EQUALTO</OPERATOR>
		                                                    <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
		                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                    </FILTER>
                                                    </FILTERLIST>
	                                            </RELATIONSHIP>");

                                #endregion

                                break;

                            case "ADD_PLAN_READER":

                                #region Add Reader Search XML

                                sb_MARelationNode = new StringBuilder(100);
                                sb_MARelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
			                                        <SELECTLIST>
				                                        <EXPRESSION>
					                                        <FIELDNAME>USERID</FIELDNAME>
					                                        <ALIAS>USERID</ALIAS>
				                                        </EXPRESSION>
			                                        </SELECTLIST>
			                                        <FILTERLIST>
                                                        <FILTER>
		                                                    <FILTERID>1</FILTERID>
		                                                    <EXPRESSION>USERID</EXPRESSION>
		                                                    <OPERATOR>EQUALTO</OPERATOR>
		                                                    <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
		                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                    </FILTER>
                                                    </FILTERLIST>
	                                            </RELATIONSHIP>");

                                #endregion

                                break;

                            case "ADD_PLAN_BUDGETMANAGER":

                                #region Add Budget Manager Search XML

                                sb_MARelationNode = new StringBuilder(100);
                                if (!String.IsNullOrEmpty(str_BMSelectionType) && str_BMSelectionType.ToUpper().Equals("SINGLESELECT"))
                                {
                                    sb_MARelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
		                                                </RELATIONSHIP>");
                                }
                                else
                                {
                                    sb_MARelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
				                                            <FILTERLIST>
                                                                <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>USERID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
                                                            </FILTERLIST>
		                                                </RELATIONSHIP>");
                                }
                                #endregion

                                break;

                            case "ADD_MA_COORDINATOR":

                                #region Add Marketing Activity Coordinator Search XML

                                sb_MARelationNode = new StringBuilder();
                                sb_MARelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
			                                            <SELECTLIST>
				                                            <EXPRESSION>
					                                            <FIELDNAME>USERID</FIELDNAME>
					                                            <ALIAS>USERID</ALIAS>
				                                            </EXPRESSION>
			                                            </SELECTLIST>
			                                            <FILTERLIST>
                                                            <FILTER>
		                                                        <FILTERID>1</FILTERID>
		                                                        <EXPRESSION>USERID</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                        </FILTERLIST>
	                                                </RELATIONSHIP>");

                                #endregion

                                break;

                            case "ADD_MA_READER":

                                #region Add Reader Search XML

                                sb_MARelationNode = new StringBuilder(100);
                                sb_MARelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_READERS'>
			                                            <SELECTLIST>
				                                            <EXPRESSION>
					                                            <FIELDNAME>USERID</FIELDNAME>
					                                            <ALIAS>USERID</ALIAS>
				                                            </EXPRESSION>
			                                            </SELECTLIST>
			                                            <FILTERLIST>
                                                            <FILTER>
		                                                        <FILTERID>1</FILTERID>
		                                                        <EXPRESSION>USERID</EXPRESSION>
		                                                        <OPERATOR>EQUALTO</OPERATOR>
		                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
		                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
	                                                        </FILTER>
                                                        </FILTERLIST>
	                                                </RELATIONSHIP>");

                                #endregion

                                break;

                            case "ADD_MA_BUDGETMANAGER":

                                #region Add Budget Manager Search XML

                                sb_MARelationNode = new StringBuilder(100);
                                if (!String.IsNullOrEmpty(str_BMSelectionType) && str_BMSelectionType.ToUpper().Equals("SINGLESELECT"))
                                {
                                    sb_MARelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
		                                                </RELATIONSHIP>");
                                }
                                else
                                {
                                    sb_MARelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                            <SELECTLIST>
					                                            <EXPRESSION>
						                                            <FIELDNAME>USERID</FIELDNAME>
						                                            <ALIAS>USERID</ALIAS>
					                                            </EXPRESSION>
				                                            </SELECTLIST>
				                                            <FILTERLIST>
                                                                <FILTER>
			                                                        <FILTERID>1</FILTERID>
			                                                        <EXPRESSION>USERID</EXPRESSION>
			                                                        <OPERATOR>EQUALTO</OPERATOR>
			                                                        <EXPRESSIONVALUE>$AL$USERID$AL$</EXPRESSIONVALUE>
			                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                        </FILTER>
                                                            </FILTERLIST>
		                                                </RELATIONSHIP>");
                                }

                                #endregion

                                break;

                            case "ADD_MA_MARKETINGOWNER":

                                #region Add Marketing Activity Search XML

                                sb_MARelationNode = new StringBuilder();
                                sb_MARelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_OWNER'>
			                                            <SELECTLIST>
				                                            <EXPRESSION>
					                                            <FIELDNAME>USERID</FIELDNAME>
					                                            <ALIAS>USERID</ALIAS>
				                                            </EXPRESSION>
			                                            </SELECTLIST>
	                                                </RELATIONSHIP>");

                                #endregion

                                break;
                        }
                    }
                    #endregion

                    sb_SearchXML.Append(sb_MARelationNode.ToString());
                    sb_SearchXML.Append(sb_FilterList.ToString());
                    sb_SearchXML.Append(@"</TARGETENTITY>
                                </SEARCH>");
                    #endregion

                    if (sb_SearchXML != null)
                    {
                        sb_FinalSearchXML = new StringBuilder(200);
                        sb_FinalSearchXML.AppendFormat("<SEARCHXML>{0}</SEARCHXML>", sb_SearchXML.ToString());
                        xmlEle_UserNode.InnerXml += sb_FinalSearchXML.ToString();
                    }
                }
            }

            return xmlDoc_User_Choice.InnerXml;
        }

        /// <summary>
        /// <Purpose>Method to add users in the plan and marketing activity.</Purpose>
        /// <Author>Parita Harniya</Author>
        /// </summary>
        /// <param name="str_UserID_Choice_MAIDs">XML containing user id and selected option and search xml for choice 3</param>
        /// <param name="str_EntityID">plan or marketing activity</param>
        /// <param name="i_EntityLevel">plan level or marketing activity level</param>
        /// <param name="str_OperationName">Operation to be performed</param>
        /// <param name="str_SearchXML">Search xml for choice 2</param>
        /// <param name="str_BMSelectionType">Budget manager selection type</param>
        /// <param name="str_AuditInfo">Audit info
        /// Format: <USERAUDITINFO>
        ///             <USER_BROWSER_IP>{0}</USER_BROWSER_IP>
        ///             <REQUESTINFO>{1}</REQUESTINFO>
        ///             <USERID>{2}</USERID>
        ///         </USERAUDITINFO>
        /// </param>
        /// <returns>Error if any else null</returns>
        public ERRORXML UserRolesBatchUpdates(String str_UserID_Choice_MAIDs, String str_EntityID, int i_EntityLevel, String str_OperationName,
                        String str_SearchXML, String str_BMSelectionType, ref String str_AuditInfo, String str_GroupInfo)
        {
            ERRORXML ErrorXML = null;
            try
            {
                PlannerServiceObj.Timeout = 900000;
                ErrorXML = PlannerServiceObj.UserRolesBatchUpdates(str_UserID_Choice_MAIDs, str_EntityID, i_EntityLevel, str_OperationName,
                                            str_SearchXML, str_BMSelectionType, ref str_AuditInfo, str_GroupInfo);
                return ErrorXML;
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        public String CreateSearchXMLForAddUsers_ForSendNotification_Plan(String str_UserList, String str_OperationName, String str_PlanID)
        {
            #region Local Variables
            String str_SearchConfigPath = null;
            String str_UserID = null;
            StringBuilder sb_PlanRelationNode = null;
            StringBuilder sb_FilterNode = null;
            int i_Filter = 1;
            String str_SearchXML = null;
            XPathDocument xpDoc_UserList = null;
            XPathNavigator xpNav_UserList = null;
            XPathNodeIterator xpNodeIte_UserList = null;
            #endregion

            if (!String.IsNullOrEmpty(str_UserList))
            {
                xpDoc_UserList = new XPathDocument(new StringReader(str_UserList));
                xpNav_UserList = xpDoc_UserList.CreateNavigator();
                xpNodeIte_UserList = xpNav_UserList.Select("UserXML/NewUsersList/USER/USERID");
            }

            str_SearchConfigPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "", "GetUserDetails_ForSendNotification_Plan");

            if (File.Exists(str_SearchConfigPath))
            {
                str_SearchXML = File.ReadAllText(str_SearchConfigPath);
            }
            if ((xpNodeIte_UserList!= null) && (xpNodeIte_UserList.Count == 0))
            {
                str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$","");
            }
            else if (!String.IsNullOrEmpty(str_SearchXML) && !String.IsNullOrEmpty(str_OperationName) && !String.IsNullOrEmpty(str_UserList))
            {
                switch (str_OperationName)
                {
                    case "PLAN_AUTHOR":

                        #region Author Search XML
                        sb_PlanRelationNode = new StringBuilder();
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_AUTHORS'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());

                        sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");
                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        #endregion

                        break;

                    case "PLAN_READER":

                        #region Reader Search XML
                        sb_PlanRelationNode = new StringBuilder(100);
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_READERS'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());

                        sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        #endregion

                        break;

                    case "PLAN_BUDGETMANAGER":

                        #region Budget Manager Search XML
                        sb_PlanRelationNode = new StringBuilder();
                        sb_PlanRelationNode.Append(@"<RELATIONSHIP NAME='PLAN_BUDGETMANAGER'>
			                                                <SELECTLIST>
				                                                <EXPRESSION>
					                                                <FIELDNAME>USERID</FIELDNAME>
					                                                <ALIAS>USERID</ALIAS>
				                                                </EXPRESSION>
			                                                </SELECTLIST>
			                                                <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_PlanRelationNode.Append(sb_FilterNode.ToString());

                        sb_PlanRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$PLANRELATIONS$AL$", sb_PlanRelationNode.ToString());
                        #endregion

                        break;

                }
            }
            str_SearchXML = str_SearchXML.Replace("$AL$PLANID$AL$", str_PlanID);
            str_SearchXML = str_SearchXML.Replace("$AL$Language$AL$", CurrentLanguage);
            str_SearchXML = str_SearchXML.Replace("$AL$TenantName$AL$", TenantName);
            str_SearchXML = str_SearchXML.Replace("$AL$UserID$AL$", UserID);
            str_SearchXML = str_SearchXML.Replace("$AL$SessionID$AL$", SessionID);
            return str_SearchXML;
        }

        public String CreateSearchXMLForAddUsers_ForSendNotification_Activity(String str_UserList, String str_OperationName,
                      String str_MarketingActivityID)
        {
            #region Local Variables
            String str_SearchConfigPath = null;
            String str_UserID = null;
            StringBuilder sb_MACoRelationNode = null;
            StringBuilder sb_MARdrRelationNode = null;
            StringBuilder sb_MABMRelationNode = null;
            StringBuilder sb_MAMORelationNode = null;
            StringBuilder sb_FilterNode = null;
            int i_Filter = 1;
            String str_SearchXML = null;
            XPathDocument xpDoc_UserList = null;
            XPathNavigator xpNav_UserList = null;
            XPathNodeIterator xpNodeIte_UserList = null;
            #endregion

            if (!String.IsNullOrEmpty(str_UserList))
            {
                xpDoc_UserList = new XPathDocument(new StringReader(str_UserList));
                xpNav_UserList = xpDoc_UserList.CreateNavigator();
                xpNodeIte_UserList = xpNav_UserList.Select("UserXML/NewUsersList/USER/USERID");
            }

            str_SearchConfigPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, SolutionName, "",
                                        "GetUserDetails_MarketingActivity_ForSendNotification_Activity");

            if (File.Exists(str_SearchConfigPath))
            {
                str_SearchXML = File.ReadAllText(str_SearchConfigPath);
            }
            if ((xpNodeIte_UserList != null) && (xpNodeIte_UserList.Count == 0))
            {
                str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$","");
            }
            else if (!String.IsNullOrEmpty(str_SearchXML) && !String.IsNullOrEmpty(str_OperationName) && !String.IsNullOrEmpty(str_UserList))
            {
                switch (str_OperationName)
                {
                    case "MA_COORDINATOR":

                        #region Delete Marketing Activity Coordinator Search XML

                        sb_MACoRelationNode = new StringBuilder();
                        sb_MACoRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_COORDINATOR'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MACoRelationNode.Append(sb_FilterNode.ToString());

                        sb_MACoRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MACoRelationNode.ToString());
                        #endregion

                        break;

                    case "MA_READER":

                        #region Delete Reader Search XML
                        sb_MARdrRelationNode = new StringBuilder(100);
                        sb_MARdrRelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_READERS'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MARdrRelationNode.Append(sb_FilterNode.ToString());

                        sb_MARdrRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MARdrRelationNode.ToString());
                        #endregion

                        break;

                    case "MA_BUDGETMANAGER":

                        #region Delete Budget Manager Search XML
                        sb_MABMRelationNode = new StringBuilder();
                        sb_MABMRelationNode.Append(@"<RELATIONSHIP NAME='BUDGETMANAGER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MABMRelationNode.Append(sb_FilterNode.ToString());

                        sb_MABMRelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MABMRelationNode.ToString());
                        #endregion

                        break;

                    case "MA_MARKETINGOWNER":

                        #region Delete Marketing Activity Search XML
                        sb_MAMORelationNode = new StringBuilder();
                        sb_MAMORelationNode.Append(@"<RELATIONSHIP NAME='MARKETING_ACTIVITY_OWNER'>
				                                        <SELECTLIST>
					                                        <EXPRESSION>
						                                        <FIELDNAME>USERID</FIELDNAME>
						                                        <ALIAS>USERID</ALIAS>
					                                        </EXPRESSION>
				                                        </SELECTLIST>
				                                        <FILTERLIST>");

                        sb_FilterNode = new StringBuilder(100);
                        foreach (XPathNavigator xpNav_User in xpNodeIte_UserList)
                        {
                            str_UserID = xpNav_User.InnerXml;
                            sb_FilterNode.AppendFormat(@"<FILTER>
			                                                <FILTERID>{0}</FILTERID>
			                                                <EXPRESSION>USERID</EXPRESSION>
			                                                <OPERATOR>EQUALTO</OPERATOR>
			                                                <EXPRESSIONVALUE>{1}</EXPRESSIONVALUE>
			                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
		                                                </FILTER>", i_Filter, str_UserID);

                            i_Filter++;
                        }
                        sb_MAMORelationNode.Append(sb_FilterNode.ToString());

                        sb_MAMORelationNode.Append(@"</FILTERLIST>
		                                                </RELATIONSHIP>");

                        str_SearchXML = str_SearchXML.Replace("$AL$MARELATIONS$AL$", sb_MAMORelationNode.ToString());
                        #endregion

                        break;
                }
            }
            str_SearchXML = str_SearchXML.Replace("$AL$MARKETINGACTIVITYID$AL$", str_MarketingActivityID);
            str_SearchXML = str_SearchXML.Replace("$AL$Language$AL$", CurrentLanguage);
            str_SearchXML = str_SearchXML.Replace("$AL$TenantName$AL$", TenantName);
            str_SearchXML = str_SearchXML.Replace("$AL$UserID$AL$", UserID);
            str_SearchXML = str_SearchXML.Replace("$AL$SessionID$AL$", SessionID);
            
            return str_SearchXML;
        }

        /// <summary>
        /// <Purpose>Method returns the list of Groups & Users associcated with the Business Unit Universe.</Purpose>
        /// <Author>Rahul Gupta</Author>
        /// </summary>
        /// <param name="str_BusinessUnitID">string having ID of Business Unit of The Plan.</param>
        /// <param name="str_BUGroupXML">Unique list of Groups Associated with the Business Unit.</param>
        /// <param name="str_BUUserList">Unique list of Users Associated with the Business Unit.</param>
        /// <returns>Error Xml</returns>
        private String BUGroupsForPlan(String str_BusinessUnitID, Boolean b_BUUniverseRequired, ref String str_BUGroupXML, ref String str_BUUserList)
        {
            String                  str_BUGroupList         = null;
            StringBuilder           sb_BUUserList           = null;
            SearchConfiguration     SearchConfigObj         = null;
            StringBuilder           sb_BUGroupSearchXML     = null;
            XPathDocument           xDoc_BUGroupXML         = null;
            XPathNavigator          xNav_BUGroup            = null;
            XPathNodeIterator       xNodeItr_Group          = null;
            XPathNodeIterator       xNodeItr_User           = null;
            ERRORXML                ErrorXML                = null;


            #region Search XML
            sb_BUGroupSearchXML = new StringBuilder(200);
            sb_BUGroupSearchXML.AppendFormat(@"<SEARCH>
                                            <TARGETOBJECT>BUSINESSUNIT</TARGETOBJECT>
                                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                            <TARGETENTITY>
                                               <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                 <FILTERLIST>			                                            
                                                    <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        <EXPRESSION>BUSINESSUNITID</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>
                                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                                    </FILTER>
                                                </FILTERLIST>
                                                <SELECTLIST>
                                                    <EXPRESSION>
                                                        <FIELDNAME>BUSINESSUNITID</FIELDNAME>
                                                         <ALIAS>BUSINESSUNITID</ALIAS>
                                                    </EXPRESSION>
                                                </SELECTLIST>
                                                <RELATIONSHIP NAME='BUUNIVERSE_GROUP'>
                                                      <SELECTLIST>
                                                        <EXPRESSION>
                                                          <FIELDNAME>GROUPID</FIELDNAME>
                                                          <ALIAS>GROUPID</ALIAS>
                                                        </EXPRESSION>
                                                      </SELECTLIST>
                                                </RELATIONSHIP>
                                                <RELATIONSHIP NAME='BUUNIVERSE_USER'>
                                                      <SELECTLIST>
                                                        <EXPRESSION>
                                                          <FIELDNAME>USERID</FIELDNAME>
                                                          <ALIAS>USERID</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                          <ALIAS>FIRSTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>LASTNAME</FIELDNAME>
                                                          <ALIAS>LASTNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>LOGINNAME</FIELDNAME>
                                                          <ALIAS>LOGINNAME</ALIAS>
                                                        </EXPRESSION>
                                                        <EXPRESSION>
                                                          <FIELDNAME>EMAILID</FIELDNAME>
                                                          <ALIAS>EMAILID</ALIAS>
                                                        </EXPRESSION>
                                                      </SELECTLIST>
                                                </RELATIONSHIP>
                                            </TARGETENTITY>
                                           </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_BusinessUnitID);


            #endregion

            SearchConfigObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
            //The str_BUGroupList will have all the Business Unit Universe Groups associated with that Plan.
            ErrorXML = SearchConfigObj.GetHierarchialData(sb_BUGroupSearchXML.ToString(), ref str_BUGroupList);
            if (String.IsNullOrEmpty(ErrorXML))
            {
                xDoc_BUGroupXML = new XPathDocument(new StringReader(str_BUGroupList));
                xNav_BUGroup    = xDoc_BUGroupXML.CreateNavigator();

                str_BUGroupXML = "<GROUPLIST>";
                xNodeItr_Group = xNav_BUGroup.Select("BUSINESSUNITCOLLECTION/BUSINESSUNIT/BUUNIVERSE_GROUP/GROUP");
                while (xNodeItr_Group.MoveNext())
                {
                    str_BUGroupXML += xNodeItr_Group.Current.InnerXml.ToString();
                }
                str_BUGroupXML += "</GROUPLIST>";

                sb_BUUserList = new StringBuilder(200);
                sb_BUUserList.Append("<FilterCollection><PermittedUsers>");

                xNodeItr_User = xNav_BUGroup.Select("BUSINESSUNITCOLLECTION/BUSINESSUNIT/BUUNIVERSE_USER/USER");
                while (xNodeItr_User.MoveNext())
                {
                    sb_BUUserList.Append("<Users>" + xNodeItr_User.Current.InnerXml.ToString() + "</Users>");
                }
                sb_BUUserList.Append("</PermittedUsers></FilterCollection>");

                str_BUUserList = sb_BUUserList.ToString();

            }
            return ErrorXML;
        }

        #endregion

        #region Notification related functions

        public string NotifyAddAuthorReader(String PlanDetailsXML, String NotificationType)
        {
            NotificationFacadeClass ObjNotificationFacade = null;
            String EMail_RO_PageUrl = null;
            StringBuilder Message = null;
            StringBuilder Subject = null;
            String Title = null;
            String retUserXML = null;
            String strUserName = null;
            StringReader retPlanXml = null;
            XPathDocument xp_PlanXMLDoc = null;
            XPathNavigator xp_PlanNav = null;
            XPathNavigator PlanTitleNode = null;
            XPathNodeIterator xp_PlanAuthorNodes = null;
            XPathNodeIterator xp_PlanReaderNodes = null;
            XML ErrorXml = null;
            String NotificationEventType = null;
            XmlDocument PlanDoc = null;
            XmlElement ElementtoRemove = null;
            XmlNode ElementNode = null;
            int Readerflg = 0;
            int Authorflg = 0;
            string PlanID = null;
            string SolutionName = "StrategicPlanner";
            XPathNavigator          xpNav_PlanCreator       = null;
            String                  str_PlanCreator         = null;

            try
            {
                retPlanXml = new StringReader(PlanDetailsXML);
                xp_PlanXMLDoc = new XPathDocument(retPlanXml);
                xp_PlanNav = xp_PlanXMLDoc.CreateNavigator();

                PlanTitleNode = xp_PlanNav.SelectSingleNode("PLAN/TITLE");
                Title = PlanTitleNode.Value;

                PlanID = xp_PlanNav.SelectSingleNode("PLAN/PLANID").Value;

                PlanDoc = new XmlDocument();
                PlanDoc.LoadXml(PlanDetailsXML);
                if (NotificationType == "Authors")
                {
                    NotificationEventType = "ADD_PLAN_AUTHOR";
                    xp_PlanAuthorNodes = xp_PlanNav.Select("PLAN/PLAN_AUTHORS[not(attribute::DISASSOCIATE)]");
                    if (xp_PlanAuthorNodes.Count != 0)
                    {
                        Authorflg = 1;
                        ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_AUTHORS[@DISASSOCIATE='TRUE']");
                        while (ElementtoRemove != null)
                        {
                            ElementNode = PlanDoc.DocumentElement.SelectSingleNode("/PLAN");
                            ElementNode.RemoveChild((XmlNode)ElementtoRemove);
                            ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_AUTHORS[@DISASSOCIATE='TRUE']");
                        }
                    }
                }
                if (NotificationType == "Readers")
                {
                    NotificationEventType = "ADD_PLAN_READER";
                    xp_PlanReaderNodes = xp_PlanNav.Select("PLAN/PLAN_READERS[not(attribute::DISASSOCIATE)]");
                    if (xp_PlanReaderNodes.Count != 0)
                    {
                        Readerflg = 1;
                        ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_READERS[@DISASSOCIATE='TRUE']");
                        while (ElementtoRemove != null)
                        {
                            ElementNode = PlanDoc.DocumentElement.SelectSingleNode("/PLAN");
                            ElementNode.RemoveChild((XmlNode)ElementtoRemove);
                            ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_READERS[@DISASSOCIATE='TRUE']");
                        }
                    }
                }

                xpNav_PlanCreator = xp_PlanNav.SelectSingleNode("PLAN/PLANCREATOR");
                if (xpNav_PlanCreator != null)
                {
                    str_PlanCreator = xpNav_PlanCreator.Value;
                }

                if (Readerflg == 1 || Authorflg == 1)
                {
                    EMail_RO_PageUrl = GetEmailROPageUrl(ref PlanID);
                    Assetlink.Solutions.Facade.UGMFacade.UserFacade UserFacadeObj = new UserFacade(SessionID, UserID, TenantName, CurrentLanguage);
                    UserFacadeObj.GetUser(Convert.ToUInt64(UserID), "", "", out retUserXML);
                    strUserName = GetUserDetails(retUserXML);
                    Message = new StringBuilder();
                    Subject = new StringBuilder();
                    Message.AppendFormat("<MESSAGE Sender='{0}' Creator='{4}'>{1}<LINKCOLLECTION><LINK>{2}<URL>{3}</URL></LINK></LINKCOLLECTION></MESSAGE>", ALSpecialCharHandling.TrimAndReplaceSpecialChars(strUserName), xp_PlanNav.InnerXml, "<NAME>Planner_ROPlanDetails</NAME>", ALCommon.TrimAndReplaceSpecialChars(EMail_RO_PageUrl), ALCommon.TrimAndReplaceSpecialChars(str_PlanCreator));
                    Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", xp_PlanNav.InnerXml);

                    if (NotificationEventType != null)
                    {
                        ObjNotificationFacade = new NotificationFacadeClass(SessionID, UserID, TenantName, SolutionName, SolutionName);
                        ErrorXml = ObjNotificationFacade.SendNotification(PlanDoc.InnerXml, Subject.ToString(), Message.ToString(), NotificationEventType);
                        if (ErrorXml != null)
                        {
                            return ErrorXml;
                        }
                        else
                            return null;
                    }
                }

                return null;
            }

            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }

        }


        public string NotifyRemoveAuthorReader(String PlanDetailsXML, String NotificationType)
        {
            NotificationFacadeClass ObjNotificationFacade = null;
            StringBuilder Message = null;
            StringBuilder Subject = null;
            String retUserXML = null;
            String strUserName = null;
            XPathNavigator PlanTitleNode = null;
            StringReader retPlanXml = null;
            XPathDocument xp_PlanXMLDoc = null;
            XPathNavigator xp_PlanNav = null;
            XPathNodeIterator xp_PlanAuthorNodes = null;
            XPathNodeIterator xp_PlanReaderNodes = null;
            XML ErrorXml = null;
            String NotificationEventType = null;
            int Readerflg = 0;
            int Authorflg = 0;
            XmlDocument PlanDoc = null;
            XmlElement ElementtoRemove = null;
            XmlNode ElementNode = null;
            string Title = null;
            string SolutionName = "StrategicPlanner";

            try
            {
                retPlanXml = new StringReader(PlanDetailsXML);
                xp_PlanXMLDoc = new XPathDocument(retPlanXml);
                xp_PlanNav = xp_PlanXMLDoc.CreateNavigator();

                PlanTitleNode = xp_PlanNav.SelectSingleNode("PLAN/TITLE");
                Title = PlanTitleNode.Value;

                PlanDoc = new XmlDocument();
                PlanDoc.LoadXml(PlanDetailsXML);
                if (NotificationType == "Authors")
                {
                    NotificationEventType = "REMOVE_PLAN_AUTHOR";
                    xp_PlanAuthorNodes = xp_PlanNav.Select("PLAN/PLAN_AUTHORS[(attribute::DISASSOCIATE)]");
                    if (xp_PlanAuthorNodes.Count != 0)
                    {
                        Authorflg = 1;
                        ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_AUTHORS[not(attribute::DISASSOCIATE)]");
                        while (ElementtoRemove != null)
                        {
                            ElementNode = PlanDoc.DocumentElement.SelectSingleNode("/PLAN");
                            ElementNode.RemoveChild((XmlNode)ElementtoRemove);
                            ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_AUTHORS[not(attribute::DISASSOCIATE)]");
                        }
                    }
                }
                if (NotificationType == "Readers")
                {
                    NotificationEventType = "REMOVE_PLAN_READER";
                    xp_PlanReaderNodes = xp_PlanNav.Select("PLAN/PLAN_READERS[(attribute::DISASSOCIATE)]");
                    if (xp_PlanReaderNodes.Count != 0)
                    {
                        Readerflg = 1;
                        ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_READERS[not(attribute::DISASSOCIATE)]");
                        while (ElementtoRemove != null)
                        {
                            ElementNode = PlanDoc.DocumentElement.SelectSingleNode("/PLAN");
                            ElementNode.RemoveChild((XmlNode)ElementtoRemove);
                            ElementtoRemove = (XmlElement)PlanDoc.DocumentElement.SelectSingleNode("/PLAN/PLAN_READERS[not(attribute::DISASSOCIATE)]");
                        }
                    }
                }

                if (Readerflg == 1 || Authorflg == 1)
                {
                    Assetlink.Solutions.Facade.UGMFacade.UserFacade UserFacadeObj = new UserFacade(SessionID, UserID, TenantName, CurrentLanguage);
                    UserFacadeObj.GetUser(Convert.ToUInt64(UserID), "", "", out retUserXML);
                    strUserName = GetUserDetails(retUserXML);

                    Message = new StringBuilder();
                    Subject = new StringBuilder();

                    Message.AppendFormat("<MESSAGE Sender='{0}'>{1}</MESSAGE>", ALSpecialCharHandling.TrimAndReplaceSpecialChars(strUserName), xp_PlanNav.InnerXml);
                    Subject.AppendFormat("<SUBJECT>{0}</SUBJECT>", xp_PlanNav.InnerXml);

                    if (NotificationEventType != null)
                    {
                        ObjNotificationFacade = new NotificationFacadeClass(SessionID, UserID, TenantName, CurrentLanguage, SolutionName);
                        ErrorXml = ObjNotificationFacade.SendNotification(PlanDoc.InnerXml, Subject.ToString(), Message.ToString(), NotificationEventType);

                        if (ErrorXml != null)
                            return ErrorXml;
                        else
                            return null;

                    }
                }

                return null;
            }

            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }


        }

        private String GetEmailROPageUrl(ref string PlanID)
        {
            StringBuilder SolutionPageUrl = null;
            StringBuilder ROEmailPageParams = null;
            StringBuilder DefaultPageParameterList = null;
            StringBuilder DefaultPageUrl = null;
            String DefaultPageMode = "EMAIL";
            String CommunicationProtocol = null;
            String InternetAddress = null;
            String EmailReadOnlyPage = "Planner_ROPlanDetails.aspx";

            CommunicationProtocol = ALCommon.GetCommunicationProtocol();
            InternetAddress = ALCommon.GetInternetAddress();

            SolutionPageUrl = new StringBuilder();
            SolutionPageUrl.AppendFormat("{0}{1}/{2}/{3}/ASPX/{4}", CommunicationProtocol, InternetAddress, TenantName, "StrategicPlanner", EmailReadOnlyPage);

            ROEmailPageParams = new StringBuilder();
            ROEmailPageParams.AppendFormat("PLANID={0}", PlanID);

            DefaultPageParameterList = new StringBuilder();
            DefaultPageParameterList.AppendFormat("Language={0}&Mode={1}&SolutionPage={2}&Param={3}", CurrentLanguage, DefaultPageMode, SolutionPageUrl, ALCommon.Encrypt(ROEmailPageParams.ToString()));

            DefaultPageUrl = new StringBuilder();
            DefaultPageUrl.AppendFormat("{0}{1}/{2}/default.aspx?{3}", CommunicationProtocol, InternetAddress, TenantName, DefaultPageParameterList.ToString());

            DefaultPageUrl = DefaultPageUrl.Replace("&", "%26");
            return DefaultPageUrl.ToString();
        }

        public void NotifiableUsers(string ListofUsers, string ListofGroups, string Role, ref XML NotifyAddUser)
        {
            ERRORXML ErrorXML = null;
            XML OutputXML = null;
            SearchConfiguration SearchConfigurationObj = null;
            StringBuilder sb_SearchBuilder = null;
            String str_EditGroupID = null;
            XPathDocument xpDoc_UserDoc = null;
            XPathDocument xpDoc_GroupDoc = null;
            XPathDocument xpDoc_GroupMembers = null;
            XPathNavigator xpNav_UserNav = null;
            XPathNavigator xpNav_GroupNav = null;
            XPathNavigator xpNav_GroupMemberNav = null;
            XPathNodeIterator xpItr_OldUsersList = null;
            XPathNodeIterator xpItr_NewUsersList = null;
            XPathNodeIterator xpItr_DelUsersList = null;
            XPathNodeIterator xpItr_OldGroupsList = null;
            XPathNodeIterator xpItr_NewGroupsList = null;
            XPathNodeIterator xpItr_DelGroupsList = null;
            XPathNodeIterator xpItr_GroupMembersList = null;
            Dictionary<string, int> uniqueUser = new Dictionary<string, int>();
            StringBuilder sb_NotificationXML = null;
            string str_UserRole = null;

            try
            {

                sb_NotificationXML = new StringBuilder();
                sb_NotificationXML.Append("<PLAN>");
                sb_NotificationXML.Append(PlanNotificationAdditionalInfo(NotifyAddUser));

                if (Role.ToUpper().Equals("READERS"))
                    str_UserRole = "PLAN_READERS";
                else if (Role.ToUpper().Equals("AUTHORS"))
                    str_UserRole = "PLAN_AUTHORS";


                xpDoc_UserDoc = new XPathDocument(new StringReader(ListofUsers));
                xpNav_UserNav = xpDoc_UserDoc.CreateNavigator();
                xpItr_OldUsersList = xpNav_UserNav.Select("//USER[@NEW='FALSE']/USERID");
                xpItr_NewUsersList = xpNav_UserNav.Select("//USER[@NEW='TRUE']/USERID");
                xpItr_DelUsersList = xpNav_UserNav.Select("//USER[@DISASSOCIATE='TRUE']/USERID");

                xpDoc_GroupDoc = new XPathDocument(new StringReader(ListofGroups));
                xpNav_GroupNav = xpDoc_GroupDoc.CreateNavigator();
                xpItr_OldGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='FALSE']/GROUPID");
                xpItr_NewGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='TRUE']/GROUPID");
                xpItr_DelGroupsList = xpNav_GroupNav.Select("//GROUP[@DISASSOCIATE='TRUE']/GROUPID");

                //Add existing users in a unique list
                if (xpItr_OldUsersList.Count > 0)
                {
                    while (xpItr_OldUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_OldUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_OldUsersList.Current.InnerXml, 0);
                        }
                    }
                }

                if (xpItr_OldGroupsList.Count > 0)
                {


                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_OldGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_OldGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }//
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }




                }

                //Add users getting deleted (This case needs to be considered for groups as same user may be present in two groups, one getting added
                //and the other getting removed. Under such a condition the user should not be notified as a new user.)

                if (xpItr_DelGroupsList.Count > 0)
                {


                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_DelGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_DelGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                if (xpItr_DelUsersList.Count > 0)
                {
                    while (xpItr_DelUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_DelUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_DelUsersList.Current.InnerXml, 0);
                        }
                    }
                }


                //Add new notifiable users 

                if (xpItr_NewGroupsList.Count > 0)
                {


                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_NewGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_NewGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }//
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                                sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION'>{1}</{2}>", str_UserRole, xpItr_GroupMembersList.Current.InnerXml, str_UserRole);
                            }
                        }
                    }

                }

                if (xpItr_NewUsersList.Count > 0)
                {
                    while (xpItr_NewUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_NewUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_NewUsersList.Current.InnerXml, 0);
                            sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION'>{1}</{2}>", str_UserRole, xpItr_NewUsersList.Current.InnerXml, str_UserRole);
                        }
                    }
                }

                sb_NotificationXML.AppendFormat(@"</PLAN>");
                NotifyAddUser = sb_NotificationXML.ToString();
            }

            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }

        }

        public void NotifiableUsersRemove(string ListofUsers, string ListofGroups, string Role, ref XML NotifyRemoveUser)
        {
            ERRORXML ErrorXML = null;
            XML OutputXML = null;
            SearchConfiguration SearchConfigurationObj = null;
            StringBuilder sb_SearchBuilder = null;
            String str_EditGroupID = null;
            XPathDocument xpDoc_UserDoc = null;
            XPathDocument xpDoc_GroupDoc = null;
            XPathDocument xpDoc_GroupMembers = null;
            XPathNavigator xpNav_UserNav = null;
            XPathNavigator xpNav_GroupNav = null;
            XPathNavigator xpNav_GroupMemberNav = null;
            XPathNodeIterator xpItr_OldUsersList = null;
            XPathNodeIterator xpItr_NewUsersList = null;
            XPathNodeIterator xpItr_DelUsersList = null;
            XPathNodeIterator xpItr_OldGroupsList = null;
            XPathNodeIterator xpItr_NewGroupsList = null;
            XPathNodeIterator xpItr_DelGroupsList = null;
            XPathNodeIterator xpItr_GroupMembersList = null;
            Dictionary<string, int> uniqueUser = new Dictionary<string, int>();
            StringBuilder sb_NotificationXML = null;
            string str_UserRole = null;

            try
            {
                sb_NotificationXML = new StringBuilder();
                sb_NotificationXML.Append("<PLAN>");
                sb_NotificationXML.Append(PlanNotificationAdditionalInfo(NotifyRemoveUser));
                if (Role.ToUpper().Equals("READERS"))
                    str_UserRole = "PLAN_READERS";
                else if (Role.ToUpper().Equals("AUTHORS"))
                    str_UserRole = "PLAN_AUTHORS";


                xpDoc_UserDoc = new XPathDocument(new StringReader(ListofUsers));
                xpNav_UserNav = xpDoc_UserDoc.CreateNavigator();
                xpItr_OldUsersList = xpNav_UserNav.Select("//USER[@NEW='FALSE']/USERID");
                xpItr_NewUsersList = xpNav_UserNav.Select("//USER[@NEW='TRUE']/USERID");
                xpItr_DelUsersList = xpNav_UserNav.Select("//USER[@DISASSOCIATE='TRUE']/USERID");

                xpDoc_GroupDoc = new XPathDocument(new StringReader(ListofGroups));
                xpNav_GroupNav = xpDoc_GroupDoc.CreateNavigator();
                xpItr_OldGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='FALSE']/GROUPID");
                xpItr_NewGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='TRUE']/GROUPID");
                xpItr_DelGroupsList = xpNav_GroupNav.Select("//GROUP[@DISASSOCIATE='TRUE']/GROUPID");

                //Add existing users in a unique list
                if (xpItr_OldUsersList.Count > 0)
                {
                    while (xpItr_OldUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_OldUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_OldUsersList.Current.InnerXml, 0);
                        }
                    }
                }

                if (xpItr_OldGroupsList.Count > 0)
                {



                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_OldGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_OldGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }




                }

                //Add new notifiable users 

                if (xpItr_NewGroupsList.Count > 0)
                {



                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_NewGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_NewGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                if (xpItr_NewUsersList.Count > 0)
                {
                    while (xpItr_NewUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_NewUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_NewUsersList.Current.InnerXml, 0);
                        }
                    }
                }

                //Add users to be deleted
                if (xpItr_DelGroupsList.Count > 0)
                {



                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_DelGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_DelGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                                sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</{2}>", str_UserRole, xpItr_GroupMembersList.Current.InnerXml, str_UserRole);
                            }
                        }
                    }

                }

                if (xpItr_DelUsersList.Count > 0)
                {
                    while (xpItr_DelUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_DelUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_DelUsersList.Current.InnerXml, 0);
                            sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</{2}>", str_UserRole, xpItr_DelUsersList.Current.InnerXml, str_UserRole);
                        }
                    }
                }



                sb_NotificationXML.AppendFormat(@"</PLAN>");
                NotifyRemoveUser = sb_NotificationXML.ToString();
            }

            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        #region ROPlanDetails related notification functions

        public void NotifiableUsersAddROPlanDetailsUser(string ListofUsers, string ListofGroups, string Role, ref XML NotifyAddUser)
        {
            ERRORXML ErrorXML = null;
            XML OutputXML = null;
            SearchConfiguration SearchConfigurationObj = null;
            StringBuilder sb_SearchBuilder = null;
            String str_EditGroupID = null;
            XPathDocument xpDoc_UserDoc = null;
            XPathDocument xpDoc_GroupDoc = null;
            XPathDocument xpDoc_GroupMembers = null;
            XPathNavigator xpNav_UserNav = null;
            XPathNavigator xpNav_GroupNav = null;
            XPathNavigator xpNav_GroupMemberNav = null;
            XPathNodeIterator xpItr_NewUsersList = null;
            XPathNodeIterator xpItr_OldGroupsList = null;
            XPathNodeIterator xpItr_GroupMembersList = null;
            Dictionary<string, int> uniqueUser = new Dictionary<string, int>();
            StringBuilder sb_NotificationXML = null;
            string str_UserRole = null;

            try
            {
                sb_NotificationXML = new StringBuilder();
                sb_NotificationXML.Append("<PLAN>");
                sb_NotificationXML.Append(PlanNotificationAdditionalInfo(NotifyAddUser));

                if (Role.ToUpper().Equals("READERS"))
                    str_UserRole = "PLAN_READERS";
                else if (Role.ToUpper().Equals("AUTHORS"))
                    str_UserRole = "PLAN_AUTHORS";


                xpDoc_GroupDoc = new XPathDocument(new StringReader(ListofGroups));
                xpNav_GroupNav = xpDoc_GroupDoc.CreateNavigator();
                xpItr_OldGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='FALSE']/GROUPID");

                xpDoc_UserDoc = new XPathDocument(new StringReader(ListofUsers));
                xpNav_UserNav = xpDoc_UserDoc.CreateNavigator();
                xpItr_NewUsersList = xpNav_UserNav.Select("//USER/USERID");

                if (xpItr_OldGroupsList.Count > 0)
                {


                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_OldGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_OldGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }//
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                if (xpItr_NewUsersList.Count > 0)
                {
                    while (xpItr_NewUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_NewUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_NewUsersList.Current.InnerXml, 0);
                            sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION'>{1}</{2}>", str_UserRole, xpItr_NewUsersList.Current.InnerXml, str_UserRole);
                        }
                    }
                }
                sb_NotificationXML.AppendFormat(@"</PLAN>");
                NotifyAddUser = sb_NotificationXML.ToString();
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }

        }

        public void NotifiableUsersAddROPlanDetailsGroup(string ListofUsers, string ListofGroups, string Role, ref XML NotifyAddUser)
        {
            ERRORXML ErrorXML = null;
            XML OutputXML = null;
            SearchConfiguration SearchConfigurationObj = null;
            StringBuilder sb_SearchBuilder = null;
            String str_EditGroupID = null;
            XPathDocument xpDoc_UserDoc = null;
            XPathDocument xpDoc_GroupDoc = null;
            XPathDocument xpDoc_GroupMembers = null;
            XPathNavigator xpNav_UserNav = null;
            XPathNavigator xpNav_GroupNav = null;
            XPathNavigator xpNav_GroupMemberNav = null;
            XPathNodeIterator xpItr_OldUsersList = null;
            XPathNodeIterator xpItr_OldGroupsList = null;
            XPathNodeIterator xpItr_NewGroupsList = null;
            XPathNodeIterator xpItr_DelGroupsList = null;
            XPathNodeIterator xpItr_GroupMembersList = null;
            Dictionary<string, int> uniqueUser = new Dictionary<string, int>();
            StringBuilder sb_NotificationXML = null;
            string str_UserRole = null;

            try
            {
                sb_NotificationXML = new StringBuilder();
                sb_NotificationXML.Append("<PLAN>");
                sb_NotificationXML.Append(PlanNotificationAdditionalInfo(NotifyAddUser));
                if (Role.ToUpper().Equals("READERS"))
                    str_UserRole = "PLAN_READERS";
                else if (Role.ToUpper().Equals("AUTHORS"))
                    str_UserRole = "PLAN_AUTHORS";

                xpDoc_GroupDoc = new XPathDocument(new StringReader(ListofGroups));
                xpNav_GroupNav = xpDoc_GroupDoc.CreateNavigator();
                xpItr_OldGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='FALSE']/GROUPID");
                xpItr_NewGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='TRUE']/GROUPID");
                xpItr_DelGroupsList = xpNav_GroupNav.Select("//GROUP[@DISASSOCIATE='TRUE']/GROUPID");

                xpDoc_UserDoc = new XPathDocument(new StringReader(ListofUsers));
                xpNav_UserNav = xpDoc_UserDoc.CreateNavigator();
                xpItr_OldUsersList = xpNav_UserNav.Select("//USER/USERID");

                //Add existing users in a unique list
                if (xpItr_OldUsersList.Count > 0)
                {
                    while (xpItr_OldUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_OldUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_OldUsersList.Current.InnerXml, 0);
                        }
                    }
                }

                if (xpItr_OldGroupsList.Count > 0)
                {


                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_OldGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_OldGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }//
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                //Add users getting deleted (This case needs to be considered for groups as same user may be present in two groups, one getting added
                //and the other getting removed. Under such a condition the user should not be notified as a new user.)

                if (xpItr_DelGroupsList.Count > 0)
                {


                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_DelGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_DelGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                if (xpItr_NewGroupsList.Count > 0)
                {
                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_NewGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_NewGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }//
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                                sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION'>{1}</{2}>", str_UserRole, xpItr_GroupMembersList.Current.InnerXml, str_UserRole);
                            }
                        }
                    }

                }

                sb_NotificationXML.AppendFormat(@"</PLAN>");
                NotifyAddUser = sb_NotificationXML.ToString();


            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        public void NotifiableUsersRemoveROPlanDetailsUser(string ListofUsers, string ListofGroups, string Role, ref XML NotifyRemoveUser)
        {
            ERRORXML ErrorXML = null;
            XML OutputXML = null;
            SearchConfiguration SearchConfigurationObj = null;
            StringBuilder sb_SearchBuilder = null;
            String str_EditGroupID = null;
            XPathDocument xpDoc_UserDoc = null;
            XPathDocument xpDoc_GroupDoc = null;
            XPathDocument xpDoc_GroupMembers = null;
            XPathNavigator xpNav_UserNav = null;
            XPathNavigator xpNav_GroupNav = null;
            XPathNavigator xpNav_GroupMemberNav = null;
            XPathNodeIterator xpItr_DelUsersList = null;
            XPathNodeIterator xpItr_OldGroupsList = null;
            XPathNodeIterator xpItr_GroupMembersList = null;
            Dictionary<string, int> uniqueUser = new Dictionary<string, int>();
            StringBuilder sb_NotificationXML = null;
            string str_UserRole = null;

            try
            {
                sb_NotificationXML = new StringBuilder();
                sb_NotificationXML.Append("<PLAN>");
                sb_NotificationXML.Append(PlanNotificationAdditionalInfo(NotifyRemoveUser));

                if (Role.ToUpper().Equals("READERS"))
                    str_UserRole = "PLAN_READERS";
                else if (Role.ToUpper().Equals("AUTHORS"))
                    str_UserRole = "PLAN_AUTHORS";

                xpDoc_GroupDoc = new XPathDocument(new StringReader(ListofGroups));
                xpNav_GroupNav = xpDoc_GroupDoc.CreateNavigator();
                xpItr_OldGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='FALSE']/GROUPID");

                xpDoc_UserDoc = new XPathDocument(new StringReader(ListofUsers));
                xpNav_UserNav = xpDoc_UserDoc.CreateNavigator();
                xpItr_DelUsersList = xpNav_UserNav.Select("//" + str_UserRole);

                if (xpItr_OldGroupsList.Count > 0)
                {
                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_OldGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_OldGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                if (xpItr_DelUsersList.Count > 0)
                {
                    while (xpItr_DelUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_DelUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_DelUsersList.Current.InnerXml, 0);
                            sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</{2}>", str_UserRole, xpItr_DelUsersList.Current.InnerXml, str_UserRole);
                        }
                    }
                }

                sb_NotificationXML.AppendFormat(@"</PLAN>");
                NotifyRemoveUser = sb_NotificationXML.ToString();


            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        public void NotifiableUsersRemoveROPlanDetailsGroup(string ListofUsers, string ListofGroups, string Role, ref XML NotifyRemoveUser)
        {
            ERRORXML ErrorXML = null;
            XML OutputXML = null;
            SearchConfiguration SearchConfigurationObj = null;
            StringBuilder sb_SearchBuilder = null;
            String str_EditGroupID = null;
            XPathDocument xpDoc_UserDoc = null;
            XPathDocument xpDoc_GroupDoc = null;
            XPathDocument xpDoc_GroupMembers = null;
            XPathNavigator xpNav_UserNav = null;
            XPathNavigator xpNav_GroupNav = null;
            XPathNavigator xpNav_GroupMemberNav = null;
            XPathNodeIterator xpItr_OldUsersList = null;
            XPathNodeIterator xpItr_OldGroupsList = null;
            XPathNodeIterator xpItr_NewGroupsList = null;
            XPathNodeIterator xpItr_DelGroupsList = null;
            XPathNodeIterator xpItr_GroupMembersList = null;
            Dictionary<string, int> uniqueUser = new Dictionary<string, int>();
            StringBuilder sb_NotificationXML = null;
            string str_UserRole = null;

            try
            {
                sb_NotificationXML = new StringBuilder();
                sb_NotificationXML.Append("<PLAN>");
                sb_NotificationXML.Append(PlanNotificationAdditionalInfo(NotifyRemoveUser));
                
                if (Role.ToUpper().Equals("READERS"))
                    str_UserRole = "PLAN_READERS";
                else if (Role.ToUpper().Equals("AUTHORS"))
                    str_UserRole = "PLAN_AUTHORS";

                xpDoc_GroupDoc = new XPathDocument(new StringReader(ListofGroups));
                xpNav_GroupNav = xpDoc_GroupDoc.CreateNavigator();
                xpItr_OldGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='FALSE']/GROUPID");
                xpItr_NewGroupsList = xpNav_GroupNav.Select("//GROUP[@NEW='TRUE']/GROUPID");
                xpItr_DelGroupsList = xpNav_GroupNav.Select("//GROUP[@DISASSOCIATE='TRUE']/GROUPID");

                xpDoc_UserDoc = new XPathDocument(new StringReader(ListofUsers));
                xpNav_UserNav = xpDoc_UserDoc.CreateNavigator();
                xpItr_OldUsersList = xpNav_UserNav.Select("//USER/USERID");

                //Add existing users in a unique list
                if (xpItr_OldUsersList.Count > 0)
                {
                    while (xpItr_OldUsersList.MoveNext())
                    {
                        if (!uniqueUser.ContainsKey(xpItr_OldUsersList.Current.InnerXml))
                        {
                            uniqueUser.Add(xpItr_OldUsersList.Current.InnerXml, 0);
                        }
                    }
                }

                if (xpItr_OldGroupsList.Count > 0)
                {
                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_OldGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_OldGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                //Add new notifiable users 

                if (xpItr_NewGroupsList.Count > 0)
                {
                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_NewGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_NewGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                            }
                        }
                    }

                }

                //Add users to be deleted
                if (xpItr_DelGroupsList.Count > 0)
                {



                    sb_SearchBuilder = new StringBuilder();
                    sb_SearchBuilder.Append("<INPUTXML>");
                    sb_SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, CurrentLanguage, UserID, SessionID);
                    sb_SearchBuilder.Append("<SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("<SEARCH>");
                    sb_SearchBuilder.Append("<TARGETOBJECT>GROUP</TARGETOBJECT><TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>");
                    sb_SearchBuilder.Append("<FILTERLIST>");
                    while (xpItr_DelGroupsList.MoveNext())
                    {
                        str_EditGroupID = xpItr_DelGroupsList.Current.InnerXml;
                        sb_SearchBuilder.AppendFormat("<FILTER><FIELDNAME>GROUPID</FIELDNAME><OPERATOR>EQUALTO</OPERATOR><FIELDVALUE>{0}</FIELDVALUE><ISCASESENSITIVE>False</ISCASESENSITIVE><NAVIGATIONPATH>GROUP</NAVIGATIONPATH></FILTER>", str_EditGroupID);
                    }
                    sb_SearchBuilder.Append("</FILTERLIST>");
                    sb_SearchBuilder.Append("<FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("<RELATEDENTITYFIELDS NavigationPath='GROUP.GROUP_MEMBERUSER'/>");
                    sb_SearchBuilder.Append("</FIELDCOLLECTION>");
                    sb_SearchBuilder.Append("</SEARCH>");
                    sb_SearchBuilder.Append("</SEARCHCOLLECTION>");
                    sb_SearchBuilder.Append("</INPUTXML>");

                    SearchConfigurationObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

                    ErrorXML = SearchConfigurationObj.DoSearch(sb_SearchBuilder.ToString(), ref OutputXML);

                    xpDoc_GroupMembers = new XPathDocument(new StringReader(OutputXML));
                    xpNav_GroupMemberNav = xpDoc_GroupMembers.CreateNavigator();
                    xpItr_GroupMembersList = xpNav_GroupMemberNav.Select("SEARCHOUTPUTXML/GROUPCOLLECTION/GROUP/GROUP_MEMBERUSER/USER/USERID");

                    if (xpItr_GroupMembersList.Count > 0)
                    {
                        while (xpItr_GroupMembersList.MoveNext())
                        {
                            if (!uniqueUser.ContainsKey(xpItr_GroupMembersList.Current.InnerXml))
                            {
                                uniqueUser.Add(xpItr_GroupMembersList.Current.InnerXml, 0);
                                sb_NotificationXML.AppendFormat("<{0} TYPE='RELATION' DISASSOCIATE='TRUE'>{1}</{2}>", str_UserRole, xpItr_GroupMembersList.Current.InnerXml, str_UserRole);
                            }
                        }
                    }

                }

                sb_NotificationXML.AppendFormat(@"</PLAN>");
                NotifyRemoveUser = sb_NotificationXML.ToString();

            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        #endregion

        #endregion

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Date>12 Mar 2009</Date>
        /// <Purpose>This method is used to call FormatDateTimeField() method of Formats Class.</Purpose>
        /// </summary>
        /// <param name="str_Value">Date time string</param>
        /// <returns>Formatted date time</returns>
        public String CallMethod_FormatDateTimeField(String str_Value)
        {
            Formats         obj_Formats             = null;
            CultureInfo     obj_CultureInfo         = null;
            String          str_CultureInfo         = null;
            String          str_FormattedDateTime   = null;

            obj_Formats     = new Formats(ALCommon.GetFormatDetails(TenantName, out str_CultureInfo));
            obj_CultureInfo = new CultureInfo(str_CultureInfo);
            str_FormattedDateTime = obj_Formats.FormatDateTimeField(str_Value, obj_CultureInfo);
            return str_FormattedDateTime;
        }
		
        #region Functions related to Actuals Settings
        
        /// <summary>
        /// <Author>Tina C. Jawale</Author>
        /// <Date>3 April 2009</Date>
        /// This method will return the settings for Actuals from Strategic Planner Solution Configuration xml
        /// </summary>
        /// <param name="str_AllowImportActualsForUnbudgetedPlans"></param>
        /// <returns></returns>
        public ERRORXML GetActualsSettings(ref Boolean bool_AllowImportActualsForUnbudgetedPlans)
        {
            String          str_Value                   = null;
            String          str_SolutionConfigXMLPath   = null;
            XPathDocument   xpDoc_SolutionConfigXML     = null;
            ERRORXML        ErrorXML                    = null;

            try
            {
                str_SolutionConfigXMLPath   = ALCommon.GetSolutionConfigurationXMLPath(TenantName, "StrategicPlanner", "SolutionConfiguration");
                xpDoc_SolutionConfigXML     = new XPathDocument(str_SolutionConfigXMLPath);

                str_Value = xpDoc_SolutionConfigXML.CreateNavigator().SelectSingleNode("SolutionConfiguration/ESTIMATECONFIGURATION/ALLOWIMPORTACTUALSFORUNBUDGETEDPLANS").Value;
                if (String.Compare(str_Value, "Yes", true) == 0)
                    bool_AllowImportActualsForUnbudgetedPlans = true;
                else
                    bool_AllowImportActualsForUnbudgetedPlans = false;

            }
            catch(Exception excepObj)
            {
                //throw excepObj;
                ErrorXML = ALSolutionCommon.PrepareErrorXML(excepObj.Message);
            }
            return ErrorXML;
        }

        #endregion

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Date>07 Apr 2009</Date>
        /// <Purpose>Method to create user name from User ID.</Purpose>
        /// </summary>
        /// <param name="str_UserID">User ID</param>
        /// <returns>User Name</returns>
        public String GetUserName_FromUserID(String str_UserID)
        {
            StringBuilder           sb_SearchXML        = null;
            SearchConfiguration     SearchConfigObj     = null;
            String                  str_UserXML         = null;
            String                  str_ErrorXML        = null;
            String                  str_UserName        = null;

            sb_SearchXML            = new StringBuilder(100);
            sb_SearchXML.AppendFormat(@"<SEARCH>
                                            <TARGETOBJECT>USER</TARGETOBJECT>
                                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                            <TARGETENTITY>
                                               <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                 <FILTERLIST>			                                            
                                                    <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                        <EXPRESSION>USERID</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>
                                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                                    </FILTER>
                                                </FILTERLIST> 
                                                <SELECTLIST>
                                                    <EXPRESSION>
                                                        <FIELDNAME>USERID</FIELDNAME>
                                                        <ALIAS>USERID</ALIAS>
                                                    </EXPRESSION>	
                                                    <EXPRESSION>
                                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                        <ALIAS>FIRSTNAME</ALIAS>
                                                    </EXPRESSION>	
                                                    <EXPRESSION>
                                                        <FIELDNAME>LASTNAME</FIELDNAME>
                                                        <ALIAS>LASTNAME</ALIAS>
                                                    </EXPRESSION>	
                                                    <EXPRESSION>
                                                        <FIELDNAME>LOGINNAME</FIELDNAME>
                                                        <ALIAS>LOGINNAME</ALIAS>
                                                    </EXPRESSION>	
                                                </SELECTLIST>
                                            </TARGETENTITY>
                                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_UserID);

            SearchConfigObj     = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
            str_ErrorXML        = SearchConfigObj.GetHierarchialData(sb_SearchXML.ToString(), ref str_UserXML);

            if (str_ErrorXML == null)
            {
                str_UserName    = GetUserDetails(str_UserXML);
            }

            return str_UserName;
        }

        /// <summary>
        /// <Purpose>Method to sort List Control source xml depending on Column name.</Purpose>
        /// </summary>
        /// <param name="ResultXML">Source xml to be assigned to List Control</param>
        /// <param name="ColumnNameToSort">Column name to sort</param>
        public void List_Sort(ref String ResultXML, String ColumnNameToSort)
        {
            #region Member Variables
            XmlDocument     xmlDoc_SortResultXML    = null;
            XmlDocument     xmlDoc_SortedResultXML  = null;
            XmlNodeList     xmlNodeList_SortedRows  = null;
            StringBuilder   sb_SortedResultXML      = null;
            String          str_sortedResultXML     = null;
            int             int_Order               = 0;
            #endregion

            try
            {
                xmlDoc_SortResultXML        = new XmlDocument();
                xmlDoc_SortResultXML.LoadXml(ResultXML);
                if (xmlDoc_SortResultXML.SelectNodes("List/Data/Group/Row").Count > 0)
                {
                    ALSolutionCommon.SortHierarchicalXml(xmlDoc_SortResultXML.CreateNavigator(), "List/Data/Group/Row", "Column[@Name=\"" + ColumnNameToSort + "\"]", "TEXT", "ASCENDING", out str_sortedResultXML);

                    xmlDoc_SortedResultXML  = new XmlDocument();
                    xmlDoc_SortedResultXML.LoadXml(str_sortedResultXML);
                    xmlNodeList_SortedRows  = xmlDoc_SortedResultXML.SelectNodes("SORTCOLLECTION/Row");

                    sb_SortedResultXML      = new StringBuilder(2000);
                    foreach (XmlNode xmlNode_temp in xmlNodeList_SortedRows)
                    {
                        int_Order++;
                        ((XmlElement)xmlNode_temp).SetAttribute("Order", int_Order.ToString());
                        sb_SortedResultXML.Append(xmlNode_temp.OuterXml);
                    }
                    xmlDoc_SortResultXML.SelectSingleNode("List/Data/Group").InnerXml = sb_SortedResultXML.ToString();
                    ResultXML               = xmlDoc_SortResultXML.OuterXml;
                }
            }
            catch
            {
            }
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Updates nodes of temporary NTFS xml using an output xml of GetHierarchialData().</Purpose>
        /// </summary>
        /// <param name="str_OutputXML">Output Xml used for updation</param>
        /// <param name="str_FieldsXpath">Array of Xpaths.
        /// Xpath Format is <ENTITYNAME>COLLECTION/<ENTITYNAME>/RELATIONSHIPNAME/....
        /// </param>
        /// <param name="str_NTFSFilePath">NTFS file to be updated</param>
        /// <param name="str_EntityName">Entity Name</param>
        public void UpdateNodes_OfTempXML_Using_OutputXml(String str_OutputXML, String[] str_FieldsXpath, String str_NTFSFilePath, String str_EntityName)
        {
            XPathDocument   xpDoc_Entity            = null;
            XPathNavigator  xpNav_Entity            = null;
            XPathNavigator  xpNav_Field             = null;
            XmlDocument     xmlDoc_Entity           = null;
            XmlNode         xmlNode_Field           = null;
            XmlNode         xmlNode_FieldParent     = null;
            String[]        strSep                  = {"/"};

            if (File.Exists(str_NTFSFilePath) && str_FieldsXpath != null)
            {
                xmlDoc_Entity           = new XmlDocument();
                xmlDoc_Entity.Load(str_NTFSFilePath);

                xpDoc_Entity            = new XPathDocument(new StringReader(str_OutputXML));
                xpNav_Entity            = xpDoc_Entity.CreateNavigator();

                foreach (String str_FieldXpath in str_FieldsXpath)
                {
                    if (!String.IsNullOrEmpty(str_FieldXpath))
                    {
                        xpNav_Field     = xpNav_Entity.SelectSingleNode(str_FieldXpath);
                        xmlNode_Field   = xmlDoc_Entity.SelectSingleNode(str_FieldXpath);

                        if(xpNav_Field != null && xmlNode_Field != null)
                        {
                            xmlNode_Field.InnerXml = xpNav_Field.InnerXml;
                        }
                        else if(xpNav_Field == null && xmlNode_Field != null)
                        {
                            xmlNode_FieldParent = xmlNode_Field.ParentNode;
                            xmlNode_FieldParent.RemoveChild(xmlNode_Field);
                        }
                        else if(xpNav_Field != null && xmlNode_Field == null)
                        {
                            UpdateNodes(str_FieldXpath, xmlDoc_Entity, xpNav_Entity, str_EntityName);
                        }
                    }
                }

                xmlDoc_Entity.Save(str_NTFSFilePath);
            }
        }

        /// <summary>
        /// <Author>Parita Harniya</Author>
        /// <Purpose>Method to update the temp xml in case of xpath not found in temp xml.
        /// This method is called by method UpdateNodes_OfTempXML_Using_OutputXml</Purpose>
        /// </summary>
        /// <param name="str_XpathNTFS">Xpath for temp xml</param>
        /// <param name="xmlDoc_Entity">Document for NTFS xml</param>
        /// <param name="xpNav_Entity">Document for entity xml</param>
        /// <param name="str_EntityName">Entity Name</param>
        private void UpdateNodes(string str_XpathNTFS, XmlDocument xmlDoc_Entity, XPathNavigator xpNav_Entity, String str_EntityName)
        {
            XPathNavigator  xpNav_Field             = null;
            XmlNode         xmlNode_Field           = null;
            String          str_XpathOutput         = null;

            while (true)
            {
                str_XpathOutput     = str_XpathNTFS;
                if (str_XpathNTFS.Substring(str_XpathNTFS.LastIndexOf("/") + 1).Equals(str_EntityName))
                {
                    break;
                }

                str_XpathNTFS       = str_XpathNTFS.Substring(0, str_XpathNTFS.LastIndexOf("/"));

                xmlNode_Field       = xmlDoc_Entity.SelectSingleNode(str_XpathNTFS);
                xpNav_Field         = xpNav_Entity.SelectSingleNode(str_XpathOutput);

                if (xmlNode_Field != null && xpNav_Field != null)
                {
                    xmlNode_Field.InnerXml += xpNav_Field.OuterXml;
                    break;
                }
            }
        }

       /// <summary>
       /// This API is used to fetch Items[CostCenter or CostCategory] according to the settings. This API will fetch the neceesary item and 
       /// prepare filterlist which will be used to populate the predefined search filters.
       /// <createdon>3 June 2009</createdon>
       /// <createdby>Varun Dighe</createdby>
       /// </summary>
       /// <param name="str_SearchItem">Specifies the Item [Costcenter or cost category]</param>
       /// <returns></returns>
       public StringBuilder FetchUserAssociatedItems(String str_SearchItem, bool b_BUUniverseRequired, String str_FilterXML, String str_SolutionConfigPath)
       {
           #region Member Variables
           SearchConfiguration      SearchObj                   = null;
           StringBuilder            SearchInputXML              = null;
           String                   SearchOutputXML             = null;
           String                   ErrorXML                    = null;
           ArrayList                Itemlist                    = null;
           bool                     b_Addflag                   = false;
           XPathDocument            xpDoc_BU_Item               = null;
           XPathNavigator           xpNav_BU_Item               = null;
           XPathNodeIterator        xpNodeItr_BU_Item           = null;
           StringBuilder            sb_FilterListXML            = null;
           StringBuilder            sb_VendorListXML            = null;
           StringBuilder            sb_BusinessUnitListXML      = null;
           bool                     CompleteAccessReq           = false;
           bool                     CompleteAccess              = false;
           
           #endregion
           try
           {
               SearchInputXML   = new StringBuilder(100);
               SearchObj        = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);

               #region Prepare Search Input XML
               CheckForCompleteAccess(str_SolutionConfigPath, UserID, ref CompleteAccessReq, ref CompleteAccess);
               if ((CompleteAccessReq) && (CompleteAccess))
               {
                   b_BUUniverseRequired = false;
               }
               if (b_BUUniverseRequired)
               {
                   #region For BUUniverse Required
                   SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <TARGETOBJECT>USER</TARGETOBJECT>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                                    <TARGETENTITY>
                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                            <SELECTLIST>
                                                                <EXPRESSION>
				                                                    <FIELDNAME>USERID</FIELDNAME>
				                                                    <ALIAS>USERID</ALIAS>
			                                                    </EXPRESSION>
                                                            </SELECTLIST>
                                                            <FILTERLIST>
                                                                <FILTER>
                                                                    <FILTERID>1</FILTERID>
                                                                    <EXPRESSION>USERID</EXPRESSION>
                                                                    <OPERATOR>EQUALTO</OPERATOR>
                                                                    <EXPRESSIONVALUE>{2}</EXPRESSIONVALUE>
                                                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                                </FILTER>
                                                            </FILTERLIST>
                                                            <RELATIONSHIP NAME='BUUNIVERSE_USER'>", CurrentLanguage, TenantName, UserID, SessionID);
                                                            if (str_SearchItem.Equals("BUUNIVERSE"))
                                                            {
                                                                SearchInputXML.AppendFormat(@"<SELECTLIST>
			                                                       <EXPRESSION>
                                                                		<FIELDNAME>USERID</FIELDNAME>
                                                                		<ALIAS>USERID</ALIAS>
                                                                    </EXPRESSION>
                                                                </SELECTLIST>");
                                                            }
                                                            else if (str_SearchItem.Equals("BUSINESSUNIT"))
                                                            {
                                                                SearchInputXML.AppendFormat(@"<SELECTLIST>
			                                                        <EXPRESSION>
				                                                        <FIELDNAME>BUSINESSUNITID</FIELDNAME>
				                                                        <ALIAS>BUSINESSUNITID</ALIAS>
			                                                        </EXPRESSION>			                                            
		                                                        </SELECTLIST>");
                                                            }

                                                               if (str_SearchItem.Equals("COSTCENTER"))
                                                               {
                                                                   SearchInputXML.Append(@"<RELATIONSHIP NAME='BUSINESSUNIT_COSTCENTERS'>
                                                                                                                <SELECTLIST>
			                                                                                                        <EXPRESSION>
				                                                                                                        <FIELDNAME>COSTCENTERSID</FIELDNAME>
				                                                                                                        <ALIAS>COSTCENTERSID</ALIAS>
			                                                                                                        </EXPRESSION>
                                                                                                                    <EXPRESSION>
				                                                                                                        <FIELDNAME>NAME</FIELDNAME>
				                                                                                                        <ALIAS>NAME</ALIAS>
			                                                                                                        </EXPRESSION>		                                            
		                                                                                                        </SELECTLIST>
                                                                                                                <SORTLIST>
                                                                                                                    <SORTEXPRESSION>
                                                                                                                        <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                                                                        <SORTORDER>ASC</SORTORDER>
                                                                                                                        <COLUMNNAME>NAME</COLUMNNAME>
                                                                                                                    </SORTEXPRESSION>
                                                                                                                </SORTLIST> 
                                                                                                            </RELATIONSHIP>");
                                                               }
                                                               if (str_SearchItem.Equals("COSTCATEGORY"))
                                                               {
                                                                   SearchInputXML.Append(@"<RELATIONSHIP NAME='BUSINESSUNIT_COSTCATEGORY'>
                                                                                                        <SELECTLIST>
			                                                                                                <EXPRESSION>
				                                                                                                <FIELDNAME>COSTCATEGORYID</FIELDNAME>
				                                                                                                <ALIAS>COSTCATEGORYID</ALIAS>
			                                                                                                </EXPRESSION>
                                                                                                            <EXPRESSION>
				                                                                                                <FIELDNAME>NAME</FIELDNAME>
				                                                                                                <ALIAS>NAME</ALIAS>
			                                                                                                </EXPRESSION>		                                            
		                                                                                                </SELECTLIST>
                                                                                                        <SORTLIST>
                                                                                                            <SORTEXPRESSION>
                                                                                                                <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                                                                <SORTORDER>ASC</SORTORDER>
                                                                                                                <COLUMNNAME>NAME</COLUMNNAME>
                                                                                                            </SORTEXPRESSION>
                                                                                                        </SORTLIST> 
                                                                                                    </RELATIONSHIP>");
                                                               }
                                                               if (str_SearchItem.Equals("VENDORS"))
                                                               {
                                                                   SearchInputXML.AppendFormat(@"<RELATIONSHIP NAME='BUSINESSUNIT_VENDORS'>
                                                                                                      <SELECTLIST>
                                                                                                        <EXPRESSION>
                                                                                                           <FIELDNAME>NAME</FIELDNAME>
                                                                                                           <ALIAS>NAME</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                        <EXPRESSION>
                                                                                                            <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                                                                            <ALIAS>DESCRIPTION</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                        <EXPRESSION>
                                                                                                            <FIELDNAME>VENDORTYPE</FIELDNAME>
                                                                                                            <ALIAS>VENDORTYPE</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                        <EXPRESSION>
                                                                                                            <FIELDNAME>ISOBSOLETE</FIELDNAME>
                                                                                                            <ALIAS>ISOBSOLETE</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                      </SELECTLIST>
                                                                                                      <SORTLIST>
                                                                                                        <SORTEXPRESSION>
                                                                                                            <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                                                            <SORTORDER>ASC</SORTORDER>
                                                                                                            <COLUMNNAME>NAME</COLUMNNAME>
                                                                                                         </SORTEXPRESSION>
                                                                                                       </SORTLIST>
                                                                                                       <FILTERLIST>{0}</FILTERLIST>
                                                                                                   </RELATIONSHIP>", str_FilterXML);
                                                               }
                                 SearchInputXML.Append(@"</RELATIONSHIP>
                                                    <RELATIONSHIP NAME='GROUP_MEMBERUSER'>
                                                        <FILTERLIST>
                                                            <FILTER>
                                                                <FILTERID>1</FILTERID>
                                                                <EXPRESSION>ISDELETED</EXPRESSION>
                                                                <OPERATOR>EQUALTO</OPERATOR>
                                                                <EXPRESSIONVALUE>0</EXPRESSIONVALUE>
                                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                            </FILTER>
                                                        </FILTERLIST>
                                                        <RELATIONSHIP NAME='BUUNIVERSE_GROUP'>");
                                                        if (str_SearchItem.Equals("BUUNIVERSE"))
                                                            {
                                                                SearchInputXML.AppendFormat(@"<SELECTLIST>
                                                                			                   <EXPRESSION>
                                                                		<FIELDNAME>GROUPID</FIELDNAME>
                                                                		<ALIAS>GROUPID</ALIAS>
                                                                    </EXPRESSION>    				                                            
                                                                		                       </SELECTLIST>");
                                                            }
                                                            else if (str_SearchItem.Equals("BUSINESSUNIT"))
                                                            {
                                                                SearchInputXML.Append(@"<SELECTLIST>
			                                                                                <EXPRESSION>
                                                                                                <FIELDNAME>BUSINESSUNITID</FIELDNAME>
				                                                                                <ALIAS>BUSINESSUNITID</ALIAS>
			                                                                                </EXPRESSION>			                                            
		                                                                                 </SELECTLIST>");
                                                            }

                                 if (str_SearchItem.Equals("COSTCENTER"))
                                 {
                                     SearchInputXML.Append(@"<RELATIONSHIP NAME='BUSINESSUNIT_COSTCENTERS'>
                                                                                                                <SELECTLIST>
			                                                                                                        <EXPRESSION>
				                                                                                                        <FIELDNAME>COSTCENTERSID</FIELDNAME>
				                                                                                                        <ALIAS>COSTCENTERSID</ALIAS>
			                                                                                                        </EXPRESSION>
                                                                                                                    <EXPRESSION>
				                                                                                                        <FIELDNAME>NAME</FIELDNAME>
				                                                                                                        <ALIAS>NAME</ALIAS>
			                                                                                                        </EXPRESSION>		                                            
		                                                                                                        </SELECTLIST>
                                                                                                                <SORTLIST>
                                                                                                                    <SORTEXPRESSION>
                                                                                                                        <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                                                                        <SORTORDER>ASC</SORTORDER>
                                                                                                                        <COLUMNNAME>NAME</COLUMNNAME>
                                                                                                                    </SORTEXPRESSION>
                                                                                                                </SORTLIST> 
                                                                                                            </RELATIONSHIP>");
                                 }
                                 if (str_SearchItem.Equals("COSTCATEGORY"))
                                 {
                                     SearchInputXML.Append(@"<RELATIONSHIP NAME='BUSINESSUNIT_COSTCATEGORY'>
                                                                                                        <SELECTLIST>
			                                                                                                <EXPRESSION>
				                                                                                                <FIELDNAME>COSTCATEGORYID</FIELDNAME>
				                                                                                                <ALIAS>COSTCATEGORYID</ALIAS>
			                                                                                                </EXPRESSION>
                                                                                                            <EXPRESSION>
				                                                                                                <FIELDNAME>NAME</FIELDNAME>
				                                                                                                <ALIAS>NAME</ALIAS>
			                                                                                                </EXPRESSION>		                                            
		                                                                                                </SELECTLIST> 
                                                                                                         <SORTLIST>
                                                                                                            <SORTEXPRESSION>
                                                                                                                <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                                                                <SORTORDER>ASC</SORTORDER>
                                                                                                                <COLUMNNAME>NAME</COLUMNNAME>
                                                                                                            </SORTEXPRESSION>
                                                                                                        </SORTLIST>
                                                                                                    </RELATIONSHIP>");
                                 }
                                 if (str_SearchItem.Equals("VENDORS"))
                                 {
                                     SearchInputXML.AppendFormat(@"<RELATIONSHIP NAME='BUSINESSUNIT_VENDORS'>
                                                                                                    <SELECTLIST>
                                                                                                        <EXPRESSION>
                                                                                                           <FIELDNAME>NAME</FIELDNAME>
                                                                                                           <ALIAS>NAME</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                        <EXPRESSION>
                                                                                                            <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                                                                            <ALIAS>DESCRIPTION</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                        <EXPRESSION>
                                                                                                            <FIELDNAME>VENDORTYPE</FIELDNAME>
                                                                                                            <ALIAS>VENDORTYPE</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                        <EXPRESSION>
                                                                                                            <FIELDNAME>ISOBSOLETE</FIELDNAME>
                                                                                                            <ALIAS>ISOBSOLETE</ALIAS>
                                                                                                        </EXPRESSION>
                                                                                                    </SELECTLIST>
                                                                                                    <SORTLIST>
                                                                                                        <SORTEXPRESSION>
                                                                                                            <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                                                            <SORTORDER>ASC</SORTORDER>
                                                                                                            <COLUMNNAME>NAME</COLUMNNAME>
                                                                                                         </SORTEXPRESSION>
                                                                                                     </SORTLIST>
                                                                                                    <FILTERLIST>{0}</FILTERLIST>
                                                                                                  </RELATIONSHIP>", str_FilterXML);
                                 }   
                                 SearchInputXML.Append(@"</RELATIONSHIP>
                                                    </RELATIONSHIP>
                                                </TARGETENTITY>
                                            </SEARCH>");
                   #endregion
               }
               else if (str_SearchItem.Equals("COSTCENTER"))
               {
                   #region CostCenter
                   SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <TARGETOBJECT>COSTCENTERS</TARGETOBJECT>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                                    <TARGETENTITY>
                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
				                                                <FIELDNAME>COSTCENTERSID</FIELDNAME>
				                                                <ALIAS>COSTCENTERSID</ALIAS>
			                                                </EXPRESSION>
                                                            <EXPRESSION>
				                                                <FIELDNAME>NAME</FIELDNAME>
				                                                <ALIAS>NAME</ALIAS>
			                                                </EXPRESSION>
                                                        </SELECTLIST>
                                                     </TARGETENTITY>
                                                  </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID);
                   #endregion
               }
               else if (str_SearchItem.Equals("COSTCATEGORY"))
               {
                   #region CostCategory
                   SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <TARGETOBJECT>COSTCATEGORY</TARGETOBJECT>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                                    <TARGETENTITY>
                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                        <SELECTLIST>
                                                            <EXPRESSION>
				                                                <FIELDNAME>COSTCATEGORYID</FIELDNAME>
				                                                <ALIAS>COSTCATEGORYID</ALIAS>
			                                                </EXPRESSION>
                                                            <EXPRESSION>
				                                                <FIELDNAME>NAME</FIELDNAME>
				                                                <ALIAS>NAME</ALIAS>
			                                                </EXPRESSION>
                                                        </SELECTLIST>
                                                     </TARGETENTITY>
                                                  </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID);
                   #endregion
               }
               else if (str_SearchItem.Equals("VENDORS"))
               {
                   #region Vendors
                   SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <TARGETOBJECT>VENDORS</TARGETOBJECT>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                                    <TARGETENTITY>
                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                            <SELECTLIST>
                                                                  <EXPRESSION>
                                                                     <FIELDNAME>NAME</FIELDNAME>
                                                                     <ALIAS>NAME</ALIAS>
                                                                  </EXPRESSION>
                                                                  <EXPRESSION>
                                                                      <FIELDNAME>DESCRIPTION</FIELDNAME>
                                                                      <ALIAS>DESCRIPTION</ALIAS>
                                                                  </EXPRESSION>
                                                                  <EXPRESSION>
                                                                      <FIELDNAME>VENDORTYPE</FIELDNAME>
                                                                      <ALIAS>VENDORTYPE</ALIAS>
                                                                  </EXPRESSION>
                                                                  <EXPRESSION>
                                                                      <FIELDNAME>ISOBSOLETE</FIELDNAME>
                                                                      <ALIAS>ISOBSOLETE</ALIAS>
                                                                  </EXPRESSION>
                                                                </SELECTLIST>
                                                                <SORTLIST>
                                                                  <SORTEXPRESSION>
                                                                      <SORTSEQUENCE>1</SORTSEQUENCE>
                                                                      <SORTORDER>ASC</SORTORDER>
                                                                      <COLUMNNAME>NAME</COLUMNNAME>
                                                                   </SORTEXPRESSION>
                                                                 </SORTLIST>
                                                                 <FILTERLIST>{4}</FILTERLIST>
                                                        </TARGETENTITY>
                                                  </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_FilterXML);
                   #endregion
               }
               else if (str_SearchItem.Equals("BUSINESSUNIT"))
               {
                   #region Business Unit
                   SearchInputXML.AppendFormat(@"<SEARCH>
                                                    <TARGETOBJECT>BUSINESSUNIT</TARGETOBJECT>
                                                    <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                                    <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                                    <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                                    <TARGETENTITY>
                                                        <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                            <SELECTLIST>
                                                                <EXPRESSION>
				                                                    <FIELDNAME>BUSINESSUNITID</FIELDNAME>
				                                                    <ALIAS>BUSINESSUNITID</ALIAS>
			                                                    </EXPRESSION>
                                                                <EXPRESSION>
				                                                    <FIELDNAME>NAME</FIELDNAME>
				                                                    <ALIAS>NAME</ALIAS>
			                                                    </EXPRESSION>
                                                            </SELECTLIST>
                                                </TARGETENTITY>
                                            </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID);
                   #endregion
               }
               #endregion

               #region Search using GetHierarchial Data
               ErrorXML =   SearchObj.GetHierarchialData(SearchInputXML.ToString(), ref SearchOutputXML);
               #endregion

               #region Process Search Output XML
               if (ErrorXML == null)
               {
                   xpDoc_BU_Item       =   new XPathDocument(new System.IO.StringReader(SearchOutputXML));
                   xpNav_BU_Item       =   xpDoc_BU_Item.CreateNavigator();
                   sb_FilterListXML     = new StringBuilder(100);

                   sb_FilterListXML.Append("<FilterValueList>");

                   if (b_BUUniverseRequired)
                   {
                       #region For BU Universe Required
                                              
                       if (str_SearchItem.Equals("COSTCENTER"))
                       {
                           xpNodeItr_BU_Item    = xpNav_BU_Item.Select("//BUSINESSUNIT/BUSINESSUNIT_COSTCENTERS/COSTCENTERS");
                           Itemlist             = new ArrayList(); 
                           while (xpNodeItr_BU_Item.MoveNext())
                           {
                               if (xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCENTERSID") != null)
                               {
                                   b_Addflag = AddToList(Itemlist, xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCENTERSID").InnerXml);
                                   if (b_Addflag == true)
                                   {
                                       sb_FilterListXML.AppendFormat("<FilterValue><Value>{1}</Value><DisplayValue>{1}</DisplayValue></FilterValue>", xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCENTERSID").InnerXml, ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("NAME").Value));
                                   }
                               }
                           }
                       }
                       else if (str_SearchItem.Equals("COSTCATEGORY"))
                       {
                           xpNodeItr_BU_Item    = xpNav_BU_Item.Select("//BUSINESSUNIT/BUSINESSUNIT_COSTCATEGORY/COSTCATEGORY");
                           Itemlist             = new ArrayList();
                           while (xpNodeItr_BU_Item.MoveNext())
                           {
                               if (xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCATEGORYID") != null)
                               {
                                   b_Addflag = AddToList(Itemlist, xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCATEGORYID").InnerXml);
                                   if (b_Addflag == true)
                                   {
                                       sb_FilterListXML.AppendFormat("<FilterValue><Value>{1}</Value><DisplayValue>{1}</DisplayValue></FilterValue>", xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCATEGORYID").InnerXml, ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("NAME").Value));
                                   }
                               }
                           }
                       }
                       else if (str_SearchItem.Equals("VENDORS"))
                       {
                           sb_VendorListXML = new StringBuilder(50);
                           sb_VendorListXML.Append("<VENDORSCOLLECTION>");
                           xpNodeItr_BU_Item = xpNav_BU_Item.Select("//BUSINESSUNIT/BUSINESSUNIT_VENDORS/VENDORS");
                           Itemlist = new ArrayList();
                           while (xpNodeItr_BU_Item.MoveNext())
                           {
                               if (xpNodeItr_BU_Item.Current.SelectSingleNode("VENDORSID") != null)
                               {
                                   b_Addflag = AddToList(Itemlist, xpNodeItr_BU_Item.Current.SelectSingleNode("VENDORSID").InnerXml);
                                   if (b_Addflag == true)
                                   {
                                       sb_VendorListXML.AppendFormat("<VENDORS><VENDORSID>{0}</VENDORSID><NAME>{1}</NAME><DESCRIPTION>{2}</DESCRIPTION><VENDORTYPE>{3}</VENDORTYPE><ISOBSOLETE>{4}</ISOBSOLETE></VENDORS>", xpNodeItr_BU_Item.Current.SelectSingleNode("VENDORSID").InnerXml, ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("NAME").Value), ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("DESCRIPTION").Value), ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("VENDORTYPE").Value), ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("ISOBSOLETE").Value));
                                   }
                               }
                           }
                           sb_VendorListXML.Append("</VENDORSCOLLECTION>");
                           return sb_VendorListXML;
                       }
                       else if (str_SearchItem.Equals("BUSINESSUNIT"))
                       {
                           sb_BusinessUnitListXML   = new StringBuilder(50);
                           xpNodeItr_BU_Item        = xpNav_BU_Item.Select("//BUSINESSUNIT");
                           Itemlist                 = new ArrayList(); 
                           while (xpNodeItr_BU_Item.MoveNext())
                           {
                               if (xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID") != null)
                               {
                                   b_Addflag = AddToList(Itemlist, xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                                   if (b_Addflag == true)
                                   {
                                       if(xpNodeItr_BU_Item.CurrentPosition == 1)
                                       {
                                           sb_BusinessUnitListXML.AppendFormat(@"{0}", xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                                       }
                                       else
                                       {
                                           sb_BusinessUnitListXML.AppendFormat(@",{0}", xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                                       }
                                       //sb_BusinessUnitListXML.AppendFormat("<BUSINESSUNIT><BUSINESSUNITIDS>{1}</BUSINESSUNITIDS></BUSINESSUNIT>", xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                                   }
                               }
                           }
                           return sb_BusinessUnitListXML;  
                        }
                       
                       #endregion
                   }
                   else if ((str_SearchItem.Equals("COSTCENTER")) && (!b_BUUniverseRequired))
                   {
                       #region For Cost Center
                       xpNodeItr_BU_Item = xpNav_BU_Item.Select("//COSTCENTERSCOLLECTION/COSTCENTERS");
                       while (xpNodeItr_BU_Item.MoveNext())
                       {
                           sb_FilterListXML.AppendFormat("<FilterValue><Value>{1}</Value><DisplayValue>{1}</DisplayValue></FilterValue>", xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCENTERSID").InnerXml, ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("NAME").Value));
                       }
                       #endregion
                   }
                   else if ((str_SearchItem.Equals("COSTCATEGORY")) && (!b_BUUniverseRequired))
                   {
                       #region For Cost Category
                       xpNodeItr_BU_Item = xpNav_BU_Item.Select("//COSTCATEGORYCOLLECTION/COSTCATEGORY");
                       while (xpNodeItr_BU_Item.MoveNext())
                       {
                           sb_FilterListXML.AppendFormat("<FilterValue><Value>{1}</Value><DisplayValue>{1}</DisplayValue></FilterValue>", xpNodeItr_BU_Item.Current.SelectSingleNode("COSTCATEGORYID").InnerXml, ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("NAME").Value));
                       }
                       #endregion
                   }
                   else if (str_SearchItem.Equals("VENDORS"))
                   {
                       #region For Vendors
                       sb_VendorListXML     = new StringBuilder(50);
                       sb_VendorListXML.Append("<VENDORSCOLLECTION>");
                       xpNodeItr_BU_Item    = xpNav_BU_Item.Select("//VENDORSCOLLECTION/VENDORS");
                       
                       while (xpNodeItr_BU_Item.MoveNext())
                       {
                           sb_VendorListXML.AppendFormat("<VENDORS><VENDORSID>{0}</VENDORSID><NAME>{1}</NAME><DESCRIPTION>{2}</DESCRIPTION><VENDORTYPE>{3}</VENDORTYPE><ISOBSOLETE>{4}</ISOBSOLETE></VENDORS>", xpNodeItr_BU_Item.Current.SelectSingleNode("VENDORSID").InnerXml, ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("NAME").Value), ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("DESCRIPTION").Value), ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("VENDORTYPE").Value), ALSpecialCharHandling.TrimAndReplaceSpecialChars(xpNodeItr_BU_Item.Current.SelectSingleNode("ISOBSOLETE").Value));
                       }
                       sb_VendorListXML.Append("</VENDORSCOLLECTION>");
                       return sb_VendorListXML;
                       #endregion
                   }
                   else if (str_SearchItem.Equals("BUSINESSUNIT"))
                   {
                       sb_BusinessUnitListXML = new StringBuilder(50);
                       xpNodeItr_BU_Item = xpNav_BU_Item.Select("//BUSINESSUNIT");
                       Itemlist = new ArrayList();
                       while (xpNodeItr_BU_Item.MoveNext())
                       {
                           if (xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID") != null)
                           {
                               b_Addflag = AddToList(Itemlist, xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                               if (b_Addflag == true)
                               {
                                   if (xpNodeItr_BU_Item.CurrentPosition == 1)
                                   {
                                       sb_BusinessUnitListXML.AppendFormat(@"{0}", xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                                   }
                                   else
                                   {
                                       sb_BusinessUnitListXML.AppendFormat(@",{0}", xpNodeItr_BU_Item.Current.SelectSingleNode("BUSINESSUNITID").InnerXml);
                                   }
                               }
                           }
                       }
                       return sb_BusinessUnitListXML;
                   }
                   sb_FilterListXML.AppendFormat("<FilterValue IsSelected='TRUE'><Value>None</Value><DisplayValue>None</DisplayValue></FilterValue>");
                   sb_FilterListXML.Append("</FilterValueList>");
                   
               }
               return sb_FilterListXML;
               #endregion
           }
           catch (Exception ExcepObj)
           {
               throw ExcepObj;
           }
       }
       
       private static bool AddToList(ArrayList list, string Value)
       {
           if (list.Contains(Value) == false)
           {
               list.Add(Value);
               return true;
           }
           else
               return false;
       }

        private String PlanNotificationAdditionalInfo(String str_PlanDetailsXML)
        {
            XPathDocument   xpDoc_PlanDetails   = null;
            XPathNavigator  xpNav_PlanDetails   = null;
            XPathNavigator  xpNav_Plan          = null;
            XPathNavigator  xpNav_Temp          = null;
            StringBuilder   sb_NotificationXML  = null;

            xpDoc_PlanDetails   = new XPathDocument(new StringReader(str_PlanDetailsXML));
            xpNav_PlanDetails   = xpDoc_PlanDetails.CreateNavigator();
            sb_NotificationXML  = new StringBuilder(100);

            xpNav_Plan          = xpNav_PlanDetails.SelectSingleNode("PLANCOLLECTION/PLAN");
            if(xpNav_Plan == null)
                xpNav_Plan      = xpNav_PlanDetails.SelectSingleNode("PLAN");

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("PLANID");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("TITLE");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("DESCRIPTION");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("FISCALYEAR");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("FROMDATE");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("TODATE");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);

            xpNav_Temp          = xpNav_Plan.SelectSingleNode("BUSINESSUNIT_FOR_PLAN");
            if (xpNav_Temp != null)
                sb_NotificationXML.Append(xpNav_Temp.OuterXml);
            return sb_NotificationXML.ToString();
        }

        #region ICM Changes
        /// <summary>
        /// This API is used to fecth data from ICM configuration xml. 
        /// Returns XML containing the details of the data that is to be fetched.
        /// <CREATEDON>13 August 2009</CREATEDON>
        /// <CREATEDBY>Varun Dighe</CREATEDBY>
        /// </summary>
        public void FetchDataFromICMConfig(String str_ICMConfigName,String str_ActivityTypeName, String str_FetchValueFor,ref String str_ReturnData)
        {
            #region Member Variables
            String              str_ICMConfigPath                = null;
            XPathDocument       xpDoc_ICMConfig                 = null;
            XPathNavigator      xpNav_IcmConfig_ActivityTypes   = null;
            XPathNodeIterator   xpNdItr_IcmConfiguration        = null;
            #endregion

            try
            {
                str_ICMConfigPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, "StrategicPlanner", "", "ICMConfiguration");
                if (!String.IsNullOrEmpty(str_ICMConfigPath))
                {
                    xpDoc_ICMConfig = new XPathDocument(str_ICMConfigPath);
                    //Check whether the activitytype name comtains Name/Path or whether it contains SALPS in the path and then modify the xpath approptiately.
                    if (String.IsNullOrEmpty(str_ActivityTypeName))
                    {
                        #region Get ActivityTypeName using ActivityID
                        #endregion
                    }
                    xpNav_IcmConfig_ActivityTypes = xpDoc_ICMConfig.CreateNavigator().SelectSingleNode("ICMCONFIGURATION/CONFIGURATION[ACTIVITYTYPES/ACTIVITYTYPE/NHVALUE=" + ALXmlUtil.GetXpathValueString(str_ActivityTypeName) + "]");
                }
                else
                {
                    str_ReturnData = null;
                    return;
                }
                if (xpNav_IcmConfig_ActivityTypes != null)
                {
                    switch (str_FetchValueFor)
                    {
                        case "FACETTYPES":
                            xpNdItr_IcmConfiguration            = xpNav_IcmConfig_ActivityTypes.Select("descendant::FACETTYPE");
                            StringBuilder sb_RelationShiplist   = new StringBuilder(100);

                            sb_RelationShiplist.Append("<RELATIONSHIPCOLLECTION>");
                            while (xpNdItr_IcmConfiguration.MoveNext())
                            {
                                sb_RelationShiplist.Append("<RELATIONSHIPS>");
                                sb_RelationShiplist.AppendFormat("<RELATIONSHIPNAME>{0}</RELATIONSHIPNAME>", ALSolutionCommon.TrimAndReplaceSpecialChars(xpNdItr_IcmConfiguration.Current.Value));
                                sb_RelationShiplist.Append("</RELATIONSHIPS>");
                            }
                            sb_RelationShiplist.Append("</RELATIONSHIPCOLLECTION>");
                            str_ReturnData  = sb_RelationShiplist.ToString(); 
                            break;
                        case "FORMS":
                            XPathNavigator XPNAV_Configuration_Activity_Form = null;
                            XPNAV_Configuration_Activity_Form = xpNav_IcmConfig_ActivityTypes.SelectSingleNode("FORMS/FORM/FORMNAME");
                            if (XPNAV_Configuration_Activity_Form != null && XPNAV_Configuration_Activity_Form.Value != null)
                            {
                                str_ReturnData = XPNAV_Configuration_Activity_Form.Value;
                            }
                            break;
                        case "BRIEFTYPES":
                            xpNdItr_IcmConfiguration    = xpNav_IcmConfig_ActivityTypes.Select("descendant::BRIEFTYPE");
                            StringBuilder sb_Brieflist  = new StringBuilder(100);

                            if (xpNdItr_IcmConfiguration.Count > 0)
                            {
                                sb_Brieflist.Append("<BRIEFCOLLECTION>");
                                while (xpNdItr_IcmConfiguration.MoveNext())
                                {
                                    sb_Brieflist.Append("<BRIEFTYPE>");
                                    sb_Brieflist.AppendFormat("<BRIEFTYPENAME>{0}</BRIEFTYPENAME>", ALSolutionCommon.TrimAndReplaceSpecialChars(xpNdItr_IcmConfiguration.Current.SelectSingleNode("BRIEFTYPENAME").Value));
                                    sb_Brieflist.AppendFormat("<BRIEFTYPEID>{0}</BRIEFTYPEID>", xpNdItr_IcmConfiguration.Current.SelectSingleNode("BRIEFTYPEID").Value);
                                    sb_Brieflist.Append("</BRIEFTYPE>");
                                }
                                sb_Brieflist.Append("</BRIEFCOLLECTION>");
                                str_ReturnData = sb_Brieflist.ToString();
                            }
                            break;
                        case "PROJECTTYPES":
                            xpNdItr_IcmConfiguration        = xpNav_IcmConfig_ActivityTypes.Select("descendant::PROJECTTYPE");
                            StringBuilder sb_Projectlist    = new StringBuilder(100);

                            if (xpNdItr_IcmConfiguration.Count > 0)
                            {
                                sb_Projectlist.Append("<PROJECTTYPECOLLECTION>");
                                while (xpNdItr_IcmConfiguration.MoveNext())
                                {
                                    sb_Projectlist.Append("<PROJECTTYPE>");
                                    sb_Projectlist.AppendFormat("<PROCESSNAME>{0}</PROCESSNAME>", ALSolutionCommon.TrimAndReplaceSpecialChars(xpNdItr_IcmConfiguration.Current.SelectSingleNode("PROJECTTYPENAME").Value));
                                    sb_Projectlist.AppendFormat("<WORKFLOWPROCESSID>{0}</WORKFLOWPROCESSID>", xpNdItr_IcmConfiguration.Current.SelectSingleNode("PROJECTTYPEID").Value);
                                    sb_Projectlist.Append("</PROJECTTYPE>");
                                }
                                sb_Projectlist.Append("</PROJECTTYPECOLLECTION>");
                                str_ReturnData = sb_Projectlist.ToString();
                            }
                            break;

                    }

                }
                else
                {
                    str_ReturnData = null;
                    return;
                }

            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }
        
        #region ICM - For fetching Activity Type path from Activitytype Id or Name.
        /// <summary>
        /// <CREATEDBY>Varun Dighe</CREATEDBY>
        /// <CREATEDON>28 August 2009</CREATEDON>
        /// The following 3 APIs are used to fetch Activity Type path from ActivitytypeID or ActivitytypeName.
        /// getPathForSelectedActivityType is an overloaded API which internally uses getFlatNamedHierarchyValue to retrive Path or ID.
        /// The TMS Engine API of GetFlattenedNamedHierarchyValues is modified appropriately to fetch ID as an attribute in Namedhierarchy.xml 
        /// </summary>
        /// <param name="str_namedHierarchyID"></param>
        public void getFlatNamedHierarchyValue(String str_namedHierarchyID)
        {   
            #region Local Variables
            StringBuilder       namedHierarchyListXml   = null;
            String              outputXml               = null;
            String              errorXml                = null;
            NHFacade            nhFacadObj              = null;
            StringBuilder       sb_NHFlatenedValues     = null;
            #endregion

            namedHierarchyListXml   = new StringBuilder(100);
            sb_NHFlatenedValues     = new StringBuilder(100); 
            nhFacadObj              = new NHFacade(SessionID, UserID, TenantName, CurrentLanguage);

            namedHierarchyListXml.Append("<NAMEDHIERARCHYCOLLECTION>");
                namedHierarchyListXml.Append("<NAMEDHIERARCHY>");
                    namedHierarchyListXml.AppendFormat("<ID>{0}</ID>", str_namedHierarchyID);
                    namedHierarchyListXml.Append("<VALUETYPE>PATH</VALUETYPE>");
                    if (FetchObsoleteValues)
                    {
                        namedHierarchyListXml.Append("<FETCHOBSOLETEVALUES>TRUE</FETCHOBSOLETEVALUES>");
                    }
                    else
                    {
                        namedHierarchyListXml.Append("<FETCHOBSOLETEVALUES>FALSE</FETCHOBSOLETEVALUES>");
                    }
                namedHierarchyListXml.Append("</NAMEDHIERARCHY>");
            namedHierarchyListXml.Append("</NAMEDHIERARCHYCOLLECTION>");

            errorXml    = nhFacadObj.GetFlattenedNamedHierarchyValues(namedHierarchyListXml.ToString(), ref outputXml);
            if (String.IsNullOrEmpty(errorXml))
            {
                sb_NHFlatenedValues.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(SessionID), str_namedHierarchyID + "_MarketingActivityTypeFlattenedValues.XML");
                File.WriteAllText(sb_NHFlatenedValues.ToString(),outputXml); 
            }
        }

        public void getPathForSelectedActivityType(String str_ActivityTypePath, ref String str_ActivityTypeID, ref String str_ActivityTypeName)
        {
            #region Member Variables
            XPathDocument   xpDoc_NHFlatLevel   = null;
            XPathNavigator  xpNav_NHFlat        = null;
            XPathNavigator  xpNav_NHValueNode   = null;
            String          str_NamedHierahcyID = null;
            StringBuilder   sb_NHFlatenedValues = null;
            #endregion

            try
            {
                //First check whether file exists on NTFS, if not then fetch, else load the file from the NTFS and fetch the path
                str_NamedHierahcyID = "857819057";
                sb_NHFlatenedValues = new StringBuilder(100);
                sb_NHFlatenedValues.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(SessionID), str_NamedHierahcyID + "_MarketingActivityTypeFlattenedValues.XML");
                if (!File.Exists(sb_NHFlatenedValues.ToString()))
                {
                    //then call this API which will write the file on the NTFS
                    getFlatNamedHierarchyValue(str_NamedHierahcyID);  
                }
                xpDoc_NHFlatLevel = new XPathDocument(sb_NHFlatenedValues.ToString());
                if (xpDoc_NHFlatLevel != null)
                    xpNav_NHFlat = xpDoc_NHFlatLevel.CreateNavigator();
                if (!String.IsNullOrEmpty(str_ActivityTypePath))
                {
                    str_ActivityTypePath = str_ActivityTypePath.Replace("$ALP$", "\\");
                    xpNav_NHValueNode = xpNav_NHFlat.SelectSingleNode("NAMEDHIERARCHYCOLLECTION//VALUELIST//VALUE[@Path=" + ALXmlUtil.GetXpathValueString(str_ActivityTypePath) + "]");
                    if (xpNav_NHValueNode != null)
                    {
                        str_ActivityTypeName    = xpNav_NHValueNode.Value;
                        str_ActivityTypeID      = xpNav_NHValueNode.GetAttribute("ID", "");
                    }
                }
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }

        public void getPathForSelectedActivityType(String str_ActivityTypeID, String str_ActivityTypeName, ref String str_ActivityTypePath)
        {
            #region Member Variables
            XPathDocument   xpDoc_NHFlatLevel   = null;
            XPathNavigator  xpNav_NHFlat        = null;
            XPathNavigator  xpNav_NHValueNode   = null;
            String          str_NamedHierahcyID = null;
            StringBuilder   sb_NHFlatenedValues = null;
            #endregion

            try
            {
                //First check whether file exists on NTFS, if not then fetch, else load the file from the NTFS and fetch the path
                str_NamedHierahcyID = "857819057";
                sb_NHFlatenedValues = new StringBuilder(100);
                sb_NHFlatenedValues.AppendFormat("{0}{1}", ALSolutionCommon.GetTempPath(SessionID), str_NamedHierahcyID + "_MarketingActivityTypeFlattenedValues.XML");
                if (!File.Exists(sb_NHFlatenedValues.ToString()))
                {
                    //then call this API which will write the file on the NTFS
                    getFlatNamedHierarchyValue(str_NamedHierahcyID);  
                }
                xpDoc_NHFlatLevel = new XPathDocument(sb_NHFlatenedValues.ToString());
                if (xpDoc_NHFlatLevel != null)
                    xpNav_NHFlat = xpDoc_NHFlatLevel.CreateNavigator();
                if (!String.IsNullOrEmpty(str_ActivityTypeID))
                {
                    xpNav_NHValueNode = xpNav_NHFlat.SelectSingleNode("NAMEDHIERARCHYCOLLECTION//VALUELIST//VALUE[@ID='" + str_ActivityTypeID + "']");
                    if (xpNav_NHValueNode != null)
                    {
                        str_ActivityTypePath = xpNav_NHValueNode.GetAttribute("Path", "");
                        str_ActivityTypePath = str_ActivityTypePath.Replace("\\","$ALP$"); 
                    }
                }
                else if(!String.IsNullOrEmpty(str_ActivityTypeName))
                {
                    str_ActivityTypeName    = str_ActivityTypeName.Replace("$ALP$", "\\"); 
                    xpNav_NHValueNode       = xpNav_NHFlat.SelectSingleNode("NAMEDHIERARCHYCOLLECTION//VALUELIST//VALUE[@Path=" + ALXmlUtil.GetXpathValueString(str_ActivityTypeName) + "]");
                    if (xpNav_NHValueNode != null)
                    {
                        str_ActivityTypePath    = xpNav_NHValueNode.GetAttribute("Path", "");
                        str_ActivityTypePath    = str_ActivityTypePath.Replace("\\","$ALP$"); 
                        str_ActivityTypeID      = xpNav_NHValueNode.GetAttribute("ID", "");
                    }
                }
            }
            catch (Exception ExcepObj)
            {
                throw ExcepObj;
            }
        }
        
        #endregion

        #endregion

        /// <summary>
        /// Method to create selected users xml while creating a review.
        /// </summary>
        /// <param name="str_PermittedGroupsAndUsersXML">Permitted users and group xml</param>
        /// <param name="str_PermittedGroupsAndUsersFile">Permitted users and group xml path</param>
        /// <param name="str_InviteeUsersFile">Invitee users file name</param>
        public void SetSelectedUsersXML(String str_PermittedGroupsAndUsersXML, String str_PermittedGroupsAndUsersFile, String str_InviteeUsersFile)
        {
            StringBuilder       sb_ReviewerListPath         = null;
            XPathDocument       xpDoc_Reviewers             = null;
            XPathNavigator      xpNav_Reviewers             = null;
            StringBuilder       sb_ROPlanXMLPath            = null;
            XmlDocument         xmlDoc_ROPlanXML            = null;
            XmlElement          xmlEle_SelectedUsers        = null;
            StringBuilder       sb_InviteeUsersFile         = null;
            String              str_InviteeUsers            = null;
            XPathNodeIterator   xpNodeIte_User              = null;

            sb_ReviewerListPath = new StringBuilder(100);
            sb_ROPlanXMLPath    = new StringBuilder(50);

            sb_InviteeUsersFile = new StringBuilder(50);
            sb_InviteeUsersFile.AppendFormat("{0}\\{1}\\MessageBoard_TopicWidget_InviteeGroupsUsers.xml", ALSolutionCommon.GetTempPath(SessionID), UserID);

            if (File.Exists(sb_InviteeUsersFile.ToString()))
            {
                str_InviteeUsers = File.ReadAllText(sb_InviteeUsersFile.ToString());
            }

            sb_ROPlanXMLPath.AppendFormat("{0}\\{1}.xml", ALSolutionCommon.GetTempPath(SessionID), str_PermittedGroupsAndUsersFile);
            xpDoc_Reviewers     = new XPathDocument(sb_ROPlanXMLPath.ToString());
            xpNav_Reviewers     = xpDoc_Reviewers.CreateNavigator();

            xmlDoc_ROPlanXML    = new XmlDocument();
            xmlDoc_ROPlanXML.LoadXml(str_PermittedGroupsAndUsersXML);

            xmlEle_SelectedUsers = (XmlElement)xmlDoc_ROPlanXML.SelectSingleNode("UserSelectionXML/SelectedUsersList");
            if (xmlEle_SelectedUsers != null)
            {
                xmlEle_SelectedUsers.InnerXml = "";
                xpNodeIte_User  = xpNav_Reviewers.Select("UserSelectionXML/SelectedUsersList/USER");
                foreach (XPathNavigator xpNav_User in xpNodeIte_User)
                {
                    if (str_InviteeUsers.Contains(xpNav_User.SelectSingleNode("USERID").Value))
                    {
                        xmlEle_SelectedUsers.InnerXml += xpNav_User.OuterXml;
                    }
                }
            }
            xmlDoc_ROPlanXML.Save(sb_ROPlanXMLPath.ToString());
        }

        /// <summary>
        /// <purpose>This API will return the forecast configuration details for the specified fiscal year from database
        /// This API is introduced for Flexible forecasting</purpose>
        /// <author>Anita Walzade</author>
        /// </summary>
        /// <param name="str_FiscalYear">Fiscal year for which configuartion is to be fetched</param>
        /// <param name="str_ForecastConfiguration">ForecastConfiguration details</param>
        /// <returns>ErrorXML if error occured else will return null</returns>
        public String GetForecastConfiguration(String str_FiscalYear, out String str_ForecastConfiguration)
        {
            String              str_ErrorXML        = null;
            String              str_SearchOutputXML = null;
            StringBuilder       sb_SearchInputXML   = null;
            SearchConfiguration obj_Search          = null;
            
            try
            {
                if (!String.IsNullOrEmpty(str_FiscalYear))
                {
                    sb_SearchInputXML = new StringBuilder(1024);
                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                            <TARGETOBJECT>FORECASTCONFIGURATION</TARGETOBJECT>
                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                            <TARGETENTITY>
                                <PRIVILEGENAME>READ</PRIVILEGENAME>
                                <SELECTLIST>
                                    <EXPRESSION>
                                        <FIELDNAME>FISCALYEAR</FIELDNAME>
                                        <ALIAS>FISCALYEAR</ALIAS>
                                    </EXPRESSION>
                                    <EXPRESSION>
                                        <FIELDNAME>DURATIONTYPE</FIELDNAME>
                                        <ALIAS>DURATIONTYPE</ALIAS>
                                    </EXPRESSION>
                                    <EXPRESSION>
                                        <FIELDNAME>PLANFORECASTDURATION</FIELDNAME>
                                        <ALIAS>PLANFORECASTDURATION</ALIAS>
                                    </EXPRESSION>
                                    <EXPRESSION>
                                        <FIELDNAME>MALEVEL1FORECASTDURATION</FIELDNAME>
                                        <ALIAS>MALEVEL1FORECASTDURATION</ALIAS>
                                    </EXPRESSION>
                                    <EXPRESSION>
                                        <FIELDNAME>MALEVEL2FORECASTDURATION</FIELDNAME>
                                        <ALIAS>MALEVEL2FORECASTDURATION</ALIAS>
                                    </EXPRESSION>
                                </SELECTLIST>
                                <FILTERLIST>
                                    <FILTER>
                                        <FILTERID>1</FILTERID>
                                        <EXPRESSION>FISCALYEAR</EXPRESSION>
                                        <OPERATOR>EQUALTO</OPERATOR>
                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                    </FILTER>
                                </FILTERLIST>
                                <RELATIONSHIP NAME='FORECASTCONFIGURATION_FORECASTPERIODS'>
                                    <SELECTLIST>
                                        <EXPRESSION>
                                            <FIELDNAME>PERIODNUMBER</FIELDNAME>
                                            <ALIAS>PERIODNUMBER</ALIAS>
                                        </EXPRESSION>
                                        <EXPRESSION>
                                            <FIELDNAME>PERIODABBREVIATION</FIELDNAME>
                                            <ALIAS>PERIODABBREVIATION</ALIAS>
                                        </EXPRESSION>
                                         <EXPRESSION>
                                            <FIELDNAME>PERIODNAME</FIELDNAME>
                                            <ALIAS>PERIODNAME</ALIAS>
                                        </EXPRESSION>
                                         <EXPRESSION>
                                            <FIELDNAME>STARTDATE</FIELDNAME>
                                            <ALIAS>STARTDATE</ALIAS>
                                        </EXPRESSION>
                                        <EXPRESSION>
                                            <FIELDNAME>ENDDATE</FIELDNAME>
                                            <ALIAS>ENDDATE</ALIAS>
                                        </EXPRESSION>
                                        <EXPRESSION>
                                            <FIELDNAME>QUARTER</FIELDNAME>
                                            <ALIAS>QUARTER</ALIAS>
                                        </EXPRESSION>
                                    </SELECTLIST>
                                    <SORTLIST>
                                        <SORTEXPRESSION>
                                            <SORTSEQUENCE>1</SORTSEQUENCE>
                                            <SORTORDER>ASC</SORTORDER>
                                            <COLUMNNAME>PERIODNUMBER</COLUMNNAME>
                                        </SORTEXPRESSION>
                                    </SORTLIST>
                                </RELATIONSHIP>
                            </TARGETENTITY>
                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_FiscalYear);
                    obj_Search      = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    str_ErrorXML    = obj_Search.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutputXML);
                }
                else
                {
                    str_ErrorXML = ALSolutionCommon.PrepareErrorXML("ERR_SP_FiscalYearCannotbeNull", Localization.GetString("ALErrorResource", TenantName, "ERR_SP_FiscalYearCannotbeNull"));
                }

                str_ForecastConfiguration = str_SearchOutputXML;
                return str_ErrorXML;
            }
            catch(Exception obj_Exception)
            {
                throw obj_Exception;
            }
        }

        /// <summary>
        /// <purpose>This API will return the forecast Durations for Plan, Activity, SubActivity for the specified fiscal year from database
        /// This API is introduced for Flexible forecasting</purpose>
        /// <author>Anita Walzade</author>
        /// </summary>
        /// <param name="str_FiscalYear">Fiscal year for which durations are to be fetched</param>
        /// <param name="str_ForecastDurations">Plan, Activity and SubActivity Durations</param>
        /// <returns>ErrorXML if error occured else will return null</returns>
        public String GetForecastDurations(String str_FiscalYear, ref String str_PlanDuration, ref String str_ActivityLevel1Duration, ref String str_ActivityLevel2Duration)
        {
            String              str_ErrorXML        = null;
            String              str_SearchOutputXML = null;
            StringBuilder       sb_SearchInputXML   = null;
            SearchConfiguration obj_Search          = null;
            try
            {
                if (!String.IsNullOrEmpty(str_FiscalYear))
                {
                    sb_SearchInputXML = new StringBuilder(1024);
                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                            <TARGETOBJECT>FORECASTCONFIGURATION</TARGETOBJECT>
                                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                            <TARGETENTITY>
                                                <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                <SELECTLIST>
                                                    <EXPRESSION>
	                                                    <FIELDNAME>PLANFORECASTDURATION</FIELDNAME>
	                                                    <ALIAS>PLANFORECASTDURATION</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
	                                                    <FIELDNAME>MALEVEL1FORECASTDURATION</FIELDNAME>
	                                                    <ALIAS>MALEVEL1FORECASTDURATION</ALIAS>
                                                    </EXPRESSION>
                                                    <EXPRESSION>
	                                                    <FIELDNAME>MALEVEL2FORECASTDURATION</FIELDNAME>
	                                                    <ALIAS>MALEVEL2FORECASTDURATION</ALIAS>
                                                    </EXPRESSION>
                                                </SELECTLIST>
                                                <FILTERLIST>
                                                    <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <EXPRESSION>FISCALYEAR</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>
                                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                </FILTERLIST>
                                            </TARGETENTITY>
                                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_FiscalYear);

                    obj_Search      = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    str_ErrorXML    = obj_Search.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutputXML);
                    if (String.IsNullOrEmpty(str_ErrorXML))
                    {
                        str_PlanDuration            = ALCommon.GetInnerValue(ref str_SearchOutputXML, "<PLANFORECASTDURATION>", "</PLANFORECASTDURATION>");
                        str_ActivityLevel1Duration  = ALCommon.GetInnerValue(ref str_SearchOutputXML, "<MALEVEL1FORECASTDURATION>", "</MALEVEL1FORECASTDURATION>");
                        str_ActivityLevel2Duration  = ALCommon.GetInnerValue(ref str_SearchOutputXML, "<MALEVEL2FORECASTDURATION>", "</MALEVEL2FORECASTDURATION>");
                    }
                }
                else
                {
                    str_ErrorXML = ALSolutionCommon.PrepareErrorXML("ERR_SP_FiscalYearCannotbeNull", Localization.GetString("ALErrorResource", TenantName, "ERR_SP_FiscalYearCannotbeNull"));
                }

                return str_ErrorXML;
            }
            catch (Exception obj_Exception)
            {
                throw obj_Exception;
            }
        }

        /// <summary>
        /// <purpose>This API will return the count of the forecasting periods for specified fiscal year from database
        /// This API is introduced for Flexible forecasting</purpose>
        /// </summary>
        /// <param name="str_FiscalYear">Fiscal year for which period count is to get</param>
        /// <param name="str_PeriodCount">Count of periods</param>
        /// <returns></returns>
        public String GetForecastPeriodCount(String str_FiscalYear, out int int_PeriodCount)
        {
            String              str_ErrorXML        = null;
            String              str_SearchOutputXML = null;
            StringBuilder       sb_SearchInputXML   = null;
            SearchConfiguration obj_Search          = null;
            XPathDocument       xpathdoc_PeriodsDoc = null;
            XPathNavigator      xpathnav_PeriodNav  = null;
            XPathNodeIterator   xpathnodeitr_Count  = null;
            int_PeriodCount = 0;
            
            try
            {
                if (!String.IsNullOrEmpty(str_FiscalYear))
                {
                    sb_SearchInputXML = new StringBuilder(1024);
                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                                            <TARGETOBJECT>FORECASTCONFIGURATION</TARGETOBJECT>
                                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                            <TARGETENTITY>
                                                <PRIVILEGENAME>READ</PRIVILEGENAME>
                                                <SELECTLIST>
                                                    <EXPRESSION>
	                                                    <FIELDNAME>FISCALYEAR</FIELDNAME>
	                                                    <ALIAS>FISCALYEAR</ALIAS>
                                                    </EXPRESSION>
                                                </SELECTLIST>
                                                <FILTERLIST>
                                                    <FILTER>
                                                        <FILTERID>1</FILTERID>
                                                        <EXPRESSION>FISCALYEAR</EXPRESSION>
                                                        <OPERATOR>EQUALTO</OPERATOR>
                                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                                    </FILTER>
                                                </FILTERLIST>
                                                <RELATIONSHIP NAME='FORECASTCONFIGURATION_FORECASTPERIODS'>
                                                    <SELECTLIST>
                                                        <EXPRESSION>
	                                                        <FIELDNAME>PERIODNUMBER</FIELDNAME>
	                                                        <ALIAS>PERIODNUMBER</ALIAS>
                                                        </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                            </TARGETENTITY>
                                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_FiscalYear);

                    obj_Search      = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    str_ErrorXML    = obj_Search.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutputXML);
                    if (String.IsNullOrEmpty(str_ErrorXML))
                    {
                        xpathdoc_PeriodsDoc = new XPathDocument(new StringReader(str_SearchOutputXML));
                        xpathnav_PeriodNav  = xpathdoc_PeriodsDoc.CreateNavigator();
                        xpathnodeitr_Count = xpathnav_PeriodNav.Select("FORECASTCONFIGURATIONCOLLECTION/FORECASTCONFIGURATION/FORECASTCONFIGURATION_FORECASTPERIODS/FORECASTPERIODS/PERIODNUMBER");
                        if (xpathnodeitr_Count != null)
                            int_PeriodCount = xpathnodeitr_Count.Count;
                    }
                }
                else
                {
                    str_ErrorXML = ALSolutionCommon.PrepareErrorXML("ERR_SP_FiscalYearCannotbeNull", Localization.GetString("ALErrorResource", TenantName, "ERR_SP_FiscalYearCannotbeNull"));
                }
                return str_ErrorXML;
            }
             catch (Exception obj_Exception)
            {
                throw obj_Exception;
            }
        }

        /// <summary>
        /// <author>Anita Walzade</author>
        /// <createdon>18th April 2012</createdon>
        /// <purpose>This API will check is forecast configuartion is done or not</purpose>
        /// </summary>
        /// <param name="str_FiscalYear">Fiscal year for which forecast configuration existance is to check</param>
        /// <returns>true if configuration exists, false otherwise</returns>
        public bool IsForecastConfiguarationExists(String str_FiscalYear)
        {
            bool                bool_ConfigExists   = false;
            StringBuilder       sb_SearchInputXML   = null;
            String              str_ErrorXML        = null;
            String              str_SearchOutputXML = null;
            String              str_ConfigValue     = null;
            SearchConfiguration obj_Search          = null;
            try
            {
                if (!String.IsNullOrEmpty(str_FiscalYear))
                {
                    sb_SearchInputXML = new StringBuilder(1024);
                    sb_SearchInputXML.AppendFormat(@"<SEARCH>
                            <TARGETOBJECT>FORECASTCONFIGURATION</TARGETOBJECT>
                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                            <TARGETENTITY>
                                <PRIVILEGENAME>READ</PRIVILEGENAME>
                                <SELECTLIST>
                                    <EXPRESSION>
                                        <FIELDNAME>FISCALYEAR</FIELDNAME>
                                        <ALIAS>FISCALYEAR</ALIAS>
                                    </EXPRESSION>
                                </SELECTLIST>
                                <FILTERLIST>
                                    <FILTER>
                                        <FILTERID>1</FILTERID>
                                        <EXPRESSION>FISCALYEAR</EXPRESSION>
                                        <OPERATOR>EQUALTO</OPERATOR>
                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                    </FILTER>
                                </FILTERLIST>
                            </TARGETENTITY>
                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, str_FiscalYear);
                    obj_Search      = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                    str_ErrorXML    = obj_Search.GetHierarchialData(sb_SearchInputXML.ToString(), ref str_SearchOutputXML);
                    if (String.IsNullOrEmpty(str_ErrorXML))
                    {
                        str_ConfigValue = ALCommon.GetInnerValue(ref str_SearchOutputXML, "<FISCALYEAR>", "</FISCALYEAR>");
                        if (!String.IsNullOrEmpty(str_ConfigValue))
                        {
                            bool_ConfigExists = true;
                        }
                    }
                    else
                    {
                        str_ErrorXML = ALSolutionCommon.PrepareErrorXML("ERR_SP_ErrorWhileFetchingForecastConfig", Localization.GetString("ALErrorResource", TenantName, "ERR_SP_ErrorWhileFetchingForecastConfig"));
                    }
                }
                else
                {
                    str_ErrorXML = ALSolutionCommon.PrepareErrorXML("ERR_SP_FiscalYearCannotbeNull", Localization.GetString("ALErrorResource", TenantName, "ERR_SP_FiscalYearCannotbeNull"));
                }
                return bool_ConfigExists;
            }
            catch (Exception obj_Exception)
            {
                throw obj_Exception;
            }
        }

        /// <summary> This method validates the forecast configurations between two fiscal years. It can be used while creating, updating
        /// or copying Plan. Following cases are validated by the method:
        /// CASE I: ****Check whether there is any forecast record exists in the system for the passed fiscal year's plan.
        ///     This validation checks a record for the budget forecast and for the resource category forecast.
        ///     If NO record present for any of the forecast, in such case set the ForecastConfigFlag to TRUE. 
        ///     This means, user can allow to create, edit or copy the plan with the selected (destination) fiscal year.
        /// CASE II: It checks whether the fiscal year configuration exists or not for both the fiscal years.
        ///     It validates the forecast durations for the passed fiscal years.
        /// CASE III: It also validates the the number of periods for both the fiscal years are matching or not.
        /// CASE IV: Checking the forecast configuration files exist on NTFS or not. It can be grid configurations
        ///     or list configurations or any other files which are required to support periodwise budget and resource forecasting.
        /// </summary>
        /// <param name="SourcePlanIDToCheckForecastRecord">This contains the plan ID for which the forecast records to be checked.</param>
        /// <param name="SourcePlanFiscalYear">This fiscal year is used as a base fiscal year.</param>
        /// <param name="DestinationPlanFiscalYear">This fiscal year is used as a child fiscal year
        /// to compare with the first/parent/base fiscal year.</param>
        /// <param name="ForecastConfigFlag">This is used to show that the forecast configurations are matching for
        /// both the fiscal years or not. TRUE means forecast configurations are matching.</param>
        /// <param name="ForecastErrorCode">This returns the error alert code which can be used at page level to display alert.</param>
        /// <returns>On failure or if any codition does not match according to the expected results, in both the cases
        /// an error (in XML format) is returned.</returns>
        public ERRORXML IsForecastConfigurationsMatching(String SourcePlanIDToCheckForecastRecord, String SourcePlanFiscalYear, 
                String DestinationPlanFiscalYear, out Boolean ForecastConfigFlag, out String ForecastErrorCode)
        {
            #region Method Variables

            SearchConfiguration search_Object               = null;
            XPathDocument       xpathdoc_ForecastConfig     = null;
            XPathNavigator      xpathnav_HelperForSourceFY  = null;
            XPathNavigator      xpathnav_HelperForDestinFY  = null;
            XPathNavigator      xpathnav_ConfigForSourceFY  = null;
            XPathNavigator      xpathnav_ConfigForDestinFY  = null;
            Int32               int_PeriodCountForSourceFY  = 0;
            Int32               int_PeriodCountForDestinFY  = 0;
            String              str_ForecastDurationType    = null;
            StringBuilder       strbldr_SearchInputXML      = null;
            Boolean             bool_ForecastRecordExist    = true;
            XML                 xml_SearchResult            = null;
            ERRORXML            errorxml_Object             = null;

            #endregion

            ForecastConfigFlag  = false;
            ForecastErrorCode   = null;

            try
            {
                if ((String.IsNullOrEmpty(SourcePlanFiscalYear)) || (String.IsNullOrEmpty(DestinationPlanFiscalYear)))
                {
                    ForecastErrorCode = "ERR_SP_FiscalYearCannotbeNull";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //NOTE: No need to check whether both the fiscal years are same. This check should be at page level.
                //This is so because this API just checks whther the forecast configuration exists and matches for the passed fiscal years or not. 

                #region CASE I

                //CASE (I): Checking budget forecast and resource category forecast records for the passed fiscal years.
                //Check whether any record is present with PLAN_FORECASTFACET and/or with PLAN_RESCAT_FORECAST.
                //If no single record is found with any PLAN for both the relations, in such case allow user to do the next set of operations.
                //Value for ForecastConfigFlag will be set to TRUE.

                //Get the forecast configuration data and do the validations.
                strbldr_SearchInputXML = new StringBuilder();
                strbldr_SearchInputXML.AppendFormat(@"<SEARCH>
                            <TARGETOBJECT>PLAN</TARGETOBJECT>
                            <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                            <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                            <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                            <TARGETENTITY>
                                <PRIVILEGENAME>READ</PRIVILEGENAME>
                                <SELECTLIST>
                                    <EXPRESSION>
                                        <FIELDNAME>PLANID</FIELDNAME>
                                        <ALIAS>PLANID</ALIAS>
                                    </EXPRESSION>
                                    <EXPRESSION>
                                        <FIELDNAME>FISCALYEAR</FIELDNAME>
                                        <ALIAS>FISCALYEAR</ALIAS>
                                    </EXPRESSION>
                                </SELECTLIST>
                                <FILTERLIST>
                                    <FILTER>
                                        <FILTERID>1</FILTERID>
                                        <EXPRESSION>PLANID</EXPRESSION>
                                        <OPERATOR>EQUALTO</OPERATOR>
                                        <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                        <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                    </FILTER>
                                </FILTERLIST>
                                <RELATIONSHIP NAME='PLAN_FORECASTFACET'>
                                    <SELECTLIST>
                                        <EXPRESSION>
                                            <FIELDNAME>ID</FIELDNAME>
                                            <ALIAS>ID</ALIAS>
                                        </EXPRESSION>
                                    </SELECTLIST>
                                </RELATIONSHIP>
                                <RELATIONSHIP NAME='PLAN_RESCAT_FORECAST'>
                                    <SELECTLIST>
                                        <EXPRESSION>
                                            <FIELDNAME>RESCATFORECASTID</FIELDNAME>
                                            <ALIAS>RESCATFORECASTID</ALIAS>
                                        </EXPRESSION>
                                    </SELECTLIST>
                                </RELATIONSHIP>
                            </TARGETENTITY>
                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, SourcePlanIDToCheckForecastRecord);
                search_Object = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                errorxml_Object = search_Object.GetHierarchialData(strbldr_SearchInputXML.ToString(), ref xml_SearchResult);
                if (!(String.IsNullOrEmpty(errorxml_Object)))
                {
                    ForecastErrorCode = "ERR_SP_ErrorWhileFetchingPlanForecast";
                    return (errorxml_Object);
                }
                else if (String.IsNullOrEmpty(xml_SearchResult))
                {
                    ForecastErrorCode = "ERR_SP_ErrorWhileFetchingPlanForecast";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //Use case validations started.
                xpathdoc_ForecastConfig = new XPathDocument(new StringReader(xml_SearchResult));
                xpathnav_HelperForSourceFY = xpathdoc_ForecastConfig.CreateNavigator().SelectSingleNode("PLANCOLLECTION");
                if (xpathnav_HelperForSourceFY != null)
                {
                    //Check whether any record present for any plan
                    // with budget forecast (PLAN_FORECASTFACET) or resource category forecast(PLAN_RESCAT_FORECAST).
                    //If any record found then return an error which found due to the mismatch with forecast configurations.
                    //This error handling is added later of this function.
                    xpathnav_ConfigForSourceFY = xpathnav_HelperForSourceFY.SelectSingleNode("PLAN/PLAN_FORECASTFACET/FORECASTFACET/ID");
                    if (xpathnav_ConfigForSourceFY == null)
                    {
                        xpathnav_ConfigForSourceFY = xpathnav_HelperForSourceFY.SelectSingleNode("PLAN/PLAN_RESCAT_FORECAST/RESCATFORECAST/RESCATFORECASTID");
                        if (xpathnav_ConfigForSourceFY == null)
                        {
                            bool_ForecastRecordExist = false;
                        }
                    }
                }

                #endregion

                #region CASE II

                //Get the forecast configuration data and do the validations.
                strbldr_SearchInputXML.Remove(0, strbldr_SearchInputXML.Length);
                strbldr_SearchInputXML.AppendFormat(@"<SEARCH>
                        <TARGETOBJECT>FORECASTCONFIGURATION</TARGETOBJECT>
                        <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                        <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                        <TARGETENTITY>
                            <PRIVILEGENAME>READ</PRIVILEGENAME>
                            <SELECTLIST>
                                <EXPRESSION>
                                    <FIELDNAME>FISCALYEAR</FIELDNAME>
                                    <ALIAS>FISCALYEAR</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>DURATIONTYPE</FIELDNAME>
                                    <ALIAS>DURATIONTYPE</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>PLANFORECASTDURATION</FIELDNAME>
                                    <ALIAS>PLANFORECASTDURATION</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>MALEVEL1FORECASTDURATION</FIELDNAME>
                                    <ALIAS>MALEVEL1FORECASTDURATION</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>MALEVEL2FORECASTDURATION</FIELDNAME>
                                    <ALIAS>MALEVEL2FORECASTDURATION</ALIAS>
                                </EXPRESSION>
                            </SELECTLIST>
                            <FILTERLIST>
                                <FILTER>
                                    <FILTERID>1</FILTERID>
                                    <EXPRESSION>FISCALYEAR</EXPRESSION>
                                    <OPERATOR>IN</OPERATOR>
                                    <EXPRESSIONVALUE>({4}, {5})</EXPRESSIONVALUE>
                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                </FILTER>
                            </FILTERLIST>
                        </TARGETENTITY>
                    </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, SourcePlanFiscalYear, DestinationPlanFiscalYear);
                search_Object = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                errorxml_Object = search_Object.GetHierarchialData(strbldr_SearchInputXML.ToString(), ref xml_SearchResult);
                if (!(String.IsNullOrEmpty(errorxml_Object)))
                {
                    ForecastErrorCode = "ERR_SP_ErrorWhileFetchingForecastConfig";
                    return (errorxml_Object);
                }
                else if (String.IsNullOrEmpty(xml_SearchResult))
                {
                    ForecastErrorCode = "ERR_SP_NoRecordForForecastConfig";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //Use case validations started.
                xpathdoc_ForecastConfig = new XPathDocument(new StringReader(xml_SearchResult));

                //CASE (II): Check the forecast durations and configurations for both the fiscal years.
                //Check whether the forecast configurations exist for both the fiscal year or not. If not then return an error.

                //(2.1) Check whether forecast configuration exists for both fiscal years. Else return an error.
                xpathnav_ConfigForSourceFY = xpathdoc_ForecastConfig.CreateNavigator().SelectSingleNode(
                        "FORECASTCONFIGURATIONCOLLECTION/FORECASTCONFIGURATION[FISCALYEAR[text()='" + SourcePlanFiscalYear + "']]");
                xpathnav_ConfigForDestinFY = xpathdoc_ForecastConfig.CreateNavigator().SelectSingleNode(
                        "FORECASTCONFIGURATIONCOLLECTION/FORECASTCONFIGURATION[FISCALYEAR[text()='" + DestinationPlanFiscalYear + "']]");
                if ((xpathnav_ConfigForSourceFY == null) || (xpathnav_ConfigForDestinFY == null))
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";

                //If any forecast record (for budget and/or resource category forecast) exist in the database with the PLAN
                // then the forecast configuration for the related fiscal years should be present into the database.
                if ((bool_ForecastRecordExist == true) && (!(String.IsNullOrEmpty(ForecastErrorCode))))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }
                else if (bool_ForecastRecordExist == false)
                {
                    //Here if forecast configuration for source or destination does not exist then return an error. Do not allow to do the 
                    // operations like EDIT or COPY if configuration does not exist. This is added after discussion with Kavita on 22nd May 2012.
                    if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                    {
                        errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                    Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                        return (errorxml_Object);
                    }

                    //Here last case is added to check whether the forecast grid/list configurations are exist or not on NTFS.
                    //If data does not present then atleast the configuration XMLs should be present on NTFS to work with
                    // periodwise budget and resource forecasting.
                    #region CASE IV

                    //CASE IV: Checking the forecast configuration files exist on NTFS or not. It can be grid configurations
                    // or list configurations or any other files which are required to support periodwise budget and resource forecasting.
                    ForecastErrorCode = isForecastConfigFilesExist(DestinationPlanFiscalYear,
                            xpathnav_ConfigForDestinFY.SelectSingleNode("DURATIONTYPE").InnerXml.ToUpper(),
                            xpathnav_ConfigForDestinFY.SelectSingleNode("PLANFORECASTDURATION").InnerXml.ToUpper(),
                            xpathnav_ConfigForDestinFY.SelectSingleNode("MALEVEL1FORECASTDURATION").InnerXml.ToUpper(),
                            xpathnav_ConfigForDestinFY.SelectSingleNode("MALEVEL2FORECASTDURATION").InnerXml.ToUpper());
                    if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                    {
                        errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                    Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                        return (errorxml_Object);
                    }

                    #endregion

                    //If no forecast record exist for the related plan then no need to check the remaining forecat durations and cofigurations.
                    ForecastConfigFlag = true;
                    return (null);
                }
                
                //(2.2) Check whether the duration types are matching for both fiscal years. Else return an error.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("DURATIONTYPE");
                xpathnav_HelperForDestinFY = xpathnav_ConfigForDestinFY.SelectSingleNode("DURATIONTYPE");
                if ((xpathnav_HelperForSourceFY == null) || (xpathnav_HelperForDestinFY == null))
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                else if (!(xpathnav_HelperForSourceFY.InnerXml.Equals(xpathnav_HelperForDestinFY.InnerXml)))
                    ForecastErrorCode = "ERR_SP_Forecast_ConfigMismatch";

                //If error code is not null then handle error and return it.
                if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }
                str_ForecastDurationType = xpathnav_HelperForSourceFY.InnerXml.ToUpper();

                //(2.3) Check whether the plan forecast durations are matching for both fiscal years. Else return an error.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("PLANFORECASTDURATION");
                xpathnav_HelperForDestinFY = xpathnav_ConfigForDestinFY.SelectSingleNode("PLANFORECASTDURATION");
                if ((xpathnav_HelperForSourceFY == null) || (xpathnav_HelperForDestinFY == null))
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                else if (!(xpathnav_HelperForSourceFY.InnerXml.Equals(xpathnav_HelperForDestinFY.InnerXml)))
                    ForecastErrorCode = "ERR_SP_Forecast_ConfigMismatch";

                //If error code is not null then handle error and return it.
                if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //(2.4) Check whether the marketing activity level1 forecast durations are matching for both fiscal years.
                //Else return an error.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("MALEVEL1FORECASTDURATION");
                xpathnav_HelperForDestinFY = xpathnav_ConfigForDestinFY.SelectSingleNode("MALEVEL1FORECASTDURATION");
                if ((xpathnav_HelperForSourceFY == null) || (xpathnav_HelperForDestinFY == null))
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                else if (!(xpathnav_HelperForSourceFY.InnerXml.Equals(xpathnav_HelperForDestinFY.InnerXml)))
                    ForecastErrorCode = "ERR_SP_Forecast_ConfigMismatch";

                //If error code is not null then handle error and return it.
                if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //(2.5) Check whether the marketing activity level2 forecast durations are matching for both fiscal years. Else return an error.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("MALEVEL2FORECASTDURATION");
                xpathnav_HelperForDestinFY = xpathnav_ConfigForDestinFY.SelectSingleNode("MALEVEL2FORECASTDURATION");
                if ((xpathnav_HelperForSourceFY == null) || (xpathnav_HelperForDestinFY == null))
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                else if (!(xpathnav_HelperForSourceFY.InnerXml.Equals(xpathnav_HelperForDestinFY.InnerXml)))
                    ForecastErrorCode = "ERR_SP_Forecast_ConfigMismatch";

                //If error code is not null then handle error and return it.
                if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                #endregion

                #region CASE III

                //CASE (III): Checking the period count if forecast duration types are PERIOD.
                //If the forecast duration type for the fiscal years is PERIOD
                // then check the number of periods for both the fiscal year. If not same then return an error.
                if (str_ForecastDurationType.Equals("PERIOD"))
                {
                    errorxml_Object = GetForecastPeriodCount(SourcePlanFiscalYear, out int_PeriodCountForSourceFY);
                    if (!(String.IsNullOrEmpty(errorxml_Object)))
                    {
                        ForecastErrorCode = "ERR_SP_Forecast_PeriodCount";
                        return (errorxml_Object);
                    }

                    errorxml_Object = GetForecastPeriodCount(DestinationPlanFiscalYear, out int_PeriodCountForDestinFY);
                    if (!(String.IsNullOrEmpty(errorxml_Object)))
                    {
                        ForecastErrorCode = "ERR_SP_Forecast_PeriodCount";
                        return (errorxml_Object);
                    }

                    //Have handled this case separately- Marketing Activity Level 2+ Forecast Durations for both the fiscal years are not matching.
                    //This handling is added into CASE III validations.
                    if (int_PeriodCountForSourceFY != int_PeriodCountForDestinFY)
                    {
                        ForecastErrorCode = "ERR_SP_Forecast_ConfigMismatch";
                        errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                        return (errorxml_Object);
                    }
                }

                #endregion

                #region CASE IV

                //CASE IV: Checking the forecast configuration files exist on NTFS or not. It can be grid configurations
                // or list configurations or any other files which are required to support periodwise budget and resource forecasting.
                ForecastErrorCode = isForecastConfigFilesExist(DestinationPlanFiscalYear,
                        xpathnav_ConfigForDestinFY.SelectSingleNode("DURATIONTYPE").InnerXml.ToUpper(),
                        xpathnav_ConfigForDestinFY.SelectSingleNode("PLANFORECASTDURATION").InnerXml.ToUpper(),
                        xpathnav_ConfigForDestinFY.SelectSingleNode("MALEVEL1FORECASTDURATION").InnerXml.ToUpper(),
                        xpathnav_ConfigForDestinFY.SelectSingleNode("MALEVEL2FORECASTDURATION").InnerXml.ToUpper());
                if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                #endregion

                //Set the flag to TRUE as all conditions are matching and no error is found.
                ForecastConfigFlag = true;
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }

            if ((!(String.IsNullOrEmpty(ForecastErrorCode))) && (String.IsNullOrEmpty(errorxml_Object)))
            {
                errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode, 
                        Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
            }

            return (errorxml_Object);
        }

        /// <summary> This method validates the forecast configuration for the provided fiscal year. It can be used while creating a Plan.
        /// Following cases are validated by the method:
        /// CASE I: Passed fiscal year should not be null or empty.
        /// CASE II: It checks whether the fiscal year configuration exists or not for the provided fiscal year.
        ///     It validates the forecast durations for the passed fiscal year.
        /// CASE III: It also validates the the number of periods, if the duration type is PERIOD.
        /// CASE IV: Checking the forecast configuration files exist on NTFS or not. It can be grid configurations
        ///     or list configurations or any other files which are required to support periodwise budget and resource forecasting.
        /// </summary>
        /// <param name="PlanFiscalYear">This fiscal year is used as a base fiscal year.</param>
        /// <param name="ForecastConfigFlag">This is used to show that the forecast configurations are proper.</param>
        /// <param name="ForecastErrorCode">This returns the error alert code which can be used at page level to display alert.</param>
        /// <returns>On failure or if any codition does not match according to the expected results, in both the cases
        /// an error (in XML format) is returned.</returns>
        public ERRORXML IsForecastConfigurationsMatching(String PlanFiscalYear, out Boolean ForecastConfigFlag, out String ForecastErrorCode)
        {
            #region Method Variables

            SearchConfiguration search_Object               = null;
            XPathDocument       xpathdoc_ForecastConfig     = null;
            XPathNavigator      xpathnav_HelperForSourceFY  = null;
            XPathNavigator      xpathnav_ConfigForSourceFY  = null;
            Int32               int_PeriodCountForSourceFY  = 0;
            String              str_ForecastDurationType    = null;
            StringBuilder       strbldr_SearchInputXML      = null;
            XML                 xml_SearchResult            = null;
            ERRORXML            errorxml_Object             = null;

            #endregion

            ForecastConfigFlag  = false;
            ForecastErrorCode   = null;

            try
            {
                #region CASE I
                //Passed fiscal year should not be null or empty.

                if (String.IsNullOrEmpty(PlanFiscalYear))
                {
                    ForecastErrorCode = "ERR_SP_FiscalYearCannotbeNull";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                #endregion

                #region CASE II

                //Get the forecast configuration data and do the validations.
                strbldr_SearchInputXML = new StringBuilder();
                strbldr_SearchInputXML.AppendFormat(@"<SEARCH>
                        <TARGETOBJECT>FORECASTCONFIGURATION</TARGETOBJECT>
                        <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                        <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                        <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                        <TARGETENTITY>
                            <PRIVILEGENAME>READ</PRIVILEGENAME>
                            <SELECTLIST>
                                <EXPRESSION>
                                    <FIELDNAME>FISCALYEAR</FIELDNAME>
                                    <ALIAS>FISCALYEAR</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>DURATIONTYPE</FIELDNAME>
                                    <ALIAS>DURATIONTYPE</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>PLANFORECASTDURATION</FIELDNAME>
                                    <ALIAS>PLANFORECASTDURATION</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>MALEVEL1FORECASTDURATION</FIELDNAME>
                                    <ALIAS>MALEVEL1FORECASTDURATION</ALIAS>
                                </EXPRESSION>
                                <EXPRESSION>
                                    <FIELDNAME>MALEVEL2FORECASTDURATION</FIELDNAME>
                                    <ALIAS>MALEVEL2FORECASTDURATION</ALIAS>
                                </EXPRESSION>
                            </SELECTLIST>
                            <FILTERLIST>
                                <FILTER>
                                    <FILTERID>1</FILTERID>
                                    <EXPRESSION>FISCALYEAR</EXPRESSION>
                                    <OPERATOR>EQUALTO</OPERATOR>
                                    <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                    <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                </FILTER>
                            </FILTERLIST>
                        </TARGETENTITY>
                    </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, PlanFiscalYear);
                search_Object = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
                errorxml_Object = search_Object.GetHierarchialData(strbldr_SearchInputXML.ToString(), ref xml_SearchResult);
                if (!(String.IsNullOrEmpty(errorxml_Object)))
                {
                    ForecastErrorCode = "ERR_SP_ErrorWhileFetchingForecastConfig";
                    return (errorxml_Object);
                }
                else if (String.IsNullOrEmpty(xml_SearchResult))
                {
                    ForecastErrorCode = "ERR_SP_NoRecordForForecastConfig";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //Use case validations started.
                xpathdoc_ForecastConfig = new XPathDocument(new StringReader(xml_SearchResult));

                //CASE (II): Check the forecast durations and configurations for the fiscal years.
                //Check whether the forecast configurations exist for the fiscal year or not. If not then return an error.

                //(2.1) Check whether forecast configuration exists for both fiscal years. Else return an error.
                xpathnav_ConfigForSourceFY = xpathdoc_ForecastConfig.CreateNavigator().SelectSingleNode(
                        "FORECASTCONFIGURATIONCOLLECTION/FORECASTCONFIGURATION[FISCALYEAR[text()='" + PlanFiscalYear + "']]");
                if (xpathnav_ConfigForSourceFY == null)
                {
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //(2.2) Check whether the duration types exists or not.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("DURATIONTYPE");
                if ((xpathnav_HelperForSourceFY == null) || (String.IsNullOrEmpty(xpathnav_HelperForSourceFY.InnerXml)))
                {
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }
                str_ForecastDurationType = xpathnav_HelperForSourceFY.InnerXml.ToUpper();

                //(2.3) Check whether the plan forecast duration exists or not.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("PLANFORECASTDURATION");
                if ((xpathnav_HelperForSourceFY == null) || (String.IsNullOrEmpty(xpathnav_HelperForSourceFY.InnerXml)))
                {
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                        Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //(2.4) Check whether the marketing activity level1 forecast duration exists or not.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("MALEVEL1FORECASTDURATION");
                if ((xpathnav_HelperForSourceFY == null) || (String.IsNullOrEmpty(xpathnav_HelperForSourceFY.InnerXml)))
                {
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                            Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                //(2.5) Check whether the marketing activity level2 forecast duration exists or not.
                xpathnav_HelperForSourceFY = xpathnav_ConfigForSourceFY.SelectSingleNode("MALEVEL2FORECASTDURATION");
                if ((xpathnav_HelperForSourceFY == null) || (String.IsNullOrEmpty(xpathnav_HelperForSourceFY.InnerXml)))
                {
                    ForecastErrorCode = "ERR_SP_Forecast_CongifNotExists";
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                        Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                #endregion

                #region CASE III

                //CASE (III): Checking the period count if forecast duration types are PERIOD.
                //If the forecast duration type for the fiscal years is PERIOD then check the number of periods. It should not be ZERO.
                if (str_ForecastDurationType.Equals("PERIOD"))
                {
                    errorxml_Object = GetForecastPeriodCount(PlanFiscalYear, out int_PeriodCountForSourceFY);
                    if (!(String.IsNullOrEmpty(errorxml_Object)))
                    {
                        ForecastErrorCode = "ERR_SP_Forecast_PeriodCount";
                        return (errorxml_Object);
                    }
                    else if (int_PeriodCountForSourceFY <=0 )
                    {
                        ForecastErrorCode = "ERR_SP_Forecast_PeriodCountZero";
                        errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                        return (errorxml_Object);
                    }
                }

                #endregion

                #region CASE IV

                //CASE IV: Checking the forecast configuration files exist on NTFS or not. It can be grid configurations
                // or list configurations or any other files which are required to support periodwise budget and resource forecasting.
                ForecastErrorCode = isForecastConfigFilesExist(PlanFiscalYear,
                        xpathnav_ConfigForSourceFY.SelectSingleNode("DURATIONTYPE").InnerXml.ToUpper(),
                        xpathnav_ConfigForSourceFY.SelectSingleNode("PLANFORECASTDURATION").InnerXml.ToUpper(),
                        xpathnav_ConfigForSourceFY.SelectSingleNode("MALEVEL1FORECASTDURATION").InnerXml.ToUpper(),
                        xpathnav_ConfigForSourceFY.SelectSingleNode("MALEVEL2FORECASTDURATION").InnerXml.ToUpper());
                if (!(String.IsNullOrEmpty(ForecastErrorCode)))
                {
                    errorxml_Object = ALSolutionCommon.PrepareErrorXML(ForecastErrorCode,
                                Localization.GetString("ALErrorResource", TenantName, ForecastErrorCode));
                    return (errorxml_Object);
                }

                #endregion

                //Set the flag to TRUE as all conditions are matching and no error is found.
                ForecastConfigFlag = true;
            }
            catch (Exception ExceptionObject)
            {
                throw (ExceptionObject);
            }

            return (errorxml_Object);
        }

        public void ProcessGridConfigXMLForResCatForecast(String ResCatForecastDuration,String FiscalYear, String FiscalMonthValue, ref XmlDocument GridConfigurationXMLDoc)
        {
            int             MonthValue          = 0;
            String          MonthDisplayText    = null;
            String          FiscalYearValue     = FiscalYear;
            XPathNavigator  xpnav               = null;

            if (ResCatForecastDuration == "MONTHLY")
            {
                MonthValue = GetMonthNumeric(FiscalMonthValue);
                if (MonthValue != 0)
                {
                    for (int iMonth = 1; iMonth <= 12; iMonth++)
                    {
                        //MonthDisplayText = GetMonthDisplayTextId(MonthValue, false);
                        MonthDisplayText = GetLocalizedMonthSTR(MonthValue, false);
                        xpnav = GridConfigurationXMLDoc.CreateNavigator().SelectSingleNode("gridconfiguration/header/headercolumn [@name='HOURSM" + iMonth + "']");
                        if (xpnav != null)
                        {
                            if (xpnav.MoveToAttribute("displaytextid", ""))
                            {
                                xpnav.SetValue(MonthDisplayText + " " + FiscalYearValue);
                                xpnav.MoveToParent();
                            }
                            else
                            {
                                xpnav.CreateAttribute("", "displaytextid", "", MonthDisplayText + " " + FiscalYearValue);
                            }
                        }
                        MonthValue++;
                        if (MonthValue > 12)
                        {
                            MonthValue = MonthValue - 12;

                            if (Convert.ToDouble(FiscalYear) == Convert.ToDouble(FiscalYearValue))
                                FiscalYearValue = (Convert.ToDouble(FiscalYearValue) + 1).ToString();
                        }
                    }
                }
            }
            else
                if (ResCatForecastDuration == "PERIODWISE")
                {
                    String              ForecastConfiguration   = null;
                    String              ErrorXML                = null;
                    XmlDocument         ConfigDoc               = null;
                    XPathNodeIterator   xpitr_FCConf            = null;

                    ErrorXML = GetForecastConfiguration(FiscalYear, out ForecastConfiguration);

                    if (string.IsNullOrEmpty(ErrorXML))
                    {
                        ConfigDoc = new XmlDocument();
                        ConfigDoc.LoadXml(ForecastConfiguration);

                        xpitr_FCConf = ConfigDoc.CreateNavigator().Select("FORECASTCONFIGURATIONCOLLECTION/FORECASTCONFIGURATION/FORECASTCONFIGURATION_FORECASTPERIODS/FORECASTPERIODS");

                        while (xpitr_FCConf.MoveNext())
                        {
                            String abbreviation = null;
                            String periodtitle = null;

                            abbreviation    = xpitr_FCConf.Current.SelectSingleNode("PERIODABBREVIATION").Value;
                            periodtitle     = xpitr_FCConf.Current.SelectSingleNode("PERIODNAME").Value;
                            periodtitle     = ALSpecialCharHandling.TrimAndReplaceSpecialChars(periodtitle);

                            xpnav = GridConfigurationXMLDoc.CreateNavigator().SelectSingleNode("gridconfiguration/header/headercolumn [@name='HOURS" + abbreviation + "']");
                            if (xpnav != null)
                            {
                                if (xpnav.MoveToAttribute("displaytextid", ""))
                                {
                                    xpnav.SetValue(periodtitle);
                                    xpnav.MoveToParent();
                                }
                                else
                                {
                                    xpnav.CreateAttribute("", "displaytextid", "", periodtitle);
                                }
                            }
                        }
                    }
                }
        }

        public String IsPlanLockedForRCFEditing(String ActivityID, out String IsPlanLocked, out XPathNavigator Plannavigator)
        {
            StringBuilder   sb_inputXML     = null;
            String          ErrorXML        = null;
            String          ResultXML       = null;
            SearchConfiguration SearchObj   = null;
            XPathDocument   xpDoc           = null;
            XPathNavigator  xpnav           = null;
                            IsPlanLocked    = null;
                            Plannavigator   = null;

            #region Search XML
            sb_inputXML = new StringBuilder(500);
            sb_inputXML.AppendFormat(@"<SEARCH>
                                          <TARGETOBJECT>MARKETINGACTIVITY</TARGETOBJECT>
                                          <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                          <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                          <SESSIONINFO Language='{0}' TenantName='{1}' UserID='{2}' SessionID='{3}'/>
                                          <TARGETENTITY>
                                            <PRIVILEGENAME>READ</PRIVILEGENAME>
                                            <FILTERLIST>
                                              <FILTER>
                                                <FILTERID>1</FILTERID>
                                                <EXPRESSION>MARKETINGACTIVITYID</EXPRESSION>
                                                <OPERATOR>EQUALTO</OPERATOR>
                                                <EXPRESSIONVALUE>{4}</EXPRESSIONVALUE>
                                                <ISCASESENSITIVE>False</ISCASESENSITIVE>
                                              </FILTER>
                                            </FILTERLIST>
                                            <SELECTLIST>
                                              <EXPRESSION>
                                                <FIELDNAME>MARKETINGACTIVITYID</FIELDNAME>
                                                <ALIAS>MARKETINGACTIVITYID</ALIAS>
                                              </EXPRESSION>
                                            </SELECTLIST>
                                            <RELATIONSHIP NAME='PLAN_MARKETINGACTIVITIES'>
                                                <SELECTLIST>
                                                 <EXPRESSION>
                                                    <FIELDNAME>FISCALYEAR</FIELDNAME>
                                                    <ALIAS>FISCALYEAR</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>ISRCFORECASTLOCKED</FIELDNAME>
                                                    <ALIAS>ISRCFORECASTLOCKED</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>RCFORECASTLOCKEDON</FIELDNAME>
                                                    <ALIAS>RCFORECASTLOCKEDON</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>RCFORECASTLOCKEDSESSION</FIELDNAME>
                                                    <ALIAS>RCFORECASTLOCKEDSESSION</ALIAS>
                                                  </EXPRESSION>
                                                </SELECTLIST>
                                                <RELATIONSHIP NAME='RESCAT_FORECAST_LOCKEDBY'>
                                                    <SELECTLIST>
                                                      <EXPRESSION>
                                                        <FIELDNAME>USERID</FIELDNAME>
                                                        <ALIAS>USERID</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>LOGINNAME</FIELDNAME>
                                                        <ALIAS>LOGINNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                        <ALIAS>FIRSTNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>LASTNAME</FIELDNAME>
                                                        <ALIAS>LASTNAME</ALIAS>
                                                      </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                            </RELATIONSHIP>
                                            <RELATIONSHIP NAME='MARKETING_ACTIVITIES_FOR_PLAN'>
                                                <SELECTLIST>
                                                 <EXPRESSION>
                                                    <FIELDNAME>FISCALYEAR</FIELDNAME>
                                                    <ALIAS>FISCALYEAR</ALIAS>
                                                  </EXPRESSION> 
                                                 <EXPRESSION>
                                                    <FIELDNAME>ISRCFORECASTLOCKED</FIELDNAME>
                                                    <ALIAS>ISRCFORECASTLOCKED</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>RCFORECASTLOCKEDON</FIELDNAME>
                                                    <ALIAS>RCFORECASTLOCKEDON</ALIAS>
                                                  </EXPRESSION>
                                                  <EXPRESSION>
                                                    <FIELDNAME>RCFORECASTLOCKEDSESSION</FIELDNAME>
                                                    <ALIAS>RCFORECASTLOCKEDSESSION</ALIAS>
                                                  </EXPRESSION>
                                                </SELECTLIST>
                                                <RELATIONSHIP NAME='RESCAT_FORECAST_LOCKEDBY'>
                                                    <SELECTLIST>
                                                      <EXPRESSION>
                                                        <FIELDNAME>USERID</FIELDNAME>
                                                        <ALIAS>USERID</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>LOGINNAME</FIELDNAME>
                                                        <ALIAS>LOGINNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>FIRSTNAME</FIELDNAME>
                                                        <ALIAS>FIRSTNAME</ALIAS>
                                                      </EXPRESSION>
                                                      <EXPRESSION>
                                                        <FIELDNAME>LASTNAME</FIELDNAME>
                                                        <ALIAS>LASTNAME</ALIAS>
                                                      </EXPRESSION>
                                                    </SELECTLIST>
                                                </RELATIONSHIP>
                                            </RELATIONSHIP>
                                           </TARGETENTITY>
                                        </SEARCH>", CurrentLanguage, TenantName, UserID, SessionID, ActivityID);
            #endregion

            SearchObj = new SearchConfiguration(SessionID, UserID, TenantName, CurrentLanguage);
            ErrorXML = SearchObj.GetHierarchialData(sb_inputXML.ToString(), ref ResultXML);

            if (String.IsNullOrEmpty(ErrorXML))
            {

                xpDoc = new XPathDocument(new StringReader(ResultXML));

                if (xpDoc.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/PLAN_MARKETINGACTIVITIES/PLAN") != null)
                    xpnav = xpDoc.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/PLAN_MARKETINGACTIVITIES/PLAN");
                else
                    if (xpDoc.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETING_ACTIVITIES_FOR_PLAN/PLAN") != null)
                        xpnav = xpDoc.CreateNavigator().SelectSingleNode("MARKETINGACTIVITYCOLLECTION/MARKETINGACTIVITY/MARKETING_ACTIVITIES_FOR_PLAN/PLAN");

                if (xpnav != null)
                {
                    IsPlanLocked = xpnav.SelectSingleNode("ISRCFORECASTLOCKED").Value;
                    Plannavigator = xpnav;
                }
            }

            return ErrorXML;

        }
        
        #region Helper Methods

        private void getFiscalYear(String DataXMLPath, ref String str_FiscalYear)
        {
            String str_DataXML = null;
            if (File.Exists(DataXMLPath))
            {
                str_DataXML     = File.ReadAllText(DataXMLPath);
                str_FiscalYear  = ALCommon.GetInnerValue(ref str_DataXML, "<FISCALYEAR>", "</FISCALYEAR>");
            }
        }

        //isForecastConfigFilesExist() method is used to validate the required grid or list configuration XMLs exist on NTFS
        // (at solucation layer) for the passed fiscal year. If not then return an error code.
        private String isForecastConfigFilesExist(String PassedFiscalYear, String ForecastDurationType, String PlanForecastDuration,
                String MALevel1ForecastDuration, String MALevel2ForecastDuration)
        {
            #region Method Variables

            String  str_ConfigFilesPath         = null;
            String  str_ConfigFileWithPath      = null;
            String  str_FileNamesBudgetForecast = null;

            #endregion

            str_FileNamesBudgetForecast = "ForecastReallocation_GridConfiguration_" ;
            str_ConfigFilesPath = ALSolutionCommon.GetConfigurationPath(this.TenantName, this.SolutionName);

            //In case of PERIOD type, check all configuration files. These are used for budget and resource forecasting.
            //**Here NULL value is checked to force to validate the configuration XMLs for both- budget and resource category forecasts.
            if ((ForecastDurationType != null) && (ForecastDurationType.Equals("CALENDAR")))
            {
                //In case of CALENDAR type, check configuration files ONLY for budget forecasting.
                str_ConfigFileWithPath = str_ConfigFilesPath + str_FileNamesBudgetForecast + PassedFiscalYear + ".xml";
                if (!(File.Exists(str_ConfigFileWithPath)))
                    return ("ERR_SP_Forecast_BudgetConfigFilesNotExist");
            }
            else
            {
                //Check configuration files for budget forecast.
                str_ConfigFileWithPath = str_ConfigFilesPath + str_FileNamesBudgetForecast + PassedFiscalYear + ".xml";
                if (!(File.Exists(str_ConfigFileWithPath)))
                    return ("ERR_SP_Forecast_BudgetConfigFilesNotExist");

                //Check configuration files for resource forecast. Following are the files to be checked in case of PERIODWISE type:
                //RCForecastPeriodwiseGridConfig_Plan_, RCForecastPeriodwiseGridConfig_Activity_RO_, RCForecastPeriodwiseGridConfig_Activity_Edit_
                if (PlanForecastDuration.Equals("PERIODWISE", StringComparison.CurrentCultureIgnoreCase))
                {
                    str_ConfigFileWithPath = str_ConfigFilesPath + "RCForecastPeriodwiseGridConfig_Plan_" + PassedFiscalYear + ".xml";
                    if (!(File.Exists(str_ConfigFileWithPath)))
                        return ("ERR_SP_Forecast_ResourceConfigFilesNotExist");
                }

                if ((MALevel1ForecastDuration.Equals("PERIODWISE", StringComparison.CurrentCultureIgnoreCase))
                        || (MALevel2ForecastDuration.Equals("PERIODWISE", StringComparison.CurrentCultureIgnoreCase)))
                {
                    str_ConfigFileWithPath = str_ConfigFilesPath + "RCForecastPeriodwiseGridConfig_Activity_RO_" + PassedFiscalYear + ".xml";
                    if (!(File.Exists(str_ConfigFileWithPath)))
                        return ("ERR_SP_Forecast_ResourceConfigFilesNotExist");

                    str_ConfigFileWithPath = str_ConfigFilesPath + "RCForecastPeriodwiseGridConfig_Activity_Edit_" + PassedFiscalYear + ".xml";
                    if (!(File.Exists(str_ConfigFileWithPath)))
                        return ("ERR_SP_Forecast_ResourceConfigFilesNotExist");
                }
            }

            return (null);
        }
        
        #endregion
    }
}
